﻿/*!
 * https://github.com/es-shims/es5-shim
 * @license es5-shim Copyright 2009-2015 by contributors, MIT License
 * see https://github.com/es-shims/es5-shim/blob/v4.5.9/LICENSE
 */
(function(t, r) {
    "use strict";
    if (typeof define === "function" && define.amd) {
        define(r)
    } else if (typeof exports === "object") {
        module.exports = r()
    } else {
        t.returnExports = r()
    }
}
)(this, function() {
    var t = Array;
    var r = t.prototype;
    var e = Object;
    var n = e.prototype;
    var i = Function;
    var a = i.prototype;
    var o = String;
    var f = o.prototype;
    var u = Number;
    var l = u.prototype;
    var s = r.slice;
    var c = r.splice;
    var v = r.push;
    var h = r.unshift;
    var p = r.concat;
    var y = r.join;
    var d = a.call;
    var g = a.apply;
    var w = Math.max;
    var b = Math.min;
    var T = n.toString;
    var m = typeof Symbol === "function" && typeof Symbol.toStringTag === "symbol";
    var D;
    var S = Function.prototype.toString
      , x = /^\s*class /
      , O = function isES6ClassFn(t) {
        try {
            var r = S.call(t);
            var e = r.replace(/\/\/.*\n/g, "");
            var n = e.replace(/\/\*[.\s\S]*\*\//g, "");
            var i = n.replace(/\n/gm, " ").replace(/ {2}/g, " ");
            return x.test(i)
        } catch (a) {
            return false
        }
    }
      , j = function tryFunctionObject(t) {
        try {
            if (O(t)) {
                return false
            }
            S.call(t);
            return true
        } catch (r) {
            return false
        }
    }
      , E = "[object Function]"
      , I = "[object GeneratorFunction]"
      , D = function isCallable(t) {
        if (!t) {
            return false
        }
        if (typeof t !== "function" && typeof t !== "object") {
            return false
        }
        if (m) {
            return j(t)
        }
        if (O(t)) {
            return false
        }
        var r = T.call(t);
        return r === E || r === I
    };
    var M;
    var U = RegExp.prototype.exec
      , F = function tryRegexExec(t) {
        try {
            U.call(t);
            return true
        } catch (r) {
            return false
        }
    }
      , N = "[object RegExp]";
    M = function isRegex(t) {
        if (typeof t !== "object") {
            return false
        }
        return m ? F(t) : T.call(t) === N
    }
    ;
    var C;
    var k = String.prototype.valueOf
      , A = function tryStringObject(t) {
        try {
            k.call(t);
            return true
        } catch (r) {
            return false
        }
    }
      , R = "[object String]";
    C = function isString(t) {
        if (typeof t === "string") {
            return true
        }
        if (typeof t !== "object") {
            return false
        }
        return m ? A(t) : T.call(t) === R
    }
    ;
    var P = e.defineProperty && function() {
        try {
            var t = {};
            e.defineProperty(t, "x", {
                enumerable: false,
                value: t
            });
            for (var r in t) {
                return false
            }
            return t.x === t
        } catch (n) {
            return false
        }
    }();
    var $ = function(t) {
        var r;
        if (P) {
            r = function(t, r, n, i) {
                if (!i && r in t) {
                    return
                }
                e.defineProperty(t, r, {
                    configurable: true,
                    enumerable: false,
                    writable: true,
                    value: n
                })
            }
        } else {
            r = function(t, r, e, n) {
                if (!n && r in t) {
                    return
                }
                t[r] = e
            }
        }
        return function defineProperties(e, n, i) {
            for (var a in n) {
                if (t.call(n, a)) {
                    r(e, a, n[a], i)
                }
            }
        }
    }(n.hasOwnProperty);
    var J = function isPrimitive(t) {
        var r = typeof t;
        return t === null || r !== "object" && r !== "function"
    };
    var Y = u.isNaN || function isActualNaN(t) {
        return t !== t
    }
    ;
    var Z = {
        ToInteger: function ToInteger(t) {
            var r = +t;
            if (Y(r)) {
                r = 0
            } else if (r !== 0 && r !== 1 / 0 && r !== -(1 / 0)) {
                r = (r > 0 || -1) * Math.floor(Math.abs(r))
            }
            return r
        },
        ToPrimitive: function ToPrimitive(t) {
            var r, e, n;
            if (J(t)) {
                return t
            }
            e = t.valueOf;
            if (D(e)) {
                r = e.call(t);
                if (J(r)) {
                    return r
                }
            }
            n = t.toString;
            if (D(n)) {
                r = n.call(t);
                if (J(r)) {
                    return r
                }
            }
            throw new TypeError
        },
        ToObject: function(t) {
            if (t == null) {
                throw new TypeError("can't convert " + t + " to object")
            }
            return e(t)
        },
        ToUint32: function ToUint32(t) {
            return t >>> 0
        }
    };
    var z = function Empty() {};
    $(a, {
        bind: function bind(t) {
            var r = this;
            if (!D(r)) {
                throw new TypeError("Function.prototype.bind called on incompatible " + r)
            }
            var n = s.call(arguments, 1);
            var a;
            var o = function() {
                if (this instanceof a) {
                    var i = g.call(r, this, p.call(n, s.call(arguments)));
                    if (e(i) === i) {
                        return i
                    }
                    return this
                } else {
                    return g.call(r, t, p.call(n, s.call(arguments)))
                }
            };
            var f = w(0, r.length - n.length);
            var u = [];
            for (var l = 0; l < f; l++) {
                v.call(u, "$" + l)
            }
            a = i("binder", "return function (" + y.call(u, ",") + "){ return binder.apply(this, arguments); }")(o);
            if (r.prototype) {
                z.prototype = r.prototype;
                a.prototype = new z;
                z.prototype = null
            }
            return a
        }
    });
    var G = d.bind(n.hasOwnProperty);
    var B = d.bind(n.toString);
    var H = d.bind(s);
    var W = g.bind(s);
    var L = d.bind(f.slice);
    var X = d.bind(f.split);
    var q = d.bind(f.indexOf);
    var K = d.bind(v);
    var Q = d.bind(n.propertyIsEnumerable);
    var V = d.bind(r.sort);
    var _ = t.isArray || function isArray(t) {
        return B(t) === "[object Array]"
    }
    ;
    var tt = [].unshift(0) !== 1;
    $(r, {
        unshift: function() {
            h.apply(this, arguments);
            return this.length
        }
    }, tt);
    $(t, {
        isArray: _
    });
    var rt = e("a");
    var et = rt[0] !== "a" || !(0 in rt);
    var nt = function properlyBoxed(t) {
        var r = true;
        var e = true;
        var n = false;
        if (t) {
            try {
                t.call("foo", function(t, e, n) {
                    if (typeof n !== "object") {
                        r = false
                    }
                });
                t.call([1], function() {
                    "use strict";
                    e = typeof this === "string"
                }, "x")
            } catch (i) {
                n = true
            }
        }
        return !!t && !n && r && e
    };
    $(r, {
        forEach: function forEach(t) {
            var r = Z.ToObject(this);
            var e = et && C(this) ? X(this, "") : r;
            var n = -1;
            var i = Z.ToUint32(e.length);
            var a;
            if (arguments.length > 1) {
                a = arguments[1]
            }
            if (!D(t)) {
                throw new TypeError("Array.prototype.forEach callback must be a function")
            }
            while (++n < i) {
                if (n in e) {
                    if (typeof a === "undefined") {
                        t(e[n], n, r)
                    } else {
                        t.call(a, e[n], n, r)
                    }
                }
            }
        }
    }, !nt(r.forEach));
    $(r, {
        map: function map(r) {
            var e = Z.ToObject(this);
            var n = et && C(this) ? X(this, "") : e;
            var i = Z.ToUint32(n.length);
            var a = t(i);
            var o;
            if (arguments.length > 1) {
                o = arguments[1]
            }
            if (!D(r)) {
                throw new TypeError("Array.prototype.map callback must be a function")
            }
            for (var f = 0; f < i; f++) {
                if (f in n) {
                    if (typeof o === "undefined") {
                        a[f] = r(n[f], f, e)
                    } else {
                        a[f] = r.call(o, n[f], f, e)
                    }
                }
            }
            return a
        }
    }, !nt(r.map));
    $(r, {
        filter: function filter(t) {
            var r = Z.ToObject(this);
            var e = et && C(this) ? X(this, "") : r;
            var n = Z.ToUint32(e.length);
            var i = [];
            var a;
            var o;
            if (arguments.length > 1) {
                o = arguments[1]
            }
            if (!D(t)) {
                throw new TypeError("Array.prototype.filter callback must be a function")
            }
            for (var f = 0; f < n; f++) {
                if (f in e) {
                    a = e[f];
                    if (typeof o === "undefined" ? t(a, f, r) : t.call(o, a, f, r)) {
                        K(i, a)
                    }
                }
            }
            return i
        }
    }, !nt(r.filter));
    $(r, {
        every: function every(t) {
            var r = Z.ToObject(this);
            var e = et && C(this) ? X(this, "") : r;
            var n = Z.ToUint32(e.length);
            var i;
            if (arguments.length > 1) {
                i = arguments[1]
            }
            if (!D(t)) {
                throw new TypeError("Array.prototype.every callback must be a function")
            }
            for (var a = 0; a < n; a++) {
                if (a in e && !(typeof i === "undefined" ? t(e[a], a, r) : t.call(i, e[a], a, r))) {
                    return false
                }
            }
            return true
        }
    }, !nt(r.every));
    $(r, {
        some: function some(t) {
            var r = Z.ToObject(this);
            var e = et && C(this) ? X(this, "") : r;
            var n = Z.ToUint32(e.length);
            var i;
            if (arguments.length > 1) {
                i = arguments[1]
            }
            if (!D(t)) {
                throw new TypeError("Array.prototype.some callback must be a function")
            }
            for (var a = 0; a < n; a++) {
                if (a in e && (typeof i === "undefined" ? t(e[a], a, r) : t.call(i, e[a], a, r))) {
                    return true
                }
            }
            return false
        }
    }, !nt(r.some));
    var it = false;
    if (r.reduce) {
        it = typeof r.reduce.call("es5", function(t, r, e, n) {
            return n
        }) === "object"
    }
    $(r, {
        reduce: function reduce(t) {
            var r = Z.ToObject(this);
            var e = et && C(this) ? X(this, "") : r;
            var n = Z.ToUint32(e.length);
            if (!D(t)) {
                throw new TypeError("Array.prototype.reduce callback must be a function")
            }
            if (n === 0 && arguments.length === 1) {
                throw new TypeError("reduce of empty array with no initial value")
            }
            var i = 0;
            var a;
            if (arguments.length >= 2) {
                a = arguments[1]
            } else {
                do {
                    if (i in e) {
                        a = e[i++];
                        break
                    }
                    if (++i >= n) {
                        throw new TypeError("reduce of empty array with no initial value")
                    }
                } while (true)
            }
            for (; i < n; i++) {
                if (i in e) {
                    a = t(a, e[i], i, r)
                }
            }
            return a
        }
    }, !it);
    var at = false;
    if (r.reduceRight) {
        at = typeof r.reduceRight.call("es5", function(t, r, e, n) {
            return n
        }) === "object"
    }
    $(r, {
        reduceRight: function reduceRight(t) {
            var r = Z.ToObject(this);
            var e = et && C(this) ? X(this, "") : r;
            var n = Z.ToUint32(e.length);
            if (!D(t)) {
                throw new TypeError("Array.prototype.reduceRight callback must be a function")
            }
            if (n === 0 && arguments.length === 1) {
                throw new TypeError("reduceRight of empty array with no initial value")
            }
            var i;
            var a = n - 1;
            if (arguments.length >= 2) {
                i = arguments[1]
            } else {
                do {
                    if (a in e) {
                        i = e[a--];
                        break
                    }
                    if (--a < 0) {
                        throw new TypeError("reduceRight of empty array with no initial value")
                    }
                } while (true)
            }
            if (a < 0) {
                return i
            }
            do {
                if (a in e) {
                    i = t(i, e[a], a, r)
                }
            } while (a--);return i
        }
    }, !at);
    var ot = r.indexOf && [0, 1].indexOf(1, 2) !== -1;
    $(r, {
        indexOf: function indexOf(t) {
            var r = et && C(this) ? X(this, "") : Z.ToObject(this);
            var e = Z.ToUint32(r.length);
            if (e === 0) {
                return -1
            }
            var n = 0;
            if (arguments.length > 1) {
                n = Z.ToInteger(arguments[1])
            }
            n = n >= 0 ? n : w(0, e + n);
            for (; n < e; n++) {
                if (n in r && r[n] === t) {
                    return n
                }
            }
            return -1
        }
    }, ot);
    var ft = r.lastIndexOf && [0, 1].lastIndexOf(0, -3) !== -1;
    $(r, {
        lastIndexOf: function lastIndexOf(t) {
            var r = et && C(this) ? X(this, "") : Z.ToObject(this);
            var e = Z.ToUint32(r.length);
            if (e === 0) {
                return -1
            }
            var n = e - 1;
            if (arguments.length > 1) {
                n = b(n, Z.ToInteger(arguments[1]))
            }
            n = n >= 0 ? n : e - Math.abs(n);
            for (; n >= 0; n--) {
                if (n in r && t === r[n]) {
                    return n
                }
            }
            return -1
        }
    }, ft);
    var ut = function() {
        var t = [1, 2];
        var r = t.splice();
        return t.length === 2 && _(r) && r.length === 0
    }();
    $(r, {
        splice: function splice(t, r) {
            if (arguments.length === 0) {
                return []
            } else {
                return c.apply(this, arguments)
            }
        }
    }, !ut);
    var lt = function() {
        var t = {};
        r.splice.call(t, 0, 0, 1);
        return t.length === 1
    }();
    $(r, {
        splice: function splice(t, r) {
            if (arguments.length === 0) {
                return []
            }
            var e = arguments;
            this.length = w(Z.ToInteger(this.length), 0);
            if (arguments.length > 0 && typeof r !== "number") {
                e = H(arguments);
                if (e.length < 2) {
                    K(e, this.length - t)
                } else {
                    e[1] = Z.ToInteger(r)
                }
            }
            return c.apply(this, e)
        }
    }, !lt);
    var st = function() {
        var r = new t(1e5);
        r[8] = "x";
        r.splice(1, 1);
        return r.indexOf("x") === 7
    }();
    var ct = function() {
        var t = 256;
        var r = [];
        r[t] = "a";
        r.splice(t + 1, 0, "b");
        return r[t] === "a"
    }();
    $(r, {
        splice: function splice(t, r) {
            var e = Z.ToObject(this);
            var n = [];
            var i = Z.ToUint32(e.length);
            var a = Z.ToInteger(t);
            var f = a < 0 ? w(i + a, 0) : b(a, i);
            var u = b(w(Z.ToInteger(r), 0), i - f);
            var l = 0;
            var s;
            while (l < u) {
                s = o(f + l);
                if (G(e, s)) {
                    n[l] = e[s]
                }
                l += 1
            }
            var c = H(arguments, 2);
            var v = c.length;
            var h;
            if (v < u) {
                l = f;
                var p = i - u;
                while (l < p) {
                    s = o(l + u);
                    h = o(l + v);
                    if (G(e, s)) {
                        e[h] = e[s]
                    } else {
                        delete e[h]
                    }
                    l += 1
                }
                l = i;
                var y = i - u + v;
                while (l > y) {
                    delete e[l - 1];
                    l -= 1
                }
            } else if (v > u) {
                l = i - u;
                while (l > f) {
                    s = o(l + u - 1);
                    h = o(l + v - 1);
                    if (G(e, s)) {
                        e[h] = e[s]
                    } else {
                        delete e[h]
                    }
                    l -= 1
                }
            }
            l = f;
            for (var d = 0; d < c.length; ++d) {
                e[l] = c[d];
                l += 1
            }
            e.length = i - u + v;
            return n
        }
    }, !st || !ct);
    var vt = r.join;
    var ht;
    try {
        ht = Array.prototype.join.call("123", ",") !== "1,2,3"
    } catch (pt) {
        ht = true
    }
    if (ht) {
        $(r, {
            join: function join(t) {
                var r = typeof t === "undefined" ? "," : t;
                return vt.call(C(this) ? X(this, "") : this, r)
            }
        }, ht)
    }
    var yt = [1, 2].join(undefined) !== "1,2";
    if (yt) {
        $(r, {
            join: function join(t) {
                var r = typeof t === "undefined" ? "," : t;
                return vt.call(this, r)
            }
        }, yt)
    }
    var dt = function push(t) {
        var r = Z.ToObject(this);
        var e = Z.ToUint32(r.length);
        var n = 0;
        while (n < arguments.length) {
            r[e + n] = arguments[n];
            n += 1
        }
        r.length = e + n;
        return e + n
    };
    var gt = function() {
        var t = {};
        var r = Array.prototype.push.call(t, undefined);
        return r !== 1 || t.length !== 1 || typeof t[0] !== "undefined" || !G(t, 0)
    }();
    $(r, {
        push: function push(t) {
            if (_(this)) {
                return v.apply(this, arguments)
            }
            return dt.apply(this, arguments)
        }
    }, gt);
    var wt = function() {
        var t = [];
        var r = t.push(undefined);
        return r !== 1 || t.length !== 1 || typeof t[0] !== "undefined" || !G(t, 0)
    }();
    $(r, {
        push: dt
    }, wt);
    $(r, {
        slice: function(t, r) {
            var e = C(this) ? X(this, "") : this;
            return W(e, arguments)
        }
    }, et);
    var bt = function() {
        try {
            [1, 2].sort(null);
            [1, 2].sort({});
            return true
        } catch (t) {}
        return false
    }();
    var Tt = function() {
        try {
            [1, 2].sort(/a/);
            return false
        } catch (t) {}
        return true
    }();
    var mt = function() {
        try {
            [1, 2].sort(undefined);
            return true
        } catch (t) {}
        return false
    }();
    $(r, {
        sort: function sort(t) {
            if (typeof t === "undefined") {
                return V(this)
            }
            if (!D(t)) {
                throw new TypeError("Array.prototype.sort callback must be a function")
            }
            return V(this, t)
        }
    }, bt || !mt || !Tt);
    var Dt = !Q({
        toString: null
    }, "toString");
    var St = Q(function() {}, "prototype");
    var xt = !G("x", "0");
    var Ot = function(t) {
        var r = t.constructor;
        return r && r.prototype === t
    };
    var jt = {
        $window: true,
        $console: true,
        $parent: true,
        $self: true,
        $frame: true,
        $frames: true,
        $frameElement: true,
        $webkitIndexedDB: true,
        $webkitStorageInfo: true,
        $external: true
    };
    var Et = function() {
        if (typeof window === "undefined") {
            return false
        }
        for (var t in window) {
            try {
                if (!jt["$" + t] && G(window, t) && window[t] !== null && typeof window[t] === "object") {
                    Ot(window[t])
                }
            } catch (r) {
                return true
            }
        }
        return false
    }();
    var It = function(t) {
        if (typeof window === "undefined" || !Et) {
            return Ot(t)
        }
        try {
            return Ot(t)
        } catch (r) {
            return false
        }
    };
    var Mt = ["toString", "toLocaleString", "valueOf", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "constructor"];
    var Ut = Mt.length;
    var Ft = function isArguments(t) {
        return B(t) === "[object Arguments]"
    };
    var Nt = function isArguments(t) {
        return t !== null && typeof t === "object" && typeof t.length === "number" && t.length >= 0 && !_(t) && D(t.callee)
    };
    var Ct = Ft(arguments) ? Ft : Nt;
    $(e, {
        keys: function keys(t) {
            var r = D(t);
            var e = Ct(t);
            var n = t !== null && typeof t === "object";
            var i = n && C(t);
            if (!n && !r && !e) {
                throw new TypeError("Object.keys called on a non-object")
            }
            var a = [];
            var f = St && r;
            if (i && xt || e) {
                for (var u = 0; u < t.length; ++u) {
                    K(a, o(u))
                }
            }
            if (!e) {
                for (var l in t) {
                    if (!(f && l === "prototype") && G(t, l)) {
                        K(a, o(l))
                    }
                }
            }
            if (Dt) {
                var s = It(t);
                for (var c = 0; c < Ut; c++) {
                    var v = Mt[c];
                    if (!(s && v === "constructor") && G(t, v)) {
                        K(a, v)
                    }
                }
            }
            return a
        }
    });
    var kt = e.keys && function() {
        return e.keys(arguments).length === 2
    }(1, 2);
    var At = e.keys && function() {
        var t = e.keys(arguments);
        return arguments.length !== 1 || t.length !== 1 || t[0] !== 1
    }(1);
    var Rt = e.keys;
    $(e, {
        keys: function keys(t) {
            if (Ct(t)) {
                return Rt(H(t))
            } else {
                return Rt(t)
            }
        }
    }, !kt || At);
    var Pt = new Date(-0xc782b5b342b24).getUTCMonth() !== 0;
    var $t = new Date(-0x55d318d56a724);
    var Jt = new Date(14496624e5);
    var Yt = $t.toUTCString() !== "Mon, 01 Jan -45875 11:59:59 GMT";
    var Zt;
    var zt;
    var Gt = $t.getTimezoneOffset();
    if (Gt < -720) {
        Zt = $t.toDateString() !== "Tue Jan 02 -45875";
        zt = !/^Thu Dec 10 2015 \d\d:\d\d:\d\d GMT[-\+]\d\d\d\d(?: |$)/.test(Jt.toString())
    } else {
        Zt = $t.toDateString() !== "Mon Jan 01 -45875";
        zt = !/^Wed Dec 09 2015 \d\d:\d\d:\d\d GMT[-\+]\d\d\d\d(?: |$)/.test(Jt.toString())
    }
    var Bt = d.bind(Date.prototype.getFullYear);
    var Ht = d.bind(Date.prototype.getMonth);
    var Wt = d.bind(Date.prototype.getDate);
    var Lt = d.bind(Date.prototype.getUTCFullYear);
    var Xt = d.bind(Date.prototype.getUTCMonth);
    var qt = d.bind(Date.prototype.getUTCDate);
    var Kt = d.bind(Date.prototype.getUTCDay);
    var Qt = d.bind(Date.prototype.getUTCHours);
    var Vt = d.bind(Date.prototype.getUTCMinutes);
    var _t = d.bind(Date.prototype.getUTCSeconds);
    var tr = d.bind(Date.prototype.getUTCMilliseconds);
    var rr = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
    var er = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    var nr = function daysInMonth(t, r) {
        return Wt(new Date(r,t,0))
    };
    $(Date.prototype, {
        getFullYear: function getFullYear() {
            if (!this || !(this instanceof Date)) {
                throw new TypeError("this is not a Date object.")
            }
            var t = Bt(this);
            if (t < 0 && Ht(this) > 11) {
                return t + 1
            }
            return t
        },
        getMonth: function getMonth() {
            if (!this || !(this instanceof Date)) {
                throw new TypeError("this is not a Date object.")
            }
            var t = Bt(this);
            var r = Ht(this);
            if (t < 0 && r > 11) {
                return 0
            }
            return r
        },
        getDate: function getDate() {
            if (!this || !(this instanceof Date)) {
                throw new TypeError("this is not a Date object.")
            }
            var t = Bt(this);
            var r = Ht(this);
            var e = Wt(this);
            if (t < 0 && r > 11) {
                if (r === 12) {
                    return e
                }
                var n = nr(0, t + 1);
                return n - e + 1
            }
            return e
        },
        getUTCFullYear: function getUTCFullYear() {
            if (!this || !(this instanceof Date)) {
                throw new TypeError("this is not a Date object.")
            }
            var t = Lt(this);
            if (t < 0 && Xt(this) > 11) {
                return t + 1
            }
            return t
        },
        getUTCMonth: function getUTCMonth() {
            if (!this || !(this instanceof Date)) {
                throw new TypeError("this is not a Date object.")
            }
            var t = Lt(this);
            var r = Xt(this);
            if (t < 0 && r > 11) {
                return 0
            }
            return r
        },
        getUTCDate: function getUTCDate() {
            if (!this || !(this instanceof Date)) {
                throw new TypeError("this is not a Date object.")
            }
            var t = Lt(this);
            var r = Xt(this);
            var e = qt(this);
            if (t < 0 && r > 11) {
                if (r === 12) {
                    return e
                }
                var n = nr(0, t + 1);
                return n - e + 1
            }
            return e
        }
    }, Pt);
    $(Date.prototype, {
        toUTCString: function toUTCString() {
            if (!this || !(this instanceof Date)) {
                throw new TypeError("this is not a Date object.")
            }
            var t = Kt(this);
            var r = qt(this);
            var e = Xt(this);
            var n = Lt(this);
            var i = Qt(this);
            var a = Vt(this);
            var o = _t(this);
            return rr[t] + ", " + (r < 10 ? "0" + r : r) + " " + er[e] + " " + n + " " + (i < 10 ? "0" + i : i) + ":" + (a < 10 ? "0" + a : a) + ":" + (o < 10 ? "0" + o : o) + " GMT"
        }
    }, Pt || Yt);
    $(Date.prototype, {
        toDateString: function toDateString() {
            if (!this || !(this instanceof Date)) {
                throw new TypeError("this is not a Date object.")
            }
            var t = this.getDay();
            var r = this.getDate();
            var e = this.getMonth();
            var n = this.getFullYear();
            return rr[t] + " " + er[e] + " " + (r < 10 ? "0" + r : r) + " " + n
        }
    }, Pt || Zt);
    if (Pt || zt) {
        Date.prototype.toString = function toString() {
            if (!this || !(this instanceof Date)) {
                throw new TypeError("this is not a Date object.")
            }
            var t = this.getDay();
            var r = this.getDate();
            var e = this.getMonth();
            var n = this.getFullYear();
            var i = this.getHours();
            var a = this.getMinutes();
            var o = this.getSeconds();
            var f = this.getTimezoneOffset();
            var u = Math.floor(Math.abs(f) / 60);
            var l = Math.floor(Math.abs(f) % 60);
            return rr[t] + " " + er[e] + " " + (r < 10 ? "0" + r : r) + " " + n + " " + (i < 10 ? "0" + i : i) + ":" + (a < 10 ? "0" + a : a) + ":" + (o < 10 ? "0" + o : o) + " GMT" + (f > 0 ? "-" : "+") + (u < 10 ? "0" + u : u) + (l < 10 ? "0" + l : l)
        }
        ;
        if (P) {
            e.defineProperty(Date.prototype, "toString", {
                configurable: true,
                enumerable: false,
                writable: true
            })
        }
    }
    var ir = -621987552e5;
    var ar = "-000001";
    var or = Date.prototype.toISOString && new Date(ir).toISOString().indexOf(ar) === -1;
    var fr = Date.prototype.toISOString && new Date(-1).toISOString() !== "1969-12-31T23:59:59.999Z";
    var ur = d.bind(Date.prototype.getTime);
    $(Date.prototype, {
        toISOString: function toISOString() {
            if (!isFinite(this) || !isFinite(ur(this))) {
                throw new RangeError("Date.prototype.toISOString called on non-finite value.")
            }
            var t = Lt(this);
            var r = Xt(this);
            t += Math.floor(r / 12);
            r = (r % 12 + 12) % 12;
            var e = [r + 1, qt(this), Qt(this), Vt(this), _t(this)];
            t = (t < 0 ? "-" : t > 9999 ? "+" : "") + L("00000" + Math.abs(t), 0 <= t && t <= 9999 ? -4 : -6);
            for (var n = 0; n < e.length; ++n) {
                e[n] = L("00" + e[n], -2)
            }
            return t + "-" + H(e, 0, 2).join("-") + "T" + H(e, 2).join(":") + "." + L("000" + tr(this), -3) + "Z"
        }
    }, or || fr);
    var lr = function() {
        try {
            return Date.prototype.toJSON && new Date(NaN).toJSON() === null && new Date(ir).toJSON().indexOf(ar) !== -1 && Date.prototype.toJSON.call({
                toISOString: function() {
                    return true
                }
            })
        } catch (t) {
            return false
        }
    }();
    if (!lr) {
        Date.prototype.toJSON = function toJSON(t) {
            var r = e(this);
            var n = Z.ToPrimitive(r);
            if (typeof n === "number" && !isFinite(n)) {
                return null
            }
            var i = r.toISOString;
            if (!D(i)) {
                throw new TypeError("toISOString property is not callable")
            }
            return i.call(r)
        }
    }
    var sr = Date.parse("+033658-09-27T01:46:40.000Z") === 1e15;
    var cr = !isNaN(Date.parse("2012-04-04T24:00:00.500Z")) || !isNaN(Date.parse("2012-11-31T23:59:59.000Z")) || !isNaN(Date.parse("2012-12-31T23:59:60.000Z"));
    var vr = isNaN(Date.parse("2000-01-01T00:00:00.000Z"));
    if (vr || cr || !sr) {
        var hr = Math.pow(2, 31) - 1;
        var pr = Y(new Date(1970,0,1,0,0,0,hr + 1).getTime());
        Date = function(t) {
            var r = function Date(e, n, i, a, f, u, l) {
                var s = arguments.length;
                var c;
                if (this instanceof t) {
                    var v = u;
                    var h = l;
                    if (pr && s >= 7 && l > hr) {
                        var p = Math.floor(l / hr) * hr;
                        var y = Math.floor(p / 1e3);
                        v += y;
                        h -= y * 1e3
                    }
                    c = s === 1 && o(e) === e ? new t(r.parse(e)) : s >= 7 ? new t(e,n,i,a,f,v,h) : s >= 6 ? new t(e,n,i,a,f,v) : s >= 5 ? new t(e,n,i,a,f) : s >= 4 ? new t(e,n,i,a) : s >= 3 ? new t(e,n,i) : s >= 2 ? new t(e,n) : s >= 1 ? new t(e instanceof t ? +e : e) : new t
                } else {
                    c = t.apply(this, arguments)
                }
                if (!J(c)) {
                    $(c, {
                        constructor: r
                    }, true)
                }
                return c
            };
            var e = new RegExp("^" + "(\\d{4}|[+-]\\d{6})" + "(?:-(\\d{2})" + "(?:-(\\d{2})" + "(?:" + "T(\\d{2})" + ":(\\d{2})" + "(?:" + ":(\\d{2})" + "(?:(\\.\\d{1,}))?" + ")?" + "(" + "Z|" + "(?:" + "([-+])" + "(\\d{2})" + ":(\\d{2})" + ")" + ")?)?)?)?" + "$");
            var n = [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365];
            var i = function dayFromMonth(t, r) {
                var e = r > 1 ? 1 : 0;
                return n[r] + Math.floor((t - 1969 + e) / 4) - Math.floor((t - 1901 + e) / 100) + Math.floor((t - 1601 + e) / 400) + 365 * (t - 1970)
            };
            var a = function toUTC(r) {
                var e = 0;
                var n = r;
                if (pr && n > hr) {
                    var i = Math.floor(n / hr) * hr;
                    var a = Math.floor(i / 1e3);
                    e += a;
                    n -= a * 1e3
                }
                return u(new t(1970,0,1,0,0,e,n))
            };
            for (var f in t) {
                if (G(t, f)) {
                    r[f] = t[f]
                }
            }
            $(r, {
                now: t.now,
                UTC: t.UTC
            }, true);
            r.prototype = t.prototype;
            $(r.prototype, {
                constructor: r
            }, true);
            var l = function parse(r) {
                var n = e.exec(r);
                if (n) {
                    var o = u(n[1]), f = u(n[2] || 1) - 1, l = u(n[3] || 1) - 1, s = u(n[4] || 0), c = u(n[5] || 0), v = u(n[6] || 0), h = Math.floor(u(n[7] || 0) * 1e3), p = Boolean(n[4] && !n[8]), y = n[9] === "-" ? 1 : -1, d = u(n[10] || 0), g = u(n[11] || 0), w;
                    var b = c > 0 || v > 0 || h > 0;
                    if (s < (b ? 24 : 25) && c < 60 && v < 60 && h < 1e3 && f > -1 && f < 12 && d < 24 && g < 60 && l > -1 && l < i(o, f + 1) - i(o, f)) {
                        w = ((i(o, f) + l) * 24 + s + d * y) * 60;
                        w = ((w + c + g * y) * 60 + v) * 1e3 + h;
                        if (p) {
                            w = a(w)
                        }
                        if (-864e13 <= w && w <= 864e13) {
                            return w
                        }
                    }
                    return NaN
                }
                return t.parse.apply(this, arguments)
            };
            $(r, {
                parse: l
            });
            return r
        }(Date)
    }
    if (!Date.now) {
        Date.now = function now() {
            return (new Date).getTime()
        }
    }
    var yr = l.toFixed && (8e-5.toFixed(3) !== "0.000" || .9.toFixed(0) !== "1" || 1.255.toFixed(2) !== "1.25" || 0xde0b6b3a7640080.toFixed(0) !== "1000000000000000128");
    var dr = {
        base: 1e7,
        size: 6,
        data: [0, 0, 0, 0, 0, 0],
        multiply: function multiply(t, r) {
            var e = -1;
            var n = r;
            while (++e < dr.size) {
                n += t * dr.data[e];
                dr.data[e] = n % dr.base;
                n = Math.floor(n / dr.base)
            }
        },
        divide: function divide(t) {
            var r = dr.size;
            var e = 0;
            while (--r >= 0) {
                e += dr.data[r];
                dr.data[r] = Math.floor(e / t);
                e = e % t * dr.base
            }
        },
        numToString: function numToString() {
            var t = dr.size;
            var r = "";
            while (--t >= 0) {
                if (r !== "" || t === 0 || dr.data[t] !== 0) {
                    var e = o(dr.data[t]);
                    if (r === "") {
                        r = e
                    } else {
                        r += L("0000000", 0, 7 - e.length) + e
                    }
                }
            }
            return r
        },
        pow: function pow(t, r, e) {
            return r === 0 ? e : r % 2 === 1 ? pow(t, r - 1, e * t) : pow(t * t, r / 2, e)
        },
        log: function log(t) {
            var r = 0;
            var e = t;
            while (e >= 4096) {
                r += 12;
                e /= 4096
            }
            while (e >= 2) {
                r += 1;
                e /= 2
            }
            return r
        }
    };
    var gr = function toFixed(t) {
        var r, e, n, i, a, f, l, s;
        r = u(t);
        r = Y(r) ? 0 : Math.floor(r);
        if (r < 0 || r > 20) {
            throw new RangeError("Number.toFixed called with invalid number of decimals")
        }
        e = u(this);
        if (Y(e)) {
            return "NaN"
        }
        if (e <= -1e21 || e >= 1e21) {
            return o(e)
        }
        n = "";
        if (e < 0) {
            n = "-";
            e = -e
        }
        i = "0";
        if (e > 1e-21) {
            a = dr.log(e * dr.pow(2, 69, 1)) - 69;
            f = a < 0 ? e * dr.pow(2, -a, 1) : e / dr.pow(2, a, 1);
            f *= 4503599627370496;
            a = 52 - a;
            if (a > 0) {
                dr.multiply(0, f);
                l = r;
                while (l >= 7) {
                    dr.multiply(1e7, 0);
                    l -= 7
                }
                dr.multiply(dr.pow(10, l, 1), 0);
                l = a - 1;
                while (l >= 23) {
                    dr.divide(1 << 23);
                    l -= 23
                }
                dr.divide(1 << l);
                dr.multiply(1, 1);
                dr.divide(2);
                i = dr.numToString()
            } else {
                dr.multiply(0, f);
                dr.multiply(1 << -a, 0);
                i = dr.numToString() + L("0.00000000000000000000", 2, 2 + r)
            }
        }
        if (r > 0) {
            s = i.length;
            if (s <= r) {
                i = n + L("0.0000000000000000000", 0, r - s + 2) + i
            } else {
                i = n + L(i, 0, s - r) + "." + L(i, s - r)
            }
        } else {
            i = n + i
        }
        return i
    };
    $(l, {
        toFixed: gr
    }, yr);
    var wr = function() {
        try {
            return 1..toPrecision(undefined) === "1"
        } catch (t) {
            return true
        }
    }();
    var br = l.toPrecision;
    $(l, {
        toPrecision: function toPrecision(t) {
            return typeof t === "undefined" ? br.call(this) : br.call(this, t)
        }
    }, wr);
    if ("ab".split(/(?:ab)*/).length !== 2 || ".".split(/(.?)(.?)/).length !== 4 || "tesst".split(/(s)*/)[1] === "t" || "test".split(/(?:)/, -1).length !== 4 || "".split(/.?/).length || ".".split(/()()/).length > 1) {
        (function() {
            var t = typeof /()??/.exec("")[1] === "undefined";
            var r = Math.pow(2, 32) - 1;
            f.split = function(e, n) {
                var i = String(this);
                if (typeof e === "undefined" && n === 0) {
                    return []
                }
                if (!M(e)) {
                    return X(this, e, n)
                }
                var a = [];
                var o = (e.ignoreCase ? "i" : "") + (e.multiline ? "m" : "") + (e.unicode ? "u" : "") + (e.sticky ? "y" : ""), f = 0, u, l, s, c;
                var h = new RegExp(e.source,o + "g");
                if (!t) {
                    u = new RegExp("^" + h.source + "$(?!\\s)",o)
                }
                var p = typeof n === "undefined" ? r : Z.ToUint32(n);
                l = h.exec(i);
                while (l) {
                    s = l.index + l[0].length;
                    if (s > f) {
                        K(a, L(i, f, l.index));
                        if (!t && l.length > 1) {
                            l[0].replace(u, function() {
                                for (var t = 1; t < arguments.length - 2; t++) {
                                    if (typeof arguments[t] === "undefined") {
                                        l[t] = void 0
                                    }
                                }
                            })
                        }
                        if (l.length > 1 && l.index < i.length) {
                            v.apply(a, H(l, 1))
                        }
                        c = l[0].length;
                        f = s;
                        if (a.length >= p) {
                            break
                        }
                    }
                    if (h.lastIndex === l.index) {
                        h.lastIndex++
                    }
                    l = h.exec(i)
                }
                if (f === i.length) {
                    if (c || !h.test("")) {
                        K(a, "")
                    }
                } else {
                    K(a, L(i, f))
                }
                return a.length > p ? H(a, 0, p) : a
            }
        }
        )()
    } else if ("0".split(void 0, 0).length) {
        f.split = function split(t, r) {
            if (typeof t === "undefined" && r === 0) {
                return []
            }
            return X(this, t, r)
        }
    }
    var Tr = f.replace;
    var mr = function() {
        var t = [];
        "x".replace(/x(.)?/g, function(r, e) {
            K(t, e)
        });
        return t.length === 1 && typeof t[0] === "undefined"
    }();
    if (!mr) {
        f.replace = function replace(t, r) {
            var e = D(r);
            var n = M(t) && /\)[*?]/.test(t.source);
            if (!e || !n) {
                return Tr.call(this, t, r)
            } else {
                var i = function(e) {
                    var n = arguments.length;
                    var i = t.lastIndex;
                    t.lastIndex = 0;
                    var a = t.exec(e) || [];
                    t.lastIndex = i;
                    K(a, arguments[n - 2], arguments[n - 1]);
                    return r.apply(this, a)
                };
                return Tr.call(this, t, i)
            }
        }
    }
    var Dr = f.substr;
    var Sr = "".substr && "0b".substr(-1) !== "b";
    $(f, {
        substr: function substr(t, r) {
            var e = t;
            if (t < 0) {
                e = w(this.length + t, 0)
            }
            return Dr.call(this, e, r)
        }
    }, Sr);
    var xr = "	\n\x0B\f\r \xa0\u1680\u180e\u2000\u2001\u2002\u2003" + "\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028" + "\u2029\ufeff";
    var Or = "\u200b";
    var jr = "[" + xr + "]";
    var Er = new RegExp("^" + jr + jr + "*");
    var Ir = new RegExp(jr + jr + "*$");
    var Mr = f.trim && (xr.trim() || !Or.trim());
    $(f, {
        trim: function trim() {
            if (typeof this === "undefined" || this === null) {
                throw new TypeError("can't convert " + this + " to object")
            }
            return o(this).replace(Er, "").replace(Ir, "")
        }
    }, Mr);
    var Ur = d.bind(String.prototype.trim);
    var Fr = f.lastIndexOf && "abc\u3042\u3044".lastIndexOf("\u3042\u3044", 2) !== -1;
    $(f, {
        lastIndexOf: function lastIndexOf(t) {
            if (typeof this === "undefined" || this === null) {
                throw new TypeError("can't convert " + this + " to object")
            }
            var r = o(this);
            var e = o(t);
            var n = arguments.length > 1 ? u(arguments[1]) : NaN;
            var i = Y(n) ? Infinity : Z.ToInteger(n);
            var a = b(w(i, 0), r.length);
            var f = e.length;
            var l = a + f;
            while (l > 0) {
                l = w(0, l - f);
                var s = q(L(r, l, a + f), e);
                if (s !== -1) {
                    return l + s
                }
            }
            return -1
        }
    }, Fr);
    var Nr = f.lastIndexOf;
    $(f, {
        lastIndexOf: function lastIndexOf(t) {
            return Nr.apply(this, arguments)
        }
    }, f.lastIndexOf.length !== 1);
    if (parseInt(xr + "08") !== 8 || parseInt(xr + "0x16") !== 22) {
        parseInt = function(t) {
            var r = /^[\-+]?0[xX]/;
            return function parseInt(e, n) {
                var i = Ur(String(e));
                var a = u(n) || (r.test(i) ? 16 : 10);
                return t(i, a)
            }
        }(parseInt)
    }
    if (1 / parseFloat("-0") !== -Infinity) {
        parseFloat = function(t) {
            return function parseFloat(r) {
                var e = Ur(String(r));
                var n = t(e);
                return n === 0 && L(e, 0, 1) === "-" ? -0 : n
            }
        }(parseFloat)
    }
    if (String(new RangeError("test")) !== "RangeError: test") {
        var Cr = function toString() {
            if (typeof this === "undefined" || this === null) {
                throw new TypeError("can't convert " + this + " to object")
            }
            var t = this.name;
            if (typeof t === "undefined") {
                t = "Error"
            } else if (typeof t !== "string") {
                t = o(t)
            }
            var r = this.message;
            if (typeof r === "undefined") {
                r = ""
            } else if (typeof r !== "string") {
                r = o(r)
            }
            if (!t) {
                return r
            }
            if (!r) {
                return t
            }
            return t + ": " + r
        };
        Error.prototype.toString = Cr
    }
    if (P) {
        var kr = function(t, r) {
            if (Q(t, r)) {
                var e = Object.getOwnPropertyDescriptor(t, r);
                if (e.configurable) {
                    e.enumerable = false;
                    Object.defineProperty(t, r, e)
                }
            }
        };
        kr(Error.prototype, "message");
        if (Error.prototype.message !== "") {
            Error.prototype.message = ""
        }
        kr(Error.prototype, "name")
    }
    if (String(/a/gim) !== "/a/gim") {
        var Ar = function toString() {
            var t = "/" + this.source + "/";
            if (this.global) {
                t += "g"
            }
            if (this.ignoreCase) {
                t += "i"
            }
            if (this.multiline) {
                t += "m"
            }
            return t
        };
        RegExp.prototype.toString = Ar
    }
});
//# sourceMappingURL=es5-shim.map

!function(t, e) {
    "object" == typeof exports && "undefined" != typeof module ? module.exports = e() : "function" == typeof define && define.amd ? define(e) : t.ES6Promise = e()
}(this, function() {
    "use strict";
    function t(t) {
        var e = typeof t;
        return null !== t && ("object" === e || "function" === e)
    }
    function e(t) {
        return "function" == typeof t
    }
    function n(t) {
        I = t
    }
    function r(t) {
        J = t
    }
    function o() {
        return function() {
            return process.nextTick(a)
        }
    }
    function i() {
        return "undefined" != typeof H ? function() {
            H(a)
        }
        : c()
    }
    function s() {
        var t = 0
          , e = new V(a)
          , n = document.createTextNode("");
        return e.observe(n, {
            characterData: !0
        }),
        function() {
            n.data = t = ++t % 2
        }
    }
    function u() {
        var t = new MessageChannel;
        return t.port1.onmessage = a,
        function() {
            return t.port2.postMessage(0)
        }
    }
    function c() {
        var t = setTimeout;
        return function() {
            return t(a, 1)
        }
    }
    function a() {
        for (var t = 0; t < G; t += 2) {
            var e = $[t]
              , n = $[t + 1];
            e(n),
            $[t] = void 0,
            $[t + 1] = void 0
        }
        G = 0
    }
    function f() {
        try {
            var t = require
              , e = t("vertx");
            return H = e.runOnLoop || e.runOnContext,
            i()
        } catch (n) {
            return c()
        }
    }
    function l(t, e) {
        var n = arguments
          , r = this
          , o = new this.constructor(p);
        void 0 === o[et] && k(o);
        var i = r._state;
        return i ? !function() {
            var t = n[i - 1];
            J(function() {
                return x(i, o, t, r._result)
            })
        }() : E(r, o, t, e),
        o
    }
    function h(t) {
        var e = this;
        if (t && "object" == typeof t && t.constructor === e)
            return t;
        var n = new e(p);
        return g(n, t),
        n
    }
    function p() {}
    function v() {
        return new TypeError("You cannot resolve a promise with itself")
    }
    function d() {
        return new TypeError("A promises callback cannot return that same promise.")
    }
    function _(t) {
        try {
            return t.then
        } catch (e) {
            return it.error = e,
            it
        }
    }
    function y(t, e, n, r) {
        try {
            t.call(e, n, r)
        } catch (o) {
            return o
        }
    }
    function m(t, e, n) {
        J(function(t) {
            var r = !1
              , o = y(n, e, function(n) {
                r || (r = !0,
                e !== n ? g(t, n) : S(t, n))
            }, function(e) {
                r || (r = !0,
                j(t, e))
            }, "Settle: " + (t._label || " unknown promise"));
            !r && o && (r = !0,
            j(t, o))
        }, t)
    }
    function b(t, e) {
        e._state === rt ? S(t, e._result) : e._state === ot ? j(t, e._result) : E(e, void 0, function(e) {
            return g(t, e)
        }, function(e) {
            return j(t, e)
        })
    }
    function w(t, n, r) {
        n.constructor === t.constructor && r === l && n.constructor.resolve === h ? b(t, n) : r === it ? (j(t, it.error),
        it.error = null) : void 0 === r ? S(t, n) : e(r) ? m(t, n, r) : S(t, n)
    }
    function g(e, n) {
        e === n ? j(e, v()) : t(n) ? w(e, n, _(n)) : S(e, n)
    }
    function A(t) {
        t._onerror && t._onerror(t._result),
        T(t)
    }
    function S(t, e) {
        t._state === nt && (t._result = e,
        t._state = rt,
        0 !== t._subscribers.length && J(T, t))
    }
    function j(t, e) {
        t._state === nt && (t._state = ot,
        t._result = e,
        J(A, t))
    }
    function E(t, e, n, r) {
        var o = t._subscribers
          , i = o.length;
        t._onerror = null,
        o[i] = e,
        o[i + rt] = n,
        o[i + ot] = r,
        0 === i && t._state && J(T, t)
    }
    function T(t) {
        var e = t._subscribers
          , n = t._state;
        if (0 !== e.length) {
            for (var r = void 0, o = void 0, i = t._result, s = 0; s < e.length; s += 3)
                r = e[s],
                o = e[s + n],
                r ? x(n, r, o, i) : o(i);
            t._subscribers.length = 0
        }
    }
    function M() {
        this.error = null
    }
    function P(t, e) {
        try {
            return t(e)
        } catch (n) {
            return st.error = n,
            st
        }
    }
    function x(t, n, r, o) {
        var i = e(r)
          , s = void 0
          , u = void 0
          , c = void 0
          , a = void 0;
        if (i) {
            if (s = P(r, o),
            s === st ? (a = !0,
            u = s.error,
            s.error = null) : c = !0,
            n === s)
                return void j(n, d())
        } else
            s = o,
            c = !0;
        n._state !== nt || (i && c ? g(n, s) : a ? j(n, u) : t === rt ? S(n, s) : t === ot && j(n, s))
    }
    function C(t, e) {
        try {
            e(function(e) {
                g(t, e)
            }, function(e) {
                j(t, e)
            })
        } catch (n) {
            j(t, n)
        }
    }
    function O() {
        return ut++
    }
    function k(t) {
        t[et] = ut++,
        t._state = void 0,
        t._result = void 0,
        t._subscribers = []
    }
    function Y(t, e) {
        this._instanceConstructor = t,
        this.promise = new t(p),
        this.promise[et] || k(this.promise),
        B(e) ? (this.length = e.length,
        this._remaining = e.length,
        this._result = new Array(this.length),
        0 === this.length ? S(this.promise, this._result) : (this.length = this.length || 0,
        this._enumerate(e),
        0 === this._remaining && S(this.promise, this._result))) : j(this.promise, q())
    }
    function q() {
        return new Error("Array Methods must be provided an Array")
    }
    function F(t) {
        return new Y(this,t).promise
    }
    function D(t) {
        var e = this;
        return new e(B(t) ? function(n, r) {
            for (var o = t.length, i = 0; i < o; i++)
                e.resolve(t[i]).then(n, r)
        }
        : function(t, e) {
            return e(new TypeError("You must pass an array to race."))
        }
        )
    }
    function K(t) {
        var e = this
          , n = new e(p);
        return j(n, t),
        n
    }
    function L() {
        throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")
    }
    function N() {
        throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")
    }
    function U(t) {
        this[et] = O(),
        this._result = this._state = void 0,
        this._subscribers = [],
        p !== t && ("function" != typeof t && L(),
        this instanceof U ? C(this, t) : N())
    }
    function W() {
        var t = void 0;
        if ("undefined" != typeof global)
            t = global;
        else if ("undefined" != typeof self)
            t = self;
        else
            try {
                t = Function("return this")()
            } catch (e) {
                throw new Error("polyfill failed because global object is unavailable in this environment")
            }
        var n = t.Promise;
        if (n) {
            var r = null;
            try {
                r = Object.prototype.toString.call(n.resolve())
            } catch (e) {}
            if ("[object Promise]" === r && !n.cast)
                return
        }
        t.Promise = U
    }
    var z = void 0;
    z = Array.isArray ? Array.isArray : function(t) {
        return "[object Array]" === Object.prototype.toString.call(t)
    }
    ;
    var B = z
      , G = 0
      , H = void 0
      , I = void 0
      , J = function(t, e) {
        $[G] = t,
        $[G + 1] = e,
        G += 2,
        2 === G && (I ? I(a) : tt())
    }
      , Q = "undefined" != typeof window ? window : void 0
      , R = Q || {}
      , V = R.MutationObserver || R.WebKitMutationObserver
      , X = "undefined" == typeof self && "undefined" != typeof process && "[object process]" === {}.toString.call(process)
      , Z = "undefined" != typeof Uint8ClampedArray && "undefined" != typeof importScripts && "undefined" != typeof MessageChannel
      , $ = new Array(1e3)
      , tt = void 0;
    tt = X ? o() : V ? s() : Z ? u() : void 0 === Q && "function" == typeof require ? f() : c();
    var et = Math.random().toString(36).substring(16)
      , nt = void 0
      , rt = 1
      , ot = 2
      , it = new M
      , st = new M
      , ut = 0;
    return Y.prototype._enumerate = function(t) {
        for (var e = 0; this._state === nt && e < t.length; e++)
            this._eachEntry(t[e], e)
    }
    ,
    Y.prototype._eachEntry = function(t, e) {
        var n = this._instanceConstructor
          , r = n.resolve;
        if (r === h) {
            var o = _(t);
            if (o === l && t._state !== nt)
                this._settledAt(t._state, e, t._result);
            else if ("function" != typeof o)
                this._remaining--,
                this._result[e] = t;
            else if (n === U) {
                var i = new n(p);
                w(i, t, o),
                this._willSettleAt(i, e)
            } else
                this._willSettleAt(new n(function(e) {
                    return e(t)
                }
                ), e)
        } else
            this._willSettleAt(r(t), e)
    }
    ,
    Y.prototype._settledAt = function(t, e, n) {
        var r = this.promise;
        r._state === nt && (this._remaining--,
        t === ot ? j(r, n) : this._result[e] = n),
        0 === this._remaining && S(r, this._result)
    }
    ,
    Y.prototype._willSettleAt = function(t, e) {
        var n = this;
        E(t, void 0, function(t) {
            return n._settledAt(rt, e, t)
        }, function(t) {
            return n._settledAt(ot, e, t)
        })
    }
    ,
    U.all = F,
    U.race = D,
    U.resolve = h,
    U.reject = K,
    U._setScheduler = n,
    U._setAsap = r,
    U._asap = J,
    U.prototype = {
        constructor: U,
        then: l,
        "catch": function(t) {
            return this.then(null, t)
        }
    },
    U.polyfill = W,
    U.Promise = U,
    U.polyfill(),
    U
});
/*! matchMedia() polyfill - Test a CSS media type/query in JS. Authors & copyright (c) 2012: Scott Jehl, Paul Irish, Nicholas Zakas, David Knight. Dual MIT/BSD license */

window.matchMedia || (window.matchMedia = function() {
    "use strict";

    // For browsers that support matchMedium api such as IE 9 and webkit
    var styleMedia = (window.styleMedia || window.media);

    // For those that don't support matchMedium
    if (!styleMedia) {
        var style = document.createElement('style')
          , script = document.getElementsByTagName('script')[0]
          , info = null;

        style.type = 'text/css';
        style.id = 'matchmediajs-test';

        script.parentNode.insertBefore(style, script);

        // 'style.currentStyle' is used by IE <= 8 and 'window.getComputedStyle' for all other browsers
        info = ('getComputedStyle'in window) && window.getComputedStyle(style, null) || style.currentStyle;

        styleMedia = {
            matchMedium: function(media) {
                var text = '@media ' + media + '{ #matchmediajs-test { width: 1px; } }';

                // 'style.styleSheet' is used by IE <= 8 and 'style.textContent' for all other browsers
                if (style.styleSheet) {
                    style.styleSheet.cssText = text;
                } else {
                    style.textContent = text;
                }

                // Test if media query is true or false
                return info.width === '1px';
            }
        };
    }

    return function(media) {
        return {
            matches: styleMedia.matchMedium(media || 'all'),
            media: media || 'all'
        };
    }
    ;
}());

/*! matchMedia() polyfill addListener/removeListener extension. Author & copyright (c) 2012: Scott Jehl. Dual MIT/BSD license */
(function() {
    // Bail out for browsers that have addListener support
    if (window.matchMedia && window.matchMedia('all').addListener) {
        return false;
    }

    var localMatchMedia = window.matchMedia
      , hasMediaQueries = localMatchMedia('only all').matches
      , isListening = false
      , timeoutID = 0
      , // setTimeout for debouncing 'handleChange'
    queries = []
      , // Contains each 'mql' and associated 'listeners' if 'addListener' is used
    handleChange = function(evt) {
        // Debounce
        clearTimeout(timeoutID);

        timeoutID = setTimeout(function() {
            for (var i = 0, il = queries.length; i < il; i++) {
                var mql = queries[i].mql
                  , listeners = queries[i].listeners || []
                  , matches = localMatchMedia(mql.media).matches;

                // Update mql.matches value and call listeners
                // Fire listeners only if transitioning to or from matched state
                if (matches !== mql.matches) {
                    mql.matches = matches;

                    for (var j = 0, jl = listeners.length; j < jl; j++) {
                        listeners[j].call(window, mql);
                    }
                }
            }
        }, 30);
    };

    window.matchMedia = function(media) {
        var mql = localMatchMedia(media)
          , listeners = []
          , index = 0;

        mql.addListener = function(listener) {
            // Changes would not occur to css media type so return now (Affects IE <= 8)
            if (!hasMediaQueries) {
                return;
            }

            // Set up 'resize' listener for browsers that support CSS3 media queries (Not for IE <= 8)
            // There should only ever be 1 resize listener running for performance
            if (!isListening) {
                isListening = true;
                window.addEventListener('resize', handleChange, true);
            }

            // Push object only if it has not been pushed already
            if (index === 0) {
                index = queries.push({
                    mql: mql,
                    listeners: listeners
                });
            }

            listeners.push(listener);
        }
        ;

        mql.removeListener = function(listener) {
            for (var i = 0, il = listeners.length; i < il; i++) {
                if (listeners[i] === listener) {
                    listeners.splice(i, 1);
                }
            }
        }
        ;

        return mql;
    }
    ;
}());

/* Laura Doktorova https://github.com/olado/doT */
(function() {
    function p(b, a, d) {
        return ("string" === typeof a ? a : a.toString()).replace(b.define || h, function(a, c, e, g) {
            0 === c.indexOf("def.") && (c = c.substring(4));
            c in d || (":" === e ? (b.defineParams && g.replace(b.defineParams, function(a, b, l) {
                d[c] = {
                    arg: b,
                    text: l
                }
            }),
            c in d || (d[c] = g)) : (new Function("def","def['" + c + "']=" + g))(d));
            return ""
        }).replace(b.use || h, function(a, c) {
            b.useParams && (c = c.replace(b.useParams, function(a, b, c, l) {
                if (d[c] && d[c].arg && l)
                    return a = (c + ":" + l).replace(/'|\\/g, "_"),
                    d.__exp = d.__exp || {},
                    d.__exp[a] = d[c].text.replace(new RegExp("(^|[^\\w$])" + d[c].arg + "([^\\w$])","g"), "$1" + l + "$2"),
                    b + "def.__exp['" + a + "']"
            }));
            var e = (new Function("def","return " + c))(d);
            return e ? p(b, e, d) : e
        })
    }
    function k(b) {
        return b.replace(/\\('|\\)/g, "$1").replace(/[\r\t\n]/g, " ")
    }
    var f = {
        version: "1.0.3",
        templateSettings: {
            evaluate: /\{\{([\s\S]+?(\}?)+)\}\}/g,
            interpolate: /\{\{=([\s\S]+?)\}\}/g,
            encode: /\{\{!([\s\S]+?)\}\}/g,
            use: /\{\{#([\s\S]+?)\}\}/g,
            useParams: /(^|[^\w$])def(?:\.|\[[\'\"])([\w$\.]+)(?:[\'\"]\])?\s*\:\s*([\w$\.]+|\"[^\"]+\"|\'[^\']+\'|\{[^\}]+\})/g,
            define: /\{\{##\s*([\w\.$]+)\s*(\:|=)([\s\S]+?)#\}\}/g,
            defineParams: /^\s*([\w$]+):([\s\S]+)/,
            conditional: /\{\{\?(\?)?\s*([\s\S]*?)\s*\}\}/g,
            iterate: /\{\{~\s*(?:\}\}|([\s\S]+?)\s*\:\s*([\w$]+)\s*(?:\:\s*([\w$]+))?\s*\}\})/g,
            varname: "it",
            strip: !0,
            append: !0,
            selfcontained: !1,
            doNotSkipEncoded: !1
        },
        template: void 0,
        compile: void 0
    }, m;
    f.encodeHTMLSource = function(b) {
        var a = {
            "&": "&#38;",
            "<": "&#60;",
            ">": "&#62;",
            '"': "&#34;",
            "'": "&#39;",
            "/": "&#47;"
        }
          , d = b ? /[&<>"'\/]/g : /&(?!#?\w+;)|<|>|"|'|\//g;
        return function(b) {
            return b ? b.toString().replace(d, function(b) {
                return a[b] || b
            }) : ""
        }
    }
    ;
    m = function() {
        return this || (0,
        eval)("this")
    }();
    "undefined" !== typeof module && module.exports ? module.exports = f : "function" === typeof define && define.amd ? define(function() {
        return f
    }) : m.doT = f;
    var r = {
        start: "'+(",
        end: ")+'",
        startencode: "'+encodeHTML("
    }
      , s = {
        start: "';out+=(",
        end: ");out+='",
        startencode: "';out+=encodeHTML("
    }
      , h = /$^/;
    f.template = function(b, a, d) {
        a = a || f.templateSettings;
        var n = a.append ? r : s, c, e = 0, g;
        b = a.use || a.define ? p(a, b, d || {}) : b;
        b = ("var out='" + (a.strip ? b.replace(/(^|\r|\n)\t* +| +\t*(\r|\n|$)/g, " ").replace(/\r|\n|\t|\/\*[\s\S]*?\*\//g, "") : b).replace(/'|\\/g, "\\$&").replace(a.interpolate || h, function(b, a) {
            return n.start + k(a) + n.end
        }).replace(a.encode || h, function(b, a) {
            c = !0;
            return n.startencode + k(a) + n.end
        }).replace(a.conditional || h, function(b, a, c) {
            return a ? c ? "';}else if(" + k(c) + "){out+='" : "';}else{out+='" : c ? "';if(" + k(c) + "){out+='" : "';}out+='"
        }).replace(a.iterate || h, function(b, a, c, d) {
            if (!a)
                return "';} } out+='";
            e += 1;
            g = d || "i" + e;
            a = k(a);
            return "';var arr" + e + "=" + a + ";if(arr" + e + "){var " + c + "," + g + "=-1,l" + e + "=arr" + e + ".length-1;while(" + g + "<l" + e + "){" + c + "=arr" + e + "[" + g + "+=1];out+='"
        }).replace(a.evaluate || h, function(a, b) {
            return "';" + k(b) + "out+='"
        }) + "';return out;").replace(/\n/g, "\\n").replace(/\t/g, "\\t").replace(/\r/g, "\\r").replace(/(\s|;|\}|^|\{)out\+='';/g, "$1").replace(/\+''/g, "");
        c && (a.selfcontained || !m || m._encodeHTML || (m._encodeHTML = f.encodeHTMLSource(a.doNotSkipEncoded)),
        b = "var encodeHTML = typeof _encodeHTML !== 'undefined' ? _encodeHTML : (" + f.encodeHTMLSource.toString() + "(" + (a.doNotSkipEncoded || "") + "));" + b);
        try {
            return new Function(a.varname,b)
        } catch (q) {
            throw "undefined" !== typeof console && console.log("Could not create a template function: " + b),
            q;
        }
    }
    ;
    f.compile = function(b, a) {
        return f.template(b, null, a)
    }
}
)();

/*! picturefill - v3.0.2 - 2016-02-12
 * https://scottjehl.github.io/picturefill/
 * Copyright (c) 2016 https://github.com/scottjehl/picturefill/blob/master/Authors.txt; Licensed MIT
 */
!function(a) {
    var b = navigator.userAgent;
    a.HTMLPictureElement && /ecko/.test(b) && b.match(/rv\:(\d+)/) && RegExp.$1 < 45 && addEventListener("resize", function() {
        var b, c = document.createElement("source"), d = function(a) {
            var b, d, e = a.parentNode;
            "PICTURE" === e.nodeName.toUpperCase() ? (b = c.cloneNode(),
            e.insertBefore(b, e.firstElementChild),
            setTimeout(function() {
                e.removeChild(b)
            })) : (!a._pfLastSize || a.offsetWidth > a._pfLastSize) && (a._pfLastSize = a.offsetWidth,
            d = a.sizes,
            a.sizes += ",100vw",
            setTimeout(function() {
                a.sizes = d
            }))
        }, e = function() {
            var a, b = document.querySelectorAll("picture > img, img[srcset][sizes]");
            for (a = 0; a < b.length; a++)
                d(b[a])
        }, f = function() {
            clearTimeout(b),
            b = setTimeout(e, 99)
        }, g = a.matchMedia && matchMedia("(orientation: landscape)"), h = function() {
            f(),
            g && g.addListener && g.addListener(f)
        };
        return c.srcset = "data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==",
        /^[c|i]|d$/.test(document.readyState || "") ? h() : document.addEventListener("DOMContentLoaded", h),
        f
    }())
}(window),
function(a, b, c) {
    "use strict";
    function d(a) {
        return " " === a || "	" === a || "\n" === a || "\f" === a || "\r" === a
    }
    function e(b, c) {
        var d = new a.Image;
        return d.onerror = function() {
            A[b] = !1,
            ba()
        }
        ,
        d.onload = function() {
            A[b] = 1 === d.width,
            ba()
        }
        ,
        d.src = c,
        "pending"
    }
    function f() {
        M = !1,
        P = a.devicePixelRatio,
        N = {},
        O = {},
        s.DPR = P || 1,
        Q.width = Math.max(a.innerWidth || 0, z.clientWidth),
        Q.height = Math.max(a.innerHeight || 0, z.clientHeight),
        Q.vw = Q.width / 100,
        Q.vh = Q.height / 100,
        r = [Q.height, Q.width, P].join("-"),
        Q.em = s.getEmValue(),
        Q.rem = Q.em
    }
    function g(a, b, c, d) {
        var e, f, g, h;
        return "saveData" === B.algorithm ? a > 2.7 ? h = c + 1 : (f = b - c,
        e = Math.pow(a - .6, 1.5),
        g = f * e,
        d && (g += .1 * e),
        h = a + g) : h = c > 1 ? Math.sqrt(a * b) : a,
        h > c
    }
    function h(a) {
        var b, c = s.getSet(a), d = !1;
        "pending" !== c && (d = r,
        c && (b = s.setRes(c),
        s.applySetCandidate(b, a))),
        a[s.ns].evaled = d
    }
    function i(a, b) {
        return a.res - b.res
    }
    function j(a, b, c) {
        var d;
        return !c && b && (c = a[s.ns].sets,
        c = c && c[c.length - 1]),
        d = k(b, c),
        d && (b = s.makeUrl(b),
        a[s.ns].curSrc = b,
        a[s.ns].curCan = d,
        d.res || aa(d, d.set.sizes)),
        d
    }
    function k(a, b) {
        var c, d, e;
        if (a && b)
            for (e = s.parseSet(b),
            a = s.makeUrl(a),
            c = 0; c < e.length; c++)
                if (a === s.makeUrl(e[c].url)) {
                    d = e[c];
                    break
                }
        return d
    }
    function l(a, b) {
        var c, d, e, f, g = a.getElementsByTagName("source");
        for (c = 0,
        d = g.length; d > c; c++)
            e = g[c],
            e[s.ns] = !0,
            f = e.getAttribute("srcset"),
            f && b.push({
                srcset: f,
                media: e.getAttribute("media"),
                type: e.getAttribute("type"),
                sizes: e.getAttribute("sizes")
            })
    }
    function m(a, b) {
        function c(b) {
            var c, d = b.exec(a.substring(m));
            return d ? (c = d[0],
            m += c.length,
            c) : void 0
        }
        function e() {
            var a, c, d, e, f, i, j, k, l, m = !1, o = {};
            for (e = 0; e < h.length; e++)
                f = h[e],
                i = f[f.length - 1],
                j = f.substring(0, f.length - 1),
                k = parseInt(j, 10),
                l = parseFloat(j),
                X.test(j) && "w" === i ? ((a || c) && (m = !0),
                0 === k ? m = !0 : a = k) : Y.test(j) && "x" === i ? ((a || c || d) && (m = !0),
                0 > l ? m = !0 : c = l) : X.test(j) && "h" === i ? ((d || c) && (m = !0),
                0 === k ? m = !0 : d = k) : m = !0;
            m || (o.url = g,
            a && (o.w = a),
            c && (o.d = c),
            d && (o.h = d),
            d || c || a || (o.d = 1),
            1 === o.d && (b.has1x = !0),
            o.set = b,
            n.push(o))
        }
        function f() {
            for (c(T),
            i = "",
            j = "in descriptor"; ; ) {
                if (k = a.charAt(m),
                "in descriptor" === j)
                    if (d(k))
                        i && (h.push(i),
                        i = "",
                        j = "after descriptor");
                    else {
                        if ("," === k)
                            return m += 1,
                            i && h.push(i),
                            void e();
                        if ("(" === k)
                            i += k,
                            j = "in parens";
                        else {
                            if ("" === k)
                                return i && h.push(i),
                                void e();
                            i += k
                        }
                    }
                else if ("in parens" === j)
                    if (")" === k)
                        i += k,
                        j = "in descriptor";
                    else {
                        if ("" === k)
                            return h.push(i),
                            void e();
                        i += k
                    }
                else if ("after descriptor" === j)
                    if (d(k))
                        ;
                    else {
                        if ("" === k)
                            return void e();
                        j = "in descriptor",
                        m -= 1
                    }
                m += 1
            }
        }
        for (var g, h, i, j, k, l = a.length, m = 0, n = []; ; ) {
            if (c(U),
            m >= l)
                return n;
            g = c(V),
            h = [],
            "," === g.slice(-1) ? (g = g.replace(W, ""),
            e()) : f()
        }
    }
    function n(a) {
        function b(a) {
            function b() {
                f && (g.push(f),
                f = "")
            }
            function c() {
                g[0] && (h.push(g),
                g = [])
            }
            for (var e, f = "", g = [], h = [], i = 0, j = 0, k = !1; ; ) {
                if (e = a.charAt(j),
                "" === e)
                    return b(),
                    c(),
                    h;
                if (k) {
                    if ("*" === e && "/" === a[j + 1]) {
                        k = !1,
                        j += 2,
                        b();
                        continue
                    }
                    j += 1
                } else {
                    if (d(e)) {
                        if (a.charAt(j - 1) && d(a.charAt(j - 1)) || !f) {
                            j += 1;
                            continue
                        }
                        if (0 === i) {
                            b(),
                            j += 1;
                            continue
                        }
                        e = " "
                    } else if ("(" === e)
                        i += 1;
                    else if (")" === e)
                        i -= 1;
                    else {
                        if ("," === e) {
                            b(),
                            c(),
                            j += 1;
                            continue
                        }
                        if ("/" === e && "*" === a.charAt(j + 1)) {
                            k = !0,
                            j += 2;
                            continue
                        }
                    }
                    f += e,
                    j += 1
                }
            }
        }
        function c(a) {
            return k.test(a) && parseFloat(a) >= 0 ? !0 : l.test(a) ? !0 : "0" === a || "-0" === a || "+0" === a ? !0 : !1
        }
        var e, f, g, h, i, j, k = /^(?:[+-]?[0-9]+|[0-9]*\.[0-9]+)(?:[eE][+-]?[0-9]+)?(?:ch|cm|em|ex|in|mm|pc|pt|px|rem|vh|vmin|vmax|vw)$/i, l = /^calc\((?:[0-9a-z \.\+\-\*\/\(\)]+)\)$/i;
        for (f = b(a),
        g = f.length,
        e = 0; g > e; e++)
            if (h = f[e],
            i = h[h.length - 1],
            c(i)) {
                if (j = i,
                h.pop(),
                0 === h.length)
                    return j;
                if (h = h.join(" "),
                s.matchesMedia(h))
                    return j
            }
        return "100vw"
    }
    b.createElement("picture");
    var o, p, q, r, s = {}, t = !1, u = function() {}, v = b.createElement("img"), w = v.getAttribute, x = v.setAttribute, y = v.removeAttribute, z = b.documentElement, A = {}, B = {
        algorithm: ""
    }, C = "data-pfsrc", D = C + "set", E = navigator.userAgent, F = /rident/.test(E) || /ecko/.test(E) && E.match(/rv\:(\d+)/) && RegExp.$1 > 35, G = "currentSrc", H = /\s+\+?\d+(e\d+)?w/, I = /(\([^)]+\))?\s*(.+)/, J = a.picturefillCFG, K = "position:absolute;left:0;visibility:hidden;display:block;padding:0;border:none;font-size:1em;width:1em;overflow:hidden;clip:rect(0px, 0px, 0px, 0px)", L = "font-size:100%!important;", M = !0, N = {}, O = {}, P = a.devicePixelRatio, Q = {
        px: 1,
        "in": 96
    }, R = b.createElement("a"), S = !1, T = /^[ \t\n\r\u000c]+/, U = /^[, \t\n\r\u000c]+/, V = /^[^ \t\n\r\u000c]+/, W = /[,]+$/, X = /^\d+$/, Y = /^-?(?:[0-9]+|[0-9]*\.[0-9]+)(?:[eE][+-]?[0-9]+)?$/, Z = function(a, b, c, d) {
        a.addEventListener ? a.addEventListener(b, c, d || !1) : a.attachEvent && a.attachEvent("on" + b, c)
    }, $ = function(a) {
        var b = {};
        return function(c) {
            return c in b || (b[c] = a(c)),
            b[c]
        }
    }, _ = function() {
        var a = /^([\d\.]+)(em|vw|px)$/
          , b = function() {
            for (var a = arguments, b = 0, c = a[0]; ++b in a; )
                c = c.replace(a[b], a[++b]);
            return c
        }
          , c = $(function(a) {
            return "return " + b((a || "").toLowerCase(), /\band\b/g, "&&", /,/g, "||", /min-([a-z-\s]+):/g, "e.$1>=", /max-([a-z-\s]+):/g, "e.$1<=", /calc([^)]+)/g, "($1)", /(\d+[\.]*[\d]*)([a-z]+)/g, "($1 * e.$2)", /^(?!(e.[a-z]|[0-9\.&=|><\+\-\*\(\)\/])).*/gi, "") + ";"
        });
        return function(b, d) {
            var e;
            if (!(b in N))
                if (N[b] = !1,
                d && (e = b.match(a)))
                    N[b] = e[1] * Q[e[2]];
                else
                    try {
                        N[b] = new Function("e",c(b))(Q)
                    } catch (f) {}
            return N[b]
        }
    }(), aa = function(a, b) {
        return a.w ? (a.cWidth = s.calcListLength(b || "100vw"),
        a.res = a.w / a.cWidth) : a.res = a.d,
        a
    }, ba = function(a) {
        if (t) {
            var c, d, e, f = a || {};
            if (f.elements && 1 === f.elements.nodeType && ("IMG" === f.elements.nodeName.toUpperCase() ? f.elements = [f.elements] : (f.context = f.elements,
            f.elements = null)),
            c = f.elements || s.qsa(f.context || b, f.reevaluate || f.reselect ? s.sel : s.selShort),
            e = c.length) {
                for (s.setupRun(f),
                S = !0,
                d = 0; e > d; d++)
                    s.fillImg(c[d], f);
                s.teardownRun(f)
            }
        }
    };
    o = a.console && console.warn ? function(a) {
        console.warn(a)
    }
    : u,
    G in v || (G = "src"),
    A["image/jpeg"] = !0,
    A["image/gif"] = !0,
    A["image/png"] = !0,
    A["image/svg+xml"] = b.implementation.hasFeature("http://www.w3.org/TR/SVG11/feature#Image", "1.1"),
    s.ns = ("pf" + (new Date).getTime()).substr(0, 9),
    s.supSrcset = "srcset"in v,
    s.supSizes = "sizes"in v,
    s.supPicture = !!a.HTMLPictureElement,
    s.supSrcset && s.supPicture && !s.supSizes && !function(a) {
        v.srcset = "data:,a",
        a.src = "data:,a",
        s.supSrcset = v.complete === a.complete,
        s.supPicture = s.supSrcset && s.supPicture
    }(b.createElement("img")),
    s.supSrcset && !s.supSizes ? !function() {
        var a = "data:image/gif;base64,R0lGODlhAgABAPAAAP///wAAACH5BAAAAAAALAAAAAACAAEAAAICBAoAOw=="
          , c = "data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw=="
          , d = b.createElement("img")
          , e = function() {
            var a = d.width;
            2 === a && (s.supSizes = !0),
            q = s.supSrcset && !s.supSizes,
            t = !0,
            setTimeout(ba)
        };
        d.onload = e,
        d.onerror = e,
        d.setAttribute("sizes", "9px"),
        d.srcset = c + " 1w," + a + " 9w",
        d.src = c
    }() : t = !0,
    s.selShort = "picture>img,img[srcset]",
    s.sel = s.selShort,
    s.cfg = B,
    s.DPR = P || 1,
    s.u = Q,
    s.types = A,
    s.setSize = u,
    s.makeUrl = $(function(a) {
        return R.href = a,
        R.href
    }),
    s.qsa = function(a, b) {
        return "querySelector"in a ? a.querySelectorAll(b) : []
    }
    ,
    s.matchesMedia = function() {
        return a.matchMedia && (matchMedia("(min-width: 0.1em)") || {}).matches ? s.matchesMedia = function(a) {
            return !a || matchMedia(a).matches
        }
        : s.matchesMedia = s.mMQ,
        s.matchesMedia.apply(this, arguments)
    }
    ,
    s.mMQ = function(a) {
        return a ? _(a) : !0
    }
    ,
    s.calcLength = function(a) {
        var b = _(a, !0) || !1;
        return 0 > b && (b = !1),
        b
    }
    ,
    s.supportsType = function(a) {
        return a ? A[a] : !0
    }
    ,
    s.parseSize = $(function(a) {
        var b = (a || "").match(I);
        return {
            media: b && b[1],
            length: b && b[2]
        }
    }),
    s.parseSet = function(a) {
        return a.cands || (a.cands = m(a.srcset, a)),
        a.cands
    }
    ,
    s.getEmValue = function() {
        var a;
        if (!p && (a = b.body)) {
            var c = b.createElement("div")
              , d = z.style.cssText
              , e = a.style.cssText;
            c.style.cssText = K,
            z.style.cssText = L,
            a.style.cssText = L,
            a.appendChild(c),
            p = c.offsetWidth,
            a.removeChild(c),
            p = parseFloat(p, 10),
            z.style.cssText = d,
            a.style.cssText = e
        }
        return p || 16
    }
    ,
    s.calcListLength = function(a) {
        if (!(a in O) || B.uT) {
            var b = s.calcLength(n(a));
            O[a] = b ? b : Q.width
        }
        return O[a]
    }
    ,
    s.setRes = function(a) {
        var b;
        if (a) {
            b = s.parseSet(a);
            for (var c = 0, d = b.length; d > c; c++)
                aa(b[c], a.sizes)
        }
        return b
    }
    ,
    s.setRes.res = aa,
    s.applySetCandidate = function(a, b) {
        if (a.length) {
            var c, d, e, f, h, k, l, m, n, o = b[s.ns], p = s.DPR;
            if (k = o.curSrc || b[G],
            l = o.curCan || j(b, k, a[0].set),
            l && l.set === a[0].set && (n = F && !b.complete && l.res - .1 > p,
            n || (l.cached = !0,
            l.res >= p && (h = l))),
            !h)
                for (a.sort(i),
                f = a.length,
                h = a[f - 1],
                d = 0; f > d; d++)
                    if (c = a[d],
                    c.res >= p) {
                        e = d - 1,
                        h = a[e] && (n || k !== s.makeUrl(c.url)) && g(a[e].res, c.res, p, a[e].cached) ? a[e] : c;
                        break
                    }
            h && (m = s.makeUrl(h.url),
            o.curSrc = m,
            o.curCan = h,
            m !== k && s.setSrc(b, h),
            s.setSize(b))
        }
    }
    ,
    s.setSrc = function(a, b) {
        var c;
        a.src = b.url,
        "image/svg+xml" === b.set.type && (c = a.style.width,
        a.style.width = a.offsetWidth + 1 + "px",
        a.offsetWidth + 1 && (a.style.width = c))
    }
    ,
    s.getSet = function(a) {
        var b, c, d, e = !1, f = a[s.ns].sets;
        for (b = 0; b < f.length && !e; b++)
            if (c = f[b],
            c.srcset && s.matchesMedia(c.media) && (d = s.supportsType(c.type))) {
                "pending" === d && (c = d),
                e = c;
                break
            }
        return e
    }
    ,
    s.parseSets = function(a, b, d) {
        var e, f, g, h, i = b && "PICTURE" === b.nodeName.toUpperCase(), j = a[s.ns];
        (j.src === c || d.src) && (j.src = w.call(a, "src"),
        j.src ? x.call(a, C, j.src) : y.call(a, C)),
        (j.srcset === c || d.srcset || !s.supSrcset || a.srcset) && (e = w.call(a, "srcset"),
        j.srcset = e,
        h = !0),
        j.sets = [],
        i && (j.pic = !0,
        l(b, j.sets)),
        j.srcset ? (f = {
            srcset: j.srcset,
            sizes: w.call(a, "sizes")
        },
        j.sets.push(f),
        g = (q || j.src) && H.test(j.srcset || ""),
        g || !j.src || k(j.src, f) || f.has1x || (f.srcset += ", " + j.src,
        f.cands.push({
            url: j.src,
            d: 1,
            set: f
        }))) : j.src && j.sets.push({
            srcset: j.src,
            sizes: null
        }),
        j.curCan = null,
        j.curSrc = c,
        j.supported = !(i || f && !s.supSrcset || g && !s.supSizes),
        h && s.supSrcset && !j.supported && (e ? (x.call(a, D, e),
        a.srcset = "") : y.call(a, D)),
        j.supported && !j.srcset && (!j.src && a.src || a.src !== s.makeUrl(j.src)) && (null === j.src ? a.removeAttribute("src") : a.src = j.src),
        j.parsed = !0
    }
    ,
    s.fillImg = function(a, b) {
        var c, d = b.reselect || b.reevaluate;
        a[s.ns] || (a[s.ns] = {}),
        c = a[s.ns],
        (d || c.evaled !== r) && ((!c.parsed || b.reevaluate) && s.parseSets(a, a.parentNode, b),
        c.supported ? c.evaled = r : h(a))
    }
    ,
    s.setupRun = function() {
        (!S || M || P !== a.devicePixelRatio) && f()
    }
    ,
    s.supPicture ? (ba = u,
    s.fillImg = u) : !function() {
        var c, d = a.attachEvent ? /d$|^c/ : /d$|^c|^i/, e = function() {
            var a = b.readyState || "";
            f = setTimeout(e, "loading" === a ? 200 : 999),
            b.body && (s.fillImgs(),
            c = c || d.test(a),
            c && clearTimeout(f))
        }, f = setTimeout(e, b.body ? 9 : 99), g = function(a, b) {
            var c, d, e = function() {
                var f = new Date - d;
                b > f ? c = setTimeout(e, b - f) : (c = null,
                a())
            };
            return function() {
                d = new Date,
                c || (c = setTimeout(e, b))
            }
        }, h = z.clientHeight, i = function() {
            M = Math.max(a.innerWidth || 0, z.clientWidth) !== Q.width || z.clientHeight !== h,
            h = z.clientHeight,
            M && s.fillImgs()
        };
        Z(a, "resize", g(i, 99)),
        Z(b, "readystatechange", e)
    }(),
    s.picturefill = ba,
    s.fillImgs = ba,
    s.teardownRun = u,
    ba._ = s,
    a.picturefillCFG = {
        pf: s,
        push: function(a) {
            var b = a.shift();
            "function" == typeof s[b] ? s[b].apply(s, a) : (B[b] = a[0],
            S && s.fillImgs({
                reselect: !0
            }))
        }
    };
    for (; J && J.length; )
        a.picturefillCFG.push(J.shift());
    a.picturefill = ba,
    "object" == typeof module && "object" == typeof module.exports ? module.exports = ba : "function" == typeof define && define.amd && define("picturefill", function() {
        return ba
    }),
    s.supPicture || (A["image/webp"] = e("image/webp", "data:image/webp;base64,UklGRkoAAABXRUJQVlA4WAoAAAAQAAAAAAAAAAAAQUxQSAwAAAABBxAR/Q9ERP8DAABWUDggGAAAADABAJ0BKgEAAQADADQlpAADcAD++/1QAA=="))
}(window, document);
/*! jQuery v2.2.3 | (c) jQuery Foundation | jquery.org/license */
!function(a, b) {
    "object" == typeof module && "object" == typeof module.exports ? module.exports = a.document ? b(a, !0) : function(a) {
        if (!a.document)
            throw new Error("jQuery requires a window with a document");
        return b(a)
    }
    : b(a)
}("undefined" != typeof window ? window : this, function(a, b) {
    var c = []
      , d = a.document
      , e = c.slice
      , f = c.concat
      , g = c.push
      , h = c.indexOf
      , i = {}
      , j = i.toString
      , k = i.hasOwnProperty
      , l = {}
      , m = "2.2.3"
      , n = function(a, b) {
        return new n.fn.init(a,b)
    }
      , o = /^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g
      , p = /^-ms-/
      , q = /-([\da-z])/gi
      , r = function(a, b) {
        return b.toUpperCase()
    };
    n.fn = n.prototype = {
        jquery: m,
        constructor: n,
        selector: "",
        length: 0,
        toArray: function() {
            return e.call(this)
        },
        get: function(a) {
            return null != a ? 0 > a ? this[a + this.length] : this[a] : e.call(this)
        },
        pushStack: function(a) {
            var b = n.merge(this.constructor(), a);
            return b.prevObject = this,
            b.context = this.context,
            b
        },
        each: function(a) {
            return n.each(this, a)
        },
        map: function(a) {
            return this.pushStack(n.map(this, function(b, c) {
                return a.call(b, c, b)
            }))
        },
        slice: function() {
            return this.pushStack(e.apply(this, arguments))
        },
        first: function() {
            return this.eq(0)
        },
        last: function() {
            return this.eq(-1)
        },
        eq: function(a) {
            var b = this.length
              , c = +a + (0 > a ? b : 0);
            return this.pushStack(c >= 0 && b > c ? [this[c]] : [])
        },
        end: function() {
            return this.prevObject || this.constructor()
        },
        push: g,
        sort: c.sort,
        splice: c.splice
    },
    n.extend = n.fn.extend = function() {
        var a, b, c, d, e, f, g = arguments[0] || {}, h = 1, i = arguments.length, j = !1;
        for ("boolean" == typeof g && (j = g,
        g = arguments[h] || {},
        h++),
        "object" == typeof g || n.isFunction(g) || (g = {}),
        h === i && (g = this,
        h--); i > h; h++)
            if (null != (a = arguments[h]))
                for (b in a)
                    c = g[b],
                    d = a[b],
                    g !== d && (j && d && (n.isPlainObject(d) || (e = n.isArray(d))) ? (e ? (e = !1,
                    f = c && n.isArray(c) ? c : []) : f = c && n.isPlainObject(c) ? c : {},
                    g[b] = n.extend(j, f, d)) : void 0 !== d && (g[b] = d));
        return g
    }
    ,
    n.extend({
        expando: "jQuery" + (m + Math.random()).replace(/\D/g, ""),
        isReady: !0,
        error: function(a) {
            throw new Error(a)
        },
        noop: function() {},
        isFunction: function(a) {
            return "function" === n.type(a)
        },
        isArray: Array.isArray,
        isWindow: function(a) {
            return null != a && a === a.window
        },
        isNumeric: function(a) {
            var b = a && a.toString();
            return !n.isArray(a) && b - parseFloat(b) + 1 >= 0
        },
        isPlainObject: function(a) {
            var b;
            if ("object" !== n.type(a) || a.nodeType || n.isWindow(a))
                return !1;
            if (a.constructor && !k.call(a, "constructor") && !k.call(a.constructor.prototype || {}, "isPrototypeOf"))
                return !1;
            for (b in a)
                ;
            return void 0 === b || k.call(a, b)
        },
        isEmptyObject: function(a) {
            var b;
            for (b in a)
                return !1;
            return !0
        },
        type: function(a) {
            return null == a ? a + "" : "object" == typeof a || "function" == typeof a ? i[j.call(a)] || "object" : typeof a
        },
        globalEval: function(a) {
            var b, c = eval;
            a = n.trim(a),
            a && (1 === a.indexOf("use strict") ? (b = d.createElement("script"),
            b.text = a,
            d.head.appendChild(b).parentNode.removeChild(b)) : c(a))
        },
        camelCase: function(a) {
            return a.replace(p, "ms-").replace(q, r)
        },
        nodeName: function(a, b) {
            return a.nodeName && a.nodeName.toLowerCase() === b.toLowerCase()
        },
        each: function(a, b) {
            var c, d = 0;
            if (s(a)) {
                for (c = a.length; c > d; d++)
                    if (b.call(a[d], d, a[d]) === !1)
                        break
            } else
                for (d in a)
                    if (b.call(a[d], d, a[d]) === !1)
                        break;
            return a
        },
        trim: function(a) {
            return null == a ? "" : (a + "").replace(o, "")
        },
        makeArray: function(a, b) {
            var c = b || [];
            return null != a && (s(Object(a)) ? n.merge(c, "string" == typeof a ? [a] : a) : g.call(c, a)),
            c
        },
        inArray: function(a, b, c) {
            return null == b ? -1 : h.call(b, a, c)
        },
        merge: function(a, b) {
            for (var c = +b.length, d = 0, e = a.length; c > d; d++)
                a[e++] = b[d];
            return a.length = e,
            a
        },
        grep: function(a, b, c) {
            for (var d, e = [], f = 0, g = a.length, h = !c; g > f; f++)
                d = !b(a[f], f),
                d !== h && e.push(a[f]);
            return e
        },
        map: function(a, b, c) {
            var d, e, g = 0, h = [];
            if (s(a))
                for (d = a.length; d > g; g++)
                    e = b(a[g], g, c),
                    null != e && h.push(e);
            else
                for (g in a)
                    e = b(a[g], g, c),
                    null != e && h.push(e);
            return f.apply([], h)
        },
        guid: 1,
        proxy: function(a, b) {
            var c, d, f;
            return "string" == typeof b && (c = a[b],
            b = a,
            a = c),
            n.isFunction(a) ? (d = e.call(arguments, 2),
            f = function() {
                return a.apply(b || this, d.concat(e.call(arguments)))
            }
            ,
            f.guid = a.guid = a.guid || n.guid++,
            f) : void 0
        },
        now: Date.now,
        support: l
    }),
    "function" == typeof Symbol && (n.fn[Symbol.iterator] = c[Symbol.iterator]),
    n.each("Boolean Number String Function Array Date RegExp Object Error Symbol".split(" "), function(a, b) {
        i["[object " + b + "]"] = b.toLowerCase()
    });
    function s(a) {
        var b = !!a && "length"in a && a.length
          , c = n.type(a);
        return "function" === c || n.isWindow(a) ? !1 : "array" === c || 0 === b || "number" == typeof b && b > 0 && b - 1 in a
    }
    var t = function(a) {
        var b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u = "sizzle" + 1 * new Date, v = a.document, w = 0, x = 0, y = ga(), z = ga(), A = ga(), B = function(a, b) {
            return a === b && (l = !0),
            0
        }, C = 1 << 31, D = {}.hasOwnProperty, E = [], F = E.pop, G = E.push, H = E.push, I = E.slice, J = function(a, b) {
            for (var c = 0, d = a.length; d > c; c++)
                if (a[c] === b)
                    return c;
            return -1
        }, K = "checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped", L = "[\\x20\\t\\r\\n\\f]", M = "(?:\\\\.|[\\w-]|[^\\x00-\\xa0])+", N = "\\[" + L + "*(" + M + ")(?:" + L + "*([*^$|!~]?=)" + L + "*(?:'((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\"|(" + M + "))|)" + L + "*\\]", O = ":(" + M + ")(?:\\((('((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\")|((?:\\\\.|[^\\\\()[\\]]|" + N + ")*)|.*)\\)|)", P = new RegExp(L + "+","g"), Q = new RegExp("^" + L + "+|((?:^|[^\\\\])(?:\\\\.)*)" + L + "+$","g"), R = new RegExp("^" + L + "*," + L + "*"), S = new RegExp("^" + L + "*([>+~]|" + L + ")" + L + "*"), T = new RegExp("=" + L + "*([^\\]'\"]*?)" + L + "*\\]","g"), U = new RegExp(O), V = new RegExp("^" + M + "$"), W = {
            ID: new RegExp("^#(" + M + ")"),
            CLASS: new RegExp("^\\.(" + M + ")"),
            TAG: new RegExp("^(" + M + "|[*])"),
            ATTR: new RegExp("^" + N),
            PSEUDO: new RegExp("^" + O),
            CHILD: new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\(" + L + "*(even|odd|(([+-]|)(\\d*)n|)" + L + "*(?:([+-]|)" + L + "*(\\d+)|))" + L + "*\\)|)","i"),
            bool: new RegExp("^(?:" + K + ")$","i"),
            needsContext: new RegExp("^" + L + "*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\(" + L + "*((?:-\\d)?\\d*)" + L + "*\\)|)(?=[^-]|$)","i")
        }, X = /^(?:input|select|textarea|button)$/i, Y = /^h\d$/i, Z = /^[^{]+\{\s*\[native \w/, $ = /^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/, _ = /[+~]/, aa = /'|\\/g, ba = new RegExp("\\\\([\\da-f]{1,6}" + L + "?|(" + L + ")|.)","ig"), ca = function(a, b, c) {
            var d = "0x" + b - 65536;
            return d !== d || c ? b : 0 > d ? String.fromCharCode(d + 65536) : String.fromCharCode(d >> 10 | 55296, 1023 & d | 56320)
        }, da = function() {
            m()
        };
        try {
            H.apply(E = I.call(v.childNodes), v.childNodes),
            E[v.childNodes.length].nodeType
        } catch (ea) {
            H = {
                apply: E.length ? function(a, b) {
                    G.apply(a, I.call(b))
                }
                : function(a, b) {
                    var c = a.length
                      , d = 0;
                    while (a[c++] = b[d++])
                        ;
                    a.length = c - 1
                }
            }
        }
        function fa(a, b, d, e) {
            var f, h, j, k, l, o, r, s, w = b && b.ownerDocument, x = b ? b.nodeType : 9;
            if (d = d || [],
            "string" != typeof a || !a || 1 !== x && 9 !== x && 11 !== x)
                return d;
            if (!e && ((b ? b.ownerDocument || b : v) !== n && m(b),
            b = b || n,
            p)) {
                if (11 !== x && (o = $.exec(a)))
                    if (f = o[1]) {
                        if (9 === x) {
                            if (!(j = b.getElementById(f)))
                                return d;
                            if (j.id === f)
                                return d.push(j),
                                d
                        } else if (w && (j = w.getElementById(f)) && t(b, j) && j.id === f)
                            return d.push(j),
                            d
                    } else {
                        if (o[2])
                            return H.apply(d, b.getElementsByTagName(a)),
                            d;
                        if ((f = o[3]) && c.getElementsByClassName && b.getElementsByClassName)
                            return H.apply(d, b.getElementsByClassName(f)),
                            d
                    }
                if (c.qsa && !A[a + " "] && (!q || !q.test(a))) {
                    if (1 !== x)
                        w = b,
                        s = a;
                    else if ("object" !== b.nodeName.toLowerCase()) {
                        (k = b.getAttribute("id")) ? k = k.replace(aa, "\\$&") : b.setAttribute("id", k = u),
                        r = g(a),
                        h = r.length,
                        l = V.test(k) ? "#" + k : "[id='" + k + "']";
                        while (h--)
                            r[h] = l + " " + qa(r[h]);
                        s = r.join(","),
                        w = _.test(a) && oa(b.parentNode) || b
                    }
                    if (s)
                        try {
                            return H.apply(d, w.querySelectorAll(s)),
                            d
                        } catch (y) {} finally {
                            k === u && b.removeAttribute("id")
                        }
                }
            }
            return i(a.replace(Q, "$1"), b, d, e)
        }
        function ga() {
            var a = [];
            function b(c, e) {
                return a.push(c + " ") > d.cacheLength && delete b[a.shift()],
                b[c + " "] = e
            }
            return b
        }
        function ha(a) {
            return a[u] = !0,
            a
        }
        function ia(a) {
            var b = n.createElement("div");
            try {
                return !!a(b)
            } catch (c) {
                return !1
            } finally {
                b.parentNode && b.parentNode.removeChild(b),
                b = null
            }
        }
        function ja(a, b) {
            var c = a.split("|")
              , e = c.length;
            while (e--)
                d.attrHandle[c[e]] = b
        }
        function ka(a, b) {
            var c = b && a
              , d = c && 1 === a.nodeType && 1 === b.nodeType && (~b.sourceIndex || C) - (~a.sourceIndex || C);
            if (d)
                return d;
            if (c)
                while (c = c.nextSibling)
                    if (c === b)
                        return -1;
            return a ? 1 : -1
        }
        function la(a) {
            return function(b) {
                var c = b.nodeName.toLowerCase();
                return "input" === c && b.type === a
            }
        }
        function ma(a) {
            return function(b) {
                var c = b.nodeName.toLowerCase();
                return ("input" === c || "button" === c) && b.type === a
            }
        }
        function na(a) {
            return ha(function(b) {
                return b = +b,
                ha(function(c, d) {
                    var e, f = a([], c.length, b), g = f.length;
                    while (g--)
                        c[e = f[g]] && (c[e] = !(d[e] = c[e]))
                })
            })
        }
        function oa(a) {
            return a && "undefined" != typeof a.getElementsByTagName && a
        }
        c = fa.support = {},
        f = fa.isXML = function(a) {
            var b = a && (a.ownerDocument || a).documentElement;
            return b ? "HTML" !== b.nodeName : !1
        }
        ,
        m = fa.setDocument = function(a) {
            var b, e, g = a ? a.ownerDocument || a : v;
            return g !== n && 9 === g.nodeType && g.documentElement ? (n = g,
            o = n.documentElement,
            p = !f(n),
            (e = n.defaultView) && e.top !== e && (e.addEventListener ? e.addEventListener("unload", da, !1) : e.attachEvent && e.attachEvent("onunload", da)),
            c.attributes = ia(function(a) {
                return a.className = "i",
                !a.getAttribute("className")
            }),
            c.getElementsByTagName = ia(function(a) {
                return a.appendChild(n.createComment("")),
                !a.getElementsByTagName("*").length
            }),
            c.getElementsByClassName = Z.test(n.getElementsByClassName),
            c.getById = ia(function(a) {
                return o.appendChild(a).id = u,
                !n.getElementsByName || !n.getElementsByName(u).length
            }),
            c.getById ? (d.find.ID = function(a, b) {
                if ("undefined" != typeof b.getElementById && p) {
                    var c = b.getElementById(a);
                    return c ? [c] : []
                }
            }
            ,
            d.filter.ID = function(a) {
                var b = a.replace(ba, ca);
                return function(a) {
                    return a.getAttribute("id") === b
                }
            }
            ) : (delete d.find.ID,
            d.filter.ID = function(a) {
                var b = a.replace(ba, ca);
                return function(a) {
                    var c = "undefined" != typeof a.getAttributeNode && a.getAttributeNode("id");
                    return c && c.value === b
                }
            }
            ),
            d.find.TAG = c.getElementsByTagName ? function(a, b) {
                return "undefined" != typeof b.getElementsByTagName ? b.getElementsByTagName(a) : c.qsa ? b.querySelectorAll(a) : void 0
            }
            : function(a, b) {
                var c, d = [], e = 0, f = b.getElementsByTagName(a);
                if ("*" === a) {
                    while (c = f[e++])
                        1 === c.nodeType && d.push(c);
                    return d
                }
                return f
            }
            ,
            d.find.CLASS = c.getElementsByClassName && function(a, b) {
                return "undefined" != typeof b.getElementsByClassName && p ? b.getElementsByClassName(a) : void 0
            }
            ,
            r = [],
            q = [],
            (c.qsa = Z.test(n.querySelectorAll)) && (ia(function(a) {
                o.appendChild(a).innerHTML = "<a id='" + u + "'></a><select id='" + u + "-\r\\' msallowcapture=''><option selected=''></option></select>",
                a.querySelectorAll("[msallowcapture^='']").length && q.push("[*^$]=" + L + "*(?:''|\"\")"),
                a.querySelectorAll("[selected]").length || q.push("\\[" + L + "*(?:value|" + K + ")"),
                a.querySelectorAll("[id~=" + u + "-]").length || q.push("~="),
                a.querySelectorAll(":checked").length || q.push(":checked"),
                a.querySelectorAll("a#" + u + "+*").length || q.push(".#.+[+~]")
            }),
            ia(function(a) {
                var b = n.createElement("input");
                b.setAttribute("type", "hidden"),
                a.appendChild(b).setAttribute("name", "D"),
                a.querySelectorAll("[name=d]").length && q.push("name" + L + "*[*^$|!~]?="),
                a.querySelectorAll(":enabled").length || q.push(":enabled", ":disabled"),
                a.querySelectorAll("*,:x"),
                q.push(",.*:")
            })),
            (c.matchesSelector = Z.test(s = o.matches || o.webkitMatchesSelector || o.mozMatchesSelector || o.oMatchesSelector || o.msMatchesSelector)) && ia(function(a) {
                c.disconnectedMatch = s.call(a, "div"),
                s.call(a, "[s!='']:x"),
                r.push("!=", O)
            }),
            q = q.length && new RegExp(q.join("|")),
            r = r.length && new RegExp(r.join("|")),
            b = Z.test(o.compareDocumentPosition),
            t = b || Z.test(o.contains) ? function(a, b) {
                var c = 9 === a.nodeType ? a.documentElement : a
                  , d = b && b.parentNode;
                return a === d || !(!d || 1 !== d.nodeType || !(c.contains ? c.contains(d) : a.compareDocumentPosition && 16 & a.compareDocumentPosition(d)))
            }
            : function(a, b) {
                if (b)
                    while (b = b.parentNode)
                        if (b === a)
                            return !0;
                return !1
            }
            ,
            B = b ? function(a, b) {
                if (a === b)
                    return l = !0,
                    0;
                var d = !a.compareDocumentPosition - !b.compareDocumentPosition;
                return d ? d : (d = (a.ownerDocument || a) === (b.ownerDocument || b) ? a.compareDocumentPosition(b) : 1,
                1 & d || !c.sortDetached && b.compareDocumentPosition(a) === d ? a === n || a.ownerDocument === v && t(v, a) ? -1 : b === n || b.ownerDocument === v && t(v, b) ? 1 : k ? J(k, a) - J(k, b) : 0 : 4 & d ? -1 : 1)
            }
            : function(a, b) {
                if (a === b)
                    return l = !0,
                    0;
                var c, d = 0, e = a.parentNode, f = b.parentNode, g = [a], h = [b];
                if (!e || !f)
                    return a === n ? -1 : b === n ? 1 : e ? -1 : f ? 1 : k ? J(k, a) - J(k, b) : 0;
                if (e === f)
                    return ka(a, b);
                c = a;
                while (c = c.parentNode)
                    g.unshift(c);
                c = b;
                while (c = c.parentNode)
                    h.unshift(c);
                while (g[d] === h[d])
                    d++;
                return d ? ka(g[d], h[d]) : g[d] === v ? -1 : h[d] === v ? 1 : 0
            }
            ,
            n) : n
        }
        ,
        fa.matches = function(a, b) {
            return fa(a, null, null, b)
        }
        ,
        fa.matchesSelector = function(a, b) {
            if ((a.ownerDocument || a) !== n && m(a),
            b = b.replace(T, "='$1']"),
            c.matchesSelector && p && !A[b + " "] && (!r || !r.test(b)) && (!q || !q.test(b)))
                try {
                    var d = s.call(a, b);
                    if (d || c.disconnectedMatch || a.document && 11 !== a.document.nodeType)
                        return d
                } catch (e) {}
            return fa(b, n, null, [a]).length > 0
        }
        ,
        fa.contains = function(a, b) {
            return (a.ownerDocument || a) !== n && m(a),
            t(a, b)
        }
        ,
        fa.attr = function(a, b) {
            (a.ownerDocument || a) !== n && m(a);
            var e = d.attrHandle[b.toLowerCase()]
              , f = e && D.call(d.attrHandle, b.toLowerCase()) ? e(a, b, !p) : void 0;
            return void 0 !== f ? f : c.attributes || !p ? a.getAttribute(b) : (f = a.getAttributeNode(b)) && f.specified ? f.value : null
        }
        ,
        fa.error = function(a) {
            throw new Error("Syntax error, unrecognized expression: " + a)
        }
        ,
        fa.uniqueSort = function(a) {
            var b, d = [], e = 0, f = 0;
            if (l = !c.detectDuplicates,
            k = !c.sortStable && a.slice(0),
            a.sort(B),
            l) {
                while (b = a[f++])
                    b === a[f] && (e = d.push(f));
                while (e--)
                    a.splice(d[e], 1)
            }
            return k = null,
            a
        }
        ,
        e = fa.getText = function(a) {
            var b, c = "", d = 0, f = a.nodeType;
            if (f) {
                if (1 === f || 9 === f || 11 === f) {
                    if ("string" == typeof a.textContent)
                        return a.textContent;
                    for (a = a.firstChild; a; a = a.nextSibling)
                        c += e(a)
                } else if (3 === f || 4 === f)
                    return a.nodeValue
            } else
                while (b = a[d++])
                    c += e(b);
            return c
        }
        ,
        d = fa.selectors = {
            cacheLength: 50,
            createPseudo: ha,
            match: W,
            attrHandle: {},
            find: {},
            relative: {
                ">": {
                    dir: "parentNode",
                    first: !0
                },
                " ": {
                    dir: "parentNode"
                },
                "+": {
                    dir: "previousSibling",
                    first: !0
                },
                "~": {
                    dir: "previousSibling"
                }
            },
            preFilter: {
                ATTR: function(a) {
                    return a[1] = a[1].replace(ba, ca),
                    a[3] = (a[3] || a[4] || a[5] || "").replace(ba, ca),
                    "~=" === a[2] && (a[3] = " " + a[3] + " "),
                    a.slice(0, 4)
                },
                CHILD: function(a) {
                    return a[1] = a[1].toLowerCase(),
                    "nth" === a[1].slice(0, 3) ? (a[3] || fa.error(a[0]),
                    a[4] = +(a[4] ? a[5] + (a[6] || 1) : 2 * ("even" === a[3] || "odd" === a[3])),
                    a[5] = +(a[7] + a[8] || "odd" === a[3])) : a[3] && fa.error(a[0]),
                    a
                },
                PSEUDO: function(a) {
                    var b, c = !a[6] && a[2];
                    return W.CHILD.test(a[0]) ? null : (a[3] ? a[2] = a[4] || a[5] || "" : c && U.test(c) && (b = g(c, !0)) && (b = c.indexOf(")", c.length - b) - c.length) && (a[0] = a[0].slice(0, b),
                    a[2] = c.slice(0, b)),
                    a.slice(0, 3))
                }
            },
            filter: {
                TAG: function(a) {
                    var b = a.replace(ba, ca).toLowerCase();
                    return "*" === a ? function() {
                        return !0
                    }
                    : function(a) {
                        return a.nodeName && a.nodeName.toLowerCase() === b
                    }
                },
                CLASS: function(a) {
                    var b = y[a + " "];
                    return b || (b = new RegExp("(^|" + L + ")" + a + "(" + L + "|$)")) && y(a, function(a) {
                        return b.test("string" == typeof a.className && a.className || "undefined" != typeof a.getAttribute && a.getAttribute("class") || "")
                    })
                },
                ATTR: function(a, b, c) {
                    return function(d) {
                        var e = fa.attr(d, a);
                        return null == e ? "!=" === b : b ? (e += "",
                        "=" === b ? e === c : "!=" === b ? e !== c : "^=" === b ? c && 0 === e.indexOf(c) : "*=" === b ? c && e.indexOf(c) > -1 : "$=" === b ? c && e.slice(-c.length) === c : "~=" === b ? (" " + e.replace(P, " ") + " ").indexOf(c) > -1 : "|=" === b ? e === c || e.slice(0, c.length + 1) === c + "-" : !1) : !0
                    }
                },
                CHILD: function(a, b, c, d, e) {
                    var f = "nth" !== a.slice(0, 3)
                      , g = "last" !== a.slice(-4)
                      , h = "of-type" === b;
                    return 1 === d && 0 === e ? function(a) {
                        return !!a.parentNode
                    }
                    : function(b, c, i) {
                        var j, k, l, m, n, o, p = f !== g ? "nextSibling" : "previousSibling", q = b.parentNode, r = h && b.nodeName.toLowerCase(), s = !i && !h, t = !1;
                        if (q) {
                            if (f) {
                                while (p) {
                                    m = b;
                                    while (m = m[p])
                                        if (h ? m.nodeName.toLowerCase() === r : 1 === m.nodeType)
                                            return !1;
                                    o = p = "only" === a && !o && "nextSibling"
                                }
                                return !0
                            }
                            if (o = [g ? q.firstChild : q.lastChild],
                            g && s) {
                                m = q,
                                l = m[u] || (m[u] = {}),
                                k = l[m.uniqueID] || (l[m.uniqueID] = {}),
                                j = k[a] || [],
                                n = j[0] === w && j[1],
                                t = n && j[2],
                                m = n && q.childNodes[n];
                                while (m = ++n && m && m[p] || (t = n = 0) || o.pop())
                                    if (1 === m.nodeType && ++t && m === b) {
                                        k[a] = [w, n, t];
                                        break
                                    }
                            } else if (s && (m = b,
                            l = m[u] || (m[u] = {}),
                            k = l[m.uniqueID] || (l[m.uniqueID] = {}),
                            j = k[a] || [],
                            n = j[0] === w && j[1],
                            t = n),
                            t === !1)
                                while (m = ++n && m && m[p] || (t = n = 0) || o.pop())
                                    if ((h ? m.nodeName.toLowerCase() === r : 1 === m.nodeType) && ++t && (s && (l = m[u] || (m[u] = {}),
                                    k = l[m.uniqueID] || (l[m.uniqueID] = {}),
                                    k[a] = [w, t]),
                                    m === b))
                                        break;
                            return t -= e,
                            t === d || t % d === 0 && t / d >= 0
                        }
                    }
                },
                PSEUDO: function(a, b) {
                    var c, e = d.pseudos[a] || d.setFilters[a.toLowerCase()] || fa.error("unsupported pseudo: " + a);
                    return e[u] ? e(b) : e.length > 1 ? (c = [a, a, "", b],
                    d.setFilters.hasOwnProperty(a.toLowerCase()) ? ha(function(a, c) {
                        var d, f = e(a, b), g = f.length;
                        while (g--)
                            d = J(a, f[g]),
                            a[d] = !(c[d] = f[g])
                    }) : function(a) {
                        return e(a, 0, c)
                    }
                    ) : e
                }
            },
            pseudos: {
                not: ha(function(a) {
                    var b = []
                      , c = []
                      , d = h(a.replace(Q, "$1"));
                    return d[u] ? ha(function(a, b, c, e) {
                        var f, g = d(a, null, e, []), h = a.length;
                        while (h--)
                            (f = g[h]) && (a[h] = !(b[h] = f))
                    }) : function(a, e, f) {
                        return b[0] = a,
                        d(b, null, f, c),
                        b[0] = null,
                        !c.pop()
                    }
                }),
                has: ha(function(a) {
                    return function(b) {
                        return fa(a, b).length > 0
                    }
                }),
                contains: ha(function(a) {
                    return a = a.replace(ba, ca),
                    function(b) {
                        return (b.textContent || b.innerText || e(b)).indexOf(a) > -1
                    }
                }),
                lang: ha(function(a) {
                    return V.test(a || "") || fa.error("unsupported lang: " + a),
                    a = a.replace(ba, ca).toLowerCase(),
                    function(b) {
                        var c;
                        do
                            if (c = p ? b.lang : b.getAttribute("xml:lang") || b.getAttribute("lang"))
                                return c = c.toLowerCase(),
                                c === a || 0 === c.indexOf(a + "-");
                        while ((b = b.parentNode) && 1 === b.nodeType);return !1
                    }
                }),
                target: function(b) {
                    var c = a.location && a.location.hash;
                    return c && c.slice(1) === b.id
                },
                root: function(a) {
                    return a === o
                },
                focus: function(a) {
                    return a === n.activeElement && (!n.hasFocus || n.hasFocus()) && !!(a.type || a.href || ~a.tabIndex)
                },
                enabled: function(a) {
                    return a.disabled === !1
                },
                disabled: function(a) {
                    return a.disabled === !0
                },
                checked: function(a) {
                    var b = a.nodeName.toLowerCase();
                    return "input" === b && !!a.checked || "option" === b && !!a.selected
                },
                selected: function(a) {
                    return a.parentNode && a.parentNode.selectedIndex,
                    a.selected === !0
                },
                empty: function(a) {
                    for (a = a.firstChild; a; a = a.nextSibling)
                        if (a.nodeType < 6)
                            return !1;
                    return !0
                },
                parent: function(a) {
                    return !d.pseudos.empty(a)
                },
                header: function(a) {
                    return Y.test(a.nodeName)
                },
                input: function(a) {
                    return X.test(a.nodeName)
                },
                button: function(a) {
                    var b = a.nodeName.toLowerCase();
                    return "input" === b && "button" === a.type || "button" === b
                },
                text: function(a) {
                    var b;
                    return "input" === a.nodeName.toLowerCase() && "text" === a.type && (null == (b = a.getAttribute("type")) || "text" === b.toLowerCase())
                },
                first: na(function() {
                    return [0]
                }),
                last: na(function(a, b) {
                    return [b - 1]
                }),
                eq: na(function(a, b, c) {
                    return [0 > c ? c + b : c]
                }),
                even: na(function(a, b) {
                    for (var c = 0; b > c; c += 2)
                        a.push(c);
                    return a
                }),
                odd: na(function(a, b) {
                    for (var c = 1; b > c; c += 2)
                        a.push(c);
                    return a
                }),
                lt: na(function(a, b, c) {
                    for (var d = 0 > c ? c + b : c; --d >= 0; )
                        a.push(d);
                    return a
                }),
                gt: na(function(a, b, c) {
                    for (var d = 0 > c ? c + b : c; ++d < b; )
                        a.push(d);
                    return a
                })
            }
        },
        d.pseudos.nth = d.pseudos.eq;
        for (b in {
            radio: !0,
            checkbox: !0,
            file: !0,
            password: !0,
            image: !0
        })
            d.pseudos[b] = la(b);
        for (b in {
            submit: !0,
            reset: !0
        })
            d.pseudos[b] = ma(b);
        function pa() {}
        pa.prototype = d.filters = d.pseudos,
        d.setFilters = new pa,
        g = fa.tokenize = function(a, b) {
            var c, e, f, g, h, i, j, k = z[a + " "];
            if (k)
                return b ? 0 : k.slice(0);
            h = a,
            i = [],
            j = d.preFilter;
            while (h) {
                c && !(e = R.exec(h)) || (e && (h = h.slice(e[0].length) || h),
                i.push(f = [])),
                c = !1,
                (e = S.exec(h)) && (c = e.shift(),
                f.push({
                    value: c,
                    type: e[0].replace(Q, " ")
                }),
                h = h.slice(c.length));
                for (g in d.filter)
                    !(e = W[g].exec(h)) || j[g] && !(e = j[g](e)) || (c = e.shift(),
                    f.push({
                        value: c,
                        type: g,
                        matches: e
                    }),
                    h = h.slice(c.length));
                if (!c)
                    break
            }
            return b ? h.length : h ? fa.error(a) : z(a, i).slice(0)
        }
        ;
        function qa(a) {
            for (var b = 0, c = a.length, d = ""; c > b; b++)
                d += a[b].value;
            return d
        }
        function ra(a, b, c) {
            var d = b.dir
              , e = c && "parentNode" === d
              , f = x++;
            return b.first ? function(b, c, f) {
                while (b = b[d])
                    if (1 === b.nodeType || e)
                        return a(b, c, f)
            }
            : function(b, c, g) {
                var h, i, j, k = [w, f];
                if (g) {
                    while (b = b[d])
                        if ((1 === b.nodeType || e) && a(b, c, g))
                            return !0
                } else
                    while (b = b[d])
                        if (1 === b.nodeType || e) {
                            if (j = b[u] || (b[u] = {}),
                            i = j[b.uniqueID] || (j[b.uniqueID] = {}),
                            (h = i[d]) && h[0] === w && h[1] === f)
                                return k[2] = h[2];
                            if (i[d] = k,
                            k[2] = a(b, c, g))
                                return !0
                        }
            }
        }
        function sa(a) {
            return a.length > 1 ? function(b, c, d) {
                var e = a.length;
                while (e--)
                    if (!a[e](b, c, d))
                        return !1;
                return !0
            }
            : a[0]
        }
        function ta(a, b, c) {
            for (var d = 0, e = b.length; e > d; d++)
                fa(a, b[d], c);
            return c
        }
        function ua(a, b, c, d, e) {
            for (var f, g = [], h = 0, i = a.length, j = null != b; i > h; h++)
                (f = a[h]) && (c && !c(f, d, e) || (g.push(f),
                j && b.push(h)));
            return g
        }
        function va(a, b, c, d, e, f) {
            return d && !d[u] && (d = va(d)),
            e && !e[u] && (e = va(e, f)),
            ha(function(f, g, h, i) {
                var j, k, l, m = [], n = [], o = g.length, p = f || ta(b || "*", h.nodeType ? [h] : h, []), q = !a || !f && b ? p : ua(p, m, a, h, i), r = c ? e || (f ? a : o || d) ? [] : g : q;
                if (c && c(q, r, h, i),
                d) {
                    j = ua(r, n),
                    d(j, [], h, i),
                    k = j.length;
                    while (k--)
                        (l = j[k]) && (r[n[k]] = !(q[n[k]] = l))
                }
                if (f) {
                    if (e || a) {
                        if (e) {
                            j = [],
                            k = r.length;
                            while (k--)
                                (l = r[k]) && j.push(q[k] = l);
                            e(null, r = [], j, i)
                        }
                        k = r.length;
                        while (k--)
                            (l = r[k]) && (j = e ? J(f, l) : m[k]) > -1 && (f[j] = !(g[j] = l))
                    }
                } else
                    r = ua(r === g ? r.splice(o, r.length) : r),
                    e ? e(null, g, r, i) : H.apply(g, r)
            })
        }
        function wa(a) {
            for (var b, c, e, f = a.length, g = d.relative[a[0].type], h = g || d.relative[" "], i = g ? 1 : 0, k = ra(function(a) {
                return a === b
            }, h, !0), l = ra(function(a) {
                return J(b, a) > -1
            }, h, !0), m = [function(a, c, d) {
                var e = !g && (d || c !== j) || ((b = c).nodeType ? k(a, c, d) : l(a, c, d));
                return b = null,
                e
            }
            ]; f > i; i++)
                if (c = d.relative[a[i].type])
                    m = [ra(sa(m), c)];
                else {
                    if (c = d.filter[a[i].type].apply(null, a[i].matches),
                    c[u]) {
                        for (e = ++i; f > e; e++)
                            if (d.relative[a[e].type])
                                break;
                        return va(i > 1 && sa(m), i > 1 && qa(a.slice(0, i - 1).concat({
                            value: " " === a[i - 2].type ? "*" : ""
                        })).replace(Q, "$1"), c, e > i && wa(a.slice(i, e)), f > e && wa(a = a.slice(e)), f > e && qa(a))
                    }
                    m.push(c)
                }
            return sa(m)
        }
        function xa(a, b) {
            var c = b.length > 0
              , e = a.length > 0
              , f = function(f, g, h, i, k) {
                var l, o, q, r = 0, s = "0", t = f && [], u = [], v = j, x = f || e && d.find.TAG("*", k), y = w += null == v ? 1 : Math.random() || .1, z = x.length;
                for (k && (j = g === n || g || k); s !== z && null != (l = x[s]); s++) {
                    if (e && l) {
                        o = 0,
                        g || l.ownerDocument === n || (m(l),
                        h = !p);
                        while (q = a[o++])
                            if (q(l, g || n, h)) {
                                i.push(l);
                                break
                            }
                        k && (w = y)
                    }
                    c && ((l = !q && l) && r--,
                    f && t.push(l))
                }
                if (r += s,
                c && s !== r) {
                    o = 0;
                    while (q = b[o++])
                        q(t, u, g, h);
                    if (f) {
                        if (r > 0)
                            while (s--)
                                t[s] || u[s] || (u[s] = F.call(i));
                        u = ua(u)
                    }
                    H.apply(i, u),
                    k && !f && u.length > 0 && r + b.length > 1 && fa.uniqueSort(i)
                }
                return k && (w = y,
                j = v),
                t
            };
            return c ? ha(f) : f
        }
        return h = fa.compile = function(a, b) {
            var c, d = [], e = [], f = A[a + " "];
            if (!f) {
                b || (b = g(a)),
                c = b.length;
                while (c--)
                    f = wa(b[c]),
                    f[u] ? d.push(f) : e.push(f);
                f = A(a, xa(e, d)),
                f.selector = a
            }
            return f
        }
        ,
        i = fa.select = function(a, b, e, f) {
            var i, j, k, l, m, n = "function" == typeof a && a, o = !f && g(a = n.selector || a);
            if (e = e || [],
            1 === o.length) {
                if (j = o[0] = o[0].slice(0),
                j.length > 2 && "ID" === (k = j[0]).type && c.getById && 9 === b.nodeType && p && d.relative[j[1].type]) {
                    if (b = (d.find.ID(k.matches[0].replace(ba, ca), b) || [])[0],
                    !b)
                        return e;
                    n && (b = b.parentNode),
                    a = a.slice(j.shift().value.length)
                }
                i = W.needsContext.test(a) ? 0 : j.length;
                while (i--) {
                    if (k = j[i],
                    d.relative[l = k.type])
                        break;
                    if ((m = d.find[l]) && (f = m(k.matches[0].replace(ba, ca), _.test(j[0].type) && oa(b.parentNode) || b))) {
                        if (j.splice(i, 1),
                        a = f.length && qa(j),
                        !a)
                            return H.apply(e, f),
                            e;
                        break
                    }
                }
            }
            return (n || h(a, o))(f, b, !p, e, !b || _.test(a) && oa(b.parentNode) || b),
            e
        }
        ,
        c.sortStable = u.split("").sort(B).join("") === u,
        c.detectDuplicates = !!l,
        m(),
        c.sortDetached = ia(function(a) {
            return 1 & a.compareDocumentPosition(n.createElement("div"))
        }),
        ia(function(a) {
            return a.innerHTML = "<a href='#'></a>",
            "#" === a.firstChild.getAttribute("href")
        }) || ja("type|href|height|width", function(a, b, c) {
            return c ? void 0 : a.getAttribute(b, "type" === b.toLowerCase() ? 1 : 2)
        }),
        c.attributes && ia(function(a) {
            return a.innerHTML = "<input/>",
            a.firstChild.setAttribute("value", ""),
            "" === a.firstChild.getAttribute("value")
        }) || ja("value", function(a, b, c) {
            return c || "input" !== a.nodeName.toLowerCase() ? void 0 : a.defaultValue
        }),
        ia(function(a) {
            return null == a.getAttribute("disabled")
        }) || ja(K, function(a, b, c) {
            var d;
            return c ? void 0 : a[b] === !0 ? b.toLowerCase() : (d = a.getAttributeNode(b)) && d.specified ? d.value : null
        }),
        fa
    }(a);
    n.find = t,
    n.expr = t.selectors,
    n.expr[":"] = n.expr.pseudos,
    n.uniqueSort = n.unique = t.uniqueSort,
    n.text = t.getText,
    n.isXMLDoc = t.isXML,
    n.contains = t.contains;
    var u = function(a, b, c) {
        var d = []
          , e = void 0 !== c;
        while ((a = a[b]) && 9 !== a.nodeType)
            if (1 === a.nodeType) {
                if (e && n(a).is(c))
                    break;
                d.push(a)
            }
        return d
    }
      , v = function(a, b) {
        for (var c = []; a; a = a.nextSibling)
            1 === a.nodeType && a !== b && c.push(a);
        return c
    }
      , w = n.expr.match.needsContext
      , x = /^<([\w-]+)\s*\/?>(?:<\/\1>|)$/
      , y = /^.[^:#\[\.,]*$/;
    function z(a, b, c) {
        if (n.isFunction(b))
            return n.grep(a, function(a, d) {
                return !!b.call(a, d, a) !== c
            });
        if (b.nodeType)
            return n.grep(a, function(a) {
                return a === b !== c
            });
        if ("string" == typeof b) {
            if (y.test(b))
                return n.filter(b, a, c);
            b = n.filter(b, a)
        }
        return n.grep(a, function(a) {
            return h.call(b, a) > -1 !== c
        })
    }
    n.filter = function(a, b, c) {
        var d = b[0];
        return c && (a = ":not(" + a + ")"),
        1 === b.length && 1 === d.nodeType ? n.find.matchesSelector(d, a) ? [d] : [] : n.find.matches(a, n.grep(b, function(a) {
            return 1 === a.nodeType
        }))
    }
    ,
    n.fn.extend({
        find: function(a) {
            var b, c = this.length, d = [], e = this;
            if ("string" != typeof a)
                return this.pushStack(n(a).filter(function() {
                    for (b = 0; c > b; b++)
                        if (n.contains(e[b], this))
                            return !0
                }));
            for (b = 0; c > b; b++)
                n.find(a, e[b], d);
            return d = this.pushStack(c > 1 ? n.unique(d) : d),
            d.selector = this.selector ? this.selector + " " + a : a,
            d
        },
        filter: function(a) {
            return this.pushStack(z(this, a || [], !1))
        },
        not: function(a) {
            return this.pushStack(z(this, a || [], !0))
        },
        is: function(a) {
            return !!z(this, "string" == typeof a && w.test(a) ? n(a) : a || [], !1).length
        }
    });
    var A, B = /^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]*))$/, C = n.fn.init = function(a, b, c) {
        var e, f;
        if (!a)
            return this;
        if (c = c || A,
        "string" == typeof a) {
            if (e = "<" === a[0] && ">" === a[a.length - 1] && a.length >= 3 ? [null, a, null] : B.exec(a),
            !e || !e[1] && b)
                return !b || b.jquery ? (b || c).find(a) : this.constructor(b).find(a);
            if (e[1]) {
                if (b = b instanceof n ? b[0] : b,
                n.merge(this, n.parseHTML(e[1], b && b.nodeType ? b.ownerDocument || b : d, !0)),
                x.test(e[1]) && n.isPlainObject(b))
                    for (e in b)
                        n.isFunction(this[e]) ? this[e](b[e]) : this.attr(e, b[e]);
                return this
            }
            return f = d.getElementById(e[2]),
            f && f.parentNode && (this.length = 1,
            this[0] = f),
            this.context = d,
            this.selector = a,
            this
        }
        return a.nodeType ? (this.context = this[0] = a,
        this.length = 1,
        this) : n.isFunction(a) ? void 0 !== c.ready ? c.ready(a) : a(n) : (void 0 !== a.selector && (this.selector = a.selector,
        this.context = a.context),
        n.makeArray(a, this))
    }
    ;
    C.prototype = n.fn,
    A = n(d);
    var D = /^(?:parents|prev(?:Until|All))/
      , E = {
        children: !0,
        contents: !0,
        next: !0,
        prev: !0
    };
    n.fn.extend({
        has: function(a) {
            var b = n(a, this)
              , c = b.length;
            return this.filter(function() {
                for (var a = 0; c > a; a++)
                    if (n.contains(this, b[a]))
                        return !0
            })
        },
        closest: function(a, b) {
            for (var c, d = 0, e = this.length, f = [], g = w.test(a) || "string" != typeof a ? n(a, b || this.context) : 0; e > d; d++)
                for (c = this[d]; c && c !== b; c = c.parentNode)
                    if (c.nodeType < 11 && (g ? g.index(c) > -1 : 1 === c.nodeType && n.find.matchesSelector(c, a))) {
                        f.push(c);
                        break
                    }
            return this.pushStack(f.length > 1 ? n.uniqueSort(f) : f)
        },
        index: function(a) {
            return a ? "string" == typeof a ? h.call(n(a), this[0]) : h.call(this, a.jquery ? a[0] : a) : this[0] && this[0].parentNode ? this.first().prevAll().length : -1
        },
        add: function(a, b) {
            return this.pushStack(n.uniqueSort(n.merge(this.get(), n(a, b))))
        },
        addBack: function(a) {
            return this.add(null == a ? this.prevObject : this.prevObject.filter(a))
        }
    });
    function F(a, b) {
        while ((a = a[b]) && 1 !== a.nodeType)
            ;
        return a
    }
    n.each({
        parent: function(a) {
            var b = a.parentNode;
            return b && 11 !== b.nodeType ? b : null
        },
        parents: function(a) {
            return u(a, "parentNode")
        },
        parentsUntil: function(a, b, c) {
            return u(a, "parentNode", c)
        },
        next: function(a) {
            return F(a, "nextSibling")
        },
        prev: function(a) {
            return F(a, "previousSibling")
        },
        nextAll: function(a) {
            return u(a, "nextSibling")
        },
        prevAll: function(a) {
            return u(a, "previousSibling")
        },
        nextUntil: function(a, b, c) {
            return u(a, "nextSibling", c)
        },
        prevUntil: function(a, b, c) {
            return u(a, "previousSibling", c)
        },
        siblings: function(a) {
            return v((a.parentNode || {}).firstChild, a)
        },
        children: function(a) {
            return v(a.firstChild)
        },
        contents: function(a) {
            return a.contentDocument || n.merge([], a.childNodes)
        }
    }, function(a, b) {
        n.fn[a] = function(c, d) {
            var e = n.map(this, b, c);
            return "Until" !== a.slice(-5) && (d = c),
            d && "string" == typeof d && (e = n.filter(d, e)),
            this.length > 1 && (E[a] || n.uniqueSort(e),
            D.test(a) && e.reverse()),
            this.pushStack(e)
        }
    });
    var G = /\S+/g;
    function H(a) {
        var b = {};
        return n.each(a.match(G) || [], function(a, c) {
            b[c] = !0
        }),
        b
    }
    n.Callbacks = function(a) {
        a = "string" == typeof a ? H(a) : n.extend({}, a);
        var b, c, d, e, f = [], g = [], h = -1, i = function() {
            for (e = a.once,
            d = b = !0; g.length; h = -1) {
                c = g.shift();
                while (++h < f.length)
                    f[h].apply(c[0], c[1]) === !1 && a.stopOnFalse && (h = f.length,
                    c = !1)
            }
            a.memory || (c = !1),
            b = !1,
            e && (f = c ? [] : "")
        }, j = {
            add: function() {
                return f && (c && !b && (h = f.length - 1,
                g.push(c)),
                function d(b) {
                    n.each(b, function(b, c) {
                        n.isFunction(c) ? a.unique && j.has(c) || f.push(c) : c && c.length && "string" !== n.type(c) && d(c)
                    })
                }(arguments),
                c && !b && i()),
                this
            },
            remove: function() {
                return n.each(arguments, function(a, b) {
                    var c;
                    while ((c = n.inArray(b, f, c)) > -1)
                        f.splice(c, 1),
                        h >= c && h--
                }),
                this
            },
            has: function(a) {
                return a ? n.inArray(a, f) > -1 : f.length > 0
            },
            empty: function() {
                return f && (f = []),
                this
            },
            disable: function() {
                return e = g = [],
                f = c = "",
                this
            },
            disabled: function() {
                return !f
            },
            lock: function() {
                return e = g = [],
                c || (f = c = ""),
                this
            },
            locked: function() {
                return !!e
            },
            fireWith: function(a, c) {
                return e || (c = c || [],
                c = [a, c.slice ? c.slice() : c],
                g.push(c),
                b || i()),
                this
            },
            fire: function() {
                return j.fireWith(this, arguments),
                this
            },
            fired: function() {
                return !!d
            }
        };
        return j
    }
    ,
    n.extend({
        Deferred: function(a) {
            var b = [["resolve", "done", n.Callbacks("once memory"), "resolved"], ["reject", "fail", n.Callbacks("once memory"), "rejected"], ["notify", "progress", n.Callbacks("memory")]]
              , c = "pending"
              , d = {
                state: function() {
                    return c
                },
                always: function() {
                    return e.done(arguments).fail(arguments),
                    this
                },
                then: function() {
                    var a = arguments;
                    return n.Deferred(function(c) {
                        n.each(b, function(b, f) {
                            var g = n.isFunction(a[b]) && a[b];
                            e[f[1]](function() {
                                var a = g && g.apply(this, arguments);
                                a && n.isFunction(a.promise) ? a.promise().progress(c.notify).done(c.resolve).fail(c.reject) : c[f[0] + "With"](this === d ? c.promise() : this, g ? [a] : arguments)
                            })
                        }),
                        a = null
                    }).promise()
                },
                promise: function(a) {
                    return null != a ? n.extend(a, d) : d
                }
            }
              , e = {};
            return d.pipe = d.then,
            n.each(b, function(a, f) {
                var g = f[2]
                  , h = f[3];
                d[f[1]] = g.add,
                h && g.add(function() {
                    c = h
                }, b[1 ^ a][2].disable, b[2][2].lock),
                e[f[0]] = function() {
                    return e[f[0] + "With"](this === e ? d : this, arguments),
                    this
                }
                ,
                e[f[0] + "With"] = g.fireWith
            }),
            d.promise(e),
            a && a.call(e, e),
            e
        },
        when: function(a) {
            var b = 0, c = e.call(arguments), d = c.length, f = 1 !== d || a && n.isFunction(a.promise) ? d : 0, g = 1 === f ? a : n.Deferred(), h = function(a, b, c) {
                return function(d) {
                    b[a] = this,
                    c[a] = arguments.length > 1 ? e.call(arguments) : d,
                    c === i ? g.notifyWith(b, c) : --f || g.resolveWith(b, c)
                }
            }, i, j, k;
            if (d > 1)
                for (i = new Array(d),
                j = new Array(d),
                k = new Array(d); d > b; b++)
                    c[b] && n.isFunction(c[b].promise) ? c[b].promise().progress(h(b, j, i)).done(h(b, k, c)).fail(g.reject) : --f;
            return f || g.resolveWith(k, c),
            g.promise()
        }
    });
    var I;
    n.fn.ready = function(a) {
        return n.ready.promise().done(a),
        this
    }
    ,
    n.extend({
        isReady: !1,
        readyWait: 1,
        holdReady: function(a) {
            a ? n.readyWait++ : n.ready(!0)
        },
        ready: function(a) {
            (a === !0 ? --n.readyWait : n.isReady) || (n.isReady = !0,
            a !== !0 && --n.readyWait > 0 || (I.resolveWith(d, [n]),
            n.fn.triggerHandler && (n(d).triggerHandler("ready"),
            n(d).off("ready"))))
        }
    });
    function J() {
        d.removeEventListener("DOMContentLoaded", J),
        a.removeEventListener("load", J),
        n.ready()
    }
    n.ready.promise = function(b) {
        return I || (I = n.Deferred(),
        "complete" === d.readyState || "loading" !== d.readyState && !d.documentElement.doScroll ? a.setTimeout(n.ready) : (d.addEventListener("DOMContentLoaded", J),
        a.addEventListener("load", J))),
        I.promise(b)
    }
    ,
    n.ready.promise();
    var K = function(a, b, c, d, e, f, g) {
        var h = 0
          , i = a.length
          , j = null == c;
        if ("object" === n.type(c)) {
            e = !0;
            for (h in c)
                K(a, b, h, c[h], !0, f, g)
        } else if (void 0 !== d && (e = !0,
        n.isFunction(d) || (g = !0),
        j && (g ? (b.call(a, d),
        b = null) : (j = b,
        b = function(a, b, c) {
            return j.call(n(a), c)
        }
        )),
        b))
            for (; i > h; h++)
                b(a[h], c, g ? d : d.call(a[h], h, b(a[h], c)));
        return e ? a : j ? b.call(a) : i ? b(a[0], c) : f
    }
      , L = function(a) {
        return 1 === a.nodeType || 9 === a.nodeType || !+a.nodeType
    };
    function M() {
        this.expando = n.expando + M.uid++
    }
    M.uid = 1,
    M.prototype = {
        register: function(a, b) {
            var c = b || {};
            return a.nodeType ? a[this.expando] = c : Object.defineProperty(a, this.expando, {
                value: c,
                writable: !0,
                configurable: !0
            }),
            a[this.expando]
        },
        cache: function(a) {
            if (!L(a))
                return {};
            var b = a[this.expando];
            return b || (b = {},
            L(a) && (a.nodeType ? a[this.expando] = b : Object.defineProperty(a, this.expando, {
                value: b,
                configurable: !0
            }))),
            b
        },
        set: function(a, b, c) {
            var d, e = this.cache(a);
            if ("string" == typeof b)
                e[b] = c;
            else
                for (d in b)
                    e[d] = b[d];
            return e
        },
        get: function(a, b) {
            return void 0 === b ? this.cache(a) : a[this.expando] && a[this.expando][b]
        },
        access: function(a, b, c) {
            var d;
            return void 0 === b || b && "string" == typeof b && void 0 === c ? (d = this.get(a, b),
            void 0 !== d ? d : this.get(a, n.camelCase(b))) : (this.set(a, b, c),
            void 0 !== c ? c : b)
        },
        remove: function(a, b) {
            var c, d, e, f = a[this.expando];
            if (void 0 !== f) {
                if (void 0 === b)
                    this.register(a);
                else {
                    n.isArray(b) ? d = b.concat(b.map(n.camelCase)) : (e = n.camelCase(b),
                    b in f ? d = [b, e] : (d = e,
                    d = d in f ? [d] : d.match(G) || [])),
                    c = d.length;
                    while (c--)
                        delete f[d[c]]
                }
                (void 0 === b || n.isEmptyObject(f)) && (a.nodeType ? a[this.expando] = void 0 : delete a[this.expando])
            }
        },
        hasData: function(a) {
            var b = a[this.expando];
            return void 0 !== b && !n.isEmptyObject(b)
        }
    };
    var N = new M
      , O = new M
      , P = /^(?:\{[\w\W]*\}|\[[\w\W]*\])$/
      , Q = /[A-Z]/g;
    function R(a, b, c) {
        var d;
        if (void 0 === c && 1 === a.nodeType)
            if (d = "data-" + b.replace(Q, "-$&").toLowerCase(),
            c = a.getAttribute(d),
            "string" == typeof c) {
                try {
                    c = "true" === c ? !0 : "false" === c ? !1 : "null" === c ? null : +c + "" === c ? +c : P.test(c) ? n.parseJSON(c) : c;
                } catch (e) {}
                O.set(a, b, c)
            } else
                c = void 0;
        return c
    }
    n.extend({
        hasData: function(a) {
            return O.hasData(a) || N.hasData(a)
        },
        data: function(a, b, c) {
            return O.access(a, b, c)
        },
        removeData: function(a, b) {
            O.remove(a, b)
        },
        _data: function(a, b, c) {
            return N.access(a, b, c)
        },
        _removeData: function(a, b) {
            N.remove(a, b)
        }
    }),
    n.fn.extend({
        data: function(a, b) {
            var c, d, e, f = this[0], g = f && f.attributes;
            if (void 0 === a) {
                if (this.length && (e = O.get(f),
                1 === f.nodeType && !N.get(f, "hasDataAttrs"))) {
                    c = g.length;
                    while (c--)
                        g[c] && (d = g[c].name,
                        0 === d.indexOf("data-") && (d = n.camelCase(d.slice(5)),
                        R(f, d, e[d])));
                    N.set(f, "hasDataAttrs", !0)
                }
                return e
            }
            return "object" == typeof a ? this.each(function() {
                O.set(this, a)
            }) : K(this, function(b) {
                var c, d;
                if (f && void 0 === b) {
                    if (c = O.get(f, a) || O.get(f, a.replace(Q, "-$&").toLowerCase()),
                    void 0 !== c)
                        return c;
                    if (d = n.camelCase(a),
                    c = O.get(f, d),
                    void 0 !== c)
                        return c;
                    if (c = R(f, d, void 0),
                    void 0 !== c)
                        return c
                } else
                    d = n.camelCase(a),
                    this.each(function() {
                        var c = O.get(this, d);
                        O.set(this, d, b),
                        a.indexOf("-") > -1 && void 0 !== c && O.set(this, a, b)
                    })
            }, null, b, arguments.length > 1, null, !0)
        },
        removeData: function(a) {
            return this.each(function() {
                O.remove(this, a)
            })
        }
    }),
    n.extend({
        queue: function(a, b, c) {
            var d;
            return a ? (b = (b || "fx") + "queue",
            d = N.get(a, b),
            c && (!d || n.isArray(c) ? d = N.access(a, b, n.makeArray(c)) : d.push(c)),
            d || []) : void 0
        },
        dequeue: function(a, b) {
            b = b || "fx";
            var c = n.queue(a, b)
              , d = c.length
              , e = c.shift()
              , f = n._queueHooks(a, b)
              , g = function() {
                n.dequeue(a, b)
            };
            "inprogress" === e && (e = c.shift(),
            d--),
            e && ("fx" === b && c.unshift("inprogress"),
            delete f.stop,
            e.call(a, g, f)),
            !d && f && f.empty.fire()
        },
        _queueHooks: function(a, b) {
            var c = b + "queueHooks";
            return N.get(a, c) || N.access(a, c, {
                empty: n.Callbacks("once memory").add(function() {
                    N.remove(a, [b + "queue", c])
                })
            })
        }
    }),
    n.fn.extend({
        queue: function(a, b) {
            var c = 2;
            return "string" != typeof a && (b = a,
            a = "fx",
            c--),
            arguments.length < c ? n.queue(this[0], a) : void 0 === b ? this : this.each(function() {
                var c = n.queue(this, a, b);
                n._queueHooks(this, a),
                "fx" === a && "inprogress" !== c[0] && n.dequeue(this, a)
            })
        },
        dequeue: function(a) {
            return this.each(function() {
                n.dequeue(this, a)
            })
        },
        clearQueue: function(a) {
            return this.queue(a || "fx", [])
        },
        promise: function(a, b) {
            var c, d = 1, e = n.Deferred(), f = this, g = this.length, h = function() {
                --d || e.resolveWith(f, [f])
            };
            "string" != typeof a && (b = a,
            a = void 0),
            a = a || "fx";
            while (g--)
                c = N.get(f[g], a + "queueHooks"),
                c && c.empty && (d++,
                c.empty.add(h));
            return h(),
            e.promise(b)
        }
    });
    var S = /[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source
      , T = new RegExp("^(?:([+-])=|)(" + S + ")([a-z%]*)$","i")
      , U = ["Top", "Right", "Bottom", "Left"]
      , V = function(a, b) {
        return a = b || a,
        "none" === n.css(a, "display") || !n.contains(a.ownerDocument, a)
    };
    function W(a, b, c, d) {
        var e, f = 1, g = 20, h = d ? function() {
            return d.cur()
        }
        : function() {
            return n.css(a, b, "")
        }
        , i = h(), j = c && c[3] || (n.cssNumber[b] ? "" : "px"), k = (n.cssNumber[b] || "px" !== j && +i) && T.exec(n.css(a, b));
        if (k && k[3] !== j) {
            j = j || k[3],
            c = c || [],
            k = +i || 1;
            do
                f = f || ".5",
                k /= f,
                n.style(a, b, k + j);
            while (f !== (f = h() / i) && 1 !== f && --g)
        }
        return c && (k = +k || +i || 0,
        e = c[1] ? k + (c[1] + 1) * c[2] : +c[2],
        d && (d.unit = j,
        d.start = k,
        d.end = e)),
        e
    }
    var X = /^(?:checkbox|radio)$/i
      , Y = /<([\w:-]+)/
      , Z = /^$|\/(?:java|ecma)script/i
      , $ = {
        option: [1, "<select multiple='multiple'>", "</select>"],
        thead: [1, "<table>", "</table>"],
        col: [2, "<table><colgroup>", "</colgroup></table>"],
        tr: [2, "<table><tbody>", "</tbody></table>"],
        td: [3, "<table><tbody><tr>", "</tr></tbody></table>"],
        _default: [0, "", ""]
    };
    $.optgroup = $.option,
    $.tbody = $.tfoot = $.colgroup = $.caption = $.thead,
    $.th = $.td;
    function _(a, b) {
        var c = "undefined" != typeof a.getElementsByTagName ? a.getElementsByTagName(b || "*") : "undefined" != typeof a.querySelectorAll ? a.querySelectorAll(b || "*") : [];
        return void 0 === b || b && n.nodeName(a, b) ? n.merge([a], c) : c
    }
    function aa(a, b) {
        for (var c = 0, d = a.length; d > c; c++)
            N.set(a[c], "globalEval", !b || N.get(b[c], "globalEval"))
    }
    var ba = /<|&#?\w+;/;
    function ca(a, b, c, d, e) {
        for (var f, g, h, i, j, k, l = b.createDocumentFragment(), m = [], o = 0, p = a.length; p > o; o++)
            if (f = a[o],
            f || 0 === f)
                if ("object" === n.type(f))
                    n.merge(m, f.nodeType ? [f] : f);
                else if (ba.test(f)) {
                    g = g || l.appendChild(b.createElement("div")),
                    h = (Y.exec(f) || ["", ""])[1].toLowerCase(),
                    i = $[h] || $._default,
                    g.innerHTML = i[1] + n.htmlPrefilter(f) + i[2],
                    k = i[0];
                    while (k--)
                        g = g.lastChild;
                    n.merge(m, g.childNodes),
                    g = l.firstChild,
                    g.textContent = ""
                } else
                    m.push(b.createTextNode(f));
        l.textContent = "",
        o = 0;
        while (f = m[o++])
            if (d && n.inArray(f, d) > -1)
                e && e.push(f);
            else if (j = n.contains(f.ownerDocument, f),
            g = _(l.appendChild(f), "script"),
            j && aa(g),
            c) {
                k = 0;
                while (f = g[k++])
                    Z.test(f.type || "") && c.push(f)
            }
        return l
    }
    !function() {
        var a = d.createDocumentFragment()
          , b = a.appendChild(d.createElement("div"))
          , c = d.createElement("input");
        c.setAttribute("type", "radio"),
        c.setAttribute("checked", "checked"),
        c.setAttribute("name", "t"),
        b.appendChild(c),
        l.checkClone = b.cloneNode(!0).cloneNode(!0).lastChild.checked,
        b.innerHTML = "<textarea>x</textarea>",
        l.noCloneChecked = !!b.cloneNode(!0).lastChild.defaultValue
    }();
    var da = /^key/
      , ea = /^(?:mouse|pointer|contextmenu|drag|drop)|click/
      , fa = /^([^.]*)(?:\.(.+)|)/;
    function ga() {
        return !0
    }
    function ha() {
        return !1
    }
    function ia() {
        try {
            return d.activeElement
        } catch (a) {}
    }
    function ja(a, b, c, d, e, f) {
        var g, h;
        if ("object" == typeof b) {
            "string" != typeof c && (d = d || c,
            c = void 0);
            for (h in b)
                ja(a, h, c, d, b[h], f);
            return a
        }
        if (null == d && null == e ? (e = c,
        d = c = void 0) : null == e && ("string" == typeof c ? (e = d,
        d = void 0) : (e = d,
        d = c,
        c = void 0)),
        e === !1)
            e = ha;
        else if (!e)
            return a;
        return 1 === f && (g = e,
        e = function(a) {
            return n().off(a),
            g.apply(this, arguments)
        }
        ,
        e.guid = g.guid || (g.guid = n.guid++)),
        a.each(function() {
            n.event.add(this, b, e, d, c)
        })
    }
    n.event = {
        global: {},
        add: function(a, b, c, d, e) {
            var f, g, h, i, j, k, l, m, o, p, q, r = N.get(a);
            if (r) {
                c.handler && (f = c,
                c = f.handler,
                e = f.selector),
                c.guid || (c.guid = n.guid++),
                (i = r.events) || (i = r.events = {}),
                (g = r.handle) || (g = r.handle = function(b) {
                    return "undefined" != typeof n && n.event.triggered !== b.type ? n.event.dispatch.apply(a, arguments) : void 0
                }
                ),
                b = (b || "").match(G) || [""],
                j = b.length;
                while (j--)
                    h = fa.exec(b[j]) || [],
                    o = q = h[1],
                    p = (h[2] || "").split(".").sort(),
                    o && (l = n.event.special[o] || {},
                    o = (e ? l.delegateType : l.bindType) || o,
                    l = n.event.special[o] || {},
                    k = n.extend({
                        type: o,
                        origType: q,
                        data: d,
                        handler: c,
                        guid: c.guid,
                        selector: e,
                        needsContext: e && n.expr.match.needsContext.test(e),
                        namespace: p.join(".")
                    }, f),
                    (m = i[o]) || (m = i[o] = [],
                    m.delegateCount = 0,
                    l.setup && l.setup.call(a, d, p, g) !== !1 || a.addEventListener && a.addEventListener(o, g)),
                    l.add && (l.add.call(a, k),
                    k.handler.guid || (k.handler.guid = c.guid)),
                    e ? m.splice(m.delegateCount++, 0, k) : m.push(k),
                    n.event.global[o] = !0)
            }
        },
        remove: function(a, b, c, d, e) {
            var f, g, h, i, j, k, l, m, o, p, q, r = N.hasData(a) && N.get(a);
            if (r && (i = r.events)) {
                b = (b || "").match(G) || [""],
                j = b.length;
                while (j--)
                    if (h = fa.exec(b[j]) || [],
                    o = q = h[1],
                    p = (h[2] || "").split(".").sort(),
                    o) {
                        l = n.event.special[o] || {},
                        o = (d ? l.delegateType : l.bindType) || o,
                        m = i[o] || [],
                        h = h[2] && new RegExp("(^|\\.)" + p.join("\\.(?:.*\\.|)") + "(\\.|$)"),
                        g = f = m.length;
                        while (f--)
                            k = m[f],
                            !e && q !== k.origType || c && c.guid !== k.guid || h && !h.test(k.namespace) || d && d !== k.selector && ("**" !== d || !k.selector) || (m.splice(f, 1),
                            k.selector && m.delegateCount--,
                            l.remove && l.remove.call(a, k));
                        g && !m.length && (l.teardown && l.teardown.call(a, p, r.handle) !== !1 || n.removeEvent(a, o, r.handle),
                        delete i[o])
                    } else
                        for (o in i)
                            n.event.remove(a, o + b[j], c, d, !0);
                n.isEmptyObject(i) && N.remove(a, "handle events")
            }
        },
        dispatch: function(a) {
            a = n.event.fix(a);
            var b, c, d, f, g, h = [], i = e.call(arguments), j = (N.get(this, "events") || {})[a.type] || [], k = n.event.special[a.type] || {};
            if (i[0] = a,
            a.delegateTarget = this,
            !k.preDispatch || k.preDispatch.call(this, a) !== !1) {
                h = n.event.handlers.call(this, a, j),
                b = 0;
                while ((f = h[b++]) && !a.isPropagationStopped()) {
                    a.currentTarget = f.elem,
                    c = 0;
                    while ((g = f.handlers[c++]) && !a.isImmediatePropagationStopped())
                        a.rnamespace && !a.rnamespace.test(g.namespace) || (a.handleObj = g,
                        a.data = g.data,
                        d = ((n.event.special[g.origType] || {}).handle || g.handler).apply(f.elem, i),
                        void 0 !== d && (a.result = d) === !1 && (a.preventDefault(),
                        a.stopPropagation()))
                }
                return k.postDispatch && k.postDispatch.call(this, a),
                a.result
            }
        },
        handlers: function(a, b) {
            var c, d, e, f, g = [], h = b.delegateCount, i = a.target;
            if (h && i.nodeType && ("click" !== a.type || isNaN(a.button) || a.button < 1))
                for (; i !== this; i = i.parentNode || this)
                    if (1 === i.nodeType && (i.disabled !== !0 || "click" !== a.type)) {
                        for (d = [],
                        c = 0; h > c; c++)
                            f = b[c],
                            e = f.selector + " ",
                            void 0 === d[e] && (d[e] = f.needsContext ? n(e, this).index(i) > -1 : n.find(e, this, null, [i]).length),
                            d[e] && d.push(f);
                        d.length && g.push({
                            elem: i,
                            handlers: d
                        })
                    }
            return h < b.length && g.push({
                elem: this,
                handlers: b.slice(h)
            }),
            g
        },
        props: "altKey bubbles cancelable ctrlKey currentTarget detail eventPhase metaKey relatedTarget shiftKey target timeStamp view which".split(" "),
        fixHooks: {},
        keyHooks: {
            props: "char charCode key keyCode".split(" "),
            filter: function(a, b) {
                return null == a.which && (a.which = null != b.charCode ? b.charCode : b.keyCode),
                a
            }
        },
        mouseHooks: {
            props: "button buttons clientX clientY offsetX offsetY pageX pageY screenX screenY toElement".split(" "),
            filter: function(a, b) {
                var c, e, f, g = b.button;
                return null == a.pageX && null != b.clientX && (c = a.target.ownerDocument || d,
                e = c.documentElement,
                f = c.body,
                a.pageX = b.clientX + (e && e.scrollLeft || f && f.scrollLeft || 0) - (e && e.clientLeft || f && f.clientLeft || 0),
                a.pageY = b.clientY + (e && e.scrollTop || f && f.scrollTop || 0) - (e && e.clientTop || f && f.clientTop || 0)),
                a.which || void 0 === g || (a.which = 1 & g ? 1 : 2 & g ? 3 : 4 & g ? 2 : 0),
                a
            }
        },
        fix: function(a) {
            if (a[n.expando])
                return a;
            var b, c, e, f = a.type, g = a, h = this.fixHooks[f];
            h || (this.fixHooks[f] = h = ea.test(f) ? this.mouseHooks : da.test(f) ? this.keyHooks : {}),
            e = h.props ? this.props.concat(h.props) : this.props,
            a = new n.Event(g),
            b = e.length;
            while (b--)
                c = e[b],
                a[c] = g[c];
            return a.target || (a.target = d),
            3 === a.target.nodeType && (a.target = a.target.parentNode),
            h.filter ? h.filter(a, g) : a
        },
        special: {
            load: {
                noBubble: !0
            },
            focus: {
                trigger: function() {
                    return this !== ia() && this.focus ? (this.focus(),
                    !1) : void 0
                },
                delegateType: "focusin"
            },
            blur: {
                trigger: function() {
                    return this === ia() && this.blur ? (this.blur(),
                    !1) : void 0
                },
                delegateType: "focusout"
            },
            click: {
                trigger: function() {
                    return "checkbox" === this.type && this.click && n.nodeName(this, "input") ? (this.click(),
                    !1) : void 0
                },
                _default: function(a) {
                    return n.nodeName(a.target, "a")
                }
            },
            beforeunload: {
                postDispatch: function(a) {
                    void 0 !== a.result && a.originalEvent && (a.originalEvent.returnValue = a.result)
                }
            }
        }
    },
    n.removeEvent = function(a, b, c) {
        a.removeEventListener && a.removeEventListener(b, c)
    }
    ,
    n.Event = function(a, b) {
        return this instanceof n.Event ? (a && a.type ? (this.originalEvent = a,
        this.type = a.type,
        this.isDefaultPrevented = a.defaultPrevented || void 0 === a.defaultPrevented && a.returnValue === !1 ? ga : ha) : this.type = a,
        b && n.extend(this, b),
        this.timeStamp = a && a.timeStamp || n.now(),
        void (this[n.expando] = !0)) : new n.Event(a,b)
    }
    ,
    n.Event.prototype = {
        constructor: n.Event,
        isDefaultPrevented: ha,
        isPropagationStopped: ha,
        isImmediatePropagationStopped: ha,
        preventDefault: function() {
            var a = this.originalEvent;
            this.isDefaultPrevented = ga,
            a && a.preventDefault()
        },
        stopPropagation: function() {
            var a = this.originalEvent;
            this.isPropagationStopped = ga,
            a && a.stopPropagation()
        },
        stopImmediatePropagation: function() {
            var a = this.originalEvent;
            this.isImmediatePropagationStopped = ga,
            a && a.stopImmediatePropagation(),
            this.stopPropagation()
        }
    },
    n.each({
        mouseenter: "mouseover",
        mouseleave: "mouseout",
        pointerenter: "pointerover",
        pointerleave: "pointerout"
    }, function(a, b) {
        n.event.special[a] = {
            delegateType: b,
            bindType: b,
            handle: function(a) {
                var c, d = this, e = a.relatedTarget, f = a.handleObj;
                return e && (e === d || n.contains(d, e)) || (a.type = f.origType,
                c = f.handler.apply(this, arguments),
                a.type = b),
                c
            }
        }
    }),
    n.fn.extend({
        on: function(a, b, c, d) {
            return ja(this, a, b, c, d)
        },
        one: function(a, b, c, d) {
            return ja(this, a, b, c, d, 1)
        },
        off: function(a, b, c) {
            var d, e;
            if (a && a.preventDefault && a.handleObj)
                return d = a.handleObj,
                n(a.delegateTarget).off(d.namespace ? d.origType + "." + d.namespace : d.origType, d.selector, d.handler),
                this;
            if ("object" == typeof a) {
                for (e in a)
                    this.off(e, b, a[e]);
                return this
            }
            return b !== !1 && "function" != typeof b || (c = b,
            b = void 0),
            c === !1 && (c = ha),
            this.each(function() {
                n.event.remove(this, a, c, b)
            })
        }
    });
    var ka = /<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:-]+)[^>]*)\/>/gi
      , la = /<script|<style|<link/i
      , ma = /checked\s*(?:[^=]|=\s*.checked.)/i
      , na = /^true\/(.*)/
      , oa = /^\s*<!(?:\[CDATA\[|--)|(?:\]\]|--)>\s*$/g;
    function pa(a, b) {
        return n.nodeName(a, "table") && n.nodeName(11 !== b.nodeType ? b : b.firstChild, "tr") ? a.getElementsByTagName("tbody")[0] || a.appendChild(a.ownerDocument.createElement("tbody")) : a
    }
    function qa(a) {
        return a.type = (null !== a.getAttribute("type")) + "/" + a.type,
        a
    }
    function ra(a) {
        var b = na.exec(a.type);
        return b ? a.type = b[1] : a.removeAttribute("type"),
        a
    }
    function sa(a, b) {
        var c, d, e, f, g, h, i, j;
        if (1 === b.nodeType) {
            if (N.hasData(a) && (f = N.access(a),
            g = N.set(b, f),
            j = f.events)) {
                delete g.handle,
                g.events = {};
                for (e in j)
                    for (c = 0,
                    d = j[e].length; d > c; c++)
                        n.event.add(b, e, j[e][c])
            }
            O.hasData(a) && (h = O.access(a),
            i = n.extend({}, h),
            O.set(b, i))
        }
    }
    function ta(a, b) {
        var c = b.nodeName.toLowerCase();
        "input" === c && X.test(a.type) ? b.checked = a.checked : "input" !== c && "textarea" !== c || (b.defaultValue = a.defaultValue)
    }
    function ua(a, b, c, d) {
        b = f.apply([], b);
        var e, g, h, i, j, k, m = 0, o = a.length, p = o - 1, q = b[0], r = n.isFunction(q);
        if (r || o > 1 && "string" == typeof q && !l.checkClone && ma.test(q))
            return a.each(function(e) {
                var f = a.eq(e);
                r && (b[0] = q.call(this, e, f.html())),
                ua(f, b, c, d)
            });
        if (o && (e = ca(b, a[0].ownerDocument, !1, a, d),
        g = e.firstChild,
        1 === e.childNodes.length && (e = g),
        g || d)) {
            for (h = n.map(_(e, "script"), qa),
            i = h.length; o > m; m++)
                j = e,
                m !== p && (j = n.clone(j, !0, !0),
                i && n.merge(h, _(j, "script"))),
                c.call(a[m], j, m);
            if (i)
                for (k = h[h.length - 1].ownerDocument,
                n.map(h, ra),
                m = 0; i > m; m++)
                    j = h[m],
                    Z.test(j.type || "") && !N.access(j, "globalEval") && n.contains(k, j) && (j.src ? n._evalUrl && n._evalUrl(j.src) : n.globalEval(j.textContent.replace(oa, "")))
        }
        return a
    }
    function va(a, b, c) {
        for (var d, e = b ? n.filter(b, a) : a, f = 0; null != (d = e[f]); f++)
            c || 1 !== d.nodeType || n.cleanData(_(d)),
            d.parentNode && (c && n.contains(d.ownerDocument, d) && aa(_(d, "script")),
            d.parentNode.removeChild(d));
        return a
    }
    n.extend({
        htmlPrefilter: function(a) {
            return a.replace(ka, "<$1></$2>")
        },
        clone: function(a, b, c) {
            var d, e, f, g, h = a.cloneNode(!0), i = n.contains(a.ownerDocument, a);
            if (!(l.noCloneChecked || 1 !== a.nodeType && 11 !== a.nodeType || n.isXMLDoc(a)))
                for (g = _(h),
                f = _(a),
                d = 0,
                e = f.length; e > d; d++)
                    ta(f[d], g[d]);
            if (b)
                if (c)
                    for (f = f || _(a),
                    g = g || _(h),
                    d = 0,
                    e = f.length; e > d; d++)
                        sa(f[d], g[d]);
                else
                    sa(a, h);
            return g = _(h, "script"),
            g.length > 0 && aa(g, !i && _(a, "script")),
            h
        },
        cleanData: function(a) {
            for (var b, c, d, e = n.event.special, f = 0; void 0 !== (c = a[f]); f++)
                if (L(c)) {
                    if (b = c[N.expando]) {
                        if (b.events)
                            for (d in b.events)
                                e[d] ? n.event.remove(c, d) : n.removeEvent(c, d, b.handle);
                        c[N.expando] = void 0
                    }
                    c[O.expando] && (c[O.expando] = void 0)
                }
        }
    }),
    n.fn.extend({
        domManip: ua,
        detach: function(a) {
            return va(this, a, !0)
        },
        remove: function(a) {
            return va(this, a)
        },
        text: function(a) {
            return K(this, function(a) {
                return void 0 === a ? n.text(this) : this.empty().each(function() {
                    1 !== this.nodeType && 11 !== this.nodeType && 9 !== this.nodeType || (this.textContent = a)
                })
            }, null, a, arguments.length)
        },
        append: function() {
            return ua(this, arguments, function(a) {
                if (1 === this.nodeType || 11 === this.nodeType || 9 === this.nodeType) {
                    var b = pa(this, a);
                    b.appendChild(a)
                }
            })
        },
        prepend: function() {
            return ua(this, arguments, function(a) {
                if (1 === this.nodeType || 11 === this.nodeType || 9 === this.nodeType) {
                    var b = pa(this, a);
                    b.insertBefore(a, b.firstChild)
                }
            })
        },
        before: function() {
            return ua(this, arguments, function(a) {
                this.parentNode && this.parentNode.insertBefore(a, this)
            })
        },
        after: function() {
            return ua(this, arguments, function(a) {
                this.parentNode && this.parentNode.insertBefore(a, this.nextSibling)
            })
        },
        empty: function() {
            for (var a, b = 0; null != (a = this[b]); b++)
                1 === a.nodeType && (n.cleanData(_(a, !1)),
                a.textContent = "");
            return this
        },
        clone: function(a, b) {
            return a = null == a ? !1 : a,
            b = null == b ? a : b,
            this.map(function() {
                return n.clone(this, a, b)
            })
        },
        html: function(a) {
            return K(this, function(a) {
                var b = this[0] || {}
                  , c = 0
                  , d = this.length;
                if (void 0 === a && 1 === b.nodeType)
                    return b.innerHTML;
                if ("string" == typeof a && !la.test(a) && !$[(Y.exec(a) || ["", ""])[1].toLowerCase()]) {
                    a = n.htmlPrefilter(a);
                    try {
                        for (; d > c; c++)
                            b = this[c] || {},
                            1 === b.nodeType && (n.cleanData(_(b, !1)),
                            b.innerHTML = a);
                        b = 0
                    } catch (e) {}
                }
                b && this.empty().append(a)
            }, null, a, arguments.length)
        },
        replaceWith: function() {
            var a = [];
            return ua(this, arguments, function(b) {
                var c = this.parentNode;
                n.inArray(this, a) < 0 && (n.cleanData(_(this)),
                c && c.replaceChild(b, this))
            }, a)
        }
    }),
    n.each({
        appendTo: "append",
        prependTo: "prepend",
        insertBefore: "before",
        insertAfter: "after",
        replaceAll: "replaceWith"
    }, function(a, b) {
        n.fn[a] = function(a) {
            for (var c, d = [], e = n(a), f = e.length - 1, h = 0; f >= h; h++)
                c = h === f ? this : this.clone(!0),
                n(e[h])[b](c),
                g.apply(d, c.get());
            return this.pushStack(d)
        }
    });
    var wa, xa = {
        HTML: "block",
        BODY: "block"
    };
    function ya(a, b) {
        var c = n(b.createElement(a)).appendTo(b.body)
          , d = n.css(c[0], "display");
        return c.detach(),
        d
    }
    function za(a) {
        var b = d
          , c = xa[a];
        return c || (c = ya(a, b),
        "none" !== c && c || (wa = (wa || n("<iframe frameborder='0' width='0' height='0'/>")).appendTo(b.documentElement),
        b = wa[0].contentDocument,
        b.write(),
        b.close(),
        c = ya(a, b),
        wa.detach()),
        xa[a] = c),
        c
    }
    var Aa = /^margin/
      , Ba = new RegExp("^(" + S + ")(?!px)[a-z%]+$","i")
      , Ca = function(b) {
        var c = b.ownerDocument.defaultView;
        return c && c.opener || (c = a),
        c.getComputedStyle(b)
    }
      , Da = function(a, b, c, d) {
        var e, f, g = {};
        for (f in b)
            g[f] = a.style[f],
            a.style[f] = b[f];
        e = c.apply(a, d || []);
        for (f in b)
            a.style[f] = g[f];
        return e
    }
      , Ea = d.documentElement;
    !function() {
        var b, c, e, f, g = d.createElement("div"), h = d.createElement("div");
        if (h.style) {
            h.style.backgroundClip = "content-box",
            h.cloneNode(!0).style.backgroundClip = "",
            l.clearCloneStyle = "content-box" === h.style.backgroundClip,
            g.style.cssText = "border:0;width:8px;height:0;top:0;left:-9999px;padding:0;margin-top:1px;position:absolute",
            g.appendChild(h);
            function i() {
                h.style.cssText = "-webkit-box-sizing:border-box;-moz-box-sizing:border-box;box-sizing:border-box;position:relative;display:block;margin:auto;border:1px;padding:1px;top:1%;width:50%",
                h.innerHTML = "",
                Ea.appendChild(g);
                var d = a.getComputedStyle(h);
                b = "1%" !== d.top,
                f = "2px" === d.marginLeft,
                c = "4px" === d.width,
                h.style.marginRight = "50%",
                e = "4px" === d.marginRight,
                Ea.removeChild(g)
            }
            n.extend(l, {
                pixelPosition: function() {
                    return i(),
                    b
                },
                boxSizingReliable: function() {
                    return null == c && i(),
                    c
                },
                pixelMarginRight: function() {
                    return null == c && i(),
                    e
                },
                reliableMarginLeft: function() {
                    return null == c && i(),
                    f
                },
                reliableMarginRight: function() {
                    var b, c = h.appendChild(d.createElement("div"));
                    return c.style.cssText = h.style.cssText = "-webkit-box-sizing:content-box;box-sizing:content-box;display:block;margin:0;border:0;padding:0",
                    c.style.marginRight = c.style.width = "0",
                    h.style.width = "1px",
                    Ea.appendChild(g),
                    b = !parseFloat(a.getComputedStyle(c).marginRight),
                    Ea.removeChild(g),
                    h.removeChild(c),
                    b
                }
            })
        }
    }();
    function Fa(a, b, c) {
        var d, e, f, g, h = a.style;
        return c = c || Ca(a),
        g = c ? c.getPropertyValue(b) || c[b] : void 0,
        "" !== g && void 0 !== g || n.contains(a.ownerDocument, a) || (g = n.style(a, b)),
        c && !l.pixelMarginRight() && Ba.test(g) && Aa.test(b) && (d = h.width,
        e = h.minWidth,
        f = h.maxWidth,
        h.minWidth = h.maxWidth = h.width = g,
        g = c.width,
        h.width = d,
        h.minWidth = e,
        h.maxWidth = f),
        void 0 !== g ? g + "" : g
    }
    function Ga(a, b) {
        return {
            get: function() {
                return a() ? void delete this.get : (this.get = b).apply(this, arguments)
            }
        }
    }
    var Ha = /^(none|table(?!-c[ea]).+)/
      , Ia = {
        position: "absolute",
        visibility: "hidden",
        display: "block"
    }
      , Ja = {
        letterSpacing: "0",
        fontWeight: "400"
    }
      , Ka = ["Webkit", "O", "Moz", "ms"]
      , La = d.createElement("div").style;
    function Ma(a) {
        if (a in La)
            return a;
        var b = a[0].toUpperCase() + a.slice(1)
          , c = Ka.length;
        while (c--)
            if (a = Ka[c] + b,
            a in La)
                return a
    }
    function Na(a, b, c) {
        var d = T.exec(b);
        return d ? Math.max(0, d[2] - (c || 0)) + (d[3] || "px") : b
    }
    function Oa(a, b, c, d, e) {
        for (var f = c === (d ? "border" : "content") ? 4 : "width" === b ? 1 : 0, g = 0; 4 > f; f += 2)
            "margin" === c && (g += n.css(a, c + U[f], !0, e)),
            d ? ("content" === c && (g -= n.css(a, "padding" + U[f], !0, e)),
            "margin" !== c && (g -= n.css(a, "border" + U[f] + "Width", !0, e))) : (g += n.css(a, "padding" + U[f], !0, e),
            "padding" !== c && (g += n.css(a, "border" + U[f] + "Width", !0, e)));
        return g
    }
    function Pa(b, c, e) {
        var f = !0
          , g = "width" === c ? b.offsetWidth : b.offsetHeight
          , h = Ca(b)
          , i = "border-box" === n.css(b, "boxSizing", !1, h);
        if (d.msFullscreenElement && a.top !== a && b.getClientRects().length && (g = Math.round(100 * b.getBoundingClientRect()[c])),
        0 >= g || null == g) {
            if (g = Fa(b, c, h),
            (0 > g || null == g) && (g = b.style[c]),
            Ba.test(g))
                return g;
            f = i && (l.boxSizingReliable() || g === b.style[c]),
            g = parseFloat(g) || 0
        }
        return g + Oa(b, c, e || (i ? "border" : "content"), f, h) + "px"
    }
    function Qa(a, b) {
        for (var c, d, e, f = [], g = 0, h = a.length; h > g; g++)
            d = a[g],
            d.style && (f[g] = N.get(d, "olddisplay"),
            c = d.style.display,
            b ? (f[g] || "none" !== c || (d.style.display = ""),
            "" === d.style.display && V(d) && (f[g] = N.access(d, "olddisplay", za(d.nodeName)))) : (e = V(d),
            "none" === c && e || N.set(d, "olddisplay", e ? c : n.css(d, "display"))));
        for (g = 0; h > g; g++)
            d = a[g],
            d.style && (b && "none" !== d.style.display && "" !== d.style.display || (d.style.display = b ? f[g] || "" : "none"));
        return a
    }
    n.extend({
        cssHooks: {
            opacity: {
                get: function(a, b) {
                    if (b) {
                        var c = Fa(a, "opacity");
                        return "" === c ? "1" : c
                    }
                }
            }
        },
        cssNumber: {
            animationIterationCount: !0,
            columnCount: !0,
            fillOpacity: !0,
            flexGrow: !0,
            flexShrink: !0,
            fontWeight: !0,
            lineHeight: !0,
            opacity: !0,
            order: !0,
            orphans: !0,
            widows: !0,
            zIndex: !0,
            zoom: !0
        },
        cssProps: {
            "float": "cssFloat"
        },
        style: function(a, b, c, d) {
            if (a && 3 !== a.nodeType && 8 !== a.nodeType && a.style) {
                var e, f, g, h = n.camelCase(b), i = a.style;
                return b = n.cssProps[h] || (n.cssProps[h] = Ma(h) || h),
                g = n.cssHooks[b] || n.cssHooks[h],
                void 0 === c ? g && "get"in g && void 0 !== (e = g.get(a, !1, d)) ? e : i[b] : (f = typeof c,
                "string" === f && (e = T.exec(c)) && e[1] && (c = W(a, b, e),
                f = "number"),
                null != c && c === c && ("number" === f && (c += e && e[3] || (n.cssNumber[h] ? "" : "px")),
                l.clearCloneStyle || "" !== c || 0 !== b.indexOf("background") || (i[b] = "inherit"),
                g && "set"in g && void 0 === (c = g.set(a, c, d)) || (i[b] = c)),
                void 0)
            }
        },
        css: function(a, b, c, d) {
            var e, f, g, h = n.camelCase(b);
            return b = n.cssProps[h] || (n.cssProps[h] = Ma(h) || h),
            g = n.cssHooks[b] || n.cssHooks[h],
            g && "get"in g && (e = g.get(a, !0, c)),
            void 0 === e && (e = Fa(a, b, d)),
            "normal" === e && b in Ja && (e = Ja[b]),
            "" === c || c ? (f = parseFloat(e),
            c === !0 || isFinite(f) ? f || 0 : e) : e
        }
    }),
    n.each(["height", "width"], function(a, b) {
        n.cssHooks[b] = {
            get: function(a, c, d) {
                return c ? Ha.test(n.css(a, "display")) && 0 === a.offsetWidth ? Da(a, Ia, function() {
                    return Pa(a, b, d)
                }) : Pa(a, b, d) : void 0
            },
            set: function(a, c, d) {
                var e, f = d && Ca(a), g = d && Oa(a, b, d, "border-box" === n.css(a, "boxSizing", !1, f), f);
                return g && (e = T.exec(c)) && "px" !== (e[3] || "px") && (a.style[b] = c,
                c = n.css(a, b)),
                Na(a, c, g)
            }
        }
    }),
    n.cssHooks.marginLeft = Ga(l.reliableMarginLeft, function(a, b) {
        return b ? (parseFloat(Fa(a, "marginLeft")) || a.getBoundingClientRect().left - Da(a, {
            marginLeft: 0
        }, function() {
            return a.getBoundingClientRect().left
        })) + "px" : void 0
    }),
    n.cssHooks.marginRight = Ga(l.reliableMarginRight, function(a, b) {
        return b ? Da(a, {
            display: "inline-block"
        }, Fa, [a, "marginRight"]) : void 0
    }),
    n.each({
        margin: "",
        padding: "",
        border: "Width"
    }, function(a, b) {
        n.cssHooks[a + b] = {
            expand: function(c) {
                for (var d = 0, e = {}, f = "string" == typeof c ? c.split(" ") : [c]; 4 > d; d++)
                    e[a + U[d] + b] = f[d] || f[d - 2] || f[0];
                return e
            }
        },
        Aa.test(a) || (n.cssHooks[a + b].set = Na)
    }),
    n.fn.extend({
        css: function(a, b) {
            return K(this, function(a, b, c) {
                var d, e, f = {}, g = 0;
                if (n.isArray(b)) {
                    for (d = Ca(a),
                    e = b.length; e > g; g++)
                        f[b[g]] = n.css(a, b[g], !1, d);
                    return f
                }
                return void 0 !== c ? n.style(a, b, c) : n.css(a, b)
            }, a, b, arguments.length > 1)
        },
        show: function() {
            return Qa(this, !0)
        },
        hide: function() {
            return Qa(this)
        },
        toggle: function(a) {
            return "boolean" == typeof a ? a ? this.show() : this.hide() : this.each(function() {
                V(this) ? n(this).show() : n(this).hide()
            })
        }
    });
    function Ra(a, b, c, d, e) {
        return new Ra.prototype.init(a,b,c,d,e)
    }
    n.Tween = Ra,
    Ra.prototype = {
        constructor: Ra,
        init: function(a, b, c, d, e, f) {
            this.elem = a,
            this.prop = c,
            this.easing = e || n.easing._default,
            this.options = b,
            this.start = this.now = this.cur(),
            this.end = d,
            this.unit = f || (n.cssNumber[c] ? "" : "px")
        },
        cur: function() {
            var a = Ra.propHooks[this.prop];
            return a && a.get ? a.get(this) : Ra.propHooks._default.get(this)
        },
        run: function(a) {
            var b, c = Ra.propHooks[this.prop];
            return this.options.duration ? this.pos = b = n.easing[this.easing](a, this.options.duration * a, 0, 1, this.options.duration) : this.pos = b = a,
            this.now = (this.end - this.start) * b + this.start,
            this.options.step && this.options.step.call(this.elem, this.now, this),
            c && c.set ? c.set(this) : Ra.propHooks._default.set(this),
            this
        }
    },
    Ra.prototype.init.prototype = Ra.prototype,
    Ra.propHooks = {
        _default: {
            get: function(a) {
                var b;
                return 1 !== a.elem.nodeType || null != a.elem[a.prop] && null == a.elem.style[a.prop] ? a.elem[a.prop] : (b = n.css(a.elem, a.prop, ""),
                b && "auto" !== b ? b : 0)
            },
            set: function(a) {
                n.fx.step[a.prop] ? n.fx.step[a.prop](a) : 1 !== a.elem.nodeType || null == a.elem.style[n.cssProps[a.prop]] && !n.cssHooks[a.prop] ? a.elem[a.prop] = a.now : n.style(a.elem, a.prop, a.now + a.unit)
            }
        }
    },
    Ra.propHooks.scrollTop = Ra.propHooks.scrollLeft = {
        set: function(a) {
            a.elem.nodeType && a.elem.parentNode && (a.elem[a.prop] = a.now)
        }
    },
    n.easing = {
        linear: function(a) {
            return a
        },
        swing: function(a) {
            return .5 - Math.cos(a * Math.PI) / 2
        },
        _default: "swing"
    },
    n.fx = Ra.prototype.init,
    n.fx.step = {};
    var Sa, Ta, Ua = /^(?:toggle|show|hide)$/, Va = /queueHooks$/;
    function Wa() {
        return a.setTimeout(function() {
            Sa = void 0
        }),
        Sa = n.now()
    }
    function Xa(a, b) {
        var c, d = 0, e = {
            height: a
        };
        for (b = b ? 1 : 0; 4 > d; d += 2 - b)
            c = U[d],
            e["margin" + c] = e["padding" + c] = a;
        return b && (e.opacity = e.width = a),
        e
    }
    function Ya(a, b, c) {
        for (var d, e = (_a.tweeners[b] || []).concat(_a.tweeners["*"]), f = 0, g = e.length; g > f; f++)
            if (d = e[f].call(c, b, a))
                return d
    }
    function Za(a, b, c) {
        var d, e, f, g, h, i, j, k, l = this, m = {}, o = a.style, p = a.nodeType && V(a), q = N.get(a, "fxshow");
        c.queue || (h = n._queueHooks(a, "fx"),
        null == h.unqueued && (h.unqueued = 0,
        i = h.empty.fire,
        h.empty.fire = function() {
            h.unqueued || i()
        }
        ),
        h.unqueued++,
        l.always(function() {
            l.always(function() {
                h.unqueued--,
                n.queue(a, "fx").length || h.empty.fire()
            })
        })),
        1 === a.nodeType && ("height"in b || "width"in b) && (c.overflow = [o.overflow, o.overflowX, o.overflowY],
        j = n.css(a, "display"),
        k = "none" === j ? N.get(a, "olddisplay") || za(a.nodeName) : j,
        "inline" === k && "none" === n.css(a, "float") && (o.display = "inline-block")),
        c.overflow && (o.overflow = "hidden",
        l.always(function() {
            o.overflow = c.overflow[0],
            o.overflowX = c.overflow[1],
            o.overflowY = c.overflow[2]
        }));
        for (d in b)
            if (e = b[d],
            Ua.exec(e)) {
                if (delete b[d],
                f = f || "toggle" === e,
                e === (p ? "hide" : "show")) {
                    if ("show" !== e || !q || void 0 === q[d])
                        continue;
                    p = !0
                }
                m[d] = q && q[d] || n.style(a, d)
            } else
                j = void 0;
        if (n.isEmptyObject(m))
            "inline" === ("none" === j ? za(a.nodeName) : j) && (o.display = j);
        else {
            q ? "hidden"in q && (p = q.hidden) : q = N.access(a, "fxshow", {}),
            f && (q.hidden = !p),
            p ? n(a).show() : l.done(function() {
                n(a).hide()
            }),
            l.done(function() {
                var b;
                N.remove(a, "fxshow");
                for (b in m)
                    n.style(a, b, m[b])
            });
            for (d in m)
                g = Ya(p ? q[d] : 0, d, l),
                d in q || (q[d] = g.start,
                p && (g.end = g.start,
                g.start = "width" === d || "height" === d ? 1 : 0))
        }
    }
    function $a(a, b) {
        var c, d, e, f, g;
        for (c in a)
            if (d = n.camelCase(c),
            e = b[d],
            f = a[c],
            n.isArray(f) && (e = f[1],
            f = a[c] = f[0]),
            c !== d && (a[d] = f,
            delete a[c]),
            g = n.cssHooks[d],
            g && "expand"in g) {
                f = g.expand(f),
                delete a[d];
                for (c in f)
                    c in a || (a[c] = f[c],
                    b[c] = e)
            } else
                b[d] = e
    }
    function _a(a, b, c) {
        var d, e, f = 0, g = _a.prefilters.length, h = n.Deferred().always(function() {
            delete i.elem
        }), i = function() {
            if (e)
                return !1;
            for (var b = Sa || Wa(), c = Math.max(0, j.startTime + j.duration - b), d = c / j.duration || 0, f = 1 - d, g = 0, i = j.tweens.length; i > g; g++)
                j.tweens[g].run(f);
            return h.notifyWith(a, [j, f, c]),
            1 > f && i ? c : (h.resolveWith(a, [j]),
            !1)
        }, j = h.promise({
            elem: a,
            props: n.extend({}, b),
            opts: n.extend(!0, {
                specialEasing: {},
                easing: n.easing._default
            }, c),
            originalProperties: b,
            originalOptions: c,
            startTime: Sa || Wa(),
            duration: c.duration,
            tweens: [],
            createTween: function(b, c) {
                var d = n.Tween(a, j.opts, b, c, j.opts.specialEasing[b] || j.opts.easing);
                return j.tweens.push(d),
                d
            },
            stop: function(b) {
                var c = 0
                  , d = b ? j.tweens.length : 0;
                if (e)
                    return this;
                for (e = !0; d > c; c++)
                    j.tweens[c].run(1);
                return b ? (h.notifyWith(a, [j, 1, 0]),
                h.resolveWith(a, [j, b])) : h.rejectWith(a, [j, b]),
                this
            }
        }), k = j.props;
        for ($a(k, j.opts.specialEasing); g > f; f++)
            if (d = _a.prefilters[f].call(j, a, k, j.opts))
                return n.isFunction(d.stop) && (n._queueHooks(j.elem, j.opts.queue).stop = n.proxy(d.stop, d)),
                d;
        return n.map(k, Ya, j),
        n.isFunction(j.opts.start) && j.opts.start.call(a, j),
        n.fx.timer(n.extend(i, {
            elem: a,
            anim: j,
            queue: j.opts.queue
        })),
        j.progress(j.opts.progress).done(j.opts.done, j.opts.complete).fail(j.opts.fail).always(j.opts.always)
    }
    n.Animation = n.extend(_a, {
        tweeners: {
            "*": [function(a, b) {
                var c = this.createTween(a, b);
                return W(c.elem, a, T.exec(b), c),
                c
            }
            ]
        },
        tweener: function(a, b) {
            n.isFunction(a) ? (b = a,
            a = ["*"]) : a = a.match(G);
            for (var c, d = 0, e = a.length; e > d; d++)
                c = a[d],
                _a.tweeners[c] = _a.tweeners[c] || [],
                _a.tweeners[c].unshift(b)
        },
        prefilters: [Za],
        prefilter: function(a, b) {
            b ? _a.prefilters.unshift(a) : _a.prefilters.push(a)
        }
    }),
    n.speed = function(a, b, c) {
        var d = a && "object" == typeof a ? n.extend({}, a) : {
            complete: c || !c && b || n.isFunction(a) && a,
            duration: a,
            easing: c && b || b && !n.isFunction(b) && b
        };
        return d.duration = n.fx.off ? 0 : "number" == typeof d.duration ? d.duration : d.duration in n.fx.speeds ? n.fx.speeds[d.duration] : n.fx.speeds._default,
        null != d.queue && d.queue !== !0 || (d.queue = "fx"),
        d.old = d.complete,
        d.complete = function() {
            n.isFunction(d.old) && d.old.call(this),
            d.queue && n.dequeue(this, d.queue)
        }
        ,
        d
    }
    ,
    n.fn.extend({
        fadeTo: function(a, b, c, d) {
            return this.filter(V).css("opacity", 0).show().end().animate({
                opacity: b
            }, a, c, d)
        },
        animate: function(a, b, c, d) {
            var e = n.isEmptyObject(a)
              , f = n.speed(b, c, d)
              , g = function() {
                var b = _a(this, n.extend({}, a), f);
                (e || N.get(this, "finish")) && b.stop(!0)
            };
            return g.finish = g,
            e || f.queue === !1 ? this.each(g) : this.queue(f.queue, g)
        },
        stop: function(a, b, c) {
            var d = function(a) {
                var b = a.stop;
                delete a.stop,
                b(c)
            };
            return "string" != typeof a && (c = b,
            b = a,
            a = void 0),
            b && a !== !1 && this.queue(a || "fx", []),
            this.each(function() {
                var b = !0
                  , e = null != a && a + "queueHooks"
                  , f = n.timers
                  , g = N.get(this);
                if (e)
                    g[e] && g[e].stop && d(g[e]);
                else
                    for (e in g)
                        g[e] && g[e].stop && Va.test(e) && d(g[e]);
                for (e = f.length; e--; )
                    f[e].elem !== this || null != a && f[e].queue !== a || (f[e].anim.stop(c),
                    b = !1,
                    f.splice(e, 1));
                !b && c || n.dequeue(this, a)
            })
        },
        finish: function(a) {
            return a !== !1 && (a = a || "fx"),
            this.each(function() {
                var b, c = N.get(this), d = c[a + "queue"], e = c[a + "queueHooks"], f = n.timers, g = d ? d.length : 0;
                for (c.finish = !0,
                n.queue(this, a, []),
                e && e.stop && e.stop.call(this, !0),
                b = f.length; b--; )
                    f[b].elem === this && f[b].queue === a && (f[b].anim.stop(!0),
                    f.splice(b, 1));
                for (b = 0; g > b; b++)
                    d[b] && d[b].finish && d[b].finish.call(this);
                delete c.finish
            })
        }
    }),
    n.each(["toggle", "show", "hide"], function(a, b) {
        var c = n.fn[b];
        n.fn[b] = function(a, d, e) {
            return null == a || "boolean" == typeof a ? c.apply(this, arguments) : this.animate(Xa(b, !0), a, d, e)
        }
    }),
    n.each({
        slideDown: Xa("show"),
        slideUp: Xa("hide"),
        slideToggle: Xa("toggle"),
        fadeIn: {
            opacity: "show"
        },
        fadeOut: {
            opacity: "hide"
        },
        fadeToggle: {
            opacity: "toggle"
        }
    }, function(a, b) {
        n.fn[a] = function(a, c, d) {
            return this.animate(b, a, c, d)
        }
    }),
    n.timers = [],
    n.fx.tick = function() {
        var a, b = 0, c = n.timers;
        for (Sa = n.now(); b < c.length; b++)
            a = c[b],
            a() || c[b] !== a || c.splice(b--, 1);
        c.length || n.fx.stop(),
        Sa = void 0
    }
    ,
    n.fx.timer = function(a) {
        n.timers.push(a),
        a() ? n.fx.start() : n.timers.pop()
    }
    ,
    n.fx.interval = 13,
    n.fx.start = function() {
        Ta || (Ta = a.setInterval(n.fx.tick, n.fx.interval))
    }
    ,
    n.fx.stop = function() {
        a.clearInterval(Ta),
        Ta = null
    }
    ,
    n.fx.speeds = {
        slow: 600,
        fast: 200,
        _default: 400
    },
    n.fn.delay = function(b, c) {
        return b = n.fx ? n.fx.speeds[b] || b : b,
        c = c || "fx",
        this.queue(c, function(c, d) {
            var e = a.setTimeout(c, b);
            d.stop = function() {
                a.clearTimeout(e)
            }
        })
    }
    ,
    function() {
        var a = d.createElement("input")
          , b = d.createElement("select")
          , c = b.appendChild(d.createElement("option"));
        a.type = "checkbox",
        l.checkOn = "" !== a.value,
        l.optSelected = c.selected,
        b.disabled = !0,
        l.optDisabled = !c.disabled,
        a = d.createElement("input"),
        a.value = "t",
        a.type = "radio",
        l.radioValue = "t" === a.value
    }();
    var ab, bb = n.expr.attrHandle;
    n.fn.extend({
        attr: function(a, b) {
            return K(this, n.attr, a, b, arguments.length > 1)
        },
        removeAttr: function(a) {
            return this.each(function() {
                n.removeAttr(this, a)
            })
        }
    }),
    n.extend({
        attr: function(a, b, c) {
            var d, e, f = a.nodeType;
            if (3 !== f && 8 !== f && 2 !== f)
                return "undefined" == typeof a.getAttribute ? n.prop(a, b, c) : (1 === f && n.isXMLDoc(a) || (b = b.toLowerCase(),
                e = n.attrHooks[b] || (n.expr.match.bool.test(b) ? ab : void 0)),
                void 0 !== c ? null === c ? void n.removeAttr(a, b) : e && "set"in e && void 0 !== (d = e.set(a, c, b)) ? d : (a.setAttribute(b, c + ""),
                c) : e && "get"in e && null !== (d = e.get(a, b)) ? d : (d = n.find.attr(a, b),
                null == d ? void 0 : d))
        },
        attrHooks: {
            type: {
                set: function(a, b) {
                    if (!l.radioValue && "radio" === b && n.nodeName(a, "input")) {
                        var c = a.value;
                        return a.setAttribute("type", b),
                        c && (a.value = c),
                        b
                    }
                }
            }
        },
        removeAttr: function(a, b) {
            var c, d, e = 0, f = b && b.match(G);
            if (f && 1 === a.nodeType)
                while (c = f[e++])
                    d = n.propFix[c] || c,
                    n.expr.match.bool.test(c) && (a[d] = !1),
                    a.removeAttribute(c)
        }
    }),
    ab = {
        set: function(a, b, c) {
            return b === !1 ? n.removeAttr(a, c) : a.setAttribute(c, c),
            c
        }
    },
    n.each(n.expr.match.bool.source.match(/\w+/g), function(a, b) {
        var c = bb[b] || n.find.attr;
        bb[b] = function(a, b, d) {
            var e, f;
            return d || (f = bb[b],
            bb[b] = e,
            e = null != c(a, b, d) ? b.toLowerCase() : null,
            bb[b] = f),
            e
        }
    });
    var cb = /^(?:input|select|textarea|button)$/i
      , db = /^(?:a|area)$/i;
    n.fn.extend({
        prop: function(a, b) {
            return K(this, n.prop, a, b, arguments.length > 1)
        },
        removeProp: function(a) {
            return this.each(function() {
                delete this[n.propFix[a] || a]
            })
        }
    }),
    n.extend({
        prop: function(a, b, c) {
            var d, e, f = a.nodeType;
            if (3 !== f && 8 !== f && 2 !== f)
                return 1 === f && n.isXMLDoc(a) || (b = n.propFix[b] || b,
                e = n.propHooks[b]),
                void 0 !== c ? e && "set"in e && void 0 !== (d = e.set(a, c, b)) ? d : a[b] = c : e && "get"in e && null !== (d = e.get(a, b)) ? d : a[b]
        },
        propHooks: {
            tabIndex: {
                get: function(a) {
                    var b = n.find.attr(a, "tabindex");
                    return b ? parseInt(b, 10) : cb.test(a.nodeName) || db.test(a.nodeName) && a.href ? 0 : -1
                }
            }
        },
        propFix: {
            "for": "htmlFor",
            "class": "className"
        }
    }),
    l.optSelected || (n.propHooks.selected = {
        get: function(a) {
            var b = a.parentNode;
            return b && b.parentNode && b.parentNode.selectedIndex,
            null
        },
        set: function(a) {
            var b = a.parentNode;
            b && (b.selectedIndex,
            b.parentNode && b.parentNode.selectedIndex)
        }
    }),
    n.each(["tabIndex", "readOnly", "maxLength", "cellSpacing", "cellPadding", "rowSpan", "colSpan", "useMap", "frameBorder", "contentEditable"], function() {
        n.propFix[this.toLowerCase()] = this
    });
    var eb = /[\t\r\n\f]/g;
    function fb(a) {
        return a.getAttribute && a.getAttribute("class") || ""
    }
    n.fn.extend({
        addClass: function(a) {
            var b, c, d, e, f, g, h, i = 0;
            if (n.isFunction(a))
                return this.each(function(b) {
                    n(this).addClass(a.call(this, b, fb(this)))
                });
            if ("string" == typeof a && a) {
                b = a.match(G) || [];
                while (c = this[i++])
                    if (e = fb(c),
                    d = 1 === c.nodeType && (" " + e + " ").replace(eb, " ")) {
                        g = 0;
                        while (f = b[g++])
                            d.indexOf(" " + f + " ") < 0 && (d += f + " ");
                        h = n.trim(d),
                        e !== h && c.setAttribute("class", h)
                    }
            }
            return this
        },
        removeClass: function(a) {
            var b, c, d, e, f, g, h, i = 0;
            if (n.isFunction(a))
                return this.each(function(b) {
                    n(this).removeClass(a.call(this, b, fb(this)))
                });
            if (!arguments.length)
                return this.attr("class", "");
            if ("string" == typeof a && a) {
                b = a.match(G) || [];
                while (c = this[i++])
                    if (e = fb(c),
                    d = 1 === c.nodeType && (" " + e + " ").replace(eb, " ")) {
                        g = 0;
                        while (f = b[g++])
                            while (d.indexOf(" " + f + " ") > -1)
                                d = d.replace(" " + f + " ", " ");
                        h = n.trim(d),
                        e !== h && c.setAttribute("class", h)
                    }
            }
            return this
        },
        toggleClass: function(a, b) {
            var c = typeof a;
            return "boolean" == typeof b && "string" === c ? b ? this.addClass(a) : this.removeClass(a) : n.isFunction(a) ? this.each(function(c) {
                n(this).toggleClass(a.call(this, c, fb(this), b), b)
            }) : this.each(function() {
                var b, d, e, f;
                if ("string" === c) {
                    d = 0,
                    e = n(this),
                    f = a.match(G) || [];
                    while (b = f[d++])
                        e.hasClass(b) ? e.removeClass(b) : e.addClass(b)
                } else
                    void 0 !== a && "boolean" !== c || (b = fb(this),
                    b && N.set(this, "__className__", b),
                    this.setAttribute && this.setAttribute("class", b || a === !1 ? "" : N.get(this, "__className__") || ""))
            })
        },
        hasClass: function(a) {
            var b, c, d = 0;
            b = " " + a + " ";
            while (c = this[d++])
                if (1 === c.nodeType && (" " + fb(c) + " ").replace(eb, " ").indexOf(b) > -1)
                    return !0;
            return !1
        }
    });
    var gb = /\r/g
      , hb = /[\x20\t\r\n\f]+/g;
    n.fn.extend({
        val: function(a) {
            var b, c, d, e = this[0];
            {
                if (arguments.length)
                    return d = n.isFunction(a),
                    this.each(function(c) {
                        var e;
                        1 === this.nodeType && (e = d ? a.call(this, c, n(this).val()) : a,
                        null == e ? e = "" : "number" == typeof e ? e += "" : n.isArray(e) && (e = n.map(e, function(a) {
                            return null == a ? "" : a + ""
                        })),
                        b = n.valHooks[this.type] || n.valHooks[this.nodeName.toLowerCase()],
                        b && "set"in b && void 0 !== b.set(this, e, "value") || (this.value = e))
                    });
                if (e)
                    return b = n.valHooks[e.type] || n.valHooks[e.nodeName.toLowerCase()],
                    b && "get"in b && void 0 !== (c = b.get(e, "value")) ? c : (c = e.value,
                    "string" == typeof c ? c.replace(gb, "") : null == c ? "" : c)
            }
        }
    }),
    n.extend({
        valHooks: {
            option: {
                get: function(a) {
                    var b = n.find.attr(a, "value");
                    return null != b ? b : n.trim(n.text(a)).replace(hb, " ")
                }
            },
            select: {
                get: function(a) {
                    for (var b, c, d = a.options, e = a.selectedIndex, f = "select-one" === a.type || 0 > e, g = f ? null : [], h = f ? e + 1 : d.length, i = 0 > e ? h : f ? e : 0; h > i; i++)
                        if (c = d[i],
                        (c.selected || i === e) && (l.optDisabled ? !c.disabled : null === c.getAttribute("disabled")) && (!c.parentNode.disabled || !n.nodeName(c.parentNode, "optgroup"))) {
                            if (b = n(c).val(),
                            f)
                                return b;
                            g.push(b)
                        }
                    return g
                },
                set: function(a, b) {
                    var c, d, e = a.options, f = n.makeArray(b), g = e.length;
                    while (g--)
                        d = e[g],
                        (d.selected = n.inArray(n.valHooks.option.get(d), f) > -1) && (c = !0);
                    return c || (a.selectedIndex = -1),
                    f
                }
            }
        }
    }),
    n.each(["radio", "checkbox"], function() {
        n.valHooks[this] = {
            set: function(a, b) {
                return n.isArray(b) ? a.checked = n.inArray(n(a).val(), b) > -1 : void 0
            }
        },
        l.checkOn || (n.valHooks[this].get = function(a) {
            return null === a.getAttribute("value") ? "on" : a.value
        }
        )
    });
    var ib = /^(?:focusinfocus|focusoutblur)$/;
    n.extend(n.event, {
        trigger: function(b, c, e, f) {
            var g, h, i, j, l, m, o, p = [e || d], q = k.call(b, "type") ? b.type : b, r = k.call(b, "namespace") ? b.namespace.split(".") : [];
            if (h = i = e = e || d,
            3 !== e.nodeType && 8 !== e.nodeType && !ib.test(q + n.event.triggered) && (q.indexOf(".") > -1 && (r = q.split("."),
            q = r.shift(),
            r.sort()),
            l = q.indexOf(":") < 0 && "on" + q,
            b = b[n.expando] ? b : new n.Event(q,"object" == typeof b && b),
            b.isTrigger = f ? 2 : 3,
            b.namespace = r.join("."),
            b.rnamespace = b.namespace ? new RegExp("(^|\\.)" + r.join("\\.(?:.*\\.|)") + "(\\.|$)") : null,
            b.result = void 0,
            b.target || (b.target = e),
            c = null == c ? [b] : n.makeArray(c, [b]),
            o = n.event.special[q] || {},
            f || !o.trigger || o.trigger.apply(e, c) !== !1)) {
                if (!f && !o.noBubble && !n.isWindow(e)) {
                    for (j = o.delegateType || q,
                    ib.test(j + q) || (h = h.parentNode); h; h = h.parentNode)
                        p.push(h),
                        i = h;
                    i === (e.ownerDocument || d) && p.push(i.defaultView || i.parentWindow || a)
                }
                g = 0;
                while ((h = p[g++]) && !b.isPropagationStopped())
                    b.type = g > 1 ? j : o.bindType || q,
                    m = (N.get(h, "events") || {})[b.type] && N.get(h, "handle"),
                    m && m.apply(h, c),
                    m = l && h[l],
                    m && m.apply && L(h) && (b.result = m.apply(h, c),
                    b.result === !1 && b.preventDefault());
                return b.type = q,
                f || b.isDefaultPrevented() || o._default && o._default.apply(p.pop(), c) !== !1 || !L(e) || l && n.isFunction(e[q]) && !n.isWindow(e) && (i = e[l],
                i && (e[l] = null),
                n.event.triggered = q,
                e[q](),
                n.event.triggered = void 0,
                i && (e[l] = i)),
                b.result
            }
        },
        simulate: function(a, b, c) {
            var d = n.extend(new n.Event, c, {
                type: a,
                isSimulated: !0
            });
            n.event.trigger(d, null, b),
            d.isDefaultPrevented() && c.preventDefault()
        }
    }),
    n.fn.extend({
        trigger: function(a, b) {
            return this.each(function() {
                n.event.trigger(a, b, this)
            })
        },
        triggerHandler: function(a, b) {
            var c = this[0];
            return c ? n.event.trigger(a, b, c, !0) : void 0
        }
    }),
    n.each("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error contextmenu".split(" "), function(a, b) {
        n.fn[b] = function(a, c) {
            return arguments.length > 0 ? this.on(b, null, a, c) : this.trigger(b)
        }
    }),
    n.fn.extend({
        hover: function(a, b) {
            return this.mouseenter(a).mouseleave(b || a)
        }
    }),
    l.focusin = "onfocusin"in a,
    l.focusin || n.each({
        focus: "focusin",
        blur: "focusout"
    }, function(a, b) {
        var c = function(a) {
            n.event.simulate(b, a.target, n.event.fix(a))
        };
        n.event.special[b] = {
            setup: function() {
                var d = this.ownerDocument || this
                  , e = N.access(d, b);
                e || d.addEventListener(a, c, !0),
                N.access(d, b, (e || 0) + 1)
            },
            teardown: function() {
                var d = this.ownerDocument || this
                  , e = N.access(d, b) - 1;
                e ? N.access(d, b, e) : (d.removeEventListener(a, c, !0),
                N.remove(d, b))
            }
        }
    });
    var jb = a.location
      , kb = n.now()
      , lb = /\?/;
    n.parseJSON = function(a) {
        return JSON.parse(a + "")
    }
    ,
    n.parseXML = function(b) {
        var c;
        if (!b || "string" != typeof b)
            return null;
        try {
            c = (new a.DOMParser).parseFromString(b, "text/xml")
        } catch (d) {
            c = void 0
        }
        return c && !c.getElementsByTagName("parsererror").length || n.error("Invalid XML: " + b),
        c
    }
    ;
    var mb = /#.*$/
      , nb = /([?&])_=[^&]*/
      , ob = /^(.*?):[ \t]*([^\r\n]*)$/gm
      , pb = /^(?:about|app|app-storage|.+-extension|file|res|widget):$/
      , qb = /^(?:GET|HEAD)$/
      , rb = /^\/\//
      , sb = {}
      , tb = {}
      , ub = "*/".concat("*")
      , vb = d.createElement("a");
    vb.href = jb.href;
    function wb(a) {
        return function(b, c) {
            "string" != typeof b && (c = b,
            b = "*");
            var d, e = 0, f = b.toLowerCase().match(G) || [];
            if (n.isFunction(c))
                while (d = f[e++])
                    "+" === d[0] ? (d = d.slice(1) || "*",
                    (a[d] = a[d] || []).unshift(c)) : (a[d] = a[d] || []).push(c)
        }
    }
    function xb(a, b, c, d) {
        var e = {}
          , f = a === tb;
        function g(h) {
            var i;
            return e[h] = !0,
            n.each(a[h] || [], function(a, h) {
                var j = h(b, c, d);
                return "string" != typeof j || f || e[j] ? f ? !(i = j) : void 0 : (b.dataTypes.unshift(j),
                g(j),
                !1)
            }),
            i
        }
        return g(b.dataTypes[0]) || !e["*"] && g("*")
    }
    function yb(a, b) {
        var c, d, e = n.ajaxSettings.flatOptions || {};
        for (c in b)
            void 0 !== b[c] && ((e[c] ? a : d || (d = {}))[c] = b[c]);
        return d && n.extend(!0, a, d),
        a
    }
    function zb(a, b, c) {
        var d, e, f, g, h = a.contents, i = a.dataTypes;
        while ("*" === i[0])
            i.shift(),
            void 0 === d && (d = a.mimeType || b.getResponseHeader("Content-Type"));
        if (d)
            for (e in h)
                if (h[e] && h[e].test(d)) {
                    i.unshift(e);
                    break
                }
        if (i[0]in c)
            f = i[0];
        else {
            for (e in c) {
                if (!i[0] || a.converters[e + " " + i[0]]) {
                    f = e;
                    break
                }
                g || (g = e)
            }
            f = f || g
        }
        return f ? (f !== i[0] && i.unshift(f),
        c[f]) : void 0
    }
    function Ab(a, b, c, d) {
        var e, f, g, h, i, j = {}, k = a.dataTypes.slice();
        if (k[1])
            for (g in a.converters)
                j[g.toLowerCase()] = a.converters[g];
        f = k.shift();
        while (f)
            if (a.responseFields[f] && (c[a.responseFields[f]] = b),
            !i && d && a.dataFilter && (b = a.dataFilter(b, a.dataType)),
            i = f,
            f = k.shift())
                if ("*" === f)
                    f = i;
                else if ("*" !== i && i !== f) {
                    if (g = j[i + " " + f] || j["* " + f],
                    !g)
                        for (e in j)
                            if (h = e.split(" "),
                            h[1] === f && (g = j[i + " " + h[0]] || j["* " + h[0]])) {
                                g === !0 ? g = j[e] : j[e] !== !0 && (f = h[0],
                                k.unshift(h[1]));
                                break
                            }
                    if (g !== !0)
                        if (g && a["throws"])
                            b = g(b);
                        else
                            try {
                                b = g(b)
                            } catch (l) {
                                return {
                                    state: "parsererror",
                                    error: g ? l : "No conversion from " + i + " to " + f
                                }
                            }
                }
        return {
            state: "success",
            data: b
        }
    }
    n.extend({
        active: 0,
        lastModified: {},
        etag: {},
        ajaxSettings: {
            url: jb.href,
            type: "GET",
            isLocal: pb.test(jb.protocol),
            global: !0,
            processData: !0,
            async: !0,
            contentType: "application/x-www-form-urlencoded; charset=UTF-8",
            accepts: {
                "*": ub,
                text: "text/plain",
                html: "text/html",
                xml: "application/xml, text/xml",
                json: "application/json, text/javascript"
            },
            contents: {
                xml: /\bxml\b/,
                html: /\bhtml/,
                json: /\bjson\b/
            },
            responseFields: {
                xml: "responseXML",
                text: "responseText",
                json: "responseJSON"
            },
            converters: {
                "* text": String,
                "text html": !0,
                "text json": n.parseJSON,
                "text xml": n.parseXML
            },
            flatOptions: {
                url: !0,
                context: !0
            }
        },
        ajaxSetup: function(a, b) {
            return b ? yb(yb(a, n.ajaxSettings), b) : yb(n.ajaxSettings, a)
        },
        ajaxPrefilter: wb(sb),
        ajaxTransport: wb(tb),
        ajax: function(b, c) {
            "object" == typeof b && (c = b,
            b = void 0),
            c = c || {};
            var e, f, g, h, i, j, k, l, m = n.ajaxSetup({}, c), o = m.context || m, p = m.context && (o.nodeType || o.jquery) ? n(o) : n.event, q = n.Deferred(), r = n.Callbacks("once memory"), s = m.statusCode || {}, t = {}, u = {}, v = 0, w = "canceled", x = {
                readyState: 0,
                getResponseHeader: function(a) {
                    var b;
                    if (2 === v) {
                        if (!h) {
                            h = {};
                            while (b = ob.exec(g))
                                h[b[1].toLowerCase()] = b[2]
                        }
                        b = h[a.toLowerCase()]
                    }
                    return null == b ? null : b
                },
                getAllResponseHeaders: function() {
                    return 2 === v ? g : null
                },
                setRequestHeader: function(a, b) {
                    var c = a.toLowerCase();
                    return v || (a = u[c] = u[c] || a,
                    t[a] = b),
                    this
                },
                overrideMimeType: function(a) {
                    return v || (m.mimeType = a),
                    this
                },
                statusCode: function(a) {
                    var b;
                    if (a)
                        if (2 > v)
                            for (b in a)
                                s[b] = [s[b], a[b]];
                        else
                            x.always(a[x.status]);
                    return this
                },
                abort: function(a) {
                    var b = a || w;
                    return e && e.abort(b),
                    z(0, b),
                    this
                }
            };
            if (q.promise(x).complete = r.add,
            x.success = x.done,
            x.error = x.fail,
            m.url = ((b || m.url || jb.href) + "").replace(mb, "").replace(rb, jb.protocol + "//"),
            m.type = c.method || c.type || m.method || m.type,
            m.dataTypes = n.trim(m.dataType || "*").toLowerCase().match(G) || [""],
            null == m.crossDomain) {
                j = d.createElement("a");
                try {
                    j.href = m.url,
                    j.href = j.href,
                    m.crossDomain = vb.protocol + "//" + vb.host != j.protocol + "//" + j.host
                } catch (y) {
                    m.crossDomain = !0
                }
            }
            if (m.data && m.processData && "string" != typeof m.data && (m.data = n.param(m.data, m.traditional)),
            xb(sb, m, c, x),
            2 === v)
                return x;
            k = n.event && m.global,
            k && 0 === n.active++ && n.event.trigger("ajaxStart"),
            m.type = m.type.toUpperCase(),
            m.hasContent = !qb.test(m.type),
            f = m.url,
            m.hasContent || (m.data && (f = m.url += (lb.test(f) ? "&" : "?") + m.data,
            delete m.data),
            m.cache === !1 && (m.url = nb.test(f) ? f.replace(nb, "$1_=" + kb++) : f + (lb.test(f) ? "&" : "?") + "_=" + kb++)),
            m.ifModified && (n.lastModified[f] && x.setRequestHeader("If-Modified-Since", n.lastModified[f]),
            n.etag[f] && x.setRequestHeader("If-None-Match", n.etag[f])),
            (m.data && m.hasContent && m.contentType !== !1 || c.contentType) && x.setRequestHeader("Content-Type", m.contentType),
            x.setRequestHeader("Accept", m.dataTypes[0] && m.accepts[m.dataTypes[0]] ? m.accepts[m.dataTypes[0]] + ("*" !== m.dataTypes[0] ? ", " + ub + "; q=0.01" : "") : m.accepts["*"]);
            for (l in m.headers)
                x.setRequestHeader(l, m.headers[l]);
            if (m.beforeSend && (m.beforeSend.call(o, x, m) === !1 || 2 === v))
                return x.abort();
            w = "abort";
            for (l in {
                success: 1,
                error: 1,
                complete: 1
            })
                x[l](m[l]);
            if (e = xb(tb, m, c, x)) {
                if (x.readyState = 1,
                k && p.trigger("ajaxSend", [x, m]),
                2 === v)
                    return x;
                m.async && m.timeout > 0 && (i = a.setTimeout(function() {
                    x.abort("timeout")
                }, m.timeout));
                try {
                    v = 1,
                    e.send(t, z)
                } catch (y) {
                    if (!(2 > v))
                        throw y;
                    z(-1, y)
                }
            } else
                z(-1, "No Transport");
            function z(b, c, d, h) {
                var j, l, t, u, w, y = c;
                2 !== v && (v = 2,
                i && a.clearTimeout(i),
                e = void 0,
                g = h || "",
                x.readyState = b > 0 ? 4 : 0,
                j = b >= 200 && 300 > b || 304 === b,
                d && (u = zb(m, x, d)),
                u = Ab(m, u, x, j),
                j ? (m.ifModified && (w = x.getResponseHeader("Last-Modified"),
                w && (n.lastModified[f] = w),
                w = x.getResponseHeader("etag"),
                w && (n.etag[f] = w)),
                204 === b || "HEAD" === m.type ? y = "nocontent" : 304 === b ? y = "notmodified" : (y = u.state,
                l = u.data,
                t = u.error,
                j = !t)) : (t = y,
                !b && y || (y = "error",
                0 > b && (b = 0))),
                x.status = b,
                x.statusText = (c || y) + "",
                j ? q.resolveWith(o, [l, y, x]) : q.rejectWith(o, [x, y, t]),
                x.statusCode(s),
                s = void 0,
                k && p.trigger(j ? "ajaxSuccess" : "ajaxError", [x, m, j ? l : t]),
                r.fireWith(o, [x, y]),
                k && (p.trigger("ajaxComplete", [x, m]),
                --n.active || n.event.trigger("ajaxStop")))
            }
            return x
        },
        getJSON: function(a, b, c) {
            return n.get(a, b, c, "json")
        },
        getScript: function(a, b) {
            return n.get(a, void 0, b, "script")
        }
    }),
    n.each(["get", "post"], function(a, b) {
        n[b] = function(a, c, d, e) {
            return n.isFunction(c) && (e = e || d,
            d = c,
            c = void 0),
            n.ajax(n.extend({
                url: a,
                type: b,
                dataType: e,
                data: c,
                success: d
            }, n.isPlainObject(a) && a))
        }
    }),
    n._evalUrl = function(a) {
        return n.ajax({
            url: a,
            type: "GET",
            dataType: "script",
            async: !1,
            global: !1,
            "throws": !0
        })
    }
    ,
    n.fn.extend({
        wrapAll: function(a) {
            var b;
            return n.isFunction(a) ? this.each(function(b) {
                n(this).wrapAll(a.call(this, b))
            }) : (this[0] && (b = n(a, this[0].ownerDocument).eq(0).clone(!0),
            this[0].parentNode && b.insertBefore(this[0]),
            b.map(function() {
                var a = this;
                while (a.firstElementChild)
                    a = a.firstElementChild;
                return a
            }).append(this)),
            this)
        },
        wrapInner: function(a) {
            return n.isFunction(a) ? this.each(function(b) {
                n(this).wrapInner(a.call(this, b))
            }) : this.each(function() {
                var b = n(this)
                  , c = b.contents();
                c.length ? c.wrapAll(a) : b.append(a)
            })
        },
        wrap: function(a) {
            var b = n.isFunction(a);
            return this.each(function(c) {
                n(this).wrapAll(b ? a.call(this, c) : a)
            })
        },
        unwrap: function() {
            return this.parent().each(function() {
                n.nodeName(this, "body") || n(this).replaceWith(this.childNodes)
            }).end()
        }
    }),
    n.expr.filters.hidden = function(a) {
        return !n.expr.filters.visible(a)
    }
    ,
    n.expr.filters.visible = function(a) {
        return a.offsetWidth > 0 || a.offsetHeight > 0 || a.getClientRects().length > 0
    }
    ;
    var Bb = /%20/g
      , Cb = /\[\]$/
      , Db = /\r?\n/g
      , Eb = /^(?:submit|button|image|reset|file)$/i
      , Fb = /^(?:input|select|textarea|keygen)/i;
    function Gb(a, b, c, d) {
        var e;
        if (n.isArray(b))
            n.each(b, function(b, e) {
                c || Cb.test(a) ? d(a, e) : Gb(a + "[" + ("object" == typeof e && null != e ? b : "") + "]", e, c, d)
            });
        else if (c || "object" !== n.type(b))
            d(a, b);
        else
            for (e in b)
                Gb(a + "[" + e + "]", b[e], c, d)
    }
    n.param = function(a, b) {
        var c, d = [], e = function(a, b) {
            b = n.isFunction(b) ? b() : null == b ? "" : b,
            d[d.length] = encodeURIComponent(a) + "=" + encodeURIComponent(b)
        };
        if (void 0 === b && (b = n.ajaxSettings && n.ajaxSettings.traditional),
        n.isArray(a) || a.jquery && !n.isPlainObject(a))
            n.each(a, function() {
                e(this.name, this.value)
            });
        else
            for (c in a)
                Gb(c, a[c], b, e);
        return d.join("&").replace(Bb, "+")
    }
    ,
    n.fn.extend({
        serialize: function() {
            return n.param(this.serializeArray())
        },
        serializeArray: function() {
            return this.map(function() {
                var a = n.prop(this, "elements");
                return a ? n.makeArray(a) : this
            }).filter(function() {
                var a = this.type;
                return this.name && !n(this).is(":disabled") && Fb.test(this.nodeName) && !Eb.test(a) && (this.checked || !X.test(a))
            }).map(function(a, b) {
                var c = n(this).val();
                return null == c ? null : n.isArray(c) ? n.map(c, function(a) {
                    return {
                        name: b.name,
                        value: a.replace(Db, "\r\n")
                    }
                }) : {
                    name: b.name,
                    value: c.replace(Db, "\r\n")
                }
            }).get()
        }
    }),
    n.ajaxSettings.xhr = function() {
        try {
            return new a.XMLHttpRequest
        } catch (b) {}
    }
    ;
    var Hb = {
        0: 200,
        1223: 204
    }
      , Ib = n.ajaxSettings.xhr();
    l.cors = !!Ib && "withCredentials"in Ib,
    l.ajax = Ib = !!Ib,
    n.ajaxTransport(function(b) {
        var c, d;
        return l.cors || Ib && !b.crossDomain ? {
            send: function(e, f) {
                var g, h = b.xhr();
                if (h.open(b.type, b.url, b.async, b.username, b.password),
                b.xhrFields)
                    for (g in b.xhrFields)
                        h[g] = b.xhrFields[g];
                b.mimeType && h.overrideMimeType && h.overrideMimeType(b.mimeType),
                b.crossDomain || e["X-Requested-With"] || (e["X-Requested-With"] = "XMLHttpRequest");
                for (g in e)
                    h.setRequestHeader(g, e[g]);
                c = function(a) {
                    return function() {
                        c && (c = d = h.onload = h.onerror = h.onabort = h.onreadystatechange = null,
                        "abort" === a ? h.abort() : "error" === a ? "number" != typeof h.status ? f(0, "error") : f(h.status, h.statusText) : f(Hb[h.status] || h.status, h.statusText, "text" !== (h.responseType || "text") || "string" != typeof h.responseText ? {
                            binary: h.response
                        } : {
                            text: h.responseText
                        }, h.getAllResponseHeaders()))
                    }
                }
                ,
                h.onload = c(),
                d = h.onerror = c("error"),
                void 0 !== h.onabort ? h.onabort = d : h.onreadystatechange = function() {
                    4 === h.readyState && a.setTimeout(function() {
                        c && d()
                    })
                }
                ,
                c = c("abort");
                try {
                    h.send(b.hasContent && b.data || null)
                } catch (i) {
                    if (c)
                        throw i
                }
            },
            abort: function() {
                c && c()
            }
        } : void 0
    }),
    n.ajaxSetup({
        accepts: {
            script: "text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"
        },
        contents: {
            script: /\b(?:java|ecma)script\b/
        },
        converters: {
            "text script": function(a) {
                return n.globalEval(a),
                a
            }
        }
    }),
    n.ajaxPrefilter("script", function(a) {
        void 0 === a.cache && (a.cache = !1),
        a.crossDomain && (a.type = "GET")
    }),
    n.ajaxTransport("script", function(a) {
        if (a.crossDomain) {
            var b, c;
            return {
                send: function(e, f) {
                    b = n("<script>").prop({
                        charset: a.scriptCharset,
                        src: a.url
                    }).on("load error", c = function(a) {
                        b.remove(),
                        c = null,
                        a && f("error" === a.type ? 404 : 200, a.type)
                    }
                    ),
                    d.head.appendChild(b[0])
                },
                abort: function() {
                    c && c()
                }
            }
        }
    });
    var Jb = []
      , Kb = /(=)\?(?=&|$)|\?\?/;
    n.ajaxSetup({
        jsonp: "callback",
        jsonpCallback: function() {
            var a = Jb.pop() || n.expando + "_" + kb++;
            return this[a] = !0,
            a
        }
    }),
    n.ajaxPrefilter("json jsonp", function(b, c, d) {
        var e, f, g, h = b.jsonp !== !1 && (Kb.test(b.url) ? "url" : "string" == typeof b.data && 0 === (b.contentType || "").indexOf("application/x-www-form-urlencoded") && Kb.test(b.data) && "data");
        return h || "jsonp" === b.dataTypes[0] ? (e = b.jsonpCallback = n.isFunction(b.jsonpCallback) ? b.jsonpCallback() : b.jsonpCallback,
        h ? b[h] = b[h].replace(Kb, "$1" + e) : b.jsonp !== !1 && (b.url += (lb.test(b.url) ? "&" : "?") + b.jsonp + "=" + e),
        b.converters["script json"] = function() {
            return g || n.error(e + " was not called"),
            g[0]
        }
        ,
        b.dataTypes[0] = "json",
        f = a[e],
        a[e] = function() {
            g = arguments
        }
        ,
        d.always(function() {
            void 0 === f ? n(a).removeProp(e) : a[e] = f,
            b[e] && (b.jsonpCallback = c.jsonpCallback,
            Jb.push(e)),
            g && n.isFunction(f) && f(g[0]),
            g = f = void 0
        }),
        "script") : void 0
    }),
    n.parseHTML = function(a, b, c) {
        if (!a || "string" != typeof a)
            return null;
        "boolean" == typeof b && (c = b,
        b = !1),
        b = b || d;
        var e = x.exec(a)
          , f = !c && [];
        return e ? [b.createElement(e[1])] : (e = ca([a], b, f),
        f && f.length && n(f).remove(),
        n.merge([], e.childNodes))
    }
    ;
    var Lb = n.fn.load;
    n.fn.load = function(a, b, c) {
        if ("string" != typeof a && Lb)
            return Lb.apply(this, arguments);
        var d, e, f, g = this, h = a.indexOf(" ");
        return h > -1 && (d = n.trim(a.slice(h)),
        a = a.slice(0, h)),
        n.isFunction(b) ? (c = b,
        b = void 0) : b && "object" == typeof b && (e = "POST"),
        g.length > 0 && n.ajax({
            url: a,
            type: e || "GET",
            dataType: "html",
            data: b
        }).done(function(a) {
            f = arguments,
            g.html(d ? n("<div>").append(n.parseHTML(a)).find(d) : a)
        }).always(c && function(a, b) {
            g.each(function() {
                c.apply(this, f || [a.responseText, b, a])
            })
        }
        ),
        this
    }
    ,
    n.each(["ajaxStart", "ajaxStop", "ajaxComplete", "ajaxError", "ajaxSuccess", "ajaxSend"], function(a, b) {
        n.fn[b] = function(a) {
            return this.on(b, a)
        }
    }),
    n.expr.filters.animated = function(a) {
        return n.grep(n.timers, function(b) {
            return a === b.elem
        }).length
    }
    ;
    function Mb(a) {
        return n.isWindow(a) ? a : 9 === a.nodeType && a.defaultView
    }
    n.offset = {
        setOffset: function(a, b, c) {
            var d, e, f, g, h, i, j, k = n.css(a, "position"), l = n(a), m = {};
            "static" === k && (a.style.position = "relative"),
            h = l.offset(),
            f = n.css(a, "top"),
            i = n.css(a, "left"),
            j = ("absolute" === k || "fixed" === k) && (f + i).indexOf("auto") > -1,
            j ? (d = l.position(),
            g = d.top,
            e = d.left) : (g = parseFloat(f) || 0,
            e = parseFloat(i) || 0),
            n.isFunction(b) && (b = b.call(a, c, n.extend({}, h))),
            null != b.top && (m.top = b.top - h.top + g),
            null != b.left && (m.left = b.left - h.left + e),
            "using"in b ? b.using.call(a, m) : l.css(m)
        }
    },
    n.fn.extend({
        offset: function(a) {
            if (arguments.length)
                return void 0 === a ? this : this.each(function(b) {
                    n.offset.setOffset(this, a, b)
                });
            var b, c, d = this[0], e = {
                top: 0,
                left: 0
            }, f = d && d.ownerDocument;
            if (f)
                return b = f.documentElement,
                n.contains(b, d) ? (e = d.getBoundingClientRect(),
                c = Mb(f),
                {
                    top: e.top + c.pageYOffset - b.clientTop,
                    left: e.left + c.pageXOffset - b.clientLeft
                }) : e
        },
        position: function() {
            if (this[0]) {
                var a, b, c = this[0], d = {
                    top: 0,
                    left: 0
                };
                return "fixed" === n.css(c, "position") ? b = c.getBoundingClientRect() : (a = this.offsetParent(),
                b = this.offset(),
                n.nodeName(a[0], "html") || (d = a.offset()),
                d.top += n.css(a[0], "borderTopWidth", !0),
                d.left += n.css(a[0], "borderLeftWidth", !0)),
                {
                    top: b.top - d.top - n.css(c, "marginTop", !0),
                    left: b.left - d.left - n.css(c, "marginLeft", !0)
                }
            }
        },
        offsetParent: function() {
            return this.map(function() {
                var a = this.offsetParent;
                while (a && "static" === n.css(a, "position"))
                    a = a.offsetParent;
                return a || Ea
            })
        }
    }),
    n.each({
        scrollLeft: "pageXOffset",
        scrollTop: "pageYOffset"
    }, function(a, b) {
        var c = "pageYOffset" === b;
        n.fn[a] = function(d) {
            return K(this, function(a, d, e) {
                var f = Mb(a);
                return void 0 === e ? f ? f[b] : a[d] : void (f ? f.scrollTo(c ? f.pageXOffset : e, c ? e : f.pageYOffset) : a[d] = e)
            }, a, d, arguments.length)
        }
    }),
    n.each(["top", "left"], function(a, b) {
        n.cssHooks[b] = Ga(l.pixelPosition, function(a, c) {
            return c ? (c = Fa(a, b),
            Ba.test(c) ? n(a).position()[b] + "px" : c) : void 0
        })
    }),
    n.each({
        Height: "height",
        Width: "width"
    }, function(a, b) {
        n.each({
            padding: "inner" + a,
            content: b,
            "": "outer" + a
        }, function(c, d) {
            n.fn[d] = function(d, e) {
                var f = arguments.length && (c || "boolean" != typeof d)
                  , g = c || (d === !0 || e === !0 ? "margin" : "border");
                return K(this, function(b, c, d) {
                    var e;
                    return n.isWindow(b) ? b.document.documentElement["client" + a] : 9 === b.nodeType ? (e = b.documentElement,
                    Math.max(b.body["scroll" + a], e["scroll" + a], b.body["offset" + a], e["offset" + a], e["client" + a])) : void 0 === d ? n.css(b, c, g) : n.style(b, c, d, g)
                }, b, f ? d : void 0, f, null)
            }
        })
    }),
    n.fn.extend({
        bind: function(a, b, c) {
            return this.on(a, null, b, c)
        },
        unbind: function(a, b) {
            return this.off(a, null, b)
        },
        delegate: function(a, b, c, d) {
            return this.on(b, a, c, d)
        },
        undelegate: function(a, b, c) {
            return 1 === arguments.length ? this.off(a, "**") : this.off(b, a || "**", c)
        },
        size: function() {
            return this.length
        }
    }),
    n.fn.andSelf = n.fn.addBack,
    "function" == typeof define && define.amd && define("jquery", [], function() {
        return n
    });
    var Nb = a.jQuery
      , Ob = a.$;
    return n.noConflict = function(b) {
        return a.$ === n && (a.$ = Ob),
        b && a.jQuery === n && (a.jQuery = Nb),
        n
    }
    ,
    b || (a.jQuery = a.$ = n),
    n
});

!function(t, e) {
    "function" == typeof define && define.amd ? define([], e) : "object" == typeof exports ? module.exports = e() : t.T = e()
}(this, function() {
    /*!
 * TerrificJS modularizes your frontend code by solely relying on naming conventions.
 * http://terrifically.org
 *
 * @copyright   Copyright (c) 2016 Remo Brunschwiler
 * @license     Licensed under MIT license
 * @version     3.0.0
 */
    function t(t, r) {
        if (t || r)
            if (i.isNode(r)) {
                var o = r;
                r = t,
                t = o
            } else
                i.isNode(t) || r ? i.isNode(t) && !r && (r = {}) : (r = t,
                t = document);
        else
            t = document,
            r = {};
        var s = {
            namespace: n
        };
        r = i.extend(s, r),
        this._ctx = i.getElement(t),
        this._config = r,
        this._sandbox = new e(this),
        this._modules = {},
        this._id = 1
    }
    function e(t) {
        this._application = t,
        this._eventEmitters = []
    }
    function n(t, e) {
        this._ctx = t,
        this._sandbox = e,
        this._events = new r(e)
    }
    function r(t) {
        this._listeners = {},
        this._sandbox = t,
        this._connected = !1
    }
    t.prototype.registerModules = function(t) {
        var e = {};
        t = i.getElement(t) || this._ctx,
        this._sandbox.dispatch("t.register.start");
        var n = i.getModuleNodes(t);
        return n.forEach(function(t) {
            var n = this.registerModule(t, t.getAttribute("data-t-name"), t.getAttribute("data-t-decorator"), t.getAttribute("data-t-namespace"));
            n && (e[n._ctx.getAttribute("data-t-id")] = n)
        }
        .bind(this)),
        this._sandbox.dispatch("t.register.end"),
        e
    }
    ,
    t.prototype.unregisterModules = function(t) {
        t = t || this._modules,
        this._sandbox.dispatch("t.unregister.start");
        for (var e in t)
            this._modules.hasOwnProperty(e) && (i.isNode(this._modules[e]._ctx) && this._modules[e]._ctx.removeAttribute("data-t-id"),
            delete this._modules[e]);
        this._sandbox.dispatch("t.unregister.end")
    }
    ,
    t.prototype.start = function(t) {
        t = t || this._modules;
        var e = [];
        this._sandbox.dispatch("t.start");
        for (var n in t)
            if (t.hasOwnProperty(n)) {
                var r = function(e) {
                    return new Promise(function(n, r) {
                        t[e].start(n, r)
                    }
                    )
                }(n);
                e.push(r)
            }
        var i = Promise.all(e);
        return i.then(function() {
            this._sandbox.dispatch("t.sync")
        }
        .bind(this))["catch"](function(t) {
            throw t
        }),
        i
    }
    ,
    t.prototype.stop = function(t) {
        t = t || this._modules,
        this._sandbox.dispatch("t.stop");
        for (var e in t)
            t.hasOwnProperty(e) && t[e].stop()
    }
    ,
    t.prototype.registerModule = function(t, e, n, r) {
        var o = this._modules;
        if (t.hasAttribute("data-t-id"))
            return null;
        if (e = i.capitalize(i.camelize(e)),
        i.isString(n) ? window[n] ? (r = window[n],
        n = null) : n = n.split(",") : !Array.isArray(n) && i.isObject(n) && (r = n,
        n = null),
        n = n || [],
        n = n.map(function(t) {
            return i.capitalize(i.camelize(t.trim()))
        }),
        r = r || this._config.namespace,
        r[e]) {
            var s = this._id++;
            t.setAttribute("data-t-id", s),
            o[s] = new r[e](t,this._sandbox);
            for (var a = 0, c = n.length; c > a; a++) {
                var u = n[a];
                r[e][u] && r[e][u](o[s])
            }
            return o[s]
        }
        return this._sandbox.dispatch("t.missing", t, e, n, r),
        null
    }
    ,
    t.prototype.getModuleById = function(t) {
        if (this._modules[t])
            return this._modules[t];
        throw Error("The module with the id " + t + " does not exist")
    }
    ,
    e.prototype.addModules = function(t) {
        var e = {}
          , n = this._application;
        return i.isNode(t) && (e = n.registerModules(t),
        n.start(e)),
        e
    }
    ,
    e.prototype.removeModules = function(t) {
        var e = this._application;
        if (i.isNode(t)) {
            var n = {}
              , r = i.getModuleNodes(t);
            r.forEach(function(t) {
                if (t.hasAttribute("data-t-id")) {
                    var e = t.getAttribute("data-t-id")
                      , r = this.getModuleById(e);
                    r && (n[e] = r)
                }
            }
            .bind(this)),
            t = n
        }
        return i.isObject(t) && (e.stop(t),
        e.unregisterModules(t)),
        this
    }
    ,
    e.prototype.getModuleById = function(t) {
        return this._application.getModuleById(t)
    }
    ,
    e.prototype.getConfig = function() {
        return this._application._config
    }
    ,
    e.prototype.getConfigParam = function(t) {
        var e = this._application._config;
        if (void 0 !== e[t])
            return e[t];
        throw Error("The config param " + t + " does not exist")
    }
    ,
    e.prototype.addEventEmitter = function(t) {
        return this._eventEmitters.push(t),
        this
    }
    ,
    e.prototype.removeEventEmitter = function(t) {
        for (var e = this._eventEmitters, n = 0, r = e.length; r > n; n++)
            if (e[n] === t) {
                e.splice(n, 1);
                break
            }
        return this
    }
    ,
    e.prototype.dispatch = function() {
        for (var t = this._eventEmitters, e = 0, n = t.length; n > e; e++) {
            var r = t[e];
            void 0 !== r && r.handle.apply(r, arguments)
        }
        return this
    }
    ,
    n.prototype.start = function(t) {
        t()
    }
    ,
    n.prototype.stop = function() {
        this._events.off().disconnect()
    }
    ,
    r.prototype.on = r.prototype.addListener = function(t, e) {
        return this.connect(),
        (this._listeners["$" + t] = this._listeners["$" + t] || []).push(e),
        this
    }
    ,
    r.prototype.once = function(t, e) {
        function n() {
            this.off(t, n),
            e.apply(this, arguments)
        }
        return this.connect(),
        n.listener = e,
        this.on(t, n),
        this
    }
    ,
    r.prototype.off = r.prototype.removeListener = r.prototype.removeAllListeners = function(t, e) {
        if (0 === arguments.length)
            return this._listeners = {},
            this;
        var n = this._listeners["$" + t];
        if (!n)
            return this;
        if (1 === arguments.length)
            return delete this._listeners["$" + t],
            this;
        for (var r, i = 0, o = n.length; o > i; i++)
            if (r = n[i],
            r === e || r.listener === e) {
                n.splice(i, 1);
                break
            }
        return this
    }
    ,
    r.prototype.emit = function() {
        return this.connect(),
        this._sandbox.dispatch.apply(this._sandbox, arguments),
        this
    }
    ,
    r.prototype.handle = function(t) {
        var e = [].slice.call(arguments, 1)
          , n = this._listeners["$" + t];
        if (n) {
            n = n.slice(0);
            for (var r = 0, i = n.length; i > r; ++r)
                n[r].apply(this, e)
        }
        return this
    }
    ,
    r.prototype.listeners = function(t) {
        return this._listeners["$" + t] || []
    }
    ,
    r.prototype.hasListeners = function(t) {
        return !!this.listeners(t).length
    }
    ,
    r.prototype.connect = function() {
        return this._connected || (this._sandbox.addEventEmitter(this),
        this._connected = !0),
        this
    }
    ,
    r.prototype.disconnect = function() {
        return this._connected && (this._sandbox.removeEventEmitter(this),
        this._connected = !1),
        this
    }
    ;
    var i = {
        capitalize: function(t) {
            return t.substr(0, 1).toUpperCase().concat(t.substr(1))
        },
        camelize: function(t) {
            return t.replace(/(\-[A-Za-z])/g, function(t) {
                return t.toUpperCase().replace("-", "")
            })
        },
        isString: function(t) {
            return "[object String]" === Object.prototype.toString.call(t)
        },
        isObject: function(t) {
            var e = typeof t;
            return !(!t || "object" !== e && "function" !== e || Array.isArray(t))
        },
        isFunction: function(t) {
            var e = typeof t;
            return !!t && "function" === e
        },
        isNode: function(t) {
            return t && t.nodeType ? 1 === t.nodeType || 9 === t.nodeType : !1
        },
        matches: function(t, e) {
            var n = Element.prototype
              , r = n.matches || n.webkitMatchesSelector || n.mozMatchesSelector || n.msMatchesSelector || function(t) {
                return -1 !== [].slice.call(document.querySelectorAll(t)).indexOf(this)
            }
            ;
            return r.call(t, e)
        },
        extend: function(t) {
            if (!i.isObject(t))
                return t;
            for (var e, n, r = 1, o = arguments.length; o > r; r++) {
                e = arguments[r];
                for (n in e)
                    e.hasOwnProperty(n) && (t[n] = e[n])
            }
            return t
        },
        getElement: function(t) {
            return this.isNode(t) ? 9 === t.nodeType && t.documentElement ? t.documentElement : t : null
        },
        getModuleNodes: function(t) {
            var e = [].slice.call(t.querySelectorAll("[data-t-name]"));
            return this.matches(t, "[data-t-name]") && e.unshift(t),
            e
        },
        createModule: function(t) {
            if (!t || !i.isObject(t))
                throw Error("Your module spec is not an object. Usage: T.createModule({ … })");
            var e = function(t, e) {
                n.call(this, t, e)
            }
              , r = e.prototype = Object.create(n.prototype);
            r.constructor = e,
            t.hasOwnProperty("statics") && i.extend(e, t.statics);
            var o = ["statics"];
            for (var s in t)
                if (t.hasOwnProperty(s) && -1 === o.indexOf(s)) {
                    var a = t[s];
                    r[s] = a
                }
            return e
        },
        createDecorator: function(t) {
            if (!t || !i.isObject(t))
                throw Error("Your decorator spec is not an object. Usage: T.createDecorator({ … })");
            return function(e) {
                var n, r = {};
                for (n in e)
                    i.isFunction(e[n]) && (r[n] = e[n].bind(e));
                for (n in t)
                    t.hasOwnProperty(n) && (e[n] = i.isFunction(t[n]) ? function(t, e) {
                        return function() {
                            return this._parent = r,
                            e.apply(this, arguments)
                        }
                    }(n, t[n]) : t[n])
            }
        }
    }
      , o = {
        Application: t,
        Sandbox: e,
        Module: n,
        EventEmitter: r,
        createModule: i.createModule,
        createDecorator: i.createDecorator,
        version: "3.0.0"
    };
    return o
});
//# sourceMappingURL=terrific.min.js.map
/**
* jquery.matchHeight-min.js master
* http://brm.io/jquery-match-height/
* License: MIT
*/
(function(c) {
    var n = -1
      , f = -1
      , g = function(a) {
        return parseFloat(a) || 0
    }
      , r = function(a) {
        var b = null
          , d = [];
        c(a).each(function() {
            var a = c(this)
              , k = a.offset().top - g(a.css("margin-top"))
              , l = 0 < d.length ? d[d.length - 1] : null;
            null === l ? d.push(a) : 1 >= Math.floor(Math.abs(b - k)) ? d[d.length - 1] = l.add(a) : d.push(a);
            b = k
        });
        return d
    }
      , p = function(a) {
        var b = {
            byRow: !0,
            property: "height",
            target: null,
            remove: !1
        };
        if ("object" === typeof a)
            return c.extend(b, a);
        "boolean" === typeof a ? b.byRow = a : "remove" === a && (b.remove = !0);
        return b
    }
      , b = c.fn.matchHeight = function(a) {
        a = p(a);
        if (a.remove) {
            var e = this;
            this.css(a.property, "");
            c.each(b._groups, function(a, b) {
                b.elements = b.elements.not(e)
            });
            return this
        }
        if (1 >= this.length && !a.target)
            return this;
        b._groups.push({
            elements: this,
            options: a
        });
        b._apply(this, a);
        return this
    }
    ;
    b._groups = [];
    b._throttle = 80;
    b._maintainScroll = !1;
    b._beforeUpdate = null;
    b._afterUpdate = null;
    b._apply = function(a, e) {
        var d = p(e)
          , h = c(a)
          , k = [h]
          , l = c(window).scrollTop()
          , f = c("html").outerHeight(!0)
          , m = h.parents().filter(":hidden");
        m.each(function() {
            var a = c(this);
            a.data("style-cache", a.attr("style"))
        });
        m.css("display", "block");
        d.byRow && !d.target && (h.each(function() {
            var a = c(this)
              , b = "inline-block" === a.css("display") ? "inline-block" : "block";
            a.data("style-cache", a.attr("style"));
            a.css({
                display: b,
                "padding-top": "0",
                "padding-bottom": "0",
                "margin-top": "0",
                "margin-bottom": "0",
                "border-top-width": "0",
                "border-bottom-width": "0",
                height: "100px"
            })
        }),
        k = r(h),
        h.each(function() {
            var a = c(this);
            a.attr("style", a.data("style-cache") || "")
        }));
        c.each(k, function(a, b) {
            var e = c(b)
              , f = 0;
            if (d.target)
                f = d.target.outerHeight(!1);
            else {
                if (d.byRow && 1 >= e.length) {
                    e.css(d.property, "");
                    return
                }
                e.each(function() {
                    var a = c(this)
                      , b = {
                        display: "inline-block" === a.css("display") ? "inline-block" : "block"
                    };
                    b[d.property] = "";
                    a.css(b);
                    a.outerHeight(!1) > f && (f = a.outerHeight(!1));
                    a.css("display", "")
                })
            }
            e.each(function() {
                var a = c(this)
                  , b = 0;
                d.target && a.is(d.target) || ("border-box" !== a.css("box-sizing") && (b += g(a.css("border-top-width")) + g(a.css("border-bottom-width")),
                b += g(a.css("padding-top")) + g(a.css("padding-bottom"))),
                a.css(d.property, f - b))
            })
        });
        m.each(function() {
            var a = c(this);
            a.attr("style", a.data("style-cache") || null)
        });
        b._maintainScroll && c(window).scrollTop(l / f * c("html").outerHeight(!0));
        return this
    }
    ;
    b._applyDataApi = function() {
        var a = {};
        c("[data-match-height], [data-mh]").each(function() {
            var b = c(this)
              , d = b.attr("data-mh") || b.attr("data-match-height");
            a[d] = d in a ? a[d].add(b) : b
        });
        c.each(a, function() {
            this.matchHeight(!0)
        })
    }
    ;
    var q = function(a) {
        b._beforeUpdate && b._beforeUpdate(a, b._groups);
        c.each(b._groups, function() {
            b._apply(this.elements, this.options)
        });
        b._afterUpdate && b._afterUpdate(a, b._groups)
    };
    b._update = function(a, e) {
        if (e && "resize" === e.type) {
            var d = c(window).width();
            if (d === n)
                return;
            n = d
        }
        a ? -1 === f && (f = setTimeout(function() {
            q(e);
            f = -1
        }, b._throttle)) : q(e)
    }
    ;
    c(b._applyDataApi);
    c(window).bind("load", function(a) {
        b._update(!1, a)
    });
    c(window).bind("resize orientationchange", function(a) {
        b._update(!0, a)
    })
}
)(jQuery);
/*!
 * enquire.js v2.1.6 - Awesome Media Queries in JavaScript
 * Copyright (c) 2017 Nick Williams - http://wicky.nillia.ms/enquire.js
 * License: MIT */

!function(a) {
    if ("object" == typeof exports && "undefined" != typeof module)
        module.exports = a();
    else if ("function" == typeof define && define.amd)
        define([], a);
    else {
        var b;
        b = "undefined" != typeof window ? window : "undefined" != typeof global ? global : "undefined" != typeof self ? self : this,
        b.enquire = a()
    }
}(function() {
    return function a(b, c, d) {
        function e(g, h) {
            if (!c[g]) {
                if (!b[g]) {
                    var i = "function" == typeof require && require;
                    if (!h && i)
                        return i(g, !0);
                    if (f)
                        return f(g, !0);
                    var j = new Error("Cannot find module '" + g + "'");
                    throw j.code = "MODULE_NOT_FOUND",
                    j
                }
                var k = c[g] = {
                    exports: {}
                };
                b[g][0].call(k.exports, function(a) {
                    var c = b[g][1][a];
                    return e(c ? c : a)
                }, k, k.exports, a, b, c, d)
            }
            return c[g].exports
        }
        for (var f = "function" == typeof require && require, g = 0; g < d.length; g++)
            e(d[g]);
        return e
    }({
        1: [function(a, b, c) {
            function d(a, b) {
                this.query = a,
                this.isUnconditional = b,
                this.handlers = [],
                this.mql = window.matchMedia(a);
                var c = this;
                this.listener = function(a) {
                    c.mql = a.currentTarget || a,
                    c.assess()
                }
                ,
                this.mql.addListener(this.listener)
            }
            var e = a(3)
              , f = a(4).each;
            d.prototype = {
                constuctor: d,
                addHandler: function(a) {
                    var b = new e(a);
                    this.handlers.push(b),
                    this.matches() && b.on()
                },
                removeHandler: function(a) {
                    var b = this.handlers;
                    f(b, function(c, d) {
                        if (c.equals(a))
                            return c.destroy(),
                            !b.splice(d, 1)
                    })
                },
                matches: function() {
                    return this.mql.matches || this.isUnconditional
                },
                clear: function() {
                    f(this.handlers, function(a) {
                        a.destroy()
                    }),
                    this.mql.removeListener(this.listener),
                    this.handlers.length = 0
                },
                assess: function() {
                    var a = this.matches() ? "on" : "off";
                    f(this.handlers, function(b) {
                        b[a]()
                    })
                }
            },
            b.exports = d
        }
        , {
            3: 3,
            4: 4
        }],
        2: [function(a, b, c) {
            function d() {
                if (!window.matchMedia)
                    throw new Error("matchMedia not present, legacy browsers require a polyfill");
                this.queries = {},
                this.browserIsIncapable = !window.matchMedia("only all").matches
            }
            var e = a(1)
              , f = a(4)
              , g = f.each
              , h = f.isFunction
              , i = f.isArray;
            d.prototype = {
                constructor: d,
                register: function(a, b, c) {
                    var d = this.queries
                      , f = c && this.browserIsIncapable;
                    return d[a] || (d[a] = new e(a,f)),
                    h(b) && (b = {
                        match: b
                    }),
                    i(b) || (b = [b]),
                    g(b, function(b) {
                        h(b) && (b = {
                            match: b
                        }),
                        d[a].addHandler(b)
                    }),
                    this
                },
                unregister: function(a, b) {
                    var c = this.queries[a];
                    return c && (b ? c.removeHandler(b) : (c.clear(),
                    delete this.queries[a])),
                    this
                }
            },
            b.exports = d
        }
        , {
            1: 1,
            4: 4
        }],
        3: [function(a, b, c) {
            function d(a) {
                this.options = a,
                !a.deferSetup && this.setup()
            }
            d.prototype = {
                constructor: d,
                setup: function() {
                    this.options.setup && this.options.setup(),
                    this.initialised = !0
                },
                on: function() {
                    !this.initialised && this.setup(),
                    this.options.match && this.options.match()
                },
                off: function() {
                    this.options.unmatch && this.options.unmatch()
                },
                destroy: function() {
                    this.options.destroy ? this.options.destroy() : this.off()
                },
                equals: function(a) {
                    return this.options === a || this.options.match === a
                }
            },
            b.exports = d
        }
        , {}],
        4: [function(a, b, c) {
            function d(a, b) {
                var c = 0
                  , d = a.length;
                for (c; c < d && b(a[c], c) !== !1; c++)
                    ;
            }
            function e(a) {
                return "[object Array]" === Object.prototype.toString.apply(a)
            }
            function f(a) {
                return "function" == typeof a
            }
            b.exports = {
                isFunction: f,
                isArray: e,
                each: d
            }
        }
        , {}],
        5: [function(a, b, c) {
            var d = a(2);
            b.exports = new d
        }
        , {
            2: 2
        }]
    }, {}, [5])(5)
});
/*! lazysizes - v3.0.0 */
!function(a, b) {
    var c = b(a, a.document);
    a.lazySizes = c,
    "object" == typeof module && module.exports && (module.exports = c)
}(window, function(a, b) {
    "use strict";
    if (b.getElementsByClassName) {
        var c, d = b.documentElement, e = a.Date, f = a.HTMLPictureElement, g = "addEventListener", h = "getAttribute", i = a[g], j = a.setTimeout, k = a.requestAnimationFrame || j, l = a.requestIdleCallback, m = /^picture$/i, n = ["load", "error", "lazyincluded", "_lazyloaded"], o = {}, p = Array.prototype.forEach, q = function(a, b) {
            return o[b] || (o[b] = new RegExp("(\\s|^)" + b + "(\\s|$)")),
            o[b].test(a[h]("class") || "") && o[b]
        }, r = function(a, b) {
            q(a, b) || a.setAttribute("class", (a[h]("class") || "").trim() + " " + b)
        }, s = function(a, b) {
            var c;
            (c = q(a, b)) && a.setAttribute("class", (a[h]("class") || "").replace(c, " "))
        }, t = function(a, b, c) {
            var d = c ? g : "removeEventListener";
            c && t(a, b),
            n.forEach(function(c) {
                a[d](c, b)
            })
        }, u = function(a, c, d, e, f) {
            var g = b.createEvent("CustomEvent");
            return g.initCustomEvent(c, !e, !f, d || {}),
            a.dispatchEvent(g),
            g
        }, v = function(b, d) {
            var e;
            !f && (e = a.picturefill || c.pf) ? e({
                reevaluate: !0,
                elements: [b]
            }) : d && d.src && (b.src = d.src)
        }, w = function(a, b) {
            return (getComputedStyle(a, null) || {})[b]
        }, x = function(a, b, d) {
            for (d = d || a.offsetWidth; d < c.minSize && b && !a._lazysizesWidth; )
                d = b.offsetWidth,
                b = b.parentNode;
            return d
        }, y = function() {
            var a, c, d = [], e = [], f = d, g = function() {
                var b = f;
                for (f = d.length ? e : d,
                a = !0,
                c = !1; b.length; )
                    b.shift()();
                a = !1
            }, h = function(d, e) {
                a && !e ? d.apply(this, arguments) : (f.push(d),
                c || (c = !0,
                (b.hidden ? j : k)(g)))
            };
            return h._lsFlush = g,
            h
        }(), z = function(a, b) {
            return b ? function() {
                y(a)
            }
            : function() {
                var b = this
                  , c = arguments;
                y(function() {
                    a.apply(b, c)
                })
            }
        }, A = function(a) {
            var b, c = 0, d = 125, f = 666, g = f, h = function() {
                b = !1,
                c = e.now(),
                a()
            }, i = l ? function() {
                l(h, {
                    timeout: g
                }),
                g !== f && (g = f)
            }
            : z(function() {
                j(h)
            }, !0);
            return function(a) {
                var f;
                (a = a === !0) && (g = 44),
                b || (b = !0,
                f = d - (e.now() - c),
                0 > f && (f = 0),
                a || 9 > f && l ? i() : j(i, f))
            }
        }, B = function(a) {
            var b, c, d = 99, f = function() {
                b = null,
                a()
            }, g = function() {
                var a = e.now() - c;
                d > a ? j(g, d - a) : (l || f)(f)
            };
            return function() {
                c = e.now(),
                b || (b = j(g, d))
            }
        }, C = function() {
            var f, k, l, n, o, x, C, E, F, G, H, I, J, K, L, M = /^img$/i, N = /^iframe$/i, O = "onscroll"in a && !/glebot/.test(navigator.userAgent), P = 0, Q = 0, R = 0, S = -1, T = function(a) {
                R--,
                a && a.target && t(a.target, T),
                (!a || 0 > R || !a.target) && (R = 0)
            }, U = function(a, c) {
                var e, f = a, g = "hidden" == w(b.body, "visibility") || "hidden" != w(a, "visibility");
                for (F -= c,
                I += c,
                G -= c,
                H += c; g && (f = f.offsetParent) && f != b.body && f != d; )
                    g = (w(f, "opacity") || 1) > 0,
                    g && "visible" != w(f, "overflow") && (e = f.getBoundingClientRect(),
                    g = H > e.left && G < e.right && I > e.top - 1 && F < e.bottom + 1);
                return g
            }, V = function() {
                var a, e, g, i, j, m, n, p, q;
                if ((o = c.loadMode) && 8 > R && (a = f.length)) {
                    e = 0,
                    S++,
                    null == K && ("expand"in c || (c.expand = d.clientHeight > 500 && d.clientWidth > 500 ? 500 : 370),
                    J = c.expand,
                    K = J * c.expFactor),
                    K > Q && 1 > R && S > 2 && o > 2 && !b.hidden ? (Q = K,
                    S = 0) : Q = o > 1 && S > 1 && 6 > R ? J : P;
                    for (; a > e; e++)
                        if (f[e] && !f[e]._lazyRace)
                            if (O)
                                if ((p = f[e][h]("data-expand")) && (m = 1 * p) || (m = Q),
                                q !== m && (C = innerWidth + m * L,
                                E = innerHeight + m,
                                n = -1 * m,
                                q = m),
                                g = f[e].getBoundingClientRect(),
                                (I = g.bottom) >= n && (F = g.top) <= E && (H = g.right) >= n * L && (G = g.left) <= C && (I || H || G || F) && (l && 3 > R && !p && (3 > o || 4 > S) || U(f[e], m))) {
                                    if (ba(f[e]),
                                    j = !0,
                                    R > 9)
                                        break
                                } else
                                    !j && l && !i && 4 > R && 4 > S && o > 2 && (k[0] || c.preloadAfterLoad) && (k[0] || !p && (I || H || G || F || "auto" != f[e][h](c.sizesAttr))) && (i = k[0] || f[e]);
                            else
                                ba(f[e]);
                    i && !j && ba(i)
                }
            }, W = A(V), X = function(a) {
                r(a.target, c.loadedClass),
                s(a.target, c.loadingClass),
                t(a.target, Z)
            }, Y = z(X), Z = function(a) {
                Y({
                    target: a.target
                })
            }, $ = function(a, b) {
                try {
                    a.contentWindow.location.replace(b)
                } catch (c) {
                    a.src = b
                }
            }, _ = function(a) {
                var b, d, e = a[h](c.srcsetAttr);
                (b = c.customMedia[a[h]("data-media") || a[h]("media")]) && a.setAttribute("media", b),
                e && a.setAttribute("srcset", e),
                b && (d = a.parentNode,
                d.insertBefore(a.cloneNode(), a),
                d.removeChild(a))
            }, aa = z(function(a, b, d, e, f) {
                var g, i, k, l, o, q;
                (o = u(a, "lazybeforeunveil", b)).defaultPrevented || (e && (d ? r(a, c.autosizesClass) : a.setAttribute("sizes", e)),
                i = a[h](c.srcsetAttr),
                g = a[h](c.srcAttr),
                f && (k = a.parentNode,
                l = k && m.test(k.nodeName || "")),
                q = b.firesLoad || "src"in a && (i || g || l),
                o = {
                    target: a
                },
                q && (t(a, T, !0),
                clearTimeout(n),
                n = j(T, 2500),
                r(a, c.loadingClass),
                t(a, Z, !0)),
                l && p.call(k.getElementsByTagName("source"), _),
                i ? a.setAttribute("srcset", i) : g && !l && (N.test(a.nodeName) ? $(a, g) : a.src = g),
                (i || l) && v(a, {
                    src: g
                })),
                a._lazyRace && delete a._lazyRace,
                s(a, c.lazyClass),
                y(function() {
                    (!q || a.complete && a.naturalWidth > 1) && (q ? T(o) : R--,
                    X(o))
                }, !0)
            }), ba = function(a) {
                var b, d = M.test(a.nodeName), e = d && (a[h](c.sizesAttr) || a[h]("sizes")), f = "auto" == e;
                (!f && l || !d || !a.src && !a.srcset || a.complete || q(a, c.errorClass)) && (b = u(a, "lazyunveilread").detail,
                f && D.updateElem(a, !0, a.offsetWidth),
                a._lazyRace = !0,
                R++,
                aa(a, b, f, e, d))
            }, ca = function() {
                if (!l) {
                    if (e.now() - x < 999)
                        return void j(ca, 999);
                    var a = B(function() {
                        c.loadMode = 3,
                        W()
                    });
                    l = !0,
                    c.loadMode = 3,
                    W(),
                    i("scroll", function() {
                        3 == c.loadMode && (c.loadMode = 2),
                        a()
                    }, !0)
                }
            };
            return {
                _: function() {
                    x = e.now(),
                    f = b.getElementsByClassName(c.lazyClass),
                    k = b.getElementsByClassName(c.lazyClass + " " + c.preloadClass),
                    L = c.hFac,
                    i("scroll", W, !0),
                    i("resize", W, !0),
                    a.MutationObserver ? new MutationObserver(W).observe(d, {
                        childList: !0,
                        subtree: !0,
                        attributes: !0
                    }) : (d[g]("DOMNodeInserted", W, !0),
                    d[g]("DOMAttrModified", W, !0),
                    setInterval(W, 999)),
                    i("hashchange", W, !0),
                    ["focus", "mouseover", "click", "load", "transitionend", "animationend", "webkitAnimationEnd"].forEach(function(a) {
                        b[g](a, W, !0)
                    }),
                    /d$|^c/.test(b.readyState) ? ca() : (i("load", ca),
                    b[g]("DOMContentLoaded", W),
                    j(ca, 2e4)),
                    f.length ? (V(),
                    y._lsFlush()) : W()
                },
                checkElems: W,
                unveil: ba
            }
        }(), D = function() {
            var a, d = z(function(a, b, c, d) {
                var e, f, g;
                if (a._lazysizesWidth = d,
                d += "px",
                a.setAttribute("sizes", d),
                m.test(b.nodeName || ""))
                    for (e = b.getElementsByTagName("source"),
                    f = 0,
                    g = e.length; g > f; f++)
                        e[f].setAttribute("sizes", d);
                c.detail.dataAttr || v(a, c.detail)
            }), e = function(a, b, c) {
                var e, f = a.parentNode;
                f && (c = x(a, f, c),
                e = u(a, "lazybeforesizes", {
                    width: c,
                    dataAttr: !!b
                }),
                e.defaultPrevented || (c = e.detail.width,
                c && c !== a._lazysizesWidth && d(a, f, e, c)))
            }, f = function() {
                var b, c = a.length;
                if (c)
                    for (b = 0; c > b; b++)
                        e(a[b])
            }, g = B(f);
            return {
                _: function() {
                    a = b.getElementsByClassName(c.autosizesClass),
                    i("resize", g)
                },
                checkElems: g,
                updateElem: e
            }
        }(), E = function() {
            E.i || (E.i = !0,
            D._(),
            C._())
        };
        return function() {
            var b, d = {
                lazyClass: "lazyload",
                loadedClass: "lazyloaded",
                loadingClass: "lazyloading",
                preloadClass: "lazypreload",
                errorClass: "lazyerror",
                autosizesClass: "lazyautosizes",
                srcAttr: "data-src",
                srcsetAttr: "data-srcset",
                sizesAttr: "data-sizes",
                minSize: 40,
                customMedia: {},
                init: !0,
                expFactor: 1.5,
                hFac: .8,
                loadMode: 2
            };
            c = a.lazySizesConfig || a.lazysizesConfig || {};
            for (b in d)
                b in c || (c[b] = d[b]);
            a.lazySizesConfig = c,
            j(function() {
                c.init && E()
            })
        }(),
        {
            cfg: c,
            autoSizer: D,
            loader: C,
            init: E,
            uP: v,
            aC: r,
            rC: s,
            hC: q,
            fire: u,
            gW: x,
            rAF: y
        }
    }
});
/*rtl:begin:ignore*/
!function(i) {
    "use strict";
    "function" == typeof define && define.amd ? define(["jquery"], i) : "undefined" != typeof exports ? module.exports = i(require("jquery")) : i(jQuery)
}(function(i) {
    "use strict";
    var e = window.Slick || {};
    (e = function() {
        var e = 0;
        return function(t, o) {
            var s, n = this;
            n.defaults = {
                accessibility: !0,
                adaptiveHeight: !1,
                appendArrows: i(t),
                appendDots: i(t),
                arrows: !0,
                asNavFor: null,
                prevArrow: '<button class="slick-prev" aria-label="Previous" type="button">Previous</button>',
                nextArrow: '<button class="slick-next" aria-label="Next" type="button">Next</button>',
                autoplay: !1,
                autoplaySpeed: 3e3,
                centerMode: !1,
                centerPadding: "50px",
                cssEase: "ease",
                customPaging: function(e, t) {
                    return i('<button type="button" />').text(t + 1)
                },
                dots: !1,
                dotsClass: "slick-dots",
                draggable: !0,
                easing: "linear",
                edgeFriction: .35,
                fade: !1,
                focusOnSelect: !1,
                infinite: !0,
                initialSlide: 0,
                lazyLoad: "ondemand",
                mobileFirst: !1,
                pauseOnHover: !0,
                pauseOnFocus: !0,
                pauseOnDotsHover: !1,
                respondTo: "window",
                responsive: null,
                rows: 1,
                rtl: !1,
                slide: "",
                slidesPerRow: 1,
                slidesToShow: 1,
                slidesToScroll: 1,
                speed: 500,
                swipe: !0,
                swipeToSlide: !1,
                touchMove: !0,
                touchThreshold: 5,
                useCSS: !0,
                useTransform: !0,
                variableWidth: !1,
                vertical: !1,
                verticalSwiping: !1,
                waitForAnimate: !0,
                zIndex: 1e3
            },
            n.initials = {
                animating: !1,
                dragging: !1,
                autoPlayTimer: null,
                currentDirection: 0,
                currentLeft: null,
                currentSlide: 0,
                direction: 1,
                $dots: null,
                listWidth: null,
                listHeight: null,
                loadIndex: 0,
                $nextArrow: null,
                $prevArrow: null,
                scrolling: !1,
                slideCount: null,
                slideWidth: null,
                $slideTrack: null,
                $slides: null,
                sliding: !1,
                slideOffset: 0,
                swipeLeft: null,
                swiping: !1,
                $list: null,
                touchObject: {},
                transformsEnabled: !1,
                unslicked: !1
            },
            i.extend(n, n.initials),
            n.activeBreakpoint = null,
            n.animType = null,
            n.animProp = null,
            n.breakpoints = [],
            n.breakpointSettings = [],
            n.cssTransitions = !1,
            n.focussed = !1,
            n.interrupted = !1,
            n.hidden = "hidden",
            n.paused = !0,
            n.positionProp = null,
            n.respondTo = null,
            n.rowCount = 1,
            n.shouldClick = !0,
            n.$slider = i(t),
            n.$slidesCache = null,
            n.transformType = null,
            n.transitionType = null,
            n.visibilityChange = "visibilitychange",
            n.windowWidth = 0,
            n.windowTimer = null,
            s = i(t).data("slick") || {},
            n.options = i.extend({}, n.defaults, o, s),
            n.currentSlide = n.options.initialSlide,
            n.originalSettings = n.options,
            void 0 !== document.mozHidden ? (n.hidden = "mozHidden",
            n.visibilityChange = "mozvisibilitychange") : void 0 !== document.webkitHidden && (n.hidden = "webkitHidden",
            n.visibilityChange = "webkitvisibilitychange"),
            n.autoPlay = i.proxy(n.autoPlay, n),
            n.autoPlayClear = i.proxy(n.autoPlayClear, n),
            n.autoPlayIterator = i.proxy(n.autoPlayIterator, n),
            n.changeSlide = i.proxy(n.changeSlide, n),
            n.clickHandler = i.proxy(n.clickHandler, n),
            n.selectHandler = i.proxy(n.selectHandler, n),
            n.setPosition = i.proxy(n.setPosition, n),
            n.swipeHandler = i.proxy(n.swipeHandler, n),
            n.dragHandler = i.proxy(n.dragHandler, n),
            n.keyHandler = i.proxy(n.keyHandler, n),
            n.instanceUid = e++,
            n.htmlExpr = /^(?:\s*(<[\w\W]+>)[^>]*)$/,
            n.registerBreakpoints(),
            n.init(!0)
        }
    }()).prototype.activateADA = function() {
        this.$slideTrack.find(".slick-active").attr({
            "aria-hidden": "false"
        }).find("a, input, button, select").attr({
            tabindex: "0"
        })
    }
    ,
    e.prototype.addSlide = e.prototype.slickAdd = function(e, t, o) {
        var s = this;
        if ("boolean" == typeof t)
            o = t,
            t = null;
        else if (t < 0 || t >= s.slideCount)
            return !1;
        s.unload(),
        "number" == typeof t ? 0 === t && 0 === s.$slides.length ? i(e).appendTo(s.$slideTrack) : o ? i(e).insertBefore(s.$slides.eq(t)) : i(e).insertAfter(s.$slides.eq(t)) : !0 === o ? i(e).prependTo(s.$slideTrack) : i(e).appendTo(s.$slideTrack),
        s.$slides = s.$slideTrack.children(this.options.slide),
        s.$slideTrack.children(this.options.slide).detach(),
        s.$slideTrack.append(s.$slides),
        s.$slides.each(function(e, t) {
            i(t).attr("data-slick-index", e)
        }),
        s.$slidesCache = s.$slides,
        s.reinit()
    }
    ,
    e.prototype.animateHeight = function() {
        var i = this;
        if (1 === i.options.slidesToShow && !0 === i.options.adaptiveHeight && !1 === i.options.vertical) {
            var e = i.$slides.eq(i.currentSlide).outerHeight(!0);
            i.$list.animate({
                height: e
            }, i.options.speed)
        }
    }
    ,
    e.prototype.animateSlide = function(e, t) {
        var o = {}
          , s = this;
        s.animateHeight(),
        !0 === s.options.rtl && !1 === s.options.vertical && (e = -e),
        !1 === s.transformsEnabled ? !1 === s.options.vertical ? s.$slideTrack.animate({
            left: e
        }, s.options.speed, s.options.easing, t) : s.$slideTrack.animate({
            top: e
        }, s.options.speed, s.options.easing, t) : !1 === s.cssTransitions ? (!0 === s.options.rtl && (s.currentLeft = -s.currentLeft),
        i({
            animStart: s.currentLeft
        }).animate({
            animStart: e
        }, {
            duration: s.options.speed,
            easing: s.options.easing,
            step: function(i) {
                i = Math.ceil(i),
                !1 === s.options.vertical ? (o[s.animType] = "translate(" + i + "px, 0px)",
                s.$slideTrack.css(o)) : (o[s.animType] = "translate(0px," + i + "px)",
                s.$slideTrack.css(o))
            },
            complete: function() {
                t && t.call()
            }
        })) : (s.applyTransition(),
        e = Math.ceil(e),
        !1 === s.options.vertical ? o[s.animType] = "translate3d(" + e + "px, 0px, 0px)" : o[s.animType] = "translate3d(0px," + e + "px, 0px)",
        s.$slideTrack.css(o),
        t && setTimeout(function() {
            s.disableTransition(),
            t.call()
        }, s.options.speed))
    }
    ,
    e.prototype.getNavTarget = function() {
        var e = this
          , t = e.options.asNavFor;
        return t && null !== t && (t = i(t).not(e.$slider)),
        t
    }
    ,
    e.prototype.asNavFor = function(e) {
        var t = this.getNavTarget();
        null !== t && "object" == typeof t && t.each(function() {
            var t = i(this).slick("getSlick");
            t.unslicked || t.slideHandler(e, !0)
        })
    }
    ,
    e.prototype.applyTransition = function(i) {
        var e = this
          , t = {};
        !1 === e.options.fade ? t[e.transitionType] = e.transformType + " " + e.options.speed + "ms " + e.options.cssEase : t[e.transitionType] = "opacity " + e.options.speed + "ms " + e.options.cssEase,
        !1 === e.options.fade ? e.$slideTrack.css(t) : e.$slides.eq(i).css(t)
    }
    ,
    e.prototype.autoPlay = function() {
        var i = this;
        i.autoPlayClear(),
        i.slideCount > i.options.slidesToShow && (i.autoPlayTimer = setInterval(i.autoPlayIterator, i.options.autoplaySpeed))
    }
    ,
    e.prototype.autoPlayClear = function() {
        var i = this;
        i.autoPlayTimer && clearInterval(i.autoPlayTimer)
    }
    ,
    e.prototype.autoPlayIterator = function() {
        var i = this
          , e = i.currentSlide + i.options.slidesToScroll;
        i.paused || i.interrupted || i.focussed || (!1 === i.options.infinite && (1 === i.direction && i.currentSlide + 1 === i.slideCount - 1 ? i.direction = 0 : 0 === i.direction && (e = i.currentSlide - i.options.slidesToScroll,
        i.currentSlide - 1 == 0 && (i.direction = 1))),
        i.slideHandler(e))
    }
    ,
    e.prototype.buildArrows = function() {
        var e = this;
        !0 === e.options.arrows && (e.$prevArrow = i(e.options.prevArrow).addClass("slick-arrow"),
        e.$nextArrow = i(e.options.nextArrow).addClass("slick-arrow"),
        e.slideCount > e.options.slidesToShow ? (e.$prevArrow.removeClass("slick-hidden").removeAttr("aria-hidden tabindex"),
        e.$nextArrow.removeClass("slick-hidden").removeAttr("aria-hidden tabindex"),
        e.htmlExpr.test(e.options.prevArrow) && e.$prevArrow.prependTo(e.options.appendArrows),
        e.htmlExpr.test(e.options.nextArrow) && e.$nextArrow.appendTo(e.options.appendArrows),
        !0 !== e.options.infinite && e.$prevArrow.addClass("slick-disabled").attr("aria-disabled", "true")) : e.$prevArrow.add(e.$nextArrow).addClass("slick-hidden").attr({
            "aria-disabled": "true",
            tabindex: "-1"
        }))
    }
    ,
    e.prototype.buildDots = function() {
        var e, t, o = this;
        if (!0 === o.options.dots) {
            for (o.$slider.addClass("slick-dotted"),
            t = i("<ul />").addClass(o.options.dotsClass),
            e = 0; e <= o.getDotCount(); e += 1)
                t.append(i("<li />").append(o.options.customPaging.call(this, o, e)));
            o.$dots = t.appendTo(o.options.appendDots),
            o.$dots.find("li").first().addClass("slick-active")
        }
    }
    ,
    e.prototype.buildOut = function() {
        var e = this;
        e.$slides = e.$slider.children(e.options.slide + ":not(.slick-cloned)").addClass("slick-slide"),
        e.slideCount = e.$slides.length,
        e.$slides.each(function(e, t) {
            i(t).attr("data-slick-index", e).data("originalStyling", i(t).attr("style") || "")
        }),
        e.$slider.addClass("slick-slider"),
        e.$slideTrack = 0 === e.slideCount ? i('<div class="slick-track"/>').appendTo(e.$slider) : e.$slides.wrapAll('<div class="slick-track"/>').parent(),
        e.$list = e.$slideTrack.wrap('<div class="slick-list"/>').parent(),
        e.$slideTrack.css("opacity", 0),
        !0 !== e.options.centerMode && !0 !== e.options.swipeToSlide || (e.options.slidesToScroll = 1),
        i("img[data-lazy]", e.$slider).not("[src]").addClass("slick-loading"),
        e.setupInfinite(),
        e.buildArrows(),
        e.buildDots(),
        e.updateDots(),
        e.setSlideClasses("number" == typeof e.currentSlide ? e.currentSlide : 0),
        !0 === e.options.draggable && e.$list.addClass("draggable")
    }
    ,
    e.prototype.buildRows = function() {
        var i, e, t, o, s, n, r, l = this;
        if (o = document.createDocumentFragment(),
        n = l.$slider.children(),
        l.options.rows > 1) {
            for (r = l.options.slidesPerRow * l.options.rows,
            s = Math.ceil(n.length / r),
            i = 0; i < s; i++) {
                var d = document.createElement("div");
                for (e = 0; e < l.options.rows; e++) {
                    var a = document.createElement("div");
                    for (t = 0; t < l.options.slidesPerRow; t++) {
                        var c = i * r + (e * l.options.slidesPerRow + t);
                        n.get(c) && a.appendChild(n.get(c))
                    }
                    d.appendChild(a)
                }
                o.appendChild(d)
            }
            l.$slider.empty().append(o),
            l.$slider.children().children().children().css({
                width: 100 / l.options.slidesPerRow + "%",
                display: "inline-block"
            })
        }
    }
    ,
    e.prototype.checkResponsive = function(e, t) {
        var o, s, n, r = this, l = !1, d = r.$slider.width(), a = window.innerWidth || i(window).width();
        if ("window" === r.respondTo ? n = a : "slider" === r.respondTo ? n = d : "min" === r.respondTo && (n = Math.min(a, d)),
        r.options.responsive && r.options.responsive.length && null !== r.options.responsive) {
            s = null;
            for (o in r.breakpoints)
                r.breakpoints.hasOwnProperty(o) && (!1 === r.originalSettings.mobileFirst ? n < r.breakpoints[o] && (s = r.breakpoints[o]) : n > r.breakpoints[o] && (s = r.breakpoints[o]));
            null !== s ? null !== r.activeBreakpoint ? (s !== r.activeBreakpoint || t) && (r.activeBreakpoint = s,
            "unslick" === r.breakpointSettings[s] ? r.unslick(s) : (r.options = i.extend({}, r.originalSettings, r.breakpointSettings[s]),
            !0 === e && (r.currentSlide = r.options.initialSlide),
            r.refresh(e)),
            l = s) : (r.activeBreakpoint = s,
            "unslick" === r.breakpointSettings[s] ? r.unslick(s) : (r.options = i.extend({}, r.originalSettings, r.breakpointSettings[s]),
            !0 === e && (r.currentSlide = r.options.initialSlide),
            r.refresh(e)),
            l = s) : null !== r.activeBreakpoint && (r.activeBreakpoint = null,
            r.options = r.originalSettings,
            !0 === e && (r.currentSlide = r.options.initialSlide),
            r.refresh(e),
            l = s),
            e || !1 === l || r.$slider.trigger("breakpoint", [r, l])
        }
    }
    ,
    e.prototype.changeSlide = function(e, t) {
        var o, s, n, r = this, l = i(e.currentTarget);
        switch (l.is("a") && e.preventDefault(),
        l.is("li") || (l = l.closest("li")),
        n = r.slideCount % r.options.slidesToScroll != 0,
        o = n ? 0 : (r.slideCount - r.currentSlide) % r.options.slidesToScroll,
        e.data.message) {
        case "previous":
            s = 0 === o ? r.options.slidesToScroll : r.options.slidesToShow - o,
            r.slideCount > r.options.slidesToShow && r.slideHandler(r.currentSlide - s, !1, t);
            break;
        case "next":
            s = 0 === o ? r.options.slidesToScroll : o,
            r.slideCount > r.options.slidesToShow && r.slideHandler(r.currentSlide + s, !1, t);
            break;
        case "index":
            var d = 0 === e.data.index ? 0 : e.data.index || l.index() * r.options.slidesToScroll;
            r.slideHandler(r.checkNavigable(d), !1, t),
            l.children().trigger("focus");
            break;
        default:
            return
        }
    }
    ,
    e.prototype.checkNavigable = function(i) {
        var e, t;
        if (e = this.getNavigableIndexes(),
        t = 0,
        i > e[e.length - 1])
            i = e[e.length - 1];
        else
            for (var o in e) {
                if (i < e[o]) {
                    i = t;
                    break
                }
                t = e[o]
            }
        return i
    }
    ,
    e.prototype.cleanUpEvents = function() {
        var e = this;
        e.options.dots && null !== e.$dots && (i("li", e.$dots).off("click.slick", e.changeSlide).off("mouseenter.slick", i.proxy(e.interrupt, e, !0)).off("mouseleave.slick", i.proxy(e.interrupt, e, !1)),
        !0 === e.options.accessibility && e.$dots.off("keydown.slick", e.keyHandler)),
        e.$slider.off("focus.slick blur.slick"),
        !0 === e.options.arrows && e.slideCount > e.options.slidesToShow && (e.$prevArrow && e.$prevArrow.off("click.slick", e.changeSlide),
        e.$nextArrow && e.$nextArrow.off("click.slick", e.changeSlide),
        !0 === e.options.accessibility && (e.$prevArrow.off("keydown.slick", e.keyHandler),
        e.$nextArrow.off("keydown.slick", e.keyHandler))),
        e.$list.off("touchstart.slick mousedown.slick", e.swipeHandler),
        e.$list.off("touchmove.slick mousemove.slick", e.swipeHandler),
        e.$list.off("touchend.slick mouseup.slick", e.swipeHandler),
        e.$list.off("touchcancel.slick mouseleave.slick", e.swipeHandler),
        e.$list.off("click.slick", e.clickHandler),
        i(document).off(e.visibilityChange, e.visibility),
        e.cleanUpSlideEvents(),
        !0 === e.options.accessibility && e.$list.off("keydown.slick", e.keyHandler),
        !0 === e.options.focusOnSelect && i(e.$slideTrack).children().off("click.slick", e.selectHandler),
        i(window).off("orientationchange.slick.slick-" + e.instanceUid, e.orientationChange),
        i(window).off("resize.slick.slick-" + e.instanceUid, e.resize),
        i("[draggable!=true]", e.$slideTrack).off("dragstart", e.preventDefault),
        i(window).off("load.slick.slick-" + e.instanceUid, e.setPosition)
    }
    ,
    e.prototype.cleanUpSlideEvents = function() {
        var e = this;
        e.$list.off("mouseenter.slick", i.proxy(e.interrupt, e, !0)),
        e.$list.off("mouseleave.slick", i.proxy(e.interrupt, e, !1))
    }
    ,
    e.prototype.cleanUpRows = function() {
        var i, e = this;
        e.options.rows > 1 && ((i = e.$slides.children().children()).removeAttr("style"),
        e.$slider.empty().append(i))
    }
    ,
    e.prototype.clickHandler = function(i) {
        !1 === this.shouldClick && (i.stopImmediatePropagation(),
        i.stopPropagation(),
        i.preventDefault())
    }
    ,
    e.prototype.destroy = function(e) {
        var t = this;
        t.autoPlayClear(),
        t.touchObject = {},
        t.cleanUpEvents(),
        i(".slick-cloned", t.$slider).detach(),
        t.$dots && t.$dots.remove(),
        t.$prevArrow && t.$prevArrow.length && (t.$prevArrow.removeClass("slick-disabled slick-arrow slick-hidden").removeAttr("aria-hidden aria-disabled tabindex").css("display", ""),
        t.htmlExpr.test(t.options.prevArrow) && t.$prevArrow.remove()),
        t.$nextArrow && t.$nextArrow.length && (t.$nextArrow.removeClass("slick-disabled slick-arrow slick-hidden").removeAttr("aria-hidden aria-disabled tabindex").css("display", ""),
        t.htmlExpr.test(t.options.nextArrow) && t.$nextArrow.remove()),
        t.$slides && (t.$slides.removeClass("slick-slide slick-active slick-center slick-visible slick-current").removeAttr("aria-hidden").removeAttr("data-slick-index").each(function() {
            i(this).attr("style", i(this).data("originalStyling"))
        }),
        t.$slideTrack.children(this.options.slide).detach(),
        t.$slideTrack.detach(),
        t.$list.detach(),
        t.$slider.append(t.$slides)),
        t.cleanUpRows(),
        t.$slider.removeClass("slick-slider"),
        t.$slider.removeClass("slick-initialized"),
        t.$slider.removeClass("slick-dotted"),
        t.unslicked = !0,
        e || t.$slider.trigger("destroy", [t])
    }
    ,
    e.prototype.disableTransition = function(i) {
        var e = this
          , t = {};
        t[e.transitionType] = "",
        !1 === e.options.fade ? e.$slideTrack.css(t) : e.$slides.eq(i).css(t)
    }
    ,
    e.prototype.fadeSlide = function(i, e) {
        var t = this;
        !1 === t.cssTransitions ? (t.$slides.eq(i).css({
            zIndex: t.options.zIndex
        }),
        t.$slides.eq(i).animate({
            opacity: 1
        }, t.options.speed, t.options.easing, e)) : (t.applyTransition(i),
        t.$slides.eq(i).css({
            opacity: 1,
            zIndex: t.options.zIndex
        }),
        e && setTimeout(function() {
            t.disableTransition(i),
            e.call()
        }, t.options.speed))
    }
    ,
    e.prototype.fadeSlideOut = function(i) {
        var e = this;
        !1 === e.cssTransitions ? e.$slides.eq(i).animate({
            opacity: 0,
            zIndex: e.options.zIndex - 2
        }, e.options.speed, e.options.easing) : (e.applyTransition(i),
        e.$slides.eq(i).css({
            opacity: 0,
            zIndex: e.options.zIndex - 2
        }))
    }
    ,
    e.prototype.filterSlides = e.prototype.slickFilter = function(i) {
        var e = this;
        null !== i && (e.$slidesCache = e.$slides,
        e.unload(),
        e.$slideTrack.children(this.options.slide).detach(),
        e.$slidesCache.filter(i).appendTo(e.$slideTrack),
        e.reinit())
    }
    ,
    e.prototype.focusHandler = function() {
        var e = this;
        e.$slider.off("focus.slick blur.slick").on("focus.slick blur.slick", "*", function(t) {
            t.stopImmediatePropagation();
            var o = i(this);
            setTimeout(function() {
                e.options.pauseOnFocus && (e.focussed = o.is(":focus"),
                e.autoPlay())
            }, 0)
        })
    }
    ,
    e.prototype.getCurrent = e.prototype.slickCurrentSlide = function() {
        return this.currentSlide
    }
    ,
    e.prototype.getDotCount = function() {
        var i = this
          , e = 0
          , t = 0
          , o = 0;
        if (!0 === i.options.infinite)
            if (i.slideCount <= i.options.slidesToShow)
                ++o;
            else
                for (; e < i.slideCount; )
                    ++o,
                    e = t + i.options.slidesToScroll,
                    t += i.options.slidesToScroll <= i.options.slidesToShow ? i.options.slidesToScroll : i.options.slidesToShow;
        else if (!0 === i.options.centerMode)
            o = i.slideCount;
        else if (i.options.asNavFor)
            for (; e < i.slideCount; )
                ++o,
                e = t + i.options.slidesToScroll,
                t += i.options.slidesToScroll <= i.options.slidesToShow ? i.options.slidesToScroll : i.options.slidesToShow;
        else
            o = 1 + Math.ceil((i.slideCount - i.options.slidesToShow) / i.options.slidesToScroll);
        return o - 1
    }
    ,
    e.prototype.getLeft = function(i) {
        var e, t, o, s = this, n = 0;
        return s.slideOffset = 0,
        t = s.$slides.first().outerHeight(!0),
        !0 === s.options.infinite ? (s.slideCount > s.options.slidesToShow && (s.slideOffset = s.slideWidth * s.options.slidesToShow * -1,
        n = t * s.options.slidesToShow * -1),
        s.slideCount % s.options.slidesToScroll != 0 && i + s.options.slidesToScroll > s.slideCount && s.slideCount > s.options.slidesToShow && (i > s.slideCount ? (s.slideOffset = (s.options.slidesToShow - (i - s.slideCount)) * s.slideWidth * -1,
        n = (s.options.slidesToShow - (i - s.slideCount)) * t * -1) : (s.slideOffset = s.slideCount % s.options.slidesToScroll * s.slideWidth * -1,
        n = s.slideCount % s.options.slidesToScroll * t * -1))) : i + s.options.slidesToShow > s.slideCount && (s.slideOffset = (i + s.options.slidesToShow - s.slideCount) * s.slideWidth,
        n = (i + s.options.slidesToShow - s.slideCount) * t),
        s.slideCount <= s.options.slidesToShow && (s.slideOffset = 0,
        n = 0),
        !0 === s.options.centerMode && s.slideCount <= s.options.slidesToShow ? s.slideOffset = s.slideWidth * Math.floor(s.options.slidesToShow) / 2 - s.slideWidth * s.slideCount / 2 : !0 === s.options.centerMode && !0 === s.options.infinite ? s.slideOffset += s.slideWidth * Math.floor(s.options.slidesToShow / 2) - s.slideWidth : !0 === s.options.centerMode && (s.slideOffset = 0,
        s.slideOffset += s.slideWidth * Math.floor(s.options.slidesToShow / 2)),
        e = !1 === s.options.vertical ? i * s.slideWidth * -1 + s.slideOffset : i * t * -1 + n,
        !0 === s.options.variableWidth && (o = s.slideCount <= s.options.slidesToShow || !1 === s.options.infinite ? s.$slideTrack.children(".slick-slide").eq(i) : s.$slideTrack.children(".slick-slide").eq(i + s.options.slidesToShow),
        e = !0 === s.options.rtl ? o[0] ? -1 * (s.$slideTrack.width() - o[0].offsetLeft - o.width()) : 0 : o[0] ? -1 * o[0].offsetLeft : 0,
        !0 === s.options.centerMode && (o = s.slideCount <= s.options.slidesToShow || !1 === s.options.infinite ? s.$slideTrack.children(".slick-slide").eq(i) : s.$slideTrack.children(".slick-slide").eq(i + s.options.slidesToShow + 1),
        e = !0 === s.options.rtl ? o[0] ? -1 * (s.$slideTrack.width() - o[0].offsetLeft - o.width()) : 0 : o[0] ? -1 * o[0].offsetLeft : 0,
        e += (s.$list.width() - o.outerWidth()) / 2)),
        e
    }
    ,
    e.prototype.getOption = e.prototype.slickGetOption = function(i) {
        return this.options[i]
    }
    ,
    e.prototype.getNavigableIndexes = function() {
        var i, e = this, t = 0, o = 0, s = [];
        for (!1 === e.options.infinite ? i = e.slideCount : (t = -1 * e.options.slidesToScroll,
        o = -1 * e.options.slidesToScroll,
        i = 2 * e.slideCount); t < i; )
            s.push(t),
            t = o + e.options.slidesToScroll,
            o += e.options.slidesToScroll <= e.options.slidesToShow ? e.options.slidesToScroll : e.options.slidesToShow;
        return s
    }
    ,
    e.prototype.getSlick = function() {
        return this
    }
    ,
    e.prototype.getSlideCount = function() {
        var e, t, o = this;
        return t = !0 === o.options.centerMode ? o.slideWidth * Math.floor(o.options.slidesToShow / 2) : 0,
        !0 === o.options.swipeToSlide ? (o.$slideTrack.find(".slick-slide").each(function(s, n) {
            if (n.offsetLeft - t + i(n).outerWidth() / 2 > -1 * o.swipeLeft)
                return e = n,
                !1
        }),
        Math.abs(i(e).attr("data-slick-index") - o.currentSlide) || 1) : o.options.slidesToScroll
    }
    ,
    e.prototype.goTo = e.prototype.slickGoTo = function(i, e) {
        this.changeSlide({
            data: {
                message: "index",
                index: parseInt(i)
            }
        }, e)
    }
    ,
    e.prototype.init = function(e) {
        var t = this;
        i(t.$slider).hasClass("slick-initialized") || (i(t.$slider).addClass("slick-initialized"),
        t.buildRows(),
        t.buildOut(),
        t.setProps(),
        t.startLoad(),
        t.loadSlider(),
        t.initializeEvents(),
        t.updateArrows(),
        t.updateDots(),
        t.checkResponsive(!0),
        t.focusHandler()),
        e && t.$slider.trigger("init", [t]),
        !0 === t.options.accessibility && t.initADA(),
        t.options.autoplay && (t.paused = !1,
        t.autoPlay())
    }
    ,
    e.prototype.initADA = function() {
        var e = this
          , t = Math.ceil(e.slideCount / e.options.slidesToShow)
          , o = e.getNavigableIndexes().filter(function(i) {
            return i >= 0 && i < e.slideCount
        });
        e.$slides.add(e.$slideTrack.find(".slick-cloned")).attr({
            "aria-hidden": "true",
            tabindex: "-1"
        }).find("a, input, button, select").attr({
            tabindex: "-1"
        }),
        null !== e.$dots && (e.$slides.not(e.$slideTrack.find(".slick-cloned")).each(function(t) {
            var s = o.indexOf(t);
            i(this).attr({
                role: "tabpanel",
                id: "slick-slide" + e.instanceUid + t,
                tabindex: -1
            }),
            -1 !== s && i(this).attr({
                "aria-describedby": "slick-slide-control" + e.instanceUid + s
            })
        }),
        e.$dots.attr("role", "tablist").find("li").each(function(s) {
            var n = o[s];
            i(this).attr({
                role: "presentation"
            }),
            i(this).find("button").first().attr({
                role: "tab",
                id: "slick-slide-control" + e.instanceUid + s,
                "aria-controls": "slick-slide" + e.instanceUid + n,
                "aria-label": s + 1 + " of " + t,
                "aria-selected": null,
                tabindex: "-1"
            })
        }).eq(e.currentSlide).find("button").attr({
            "aria-selected": "true",
            tabindex: "0"
        }).end());
        for (var s = e.currentSlide, n = s + e.options.slidesToShow; s < n; s++)
            e.$slides.eq(s).attr("tabindex", 0);
        e.activateADA()
    }
    ,
    e.prototype.initArrowEvents = function() {
        var i = this;
        !0 === i.options.arrows && i.slideCount > i.options.slidesToShow && (i.$prevArrow.off("click.slick").on("click.slick", {
            message: "previous"
        }, i.changeSlide),
        i.$nextArrow.off("click.slick").on("click.slick", {
            message: "next"
        }, i.changeSlide),
        !0 === i.options.accessibility && (i.$prevArrow.on("keydown.slick", i.keyHandler),
        i.$nextArrow.on("keydown.slick", i.keyHandler)))
    }
    ,
    e.prototype.initDotEvents = function() {
        var e = this;
        !0 === e.options.dots && (i("li", e.$dots).on("click.slick", {
            message: "index"
        }, e.changeSlide),
        !0 === e.options.accessibility && e.$dots.on("keydown.slick", e.keyHandler)),
        !0 === e.options.dots && !0 === e.options.pauseOnDotsHover && i("li", e.$dots).on("mouseenter.slick", i.proxy(e.interrupt, e, !0)).on("mouseleave.slick", i.proxy(e.interrupt, e, !1))
    }
    ,
    e.prototype.initSlideEvents = function() {
        var e = this;
        e.options.pauseOnHover && (e.$list.on("mouseenter.slick", i.proxy(e.interrupt, e, !0)),
        e.$list.on("mouseleave.slick", i.proxy(e.interrupt, e, !1)))
    }
    ,
    e.prototype.initializeEvents = function() {
        var e = this;
        e.initArrowEvents(),
        e.initDotEvents(),
        e.initSlideEvents(),
        e.$list.on("touchstart.slick mousedown.slick", {
            action: "start"
        }, e.swipeHandler),
        e.$list.on("touchmove.slick mousemove.slick", {
            action: "move"
        }, e.swipeHandler),
        e.$list.on("touchend.slick mouseup.slick", {
            action: "end"
        }, e.swipeHandler),
        e.$list.on("touchcancel.slick mouseleave.slick", {
            action: "end"
        }, e.swipeHandler),
        e.$list.on("click.slick", e.clickHandler),
        i(document).on(e.visibilityChange, i.proxy(e.visibility, e)),
        !0 === e.options.accessibility && e.$list.on("keydown.slick", e.keyHandler),
        !0 === e.options.focusOnSelect && i(e.$slideTrack).children().on("click.slick", e.selectHandler),
        i(window).on("orientationchange.slick.slick-" + e.instanceUid, i.proxy(e.orientationChange, e)),
        i(window).on("resize.slick.slick-" + e.instanceUid, i.proxy(e.resize, e)),
        i("[draggable!=true]", e.$slideTrack).on("dragstart", e.preventDefault),
        i(window).on("load.slick.slick-" + e.instanceUid, e.setPosition),
        i(e.setPosition)
    }
    ,
    e.prototype.initUI = function() {
        var i = this;
        !0 === i.options.arrows && i.slideCount > i.options.slidesToShow && (i.$prevArrow.show(),
        i.$nextArrow.show()),
        !0 === i.options.dots && i.slideCount > i.options.slidesToShow && i.$dots.show()
    }
    ,
    e.prototype.keyHandler = function(i) {
        var e = this;
        i.target.tagName.match("TEXTAREA|INPUT|SELECT") || (37 === i.keyCode && !0 === e.options.accessibility ? e.changeSlide({
            data: {
                message: !0 === e.options.rtl ? "next" : "previous"
            }
        }) : 39 === i.keyCode && !0 === e.options.accessibility && e.changeSlide({
            data: {
                message: !0 === e.options.rtl ? "previous" : "next"
            }
        }))
    }
    ,
    e.prototype.lazyLoad = function() {
        function e(e) {
            i("img[data-lazy]", e).each(function() {
                var e = i(this)
                  , t = i(this).attr("data-lazy")
                  , o = i(this).attr("data-srcset")
                  , s = i(this).attr("data-sizes") || n.$slider.attr("data-sizes")
                  , r = document.createElement("img");
                r.onload = function() {
                    e.animate({
                        opacity: 0
                    }, 100, function() {
                        o && (e.attr("srcset", o),
                        s && e.attr("sizes", s)),
                        e.attr("src", t).animate({
                            opacity: 1
                        }, 200, function() {
                            e.removeAttr("data-lazy data-srcset data-sizes").removeClass("slick-loading")
                        }),
                        n.$slider.trigger("lazyLoaded", [n, e, t])
                    })
                }
                ,
                r.onerror = function() {
                    e.removeAttr("data-lazy").removeClass("slick-loading").addClass("slick-lazyload-error"),
                    n.$slider.trigger("lazyLoadError", [n, e, t])
                }
                ,
                r.src = t
            })
        }
        var t, o, s, n = this;
        if (!0 === n.options.centerMode ? !0 === n.options.infinite ? s = (o = n.currentSlide + (n.options.slidesToShow / 2 + 1)) + n.options.slidesToShow + 2 : (o = Math.max(0, n.currentSlide - (n.options.slidesToShow / 2 + 1)),
        s = n.options.slidesToShow / 2 + 1 + 2 + n.currentSlide) : (o = n.options.infinite ? n.options.slidesToShow + n.currentSlide : n.currentSlide,
        s = Math.ceil(o + n.options.slidesToShow),
        !0 === n.options.fade && (o > 0 && o--,
        s <= n.slideCount && s++)),
        t = n.$slider.find(".slick-slide").slice(o, s),
        "anticipated" === n.options.lazyLoad)
            for (var r = o - 1, l = s, d = n.$slider.find(".slick-slide"), a = 0; a < n.options.slidesToScroll; a++)
                r < 0 && (r = n.slideCount - 1),
                t = (t = t.add(d.eq(r))).add(d.eq(l)),
                r--,
                l++;
        e(t),
        n.slideCount <= n.options.slidesToShow ? e(n.$slider.find(".slick-slide")) : n.currentSlide >= n.slideCount - n.options.slidesToShow ? e(n.$slider.find(".slick-cloned").slice(0, n.options.slidesToShow)) : 0 === n.currentSlide && e(n.$slider.find(".slick-cloned").slice(-1 * n.options.slidesToShow))
    }
    ,
    e.prototype.loadSlider = function() {
        var i = this;
        i.setPosition(),
        i.$slideTrack.css({
            opacity: 1
        }),
        i.$slider.removeClass("slick-loading"),
        i.initUI(),
        "progressive" === i.options.lazyLoad && i.progressiveLazyLoad()
    }
    ,
    e.prototype.next = e.prototype.slickNext = function() {
        this.changeSlide({
            data: {
                message: "next"
            }
        })
    }
    ,
    e.prototype.orientationChange = function() {
        var i = this;
        i.checkResponsive(),
        i.setPosition()
    }
    ,
    e.prototype.pause = e.prototype.slickPause = function() {
        var i = this;
        i.autoPlayClear(),
        i.paused = !0
    }
    ,
    e.prototype.play = e.prototype.slickPlay = function() {
        var i = this;
        i.autoPlay(),
        i.options.autoplay = !0,
        i.paused = !1,
        i.focussed = !1,
        i.interrupted = !1
    }
    ,
    e.prototype.postSlide = function(e) {
        var t = this;
        t.unslicked || (t.$slider.trigger("afterChange", [t, e]),
        t.animating = !1,
        t.slideCount > t.options.slidesToShow && t.setPosition(),
        t.swipeLeft = null,
        t.options.autoplay && t.autoPlay(),
        !0 === t.options.accessibility && (t.initADA(),
        t.options.autoplay || i(t.$slides.get(t.currentSlide)).attr("tabindex", 0).focus()))
    }
    ,
    e.prototype.prev = e.prototype.slickPrev = function() {
        this.changeSlide({
            data: {
                message: "previous"
            }
        })
    }
    ,
    e.prototype.preventDefault = function(i) {
        i.preventDefault()
    }
    ,
    e.prototype.progressiveLazyLoad = function(e) {
        e = e || 1;
        var t, o, s, n, r, l = this, d = i("img[data-lazy]", l.$slider);
        d.length ? (t = d.first(),
        o = t.attr("data-lazy"),
        s = t.attr("data-srcset"),
        n = t.attr("data-sizes") || l.$slider.attr("data-sizes"),
        (r = document.createElement("img")).onload = function() {
            s && (t.attr("srcset", s),
            n && t.attr("sizes", n)),
            t.attr("src", o).removeAttr("data-lazy data-srcset data-sizes").removeClass("slick-loading"),
            !0 === l.options.adaptiveHeight && l.setPosition(),
            l.$slider.trigger("lazyLoaded", [l, t, o]),
            l.progressiveLazyLoad()
        }
        ,
        r.onerror = function() {
            e < 3 ? setTimeout(function() {
                l.progressiveLazyLoad(e + 1)
            }, 500) : (t.removeAttr("data-lazy").removeClass("slick-loading").addClass("slick-lazyload-error"),
            l.$slider.trigger("lazyLoadError", [l, t, o]),
            l.progressiveLazyLoad())
        }
        ,
        r.src = o) : l.$slider.trigger("allImagesLoaded", [l])
    }
    ,
    e.prototype.refresh = function(e) {
        var t, o, s = this;
        o = s.slideCount - s.options.slidesToShow,
        !s.options.infinite && s.currentSlide > o && (s.currentSlide = o),
        s.slideCount <= s.options.slidesToShow && (s.currentSlide = 0),
        t = s.currentSlide,
        s.destroy(!0),
        i.extend(s, s.initials, {
            currentSlide: t
        }),
        s.init(),
        e || s.changeSlide({
            data: {
                message: "index",
                index: t
            }
        }, !1)
    }
    ,
    e.prototype.registerBreakpoints = function() {
        var e, t, o, s = this, n = s.options.responsive || null;
        if ("array" === i.type(n) && n.length) {
            s.respondTo = s.options.respondTo || "window";
            for (e in n)
                if (o = s.breakpoints.length - 1,
                n.hasOwnProperty(e)) {
                    for (t = n[e].breakpoint; o >= 0; )
                        s.breakpoints[o] && s.breakpoints[o] === t && s.breakpoints.splice(o, 1),
                        o--;
                    s.breakpoints.push(t),
                    s.breakpointSettings[t] = n[e].settings
                }
            s.breakpoints.sort(function(i, e) {
                return s.options.mobileFirst ? i - e : e - i
            })
        }
    }
    ,
    e.prototype.reinit = function() {
        var e = this;
        e.$slides = e.$slideTrack.children(e.options.slide).addClass("slick-slide"),
        e.slideCount = e.$slides.length,
        e.currentSlide >= e.slideCount && 0 !== e.currentSlide && (e.currentSlide = e.currentSlide - e.options.slidesToScroll),
        e.slideCount <= e.options.slidesToShow && (e.currentSlide = 0),
        e.registerBreakpoints(),
        e.setProps(),
        e.setupInfinite(),
        e.buildArrows(),
        e.updateArrows(),
        e.initArrowEvents(),
        e.buildDots(),
        e.updateDots(),
        e.initDotEvents(),
        e.cleanUpSlideEvents(),
        e.initSlideEvents(),
        e.checkResponsive(!1, !0),
        !0 === e.options.focusOnSelect && i(e.$slideTrack).children().on("click.slick", e.selectHandler),
        e.setSlideClasses("number" == typeof e.currentSlide ? e.currentSlide : 0),
        e.setPosition(),
        e.focusHandler(),
        e.paused = !e.options.autoplay,
        e.autoPlay(),
        e.$slider.trigger("reInit", [e])
    }
    ,
    e.prototype.resize = function() {
        var e = this;
        i(window).width() !== e.windowWidth && (clearTimeout(e.windowDelay),
        e.windowDelay = window.setTimeout(function() {
            e.windowWidth = i(window).width(),
            e.checkResponsive(),
            e.unslicked || e.setPosition()
        }, 50))
    }
    ,
    e.prototype.removeSlide = e.prototype.slickRemove = function(i, e, t) {
        var o = this;
        if (i = "boolean" == typeof i ? !0 === (e = i) ? 0 : o.slideCount - 1 : !0 === e ? --i : i,
        o.slideCount < 1 || i < 0 || i > o.slideCount - 1)
            return !1;
        o.unload(),
        !0 === t ? o.$slideTrack.children().remove() : o.$slideTrack.children(this.options.slide).eq(i).remove(),
        o.$slides = o.$slideTrack.children(this.options.slide),
        o.$slideTrack.children(this.options.slide).detach(),
        o.$slideTrack.append(o.$slides),
        o.$slidesCache = o.$slides,
        o.reinit()
    }
    ,
    e.prototype.setCSS = function(i) {
        var e, t, o = this, s = {};
        !0 === o.options.rtl && (i = -i),
        e = "left" == o.positionProp ? Math.ceil(i) + "px" : "0px",
        t = "top" == o.positionProp ? Math.ceil(i) + "px" : "0px",
        s[o.positionProp] = i,
        !1 === o.transformsEnabled ? o.$slideTrack.css(s) : (s = {},
        !1 === o.cssTransitions ? (s[o.animType] = "translate(" + e + ", " + t + ")",
        o.$slideTrack.css(s)) : (s[o.animType] = "translate3d(" + e + ", " + t + ", 0px)",
        o.$slideTrack.css(s)))
    }
    ,
    e.prototype.setDimensions = function() {
        var i = this;
        !1 === i.options.vertical ? !0 === i.options.centerMode && i.$list.css({
            padding: "0px " + i.options.centerPadding
        }) : (i.$list.height(i.$slides.first().outerHeight(!0) * i.options.slidesToShow),
        !0 === i.options.centerMode && i.$list.css({
            padding: i.options.centerPadding + " 0px"
        })),
        i.listWidth = i.$list.width(),
        i.listHeight = i.$list.height(),
        !1 === i.options.vertical && !1 === i.options.variableWidth ? (i.slideWidth = Math.ceil(i.listWidth / i.options.slidesToShow),
        i.$slideTrack.width(Math.ceil(i.slideWidth * i.$slideTrack.children(".slick-slide").length))) : !0 === i.options.variableWidth ? i.$slideTrack.width(5e3 * i.slideCount) : (i.slideWidth = Math.ceil(i.listWidth),
        i.$slideTrack.height(Math.ceil(i.$slides.first().outerHeight(!0) * i.$slideTrack.children(".slick-slide").length)));
        var e = i.$slides.first().outerWidth(!0) - i.$slides.first().width();
        !1 === i.options.variableWidth && i.$slideTrack.children(".slick-slide").width(i.slideWidth - e)
    }
    ,
    e.prototype.setFade = function() {
        var e, t = this;
        t.$slides.each(function(o, s) {
            e = t.slideWidth * o * -1,
            !0 === t.options.rtl ? i(s).css({
                position: "relative",
                right: e,
                top: 0,
                zIndex: t.options.zIndex - 2,
                opacity: 0
            }) : i(s).css({
                position: "relative",
                left: e,
                top: 0,
                zIndex: t.options.zIndex - 2,
                opacity: 0
            })
        }),
        t.$slides.eq(t.currentSlide).css({
            zIndex: t.options.zIndex - 1,
            opacity: 1
        })
    }
    ,
    e.prototype.setHeight = function() {
        var i = this;
        if (1 === i.options.slidesToShow && !0 === i.options.adaptiveHeight && !1 === i.options.vertical) {
            var e = i.$slides.eq(i.currentSlide).outerHeight(!0);
            i.$list.css("height", e)
        }
    }
    ,
    e.prototype.setOption = e.prototype.slickSetOption = function() {
        var e, t, o, s, n, r = this, l = !1;
        if ("object" === i.type(arguments[0]) ? (o = arguments[0],
        l = arguments[1],
        n = "multiple") : "string" === i.type(arguments[0]) && (o = arguments[0],
        s = arguments[1],
        l = arguments[2],
        "responsive" === arguments[0] && "array" === i.type(arguments[1]) ? n = "responsive" : void 0 !== arguments[1] && (n = "single")),
        "single" === n)
            r.options[o] = s;
        else if ("multiple" === n)
            i.each(o, function(i, e) {
                r.options[i] = e
            });
        else if ("responsive" === n)
            for (t in s)
                if ("array" !== i.type(r.options.responsive))
                    r.options.responsive = [s[t]];
                else {
                    for (e = r.options.responsive.length - 1; e >= 0; )
                        r.options.responsive[e].breakpoint === s[t].breakpoint && r.options.responsive.splice(e, 1),
                        e--;
                    r.options.responsive.push(s[t])
                }
        l && (r.unload(),
        r.reinit())
    }
    ,
    e.prototype.setPosition = function() {
        var i = this;
        i.setDimensions(),
        i.setHeight(),
        !1 === i.options.fade ? i.setCSS(i.getLeft(i.currentSlide)) : i.setFade(),
        i.$slider.trigger("setPosition", [i])
    }
    ,
    e.prototype.setProps = function() {
        var i = this
          , e = document.body.style;
        i.positionProp = !0 === i.options.vertical ? "top" : "left",
        "top" === i.positionProp ? i.$slider.addClass("slick-vertical") : i.$slider.removeClass("slick-vertical"),
        void 0 === e.WebkitTransition && void 0 === e.MozTransition && void 0 === e.msTransition || !0 === i.options.useCSS && (i.cssTransitions = !0),
        i.options.fade && ("number" == typeof i.options.zIndex ? i.options.zIndex < 3 && (i.options.zIndex = 3) : i.options.zIndex = i.defaults.zIndex),
        void 0 !== e.OTransform && (i.animType = "OTransform",
        i.transformType = "-o-transform",
        i.transitionType = "OTransition",
        void 0 === e.perspectiveProperty && void 0 === e.webkitPerspective && (i.animType = !1)),
        void 0 !== e.MozTransform && (i.animType = "MozTransform",
        i.transformType = "-moz-transform",
        i.transitionType = "MozTransition",
        void 0 === e.perspectiveProperty && void 0 === e.MozPerspective && (i.animType = !1)),
        void 0 !== e.webkitTransform && (i.animType = "webkitTransform",
        i.transformType = "-webkit-transform",
        i.transitionType = "webkitTransition",
        void 0 === e.perspectiveProperty && void 0 === e.webkitPerspective && (i.animType = !1)),
        void 0 !== e.msTransform && (i.animType = "msTransform",
        i.transformType = "-ms-transform",
        i.transitionType = "msTransition",
        void 0 === e.msTransform && (i.animType = !1)),
        void 0 !== e.transform && !1 !== i.animType && (i.animType = "transform",
        i.transformType = "transform",
        i.transitionType = "transition"),
        i.transformsEnabled = i.options.useTransform && null !== i.animType && !1 !== i.animType
    }
    ,
    e.prototype.setSlideClasses = function(i) {
        var e, t, o, s, n = this;
        t = n.$slider.find(".slick-slide").removeClass("slick-active slick-center slick-current").attr("aria-hidden", "true"),
        n.$slides.eq(i).addClass("slick-current"),
        !0 === n.options.centerMode ? (e = Math.floor(n.options.slidesToShow / 2),
        !0 === n.options.infinite && (i >= e && i <= n.slideCount - 1 - e ? n.$slides.slice(i - e, i + e + 1).addClass("slick-active").attr("aria-hidden", "false") : (o = n.options.slidesToShow + i,
        t.slice(o - e + 1, o + e + 2).addClass("slick-active").attr("aria-hidden", "false")),
        0 === i ? t.eq(t.length - 1 - n.options.slidesToShow).addClass("slick-center") : i === n.slideCount - 1 && t.eq(n.options.slidesToShow).addClass("slick-center")),
        n.$slides.eq(i).addClass("slick-center")) : i >= 0 && i <= n.slideCount - n.options.slidesToShow ? n.$slides.slice(i, i + n.options.slidesToShow).addClass("slick-active").attr("aria-hidden", "false") : t.length <= n.options.slidesToShow ? t.addClass("slick-active").attr("aria-hidden", "false") : (s = n.slideCount % n.options.slidesToShow,
        o = !0 === n.options.infinite ? n.options.slidesToShow + i : i,
        n.options.slidesToShow == n.options.slidesToScroll && n.slideCount - i < n.options.slidesToShow ? t.slice(o - (n.options.slidesToShow - s), o + s).addClass("slick-active").attr("aria-hidden", "false") : t.slice(o, o + n.options.slidesToShow).addClass("slick-active").attr("aria-hidden", "false")),
        "ondemand" !== n.options.lazyLoad && "anticipated" !== n.options.lazyLoad || n.lazyLoad()
    }
    ,
    e.prototype.setupInfinite = function() {
        var e, t, o, s = this;
        if (!0 === s.options.fade && (s.options.centerMode = !1),
        !0 === s.options.infinite && !1 === s.options.fade && (t = null,
        s.slideCount > s.options.slidesToShow)) {
            for (o = !0 === s.options.centerMode ? s.options.slidesToShow + 1 : s.options.slidesToShow,
            e = s.slideCount; e > s.slideCount - o; e -= 1)
                t = e - 1,
                i(s.$slides[t]).clone(!0).attr("id", "").attr("data-slick-index", t - s.slideCount).prependTo(s.$slideTrack).addClass("slick-cloned");
            for (e = 0; e < o + s.slideCount; e += 1)
                t = e,
                i(s.$slides[t]).clone(!0).attr("id", "").attr("data-slick-index", t + s.slideCount).appendTo(s.$slideTrack).addClass("slick-cloned");
            s.$slideTrack.find(".slick-cloned").find("[id]").each(function() {
                i(this).attr("id", "")
            })
        }
    }
    ,
    e.prototype.interrupt = function(i) {
        var e = this;
        i || e.autoPlay(),
        e.interrupted = i
    }
    ,
    e.prototype.selectHandler = function(e) {
        var t = this
          , o = i(e.target).is(".slick-slide") ? i(e.target) : i(e.target).parents(".slick-slide")
          , s = parseInt(o.attr("data-slick-index"));
        s || (s = 0),
        t.slideCount <= t.options.slidesToShow ? t.slideHandler(s, !1, !0) : t.slideHandler(s)
    }
    ,
    e.prototype.slideHandler = function(i, e, t) {
        var o, s, n, r, l, d = null, a = this;
        if (e = e || !1,
        !(!0 === a.animating && !0 === a.options.waitForAnimate || !0 === a.options.fade && a.currentSlide === i))
            if (!1 === e && a.asNavFor(i),
            o = i,
            d = a.getLeft(o),
            r = a.getLeft(a.currentSlide),
            a.currentLeft = null === a.swipeLeft ? r : a.swipeLeft,
            !1 === a.options.infinite && !1 === a.options.centerMode && (i < 0 || i > a.getDotCount() * a.options.slidesToScroll))
                !1 === a.options.fade && (o = a.currentSlide,
                !0 !== t ? a.animateSlide(r, function() {
                    a.postSlide(o)
                }) : a.postSlide(o));
            else if (!1 === a.options.infinite && !0 === a.options.centerMode && (i < 0 || i > a.slideCount - a.options.slidesToScroll))
                !1 === a.options.fade && (o = a.currentSlide,
                !0 !== t ? a.animateSlide(r, function() {
                    a.postSlide(o)
                }) : a.postSlide(o));
            else {
                if (a.options.autoplay && clearInterval(a.autoPlayTimer),
                s = o < 0 ? a.slideCount % a.options.slidesToScroll != 0 ? a.slideCount - a.slideCount % a.options.slidesToScroll : a.slideCount + o : o >= a.slideCount ? a.slideCount % a.options.slidesToScroll != 0 ? 0 : o - a.slideCount : o,
                a.animating = !0,
                a.$slider.trigger("beforeChange", [a, a.currentSlide, s]),
                n = a.currentSlide,
                a.currentSlide = s,
                a.setSlideClasses(a.currentSlide),
                a.options.asNavFor && (l = (l = a.getNavTarget()).slick("getSlick")).slideCount <= l.options.slidesToShow && l.setSlideClasses(a.currentSlide),
                a.updateDots(),
                a.updateArrows(),
                !0 === a.options.fade)
                    return !0 !== t ? (a.fadeSlideOut(n),
                    a.fadeSlide(s, function() {
                        a.postSlide(s)
                    })) : a.postSlide(s),
                    void a.animateHeight();
                !0 !== t ? a.animateSlide(d, function() {
                    a.postSlide(s)
                }) : a.postSlide(s)
            }
    }
    ,
    e.prototype.startLoad = function() {
        var i = this;
        !0 === i.options.arrows && i.slideCount > i.options.slidesToShow && (i.$prevArrow.hide(),
        i.$nextArrow.hide()),
        !0 === i.options.dots && i.slideCount > i.options.slidesToShow && i.$dots.hide(),
        i.$slider.addClass("slick-loading")
    }
    ,
    e.prototype.swipeDirection = function() {
        var i, e, t, o, s = this;
        return i = s.touchObject.startX - s.touchObject.curX,
        e = s.touchObject.startY - s.touchObject.curY,
        t = Math.atan2(e, i),
        (o = Math.round(180 * t / Math.PI)) < 0 && (o = 360 - Math.abs(o)),
        o <= 45 && o >= 0 ? !1 === s.options.rtl ? "left" : "right" : o <= 360 && o >= 315 ? !1 === s.options.rtl ? "left" : "right" : o >= 135 && o <= 225 ? !1 === s.options.rtl ? "right" : "left" : !0 === s.options.verticalSwiping ? o >= 35 && o <= 135 ? "down" : "up" : "vertical"
    }
    ,
    e.prototype.swipeEnd = function(i) {
        var e, t, o = this;
        if (o.dragging = !1,
        o.swiping = !1,
        o.scrolling)
            return o.scrolling = !1,
            !1;
        if (o.interrupted = !1,
        o.shouldClick = !(o.touchObject.swipeLength > 10),
        void 0 === o.touchObject.curX)
            return !1;
        if (!0 === o.touchObject.edgeHit && o.$slider.trigger("edge", [o, o.swipeDirection()]),
        o.touchObject.swipeLength >= o.touchObject.minSwipe) {
            switch (t = o.swipeDirection()) {
            case "left":
            case "down":
                e = o.options.swipeToSlide ? o.checkNavigable(o.currentSlide + o.getSlideCount()) : o.currentSlide + o.getSlideCount(),
                o.currentDirection = 0;
                break;
            case "right":
            case "up":
                e = o.options.swipeToSlide ? o.checkNavigable(o.currentSlide - o.getSlideCount()) : o.currentSlide - o.getSlideCount(),
                o.currentDirection = 1
            }
            "vertical" != t && (o.slideHandler(e),
            o.touchObject = {},
            o.$slider.trigger("swipe", [o, t]))
        } else
            o.touchObject.startX !== o.touchObject.curX && (o.slideHandler(o.currentSlide),
            o.touchObject = {})
    }
    ,
    e.prototype.swipeHandler = function(i) {
        var e = this;
        if (!(!1 === e.options.swipe || "ontouchend"in document && !1 === e.options.swipe || !1 === e.options.draggable && -1 !== i.type.indexOf("mouse")))
            switch (e.touchObject.fingerCount = i.originalEvent && void 0 !== i.originalEvent.touches ? i.originalEvent.touches.length : 1,
            e.touchObject.minSwipe = e.listWidth / e.options.touchThreshold,
            !0 === e.options.verticalSwiping && (e.touchObject.minSwipe = e.listHeight / e.options.touchThreshold),
            i.data.action) {
            case "start":
                e.swipeStart(i);
                break;
            case "move":
                e.swipeMove(i);
                break;
            case "end":
                e.swipeEnd(i)
            }
    }
    ,
    e.prototype.swipeMove = function(i) {
        var e, t, o, s, n, r, l = this;
        return n = void 0 !== i.originalEvent ? i.originalEvent.touches : null,
        !(!l.dragging || l.scrolling || n && 1 !== n.length) && (e = l.getLeft(l.currentSlide),
        l.touchObject.curX = void 0 !== n ? n[0].pageX : i.clientX,
        l.touchObject.curY = void 0 !== n ? n[0].pageY : i.clientY,
        l.touchObject.swipeLength = Math.round(Math.sqrt(Math.pow(l.touchObject.curX - l.touchObject.startX, 2))),
        r = Math.round(Math.sqrt(Math.pow(l.touchObject.curY - l.touchObject.startY, 2))),
        !l.options.verticalSwiping && !l.swiping && r > 4 ? (l.scrolling = !0,
        !1) : (!0 === l.options.verticalSwiping && (l.touchObject.swipeLength = r),
        t = l.swipeDirection(),
        void 0 !== i.originalEvent && l.touchObject.swipeLength > 4 && (l.swiping = !0,
        i.preventDefault()),
        s = (!1 === l.options.rtl ? 1 : -1) * (l.touchObject.curX > l.touchObject.startX ? 1 : -1),
        !0 === l.options.verticalSwiping && (s = l.touchObject.curY > l.touchObject.startY ? 1 : -1),
        o = l.touchObject.swipeLength,
        l.touchObject.edgeHit = !1,
        !1 === l.options.infinite && (0 === l.currentSlide && "right" === t || l.currentSlide >= l.getDotCount() && "left" === t) && (o = l.touchObject.swipeLength * l.options.edgeFriction,
        l.touchObject.edgeHit = !0),
        !1 === l.options.vertical ? l.swipeLeft = e + o * s : l.swipeLeft = e + o * (l.$list.height() / l.listWidth) * s,
        !0 === l.options.verticalSwiping && (l.swipeLeft = e + o * s),
        !0 !== l.options.fade && !1 !== l.options.touchMove && (!0 === l.animating ? (l.swipeLeft = null,
        !1) : void l.setCSS(l.swipeLeft))))
    }
    ,
    e.prototype.swipeStart = function(i) {
        var e, t = this;
        if (t.interrupted = !0,
        1 !== t.touchObject.fingerCount || t.slideCount <= t.options.slidesToShow)
            return t.touchObject = {},
            !1;
        void 0 !== i.originalEvent && void 0 !== i.originalEvent.touches && (e = i.originalEvent.touches[0]),
        t.touchObject.startX = t.touchObject.curX = void 0 !== e ? e.pageX : i.clientX,
        t.touchObject.startY = t.touchObject.curY = void 0 !== e ? e.pageY : i.clientY,
        t.dragging = !0
    }
    ,
    e.prototype.unfilterSlides = e.prototype.slickUnfilter = function() {
        var i = this;
        null !== i.$slidesCache && (i.unload(),
        i.$slideTrack.children(this.options.slide).detach(),
        i.$slidesCache.appendTo(i.$slideTrack),
        i.reinit())
    }
    ,
    e.prototype.unload = function() {
        var e = this;
        i(".slick-cloned", e.$slider).remove(),
        e.$dots && e.$dots.remove(),
        e.$prevArrow && e.htmlExpr.test(e.options.prevArrow) && e.$prevArrow.remove(),
        e.$nextArrow && e.htmlExpr.test(e.options.nextArrow) && e.$nextArrow.remove(),
        e.$slides.removeClass("slick-slide slick-active slick-visible slick-current").attr("aria-hidden", "true").css("width", "")
    }
    ,
    e.prototype.unslick = function(i) {
        var e = this;
        e.$slider.trigger("unslick", [e, i]),
        e.destroy()
    }
    ,
    e.prototype.updateArrows = function() {
        var i = this;
        Math.floor(i.options.slidesToShow / 2),
        !0 === i.options.arrows && i.slideCount > i.options.slidesToShow && !i.options.infinite && (i.$prevArrow.removeClass("slick-disabled").attr("aria-disabled", "false"),
        i.$nextArrow.removeClass("slick-disabled").attr("aria-disabled", "false"),
        0 === i.currentSlide ? (i.$prevArrow.addClass("slick-disabled").attr("aria-disabled", "true"),
        i.$nextArrow.removeClass("slick-disabled").attr("aria-disabled", "false")) : i.currentSlide >= i.slideCount - i.options.slidesToShow && !1 === i.options.centerMode ? (i.$nextArrow.addClass("slick-disabled").attr("aria-disabled", "true"),
        i.$prevArrow.removeClass("slick-disabled").attr("aria-disabled", "false")) : i.currentSlide >= i.slideCount - 1 && !0 === i.options.centerMode && (i.$nextArrow.addClass("slick-disabled").attr("aria-disabled", "true"),
        i.$prevArrow.removeClass("slick-disabled").attr("aria-disabled", "false")))
    }
    ,
    e.prototype.updateDots = function() {
        var i = this;
        null !== i.$dots && (i.$dots.find("li").removeClass("slick-active").end(),
        i.$dots.find("li").eq(Math.floor(i.currentSlide / i.options.slidesToScroll)).addClass("slick-active"))
    }
    ,
    e.prototype.visibility = function() {
        var i = this;
        i.options.autoplay && (document[i.hidden] ? i.interrupted = !0 : i.interrupted = !1)
    }
    ,
    i.fn.slick = function() {
        var i, t, o = this, s = arguments[0], n = Array.prototype.slice.call(arguments, 1), r = o.length;
        for (i = 0; i < r; i++)
            if ("object" == typeof s || void 0 === s ? o[i].slick = new e(o[i],s) : t = o[i].slick[s].apply(o[i].slick, n),
            void 0 !== t)
                return t;
        return o
    }
});

/*rtl:end:ignore*/

/*! Select2 4.0.4 | https://github.com/select2/select2/blob/master/LICENSE.md */
!function(a) {
    "function" == typeof define && define.amd ? define(["jquery"], a) : "object" == typeof module && module.exports ? module.exports = function(b, c) {
        return void 0 === c && (c = "undefined" != typeof window ? require("jquery") : require("jquery")(b)),
        a(c),
        c
    }
    : a(jQuery)
}(function(a) {
    var b = function() {
        if (a && a.fn && a.fn.select2 && a.fn.select2.amd)
            var b = a.fn.select2.amd;
        var b;
        return function() {
            if (!b || !b.requirejs) {
                b ? c = b : b = {};
                var a, c, d;
                !function(b) {
                    function e(a, b) {
                        return v.call(a, b)
                    }
                    function f(a, b) {
                        var c, d, e, f, g, h, i, j, k, l, m, n, o = b && b.split("/"), p = t.map, q = p && p["*"] || {};
                        if (a) {
                            for (a = a.split("/"),
                            g = a.length - 1,
                            t.nodeIdCompat && x.test(a[g]) && (a[g] = a[g].replace(x, "")),
                            "." === a[0].charAt(0) && o && (n = o.slice(0, o.length - 1),
                            a = n.concat(a)),
                            k = 0; k < a.length; k++)
                                if ("." === (m = a[k]))
                                    a.splice(k, 1),
                                    k -= 1;
                                else if (".." === m) {
                                    if (0 === k || 1 === k && ".." === a[2] || ".." === a[k - 1])
                                        continue;
                                    k > 0 && (a.splice(k - 1, 2),
                                    k -= 2)
                                }
                            a = a.join("/")
                        }
                        if ((o || q) && p) {
                            for (c = a.split("/"),
                            k = c.length; k > 0; k -= 1) {
                                if (d = c.slice(0, k).join("/"),
                                o)
                                    for (l = o.length; l > 0; l -= 1)
                                        if ((e = p[o.slice(0, l).join("/")]) && (e = e[d])) {
                                            f = e,
                                            h = k;
                                            break
                                        }
                                if (f)
                                    break;
                                !i && q && q[d] && (i = q[d],
                                j = k)
                            }
                            !f && i && (f = i,
                            h = j),
                            f && (c.splice(0, h, f),
                            a = c.join("/"))
                        }
                        return a
                    }
                    function g(a, c) {
                        return function() {
                            var d = w.call(arguments, 0);
                            return "string" != typeof d[0] && 1 === d.length && d.push(null),
                            o.apply(b, d.concat([a, c]))
                        }
                    }
                    function h(a) {
                        return function(b) {
                            return f(b, a)
                        }
                    }
                    function i(a) {
                        return function(b) {
                            r[a] = b
                        }
                    }
                    function j(a) {
                        if (e(s, a)) {
                            var c = s[a];
                            delete s[a],
                            u[a] = !0,
                            n.apply(b, c)
                        }
                        if (!e(r, a) && !e(u, a))
                            throw new Error("No " + a);
                        return r[a]
                    }
                    function k(a) {
                        var b, c = a ? a.indexOf("!") : -1;
                        return c > -1 && (b = a.substring(0, c),
                        a = a.substring(c + 1, a.length)),
                        [b, a]
                    }
                    function l(a) {
                        return a ? k(a) : []
                    }
                    function m(a) {
                        return function() {
                            return t && t.config && t.config[a] || {}
                        }
                    }
                    var n, o, p, q, r = {}, s = {}, t = {}, u = {}, v = Object.prototype.hasOwnProperty, w = [].slice, x = /\.js$/;
                    p = function(a, b) {
                        var c, d = k(a), e = d[0], g = b[1];
                        return a = d[1],
                        e && (e = f(e, g),
                        c = j(e)),
                        e ? a = c && c.normalize ? c.normalize(a, h(g)) : f(a, g) : (a = f(a, g),
                        d = k(a),
                        e = d[0],
                        a = d[1],
                        e && (c = j(e))),
                        {
                            f: e ? e + "!" + a : a,
                            n: a,
                            pr: e,
                            p: c
                        }
                    }
                    ,
                    q = {
                        require: function(a) {
                            return g(a)
                        },
                        exports: function(a) {
                            var b = r[a];
                            return void 0 !== b ? b : r[a] = {}
                        },
                        module: function(a) {
                            return {
                                id: a,
                                uri: "",
                                exports: r[a],
                                config: m(a)
                            }
                        }
                    },
                    n = function(a, c, d, f) {
                        var h, k, m, n, o, t, v, w = [], x = typeof d;
                        if (f = f || a,
                        t = l(f),
                        "undefined" === x || "function" === x) {
                            for (c = !c.length && d.length ? ["require", "exports", "module"] : c,
                            o = 0; o < c.length; o += 1)
                                if (n = p(c[o], t),
                                "require" === (k = n.f))
                                    w[o] = q.require(a);
                                else if ("exports" === k)
                                    w[o] = q.exports(a),
                                    v = !0;
                                else if ("module" === k)
                                    h = w[o] = q.module(a);
                                else if (e(r, k) || e(s, k) || e(u, k))
                                    w[o] = j(k);
                                else {
                                    if (!n.p)
                                        throw new Error(a + " missing " + k);
                                    n.p.load(n.n, g(f, !0), i(k), {}),
                                    w[o] = r[k]
                                }
                            m = d ? d.apply(r[a], w) : void 0,
                            a && (h && h.exports !== b && h.exports !== r[a] ? r[a] = h.exports : m === b && v || (r[a] = m))
                        } else
                            a && (r[a] = d)
                    }
                    ,
                    a = c = o = function(a, c, d, e, f) {
                        if ("string" == typeof a)
                            return q[a] ? q[a](c) : j(p(a, l(c)).f);
                        if (!a.splice) {
                            if (t = a,
                            t.deps && o(t.deps, t.callback),
                            !c)
                                return;
                            c.splice ? (a = c,
                            c = d,
                            d = null) : a = b
                        }
                        return c = c || function() {}
                        ,
                        "function" == typeof d && (d = e,
                        e = f),
                        e ? n(b, a, c, d) : setTimeout(function() {
                            n(b, a, c, d)
                        }, 4),
                        o
                    }
                    ,
                    o.config = function(a) {
                        return o(a)
                    }
                    ,
                    a._defined = r,
                    d = function(a, b, c) {
                        if ("string" != typeof a)
                            throw new Error("See almond README: incorrect module build, no module name");
                        b.splice || (c = b,
                        b = []),
                        e(r, a) || e(s, a) || (s[a] = [a, b, c])
                    }
                    ,
                    d.amd = {
                        jQuery: !0
                    }
                }(),
                b.requirejs = a,
                b.require = c,
                b.define = d
            }
        }(),
        b.define("almond", function() {}),
        b.define("jquery", [], function() {
            var b = a || $;
            return null == b && console && console.error && console.error("Select2: An instance of jQuery or a jQuery-compatible library was not found. Make sure that you are including jQuery before Select2 on your web page."),
            b
        }),
        b.define("select2/utils", ["jquery"], function(a) {
            function b(a) {
                var b = a.prototype
                  , c = [];
                for (var d in b) {
                    "function" == typeof b[d] && ("constructor" !== d && c.push(d))
                }
                return c
            }
            var c = {};
            c.Extend = function(a, b) {
                function c() {
                    this.constructor = a
                }
                var d = {}.hasOwnProperty;
                for (var e in b)
                    d.call(b, e) && (a[e] = b[e]);
                return c.prototype = b.prototype,
                a.prototype = new c,
                a.__super__ = b.prototype,
                a
            }
            ,
            c.Decorate = function(a, c) {
                function d() {
                    var b = Array.prototype.unshift
                      , d = c.prototype.constructor.length
                      , e = a.prototype.constructor;
                    d > 0 && (b.call(arguments, a.prototype.constructor),
                    e = c.prototype.constructor),
                    e.apply(this, arguments)
                }
                function e() {
                    this.constructor = d
                }
                var f = b(c)
                  , g = b(a);
                c.displayName = a.displayName,
                d.prototype = new e;
                for (var h = 0; h < g.length; h++) {
                    var i = g[h];
                    d.prototype[i] = a.prototype[i]
                }
                for (var j = (function(a) {
                    var b = function() {};
                    a in d.prototype && (b = d.prototype[a]);
                    var e = c.prototype[a];
                    return function() {
                        return Array.prototype.unshift.call(arguments, b),
                        e.apply(this, arguments)
                    }
                }
                ), k = 0; k < f.length; k++) {
                    var l = f[k];
                    d.prototype[l] = j(l)
                }
                return d
            }
            ;
            var d = function() {
                this.listeners = {}
            };
            return d.prototype.on = function(a, b) {
                this.listeners = this.listeners || {},
                a in this.listeners ? this.listeners[a].push(b) : this.listeners[a] = [b]
            }
            ,
            d.prototype.trigger = function(a) {
                var b = Array.prototype.slice
                  , c = b.call(arguments, 1);
                this.listeners = this.listeners || {},
                null == c && (c = []),
                0 === c.length && c.push({}),
                c[0]._type = a,
                a in this.listeners && this.invoke(this.listeners[a], b.call(arguments, 1)),
                "*"in this.listeners && this.invoke(this.listeners["*"], arguments)
            }
            ,
            d.prototype.invoke = function(a, b) {
                for (var c = 0, d = a.length; c < d; c++)
                    a[c].apply(this, b)
            }
            ,
            c.Observable = d,
            c.generateChars = function(a) {
                for (var b = "", c = 0; c < a; c++) {
                    b += Math.floor(36 * Math.random()).toString(36)
                }
                return b
            }
            ,
            c.bind = function(a, b) {
                return function() {
                    a.apply(b, arguments)
                }
            }
            ,
            c._convertData = function(a) {
                for (var b in a) {
                    var c = b.split("-")
                      , d = a;
                    if (1 !== c.length) {
                        for (var e = 0; e < c.length; e++) {
                            var f = c[e];
                            f = f.substring(0, 1).toLowerCase() + f.substring(1),
                            f in d || (d[f] = {}),
                            e == c.length - 1 && (d[f] = a[b]),
                            d = d[f]
                        }
                        delete a[b]
                    }
                }
                return a
            }
            ,
            c.hasScroll = function(b, c) {
                var d = a(c)
                  , e = c.style.overflowX
                  , f = c.style.overflowY;
                return (e !== f || "hidden" !== f && "visible" !== f) && ("scroll" === e || "scroll" === f || (d.innerHeight() < c.scrollHeight || d.innerWidth() < c.scrollWidth))
            }
            ,
            c.escapeMarkup = function(a) {
                var b = {
                    "\\": "&#92;",
                    "&": "&amp;",
                    "<": "&lt;",
                    ">": "&gt;",
                    '"': "&quot;",
                    "'": "&#39;",
                    "/": "&#47;"
                };
                return "string" != typeof a ? a : String(a).replace(/[&<>"'\/\\]/g, function(a) {
                    return b[a]
                })
            }
            ,
            c.appendMany = function(b, c) {
                if ("1.7" === a.fn.jquery.substr(0, 3)) {
                    var d = a();
                    a.map(c, function(a) {
                        d = d.add(a)
                    }),
                    c = d
                }
                b.append(c)
            }
            ,
            c
        }),
        b.define("select2/results", ["jquery", "./utils"], function(a, b) {
            function c(a, b, d) {
                this.$element = a,
                this.data = d,
                this.options = b,
                c.__super__.constructor.call(this)
            }
            return b.Extend(c, b.Observable),
            c.prototype.render = function() {
                var b = a('<ul class="select2-results__options" role="tree"></ul>');
                return this.options.get("multiple") && b.attr("aria-multiselectable", "true"),
                this.$results = b,
                b
            }
            ,
            c.prototype.clear = function() {
                this.$results.empty()
            }
            ,
            c.prototype.displayMessage = function(b) {
                var c = this.options.get("escapeMarkup");
                this.clear(),
                this.hideLoading();
                var d = a('<li role="treeitem" aria-live="assertive" class="select2-results__option"></li>')
                  , e = this.options.get("translations").get(b.message);
                d.append(c(e(b.args))),
                d[0].className += " select2-results__message",
                this.$results.append(d)
            }
            ,
            c.prototype.hideMessages = function() {
                this.$results.find(".select2-results__message").remove()
            }
            ,
            c.prototype.append = function(a) {
                this.hideLoading();
                var b = [];
                if (null == a.results || 0 === a.results.length)
                    return void (0 === this.$results.children().length && this.trigger("results:message", {
                        message: "noResults"
                    }));
                a.results = this.sort(a.results);
                for (var c = 0; c < a.results.length; c++) {
                    var d = a.results[c]
                      , e = this.option(d);
                    b.push(e)
                }
                this.$results.append(b)
            }
            ,
            c.prototype.position = function(a, b) {
                b.find(".select2-results").append(a)
            }
            ,
            c.prototype.sort = function(a) {
                return this.options.get("sorter")(a)
            }
            ,
            c.prototype.highlightFirstItem = function() {
                var a = this.$results.find(".select2-results__option[aria-selected]")
                  , b = a.filter("[aria-selected=true]");
                b.length > 0 ? b.first().trigger("mouseenter") : a.first().trigger("mouseenter"),
                this.ensureHighlightVisible()
            }
            ,
            c.prototype.setClasses = function() {
                var b = this;
                this.data.current(function(c) {
                    var d = a.map(c, function(a) {
                        return a.id.toString()
                    });
                    b.$results.find(".select2-results__option[aria-selected]").each(function() {
                        var b = a(this)
                          , c = a.data(this, "data")
                          , e = "" + c.id;
                        null != c.element && c.element.selected || null == c.element && a.inArray(e, d) > -1 ? b.attr("aria-selected", "true") : b.attr("aria-selected", "false")
                    })
                })
            }
            ,
            c.prototype.showLoading = function(a) {
                this.hideLoading();
                var b = this.options.get("translations").get("searching")
                  , c = {
                    disabled: !0,
                    loading: !0,
                    text: b(a)
                }
                  , d = this.option(c);
                d.className += " loading-results",
                this.$results.prepend(d)
            }
            ,
            c.prototype.hideLoading = function() {
                this.$results.find(".loading-results").remove()
            }
            ,
            c.prototype.option = function(b) {
                var c = document.createElement("li");
                c.className = "select2-results__option";
                var d = {
                    role: "treeitem",
                    "aria-selected": "false"
                };
                b.disabled && (delete d["aria-selected"],
                d["aria-disabled"] = "true"),
                null == b.id && delete d["aria-selected"],
                null != b._resultId && (c.id = b._resultId),
                b.title && (c.title = b.title),
                b.children && (d.role = "group",
                d["aria-label"] = b.text,
                delete d["aria-selected"]);
                for (var e in d) {
                    var f = d[e];
                    c.setAttribute(e, f)
                }
                if (b.children) {
                    var g = a(c)
                      , h = document.createElement("strong");
                    h.className = "select2-results__group";
                    a(h);
                    this.template(b, h);
                    for (var i = [], j = 0; j < b.children.length; j++) {
                        var k = b.children[j]
                          , l = this.option(k);
                        i.push(l)
                    }
                    var m = a("<ul></ul>", {
                        class: "select2-results__options select2-results__options--nested"
                    });
                    m.append(i),
                    g.append(h),
                    g.append(m)
                } else
                    this.template(b, c);
                return a.data(c, "data", b),
                c
            }
            ,
            c.prototype.bind = function(b, c) {
                var d = this
                  , e = b.id + "-results";
                this.$results.attr("id", e),
                b.on("results:all", function(a) {
                    d.clear(),
                    d.append(a.data),
                    b.isOpen() && (d.setClasses(),
                    d.highlightFirstItem())
                }),
                b.on("results:append", function(a) {
                    d.append(a.data),
                    b.isOpen() && d.setClasses()
                }),
                b.on("query", function(a) {
                    d.hideMessages(),
                    d.showLoading(a)
                }),
                b.on("select", function() {
                    b.isOpen() && (d.setClasses(),
                    d.highlightFirstItem())
                }),
                b.on("unselect", function() {
                    b.isOpen() && (d.setClasses(),
                    d.highlightFirstItem())
                }),
                b.on("open", function() {
                    d.$results.attr("aria-expanded", "true"),
                    d.$results.attr("aria-hidden", "false"),
                    d.setClasses(),
                    d.ensureHighlightVisible()
                }),
                b.on("close", function() {
                    d.$results.attr("aria-expanded", "false"),
                    d.$results.attr("aria-hidden", "true"),
                    d.$results.removeAttr("aria-activedescendant")
                }),
                b.on("results:toggle", function() {
                    var a = d.getHighlightedResults();
                    0 !== a.length && a.trigger("mouseup")
                }),
                b.on("results:select", function() {
                    var a = d.getHighlightedResults();
                    if (0 !== a.length) {
                        var b = a.data("data");
                        "true" == a.attr("aria-selected") ? d.trigger("close", {}) : d.trigger("select", {
                            data: b
                        })
                    }
                }),
                b.on("results:previous", function() {
                    var a = d.getHighlightedResults()
                      , b = d.$results.find("[aria-selected]")
                      , c = b.index(a);
                    if (0 !== c) {
                        var e = c - 1;
                        0 === a.length && (e = 0);
                        var f = b.eq(e);
                        f.trigger("mouseenter");
                        var g = d.$results.offset().top
                          , h = f.offset().top
                          , i = d.$results.scrollTop() + (h - g);
                        0 === e ? d.$results.scrollTop(0) : h - g < 0 && d.$results.scrollTop(i)
                    }
                }),
                b.on("results:next", function() {
                    var a = d.getHighlightedResults()
                      , b = d.$results.find("[aria-selected]")
                      , c = b.index(a)
                      , e = c + 1;
                    if (!(e >= b.length)) {
                        var f = b.eq(e);
                        f.trigger("mouseenter");
                        var g = d.$results.offset().top + d.$results.outerHeight(!1)
                          , h = f.offset().top + f.outerHeight(!1)
                          , i = d.$results.scrollTop() + h - g;
                        0 === e ? d.$results.scrollTop(0) : h > g && d.$results.scrollTop(i)
                    }
                }),
                b.on("results:focus", function(a) {
                    a.element.addClass("select2-results__option--highlighted")
                }),
                b.on("results:message", function(a) {
                    d.displayMessage(a)
                }),
                a.fn.mousewheel && this.$results.on("mousewheel", function(a) {
                    var b = d.$results.scrollTop()
                      , c = d.$results.get(0).scrollHeight - b + a.deltaY
                      , e = a.deltaY > 0 && b - a.deltaY <= 0
                      , f = a.deltaY < 0 && c <= d.$results.height();
                    e ? (d.$results.scrollTop(0),
                    a.preventDefault(),
                    a.stopPropagation()) : f && (d.$results.scrollTop(d.$results.get(0).scrollHeight - d.$results.height()),
                    a.preventDefault(),
                    a.stopPropagation())
                }),
                this.$results.on("mouseup", ".select2-results__option[aria-selected]", function(b) {
                    var c = a(this)
                      , e = c.data("data");
                    if ("true" === c.attr("aria-selected"))
                        return void (d.options.get("multiple") ? d.trigger("unselect", {
                            originalEvent: b,
                            data: e
                        }) : d.trigger("close", {}));
                    d.trigger("select", {
                        originalEvent: b,
                        data: e
                    })
                }),
                this.$results.on("mouseenter", ".select2-results__option[aria-selected]", function(b) {
                    var c = a(this).data("data");
                    d.getHighlightedResults().removeClass("select2-results__option--highlighted"),
                    d.trigger("results:focus", {
                        data: c,
                        element: a(this)
                    })
                })
            }
            ,
            c.prototype.getHighlightedResults = function() {
                return this.$results.find(".select2-results__option--highlighted")
            }
            ,
            c.prototype.destroy = function() {
                this.$results.remove()
            }
            ,
            c.prototype.ensureHighlightVisible = function() {
                var a = this.getHighlightedResults();
                if (0 !== a.length) {
                    var b = this.$results.find("[aria-selected]")
                      , c = b.index(a)
                      , d = this.$results.offset().top
                      , e = a.offset().top
                      , f = this.$results.scrollTop() + (e - d)
                      , g = e - d;
                    f -= 2 * a.outerHeight(!1),
                    c <= 2 ? this.$results.scrollTop(0) : (g > this.$results.outerHeight() || g < 0) && this.$results.scrollTop(f)
                }
            }
            ,
            c.prototype.template = function(b, c) {
                var d = this.options.get("templateResult")
                  , e = this.options.get("escapeMarkup")
                  , f = d(b, c);
                null == f ? c.style.display = "none" : "string" == typeof f ? c.innerHTML = e(f) : a(c).append(f)
            }
            ,
            c
        }),
        b.define("select2/keys", [], function() {
            return {
                BACKSPACE: 8,
                TAB: 9,
                ENTER: 13,
                SHIFT: 16,
                CTRL: 17,
                ALT: 18,
                ESC: 27,
                SPACE: 32,
                PAGE_UP: 33,
                PAGE_DOWN: 34,
                END: 35,
                HOME: 36,
                LEFT: 37,
                UP: 38,
                RIGHT: 39,
                DOWN: 40,
                DELETE: 46
            }
        }),
        b.define("select2/selection/base", ["jquery", "../utils", "../keys"], function(a, b, c) {
            function d(a, b) {
                this.$element = a,
                this.options = b,
                d.__super__.constructor.call(this)
            }
            return b.Extend(d, b.Observable),
            d.prototype.render = function() {
                var b = a('<span class="select2-selection" role="combobox"  aria-haspopup="true" aria-expanded="false"></span>');
                return this._tabindex = 0,
                null != this.$element.data("old-tabindex") ? this._tabindex = this.$element.data("old-tabindex") : null != this.$element.attr("tabindex") && (this._tabindex = this.$element.attr("tabindex")),
                b.attr("title", this.$element.attr("title")),
                b.attr("tabindex", this._tabindex),
                this.$selection = b,
                b
            }
            ,
            d.prototype.bind = function(a, b) {
                var d = this
                  , e = (a.id,
                a.id + "-results");
                this.container = a,
                this.$selection.on("focus", function(a) {
                    d.trigger("focus", a)
                }),
                this.$selection.on("blur", function(a) {
                    d._handleBlur(a)
                }),
                this.$selection.on("keydown", function(a) {
                    d.trigger("keypress", a),
                    a.which === c.SPACE && a.preventDefault()
                }),
                a.on("results:focus", function(a) {
                    d.$selection.attr("aria-activedescendant", a.data._resultId)
                }),
                a.on("selection:update", function(a) {
                    d.update(a.data)
                }),
                a.on("open", function() {
                    d.$selection.attr("aria-expanded", "true"),
                    d.$selection.attr("aria-owns", e),
                    d._attachCloseHandler(a)
                }),
                a.on("close", function() {
                    d.$selection.attr("aria-expanded", "false"),
                    d.$selection.removeAttr("aria-activedescendant"),
                    d.$selection.removeAttr("aria-owns"),
                    d.$selection.focus(),
                    d._detachCloseHandler(a)
                }),
                a.on("enable", function() {
                    d.$selection.attr("tabindex", d._tabindex)
                }),
                a.on("disable", function() {
                    d.$selection.attr("tabindex", "-1")
                })
            }
            ,
            d.prototype._handleBlur = function(b) {
                var c = this;
                window.setTimeout(function() {
                    document.activeElement == c.$selection[0] || a.contains(c.$selection[0], document.activeElement) || c.trigger("blur", b)
                }, 1)
            }
            ,
            d.prototype._attachCloseHandler = function(b) {
                a(document.body).on("mousedown.select2." + b.id, function(b) {
                    var c = a(b.target)
                      , d = c.closest(".select2");
                    a(".select2.select2-container--open").each(function() {
                        var b = a(this);
                        this != d[0] && b.data("element").select2("close")
                    })
                })
            }
            ,
            d.prototype._detachCloseHandler = function(b) {
                a(document.body).off("mousedown.select2." + b.id)
            }
            ,
            d.prototype.position = function(a, b) {
                b.find(".selection").append(a)
            }
            ,
            d.prototype.destroy = function() {
                this._detachCloseHandler(this.container)
            }
            ,
            d.prototype.update = function(a) {
                throw new Error("The `update` method must be defined in child classes.")
            }
            ,
            d
        }),
        b.define("select2/selection/single", ["jquery", "./base", "../utils", "../keys"], function(a, b, c, d) {
            function e() {
                e.__super__.constructor.apply(this, arguments)
            }
            return c.Extend(e, b),
            e.prototype.render = function() {
                var a = e.__super__.render.call(this);
                return a.addClass("select2-selection--single"),
                a.html('<span class="select2-selection__rendered"></span><span class="select2-selection__arrow" role="presentation"><b role="presentation"></b></span>'),
                a
            }
            ,
            e.prototype.bind = function(a, b) {
                var c = this;
                e.__super__.bind.apply(this, arguments);
                var d = a.id + "-container";
                this.$selection.find(".select2-selection__rendered").attr("id", d),
                this.$selection.attr("aria-labelledby", d),
                this.$selection.on("mousedown", function(a) {
                    1 === a.which && c.trigger("toggle", {
                        originalEvent: a
                    })
                }),
                this.$selection.on("focus", function(a) {}),
                this.$selection.on("blur", function(a) {}),
                a.on("focus", function(b) {
                    a.isOpen() || c.$selection.focus()
                }),
                a.on("selection:update", function(a) {
                    c.update(a.data)
                })
            }
            ,
            e.prototype.clear = function() {
                this.$selection.find(".select2-selection__rendered").empty()
            }
            ,
            e.prototype.display = function(a, b) {
                var c = this.options.get("templateSelection");
                return this.options.get("escapeMarkup")(c(a, b))
            }
            ,
            e.prototype.selectionContainer = function() {
                return a("<span></span>")
            }
            ,
            e.prototype.update = function(a) {
                if (0 === a.length)
                    return void this.clear();
                var b = a[0]
                  , c = this.$selection.find(".select2-selection__rendered")
                  , d = this.display(b, c);
                c.empty().append(d),
                c.prop("title", b.title || b.text)
            }
            ,
            e
        }),
        b.define("select2/selection/multiple", ["jquery", "./base", "../utils"], function(a, b, c) {
            function d(a, b) {
                d.__super__.constructor.apply(this, arguments)
            }
            return c.Extend(d, b),
            d.prototype.render = function() {
                var a = d.__super__.render.call(this);
                return a.addClass("select2-selection--multiple"),
                a.html('<ul class="select2-selection__rendered"></ul>'),
                a
            }
            ,
            d.prototype.bind = function(b, c) {
                var e = this;
                d.__super__.bind.apply(this, arguments),
                this.$selection.on("click", function(a) {
                    e.trigger("toggle", {
                        originalEvent: a
                    })
                }),
                this.$selection.on("click", ".select2-selection__choice__remove", function(b) {
                    if (!e.options.get("disabled")) {
                        var c = a(this)
                          , d = c.parent()
                          , f = d.data("data");
                        e.trigger("unselect", {
                            originalEvent: b,
                            data: f
                        })
                    }
                })
            }
            ,
            d.prototype.clear = function() {
                this.$selection.find(".select2-selection__rendered").empty()
            }
            ,
            d.prototype.display = function(a, b) {
                var c = this.options.get("templateSelection");
                return this.options.get("escapeMarkup")(c(a, b))
            }
            ,
            d.prototype.selectionContainer = function() {
                return a('<li class="select2-selection__choice"><span class="select2-selection__choice__remove" role="presentation">&times;</span></li>')
            }
            ,
            d.prototype.update = function(a) {
                if (this.clear(),
                0 !== a.length) {
                    for (var b = [], d = 0; d < a.length; d++) {
                        var e = a[d]
                          , f = this.selectionContainer()
                          , g = this.display(e, f);
                        f.append(g),
                        f.prop("title", e.title || e.text),
                        f.data("data", e),
                        b.push(f)
                    }
                    var h = this.$selection.find(".select2-selection__rendered");
                    c.appendMany(h, b)
                }
            }
            ,
            d
        }),
        b.define("select2/selection/placeholder", ["../utils"], function(a) {
            function b(a, b, c) {
                this.placeholder = this.normalizePlaceholder(c.get("placeholder")),
                a.call(this, b, c)
            }
            return b.prototype.normalizePlaceholder = function(a, b) {
                return "string" == typeof b && (b = {
                    id: "",
                    text: b
                }),
                b
            }
            ,
            b.prototype.createPlaceholder = function(a, b) {
                var c = this.selectionContainer();
                return c.html(this.display(b)),
                c.addClass("select2-selection__placeholder").removeClass("select2-selection__choice"),
                c
            }
            ,
            b.prototype.update = function(a, b) {
                var c = 1 == b.length && b[0].id != this.placeholder.id;
                if (b.length > 1 || c)
                    return a.call(this, b);
                this.clear();
                var d = this.createPlaceholder(this.placeholder);
                this.$selection.find(".select2-selection__rendered").append(d)
            }
            ,
            b
        }),
        b.define("select2/selection/allowClear", ["jquery", "../keys"], function(a, b) {
            function c() {}
            return c.prototype.bind = function(a, b, c) {
                var d = this;
                a.call(this, b, c),
                null == this.placeholder && this.options.get("debug") && window.console && console.error && console.error("Select2: The `allowClear` option should be used in combination with the `placeholder` option."),
                this.$selection.on("mousedown", ".select2-selection__clear", function(a) {
                    d._handleClear(a)
                }),
                b.on("keypress", function(a) {
                    d._handleKeyboardClear(a, b)
                })
            }
            ,
            c.prototype._handleClear = function(a, b) {
                if (!this.options.get("disabled")) {
                    var c = this.$selection.find(".select2-selection__clear");
                    if (0 !== c.length) {
                        b.stopPropagation();
                        for (var d = c.data("data"), e = 0; e < d.length; e++) {
                            var f = {
                                data: d[e]
                            };
                            if (this.trigger("unselect", f),
                            f.prevented)
                                return
                        }
                        this.$element.val(this.placeholder.id).trigger("change"),
                        this.trigger("toggle", {})
                    }
                }
            }
            ,
            c.prototype._handleKeyboardClear = function(a, c, d) {
                d.isOpen() || c.which != b.DELETE && c.which != b.BACKSPACE || this._handleClear(c)
            }
            ,
            c.prototype.update = function(b, c) {
                if (b.call(this, c),
                !(this.$selection.find(".select2-selection__placeholder").length > 0 || 0 === c.length)) {
                    var d = a('<span class="select2-selection__clear">&times;</span>');
                    d.data("data", c),
                    this.$selection.find(".select2-selection__rendered").prepend(d)
                }
            }
            ,
            c
        }),
        b.define("select2/selection/search", ["jquery", "../utils", "../keys"], function(a, b, c) {
            function d(a, b, c) {
                a.call(this, b, c)
            }
            return d.prototype.render = function(b) {
                var c = a('<li class="select2-search select2-search--inline"><input class="select2-search__field" type="search" tabindex="-1" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" role="textbox" aria-autocomplete="list" /></li>');
                this.$searchContainer = c,
                this.$search = c.find("input");
                var d = b.call(this);
                return this._transferTabIndex(),
                d
            }
            ,
            d.prototype.bind = function(a, b, d) {
                var e = this;
                a.call(this, b, d),
                b.on("open", function() {
                    e.$search.trigger("focus")
                }),
                b.on("close", function() {
                    e.$search.val(""),
                    e.$search.removeAttr("aria-activedescendant"),
                    e.$search.trigger("focus")
                }),
                b.on("enable", function() {
                    e.$search.prop("disabled", !1),
                    e._transferTabIndex()
                }),
                b.on("disable", function() {
                    e.$search.prop("disabled", !0)
                }),
                b.on("focus", function(a) {
                    e.$search.trigger("focus")
                }),
                b.on("results:focus", function(a) {
                    e.$search.attr("aria-activedescendant", a.id)
                }),
                this.$selection.on("focusin", ".select2-search--inline", function(a) {
                    e.trigger("focus", a)
                }),
                this.$selection.on("focusout", ".select2-search--inline", function(a) {
                    e._handleBlur(a)
                }),
                this.$selection.on("keydown", ".select2-search--inline", function(a) {
                    if (a.stopPropagation(),
                    e.trigger("keypress", a),
                    e._keyUpPrevented = a.isDefaultPrevented(),
                    a.which === c.BACKSPACE && "" === e.$search.val()) {
                        var b = e.$searchContainer.prev(".select2-selection__choice");
                        if (b.length > 0) {
                            var d = b.data("data");
                            e.searchRemoveChoice(d),
                            a.preventDefault()
                        }
                    }
                });
                var f = document.documentMode
                  , g = f && f <= 11;
                this.$selection.on("input.searchcheck", ".select2-search--inline", function(a) {
                    if (g)
                        return void e.$selection.off("input.search input.searchcheck");
                    e.$selection.off("keyup.search")
                }),
                this.$selection.on("keyup.search input.search", ".select2-search--inline", function(a) {
                    if (g && "input" === a.type)
                        return void e.$selection.off("input.search input.searchcheck");
                    var b = a.which;
                    b != c.SHIFT && b != c.CTRL && b != c.ALT && b != c.TAB && e.handleSearch(a)
                })
            }
            ,
            d.prototype._transferTabIndex = function(a) {
                this.$search.attr("tabindex", this.$selection.attr("tabindex")),
                this.$selection.attr("tabindex", "-1")
            }
            ,
            d.prototype.createPlaceholder = function(a, b) {
                this.$search.attr("placeholder", b.text)
            }
            ,
            d.prototype.update = function(a, b) {
                var c = this.$search[0] == document.activeElement;
                this.$search.attr("placeholder", ""),
                a.call(this, b),
                this.$selection.find(".select2-selection__rendered").append(this.$searchContainer),
                this.resizeSearch(),
                c && this.$search.focus()
            }
            ,
            d.prototype.handleSearch = function() {
                if (this.resizeSearch(),
                !this._keyUpPrevented) {
                    var a = this.$search.val();
                    this.trigger("query", {
                        term: a
                    })
                }
                this._keyUpPrevented = !1
            }
            ,
            d.prototype.searchRemoveChoice = function(a, b) {
                this.trigger("unselect", {
                    data: b
                }),
                this.$search.val(b.text),
                this.handleSearch()
            }
            ,
            d.prototype.resizeSearch = function() {
                this.$search.css("width", "25px");
                var a = "";
                if ("" !== this.$search.attr("placeholder"))
                    a = this.$selection.find(".select2-selection__rendered").innerWidth();
                else {
                    a = .75 * (this.$search.val().length + 1) + "em"
                }
                this.$search.css("width", a)
            }
            ,
            d
        }),
        b.define("select2/selection/eventRelay", ["jquery"], function(a) {
            function b() {}
            return b.prototype.bind = function(b, c, d) {
                var e = this
                  , f = ["open", "opening", "close", "closing", "select", "selecting", "unselect", "unselecting"]
                  , g = ["opening", "closing", "selecting", "unselecting"];
                b.call(this, c, d),
                c.on("*", function(b, c) {
                    if (-1 !== a.inArray(b, f)) {
                        c = c || {};
                        var d = a.Event("select2:" + b, {
                            params: c
                        });
                        e.$element.trigger(d),
                        -1 !== a.inArray(b, g) && (c.prevented = d.isDefaultPrevented())
                    }
                })
            }
            ,
            b
        }),
        b.define("select2/translation", ["jquery", "require"], function(a, b) {
            function c(a) {
                this.dict = a || {}
            }
            return c.prototype.all = function() {
                return this.dict
            }
            ,
            c.prototype.get = function(a) {
                return this.dict[a]
            }
            ,
            c.prototype.extend = function(b) {
                this.dict = a.extend({}, b.all(), this.dict)
            }
            ,
            c._cache = {},
            c.loadPath = function(a) {
                if (!(a in c._cache)) {
                    var d = b(a);
                    c._cache[a] = d
                }
                return new c(c._cache[a])
            }
            ,
            c
        }),
        b.define("select2/diacritics", [], function() {
            return {
                "Ⓐ": "A",
                "Ａ": "A",
                "À": "A",
                "Á": "A",
                "Â": "A",
                "Ầ": "A",
                "Ấ": "A",
                "Ẫ": "A",
                "Ẩ": "A",
                "Ã": "A",
                "Ā": "A",
                "Ă": "A",
                "Ằ": "A",
                "Ắ": "A",
                "Ẵ": "A",
                "Ẳ": "A",
                "Ȧ": "A",
                "Ǡ": "A",
                "Ä": "A",
                "Ǟ": "A",
                "Ả": "A",
                "Å": "A",
                "Ǻ": "A",
                "Ǎ": "A",
                "Ȁ": "A",
                "Ȃ": "A",
                "Ạ": "A",
                "Ậ": "A",
                "Ặ": "A",
                "Ḁ": "A",
                "Ą": "A",
                "Ⱥ": "A",
                "Ɐ": "A",
                "Ꜳ": "AA",
                "Æ": "AE",
                "Ǽ": "AE",
                "Ǣ": "AE",
                "Ꜵ": "AO",
                "Ꜷ": "AU",
                "Ꜹ": "AV",
                "Ꜻ": "AV",
                "Ꜽ": "AY",
                "Ⓑ": "B",
                "Ｂ": "B",
                "Ḃ": "B",
                "Ḅ": "B",
                "Ḇ": "B",
                "Ƀ": "B",
                "Ƃ": "B",
                "Ɓ": "B",
                "Ⓒ": "C",
                "Ｃ": "C",
                "Ć": "C",
                "Ĉ": "C",
                "Ċ": "C",
                "Č": "C",
                "Ç": "C",
                "Ḉ": "C",
                "Ƈ": "C",
                "Ȼ": "C",
                "Ꜿ": "C",
                "Ⓓ": "D",
                "Ｄ": "D",
                "Ḋ": "D",
                "Ď": "D",
                "Ḍ": "D",
                "Ḑ": "D",
                "Ḓ": "D",
                "Ḏ": "D",
                "Đ": "D",
                "Ƌ": "D",
                "Ɗ": "D",
                "Ɖ": "D",
                "Ꝺ": "D",
                "Ǳ": "DZ",
                "Ǆ": "DZ",
                "ǲ": "Dz",
                "ǅ": "Dz",
                "Ⓔ": "E",
                "Ｅ": "E",
                "È": "E",
                "É": "E",
                "Ê": "E",
                "Ề": "E",
                "Ế": "E",
                "Ễ": "E",
                "Ể": "E",
                "Ẽ": "E",
                "Ē": "E",
                "Ḕ": "E",
                "Ḗ": "E",
                "Ĕ": "E",
                "Ė": "E",
                "Ë": "E",
                "Ẻ": "E",
                "Ě": "E",
                "Ȅ": "E",
                "Ȇ": "E",
                "Ẹ": "E",
                "Ệ": "E",
                "Ȩ": "E",
                "Ḝ": "E",
                "Ę": "E",
                "Ḙ": "E",
                "Ḛ": "E",
                "Ɛ": "E",
                "Ǝ": "E",
                "Ⓕ": "F",
                "Ｆ": "F",
                "Ḟ": "F",
                "Ƒ": "F",
                "Ꝼ": "F",
                "Ⓖ": "G",
                "Ｇ": "G",
                "Ǵ": "G",
                "Ĝ": "G",
                "Ḡ": "G",
                "Ğ": "G",
                "Ġ": "G",
                "Ǧ": "G",
                "Ģ": "G",
                "Ǥ": "G",
                "Ɠ": "G",
                "Ꞡ": "G",
                "Ᵹ": "G",
                "Ꝿ": "G",
                "Ⓗ": "H",
                "Ｈ": "H",
                "Ĥ": "H",
                "Ḣ": "H",
                "Ḧ": "H",
                "Ȟ": "H",
                "Ḥ": "H",
                "Ḩ": "H",
                "Ḫ": "H",
                "Ħ": "H",
                "Ⱨ": "H",
                "Ⱶ": "H",
                "Ɥ": "H",
                "Ⓘ": "I",
                "Ｉ": "I",
                "Ì": "I",
                "Í": "I",
                "Î": "I",
                "Ĩ": "I",
                "Ī": "I",
                "Ĭ": "I",
                "İ": "I",
                "Ï": "I",
                "Ḯ": "I",
                "Ỉ": "I",
                "Ǐ": "I",
                "Ȉ": "I",
                "Ȋ": "I",
                "Ị": "I",
                "Į": "I",
                "Ḭ": "I",
                "Ɨ": "I",
                "Ⓙ": "J",
                "Ｊ": "J",
                "Ĵ": "J",
                "Ɉ": "J",
                "Ⓚ": "K",
                "Ｋ": "K",
                "Ḱ": "K",
                "Ǩ": "K",
                "Ḳ": "K",
                "Ķ": "K",
                "Ḵ": "K",
                "Ƙ": "K",
                "Ⱪ": "K",
                "Ꝁ": "K",
                "Ꝃ": "K",
                "Ꝅ": "K",
                "Ꞣ": "K",
                "Ⓛ": "L",
                "Ｌ": "L",
                "Ŀ": "L",
                "Ĺ": "L",
                "Ľ": "L",
                "Ḷ": "L",
                "Ḹ": "L",
                "Ļ": "L",
                "Ḽ": "L",
                "Ḻ": "L",
                "Ł": "L",
                "Ƚ": "L",
                "Ɫ": "L",
                "Ⱡ": "L",
                "Ꝉ": "L",
                "Ꝇ": "L",
                "Ꞁ": "L",
                "Ǉ": "LJ",
                "ǈ": "Lj",
                "Ⓜ": "M",
                "Ｍ": "M",
                "Ḿ": "M",
                "Ṁ": "M",
                "Ṃ": "M",
                "Ɱ": "M",
                "Ɯ": "M",
                "Ⓝ": "N",
                "Ｎ": "N",
                "Ǹ": "N",
                "Ń": "N",
                "Ñ": "N",
                "Ṅ": "N",
                "Ň": "N",
                "Ṇ": "N",
                "Ņ": "N",
                "Ṋ": "N",
                "Ṉ": "N",
                "Ƞ": "N",
                "Ɲ": "N",
                "Ꞑ": "N",
                "Ꞥ": "N",
                "Ǌ": "NJ",
                "ǋ": "Nj",
                "Ⓞ": "O",
                "Ｏ": "O",
                "Ò": "O",
                "Ó": "O",
                "Ô": "O",
                "Ồ": "O",
                "Ố": "O",
                "Ỗ": "O",
                "Ổ": "O",
                "Õ": "O",
                "Ṍ": "O",
                "Ȭ": "O",
                "Ṏ": "O",
                "Ō": "O",
                "Ṑ": "O",
                "Ṓ": "O",
                "Ŏ": "O",
                "Ȯ": "O",
                "Ȱ": "O",
                "Ö": "O",
                "Ȫ": "O",
                "Ỏ": "O",
                "Ő": "O",
                "Ǒ": "O",
                "Ȍ": "O",
                "Ȏ": "O",
                "Ơ": "O",
                "Ờ": "O",
                "Ớ": "O",
                "Ỡ": "O",
                "Ở": "O",
                "Ợ": "O",
                "Ọ": "O",
                "Ộ": "O",
                "Ǫ": "O",
                "Ǭ": "O",
                "Ø": "O",
                "Ǿ": "O",
                "Ɔ": "O",
                "Ɵ": "O",
                "Ꝋ": "O",
                "Ꝍ": "O",
                "Ƣ": "OI",
                "Ꝏ": "OO",
                "Ȣ": "OU",
                "Ⓟ": "P",
                "Ｐ": "P",
                "Ṕ": "P",
                "Ṗ": "P",
                "Ƥ": "P",
                "Ᵽ": "P",
                "Ꝑ": "P",
                "Ꝓ": "P",
                "Ꝕ": "P",
                "Ⓠ": "Q",
                "Ｑ": "Q",
                "Ꝗ": "Q",
                "Ꝙ": "Q",
                "Ɋ": "Q",
                "Ⓡ": "R",
                "Ｒ": "R",
                "Ŕ": "R",
                "Ṙ": "R",
                "Ř": "R",
                "Ȑ": "R",
                "Ȓ": "R",
                "Ṛ": "R",
                "Ṝ": "R",
                "Ŗ": "R",
                "Ṟ": "R",
                "Ɍ": "R",
                "Ɽ": "R",
                "Ꝛ": "R",
                "Ꞧ": "R",
                "Ꞃ": "R",
                "Ⓢ": "S",
                "Ｓ": "S",
                "ẞ": "S",
                "Ś": "S",
                "Ṥ": "S",
                "Ŝ": "S",
                "Ṡ": "S",
                "Š": "S",
                "Ṧ": "S",
                "Ṣ": "S",
                "Ṩ": "S",
                "Ș": "S",
                "Ş": "S",
                "Ȿ": "S",
                "Ꞩ": "S",
                "Ꞅ": "S",
                "Ⓣ": "T",
                "Ｔ": "T",
                "Ṫ": "T",
                "Ť": "T",
                "Ṭ": "T",
                "Ț": "T",
                "Ţ": "T",
                "Ṱ": "T",
                "Ṯ": "T",
                "Ŧ": "T",
                "Ƭ": "T",
                "Ʈ": "T",
                "Ⱦ": "T",
                "Ꞇ": "T",
                "Ꜩ": "TZ",
                "Ⓤ": "U",
                "Ｕ": "U",
                "Ù": "U",
                "Ú": "U",
                "Û": "U",
                "Ũ": "U",
                "Ṹ": "U",
                "Ū": "U",
                "Ṻ": "U",
                "Ŭ": "U",
                "Ü": "U",
                "Ǜ": "U",
                "Ǘ": "U",
                "Ǖ": "U",
                "Ǚ": "U",
                "Ủ": "U",
                "Ů": "U",
                "Ű": "U",
                "Ǔ": "U",
                "Ȕ": "U",
                "Ȗ": "U",
                "Ư": "U",
                "Ừ": "U",
                "Ứ": "U",
                "Ữ": "U",
                "Ử": "U",
                "Ự": "U",
                "Ụ": "U",
                "Ṳ": "U",
                "Ų": "U",
                "Ṷ": "U",
                "Ṵ": "U",
                "Ʉ": "U",
                "Ⓥ": "V",
                "Ｖ": "V",
                "Ṽ": "V",
                "Ṿ": "V",
                "Ʋ": "V",
                "Ꝟ": "V",
                "Ʌ": "V",
                "Ꝡ": "VY",
                "Ⓦ": "W",
                "Ｗ": "W",
                "Ẁ": "W",
                "Ẃ": "W",
                "Ŵ": "W",
                "Ẇ": "W",
                "Ẅ": "W",
                "Ẉ": "W",
                "Ⱳ": "W",
                "Ⓧ": "X",
                "Ｘ": "X",
                "Ẋ": "X",
                "Ẍ": "X",
                "Ⓨ": "Y",
                "Ｙ": "Y",
                "Ỳ": "Y",
                "Ý": "Y",
                "Ŷ": "Y",
                "Ỹ": "Y",
                "Ȳ": "Y",
                "Ẏ": "Y",
                "Ÿ": "Y",
                "Ỷ": "Y",
                "Ỵ": "Y",
                "Ƴ": "Y",
                "Ɏ": "Y",
                "Ỿ": "Y",
                "Ⓩ": "Z",
                "Ｚ": "Z",
                "Ź": "Z",
                "Ẑ": "Z",
                "Ż": "Z",
                "Ž": "Z",
                "Ẓ": "Z",
                "Ẕ": "Z",
                "Ƶ": "Z",
                "Ȥ": "Z",
                "Ɀ": "Z",
                "Ⱬ": "Z",
                "Ꝣ": "Z",
                "ⓐ": "a",
                "ａ": "a",
                "ẚ": "a",
                "à": "a",
                "á": "a",
                "â": "a",
                "ầ": "a",
                "ấ": "a",
                "ẫ": "a",
                "ẩ": "a",
                "ã": "a",
                "ā": "a",
                "ă": "a",
                "ằ": "a",
                "ắ": "a",
                "ẵ": "a",
                "ẳ": "a",
                "ȧ": "a",
                "ǡ": "a",
                "ä": "a",
                "ǟ": "a",
                "ả": "a",
                "å": "a",
                "ǻ": "a",
                "ǎ": "a",
                "ȁ": "a",
                "ȃ": "a",
                "ạ": "a",
                "ậ": "a",
                "ặ": "a",
                "ḁ": "a",
                "ą": "a",
                "ⱥ": "a",
                "ɐ": "a",
                "ꜳ": "aa",
                "æ": "ae",
                "ǽ": "ae",
                "ǣ": "ae",
                "ꜵ": "ao",
                "ꜷ": "au",
                "ꜹ": "av",
                "ꜻ": "av",
                "ꜽ": "ay",
                "ⓑ": "b",
                "ｂ": "b",
                "ḃ": "b",
                "ḅ": "b",
                "ḇ": "b",
                "ƀ": "b",
                "ƃ": "b",
                "ɓ": "b",
                "ⓒ": "c",
                "ｃ": "c",
                "ć": "c",
                "ĉ": "c",
                "ċ": "c",
                "č": "c",
                "ç": "c",
                "ḉ": "c",
                "ƈ": "c",
                "ȼ": "c",
                "ꜿ": "c",
                "ↄ": "c",
                "ⓓ": "d",
                "ｄ": "d",
                "ḋ": "d",
                "ď": "d",
                "ḍ": "d",
                "ḑ": "d",
                "ḓ": "d",
                "ḏ": "d",
                "đ": "d",
                "ƌ": "d",
                "ɖ": "d",
                "ɗ": "d",
                "ꝺ": "d",
                "ǳ": "dz",
                "ǆ": "dz",
                "ⓔ": "e",
                "ｅ": "e",
                "è": "e",
                "é": "e",
                "ê": "e",
                "ề": "e",
                "ế": "e",
                "ễ": "e",
                "ể": "e",
                "ẽ": "e",
                "ē": "e",
                "ḕ": "e",
                "ḗ": "e",
                "ĕ": "e",
                "ė": "e",
                "ë": "e",
                "ẻ": "e",
                "ě": "e",
                "ȅ": "e",
                "ȇ": "e",
                "ẹ": "e",
                "ệ": "e",
                "ȩ": "e",
                "ḝ": "e",
                "ę": "e",
                "ḙ": "e",
                "ḛ": "e",
                "ɇ": "e",
                "ɛ": "e",
                "ǝ": "e",
                "ⓕ": "f",
                "ｆ": "f",
                "ḟ": "f",
                "ƒ": "f",
                "ꝼ": "f",
                "ⓖ": "g",
                "ｇ": "g",
                "ǵ": "g",
                "ĝ": "g",
                "ḡ": "g",
                "ğ": "g",
                "ġ": "g",
                "ǧ": "g",
                "ģ": "g",
                "ǥ": "g",
                "ɠ": "g",
                "ꞡ": "g",
                "ᵹ": "g",
                "ꝿ": "g",
                "ⓗ": "h",
                "ｈ": "h",
                "ĥ": "h",
                "ḣ": "h",
                "ḧ": "h",
                "ȟ": "h",
                "ḥ": "h",
                "ḩ": "h",
                "ḫ": "h",
                "ẖ": "h",
                "ħ": "h",
                "ⱨ": "h",
                "ⱶ": "h",
                "ɥ": "h",
                "ƕ": "hv",
                "ⓘ": "i",
                "ｉ": "i",
                "ì": "i",
                "í": "i",
                "î": "i",
                "ĩ": "i",
                "ī": "i",
                "ĭ": "i",
                "ï": "i",
                "ḯ": "i",
                "ỉ": "i",
                "ǐ": "i",
                "ȉ": "i",
                "ȋ": "i",
                "ị": "i",
                "į": "i",
                "ḭ": "i",
                "ɨ": "i",
                "ı": "i",
                "ⓙ": "j",
                "ｊ": "j",
                "ĵ": "j",
                "ǰ": "j",
                "ɉ": "j",
                "ⓚ": "k",
                "ｋ": "k",
                "ḱ": "k",
                "ǩ": "k",
                "ḳ": "k",
                "ķ": "k",
                "ḵ": "k",
                "ƙ": "k",
                "ⱪ": "k",
                "ꝁ": "k",
                "ꝃ": "k",
                "ꝅ": "k",
                "ꞣ": "k",
                "ⓛ": "l",
                "ｌ": "l",
                "ŀ": "l",
                "ĺ": "l",
                "ľ": "l",
                "ḷ": "l",
                "ḹ": "l",
                "ļ": "l",
                "ḽ": "l",
                "ḻ": "l",
                "ſ": "l",
                "ł": "l",
                "ƚ": "l",
                "ɫ": "l",
                "ⱡ": "l",
                "ꝉ": "l",
                "ꞁ": "l",
                "ꝇ": "l",
                "ǉ": "lj",
                "ⓜ": "m",
                "ｍ": "m",
                "ḿ": "m",
                "ṁ": "m",
                "ṃ": "m",
                "ɱ": "m",
                "ɯ": "m",
                "ⓝ": "n",
                "ｎ": "n",
                "ǹ": "n",
                "ń": "n",
                "ñ": "n",
                "ṅ": "n",
                "ň": "n",
                "ṇ": "n",
                "ņ": "n",
                "ṋ": "n",
                "ṉ": "n",
                "ƞ": "n",
                "ɲ": "n",
                "ŉ": "n",
                "ꞑ": "n",
                "ꞥ": "n",
                "ǌ": "nj",
                "ⓞ": "o",
                "ｏ": "o",
                "ò": "o",
                "ó": "o",
                "ô": "o",
                "ồ": "o",
                "ố": "o",
                "ỗ": "o",
                "ổ": "o",
                "õ": "o",
                "ṍ": "o",
                "ȭ": "o",
                "ṏ": "o",
                "ō": "o",
                "ṑ": "o",
                "ṓ": "o",
                "ŏ": "o",
                "ȯ": "o",
                "ȱ": "o",
                "ö": "o",
                "ȫ": "o",
                "ỏ": "o",
                "ő": "o",
                "ǒ": "o",
                "ȍ": "o",
                "ȏ": "o",
                "ơ": "o",
                "ờ": "o",
                "ớ": "o",
                "ỡ": "o",
                "ở": "o",
                "ợ": "o",
                "ọ": "o",
                "ộ": "o",
                "ǫ": "o",
                "ǭ": "o",
                "ø": "o",
                "ǿ": "o",
                "ɔ": "o",
                "ꝋ": "o",
                "ꝍ": "o",
                "ɵ": "o",
                "ƣ": "oi",
                "ȣ": "ou",
                "ꝏ": "oo",
                "ⓟ": "p",
                "ｐ": "p",
                "ṕ": "p",
                "ṗ": "p",
                "ƥ": "p",
                "ᵽ": "p",
                "ꝑ": "p",
                "ꝓ": "p",
                "ꝕ": "p",
                "ⓠ": "q",
                "ｑ": "q",
                "ɋ": "q",
                "ꝗ": "q",
                "ꝙ": "q",
                "ⓡ": "r",
                "ｒ": "r",
                "ŕ": "r",
                "ṙ": "r",
                "ř": "r",
                "ȑ": "r",
                "ȓ": "r",
                "ṛ": "r",
                "ṝ": "r",
                "ŗ": "r",
                "ṟ": "r",
                "ɍ": "r",
                "ɽ": "r",
                "ꝛ": "r",
                "ꞧ": "r",
                "ꞃ": "r",
                "ⓢ": "s",
                "ｓ": "s",
                "ß": "s",
                "ś": "s",
                "ṥ": "s",
                "ŝ": "s",
                "ṡ": "s",
                "š": "s",
                "ṧ": "s",
                "ṣ": "s",
                "ṩ": "s",
                "ș": "s",
                "ş": "s",
                "ȿ": "s",
                "ꞩ": "s",
                "ꞅ": "s",
                "ẛ": "s",
                "ⓣ": "t",
                "ｔ": "t",
                "ṫ": "t",
                "ẗ": "t",
                "ť": "t",
                "ṭ": "t",
                "ț": "t",
                "ţ": "t",
                "ṱ": "t",
                "ṯ": "t",
                "ŧ": "t",
                "ƭ": "t",
                "ʈ": "t",
                "ⱦ": "t",
                "ꞇ": "t",
                "ꜩ": "tz",
                "ⓤ": "u",
                "ｕ": "u",
                "ù": "u",
                "ú": "u",
                "û": "u",
                "ũ": "u",
                "ṹ": "u",
                "ū": "u",
                "ṻ": "u",
                "ŭ": "u",
                "ü": "u",
                "ǜ": "u",
                "ǘ": "u",
                "ǖ": "u",
                "ǚ": "u",
                "ủ": "u",
                "ů": "u",
                "ű": "u",
                "ǔ": "u",
                "ȕ": "u",
                "ȗ": "u",
                "ư": "u",
                "ừ": "u",
                "ứ": "u",
                "ữ": "u",
                "ử": "u",
                "ự": "u",
                "ụ": "u",
                "ṳ": "u",
                "ų": "u",
                "ṷ": "u",
                "ṵ": "u",
                "ʉ": "u",
                "ⓥ": "v",
                "ｖ": "v",
                "ṽ": "v",
                "ṿ": "v",
                "ʋ": "v",
                "ꝟ": "v",
                "ʌ": "v",
                "ꝡ": "vy",
                "ⓦ": "w",
                "ｗ": "w",
                "ẁ": "w",
                "ẃ": "w",
                "ŵ": "w",
                "ẇ": "w",
                "ẅ": "w",
                "ẘ": "w",
                "ẉ": "w",
                "ⱳ": "w",
                "ⓧ": "x",
                "ｘ": "x",
                "ẋ": "x",
                "ẍ": "x",
                "ⓨ": "y",
                "ｙ": "y",
                "ỳ": "y",
                "ý": "y",
                "ŷ": "y",
                "ỹ": "y",
                "ȳ": "y",
                "ẏ": "y",
                "ÿ": "y",
                "ỷ": "y",
                "ẙ": "y",
                "ỵ": "y",
                "ƴ": "y",
                "ɏ": "y",
                "ỿ": "y",
                "ⓩ": "z",
                "ｚ": "z",
                "ź": "z",
                "ẑ": "z",
                "ż": "z",
                "ž": "z",
                "ẓ": "z",
                "ẕ": "z",
                "ƶ": "z",
                "ȥ": "z",
                "ɀ": "z",
                "ⱬ": "z",
                "ꝣ": "z",
                "Ά": "Α",
                "Έ": "Ε",
                "Ή": "Η",
                "Ί": "Ι",
                "Ϊ": "Ι",
                "Ό": "Ο",
                "Ύ": "Υ",
                "Ϋ": "Υ",
                "Ώ": "Ω",
                "ά": "α",
                "έ": "ε",
                "ή": "η",
                "ί": "ι",
                "ϊ": "ι",
                "ΐ": "ι",
                "ό": "ο",
                "ύ": "υ",
                "ϋ": "υ",
                "ΰ": "υ",
                "ω": "ω",
                "ς": "σ"
            }
        }),
        b.define("select2/data/base", ["../utils"], function(a) {
            function b(a, c) {
                b.__super__.constructor.call(this)
            }
            return a.Extend(b, a.Observable),
            b.prototype.current = function(a) {
                throw new Error("The `current` method must be defined in child classes.")
            }
            ,
            b.prototype.query = function(a, b) {
                throw new Error("The `query` method must be defined in child classes.")
            }
            ,
            b.prototype.bind = function(a, b) {}
            ,
            b.prototype.destroy = function() {}
            ,
            b.prototype.generateResultId = function(b, c) {
                var d = b.id + "-result-";
                return d += a.generateChars(4),
                null != c.id ? d += "-" + c.id.toString() : d += "-" + a.generateChars(4),
                d
            }
            ,
            b
        }),
        b.define("select2/data/select", ["./base", "../utils", "jquery"], function(a, b, c) {
            function d(a, b) {
                this.$element = a,
                this.options = b,
                d.__super__.constructor.call(this)
            }
            return b.Extend(d, a),
            d.prototype.current = function(a) {
                var b = []
                  , d = this;
                this.$element.find(":selected").each(function() {
                    var a = c(this)
                      , e = d.item(a);
                    b.push(e)
                }),
                a(b)
            }
            ,
            d.prototype.select = function(a) {
                var b = this;
                if (a.selected = !0,
                c(a.element).is("option"))
                    return a.element.selected = !0,
                    void this.$element.trigger("change");
                if (this.$element.prop("multiple"))
                    this.current(function(d) {
                        var e = [];
                        a = [a],
                        a.push.apply(a, d);
                        for (var f = 0; f < a.length; f++) {
                            var g = a[f].id;
                            -1 === c.inArray(g, e) && e.push(g)
                        }
                        b.$element.val(e),
                        b.$element.trigger("change")
                    });
                else {
                    var d = a.id;
                    this.$element.val(d),
                    this.$element.trigger("change")
                }
            }
            ,
            d.prototype.unselect = function(a) {
                var b = this;
                if (this.$element.prop("multiple")) {
                    if (a.selected = !1,
                    c(a.element).is("option"))
                        return a.element.selected = !1,
                        void this.$element.trigger("change");
                    this.current(function(d) {
                        for (var e = [], f = 0; f < d.length; f++) {
                            var g = d[f].id;
                            g !== a.id && -1 === c.inArray(g, e) && e.push(g)
                        }
                        b.$element.val(e),
                        b.$element.trigger("change")
                    })
                }
            }
            ,
            d.prototype.bind = function(a, b) {
                var c = this;
                this.container = a,
                a.on("select", function(a) {
                    c.select(a.data)
                }),
                a.on("unselect", function(a) {
                    c.unselect(a.data)
                })
            }
            ,
            d.prototype.destroy = function() {
                this.$element.find("*").each(function() {
                    c.removeData(this, "data")
                })
            }
            ,
            d.prototype.query = function(a, b) {
                var d = []
                  , e = this;
                this.$element.children().each(function() {
                    var b = c(this);
                    if (b.is("option") || b.is("optgroup")) {
                        var f = e.item(b)
                          , g = e.matches(a, f);
                        null !== g && d.push(g)
                    }
                }),
                b({
                    results: d
                })
            }
            ,
            d.prototype.addOptions = function(a) {
                b.appendMany(this.$element, a)
            }
            ,
            d.prototype.option = function(a) {
                var b;
                a.children ? (b = document.createElement("optgroup"),
                b.label = a.text) : (b = document.createElement("option"),
                void 0 !== b.textContent ? b.textContent = a.text : b.innerText = a.text),
                void 0 !== a.id && (b.value = a.id),
                a.disabled && (b.disabled = !0),
                a.selected && (b.selected = !0),
                a.title && (b.title = a.title);
                var d = c(b)
                  , e = this._normalizeItem(a);
                return e.element = b,
                c.data(b, "data", e),
                d
            }
            ,
            d.prototype.item = function(a) {
                var b = {};
                if (null != (b = c.data(a[0], "data")))
                    return b;
                if (a.is("option"))
                    b = {
                        id: a.val(),
                        text: a.text(),
                        disabled: a.prop("disabled"),
                        selected: a.prop("selected"),
                        title: a.prop("title")
                    };
                else if (a.is("optgroup")) {
                    b = {
                        text: a.prop("label"),
                        children: [],
                        title: a.prop("title")
                    };
                    for (var d = a.children("option"), e = [], f = 0; f < d.length; f++) {
                        var g = c(d[f])
                          , h = this.item(g);
                        e.push(h)
                    }
                    b.children = e
                }
                return b = this._normalizeItem(b),
                b.element = a[0],
                c.data(a[0], "data", b),
                b
            }
            ,
            d.prototype._normalizeItem = function(a) {
                c.isPlainObject(a) || (a = {
                    id: a,
                    text: a
                }),
                a = c.extend({}, {
                    text: ""
                }, a);
                var b = {
                    selected: !1,
                    disabled: !1
                };
                return null != a.id && (a.id = a.id.toString()),
                null != a.text && (a.text = a.text.toString()),
                null == a._resultId && a.id && null != this.container && (a._resultId = this.generateResultId(this.container, a)),
                c.extend({}, b, a)
            }
            ,
            d.prototype.matches = function(a, b) {
                return this.options.get("matcher")(a, b)
            }
            ,
            d
        }),
        b.define("select2/data/array", ["./select", "../utils", "jquery"], function(a, b, c) {
            function d(a, b) {
                var c = b.get("data") || [];
                d.__super__.constructor.call(this, a, b),
                this.addOptions(this.convertToOptions(c))
            }
            return b.Extend(d, a),
            d.prototype.select = function(a) {
                var b = this.$element.find("option").filter(function(b, c) {
                    return c.value == a.id.toString()
                });
                0 === b.length && (b = this.option(a),
                this.addOptions(b)),
                d.__super__.select.call(this, a)
            }
            ,
            d.prototype.convertToOptions = function(a) {
                function d(a) {
                    return function() {
                        return c(this).val() == a.id
                    }
                }
                for (var e = this, f = this.$element.find("option"), g = f.map(function() {
                    return e.item(c(this)).id
                }).get(), h = [], i = 0; i < a.length; i++) {
                    var j = this._normalizeItem(a[i]);
                    if (c.inArray(j.id, g) >= 0) {
                        var k = f.filter(d(j))
                          , l = this.item(k)
                          , m = c.extend(!0, {}, j, l)
                          , n = this.option(m);
                        k.replaceWith(n)
                    } else {
                        var o = this.option(j);
                        if (j.children) {
                            var p = this.convertToOptions(j.children);
                            b.appendMany(o, p)
                        }
                        h.push(o)
                    }
                }
                return h
            }
            ,
            d
        }),
        b.define("select2/data/ajax", ["./array", "../utils", "jquery"], function(a, b, c) {
            function d(a, b) {
                this.ajaxOptions = this._applyDefaults(b.get("ajax")),
                null != this.ajaxOptions.processResults && (this.processResults = this.ajaxOptions.processResults),
                d.__super__.constructor.call(this, a, b)
            }
            return b.Extend(d, a),
            d.prototype._applyDefaults = function(a) {
                var b = {
                    data: function(a) {
                        return c.extend({}, a, {
                            q: a.term
                        })
                    },
                    transport: function(a, b, d) {
                        var e = c.ajax(a);
                        return e.then(b),
                        e.fail(d),
                        e
                    }
                };
                return c.extend({}, b, a, !0)
            }
            ,
            d.prototype.processResults = function(a) {
                return a
            }
            ,
            d.prototype.query = function(a, b) {
                function d() {
                    var d = f.transport(f, function(d) {
                        var f = e.processResults(d, a);
                        e.options.get("debug") && window.console && console.error && (f && f.results && c.isArray(f.results) || console.error("Select2: The AJAX results did not return an array in the `results` key of the response.")),
                        b(f)
                    }, function() {
                        d.status && "0" === d.status || e.trigger("results:message", {
                            message: "errorLoading"
                        })
                    });
                    e._request = d
                }
                var e = this;
                null != this._request && (c.isFunction(this._request.abort) && this._request.abort(),
                this._request = null);
                var f = c.extend({
                    type: "GET"
                }, this.ajaxOptions);
                "function" == typeof f.url && (f.url = f.url.call(this.$element, a)),
                "function" == typeof f.data && (f.data = f.data.call(this.$element, a)),
                this.ajaxOptions.delay && null != a.term ? (this._queryTimeout && window.clearTimeout(this._queryTimeout),
                this._queryTimeout = window.setTimeout(d, this.ajaxOptions.delay)) : d()
            }
            ,
            d
        }),
        b.define("select2/data/tags", ["jquery"], function(a) {
            function b(b, c, d) {
                var e = d.get("tags")
                  , f = d.get("createTag");
                void 0 !== f && (this.createTag = f);
                var g = d.get("insertTag");
                if (void 0 !== g && (this.insertTag = g),
                b.call(this, c, d),
                a.isArray(e))
                    for (var h = 0; h < e.length; h++) {
                        var i = e[h]
                          , j = this._normalizeItem(i)
                          , k = this.option(j);
                        this.$element.append(k)
                    }
            }
            return b.prototype.query = function(a, b, c) {
                function d(a, f) {
                    for (var g = a.results, h = 0; h < g.length; h++) {
                        var i = g[h]
                          , j = null != i.children && !d({
                            results: i.children
                        }, !0);
                        if ((i.text || "").toUpperCase() === (b.term || "").toUpperCase() || j)
                            return !f && (a.data = g,
                            void c(a))
                    }
                    if (f)
                        return !0;
                    var k = e.createTag(b);
                    if (null != k) {
                        var l = e.option(k);
                        l.attr("data-select2-tag", !0),
                        e.addOptions([l]),
                        e.insertTag(g, k)
                    }
                    a.results = g,
                    c(a)
                }
                var e = this;
                if (this._removeOldTags(),
                null == b.term || null != b.page)
                    return void a.call(this, b, c);
                a.call(this, b, d)
            }
            ,
            b.prototype.createTag = function(b, c) {
                var d = a.trim(c.term);
                return "" === d ? null : {
                    id: d,
                    text: d
                }
            }
            ,
            b.prototype.insertTag = function(a, b, c) {
                b.unshift(c)
            }
            ,
            b.prototype._removeOldTags = function(b) {
                this._lastTag;
                this.$element.find("option[data-select2-tag]").each(function() {
                    this.selected || a(this).remove()
                })
            }
            ,
            b
        }),
        b.define("select2/data/tokenizer", ["jquery"], function(a) {
            function b(a, b, c) {
                var d = c.get("tokenizer");
                void 0 !== d && (this.tokenizer = d),
                a.call(this, b, c)
            }
            return b.prototype.bind = function(a, b, c) {
                a.call(this, b, c),
                this.$search = b.dropdown.$search || b.selection.$search || c.find(".select2-search__field")
            }
            ,
            b.prototype.query = function(b, c, d) {
                function e(b) {
                    var c = g._normalizeItem(b);
                    if (!g.$element.find("option").filter(function() {
                        return a(this).val() === c.id
                    }).length) {
                        var d = g.option(c);
                        d.attr("data-select2-tag", !0),
                        g._removeOldTags(),
                        g.addOptions([d])
                    }
                    f(c)
                }
                function f(a) {
                    g.trigger("select", {
                        data: a
                    })
                }
                var g = this;
                c.term = c.term || "";
                var h = this.tokenizer(c, this.options, e);
                h.term !== c.term && (this.$search.length && (this.$search.val(h.term),
                this.$search.focus()),
                c.term = h.term),
                b.call(this, c, d)
            }
            ,
            b.prototype.tokenizer = function(b, c, d, e) {
                for (var f = d.get("tokenSeparators") || [], g = c.term, h = 0, i = this.createTag || function(a) {
                    return {
                        id: a.term,
                        text: a.term
                    }
                }
                ; h < g.length; ) {
                    var j = g[h];
                    if (-1 !== a.inArray(j, f)) {
                        var k = g.substr(0, h)
                          , l = a.extend({}, c, {
                            term: k
                        })
                          , m = i(l);
                        null != m ? (e(m),
                        g = g.substr(h + 1) || "",
                        h = 0) : h++
                    } else
                        h++
                }
                return {
                    term: g
                }
            }
            ,
            b
        }),
        b.define("select2/data/minimumInputLength", [], function() {
            function a(a, b, c) {
                this.minimumInputLength = c.get("minimumInputLength"),
                a.call(this, b, c)
            }
            return a.prototype.query = function(a, b, c) {
                if (b.term = b.term || "",
                b.term.length < this.minimumInputLength)
                    return void this.trigger("results:message", {
                        message: "inputTooShort",
                        args: {
                            minimum: this.minimumInputLength,
                            input: b.term,
                            params: b
                        }
                    });
                a.call(this, b, c)
            }
            ,
            a
        }),
        b.define("select2/data/maximumInputLength", [], function() {
            function a(a, b, c) {
                this.maximumInputLength = c.get("maximumInputLength"),
                a.call(this, b, c)
            }
            return a.prototype.query = function(a, b, c) {
                if (b.term = b.term || "",
                this.maximumInputLength > 0 && b.term.length > this.maximumInputLength)
                    return void this.trigger("results:message", {
                        message: "inputTooLong",
                        args: {
                            maximum: this.maximumInputLength,
                            input: b.term,
                            params: b
                        }
                    });
                a.call(this, b, c)
            }
            ,
            a
        }),
        b.define("select2/data/maximumSelectionLength", [], function() {
            function a(a, b, c) {
                this.maximumSelectionLength = c.get("maximumSelectionLength"),
                a.call(this, b, c)
            }
            return a.prototype.query = function(a, b, c) {
                var d = this;
                this.current(function(e) {
                    var f = null != e ? e.length : 0;
                    if (d.maximumSelectionLength > 0 && f >= d.maximumSelectionLength)
                        return void d.trigger("results:message", {
                            message: "maximumSelected",
                            args: {
                                maximum: d.maximumSelectionLength
                            }
                        });
                    a.call(d, b, c)
                })
            }
            ,
            a
        }),
        b.define("select2/dropdown", ["jquery", "./utils"], function(a, b) {
            function c(a, b) {
                this.$element = a,
                this.options = b,
                c.__super__.constructor.call(this)
            }
            return b.Extend(c, b.Observable),
            c.prototype.render = function() {
                var b = a('<span class="select2-dropdown"><span class="select2-results"></span></span>');
                return b.attr("dir", this.options.get("dir")),
                this.$dropdown = b,
                b
            }
            ,
            c.prototype.bind = function() {}
            ,
            c.prototype.position = function(a, b) {}
            ,
            c.prototype.destroy = function() {
                this.$dropdown.remove()
            }
            ,
            c
        }),
        b.define("select2/dropdown/search", ["jquery", "../utils"], function(a, b) {
            function c() {}
            return c.prototype.render = function(b) {
                var c = b.call(this)
                  , d = a('<span class="select2-search select2-search--dropdown"><input class="select2-search__field" type="search" tabindex="-1" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" role="textbox" /></span>');
                return this.$searchContainer = d,
                this.$search = d.find("input"),
                c.prepend(d),
                c
            }
            ,
            c.prototype.bind = function(b, c, d) {
                var e = this;
                b.call(this, c, d),
                this.$search.on("keydown", function(a) {
                    e.trigger("keypress", a),
                    e._keyUpPrevented = a.isDefaultPrevented()
                }),
                this.$search.on("input", function(b) {
                    a(this).off("keyup")
                }),
                this.$search.on("keyup input", function(a) {
                    e.handleSearch(a)
                }),
                c.on("open", function() {
                    e.$search.attr("tabindex", 0),
                    e.$search.focus(),
                    window.setTimeout(function() {
                        e.$search.focus()
                    }, 0)
                }),
                c.on("close", function() {
                    e.$search.attr("tabindex", -1),
                    e.$search.val("")
                }),
                c.on("focus", function() {
                    c.isOpen() || e.$search.focus()
                }),
                c.on("results:all", function(a) {
                    if (null == a.query.term || "" === a.query.term) {
                        e.showSearch(a) ? e.$searchContainer.removeClass("select2-search--hide") : e.$searchContainer.addClass("select2-search--hide")
                    }
                })
            }
            ,
            c.prototype.handleSearch = function(a) {
                if (!this._keyUpPrevented) {
                    var b = this.$search.val();
                    this.trigger("query", {
                        term: b
                    })
                }
                this._keyUpPrevented = !1
            }
            ,
            c.prototype.showSearch = function(a, b) {
                return !0
            }
            ,
            c
        }),
        b.define("select2/dropdown/hidePlaceholder", [], function() {
            function a(a, b, c, d) {
                this.placeholder = this.normalizePlaceholder(c.get("placeholder")),
                a.call(this, b, c, d)
            }
            return a.prototype.append = function(a, b) {
                b.results = this.removePlaceholder(b.results),
                a.call(this, b)
            }
            ,
            a.prototype.normalizePlaceholder = function(a, b) {
                return "string" == typeof b && (b = {
                    id: "",
                    text: b
                }),
                b
            }
            ,
            a.prototype.removePlaceholder = function(a, b) {
                for (var c = b.slice(0), d = b.length - 1; d >= 0; d--) {
                    var e = b[d];
                    this.placeholder.id === e.id && c.splice(d, 1)
                }
                return c
            }
            ,
            a
        }),
        b.define("select2/dropdown/infiniteScroll", ["jquery"], function(a) {
            function b(a, b, c, d) {
                this.lastParams = {},
                a.call(this, b, c, d),
                this.$loadingMore = this.createLoadingMore(),
                this.loading = !1
            }
            return b.prototype.append = function(a, b) {
                this.$loadingMore.remove(),
                this.loading = !1,
                a.call(this, b),
                this.showLoadingMore(b) && this.$results.append(this.$loadingMore)
            }
            ,
            b.prototype.bind = function(b, c, d) {
                var e = this;
                b.call(this, c, d),
                c.on("query", function(a) {
                    e.lastParams = a,
                    e.loading = !0
                }),
                c.on("query:append", function(a) {
                    e.lastParams = a,
                    e.loading = !0
                }),
                this.$results.on("scroll", function() {
                    var b = a.contains(document.documentElement, e.$loadingMore[0]);
                    if (!e.loading && b) {
                        e.$results.offset().top + e.$results.outerHeight(!1) + 50 >= e.$loadingMore.offset().top + e.$loadingMore.outerHeight(!1) && e.loadMore()
                    }
                })
            }
            ,
            b.prototype.loadMore = function() {
                this.loading = !0;
                var b = a.extend({}, {
                    page: 1
                }, this.lastParams);
                b.page++,
                this.trigger("query:append", b)
            }
            ,
            b.prototype.showLoadingMore = function(a, b) {
                return b.pagination && b.pagination.more
            }
            ,
            b.prototype.createLoadingMore = function() {
                var b = a('<li class="select2-results__option select2-results__option--load-more"role="treeitem" aria-disabled="true"></li>')
                  , c = this.options.get("translations").get("loadingMore");
                return b.html(c(this.lastParams)),
                b
            }
            ,
            b
        }),
        b.define("select2/dropdown/attachBody", ["jquery", "../utils"], function(a, b) {
            function c(b, c, d) {
                this.$dropdownParent = d.get("dropdownParent") || a(document.body),
                b.call(this, c, d)
            }
            return c.prototype.bind = function(a, b, c) {
                var d = this
                  , e = !1;
                a.call(this, b, c),
                b.on("open", function() {
                    d._showDropdown(),
                    d._attachPositioningHandler(b),
                    e || (e = !0,
                    b.on("results:all", function() {
                        d._positionDropdown(),
                        d._resizeDropdown()
                    }),
                    b.on("results:append", function() {
                        d._positionDropdown(),
                        d._resizeDropdown()
                    }))
                }),
                b.on("close", function() {
                    d._hideDropdown(),
                    d._detachPositioningHandler(b)
                }),
                this.$dropdownContainer.on("mousedown", function(a) {
                    a.stopPropagation()
                })
            }
            ,
            c.prototype.destroy = function(a) {
                a.call(this),
                this.$dropdownContainer.remove()
            }
            ,
            c.prototype.position = function(a, b, c) {
                b.attr("class", c.attr("class")),
                b.removeClass("select2"),
                b.addClass("select2-container--open"),
                b.css({
                    position: "absolute",
                    top: -999999
                }),
                this.$container = c
            }
            ,
            c.prototype.render = function(b) {
                var c = a("<span></span>")
                  , d = b.call(this);
                return c.append(d),
                this.$dropdownContainer = c,
                c
            }
            ,
            c.prototype._hideDropdown = function(a) {
                this.$dropdownContainer.detach()
            }
            ,
            c.prototype._attachPositioningHandler = function(c, d) {
                var e = this
                  , f = "scroll.select2." + d.id
                  , g = "resize.select2." + d.id
                  , h = "orientationchange.select2." + d.id
                  , i = this.$container.parents().filter(b.hasScroll);
                i.each(function() {
                    a(this).data("select2-scroll-position", {
                        x: a(this).scrollLeft(),
                        y: a(this).scrollTop()
                    })
                }),
                i.on(f, function(b) {
                    var c = a(this).data("select2-scroll-position");
                    a(this).scrollTop(c.y)
                }),
                a(window).on(f + " " + g + " " + h, function(a) {
                    e._positionDropdown(),
                    e._resizeDropdown()
                })
            }
            ,
            c.prototype._detachPositioningHandler = function(c, d) {
                var e = "scroll.select2." + d.id
                  , f = "resize.select2." + d.id
                  , g = "orientationchange.select2." + d.id;
                this.$container.parents().filter(b.hasScroll).off(e),
                a(window).off(e + " " + f + " " + g)
            }
            ,
            c.prototype._positionDropdown = function() {
                var b = a(window)
                  , c = this.$dropdown.hasClass("select2-dropdown--above")
                  , d = this.$dropdown.hasClass("select2-dropdown--below")
                  , e = null
                  , f = this.$container.offset();
                f.bottom = f.top + this.$container.outerHeight(!1);
                var g = {
                    height: this.$container.outerHeight(!1)
                };
                g.top = f.top,
                g.bottom = f.top + g.height;
                var h = {
                    height: this.$dropdown.outerHeight(!1)
                }
                  , i = {
                    top: b.scrollTop(),
                    bottom: b.scrollTop() + b.height()
                }
                  , j = i.top < f.top - h.height
                  , k = i.bottom > f.bottom + h.height
                  , l = {
                    left: f.left,
                    top: g.bottom
                }
                  , m = this.$dropdownParent;
                "static" === m.css("position") && (m = m.offsetParent());
                var n = m.offset();
                l.top -= n.top,
                l.left -= n.left,
                c || d || (e = "below"),
                k || !j || c ? !j && k && c && (e = "below") : e = "above",
                ("above" == e || c && "below" !== e) && (l.top = g.top - n.top - h.height),
                null != e && (this.$dropdown.removeClass("select2-dropdown--below select2-dropdown--above").addClass("select2-dropdown--" + e),
                this.$container.removeClass("select2-container--below select2-container--above").addClass("select2-container--" + e)),
                this.$dropdownContainer.css(l)
            }
            ,
            c.prototype._resizeDropdown = function() {
                var a = {
                    width: this.$container.outerWidth(!1) + "px"
                };
                this.options.get("dropdownAutoWidth") && (a.minWidth = a.width,
                a.position = "relative",
                a.width = "auto"),
                this.$dropdown.css(a)
            }
            ,
            c.prototype._showDropdown = function(a) {
                this.$dropdownContainer.appendTo(this.$dropdownParent),
                this._positionDropdown(),
                this._resizeDropdown()
            }
            ,
            c
        }),
        b.define("select2/dropdown/minimumResultsForSearch", [], function() {
            function a(b) {
                for (var c = 0, d = 0; d < b.length; d++) {
                    var e = b[d];
                    e.children ? c += a(e.children) : c++
                }
                return c
            }
            function b(a, b, c, d) {
                this.minimumResultsForSearch = c.get("minimumResultsForSearch"),
                this.minimumResultsForSearch < 0 && (this.minimumResultsForSearch = 1 / 0),
                a.call(this, b, c, d)
            }
            return b.prototype.showSearch = function(b, c) {
                return !(a(c.data.results) < this.minimumResultsForSearch) && b.call(this, c)
            }
            ,
            b
        }),
        b.define("select2/dropdown/selectOnClose", [], function() {
            function a() {}
            return a.prototype.bind = function(a, b, c) {
                var d = this;
                a.call(this, b, c),
                b.on("close", function(a) {
                    d._handleSelectOnClose(a)
                })
            }
            ,
            a.prototype._handleSelectOnClose = function(a, b) {
                if (b && null != b.originalSelect2Event) {
                    var c = b.originalSelect2Event;
                    if ("select" === c._type || "unselect" === c._type)
                        return
                }
                var d = this.getHighlightedResults();
                if (!(d.length < 1)) {
                    var e = d.data("data");
                    null != e.element && e.element.selected || null == e.element && e.selected || this.trigger("select", {
                        data: e
                    })
                }
            }
            ,
            a
        }),
        b.define("select2/dropdown/closeOnSelect", [], function() {
            function a() {}
            return a.prototype.bind = function(a, b, c) {
                var d = this;
                a.call(this, b, c),
                b.on("select", function(a) {
                    d._selectTriggered(a)
                }),
                b.on("unselect", function(a) {
                    d._selectTriggered(a)
                })
            }
            ,
            a.prototype._selectTriggered = function(a, b) {
                var c = b.originalEvent;
                c && c.ctrlKey || this.trigger("close", {
                    originalEvent: c,
                    originalSelect2Event: b
                })
            }
            ,
            a
        }),
        b.define("select2/i18n/en", [], function() {
            return {
                errorLoading: function() {
                    return "The results could not be loaded."
                },
                inputTooLong: function(a) {
                    var b = a.input.length - a.maximum
                      , c = "Please delete " + b + " character";
                    return 1 != b && (c += "s"),
                    c
                },
                inputTooShort: function(a) {
                    return "Please enter " + (a.minimum - a.input.length) + " or more characters"
                },
                loadingMore: function() {
                    return "Loading more results…"
                },
                maximumSelected: function(a) {
                    var b = "You can only select " + a.maximum + " item";
                    return 1 != a.maximum && (b += "s"),
                    b
                },
                noResults: function() {
                    return "No results found"
                },
                searching: function() {
                    return "Searching…"
                }
            }
        }),
        b.define("select2/defaults", ["jquery", "require", "./results", "./selection/single", "./selection/multiple", "./selection/placeholder", "./selection/allowClear", "./selection/search", "./selection/eventRelay", "./utils", "./translation", "./diacritics", "./data/select", "./data/array", "./data/ajax", "./data/tags", "./data/tokenizer", "./data/minimumInputLength", "./data/maximumInputLength", "./data/maximumSelectionLength", "./dropdown", "./dropdown/search", "./dropdown/hidePlaceholder", "./dropdown/infiniteScroll", "./dropdown/attachBody", "./dropdown/minimumResultsForSearch", "./dropdown/selectOnClose", "./dropdown/closeOnSelect", "./i18n/en"], function(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w, x, y, z, A, B, C) {
            function D() {
                this.reset()
            }
            return D.prototype.apply = function(l) {
                if (l = a.extend(!0, {}, this.defaults, l),
                null == l.dataAdapter) {
                    if (null != l.ajax ? l.dataAdapter = o : null != l.data ? l.dataAdapter = n : l.dataAdapter = m,
                    l.minimumInputLength > 0 && (l.dataAdapter = j.Decorate(l.dataAdapter, r)),
                    l.maximumInputLength > 0 && (l.dataAdapter = j.Decorate(l.dataAdapter, s)),
                    l.maximumSelectionLength > 0 && (l.dataAdapter = j.Decorate(l.dataAdapter, t)),
                    l.tags && (l.dataAdapter = j.Decorate(l.dataAdapter, p)),
                    null == l.tokenSeparators && null == l.tokenizer || (l.dataAdapter = j.Decorate(l.dataAdapter, q)),
                    null != l.query) {
                        var C = b(l.amdBase + "compat/query");
                        l.dataAdapter = j.Decorate(l.dataAdapter, C)
                    }
                    if (null != l.initSelection) {
                        var D = b(l.amdBase + "compat/initSelection");
                        l.dataAdapter = j.Decorate(l.dataAdapter, D)
                    }
                }
                if (null == l.resultsAdapter && (l.resultsAdapter = c,
                null != l.ajax && (l.resultsAdapter = j.Decorate(l.resultsAdapter, x)),
                null != l.placeholder && (l.resultsAdapter = j.Decorate(l.resultsAdapter, w)),
                l.selectOnClose && (l.resultsAdapter = j.Decorate(l.resultsAdapter, A))),
                null == l.dropdownAdapter) {
                    if (l.multiple)
                        l.dropdownAdapter = u;
                    else {
                        var E = j.Decorate(u, v);
                        l.dropdownAdapter = E
                    }
                    if (0 !== l.minimumResultsForSearch && (l.dropdownAdapter = j.Decorate(l.dropdownAdapter, z)),
                    l.closeOnSelect && (l.dropdownAdapter = j.Decorate(l.dropdownAdapter, B)),
                    null != l.dropdownCssClass || null != l.dropdownCss || null != l.adaptDropdownCssClass) {
                        var F = b(l.amdBase + "compat/dropdownCss");
                        l.dropdownAdapter = j.Decorate(l.dropdownAdapter, F)
                    }
                    l.dropdownAdapter = j.Decorate(l.dropdownAdapter, y)
                }
                if (null == l.selectionAdapter) {
                    if (l.multiple ? l.selectionAdapter = e : l.selectionAdapter = d,
                    null != l.placeholder && (l.selectionAdapter = j.Decorate(l.selectionAdapter, f)),
                    l.allowClear && (l.selectionAdapter = j.Decorate(l.selectionAdapter, g)),
                    l.multiple && (l.selectionAdapter = j.Decorate(l.selectionAdapter, h)),
                    null != l.containerCssClass || null != l.containerCss || null != l.adaptContainerCssClass) {
                        var G = b(l.amdBase + "compat/containerCss");
                        l.selectionAdapter = j.Decorate(l.selectionAdapter, G)
                    }
                    l.selectionAdapter = j.Decorate(l.selectionAdapter, i)
                }
                if ("string" == typeof l.language)
                    if (l.language.indexOf("-") > 0) {
                        var H = l.language.split("-")
                          , I = H[0];
                        l.language = [l.language, I]
                    } else
                        l.language = [l.language];
                if (a.isArray(l.language)) {
                    var J = new k;
                    l.language.push("en");
                    for (var K = l.language, L = 0; L < K.length; L++) {
                        var M = K[L]
                          , N = {};
                        try {
                            N = k.loadPath(M)
                        } catch (a) {
                            try {
                                M = this.defaults.amdLanguageBase + M,
                                N = k.loadPath(M)
                            } catch (a) {
                                l.debug && window.console && console.warn && console.warn('Select2: The language file for "' + M + '" could not be automatically loaded. A fallback will be used instead.');
                                continue
                            }
                        }
                        J.extend(N)
                    }
                    l.translations = J
                } else {
                    var O = k.loadPath(this.defaults.amdLanguageBase + "en")
                      , P = new k(l.language);
                    P.extend(O),
                    l.translations = P
                }
                return l
            }
            ,
            D.prototype.reset = function() {
                function b(a) {
                    function b(a) {
                        return l[a] || a
                    }
                    return a.replace(/[^\u0000-\u007E]/g, b)
                }
                function c(d, e) {
                    if ("" === a.trim(d.term))
                        return e;
                    if (e.children && e.children.length > 0) {
                        for (var f = a.extend(!0, {}, e), g = e.children.length - 1; g >= 0; g--) {
                            null == c(d, e.children[g]) && f.children.splice(g, 1)
                        }
                        return f.children.length > 0 ? f : c(d, f)
                    }
                    var h = b(e.text).toUpperCase()
                      , i = b(d.term).toUpperCase();
                    return h.indexOf(i) > -1 ? e : null
                }
                this.defaults = {
                    amdBase: "./",
                    amdLanguageBase: "./i18n/",
                    closeOnSelect: !0,
                    debug: !1,
                    dropdownAutoWidth: !1,
                    escapeMarkup: j.escapeMarkup,
                    language: C,
                    matcher: c,
                    minimumInputLength: 0,
                    maximumInputLength: 0,
                    maximumSelectionLength: 0,
                    minimumResultsForSearch: 0,
                    selectOnClose: !1,
                    sorter: function(a) {
                        return a
                    },
                    templateResult: function(a) {
                        return a.text
                    },
                    templateSelection: function(a) {
                        return a.text
                    },
                    theme: "default",
                    width: "resolve"
                }
            }
            ,
            D.prototype.set = function(b, c) {
                var d = a.camelCase(b)
                  , e = {};
                e[d] = c;
                var f = j._convertData(e);
                a.extend(this.defaults, f)
            }
            ,
            new D
        }),
        b.define("select2/options", ["require", "jquery", "./defaults", "./utils"], function(a, b, c, d) {
            function e(b, e) {
                if (this.options = b,
                null != e && this.fromElement(e),
                this.options = c.apply(this.options),
                e && e.is("input")) {
                    var f = a(this.get("amdBase") + "compat/inputData");
                    this.options.dataAdapter = d.Decorate(this.options.dataAdapter, f)
                }
            }
            return e.prototype.fromElement = function(a) {
                var c = ["select2"];
                null == this.options.multiple && (this.options.multiple = a.prop("multiple")),
                null == this.options.disabled && (this.options.disabled = a.prop("disabled")),
                null == this.options.language && (a.prop("lang") ? this.options.language = a.prop("lang").toLowerCase() : a.closest("[lang]").prop("lang") && (this.options.language = a.closest("[lang]").prop("lang"))),
                null == this.options.dir && (a.prop("dir") ? this.options.dir = a.prop("dir") : a.closest("[dir]").prop("dir") ? this.options.dir = a.closest("[dir]").prop("dir") : this.options.dir = "ltr"),
                a.prop("disabled", this.options.disabled),
                a.prop("multiple", this.options.multiple),
                a.data("select2Tags") && (this.options.debug && window.console && console.warn && console.warn('Select2: The `data-select2-tags` attribute has been changed to use the `data-data` and `data-tags="true"` attributes and will be removed in future versions of Select2.'),
                a.data("data", a.data("select2Tags")),
                a.data("tags", !0)),
                a.data("ajaxUrl") && (this.options.debug && window.console && console.warn && console.warn("Select2: The `data-ajax-url` attribute has been changed to `data-ajax--url` and support for the old attribute will be removed in future versions of Select2."),
                a.attr("ajax--url", a.data("ajaxUrl")),
                a.data("ajax--url", a.data("ajaxUrl")));
                var e = {};
                e = b.fn.jquery && "1." == b.fn.jquery.substr(0, 2) && a[0].dataset ? b.extend(!0, {}, a[0].dataset, a.data()) : a.data();
                var f = b.extend(!0, {}, e);
                f = d._convertData(f);
                for (var g in f)
                    b.inArray(g, c) > -1 || (b.isPlainObject(this.options[g]) ? b.extend(this.options[g], f[g]) : this.options[g] = f[g]);
                return this
            }
            ,
            e.prototype.get = function(a) {
                return this.options[a]
            }
            ,
            e.prototype.set = function(a, b) {
                this.options[a] = b
            }
            ,
            e
        }),
        b.define("select2/core", ["jquery", "./options", "./utils", "./keys"], function(a, b, c, d) {
            var e = function(a, c) {
                null != a.data("select2") && a.data("select2").destroy(),
                this.$element = a,
                this.id = this._generateId(a),
                c = c || {},
                this.options = new b(c,a),
                e.__super__.constructor.call(this);
                var d = a.attr("tabindex") || 0;
                a.data("old-tabindex", d),
                a.attr("tabindex", "-1");
                var f = this.options.get("dataAdapter");
                this.dataAdapter = new f(a,this.options);
                var g = this.render();
                this._placeContainer(g);
                var h = this.options.get("selectionAdapter");
                this.selection = new h(a,this.options),
                this.$selection = this.selection.render(),
                this.selection.position(this.$selection, g);
                var i = this.options.get("dropdownAdapter");
                this.dropdown = new i(a,this.options),
                this.$dropdown = this.dropdown.render(),
                this.dropdown.position(this.$dropdown, g);
                var j = this.options.get("resultsAdapter");
                this.results = new j(a,this.options,this.dataAdapter),
                this.$results = this.results.render(),
                this.results.position(this.$results, this.$dropdown);
                var k = this;
                this._bindAdapters(),
                this._registerDomEvents(),
                this._registerDataEvents(),
                this._registerSelectionEvents(),
                this._registerDropdownEvents(),
                this._registerResultsEvents(),
                this._registerEvents(),
                this.dataAdapter.current(function(a) {
                    k.trigger("selection:update", {
                        data: a
                    })
                }),
                a.addClass("select2-hidden-accessible"),
                a.attr("aria-hidden", "true"),
                this._syncAttributes(),
                a.data("select2", this)
            };
            return c.Extend(e, c.Observable),
            e.prototype._generateId = function(a) {
                var b = "";
                return b = null != a.attr("id") ? a.attr("id") : null != a.attr("name") ? a.attr("name") + "-" + c.generateChars(2) : c.generateChars(4),
                b = b.replace(/(:|\.|\[|\]|,)/g, ""),
                b = "select2-" + b
            }
            ,
            e.prototype._placeContainer = function(a) {
                a.insertAfter(this.$element);
                var b = this._resolveWidth(this.$element, this.options.get("width"));
                null != b && a.css("width", b)
            }
            ,
            e.prototype._resolveWidth = function(a, b) {
                var c = /^width:(([-+]?([0-9]*\.)?[0-9]+)(px|em|ex|%|in|cm|mm|pt|pc))/i;
                if ("resolve" == b) {
                    var d = this._resolveWidth(a, "style");
                    return null != d ? d : this._resolveWidth(a, "element")
                }
                if ("element" == b) {
                    var e = a.outerWidth(!1);
                    return e <= 0 ? "auto" : e + "px"
                }
                if ("style" == b) {
                    var f = a.attr("style");
                    if ("string" != typeof f)
                        return null;
                    for (var g = f.split(";"), h = 0, i = g.length; h < i; h += 1) {
                        var j = g[h].replace(/\s/g, "")
                          , k = j.match(c);
                        if (null !== k && k.length >= 1)
                            return k[1]
                    }
                    return null
                }
                return b
            }
            ,
            e.prototype._bindAdapters = function() {
                this.dataAdapter.bind(this, this.$container),
                this.selection.bind(this, this.$container),
                this.dropdown.bind(this, this.$container),
                this.results.bind(this, this.$container)
            }
            ,
            e.prototype._registerDomEvents = function() {
                var b = this;
                this.$element.on("change.select2", function() {
                    b.dataAdapter.current(function(a) {
                        b.trigger("selection:update", {
                            data: a
                        })
                    })
                }),
                this.$element.on("focus.select2", function(a) {
                    b.trigger("focus", a)
                }),
                this._syncA = c.bind(this._syncAttributes, this),
                this._syncS = c.bind(this._syncSubtree, this),
                this.$element[0].attachEvent && this.$element[0].attachEvent("onpropertychange", this._syncA);
                var d = window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver;
                null != d ? (this._observer = new d(function(c) {
                    a.each(c, b._syncA),
                    a.each(c, b._syncS)
                }
                ),
                this._observer.observe(this.$element[0], {
                    attributes: !0,
                    childList: !0,
                    subtree: !1
                })) : this.$element[0].addEventListener && (this.$element[0].addEventListener("DOMAttrModified", b._syncA, !1),
                this.$element[0].addEventListener("DOMNodeInserted", b._syncS, !1),
                this.$element[0].addEventListener("DOMNodeRemoved", b._syncS, !1))
            }
            ,
            e.prototype._registerDataEvents = function() {
                var a = this;
                this.dataAdapter.on("*", function(b, c) {
                    a.trigger(b, c)
                })
            }
            ,
            e.prototype._registerSelectionEvents = function() {
                var b = this
                  , c = ["toggle", "focus"];
                this.selection.on("toggle", function() {
                    b.toggleDropdown()
                }),
                this.selection.on("focus", function(a) {
                    b.focus(a)
                }),
                this.selection.on("*", function(d, e) {
                    -1 === a.inArray(d, c) && b.trigger(d, e)
                })
            }
            ,
            e.prototype._registerDropdownEvents = function() {
                var a = this;
                this.dropdown.on("*", function(b, c) {
                    a.trigger(b, c)
                })
            }
            ,
            e.prototype._registerResultsEvents = function() {
                var a = this;
                this.results.on("*", function(b, c) {
                    a.trigger(b, c)
                })
            }
            ,
            e.prototype._registerEvents = function() {
                var a = this;
                this.on("open", function() {
                    a.$container.addClass("select2-container--open")
                }),
                this.on("close", function() {
                    a.$container.removeClass("select2-container--open")
                }),
                this.on("enable", function() {
                    a.$container.removeClass("select2-container--disabled")
                }),
                this.on("disable", function() {
                    a.$container.addClass("select2-container--disabled")
                }),
                this.on("blur", function() {
                    a.$container.removeClass("select2-container--focus")
                }),
                this.on("query", function(b) {
                    a.isOpen() || a.trigger("open", {}),
                    this.dataAdapter.query(b, function(c) {
                        a.trigger("results:all", {
                            data: c,
                            query: b
                        })
                    })
                }),
                this.on("query:append", function(b) {
                    this.dataAdapter.query(b, function(c) {
                        a.trigger("results:append", {
                            data: c,
                            query: b
                        })
                    })
                }),
                this.on("keypress", function(b) {
                    var c = b.which;
                    a.isOpen() ? c === d.ESC || c === d.TAB || c === d.UP && b.altKey ? (a.close(),
                    b.preventDefault()) : c === d.ENTER ? (a.trigger("results:select", {}),
                    b.preventDefault()) : c === d.SPACE && b.ctrlKey ? (a.trigger("results:toggle", {}),
                    b.preventDefault()) : c === d.UP ? (a.trigger("results:previous", {}),
                    b.preventDefault()) : c === d.DOWN && (a.trigger("results:next", {}),
                    b.preventDefault()) : (c === d.ENTER || c === d.SPACE || c === d.DOWN && b.altKey) && (a.open(),
                    b.preventDefault())
                })
            }
            ,
            e.prototype._syncAttributes = function() {
                this.options.set("disabled", this.$element.prop("disabled")),
                this.options.get("disabled") ? (this.isOpen() && this.close(),
                this.trigger("disable", {})) : this.trigger("enable", {})
            }
            ,
            e.prototype._syncSubtree = function(a, b) {
                var c = !1
                  , d = this;
                if (!a || !a.target || "OPTION" === a.target.nodeName || "OPTGROUP" === a.target.nodeName) {
                    if (b)
                        if (b.addedNodes && b.addedNodes.length > 0)
                            for (var e = 0; e < b.addedNodes.length; e++) {
                                var f = b.addedNodes[e];
                                f.selected && (c = !0)
                            }
                        else
                            b.removedNodes && b.removedNodes.length > 0 && (c = !0);
                    else
                        c = !0;
                    c && this.dataAdapter.current(function(a) {
                        d.trigger("selection:update", {
                            data: a
                        })
                    })
                }
            }
            ,
            e.prototype.trigger = function(a, b) {
                var c = e.__super__.trigger
                  , d = {
                    open: "opening",
                    close: "closing",
                    select: "selecting",
                    unselect: "unselecting"
                };
                if (void 0 === b && (b = {}),
                a in d) {
                    var f = d[a]
                      , g = {
                        prevented: !1,
                        name: a,
                        args: b
                    };
                    if (c.call(this, f, g),
                    g.prevented)
                        return void (b.prevented = !0)
                }
                c.call(this, a, b)
            }
            ,
            e.prototype.toggleDropdown = function() {
                this.options.get("disabled") || (this.isOpen() ? this.close() : this.open())
            }
            ,
            e.prototype.open = function() {
                this.isOpen() || this.trigger("query", {})
            }
            ,
            e.prototype.close = function() {
                this.isOpen() && this.trigger("close", {})
            }
            ,
            e.prototype.isOpen = function() {
                return this.$container.hasClass("select2-container--open")
            }
            ,
            e.prototype.hasFocus = function() {
                return this.$container.hasClass("select2-container--focus")
            }
            ,
            e.prototype.focus = function(a) {
                this.hasFocus() || (this.$container.addClass("select2-container--focus"),
                this.trigger("focus", {}))
            }
            ,
            e.prototype.enable = function(a) {
                this.options.get("debug") && window.console && console.warn && console.warn('Select2: The `select2("enable")` method has been deprecated and will be removed in later Select2 versions. Use $element.prop("disabled") instead.'),
                null != a && 0 !== a.length || (a = [!0]);
                var b = !a[0];
                this.$element.prop("disabled", b)
            }
            ,
            e.prototype.data = function() {
                this.options.get("debug") && arguments.length > 0 && window.console && console.warn && console.warn('Select2: Data can no longer be set using `select2("data")`. You should consider setting the value instead using `$element.val()`.');
                var a = [];
                return this.dataAdapter.current(function(b) {
                    a = b
                }),
                a
            }
            ,
            e.prototype.val = function(b) {
                if (this.options.get("debug") && window.console && console.warn && console.warn('Select2: The `select2("val")` method has been deprecated and will be removed in later Select2 versions. Use $element.val() instead.'),
                null == b || 0 === b.length)
                    return this.$element.val();
                var c = b[0];
                a.isArray(c) && (c = a.map(c, function(a) {
                    return a.toString()
                })),
                this.$element.val(c).trigger("change")
            }
            ,
            e.prototype.destroy = function() {
                this.$container.remove(),
                this.$element[0].detachEvent && this.$element[0].detachEvent("onpropertychange", this._syncA),
                null != this._observer ? (this._observer.disconnect(),
                this._observer = null) : this.$element[0].removeEventListener && (this.$element[0].removeEventListener("DOMAttrModified", this._syncA, !1),
                this.$element[0].removeEventListener("DOMNodeInserted", this._syncS, !1),
                this.$element[0].removeEventListener("DOMNodeRemoved", this._syncS, !1)),
                this._syncA = null,
                this._syncS = null,
                this.$element.off(".select2"),
                this.$element.attr("tabindex", this.$element.data("old-tabindex")),
                this.$element.removeClass("select2-hidden-accessible"),
                this.$element.attr("aria-hidden", "false"),
                this.$element.removeData("select2"),
                this.dataAdapter.destroy(),
                this.selection.destroy(),
                this.dropdown.destroy(),
                this.results.destroy(),
                this.dataAdapter = null,
                this.selection = null,
                this.dropdown = null,
                this.results = null
            }
            ,
            e.prototype.render = function() {
                var b = a('<span class="select2 select2-container"><span class="selection"></span><span class="dropdown-wrapper" aria-hidden="true"></span></span>');
                return b.attr("dir", this.options.get("dir")),
                this.$container = b,
                this.$container.addClass("select2-container--" + this.options.get("theme")),
                b.data("element", this.$element),
                b
            }
            ,
            e
        }),
        b.define("jquery-mousewheel", ["jquery"], function(a) {
            return a
        }),
        b.define("jquery.select2", ["jquery", "jquery-mousewheel", "./select2/core", "./select2/defaults"], function(a, b, c, d) {
            if (null == a.fn.select2) {
                var e = ["open", "close", "destroy"];
                a.fn.select2 = function(b) {
                    if ("object" == typeof (b = b || {}))
                        return this.each(function() {
                            var d = a.extend(!0, {}, b);
                            new c(a(this),d)
                        }),
                        this;
                    if ("string" == typeof b) {
                        var d, f = Array.prototype.slice.call(arguments, 1);
                        return this.each(function() {
                            var c = a(this).data("select2");
                            null == c && window.console && console.error && console.error("The select2('" + b + "') method was called on an element that is not using Select2."),
                            d = c[b].apply(c, f)
                        }),
                        a.inArray(b, e) > -1 ? this : d
                    }
                    throw new Error("Invalid arguments for Select2: " + b)
                }
            }
            return null == a.fn.select2.defaults && (a.fn.select2.defaults = d),
            c
        }),
        {
            define: b.define,
            require: b.require
        }
    }()
      , c = b.require("jquery.select2");
    return a.fn.select2.amd = b,
    c
});
/*! nouislider - 8.2.1 - 2015-12-02 21:43:14 */

!function(a) {
    "function" == typeof define && define.amd ? define([], a) : "object" == typeof exports ? module.exports = a() : window.noUiSlider = a()
}(function() {
    "use strict";
    function a(a) {
        return a.filter(function(a) {
            return this[a] ? !1 : this[a] = !0
        }, {})
    }
    function b(a, b) {
        return Math.round(a / b) * b
    }
    function c(a) {
        var b = a.getBoundingClientRect()
          , c = a.ownerDocument
          , d = c.documentElement
          , e = m();
        return /webkit.*Chrome.*Mobile/i.test(navigator.userAgent) && (e.x = 0),
        {
            top: b.top + e.y - d.clientTop,
            left: b.left + e.x - d.clientLeft
        }
    }
    function d(a) {
        return "number" == typeof a && !isNaN(a) && isFinite(a)
    }
    function e(a) {
        var b = Math.pow(10, 7);
        return Number((Math.round(a * b) / b).toFixed(7))
    }
    function f(a, b, c) {
        j(a, b),
        setTimeout(function() {
            k(a, b)
        }, c)
    }
    function g(a) {
        return Math.max(Math.min(a, 100), 0)
    }
    function h(a) {
        return Array.isArray(a) ? a : [a]
    }
    function i(a) {
        var b = a.split(".");
        return b.length > 1 ? b[1].length : 0
    }
    function j(a, b) {
        a.classList ? a.classList.add(b) : a.className += " " + b
    }
    function k(a, b) {
        a.classList ? a.classList.remove(b) : a.className = a.className.replace(new RegExp("(^|\\b)" + b.split(" ").join("|") + "(\\b|$)","gi"), " ")
    }
    function l(a, b) {
        a.classList ? a.classList.contains(b) : new RegExp("(^| )" + b + "( |$)","gi").test(a.className)
    }
    function m() {
        var a = void 0 !== window.pageXOffset
          , b = "CSS1Compat" === (document.compatMode || "")
          , c = a ? window.pageXOffset : b ? document.documentElement.scrollLeft : document.body.scrollLeft
          , d = a ? window.pageYOffset : b ? document.documentElement.scrollTop : document.body.scrollTop;
        return {
            x: c,
            y: d
        }
    }
    function n(a) {
        a.stopPropagation()
    }
    function o(a) {
        return function(b) {
            return a + b
        }
    }
    function p(a, b) {
        return 100 / (b - a)
    }
    function q(a, b) {
        return 100 * b / (a[1] - a[0])
    }
    function r(a, b) {
        return q(a, a[0] < 0 ? b + Math.abs(a[0]) : b - a[0])
    }
    function s(a, b) {
        return b * (a[1] - a[0]) / 100 + a[0]
    }
    function t(a, b) {
        for (var c = 1; a >= b[c]; )
            c += 1;
        return c
    }
    function u(a, b, c) {
        if (c >= a.slice(-1)[0])
            return 100;
        var d, e, f, g, h = t(c, a);
        return d = a[h - 1],
        e = a[h],
        f = b[h - 1],
        g = b[h],
        f + r([d, e], c) / p(f, g)
    }
    function v(a, b, c) {
        if (c >= 100)
            return a.slice(-1)[0];
        var d, e, f, g, h = t(c, b);
        return d = a[h - 1],
        e = a[h],
        f = b[h - 1],
        g = b[h],
        s([d, e], (c - f) * p(f, g))
    }
    function w(a, c, d, e) {
        if (100 === e)
            return e;
        var f, g, h = t(e, a);
        return d ? (f = a[h - 1],
        g = a[h],
        e - f > (g - f) / 2 ? g : f) : c[h - 1] ? a[h - 1] + b(e - a[h - 1], c[h - 1]) : e
    }
    function x(a, b, c) {
        var e;
        if ("number" == typeof b && (b = [b]),
        "[object Array]" !== Object.prototype.toString.call(b))
            throw new Error("noUiSlider: 'range' contains invalid value.");
        if (e = "min" === a ? 0 : "max" === a ? 100 : parseFloat(a),
        !d(e) || !d(b[0]))
            throw new Error("noUiSlider: 'range' value isn't numeric.");
        c.xPct.push(e),
        c.xVal.push(b[0]),
        e ? c.xSteps.push(isNaN(b[1]) ? !1 : b[1]) : isNaN(b[1]) || (c.xSteps[0] = b[1])
    }
    function y(a, b, c) {
        return b ? void (c.xSteps[a] = q([c.xVal[a], c.xVal[a + 1]], b) / p(c.xPct[a], c.xPct[a + 1])) : !0
    }
    function z(a, b, c, d) {
        this.xPct = [],
        this.xVal = [],
        this.xSteps = [d || !1],
        this.xNumSteps = [!1],
        this.snap = b,
        this.direction = c;
        var e, f = [];
        for (e in a)
            a.hasOwnProperty(e) && f.push([a[e], e]);
        for (f.length && "object" == typeof f[0][0] ? f.sort(function(a, b) {
            return a[0][0] - b[0][0]
        }) : f.sort(function(a, b) {
            return a[0] - b[0]
        }),
        e = 0; e < f.length; e++)
            x(f[e][1], f[e][0], this);
        for (this.xNumSteps = this.xSteps.slice(0),
        e = 0; e < this.xNumSteps.length; e++)
            y(e, this.xNumSteps[e], this)
    }
    function A(a, b) {
        if (!d(b))
            throw new Error("noUiSlider: 'step' is not numeric.");
        a.singleStep = b
    }
    function B(a, b) {
        if ("object" != typeof b || Array.isArray(b))
            throw new Error("noUiSlider: 'range' is not an object.");
        if (void 0 === b.min || void 0 === b.max)
            throw new Error("noUiSlider: Missing 'min' or 'max' in 'range'.");
        if (b.min === b.max)
            throw new Error("noUiSlider: 'range' 'min' and 'max' cannot be equal.");
        a.spectrum = new z(b,a.snap,a.dir,a.singleStep)
    }
    function C(a, b) {
        if (b = h(b),
        !Array.isArray(b) || !b.length || b.length > 2)
            throw new Error("noUiSlider: 'start' option is incorrect.");
        a.handles = b.length,
        a.start = b
    }
    function D(a, b) {
        if (a.snap = b,
        "boolean" != typeof b)
            throw new Error("noUiSlider: 'snap' option must be a boolean.")
    }
    function E(a, b) {
        if (a.animate = b,
        "boolean" != typeof b)
            throw new Error("noUiSlider: 'animate' option must be a boolean.")
    }
    function F(a, b) {
        if ("lower" === b && 1 === a.handles)
            a.connect = 1;
        else if ("upper" === b && 1 === a.handles)
            a.connect = 2;
        else if (b === !0 && 2 === a.handles)
            a.connect = 3;
        else {
            if (b !== !1)
                throw new Error("noUiSlider: 'connect' option doesn't match handle count.");
            a.connect = 0
        }
    }
    function G(a, b) {
        switch (b) {
        case "horizontal":
            a.ort = 0;
            break;
        case "vertical":
            a.ort = 1;
            break;
        default:
            throw new Error("noUiSlider: 'orientation' option is invalid.")
        }
    }
    function H(a, b) {
        if (!d(b))
            throw new Error("noUiSlider: 'margin' option must be numeric.");
        if (a.margin = a.spectrum.getMargin(b),
        !a.margin)
            throw new Error("noUiSlider: 'margin' option is only supported on linear sliders.")
    }
    function I(a, b) {
        if (!d(b))
            throw new Error("noUiSlider: 'limit' option must be numeric.");
        if (a.limit = a.spectrum.getMargin(b),
        !a.limit)
            throw new Error("noUiSlider: 'limit' option is only supported on linear sliders.")
    }
    function J(a, b) {
        switch (b) {
        case "ltr":
            a.dir = 0;
            break;
        case "rtl":
            a.dir = 1,
            a.connect = [0, 2, 1, 3][a.connect];
            break;
        default:
            throw new Error("noUiSlider: 'direction' option was not recognized.")
        }
    }
    function K(a, b) {
        if ("string" != typeof b)
            throw new Error("noUiSlider: 'behaviour' must be a string containing options.");
        var c = b.indexOf("tap") >= 0
          , d = b.indexOf("drag") >= 0
          , e = b.indexOf("fixed") >= 0
          , f = b.indexOf("snap") >= 0
          , g = b.indexOf("hover") >= 0;
        if (d && !a.connect)
            throw new Error("noUiSlider: 'drag' behaviour must be used with 'connect': true.");
        a.events = {
            tap: c || f,
            drag: d,
            fixed: e,
            snap: f,
            hover: g
        }
    }
    function L(a, b) {
        var c;
        if (b !== !1)
            if (b === !0)
                for (a.tooltips = [],
                c = 0; c < a.handles; c++)
                    a.tooltips.push(!0);
            else {
                if (a.tooltips = h(b),
                a.tooltips.length !== a.handles)
                    throw new Error("noUiSlider: must pass a formatter for all handles.");
                a.tooltips.forEach(function(a) {
                    if ("boolean" != typeof a && ("object" != typeof a || "function" != typeof a.to))
                        throw new Error("noUiSlider: 'tooltips' must be passed a formatter or 'false'.")
                })
            }
    }
    function M(a, b) {
        if (a.format = b,
        "function" == typeof b.to && "function" == typeof b.from)
            return !0;
        throw new Error("noUiSlider: 'format' requires 'to' and 'from' methods.")
    }
    function N(a, b) {
        if (void 0 !== b && "string" != typeof b)
            throw new Error("noUiSlider: 'cssPrefix' must be a string.");
        a.cssPrefix = b
    }
    function O(a) {
        var b, c = {
            margin: 0,
            limit: 0,
            animate: !0,
            format: T
        };
        b = {
            step: {
                r: !1,
                t: A
            },
            start: {
                r: !0,
                t: C
            },
            connect: {
                r: !0,
                t: F
            },
            direction: {
                r: !0,
                t: J
            },
            snap: {
                r: !1,
                t: D
            },
            animate: {
                r: !1,
                t: E
            },
            range: {
                r: !0,
                t: B
            },
            orientation: {
                r: !1,
                t: G
            },
            margin: {
                r: !1,
                t: H
            },
            limit: {
                r: !1,
                t: I
            },
            behaviour: {
                r: !0,
                t: K
            },
            format: {
                r: !1,
                t: M
            },
            tooltips: {
                r: !1,
                t: L
            },
            cssPrefix: {
                r: !1,
                t: N
            }
        };
        var d = {
            connect: !1,
            direction: "ltr",
            behaviour: "tap",
            orientation: "horizontal"
        };
        return Object.keys(b).forEach(function(e) {
            if (void 0 === a[e] && void 0 === d[e]) {
                if (b[e].r)
                    throw new Error("noUiSlider: '" + e + "' is required.");
                return !0
            }
            b[e].t(c, void 0 === a[e] ? d[e] : a[e])
        }),
        c.pips = a.pips,
        c.style = c.ort ? "top" : "left",
        c
    }
    function P(b, d) {
        function e(a, b, c) {
            var d = a + b[0]
              , e = a + b[1];
            return c ? (0 > d && (e += Math.abs(d)),
            e > 100 && (d -= e - 100),
            [g(d), g(e)]) : [d, e]
        }
        function p(a, b) {
            a.preventDefault();
            var c, d, e = 0 === a.type.indexOf("touch"), f = 0 === a.type.indexOf("mouse"), g = 0 === a.type.indexOf("pointer"), h = a;
            return 0 === a.type.indexOf("MSPointer") && (g = !0),
            e && (c = a.changedTouches[0].pageX,
            d = a.changedTouches[0].pageY),
            b = b || m(),
            (f || g) && (c = a.clientX + b.x,
            d = a.clientY + b.y),
            h.pageOffset = b,
            h.points = [c, d],
            h.cursor = f || g,
            h
        }
        function q(a, b) {
            var c = document.createElement("div")
              , d = document.createElement("div")
              , e = ["-lower", "-upper"];
            return a && e.reverse(),
            j(d, da[3]),
            j(d, da[3] + e[b]),
            j(c, da[2]),
            c.appendChild(d),
            c
        }
        function r(a, b, c) {
            switch (a) {
            case 1:
                j(b, da[7]),
                j(c[0], da[6]);
                break;
            case 3:
                j(c[1], da[6]);
            case 2:
                j(c[0], da[7]);
            case 0:
                j(b, da[6])
            }
        }
        function s(a, b, c) {
            var d, e = [];
            for (d = 0; a > d; d += 1)
                e.push(c.appendChild(q(b, d)));
            return e
        }
        function t(a, b, c) {
            j(c, da[0]),
            j(c, da[8 + a]),
            j(c, da[4 + b]);
            var d = document.createElement("div");
            return j(d, da[1]),
            c.appendChild(d),
            d
        }
        function u(a, b) {
            if (!d.tooltips[b])
                return !1;
            var c = document.createElement("div");
            return c.className = da[18],
            a.firstChild.appendChild(c)
        }
        function v() {
            d.dir && d.tooltips.reverse();
            var a = Y.map(u);
            d.dir && (a.reverse(),
            d.tooltips.reverse()),
            U("update", function(b, c, e) {
                a[c] && (a[c].innerHTML = d.tooltips[c] === !0 ? b[c] : d.tooltips[c].to(e[c]))
            })
        }
        function w(a, b, c) {
            if ("range" === a || "steps" === a)
                return aa.xVal;
            if ("count" === a) {
                var d, e = 100 / (b - 1), f = 0;
                for (b = []; (d = f++ * e) <= 100; )
                    b.push(d);
                a = "positions"
            }
            return "positions" === a ? b.map(function(a) {
                return aa.fromStepping(c ? aa.getStep(a) : a)
            }) : "values" === a ? c ? b.map(function(a) {
                return aa.fromStepping(aa.getStep(aa.toStepping(a)))
            }) : b : void 0
        }
        function x(b, c, d) {
            function e(a, b) {
                return (a + b).toFixed(7) / 1
            }
            var f = aa.direction
              , g = {}
              , h = aa.xVal[0]
              , i = aa.xVal[aa.xVal.length - 1]
              , j = !1
              , k = !1
              , l = 0;
            return aa.direction = 0,
            d = a(d.slice().sort(function(a, b) {
                return a - b
            })),
            d[0] !== h && (d.unshift(h),
            j = !0),
            d[d.length - 1] !== i && (d.push(i),
            k = !0),
            d.forEach(function(a, f) {
                var h, i, m, n, o, p, q, r, s, t, u = a, v = d[f + 1];
                if ("steps" === c && (h = aa.xNumSteps[f]),
                h || (h = v - u),
                u !== !1 && void 0 !== v)
                    for (i = u; v >= i; i = e(i, h)) {
                        for (n = aa.toStepping(i),
                        o = n - l,
                        r = o / b,
                        s = Math.round(r),
                        t = o / s,
                        m = 1; s >= m; m += 1)
                            p = l + m * t,
                            g[p.toFixed(5)] = ["x", 0];
                        q = d.indexOf(i) > -1 ? 1 : "steps" === c ? 2 : 0,
                        !f && j && (q = 0),
                        i === v && k || (g[n.toFixed(5)] = [i, q]),
                        l = n
                    }
            }),
            aa.direction = f,
            g
        }
        function y(a, b, c) {
            function e(a) {
                return ["-normal", "-large", "-sub"][a]
            }
            function f(a, b, c) {
                return 'class="' + b + " " + b + "-" + h + " " + b + e(c[1]) + '" style="' + d.style + ": " + a + '%"'
            }
            function g(a, d) {
                aa.direction && (a = 100 - a),
                d[1] = d[1] && b ? b(d[0], d[1]) : d[1],
                i.innerHTML += "<div " + f(a, da[21], d) + "></div>",
                d[1] && (i.innerHTML += "<div " + f(a, da[22], d) + ">" + c.to(d[0]) + "</div>")
            }
            var h = ["horizontal", "vertical"][d.ort]
              , i = document.createElement("div");
            return j(i, da[20]),
            j(i, da[20] + "-" + h),
            Object.keys(a).forEach(function(b) {
                g(b, a[b])
            }),
            i
        }
        function z(a) {
            var b = a.mode
              , c = a.density || 1
              , d = a.filter || !1
              , e = a.values || !1
              , f = a.stepped || !1
              , g = w(b, e, f)
              , h = x(c, b, g)
              , i = a.format || {
                to: Math.round
            };
            return $.appendChild(y(h, d, i))
        }
        function A() {
            return X["offset" + ["Width", "Height"][d.ort]]
        }
        function B(a, b, c) {
            void 0 !== b && 1 !== d.handles && (b = Math.abs(b - d.dir)),
            Object.keys(ca).forEach(function(d) {
                var e = d.split(".")[0];
                a === e && ca[d].forEach(function(a) {
                    a.call(Z, h(P()), b, h(C(Array.prototype.slice.call(ba))), c || !1)
                })
            })
        }
        function C(a) {
            return 1 === a.length ? a[0] : d.dir ? a.reverse() : a
        }
        function D(a, b, c, e) {
            var f = function(b) {
                return $.hasAttribute("disabled") ? !1 : l($, da[14]) ? !1 : (b = p(b, e.pageOffset),
                a === R.start && void 0 !== b.buttons && b.buttons > 1 ? !1 : e.hover && b.buttons ? !1 : (b.calcPoint = b.points[d.ort],
                void c(b, e)))
            }
              , g = [];
            return a.split(" ").forEach(function(a) {
                b.addEventListener(a, f, !1),
                g.push([a, f])
            }),
            g
        }
        function E(a, b) {
            if (-1 === navigator.appVersion.indexOf("MSIE 9") && 0 === a.buttons && 0 !== b.buttonsProperty)
                return F(a, b);
            var c, d, f = b.handles || Y, g = !1, h = 100 * (a.calcPoint - b.start) / b.baseSize, i = f[0] === Y[0] ? 0 : 1;
            if (c = e(h, b.positions, f.length > 1),
            g = L(f[0], c[i], 1 === f.length),
            f.length > 1) {
                if (g = L(f[1], c[i ? 0 : 1], !1) || g)
                    for (d = 0; d < b.handles.length; d++)
                        B("slide", d)
            } else
                g && B("slide", i)
        }
        function F(a, b) {
            var c = X.querySelector("." + da[15])
              , d = b.handles[0] === Y[0] ? 0 : 1;
            null !== c && k(c, da[15]),
            a.cursor && (document.body.style.cursor = "",
            document.body.removeEventListener("selectstart", document.body.noUiListener));
            var e = document.documentElement;
            e.noUiListeners.forEach(function(a) {
                e.removeEventListener(a[0], a[1])
            }),
            k($, da[12]),
            B("set", d),
            B("change", d),
            void 0 !== b.handleNumber && B("end", b.handleNumber)
        }
        function G(a, b) {
            "mouseout" === a.type && "HTML" === a.target.nodeName && null === a.relatedTarget && F(a, b)
        }
        function H(a, b) {
            var c = document.documentElement;
            if (1 === b.handles.length && (j(b.handles[0].children[0], da[15]),
            b.handles[0].hasAttribute("disabled")))
                return !1;
            a.preventDefault(),
            a.stopPropagation();
            var d = D(R.move, c, E, {
                start: a.calcPoint,
                baseSize: A(),
                pageOffset: a.pageOffset,
                handles: b.handles,
                handleNumber: b.handleNumber,
                buttonsProperty: a.buttons,
                positions: [_[0], _[Y.length - 1]]
            })
              , e = D(R.end, c, F, {
                handles: b.handles,
                handleNumber: b.handleNumber
            })
              , f = D("mouseout", c, G, {
                handles: b.handles,
                handleNumber: b.handleNumber
            });
            if (c.noUiListeners = d.concat(e, f),
            a.cursor) {
                document.body.style.cursor = getComputedStyle(a.target).cursor,
                Y.length > 1 && j($, da[12]);
                var g = function() {
                    return !1
                };
                document.body.noUiListener = g,
                document.body.addEventListener("selectstart", g, !1)
            }
            void 0 !== b.handleNumber && B("start", b.handleNumber)
        }
        function I(a) {
            var b, e, g = a.calcPoint, h = 0;
            return a.stopPropagation(),
            Y.forEach(function(a) {
                h += c(a)[d.style]
            }),
            b = h / 2 > g || 1 === Y.length ? 0 : 1,
            g -= c(X)[d.style],
            e = 100 * g / A(),
            d.events.snap || f($, da[14], 300),
            Y[b].hasAttribute("disabled") ? !1 : (L(Y[b], e),
            B("slide", b, !0),
            B("set", b, !0),
            B("change", b, !0),
            void (d.events.snap && H(a, {
                handles: [Y[b]]
            })))
        }
        function J(a) {
            var b = a.calcPoint - c(X)[d.style]
              , e = aa.getStep(100 * b / A())
              , f = aa.fromStepping(e);
            Object.keys(ca).forEach(function(a) {
                "hover" === a.split(".")[0] && ca[a].forEach(function(a) {
                    a.call(Z, f)
                })
            })
        }
        function K(a) {
            var b, c;
            if (!a.fixed)
                for (b = 0; b < Y.length; b += 1)
                    D(R.start, Y[b].children[0], H, {
                        handles: [Y[b]],
                        handleNumber: b
                    });
            if (a.tap && D(R.start, X, I, {
                handles: Y
            }),
            a.hover)
                for (D(R.move, X, J, {
                    hover: !0
                }),
                b = 0; b < Y.length; b += 1)
                    ["mousemove MSPointerMove pointermove"].forEach(function(a) {
                        Y[b].children[0].addEventListener(a, n, !1)
                    });
            a.drag && (c = [X.querySelector("." + da[7])],
            j(c[0], da[10]),
            a.fixed && c.push(Y[c[0] === Y[0] ? 1 : 0].children[0]),
            c.forEach(function(a) {
                D(R.start, a, H, {
                    handles: Y
                })
            }))
        }
        function L(a, b, c) {
            var e = a !== Y[0] ? 1 : 0
              , f = _[0] + d.margin
              , h = _[1] - d.margin
              , i = _[0] + d.limit
              , l = _[1] - d.limit;
            return Y.length > 1 && (b = e ? Math.max(b, f) : Math.min(b, h)),
            c !== !1 && d.limit && Y.length > 1 && (b = e ? Math.min(b, i) : Math.max(b, l)),
            b = aa.getStep(b),
            b = g(parseFloat(b.toFixed(7))),
            b === _[e] ? !1 : (window.requestAnimationFrame ? window.requestAnimationFrame(function() {
                a.style[d.style] = b + "%"
            }) : a.style[d.style] = b + "%",
            a.previousSibling || (k(a, da[17]),
            b > 50 && j(a, da[17])),
            _[e] = b,
            ba[e] = aa.fromStepping(b),
            B("update", e),
            !0)
        }
        function M(a, b) {
            var c, e, f;
            for (d.limit && (a += 1),
            c = 0; a > c; c += 1)
                e = c % 2,
                f = b[e],
                null !== f && f !== !1 && ("number" == typeof f && (f = String(f)),
                f = d.format.from(f),
                (f === !1 || isNaN(f) || L(Y[e], aa.toStepping(f), c === 3 - d.dir) === !1) && B("update", e))
        }
        function N(a) {
            var b, c, e = h(a);
            for (d.dir && d.handles > 1 && e.reverse(),
            d.animate && -1 !== _[0] && f($, da[14], 300),
            b = Y.length > 1 ? 3 : 1,
            1 === e.length && (b = 1),
            M(b, e),
            c = 0; c < Y.length; c++)
                B("set", c)
        }
        function P() {
            var a, b = [];
            for (a = 0; a < d.handles; a += 1)
                b[a] = d.format.to(ba[a]);
            return C(b)
        }
        function Q() {
            da.forEach(function(a) {
                a && k($, a)
            }),
            $.innerHTML = "",
            delete $.noUiSlider
        }
        function T() {
            var a = _.map(function(a, b) {
                var c = aa.getApplicableStep(a)
                  , d = i(String(c[2]))
                  , e = ba[b]
                  , f = 100 === a ? null : c[2]
                  , g = Number((e - c[2]).toFixed(d))
                  , h = 0 === a ? null : g >= c[1] ? c[2] : c[0] || !1;
                return [h, f]
            });
            return C(a)
        }
        function U(a, b) {
            ca[a] = ca[a] || [],
            ca[a].push(b),
            "update" === a.split(".")[0] && Y.forEach(function(a, b) {
                B("update", b)
            })
        }
        function V(a) {
            var b = a.split(".")[0]
              , c = a.substring(b.length);
            Object.keys(ca).forEach(function(a) {
                var d = a.split(".")[0]
                  , e = a.substring(d.length);
                b && b !== d || c && c !== e || delete ca[a]
            })
        }
        function W(a) {
            var b, c = P(), e = O({
                start: [0, 0],
                margin: a.margin,
                limit: a.limit,
                step: a.step,
                range: a.range,
                animate: a.animate,
                snap: void 0 === a.snap ? d.snap : a.snap
            });
            for (["margin", "limit", "step", "range", "animate"].forEach(function(b) {
                void 0 !== a[b] && (d[b] = a[b])
            }),
            aa = e.spectrum,
            _ = [-1, -1],
            N(c),
            b = 0; b < Y.length; b++)
                B("update", b)
        }
        var X, Y, Z, $ = b, _ = [-1, -1], aa = d.spectrum, ba = [], ca = {}, da = ["target", "base", "origin", "handle", "horizontal", "vertical", "background", "connect", "ltr", "rtl", "draggable", "", "state-drag", "", "state-tap", "active", "", "stacking", "tooltip", "", "pips", "marker", "value"].map(o(d.cssPrefix || S));
        if ($.noUiSlider)
            throw new Error("Slider was already initialized.");
        return X = t(d.dir, d.ort, $),
        Y = s(d.handles, d.dir, X),
        r(d.connect, $, Y),
        d.pips && z(d.pips),
        d.tooltips && v(),
        Z = {
            destroy: Q,
            steps: T,
            on: U,
            off: V,
            get: P,
            set: N,
            updateOptions: W
        },
        K(d.events),
        Z
    }
    function Q(a, b) {
        if (!a.nodeName)
            throw new Error("noUiSlider.create requires a single element.");
        var c = O(b, a)
          , d = P(a, c);
        return d.set(c.start),
        a.noUiSlider = d,
        d
    }
    var R = window.navigator.pointerEnabled ? {
        start: "pointerdown",
        move: "pointermove",
        end: "pointerup"
    } : window.navigator.msPointerEnabled ? {
        start: "MSPointerDown",
        move: "MSPointerMove",
        end: "MSPointerUp"
    } : {
        start: "mousedown touchstart",
        move: "mousemove touchmove",
        end: "mouseup touchend"
    }
      , S = "noUi-";
    z.prototype.getMargin = function(a) {
        return 2 === this.xPct.length ? q(this.xVal, a) : !1
    }
    ,
    z.prototype.toStepping = function(a) {
        return a = u(this.xVal, this.xPct, a),
        this.direction && (a = 100 - a),
        a
    }
    ,
    z.prototype.fromStepping = function(a) {
        return this.direction && (a = 100 - a),
        e(v(this.xVal, this.xPct, a))
    }
    ,
    z.prototype.getStep = function(a) {
        return this.direction && (a = 100 - a),
        a = w(this.xPct, this.xSteps, this.snap, a),
        this.direction && (a = 100 - a),
        a
    }
    ,
    z.prototype.getApplicableStep = function(a) {
        var b = t(a, this.xPct)
          , c = 100 === a ? 2 : 1;
        return [this.xNumSteps[b - 2], this.xVal[b - c], this.xNumSteps[b - c]]
    }
    ,
    z.prototype.convert = function(a) {
        return this.getStep(this.toStepping(a))
    }
    ;
    var T = {
        to: function(a) {
            return void 0 !== a && a.toFixed(2)
        },
        from: Number
    };
    return {
        create: Q
    }
});
/**
 * jQuery serializeObject
 * @copyright 2014, macek <paulmacek@gmail.com>
 * @link https://github.com/macek/jquery-serialize-object
 * @license BSD
 * @version 2.5.0
 */
!function(e, i) {
    if ("function" == typeof define && define.amd)
        define(["exports", "jquery"], function(e, r) {
            return i(e, r)
        });
    else if ("undefined" != typeof exports) {
        var r = require("jquery");
        i(exports, r)
    } else
        i(e, e.jQuery || e.Zepto || e.ender || e.$)
}(this, function(e, i) {
    function r(e, r) {
        function n(e, i, r) {
            return e[i] = r,
            e
        }
        function a(e, i) {
            for (var r, a = e.match(t.key); void 0 !== (r = a.pop()); )
                if (t.push.test(r)) {
                    var u = s(e.replace(/\[\]$/, ""));
                    i = n([], u, i)
                } else
                    t.fixed.test(r) ? i = n([], r, i) : t.named.test(r) && (i = n({}, r, i));
            return i
        }
        function s(e) {
            return void 0 === h[e] && (h[e] = 0),
            h[e]++
        }
        function u(e) {
            switch (i('[name="' + e.name + '"]', r).attr("type")) {
            case "checkbox":
                return "on" === e.value ? !0 : e.value;
            default:
                return e.value
            }
        }
        function f(i) {
            if (!t.validate.test(i.name))
                return this;
            var r = a(i.name, u(i));
            return l = e.extend(!0, l, r),
            this
        }
        function d(i) {
            if (!e.isArray(i))
                throw new Error("formSerializer.addPairs expects an Array");
            for (var r = 0, t = i.length; t > r; r++)
                this.addPair(i[r]);
            return this
        }
        function o() {
            return l
        }
        function c() {
            return JSON.stringify(o())
        }
        var l = {}
          , h = {};
        this.addPair = f,
        this.addPairs = d,
        this.serialize = o,
        this.serializeJSON = c
    }
    var t = {
        validate: /^[a-z_][a-z0-9_]*(?:\[(?:\d*|[a-z0-9_]+)\])*$/i,
        key: /[a-z0-9_]+|(?=\[\])/gi,
        push: /^$/,
        fixed: /^\d+$/,
        named: /^[a-z0-9_]+$/i
    };
    return r.patterns = t,
    r.serializeObject = function() {
        return new r(i,this).addPairs(this.serializeArray()).serialize()
    }
    ,
    r.serializeJSON = function() {
        return new r(i,this).addPairs(this.serializeArray()).serializeJSON()
    }
    ,
    "undefined" != typeof i.fn && (i.fn.serializeObject = r.serializeObject,
    i.fn.serializeJSON = r.serializeJSON),
    e.FormSerializer = r,
    r
});

//! moment.js
//! version : 2.15.2
//! authors : Tim Wood, Iskren Chernev, Moment.js contributors
//! license : MIT
//! momentjs.com
!function(a, b) {
    "object" == typeof exports && "undefined" != typeof module ? module.exports = b() : "function" == typeof define && define.amd ? define(b) : a.moment = b()
}(this, function() {
    "use strict";
    function a() {
        return md.apply(null, arguments)
    }
    // This is done to register the method called with moment()
    // without creating circular dependencies.
    function b(a) {
        md = a
    }
    function c(a) {
        return a instanceof Array || "[object Array]" === Object.prototype.toString.call(a)
    }
    function d(a) {
        // IE8 will treat undefined and null as object if it wasn't for
        // input != null
        return null != a && "[object Object]" === Object.prototype.toString.call(a)
    }
    function e(a) {
        var b;
        for (b in a)
            // even if its not own property I'd still call it non-empty
            return !1;
        return !0
    }
    function f(a) {
        return a instanceof Date || "[object Date]" === Object.prototype.toString.call(a)
    }
    function g(a, b) {
        var c, d = [];
        for (c = 0; c < a.length; ++c)
            d.push(b(a[c], c));
        return d
    }
    function h(a, b) {
        return Object.prototype.hasOwnProperty.call(a, b)
    }
    function i(a, b) {
        for (var c in b)
            h(b, c) && (a[c] = b[c]);
        return h(b, "toString") && (a.toString = b.toString),
        h(b, "valueOf") && (a.valueOf = b.valueOf),
        a
    }
    function j(a, b, c, d) {
        return qb(a, b, c, d, !0).utc()
    }
    function k() {
        // We need to deep clone this object.
        return {
            empty: !1,
            unusedTokens: [],
            unusedInput: [],
            overflow: -2,
            charsLeftOver: 0,
            nullInput: !1,
            invalidMonth: null,
            invalidFormat: !1,
            userInvalidated: !1,
            iso: !1,
            parsedDateParts: [],
            meridiem: null
        }
    }
    function l(a) {
        return null == a._pf && (a._pf = k()),
        a._pf
    }
    function m(a) {
        if (null == a._isValid) {
            var b = l(a)
              , c = nd.call(b.parsedDateParts, function(a) {
                return null != a
            })
              , d = !isNaN(a._d.getTime()) && b.overflow < 0 && !b.empty && !b.invalidMonth && !b.invalidWeekday && !b.nullInput && !b.invalidFormat && !b.userInvalidated && (!b.meridiem || b.meridiem && c);
            if (a._strict && (d = d && 0 === b.charsLeftOver && 0 === b.unusedTokens.length && void 0 === b.bigHour),
            null != Object.isFrozen && Object.isFrozen(a))
                return d;
            a._isValid = d
        }
        return a._isValid
    }
    function n(a) {
        var b = j(NaN);
        return null != a ? i(l(b), a) : l(b).userInvalidated = !0,
        b
    }
    function o(a) {
        return void 0 === a
    }
    function p(a, b) {
        var c, d, e;
        if (o(b._isAMomentObject) || (a._isAMomentObject = b._isAMomentObject),
        o(b._i) || (a._i = b._i),
        o(b._f) || (a._f = b._f),
        o(b._l) || (a._l = b._l),
        o(b._strict) || (a._strict = b._strict),
        o(b._tzm) || (a._tzm = b._tzm),
        o(b._isUTC) || (a._isUTC = b._isUTC),
        o(b._offset) || (a._offset = b._offset),
        o(b._pf) || (a._pf = l(b)),
        o(b._locale) || (a._locale = b._locale),
        od.length > 0)
            for (c in od)
                d = od[c],
                e = b[d],
                o(e) || (a[d] = e);
        return a
    }
    // Moment prototype object
    function q(b) {
        p(this, b),
        this._d = new Date(null != b._d ? b._d.getTime() : NaN),
        // Prevent infinite loop in case updateOffset creates new moment
        // objects.
        pd === !1 && (pd = !0,
        a.updateOffset(this),
        pd = !1)
    }
    function r(a) {
        return a instanceof q || null != a && null != a._isAMomentObject
    }
    function s(a) {
        return a < 0 ? Math.ceil(a) || 0 : Math.floor(a)
    }
    function t(a) {
        var b = +a
          , c = 0;
        return 0 !== b && isFinite(b) && (c = s(b)),
        c
    }
    // compare two arrays, return the number of differences
    function u(a, b, c) {
        var d, e = Math.min(a.length, b.length), f = Math.abs(a.length - b.length), g = 0;
        for (d = 0; d < e; d++)
            (c && a[d] !== b[d] || !c && t(a[d]) !== t(b[d])) && g++;
        return g + f
    }
    function v(b) {
        a.suppressDeprecationWarnings === !1 && "undefined" != typeof console && console.warn && console.warn("Deprecation warning: " + b)
    }
    function w(b, c) {
        var d = !0;
        return i(function() {
            if (null != a.deprecationHandler && a.deprecationHandler(null, b),
            d) {
                for (var e, f = [], g = 0; g < arguments.length; g++) {
                    if (e = "",
                    "object" == typeof arguments[g]) {
                        e += "\n[" + g + "] ";
                        for (var h in arguments[0])
                            e += h + ": " + arguments[0][h] + ", ";
                        e = e.slice(0, -2)
                    } else
                        e = arguments[g];
                    f.push(e)
                }
                v(b + "\nArguments: " + Array.prototype.slice.call(f).join("") + "\n" + (new Error).stack),
                d = !1
            }
            return c.apply(this, arguments)
        }, c)
    }
    function x(b, c) {
        null != a.deprecationHandler && a.deprecationHandler(b, c),
        qd[b] || (v(c),
        qd[b] = !0)
    }
    function y(a) {
        return a instanceof Function || "[object Function]" === Object.prototype.toString.call(a)
    }
    function z(a) {
        var b, c;
        for (c in a)
            b = a[c],
            y(b) ? this[c] = b : this["_" + c] = b;
        this._config = a,
        // Lenient ordinal parsing accepts just a number in addition to
        // number + (possibly) stuff coming from _ordinalParseLenient.
        this._ordinalParseLenient = new RegExp(this._ordinalParse.source + "|" + /\d{1,2}/.source)
    }
    function A(a, b) {
        var c, e = i({}, a);
        for (c in b)
            h(b, c) && (d(a[c]) && d(b[c]) ? (e[c] = {},
            i(e[c], a[c]),
            i(e[c], b[c])) : null != b[c] ? e[c] = b[c] : delete e[c]);
        for (c in a)
            h(a, c) && !h(b, c) && d(a[c]) && (// make sure changes to properties don't modify parent config
            e[c] = i({}, e[c]));
        return e
    }
    function B(a) {
        null != a && this.set(a)
    }
    function C(a, b, c) {
        var d = this._calendar[a] || this._calendar.sameElse;
        return y(d) ? d.call(b, c) : d
    }
    function D(a) {
        var b = this._longDateFormat[a]
          , c = this._longDateFormat[a.toUpperCase()];
        return b || !c ? b : (this._longDateFormat[a] = c.replace(/MMMM|MM|DD|dddd/g, function(a) {
            return a.slice(1)
        }),
        this._longDateFormat[a])
    }
    function E() {
        return this._invalidDate
    }
    function F(a) {
        return this._ordinal.replace("%d", a)
    }
    function G(a, b, c, d) {
        var e = this._relativeTime[c];
        return y(e) ? e(a, b, c, d) : e.replace(/%d/i, a)
    }
    function H(a, b) {
        var c = this._relativeTime[a > 0 ? "future" : "past"];
        return y(c) ? c(b) : c.replace(/%s/i, b)
    }
    function I(a, b) {
        var c = a.toLowerCase();
        zd[c] = zd[c + "s"] = zd[b] = a
    }
    function J(a) {
        return "string" == typeof a ? zd[a] || zd[a.toLowerCase()] : void 0
    }
    function K(a) {
        var b, c, d = {};
        for (c in a)
            h(a, c) && (b = J(c),
            b && (d[b] = a[c]));
        return d
    }
    function L(a, b) {
        Ad[a] = b
    }
    function M(a) {
        var b = [];
        for (var c in a)
            b.push({
                unit: c,
                priority: Ad[c]
            });
        return b.sort(function(a, b) {
            return a.priority - b.priority
        }),
        b
    }
    function N(b, c) {
        return function(d) {
            return null != d ? (P(this, b, d),
            a.updateOffset(this, c),
            this) : O(this, b)
        }
    }
    function O(a, b) {
        return a.isValid() ? a._d["get" + (a._isUTC ? "UTC" : "") + b]() : NaN
    }
    function P(a, b, c) {
        a.isValid() && a._d["set" + (a._isUTC ? "UTC" : "") + b](c)
    }
    // MOMENTS
    function Q(a) {
        return a = J(a),
        y(this[a]) ? this[a]() : this
    }
    function R(a, b) {
        if ("object" == typeof a) {
            a = K(a);
            for (var c = M(a), d = 0; d < c.length; d++)
                this[c[d].unit](a[c[d].unit])
        } else if (a = J(a),
        y(this[a]))
            return this[a](b);
        return this
    }
    function S(a, b, c) {
        var d = "" + Math.abs(a)
          , e = b - d.length
          , f = a >= 0;
        return (f ? c ? "+" : "" : "-") + Math.pow(10, Math.max(0, e)).toString().substr(1) + d
    }
    // token:    'M'
    // padded:   ['MM', 2]
    // ordinal:  'Mo'
    // callback: function () { this.month() + 1 }
    function T(a, b, c, d) {
        var e = d;
        "string" == typeof d && (e = function() {
            return this[d]()
        }
        ),
        a && (Ed[a] = e),
        b && (Ed[b[0]] = function() {
            return S(e.apply(this, arguments), b[1], b[2])
        }
        ),
        c && (Ed[c] = function() {
            return this.localeData().ordinal(e.apply(this, arguments), a)
        }
        )
    }
    function U(a) {
        return a.match(/\[[\s\S]/) ? a.replace(/^\[|\]$/g, "") : a.replace(/\\/g, "")
    }
    function V(a) {
        var b, c, d = a.match(Bd);
        for (b = 0,
        c = d.length; b < c; b++)
            Ed[d[b]] ? d[b] = Ed[d[b]] : d[b] = U(d[b]);
        return function(b) {
            var e, f = "";
            for (e = 0; e < c; e++)
                f += d[e]instanceof Function ? d[e].call(b, a) : d[e];
            return f
        }
    }
    // format date using native date object
    function W(a, b) {
        return a.isValid() ? (b = X(b, a.localeData()),
        Dd[b] = Dd[b] || V(b),
        Dd[b](a)) : a.localeData().invalidDate()
    }
    function X(a, b) {
        function c(a) {
            return b.longDateFormat(a) || a
        }
        var d = 5;
        for (Cd.lastIndex = 0; d >= 0 && Cd.test(a); )
            a = a.replace(Cd, c),
            Cd.lastIndex = 0,
            d -= 1;
        return a
    }
    function Y(a, b, c) {
        Wd[a] = y(b) ? b : function(a, d) {
            return a && c ? c : b
        }
    }
    function Z(a, b) {
        return h(Wd, a) ? Wd[a](b._strict, b._locale) : new RegExp($(a))
    }
    // Code from http://stackoverflow.com/questions/3561493/is-there-a-regexp-escape-function-in-javascript
    function $(a) {
        return _(a.replace("\\", "").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g, function(a, b, c, d, e) {
            return b || c || d || e
        }))
    }
    function _(a) {
        return a.replace(/[-\/\\^$*+?.()|[\]{}]/g, "\\$&")
    }
    function aa(a, b) {
        var c, d = b;
        for ("string" == typeof a && (a = [a]),
        "number" == typeof b && (d = function(a, c) {
            c[b] = t(a)
        }
        ),
        c = 0; c < a.length; c++)
            Xd[a[c]] = d
    }
    function ba(a, b) {
        aa(a, function(a, c, d, e) {
            d._w = d._w || {},
            b(a, d._w, d, e)
        })
    }
    function ca(a, b, c) {
        null != b && h(Xd, a) && Xd[a](b, c._a, c, a)
    }
    function da(a, b) {
        return new Date(Date.UTC(a, b + 1, 0)).getUTCDate()
    }
    function ea(a, b) {
        return a ? c(this._months) ? this._months[a.month()] : this._months[(this._months.isFormat || fe).test(b) ? "format" : "standalone"][a.month()] : this._months
    }
    function fa(a, b) {
        return a ? c(this._monthsShort) ? this._monthsShort[a.month()] : this._monthsShort[fe.test(b) ? "format" : "standalone"][a.month()] : this._monthsShort
    }
    function ga(a, b, c) {
        var d, e, f, g = a.toLocaleLowerCase();
        if (!this._monthsParse)
            for (// this is not used
            this._monthsParse = [],
            this._longMonthsParse = [],
            this._shortMonthsParse = [],
            d = 0; d < 12; ++d)
                f = j([2e3, d]),
                this._shortMonthsParse[d] = this.monthsShort(f, "").toLocaleLowerCase(),
                this._longMonthsParse[d] = this.months(f, "").toLocaleLowerCase();
        return c ? "MMM" === b ? (e = sd.call(this._shortMonthsParse, g),
        e !== -1 ? e : null) : (e = sd.call(this._longMonthsParse, g),
        e !== -1 ? e : null) : "MMM" === b ? (e = sd.call(this._shortMonthsParse, g),
        e !== -1 ? e : (e = sd.call(this._longMonthsParse, g),
        e !== -1 ? e : null)) : (e = sd.call(this._longMonthsParse, g),
        e !== -1 ? e : (e = sd.call(this._shortMonthsParse, g),
        e !== -1 ? e : null))
    }
    function ha(a, b, c) {
        var d, e, f;
        if (this._monthsParseExact)
            return ga.call(this, a, b, c);
        // TODO: add sorting
        // Sorting makes sure if one month (or abbr) is a prefix of another
        // see sorting in computeMonthsParse
        for (this._monthsParse || (this._monthsParse = [],
        this._longMonthsParse = [],
        this._shortMonthsParse = []),
        d = 0; d < 12; d++) {
            // test the regex
            if (// make the regex if we don't have it already
            e = j([2e3, d]),
            c && !this._longMonthsParse[d] && (this._longMonthsParse[d] = new RegExp("^" + this.months(e, "").replace(".", "") + "$","i"),
            this._shortMonthsParse[d] = new RegExp("^" + this.monthsShort(e, "").replace(".", "") + "$","i")),
            c || this._monthsParse[d] || (f = "^" + this.months(e, "") + "|^" + this.monthsShort(e, ""),
            this._monthsParse[d] = new RegExp(f.replace(".", ""),"i")),
            c && "MMMM" === b && this._longMonthsParse[d].test(a))
                return d;
            if (c && "MMM" === b && this._shortMonthsParse[d].test(a))
                return d;
            if (!c && this._monthsParse[d].test(a))
                return d
        }
    }
    // MOMENTS
    function ia(a, b) {
        var c;
        if (!a.isValid())
            // No op
            return a;
        if ("string" == typeof b)
            if (/^\d+$/.test(b))
                b = t(b);
            else // TODO: Another silent failure?
            if (b = a.localeData().monthsParse(b),
            "number" != typeof b)
                return a;
        return c = Math.min(a.date(), da(a.year(), b)),
        a._d["set" + (a._isUTC ? "UTC" : "") + "Month"](b, c),
        a
    }
    function ja(b) {
        return null != b ? (ia(this, b),
        a.updateOffset(this, !0),
        this) : O(this, "Month")
    }
    function ka() {
        return da(this.year(), this.month())
    }
    function la(a) {
        return this._monthsParseExact ? (h(this, "_monthsRegex") || na.call(this),
        a ? this._monthsShortStrictRegex : this._monthsShortRegex) : (h(this, "_monthsShortRegex") || (this._monthsShortRegex = ie),
        this._monthsShortStrictRegex && a ? this._monthsShortStrictRegex : this._monthsShortRegex)
    }
    function ma(a) {
        return this._monthsParseExact ? (h(this, "_monthsRegex") || na.call(this),
        a ? this._monthsStrictRegex : this._monthsRegex) : (h(this, "_monthsRegex") || (this._monthsRegex = je),
        this._monthsStrictRegex && a ? this._monthsStrictRegex : this._monthsRegex)
    }
    function na() {
        function a(a, b) {
            return b.length - a.length
        }
        var b, c, d = [], e = [], f = [];
        for (b = 0; b < 12; b++)
            // make the regex if we don't have it already
            c = j([2e3, b]),
            d.push(this.monthsShort(c, "")),
            e.push(this.months(c, "")),
            f.push(this.months(c, "")),
            f.push(this.monthsShort(c, ""));
        for (// Sorting makes sure if one month (or abbr) is a prefix of another it
        // will match the longer piece.
        d.sort(a),
        e.sort(a),
        f.sort(a),
        b = 0; b < 12; b++)
            d[b] = _(d[b]),
            e[b] = _(e[b]);
        for (b = 0; b < 24; b++)
            f[b] = _(f[b]);
        this._monthsRegex = new RegExp("^(" + f.join("|") + ")","i"),
        this._monthsShortRegex = this._monthsRegex,
        this._monthsStrictRegex = new RegExp("^(" + e.join("|") + ")","i"),
        this._monthsShortStrictRegex = new RegExp("^(" + d.join("|") + ")","i")
    }
    // HELPERS
    function oa(a) {
        return pa(a) ? 366 : 365
    }
    function pa(a) {
        return a % 4 === 0 && a % 100 !== 0 || a % 400 === 0
    }
    function qa() {
        return pa(this.year())
    }
    function ra(a, b, c, d, e, f, g) {
        //can't just apply() to create a date:
        //http://stackoverflow.com/questions/181348/instantiating-a-javascript-object-by-calling-prototype-constructor-apply
        var h = new Date(a,b,c,d,e,f,g);
        //the date constructor remaps years 0-99 to 1900-1999
        return a < 100 && a >= 0 && isFinite(h.getFullYear()) && h.setFullYear(a),
        h
    }
    function sa(a) {
        var b = new Date(Date.UTC.apply(null, arguments));
        //the Date.UTC function remaps years 0-99 to 1900-1999
        return a < 100 && a >= 0 && isFinite(b.getUTCFullYear()) && b.setUTCFullYear(a),
        b
    }
    // start-of-first-week - start-of-year
    function ta(a, b, c) {
        var // first-week day -- which january is always in the first week (4 for iso, 1 for other)
        d = 7 + b - c
          , // first-week day local weekday -- which local weekday is fwd
        e = (7 + sa(a, 0, d).getUTCDay() - b) % 7;
        return -e + d - 1
    }
    //http://en.wikipedia.org/wiki/ISO_week_date#Calculating_a_date_given_the_year.2C_week_number_and_weekday
    function ua(a, b, c, d, e) {
        var f, g, h = (7 + c - d) % 7, i = ta(a, d, e), j = 1 + 7 * (b - 1) + h + i;
        return j <= 0 ? (f = a - 1,
        g = oa(f) + j) : j > oa(a) ? (f = a + 1,
        g = j - oa(a)) : (f = a,
        g = j),
        {
            year: f,
            dayOfYear: g
        }
    }
    function va(a, b, c) {
        var d, e, f = ta(a.year(), b, c), g = Math.floor((a.dayOfYear() - f - 1) / 7) + 1;
        return g < 1 ? (e = a.year() - 1,
        d = g + wa(e, b, c)) : g > wa(a.year(), b, c) ? (d = g - wa(a.year(), b, c),
        e = a.year() + 1) : (e = a.year(),
        d = g),
        {
            week: d,
            year: e
        }
    }
    function wa(a, b, c) {
        var d = ta(a, b, c)
          , e = ta(a + 1, b, c);
        return (oa(a) - d + e) / 7
    }
    // HELPERS
    // LOCALES
    function xa(a) {
        return va(a, this._week.dow, this._week.doy).week
    }
    function ya() {
        return this._week.dow
    }
    function za() {
        return this._week.doy
    }
    // MOMENTS
    function Aa(a) {
        var b = this.localeData().week(this);
        return null == a ? b : this.add(7 * (a - b), "d")
    }
    function Ba(a) {
        var b = va(this, 1, 4).week;
        return null == a ? b : this.add(7 * (a - b), "d")
    }
    // HELPERS
    function Ca(a, b) {
        return "string" != typeof a ? a : isNaN(a) ? (a = b.weekdaysParse(a),
        "number" == typeof a ? a : null) : parseInt(a, 10)
    }
    function Da(a, b) {
        return "string" == typeof a ? b.weekdaysParse(a) % 7 || 7 : isNaN(a) ? null : a
    }
    function Ea(a, b) {
        return a ? c(this._weekdays) ? this._weekdays[a.day()] : this._weekdays[this._weekdays.isFormat.test(b) ? "format" : "standalone"][a.day()] : this._weekdays
    }
    function Fa(a) {
        return a ? this._weekdaysShort[a.day()] : this._weekdaysShort
    }
    function Ga(a) {
        return a ? this._weekdaysMin[a.day()] : this._weekdaysMin
    }
    function Ha(a, b, c) {
        var d, e, f, g = a.toLocaleLowerCase();
        if (!this._weekdaysParse)
            for (this._weekdaysParse = [],
            this._shortWeekdaysParse = [],
            this._minWeekdaysParse = [],
            d = 0; d < 7; ++d)
                f = j([2e3, 1]).day(d),
                this._minWeekdaysParse[d] = this.weekdaysMin(f, "").toLocaleLowerCase(),
                this._shortWeekdaysParse[d] = this.weekdaysShort(f, "").toLocaleLowerCase(),
                this._weekdaysParse[d] = this.weekdays(f, "").toLocaleLowerCase();
        return c ? "dddd" === b ? (e = sd.call(this._weekdaysParse, g),
        e !== -1 ? e : null) : "ddd" === b ? (e = sd.call(this._shortWeekdaysParse, g),
        e !== -1 ? e : null) : (e = sd.call(this._minWeekdaysParse, g),
        e !== -1 ? e : null) : "dddd" === b ? (e = sd.call(this._weekdaysParse, g),
        e !== -1 ? e : (e = sd.call(this._shortWeekdaysParse, g),
        e !== -1 ? e : (e = sd.call(this._minWeekdaysParse, g),
        e !== -1 ? e : null))) : "ddd" === b ? (e = sd.call(this._shortWeekdaysParse, g),
        e !== -1 ? e : (e = sd.call(this._weekdaysParse, g),
        e !== -1 ? e : (e = sd.call(this._minWeekdaysParse, g),
        e !== -1 ? e : null))) : (e = sd.call(this._minWeekdaysParse, g),
        e !== -1 ? e : (e = sd.call(this._weekdaysParse, g),
        e !== -1 ? e : (e = sd.call(this._shortWeekdaysParse, g),
        e !== -1 ? e : null)))
    }
    function Ia(a, b, c) {
        var d, e, f;
        if (this._weekdaysParseExact)
            return Ha.call(this, a, b, c);
        for (this._weekdaysParse || (this._weekdaysParse = [],
        this._minWeekdaysParse = [],
        this._shortWeekdaysParse = [],
        this._fullWeekdaysParse = []),
        d = 0; d < 7; d++) {
            // test the regex
            if (// make the regex if we don't have it already
            e = j([2e3, 1]).day(d),
            c && !this._fullWeekdaysParse[d] && (this._fullWeekdaysParse[d] = new RegExp("^" + this.weekdays(e, "").replace(".", ".?") + "$","i"),
            this._shortWeekdaysParse[d] = new RegExp("^" + this.weekdaysShort(e, "").replace(".", ".?") + "$","i"),
            this._minWeekdaysParse[d] = new RegExp("^" + this.weekdaysMin(e, "").replace(".", ".?") + "$","i")),
            this._weekdaysParse[d] || (f = "^" + this.weekdays(e, "") + "|^" + this.weekdaysShort(e, "") + "|^" + this.weekdaysMin(e, ""),
            this._weekdaysParse[d] = new RegExp(f.replace(".", ""),"i")),
            c && "dddd" === b && this._fullWeekdaysParse[d].test(a))
                return d;
            if (c && "ddd" === b && this._shortWeekdaysParse[d].test(a))
                return d;
            if (c && "dd" === b && this._minWeekdaysParse[d].test(a))
                return d;
            if (!c && this._weekdaysParse[d].test(a))
                return d
        }
    }
    // MOMENTS
    function Ja(a) {
        if (!this.isValid())
            return null != a ? this : NaN;
        var b = this._isUTC ? this._d.getUTCDay() : this._d.getDay();
        return null != a ? (a = Ca(a, this.localeData()),
        this.add(a - b, "d")) : b
    }
    function Ka(a) {
        if (!this.isValid())
            return null != a ? this : NaN;
        var b = (this.day() + 7 - this.localeData()._week.dow) % 7;
        return null == a ? b : this.add(a - b, "d")
    }
    function La(a) {
        if (!this.isValid())
            return null != a ? this : NaN;
        // behaves the same as moment#day except
        // as a getter, returns 7 instead of 0 (1-7 range instead of 0-6)
        // as a setter, sunday should belong to the previous week.
        if (null != a) {
            var b = Da(a, this.localeData());
            return this.day(this.day() % 7 ? b : b - 7)
        }
        return this.day() || 7
    }
    function Ma(a) {
        return this._weekdaysParseExact ? (h(this, "_weekdaysRegex") || Pa.call(this),
        a ? this._weekdaysStrictRegex : this._weekdaysRegex) : (h(this, "_weekdaysRegex") || (this._weekdaysRegex = pe),
        this._weekdaysStrictRegex && a ? this._weekdaysStrictRegex : this._weekdaysRegex)
    }
    function Na(a) {
        return this._weekdaysParseExact ? (h(this, "_weekdaysRegex") || Pa.call(this),
        a ? this._weekdaysShortStrictRegex : this._weekdaysShortRegex) : (h(this, "_weekdaysShortRegex") || (this._weekdaysShortRegex = qe),
        this._weekdaysShortStrictRegex && a ? this._weekdaysShortStrictRegex : this._weekdaysShortRegex)
    }
    function Oa(a) {
        return this._weekdaysParseExact ? (h(this, "_weekdaysRegex") || Pa.call(this),
        a ? this._weekdaysMinStrictRegex : this._weekdaysMinRegex) : (h(this, "_weekdaysMinRegex") || (this._weekdaysMinRegex = re),
        this._weekdaysMinStrictRegex && a ? this._weekdaysMinStrictRegex : this._weekdaysMinRegex)
    }
    function Pa() {
        function a(a, b) {
            return b.length - a.length
        }
        var b, c, d, e, f, g = [], h = [], i = [], k = [];
        for (b = 0; b < 7; b++)
            // make the regex if we don't have it already
            c = j([2e3, 1]).day(b),
            d = this.weekdaysMin(c, ""),
            e = this.weekdaysShort(c, ""),
            f = this.weekdays(c, ""),
            g.push(d),
            h.push(e),
            i.push(f),
            k.push(d),
            k.push(e),
            k.push(f);
        for (// Sorting makes sure if one weekday (or abbr) is a prefix of another it
        // will match the longer piece.
        g.sort(a),
        h.sort(a),
        i.sort(a),
        k.sort(a),
        b = 0; b < 7; b++)
            h[b] = _(h[b]),
            i[b] = _(i[b]),
            k[b] = _(k[b]);
        this._weekdaysRegex = new RegExp("^(" + k.join("|") + ")","i"),
        this._weekdaysShortRegex = this._weekdaysRegex,
        this._weekdaysMinRegex = this._weekdaysRegex,
        this._weekdaysStrictRegex = new RegExp("^(" + i.join("|") + ")","i"),
        this._weekdaysShortStrictRegex = new RegExp("^(" + h.join("|") + ")","i"),
        this._weekdaysMinStrictRegex = new RegExp("^(" + g.join("|") + ")","i")
    }
    // FORMATTING
    function Qa() {
        return this.hours() % 12 || 12
    }
    function Ra() {
        return this.hours() || 24
    }
    function Sa(a, b) {
        T(a, 0, 0, function() {
            return this.localeData().meridiem(this.hours(), this.minutes(), b)
        })
    }
    // PARSING
    function Ta(a, b) {
        return b._meridiemParse
    }
    // LOCALES
    function Ua(a) {
        // IE8 Quirks Mode & IE7 Standards Mode do not allow accessing strings like arrays
        // Using charAt should be more compatible.
        return "p" === (a + "").toLowerCase().charAt(0)
    }
    function Va(a, b, c) {
        return a > 11 ? c ? "pm" : "PM" : c ? "am" : "AM"
    }
    function Wa(a) {
        return a ? a.toLowerCase().replace("_", "-") : a
    }
    // pick the locale from the array
    // try ['en-au', 'en-gb'] as 'en-au', 'en-gb', 'en', as in move through the list trying each
    // substring from most specific to least, but move to the next array item if it's a more specific variant than the current root
    function Xa(a) {
        for (var b, c, d, e, f = 0; f < a.length; ) {
            for (e = Wa(a[f]).split("-"),
            b = e.length,
            c = Wa(a[f + 1]),
            c = c ? c.split("-") : null; b > 0; ) {
                if (d = Ya(e.slice(0, b).join("-")))
                    return d;
                if (c && c.length >= b && u(e, c, !0) >= b - 1)
                    //the next array item is better than a shallower substring of this one
                    break;
                b--
            }
            f++
        }
        return null
    }
    function Ya(a) {
        var b = null;
        // TODO: Find a better way to register and load all the locales in Node
        if (!we[a] && "undefined" != typeof module && module && module.exports)
            try {
                b = se._abbr,
                require("./locale/" + a),
                // because defineLocale currently also sets the global locale, we
                // want to undo that for lazy loaded locales
                Za(b)
            } catch (a) {}
        return we[a]
    }
    // This function will load locale and then set the global locale.  If
    // no arguments are passed in, it will simply return the current global
    // locale key.
    function Za(a, b) {
        var c;
        // moment.duration._locale = moment._locale = data;
        return a && (c = o(b) ? ab(a) : $a(a, b),
        c && (se = c)),
        se._abbr
    }
    function $a(a, b) {
        if (null !== b) {
            var c = ve;
            // treat as if there is no base config
            // backwards compat for now: also set the locale
            return b.abbr = a,
            null != we[a] ? (x("defineLocaleOverride", "use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),
            c = we[a]._config) : null != b.parentLocale && (null != we[b.parentLocale] ? c = we[b.parentLocale]._config : x("parentLocaleUndefined", "specified parentLocale is not defined yet. See http://momentjs.com/guides/#/warnings/parent-locale/")),
            we[a] = new B(A(c, b)),
            Za(a),
            we[a]
        }
        // useful for testing
        return delete we[a],
        null
    }
    function _a(a, b) {
        if (null != b) {
            var c, d = ve;
            // MERGE
            null != we[a] && (d = we[a]._config),
            b = A(d, b),
            c = new B(b),
            c.parentLocale = we[a],
            we[a] = c,
            // backwards compat for now: also set the locale
            Za(a)
        } else
            // pass null for config to unupdate, useful for tests
            null != we[a] && (null != we[a].parentLocale ? we[a] = we[a].parentLocale : null != we[a] && delete we[a]);
        return we[a]
    }
    // returns locale data
    function ab(a) {
        var b;
        if (a && a._locale && a._locale._abbr && (a = a._locale._abbr),
        !a)
            return se;
        if (!c(a)) {
            if (//short-circuit everything else
            b = Ya(a))
                return b;
            a = [a]
        }
        return Xa(a)
    }
    function bb() {
        return rd(we)
    }
    function cb(a) {
        var b, c = a._a;
        return c && l(a).overflow === -2 && (b = c[Zd] < 0 || c[Zd] > 11 ? Zd : c[$d] < 1 || c[$d] > da(c[Yd], c[Zd]) ? $d : c[_d] < 0 || c[_d] > 24 || 24 === c[_d] && (0 !== c[ae] || 0 !== c[be] || 0 !== c[ce]) ? _d : c[ae] < 0 || c[ae] > 59 ? ae : c[be] < 0 || c[be] > 59 ? be : c[ce] < 0 || c[ce] > 999 ? ce : -1,
        l(a)._overflowDayOfYear && (b < Yd || b > $d) && (b = $d),
        l(a)._overflowWeeks && b === -1 && (b = de),
        l(a)._overflowWeekday && b === -1 && (b = ee),
        l(a).overflow = b),
        a
    }
    // date from iso format
    function db(a) {
        var b, c, d, e, f, g, h = a._i, i = xe.exec(h) || ye.exec(h);
        if (i) {
            for (l(a).iso = !0,
            b = 0,
            c = Ae.length; b < c; b++)
                if (Ae[b][1].exec(i[1])) {
                    e = Ae[b][0],
                    d = Ae[b][2] !== !1;
                    break
                }
            if (null == e)
                return void (a._isValid = !1);
            if (i[3]) {
                for (b = 0,
                c = Be.length; b < c; b++)
                    if (Be[b][1].exec(i[3])) {
                        // match[2] should be 'T' or space
                        f = (i[2] || " ") + Be[b][0];
                        break
                    }
                if (null == f)
                    return void (a._isValid = !1)
            }
            if (!d && null != f)
                return void (a._isValid = !1);
            if (i[4]) {
                if (!ze.exec(i[4]))
                    return void (a._isValid = !1);
                g = "Z"
            }
            a._f = e + (f || "") + (g || ""),
            jb(a)
        } else
            a._isValid = !1
    }
    // date from iso format or fallback
    function eb(b) {
        var c = Ce.exec(b._i);
        return null !== c ? void (b._d = new Date(+c[1])) : (db(b),
        void (b._isValid === !1 && (delete b._isValid,
        a.createFromInputFallback(b))))
    }
    // Pick the first defined of two or three arguments.
    function fb(a, b, c) {
        return null != a ? a : null != b ? b : c
    }
    function gb(b) {
        // hooks is actually the exported moment object
        var c = new Date(a.now());
        return b._useUTC ? [c.getUTCFullYear(), c.getUTCMonth(), c.getUTCDate()] : [c.getFullYear(), c.getMonth(), c.getDate()]
    }
    // convert an array to a date.
    // the array should mirror the parameters below
    // note: all values past the year are optional and will default to the lowest possible value.
    // [year, month, day , hour, minute, second, millisecond]
    function hb(a) {
        var b, c, d, e, f = [];
        if (!a._d) {
            // Default to current date.
            // * if no year, month, day of month are given, default to today
            // * if day of month is given, default month and year
            // * if month is given, default only year
            // * if year is given, don't default anything
            for (d = gb(a),
            //compute day of the year from weeks and weekdays
            a._w && null == a._a[$d] && null == a._a[Zd] && ib(a),
            //if the day of the year is set, figure out what it is
            a._dayOfYear && (e = fb(a._a[Yd], d[Yd]),
            a._dayOfYear > oa(e) && (l(a)._overflowDayOfYear = !0),
            c = sa(e, 0, a._dayOfYear),
            a._a[Zd] = c.getUTCMonth(),
            a._a[$d] = c.getUTCDate()),
            b = 0; b < 3 && null == a._a[b]; ++b)
                a._a[b] = f[b] = d[b];
            // Zero out whatever was not defaulted, including time
            for (; b < 7; b++)
                a._a[b] = f[b] = null == a._a[b] ? 2 === b ? 1 : 0 : a._a[b];
            // Check for 24:00:00.000
            24 === a._a[_d] && 0 === a._a[ae] && 0 === a._a[be] && 0 === a._a[ce] && (a._nextDay = !0,
            a._a[_d] = 0),
            a._d = (a._useUTC ? sa : ra).apply(null, f),
            // Apply timezone offset from input. The actual utcOffset can be changed
            // with parseZone.
            null != a._tzm && a._d.setUTCMinutes(a._d.getUTCMinutes() - a._tzm),
            a._nextDay && (a._a[_d] = 24)
        }
    }
    function ib(a) {
        var b, c, d, e, f, g, h, i;
        b = a._w,
        null != b.GG || null != b.W || null != b.E ? (f = 1,
        g = 4,
        // TODO: We need to take the current isoWeekYear, but that depends on
        // how we interpret now (local, utc, fixed offset). So create
        // a now version of current config (take local/utc/offset flags, and
        // create now).
        c = fb(b.GG, a._a[Yd], va(rb(), 1, 4).year),
        d = fb(b.W, 1),
        e = fb(b.E, 1),
        (e < 1 || e > 7) && (i = !0)) : (f = a._locale._week.dow,
        g = a._locale._week.doy,
        c = fb(b.gg, a._a[Yd], va(rb(), f, g).year),
        d = fb(b.w, 1),
        null != b.d ? (// weekday -- low day numbers are considered next week
        e = b.d,
        (e < 0 || e > 6) && (i = !0)) : null != b.e ? (// local weekday -- counting starts from begining of week
        e = b.e + f,
        (b.e < 0 || b.e > 6) && (i = !0)) : // default to begining of week
        e = f),
        d < 1 || d > wa(c, f, g) ? l(a)._overflowWeeks = !0 : null != i ? l(a)._overflowWeekday = !0 : (h = ua(c, d, e, f, g),
        a._a[Yd] = h.year,
        a._dayOfYear = h.dayOfYear)
    }
    // date from string and format string
    function jb(b) {
        // TODO: Move this to another part of the creation flow to prevent circular deps
        if (b._f === a.ISO_8601)
            return void db(b);
        b._a = [],
        l(b).empty = !0;
        // This array is used to make a Date, either with `new Date` or `Date.UTC`
        var c, d, e, f, g, h = "" + b._i, i = h.length, j = 0;
        for (e = X(b._f, b._locale).match(Bd) || [],
        c = 0; c < e.length; c++)
            f = e[c],
            d = (h.match(Z(f, b)) || [])[0],
            // console.log('token', token, 'parsedInput', parsedInput,
            //         'regex', getParseRegexForToken(token, config));
            d && (g = h.substr(0, h.indexOf(d)),
            g.length > 0 && l(b).unusedInput.push(g),
            h = h.slice(h.indexOf(d) + d.length),
            j += d.length),
            // don't parse if it's not a known token
            Ed[f] ? (d ? l(b).empty = !1 : l(b).unusedTokens.push(f),
            ca(f, d, b)) : b._strict && !d && l(b).unusedTokens.push(f);
        // add remaining unparsed input length to the string
        l(b).charsLeftOver = i - j,
        h.length > 0 && l(b).unusedInput.push(h),
        // clear _12h flag if hour is <= 12
        b._a[_d] <= 12 && l(b).bigHour === !0 && b._a[_d] > 0 && (l(b).bigHour = void 0),
        l(b).parsedDateParts = b._a.slice(0),
        l(b).meridiem = b._meridiem,
        // handle meridiem
        b._a[_d] = kb(b._locale, b._a[_d], b._meridiem),
        hb(b),
        cb(b)
    }
    function kb(a, b, c) {
        var d;
        // Fallback
        return null == c ? b : null != a.meridiemHour ? a.meridiemHour(b, c) : null != a.isPM ? (d = a.isPM(c),
        d && b < 12 && (b += 12),
        d || 12 !== b || (b = 0),
        b) : b
    }
    // date from string and array of format strings
    function lb(a) {
        var b, c, d, e, f;
        if (0 === a._f.length)
            return l(a).invalidFormat = !0,
            void (a._d = new Date(NaN));
        for (e = 0; e < a._f.length; e++)
            f = 0,
            b = p({}, a),
            null != a._useUTC && (b._useUTC = a._useUTC),
            b._f = a._f[e],
            jb(b),
            m(b) && (// if there is any input that was not parsed add a penalty for that format
            f += l(b).charsLeftOver,
            //or tokens
            f += 10 * l(b).unusedTokens.length,
            l(b).score = f,
            (null == d || f < d) && (d = f,
            c = b));
        i(a, c || b)
    }
    function mb(a) {
        if (!a._d) {
            var b = K(a._i);
            a._a = g([b.year, b.month, b.day || b.date, b.hour, b.minute, b.second, b.millisecond], function(a) {
                return a && parseInt(a, 10)
            }),
            hb(a)
        }
    }
    function nb(a) {
        var b = new q(cb(ob(a)));
        // Adding is smart enough around DST
        return b._nextDay && (b.add(1, "d"),
        b._nextDay = void 0),
        b
    }
    function ob(a) {
        var b = a._i
          , d = a._f;
        return a._locale = a._locale || ab(a._l),
        null === b || void 0 === d && "" === b ? n({
            nullInput: !0
        }) : ("string" == typeof b && (a._i = b = a._locale.preparse(b)),
        r(b) ? new q(cb(b)) : (c(d) ? lb(a) : f(b) ? a._d = b : d ? jb(a) : pb(a),
        m(a) || (a._d = null),
        a))
    }
    function pb(b) {
        var d = b._i;
        void 0 === d ? b._d = new Date(a.now()) : f(d) ? b._d = new Date(d.valueOf()) : "string" == typeof d ? eb(b) : c(d) ? (b._a = g(d.slice(0), function(a) {
            return parseInt(a, 10)
        }),
        hb(b)) : "object" == typeof d ? mb(b) : "number" == typeof d ? // from milliseconds
        b._d = new Date(d) : a.createFromInputFallback(b)
    }
    function qb(a, b, f, g, h) {
        var i = {};
        // object construction must be done this way.
        // https://github.com/moment/moment/issues/1423
        return "boolean" == typeof f && (g = f,
        f = void 0),
        (d(a) && e(a) || c(a) && 0 === a.length) && (a = void 0),
        i._isAMomentObject = !0,
        i._useUTC = i._isUTC = h,
        i._l = f,
        i._i = a,
        i._f = b,
        i._strict = g,
        nb(i)
    }
    function rb(a, b, c, d) {
        return qb(a, b, c, d, !1)
    }
    // Pick a moment m from moments so that m[fn](other) is true for all
    // other. This relies on the function fn to be transitive.
    //
    // moments should either be an array of moment objects or an array, whose
    // first element is an array of moment objects.
    function sb(a, b) {
        var d, e;
        if (1 === b.length && c(b[0]) && (b = b[0]),
        !b.length)
            return rb();
        for (d = b[0],
        e = 1; e < b.length; ++e)
            b[e].isValid() && !b[e][a](d) || (d = b[e]);
        return d
    }
    // TODO: Use [].sort instead?
    function tb() {
        var a = [].slice.call(arguments, 0);
        return sb("isBefore", a)
    }
    function ub() {
        var a = [].slice.call(arguments, 0);
        return sb("isAfter", a)
    }
    function vb(a) {
        var b = K(a)
          , c = b.year || 0
          , d = b.quarter || 0
          , e = b.month || 0
          , f = b.week || 0
          , g = b.day || 0
          , h = b.hour || 0
          , i = b.minute || 0
          , j = b.second || 0
          , k = b.millisecond || 0;
        // representation for dateAddRemove
        this._milliseconds = +k + 1e3 * j + // 1000
        6e4 * i + // 1000 * 60
        1e3 * h * 60 * 60,
        //using 1000 * 60 * 60 instead of 36e5 to avoid floating point rounding errors https://github.com/moment/moment/issues/2978
        // Because of dateAddRemove treats 24 hours as different from a
        // day when working around DST, we need to store them separately
        this._days = +g + 7 * f,
        // It is impossible translate months into days without knowing
        // which months you are are talking about, so we have to store
        // it separately.
        this._months = +e + 3 * d + 12 * c,
        this._data = {},
        this._locale = ab(),
        this._bubble()
    }
    function wb(a) {
        return a instanceof vb
    }
    function xb(a) {
        return a < 0 ? Math.round(-1 * a) * -1 : Math.round(a)
    }
    // FORMATTING
    function yb(a, b) {
        T(a, 0, 0, function() {
            var a = this.utcOffset()
              , c = "+";
            return a < 0 && (a = -a,
            c = "-"),
            c + S(~~(a / 60), 2) + b + S(~~a % 60, 2)
        })
    }
    function zb(a, b) {
        var c = (b || "").match(a) || []
          , d = c[c.length - 1] || []
          , e = (d + "").match(Ge) || ["-", 0, 0]
          , f = +(60 * e[1]) + t(e[2]);
        return "+" === e[0] ? f : -f
    }
    // Return a moment from input, that is local/utc/zone equivalent to model.
    function Ab(b, c) {
        var d, e;
        // Use low-level api, because this fn is low-level api.
        return c._isUTC ? (d = c.clone(),
        e = (r(b) || f(b) ? b.valueOf() : rb(b).valueOf()) - d.valueOf(),
        d._d.setTime(d._d.valueOf() + e),
        a.updateOffset(d, !1),
        d) : rb(b).local()
    }
    function Bb(a) {
        // On Firefox.24 Date#getTimezoneOffset returns a floating point.
        // https://github.com/moment/moment/pull/1871
        return 15 * -Math.round(a._d.getTimezoneOffset() / 15)
    }
    // MOMENTS
    // keepLocalTime = true means only change the timezone, without
    // affecting the local hour. So 5:31:26 +0300 --[utcOffset(2, true)]-->
    // 5:31:26 +0200 It is possible that 5:31:26 doesn't exist with offset
    // +0200, so we adjust the time as needed, to be valid.
    //
    // Keeping the time actually adds/subtracts (one hour)
    // from the actual represented time. That is why we call updateOffset
    // a second time. In case it wants us to change the offset again
    // _changeInProgress == true case, then we have to adjust, because
    // there is no such time in the given timezone.
    function Cb(b, c) {
        var d, e = this._offset || 0;
        return this.isValid() ? null != b ? ("string" == typeof b ? b = zb(Td, b) : Math.abs(b) < 16 && (b = 60 * b),
        !this._isUTC && c && (d = Bb(this)),
        this._offset = b,
        this._isUTC = !0,
        null != d && this.add(d, "m"),
        e !== b && (!c || this._changeInProgress ? Sb(this, Nb(b - e, "m"), 1, !1) : this._changeInProgress || (this._changeInProgress = !0,
        a.updateOffset(this, !0),
        this._changeInProgress = null)),
        this) : this._isUTC ? e : Bb(this) : null != b ? this : NaN
    }
    function Db(a, b) {
        return null != a ? ("string" != typeof a && (a = -a),
        this.utcOffset(a, b),
        this) : -this.utcOffset()
    }
    function Eb(a) {
        return this.utcOffset(0, a)
    }
    function Fb(a) {
        return this._isUTC && (this.utcOffset(0, a),
        this._isUTC = !1,
        a && this.subtract(Bb(this), "m")),
        this
    }
    function Gb() {
        if (this._tzm)
            this.utcOffset(this._tzm);
        else if ("string" == typeof this._i) {
            var a = zb(Sd, this._i);
            0 === a ? this.utcOffset(0, !0) : this.utcOffset(zb(Sd, this._i))
        }
        return this
    }
    function Hb(a) {
        return !!this.isValid() && (a = a ? rb(a).utcOffset() : 0,
        (this.utcOffset() - a) % 60 === 0)
    }
    function Ib() {
        return this.utcOffset() > this.clone().month(0).utcOffset() || this.utcOffset() > this.clone().month(5).utcOffset()
    }
    function Jb() {
        if (!o(this._isDSTShifted))
            return this._isDSTShifted;
        var a = {};
        if (p(a, this),
        a = ob(a),
        a._a) {
            var b = a._isUTC ? j(a._a) : rb(a._a);
            this._isDSTShifted = this.isValid() && u(a._a, b.toArray()) > 0
        } else
            this._isDSTShifted = !1;
        return this._isDSTShifted
    }
    function Kb() {
        return !!this.isValid() && !this._isUTC
    }
    function Lb() {
        return !!this.isValid() && this._isUTC
    }
    function Mb() {
        return !!this.isValid() && (this._isUTC && 0 === this._offset)
    }
    function Nb(a, b) {
        var c, d, e, f = a, // matching against regexp is expensive, do it on demand
        g = null;
        // checks for null or undefined
        return wb(a) ? f = {
            ms: a._milliseconds,
            d: a._days,
            M: a._months
        } : "number" == typeof a ? (f = {},
        b ? f[b] = a : f.milliseconds = a) : (g = He.exec(a)) ? (c = "-" === g[1] ? -1 : 1,
        f = {
            y: 0,
            d: t(g[$d]) * c,
            h: t(g[_d]) * c,
            m: t(g[ae]) * c,
            s: t(g[be]) * c,
            ms: t(xb(1e3 * g[ce])) * c
        }) : (g = Ie.exec(a)) ? (c = "-" === g[1] ? -1 : 1,
        f = {
            y: Ob(g[2], c),
            M: Ob(g[3], c),
            w: Ob(g[4], c),
            d: Ob(g[5], c),
            h: Ob(g[6], c),
            m: Ob(g[7], c),
            s: Ob(g[8], c)
        }) : null == f ? f = {} : "object" == typeof f && ("from"in f || "to"in f) && (e = Qb(rb(f.from), rb(f.to)),
        f = {},
        f.ms = e.milliseconds,
        f.M = e.months),
        d = new vb(f),
        wb(a) && h(a, "_locale") && (d._locale = a._locale),
        d
    }
    function Ob(a, b) {
        // We'd normally use ~~inp for this, but unfortunately it also
        // converts floats to ints.
        // inp may be undefined, so careful calling replace on it.
        var c = a && parseFloat(a.replace(",", "."));
        // apply sign while we're at it
        return (isNaN(c) ? 0 : c) * b
    }
    function Pb(a, b) {
        var c = {
            milliseconds: 0,
            months: 0
        };
        return c.months = b.month() - a.month() + 12 * (b.year() - a.year()),
        a.clone().add(c.months, "M").isAfter(b) && --c.months,
        c.milliseconds = +b - +a.clone().add(c.months, "M"),
        c
    }
    function Qb(a, b) {
        var c;
        return a.isValid() && b.isValid() ? (b = Ab(b, a),
        a.isBefore(b) ? c = Pb(a, b) : (c = Pb(b, a),
        c.milliseconds = -c.milliseconds,
        c.months = -c.months),
        c) : {
            milliseconds: 0,
            months: 0
        }
    }
    // TODO: remove 'name' arg after deprecation is removed
    function Rb(a, b) {
        return function(c, d) {
            var e, f;
            //invert the arguments, but complain about it
            return null === d || isNaN(+d) || (x(b, "moment()." + b + "(period, number) is deprecated. Please use moment()." + b + "(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),
            f = c,
            c = d,
            d = f),
            c = "string" == typeof c ? +c : c,
            e = Nb(c, d),
            Sb(this, e, a),
            this
        }
    }
    function Sb(b, c, d, e) {
        var f = c._milliseconds
          , g = xb(c._days)
          , h = xb(c._months);
        b.isValid() && (e = null == e || e,
        f && b._d.setTime(b._d.valueOf() + f * d),
        g && P(b, "Date", O(b, "Date") + g * d),
        h && ia(b, O(b, "Month") + h * d),
        e && a.updateOffset(b, g || h))
    }
    function Tb(a, b) {
        var c = a.diff(b, "days", !0);
        return c < -6 ? "sameElse" : c < -1 ? "lastWeek" : c < 0 ? "lastDay" : c < 1 ? "sameDay" : c < 2 ? "nextDay" : c < 7 ? "nextWeek" : "sameElse"
    }
    function Ub(b, c) {
        // We want to compare the start of today, vs this.
        // Getting start-of-today depends on whether we're local/utc/offset or not.
        var d = b || rb()
          , e = Ab(d, this).startOf("day")
          , f = a.calendarFormat(this, e) || "sameElse"
          , g = c && (y(c[f]) ? c[f].call(this, d) : c[f]);
        return this.format(g || this.localeData().calendar(f, this, rb(d)))
    }
    function Vb() {
        return new q(this)
    }
    function Wb(a, b) {
        var c = r(a) ? a : rb(a);
        return !(!this.isValid() || !c.isValid()) && (b = J(o(b) ? "millisecond" : b),
        "millisecond" === b ? this.valueOf() > c.valueOf() : c.valueOf() < this.clone().startOf(b).valueOf())
    }
    function Xb(a, b) {
        var c = r(a) ? a : rb(a);
        return !(!this.isValid() || !c.isValid()) && (b = J(o(b) ? "millisecond" : b),
        "millisecond" === b ? this.valueOf() < c.valueOf() : this.clone().endOf(b).valueOf() < c.valueOf())
    }
    function Yb(a, b, c, d) {
        return d = d || "()",
        ("(" === d[0] ? this.isAfter(a, c) : !this.isBefore(a, c)) && (")" === d[1] ? this.isBefore(b, c) : !this.isAfter(b, c))
    }
    function Zb(a, b) {
        var c, d = r(a) ? a : rb(a);
        return !(!this.isValid() || !d.isValid()) && (b = J(b || "millisecond"),
        "millisecond" === b ? this.valueOf() === d.valueOf() : (c = d.valueOf(),
        this.clone().startOf(b).valueOf() <= c && c <= this.clone().endOf(b).valueOf()))
    }
    function $b(a, b) {
        return this.isSame(a, b) || this.isAfter(a, b)
    }
    function _b(a, b) {
        return this.isSame(a, b) || this.isBefore(a, b)
    }
    function ac(a, b, c) {
        var d, e, f, g;
        // 1000
        // 1000 * 60
        // 1000 * 60 * 60
        // 1000 * 60 * 60 * 24, negate dst
        // 1000 * 60 * 60 * 24 * 7, negate dst
        return this.isValid() ? (d = Ab(a, this),
        d.isValid() ? (e = 6e4 * (d.utcOffset() - this.utcOffset()),
        b = J(b),
        "year" === b || "month" === b || "quarter" === b ? (g = bc(this, d),
        "quarter" === b ? g /= 3 : "year" === b && (g /= 12)) : (f = this - d,
        g = "second" === b ? f / 1e3 : "minute" === b ? f / 6e4 : "hour" === b ? f / 36e5 : "day" === b ? (f - e) / 864e5 : "week" === b ? (f - e) / 6048e5 : f),
        c ? g : s(g)) : NaN) : NaN
    }
    function bc(a, b) {
        // difference in months
        var c, d, e = 12 * (b.year() - a.year()) + (b.month() - a.month()), // b is in (anchor - 1 month, anchor + 1 month)
        f = a.clone().add(e, "months");
        //check for negative zero, return zero if negative zero
        // linear across the month
        // linear across the month
        return b - f < 0 ? (c = a.clone().add(e - 1, "months"),
        d = (b - f) / (f - c)) : (c = a.clone().add(e + 1, "months"),
        d = (b - f) / (c - f)),
        -(e + d) || 0
    }
    function cc() {
        return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")
    }
    function dc() {
        var a = this.clone().utc();
        return 0 < a.year() && a.year() <= 9999 ? y(Date.prototype.toISOString) ? this.toDate().toISOString() : W(a, "YYYY-MM-DD[T]HH:mm:ss.SSS[Z]") : W(a, "YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]")
    }
    function ec(b) {
        b || (b = this.isUtc() ? a.defaultFormatUtc : a.defaultFormat);
        var c = W(this, b);
        return this.localeData().postformat(c)
    }
    function fc(a, b) {
        return this.isValid() && (r(a) && a.isValid() || rb(a).isValid()) ? Nb({
            to: this,
            from: a
        }).locale(this.locale()).humanize(!b) : this.localeData().invalidDate()
    }
    function gc(a) {
        return this.from(rb(), a)
    }
    function hc(a, b) {
        return this.isValid() && (r(a) && a.isValid() || rb(a).isValid()) ? Nb({
            from: this,
            to: a
        }).locale(this.locale()).humanize(!b) : this.localeData().invalidDate()
    }
    function ic(a) {
        return this.to(rb(), a)
    }
    // If passed a locale key, it will set the locale for this
    // instance.  Otherwise, it will return the locale configuration
    // variables for this instance.
    function jc(a) {
        var b;
        return void 0 === a ? this._locale._abbr : (b = ab(a),
        null != b && (this._locale = b),
        this)
    }
    function kc() {
        return this._locale
    }
    function lc(a) {
        // the following switch intentionally omits break keywords
        // to utilize falling through the cases.
        switch (a = J(a)) {
        case "year":
            this.month(0);
            /* falls through */
        case "quarter":
        case "month":
            this.date(1);
            /* falls through */
        case "week":
        case "isoWeek":
        case "day":
        case "date":
            this.hours(0);
            /* falls through */
        case "hour":
            this.minutes(0);
            /* falls through */
        case "minute":
            this.seconds(0);
            /* falls through */
        case "second":
            this.milliseconds(0)
        }
        // weeks are a special case
        // quarters are also special
        return "week" === a && this.weekday(0),
        "isoWeek" === a && this.isoWeekday(1),
        "quarter" === a && this.month(3 * Math.floor(this.month() / 3)),
        this
    }
    function mc(a) {
        // 'date' is an alias for 'day', so it should be considered as such.
        return a = J(a),
        void 0 === a || "millisecond" === a ? this : ("date" === a && (a = "day"),
        this.startOf(a).add(1, "isoWeek" === a ? "week" : a).subtract(1, "ms"))
    }
    function nc() {
        return this._d.valueOf() - 6e4 * (this._offset || 0)
    }
    function oc() {
        return Math.floor(this.valueOf() / 1e3)
    }
    function pc() {
        return new Date(this.valueOf())
    }
    function qc() {
        var a = this;
        return [a.year(), a.month(), a.date(), a.hour(), a.minute(), a.second(), a.millisecond()]
    }
    function rc() {
        var a = this;
        return {
            years: a.year(),
            months: a.month(),
            date: a.date(),
            hours: a.hours(),
            minutes: a.minutes(),
            seconds: a.seconds(),
            milliseconds: a.milliseconds()
        }
    }
    function sc() {
        // new Date(NaN).toJSON() === null
        return this.isValid() ? this.toISOString() : null
    }
    function tc() {
        return m(this)
    }
    function uc() {
        return i({}, l(this))
    }
    function vc() {
        return l(this).overflow
    }
    function wc() {
        return {
            input: this._i,
            format: this._f,
            locale: this._locale,
            isUTC: this._isUTC,
            strict: this._strict
        }
    }
    function xc(a, b) {
        T(0, [a, a.length], 0, b)
    }
    // MOMENTS
    function yc(a) {
        return Cc.call(this, a, this.week(), this.weekday(), this.localeData()._week.dow, this.localeData()._week.doy)
    }
    function zc(a) {
        return Cc.call(this, a, this.isoWeek(), this.isoWeekday(), 1, 4)
    }
    function Ac() {
        return wa(this.year(), 1, 4)
    }
    function Bc() {
        var a = this.localeData()._week;
        return wa(this.year(), a.dow, a.doy)
    }
    function Cc(a, b, c, d, e) {
        var f;
        return null == a ? va(this, d, e).year : (f = wa(a, d, e),
        b > f && (b = f),
        Dc.call(this, a, b, c, d, e))
    }
    function Dc(a, b, c, d, e) {
        var f = ua(a, b, c, d, e)
          , g = sa(f.year, 0, f.dayOfYear);
        return this.year(g.getUTCFullYear()),
        this.month(g.getUTCMonth()),
        this.date(g.getUTCDate()),
        this
    }
    // MOMENTS
    function Ec(a) {
        return null == a ? Math.ceil((this.month() + 1) / 3) : this.month(3 * (a - 1) + this.month() % 3)
    }
    // HELPERS
    // MOMENTS
    function Fc(a) {
        var b = Math.round((this.clone().startOf("day") - this.clone().startOf("year")) / 864e5) + 1;
        return null == a ? b : this.add(a - b, "d")
    }
    function Gc(a, b) {
        b[ce] = t(1e3 * ("0." + a))
    }
    // MOMENTS
    function Hc() {
        return this._isUTC ? "UTC" : ""
    }
    function Ic() {
        return this._isUTC ? "Coordinated Universal Time" : ""
    }
    function Jc(a) {
        return rb(1e3 * a)
    }
    function Kc() {
        return rb.apply(null, arguments).parseZone()
    }
    function Lc(a) {
        return a
    }
    function Mc(a, b, c, d) {
        var e = ab()
          , f = j().set(d, b);
        return e[c](f, a)
    }
    function Nc(a, b, c) {
        if ("number" == typeof a && (b = a,
        a = void 0),
        a = a || "",
        null != b)
            return Mc(a, b, c, "month");
        var d, e = [];
        for (d = 0; d < 12; d++)
            e[d] = Mc(a, d, c, "month");
        return e
    }
    // ()
    // (5)
    // (fmt, 5)
    // (fmt)
    // (true)
    // (true, 5)
    // (true, fmt, 5)
    // (true, fmt)
    function Oc(a, b, c, d) {
        "boolean" == typeof a ? ("number" == typeof b && (c = b,
        b = void 0),
        b = b || "") : (b = a,
        c = b,
        a = !1,
        "number" == typeof b && (c = b,
        b = void 0),
        b = b || "");
        var e = ab()
          , f = a ? e._week.dow : 0;
        if (null != c)
            return Mc(b, (c + f) % 7, d, "day");
        var g, h = [];
        for (g = 0; g < 7; g++)
            h[g] = Mc(b, (g + f) % 7, d, "day");
        return h
    }
    function Pc(a, b) {
        return Nc(a, b, "months")
    }
    function Qc(a, b) {
        return Nc(a, b, "monthsShort")
    }
    function Rc(a, b, c) {
        return Oc(a, b, c, "weekdays")
    }
    function Sc(a, b, c) {
        return Oc(a, b, c, "weekdaysShort")
    }
    function Tc(a, b, c) {
        return Oc(a, b, c, "weekdaysMin")
    }
    function Uc() {
        var a = this._data;
        return this._milliseconds = Ue(this._milliseconds),
        this._days = Ue(this._days),
        this._months = Ue(this._months),
        a.milliseconds = Ue(a.milliseconds),
        a.seconds = Ue(a.seconds),
        a.minutes = Ue(a.minutes),
        a.hours = Ue(a.hours),
        a.months = Ue(a.months),
        a.years = Ue(a.years),
        this
    }
    function Vc(a, b, c, d) {
        var e = Nb(b, c);
        return a._milliseconds += d * e._milliseconds,
        a._days += d * e._days,
        a._months += d * e._months,
        a._bubble()
    }
    // supports only 2.0-style add(1, 's') or add(duration)
    function Wc(a, b) {
        return Vc(this, a, b, 1)
    }
    // supports only 2.0-style subtract(1, 's') or subtract(duration)
    function Xc(a, b) {
        return Vc(this, a, b, -1)
    }
    function Yc(a) {
        return a < 0 ? Math.floor(a) : Math.ceil(a)
    }
    function Zc() {
        var a, b, c, d, e, f = this._milliseconds, g = this._days, h = this._months, i = this._data;
        // if we have a mix of positive and negative values, bubble down first
        // check: https://github.com/moment/moment/issues/2166
        // The following code bubbles up values, see the tests for
        // examples of what that means.
        // convert days to months
        // 12 months -> 1 year
        return f >= 0 && g >= 0 && h >= 0 || f <= 0 && g <= 0 && h <= 0 || (f += 864e5 * Yc(_c(h) + g),
        g = 0,
        h = 0),
        i.milliseconds = f % 1e3,
        a = s(f / 1e3),
        i.seconds = a % 60,
        b = s(a / 60),
        i.minutes = b % 60,
        c = s(b / 60),
        i.hours = c % 24,
        g += s(c / 24),
        e = s($c(g)),
        h += e,
        g -= Yc(_c(e)),
        d = s(h / 12),
        h %= 12,
        i.days = g,
        i.months = h,
        i.years = d,
        this
    }
    function $c(a) {
        // 400 years have 146097 days (taking into account leap year rules)
        // 400 years have 12 months === 4800
        return 4800 * a / 146097
    }
    function _c(a) {
        // the reverse of daysToMonths
        return 146097 * a / 4800
    }
    function ad(a) {
        var b, c, d = this._milliseconds;
        if (a = J(a),
        "month" === a || "year" === a)
            return b = this._days + d / 864e5,
            c = this._months + $c(b),
            "month" === a ? c : c / 12;
        switch (// handle milliseconds separately because of floating point math errors (issue #1867)
        b = this._days + Math.round(_c(this._months)),
        a) {
        case "week":
            return b / 7 + d / 6048e5;
        case "day":
            return b + d / 864e5;
        case "hour":
            return 24 * b + d / 36e5;
        case "minute":
            return 1440 * b + d / 6e4;
        case "second":
            return 86400 * b + d / 1e3;
            // Math.floor prevents floating point math errors here
        case "millisecond":
            return Math.floor(864e5 * b) + d;
        default:
            throw new Error("Unknown unit " + a)
        }
    }
    // TODO: Use this.as('ms')?
    function bd() {
        return this._milliseconds + 864e5 * this._days + this._months % 12 * 2592e6 + 31536e6 * t(this._months / 12)
    }
    function cd(a) {
        return function() {
            return this.as(a)
        }
    }
    function dd(a) {
        return a = J(a),
        this[a + "s"]()
    }
    function ed(a) {
        return function() {
            return this._data[a]
        }
    }
    function fd() {
        return s(this.days() / 7)
    }
    // helper function for moment.fn.from, moment.fn.fromNow, and moment.duration.fn.humanize
    function gd(a, b, c, d, e) {
        return e.relativeTime(b || 1, !!c, a, d)
    }
    function hd(a, b, c) {
        var d = Nb(a).abs()
          , e = jf(d.as("s"))
          , f = jf(d.as("m"))
          , g = jf(d.as("h"))
          , h = jf(d.as("d"))
          , i = jf(d.as("M"))
          , j = jf(d.as("y"))
          , k = e < kf.s && ["s", e] || f <= 1 && ["m"] || f < kf.m && ["mm", f] || g <= 1 && ["h"] || g < kf.h && ["hh", g] || h <= 1 && ["d"] || h < kf.d && ["dd", h] || i <= 1 && ["M"] || i < kf.M && ["MM", i] || j <= 1 && ["y"] || ["yy", j];
        return k[2] = b,
        k[3] = +a > 0,
        k[4] = c,
        gd.apply(null, k)
    }
    // This function allows you to set the rounding function for relative time strings
    function id(a) {
        return void 0 === a ? jf : "function" == typeof a && (jf = a,
        !0)
    }
    // This function allows you to set a threshold for relative time strings
    function jd(a, b) {
        return void 0 !== kf[a] && (void 0 === b ? kf[a] : (kf[a] = b,
        !0))
    }
    function kd(a) {
        var b = this.localeData()
          , c = hd(this, !a, b);
        return a && (c = b.pastFuture(+this, c)),
        b.postformat(c)
    }
    function ld() {
        // for ISO strings we do not use the normal bubbling rules:
        //  * milliseconds bubble up until they become hours
        //  * days do not bubble at all
        //  * months bubble up until they become years
        // This is because there is no context-free conversion between hours and days
        // (think of clock changes)
        // and also not between days and months (28-31 days per month)
        var a, b, c, d = lf(this._milliseconds) / 1e3, e = lf(this._days), f = lf(this._months);
        // 3600 seconds -> 60 minutes -> 1 hour
        a = s(d / 60),
        b = s(a / 60),
        d %= 60,
        a %= 60,
        // 12 months -> 1 year
        c = s(f / 12),
        f %= 12;
        // inspired by https://github.com/dordille/moment-isoduration/blob/master/moment.isoduration.js
        var g = c
          , h = f
          , i = e
          , j = b
          , k = a
          , l = d
          , m = this.asSeconds();
        return m ? (m < 0 ? "-" : "") + "P" + (g ? g + "Y" : "") + (h ? h + "M" : "") + (i ? i + "D" : "") + (j || k || l ? "T" : "") + (j ? j + "H" : "") + (k ? k + "M" : "") + (l ? l + "S" : "") : "P0D"
    }
    var md, nd;
    nd = Array.prototype.some ? Array.prototype.some : function(a) {
        for (var b = Object(this), c = b.length >>> 0, d = 0; d < c; d++)
            if (d in b && a.call(this, b[d], d, b))
                return !0;
        return !1
    }
    ;
    // Plugins that add properties should also add the key here (null value),
    // so we can properly clone ourselves.
    var od = a.momentProperties = []
      , pd = !1
      , qd = {};
    a.suppressDeprecationWarnings = !1,
    a.deprecationHandler = null;
    var rd;
    rd = Object.keys ? Object.keys : function(a) {
        var b, c = [];
        for (b in a)
            h(a, b) && c.push(b);
        return c
    }
    ;
    var sd, td = {
        sameDay: "[Today at] LT",
        nextDay: "[Tomorrow at] LT",
        nextWeek: "dddd [at] LT",
        lastDay: "[Yesterday at] LT",
        lastWeek: "[Last] dddd [at] LT",
        sameElse: "L"
    }, ud = {
        LTS: "h:mm:ss A",
        LT: "h:mm A",
        L: "MM/DD/YYYY",
        LL: "MMMM D, YYYY",
        LLL: "MMMM D, YYYY h:mm A",
        LLLL: "dddd, MMMM D, YYYY h:mm A"
    }, vd = "Invalid date", wd = "%d", xd = /\d{1,2}/, yd = {
        future: "in %s",
        past: "%s ago",
        s: "a few seconds",
        m: "a minute",
        mm: "%d minutes",
        h: "an hour",
        hh: "%d hours",
        d: "a day",
        dd: "%d days",
        M: "a month",
        MM: "%d months",
        y: "a year",
        yy: "%d years"
    }, zd = {}, Ad = {}, Bd = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g, Cd = /(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g, Dd = {}, Ed = {}, Fd = /\d/, Gd = /\d\d/, Hd = /\d{3}/, Id = /\d{4}/, Jd = /[+-]?\d{6}/, Kd = /\d\d?/, Ld = /\d\d\d\d?/, Md = /\d\d\d\d\d\d?/, Nd = /\d{1,3}/, Od = /\d{1,4}/, Pd = /[+-]?\d{1,6}/, Qd = /\d+/, Rd = /[+-]?\d+/, Sd = /Z|[+-]\d\d:?\d\d/gi, Td = /Z|[+-]\d\d(?::?\d\d)?/gi, Ud = /[+-]?\d+(\.\d{1,3})?/, Vd = /[0-9]*['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+|[\u0600-\u06FF\/]+(\s*?[\u0600-\u06FF]+){1,2}/i, Wd = {}, Xd = {}, Yd = 0, Zd = 1, $d = 2, _d = 3, ae = 4, be = 5, ce = 6, de = 7, ee = 8;
    sd = Array.prototype.indexOf ? Array.prototype.indexOf : function(a) {
        // I know
        var b;
        for (b = 0; b < this.length; ++b)
            if (this[b] === a)
                return b;
        return -1
    }
    ,
    // FORMATTING
    T("M", ["MM", 2], "Mo", function() {
        return this.month() + 1
    }),
    T("MMM", 0, 0, function(a) {
        return this.localeData().monthsShort(this, a)
    }),
    T("MMMM", 0, 0, function(a) {
        return this.localeData().months(this, a)
    }),
    // ALIASES
    I("month", "M"),
    // PRIORITY
    L("month", 8),
    // PARSING
    Y("M", Kd),
    Y("MM", Kd, Gd),
    Y("MMM", function(a, b) {
        return b.monthsShortRegex(a)
    }),
    Y("MMMM", function(a, b) {
        return b.monthsRegex(a)
    }),
    aa(["M", "MM"], function(a, b) {
        b[Zd] = t(a) - 1
    }),
    aa(["MMM", "MMMM"], function(a, b, c, d) {
        var e = c._locale.monthsParse(a, d, c._strict);
        // if we didn't find a month name, mark the date as invalid.
        null != e ? b[Zd] = e : l(c).invalidMonth = a
    });
    // LOCALES
    var fe = /D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/
      , ge = "January_February_March_April_May_June_July_August_September_October_November_December".split("_")
      , he = "Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_")
      , ie = Vd
      , je = Vd;
    // FORMATTING
    T("Y", 0, 0, function() {
        var a = this.year();
        return a <= 9999 ? "" + a : "+" + a
    }),
    T(0, ["YY", 2], 0, function() {
        return this.year() % 100
    }),
    T(0, ["YYYY", 4], 0, "year"),
    T(0, ["YYYYY", 5], 0, "year"),
    T(0, ["YYYYYY", 6, !0], 0, "year"),
    // ALIASES
    I("year", "y"),
    // PRIORITIES
    L("year", 1),
    // PARSING
    Y("Y", Rd),
    Y("YY", Kd, Gd),
    Y("YYYY", Od, Id),
    Y("YYYYY", Pd, Jd),
    Y("YYYYYY", Pd, Jd),
    aa(["YYYYY", "YYYYYY"], Yd),
    aa("YYYY", function(b, c) {
        c[Yd] = 2 === b.length ? a.parseTwoDigitYear(b) : t(b)
    }),
    aa("YY", function(b, c) {
        c[Yd] = a.parseTwoDigitYear(b)
    }),
    aa("Y", function(a, b) {
        b[Yd] = parseInt(a, 10)
    }),
    // HOOKS
    a.parseTwoDigitYear = function(a) {
        return t(a) + (t(a) > 68 ? 1900 : 2e3)
    }
    ;
    // MOMENTS
    var ke = N("FullYear", !0);
    // FORMATTING
    T("w", ["ww", 2], "wo", "week"),
    T("W", ["WW", 2], "Wo", "isoWeek"),
    // ALIASES
    I("week", "w"),
    I("isoWeek", "W"),
    // PRIORITIES
    L("week", 5),
    L("isoWeek", 5),
    // PARSING
    Y("w", Kd),
    Y("ww", Kd, Gd),
    Y("W", Kd),
    Y("WW", Kd, Gd),
    ba(["w", "ww", "W", "WW"], function(a, b, c, d) {
        b[d.substr(0, 1)] = t(a)
    });
    var le = {
        dow: 0,
        // Sunday is the first day of the week.
        doy: 6
    };
    // FORMATTING
    T("d", 0, "do", "day"),
    T("dd", 0, 0, function(a) {
        return this.localeData().weekdaysMin(this, a)
    }),
    T("ddd", 0, 0, function(a) {
        return this.localeData().weekdaysShort(this, a)
    }),
    T("dddd", 0, 0, function(a) {
        return this.localeData().weekdays(this, a)
    }),
    T("e", 0, 0, "weekday"),
    T("E", 0, 0, "isoWeekday"),
    // ALIASES
    I("day", "d"),
    I("weekday", "e"),
    I("isoWeekday", "E"),
    // PRIORITY
    L("day", 11),
    L("weekday", 11),
    L("isoWeekday", 11),
    // PARSING
    Y("d", Kd),
    Y("e", Kd),
    Y("E", Kd),
    Y("dd", function(a, b) {
        return b.weekdaysMinRegex(a)
    }),
    Y("ddd", function(a, b) {
        return b.weekdaysShortRegex(a)
    }),
    Y("dddd", function(a, b) {
        return b.weekdaysRegex(a)
    }),
    ba(["dd", "ddd", "dddd"], function(a, b, c, d) {
        var e = c._locale.weekdaysParse(a, d, c._strict);
        // if we didn't get a weekday name, mark the date as invalid
        null != e ? b.d = e : l(c).invalidWeekday = a
    }),
    ba(["d", "e", "E"], function(a, b, c, d) {
        b[d] = t(a)
    });
    // LOCALES
    var me = "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_")
      , ne = "Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_")
      , oe = "Su_Mo_Tu_We_Th_Fr_Sa".split("_")
      , pe = Vd
      , qe = Vd
      , re = Vd;
    T("H", ["HH", 2], 0, "hour"),
    T("h", ["hh", 2], 0, Qa),
    T("k", ["kk", 2], 0, Ra),
    T("hmm", 0, 0, function() {
        return "" + Qa.apply(this) + S(this.minutes(), 2)
    }),
    T("hmmss", 0, 0, function() {
        return "" + Qa.apply(this) + S(this.minutes(), 2) + S(this.seconds(), 2)
    }),
    T("Hmm", 0, 0, function() {
        return "" + this.hours() + S(this.minutes(), 2)
    }),
    T("Hmmss", 0, 0, function() {
        return "" + this.hours() + S(this.minutes(), 2) + S(this.seconds(), 2)
    }),
    Sa("a", !0),
    Sa("A", !1),
    // ALIASES
    I("hour", "h"),
    // PRIORITY
    L("hour", 13),
    Y("a", Ta),
    Y("A", Ta),
    Y("H", Kd),
    Y("h", Kd),
    Y("HH", Kd, Gd),
    Y("hh", Kd, Gd),
    Y("hmm", Ld),
    Y("hmmss", Md),
    Y("Hmm", Ld),
    Y("Hmmss", Md),
    aa(["H", "HH"], _d),
    aa(["a", "A"], function(a, b, c) {
        c._isPm = c._locale.isPM(a),
        c._meridiem = a
    }),
    aa(["h", "hh"], function(a, b, c) {
        b[_d] = t(a),
        l(c).bigHour = !0
    }),
    aa("hmm", function(a, b, c) {
        var d = a.length - 2;
        b[_d] = t(a.substr(0, d)),
        b[ae] = t(a.substr(d)),
        l(c).bigHour = !0
    }),
    aa("hmmss", function(a, b, c) {
        var d = a.length - 4
          , e = a.length - 2;
        b[_d] = t(a.substr(0, d)),
        b[ae] = t(a.substr(d, 2)),
        b[be] = t(a.substr(e)),
        l(c).bigHour = !0
    }),
    aa("Hmm", function(a, b, c) {
        var d = a.length - 2;
        b[_d] = t(a.substr(0, d)),
        b[ae] = t(a.substr(d))
    }),
    aa("Hmmss", function(a, b, c) {
        var d = a.length - 4
          , e = a.length - 2;
        b[_d] = t(a.substr(0, d)),
        b[ae] = t(a.substr(d, 2)),
        b[be] = t(a.substr(e))
    });
    var se, te = /[ap]\.?m?\.?/i, ue = N("Hours", !0), ve = {
        calendar: td,
        longDateFormat: ud,
        invalidDate: vd,
        ordinal: wd,
        ordinalParse: xd,
        relativeTime: yd,
        months: ge,
        monthsShort: he,
        week: le,
        weekdays: me,
        weekdaysMin: oe,
        weekdaysShort: ne,
        meridiemParse: te
    }, we = {}, xe = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/, ye = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/, ze = /Z|[+-]\d\d(?::?\d\d)?/, Ae = [["YYYYYY-MM-DD", /[+-]\d{6}-\d\d-\d\d/], ["YYYY-MM-DD", /\d{4}-\d\d-\d\d/], ["GGGG-[W]WW-E", /\d{4}-W\d\d-\d/], ["GGGG-[W]WW", /\d{4}-W\d\d/, !1], ["YYYY-DDD", /\d{4}-\d{3}/], ["YYYY-MM", /\d{4}-\d\d/, !1], ["YYYYYYMMDD", /[+-]\d{10}/], ["YYYYMMDD", /\d{8}/], // YYYYMM is NOT allowed by the standard
    ["GGGG[W]WWE", /\d{4}W\d{3}/], ["GGGG[W]WW", /\d{4}W\d{2}/, !1], ["YYYYDDD", /\d{7}/]], Be = [["HH:mm:ss.SSSS", /\d\d:\d\d:\d\d\.\d+/], ["HH:mm:ss,SSSS", /\d\d:\d\d:\d\d,\d+/], ["HH:mm:ss", /\d\d:\d\d:\d\d/], ["HH:mm", /\d\d:\d\d/], ["HHmmss.SSSS", /\d\d\d\d\d\d\.\d+/], ["HHmmss,SSSS", /\d\d\d\d\d\d,\d+/], ["HHmmss", /\d\d\d\d\d\d/], ["HHmm", /\d\d\d\d/], ["HH", /\d\d/]], Ce = /^\/?Date\((\-?\d+)/i;
    a.createFromInputFallback = w("value provided is not in a recognized ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.", function(a) {
        a._d = new Date(a._i + (a._useUTC ? " UTC" : ""))
    }),
    // constant that refers to the ISO standard
    a.ISO_8601 = function() {}
    ;
    var De = w("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/", function() {
        var a = rb.apply(null, arguments);
        return this.isValid() && a.isValid() ? a < this ? this : a : n()
    })
      , Ee = w("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/", function() {
        var a = rb.apply(null, arguments);
        return this.isValid() && a.isValid() ? a > this ? this : a : n()
    })
      , Fe = function() {
        return Date.now ? Date.now() : +new Date
    };
    yb("Z", ":"),
    yb("ZZ", ""),
    // PARSING
    Y("Z", Td),
    Y("ZZ", Td),
    aa(["Z", "ZZ"], function(a, b, c) {
        c._useUTC = !0,
        c._tzm = zb(Td, a)
    });
    // HELPERS
    // timezone chunker
    // '+10:00' > ['10',  '00']
    // '-1530'  > ['-15', '30']
    var Ge = /([\+\-]|\d\d)/gi;
    // HOOKS
    // This function will be called whenever a moment is mutated.
    // It is intended to keep the offset in sync with the timezone.
    a.updateOffset = function() {}
    ;
    // ASP.NET json date format regex
    var He = /^(\-)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/
      , Ie = /^(-)?P(?:(-?[0-9,.]*)Y)?(?:(-?[0-9,.]*)M)?(?:(-?[0-9,.]*)W)?(?:(-?[0-9,.]*)D)?(?:T(?:(-?[0-9,.]*)H)?(?:(-?[0-9,.]*)M)?(?:(-?[0-9,.]*)S)?)?$/;
    Nb.fn = vb.prototype;
    var Je = Rb(1, "add")
      , Ke = Rb(-1, "subtract");
    a.defaultFormat = "YYYY-MM-DDTHH:mm:ssZ",
    a.defaultFormatUtc = "YYYY-MM-DDTHH:mm:ss[Z]";
    var Le = w("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.", function(a) {
        return void 0 === a ? this.localeData() : this.locale(a)
    });
    // FORMATTING
    T(0, ["gg", 2], 0, function() {
        return this.weekYear() % 100
    }),
    T(0, ["GG", 2], 0, function() {
        return this.isoWeekYear() % 100
    }),
    xc("gggg", "weekYear"),
    xc("ggggg", "weekYear"),
    xc("GGGG", "isoWeekYear"),
    xc("GGGGG", "isoWeekYear"),
    // ALIASES
    I("weekYear", "gg"),
    I("isoWeekYear", "GG"),
    // PRIORITY
    L("weekYear", 1),
    L("isoWeekYear", 1),
    // PARSING
    Y("G", Rd),
    Y("g", Rd),
    Y("GG", Kd, Gd),
    Y("gg", Kd, Gd),
    Y("GGGG", Od, Id),
    Y("gggg", Od, Id),
    Y("GGGGG", Pd, Jd),
    Y("ggggg", Pd, Jd),
    ba(["gggg", "ggggg", "GGGG", "GGGGG"], function(a, b, c, d) {
        b[d.substr(0, 2)] = t(a)
    }),
    ba(["gg", "GG"], function(b, c, d, e) {
        c[e] = a.parseTwoDigitYear(b)
    }),
    // FORMATTING
    T("Q", 0, "Qo", "quarter"),
    // ALIASES
    I("quarter", "Q"),
    // PRIORITY
    L("quarter", 7),
    // PARSING
    Y("Q", Fd),
    aa("Q", function(a, b) {
        b[Zd] = 3 * (t(a) - 1)
    }),
    // FORMATTING
    T("D", ["DD", 2], "Do", "date"),
    // ALIASES
    I("date", "D"),
    // PRIOROITY
    L("date", 9),
    // PARSING
    Y("D", Kd),
    Y("DD", Kd, Gd),
    Y("Do", function(a, b) {
        return a ? b._ordinalParse : b._ordinalParseLenient
    }),
    aa(["D", "DD"], $d),
    aa("Do", function(a, b) {
        b[$d] = t(a.match(Kd)[0], 10)
    });
    // MOMENTS
    var Me = N("Date", !0);
    // FORMATTING
    T("DDD", ["DDDD", 3], "DDDo", "dayOfYear"),
    // ALIASES
    I("dayOfYear", "DDD"),
    // PRIORITY
    L("dayOfYear", 4),
    // PARSING
    Y("DDD", Nd),
    Y("DDDD", Hd),
    aa(["DDD", "DDDD"], function(a, b, c) {
        c._dayOfYear = t(a)
    }),
    // FORMATTING
    T("m", ["mm", 2], 0, "minute"),
    // ALIASES
    I("minute", "m"),
    // PRIORITY
    L("minute", 14),
    // PARSING
    Y("m", Kd),
    Y("mm", Kd, Gd),
    aa(["m", "mm"], ae);
    // MOMENTS
    var Ne = N("Minutes", !1);
    // FORMATTING
    T("s", ["ss", 2], 0, "second"),
    // ALIASES
    I("second", "s"),
    // PRIORITY
    L("second", 15),
    // PARSING
    Y("s", Kd),
    Y("ss", Kd, Gd),
    aa(["s", "ss"], be);
    // MOMENTS
    var Oe = N("Seconds", !1);
    // FORMATTING
    T("S", 0, 0, function() {
        return ~~(this.millisecond() / 100)
    }),
    T(0, ["SS", 2], 0, function() {
        return ~~(this.millisecond() / 10)
    }),
    T(0, ["SSS", 3], 0, "millisecond"),
    T(0, ["SSSS", 4], 0, function() {
        return 10 * this.millisecond()
    }),
    T(0, ["SSSSS", 5], 0, function() {
        return 100 * this.millisecond()
    }),
    T(0, ["SSSSSS", 6], 0, function() {
        return 1e3 * this.millisecond()
    }),
    T(0, ["SSSSSSS", 7], 0, function() {
        return 1e4 * this.millisecond()
    }),
    T(0, ["SSSSSSSS", 8], 0, function() {
        return 1e5 * this.millisecond()
    }),
    T(0, ["SSSSSSSSS", 9], 0, function() {
        return 1e6 * this.millisecond()
    }),
    // ALIASES
    I("millisecond", "ms"),
    // PRIORITY
    L("millisecond", 16),
    // PARSING
    Y("S", Nd, Fd),
    Y("SS", Nd, Gd),
    Y("SSS", Nd, Hd);
    var Pe;
    for (Pe = "SSSS"; Pe.length <= 9; Pe += "S")
        Y(Pe, Qd);
    for (Pe = "S"; Pe.length <= 9; Pe += "S")
        aa(Pe, Gc);
    // MOMENTS
    var Qe = N("Milliseconds", !1);
    // FORMATTING
    T("z", 0, 0, "zoneAbbr"),
    T("zz", 0, 0, "zoneName");
    var Re = q.prototype;
    Re.add = Je,
    Re.calendar = Ub,
    Re.clone = Vb,
    Re.diff = ac,
    Re.endOf = mc,
    Re.format = ec,
    Re.from = fc,
    Re.fromNow = gc,
    Re.to = hc,
    Re.toNow = ic,
    Re.get = Q,
    Re.invalidAt = vc,
    Re.isAfter = Wb,
    Re.isBefore = Xb,
    Re.isBetween = Yb,
    Re.isSame = Zb,
    Re.isSameOrAfter = $b,
    Re.isSameOrBefore = _b,
    Re.isValid = tc,
    Re.lang = Le,
    Re.locale = jc,
    Re.localeData = kc,
    Re.max = Ee,
    Re.min = De,
    Re.parsingFlags = uc,
    Re.set = R,
    Re.startOf = lc,
    Re.subtract = Ke,
    Re.toArray = qc,
    Re.toObject = rc,
    Re.toDate = pc,
    Re.toISOString = dc,
    Re.toJSON = sc,
    Re.toString = cc,
    Re.unix = oc,
    Re.valueOf = nc,
    Re.creationData = wc,
    // Year
    Re.year = ke,
    Re.isLeapYear = qa,
    // Week Year
    Re.weekYear = yc,
    Re.isoWeekYear = zc,
    // Quarter
    Re.quarter = Re.quarters = Ec,
    // Month
    Re.month = ja,
    Re.daysInMonth = ka,
    // Week
    Re.week = Re.weeks = Aa,
    Re.isoWeek = Re.isoWeeks = Ba,
    Re.weeksInYear = Bc,
    Re.isoWeeksInYear = Ac,
    // Day
    Re.date = Me,
    Re.day = Re.days = Ja,
    Re.weekday = Ka,
    Re.isoWeekday = La,
    Re.dayOfYear = Fc,
    // Hour
    Re.hour = Re.hours = ue,
    // Minute
    Re.minute = Re.minutes = Ne,
    // Second
    Re.second = Re.seconds = Oe,
    // Millisecond
    Re.millisecond = Re.milliseconds = Qe,
    // Offset
    Re.utcOffset = Cb,
    Re.utc = Eb,
    Re.local = Fb,
    Re.parseZone = Gb,
    Re.hasAlignedHourOffset = Hb,
    Re.isDST = Ib,
    Re.isLocal = Kb,
    Re.isUtcOffset = Lb,
    Re.isUtc = Mb,
    Re.isUTC = Mb,
    // Timezone
    Re.zoneAbbr = Hc,
    Re.zoneName = Ic,
    // Deprecations
    Re.dates = w("dates accessor is deprecated. Use date instead.", Me),
    Re.months = w("months accessor is deprecated. Use month instead", ja),
    Re.years = w("years accessor is deprecated. Use year instead", ke),
    Re.zone = w("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/", Db),
    Re.isDSTShifted = w("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information", Jb);
    var Se = Re
      , Te = B.prototype;
    Te.calendar = C,
    Te.longDateFormat = D,
    Te.invalidDate = E,
    Te.ordinal = F,
    Te.preparse = Lc,
    Te.postformat = Lc,
    Te.relativeTime = G,
    Te.pastFuture = H,
    Te.set = z,
    // Month
    Te.months = ea,
    Te.monthsShort = fa,
    Te.monthsParse = ha,
    Te.monthsRegex = ma,
    Te.monthsShortRegex = la,
    // Week
    Te.week = xa,
    Te.firstDayOfYear = za,
    Te.firstDayOfWeek = ya,
    // Day of Week
    Te.weekdays = Ea,
    Te.weekdaysMin = Ga,
    Te.weekdaysShort = Fa,
    Te.weekdaysParse = Ia,
    Te.weekdaysRegex = Ma,
    Te.weekdaysShortRegex = Na,
    Te.weekdaysMinRegex = Oa,
    // Hours
    Te.isPM = Ua,
    Te.meridiem = Va,
    Za("en", {
        ordinalParse: /\d{1,2}(th|st|nd|rd)/,
        ordinal: function(a) {
            var b = a % 10
              , c = 1 === t(a % 100 / 10) ? "th" : 1 === b ? "st" : 2 === b ? "nd" : 3 === b ? "rd" : "th";
            return a + c
        }
    }),
    // Side effect imports
    a.lang = w("moment.lang is deprecated. Use moment.locale instead.", Za),
    a.langData = w("moment.langData is deprecated. Use moment.localeData instead.", ab);
    var Ue = Math.abs
      , Ve = cd("ms")
      , We = cd("s")
      , Xe = cd("m")
      , Ye = cd("h")
      , Ze = cd("d")
      , $e = cd("w")
      , _e = cd("M")
      , af = cd("y")
      , bf = ed("milliseconds")
      , cf = ed("seconds")
      , df = ed("minutes")
      , ef = ed("hours")
      , ff = ed("days")
      , gf = ed("months")
      , hf = ed("years")
      , jf = Math.round
      , kf = {
        s: 45,
        // seconds to minute
        m: 45,
        // minutes to hour
        h: 22,
        // hours to day
        d: 26,
        // days to month
        M: 11
    }
      , lf = Math.abs
      , mf = vb.prototype;
    mf.abs = Uc,
    mf.add = Wc,
    mf.subtract = Xc,
    mf.as = ad,
    mf.asMilliseconds = Ve,
    mf.asSeconds = We,
    mf.asMinutes = Xe,
    mf.asHours = Ye,
    mf.asDays = Ze,
    mf.asWeeks = $e,
    mf.asMonths = _e,
    mf.asYears = af,
    mf.valueOf = bd,
    mf._bubble = Zc,
    mf.get = dd,
    mf.milliseconds = bf,
    mf.seconds = cf,
    mf.minutes = df,
    mf.hours = ef,
    mf.days = ff,
    mf.weeks = fd,
    mf.months = gf,
    mf.years = hf,
    mf.humanize = kd,
    mf.toISOString = ld,
    mf.toString = ld,
    mf.toJSON = ld,
    mf.locale = jc,
    mf.localeData = kc,
    // Deprecations
    mf.toIsoString = w("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)", ld),
    mf.lang = Le,
    // Side effect imports
    // FORMATTING
    T("X", 0, 0, "unix"),
    T("x", 0, 0, "valueOf"),
    // PARSING
    Y("x", Rd),
    Y("X", Ud),
    aa("X", function(a, b, c) {
        c._d = new Date(1e3 * parseFloat(a, 10))
    }),
    aa("x", function(a, b, c) {
        c._d = new Date(t(a))
    }),
    // Side effect imports
    a.version = "2.15.2",
    b(rb),
    a.fn = Se,
    a.min = tb,
    a.max = ub,
    a.now = Fe,
    a.utc = j,
    a.unix = Jc,
    a.months = Pc,
    a.isDate = f,
    a.locale = Za,
    a.invalid = n,
    a.duration = Nb,
    a.isMoment = r,
    a.weekdays = Rc,
    a.parseZone = Kc,
    a.localeData = ab,
    a.isDuration = wb,
    a.monthsShort = Qc,
    a.weekdaysMin = Tc,
    a.defineLocale = $a,
    a.updateLocale = _a,
    a.locales = bb,
    a.weekdaysShort = Sc,
    a.normalizeUnits = J,
    a.relativeTimeRounding = id,
    a.relativeTimeThreshold = jd,
    a.calendarFormat = Tb,
    a.prototype = Se;
    var nf = a;
    return nf
});
/*!
 * Pikaday
 *
 * Copyright © 2014 David Bushell | BSD & MIT license | https://github.com/dbushell/Pikaday
 */

(function(root, factory) {
    'use strict';

    var moment;
    if (typeof exports === 'object') {
        // CommonJS module
        // Load moment.js as an optional dependency
        try {
            moment = require('moment');
        } catch (e) {}
        module.exports = factory(moment);
    } else if (typeof define === 'function' && define.amd) {
        // AMD. Register as an anonymous module.
        define(function(req) {
            // Load moment.js as an optional dependency
            var id = 'moment';
            try {
                moment = req(id);
            } catch (e) {}
            return factory(moment);
        });
    } else {
        root.Pikaday = factory(root.moment);
    }
}(this, function(moment) {
    'use strict';

    /**
     * feature detection and helper functions
     */
    var hasMoment = typeof moment === 'function'
      ,
    hasEventListeners = !!window.addEventListener
      ,
    document = window.document
      ,
    sto = window.setTimeout
      ,
    addEvent = function(el, e, callback, capture) {
        if (hasEventListeners) {
            el.addEventListener(e, callback, !!capture);
        } else {
            el.attachEvent('on' + e, callback);
        }
    }
      ,
    removeEvent = function(el, e, callback, capture) {
        if (hasEventListeners) {
            el.removeEventListener(e, callback, !!capture);
        } else {
            el.detachEvent('on' + e, callback);
        }
    }
      ,
    fireEvent = function(el, eventName, data) {
        var ev;

        if (document.createEvent) {
            ev = document.createEvent('HTMLEvents');
            ev.initEvent(eventName, true, false);
            ev = extend(ev, data);
            el.dispatchEvent(ev);
        } else if (document.createEventObject) {
            ev = document.createEventObject();
            ev = extend(ev, data);
            el.fireEvent('on' + eventName, ev);
        }
    }
      ,
    trim = function(str) {
        return str.trim ? str.trim() : str.replace(/^\s+|\s+$/g, '');
    }
      ,
    hasClass = function(el, cn) {
        return (' ' + el.className + ' ').indexOf(' ' + cn + ' ') !== -1;
    }
      ,
    addClass = function(el, cn) {
        if (!hasClass(el, cn)) {
            el.className = (el.className === '') ? cn : el.className + ' ' + cn;
        }
    }
      ,
    removeClass = function(el, cn) {
        el.className = trim((' ' + el.className + ' ').replace(' ' + cn + ' ', ' '));
    }
      ,
    isArray = function(obj) {
        return (/Array/).test(Object.prototype.toString.call(obj));
    }
      ,
    isDate = function(obj) {
        return (/Date/).test(Object.prototype.toString.call(obj)) && !isNaN(obj.getTime());
    }
      ,
    isWeekend = function(date) {
        var day = date.getDay();
        return day === 0 || day === 6;
    }
      ,
    isLeapYear = function(year) {
        // solution by Matti Virkkunen: http://stackoverflow.com/a/4881951
        return year % 4 === 0 && year % 100 !== 0 || year % 400 === 0;
    }
      ,
    getDaysInMonth = function(year, month) {
        return [31, isLeapYear(year) ? 29 : 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month];
    }
      ,
    setToStartOfDay = function(date) {
        if (isDate(date))
            date.setHours(0, 0, 0, 0);
    }
      ,
    compareDates = function(a, b) {
        // weak date comparison (use setToStartOfDay(date) to ensure correct result)
        return a.getTime() === b.getTime();
    }
      ,
    extend = function(to, from, overwrite) {
        var prop, hasProp;
        for (prop in from) {
            hasProp = to[prop] !== undefined;
            if (hasProp && typeof from[prop] === 'object' && from[prop] !== null && from[prop].nodeName === undefined) {
                if (isDate(from[prop])) {
                    if (overwrite) {
                        to[prop] = new Date(from[prop].getTime());
                    }
                } else if (isArray(from[prop])) {
                    if (overwrite) {
                        to[prop] = from[prop].slice(0);
                    }
                } else {
                    to[prop] = extend({}, from[prop], overwrite);
                }
            } else if (overwrite || !hasProp) {
                to[prop] = from[prop];
            }
        }
        return to;
    }
      ,
    adjustCalendar = function(calendar) {
        if (calendar.month < 0) {
            calendar.year -= Math.ceil(Math.abs(calendar.month) / 12);
            calendar.month += 12;
        }
        if (calendar.month > 11) {
            calendar.year += Math.floor(Math.abs(calendar.month) / 12);
            calendar.month -= 12;
        }
        return calendar;
    }
      ,
    /**
     * defaults and localisation
     */
    defaults = {

        // bind the picker to a form field
        field: null,

        // automatically show/hide the picker on `field` focus (default `true` if `field` is set)
        bound: undefined,

        // position of the datepicker, relative to the field (default to bottom & left)
        // ('bottom' & 'left' keywords are not used, 'top' & 'right' are modifier on the bottom/left position)
        position: 'bottom left',

        // automatically fit in the viewport even if it means repositioning from the position option
        reposition: true,

        // the default output format for `.toString()` and `field` value
        format: 'YYYY-MM-DD',

        // the initial date to view when first opened
        defaultDate: null,

        // make the `defaultDate` the initial selected value
        setDefaultDate: false,

        // first day of week (0: Sunday, 1: Monday etc)
        firstDay: 0,

        // the default flag for moment's strict date parsing
        formatStrict: false,

        // the minimum/earliest date that can be selected
        minDate: null,
        // the maximum/latest date that can be selected
        maxDate: null,

        // number of years either side, or array of upper/lower range
        yearRange: 10,

        // show week numbers at head of row
        showWeekNumber: false,

        // used internally (don't config outside)
        minYear: 0,
        maxYear: 9999,
        minMonth: undefined,
        maxMonth: undefined,

        startRange: null,
        endRange: null,

        isRTL: false,

        // Additional text to append to the year in the calendar title
        yearSuffix: '',

        // Render the month after year in the calendar title
        showMonthAfterYear: false,

        // Render days of the calendar grid that fall in the next or previous month
        showDaysInNextAndPreviousMonths: false,

        // how many months are visible
        numberOfMonths: 1,

        // when numberOfMonths is used, this will help you to choose where the main calendar will be (default `left`, can be set to `right`)
        // only used for the first display or when a selected date is not visible
        mainCalendar: 'left',

        // Specify a DOM element to render the calendar in
        container: undefined,

        // internationalization
        i18n: {
            previousMonth: 'Previous Month',
            nextMonth: 'Next Month',
            months: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
            weekdays: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
            weekdaysShort: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat']
        },

        // Theme Classname
        theme: null,

        // callback function
        onSelect: null,
        onOpen: null,
        onClose: null,
        onDraw: null
    }
      ,
    /**
     * templating functions to abstract HTML rendering
     */
    renderDayName = function(opts, day, abbr) {
        day += opts.firstDay;
        while (day >= 7) {
            day -= 7;
        }
        return abbr ? opts.i18n.weekdaysShort[day] : opts.i18n.weekdays[day];
    }
      ,
    renderDay = function(opts) {
        var arr = [];
        var ariaSelected = 'false';
        if (opts.isEmpty) {
            if (opts.showDaysInNextAndPreviousMonths) {
                arr.push('is-outside-current-month');
            } else {
                return '<td class="is-empty"></td>';
            }
        }
        if (opts.isDisabled) {
            arr.push('is-disabled');
        }
        if (opts.isToday) {
            arr.push('is-today');
        }
        if (opts.isSelected) {
            arr.push('is-selected');
            ariaSelected = 'true';
        }
        if (opts.isInRange) {
            arr.push('is-inrange');
        }
        if (opts.isStartRange) {
            arr.push('is-startrange');
        }
        if (opts.isEndRange) {
            arr.push('is-endrange');
        }
        return '<td data-day="' + opts.day + '" class="' + arr.join(' ') + '" aria-selected="' + ariaSelected + '">' + '<button class="pika-button pika-day" type="button" ' + 'data-pika-year="' + opts.year + '" data-pika-month="' + opts.month + '" data-pika-day="' + opts.day + '">' + opts.day + '</button>' + '</td>';
    }
      ,
    renderWeek = function(d, m, y) {
        // Lifted from http://javascript.about.com/library/blweekyear.htm, lightly modified.
        var onejan = new Date(y,0,1)
          , weekNum = Math.ceil((((new Date(y,m,d) - onejan) / 86400000) + onejan.getDay() + 1) / 7);
        return '<td class="pika-week">' + weekNum + '</td>';
    }
      ,
    renderRow = function(days, isRTL) {
        return '<tr>' + (isRTL ? days.reverse() : days).join('') + '</tr>';
    }
      ,
    renderBody = function(rows) {
        return '<tbody>' + rows.join('') + '</tbody>';
    }
      ,
    renderHead = function(opts) {
        var i, arr = [];
        if (opts.showWeekNumber) {
            arr.push('<th></th>');
        }
        for (i = 0; i < 7; i++) {
            arr.push('<th scope="col"><abbr title="' + renderDayName(opts, i) + '">' + renderDayName(opts, i, true) + '</abbr></th>');
        }
        return '<thead><tr>' + (opts.isRTL ? arr.reverse() : arr).join('') + '</tr></thead>';
    }
      ,
    renderTitle = function(instance, c, year, month, refYear, randId) {
        var i, j, arr, opts = instance._o, isMinYear = year === opts.minYear, isMaxYear = year === opts.maxYear, html = '<div id="' + randId + '" class="pika-title" role="heading" aria-live="assertive">', monthHtml, yearHtml, prev = true, next = true;

        for (arr = [],
        i = 0; i < 12; i++) {
            arr.push('<option value="' + (year === refYear ? i - c : 12 + i - c) + '"' + (i === month ? ' selected="selected"' : '') + ((isMinYear && i < opts.minMonth) || (isMaxYear && i > opts.maxMonth) ? 'disabled="disabled"' : '') + '>' + opts.i18n.months[i] + '</option>');
        }

        monthHtml = '<div class="pika-label">' + opts.i18n.months[month] + '<select class="pika-select pika-select-month" tabindex="-1">' + arr.join('') + '</select></div>';

        if (isArray(opts.yearRange)) {
            i = opts.yearRange[0];
            j = opts.yearRange[1] + 1;
        } else {
            i = year - opts.yearRange;
            j = 1 + year + opts.yearRange;
        }

        for (arr = []; i < j && i <= opts.maxYear; i++) {
            if (i >= opts.minYear) {
                arr.push('<option value="' + i + '"' + (i === year ? ' selected="selected"' : '') + '>' + (i) + '</option>');
            }
        }
        yearHtml = '<div class="pika-label">' + year + opts.yearSuffix + '<select class="pika-select pika-select-year" tabindex="-1">' + arr.join('') + '</select></div>';

        if (opts.showMonthAfterYear) {
            html += yearHtml + monthHtml;
        } else {
            html += monthHtml + yearHtml;
        }

        if (isMinYear && (month === 0 || opts.minMonth >= month)) {
            prev = false;
        }

        if (isMaxYear && (month === 11 || opts.maxMonth <= month)) {
            next = false;
        }

        if (c === 0) {
            html += '<button class="pika-prev' + (prev ? '' : ' is-disabled') + '" type="button">' + opts.i18n.previousMonth + '</button>';
        }
        if (c === (instance._o.numberOfMonths - 1)) {
            html += '<button class="pika-next' + (next ? '' : ' is-disabled') + '" type="button">' + opts.i18n.nextMonth + '</button>';
        }

        return html += '</div>';
    }
      ,
    renderTable = function(opts, data, randId) {
        return '<table cellpadding="0" cellspacing="0" class="pika-table" role="grid" aria-labelledby="' + randId + '">' + renderHead(opts) + renderBody(data) + '</table>';
    }
      ,
    /**
     * Pikaday constructor
     */
    Pikaday = function(options) {
        var self = this
          , opts = self.config(options);

        self._onMouseDown = function(e) {
            if (!self._v) {
                return;
            }
            e = e || window.event;
            var target = e.target || e.srcElement;
            if (!target) {
                return;
            }

            if (!hasClass(target, 'is-disabled')) {
                if (hasClass(target, 'pika-button') && !hasClass(target, 'is-empty') && !hasClass(target.parentNode, 'is-disabled')) {
                    self.setDate(new Date(target.getAttribute('data-pika-year'),target.getAttribute('data-pika-month'),target.getAttribute('data-pika-day')));
                    if (opts.bound) {
                        sto(function() {
                            self.hide();
                            if (opts.field) {
                                opts.field.blur();
                            }
                        }, 100);
                    }
                } else if (hasClass(target, 'pika-prev')) {
                    self.prevMonth();
                } else if (hasClass(target, 'pika-next')) {
                    self.nextMonth();
                }
            }
            if (!hasClass(target, 'pika-select')) {
                // if this is touch event prevent mouse events emulation
                if (e.preventDefault) {
                    e.preventDefault();
                } else {
                    e.returnValue = false;
                    return false;
                }
            } else {
                self._c = true;
            }
        }
        ;

        self._onChange = function(e) {
            e = e || window.event;
            var target = e.target || e.srcElement;
            if (!target) {
                return;
            }
            if (hasClass(target, 'pika-select-month')) {
                self.gotoMonth(target.value);
            } else if (hasClass(target, 'pika-select-year')) {
                self.gotoYear(target.value);
            }
        }
        ;

        self._onKeyChange = function(e) {
            e = e || window.event;

            if (self.isVisible()) {

                switch (e.keyCode) {
                case 13:
                case 27:
                    opts.field.blur();
                    break;
                case 37:
                    e.preventDefault();
                    self.adjustDate('subtract', 1);
                    break;
                case 38:
                    self.adjustDate('subtract', 7);
                    break;
                case 39:
                    self.adjustDate('add', 1);
                    break;
                case 40:
                    self.adjustDate('add', 7);
                    break;
                }
            }
        }
        ;

        self._onInputChange = function(e) {
            var date;

            if (e.firedBy === self) {
                return;
            }
            if (hasMoment) {
                date = moment(opts.field.value, opts.format, opts.formatStrict);
                date = (date && date.isValid()) ? date.toDate() : null;
            } else {
                date = new Date(Date.parse(opts.field.value));
            }
            if (isDate(date)) {
                self.setDate(date);
            }
            if (!self._v) {
                self.show();
            }
        }
        ;

        self._onInputFocus = function() {
            self.show();
        }
        ;

        self._onInputClick = function() {
            self.show();
        }
        ;

        self._onInputBlur = function() {
            // IE allows pika div to gain focus; catch blur the input field
            var pEl = document.activeElement;
            do {
                if (hasClass(pEl, 'pika-single')) {
                    return;
                }
            } while ((pEl = pEl.parentNode));
            if (!self._c) {
                self._b = sto(function() {
                    self.hide();
                }, 50);
            }
            self._c = false;
        }
        ;

        self._onClick = function(e) {
            e = e || window.event;
            var target = e.target || e.srcElement
              , pEl = target;
            if (!target) {
                return;
            }
            if (!hasEventListeners && hasClass(target, 'pika-select')) {
                if (!target.onchange) {
                    target.setAttribute('onchange', 'return;');
                    addEvent(target, 'change', self._onChange);
                }
            }
            do {
                if (hasClass(pEl, 'pika-single') || pEl === opts.trigger) {
                    return;
                }
            } while ((pEl = pEl.parentNode));if (self._v && target !== opts.trigger && pEl !== opts.trigger) {
                self.hide();
            }
        }
        ;

        self.el = document.createElement('div');
        self.el.className = 'pika-single' + (opts.isRTL ? ' is-rtl' : '') + (opts.theme ? ' ' + opts.theme : '');

        addEvent(self.el, 'mousedown', self._onMouseDown, true);
        addEvent(self.el, 'touchend', self._onMouseDown, true);
        addEvent(self.el, 'change', self._onChange);
        addEvent(document, 'keydown', self._onKeyChange);

        if (opts.field) {
            if (opts.container) {
                opts.container.appendChild(self.el);
            } else if (opts.bound) {
                document.body.appendChild(self.el);
            } else {
                opts.field.parentNode.insertBefore(self.el, opts.field.nextSibling);
            }
            addEvent(opts.field, 'change', self._onInputChange);

            if (!opts.defaultDate) {
                if (hasMoment && opts.field.value) {
                    opts.defaultDate = moment(opts.field.value, opts.format).toDate();
                } else {
                    opts.defaultDate = new Date(Date.parse(opts.field.value));
                }
                opts.setDefaultDate = true;
            }
        }

        var defDate = opts.defaultDate;

        if (isDate(defDate)) {
            if (opts.setDefaultDate) {
                self.setDate(defDate, true);
            } else {
                self.gotoDate(defDate);
            }
        } else {
            self.gotoDate(new Date());
        }

        if (opts.bound) {
            this.hide();
            self.el.className += ' is-bound';
            addEvent(opts.trigger, 'click', self._onInputClick);
            addEvent(opts.trigger, 'focus', self._onInputFocus);
            addEvent(opts.trigger, 'blur', self._onInputBlur);
        } else {
            this.show();
        }
    };

    /**
     * public Pikaday API
     */
    Pikaday.prototype = {

        /**
         * configure functionality
         */
        config: function(options) {
            if (!this._o) {
                this._o = extend({}, defaults, true);
            }

            var opts = extend(this._o, options, true);

            opts.isRTL = !!opts.isRTL;

            opts.field = (opts.field && opts.field.nodeName) ? opts.field : null;

            opts.theme = (typeof opts.theme) === 'string' && opts.theme ? opts.theme : null;

            opts.bound = !!(opts.bound !== undefined ? opts.field && opts.bound : opts.field);

            opts.trigger = (opts.trigger && opts.trigger.nodeName) ? opts.trigger : opts.field;

            opts.disableWeekends = !!opts.disableWeekends;

            opts.disableDayFn = (typeof opts.disableDayFn) === 'function' ? opts.disableDayFn : null;

            var nom = parseInt(opts.numberOfMonths, 10) || 1;
            opts.numberOfMonths = nom > 4 ? 4 : nom;

            if (!isDate(opts.minDate)) {
                opts.minDate = false;
            }
            if (!isDate(opts.maxDate)) {
                opts.maxDate = false;
            }
            if ((opts.minDate && opts.maxDate) && opts.maxDate < opts.minDate) {
                opts.maxDate = opts.minDate = false;
            }
            if (opts.minDate) {
                this.setMinDate(opts.minDate);
            }
            if (opts.maxDate) {
                this.setMaxDate(opts.maxDate);
            }

            if (isArray(opts.yearRange)) {
                var fallback = new Date().getFullYear() - 10;
                opts.yearRange[0] = parseInt(opts.yearRange[0], 10) || fallback;
                opts.yearRange[1] = parseInt(opts.yearRange[1], 10) || fallback;
            } else {
                opts.yearRange = Math.abs(parseInt(opts.yearRange, 10)) || defaults.yearRange;
                if (opts.yearRange > 100) {
                    opts.yearRange = 100;
                }
            }

            return opts;
        },

        /**
         * return a formatted string of the current selection (using Moment.js if available)
         */
        toString: function(format) {
            return !isDate(this._d) ? '' : hasMoment ? moment(this._d).format(format || this._o.format) : this._d.toDateString();
        },

        /**
         * return a Moment.js object of the current selection (if available)
         */
        getMoment: function() {
            return hasMoment ? moment(this._d) : null;
        },

        /**
         * set the current selection from a Moment.js object (if available)
         */
        setMoment: function(date, preventOnSelect) {
            if (hasMoment && moment.isMoment(date)) {
                this.setDate(date.toDate(), preventOnSelect);
            }
        },

        /**
         * return a Date object of the current selection with fallback for the current date
         */
        getDate: function() {
            return isDate(this._d) ? new Date(this._d.getTime()) : new Date();
        },

        /**
         * set the current selection
         */
        setDate: function(date, preventOnSelect) {
            if (!date) {
                this._d = null;

                if (this._o.field) {
                    this._o.field.value = '';
                    fireEvent(this._o.field, 'change', {
                        firedBy: this
                    });
                }

                return this.draw();
            }
            if (typeof date === 'string') {
                date = new Date(Date.parse(date));
            }
            if (!isDate(date)) {
                return;
            }

            var min = this._o.minDate
              , max = this._o.maxDate;

            if (isDate(min) && date < min) {
                date = min;
            } else if (isDate(max) && date > max) {
                date = max;
            }

            this._d = new Date(date.getTime());
            setToStartOfDay(this._d);
            this.gotoDate(this._d);

            if (this._o.field) {
                this._o.field.value = this.toString();
                fireEvent(this._o.field, 'change', {
                    firedBy: this
                });
            }
            if (!preventOnSelect && typeof this._o.onSelect === 'function') {
                this._o.onSelect.call(this, this.getDate());
            }
        },

        /**
         * change view to a specific date
         */
        gotoDate: function(date) {
            var newCalendar = true;

            if (!isDate(date)) {
                return;
            }

            if (this.calendars) {
                var firstVisibleDate = new Date(this.calendars[0].year,this.calendars[0].month,1)
                  , lastVisibleDate = new Date(this.calendars[this.calendars.length - 1].year,this.calendars[this.calendars.length - 1].month,1)
                  , visibleDate = date.getTime();
                // get the end of the month
                lastVisibleDate.setMonth(lastVisibleDate.getMonth() + 1);
                lastVisibleDate.setDate(lastVisibleDate.getDate() - 1);
                newCalendar = (visibleDate < firstVisibleDate.getTime() || lastVisibleDate.getTime() < visibleDate);
            }

            if (newCalendar) {
                this.calendars = [{
                    month: date.getMonth(),
                    year: date.getFullYear()
                }];
                if (this._o.mainCalendar === 'right') {
                    this.calendars[0].month += 1 - this._o.numberOfMonths;
                }
            }

            this.adjustCalendars();
        },

        adjustDate: function(sign, days) {

            var day = this.getDate();
            var difference = parseInt(days) * 24 * 60 * 60 * 1000;

            var newDay;

            if (sign === 'add') {
                newDay = new Date(day.valueOf() + difference);
            } else if (sign === 'subtract') {
                newDay = new Date(day.valueOf() - difference);
            }

            if (hasMoment) {
                if (sign === 'add') {
                    newDay = moment(day).add(days, "days").toDate();
                } else if (sign === 'subtract') {
                    newDay = moment(day).subtract(days, "days").toDate();
                }
            }

            this.setDate(newDay);
        },

        adjustCalendars: function() {
            this.calendars[0] = adjustCalendar(this.calendars[0]);
            for (var c = 1; c < this._o.numberOfMonths; c++) {
                this.calendars[c] = adjustCalendar({
                    month: this.calendars[0].month + c,
                    year: this.calendars[0].year
                });
            }
            this.draw();
        },

        gotoToday: function() {
            this.gotoDate(new Date());
        },

        /**
         * change view to a specific month (zero-index, e.g. 0: January)
         */
        gotoMonth: function(month) {
            if (!isNaN(month)) {
                this.calendars[0].month = parseInt(month, 10);
                this.adjustCalendars();
            }
        },

        nextMonth: function() {
            this.calendars[0].month++;
            this.adjustCalendars();
        },

        prevMonth: function() {
            this.calendars[0].month--;
            this.adjustCalendars();
        },

        /**
         * change view to a specific full year (e.g. "2012")
         */
        gotoYear: function(year) {
            if (!isNaN(year)) {
                this.calendars[0].year = parseInt(year, 10);
                this.adjustCalendars();
            }
        },

        /**
         * change the minDate
         */
        setMinDate: function(value) {
            if (value instanceof Date) {
                setToStartOfDay(value);
                this._o.minDate = value;
                this._o.minYear = value.getFullYear();
                this._o.minMonth = value.getMonth();
            } else {
                this._o.minDate = defaults.minDate;
                this._o.minYear = defaults.minYear;
                this._o.minMonth = defaults.minMonth;
                this._o.startRange = defaults.startRange;
            }

            this.draw();
        },

        /**
         * change the maxDate
         */
        setMaxDate: function(value) {
            if (value instanceof Date) {
                setToStartOfDay(value);
                this._o.maxDate = value;
                this._o.maxYear = value.getFullYear();
                this._o.maxMonth = value.getMonth();
            } else {
                this._o.maxDate = defaults.maxDate;
                this._o.maxYear = defaults.maxYear;
                this._o.maxMonth = defaults.maxMonth;
                this._o.endRange = defaults.endRange;
            }

            this.draw();
        },

        setStartRange: function(value) {
            this._o.startRange = value;
        },

        setEndRange: function(value) {
            this._o.endRange = value;
        },

        /**
         * refresh the HTML
         */
        draw: function(force) {
            if (!this._v && !force) {
                return;
            }
            var opts = this._o, minYear = opts.minYear, maxYear = opts.maxYear, minMonth = opts.minMonth, maxMonth = opts.maxMonth, html = '', randId;

            if (this._y <= minYear) {
                this._y = minYear;
                if (!isNaN(minMonth) && this._m < minMonth) {
                    this._m = minMonth;
                }
            }
            if (this._y >= maxYear) {
                this._y = maxYear;
                if (!isNaN(maxMonth) && this._m > maxMonth) {
                    this._m = maxMonth;
                }
            }

            randId = 'pika-title-' + Math.random().toString(36).replace(/[^a-z]+/g, '').substr(0, 2);

            for (var c = 0; c < opts.numberOfMonths; c++) {
                html += '<div class="pika-lendar">' + renderTitle(this, c, this.calendars[c].year, this.calendars[c].month, this.calendars[0].year, randId) + this.render(this.calendars[c].year, this.calendars[c].month, randId) + '</div>';
            }

            this.el.innerHTML = html;

            if (opts.bound) {
                if (opts.field.type !== 'hidden') {
                    sto(function() {
                        opts.trigger.focus();
                    }, 1);
                }
            }

            if (typeof this._o.onDraw === 'function') {
                this._o.onDraw(this);
            }

            if (opts.bound) {
                // let the screen reader user know to use arrow keys
                opts.field.setAttribute('aria-label', 'Use the arrow keys to pick a date');
            }
        },

        adjustPosition: function() {
            var field, pEl, width, height, viewportWidth, viewportHeight, scrollTop, left, top, clientRect;

            if (this._o.container)
                return;

            this.el.style.position = 'absolute';

            field = this._o.trigger;
            pEl = field;
            width = this.el.offsetWidth;
            height = this.el.offsetHeight;
            viewportWidth = window.innerWidth || document.documentElement.clientWidth;
            viewportHeight = window.innerHeight || document.documentElement.clientHeight;
            scrollTop = window.pageYOffset || document.body.scrollTop || document.documentElement.scrollTop;

            if (typeof field.getBoundingClientRect === 'function') {
                clientRect = field.getBoundingClientRect();
                left = clientRect.left + window.pageXOffset;
                top = clientRect.bottom + window.pageYOffset;
            } else {
                left = pEl.offsetLeft;
                top = pEl.offsetTop + pEl.offsetHeight;
                while ((pEl = pEl.offsetParent)) {
                    left += pEl.offsetLeft;
                    top += pEl.offsetTop;
                }
            }

            // default position is bottom & left
            if ((this._o.reposition && left + width > viewportWidth) || (this._o.position.indexOf('right') > -1 && left - width + field.offsetWidth > 0)) {
                left = left - width + field.offsetWidth;
            }
            if ((this._o.reposition && top + height > viewportHeight + scrollTop) || (this._o.position.indexOf('top') > -1 && top - height - field.offsetHeight > 0)) {
                top = top - height - field.offsetHeight;
            }

            this.el.style.left = left + 'px';
            this.el.style.top = top + 'px';
        },

        /**
         * render HTML for a particular month
         */
        render: function(year, month, randId) {
            var opts = this._o
              , now = new Date()
              , days = getDaysInMonth(year, month)
              , before = new Date(year,month,1).getDay()
              , data = []
              , row = [];
            setToStartOfDay(now);
            if (opts.firstDay > 0) {
                before -= opts.firstDay;
                if (before < 0) {
                    before += 7;
                }
            }
            var previousMonth = month === 0 ? 11 : month - 1
              , nextMonth = month === 11 ? 0 : month + 1
              , yearOfPreviousMonth = month === 0 ? year - 1 : year
              , yearOfNextMonth = month === 11 ? year + 1 : year
              , daysInPreviousMonth = getDaysInMonth(yearOfPreviousMonth, previousMonth);
            var cells = days + before
              , after = cells;
            while (after > 7) {
                after -= 7;
            }
            cells += 7 - after;
            for (var i = 0, r = 0; i < cells; i++) {
                var day = new Date(year,month,1 + (i - before))
                  , isSelected = isDate(this._d) ? compareDates(day, this._d) : false
                  , isToday = compareDates(day, now)
                  , isEmpty = i < before || i >= (days + before)
                  , dayNumber = 1 + (i - before)
                  , monthNumber = month
                  , yearNumber = year
                  , isStartRange = opts.startRange && compareDates(opts.startRange, day)
                  , isEndRange = opts.endRange && compareDates(opts.endRange, day)
                  , isInRange = opts.startRange && opts.endRange && opts.startRange < day && day < opts.endRange
                  , isDisabled = (opts.minDate && day < opts.minDate) || (opts.maxDate && day > opts.maxDate) || (opts.disableWeekends && isWeekend(day)) || (opts.disableDayFn && opts.disableDayFn(day));

                if (isEmpty) {
                    if (i < before) {
                        dayNumber = daysInPreviousMonth + dayNumber;
                        monthNumber = previousMonth;
                        yearNumber = yearOfPreviousMonth;
                    } else {
                        dayNumber = dayNumber - days;
                        monthNumber = nextMonth;
                        yearNumber = yearOfNextMonth;
                    }
                }

                var dayConfig = {
                    day: dayNumber,
                    month: monthNumber,
                    year: yearNumber,
                    isSelected: isSelected,
                    isToday: isToday,
                    isDisabled: isDisabled,
                    isEmpty: isEmpty,
                    isStartRange: isStartRange,
                    isEndRange: isEndRange,
                    isInRange: isInRange,
                    showDaysInNextAndPreviousMonths: opts.showDaysInNextAndPreviousMonths
                };

                row.push(renderDay(dayConfig));

                if (++r === 7) {
                    if (opts.showWeekNumber) {
                        row.unshift(renderWeek(i - before, month, year));
                    }
                    data.push(renderRow(row, opts.isRTL));
                    row = [];
                    r = 0;
                }
            }
            return renderTable(opts, data, randId);
        },

        isVisible: function() {
            return this._v;
        },

        show: function() {
            if (!this.isVisible()) {
                removeClass(this.el, 'is-hidden');
                this._v = true;
                this.draw();
                if (this._o.bound) {
                    addEvent(document, 'click', this._onClick);
                    this.adjustPosition();
                }
                if (typeof this._o.onOpen === 'function') {
                    this._o.onOpen.call(this);
                }
            }
        },

        hide: function() {
            var v = this._v;
            if (v !== false) {
                if (this._o.bound) {
                    removeEvent(document, 'click', this._onClick);
                }
                this.el.style.position = 'static';
                // reset
                this.el.style.left = 'auto';
                this.el.style.top = 'auto';
                addClass(this.el, 'is-hidden');
                this._v = false;
                if (v !== undefined && typeof this._o.onClose === 'function') {
                    this._o.onClose.call(this);
                }
            }
        },

        /**
         * GAME OVER
         */
        destroy: function() {
            this.hide();
            removeEvent(this.el, 'mousedown', this._onMouseDown, true);
            removeEvent(this.el, 'touchend', this._onMouseDown, true);
            removeEvent(this.el, 'change', this._onChange);
            if (this._o.field) {
                removeEvent(this._o.field, 'change', this._onInputChange);
                if (this._o.bound) {
                    removeEvent(this._o.trigger, 'click', this._onInputClick);
                    removeEvent(this._o.trigger, 'focus', this._onInputFocus);
                    removeEvent(this._o.trigger, 'blur', this._onInputBlur);
                }
            }
            if (this.el.parentNode) {
                this.el.parentNode.removeChild(this.el);
            }
        }

    };

    return Pikaday;

}));

/* build: `node build.js modules=ALL exclude=gestures,json minifier=uglifyjs` */
/*! Fabric.js Copyright 2008-2015, Printio (Juriy Zaytsev, Maxim Chernyak) */
var fabric = fabric || {
    version: "1.5.0"
};
typeof exports != "undefined" && (exports.fabric = fabric),
typeof document != "undefined" && typeof window != "undefined" ? (fabric.document = document,
fabric.window = window,
window.fabric = fabric) : (fabric.document = require("jsdom").jsdom("<!DOCTYPE html><html><head></head><body></body></html>"),
fabric.document.createWindow ? fabric.window = fabric.document.createWindow() : fabric.window = fabric.document.parentWindow),
fabric.isTouchSupported = "ontouchstart"in fabric.document.documentElement,
fabric.isLikelyNode = typeof Buffer != "undefined" && typeof window == "undefined",
fabric.SHARED_ATTRIBUTES = ["display", "transform", "fill", "fill-opacity", "fill-rule", "opacity", "stroke", "stroke-dasharray", "stroke-linecap", "stroke-linejoin", "stroke-miterlimit", "stroke-opacity", "stroke-width"],
fabric.DPI = 96,
fabric.reNum = "(?:[-+]?(?:\\d+|\\d*\\.\\d+)(?:e[-+]?\\d+)?)",
function() {
    function e(e, t) {
        if (!this.__eventListeners[e])
            return;
        t ? fabric.util.removeFromArray(this.__eventListeners[e], t) : this.__eventListeners[e].length = 0
    }
    function t(e, t) {
        this.__eventListeners || (this.__eventListeners = {});
        if (arguments.length === 1)
            for (var n in e)
                this.on(n, e[n]);
        else
            this.__eventListeners[e] || (this.__eventListeners[e] = []),
            this.__eventListeners[e].push(t);
        return this
    }
    function n(t, n) {
        if (!this.__eventListeners)
            return;
        if (arguments.length === 0)
            this.__eventListeners = {};
        else if (arguments.length === 1 && typeof arguments[0] == "object")
            for (var r in t)
                e.call(this, r, t[r]);
        else
            e.call(this, t, n);
        return this
    }
    function r(e, t) {
        if (!this.__eventListeners)
            return;
        var n = this.__eventListeners[e];
        if (!n)
            return;
        for (var r = 0, i = n.length; r < i; r++)
            n[r].call(this, t || {});
        return this
    }
    fabric.Observable = {
        observe: t,
        stopObserving: n,
        fire: r,
        on: t,
        off: n,
        trigger: r
    }
}(),
fabric.Collection = {
    add: function() {
        this._objects.push.apply(this._objects, arguments);
        for (var e = 0, t = arguments.length; e < t; e++)
            this._onObjectAdded(arguments[e]);
        return this.renderOnAddRemove && this.renderAll(),
        this
    },
    insertAt: function(e, t, n) {
        var r = this.getObjects();
        return n ? r[t] = e : r.splice(t, 0, e),
        this._onObjectAdded(e),
        this.renderOnAddRemove && this.renderAll(),
        this
    },
    remove: function() {
        var e = this.getObjects(), t;
        for (var n = 0, r = arguments.length; n < r; n++)
            t = e.indexOf(arguments[n]),
            t !== -1 && (e.splice(t, 1),
            this._onObjectRemoved(arguments[n]));
        return this.renderOnAddRemove && this.renderAll(),
        this
    },
    forEachObject: function(e, t) {
        var n = this.getObjects()
          , r = n.length;
        while (r--)
            e.call(t, n[r], r, n);
        return this
    },
    getObjects: function(e) {
        return typeof e == "undefined" ? this._objects : this._objects.filter(function(t) {
            return t.type === e
        })
    },
    item: function(e) {
        return this.getObjects()[e]
    },
    isEmpty: function() {
        return this.getObjects().length === 0
    },
    size: function() {
        return this.getObjects().length
    },
    contains: function(e) {
        return this.getObjects().indexOf(e) > -1
    },
    complexity: function() {
        return this.getObjects().reduce(function(e, t) {
            return e += t.complexity ? t.complexity() : 0,
            e
        }, 0)
    }
},
function(e) {
    var t = Math.sqrt
      , n = Math.atan2
      , r = Math.PI / 180;
    fabric.util = {
        removeFromArray: function(e, t) {
            var n = e.indexOf(t);
            return n !== -1 && e.splice(n, 1),
            e
        },
        getRandomInt: function(e, t) {
            return Math.floor(Math.random() * (t - e + 1)) + e
        },
        degreesToRadians: function(e) {
            return e * r
        },
        radiansToDegrees: function(e) {
            return e / r
        },
        rotatePoint: function(e, t, n) {
            var r = Math.sin(n)
              , i = Math.cos(n);
            e.subtractEquals(t);
            var s = e.x * i - e.y * r
              , o = e.x * r + e.y * i;
            return (new fabric.Point(s,o)).addEquals(t)
        },
        transformPoint: function(e, t, n) {
            return n ? new fabric.Point(t[0] * e.x + t[2] * e.y,t[1] * e.x + t[3] * e.y) : new fabric.Point(t[0] * e.x + t[2] * e.y + t[4],t[1] * e.x + t[3] * e.y + t[5])
        },
        invertTransform: function(e) {
            var t = e.slice()
              , n = 1 / (e[0] * e[3] - e[1] * e[2]);
            t = [n * e[3], -n * e[1], -n * e[2], n * e[0], 0, 0];
            var r = fabric.util.transformPoint({
                x: e[4],
                y: e[5]
            }, t);
            return t[4] = -r.x,
            t[5] = -r.y,
            t
        },
        toFixed: function(e, t) {
            return parseFloat(Number(e).toFixed(t))
        },
        parseUnit: function(e, t) {
            var n = /\D{0,2}$/.exec(e)
              , r = parseFloat(e);
            t || (t = fabric.Text.DEFAULT_SVG_FONT_SIZE);
            switch (n[0]) {
            case "mm":
                return r * fabric.DPI / 25.4;
            case "cm":
                return r * fabric.DPI / 2.54;
            case "in":
                return r * fabric.DPI;
            case "pt":
                return r * fabric.DPI / 72;
            case "pc":
                return r * fabric.DPI / 72 * 12;
            case "em":
                return r * t;
            default:
                return r
            }
        },
        falseFunction: function() {
            return !1
        },
        getKlass: function(e, t) {
            return e = fabric.util.string.camelize(e.charAt(0).toUpperCase() + e.slice(1)),
            fabric.util.resolveNamespace(t)[e]
        },
        resolveNamespace: function(t) {
            if (!t)
                return fabric;
            var n = t.split(".")
              , r = n.length
              , i = e || fabric.window;
            for (var s = 0; s < r; ++s)
                i = i[n[s]];
            return i
        },
        loadImage: function(e, t, n, r) {
            if (!e) {
                t && t.call(n, e);
                return
            }
            var i = fabric.util.createImage();
            i.onload = function() {
                t && t.call(n, i),
                i = i.onload = i.onerror = null
            }
            ,
            i.onerror = function() {
                fabric.log("Error loading " + i.src),
                t && t.call(n, null, !0),
                i = i.onload = i.onerror = null
            }
            ,
            e.indexOf("data") !== 0 && typeof r != "undefined" && (i.crossOrigin = r),
            i.src = e
        },
        enlivenObjects: function(e, t, n, r) {
            function i() {
                ++o === u && t && t(s)
            }
            e = e || [];
            var s = []
              , o = 0
              , u = e.length;
            if (!u) {
                t && t(s);
                return
            }
            e.forEach(function(e, t) {
                if (!e || !e.type) {
                    i();
                    return
                }
                var o = fabric.util.getKlass(e.type, n);
                o.async ? o.fromObject(e, function(n, o) {
                    o || (s[t] = n,
                    r && r(e, s[t])),
                    i()
                }) : (s[t] = o.fromObject(e),
                r && r(e, s[t]),
                i())
            })
        },
        groupSVGElements: function(e, t, n) {
            var r;
            return r = new fabric.PathGroup(e,t),
            typeof n != "undefined" && r.setSourcePath(n),
            r
        },
        populateWithProperties: function(e, t, n) {
            if (n && Object.prototype.toString.call(n) === "[object Array]")
                for (var r = 0, i = n.length; r < i; r++)
                    n[r]in e && (t[n[r]] = e[n[r]])
        },
        drawDashedLine: function(e, r, i, s, o, u) {
            var a = s - r
              , f = o - i
              , l = t(a * a + f * f)
              , c = n(f, a)
              , h = u.length
              , p = 0
              , d = !0;
            e.save(),
            e.translate(r, i),
            e.moveTo(0, 0),
            e.rotate(c),
            r = 0;
            while (l > r)
                r += u[p++ % h],
                r > l && (r = l),
                e[d ? "lineTo" : "moveTo"](r, 0),
                d = !d;
            e.restore()
        },
        createCanvasElement: function(e) {
            return e || (e = fabric.document.createElement("canvas")),
            !e.getContext && typeof G_vmlCanvasManager != "undefined" && G_vmlCanvasManager.initElement(e),
            e
        },
        createImage: function() {
            return fabric.isLikelyNode ? new (require("canvas").Image) : fabric.document.createElement("img")
        },
        createAccessors: function(e) {
            var t = e.prototype;
            for (var n = t.stateProperties.length; n--; ) {
                var r = t.stateProperties[n]
                  , i = r.charAt(0).toUpperCase() + r.slice(1)
                  , s = "set" + i
                  , o = "get" + i;
                t[o] || (t[o] = function(e) {
                    return new Function('return this.get("' + e + '")')
                }(r)),
                t[s] || (t[s] = function(e) {
                    return new Function("value",'return this.set("' + e + '", value)')
                }(r))
            }
        },
        clipContext: function(e, t) {
            t.save(),
            t.beginPath(),
            e.clipTo(t),
            t.clip()
        },
        multiplyTransformMatrices: function(e, t) {
            return [e[0] * t[0] + e[2] * t[1], e[1] * t[0] + e[3] * t[1], e[0] * t[2] + e[2] * t[3], e[1] * t[2] + e[3] * t[3], e[0] * t[4] + e[2] * t[5] + e[4], e[1] * t[4] + e[3] * t[5] + e[5]]
        },
        getFunctionBody: function(e) {
            return (String(e).match(/function[^{]*\{([\s\S]*)\}/) || {})[1]
        },
        isTransparent: function(e, t, n, r) {
            r > 0 && (t > r ? t -= r : t = 0,
            n > r ? n -= r : n = 0);
            var i = !0
              , s = e.getImageData(t, n, r * 2 || 1, r * 2 || 1);
            for (var o = 3, u = s.data.length; o < u; o += 4) {
                var a = s.data[o];
                i = a <= 0;
                if (i === !1)
                    break
            }
            return s = null,
            i
        }
    }
}(typeof exports != "undefined" ? exports : this),
function() {
    function i(t, n, i, u, a, f, l) {
        var c = r.call(arguments);
        if (e[c])
            return e[c];
        var h = Math.PI
          , p = l * h / 180
          , d = Math.sin(p)
          , v = Math.cos(p)
          , m = 0
          , g = 0;
        i = Math.abs(i),
        u = Math.abs(u);
        var y = -v * t * .5 - d * n * .5
          , b = -v * n * .5 + d * t * .5
          , w = i * i
          , E = u * u
          , S = b * b
          , x = y * y
          , T = w * E - w * S - E * x
          , N = 0;
        if (T < 0) {
            var C = Math.sqrt(1 - T / (w * E));
            i *= C,
            u *= C
        } else
            N = (a === f ? -1 : 1) * Math.sqrt(T / (w * S + E * x));
        var k = N * i * b / u
          , L = -N * u * y / i
          , A = v * k - d * L + t * .5
          , O = d * k + v * L + n * .5
          , M = o(1, 0, (y - k) / i, (b - L) / u)
          , _ = o((y - k) / i, (b - L) / u, (-y - k) / i, (-b - L) / u);
        f === 0 && _ > 0 ? _ -= 2 * h : f === 1 && _ < 0 && (_ += 2 * h);
        var D = Math.ceil(Math.abs(_ / h * 2))
          , P = []
          , H = _ / D
          , B = 8 / 3 * Math.sin(H / 4) * Math.sin(H / 4) / Math.sin(H / 2)
          , j = M + H;
        for (var F = 0; F < D; F++)
            P[F] = s(M, j, v, d, i, u, A, O, B, m, g),
            m = P[F][4],
            g = P[F][5],
            M = j,
            j += H;
        return e[c] = P,
        P
    }
    function s(e, n, i, s, o, u, a, f, l, c, h) {
        var p = r.call(arguments);
        if (t[p])
            return t[p];
        var d = Math.cos(e)
          , v = Math.sin(e)
          , m = Math.cos(n)
          , g = Math.sin(n)
          , y = i * o * m - s * u * g + a
          , b = s * o * m + i * u * g + f
          , w = c + l * (-i * o * v - s * u * d)
          , E = h + l * (-s * o * v + i * u * d)
          , S = y + l * (i * o * g + s * u * m)
          , x = b + l * (s * o * g - i * u * m);
        return t[p] = [w, E, S, x, y, b],
        t[p]
    }
    function o(e, t, n, r) {
        var i = Math.atan2(t, e)
          , s = Math.atan2(r, n);
        return s >= i ? s - i : 2 * Math.PI - (i - s)
    }
    function u(e, t, i, s, o, u, a, f) {
        var l = r.call(arguments);
        if (n[l])
            return n[l];
        var c = Math.sqrt, h = Math.min, p = Math.max, d = Math.abs, v = [], m = [[], []], g, y, b, w, E, S, x, T;
        y = 6 * e - 12 * i + 6 * o,
        g = -3 * e + 9 * i - 9 * o + 3 * a,
        b = 3 * i - 3 * e;
        for (var N = 0; N < 2; ++N) {
            N > 0 && (y = 6 * t - 12 * s + 6 * u,
            g = -3 * t + 9 * s - 9 * u + 3 * f,
            b = 3 * s - 3 * t);
            if (d(g) < 1e-12) {
                if (d(y) < 1e-12)
                    continue;
                w = -b / y,
                0 < w && w < 1 && v.push(w);
                continue
            }
            x = y * y - 4 * b * g;
            if (x < 0)
                continue;
            T = c(x),
            E = (-y + T) / (2 * g),
            0 < E && E < 1 && v.push(E),
            S = (-y - T) / (2 * g),
            0 < S && S < 1 && v.push(S)
        }
        var C, k, L = v.length, A = L, O;
        while (L--)
            w = v[L],
            O = 1 - w,
            C = O * O * O * e + 3 * O * O * w * i + 3 * O * w * w * o + w * w * w * a,
            m[0][L] = C,
            k = O * O * O * t + 3 * O * O * w * s + 3 * O * w * w * u + w * w * w * f,
            m[1][L] = k;
        m[0][A] = e,
        m[1][A] = t,
        m[0][A + 1] = a,
        m[1][A + 1] = f;
        var M = [{
            x: h.apply(null, m[0]),
            y: h.apply(null, m[1])
        }, {
            x: p.apply(null, m[0]),
            y: p.apply(null, m[1])
        }];
        return n[l] = M,
        M
    }
    var e = {}
      , t = {}
      , n = {}
      , r = Array.prototype.join;
    fabric.util.drawArc = function(e, t, n, r) {
        var s = r[0]
          , o = r[1]
          , u = r[2]
          , a = r[3]
          , f = r[4]
          , l = r[5]
          , c = r[6]
          , h = [[], [], [], []]
          , p = i(l - t, c - n, s, o, a, f, u);
        for (var d = 0, v = p.length; d < v; d++)
            h[d][0] = p[d][0] + t,
            h[d][1] = p[d][1] + n,
            h[d][2] = p[d][2] + t,
            h[d][3] = p[d][3] + n,
            h[d][4] = p[d][4] + t,
            h[d][5] = p[d][5] + n,
            e.bezierCurveTo.apply(e, h[d])
    }
    ,
    fabric.util.getBoundsOfArc = function(e, t, n, r, s, o, a, f, l) {
        var c = 0
          , h = 0
          , p = []
          , d = []
          , v = i(f - e, l - t, n, r, o, a, s)
          , m = [[], []];
        for (var g = 0, y = v.length; g < y; g++)
            p = u(c, h, v[g][0], v[g][1], v[g][2], v[g][3], v[g][4], v[g][5]),
            m[0].x = p[0].x + e,
            m[0].y = p[0].y + t,
            m[1].x = p[1].x + e,
            m[1].y = p[1].y + t,
            d.push(m[0]),
            d.push(m[1]),
            c = v[g][4],
            h = v[g][5];
        return d
    }
    ,
    fabric.util.getBoundsOfCurve = u
}(),
function() {
    function t(t, n) {
        var r = e.call(arguments, 2)
          , i = [];
        for (var s = 0, o = t.length; s < o; s++)
            i[s] = r.length ? t[s][n].apply(t[s], r) : t[s][n].call(t[s]);
        return i
    }
    function n(e, t) {
        return i(e, t, function(e, t) {
            return e >= t
        })
    }
    function r(e, t) {
        return i(e, t, function(e, t) {
            return e < t
        })
    }
    function i(e, t, n) {
        if (!e || e.length === 0)
            return;
        var r = e.length - 1
          , i = t ? e[r][t] : e[r];
        if (t)
            while (r--)
                n(e[r][t], i) && (i = e[r][t]);
        else
            while (r--)
                n(e[r], i) && (i = e[r]);
        return i
    }
    var e = Array.prototype.slice;
    Array.prototype.indexOf || (Array.prototype.indexOf = function(e) {
        if (this === void 0 || this === null)
            throw new TypeError;
        var t = Object(this)
          , n = t.length >>> 0;
        if (n === 0)
            return -1;
        var r = 0;
        arguments.length > 0 && (r = Number(arguments[1]),
        r !== r ? r = 0 : r !== 0 && r !== Number.POSITIVE_INFINITY && r !== Number.NEGATIVE_INFINITY && (r = (r > 0 || -1) * Math.floor(Math.abs(r))));
        if (r >= n)
            return -1;
        var i = r >= 0 ? r : Math.max(n - Math.abs(r), 0);
        for (; i < n; i++)
            if (i in t && t[i] === e)
                return i;
        return -1
    }
    ),
    Array.prototype.forEach || (Array.prototype.forEach = function(e, t) {
        for (var n = 0, r = this.length >>> 0; n < r; n++)
            n in this && e.call(t, this[n], n, this)
    }
    ),
    Array.prototype.map || (Array.prototype.map = function(e, t) {
        var n = [];
        for (var r = 0, i = this.length >>> 0; r < i; r++)
            r in this && (n[r] = e.call(t, this[r], r, this));
        return n
    }
    ),
    Array.prototype.every || (Array.prototype.every = function(e, t) {
        for (var n = 0, r = this.length >>> 0; n < r; n++)
            if (n in this && !e.call(t, this[n], n, this))
                return !1;
        return !0
    }
    ),
    Array.prototype.some || (Array.prototype.some = function(e, t) {
        for (var n = 0, r = this.length >>> 0; n < r; n++)
            if (n in this && e.call(t, this[n], n, this))
                return !0;
        return !1
    }
    ),
    Array.prototype.filter || (Array.prototype.filter = function(e, t) {
        var n = [], r;
        for (var i = 0, s = this.length >>> 0; i < s; i++)
            i in this && (r = this[i],
            e.call(t, r, i, this) && n.push(r));
        return n
    }
    ),
    Array.prototype.reduce || (Array.prototype.reduce = function(e) {
        var t = this.length >>> 0, n = 0, r;
        if (arguments.length > 1)
            r = arguments[1];
        else
            do {
                if (n in this) {
                    r = this[n++];
                    break
                }
                if (++n >= t)
                    throw new TypeError
            } while (!0);for (; n < t; n++)
            n in this && (r = e.call(null, r, this[n], n, this));
        return r
    }
    ),
    fabric.util.array = {
        invoke: t,
        min: r,
        max: n
    }
}(),
function() {
    function e(e, t) {
        for (var n in t)
            e[n] = t[n];
        return e
    }
    function t(t) {
        return e({}, t)
    }
    fabric.util.object = {
        extend: e,
        clone: t
    }
}(),
function() {
    function e(e) {
        return e.replace(/-+(.)?/g, function(e, t) {
            return t ? t.toUpperCase() : ""
        })
    }
    function t(e, t) {
        return e.charAt(0).toUpperCase() + (t ? e.slice(1) : e.slice(1).toLowerCase())
    }
    function n(e) {
        return e.replace(/&/g, "&amp;").replace(/"/g, "&quot;").replace(/'/g, "&apos;").replace(/</g, "&lt;").replace(/>/g, "&gt;")
    }
    String.prototype.trim || (String.prototype.trim = function() {
        return this.replace(/^[\s\xA0]+/, "").replace(/[\s\xA0]+$/, "")
    }
    ),
    fabric.util.string = {
        camelize: e,
        capitalize: t,
        escapeXml: n
    }
}(),
function() {
    var e = Array.prototype.slice
      , t = Function.prototype.apply
      , n = function() {};
    Function.prototype.bind || (Function.prototype.bind = function(r) {
        var i = this, s = e.call(arguments, 1), o;
        return s.length ? o = function() {
            return t.call(i, this instanceof n ? this : r, s.concat(e.call(arguments)))
        }
        : o = function() {
            return t.call(i, this instanceof n ? this : r, arguments)
        }
        ,
        n.prototype = this.prototype,
        o.prototype = new n,
        o
    }
    )
}(),
function() {
    function i() {}
    function s(t) {
        var n = this.constructor.superclass.prototype[t];
        return arguments.length > 1 ? n.apply(this, e.call(arguments, 1)) : n.call(this)
    }
    function o() {
        function u() {
            this.initialize.apply(this, arguments)
        }
        var n = null
          , o = e.call(arguments, 0);
        typeof o[0] == "function" && (n = o.shift()),
        u.superclass = n,
        u.subclasses = [],
        n && (i.prototype = n.prototype,
        u.prototype = new i,
        n.subclasses.push(u));
        for (var a = 0, f = o.length; a < f; a++)
            r(u, o[a], n);
        return u.prototype.initialize || (u.prototype.initialize = t),
        u.prototype.constructor = u,
        u.prototype.callSuper = s,
        u
    }
    var e = Array.prototype.slice
      , t = function() {}
      , n = function() {
        for (var e in {
            toString: 1
        })
            if (e === "toString")
                return !1;
        return !0
    }()
      , r = function(e, t, r) {
        for (var i in t)
            i in e.prototype && typeof e.prototype[i] == "function" && (t[i] + "").indexOf("callSuper") > -1 ? e.prototype[i] = function(e) {
                return function() {
                    var n = this.constructor.superclass;
                    this.constructor.superclass = r;
                    var i = t[e].apply(this, arguments);
                    this.constructor.superclass = n;
                    if (e !== "initialize")
                        return i
                }
            }(i) : e.prototype[i] = t[i],
            n && (t.toString !== Object.prototype.toString && (e.prototype.toString = t.toString),
            t.valueOf !== Object.prototype.valueOf && (e.prototype.valueOf = t.valueOf))
    };
    fabric.util.createClass = o
}(),
function() {
    function t(e) {
        var t = Array.prototype.slice.call(arguments, 1), n, r, i = t.length;
        for (r = 0; r < i; r++) {
            n = typeof e[t[r]];
            if (!/^(?:function|object|unknown)$/.test(n))
                return !1
        }
        return !0
    }
    function s(e, t) {
        return {
            handler: t,
            wrappedHandler: o(e, t)
        }
    }
    function o(e, t) {
        return function(r) {
            t.call(n(e), r || fabric.window.event)
        }
    }
    function u(e, t) {
        return function(n) {
            if (c[e] && c[e][t]) {
                var r = c[e][t];
                for (var i = 0, s = r.length; i < s; i++)
                    r[i].call(this, n || fabric.window.event)
            }
        }
    }
    function d(t, n) {
        t || (t = fabric.window.event);
        var r = t.target || (typeof t.srcElement !== e ? t.srcElement : null)
          , i = fabric.util.getScrollLeftTop(r, n);
        return {
            x: v(t) + i.left,
            y: m(t) + i.top
        }
    }
    function g(e, t, n) {
        var r = e.type === "touchend" ? "changedTouches" : "touches";
        return e[r] && e[r][0] ? e[r][0][t] - (e[r][0][t] - e[r][0][n]) || e[n] : e[n]
    }
    var e = "unknown", n, r, i = function() {
        var e = 0;
        return function(t) {
            return t.__uniqueID || (t.__uniqueID = "uniqueID__" + e++)
        }
    }();
    (function() {
        var e = {};
        n = function(t) {
            return e[t]
        }
        ,
        r = function(t, n) {
            e[t] = n
        }
    }
    )();
    var a = t(fabric.document.documentElement, "addEventListener", "removeEventListener") && t(fabric.window, "addEventListener", "removeEventListener"), f = t(fabric.document.documentElement, "attachEvent", "detachEvent") && t(fabric.window, "attachEvent", "detachEvent"), l = {}, c = {}, h, p;
    a ? (h = function(e, t, n) {
        e.addEventListener(t, n, !1)
    }
    ,
    p = function(e, t, n) {
        e.removeEventListener(t, n, !1)
    }
    ) : f ? (h = function(e, t, n) {
        var o = i(e);
        r(o, e),
        l[o] || (l[o] = {}),
        l[o][t] || (l[o][t] = []);
        var u = s(o, n);
        l[o][t].push(u),
        e.attachEvent("on" + t, u.wrappedHandler)
    }
    ,
    p = function(e, t, n) {
        var r = i(e), s;
        if (l[r] && l[r][t])
            for (var o = 0, u = l[r][t].length; o < u; o++)
                s = l[r][t][o],
                s && s.handler === n && (e.detachEvent("on" + t, s.wrappedHandler),
                l[r][t][o] = null)
    }
    ) : (h = function(e, t, n) {
        var r = i(e);
        c[r] || (c[r] = {});
        if (!c[r][t]) {
            c[r][t] = [];
            var s = e["on" + t];
            s && c[r][t].push(s),
            e["on" + t] = u(r, t)
        }
        c[r][t].push(n)
    }
    ,
    p = function(e, t, n) {
        var r = i(e);
        if (c[r] && c[r][t]) {
            var s = c[r][t];
            for (var o = 0, u = s.length; o < u; o++)
                s[o] === n && s.splice(o, 1)
        }
    }
    ),
    fabric.util.addListener = h,
    fabric.util.removeListener = p;
    var v = function(t) {
        return typeof t.clientX !== e ? t.clientX : 0
    }
      , m = function(t) {
        return typeof t.clientY !== e ? t.clientY : 0
    };
    fabric.isTouchSupported && (v = function(e) {
        return g(e, "pageX", "clientX")
    }
    ,
    m = function(e) {
        return g(e, "pageY", "clientY")
    }
    ),
    fabric.util.getPointer = d,
    fabric.util.object.extend(fabric.util, fabric.Observable)
}(),
function() {
    function e(e, t) {
        var n = e.style;
        if (!n)
            return e;
        if (typeof t == "string")
            return e.style.cssText += ";" + t,
            t.indexOf("opacity") > -1 ? s(e, t.match(/opacity:\s*(\d?\.?\d*)/)[1]) : e;
        for (var r in t)
            if (r === "opacity")
                s(e, t[r]);
            else {
                var i = r === "float" || r === "cssFloat" ? typeof n.styleFloat == "undefined" ? "cssFloat" : "styleFloat" : r;
                n[i] = t[r]
            }
        return e
    }
    var t = fabric.document.createElement("div")
      , n = typeof t.style.opacity == "string"
      , r = typeof t.style.filter == "string"
      , i = /alpha\s*\(\s*opacity\s*=\s*([^\)]+)\)/
      , s = function(e) {
        return e
    };
    n ? s = function(e, t) {
        return e.style.opacity = t,
        e
    }
    : r && (s = function(e, t) {
        var n = e.style;
        return e.currentStyle && !e.currentStyle.hasLayout && (n.zoom = 1),
        i.test(n.filter) ? (t = t >= .9999 ? "" : "alpha(opacity=" + t * 100 + ")",
        n.filter = n.filter.replace(i, t)) : n.filter += " alpha(opacity=" + t * 100 + ")",
        e
    }
    ),
    fabric.util.setStyle = e
}(),
function() {
    function t(e) {
        return typeof e == "string" ? fabric.document.getElementById(e) : e
    }
    function s(e, t) {
        var n = fabric.document.createElement(e);
        for (var r in t)
            r === "class" ? n.className = t[r] : r === "for" ? n.htmlFor = t[r] : n.setAttribute(r, t[r]);
        return n
    }
    function o(e, t) {
        e && (" " + e.className + " ").indexOf(" " + t + " ") === -1 && (e.className += (e.className ? " " : "") + t)
    }
    function u(e, t, n) {
        return typeof t == "string" && (t = s(t, n)),
        e.parentNode && e.parentNode.replaceChild(t, e),
        t.appendChild(e),
        t
    }
    function a(e, t) {
        var n, r, i = 0, s = 0, o = fabric.document.documentElement, u = fabric.document.body || {
            scrollLeft: 0,
            scrollTop: 0
        };
        r = e;
        while (e && e.parentNode && !n)
            e = e.parentNode,
            e.nodeType === 1 && fabric.util.getElementStyle(e, "position") === "fixed" && (n = e),
            e.nodeType === 1 && r !== t && fabric.util.getElementStyle(e, "position") === "absolute" ? (i = 0,
            s = 0) : e === fabric.document ? (i = u.scrollLeft || o.scrollLeft || 0,
            s = u.scrollTop || o.scrollTop || 0) : (i += e.scrollLeft || 0,
            s += e.scrollTop || 0);
        return {
            left: i,
            top: s
        }
    }
    function f(e) {
        var t, n = e && e.ownerDocument, r = {
            left: 0,
            top: 0
        }, i = {
            left: 0,
            top: 0
        }, s, o = {
            borderLeftWidth: "left",
            borderTopWidth: "top",
            paddingLeft: "left",
            paddingTop: "top"
        };
        if (!n)
            return {
                left: 0,
                top: 0
            };
        for (var u in o)
            i[o[u]] += parseInt(l(e, u), 10) || 0;
        return t = n.documentElement,
        typeof e.getBoundingClientRect != "undefined" && (r = e.getBoundingClientRect()),
        s = fabric.util.getScrollLeftTop(e, null),
        {
            left: r.left + s.left - (t.clientLeft || 0) + i.left,
            top: r.top + s.top - (t.clientTop || 0) + i.top
        }
    }
    var e = Array.prototype.slice, n, r = function(t) {
        return e.call(t, 0)
    };
    try {
        n = r(fabric.document.childNodes)instanceof Array
    } catch (i) {}
    n || (r = function(e) {
        var t = new Array(e.length)
          , n = e.length;
        while (n--)
            t[n] = e[n];
        return t
    }
    );
    var l;
    fabric.document.defaultView && fabric.document.defaultView.getComputedStyle ? l = function(e, t) {
        var n = fabric.document.defaultView.getComputedStyle(e, null);
        return n ? n[t] : undefined
    }
    : l = function(e, t) {
        var n = e.style[t];
        return !n && e.currentStyle && (n = e.currentStyle[t]),
        n
    }
    ,
    function() {
        function n(e) {
            return typeof e.onselectstart != "undefined" && (e.onselectstart = fabric.util.falseFunction),
            t ? e.style[t] = "none" : typeof e.unselectable == "string" && (e.unselectable = "on"),
            e
        }
        function r(e) {
            return typeof e.onselectstart != "undefined" && (e.onselectstart = null),
            t ? e.style[t] = "" : typeof e.unselectable == "string" && (e.unselectable = ""),
            e
        }
        var e = fabric.document.documentElement.style
          , t = "userSelect"in e ? "userSelect" : "MozUserSelect"in e ? "MozUserSelect" : "WebkitUserSelect"in e ? "WebkitUserSelect" : "KhtmlUserSelect"in e ? "KhtmlUserSelect" : "";
        fabric.util.makeElementUnselectable = n,
        fabric.util.makeElementSelectable = r
    }(),
    function() {
        function e(e, t) {
            var n = fabric.document.getElementsByTagName("head")[0]
              , r = fabric.document.createElement("script")
              , i = !0;
            r.onload = r.onreadystatechange = function(e) {
                if (i) {
                    if (typeof this.readyState == "string" && this.readyState !== "loaded" && this.readyState !== "complete")
                        return;
                    i = !1,
                    t(e || fabric.window.event),
                    r = r.onload = r.onreadystatechange = null
                }
            }
            ,
            r.src = e,
            n.appendChild(r)
        }
        fabric.util.getScript = e
    }(),
    fabric.util.getById = t,
    fabric.util.toArray = r,
    fabric.util.makeElement = s,
    fabric.util.addClass = o,
    fabric.util.wrapElement = u,
    fabric.util.getScrollLeftTop = a,
    fabric.util.getElementOffset = f,
    fabric.util.getElementStyle = l
}(),
function() {
    function e(e, t) {
        return e + (/\?/.test(e) ? "&" : "?") + t
    }
    function n() {}
    function r(r, i) {
        i || (i = {});
        var s = i.method ? i.method.toUpperCase() : "GET", o = i.onComplete || function() {}
        , u = t(), a;
        return u.onreadystatechange = function() {
            u.readyState === 4 && (o(u),
            u.onreadystatechange = n)
        }
        ,
        s === "GET" && (a = null,
        typeof i.parameters == "string" && (r = e(r, i.parameters))),
        u.open(s, r, !0),
        (s === "POST" || s === "PUT") && u.setRequestHeader("Content-Type", "application/x-www-form-urlencoded"),
        u.send(a),
        u
    }
    var t = function() {
        var e = [function() {
            return new ActiveXObject("Microsoft.XMLHTTP")
        }
        , function() {
            return new ActiveXObject("Msxml2.XMLHTTP")
        }
        , function() {
            return new ActiveXObject("Msxml2.XMLHTTP.3.0")
        }
        , function() {
            return new XMLHttpRequest
        }
        ];
        for (var t = e.length; t--; )
            try {
                var n = e[t]();
                if (n)
                    return e[t]
            } catch (r) {}
    }();
    fabric.util.request = r
}(),
fabric.log = function() {}
,
fabric.warn = function() {}
,
typeof console != "undefined" && ["log", "warn"].forEach(function(e) {
    typeof console[e] != "undefined" && typeof console[e].apply == "function" && (fabric[e] = function() {
        return console[e].apply(console, arguments)
    }
    )
}),
function() {
    function e(e) {
        n(function(t) {
            e || (e = {});
            var r = t || +(new Date), i = e.duration || 500, s = r + i, o, u = e.onChange || function() {}
            , a = e.abort || function() {
                return !1
            }
            , f = e.easing || function(e, t, n, r) {
                return -n * Math.cos(e / r * (Math.PI / 2)) + n + t
            }
            , l = "startValue"in e ? e.startValue : 0, c = "endValue"in e ? e.endValue : 100, h = e.byValue || c - l;
            e.onStart && e.onStart(),
            function p(t) {
                o = t || +(new Date);
                var c = o > s ? i : o - r;
                if (a()) {
                    e.onComplete && e.onComplete();
                    return
                }
                u(f(c, l, h, i));
                if (o > s) {
                    e.onComplete && e.onComplete();
                    return
                }
                n(p)
            }(r)
        })
    }
    function n() {
        return t.apply(fabric.window, arguments)
    }
    var t = fabric.window.requestAnimationFrame || fabric.window.webkitRequestAnimationFrame || fabric.window.mozRequestAnimationFrame || fabric.window.oRequestAnimationFrame || fabric.window.msRequestAnimationFrame || function(e) {
        fabric.window.setTimeout(e, 1e3 / 60)
    }
    ;
    fabric.util.animate = e,
    fabric.util.requestAnimFrame = n
}(),
function() {
    function e(e, t, n, r) {
        return e < Math.abs(t) ? (e = t,
        r = n / 4) : r = n / (2 * Math.PI) * Math.asin(t / e),
        {
            a: e,
            c: t,
            p: n,
            s: r
        }
    }
    function t(e, t, n) {
        return e.a * Math.pow(2, 10 * (t -= 1)) * Math.sin((t * n - e.s) * 2 * Math.PI / e.p)
    }
    function n(e, t, n, r) {
        return n * ((e = e / r - 1) * e * e + 1) + t
    }
    function r(e, t, n, r) {
        return e /= r / 2,
        e < 1 ? n / 2 * e * e * e + t : n / 2 * ((e -= 2) * e * e + 2) + t
    }
    function i(e, t, n, r) {
        return n * (e /= r) * e * e * e + t
    }
    function s(e, t, n, r) {
        return -n * ((e = e / r - 1) * e * e * e - 1) + t
    }
    function o(e, t, n, r) {
        return e /= r / 2,
        e < 1 ? n / 2 * e * e * e * e + t : -n / 2 * ((e -= 2) * e * e * e - 2) + t
    }
    function u(e, t, n, r) {
        return n * (e /= r) * e * e * e * e + t
    }
    function a(e, t, n, r) {
        return n * ((e = e / r - 1) * e * e * e * e + 1) + t
    }
    function f(e, t, n, r) {
        return e /= r / 2,
        e < 1 ? n / 2 * e * e * e * e * e + t : n / 2 * ((e -= 2) * e * e * e * e + 2) + t
    }
    function l(e, t, n, r) {
        return -n * Math.cos(e / r * (Math.PI / 2)) + n + t
    }
    function c(e, t, n, r) {
        return n * Math.sin(e / r * (Math.PI / 2)) + t
    }
    function h(e, t, n, r) {
        return -n / 2 * (Math.cos(Math.PI * e / r) - 1) + t
    }
    function p(e, t, n, r) {
        return e === 0 ? t : n * Math.pow(2, 10 * (e / r - 1)) + t
    }
    function d(e, t, n, r) {
        return e === r ? t + n : n * (-Math.pow(2, -10 * e / r) + 1) + t
    }
    function v(e, t, n, r) {
        return e === 0 ? t : e === r ? t + n : (e /= r / 2,
        e < 1 ? n / 2 * Math.pow(2, 10 * (e - 1)) + t : n / 2 * (-Math.pow(2, -10 * --e) + 2) + t)
    }
    function m(e, t, n, r) {
        return -n * (Math.sqrt(1 - (e /= r) * e) - 1) + t
    }
    function g(e, t, n, r) {
        return n * Math.sqrt(1 - (e = e / r - 1) * e) + t
    }
    function y(e, t, n, r) {
        return e /= r / 2,
        e < 1 ? -n / 2 * (Math.sqrt(1 - e * e) - 1) + t : n / 2 * (Math.sqrt(1 - (e -= 2) * e) + 1) + t
    }
    function b(n, r, i, s) {
        var o = 1.70158
          , u = 0
          , a = i;
        if (n === 0)
            return r;
        n /= s;
        if (n === 1)
            return r + i;
        u || (u = s * .3);
        var f = e(a, i, u, o);
        return -t(f, n, s) + r
    }
    function w(t, n, r, i) {
        var s = 1.70158
          , o = 0
          , u = r;
        if (t === 0)
            return n;
        t /= i;
        if (t === 1)
            return n + r;
        o || (o = i * .3);
        var a = e(u, r, o, s);
        return a.a * Math.pow(2, -10 * t) * Math.sin((t * i - a.s) * 2 * Math.PI / a.p) + a.c + n
    }
    function E(n, r, i, s) {
        var o = 1.70158
          , u = 0
          , a = i;
        if (n === 0)
            return r;
        n /= s / 2;
        if (n === 2)
            return r + i;
        u || (u = s * .3 * 1.5);
        var f = e(a, i, u, o);
        return n < 1 ? -0.5 * t(f, n, s) + r : f.a * Math.pow(2, -10 * (n -= 1)) * Math.sin((n * s - f.s) * 2 * Math.PI / f.p) * .5 + f.c + r
    }
    function S(e, t, n, r, i) {
        return i === undefined && (i = 1.70158),
        n * (e /= r) * e * ((i + 1) * e - i) + t
    }
    function x(e, t, n, r, i) {
        return i === undefined && (i = 1.70158),
        n * ((e = e / r - 1) * e * ((i + 1) * e + i) + 1) + t
    }
    function T(e, t, n, r, i) {
        return i === undefined && (i = 1.70158),
        e /= r / 2,
        e < 1 ? n / 2 * e * e * (((i *= 1.525) + 1) * e - i) + t : n / 2 * ((e -= 2) * e * (((i *= 1.525) + 1) * e + i) + 2) + t
    }
    function N(e, t, n, r) {
        return n - C(r - e, 0, n, r) + t
    }
    function C(e, t, n, r) {
        return (e /= r) < 1 / 2.75 ? n * 7.5625 * e * e + t : e < 2 / 2.75 ? n * (7.5625 * (e -= 1.5 / 2.75) * e + .75) + t : e < 2.5 / 2.75 ? n * (7.5625 * (e -= 2.25 / 2.75) * e + .9375) + t : n * (7.5625 * (e -= 2.625 / 2.75) * e + .984375) + t
    }
    function k(e, t, n, r) {
        return e < r / 2 ? N(e * 2, 0, n, r) * .5 + t : C(e * 2 - r, 0, n, r) * .5 + n * .5 + t
    }
    fabric.util.ease = {
        easeInQuad: function(e, t, n, r) {
            return n * (e /= r) * e + t
        },
        easeOutQuad: function(e, t, n, r) {
            return -n * (e /= r) * (e - 2) + t
        },
        easeInOutQuad: function(e, t, n, r) {
            return e /= r / 2,
            e < 1 ? n / 2 * e * e + t : -n / 2 * (--e * (e - 2) - 1) + t
        },
        easeInCubic: function(e, t, n, r) {
            return n * (e /= r) * e * e + t
        },
        easeOutCubic: n,
        easeInOutCubic: r,
        easeInQuart: i,
        easeOutQuart: s,
        easeInOutQuart: o,
        easeInQuint: u,
        easeOutQuint: a,
        easeInOutQuint: f,
        easeInSine: l,
        easeOutSine: c,
        easeInOutSine: h,
        easeInExpo: p,
        easeOutExpo: d,
        easeInOutExpo: v,
        easeInCirc: m,
        easeOutCirc: g,
        easeInOutCirc: y,
        easeInElastic: b,
        easeOutElastic: w,
        easeInOutElastic: E,
        easeInBack: S,
        easeOutBack: x,
        easeInOutBack: T,
        easeInBounce: N,
        easeOutBounce: C,
        easeInOutBounce: k
    }
}(),
function(e) {
    "use strict";
    function l(e) {
        return e in a ? a[e] : e
    }
    function c(e, n, r, i) {
        var s = Object.prototype.toString.call(n) === "[object Array]", a;
        return e !== "fill" && e !== "stroke" || n !== "none" ? e === "strokeDashArray" ? n = n.replace(/,/g, " ").split(/\s+/).map(function(e) {
            return parseFloat(e)
        }) : e === "transformMatrix" ? r && r.transformMatrix ? n = u(r.transformMatrix, t.parseTransformAttribute(n)) : n = t.parseTransformAttribute(n) : e === "visible" ? (n = n === "none" || n === "hidden" ? !1 : !0,
        r && r.visible === !1 && (n = !1)) : e === "originX" ? n = n === "start" ? "left" : n === "end" ? "right" : "center" : a = s ? n.map(o) : o(n, i) : n = "",
        !s && isNaN(a) ? n : a
    }
    function h(e) {
        for (var n in f) {
            if (!e[n] || typeof e[f[n]] == "undefined")
                continue;
            if (e[n].indexOf("url(") === 0)
                continue;
            var r = new t.Color(e[n]);
            e[n] = r.setAlpha(s(r.getAlpha() * e[f[n]], 2)).toRgba()
        }
        return e
    }
    function p(e, t) {
        var n, r;
        e.replace(/;$/, "").split(";").forEach(function(e) {
            var i = e.split(":");
            n = l(i[0].trim().toLowerCase()),
            r = c(n, i[1].trim()),
            t[n] = r
        })
    }
    function d(e, t) {
        var n, r;
        for (var i in e) {
            if (typeof e[i] == "undefined")
                continue;
            n = l(i.toLowerCase()),
            r = c(n, e[i]),
            t[n] = r
        }
    }
    function v(e, n) {
        var r = {};
        for (var i in t.cssRules[n])
            if (m(e, i.split(" ")))
                for (var s in t.cssRules[n][i])
                    r[s] = t.cssRules[n][i][s];
        return r
    }
    function m(e, t) {
        var n, r = !0;
        return n = y(e, t.pop()),
        n && t.length && (r = g(e, t)),
        n && r && t.length === 0
    }
    function g(e, t) {
        var n, r = !0;
        while (e.parentNode && e.parentNode.nodeType === 1 && t.length)
            r && (n = t.pop()),
            e = e.parentNode,
            r = y(e, n);
        return t.length === 0
    }
    function y(e, t) {
        var n = e.nodeName, r = e.getAttribute("class"), i = e.getAttribute("id"), s;
        s = new RegExp("^" + n,"i"),
        t = t.replace(s, ""),
        i && t.length && (s = new RegExp("#" + i + "(?![a-zA-Z\\-]+)","i"),
        t = t.replace(s, ""));
        if (r && t.length) {
            r = r.split(" ");
            for (var o = r.length; o--; )
                s = new RegExp("\\." + r[o] + "(?![a-zA-Z\\-]+)","i"),
                t = t.replace(s, "")
        }
        return t.length === 0
    }
    function b(e) {
        var t = e.getElementsByTagName("use");
        while (t.length) {
            var n = t[0], r = n.getAttribute("xlink:href").substr(1), i = n.getAttribute("x") || 0, s = n.getAttribute("y") || 0, o = e.getElementById(r).cloneNode(!0), u = (o.getAttribute("transform") || "") + " translate(" + i + ", " + s + ")", a;
            for (var f = 0, l = n.attributes, c = l.length; f < c; f++) {
                var h = l.item(f);
                if (h.nodeName === "x" || h.nodeName === "y" || h.nodeName === "xlink:href")
                    continue;
                h.nodeName === "transform" ? u = h.nodeValue + " " + u : o.setAttribute(h.nodeName, h.nodeValue)
            }
            o.setAttribute("transform", u),
            o.setAttribute("instantiated_by_use", "1"),
            o.removeAttribute("id"),
            a = n.parentNode,
            a.replaceChild(o, n)
        }
    }
    function E(e, t, n) {
        var r = e.getAttribute("viewBox"), i = 1, s = 1, o = 0, u = 0, a, f, l, c;
        if (!r || !(r = r.match(w)))
            return;
        o = -parseFloat(r[1]),
        u = -parseFloat(r[2]),
        a = parseFloat(r[3]),
        f = parseFloat(r[4]),
        t && t !== a && (i = t / a),
        n && n !== f && (s = n / f),
        s = i = i > s ? s : i;
        if (i === 1 && s === 1 && o === 0 && u === 0)
            return;
        l = " matrix(" + i + " 0" + " 0 " + s + " " + o * i + " " + u * s + ") ";
        if (e.tagName === "svg") {
            c = e.ownerDocument.createElement("g");
            while (e.firstChild != null)
                c.appendChild(e.firstChild);
            e.appendChild(c)
        } else
            c = e,
            l = c.getAttribute("transform") + l;
        c.setAttribute("transform", l)
    }
    function x(e) {
        var n = e.objects
          , i = e.options;
        return n = n.map(function(e) {
            return t[r(e.type)].fromObject(e)
        }),
        {
            objects: n,
            options: i
        }
    }
    function T(e, t, n) {
        t[n] && t[n].toSVG && e.push('<pattern x="0" y="0" id="', n, 'Pattern" ', 'width="', t[n].source.width, '" height="', t[n].source.height, '" patternUnits="userSpaceOnUse">', '<image x="0" y="0" ', 'width="', t[n].source.width, '" height="', t[n].source.height, '" xlink:href="', t[n].source.src, '"></image></pattern>')
    }
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend
      , r = t.util.string.capitalize
      , i = t.util.object.clone
      , s = t.util.toFixed
      , o = t.util.parseUnit
      , u = t.util.multiplyTransformMatrices
      , a = {
        cx: "left",
        x: "left",
        r: "radius",
        cy: "top",
        y: "top",
        display: "visible",
        visibility: "visible",
        transform: "transformMatrix",
        "fill-opacity": "fillOpacity",
        "fill-rule": "fillRule",
        "font-family": "fontFamily",
        "font-size": "fontSize",
        "font-style": "fontStyle",
        "font-weight": "fontWeight",
        "stroke-dasharray": "strokeDashArray",
        "stroke-linecap": "strokeLineCap",
        "stroke-linejoin": "strokeLineJoin",
        "stroke-miterlimit": "strokeMiterLimit",
        "stroke-opacity": "strokeOpacity",
        "stroke-width": "strokeWidth",
        "text-decoration": "textDecoration",
        "text-anchor": "originX"
    }
      , f = {
        stroke: "strokeOpacity",
        fill: "fillOpacity"
    };
    t.cssRules = {},
    t.gradientDefs = {},
    t.parseTransformAttribute = function() {
        function e(e, t) {
            var n = t[0];
            e[0] = Math.cos(n),
            e[1] = Math.sin(n),
            e[2] = -Math.sin(n),
            e[3] = Math.cos(n)
        }
        function n(e, t) {
            var n = t[0]
              , r = t.length === 2 ? t[1] : t[0];
            e[0] = n,
            e[3] = r
        }
        function r(e, n) {
            e[2] = Math.tan(t.util.degreesToRadians(n[0]))
        }
        function i(e, n) {
            e[1] = Math.tan(t.util.degreesToRadians(n[0]))
        }
        function s(e, t) {
            e[4] = t[0],
            t.length === 2 && (e[5] = t[1])
        }
        var o = [1, 0, 0, 1, 0, 0]
          , u = t.reNum
          , a = "(?:\\s+,?\\s*|,\\s*)"
          , f = "(?:(skewX)\\s*\\(\\s*(" + u + ")\\s*\\))"
          , l = "(?:(skewY)\\s*\\(\\s*(" + u + ")\\s*\\))"
          , c = "(?:(rotate)\\s*\\(\\s*(" + u + ")(?:" + a + "(" + u + ")" + a + "(" + u + "))?\\s*\\))"
          , h = "(?:(scale)\\s*\\(\\s*(" + u + ")(?:" + a + "(" + u + "))?\\s*\\))"
          , p = "(?:(translate)\\s*\\(\\s*(" + u + ")(?:" + a + "(" + u + "))?\\s*\\))"
          , d = "(?:(matrix)\\s*\\(\\s*(" + u + ")" + a + "(" + u + ")" + a + "(" + u + ")" + a + "(" + u + ")" + a + "(" + u + ")" + a + "(" + u + ")" + "\\s*\\))"
          , v = "(?:" + d + "|" + p + "|" + h + "|" + c + "|" + f + "|" + l + ")"
          , m = "(?:" + v + "(?:" + a + v + ")*" + ")"
          , g = "^\\s*(?:" + m + "?)\\s*$"
          , y = new RegExp(g)
          , b = new RegExp(v,"g");
        return function(u) {
            var a = o.concat()
              , f = [];
            if (!u || u && !y.test(u))
                return a;
            u.replace(b, function(u) {
                var l = (new RegExp(v)).exec(u).filter(function(e) {
                    return e !== "" && e != null
                })
                  , c = l[1]
                  , h = l.slice(2).map(parseFloat);
                switch (c) {
                case "translate":
                    s(a, h);
                    break;
                case "rotate":
                    h[0] = t.util.degreesToRadians(h[0]),
                    e(a, h);
                    break;
                case "scale":
                    n(a, h);
                    break;
                case "skewX":
                    r(a, h);
                    break;
                case "skewY":
                    i(a, h);
                    break;
                case "matrix":
                    a = h
                }
                f.push(a.concat()),
                a = o.concat()
            });
            var l = f[0];
            while (f.length > 1)
                f.shift(),
                l = t.util.multiplyTransformMatrices(l, f[0]);
            return l
        }
    }();
    var w = new RegExp("^\\s*(" + t.reNum + "+)\\s*,?" + "\\s*(" + t.reNum + "+)\\s*,?" + "\\s*(" + t.reNum + "+)\\s*,?" + "\\s*(" + t.reNum + "+)\\s*" + "$");
    t.parseSVGDocument = function() {
        function r(e, t) {
            while (e && (e = e.parentNode))
                if (t.test(e.nodeName) && !e.getAttribute("instantiated_by_use"))
                    return !0;
            return !1
        }
        var e = /^(path|circle|polygon|polyline|ellipse|rect|line|image|text)$/
          , n = /^(symbol|image|marker|pattern|view)$/;
        return function(s, u, a) {
            if (!s)
                return;
            b(s);
            var f = new Date, l = t.Object.__uid++, c, h, p = !1;
            s.getAttribute("width") && s.getAttribute("width") !== "100%" && (c = o(s.getAttribute("width"))),
            s.getAttribute("height") && s.getAttribute("height") !== "100%" && (h = o(s.getAttribute("height")));
            if (!c || !h) {
                var d = s.getAttribute("viewBox");
                d && (d = d.match(w)) ? (c = parseFloat(d[3]),
                h = parseFloat(d[4])) : p = !0
            }
            E(s, c, h);
            var v = t.util.toArray(s.getElementsByTagName("*"));
            if (v.length === 0 && t.isLikelyNode) {
                v = s.selectNodes('//*[name(.)!="svg"]');
                var m = [];
                for (var g = 0, y = v.length; g < y; g++)
                    m[g] = v[g];
                v = m
            }
            var S = v.filter(function(t) {
                return n.test(t.tagName) && E(t, 0, 0),
                e.test(t.tagName) && !r(t, /^(?:pattern|defs|symbol)$/)
            });
            if (!S || S && !S.length) {
                u && u([], {});
                return
            }
            var x = {
                width: c,
                height: h,
                svgUid: l,
                toBeParsed: p
            };
            t.gradientDefs[l] = t.getGradientDefs(s),
            t.cssRules[l] = t.getCSSRules(s),
            t.parseElements(S, function(e) {
                t.documentParsingTime = new Date - f,
                u && u(e, x)
            }, i(x), a)
        }
    }();
    var S = {
        has: function(e, t) {
            t(!1)
        },
        get: function() {},
        set: function() {}
    }
      , N = new RegExp("(normal|italic)?\\s*(normal|small-caps)?\\s*(normal|bold|bolder|lighter|100|200|300|400|500|600|700|800|900)?\\s*(" + t.reNum + "(?:px|cm|mm|em|pt|pc|in)*)(?:\\/(normal|" + t.reNum + "))?\\s+(.*)");
    n(t, {
        parseFontDeclaration: function(e, t) {
            var n = e.match(N);
            if (!n)
                return;
            var r = n[1]
              , i = n[3]
              , s = n[4]
              , u = n[5]
              , a = n[6];
            r && (t.fontStyle = r),
            i && (t.fontWeight = isNaN(parseFloat(i)) ? i : parseFloat(i)),
            s && (t.fontSize = o(s)),
            a && (t.fontFamily = a),
            u && (t.lineHeight = u === "normal" ? 1 : u)
        },
        getGradientDefs: function(e) {
            var t = e.getElementsByTagName("linearGradient"), n = e.getElementsByTagName("radialGradient"), r, i, s = 0, o, u, a = [], f = {}, l = {};
            a.length = t.length + n.length,
            i = t.length;
            while (i--)
                a[s++] = t[i];
            i = n.length;
            while (i--)
                a[s++] = n[i];
            while (s--)
                r = a[s],
                u = r.getAttribute("xlink:href"),
                o = r.getAttribute("id"),
                u && (l[o] = u.substr(1)),
                f[o] = r;
            for (o in l) {
                var c = f[l[o]].cloneNode(!0);
                r = f[o];
                while (c.firstChild)
                    r.appendChild(c.firstChild)
            }
            return f
        },
        parseAttributes: function(e, r, i) {
            if (!e)
                return;
            var s, o = {}, u;
            typeof i == "undefined" && (i = e.getAttribute("svgUid")),
            e.parentNode && /^symbol|[g|a]$/i.test(e.parentNode.nodeName) && (o = t.parseAttributes(e.parentNode, r, i)),
            u = o && o.fontSize || e.getAttribute("font-size") || t.Text.DEFAULT_SVG_FONT_SIZE;
            var a = r.reduce(function(t, n) {
                return s = e.getAttribute(n),
                s && (n = l(n),
                s = c(n, s, o, u),
                t[n] = s),
                t
            }, {});
            return a = n(a, n(v(e, i), t.parseStyleAttribute(e))),
            a.font && t.parseFontDeclaration(a.font, a),
            h(n(o, a))
        },
        parseElements: function(e, n, r, i) {
            (new t.ElementsParser(e,n,r,i)).parse()
        },
        parseStyleAttribute: function(e) {
            var t = {}
              , n = e.getAttribute("style");
            return n ? (typeof n == "string" ? p(n, t) : d(n, t),
            t) : t
        },
        parsePointsAttribute: function(e) {
            if (!e)
                return null;
            e = e.replace(/,/g, " ").trim(),
            e = e.split(/\s+/);
            var t = [], n, r;
            n = 0,
            r = e.length;
            for (; n < r; n += 2)
                t.push({
                    x: parseFloat(e[n]),
                    y: parseFloat(e[n + 1])
                });
            return t
        },
        getCSSRules: function(e) {
            var n = e.getElementsByTagName("style"), r = {}, i;
            for (var s = 0, o = n.length; s < o; s++) {
                var u = n[s].textContent;
                u = u.replace(/\/\*[\s\S]*?\*\//g, "");
                if (u.trim() === "")
                    continue;
                i = u.match(/[^{]*\{[\s\S]*?\}/g),
                i = i.map(function(e) {
                    return e.trim()
                }),
                i.forEach(function(e) {
                    var n = e.match(/([\s\S]*?)\s*\{([^}]*)\}/)
                      , i = {}
                      , s = n[2].trim()
                      , o = s.replace(/;$/, "").split(/\s*;\s*/);
                    for (var u = 0, a = o.length; u < a; u++) {
                        var f = o[u].split(/\s*:\s*/)
                          , h = l(f[0])
                          , p = c(h, f[1], f[0]);
                        i[h] = p
                    }
                    e = n[1],
                    e.split(",").forEach(function(e) {
                        e = e.replace(/^svg/i, "").trim();
                        if (e === "")
                            return;
                        r[e] = t.util.object.clone(i)
                    })
                })
            }
            return r
        },
        loadSVGFromURL: function(e, n, r) {
            function i(i) {
                var s = i.responseXML;
                s && !s.documentElement && t.window.ActiveXObject && i.responseText && (s = new ActiveXObject("Microsoft.XMLDOM"),
                s.async = "false",
                s.loadXML(i.responseText.replace(/<!DOCTYPE[\s\S]*?(\[[\s\S]*\])*?>/i, "")));
                if (!s || !s.documentElement)
                    return;
                t.parseSVGDocument(s.documentElement, function(r, i) {
                    S.set(e, {
                        objects: t.util.array.invoke(r, "toObject"),
                        options: i
                    }),
                    n(r, i)
                }, r)
            }
            e = e.replace(/^\n\s*/, "").trim(),
            S.has(e, function(r) {
                r ? S.get(e, function(e) {
                    var t = x(e);
                    n(t.objects, t.options)
                }) : new t.util.request(e,{
                    method: "get",
                    onComplete: i
                })
            })
        },
        loadSVGFromString: function(e, n, r) {
            e = e.trim();
            var i;
            if (typeof DOMParser != "undefined") {
                var s = new DOMParser;
                s && s.parseFromString && (i = s.parseFromString(e, "text/xml"))
            } else
                t.window.ActiveXObject && (i = new ActiveXObject("Microsoft.XMLDOM"),
                i.async = "false",
                i.loadXML(e.replace(/<!DOCTYPE[\s\S]*?(\[[\s\S]*\])*?>/i, "")));
            t.parseSVGDocument(i.documentElement, function(e, t) {
                n(e, t)
            }, r)
        },
        createSVGFontFacesMarkup: function(e) {
            var t = "";
            for (var n = 0, r = e.length; n < r; n++) {
                if (e[n].type !== "text" || !e[n].path)
                    continue;
                t += ["@font-face {", "font-family: ", e[n].fontFamily, "; ", "src: url('", e[n].path, "')", "}"].join("")
            }
            return t && (t = ['<style type="text/css">', "<![CDATA[", t, "]]>", "</style>"].join("")),
            t
        },
        createSVGRefElementsMarkup: function(e) {
            var t = [];
            return T(t, e, "backgroundColor"),
            T(t, e, "overlayColor"),
            t.join("")
        }
    })
}(typeof exports != "undefined" ? exports : this),
fabric.ElementsParser = function(e, t, n, r) {
    this.elements = e,
    this.callback = t,
    this.options = n,
    this.reviver = r,
    this.svgUid = n && n.svgUid || 0
}
,
fabric.ElementsParser.prototype.parse = function() {
    this.instances = new Array(this.elements.length),
    this.numElements = this.elements.length,
    this.createObjects()
}
,
fabric.ElementsParser.prototype.createObjects = function() {
    for (var e = 0, t = this.elements.length; e < t; e++)
        this.elements[e].setAttribute("svgUid", this.svgUid),
        function(e, t) {
            setTimeout(function() {
                e.createObject(e.elements[t], t)
            }, 0)
        }(this, e)
}
,
fabric.ElementsParser.prototype.createObject = function(e, t) {
    var n = fabric[fabric.util.string.capitalize(e.tagName)];
    if (n && n.fromElement)
        try {
            this._createObject(n, e, t)
        } catch (r) {
            fabric.log(r)
        }
    else
        this.checkIfDone()
}
,
fabric.ElementsParser.prototype._createObject = function(e, t, n) {
    if (e.async)
        e.fromElement(t, this.createCallback(n, t), this.options);
    else {
        var r = e.fromElement(t, this.options);
        this.resolveGradient(r, "fill"),
        this.resolveGradient(r, "stroke"),
        this.reviver && this.reviver(t, r),
        this.instances[n] = r,
        this.checkIfDone()
    }
}
,
fabric.ElementsParser.prototype.createCallback = function(e, t) {
    var n = this;
    return function(r) {
        n.resolveGradient(r, "fill"),
        n.resolveGradient(r, "stroke"),
        n.reviver && n.reviver(t, r),
        n.instances[e] = r,
        n.checkIfDone()
    }
}
,
fabric.ElementsParser.prototype.resolveGradient = function(e, t) {
    var n = e.get(t);
    if (!/^url\(/.test(n))
        return;
    var r = n.slice(5, n.length - 1);
    fabric.gradientDefs[this.svgUid][r] && e.set(t, fabric.Gradient.fromElement(fabric.gradientDefs[this.svgUid][r], e))
}
,
fabric.ElementsParser.prototype.checkIfDone = function() {
    --this.numElements === 0 && (this.instances = this.instances.filter(function(e) {
        return e != null
    }),
    this.callback(this.instances))
}
,
function(e) {
    "use strict";
    function n(e, t) {
        this.x = e,
        this.y = t
    }
    var t = e.fabric || (e.fabric = {});
    if (t.Point) {
        t.warn("fabric.Point is already defined");
        return
    }
    t.Point = n,
    n.prototype = {
        constructor: n,
        add: function(e) {
            return new n(this.x + e.x,this.y + e.y)
        },
        addEquals: function(e) {
            return this.x += e.x,
            this.y += e.y,
            this
        },
        scalarAdd: function(e) {
            return new n(this.x + e,this.y + e)
        },
        scalarAddEquals: function(e) {
            return this.x += e,
            this.y += e,
            this
        },
        subtract: function(e) {
            return new n(this.x - e.x,this.y - e.y)
        },
        subtractEquals: function(e) {
            return this.x -= e.x,
            this.y -= e.y,
            this
        },
        scalarSubtract: function(e) {
            return new n(this.x - e,this.y - e)
        },
        scalarSubtractEquals: function(e) {
            return this.x -= e,
            this.y -= e,
            this
        },
        multiply: function(e) {
            return new n(this.x * e,this.y * e)
        },
        multiplyEquals: function(e) {
            return this.x *= e,
            this.y *= e,
            this
        },
        divide: function(e) {
            return new n(this.x / e,this.y / e)
        },
        divideEquals: function(e) {
            return this.x /= e,
            this.y /= e,
            this
        },
        eq: function(e) {
            return this.x === e.x && this.y === e.y
        },
        lt: function(e) {
            return this.x < e.x && this.y < e.y
        },
        lte: function(e) {
            return this.x <= e.x && this.y <= e.y
        },
        gt: function(e) {
            return this.x > e.x && this.y > e.y
        },
        gte: function(e) {
            return this.x >= e.x && this.y >= e.y
        },
        lerp: function(e, t) {
            return new n(this.x + (e.x - this.x) * t,this.y + (e.y - this.y) * t)
        },
        distanceFrom: function(e) {
            var t = this.x - e.x
              , n = this.y - e.y;
            return Math.sqrt(t * t + n * n)
        },
        midPointFrom: function(e) {
            return new n(this.x + (e.x - this.x) / 2,this.y + (e.y - this.y) / 2)
        },
        min: function(e) {
            return new n(Math.min(this.x, e.x),Math.min(this.y, e.y))
        },
        max: function(e) {
            return new n(Math.max(this.x, e.x),Math.max(this.y, e.y))
        },
        toString: function() {
            return this.x + "," + this.y
        },
        setXY: function(e, t) {
            this.x = e,
            this.y = t
        },
        setFromPoint: function(e) {
            this.x = e.x,
            this.y = e.y
        },
        swap: function(e) {
            var t = this.x
              , n = this.y;
            this.x = e.x,
            this.y = e.y,
            e.x = t,
            e.y = n
        }
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    function n(e) {
        this.status = e,
        this.points = []
    }
    var t = e.fabric || (e.fabric = {});
    if (t.Intersection) {
        t.warn("fabric.Intersection is already defined");
        return
    }
    t.Intersection = n,
    t.Intersection.prototype = {
        appendPoint: function(e) {
            this.points.push(e)
        },
        appendPoints: function(e) {
            this.points = this.points.concat(e)
        }
    },
    t.Intersection.intersectLineLine = function(e, r, i, s) {
        var o, u = (s.x - i.x) * (e.y - i.y) - (s.y - i.y) * (e.x - i.x), a = (r.x - e.x) * (e.y - i.y) - (r.y - e.y) * (e.x - i.x), f = (s.y - i.y) * (r.x - e.x) - (s.x - i.x) * (r.y - e.y);
        if (f !== 0) {
            var l = u / f
              , c = a / f;
            0 <= l && l <= 1 && 0 <= c && c <= 1 ? (o = new n("Intersection"),
            o.points.push(new t.Point(e.x + l * (r.x - e.x),e.y + l * (r.y - e.y)))) : o = new n
        } else
            u === 0 || a === 0 ? o = new n("Coincident") : o = new n("Parallel");
        return o
    }
    ,
    t.Intersection.intersectLinePolygon = function(e, t, r) {
        var i = new n
          , s = r.length;
        for (var o = 0; o < s; o++) {
            var u = r[o]
              , a = r[(o + 1) % s]
              , f = n.intersectLineLine(e, t, u, a);
            i.appendPoints(f.points)
        }
        return i.points.length > 0 && (i.status = "Intersection"),
        i
    }
    ,
    t.Intersection.intersectPolygonPolygon = function(e, t) {
        var r = new n
          , i = e.length;
        for (var s = 0; s < i; s++) {
            var o = e[s]
              , u = e[(s + 1) % i]
              , a = n.intersectLinePolygon(o, u, t);
            r.appendPoints(a.points)
        }
        return r.points.length > 0 && (r.status = "Intersection"),
        r
    }
    ,
    t.Intersection.intersectPolygonRectangle = function(e, r, i) {
        var s = r.min(i)
          , o = r.max(i)
          , u = new t.Point(o.x,s.y)
          , a = new t.Point(s.x,o.y)
          , f = n.intersectLinePolygon(s, u, e)
          , l = n.intersectLinePolygon(u, o, e)
          , c = n.intersectLinePolygon(o, a, e)
          , h = n.intersectLinePolygon(a, s, e)
          , p = new n;
        return p.appendPoints(f.points),
        p.appendPoints(l.points),
        p.appendPoints(c.points),
        p.appendPoints(h.points),
        p.points.length > 0 && (p.status = "Intersection"),
        p
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    function n(e) {
        e ? this._tryParsingColor(e) : this.setSource([0, 0, 0, 1])
    }
    function r(e, t, n) {
        return n < 0 && (n += 1),
        n > 1 && (n -= 1),
        n < 1 / 6 ? e + (t - e) * 6 * n : n < .5 ? t : n < 2 / 3 ? e + (t - e) * (2 / 3 - n) * 6 : e
    }
    var t = e.fabric || (e.fabric = {});
    if (t.Color) {
        t.warn("fabric.Color is already defined.");
        return
    }
    t.Color = n,
    t.Color.prototype = {
        _tryParsingColor: function(e) {
            var t;
            e in n.colorNameMap && (e = n.colorNameMap[e]);
            if (e === "transparent") {
                this.setSource([255, 255, 255, 0]);
                return
            }
            t = n.sourceFromHex(e),
            t || (t = n.sourceFromRgb(e)),
            t || (t = n.sourceFromHsl(e)),
            t && this.setSource(t)
        },
        _rgbToHsl: function(e, n, r) {
            e /= 255,
            n /= 255,
            r /= 255;
            var i, s, o, u = t.util.array.max([e, n, r]), a = t.util.array.min([e, n, r]);
            o = (u + a) / 2;
            if (u === a)
                i = s = 0;
            else {
                var f = u - a;
                s = o > .5 ? f / (2 - u - a) : f / (u + a);
                switch (u) {
                case e:
                    i = (n - r) / f + (n < r ? 6 : 0);
                    break;
                case n:
                    i = (r - e) / f + 2;
                    break;
                case r:
                    i = (e - n) / f + 4
                }
                i /= 6
            }
            return [Math.round(i * 360), Math.round(s * 100), Math.round(o * 100)]
        },
        getSource: function() {
            return this._source
        },
        setSource: function(e) {
            this._source = e
        },
        toRgb: function() {
            var e = this.getSource();
            return "rgb(" + e[0] + "," + e[1] + "," + e[2] + ")"
        },
        toRgba: function() {
            var e = this.getSource();
            return "rgba(" + e[0] + "," + e[1] + "," + e[2] + "," + e[3] + ")"
        },
        toHsl: function() {
            var e = this.getSource()
              , t = this._rgbToHsl(e[0], e[1], e[2]);
            return "hsl(" + t[0] + "," + t[1] + "%," + t[2] + "%)"
        },
        toHsla: function() {
            var e = this.getSource()
              , t = this._rgbToHsl(e[0], e[1], e[2]);
            return "hsla(" + t[0] + "," + t[1] + "%," + t[2] + "%," + e[3] + ")"
        },
        toHex: function() {
            var e = this.getSource(), t, n, r;
            return t = e[0].toString(16),
            t = t.length === 1 ? "0" + t : t,
            n = e[1].toString(16),
            n = n.length === 1 ? "0" + n : n,
            r = e[2].toString(16),
            r = r.length === 1 ? "0" + r : r,
            t.toUpperCase() + n.toUpperCase() + r.toUpperCase()
        },
        getAlpha: function() {
            return this.getSource()[3]
        },
        setAlpha: function(e) {
            var t = this.getSource();
            return t[3] = e,
            this.setSource(t),
            this
        },
        toGrayscale: function() {
            var e = this.getSource()
              , t = parseInt((e[0] * .3 + e[1] * .59 + e[2] * .11).toFixed(0), 10)
              , n = e[3];
            return this.setSource([t, t, t, n]),
            this
        },
        toBlackWhite: function(e) {
            var t = this.getSource()
              , n = (t[0] * .3 + t[1] * .59 + t[2] * .11).toFixed(0)
              , r = t[3];
            return e = e || 127,
            n = Number(n) < Number(e) ? 0 : 255,
            this.setSource([n, n, n, r]),
            this
        },
        overlayWith: function(e) {
            e instanceof n || (e = new n(e));
            var t = []
              , r = this.getAlpha()
              , i = .5
              , s = this.getSource()
              , o = e.getSource();
            for (var u = 0; u < 3; u++)
                t.push(Math.round(s[u] * (1 - i) + o[u] * i));
            return t[3] = r,
            this.setSource(t),
            this
        }
    },
    t.Color.reRGBa = /^rgba?\(\s*(\d{1,3}(?:\.\d+)?\%?)\s*,\s*(\d{1,3}(?:\.\d+)?\%?)\s*,\s*(\d{1,3}(?:\.\d+)?\%?)\s*(?:\s*,\s*(\d+(?:\.\d+)?)\s*)?\)$/,
    t.Color.reHSLa = /^hsla?\(\s*(\d{1,3})\s*,\s*(\d{1,3}\%)\s*,\s*(\d{1,3}\%)\s*(?:\s*,\s*(\d+(?:\.\d+)?)\s*)?\)$/,
    t.Color.reHex = /^#?([0-9a-f]{6}|[0-9a-f]{3})$/i,
    t.Color.colorNameMap = {
        aqua: "#00FFFF",
        black: "#000000",
        blue: "#0000FF",
        fuchsia: "#FF00FF",
        gray: "#808080",
        green: "#008000",
        lime: "#00FF00",
        maroon: "#800000",
        navy: "#000080",
        olive: "#808000",
        orange: "#FFA500",
        purple: "#800080",
        red: "#FF0000",
        silver: "#C0C0C0",
        teal: "#008080",
        white: "#FFFFFF",
        yellow: "#FFFF00"
    },
    t.Color.fromRgb = function(e) {
        return n.fromSource(n.sourceFromRgb(e))
    }
    ,
    t.Color.sourceFromRgb = function(e) {
        var t = e.match(n.reRGBa);
        if (t) {
            var r = parseInt(t[1], 10) / (/%$/.test(t[1]) ? 100 : 1) * (/%$/.test(t[1]) ? 255 : 1)
              , i = parseInt(t[2], 10) / (/%$/.test(t[2]) ? 100 : 1) * (/%$/.test(t[2]) ? 255 : 1)
              , s = parseInt(t[3], 10) / (/%$/.test(t[3]) ? 100 : 1) * (/%$/.test(t[3]) ? 255 : 1);
            return [parseInt(r, 10), parseInt(i, 10), parseInt(s, 10), t[4] ? parseFloat(t[4]) : 1]
        }
    }
    ,
    t.Color.fromRgba = n.fromRgb,
    t.Color.fromHsl = function(e) {
        return n.fromSource(n.sourceFromHsl(e))
    }
    ,
    t.Color.sourceFromHsl = function(e) {
        var t = e.match(n.reHSLa);
        if (!t)
            return;
        var i = (parseFloat(t[1]) % 360 + 360) % 360 / 360, s = parseFloat(t[2]) / (/%$/.test(t[2]) ? 100 : 1), o = parseFloat(t[3]) / (/%$/.test(t[3]) ? 100 : 1), u, a, f;
        if (s === 0)
            u = a = f = o;
        else {
            var l = o <= .5 ? o * (s + 1) : o + s - o * s
              , c = o * 2 - l;
            u = r(c, l, i + 1 / 3),
            a = r(c, l, i),
            f = r(c, l, i - 1 / 3)
        }
        return [Math.round(u * 255), Math.round(a * 255), Math.round(f * 255), t[4] ? parseFloat(t[4]) : 1]
    }
    ,
    t.Color.fromHsla = n.fromHsl,
    t.Color.fromHex = function(e) {
        return n.fromSource(n.sourceFromHex(e))
    }
    ,
    t.Color.sourceFromHex = function(e) {
        if (e.match(n.reHex)) {
            var t = e.slice(e.indexOf("#") + 1)
              , r = t.length === 3
              , i = r ? t.charAt(0) + t.charAt(0) : t.substring(0, 2)
              , s = r ? t.charAt(1) + t.charAt(1) : t.substring(2, 4)
              , o = r ? t.charAt(2) + t.charAt(2) : t.substring(4, 6);
            return [parseInt(i, 16), parseInt(s, 16), parseInt(o, 16), 1]
        }
    }
    ,
    t.Color.fromSource = function(e) {
        var t = new n;
        return t.setSource(e),
        t
    }
}(typeof exports != "undefined" ? exports : this),
function() {
    function e(e) {
        var t = e.getAttribute("style"), n = e.getAttribute("offset"), r, i, s;
        n = parseFloat(n) / (/%$/.test(n) ? 100 : 1),
        n = n < 0 ? 0 : n > 1 ? 1 : n;
        if (t) {
            var o = t.split(/\s*;\s*/);
            o[o.length - 1] === "" && o.pop();
            for (var u = o.length; u--; ) {
                var a = o[u].split(/\s*:\s*/)
                  , f = a[0].trim()
                  , l = a[1].trim();
                f === "stop-color" ? r = l : f === "stop-opacity" && (s = l)
            }
        }
        return r || (r = e.getAttribute("stop-color") || "rgb(0,0,0)"),
        s || (s = e.getAttribute("stop-opacity")),
        r = new fabric.Color(r),
        i = r.getAlpha(),
        s = isNaN(parseFloat(s)) ? 1 : parseFloat(s),
        s *= i,
        {
            offset: n,
            color: r.toRgb(),
            opacity: s
        }
    }
    function t(e) {
        return {
            x1: e.getAttribute("x1") || 0,
            y1: e.getAttribute("y1") || 0,
            x2: e.getAttribute("x2") || "100%",
            y2: e.getAttribute("y2") || 0
        }
    }
    function n(e) {
        return {
            x1: e.getAttribute("fx") || e.getAttribute("cx") || "50%",
            y1: e.getAttribute("fy") || e.getAttribute("cy") || "50%",
            r1: 0,
            x2: e.getAttribute("cx") || "50%",
            y2: e.getAttribute("cy") || "50%",
            r2: e.getAttribute("r") || "50%"
        }
    }
    function r(e, t, n) {
        var r, i = 0, s = 1, o = "";
        for (var u in t) {
            r = parseFloat(t[u], 10),
            typeof t[u] == "string" && /^\d+%$/.test(t[u]) ? s = .01 : s = 1;
            if (u === "x1" || u === "x2" || u === "r2")
                s *= n === "objectBoundingBox" ? e.width : 1,
                i = n === "objectBoundingBox" ? e.left || 0 : 0;
            else if (u === "y1" || u === "y2")
                s *= n === "objectBoundingBox" ? e.height : 1,
                i = n === "objectBoundingBox" ? e.top || 0 : 0;
            t[u] = r * s + i
        }
        if (e.type === "ellipse" && t.r2 !== null && n === "objectBoundingBox" && e.rx !== e.ry) {
            var a = e.ry / e.rx;
            o = " scale(1, " + a + ")",
            t.y1 && (t.y1 /= a),
            t.y2 && (t.y2 /= a)
        }
        return o
    }
    fabric.Gradient = fabric.util.createClass({
        offsetX: 0,
        offsetY: 0,
        initialize: function(e) {
            e || (e = {});
            var t = {};
            this.id = fabric.Object.__uid++,
            this.type = e.type || "linear",
            t = {
                x1: e.coords.x1 || 0,
                y1: e.coords.y1 || 0,
                x2: e.coords.x2 || 0,
                y2: e.coords.y2 || 0
            },
            this.type === "radial" && (t.r1 = e.coords.r1 || 0,
            t.r2 = e.coords.r2 || 0),
            this.coords = t,
            this.colorStops = e.colorStops.slice(),
            e.gradientTransform && (this.gradientTransform = e.gradientTransform),
            this.offsetX = e.offsetX || this.offsetX,
            this.offsetY = e.offsetY || this.offsetY
        },
        addColorStop: function(e) {
            for (var t in e) {
                var n = new fabric.Color(e[t]);
                this.colorStops.push({
                    offset: t,
                    color: n.toRgb(),
                    opacity: n.getAlpha()
                })
            }
            return this
        },
        toObject: function() {
            return {
                type: this.type,
                coords: this.coords,
                colorStops: this.colorStops,
                offsetX: this.offsetX,
                offsetY: this.offsetY
            }
        },
        toSVG: function(e) {
            var t = fabric.util.object.clone(this.coords), n, r;
            this.colorStops.sort(function(e, t) {
                return e.offset - t.offset
            });
            if (!e.group || e.group.type !== "path-group")
                for (var i in t)
                    if (i === "x1" || i === "x2" || i === "r2")
                        t[i] += this.offsetX - e.width / 2;
                    else if (i === "y1" || i === "y2")
                        t[i] += this.offsetY - e.height / 2;
            r = 'id="SVGID_' + this.id + '" gradientUnits="userSpaceOnUse"',
            this.gradientTransform && (r += ' gradientTransform="matrix(' + this.gradientTransform.join(" ") + ')" '),
            this.type === "linear" ? n = ["<linearGradient ", r, ' x1="', t.x1, '" y1="', t.y1, '" x2="', t.x2, '" y2="', t.y2, '">\n'] : this.type === "radial" && (n = ["<radialGradient ", r, ' cx="', t.x2, '" cy="', t.y2, '" r="', t.r2, '" fx="', t.x1, '" fy="', t.y1, '">\n']);
            for (var s = 0; s < this.colorStops.length; s++)
                n.push("<stop ", 'offset="', this.colorStops[s].offset * 100 + "%", '" style="stop-color:', this.colorStops[s].color, this.colorStops[s].opacity != null ? ";stop-opacity: " + this.colorStops[s].opacity : ";", '"/>\n');
            return n.push(this.type === "linear" ? "</linearGradient>\n" : "</radialGradient>\n"),
            n.join("")
        },
        toLive: function(e, t) {
            var n, r, i = fabric.util.object.clone(this.coords);
            if (!this.type)
                return;
            if (t.group && t.group.type === "path-group")
                for (r in i)
                    if (r === "x1" || r === "x2")
                        i[r] += -this.offsetX + t.width / 2;
                    else if (r === "y1" || r === "y2")
                        i[r] += -this.offsetY + t.height / 2;
            if (t.type === "text" || t.type === "i-text")
                for (r in i)
                    if (r === "x1" || r === "x2")
                        i[r] -= t.width / 2;
                    else if (r === "y1" || r === "y2")
                        i[r] -= t.height / 2;
            this.type === "linear" ? n = e.createLinearGradient(i.x1, i.y1, i.x2, i.y2) : this.type === "radial" && (n = e.createRadialGradient(i.x1, i.y1, i.r1, i.x2, i.y2, i.r2));
            for (var s = 0, o = this.colorStops.length; s < o; s++) {
                var u = this.colorStops[s].color
                  , a = this.colorStops[s].opacity
                  , f = this.colorStops[s].offset;
                typeof a != "undefined" && (u = (new fabric.Color(u)).setAlpha(a).toRgba()),
                n.addColorStop(parseFloat(f), u)
            }
            return n
        }
    }),
    fabric.util.object.extend(fabric.Gradient, {
        fromElement: function(i, s) {
            var o = i.getElementsByTagName("stop"), u = i.nodeName === "linearGradient" ? "linear" : "radial", a = i.getAttribute("gradientUnits") || "objectBoundingBox", f = i.getAttribute("gradientTransform"), l = [], c = {}, h;
            u === "linear" ? c = t(i) : u === "radial" && (c = n(i));
            for (var p = o.length; p--; )
                l.push(e(o[p]));
            h = r(s, c, a);
            var d = new fabric.Gradient({
                type: u,
                coords: c,
                colorStops: l,
                offsetX: -s.left,
                offsetY: -s.top
            });
            if (f || h !== "")
                d.gradientTransform = fabric.parseTransformAttribute((f || "") + h);
            return d
        },
        forObject: function(e, t) {
            return t || (t = {}),
            r(e, t.coords, "userSpaceOnUse"),
            new fabric.Gradient(t)
        }
    })
}(),
fabric.Pattern = fabric.util.createClass({
    repeat: "repeat",
    offsetX: 0,
    offsetY: 0,
    initialize: function(e) {
        e || (e = {}),
        this.id = fabric.Object.__uid++;
        if (e.source)
            if (typeof e.source == "string")
                if (typeof fabric.util.getFunctionBody(e.source) != "undefined")
                    this.source = new Function(fabric.util.getFunctionBody(e.source));
                else {
                    var t = this;
                    this.source = fabric.util.createImage(),
                    fabric.util.loadImage(e.source, function(e) {
                        t.source = e
                    })
                }
            else
                this.source = e.source;
        e.repeat && (this.repeat = e.repeat),
        e.offsetX && (this.offsetX = e.offsetX),
        e.offsetY && (this.offsetY = e.offsetY)
    },
    toObject: function() {
        var e;
        return typeof this.source == "function" ? e = String(this.source) : typeof this.source.src == "string" && (e = this.source.src),
        {
            source: e,
            repeat: this.repeat,
            offsetX: this.offsetX,
            offsetY: this.offsetY
        }
    },
    toSVG: function(e) {
        var t = typeof this.source == "function" ? this.source() : this.source
          , n = t.width / e.getWidth()
          , r = t.height / e.getHeight()
          , i = this.offsetX / e.getWidth()
          , s = this.offsetY / e.getHeight()
          , o = "";
        if (this.repeat === "repeat-x" || this.repeat === "no-repeat")
            r = 1;
        if (this.repeat === "repeat-y" || this.repeat === "no-repeat")
            n = 1;
        return t.src ? o = t.src : t.toDataURL && (o = t.toDataURL()),
        '<pattern id="SVGID_' + this.id + '" x="' + i + '" y="' + s + '" width="' + n + '" height="' + r + '">\n' + '<image x="0" y="0"' + ' width="' + t.width + '" height="' + t.height + '" xlink:href="' + o + '"></image>\n' + "</pattern>\n"
    },
    toLive: function(e) {
        var t = typeof this.source == "function" ? this.source() : this.source;
        if (!t)
            return "";
        if (typeof t.src != "undefined") {
            if (!t.complete)
                return "";
            if (t.naturalWidth === 0 || t.naturalHeight === 0)
                return ""
        }
        return e.createPattern(t, this.repeat)
    }
}),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.toFixed;
    if (t.Shadow) {
        t.warn("fabric.Shadow is already defined.");
        return
    }
    t.Shadow = t.util.createClass({
        color: "rgb(0,0,0)",
        blur: 0,
        offsetX: 0,
        offsetY: 0,
        affectStroke: !1,
        includeDefaultValues: !0,
        initialize: function(e) {
            typeof e == "string" && (e = this._parseShadow(e));
            for (var n in e)
                this[n] = e[n];
            this.id = t.Object.__uid++
        },
        _parseShadow: function(e) {
            var n = e.trim()
              , r = t.Shadow.reOffsetsAndBlur.exec(n) || []
              , i = n.replace(t.Shadow.reOffsetsAndBlur, "") || "rgb(0,0,0)";
            return {
                color: i.trim(),
                offsetX: parseInt(r[1], 10) || 0,
                offsetY: parseInt(r[2], 10) || 0,
                blur: parseInt(r[3], 10) || 0
            }
        },
        toString: function() {
            return [this.offsetX, this.offsetY, this.blur, this.color].join("px ")
        },
        toSVG: function(e) {
            var t = "SourceAlpha"
              , r = 40
              , i = 40;
            return e && (e.fill === this.color || e.stroke === this.color) && (t = "SourceGraphic"),
            e.width && e.height && (r = n(Math.abs(this.offsetX / e.getWidth()), 2) * 100 + 20,
            i = n(Math.abs(this.offsetY / e.getHeight()), 2) * 100 + 20),
            '<filter id="SVGID_' + this.id + '" y="-' + i + '%" height="' + (100 + 2 * i) + '%" ' + 'x="-' + r + '%" width="' + (100 + 2 * r) + '%" ' + ">\n" + '	<feGaussianBlur in="' + t + '" stdDeviation="' + n(this.blur ? this.blur / 2 : 0, 3) + '" result="blurOut"></feGaussianBlur>\n' + '	<feColorMatrix result="matrixOut" in="blurOut" type="matrix" ' + 'values="1 0 0 0 0 0 1 0 0 0 0 0 1 0 0 0 0 0 0.30 0" ></feColorMatrix >\n' + '	<feOffset dx="' + this.offsetX + '" dy="' + this.offsetY + '"></feOffset>\n' + "	<feMerge>\n" + "		<feMergeNode></feMergeNode>\n" + '		<feMergeNode in="SourceGraphic"></feMergeNode>\n' + "	</feMerge>\n" + "</filter>\n"
        },
        toObject: function() {
            if (this.includeDefaultValues)
                return {
                    color: this.color,
                    blur: this.blur,
                    offsetX: this.offsetX,
                    offsetY: this.offsetY
                };
            var e = {}
              , n = t.Shadow.prototype;
            return this.color !== n.color && (e.color = this.color),
            this.blur !== n.blur && (e.blur = this.blur),
            this.offsetX !== n.offsetX && (e.offsetX = this.offsetX),
            this.offsetY !== n.offsetY && (e.offsetY = this.offsetY),
            e
        }
    }),
    t.Shadow.reOffsetsAndBlur = /(?:\s|^)(-?\d+(?:px)?(?:\s?|$))?(-?\d+(?:px)?(?:\s?|$))?(\d+(?:px)?)?(?:\s?|$)(?:$|\s)/
}(typeof exports != "undefined" ? exports : this),
function() {
    "use strict";
    if (fabric.StaticCanvas) {
        fabric.warn("fabric.StaticCanvas is already defined.");
        return
    }
    var e = fabric.util.object.extend
      , t = fabric.util.getElementOffset
      , n = fabric.util.removeFromArray
      , r = new Error("Could not initialize `canvas` element");
    fabric.StaticCanvas = fabric.util.createClass({
        initialize: function(e, t) {
            t || (t = {}),
            this._initStatic(e, t),
            fabric.StaticCanvas.activeInstance = this
        },
        backgroundColor: "",
        backgroundImage: null,
        overlayColor: "",
        overlayImage: null,
        includeDefaultValues: !0,
        stateful: !0,
        renderOnAddRemove: !0,
        clipTo: null,
        controlsAboveOverlay: !1,
        allowTouchScrolling: !1,
        imageSmoothingEnabled: !0,
        preserveObjectStacking: !1,
        viewportTransform: [1, 0, 0, 1, 0, 0],
        onBeforeScaleRotate: function() {},
        _initStatic: function(e, t) {
            this._objects = [],
            this._createLowerCanvas(e),
            this._initOptions(t),
            this._setImageSmoothing(),
            t.overlayImage && this.setOverlayImage(t.overlayImage, this.renderAll.bind(this)),
            t.backgroundImage && this.setBackgroundImage(t.backgroundImage, this.renderAll.bind(this)),
            t.backgroundColor && this.setBackgroundColor(t.backgroundColor, this.renderAll.bind(this)),
            t.overlayColor && this.setOverlayColor(t.overlayColor, this.renderAll.bind(this)),
            this.calcOffset()
        },
        calcOffset: function() {
            return this._offset = t(this.lowerCanvasEl),
            this
        },
        setOverlayImage: function(e, t, n) {
            return this.__setBgOverlayImage("overlayImage", e, t, n)
        },
        setBackgroundImage: function(e, t, n) {
            return this.__setBgOverlayImage("backgroundImage", e, t, n)
        },
        setOverlayColor: function(e, t) {
            return this.__setBgOverlayColor("overlayColor", e, t)
        },
        setBackgroundColor: function(e, t) {
            return this.__setBgOverlayColor("backgroundColor", e, t)
        },
        _setImageSmoothing: function() {
            var e = this.getContext();
            e.imageSmoothingEnabled = this.imageSmoothingEnabled,
            e.webkitImageSmoothingEnabled = this.imageSmoothingEnabled,
            e.mozImageSmoothingEnabled = this.imageSmoothingEnabled,
            e.msImageSmoothingEnabled = this.imageSmoothingEnabled,
            e.oImageSmoothingEnabled = this.imageSmoothingEnabled
        },
        __setBgOverlayImage: function(e, t, n, r) {
            return typeof t == "string" ? fabric.util.loadImage(t, function(t) {
                this[e] = new fabric.Image(t,r),
                n && n()
            }, this, r && r.crossOrigin) : (r && t.setOptions(r),
            this[e] = t,
            n && n()),
            this
        },
        __setBgOverlayColor: function(e, t, n) {
            if (t && t.source) {
                var r = this;
                fabric.util.loadImage(t.source, function(i) {
                    r[e] = new fabric.Pattern({
                        source: i,
                        repeat: t.repeat,
                        offsetX: t.offsetX,
                        offsetY: t.offsetY
                    }),
                    n && n()
                })
            } else
                this[e] = t,
                n && n();
            return this
        },
        _createCanvasElement: function() {
            var e = fabric.document.createElement("canvas");
            e.style || (e.style = {});
            if (!e)
                throw r;
            return this._initCanvasElement(e),
            e
        },
        _initCanvasElement: function(e) {
            fabric.util.createCanvasElement(e);
            if (typeof e.getContext == "undefined")
                throw r
        },
        _initOptions: function(e) {
            for (var t in e)
                this[t] = e[t];
            this.width = this.width || parseInt(this.lowerCanvasEl.width, 10) || 0,
            this.height = this.height || parseInt(this.lowerCanvasEl.height, 10) || 0;
            if (!this.lowerCanvasEl.style)
                return;
            this.lowerCanvasEl.width = this.width,
            this.lowerCanvasEl.height = this.height,
            this.lowerCanvasEl.style.width = this.width + "px",
            this.lowerCanvasEl.style.height = this.height + "px",
            this.viewportTransform = this.viewportTransform.slice()
        },
        _createLowerCanvas: function(e) {
            this.lowerCanvasEl = fabric.util.getById(e) || this._createCanvasElement(),
            this._initCanvasElement(this.lowerCanvasEl),
            fabric.util.addClass(this.lowerCanvasEl, "lower-canvas"),
            this.interactive && this._applyCanvasStyle(this.lowerCanvasEl),
            this.contextContainer = this.lowerCanvasEl.getContext("2d")
        },
        getWidth: function() {
            return this.width
        },
        getHeight: function() {
            return this.height
        },
        setWidth: function(e, t) {
            return this.setDimensions({
                width: e
            }, t)
        },
        setHeight: function(e, t) {
            return this.setDimensions({
                height: e
            }, t)
        },
        setDimensions: function(e, t) {
            var n;
            t = t || {};
            for (var r in e)
                n = e[r],
                t.cssOnly || (this._setBackstoreDimension(r, e[r]),
                n += "px"),
                t.backstoreOnly || this._setCssDimension(r, n);
            return t.cssOnly || this.renderAll(),
            this.calcOffset(),
            this
        },
        _setBackstoreDimension: function(e, t) {
            return this.lowerCanvasEl[e] = t,
            this.upperCanvasEl && (this.upperCanvasEl[e] = t),
            this.cacheCanvasEl && (this.cacheCanvasEl[e] = t),
            this[e] = t,
            this
        },
        _setCssDimension: function(e, t) {
            return this.lowerCanvasEl.style[e] = t,
            this.upperCanvasEl && (this.upperCanvasEl.style[e] = t),
            this.wrapperEl && (this.wrapperEl.style[e] = t),
            this
        },
        getZoom: function() {
            return Math.sqrt(this.viewportTransform[0] * this.viewportTransform[3])
        },
        setViewportTransform: function(e) {
            var t = this.getActiveGroup();
            this.viewportTransform = e,
            this.renderAll();
            for (var n = 0, r = this._objects.length; n < r; n++)
                this._objects[n].setCoords();
            return t && t.setCoords(),
            this
        },
        zoomToPoint: function(e, t) {
            var n = e;
            e = fabric.util.transformPoint(e, fabric.util.invertTransform(this.viewportTransform)),
            this.viewportTransform[0] = t,
            this.viewportTransform[3] = t;
            var r = fabric.util.transformPoint(e, this.viewportTransform);
            this.viewportTransform[4] += n.x - r.x,
            this.viewportTransform[5] += n.y - r.y,
            this.renderAll();
            for (var i = 0, s = this._objects.length; i < s; i++)
                this._objects[i].setCoords();
            return this
        },
        setZoom: function(e) {
            return this.zoomToPoint(new fabric.Point(0,0), e),
            this
        },
        absolutePan: function(e) {
            this.viewportTransform[4] = -e.x,
            this.viewportTransform[5] = -e.y,
            this.renderAll();
            for (var t = 0, n = this._objects.length; t < n; t++)
                this._objects[t].setCoords();
            return this
        },
        relativePan: function(e) {
            return this.absolutePan(new fabric.Point(-e.x - this.viewportTransform[4],-e.y - this.viewportTransform[5]))
        },
        getElement: function() {
            return this.lowerCanvasEl
        },
        getActiveObject: function() {
            return null
        },
        getActiveGroup: function() {
            return null
        },
        _draw: function(e, t) {
            if (!t)
                return;
            e.save();
            var n = this.viewportTransform;
            e.transform(n[0], n[1], n[2], n[3], n[4], n[5]),
            this._shouldRenderObject(t) && t.render(e),
            e.restore(),
            this.controlsAboveOverlay || t._renderControls(e)
        },
        _shouldRenderObject: function(e) {
            return e ? e !== this.getActiveGroup() || !this.preserveObjectStacking : !1
        },
        _onObjectAdded: function(e) {
            this.stateful && e.setupState(),
            e.canvas = this,
            e.setCoords(),
            this.fire("object:added", {
                target: e
            }),
            e.fire("added")
        },
        _onObjectRemoved: function(e) {
            this.getActiveObject() === e && (this.fire("before:selection:cleared", {
                target: e
            }),
            this._discardActiveObject(),
            this.fire("selection:cleared")),
            this.fire("object:removed", {
                target: e
            }),
            e.fire("removed")
        },
        clearContext: function(e) {
            return e.clearRect(0, 0, this.width, this.height),
            this
        },
        getContext: function() {
            return this.contextContainer
        },
        clear: function() {
            return this._objects.length = 0,
            this.discardActiveGroup && this.discardActiveGroup(),
            this.discardActiveObject && this.discardActiveObject(),
            this.clearContext(this.contextContainer),
            this.contextTop && this.clearContext(this.contextTop),
            this.fire("canvas:cleared"),
            this.renderAll(),
            this
        },
        renderAll: function(e) {
            var t = this[e === !0 && this.interactive ? "contextTop" : "contextContainer"]
              , n = this.getActiveGroup();
            return this.contextTop && this.selection && !this._groupSelector && this.clearContext(this.contextTop),
            e || this.clearContext(t),
            this.fire("before:render"),
            this.clipTo && fabric.util.clipContext(this, t),
            this._renderBackground(t),
            this._renderObjects(t, n),
            this._renderActiveGroup(t, n),
            this.clipTo && t.restore(),
            this._renderOverlay(t),
            this.controlsAboveOverlay && this.interactive && this.drawControls(t),
            this.fire("after:render"),
            this
        },
        _renderObjects: function(e, t) {
            var n, r;
            if (!t || this.preserveObjectStacking)
                for (n = 0,
                r = this._objects.length; n < r; ++n)
                    this._draw(e, this._objects[n]);
            else
                for (n = 0,
                r = this._objects.length; n < r; ++n)
                    this._objects[n] && !t.contains(this._objects[n]) && this._draw(e, this._objects[n])
        },
        _renderActiveGroup: function(e, t) {
            if (t) {
                var n = [];
                this.forEachObject(function(e) {
                    t.contains(e) && n.push(e)
                }),
                t._set("objects", n),
                this._draw(e, t)
            }
        },
        _renderBackground: function(e) {
            this.backgroundColor && (e.fillStyle = this.backgroundColor.toLive ? this.backgroundColor.toLive(e) : this.backgroundColor,
            e.fillRect(this.backgroundColor.offsetX || 0, this.backgroundColor.offsetY || 0, this.width, this.height)),
            this.backgroundImage && this._draw(e, this.backgroundImage)
        },
        _renderOverlay: function(e) {
            this.overlayColor && (e.fillStyle = this.overlayColor.toLive ? this.overlayColor.toLive(e) : this.overlayColor,
            e.fillRect(this.overlayColor.offsetX || 0, this.overlayColor.offsetY || 0, this.width, this.height)),
            this.overlayImage && this._draw(e, this.overlayImage)
        },
        renderTop: function() {
            var e = this.contextTop || this.contextContainer;
            this.clearContext(e),
            this.selection && this._groupSelector && this._drawSelection();
            var t = this.getActiveGroup();
            return t && t.render(e),
            this._renderOverlay(e),
            this.fire("after:render"),
            this
        },
        getCenter: function() {
            return {
                top: this.getHeight() / 2,
                left: this.getWidth() / 2
            }
        },
        centerObjectH: function(e) {
            return this._centerObject(e, new fabric.Point(this.getCenter().left,e.getCenterPoint().y)),
            this.renderAll(),
            this
        },
        centerObjectV: function(e) {
            return this._centerObject(e, new fabric.Point(e.getCenterPoint().x,this.getCenter().top)),
            this.renderAll(),
            this
        },
        centerObject: function(e) {
            var t = this.getCenter();
            return this._centerObject(e, new fabric.Point(t.left,t.top)),
            this.renderAll(),
            this
        },
        _centerObject: function(e, t) {
            return e.setPositionByOrigin(t, "center", "center"),
            this
        },
        toDatalessJSON: function(e) {
            return this.toDatalessObject(e)
        },
        toObject: function(e) {
            return this._toObjectMethod("toObject", e)
        },
        toDatalessObject: function(e) {
            return this._toObjectMethod("toDatalessObject", e)
        },
        _toObjectMethod: function(t, n) {
            var r = {
                objects: this._toObjects(t, n)
            };
            return e(r, this.__serializeBgOverlay()),
            fabric.util.populateWithProperties(this, r, n),
            r
        },
        _toObjects: function(e, t) {
            return this.getObjects().map(function(n) {
                return this._toObject(n, e, t)
            }, this)
        },
        _toObject: function(e, t, n) {
            var r;
            this.includeDefaultValues || (r = e.includeDefaultValues,
            e.includeDefaultValues = !1);
            var i = this._realizeGroupTransformOnObject(e)
              , s = e[t](n);
            return this.includeDefaultValues || (e.includeDefaultValues = r),
            this._unwindGroupTransformOnObject(e, i),
            s
        },
        _realizeGroupTransformOnObject: function(e) {
            var t = ["angle", "flipX", "flipY", "height", "left", "scaleX", "scaleY", "top", "width"];
            if (e.group && e.group === this.getActiveGroup()) {
                var n = {};
                return t.forEach(function(t) {
                    n[t] = e[t]
                }),
                this.getActiveGroup().realizeTransform(e),
                n
            }
            return null
        },
        _unwindGroupTransformOnObject: function(e, t) {
            t && e.set(t)
        },
        __serializeBgOverlay: function() {
            var e = {
                background: this.backgroundColor && this.backgroundColor.toObject ? this.backgroundColor.toObject() : this.backgroundColor
            };
            return this.overlayColor && (e.overlay = this.overlayColor.toObject ? this.overlayColor.toObject() : this.overlayColor),
            this.backgroundImage && (e.backgroundImage = this.backgroundImage.toObject()),
            this.overlayImage && (e.overlayImage = this.overlayImage.toObject()),
            e
        },
        svgViewportTransformation: !0,
        toSVG: function(e, t) {
            e || (e = {});
            var n = [];
            return this._setSVGPreamble(n, e),
            this._setSVGHeader(n, e),
            this._setSVGBgOverlayColor(n, "backgroundColor"),
            this._setSVGBgOverlayImage(n, "backgroundImage"),
            this._setSVGObjects(n, t),
            this._setSVGBgOverlayColor(n, "overlayColor"),
            this._setSVGBgOverlayImage(n, "overlayImage"),
            n.push("</svg>"),
            n.join("")
        },
        _setSVGPreamble: function(e, t) {
            t.suppressPreamble || e.push('<?xml version="1.0" encoding="', t.encoding || "UTF-8", '" standalone="no" ?>', '<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" ', '"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">\n')
        },
        _setSVGHeader: function(e, t) {
            var n, r, i;
            t.viewBox ? (n = t.viewBox.width,
            r = t.viewBox.height) : (n = this.width,
            r = this.height,
            this.svgViewportTransformation || (i = this.viewportTransform,
            n /= i[0],
            r /= i[3])),
            e.push("<svg ", 'xmlns="http://www.w3.org/2000/svg" ', 'xmlns:xlink="http://www.w3.org/1999/xlink" ', 'version="1.1" ', 'width="', n, '" ', 'height="', r, '" ', this.backgroundColor && !this.backgroundColor.toLive ? 'style="background-color: ' + this.backgroundColor + '" ' : null, t.viewBox ? 'viewBox="' + t.viewBox.x + " " + t.viewBox.y + " " + t.viewBox.width + " " + t.viewBox.height + '" ' : null, 'xml:space="preserve">', "<desc>Created with Fabric.js ", fabric.version, "</desc>", "<defs>", fabric.createSVGFontFacesMarkup(this.getObjects()), fabric.createSVGRefElementsMarkup(this), "</defs>")
        },
        _setSVGObjects: function(e, t) {
            for (var n = 0, r = this.getObjects(), i = r.length; n < i; n++) {
                var s = r[n]
                  , o = this._realizeGroupTransformOnObject(s);
                e.push(s.toSVG(t)),
                this._unwindGroupTransformOnObject(s, o)
            }
        },
        _setSVGBgOverlayImage: function(e, t) {
            this[t] && this[t].toSVG && e.push(this[t].toSVG())
        },
        _setSVGBgOverlayColor: function(e, t) {
            this[t] && this[t].source ? e.push('<rect x="', this[t].offsetX, '" y="', this[t].offsetY, '" ', 'width="', this[t].repeat === "repeat-y" || this[t].repeat === "no-repeat" ? this[t].source.width : this.width, '" height="', this[t].repeat === "repeat-x" || this[t].repeat === "no-repeat" ? this[t].source.height : this.height, '" fill="url(#' + t + 'Pattern)"', "></rect>") : this[t] && t === "overlayColor" && e.push('<rect x="0" y="0" ', 'width="', this.width, '" height="', this.height, '" fill="', this[t], '"', "></rect>")
        },
        sendToBack: function(e) {
            return n(this._objects, e),
            this._objects.unshift(e),
            this.renderAll && this.renderAll()
        },
        bringToFront: function(e) {
            return n(this._objects, e),
            this._objects.push(e),
            this.renderAll && this.renderAll()
        },
        sendBackwards: function(e, t) {
            var r = this._objects.indexOf(e);
            if (r !== 0) {
                var i = this._findNewLowerIndex(e, r, t);
                n(this._objects, e),
                this._objects.splice(i, 0, e),
                this.renderAll && this.renderAll()
            }
            return this
        },
        _findNewLowerIndex: function(e, t, n) {
            var r;
            if (n) {
                r = t;
                for (var i = t - 1; i >= 0; --i) {
                    var s = e.intersectsWithObject(this._objects[i]) || e.isContainedWithinObject(this._objects[i]) || this._objects[i].isContainedWithinObject(e);
                    if (s) {
                        r = i;
                        break
                    }
                }
            } else
                r = t - 1;
            return r
        },
        bringForward: function(e, t) {
            var r = this._objects.indexOf(e);
            if (r !== this._objects.length - 1) {
                var i = this._findNewUpperIndex(e, r, t);
                n(this._objects, e),
                this._objects.splice(i, 0, e),
                this.renderAll && this.renderAll()
            }
            return this
        },
        _findNewUpperIndex: function(e, t, n) {
            var r;
            if (n) {
                r = t;
                for (var i = t + 1; i < this._objects.length; ++i) {
                    var s = e.intersectsWithObject(this._objects[i]) || e.isContainedWithinObject(this._objects[i]) || this._objects[i].isContainedWithinObject(e);
                    if (s) {
                        r = i;
                        break
                    }
                }
            } else
                r = t + 1;
            return r
        },
        moveTo: function(e, t) {
            return n(this._objects, e),
            this._objects.splice(t, 0, e),
            this.renderAll && this.renderAll()
        },
        dispose: function() {
            return this.clear(),
            this.interactive && this.removeListeners(),
            this
        },
        toString: function() {
            return "#<fabric.Canvas (" + this.complexity() + "): " + "{ objects: " + this.getObjects().length + " }>"
        }
    }),
    e(fabric.StaticCanvas.prototype, fabric.Observable),
    e(fabric.StaticCanvas.prototype, fabric.Collection),
    e(fabric.StaticCanvas.prototype, fabric.DataURLExporter),
    e(fabric.StaticCanvas, {
        EMPTY_JSON: '{"objects": [], "background": "white"}',
        supports: function(e) {
            var t = fabric.util.createCanvasElement();
            if (!t || !t.getContext)
                return null;
            var n = t.getContext("2d");
            if (!n)
                return null;
            switch (e) {
            case "getImageData":
                return typeof n.getImageData != "undefined";
            case "setLineDash":
                return typeof n.setLineDash != "undefined";
            case "toDataURL":
                return typeof t.toDataURL != "undefined";
            case "toDataURLWithQuality":
                try {
                    return t.toDataURL("image/jpeg", 0),
                    !0
                } catch (r) {}
                return !1;
            default:
                return null
            }
        }
    }),
    fabric.StaticCanvas.prototype.toJSON = fabric.StaticCanvas.prototype.toObject
}(),
fabric.BaseBrush = fabric.util.createClass({
    color: "rgb(0, 0, 0)",
    width: 1,
    shadow: null,
    strokeLineCap: "round",
    strokeLineJoin: "round",
    strokeDashArray: null,
    setShadow: function(e) {
        return this.shadow = new fabric.Shadow(e),
        this
    },
    _setBrushStyles: function() {
        var e = this.canvas.contextTop;
        e.strokeStyle = this.color,
        e.lineWidth = this.width,
        e.lineCap = this.strokeLineCap,
        e.lineJoin = this.strokeLineJoin,
        this.strokeDashArray && fabric.StaticCanvas.supports("setLineDash") && e.setLineDash(this.strokeDashArray)
    },
    _setShadow: function() {
        if (!this.shadow)
            return;
        var e = this.canvas.contextTop;
        e.shadowColor = this.shadow.color,
        e.shadowBlur = this.shadow.blur,
        e.shadowOffsetX = this.shadow.offsetX,
        e.shadowOffsetY = this.shadow.offsetY
    },
    _resetShadow: function() {
        var e = this.canvas.contextTop;
        e.shadowColor = "",
        e.shadowBlur = e.shadowOffsetX = e.shadowOffsetY = 0
    }
}),
function() {
    fabric.PencilBrush = fabric.util.createClass(fabric.BaseBrush, {
        initialize: function(e) {
            this.canvas = e,
            this._points = []
        },
        onMouseDown: function(e) {
            this._prepareForDrawing(e),
            this._captureDrawingPath(e),
            this._render()
        },
        onMouseMove: function(e) {
            this._captureDrawingPath(e),
            this.canvas.clearContext(this.canvas.contextTop),
            this._render()
        },
        onMouseUp: function() {
            this._finalizeAndAddPath()
        },
        _prepareForDrawing: function(e) {
            var t = new fabric.Point(e.x,e.y);
            this._reset(),
            this._addPoint(t),
            this.canvas.contextTop.moveTo(t.x, t.y)
        },
        _addPoint: function(e) {
            this._points.push(e)
        },
        _reset: function() {
            this._points.length = 0,
            this._setBrushStyles(),
            this._setShadow()
        },
        _captureDrawingPath: function(e) {
            var t = new fabric.Point(e.x,e.y);
            this._addPoint(t)
        },
        _render: function() {
            var e = this.canvas.contextTop
              , t = this.canvas.viewportTransform
              , n = this._points[0]
              , r = this._points[1];
            e.save(),
            e.transform(t[0], t[1], t[2], t[3], t[4], t[5]),
            e.beginPath(),
            this._points.length === 2 && n.x === r.x && n.y === r.y && (n.x -= .5,
            r.x += .5),
            e.moveTo(n.x, n.y);
            for (var i = 1, s = this._points.length; i < s; i++) {
                var o = n.midPointFrom(r);
                e.quadraticCurveTo(n.x, n.y, o.x, o.y),
                n = this._points[i],
                r = this._points[i + 1]
            }
            e.lineTo(n.x, n.y),
            e.stroke(),
            e.restore()
        },
        convertPointsToSVGPath: function(e) {
            var t = []
              , n = new fabric.Point(e[0].x,e[0].y)
              , r = new fabric.Point(e[1].x,e[1].y);
            t.push("M ", e[0].x, " ", e[0].y, " ");
            for (var i = 1, s = e.length; i < s; i++) {
                var o = n.midPointFrom(r);
                t.push("Q ", n.x, " ", n.y, " ", o.x, " ", o.y, " "),
                n = new fabric.Point(e[i].x,e[i].y),
                i + 1 < e.length && (r = new fabric.Point(e[i + 1].x,e[i + 1].y))
            }
            return t.push("L ", n.x, " ", n.y, " "),
            t
        },
        createPath: function(e) {
            var t = new fabric.Path(e,{
                fill: null,
                stroke: this.color,
                strokeWidth: this.width,
                strokeLineCap: this.strokeLineCap,
                strokeLineJoin: this.strokeLineJoin,
                strokeDashArray: this.strokeDashArray,
                originX: "center",
                originY: "center"
            });
            return this.shadow && (this.shadow.affectStroke = !0,
            t.setShadow(this.shadow)),
            t
        },
        _finalizeAndAddPath: function() {
            var e = this.canvas.contextTop;
            e.closePath();
            var t = this.convertPointsToSVGPath(this._points).join("");
            if (t === "M 0 0 Q 0 0 0 0 L 0 0") {
                this.canvas.renderAll();
                return
            }
            var n = this.createPath(t);
            this.canvas.add(n),
            n.setCoords(),
            this.canvas.clearContext(this.canvas.contextTop),
            this._resetShadow(),
            this.canvas.renderAll(),
            this.canvas.fire("path:created", {
                path: n
            })
        }
    })
}(),
fabric.CircleBrush = fabric.util.createClass(fabric.BaseBrush, {
    width: 10,
    initialize: function(e) {
        this.canvas = e,
        this.points = []
    },
    drawDot: function(e) {
        var t = this.addPoint(e)
          , n = this.canvas.contextTop
          , r = this.canvas.viewportTransform;
        n.save(),
        n.transform(r[0], r[1], r[2], r[3], r[4], r[5]),
        n.fillStyle = t.fill,
        n.beginPath(),
        n.arc(t.x, t.y, t.radius, 0, Math.PI * 2, !1),
        n.closePath(),
        n.fill(),
        n.restore()
    },
    onMouseDown: function(e) {
        this.points.length = 0,
        this.canvas.clearContext(this.canvas.contextTop),
        this._setShadow(),
        this.drawDot(e)
    },
    onMouseMove: function(e) {
        this.drawDot(e)
    },
    onMouseUp: function() {
        var e = this.canvas.renderOnAddRemove;
        this.canvas.renderOnAddRemove = !1;
        var t = [];
        for (var n = 0, r = this.points.length; n < r; n++) {
            var i = this.points[n]
              , s = new fabric.Circle({
                radius: i.radius,
                left: i.x,
                top: i.y,
                originX: "center",
                originY: "center",
                fill: i.fill
            });
            this.shadow && s.setShadow(this.shadow),
            t.push(s)
        }
        var o = new fabric.Group(t,{
            originX: "center",
            originY: "center"
        });
        o.canvas = this.canvas,
        this.canvas.add(o),
        this.canvas.fire("path:created", {
            path: o
        }),
        this.canvas.clearContext(this.canvas.contextTop),
        this._resetShadow(),
        this.canvas.renderOnAddRemove = e,
        this.canvas.renderAll()
    },
    addPoint: function(e) {
        var t = new fabric.Point(e.x,e.y)
          , n = fabric.util.getRandomInt(Math.max(0, this.width - 20), this.width + 20) / 2
          , r = (new fabric.Color(this.color)).setAlpha(fabric.util.getRandomInt(0, 100) / 100).toRgba();
        return t.radius = n,
        t.fill = r,
        this.points.push(t),
        t
    }
}),
fabric.SprayBrush = fabric.util.createClass(fabric.BaseBrush, {
    width: 10,
    density: 20,
    dotWidth: 1,
    dotWidthVariance: 1,
    randomOpacity: !1,
    optimizeOverlapping: !0,
    initialize: function(e) {
        this.canvas = e,
        this.sprayChunks = []
    },
    onMouseDown: function(e) {
        this.sprayChunks.length = 0,
        this.canvas.clearContext(this.canvas.contextTop),
        this._setShadow(),
        this.addSprayChunk(e),
        this.render()
    },
    onMouseMove: function(e) {
        this.addSprayChunk(e),
        this.render()
    },
    onMouseUp: function() {
        var e = this.canvas.renderOnAddRemove;
        this.canvas.renderOnAddRemove = !1;
        var t = [];
        for (var n = 0, r = this.sprayChunks.length; n < r; n++) {
            var i = this.sprayChunks[n];
            for (var s = 0, o = i.length; s < o; s++) {
                var u = new fabric.Rect({
                    width: i[s].width,
                    height: i[s].width,
                    left: i[s].x + 1,
                    top: i[s].y + 1,
                    originX: "center",
                    originY: "center",
                    fill: this.color
                });
                this.shadow && u.setShadow(this.shadow),
                t.push(u)
            }
        }
        this.optimizeOverlapping && (t = this._getOptimizedRects(t));
        var a = new fabric.Group(t,{
            originX: "center",
            originY: "center"
        });
        a.canvas = this.canvas,
        this.canvas.add(a),
        this.canvas.fire("path:created", {
            path: a
        }),
        this.canvas.clearContext(this.canvas.contextTop),
        this._resetShadow(),
        this.canvas.renderOnAddRemove = e,
        this.canvas.renderAll()
    },
    _getOptimizedRects: function(e) {
        var t = {}, n;
        for (var r = 0, i = e.length; r < i; r++)
            n = e[r].left + "" + e[r].top,
            t[n] || (t[n] = e[r]);
        var s = [];
        for (n in t)
            s.push(t[n]);
        return s
    },
    render: function() {
        var e = this.canvas.contextTop;
        e.fillStyle = this.color;
        var t = this.canvas.viewportTransform;
        e.save(),
        e.transform(t[0], t[1], t[2], t[3], t[4], t[5]);
        for (var n = 0, r = this.sprayChunkPoints.length; n < r; n++) {
            var i = this.sprayChunkPoints[n];
            typeof i.opacity != "undefined" && (e.globalAlpha = i.opacity),
            e.fillRect(i.x, i.y, i.width, i.width)
        }
        e.restore()
    },
    addSprayChunk: function(e) {
        this.sprayChunkPoints = [];
        var t, n, r, i = this.width / 2;
        for (var s = 0; s < this.density; s++) {
            t = fabric.util.getRandomInt(e.x - i, e.x + i),
            n = fabric.util.getRandomInt(e.y - i, e.y + i),
            this.dotWidthVariance ? r = fabric.util.getRandomInt(Math.max(1, this.dotWidth - this.dotWidthVariance), this.dotWidth + this.dotWidthVariance) : r = this.dotWidth;
            var o = new fabric.Point(t,n);
            o.width = r,
            this.randomOpacity && (o.opacity = fabric.util.getRandomInt(0, 100) / 100),
            this.sprayChunkPoints.push(o)
        }
        this.sprayChunks.push(this.sprayChunkPoints)
    }
}),
fabric.PatternBrush = fabric.util.createClass(fabric.PencilBrush, {
    getPatternSrc: function() {
        var e = 20
          , t = 5
          , n = fabric.document.createElement("canvas")
          , r = n.getContext("2d");
        return n.width = n.height = e + t,
        r.fillStyle = this.color,
        r.beginPath(),
        r.arc(e / 2, e / 2, e / 2, 0, Math.PI * 2, !1),
        r.closePath(),
        r.fill(),
        n
    },
    getPatternSrcFunction: function() {
        return String(this.getPatternSrc).replace("this.color", '"' + this.color + '"')
    },
    getPattern: function() {
        return this.canvas.contextTop.createPattern(this.source || this.getPatternSrc(), "repeat")
    },
    _setBrushStyles: function() {
        this.callSuper("_setBrushStyles"),
        this.canvas.contextTop.strokeStyle = this.getPattern()
    },
    createPath: function(e) {
        var t = this.callSuper("createPath", e);
        return t.stroke = new fabric.Pattern({
            source: this.source || this.getPatternSrcFunction()
        }),
        t
    }
}),
function() {
    var e = fabric.util.getPointer
      , t = fabric.util.degreesToRadians
      , n = fabric.util.radiansToDegrees
      , r = Math.atan2
      , i = Math.abs
      , s = .5;
    fabric.Canvas = fabric.util.createClass(fabric.StaticCanvas, {
        initialize: function(e, t) {
            t || (t = {}),
            this._initStatic(e, t),
            this._initInteractive(),
            this._createCacheCanvas(),
            fabric.Canvas.activeInstance = this
        },
        uniScaleTransform: !1,
        centeredScaling: !1,
        centeredRotation: !1,
        interactive: !0,
        selection: !0,
        selectionColor: "rgba(100, 100, 255, 0.3)",
        selectionDashArray: [],
        selectionBorderColor: "rgba(255, 255, 255, 0.3)",
        selectionLineWidth: 1,
        hoverCursor: "move",
        moveCursor: "move",
        defaultCursor: "default",
        freeDrawingCursor: "crosshair",
        rotationCursor: "crosshair",
        containerClass: "canvas-container",
        perPixelTargetFind: !1,
        targetFindTolerance: 0,
        skipTargetFind: !1,
        _initInteractive: function() {
            this._currentTransform = null,
            this._groupSelector = null,
            this._initWrapperElement(),
            this._createUpperCanvas(),
            this._initEventListeners(),
            this.freeDrawingBrush = fabric.PencilBrush && new fabric.PencilBrush(this),
            this.calcOffset()
        },
        _resetCurrentTransform: function(e) {
            var t = this._currentTransform;
            t.target.set({
                scaleX: t.original.scaleX,
                scaleY: t.original.scaleY,
                left: t.original.left,
                top: t.original.top
            }),
            this._shouldCenterTransform(e, t.target) ? t.action === "rotate" ? this._setOriginToCenter(t.target) : (t.originX !== "center" && (t.originX === "right" ? t.mouseXSign = -1 : t.mouseXSign = 1),
            t.originY !== "center" && (t.originY === "bottom" ? t.mouseYSign = -1 : t.mouseYSign = 1),
            t.originX = "center",
            t.originY = "center") : (t.originX = t.original.originX,
            t.originY = t.original.originY)
        },
        containsPoint: function(e, t) {
            var n = this.getPointer(e, !0)
              , r = this._normalizePointer(t, n);
            return t.containsPoint(r) || t._findTargetCorner(n)
        },
        _normalizePointer: function(e, t) {
            var n = this.getActiveGroup(), r = t.x, i = t.y, s = n && e.type !== "group" && n.contains(e), o;
            return s && (o = new fabric.Point(n.left,n.top),
            o = fabric.util.transformPoint(o, this.viewportTransform, !0),
            r -= o.x,
            i -= o.y),
            {
                x: r,
                y: i
            }
        },
        isTargetTransparent: function(e, t, n) {
            var r = e.hasBorders
              , i = e.transparentCorners;
            e.hasBorders = e.transparentCorners = !1,
            this._draw(this.contextCache, e),
            e.hasBorders = r,
            e.transparentCorners = i;
            var s = fabric.util.isTransparent(this.contextCache, t, n, this.targetFindTolerance);
            return this.clearContext(this.contextCache),
            s
        },
        _shouldClearSelection: function(e, t) {
            var n = this.getActiveGroup()
              , r = this.getActiveObject();
            return !t || t && n && !n.contains(t) && n !== t && !e.shiftKey || t && !t.evented || t && !t.selectable && r && r !== t
        },
        _shouldCenterTransform: function(e, t) {
            if (!t)
                return;
            var n = this._currentTransform, r;
            return n.action === "scale" || n.action === "scaleX" || n.action === "scaleY" ? r = this.centeredScaling || t.centeredScaling : n.action === "rotate" && (r = this.centeredRotation || t.centeredRotation),
            r ? !e.altKey : e.altKey
        },
        _getOriginFromCorner: function(e, t) {
            var n = {
                x: e.originX,
                y: e.originY
            };
            if (t === "ml" || t === "tl" || t === "bl")
                n.x = "right";
            else if (t === "mr" || t === "tr" || t === "br")
                n.x = "left";
            if (t === "tl" || t === "mt" || t === "tr")
                n.y = "bottom";
            else if (t === "bl" || t === "mb" || t === "br")
                n.y = "top";
            return n
        },
        _getActionFromCorner: function(e, t) {
            var n = "drag";
            return t && (n = t === "ml" || t === "mr" ? "scaleX" : t === "mt" || t === "mb" ? "scaleY" : t === "mtr" ? "rotate" : "scale"),
            n
        },
        _setupCurrentTransform: function(e, n) {
            if (!n)
                return;
            var r = this.getPointer(e)
              , i = n._findTargetCorner(this.getPointer(e, !0))
              , s = this._getActionFromCorner(n, i)
              , o = this._getOriginFromCorner(n, i);
            this._currentTransform = {
                target: n,
                action: s,
                scaleX: n.scaleX,
                scaleY: n.scaleY,
                offsetX: r.x - n.left,
                offsetY: r.y - n.top,
                originX: o.x,
                originY: o.y,
                ex: r.x,
                ey: r.y,
                left: n.left,
                top: n.top,
                theta: t(n.angle),
                width: n.width * n.scaleX,
                mouseXSign: 1,
                mouseYSign: 1
            },
            this._currentTransform.original = {
                left: n.left,
                top: n.top,
                scaleX: n.scaleX,
                scaleY: n.scaleY,
                originX: o.x,
                originY: o.y
            },
            this._resetCurrentTransform(e)
        },
        _translateObject: function(e, t) {
            var n = this._currentTransform.target;
            n.get("lockMovementX") || n.set("left", e - this._currentTransform.offsetX),
            n.get("lockMovementY") || n.set("top", t - this._currentTransform.offsetY)
        },
        _scaleObject: function(e, t, n) {
            var r = this._currentTransform
              , i = r.target
              , s = i.get("lockScalingX")
              , o = i.get("lockScalingY")
              , u = i.get("lockScalingFlip");
            if (s && o)
                return;
            var a = i.translateToOriginPoint(i.getCenterPoint(), r.originX, r.originY)
              , f = i.toLocalPoint(new fabric.Point(e,t), r.originX, r.originY);
            this._setLocalMouse(f, r),
            this._setObjectScale(f, r, s, o, n, u),
            i.setPositionByOrigin(a, r.originX, r.originY)
        },
        _setObjectScale: function(e, t, n, r, i, s) {
            var o = t.target
              , u = !1
              , a = !1
              , f = o.stroke ? o.strokeWidth : 0;
            t.newScaleX = e.x / (o.width + f / 2),
            t.newScaleY = e.y / (o.height + f / 2),
            s && t.newScaleX <= 0 && t.newScaleX < o.scaleX && (u = !0),
            s && t.newScaleY <= 0 && t.newScaleY < o.scaleY && (a = !0),
            i === "equally" && !n && !r ? u || a || this._scaleObjectEqually(e, o, t) : i ? i === "x" && !o.get("lockUniScaling") ? u || n || o.set("scaleX", t.newScaleX) : i === "y" && !o.get("lockUniScaling") && (a || r || o.set("scaleY", t.newScaleY)) : (u || n || o.set("scaleX", t.newScaleX),
            a || r || o.set("scaleY", t.newScaleY)),
            u || a || this._flipObject(t, i)
        },
        _scaleObjectEqually: function(e, t, n) {
            var r = e.y + e.x
              , i = t.stroke ? t.strokeWidth : 0
              , s = (t.height + i / 2) * n.original.scaleY + (t.width + i / 2) * n.original.scaleX;
            n.newScaleX = n.original.scaleX * r / s,
            n.newScaleY = n.original.scaleY * r / s,
            t.set("scaleX", n.newScaleX),
            t.set("scaleY", n.newScaleY)
        },
        _flipObject: function(e, t) {
            e.newScaleX < 0 && t !== "y" && (e.originX === "left" ? e.originX = "right" : e.originX === "right" && (e.originX = "left")),
            e.newScaleY < 0 && t !== "x" && (e.originY === "top" ? e.originY = "bottom" : e.originY === "bottom" && (e.originY = "top"))
        },
        _setLocalMouse: function(e, t) {
            var n = t.target;
            t.originX === "right" ? e.x *= -1 : t.originX === "center" && (e.x *= t.mouseXSign * 2,
            e.x < 0 && (t.mouseXSign = -t.mouseXSign)),
            t.originY === "bottom" ? e.y *= -1 : t.originY === "center" && (e.y *= t.mouseYSign * 2,
            e.y < 0 && (t.mouseYSign = -t.mouseYSign)),
            i(e.x) > n.padding ? e.x < 0 ? e.x += n.padding : e.x -= n.padding : e.x = 0,
            i(e.y) > n.padding ? e.y < 0 ? e.y += n.padding : e.y -= n.padding : e.y = 0
        },
        _rotateObject: function(e, t) {
            var i = this._currentTransform;
            if (i.target.get("lockRotation"))
                return;
            var s = r(i.ey - i.top, i.ex - i.left)
              , o = r(t - i.top, e - i.left)
              , u = n(o - s + i.theta);
            u < 0 && (u = 360 + u),
            i.target.angle = u % 360
        },
        setCursor: function(e) {
            this.upperCanvasEl.style.cursor = e
        },
        _resetObjectTransform: function(e) {
            e.scaleX = 1,
            e.scaleY = 1,
            e.setAngle(0)
        },
        _drawSelection: function() {
            var e = this.contextTop
              , t = this._groupSelector
              , n = t.left
              , r = t.top
              , o = i(n)
              , u = i(r);
            e.fillStyle = this.selectionColor,
            e.fillRect(t.ex - (n > 0 ? 0 : -n), t.ey - (r > 0 ? 0 : -r), o, u),
            e.lineWidth = this.selectionLineWidth,
            e.strokeStyle = this.selectionBorderColor;
            if (this.selectionDashArray.length > 1) {
                var a = t.ex + s - (n > 0 ? 0 : o)
                  , f = t.ey + s - (r > 0 ? 0 : u);
                e.beginPath(),
                fabric.util.drawDashedLine(e, a, f, a + o, f, this.selectionDashArray),
                fabric.util.drawDashedLine(e, a, f + u - 1, a + o, f + u - 1, this.selectionDashArray),
                fabric.util.drawDashedLine(e, a, f, a, f + u, this.selectionDashArray),
                fabric.util.drawDashedLine(e, a + o - 1, f, a + o - 1, f + u, this.selectionDashArray),
                e.closePath(),
                e.stroke()
            } else
                e.strokeRect(t.ex + s - (n > 0 ? 0 : o), t.ey + s - (r > 0 ? 0 : u), o, u)
        },
        _isLastRenderedObject: function(e) {
            return this.controlsAboveOverlay && this.lastRenderedObjectWithControlsAboveOverlay && this.lastRenderedObjectWithControlsAboveOverlay.visible && this.containsPoint(e, this.lastRenderedObjectWithControlsAboveOverlay) && this.lastRenderedObjectWithControlsAboveOverlay._findTargetCorner(this.getPointer(e, !0))
        },
        findTarget: function(e, t) {
            if (this.skipTargetFind)
                return;
            if (this._isLastRenderedObject(e))
                return this.lastRenderedObjectWithControlsAboveOverlay;
            var n = this.getActiveGroup();
            if (n && !t && this.containsPoint(e, n))
                return n;
            var r = this._searchPossibleTargets(e);
            return this._fireOverOutEvents(r),
            r
        },
        _fireOverOutEvents: function(e) {
            e ? this._hoveredTarget !== e && (this.fire("mouse:over", {
                target: e
            }),
            e.fire("mouseover"),
            this._hoveredTarget && (this.fire("mouse:out", {
                target: this._hoveredTarget
            }),
            this._hoveredTarget.fire("mouseout")),
            this._hoveredTarget = e) : this._hoveredTarget && (this.fire("mouse:out", {
                target: this._hoveredTarget
            }),
            this._hoveredTarget.fire("mouseout"),
            this._hoveredTarget = null)
        },
        _checkTarget: function(e, t, n) {
            if (t && t.visible && t.evented && this.containsPoint(e, t)) {
                if (!this.perPixelTargetFind && !t.perPixelTargetFind || !!t.isEditing)
                    return !0;
                var r = this.isTargetTransparent(t, n.x, n.y);
                if (!r)
                    return !0
            }
        },
        _searchPossibleTargets: function(e) {
            var t, n = this.getPointer(e, !0), r = this._objects.length;
            while (r--)
                if (!this._objects[r].group && this._checkTarget(e, this._objects[r], n)) {
                    this.relatedTarget = this._objects[r],
                    t = this._objects[r];
                    break
                }
            return t
        },
        getPointer: function(t, n, r) {
            r || (r = this.upperCanvasEl);
            var i = e(t, r), s = r.getBoundingClientRect(), o = s.width || 0, u = s.height || 0, a;
            if (!o || !u)
                "top"in s && "bottom"in s && (u = Math.abs(s.top - s.bottom)),
                "right"in s && "left"in s && (o = Math.abs(s.right - s.left));
            return this.calcOffset(),
            i.x = i.x - this._offset.left,
            i.y = i.y - this._offset.top,
            n || (i = fabric.util.transformPoint(i, fabric.util.invertTransform(this.viewportTransform))),
            o === 0 || u === 0 ? a = {
                width: 1,
                height: 1
            } : a = {
                width: r.width / o,
                height: r.height / u
            },
            {
                x: i.x * a.width,
                y: i.y * a.height
            }
        },
        _createUpperCanvas: function() {
            var e = this.lowerCanvasEl.className.replace(/\s*lower-canvas\s*/, "");
            this.upperCanvasEl = this._createCanvasElement(),
            fabric.util.addClass(this.upperCanvasEl, "upper-canvas " + e),
            this.wrapperEl.appendChild(this.upperCanvasEl),
            this._copyCanvasStyle(this.lowerCanvasEl, this.upperCanvasEl),
            this._applyCanvasStyle(this.upperCanvasEl),
            this.contextTop = this.upperCanvasEl.getContext("2d")
        },
        _createCacheCanvas: function() {
            this.cacheCanvasEl = this._createCanvasElement(),
            this.cacheCanvasEl.setAttribute("width", this.width),
            this.cacheCanvasEl.setAttribute("height", this.height),
            this.contextCache = this.cacheCanvasEl.getContext("2d")
        },
        _initWrapperElement: function() {
            this.wrapperEl = fabric.util.wrapElement(this.lowerCanvasEl, "div", {
                "class": this.containerClass
            }),
            fabric.util.setStyle(this.wrapperEl, {
                width: this.getWidth() + "px",
                height: this.getHeight() + "px",
                position: "relative"
            }),
            fabric.util.makeElementUnselectable(this.wrapperEl)
        },
        _applyCanvasStyle: function(e) {
            var t = this.getWidth() || e.width
              , n = this.getHeight() || e.height;
            fabric.util.setStyle(e, {
                position: "absolute",
                width: t + "px",
                height: n + "px",
                left: 0,
                top: 0
            }),
            e.width = t,
            e.height = n,
            fabric.util.makeElementUnselectable(e)
        },
        _copyCanvasStyle: function(e, t) {
            t.style.cssText = e.style.cssText
        },
        getSelectionContext: function() {
            return this.contextTop
        },
        getSelectionElement: function() {
            return this.upperCanvasEl
        },
        _setActiveObject: function(e) {
            this._activeObject && this._activeObject.set("active", !1),
            this._activeObject = e,
            e.set("active", !0)
        },
        setActiveObject: function(e, t) {
            return this._setActiveObject(e),
            this.renderAll(),
            this.fire("object:selected", {
                target: e,
                e: t
            }),
            e.fire("selected", {
                e: t
            }),
            this
        },
        getActiveObject: function() {
            return this._activeObject
        },
        _discardActiveObject: function() {
            this._activeObject && this._activeObject.set("active", !1),
            this._activeObject = null
        },
        discardActiveObject: function(e) {
            return this._discardActiveObject(),
            this.renderAll(),
            this.fire("selection:cleared", {
                e: e
            }),
            this
        },
        _setActiveGroup: function(e) {
            this._activeGroup = e,
            e && e.set("active", !0)
        },
        setActiveGroup: function(e, t) {
            return this._setActiveGroup(e),
            e && (this.fire("object:selected", {
                target: e,
                e: t
            }),
            e.fire("selected", {
                e: t
            })),
            this
        },
        getActiveGroup: function() {
            return this._activeGroup
        },
        _discardActiveGroup: function() {
            var e = this.getActiveGroup();
            e && e.destroy(),
            this.setActiveGroup(null)
        },
        discardActiveGroup: function(e) {
            return this._discardActiveGroup(),
            this.fire("selection:cleared", {
                e: e
            }),
            this
        },
        deactivateAll: function() {
            var e = this.getObjects()
              , t = 0
              , n = e.length;
            for (; t < n; t++)
                e[t].set("active", !1);
            return this._discardActiveGroup(),
            this._discardActiveObject(),
            this
        },
        deactivateAllWithDispatch: function(e) {
            var t = this.getActiveGroup() || this.getActiveObject();
            return t && this.fire("before:selection:cleared", {
                target: t,
                e: e
            }),
            this.deactivateAll(),
            t && this.fire("selection:cleared", {
                e: e
            }),
            this
        },
        drawControls: function(e) {
            var t = this.getActiveGroup();
            t ? this._drawGroupControls(e, t) : this._drawObjectsControls(e)
        },
        _drawGroupControls: function(e, t) {
            t._renderControls(e)
        },
        _drawObjectsControls: function(e) {
            for (var t = 0, n = this._objects.length; t < n; ++t) {
                if (!this._objects[t] || !this._objects[t].active)
                    continue;
                this._objects[t]._renderControls(e),
                this.lastRenderedObjectWithControlsAboveOverlay = this._objects[t]
            }
        }
    });
    for (var o in fabric.StaticCanvas)
        o !== "prototype" && (fabric.Canvas[o] = fabric.StaticCanvas[o]);
    fabric.isTouchSupported && (fabric.Canvas.prototype._setCursorFromEvent = function() {}
    ),
    fabric.Element = fabric.Canvas
}(),
function() {
    var e = {
        mt: 0,
        tr: 1,
        mr: 2,
        br: 3,
        mb: 4,
        bl: 5,
        ml: 6,
        tl: 7
    }
      , t = fabric.util.addListener
      , n = fabric.util.removeListener;
    fabric.util.object.extend(fabric.Canvas.prototype, {
        cursorMap: ["n-resize", "ne-resize", "e-resize", "se-resize", "s-resize", "sw-resize", "w-resize", "nw-resize"],
        _initEventListeners: function() {
            this._bindEvents(),
            t(fabric.window, "resize", this._onResize),
            t(this.upperCanvasEl, "mousedown", this._onMouseDown),
            t(this.upperCanvasEl, "mousemove", this._onMouseMove),
            t(this.upperCanvasEl, "mousewheel", this._onMouseWheel),
            t(this.upperCanvasEl, "touchstart", this._onMouseDown),
            t(this.upperCanvasEl, "touchmove", this._onMouseMove),
            typeof eventjs != "undefined" && "add"in eventjs && (eventjs.add(this.upperCanvasEl, "gesture", this._onGesture),
            eventjs.add(this.upperCanvasEl, "drag", this._onDrag),
            eventjs.add(this.upperCanvasEl, "orientation", this._onOrientationChange),
            eventjs.add(this.upperCanvasEl, "shake", this._onShake),
            eventjs.add(this.upperCanvasEl, "longpress", this._onLongPress))
        },
        _bindEvents: function() {
            this._onMouseDown = this._onMouseDown.bind(this),
            this._onMouseMove = this._onMouseMove.bind(this),
            this._onMouseUp = this._onMouseUp.bind(this),
            this._onResize = this._onResize.bind(this),
            this._onGesture = this._onGesture.bind(this),
            this._onDrag = this._onDrag.bind(this),
            this._onShake = this._onShake.bind(this),
            this._onLongPress = this._onLongPress.bind(this),
            this._onOrientationChange = this._onOrientationChange.bind(this),
            this._onMouseWheel = this._onMouseWheel.bind(this)
        },
        removeListeners: function() {
            n(fabric.window, "resize", this._onResize),
            n(this.upperCanvasEl, "mousedown", this._onMouseDown),
            n(this.upperCanvasEl, "mousemove", this._onMouseMove),
            n(this.upperCanvasEl, "mousewheel", this._onMouseWheel),
            n(this.upperCanvasEl, "touchstart", this._onMouseDown),
            n(this.upperCanvasEl, "touchmove", this._onMouseMove),
            typeof eventjs != "undefined" && "remove"in eventjs && (eventjs.remove(this.upperCanvasEl, "gesture", this._onGesture),
            eventjs.remove(this.upperCanvasEl, "drag", this._onDrag),
            eventjs.remove(this.upperCanvasEl, "orientation", this._onOrientationChange),
            eventjs.remove(this.upperCanvasEl, "shake", this._onShake),
            eventjs.remove(this.upperCanvasEl, "longpress", this._onLongPress))
        },
        _onGesture: function(e, t) {
            this.__onTransformGesture && this.__onTransformGesture(e, t)
        },
        _onDrag: function(e, t) {
            this.__onDrag && this.__onDrag(e, t)
        },
        _onMouseWheel: function(e, t) {
            this.__onMouseWheel && this.__onMouseWheel(e, t)
        },
        _onOrientationChange: function(e, t) {
            this.__onOrientationChange && this.__onOrientationChange(e, t)
        },
        _onShake: function(e, t) {
            this.__onShake && this.__onShake(e, t)
        },
        _onLongPress: function(e, t) {
            this.__onLongPress && this.__onLongPress(e, t)
        },
        _onMouseDown: function(e) {
            this.__onMouseDown(e),
            t(fabric.document, "touchend", this._onMouseUp),
            t(fabric.document, "touchmove", this._onMouseMove),
            n(this.upperCanvasEl, "mousemove", this._onMouseMove),
            n(this.upperCanvasEl, "touchmove", this._onMouseMove),
            e.type === "touchstart" ? n(this.upperCanvasEl, "mousedown", this._onMouseDown) : (t(fabric.document, "mouseup", this._onMouseUp),
            t(fabric.document, "mousemove", this._onMouseMove))
        },
        _onMouseUp: function(e) {
            this.__onMouseUp(e),
            n(fabric.document, "mouseup", this._onMouseUp),
            n(fabric.document, "touchend", this._onMouseUp),
            n(fabric.document, "mousemove", this._onMouseMove),
            n(fabric.document, "touchmove", this._onMouseMove),
            t(this.upperCanvasEl, "mousemove", this._onMouseMove),
            t(this.upperCanvasEl, "touchmove", this._onMouseMove);
            if (e.type === "touchend") {
                var r = this;
                setTimeout(function() {
                    t(r.upperCanvasEl, "mousedown", r._onMouseDown)
                }, 400)
            }
        },
        _onMouseMove: function(e) {
            !this.allowTouchScrolling && e.preventDefault && e.preventDefault(),
            this.__onMouseMove(e)
        },
        _onResize: function() {
            this.calcOffset()
        },
        _shouldRender: function(e, t) {
            var n = this.getActiveGroup() || this.getActiveObject();
            return !!(e && (e.isMoving || e !== n) || !e && !!n || !e && !n && !this._groupSelector || t && this._previousPointer && this.selection && (t.x !== this._previousPointer.x || t.y !== this._previousPointer.y))
        },
        __onMouseUp: function(e) {
            var t;
            if (this.isDrawingMode && this._isCurrentlyDrawing) {
                this._onMouseUpInDrawingMode(e);
                return
            }
            this._currentTransform ? (this._finalizeCurrentTransform(),
            t = this._currentTransform.target) : t = this.findTarget(e, !0);
            var n = this._shouldRender(t, this.getPointer(e));
            this._maybeGroupObjects(e),
            t && (t.isMoving = !1),
            n && this.renderAll(),
            this._handleCursorAndEvent(e, t)
        },
        _handleCursorAndEvent: function(e, t) {
            this._setCursorFromEvent(e, t);
            var n = this;
            setTimeout(function() {
                n._setCursorFromEvent(e, t)
            }, 50),
            this.fire("mouse:up", {
                target: t,
                e: e
            }),
            t && t.fire("mouseup", {
                e: e
            })
        },
        _finalizeCurrentTransform: function() {
            var e = this._currentTransform
              , t = e.target;
            t._scaling && (t._scaling = !1),
            t.setCoords(),
            this.stateful && t.hasStateChanged() && (this.fire("object:modified", {
                target: t
            }),
            t.fire("modified")),
            this._restoreOriginXY(t)
        },
        _restoreOriginXY: function(e) {
            if (this._previousOriginX && this._previousOriginY) {
                var t = e.translateToOriginPoint(e.getCenterPoint(), this._previousOriginX, this._previousOriginY);
                e.originX = this._previousOriginX,
                e.originY = this._previousOriginY,
                e.left = t.x,
                e.top = t.y,
                this._previousOriginX = null,
                this._previousOriginY = null
            }
        },
        _onMouseDownInDrawingMode: function(e) {
            this._isCurrentlyDrawing = !0,
            this.discardActiveObject(e).renderAll(),
            this.clipTo && fabric.util.clipContext(this, this.contextTop);
            var t = fabric.util.invertTransform(this.viewportTransform)
              , n = fabric.util.transformPoint(this.getPointer(e, !0), t);
            this.freeDrawingBrush.onMouseDown(n),
            this.fire("mouse:down", {
                e: e
            });
            var r = this.findTarget(e);
            typeof r != "undefined" && r.fire("mousedown", {
                e: e,
                target: r
            })
        },
        _onMouseMoveInDrawingMode: function(e) {
            if (this._isCurrentlyDrawing) {
                var t = fabric.util.invertTransform(this.viewportTransform)
                  , n = fabric.util.transformPoint(this.getPointer(e, !0), t);
                this.freeDrawingBrush.onMouseMove(n)
            }
            this.setCursor(this.freeDrawingCursor),
            this.fire("mouse:move", {
                e: e
            });
            var r = this.findTarget(e);
            typeof r != "undefined" && r.fire("mousemove", {
                e: e,
                target: r
            })
        },
        _onMouseUpInDrawingMode: function(e) {
            this._isCurrentlyDrawing = !1,
            this.clipTo && this.contextTop.restore(),
            this.freeDrawingBrush.onMouseUp(),
            this.fire("mouse:up", {
                e: e
            });
            var t = this.findTarget(e);
            typeof t != "undefined" && t.fire("mouseup", {
                e: e,
                target: t
            })
        },
        __onMouseDown: function(e) {
            var t = "which"in e ? e.which === 1 : e.button === 1;
            if (!t && !fabric.isTouchSupported)
                return;
            if (this.isDrawingMode) {
                this._onMouseDownInDrawingMode(e);
                return
            }
            if (this._currentTransform)
                return;
            var n = this.findTarget(e)
              , r = this.getPointer(e, !0);
            this._previousPointer = r;
            var i = this._shouldRender(n, r)
              , s = this._shouldGroup(e, n);
            this._shouldClearSelection(e, n) ? this._clearSelection(e, n, r) : s && (this._handleGrouping(e, n),
            n = this.getActiveGroup()),
            n && n.selectable && !s && (this._beforeTransform(e, n),
            this._setupCurrentTransform(e, n)),
            i && this.renderAll(),
            this.fire("mouse:down", {
                target: n,
                e: e
            }),
            n && n.fire("mousedown", {
                e: e
            })
        },
        _beforeTransform: function(e, t) {
            this.stateful && t.saveState(),
            t._findTargetCorner(this.getPointer(e)) && this.onBeforeScaleRotate(t),
            t !== this.getActiveGroup() && t !== this.getActiveObject() && (this.deactivateAll(),
            this.setActiveObject(t, e))
        },
        _clearSelection: function(e, t, n) {
            this.deactivateAllWithDispatch(e),
            t && t.selectable ? this.setActiveObject(t, e) : this.selection && (this._groupSelector = {
                ex: n.x,
                ey: n.y,
                top: 0,
                left: 0
            })
        },
        _setOriginToCenter: function(e) {
            this._previousOriginX = this._currentTransform.target.originX,
            this._previousOriginY = this._currentTransform.target.originY;
            var t = e.getCenterPoint();
            e.originX = "center",
            e.originY = "center",
            e.left = t.x,
            e.top = t.y,
            this._currentTransform.left = e.left,
            this._currentTransform.top = e.top
        },
        _setCenterToOrigin: function(e) {
            var t = e.translateToOriginPoint(e.getCenterPoint(), this._previousOriginX, this._previousOriginY);
            e.originX = this._previousOriginX,
            e.originY = this._previousOriginY,
            e.left = t.x,
            e.top = t.y,
            this._previousOriginX = null,
            this._previousOriginY = null
        },
        __onMouseMove: function(e) {
            var t, n;
            if (this.isDrawingMode) {
                this._onMouseMoveInDrawingMode(e);
                return
            }
            if (typeof e.touches != "undefined" && e.touches.length > 1)
                return;
            var r = this._groupSelector;
            r ? (n = this.getPointer(e, !0),
            r.left = n.x - r.ex,
            r.top = n.y - r.ey,
            this.renderTop()) : this._currentTransform ? this._transformObject(e) : (t = this.findTarget(e),
            !t || t && !t.selectable ? this.setCursor(this.defaultCursor) : this._setCursorFromEvent(e, t)),
            this.fire("mouse:move", {
                target: t,
                e: e
            }),
            t && t.fire("mousemove", {
                e: e
            })
        },
        _transformObject: function(e) {
            var t = this.getPointer(e)
              , n = this._currentTransform;
            n.reset = !1,
            n.target.isMoving = !0,
            this._beforeScaleTransform(e, n),
            this._performTransformAction(e, n, t),
            this.renderAll()
        },
        _performTransformAction: function(e, t, n) {
            var r = n.x
              , i = n.y
              , s = t.target
              , o = t.action;
            o === "rotate" ? (this._rotateObject(r, i),
            this._fire("rotating", s, e)) : o === "scale" ? (this._onScale(e, t, r, i),
            this._fire("scaling", s, e)) : o === "scaleX" ? (this._scaleObject(r, i, "x"),
            this._fire("scaling", s, e)) : o === "scaleY" ? (this._scaleObject(r, i, "y"),
            this._fire("scaling", s, e)) : (this._translateObject(r, i),
            this._fire("moving", s, e),
            this.setCursor(this.moveCursor))
        },
        _fire: function(e, t, n) {
            this.fire("object:" + e, {
                target: t,
                e: n
            }),
            t.fire(e, {
                e: n
            })
        },
        _beforeScaleTransform: function(e, t) {
            if (t.action === "scale" || t.action === "scaleX" || t.action === "scaleY") {
                var n = this._shouldCenterTransform(e, t.target);
                if (n && (t.originX !== "center" || t.originY !== "center") || !n && t.originX === "center" && t.originY === "center")
                    this._resetCurrentTransform(e),
                    t.reset = !0
            }
        },
        _onScale: function(e, t, n, r) {
            (e.shiftKey || this.uniScaleTransform) && !t.target.get("lockUniScaling") ? (t.currentAction = "scale",
            this._scaleObject(n, r)) : (!t.reset && t.currentAction === "scale" && this._resetCurrentTransform(e, t.target),
            t.currentAction = "scaleEqually",
            this._scaleObject(n, r, "equally"))
        },
        _setCursorFromEvent: function(e, t) {
            if (!t || !t.selectable)
                return this.setCursor(this.defaultCursor),
                !1;
            var n = this.getActiveGroup()
              , r = t._findTargetCorner && (!n || !n.contains(t)) && t._findTargetCorner(this.getPointer(e, !0));
            return r ? this._setCornerCursor(r, t) : this.setCursor(t.hoverCursor || this.hoverCursor),
            !0
        },
        _setCornerCursor: function(t, n) {
            if (t in e)
                this.setCursor(this._getRotatedCornerCursor(t, n));
            else {
                if (t !== "mtr" || !n.hasRotatingPoint)
                    return this.setCursor(this.defaultCursor),
                    !1;
                this.setCursor(this.rotationCursor)
            }
        },
        _getRotatedCornerCursor: function(t, n) {
            var r = Math.round(n.getAngle() % 360 / 45);
            return r < 0 && (r += 8),
            r += e[t],
            r %= 8,
            this.cursorMap[r]
        }
    })
}(),
function() {
    var e = Math.min
      , t = Math.max;
    fabric.util.object.extend(fabric.Canvas.prototype, {
        _shouldGroup: function(e, t) {
            var n = this.getActiveObject();
            return e.shiftKey && (this.getActiveGroup() || n && n !== t) && this.selection
        },
        _handleGrouping: function(e, t) {
            if (t === this.getActiveGroup()) {
                t = this.findTarget(e, !0);
                if (!t || t.isType("group"))
                    return
            }
            this.getActiveGroup() ? this._updateActiveGroup(t, e) : this._createActiveGroup(t, e),
            this._activeGroup && this._activeGroup.saveCoords()
        },
        _updateActiveGroup: function(e, t) {
            var n = this.getActiveGroup();
            if (n.contains(e)) {
                n.removeWithUpdate(e),
                this._resetObjectTransform(n),
                e.set("active", !1);
                if (n.size() === 1) {
                    this.discardActiveGroup(t),
                    this.setActiveObject(n.item(0));
                    return
                }
            } else
                n.addWithUpdate(e),
                this._resetObjectTransform(n);
            this.fire("selection:created", {
                target: n,
                e: t
            }),
            n.set("active", !0)
        },
        _createActiveGroup: function(e, t) {
            if (this._activeObject && e !== this._activeObject) {
                var n = this._createGroup(e);
                n.addWithUpdate(),
                this.setActiveGroup(n),
                this._activeObject = null,
                this.fire("selection:created", {
                    target: n,
                    e: t
                })
            }
            e.set("active", !0)
        },
        _createGroup: function(e) {
            var t = this.getObjects()
              , n = t.indexOf(this._activeObject) < t.indexOf(e)
              , r = n ? [this._activeObject, e] : [e, this._activeObject];
            return new fabric.Group(r,{
                canvas: this
            })
        },
        _groupSelectedObjects: function(e) {
            var t = this._collectObjects();
            t.length === 1 ? this.setActiveObject(t[0], e) : t.length > 1 && (t = new fabric.Group(t.reverse(),{
                canvas: this
            }),
            t.addWithUpdate(),
            this.setActiveGroup(t, e),
            t.saveCoords(),
            this.fire("selection:created", {
                target: t
            }),
            this.renderAll())
        },
        _collectObjects: function() {
            var n = [], r, i = this._groupSelector.ex, s = this._groupSelector.ey, o = i + this._groupSelector.left, u = s + this._groupSelector.top, a = new fabric.Point(e(i, o),e(s, u)), f = new fabric.Point(t(i, o),t(s, u)), l = i === o && s === u;
            for (var c = this._objects.length; c--; ) {
                r = this._objects[c];
                if (!r || !r.selectable || !r.visible)
                    continue;
                if (r.intersectsWithRect(a, f) || r.isContainedWithinRect(a, f) || r.containsPoint(a) || r.containsPoint(f)) {
                    r.set("active", !0),
                    n.push(r);
                    if (l)
                        break
                }
            }
            return n
        },
        _maybeGroupObjects: function(e) {
            this.selection && this._groupSelector && this._groupSelectedObjects(e);
            var t = this.getActiveGroup();
            t && (t.setObjectsCoords().setCoords(),
            t.isMoving = !1,
            this.setCursor(this.defaultCursor)),
            this._groupSelector = null,
            this._currentTransform = null
        }
    })
}(),
fabric.util.object.extend(fabric.StaticCanvas.prototype, {
    toDataURL: function(e) {
        e || (e = {});
        var t = e.format || "png"
          , n = e.quality || 1
          , r = e.multiplier || 1
          , i = {
            left: e.left,
            top: e.top,
            width: e.width,
            height: e.height
        };
        return r !== 1 ? this.__toDataURLWithMultiplier(t, n, i, r) : this.__toDataURL(t, n, i)
    },
    __toDataURL: function(e, t, n) {
        this.renderAll(!0);
        var r = this.upperCanvasEl || this.lowerCanvasEl
          , i = this.__getCroppedCanvas(r, n);
        e === "jpg" && (e = "jpeg");
        var s = fabric.StaticCanvas.supports("toDataURLWithQuality") ? (i || r).toDataURL("image/" + e, t) : (i || r).toDataURL("image/" + e);
        return this.contextTop && this.clearContext(this.contextTop),
        this.renderAll(),
        i && (i = null),
        s
    },
    __getCroppedCanvas: function(e, t) {
        var n, r, i = "left"in t || "top"in t || "width"in t || "height"in t;
        return i && (n = fabric.util.createCanvasElement(),
        r = n.getContext("2d"),
        n.width = t.width || this.width,
        n.height = t.height || this.height,
        r.drawImage(e, -t.left || 0, -t.top || 0)),
        n
    },
    __toDataURLWithMultiplier: function(e, t, n, r) {
        var i = this.getWidth()
          , s = this.getHeight()
          , o = i * r
          , u = s * r
          , a = this.getActiveObject()
          , f = this.getActiveGroup()
          , l = this.contextTop || this.contextContainer;
        r > 1 && this.setWidth(o).setHeight(u),
        l.scale(r, r),
        n.left && (n.left *= r),
        n.top && (n.top *= r),
        n.width ? n.width *= r : r < 1 && (n.width = o),
        n.height ? n.height *= r : r < 1 && (n.height = u),
        f ? this._tempRemoveBordersControlsFromGroup(f) : a && this.deactivateAll && this.deactivateAll(),
        this.renderAll(!0);
        var c = this.__toDataURL(e, t, n);
        return this.width = i,
        this.height = s,
        l.scale(1 / r, 1 / r),
        this.setWidth(i).setHeight(s),
        f ? this._restoreBordersControlsOnGroup(f) : a && this.setActiveObject && this.setActiveObject(a),
        this.contextTop && this.clearContext(this.contextTop),
        this.renderAll(),
        c
    },
    toDataURLWithMultiplier: function(e, t, n) {
        return this.toDataURL({
            format: e,
            multiplier: t,
            quality: n
        })
    },
    _tempRemoveBordersControlsFromGroup: function(e) {
        e.origHasControls = e.hasControls,
        e.origBorderColor = e.borderColor,
        e.hasControls = !0,
        e.borderColor = "rgba(0,0,0,0)",
        e.forEachObject(function(e) {
            e.origBorderColor = e.borderColor,
            e.borderColor = "rgba(0,0,0,0)"
        })
    },
    _restoreBordersControlsOnGroup: function(e) {
        e.hideControls = e.origHideControls,
        e.borderColor = e.origBorderColor,
        e.forEachObject(function(e) {
            e.borderColor = e.origBorderColor,
            delete e.origBorderColor
        })
    }
}),
fabric.util.object.extend(fabric.StaticCanvas.prototype, {
    loadFromDatalessJSON: function(e, t, n) {
        return this.loadFromJSON(e, t, n)
    },
    loadFromJSON: function(e, t, n) {
        if (!e)
            return;
        var r = typeof e == "string" ? JSON.parse(e) : e;
        this.clear();
        var i = this;
        return this._enlivenObjects(r.objects, function() {
            i._setBgOverlay(r, t)
        }, n),
        this
    },
    _setBgOverlay: function(e, t) {
        var n = this
          , r = {
            backgroundColor: !1,
            overlayColor: !1,
            backgroundImage: !1,
            overlayImage: !1
        };
        if (!e.backgroundImage && !e.overlayImage && !e.background && !e.overlay) {
            t && t();
            return
        }
        var i = function() {
            r.backgroundImage && r.overlayImage && r.backgroundColor && r.overlayColor && (n.renderAll(),
            t && t())
        };
        this.__setBgOverlay("backgroundImage", e.backgroundImage, r, i),
        this.__setBgOverlay("overlayImage", e.overlayImage, r, i),
        this.__setBgOverlay("backgroundColor", e.background, r, i),
        this.__setBgOverlay("overlayColor", e.overlay, r, i),
        i()
    },
    __setBgOverlay: function(e, t, n, r) {
        var i = this;
        if (!t) {
            n[e] = !0;
            return
        }
        e === "backgroundImage" || e === "overlayImage" ? fabric.Image.fromObject(t, function(t) {
            i[e] = t,
            n[e] = !0,
            r && r()
        }) : this["set" + fabric.util.string.capitalize(e, !0)](t, function() {
            n[e] = !0,
            r && r()
        })
    },
    _enlivenObjects: function(e, t, n) {
        var r = this;
        if (!e || e.length === 0) {
            t && t();
            return
        }
        var i = this.renderOnAddRemove;
        this.renderOnAddRemove = !1,
        fabric.util.enlivenObjects(e, function(e) {
            e.forEach(function(e, t) {
                r.insertAt(e, t, !0)
            }),
            r.renderOnAddRemove = i,
            t && t()
        }, null, n)
    },
    _toDataURL: function(e, t) {
        this.clone(function(n) {
            t(n.toDataURL(e))
        })
    },
    _toDataURLWithMultiplier: function(e, t, n) {
        this.clone(function(r) {
            n(r.toDataURLWithMultiplier(e, t))
        })
    },
    clone: function(e, t) {
        var n = JSON.stringify(this.toJSON(t));
        this.cloneWithoutData(function(t) {
            t.loadFromJSON(n, function() {
                e && e(t)
            })
        })
    },
    cloneWithoutData: function(e) {
        var t = fabric.document.createElement("canvas");
        t.width = this.getWidth(),
        t.height = this.getHeight();
        var n = new fabric.Canvas(t);
        n.clipTo = this.clipTo,
        this.backgroundImage ? (n.setBackgroundImage(this.backgroundImage.src, function() {
            n.renderAll(),
            e && e(n)
        }),
        n.backgroundImageOpacity = this.backgroundImageOpacity,
        n.backgroundImageStretch = this.backgroundImageStretch) : e && e(n)
    }
}),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend
      , r = t.util.toFixed
      , i = t.util.string.capitalize
      , s = t.util.degreesToRadians
      , o = t.StaticCanvas.supports("setLineDash");
    if (t.Object)
        return;
    t.Object = t.util.createClass({
        type: "object",
        originX: "left",
        originY: "top",
        top: 0,
        left: 0,
        width: 0,
        height: 0,
        scaleX: 1,
        scaleY: 1,
        flipX: !1,
        flipY: !1,
        opacity: 1,
        angle: 0,
        cornerSize: 12,
        transparentCorners: !0,
        hoverCursor: null,
        padding: 0,
        borderColor: "rgba(102,153,255,0.75)",
        cornerColor: "rgba(102,153,255,0.5)",
        centeredScaling: !1,
        centeredRotation: !0,
        fill: "rgb(0,0,0)",
        fillRule: "nonzero",
        globalCompositeOperation: "source-over",
        backgroundColor: "",
        stroke: null,
        strokeWidth: 1,
        strokeDashArray: null,
        strokeLineCap: "butt",
        strokeLineJoin: "miter",
        strokeMiterLimit: 10,
        shadow: null,
        borderOpacityWhenMoving: .4,
        borderScaleFactor: 1,
        transformMatrix: null,
        minScaleLimit: .01,
        selectable: !0,
        evented: !0,
        visible: !0,
        hasControls: !0,
        hasBorders: !0,
        hasRotatingPoint: !0,
        rotatingPointOffset: 40,
        perPixelTargetFind: !1,
        includeDefaultValues: !0,
        clipTo: null,
        lockMovementX: !1,
        lockMovementY: !1,
        lockRotation: !1,
        lockScalingX: !1,
        lockScalingY: !1,
        lockUniScaling: !1,
        lockScalingFlip: !1,
        stateProperties: "top left width height scaleX scaleY flipX flipY originX originY transformMatrix stroke strokeWidth strokeDashArray strokeLineCap strokeLineJoin strokeMiterLimit angle opacity fill fillRule globalCompositeOperation shadow clipTo visible backgroundColor".split(" "),
        initialize: function(e) {
            e && this.setOptions(e)
        },
        _initGradient: function(e) {
            e.fill && e.fill.colorStops && !(e.fill instanceof t.Gradient) && this.set("fill", new t.Gradient(e.fill))
        },
        _initPattern: function(e) {
            e.fill && e.fill.source && !(e.fill instanceof t.Pattern) && this.set("fill", new t.Pattern(e.fill)),
            e.stroke && e.stroke.source && !(e.stroke instanceof t.Pattern) && this.set("stroke", new t.Pattern(e.stroke))
        },
        _initClipping: function(e) {
            if (!e.clipTo || typeof e.clipTo != "string")
                return;
            var n = t.util.getFunctionBody(e.clipTo);
            typeof n != "undefined" && (this.clipTo = new Function("ctx",n))
        },
        setOptions: function(e) {
            for (var t in e)
                this.set(t, e[t]);
            this._initGradient(e),
            this._initPattern(e),
            this._initClipping(e)
        },
        transform: function(e, t) {
            var n = t ? this._getLeftTopCoords() : this.getCenterPoint();
            e.translate(n.x, n.y),
            e.rotate(s(this.angle)),
            e.scale(this.scaleX * (this.flipX ? -1 : 1), this.scaleY * (this.flipY ? -1 : 1))
        },
        toObject: function(e) {
            var n = t.Object.NUM_FRACTION_DIGITS
              , i = {
                type: this.type,
                originX: this.originX,
                originY: this.originY,
                left: r(this.left, n),
                top: r(this.top, n),
                width: r(this.width, n),
                height: r(this.height, n),
                fill: this.fill && this.fill.toObject ? this.fill.toObject() : this.fill,
                stroke: this.stroke && this.stroke.toObject ? this.stroke.toObject() : this.stroke,
                strokeWidth: r(this.strokeWidth, n),
                strokeDashArray: this.strokeDashArray,
                strokeLineCap: this.strokeLineCap,
                strokeLineJoin: this.strokeLineJoin,
                strokeMiterLimit: r(this.strokeMiterLimit, n),
                scaleX: r(this.scaleX, n),
                scaleY: r(this.scaleY, n),
                angle: r(this.getAngle(), n),
                flipX: this.flipX,
                flipY: this.flipY,
                opacity: r(this.opacity, n),
                shadow: this.shadow && this.shadow.toObject ? this.shadow.toObject() : this.shadow,
                visible: this.visible,
                clipTo: this.clipTo && String(this.clipTo),
                backgroundColor: this.backgroundColor,
                fillRule: this.fillRule,
                globalCompositeOperation: this.globalCompositeOperation
            };
            return this.includeDefaultValues || (i = this._removeDefaultValues(i)),
            t.util.populateWithProperties(this, i, e),
            i
        },
        toDatalessObject: function(e) {
            return this.toObject(e)
        },
        _removeDefaultValues: function(e) {
            var n = t.util.getKlass(e.type).prototype
              , r = n.stateProperties;
            return r.forEach(function(t) {
                e[t] === n[t] && delete e[t]
            }),
            e
        },
        toString: function() {
            return "#<fabric." + i(this.type) + ">"
        },
        get: function(e) {
            return this[e]
        },
        _setObject: function(e) {
            for (var t in e)
                this._set(t, e[t])
        },
        set: function(e, t) {
            return typeof e == "object" ? this._setObject(e) : typeof t == "function" && e !== "clipTo" ? this._set(e, t(this.get(e))) : this._set(e, t),
            this
        },
        _set: function(e, n) {
            var i = e === "scaleX" || e === "scaleY";
            return i && (n = this._constrainScale(n)),
            e === "scaleX" && n < 0 ? (this.flipX = !this.flipX,
            n *= -1) : e === "scaleY" && n < 0 ? (this.flipY = !this.flipY,
            n *= -1) : e === "width" || e === "height" ? this.minScaleLimit = r(Math.min(.1, 1 / Math.max(this.width, this.height)), 2) : e === "shadow" && n && !(n instanceof t.Shadow) && (n = new t.Shadow(n)),
            this[e] = n,
            this
        },
        toggle: function(e) {
            var t = this.get(e);
            return typeof t == "boolean" && this.set(e, !t),
            this
        },
        setSourcePath: function(e) {
            return this.sourcePath = e,
            this
        },
        getViewportTransform: function() {
            return this.canvas && this.canvas.viewportTransform ? this.canvas.viewportTransform : [1, 0, 0, 1, 0, 0]
        },
        render: function(e, n) {
            if (this.width === 0 && this.height === 0 || !this.visible)
                return;
            e.save(),
            this._setupCompositeOperation(e),
            n || this.transform(e),
            this._setStrokeStyles(e),
            this._setFillStyles(e),
            this.transformMatrix && e.transform.apply(e, this.transformMatrix),
            this._setOpacity(e),
            this._setShadow(e),
            this.clipTo && t.util.clipContext(this, e),
            this._render(e, n),
            this.clipTo && e.restore(),
            this._removeShadow(e),
            this._restoreCompositeOperation(e),
            e.restore()
        },
        _setOpacity: function(e) {
            this.group && this.group._setOpacity(e),
            e.globalAlpha *= this.opacity
        },
        _setStrokeStyles: function(e) {
            this.stroke && (e.lineWidth = this.strokeWidth,
            e.lineCap = this.strokeLineCap,
            e.lineJoin = this.strokeLineJoin,
            e.miterLimit = this.strokeMiterLimit,
            e.strokeStyle = this.stroke.toLive ? this.stroke.toLive(e, this) : this.stroke)
        },
        _setFillStyles: function(e) {
            this.fill && (e.fillStyle = this.fill.toLive ? this.fill.toLive(e, this) : this.fill)
        },
        _renderControls: function(e, n) {
            if (!this.active || n)
                return;
            var r = this.getViewportTransform();
            e.save();
            var i;
            this.group && (i = t.util.transformPoint(this.group.getCenterPoint(), r),
            e.translate(i.x, i.y),
            e.rotate(s(this.group.angle))),
            i = t.util.transformPoint(this.getCenterPoint(), r, null != this.group),
            this.group && (i.x *= this.group.scaleX,
            i.y *= this.group.scaleY),
            e.translate(i.x, i.y),
            e.rotate(s(this.angle)),
            this.drawBorders(e),
            this.drawControls(e),
            e.restore()
        },
        _setShadow: function(e) {
            if (!this.shadow)
                return;
            var t = this.canvas && this.canvas.viewportTransform[0] || 1
              , n = this.canvas && this.canvas.viewportTransform[3] || 1;
            e.shadowColor = this.shadow.color,
            e.shadowBlur = this.shadow.blur * (t + n) * (this.scaleX + this.scaleY) / 4,
            e.shadowOffsetX = this.shadow.offsetX * t * this.scaleX,
            e.shadowOffsetY = this.shadow.offsetY * n * this.scaleY
        },
        _removeShadow: function(e) {
            if (!this.shadow)
                return;
            e.shadowColor = "",
            e.shadowBlur = e.shadowOffsetX = e.shadowOffsetY = 0
        },
        _renderFill: function(e) {
            if (!this.fill)
                return;
            e.save();
            if (this.fill.gradientTransform) {
                var t = this.fill.gradientTransform;
                e.transform.apply(e, t)
            }
            this.fill.toLive && e.translate(-this.width / 2 + this.fill.offsetX || 0, -this.height / 2 + this.fill.offsetY || 0),
            this.fillRule === "evenodd" ? e.fill("evenodd") : e.fill(),
            e.restore(),
            this.shadow && !this.shadow.affectStroke && this._removeShadow(e)
        },
        _renderStroke: function(e) {
            if (!this.stroke || this.strokeWidth === 0)
                return;
            e.save();
            if (this.strokeDashArray)
                1 & this.strokeDashArray.length && this.strokeDashArray.push.apply(this.strokeDashArray, this.strokeDashArray),
                o ? (e.setLineDash(this.strokeDashArray),
                this._stroke && this._stroke(e)) : this._renderDashedStroke && this._renderDashedStroke(e),
                e.stroke();
            else {
                if (this.stroke.gradientTransform) {
                    var t = this.stroke.gradientTransform;
                    e.transform.apply(e, t)
                }
                this._stroke ? this._stroke(e) : e.stroke()
            }
            this._removeShadow(e),
            e.restore()
        },
        clone: function(e, n) {
            return this.constructor.fromObject ? this.constructor.fromObject(this.toObject(n), e) : new t.Object(this.toObject(n))
        },
        cloneAsImage: function(e) {
            var n = this.toDataURL();
            return t.util.loadImage(n, function(n) {
                e && e(new t.Image(n))
            }),
            this
        },
        toDataURL: function(e) {
            e || (e = {});
            var n = t.util.createCanvasElement()
              , r = this.getBoundingRect();
            n.width = r.width,
            n.height = r.height,
            t.util.wrapElement(n, "div");
            var i = new t.StaticCanvas(n);
            e.format === "jpg" && (e.format = "jpeg"),
            e.format === "jpeg" && (i.backgroundColor = "#fff");
            var s = {
                active: this.get("active"),
                left: this.getLeft(),
                top: this.getTop()
            };
            this.set("active", !1),
            this.setPositionByOrigin(new t.Point(n.width / 2,n.height / 2), "center", "center");
            var o = this.canvas;
            i.add(this);
            var u = i.toDataURL(e);
            return this.set(s).setCoords(),
            this.canvas = o,
            i.dispose(),
            i = null,
            u
        },
        isType: function(e) {
            return this.type === e
        },
        complexity: function() {
            return 0
        },
        toJSON: function(e) {
            return this.toObject(e)
        },
        setGradient: function(e, n) {
            n || (n = {});
            var r = {
                colorStops: []
            };
            r.type = n.type || (n.r1 || n.r2 ? "radial" : "linear"),
            r.coords = {
                x1: n.x1,
                y1: n.y1,
                x2: n.x2,
                y2: n.y2
            };
            if (n.r1 || n.r2)
                r.coords.r1 = n.r1,
                r.coords.r2 = n.r2;
            for (var i in n.colorStops) {
                var s = new t.Color(n.colorStops[i]);
                r.colorStops.push({
                    offset: i,
                    color: s.toRgb(),
                    opacity: s.getAlpha()
                })
            }
            return this.set(e, t.Gradient.forObject(this, r))
        },
        setPatternFill: function(e) {
            return this.set("fill", new t.Pattern(e))
        },
        setShadow: function(e) {
            return this.set("shadow", e ? new t.Shadow(e) : null)
        },
        setColor: function(e) {
            return this.set("fill", e),
            this
        },
        setAngle: function(e) {
            var t = (this.originX !== "center" || this.originY !== "center") && this.centeredRotation;
            return t && this._setOriginToCenter(),
            this.set("angle", e),
            t && this._resetOrigin(),
            this
        },
        centerH: function() {
            return this.canvas.centerObjectH(this),
            this
        },
        centerV: function() {
            return this.canvas.centerObjectV(this),
            this
        },
        center: function() {
            return this.canvas.centerObject(this),
            this
        },
        remove: function() {
            return this.canvas.remove(this),
            this
        },
        getLocalPointer: function(e, t) {
            t = t || this.canvas.getPointer(e);
            var n = this.translateToOriginPoint(this.getCenterPoint(), "left", "top");
            return {
                x: t.x - n.x,
                y: t.y - n.y
            }
        },
        _setupCompositeOperation: function(e) {
            this.globalCompositeOperation && (this._prevGlobalCompositeOperation = e.globalCompositeOperation,
            e.globalCompositeOperation = this.globalCompositeOperation)
        },
        _restoreCompositeOperation: function(e) {
            this.globalCompositeOperation && this._prevGlobalCompositeOperation && (e.globalCompositeOperation = this._prevGlobalCompositeOperation)
        }
    }),
    t.util.createAccessors(t.Object),
    t.Object.prototype.rotate = t.Object.prototype.setAngle,
    n(t.Object.prototype, t.Observable),
    t.Object.NUM_FRACTION_DIGITS = 2,
    t.Object.__uid = 0
}(typeof exports != "undefined" ? exports : this),
function() {
    var e = fabric.util.degreesToRadians;
    fabric.util.object.extend(fabric.Object.prototype, {
        translateToCenterPoint: function(t, n, r) {
            var i = t.x
              , s = t.y
              , o = this.stroke ? this.strokeWidth : 0;
            return n === "left" ? i = t.x + (this.getWidth() + o * this.scaleX) / 2 : n === "right" && (i = t.x - (this.getWidth() + o * this.scaleX) / 2),
            r === "top" ? s = t.y + (this.getHeight() + o * this.scaleY) / 2 : r === "bottom" && (s = t.y - (this.getHeight() + o * this.scaleY) / 2),
            fabric.util.rotatePoint(new fabric.Point(i,s), t, e(this.angle))
        },
        translateToOriginPoint: function(t, n, r) {
            var i = t.x
              , s = t.y
              , o = this.stroke ? this.strokeWidth : 0;
            return n === "left" ? i = t.x - (this.getWidth() + o * this.scaleX) / 2 : n === "right" && (i = t.x + (this.getWidth() + o * this.scaleX) / 2),
            r === "top" ? s = t.y - (this.getHeight() + o * this.scaleY) / 2 : r === "bottom" && (s = t.y + (this.getHeight() + o * this.scaleY) / 2),
            fabric.util.rotatePoint(new fabric.Point(i,s), t, e(this.angle))
        },
        getCenterPoint: function() {
            var e = new fabric.Point(this.left,this.top);
            return this.translateToCenterPoint(e, this.originX, this.originY)
        },
        getPointByOrigin: function(e, t) {
            var n = this.getCenterPoint();
            return this.translateToOriginPoint(n, e, t)
        },
        toLocalPoint: function(t, n, r) {
            var i = this.getCenterPoint(), s = this.stroke ? this.strokeWidth : 0, o, u;
            return n && r ? (n === "left" ? o = i.x - (this.getWidth() + s * this.scaleX) / 2 : n === "right" ? o = i.x + (this.getWidth() + s * this.scaleX) / 2 : o = i.x,
            r === "top" ? u = i.y - (this.getHeight() + s * this.scaleY) / 2 : r === "bottom" ? u = i.y + (this.getHeight() + s * this.scaleY) / 2 : u = i.y) : (o = this.left,
            u = this.top),
            fabric.util.rotatePoint(new fabric.Point(t.x,t.y), i, -e(this.angle)).subtractEquals(new fabric.Point(o,u))
        },
        setPositionByOrigin: function(e, t, n) {
            var r = this.translateToCenterPoint(e, t, n)
              , i = this.translateToOriginPoint(r, this.originX, this.originY);
            this.set("left", i.x),
            this.set("top", i.y)
        },
        adjustPosition: function(t) {
            var n = e(this.angle)
              , r = this.getWidth() / 2
              , i = Math.cos(n) * r
              , s = Math.sin(n) * r
              , o = this.getWidth()
              , u = Math.cos(n) * o
              , a = Math.sin(n) * o;
            this.originX === "center" && t === "left" || this.originX === "right" && t === "center" ? (this.left -= i,
            this.top -= s) : this.originX === "left" && t === "center" || this.originX === "center" && t === "right" ? (this.left += i,
            this.top += s) : this.originX === "left" && t === "right" ? (this.left += u,
            this.top += a) : this.originX === "right" && t === "left" && (this.left -= u,
            this.top -= a),
            this.setCoords(),
            this.originX = t
        },
        _setOriginToCenter: function() {
            this._originalOriginX = this.originX,
            this._originalOriginY = this.originY;
            var e = this.getCenterPoint();
            this.originX = "center",
            this.originY = "center",
            this.left = e.x,
            this.top = e.y
        },
        _resetOrigin: function() {
            var e = this.translateToOriginPoint(this.getCenterPoint(), this._originalOriginX, this._originalOriginY);
            this.originX = this._originalOriginX,
            this.originY = this._originalOriginY,
            this.left = e.x,
            this.top = e.y,
            this._originalOriginX = null,
            this._originalOriginY = null
        },
        _getLeftTopCoords: function() {
            return this.translateToOriginPoint(this.getCenterPoint(), "left", "center")
        }
    })
}(),
function() {
    var e = fabric.util.degreesToRadians;
    fabric.util.object.extend(fabric.Object.prototype, {
        oCoords: null,
        intersectsWithRect: function(e, t) {
            var n = this.oCoords
              , r = new fabric.Point(n.tl.x,n.tl.y)
              , i = new fabric.Point(n.tr.x,n.tr.y)
              , s = new fabric.Point(n.bl.x,n.bl.y)
              , o = new fabric.Point(n.br.x,n.br.y)
              , u = fabric.Intersection.intersectPolygonRectangle([r, i, o, s], e, t);
            return u.status === "Intersection"
        },
        intersectsWithObject: function(e) {
            function t(e) {
                return {
                    tl: new fabric.Point(e.tl.x,e.tl.y),
                    tr: new fabric.Point(e.tr.x,e.tr.y),
                    bl: new fabric.Point(e.bl.x,e.bl.y),
                    br: new fabric.Point(e.br.x,e.br.y)
                }
            }
            var n = t(this.oCoords)
              , r = t(e.oCoords)
              , i = fabric.Intersection.intersectPolygonPolygon([n.tl, n.tr, n.br, n.bl], [r.tl, r.tr, r.br, r.bl]);
            return i.status === "Intersection"
        },
        isContainedWithinObject: function(e) {
            var t = e.getBoundingRect()
              , n = new fabric.Point(t.left,t.top)
              , r = new fabric.Point(t.left + t.width,t.top + t.height);
            return this.isContainedWithinRect(n, r)
        },
        isContainedWithinRect: function(e, t) {
            var n = this.getBoundingRect();
            return n.left >= e.x && n.left + n.width <= t.x && n.top >= e.y && n.top + n.height <= t.y
        },
        containsPoint: function(e) {
            var t = this._getImageLines(this.oCoords)
              , n = this._findCrossPoints(e, t);
            return n !== 0 && n % 2 === 1
        },
        _getImageLines: function(e) {
            return {
                topline: {
                    o: e.tl,
                    d: e.tr
                },
                rightline: {
                    o: e.tr,
                    d: e.br
                },
                bottomline: {
                    o: e.br,
                    d: e.bl
                },
                leftline: {
                    o: e.bl,
                    d: e.tl
                }
            }
        },
        _findCrossPoints: function(e, t) {
            var n, r, i, s, o, u, a = 0, f;
            for (var l in t) {
                f = t[l];
                if (f.o.y < e.y && f.d.y < e.y)
                    continue;
                if (f.o.y >= e.y && f.d.y >= e.y)
                    continue;
                f.o.x === f.d.x && f.o.x >= e.x ? (o = f.o.x,
                u = e.y) : (n = 0,
                r = (f.d.y - f.o.y) / (f.d.x - f.o.x),
                i = e.y - n * e.x,
                s = f.o.y - r * f.o.x,
                o = -(i - s) / (n - r),
                u = i + n * o),
                o >= e.x && (a += 1);
                if (a === 2)
                    break
            }
            return a
        },
        getBoundingRectWidth: function() {
            return this.getBoundingRect().width
        },
        getBoundingRectHeight: function() {
            return this.getBoundingRect().height
        },
        getBoundingRect: function() {
            this.oCoords || this.setCoords();
            var e = [this.oCoords.tl.x, this.oCoords.tr.x, this.oCoords.br.x, this.oCoords.bl.x]
              , t = fabric.util.array.min(e)
              , n = fabric.util.array.max(e)
              , r = Math.abs(t - n)
              , i = [this.oCoords.tl.y, this.oCoords.tr.y, this.oCoords.br.y, this.oCoords.bl.y]
              , s = fabric.util.array.min(i)
              , o = fabric.util.array.max(i)
              , u = Math.abs(s - o);
            return {
                left: t,
                top: s,
                width: r,
                height: u
            }
        },
        getWidth: function() {
            return this.width * this.scaleX
        },
        getHeight: function() {
            return this.height * this.scaleY
        },
        _constrainScale: function(e) {
            return Math.abs(e) < this.minScaleLimit ? e < 0 ? -this.minScaleLimit : this.minScaleLimit : e
        },
        scale: function(e) {
            return e = this._constrainScale(e),
            e < 0 && (this.flipX = !this.flipX,
            this.flipY = !this.flipY,
            e *= -1),
            this.scaleX = e,
            this.scaleY = e,
            this.setCoords(),
            this
        },
        scaleToWidth: function(e) {
            var t = this.getBoundingRectWidth() / this.getWidth();
            return this.scale(e / this.width / t)
        },
        scaleToHeight: function(e) {
            var t = this.getBoundingRectHeight() / this.getHeight();
            return this.scale(e / this.height / t)
        },
        setCoords: function() {
            var t = e(this.angle)
              , n = this.getViewportTransform()
              , r = function(e) {
                return fabric.util.transformPoint(e, n)
            }
              , i = this._calculateCurrentDimensions(!1)
              , s = i.x
              , o = i.y;
            s < 0 && (s = Math.abs(s));
            var u = Math.sqrt(Math.pow(s / 2, 2) + Math.pow(o / 2, 2))
              , a = Math.atan(isFinite(o / s) ? o / s : 0)
              , f = Math.cos(a + t) * u
              , l = Math.sin(a + t) * u
              , c = Math.sin(t)
              , h = Math.cos(t)
              , p = this.getCenterPoint()
              , d = new fabric.Point(s,o)
              , v = new fabric.Point(p.x - f,p.y - l)
              , m = new fabric.Point(v.x + d.x * h,v.y + d.x * c)
              , g = r(new fabric.Point(v.x - d.y * c,v.y + d.y * h))
              , y = r(new fabric.Point(m.x - d.y * c,m.y + d.y * h))
              , b = r(v)
              , w = r(m)
              , E = new fabric.Point((b.x + g.x) / 2,(b.y + g.y) / 2)
              , S = new fabric.Point((w.x + b.x) / 2,(w.y + b.y) / 2)
              , x = new fabric.Point((y.x + w.x) / 2,(y.y + w.y) / 2)
              , T = new fabric.Point((y.x + g.x) / 2,(y.y + g.y) / 2)
              , N = new fabric.Point(S.x + c * this.rotatingPointOffset,S.y - h * this.rotatingPointOffset);
            return this.oCoords = {
                tl: b,
                tr: w,
                br: y,
                bl: g,
                ml: E,
                mt: S,
                mr: x,
                mb: T,
                mtr: N
            },
            this._setCornerCoords && this._setCornerCoords(),
            this
        }
    })
}(),
fabric.util.object.extend(fabric.Object.prototype, {
    sendToBack: function() {
        return this.group ? fabric.StaticCanvas.prototype.sendToBack.call(this.group, this) : this.canvas.sendToBack(this),
        this
    },
    bringToFront: function() {
        return this.group ? fabric.StaticCanvas.prototype.bringToFront.call(this.group, this) : this.canvas.bringToFront(this),
        this
    },
    sendBackwards: function(e) {
        return this.group ? fabric.StaticCanvas.prototype.sendBackwards.call(this.group, this, e) : this.canvas.sendBackwards(this, e),
        this
    },
    bringForward: function(e) {
        return this.group ? fabric.StaticCanvas.prototype.bringForward.call(this.group, this, e) : this.canvas.bringForward(this, e),
        this
    },
    moveTo: function(e) {
        return this.group ? fabric.StaticCanvas.prototype.moveTo.call(this.group, this, e) : this.canvas.moveTo(this, e),
        this
    }
}),
fabric.util.object.extend(fabric.Object.prototype, {
    getSvgStyles: function() {
        var e = this.fill ? this.fill.toLive ? "url(#SVGID_" + this.fill.id + ")" : this.fill : "none"
          , t = this.fillRule
          , n = this.stroke ? this.stroke.toLive ? "url(#SVGID_" + this.stroke.id + ")" : this.stroke : "none"
          , r = this.strokeWidth ? this.strokeWidth : "0"
          , i = this.strokeDashArray ? this.strokeDashArray.join(" ") : ""
          , s = this.strokeLineCap ? this.strokeLineCap : "butt"
          , o = this.strokeLineJoin ? this.strokeLineJoin : "miter"
          , u = this.strokeMiterLimit ? this.strokeMiterLimit : "4"
          , a = typeof this.opacity != "undefined" ? this.opacity : "1"
          , f = this.visible ? "" : " visibility: hidden;"
          , l = this.shadow ? "filter: url(#SVGID_" + this.shadow.id + ");" : "";
        return ["stroke: ", n, "; ", "stroke-width: ", r, "; ", "stroke-dasharray: ", i, "; ", "stroke-linecap: ", s, "; ", "stroke-linejoin: ", o, "; ", "stroke-miterlimit: ", u, "; ", "fill: ", e, "; ", "fill-rule: ", t, "; ", "opacity: ", a, ";", l, f].join("")
    },
    getSvgTransform: function() {
        if (this.group && this.group.type === "path-group")
            return "";
        var e = fabric.util.toFixed
          , t = this.getAngle()
          , n = !this.canvas || this.canvas.svgViewportTransformation ? this.getViewportTransform() : [1, 0, 0, 1, 0, 0]
          , r = fabric.util.transformPoint(this.getCenterPoint(), n)
          , i = fabric.Object.NUM_FRACTION_DIGITS
          , s = this.type === "path-group" ? "" : "translate(" + e(r.x, i) + " " + e(r.y, i) + ")"
          , o = t !== 0 ? " rotate(" + e(t, i) + ")" : ""
          , u = this.scaleX === 1 && this.scaleY === 1 && n[0] === 1 && n[3] === 1 ? "" : " scale(" + e(this.scaleX * n[0], i) + " " + e(this.scaleY * n[3], i) + ")"
          , a = this.type === "path-group" ? this.width * n[0] : 0
          , f = this.flipX ? " matrix(-1 0 0 1 " + a + " 0) " : ""
          , l = this.type === "path-group" ? this.height * n[3] : 0
          , c = this.flipY ? " matrix(1 0 0 -1 0 " + l + ")" : "";
        return [s, o, u, f, c].join("")
    },
    getSvgTransformMatrix: function() {
        return this.transformMatrix ? " matrix(" + this.transformMatrix.join(" ") + ") " : ""
    },
    _createBaseSVGMarkup: function() {
        var e = [];
        return this.fill && this.fill.toLive && e.push(this.fill.toSVG(this, !1)),
        this.stroke && this.stroke.toLive && e.push(this.stroke.toSVG(this, !1)),
        this.shadow && e.push(this.shadow.toSVG(this)),
        e
    }
}),
fabric.util.object.extend(fabric.Object.prototype, {
    hasStateChanged: function() {
        return this.stateProperties.some(function(e) {
            return this.get(e) !== this.originalState[e]
        }, this)
    },
    saveState: function(e) {
        return this.stateProperties.forEach(function(e) {
            this.originalState[e] = this.get(e)
        }, this),
        e && e.stateProperties && e.stateProperties.forEach(function(e) {
            this.originalState[e] = this.get(e)
        }, this),
        this
    },
    setupState: function() {
        return this.originalState = {},
        this.saveState(),
        this
    }
}),
function() {
    var e = fabric.util.degreesToRadians
      , t = function() {
        return typeof G_vmlCanvasManager != "undefined"
    };
    fabric.util.object.extend(fabric.Object.prototype, {
        _controlsVisibility: null,
        _findTargetCorner: function(e) {
            if (!this.hasControls || !this.active)
                return !1;
            var t = e.x, n = e.y, r, i;
            for (var s in this.oCoords) {
                if (!this.isControlVisible(s))
                    continue;
                if (s === "mtr" && !this.hasRotatingPoint)
                    continue;
                if (!(!this.get("lockUniScaling") || s !== "mt" && s !== "mr" && s !== "mb" && s !== "ml"))
                    continue;
                i = this._getImageLines(this.oCoords[s].corner),
                r = this._findCrossPoints({
                    x: t,
                    y: n
                }, i);
                if (r !== 0 && r % 2 === 1)
                    return this.__corner = s,
                    s
            }
            return !1
        },
        _setCornerCoords: function() {
            var t = this.oCoords, n = e(45 - this.angle), r = Math.sqrt(2 * Math.pow(this.cornerSize, 2)) / 2, i = r * Math.cos(n), s = r * Math.sin(n), o, u;
            for (var a in t)
                o = t[a].x,
                u = t[a].y,
                t[a].corner = {
                    tl: {
                        x: o - s,
                        y: u - i
                    },
                    tr: {
                        x: o + i,
                        y: u - s
                    },
                    bl: {
                        x: o - i,
                        y: u + s
                    },
                    br: {
                        x: o + s,
                        y: u + i
                    }
                }
        },
        _calculateCurrentDimensions: function(e) {
            var t = this.getViewportTransform()
              , n = this.strokeWidth
              , r = this.width
              , i = this.height
              , s = this.strokeLineCap === "round" || this.strokeLineCap === "square"
              , o = this.type === "line" && this.width === 0
              , u = this.type === "line" && this.height === 0
              , a = o || u
              , f = s && u || !a
              , l = s && o || !a;
            return o ? r = n : u && (i = n),
            f && (r += r < 0 ? -n : n),
            l && (i += i < 0 ? -n : n),
            r = r * this.scaleX + 2 * this.padding,
            i = i * this.scaleY + 2 * this.padding,
            e ? fabric.util.transformPoint(new fabric.Point(r,i), t, !0) : {
                x: r,
                y: i
            }
        },
        drawBorders: function(e) {
            if (!this.hasBorders)
                return this;
            e.save(),
            e.globalAlpha = this.isMoving ? this.borderOpacityWhenMoving : 1,
            e.strokeStyle = this.borderColor,
            e.lineWidth = 1 / this.borderScaleFactor;
            var t = this._calculateCurrentDimensions(!0)
              , n = t.x
              , r = t.y;
            this.group && (n *= this.group.scaleX,
            r *= this.group.scaleY),
            e.strokeRect(~~-(n / 2) - .5, ~~-(r / 2) - .5, ~~n + 1, ~~r + 1);
            if (this.hasRotatingPoint && this.isControlVisible("mtr") && !this.get("lockRotation") && this.hasControls) {
                var i = -r / 2;
                e.beginPath(),
                e.moveTo(0, i),
                e.lineTo(0, i - this.rotatingPointOffset),
                e.closePath(),
                e.stroke()
            }
            return e.restore(),
            this
        },
        drawControls: function(e) {
            if (!this.hasControls)
                return this;
            var t = this._calculateCurrentDimensions(!0)
              , n = t.x
              , r = t.y
              , i = -(n / 2)
              , s = -(r / 2)
              , o = this.cornerSize / 2
              , u = this.transparentCorners ? "strokeRect" : "fillRect";
            return e.save(),
            e.lineWidth = 1,
            e.globalAlpha = this.isMoving ? this.borderOpacityWhenMoving : 1,
            e.strokeStyle = e.fillStyle = this.cornerColor,
            this._drawControl("tl", e, u, i - o, s - o),
            this._drawControl("tr", e, u, i + n - o, s - o),
            this._drawControl("bl", e, u, i - o, s + r - o),
            this._drawControl("br", e, u, i + n - o, s + r - o),
            this.get("lockUniScaling") || (this._drawControl("mt", e, u, i + n / 2 - o, s - o),
            this._drawControl("mb", e, u, i + n / 2 - o, s + r - o),
            this._drawControl("mr", e, u, i + n - o, s + r / 2 - o),
            this._drawControl("ml", e, u, i - o, s + r / 2 - o)),
            this.hasRotatingPoint && this._drawControl("mtr", e, u, i + n / 2 - o, s - this.rotatingPointOffset - o),
            e.restore(),
            this
        },
        _drawControl: function(e, n, r, i, s) {
            if (!this.isControlVisible(e))
                return;
            var o = this.cornerSize;
            t() || this.transparentCorners || n.clearRect(i, s, o, o),
            n[r](i, s, o, o)
        },
        isControlVisible: function(e) {
            return this._getControlsVisibility()[e]
        },
        setControlVisible: function(e, t) {
            return this._getControlsVisibility()[e] = t,
            this
        },
        setControlsVisibility: function(e) {
            e || (e = {});
            for (var t in e)
                this.setControlVisible(t, e[t]);
            return this
        },
        _getControlsVisibility: function() {
            return this._controlsVisibility || (this._controlsVisibility = {
                tl: !0,
                tr: !0,
                br: !0,
                bl: !0,
                ml: !0,
                mt: !0,
                mr: !0,
                mb: !0,
                mtr: !0
            }),
            this._controlsVisibility
        }
    })
}(),
fabric.util.object.extend(fabric.StaticCanvas.prototype, {
    FX_DURATION: 500,
    fxCenterObjectH: function(e, t) {
        t = t || {};
        var n = function() {}
          , r = t.onComplete || n
          , i = t.onChange || n
          , s = this;
        return fabric.util.animate({
            startValue: e.get("left"),
            endValue: this.getCenter().left,
            duration: this.FX_DURATION,
            onChange: function(t) {
                e.set("left", t),
                s.renderAll(),
                i()
            },
            onComplete: function() {
                e.setCoords(),
                r()
            }
        }),
        this
    },
    fxCenterObjectV: function(e, t) {
        t = t || {};
        var n = function() {}
          , r = t.onComplete || n
          , i = t.onChange || n
          , s = this;
        return fabric.util.animate({
            startValue: e.get("top"),
            endValue: this.getCenter().top,
            duration: this.FX_DURATION,
            onChange: function(t) {
                e.set("top", t),
                s.renderAll(),
                i()
            },
            onComplete: function() {
                e.setCoords(),
                r()
            }
        }),
        this
    },
    fxRemove: function(e, t) {
        t = t || {};
        var n = function() {}
          , r = t.onComplete || n
          , i = t.onChange || n
          , s = this;
        return fabric.util.animate({
            startValue: e.get("opacity"),
            endValue: 0,
            duration: this.FX_DURATION,
            onStart: function() {
                e.set("active", !1)
            },
            onChange: function(t) {
                e.set("opacity", t),
                s.renderAll(),
                i()
            },
            onComplete: function() {
                s.remove(e),
                r()
            }
        }),
        this
    }
}),
fabric.util.object.extend(fabric.Object.prototype, {
    animate: function() {
        if (arguments[0] && typeof arguments[0] == "object") {
            var e = [], t, n;
            for (t in arguments[0])
                e.push(t);
            for (var r = 0, i = e.length; r < i; r++)
                t = e[r],
                n = r !== i - 1,
                this._animate(t, arguments[0][t], arguments[1], n)
        } else
            this._animate.apply(this, arguments);
        return this
    },
    _animate: function(e, t, n, r) {
        var i = this, s;
        t = t.toString(),
        n ? n = fabric.util.object.clone(n) : n = {},
        ~e.indexOf(".") && (s = e.split("."));
        var o = s ? this.get(s[0])[s[1]] : this.get(e);
        "from"in n || (n.from = o),
        ~t.indexOf("=") ? t = o + parseFloat(t.replace("=", "")) : t = parseFloat(t),
        fabric.util.animate({
            startValue: n.from,
            endValue: t,
            byValue: n.by,
            easing: n.easing,
            duration: n.duration,
            abort: n.abort && function() {
                return n.abort.call(i)
            }
            ,
            onChange: function(t) {
                s ? i[s[0]][s[1]] = t : i.set(e, t);
                if (r)
                    return;
                n.onChange && n.onChange()
            },
            onComplete: function() {
                if (r)
                    return;
                i.setCoords(),
                n.onComplete && n.onComplete()
            }
        })
    }
}),
function(e) {
    "use strict";
    function s(e, t) {
        var n = e.origin
          , r = e.axis1
          , i = e.axis2
          , s = e.dimension
          , o = t.nearest
          , u = t.center
          , a = t.farthest;
        return function() {
            switch (this.get(n)) {
            case o:
                return Math.min(this.get(r), this.get(i));
            case u:
                return Math.min(this.get(r), this.get(i)) + .5 * this.get(s);
            case a:
                return Math.max(this.get(r), this.get(i))
            }
        }
    }
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend
      , r = {
        x1: 1,
        x2: 1,
        y1: 1,
        y2: 1
    }
      , i = t.StaticCanvas.supports("setLineDash");
    if (t.Line) {
        t.warn("fabric.Line is already defined");
        return
    }
    t.Line = t.util.createClass(t.Object, {
        type: "line",
        x1: 0,
        y1: 0,
        x2: 0,
        y2: 0,
        initialize: function(e, t) {
            t = t || {},
            e || (e = [0, 0, 0, 0]),
            this.callSuper("initialize", t),
            this.set("x1", e[0]),
            this.set("y1", e[1]),
            this.set("x2", e[2]),
            this.set("y2", e[3]),
            this._setWidthHeight(t)
        },
        _setWidthHeight: function(e) {
            e || (e = {}),
            this.width = Math.abs(this.x2 - this.x1),
            this.height = Math.abs(this.y2 - this.y1),
            this.left = "left"in e ? e.left : this._getLeftToOriginX(),
            this.top = "top"in e ? e.top : this._getTopToOriginY()
        },
        _set: function(e, t) {
            return this.callSuper("_set", e, t),
            typeof r[e] != "undefined" && this._setWidthHeight(),
            this
        },
        _getLeftToOriginX: s({
            origin: "originX",
            axis1: "x1",
            axis2: "x2",
            dimension: "width"
        }, {
            nearest: "left",
            center: "center",
            farthest: "right"
        }),
        _getTopToOriginY: s({
            origin: "originY",
            axis1: "y1",
            axis2: "y2",
            dimension: "height"
        }, {
            nearest: "top",
            center: "center",
            farthest: "bottom"
        }),
        _render: function(e, t) {
            e.beginPath();
            if (t) {
                var n = this.getCenterPoint();
                e.translate(n.x - this.strokeWidth / 2, n.y - this.strokeWidth / 2)
            }
            if (!this.strokeDashArray || this.strokeDashArray && i) {
                var r = this.calcLinePoints();
                e.moveTo(r.x1, r.y1),
                e.lineTo(r.x2, r.y2)
            }
            e.lineWidth = this.strokeWidth;
            var s = e.strokeStyle;
            e.strokeStyle = this.stroke || e.fillStyle,
            this.stroke && this._renderStroke(e),
            e.strokeStyle = s
        },
        _renderDashedStroke: function(e) {
            var n = this.calcLinePoints();
            e.beginPath(),
            t.util.drawDashedLine(e, n.x1, n.y1, n.x2, n.y2, this.strokeDashArray),
            e.closePath()
        },
        toObject: function(e) {
            return n(this.callSuper("toObject", e), this.calcLinePoints())
        },
        calcLinePoints: function() {
            var e = this.x1 <= this.x2 ? -1 : 1
              , t = this.y1 <= this.y2 ? -1 : 1
              , n = e * this.width * .5
              , r = t * this.height * .5
              , i = e * this.width * -0.5
              , s = t * this.height * -0.5;
            return {
                x1: n,
                x2: i,
                y1: r,
                y2: s
            }
        },
        toSVG: function(e) {
            var t = this._createBaseSVGMarkup()
              , n = {
                x1: this.x1,
                x2: this.x2,
                y1: this.y1,
                y2: this.y2
            };
            if (!this.group || this.group.type !== "path-group")
                n = this.calcLinePoints();
            return t.push("<line ", 'x1="', n.x1, '" y1="', n.y1, '" x2="', n.x2, '" y2="', n.y2, '" style="', this.getSvgStyles(), '" transform="', this.getSvgTransform(), this.getSvgTransformMatrix(), '"/>\n'),
            e ? e(t.join("")) : t.join("")
        },
        complexity: function() {
            return 1
        }
    }),
    t.Line.ATTRIBUTE_NAMES = t.SHARED_ATTRIBUTES.concat("x1 y1 x2 y2".split(" ")),
    t.Line.fromElement = function(e, r) {
        var i = t.parseAttributes(e, t.Line.ATTRIBUTE_NAMES)
          , s = [i.x1 || 0, i.y1 || 0, i.x2 || 0, i.y2 || 0];
        return new t.Line(s,n(i, r))
    }
    ,
    t.Line.fromObject = function(e) {
        var n = [e.x1, e.y1, e.x2, e.y2];
        return new t.Line(n,e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    function i(e) {
        return "radius"in e && e.radius >= 0
    }
    var t = e.fabric || (e.fabric = {})
      , n = Math.PI
      , r = t.util.object.extend;
    if (t.Circle) {
        t.warn("fabric.Circle is already defined.");
        return
    }
    t.Circle = t.util.createClass(t.Object, {
        type: "circle",
        radius: 0,
        startAngle: 0,
        endAngle: n * 2,
        initialize: function(e) {
            e = e || {},
            this.callSuper("initialize", e),
            this.set("radius", e.radius || 0),
            this.startAngle = e.startAngle || this.startAngle,
            this.endAngle = e.endAngle || this.endAngle
        },
        _set: function(e, t) {
            return this.callSuper("_set", e, t),
            e === "radius" && this.setRadius(t),
            this
        },
        toObject: function(e) {
            return r(this.callSuper("toObject", e), {
                radius: this.get("radius"),
                startAngle: this.startAngle,
                endAngle: this.endAngle
            })
        },
        toSVG: function(e) {
            var t = this._createBaseSVGMarkup()
              , r = 0
              , i = 0
              , s = (this.endAngle - this.startAngle) % (2 * n);
            if (s === 0)
                this.group && this.group.type === "path-group" && (r = this.left + this.radius,
                i = this.top + this.radius),
                t.push("<circle ", 'cx="' + r + '" cy="' + i + '" ', 'r="', this.radius, '" style="', this.getSvgStyles(), '" transform="', this.getSvgTransform(), " ", this.getSvgTransformMatrix(), '"/>\n');
            else {
                var o = Math.cos(this.startAngle) * this.radius
                  , u = Math.sin(this.startAngle) * this.radius
                  , a = Math.cos(this.endAngle) * this.radius
                  , f = Math.sin(this.endAngle) * this.radius
                  , l = s > n ? "1" : "0";
                t.push('<path d="M ' + o + " " + u, " A " + this.radius + " " + this.radius, " 0 ", +l + " 1", " " + a + " " + f, '" style="', this.getSvgStyles(), '" transform="', this.getSvgTransform(), " ", this.getSvgTransformMatrix(), '"/>\n')
            }
            return e ? e(t.join("")) : t.join("")
        },
        _render: function(e, t) {
            e.beginPath(),
            e.arc(t ? this.left + this.radius : 0, t ? this.top + this.radius : 0, this.radius, this.startAngle, this.endAngle, !1),
            this._renderFill(e),
            this._renderStroke(e)
        },
        getRadiusX: function() {
            return this.get("radius") * this.get("scaleX")
        },
        getRadiusY: function() {
            return this.get("radius") * this.get("scaleY")
        },
        setRadius: function(e) {
            this.radius = e,
            this.set("width", e * 2).set("height", e * 2)
        },
        complexity: function() {
            return 1
        }
    }),
    t.Circle.ATTRIBUTE_NAMES = t.SHARED_ATTRIBUTES.concat("cx cy r".split(" ")),
    t.Circle.fromElement = function(e, n) {
        n || (n = {});
        var s = t.parseAttributes(e, t.Circle.ATTRIBUTE_NAMES);
        if (!i(s))
            throw new Error("value of `r` attribute is required and can not be negative");
        s.left = s.left || 0,
        s.top = s.top || 0;
        var o = new t.Circle(r(s, n));
        return o.left -= o.radius,
        o.top -= o.radius,
        o
    }
    ,
    t.Circle.fromObject = function(e) {
        return new t.Circle(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {});
    if (t.Triangle) {
        t.warn("fabric.Triangle is already defined");
        return
    }
    t.Triangle = t.util.createClass(t.Object, {
        type: "triangle",
        initialize: function(e) {
            e = e || {},
            this.callSuper("initialize", e),
            this.set("width", e.width || 100).set("height", e.height || 100)
        },
        _render: function(e) {
            var t = this.width / 2
              , n = this.height / 2;
            e.beginPath(),
            e.moveTo(-t, n),
            e.lineTo(0, -n),
            e.lineTo(t, n),
            e.closePath(),
            this._renderFill(e),
            this._renderStroke(e)
        },
        _renderDashedStroke: function(e) {
            var n = this.width / 2
              , r = this.height / 2;
            e.beginPath(),
            t.util.drawDashedLine(e, -n, r, 0, -r, this.strokeDashArray),
            t.util.drawDashedLine(e, 0, -r, n, r, this.strokeDashArray),
            t.util.drawDashedLine(e, n, r, -n, r, this.strokeDashArray),
            e.closePath()
        },
        toSVG: function(e) {
            var t = this._createBaseSVGMarkup()
              , n = this.width / 2
              , r = this.height / 2
              , i = [-n + " " + r, "0 " + -r, n + " " + r].join(",");
            return t.push("<polygon ", 'points="', i, '" style="', this.getSvgStyles(), '" transform="', this.getSvgTransform(), '"/>'),
            e ? e(t.join("")) : t.join("")
        },
        complexity: function() {
            return 1
        }
    }),
    t.Triangle.fromObject = function(e) {
        return new t.Triangle(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = Math.PI * 2
      , r = t.util.object.extend;
    if (t.Ellipse) {
        t.warn("fabric.Ellipse is already defined.");
        return
    }
    t.Ellipse = t.util.createClass(t.Object, {
        type: "ellipse",
        rx: 0,
        ry: 0,
        initialize: function(e) {
            e = e || {},
            this.callSuper("initialize", e),
            this.set("rx", e.rx || 0),
            this.set("ry", e.ry || 0)
        },
        _set: function(e, t) {
            this.callSuper("_set", e, t);
            switch (e) {
            case "rx":
                this.rx = t,
                this.set("width", t * 2);
                break;
            case "ry":
                this.ry = t,
                this.set("height", t * 2)
            }
            return this
        },
        getRx: function() {
            return this.get("rx") * this.get("scaleX")
        },
        getRy: function() {
            return this.get("ry") * this.get("scaleY")
        },
        toObject: function(e) {
            return r(this.callSuper("toObject", e), {
                rx: this.get("rx"),
                ry: this.get("ry")
            })
        },
        toSVG: function(e) {
            var t = this._createBaseSVGMarkup()
              , n = 0
              , r = 0;
            return this.group && this.group.type === "path-group" && (n = this.left + this.rx,
            r = this.top + this.ry),
            t.push("<ellipse ", 'cx="', n, '" cy="', r, '" ', 'rx="', this.rx, '" ry="', this.ry, '" style="', this.getSvgStyles(), '" transform="', this.getSvgTransform(), this.getSvgTransformMatrix(), '"/>\n'),
            e ? e(t.join("")) : t.join("")
        },
        _render: function(e, t) {
            e.beginPath(),
            e.save(),
            e.transform(1, 0, 0, this.ry / this.rx, 0, 0),
            e.arc(t ? this.left + this.rx : 0, t ? (this.top + this.ry) * this.rx / this.ry : 0, this.rx, 0, n, !1),
            e.restore(),
            this._renderFill(e),
            this._renderStroke(e)
        },
        complexity: function() {
            return 1
        }
    }),
    t.Ellipse.ATTRIBUTE_NAMES = t.SHARED_ATTRIBUTES.concat("cx cy rx ry".split(" ")),
    t.Ellipse.fromElement = function(e, n) {
        n || (n = {});
        var i = t.parseAttributes(e, t.Ellipse.ATTRIBUTE_NAMES);
        i.left = i.left || 0,
        i.top = i.top || 0;
        var s = new t.Ellipse(r(i, n));
        return s.top -= s.ry,
        s.left -= s.rx,
        s
    }
    ,
    t.Ellipse.fromObject = function(e) {
        return new t.Ellipse(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend;
    if (t.Rect) {
        console.warn("fabric.Rect is already defined");
        return
    }
    var r = t.Object.prototype.stateProperties.concat();
    r.push("rx", "ry", "x", "y"),
    t.Rect = t.util.createClass(t.Object, {
        stateProperties: r,
        type: "rect",
        rx: 0,
        ry: 0,
        strokeDashArray: null,
        initialize: function(e) {
            e = e || {},
            this.callSuper("initialize", e),
            this._initRxRy()
        },
        _initRxRy: function() {
            this.rx && !this.ry ? this.ry = this.rx : this.ry && !this.rx && (this.rx = this.ry)
        },
        _render: function(e, t) {
            if (this.width === 1 && this.height === 1) {
                e.fillRect(0, 0, 1, 1);
                return
            }
            var n = this.rx ? Math.min(this.rx, this.width / 2) : 0
              , r = this.ry ? Math.min(this.ry, this.height / 2) : 0
              , i = this.width
              , s = this.height
              , o = t ? this.left : -this.width / 2
              , u = t ? this.top : -this.height / 2
              , a = n !== 0 || r !== 0
              , f = .4477152502;
            e.beginPath(),
            e.moveTo(o + n, u),
            e.lineTo(o + i - n, u),
            a && e.bezierCurveTo(o + i - f * n, u, o + i, u + f * r, o + i, u + r),
            e.lineTo(o + i, u + s - r),
            a && e.bezierCurveTo(o + i, u + s - f * r, o + i - f * n, u + s, o + i - n, u + s),
            e.lineTo(o + n, u + s),
            a && e.bezierCurveTo(o + f * n, u + s, o, u + s - f * r, o, u + s - r),
            e.lineTo(o, u + r),
            a && e.bezierCurveTo(o, u + f * r, o + f * n, u, o + n, u),
            e.closePath(),
            this._renderFill(e),
            this._renderStroke(e)
        },
        _renderDashedStroke: function(e) {
            var n = -this.width / 2
              , r = -this.height / 2
              , i = this.width
              , s = this.height;
            e.beginPath(),
            t.util.drawDashedLine(e, n, r, n + i, r, this.strokeDashArray),
            t.util.drawDashedLine(e, n + i, r, n + i, r + s, this.strokeDashArray),
            t.util.drawDashedLine(e, n + i, r + s, n, r + s, this.strokeDashArray),
            t.util.drawDashedLine(e, n, r + s, n, r, this.strokeDashArray),
            e.closePath()
        },
        toObject: function(e) {
            var t = n(this.callSuper("toObject", e), {
                rx: this.get("rx") || 0,
                ry: this.get("ry") || 0
            });
            return this.includeDefaultValues || this._removeDefaultValues(t),
            t
        },
        toSVG: function(e) {
            var t = this._createBaseSVGMarkup()
              , n = this.left
              , r = this.top;
            if (!this.group || this.group.type !== "path-group")
                n = -this.width / 2,
                r = -this.height / 2;
            return t.push("<rect ", 'x="', n, '" y="', r, '" rx="', this.get("rx"), '" ry="', this.get("ry"), '" width="', this.width, '" height="', this.height, '" style="', this.getSvgStyles(), '" transform="', this.getSvgTransform(), this.getSvgTransformMatrix(), '"/>\n'),
            e ? e(t.join("")) : t.join("")
        },
        complexity: function() {
            return 1
        }
    }),
    t.Rect.ATTRIBUTE_NAMES = t.SHARED_ATTRIBUTES.concat("x y rx ry width height".split(" ")),
    t.Rect.fromElement = function(e, r) {
        if (!e)
            return null;
        r = r || {};
        var i = t.parseAttributes(e, t.Rect.ATTRIBUTE_NAMES);
        i.left = i.left || 0,
        i.top = i.top || 0;
        var s = new t.Rect(n(r ? t.util.object.clone(r) : {}, i));
        return s.visible = s.width > 0 && s.height > 0,
        s
    }
    ,
    t.Rect.fromObject = function(e) {
        return new t.Rect(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {});
    if (t.Polyline) {
        t.warn("fabric.Polyline is already defined");
        return
    }
    t.Polyline = t.util.createClass(t.Object, {
        type: "polyline",
        points: null,
        minX: 0,
        minY: 0,
        initialize: function(e, n) {
            return t.Polygon.prototype.initialize.call(this, e, n)
        },
        _calcDimensions: function() {
            return t.Polygon.prototype._calcDimensions.call(this)
        },
        _applyPointOffset: function() {
            return t.Polygon.prototype._applyPointOffset.call(this)
        },
        toObject: function(e) {
            return t.Polygon.prototype.toObject.call(this, e)
        },
        toSVG: function(e) {
            return t.Polygon.prototype.toSVG.call(this, e)
        },
        _render: function(e) {
            if (!t.Polygon.prototype.commonRender.call(this, e))
                return;
            this._renderFill(e),
            this._renderStroke(e)
        },
        _renderDashedStroke: function(e) {
            var n, r;
            e.beginPath();
            for (var i = 0, s = this.points.length; i < s; i++)
                n = this.points[i],
                r = this.points[i + 1] || n,
                t.util.drawDashedLine(e, n.x, n.y, r.x, r.y, this.strokeDashArray)
        },
        complexity: function() {
            return this.get("points").length
        }
    }),
    t.Polyline.ATTRIBUTE_NAMES = t.SHARED_ATTRIBUTES.concat(),
    t.Polyline.fromElement = function(e, n) {
        if (!e)
            return null;
        n || (n = {});
        var r = t.parsePointsAttribute(e.getAttribute("points"))
          , i = t.parseAttributes(e, t.Polyline.ATTRIBUTE_NAMES);
        return new t.Polyline(r,t.util.object.extend(i, n))
    }
    ,
    t.Polyline.fromObject = function(e) {
        var n = e.points;
        return new t.Polyline(n,e,!0)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend
      , r = t.util.array.min
      , i = t.util.array.max
      , s = t.util.toFixed;
    if (t.Polygon) {
        t.warn("fabric.Polygon is already defined");
        return
    }
    t.Polygon = t.util.createClass(t.Object, {
        type: "polygon",
        points: null,
        minX: 0,
        minY: 0,
        initialize: function(e, t) {
            t = t || {},
            this.points = e || [],
            this.callSuper("initialize", t),
            this._calcDimensions(),
            "top"in t || (this.top = this.minY),
            "left"in t || (this.left = this.minX)
        },
        _calcDimensions: function() {
            var e = this.points
              , t = r(e, "x")
              , n = r(e, "y")
              , s = i(e, "x")
              , o = i(e, "y");
            this.width = s - t || 0,
            this.height = o - n || 0,
            this.minX = t || 0,
            this.minY = n || 0
        },
        _applyPointOffset: function() {
            this.points.forEach(function(e) {
                e.x -= this.minX + this.width / 2,
                e.y -= this.minY + this.height / 2
            }, this)
        },
        toObject: function(e) {
            return n(this.callSuper("toObject", e), {
                points: this.points.concat()
            })
        },
        toSVG: function(e) {
            var t = []
              , n = this._createBaseSVGMarkup();
            for (var r = 0, i = this.points.length; r < i; r++)
                t.push(s(this.points[r].x, 2), ",", s(this.points[r].y, 2), " ");
            return n.push("<", this.type, " ", 'points="', t.join(""), '" style="', this.getSvgStyles(), '" transform="', this.getSvgTransform(), " ", this.getSvgTransformMatrix(), '"/>\n'),
            e ? e(n.join("")) : n.join("")
        },
        _render: function(e) {
            if (!this.commonRender(e))
                return;
            this._renderFill(e);
            if (this.stroke || this.strokeDashArray)
                e.closePath(),
                this._renderStroke(e)
        },
        commonRender: function(e) {
            var t, n = this.points.length;
            if (!n || isNaN(this.points[n - 1].y))
                return !1;
            e.beginPath(),
            this._applyPointOffset && ((!this.group || this.group.type !== "path-group") && this._applyPointOffset(),
            this._applyPointOffset = null),
            e.moveTo(this.points[0].x, this.points[0].y);
            for (var r = 0; r < n; r++)
                t = this.points[r],
                e.lineTo(t.x, t.y);
            return !0
        },
        _renderDashedStroke: function(e) {
            t.Polyline.prototype._renderDashedStroke.call(this, e),
            e.closePath()
        },
        complexity: function() {
            return this.points.length
        }
    }),
    t.Polygon.ATTRIBUTE_NAMES = t.SHARED_ATTRIBUTES.concat(),
    t.Polygon.fromElement = function(e, r) {
        if (!e)
            return null;
        r || (r = {});
        var i = t.parsePointsAttribute(e.getAttribute("points"))
          , s = t.parseAttributes(e, t.Polygon.ATTRIBUTE_NAMES);
        return new t.Polygon(i,n(s, r))
    }
    ,
    t.Polygon.fromObject = function(e) {
        return new t.Polygon(e.points,e,!0)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.array.min
      , r = t.util.array.max
      , i = t.util.object.extend
      , s = Object.prototype.toString
      , o = t.util.drawArc
      , u = {
        m: 2,
        l: 2,
        h: 1,
        v: 1,
        c: 6,
        s: 4,
        q: 4,
        t: 2,
        a: 7
    }
      , a = {
        m: "l",
        M: "L"
    };
    if (t.Path) {
        t.warn("fabric.Path is already defined");
        return
    }
    t.Path = t.util.createClass(t.Object, {
        type: "path",
        path: null,
        minX: 0,
        minY: 0,
        initialize: function(e, t) {
            t = t || {},
            this.setOptions(t);
            if (!e)
                throw new Error("`path` argument is required");
            var n = s.call(e) === "[object Array]";
            this.path = n ? e : e.match && e.match(/[mzlhvcsqta][^mzlhvcsqta]*/gi);
            if (!this.path)
                return;
            n || (this.path = this._parsePath()),
            this._setPositionDimensions(),
            t.sourcePath && this.setSourcePath(t.sourcePath)
        },
        _setPositionDimensions: function() {
            var e = this._parseDimensions();
            this.minX = e.left,
            this.minY = e.top,
            this.width = e.width,
            this.height = e.height,
            e.left += this.originX === "center" ? this.width / 2 : this.originX === "right" ? this.width : 0,
            e.top += this.originY === "center" ? this.height / 2 : this.originY === "bottom" ? this.height : 0,
            this.top = this.top || e.top,
            this.left = this.left || e.left,
            this.pathOffset = this.pathOffset || {
                x: this.minX + this.width / 2,
                y: this.minY + this.height / 2
            }
        },
        _render: function(e) {
            var t, n = null, r = 0, i = 0, s = 0, u = 0, a = 0, f = 0, l, c, h = -this.pathOffset.x, p = -this.pathOffset.y;
            this.group && this.group.type === "path-group" && (h = 0,
            p = 0),
            e.beginPath();
            for (var d = 0, v = this.path.length; d < v; ++d) {
                t = this.path[d];
                switch (t[0]) {
                case "l":
                    s += t[1],
                    u += t[2],
                    e.lineTo(s + h, u + p);
                    break;
                case "L":
                    s = t[1],
                    u = t[2],
                    e.lineTo(s + h, u + p);
                    break;
                case "h":
                    s += t[1],
                    e.lineTo(s + h, u + p);
                    break;
                case "H":
                    s = t[1],
                    e.lineTo(s + h, u + p);
                    break;
                case "v":
                    u += t[1],
                    e.lineTo(s + h, u + p);
                    break;
                case "V":
                    u = t[1],
                    e.lineTo(s + h, u + p);
                    break;
                case "m":
                    s += t[1],
                    u += t[2],
                    r = s,
                    i = u,
                    e.moveTo(s + h, u + p);
                    break;
                case "M":
                    s = t[1],
                    u = t[2],
                    r = s,
                    i = u,
                    e.moveTo(s + h, u + p);
                    break;
                case "c":
                    l = s + t[5],
                    c = u + t[6],
                    a = s + t[3],
                    f = u + t[4],
                    e.bezierCurveTo(s + t[1] + h, u + t[2] + p, a + h, f + p, l + h, c + p),
                    s = l,
                    u = c;
                    break;
                case "C":
                    s = t[5],
                    u = t[6],
                    a = t[3],
                    f = t[4],
                    e.bezierCurveTo(t[1] + h, t[2] + p, a + h, f + p, s + h, u + p);
                    break;
                case "s":
                    l = s + t[3],
                    c = u + t[4],
                    n[0].match(/[CcSs]/) === null ? (a = s,
                    f = u) : (a = 2 * s - a,
                    f = 2 * u - f),
                    e.bezierCurveTo(a + h, f + p, s + t[1] + h, u + t[2] + p, l + h, c + p),
                    a = s + t[1],
                    f = u + t[2],
                    s = l,
                    u = c;
                    break;
                case "S":
                    l = t[3],
                    c = t[4],
                    n[0].match(/[CcSs]/) === null ? (a = s,
                    f = u) : (a = 2 * s - a,
                    f = 2 * u - f),
                    e.bezierCurveTo(a + h, f + p, t[1] + h, t[2] + p, l + h, c + p),
                    s = l,
                    u = c,
                    a = t[1],
                    f = t[2];
                    break;
                case "q":
                    l = s + t[3],
                    c = u + t[4],
                    a = s + t[1],
                    f = u + t[2],
                    e.quadraticCurveTo(a + h, f + p, l + h, c + p),
                    s = l,
                    u = c;
                    break;
                case "Q":
                    l = t[3],
                    c = t[4],
                    e.quadraticCurveTo(t[1] + h, t[2] + p, l + h, c + p),
                    s = l,
                    u = c,
                    a = t[1],
                    f = t[2];
                    break;
                case "t":
                    l = s + t[1],
                    c = u + t[2],
                    n[0].match(/[QqTt]/) === null ? (a = s,
                    f = u) : (a = 2 * s - a,
                    f = 2 * u - f),
                    e.quadraticCurveTo(a + h, f + p, l + h, c + p),
                    s = l,
                    u = c;
                    break;
                case "T":
                    l = t[1],
                    c = t[2],
                    n[0].match(/[QqTt]/) === null ? (a = s,
                    f = u) : (a = 2 * s - a,
                    f = 2 * u - f),
                    e.quadraticCurveTo(a + h, f + p, l + h, c + p),
                    s = l,
                    u = c;
                    break;
                case "a":
                    o(e, s + h, u + p, [t[1], t[2], t[3], t[4], t[5], t[6] + s + h, t[7] + u + p]),
                    s += t[6],
                    u += t[7];
                    break;
                case "A":
                    o(e, s + h, u + p, [t[1], t[2], t[3], t[4], t[5], t[6] + h, t[7] + p]),
                    s = t[6],
                    u = t[7];
                    break;
                case "z":
                case "Z":
                    s = r,
                    u = i,
                    e.closePath()
                }
                n = t
            }
            this._renderFill(e),
            this._renderStroke(e)
        },
        toString: function() {
            return "#<fabric.Path (" + this.complexity() + '): { "top": ' + this.top + ', "left": ' + this.left + " }>"
        },
        toObject: function(e) {
            var t = i(this.callSuper("toObject", e), {
                path: this.path.map(function(e) {
                    return e.slice()
                }),
                pathOffset: this.pathOffset
            });
            return this.sourcePath && (t.sourcePath = this.sourcePath),
            this.transformMatrix && (t.transformMatrix = this.transformMatrix),
            t
        },
        toDatalessObject: function(e) {
            var t = this.toObject(e);
            return this.sourcePath && (t.path = this.sourcePath),
            delete t.sourcePath,
            t
        },
        toSVG: function(e) {
            var t = []
              , n = this._createBaseSVGMarkup()
              , r = "";
            for (var i = 0, s = this.path.length; i < s; i++)
                t.push(this.path[i].join(" "));
            var o = t.join(" ");
            if (!this.group || this.group.type !== "path-group")
                r = " translate(" + -this.pathOffset.x + ", " + -this.pathOffset.y + ") ";
            return n.push("<path ", 'd="', o, '" style="', this.getSvgStyles(), '" transform="', this.getSvgTransform(), r, this.getSvgTransformMatrix(), '" stroke-linecap="round" ', "/>\n"),
            e ? e(n.join("")) : n.join("")
        },
        complexity: function() {
            return this.path.length
        },
        _parsePath: function() {
            var e = [], t = [], n, r, i = /([-+]?((\d+\.\d+)|((\d+)|(\.\d+)))(?:e[-+]?\d+)?)/ig, s, o;
            for (var f = 0, l, c = this.path.length; f < c; f++) {
                n = this.path[f],
                o = n.slice(1).trim(),
                t.length = 0;
                while (s = i.exec(o))
                    t.push(s[0]);
                l = [n.charAt(0)];
                for (var h = 0, p = t.length; h < p; h++)
                    r = parseFloat(t[h]),
                    isNaN(r) || l.push(r);
                var d = l[0]
                  , v = u[d.toLowerCase()]
                  , m = a[d] || d;
                if (l.length - 1 > v)
                    for (var g = 1, y = l.length; g < y; g += v)
                        e.push([d].concat(l.slice(g, g + v))),
                        d = m;
                else
                    e.push(l)
            }
            return e
        },
        _parseDimensions: function() {
            var e = [], i = [], s, o = null, u = 0, a = 0, f = 0, l = 0, c = 0, h = 0, p, d, v;
            for (var m = 0, g = this.path.length; m < g; ++m) {
                s = this.path[m];
                switch (s[0]) {
                case "l":
                    f += s[1],
                    l += s[2],
                    v = [];
                    break;
                case "L":
                    f = s[1],
                    l = s[2],
                    v = [];
                    break;
                case "h":
                    f += s[1],
                    v = [];
                    break;
                case "H":
                    f = s[1],
                    v = [];
                    break;
                case "v":
                    l += s[1],
                    v = [];
                    break;
                case "V":
                    l = s[1],
                    v = [];
                    break;
                case "m":
                    f += s[1],
                    l += s[2],
                    u = f,
                    a = l,
                    v = [];
                    break;
                case "M":
                    f = s[1],
                    l = s[2],
                    u = f,
                    a = l,
                    v = [];
                    break;
                case "c":
                    p = f + s[5],
                    d = l + s[6],
                    c = f + s[3],
                    h = l + s[4],
                    v = t.util.getBoundsOfCurve(f, l, f + s[1], l + s[2], c, h, p, d),
                    f = p,
                    l = d;
                    break;
                case "C":
                    f = s[5],
                    l = s[6],
                    c = s[3],
                    h = s[4],
                    v = t.util.getBoundsOfCurve(f, l, s[1], s[2], c, h, f, l);
                    break;
                case "s":
                    p = f + s[3],
                    d = l + s[4],
                    o[0].match(/[CcSs]/) === null ? (c = f,
                    h = l) : (c = 2 * f - c,
                    h = 2 * l - h),
                    v = t.util.getBoundsOfCurve(f, l, c, h, f + s[1], l + s[2], p, d),
                    c = f + s[1],
                    h = l + s[2],
                    f = p,
                    l = d;
                    break;
                case "S":
                    p = s[3],
                    d = s[4],
                    o[0].match(/[CcSs]/) === null ? (c = f,
                    h = l) : (c = 2 * f - c,
                    h = 2 * l - h),
                    v = t.util.getBoundsOfCurve(f, l, c, h, s[1], s[2], p, d),
                    f = p,
                    l = d,
                    c = s[1],
                    h = s[2];
                    break;
                case "q":
                    p = f + s[3],
                    d = l + s[4],
                    c = f + s[1],
                    h = l + s[2],
                    v = t.util.getBoundsOfCurve(f, l, c, h, c, h, p, d),
                    f = p,
                    l = d;
                    break;
                case "Q":
                    c = s[1],
                    h = s[2],
                    v = t.util.getBoundsOfCurve(f, l, c, h, c, h, s[3], s[4]),
                    f = s[3],
                    l = s[4];
                    break;
                case "t":
                    p = f + s[1],
                    d = l + s[2],
                    o[0].match(/[QqTt]/) === null ? (c = f,
                    h = l) : (c = 2 * f - c,
                    h = 2 * l - h),
                    v = t.util.getBoundsOfCurve(f, l, c, h, c, h, p, d),
                    f = p,
                    l = d;
                    break;
                case "T":
                    p = s[1],
                    d = s[2],
                    o[0].match(/[QqTt]/) === null ? (c = f,
                    h = l) : (c = 2 * f - c,
                    h = 2 * l - h),
                    v = t.util.getBoundsOfCurve(f, l, c, h, c, h, p, d),
                    f = p,
                    l = d;
                    break;
                case "a":
                    v = t.util.getBoundsOfArc(f, l, s[1], s[2], s[3], s[4], s[5], s[6] + f, s[7] + l),
                    f += s[6],
                    l += s[7];
                    break;
                case "A":
                    v = t.util.getBoundsOfArc(f, l, s[1], s[2], s[3], s[4], s[5], s[6], s[7]),
                    f = s[6],
                    l = s[7];
                    break;
                case "z":
                case "Z":
                    f = u,
                    l = a
                }
                o = s,
                v.forEach(function(t) {
                    e.push(t.x),
                    i.push(t.y)
                }),
                e.push(f),
                i.push(l)
            }
            var y = n(e)
              , b = n(i)
              , w = r(e)
              , E = r(i)
              , S = w - y
              , x = E - b
              , T = {
                left: y,
                top: b,
                width: S,
                height: x
            };
            return T
        }
    }),
    t.Path.fromObject = function(e, n) {
        typeof e.path == "string" ? t.loadSVGFromURL(e.path, function(r) {
            var i = r[0]
              , s = e.path;
            delete e.path,
            t.util.object.extend(i, e),
            i.setSourcePath(s),
            n(i)
        }) : n(new t.Path(e.path,e))
    }
    ,
    t.Path.ATTRIBUTE_NAMES = t.SHARED_ATTRIBUTES.concat(["d"]),
    t.Path.fromElement = function(e, n, r) {
        var s = t.parseAttributes(e, t.Path.ATTRIBUTE_NAMES);
        n && n(new t.Path(s.d,i(s, r)))
    }
    ,
    t.Path.async = !0
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend
      , r = t.util.array.invoke
      , i = t.Object.prototype.toObject;
    if (t.PathGroup) {
        t.warn("fabric.PathGroup is already defined");
        return
    }
    t.PathGroup = t.util.createClass(t.Path, {
        type: "path-group",
        fill: "",
        initialize: function(e, t) {
            t = t || {},
            this.paths = e || [];
            for (var n = this.paths.length; n--; )
                this.paths[n].group = this;
            t.toBeParsed && (this.parseDimensionsFromPaths(t),
            delete t.toBeParsed),
            this.setOptions(t),
            this.setCoords(),
            t.sourcePath && this.setSourcePath(t.sourcePath)
        },
        parseDimensionsFromPaths: function(e) {
            var n, r, i = [], s = [], o, u, a, f = this.transformMatrix;
            for (var l = this.paths.length; l--; ) {
                o = this.paths[l],
                u = o.height + o.strokeWidth,
                a = o.width + o.strokeWidth,
                n = [{
                    x: o.left,
                    y: o.top
                }, {
                    x: o.left + a,
                    y: o.top
                }, {
                    x: o.left,
                    y: o.top + u
                }, {
                    x: o.left + a,
                    y: o.top + u
                }];
                for (var c = 0; c < n.length; c++)
                    r = n[c],
                    f && (r = t.util.transformPoint(r, f, !1)),
                    i.push(r.x),
                    s.push(r.y)
            }
            e.width = Math.max.apply(null, i),
            e.height = Math.max.apply(null, s)
        },
        render: function(e) {
            if (!this.visible)
                return;
            e.save(),
            this.transformMatrix && e.transform.apply(e, this.transformMatrix),
            this.transform(e),
            this._setShadow(e),
            this.clipTo && t.util.clipContext(this, e),
            e.translate(-this.width / 2, -this.height / 2);
            for (var n = 0, r = this.paths.length; n < r; ++n)
                this.paths[n].render(e, !0);
            this.clipTo && e.restore(),
            this._removeShadow(e),
            e.restore()
        },
        _set: function(e, t) {
            if (e === "fill" && t && this.isSameColor()) {
                var n = this.paths.length;
                while (n--)
                    this.paths[n]._set(e, t)
            }
            return this.callSuper("_set", e, t)
        },
        toObject: function(e) {
            var t = n(i.call(this, e), {
                paths: r(this.getObjects(), "toObject", e)
            });
            return this.sourcePath && (t.sourcePath = this.sourcePath),
            t
        },
        toDatalessObject: function(e) {
            var t = this.toObject(e);
            return this.sourcePath && (t.paths = this.sourcePath),
            t
        },
        toSVG: function(e) {
            var t = this.getObjects()
              , n = this.getPointByOrigin("left", "top")
              , r = "translate(" + n.x + " " + n.y + ")"
              , i = ["<g ", 'style="', this.getSvgStyles(), '" ', 'transform="', this.getSvgTransformMatrix(), r, this.getSvgTransform(), '" ', ">\n"];
            for (var s = 0, o = t.length; s < o; s++)
                i.push(t[s].toSVG(e));
            return i.push("</g>\n"),
            e ? e(i.join("")) : i.join("")
        },
        toString: function() {
            return "#<fabric.PathGroup (" + this.complexity() + "): { top: " + this.top + ", left: " + this.left + " }>"
        },
        isSameColor: function() {
            var e = (this.getObjects()[0].get("fill") || "").toLowerCase();
            return this.getObjects().every(function(t) {
                return (t.get("fill") || "").toLowerCase() === e
            })
        },
        complexity: function() {
            return this.paths.reduce(function(e, t) {
                return e + (t && t.complexity ? t.complexity() : 0)
            }, 0)
        },
        getObjects: function() {
            return this.paths
        }
    }),
    t.PathGroup.fromObject = function(e, n) {
        typeof e.paths == "string" ? t.loadSVGFromURL(e.paths, function(r) {
            var i = e.paths;
            delete e.paths;
            var s = t.util.groupSVGElements(r, e, i);
            n(s)
        }) : t.util.enlivenObjects(e.paths, function(r) {
            delete e.paths,
            n(new t.PathGroup(r,e))
        })
    }
    ,
    t.PathGroup.async = !0
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend
      , r = t.util.array.min
      , i = t.util.array.max
      , s = t.util.array.invoke;
    if (t.Group)
        return;
    var o = {
        lockMovementX: !0,
        lockMovementY: !0,
        lockRotation: !0,
        lockScalingX: !0,
        lockScalingY: !0,
        lockUniScaling: !0
    };
    t.Group = t.util.createClass(t.Object, t.Collection, {
        type: "group",
        initialize: function(e, t) {
            t = t || {},
            this._objects = e || [];
            for (var n = this._objects.length; n--; )
                this._objects[n].group = this;
            this.originalState = {},
            this.callSuper("initialize"),
            t.originX && (this.originX = t.originX),
            t.originY && (this.originY = t.originY),
            this._calcBounds(),
            this._updateObjectsCoords(),
            this.callSuper("initialize", t),
            this.setCoords(),
            this.saveCoords()
        },
        _updateObjectsCoords: function() {
            this.forEachObject(this._updateObjectCoords, this)
        },
        _updateObjectCoords: function(e) {
            var t = e.getLeft()
              , n = e.getTop()
              , r = this.getCenterPoint();
            e.set({
                originalLeft: t,
                originalTop: n,
                left: t - r.x,
                top: n - r.y
            }),
            e.setCoords(),
            e.__origHasControls = e.hasControls,
            e.hasControls = !1
        },
        toString: function() {
            return "#<fabric.Group: (" + this.complexity() + ")>"
        },
        addWithUpdate: function(e) {
            return this._restoreObjectsState(),
            e && (this._objects.push(e),
            e.group = this),
            this.forEachObject(this._setObjectActive, this),
            this._calcBounds(),
            this._updateObjectsCoords(),
            this
        },
        _setObjectActive: function(e) {
            e.set("active", !0),
            e.group = this
        },
        removeWithUpdate: function(e) {
            return this._moveFlippedObject(e),
            this._restoreObjectsState(),
            this.forEachObject(this._setObjectActive, this),
            this.remove(e),
            this._calcBounds(),
            this._updateObjectsCoords(),
            this
        },
        _onObjectAdded: function(e) {
            e.group = this
        },
        _onObjectRemoved: function(e) {
            delete e.group,
            e.set("active", !1)
        },
        delegatedProperties: {
            fill: !0,
            opacity: !0,
            fontFamily: !0,
            fontWeight: !0,
            fontSize: !0,
            fontStyle: !0,
            lineHeight: !0,
            textDecoration: !0,
            textAlign: !0,
            backgroundColor: !0
        },
        _set: function(e, t) {
            if (e in this.delegatedProperties) {
                var n = this._objects.length;
                while (n--)
                    this._objects[n].set(e, t)
            }
            this.callSuper("_set", e, t)
        },
        toObject: function(e) {
            return n(this.callSuper("toObject", e), {
                objects: s(this._objects, "toObject", e)
            })
        },
        render: function(e) {
            if (!this.visible)
                return;
            e.save(),
            this.clipTo && t.util.clipContext(this, e),
            this.transform(e);
            for (var n = 0, r = this._objects.length; n < r; n++)
                this._renderObject(this._objects[n], e);
            this.clipTo && e.restore(),
            e.restore()
        },
        _renderControls: function(e, t) {
            this.callSuper("_renderControls", e, t);
            for (var n = 0, r = this._objects.length; n < r; n++)
                this._objects[n]._renderControls(e)
        },
        _renderObject: function(e, t) {
            var n = e.hasRotatingPoint;
            if (!e.visible)
                return;
            e.hasRotatingPoint = !1,
            e.render(t),
            e.hasRotatingPoint = n
        },
        _restoreObjectsState: function() {
            return this._objects.forEach(this._restoreObjectState, this),
            this
        },
        realizeTransform: function(e) {
            return this._moveFlippedObject(e),
            this._setObjectPosition(e),
            e
        },
        _moveFlippedObject: function(e) {
            var t = e.get("originX")
              , n = e.get("originY")
              , r = e.getCenterPoint();
            e.set({
                originX: "center",
                originY: "center",
                left: r.x,
                top: r.y
            }),
            this._toggleFlipping(e);
            var i = e.getPointByOrigin(t, n);
            return e.set({
                originX: t,
                originY: n,
                left: i.x,
                top: i.y
            }),
            this
        },
        _toggleFlipping: function(e) {
            this.flipX && (e.toggle("flipX"),
            e.set("left", -e.get("left")),
            e.setAngle(-e.getAngle())),
            this.flipY && (e.toggle("flipY"),
            e.set("top", -e.get("top")),
            e.setAngle(-e.getAngle()))
        },
        _restoreObjectState: function(e) {
            return this._setObjectPosition(e),
            e.setCoords(),
            e.hasControls = e.__origHasControls,
            delete e.__origHasControls,
            e.set("active", !1),
            e.setCoords(),
            delete e.group,
            this
        },
        _setObjectPosition: function(e) {
            var t = this.getCenterPoint()
              , n = this._getRotatedLeftTop(e);
            e.set({
                angle: e.getAngle() + this.getAngle(),
                left: t.x + n.left,
                top: t.y + n.top,
                scaleX: e.get("scaleX") * this.get("scaleX"),
                scaleY: e.get("scaleY") * this.get("scaleY")
            })
        },
        _getRotatedLeftTop: function(e) {
            var t = this.getAngle() * (Math.PI / 180);
            return {
                left: -Math.sin(t) * e.getTop() * this.get("scaleY") + Math.cos(t) * e.getLeft() * this.get("scaleX"),
                top: Math.cos(t) * e.getTop() * this.get("scaleY") + Math.sin(t) * e.getLeft() * this.get("scaleX")
            }
        },
        destroy: function() {
            return this._objects.forEach(this._moveFlippedObject, this),
            this._restoreObjectsState()
        },
        saveCoords: function() {
            return this._originalLeft = this.get("left"),
            this._originalTop = this.get("top"),
            this
        },
        hasMoved: function() {
            return this._originalLeft !== this.get("left") || this._originalTop !== this.get("top")
        },
        setObjectsCoords: function() {
            return this.forEachObject(function(e) {
                e.setCoords()
            }),
            this
        },
        _calcBounds: function(e) {
            var t = [], n = [], r, i, s = ["tr", "br", "bl", "tl"];
            for (var o = 0, u = this._objects.length; o < u; ++o) {
                r = this._objects[o],
                r.setCoords();
                for (var a = 0; a < s.length; a++)
                    i = s[a],
                    t.push(r.oCoords[i].x),
                    n.push(r.oCoords[i].y)
            }
            this.set(this._getBounds(t, n, e))
        },
        _getBounds: function(e, n, s) {
            var o = t.util.invertTransform(this.getViewportTransform())
              , u = t.util.transformPoint(new t.Point(r(e),r(n)), o)
              , a = t.util.transformPoint(new t.Point(i(e),i(n)), o)
              , f = {
                width: a.x - u.x || 0,
                height: a.y - u.y || 0
            };
            return s || (f.left = u.x || 0,
            f.top = u.y || 0,
            this.originX === "center" && (f.left += f.width / 2),
            this.originX === "right" && (f.left += f.width),
            this.originY === "center" && (f.top += f.height / 2),
            this.originY === "bottom" && (f.top += f.height)),
            f
        },
        toSVG: function(e) {
            var t = ["<g ", 'transform="', this.getSvgTransform(), '">\n'];
            for (var n = 0, r = this._objects.length; n < r; n++)
                t.push(this._objects[n].toSVG(e));
            return t.push("</g>\n"),
            e ? e(t.join("")) : t.join("")
        },
        get: function(e) {
            if (e in o) {
                if (this[e])
                    return this[e];
                for (var t = 0, n = this._objects.length; t < n; t++)
                    if (this._objects[t][e])
                        return !0;
                return !1
            }
            return e in this.delegatedProperties ? this._objects[0] && this._objects[0].get(e) : this[e]
        }
    }),
    t.Group.fromObject = function(e, n) {
        t.util.enlivenObjects(e.objects, function(r) {
            delete e.objects,
            n && n(new t.Group(r,e))
        })
    }
    ,
    t.Group.async = !0
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = fabric.util.object.extend;
    e.fabric || (e.fabric = {});
    if (e.fabric.Image) {
        fabric.warn("fabric.Image is already defined.");
        return
    }
    fabric.Image = fabric.util.createClass(fabric.Object, {
        type: "image",
        crossOrigin: "",
        alignX: "none",
        alignY: "none",
        meetOrSlice: "meet",
        _lastScaleX: 1,
        _lastScaleY: 1,
        initialize: function(e, t) {
            t || (t = {}),
            this.filters = [],
            this.resizeFilters = [],
            this.callSuper("initialize", t),
            this._initElement(e, t),
            this._initConfig(t),
            t.filters && (this.filters = t.filters,
            this.applyFilters())
        },
        getElement: function() {
            return this._element
        },
        setElement: function(e, t, n) {
            return this._element = e,
            this._originalElement = e,
            this._initConfig(n),
            this.filters.length !== 0 ? this.applyFilters(t) : t && t(),
            this
        },
        setCrossOrigin: function(e) {
            return this.crossOrigin = e,
            this._element.crossOrigin = e,
            this
        },
        getOriginalSize: function() {
            var e = this.getElement();
            return {
                width: e.width,
                height: e.height
            }
        },
        _stroke: function(e) {
            e.save(),
            this._setStrokeStyles(e),
            e.beginPath(),
            e.strokeRect(-this.width / 2, -this.height / 2, this.width, this.height),
            e.closePath(),
            e.restore()
        },
        _renderDashedStroke: function(e) {
            var t = -this.width / 2
              , n = -this.height / 2
              , r = this.width
              , i = this.height;
            e.save(),
            this._setStrokeStyles(e),
            e.beginPath(),
            fabric.util.drawDashedLine(e, t, n, t + r, n, this.strokeDashArray),
            fabric.util.drawDashedLine(e, t + r, n, t + r, n + i, this.strokeDashArray),
            fabric.util.drawDashedLine(e, t + r, n + i, t, n + i, this.strokeDashArray),
            fabric.util.drawDashedLine(e, t, n + i, t, n, this.strokeDashArray),
            e.closePath(),
            e.restore()
        },
        toObject: function(e) {
            return t(this.callSuper("toObject", e), {
                src: this._originalElement.src || this._originalElement._src,
                filters: this.filters.map(function(e) {
                    return e && e.toObject()
                }),
                crossOrigin: this.crossOrigin,
                alignX: this.alignX,
                alignY: this.alignY,
                meetOrSlice: this.meetOrSlice
            })
        },
        toSVG: function(e) {
            var t = []
              , n = -this.width / 2
              , r = -this.height / 2
              , i = "none";
            this.group && this.group.type === "path-group" && (n = this.left,
            r = this.top),
            this.alignX !== "none" && this.alignY !== "none" && (i = "x" + this.alignX + "Y" + this.alignY + " " + this.meetOrSlice),
            t.push('<g transform="', this.getSvgTransform(), this.getSvgTransformMatrix(), '">\n', '<image xlink:href="', this.getSvgSrc(), '" x="', n, '" y="', r, '" style="', this.getSvgStyles(), '" width="', this.width, '" height="', this.height, '" preserveAspectRatio="', i, '"', "></image>\n");
            if (this.stroke || this.strokeDashArray) {
                var s = this.fill;
                this.fill = null,
                t.push("<rect ", 'x="', n, '" y="', r, '" width="', this.width, '" height="', this.height, '" style="', this.getSvgStyles(), '"/>\n'),
                this.fill = s
            }
            return t.push("</g>\n"),
            e ? e(t.join("")) : t.join("")
        },
        getSrc: function() {
            if (this.getElement())
                return this.getElement().src || this.getElement()._src
        },
        setSrc: function(e, t, n) {
            fabric.util.loadImage(e, function(e) {
                return this.setElement(e, t, n)
            }, this, n && n.crossOrigin)
        },
        toString: function() {
            return '#<fabric.Image: { src: "' + this.getSrc() + '" }>'
        },
        clone: function(e, t) {
            this.constructor.fromObject(this.toObject(t), e)
        },
        applyFilters: function(e, t, n, r) {
            t = t || this.filters,
            n = n || this._originalElement;
            if (!n)
                return;
            var i = n
              , s = fabric.util.createCanvasElement()
              , o = fabric.util.createImage()
              , u = this;
            return s.width = i.width,
            s.height = i.height,
            s.getContext("2d").drawImage(i, 0, 0, i.width, i.height),
            t.length === 0 ? (this._element = n,
            e && e(),
            s) : (t.forEach(function(e) {
                e && e.applyTo(s, e.scaleX || u.scaleX, e.scaleY || u.scaleY),
                !r && e && e.type === "Resize" && (u.width *= e.scaleX,
                u.height *= e.scaleY)
            }),
            o.width = s.width,
            o.height = s.height,
            fabric.isLikelyNode ? (o.src = s.toBuffer(undefined, fabric.Image.pngCompression),
            u._element = o,
            !r && (u._filteredEl = o),
            e && e()) : (o.onload = function() {
                u._element = o,
                !r && (u._filteredEl = o),
                e && e(),
                o.onload = s = i = null
            }
            ,
            o.src = s.toDataURL("image/png")),
            s)
        },
        _render: function(e, t) {
            var n, r, i = this._findMargins(), s;
            n = t ? this.left : -this.width / 2,
            r = t ? this.top : -this.height / 2,
            this.meetOrSlice === "slice" && (e.beginPath(),
            e.rect(n, r, this.width, this.height),
            e.clip()),
            this.isMoving === !1 && this.resizeFilters.length && this._needsResize() ? (this._lastScaleX = this.scaleX,
            this._lastScaleY = this.scaleY,
            s = this.applyFilters(null, this.resizeFilters, this._filteredEl || this._originalElement, !0)) : s = this._element,
            s && e.drawImage(s, n + i.marginX, r + i.marginY, i.width, i.height),
            this._renderStroke(e)
        },
        _needsResize: function() {
            return this.scaleX !== this._lastScaleX || this.scaleY !== this._lastScaleY
        },
        _findMargins: function() {
            var e = this.width, t = this.height, n, r, i = 0, s = 0;
            if (this.alignX !== "none" || this.alignY !== "none")
                n = [this.width / this._element.width, this.height / this._element.height],
                r = this.meetOrSlice === "meet" ? Math.min.apply(null, n) : Math.max.apply(null, n),
                e = this._element.width * r,
                t = this._element.height * r,
                this.alignX === "Mid" && (i = (this.width - e) / 2),
                this.alignX === "Max" && (i = this.width - e),
                this.alignY === "Mid" && (s = (this.height - t) / 2),
                this.alignY === "Max" && (s = this.height - t);
            return {
                width: e,
                height: t,
                marginX: i,
                marginY: s
            }
        },
        _resetWidthHeight: function() {
            var e = this.getElement();
            this.set("width", e.width),
            this.set("height", e.height)
        },
        _initElement: function(e) {
            this.setElement(fabric.util.getById(e)),
            fabric.util.addClass(this.getElement(), fabric.Image.CSS_CANVAS)
        },
        _initConfig: function(e) {
            e || (e = {}),
            this.setOptions(e),
            this._setWidthHeight(e),
            this._element && this.crossOrigin && (this._element.crossOrigin = this.crossOrigin)
        },
        _initFilters: function(e, t) {
            e.filters && e.filters.length ? fabric.util.enlivenObjects(e.filters, function(e) {
                t && t(e)
            }, "fabric.Image.filters") : t && t()
        },
        _setWidthHeight: function(e) {
            this.width = "width"in e ? e.width : this.getElement() ? this.getElement().width || 0 : 0,
            this.height = "height"in e ? e.height : this.getElement() ? this.getElement().height || 0 : 0
        },
        complexity: function() {
            return 1
        }
    }),
    fabric.Image.CSS_CANVAS = "canvas-img",
    fabric.Image.prototype.getSvgSrc = fabric.Image.prototype.getSrc,
    fabric.Image.fromObject = function(e, t) {
        fabric.util.loadImage(e.src, function(n) {
            fabric.Image.prototype._initFilters.call(e, e, function(r) {
                e.filters = r || [];
                var i = new fabric.Image(n,e);
                t && t(i)
            })
        }, null, e.crossOrigin)
    }
    ,
    fabric.Image.fromURL = function(e, t, n) {
        fabric.util.loadImage(e, function(e) {
            t && t(new fabric.Image(e,n))
        }, null, n && n.crossOrigin)
    }
    ,
    fabric.Image.ATTRIBUTE_NAMES = fabric.SHARED_ATTRIBUTES.concat("x y width height preserveAspectRatio xlink:href".split(" ")),
    fabric.Image.fromElement = function(e, n, r) {
        var i = fabric.parseAttributes(e, fabric.Image.ATTRIBUTE_NAMES), s = "xMidYMid", o = "meet", u, a, f;
        i.preserveAspectRatio && (f = i.preserveAspectRatio.split(" ")),
        f && f.length && (o = f.pop(),
        o !== "meet" && o !== "slice" ? (s = o,
        o = "meet") : f.length && (s = f.pop())),
        u = s !== "none" ? s.slice(1, 4) : "none",
        a = s !== "none" ? s.slice(5, 8) : "none",
        i.alignX = u,
        i.alignY = a,
        i.meetOrSlice = o,
        fabric.Image.fromURL(i["xlink:href"], n, t(r ? fabric.util.object.clone(r) : {}, i))
    }
    ,
    fabric.Image.async = !0,
    fabric.Image.pngCompression = 1
}(typeof exports != "undefined" ? exports : this),
fabric.util.object.extend(fabric.Object.prototype, {
    _getAngleValueForStraighten: function() {
        var e = this.getAngle() % 360;
        return e > 0 ? Math.round((e - 1) / 90) * 90 : Math.round(e / 90) * 90
    },
    straighten: function() {
        return this.setAngle(this._getAngleValueForStraighten()),
        this
    },
    fxStraighten: function(e) {
        e = e || {};
        var t = function() {}
          , n = e.onComplete || t
          , r = e.onChange || t
          , i = this;
        return fabric.util.animate({
            startValue: this.get("angle"),
            endValue: this._getAngleValueForStraighten(),
            duration: this.FX_DURATION,
            onChange: function(e) {
                i.setAngle(e),
                r()
            },
            onComplete: function() {
                i.setCoords(),
                n()
            },
            onStart: function() {
                i.set("active", !1)
            }
        }),
        this
    }
}),
fabric.util.object.extend(fabric.StaticCanvas.prototype, {
    straightenObject: function(e) {
        return e.straighten(),
        this.renderAll(),
        this
    },
    fxStraightenObject: function(e) {
        return e.fxStraighten({
            onChange: this.renderAll.bind(this)
        }),
        this
    }
}),
fabric.Image.filters = fabric.Image.filters || {},
fabric.Image.filters.BaseFilter = fabric.util.createClass({
    type: "BaseFilter",
    initialize: function(e) {
        e && this.setOptions(e)
    },
    setOptions: function(e) {
        for (var t in e)
            this[t] = e[t]
    },
    toObject: function() {
        return {
            type: this.type
        }
    },
    toJSON: function() {
        return this.toObject()
    }
}),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend;
    t.Image.filters.Brightness = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "Brightness",
        initialize: function(e) {
            e = e || {},
            this.brightness = e.brightness || 0
        },
        applyTo: function(e) {
            var t = e.getContext("2d")
              , n = t.getImageData(0, 0, e.width, e.height)
              , r = n.data
              , i = this.brightness;
            for (var s = 0, o = r.length; s < o; s += 4)
                r[s] += i,
                r[s + 1] += i,
                r[s + 2] += i;
            t.putImageData(n, 0, 0)
        },
        toObject: function() {
            return n(this.callSuper("toObject"), {
                brightness: this.brightness
            })
        }
    }),
    t.Image.filters.Brightness.fromObject = function(e) {
        return new t.Image.filters.Brightness(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend;
    t.Image.filters.Convolute = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "Convolute",
        initialize: function(e) {
            e = e || {},
            this.opaque = e.opaque,
            this.matrix = e.matrix || [0, 0, 0, 0, 1, 0, 0, 0, 0];
            var n = t.util.createCanvasElement();
            this.tmpCtx = n.getContext("2d")
        },
        _createImageData: function(e, t) {
            return this.tmpCtx.createImageData(e, t)
        },
        applyTo: function(e) {
            var t = this.matrix
              , n = e.getContext("2d")
              , r = n.getImageData(0, 0, e.width, e.height)
              , i = Math.round(Math.sqrt(t.length))
              , s = Math.floor(i / 2)
              , o = r.data
              , u = r.width
              , a = r.height
              , f = u
              , l = a
              , c = this._createImageData(f, l)
              , h = c.data
              , p = this.opaque ? 1 : 0;
            for (var d = 0; d < l; d++)
                for (var v = 0; v < f; v++) {
                    var m = d
                      , g = v
                      , y = (d * f + v) * 4
                      , b = 0
                      , w = 0
                      , E = 0
                      , S = 0;
                    for (var x = 0; x < i; x++)
                        for (var T = 0; T < i; T++) {
                            var N = m + x - s
                              , C = g + T - s;
                            if (N < 0 || N > a || C < 0 || C > u)
                                continue;
                            var k = (N * u + C) * 4
                              , L = t[x * i + T];
                            b += o[k] * L,
                            w += o[k + 1] * L,
                            E += o[k + 2] * L,
                            S += o[k + 3] * L
                        }
                    h[y] = b,
                    h[y + 1] = w,
                    h[y + 2] = E,
                    h[y + 3] = S + p * (255 - S)
                }
            n.putImageData(c, 0, 0)
        },
        toObject: function() {
            return n(this.callSuper("toObject"), {
                opaque: this.opaque,
                matrix: this.matrix
            })
        }
    }),
    t.Image.filters.Convolute.fromObject = function(e) {
        return new t.Image.filters.Convolute(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend;
    t.Image.filters.GradientTransparency = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "GradientTransparency",
        initialize: function(e) {
            e = e || {},
            this.threshold = e.threshold || 100
        },
        applyTo: function(e) {
            var t = e.getContext("2d")
              , n = t.getImageData(0, 0, e.width, e.height)
              , r = n.data
              , i = this.threshold
              , s = r.length;
            for (var o = 0, u = r.length; o < u; o += 4)
                r[o + 3] = i + 255 * (s - o) / s;
            t.putImageData(n, 0, 0)
        },
        toObject: function() {
            return n(this.callSuper("toObject"), {
                threshold: this.threshold
            })
        }
    }),
    t.Image.filters.GradientTransparency.fromObject = function(e) {
        return new t.Image.filters.GradientTransparency(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {});
    t.Image.filters.Grayscale = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "Grayscale",
        applyTo: function(e) {
            var t = e.getContext("2d"), n = t.getImageData(0, 0, e.width, e.height), r = n.data, i = n.width * n.height * 4, s = 0, o;
            while (s < i)
                o = (r[s] + r[s + 1] + r[s + 2]) / 3,
                r[s] = o,
                r[s + 1] = o,
                r[s + 2] = o,
                s += 4;
            t.putImageData(n, 0, 0)
        }
    }),
    t.Image.filters.Grayscale.fromObject = function() {
        return new t.Image.filters.Grayscale
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {});
    t.Image.filters.Invert = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "Invert",
        applyTo: function(e) {
            var t = e.getContext("2d"), n = t.getImageData(0, 0, e.width, e.height), r = n.data, i = r.length, s;
            for (s = 0; s < i; s += 4)
                r[s] = 255 - r[s],
                r[s + 1] = 255 - r[s + 1],
                r[s + 2] = 255 - r[s + 2];
            t.putImageData(n, 0, 0)
        }
    }),
    t.Image.filters.Invert.fromObject = function() {
        return new t.Image.filters.Invert
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend;
    t.Image.filters.Mask = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "Mask",
        initialize: function(e) {
            e = e || {},
            this.mask = e.mask,
            this.channel = [0, 1, 2, 3].indexOf(e.channel) > -1 ? e.channel : 0
        },
        applyTo: function(e) {
            if (!this.mask)
                return;
            var n = e.getContext("2d"), r = n.getImageData(0, 0, e.width, e.height), i = r.data, s = this.mask.getElement(), o = t.util.createCanvasElement(), u = this.channel, a, f = r.width * r.height * 4;
            o.width = s.width,
            o.height = s.height,
            o.getContext("2d").drawImage(s, 0, 0, s.width, s.height);
            var l = o.getContext("2d").getImageData(0, 0, s.width, s.height)
              , c = l.data;
            for (a = 0; a < f; a += 4)
                i[a + 3] = c[a + u];
            n.putImageData(r, 0, 0)
        },
        toObject: function() {
            return n(this.callSuper("toObject"), {
                mask: this.mask.toObject(),
                channel: this.channel
            })
        }
    }),
    t.Image.filters.Mask.fromObject = function(e, n) {
        t.util.loadImage(e.mask.src, function(r) {
            e.mask = new t.Image(r,e.mask),
            n && n(new t.Image.filters.Mask(e))
        })
    }
    ,
    t.Image.filters.Mask.async = !0
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend;
    t.Image.filters.Noise = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "Noise",
        initialize: function(e) {
            e = e || {},
            this.noise = e.noise || 0
        },
        applyTo: function(e) {
            var t = e.getContext("2d"), n = t.getImageData(0, 0, e.width, e.height), r = n.data, i = this.noise, s;
            for (var o = 0, u = r.length; o < u; o += 4)
                s = (.5 - Math.random()) * i,
                r[o] += s,
                r[o + 1] += s,
                r[o + 2] += s;
            t.putImageData(n, 0, 0)
        },
        toObject: function() {
            return n(this.callSuper("toObject"), {
                noise: this.noise
            })
        }
    }),
    t.Image.filters.Noise.fromObject = function(e) {
        return new t.Image.filters.Noise(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend;
    t.Image.filters.Pixelate = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "Pixelate",
        initialize: function(e) {
            e = e || {},
            this.blocksize = e.blocksize || 4
        },
        applyTo: function(e) {
            var t = e.getContext("2d"), n = t.getImageData(0, 0, e.width, e.height), r = n.data, i = n.height, s = n.width, o, u, a, f, l, c, h;
            for (u = 0; u < i; u += this.blocksize)
                for (a = 0; a < s; a += this.blocksize) {
                    o = u * 4 * s + a * 4,
                    f = r[o],
                    l = r[o + 1],
                    c = r[o + 2],
                    h = r[o + 3];
                    for (var p = u, d = u + this.blocksize; p < d; p++)
                        for (var v = a, m = a + this.blocksize; v < m; v++)
                            o = p * 4 * s + v * 4,
                            r[o] = f,
                            r[o + 1] = l,
                            r[o + 2] = c,
                            r[o + 3] = h
                }
            t.putImageData(n, 0, 0)
        },
        toObject: function() {
            return n(this.callSuper("toObject"), {
                blocksize: this.blocksize
            })
        }
    }),
    t.Image.filters.Pixelate.fromObject = function(e) {
        return new t.Image.filters.Pixelate(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend;
    t.Image.filters.RemoveWhite = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "RemoveWhite",
        initialize: function(e) {
            e = e || {},
            this.threshold = e.threshold || 30,
            this.distance = e.distance || 20
        },
        applyTo: function(e) {
            var t = e.getContext("2d"), n = t.getImageData(0, 0, e.width, e.height), r = n.data, i = this.threshold, s = this.distance, o = 255 - i, u = Math.abs, a, f, l;
            for (var c = 0, h = r.length; c < h; c += 4)
                a = r[c],
                f = r[c + 1],
                l = r[c + 2],
                a > o && f > o && l > o && u(a - f) < s && u(a - l) < s && u(f - l) < s && (r[c + 3] = 1);
            t.putImageData(n, 0, 0)
        },
        toObject: function() {
            return n(this.callSuper("toObject"), {
                threshold: this.threshold,
                distance: this.distance
            })
        }
    }),
    t.Image.filters.RemoveWhite.fromObject = function(e) {
        return new t.Image.filters.RemoveWhite(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {});
    t.Image.filters.Sepia = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "Sepia",
        applyTo: function(e) {
            var t = e.getContext("2d"), n = t.getImageData(0, 0, e.width, e.height), r = n.data, i = r.length, s, o;
            for (s = 0; s < i; s += 4)
                o = .3 * r[s] + .59 * r[s + 1] + .11 * r[s + 2],
                r[s] = o + 100,
                r[s + 1] = o + 50,
                r[s + 2] = o + 255;
            t.putImageData(n, 0, 0)
        }
    }),
    t.Image.filters.Sepia.fromObject = function() {
        return new t.Image.filters.Sepia
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {});
    t.Image.filters.Sepia2 = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "Sepia2",
        applyTo: function(e) {
            var t = e.getContext("2d"), n = t.getImageData(0, 0, e.width, e.height), r = n.data, i = r.length, s, o, u, a;
            for (s = 0; s < i; s += 4)
                o = r[s],
                u = r[s + 1],
                a = r[s + 2],
                r[s] = (o * .393 + u * .769 + a * .189) / 1.351,
                r[s + 1] = (o * .349 + u * .686 + a * .168) / 1.203,
                r[s + 2] = (o * .272 + u * .534 + a * .131) / 2.14;
            t.putImageData(n, 0, 0)
        }
    }),
    t.Image.filters.Sepia2.fromObject = function() {
        return new t.Image.filters.Sepia2
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend;
    t.Image.filters.Tint = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "Tint",
        initialize: function(e) {
            e = e || {},
            this.color = e.color || "#000000",
            this.opacity = typeof e.opacity != "undefined" ? e.opacity : (new t.Color(this.color)).getAlpha()
        },
        applyTo: function(e) {
            var n = e.getContext("2d"), r = n.getImageData(0, 0, e.width, e.height), i = r.data, s = i.length, o, u, a, f, l, c, h, p, d;
            d = (new t.Color(this.color)).getSource(),
            u = d[0] * this.opacity,
            a = d[1] * this.opacity,
            f = d[2] * this.opacity,
            p = 1 - this.opacity;
            for (o = 0; o < s; o += 4)
                l = i[o],
                c = i[o + 1],
                h = i[o + 2],
                i[o] = u + l * p,
                i[o + 1] = a + c * p,
                i[o + 2] = f + h * p;
            n.putImageData(r, 0, 0)
        },
        toObject: function() {
            return n(this.callSuper("toObject"), {
                color: this.color,
                opacity: this.opacity
            })
        }
    }),
    t.Image.filters.Tint.fromObject = function(e) {
        return new t.Image.filters.Tint(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend;
    t.Image.filters.Multiply = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "Multiply",
        initialize: function(e) {
            e = e || {},
            this.color = e.color || "#000000"
        },
        applyTo: function(e) {
            var n = e.getContext("2d"), r = n.getImageData(0, 0, e.width, e.height), i = r.data, s = i.length, o, u;
            u = (new t.Color(this.color)).getSource();
            for (o = 0; o < s; o += 4)
                i[o] *= u[0] / 255,
                i[o + 1] *= u[1] / 255,
                i[o + 2] *= u[2] / 255;
            n.putImageData(r, 0, 0)
        },
        toObject: function() {
            return n(this.callSuper("toObject"), {
                color: this.color
            })
        }
    }),
    t.Image.filters.Multiply.fromObject = function(e) {
        return new t.Image.filters.Multiply(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric;
    t.Image.filters.Blend = t.util.createClass({
        type: "Blend",
        initialize: function(e) {
            e = e || {},
            this.color = e.color || "#000",
            this.image = e.image || !1,
            this.mode = e.mode || "multiply",
            this.alpha = e.alpha || 1
        },
        applyTo: function(e) {
            var n = e.getContext("2d"), r = n.getImageData(0, 0, e.width, e.height), i = r.data, s, o, u, a, f, l, c, h, p, d, v = !1;
            if (this.image) {
                v = !0;
                var m = t.util.createCanvasElement();
                m.width = this.image.width,
                m.height = this.image.height;
                var g = new t.StaticCanvas(m);
                g.add(this.image);
                var y = g.getContext("2d");
                d = y.getImageData(0, 0, g.width, g.height).data
            } else
                d = (new t.Color(this.color)).getSource(),
                s = d[0] * this.alpha,
                o = d[1] * this.alpha,
                u = d[2] * this.alpha;
            for (var b = 0, w = i.length; b < w; b += 4) {
                a = i[b],
                f = i[b + 1],
                l = i[b + 2],
                v && (s = d[b] * this.alpha,
                o = d[b + 1] * this.alpha,
                u = d[b + 2] * this.alpha);
                switch (this.mode) {
                case "multiply":
                    i[b] = a * s / 255,
                    i[b + 1] = f * o / 255,
                    i[b + 2] = l * u / 255;
                    break;
                case "screen":
                    i[b] = 1 - (1 - a) * (1 - s),
                    i[b + 1] = 1 - (1 - f) * (1 - o),
                    i[b + 2] = 1 - (1 - l) * (1 - u);
                    break;
                case "add":
                    i[b] = Math.min(255, a + s),
                    i[b + 1] = Math.min(255, f + o),
                    i[b + 2] = Math.min(255, l + u);
                    break;
                case "diff":
                case "difference":
                    i[b] = Math.abs(a - s),
                    i[b + 1] = Math.abs(f - o),
                    i[b + 2] = Math.abs(l - u);
                    break;
                case "subtract":
                    c = a - s,
                    h = f - o,
                    p = l - u,
                    i[b] = c < 0 ? 0 : c,
                    i[b + 1] = h < 0 ? 0 : h,
                    i[b + 2] = p < 0 ? 0 : p;
                    break;
                case "darken":
                    i[b] = Math.min(a, s),
                    i[b + 1] = Math.min(f, o),
                    i[b + 2] = Math.min(l, u);
                    break;
                case "lighten":
                    i[b] = Math.max(a, s),
                    i[b + 1] = Math.max(f, o),
                    i[b + 2] = Math.max(l, u)
                }
            }
            n.putImageData(r, 0, 0)
        },
        toObject: function() {
            return {
                color: this.color,
                image: this.image,
                mode: this.mode,
                alpha: this.alpha
            }
        }
    }),
    t.Image.filters.Blend.fromObject = function(e) {
        return new t.Image.filters.Blend(e)
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = Math.pow
      , r = Math.floor
      , i = Math.sqrt
      , s = Math.abs
      , o = Math.max
      , u = Math.round
      , a = Math.sin
      , f = Math.ceil;
    t.Image.filters.Resize = t.util.createClass(t.Image.filters.BaseFilter, {
        type: "Resize",
        resizeType: "hermite",
        scaleX: 0,
        scaleY: 0,
        lanczosLobes: 3,
        applyTo: function(e, t, n) {
            this.rcpScaleX = 1 / t,
            this.rcpScaleY = 1 / n;
            var r = e.width, i = e.height, s = u(r * t), o = u(i * n), a;
            this.resizeType === "sliceHack" && (a = this.sliceByTwo(e, r, i, s, o)),
            this.resizeType === "hermite" && (a = this.hermiteFastResize(e, r, i, s, o)),
            this.resizeType === "bilinear" && (a = this.bilinearFiltering(e, r, i, s, o)),
            this.resizeType === "lanczos" && (a = this.lanczosResize(e, r, i, s, o)),
            e.width = s,
            e.height = o,
            e.getContext("2d").putImageData(a, 0, 0)
        },
        sliceByTwo: function(e, n, i, s, u) {
            var a = e.getContext("2d"), f, l = .5, c = .5, h = 1, p = 1, d = !1, v = !1, m = n, g = i, y = t.util.createCanvasElement(), b = y.getContext("2d");
            s = r(s),
            u = r(u),
            y.width = o(s, n),
            y.height = o(u, i),
            s > n && (l = 2,
            h = -1),
            u > i && (c = 2,
            p = -1),
            f = a.getImageData(0, 0, n, i),
            e.width = o(s, n),
            e.height = o(u, i),
            a.putImageData(f, 0, 0);
            while (!d || !v)
                n = m,
                i = g,
                s * h < r(m * l * h) ? m = r(m * l) : (m = s,
                d = !0),
                u * p < r(g * c * p) ? g = r(g * c) : (g = u,
                v = !0),
                f = a.getImageData(0, 0, n, i),
                b.putImageData(f, 0, 0),
                a.clearRect(0, 0, m, g),
                a.drawImage(y, 0, 0, n, i, 0, 0, m, g);
            return a.getImageData(0, 0, s, u)
        },
        lanczosResize: function(e, t, o, u, l) {
            function c(e) {
                return function(t) {
                    if (t > e)
                        return 0;
                    t *= Math.PI;
                    if (s(t) < 1e-16)
                        return 1;
                    var n = t / e;
                    return a(t) * a(n) / t / n
                }
            }
            function h(e) {
                var a, f, c, p, d, L, A, O, M, _, D;
                C.x = (e + .5) * b,
                k.x = r(C.x);
                for (a = 0; a < l; a++) {
                    C.y = (a + .5) * w,
                    k.y = r(C.y),
                    d = 0,
                    L = 0,
                    A = 0,
                    O = 0,
                    M = 0;
                    for (f = k.x - x; f <= k.x + x; f++) {
                        if (f < 0 || f >= t)
                            continue;
                        _ = r(1e3 * s(f - C.x)),
                        N[_] || (N[_] = {});
                        for (var P = k.y - T; P <= k.y + T; P++) {
                            if (P < 0 || P >= o)
                                continue;
                            D = r(1e3 * s(P - C.y)),
                            N[_][D] || (N[_][D] = y(i(n(_ * E, 2) + n(D * S, 2)) / 1e3)),
                            c = N[_][D],
                            c > 0 && (p = (P * t + f) * 4,
                            d += c,
                            L += c * m[p],
                            A += c * m[p + 1],
                            O += c * m[p + 2],
                            M += c * m[p + 3])
                        }
                    }
                    p = (a * u + e) * 4,
                    g[p] = L / d,
                    g[p + 1] = A / d,
                    g[p + 2] = O / d,
                    g[p + 3] = M / d
                }
                return ++e < u ? h(e) : v
            }
            var p = e.getContext("2d")
              , d = p.getImageData(0, 0, t, o)
              , v = p.getImageData(0, 0, u, l)
              , m = d.data
              , g = v.data
              , y = c(this.lanczosLobes)
              , b = this.rcpScaleX
              , w = this.rcpScaleY
              , E = 2 / this.rcpScaleX
              , S = 2 / this.rcpScaleY
              , x = f(b * this.lanczosLobes / 2)
              , T = f(w * this.lanczosLobes / 2)
              , N = {}
              , C = {}
              , k = {};
            return h(0)
        },
        bilinearFiltering: function(e, t, n, i, s) {
            var o, u, a, f, l, c, h, p, d, v, m, g, y = 0, b, w = this.rcpScaleX, E = this.rcpScaleY, S = e.getContext("2d"), x = 4 * (t - 1), T = S.getImageData(0, 0, t, n), N = T.data, C = S.getImageData(0, 0, i, s), k = C.data;
            for (h = 0; h < s; h++)
                for (p = 0; p < i; p++) {
                    l = r(w * p),
                    c = r(E * h),
                    d = w * p - l,
                    v = E * h - c,
                    b = 4 * (c * t + l);
                    for (m = 0; m < 4; m++)
                        o = N[b + m],
                        u = N[b + 4 + m],
                        a = N[b + x + m],
                        f = N[b + x + 4 + m],
                        g = o * (1 - d) * (1 - v) + u * d * (1 - v) + a * v * (1 - d) + f * d * v,
                        k[y++] = g
                }
            return C
        },
        hermiteFastResize: function(e, t, n, o, u) {
            var a = this.rcpScaleX
              , l = this.rcpScaleY
              , c = f(a / 2)
              , h = f(l / 2)
              , p = e.getContext("2d")
              , d = p.getImageData(0, 0, t, n)
              , v = d.data
              , m = p.getImageData(0, 0, o, u)
              , g = m.data;
            for (var y = 0; y < u; y++)
                for (var b = 0; b < o; b++) {
                    var w = (b + y * o) * 4
                      , E = 0
                      , S = 0
                      , x = 0
                      , T = 0
                      , N = 0
                      , C = 0
                      , k = 0
                      , L = (y + .5) * l;
                    for (var A = r(y * l); A < (y + 1) * l; A++) {
                        var O = s(L - (A + .5)) / h
                          , M = (b + .5) * a
                          , _ = O * O;
                        for (var D = r(b * a); D < (b + 1) * a; D++) {
                            var P = s(M - (D + .5)) / c
                              , H = i(_ + P * P);
                            if (H > 1 && H < -1)
                                continue;
                            E = 2 * H * H * H - 3 * H * H + 1,
                            E > 0 && (P = 4 * (D + A * t),
                            k += E * v[P + 3],
                            x += E,
                            v[P + 3] < 255 && (E = E * v[P + 3] / 250),
                            T += E * v[P],
                            N += E * v[P + 1],
                            C += E * v[P + 2],
                            S += E)
                        }
                    }
                    g[w] = T / S,
                    g[w + 1] = N / S,
                    g[w + 2] = C / S,
                    g[w + 3] = k / x
                }
            return m
        },
        toObject: function() {
            return {
                type: this.type,
                scaleX: this.scaleX,
                scaley: this.scaleY,
                resizeType: this.resizeType,
                lanczosLobes: this.lanczosLobes
            }
        }
    }),
    t.Image.filters.Resize.fromObject = function() {
        return new t.Image.filters.Resize
    }
}(typeof exports != "undefined" ? exports : this),
function(e) {
    "use strict";
    var t = e.fabric || (e.fabric = {})
      , n = t.util.object.extend
      , r = t.util.object.clone
      , i = t.util.toFixed
      , s = t.StaticCanvas.supports("setLineDash");
    if (t.Text) {
        t.warn("fabric.Text is already defined");
        return
    }
    var o = t.Object.prototype.stateProperties.concat();
    o.push("fontFamily", "fontWeight", "fontSize", "text", "textDecoration", "textAlign", "fontStyle", "lineHeight", "textBackgroundColor"),
    t.Text = t.util.createClass(t.Object, {
        _dimensionAffectingProps: {
            fontSize: !0,
            fontWeight: !0,
            fontFamily: !0,
            fontStyle: !0,
            lineHeight: !0,
            stroke: !0,
            strokeWidth: !0,
            text: !0,
            textAlign: !0
        },
        _reNewline: /\r?\n/,
        type: "text",
        fontSize: 40,
        fontWeight: "normal",
        fontFamily: "Times New Roman",
        textDecoration: "",
        textAlign: "left",
        fontStyle: "",
        lineHeight: 1.16,
        textBackgroundColor: "",
        stateProperties: o,
        stroke: null,
        shadow: null,
        _fontSizeFraction: .25,
        _fontSizeMult: 1.13,
        initialize: function(e, t) {
            t = t || {},
            this.text = e,
            this.__skipDimension = !0,
            this.setOptions(t),
            this.__skipDimension = !1,
            this._initDimensions()
        },
        _initDimensions: function(e) {
            if (this.__skipDimension)
                return;
            e || (e = t.util.createCanvasElement().getContext("2d"),
            this._setTextStyles(e)),
            this._textLines = this.text.split(this._reNewline),
            this._clearCache();
            var n = this.textAlign;
            this.textAlign = "left",
            this.width = this._getTextWidth(e),
            this.textAlign = n,
            this.height = this._getTextHeight(e)
        },
        toString: function() {
            return "#<fabric.Text (" + this.complexity() + '): { "text": "' + this.text + '", "fontFamily": "' + this.fontFamily + '" }>'
        },
        _render: function(e) {
            this.clipTo && t.util.clipContext(this, e),
            this._renderTextBackground(e),
            this._renderText(e),
            this._renderTextDecoration(e),
            this.clipTo && e.restore()
        },
        _renderText: function(e) {
            e.save(),
            this._translateForTextAlign(e),
            this._setOpacity(e),
            this._setShadow(e),
            this._setupCompositeOperation(e),
            this._renderTextFill(e),
            this._renderTextStroke(e),
            this._restoreCompositeOperation(e),
            this._removeShadow(e),
            e.restore()
        },
        _translateForTextAlign: function(e) {
            this.textAlign !== "left" && this.textAlign !== "justify" && e.translate(this.textAlign === "center" ? this.width / 2 : this.width, 0)
        },
        _setTextStyles: function(e) {
            e.textBaseline = "alphabetic",
            this.skipTextAlign || (e.textAlign = this.textAlign),
            e.font = this._getFontDeclaration()
        },
        _getTextHeight: function() {
            return this._textLines.length * this._getHeightOfLine()
        },
        _getTextWidth: function(e) {
            var t = this._getLineWidth(e, 0);
            for (var n = 1, r = this._textLines.length; n < r; n++) {
                var i = this._getLineWidth(e, n);
                i > t && (t = i)
            }
            return t
        },
        _renderChars: function(e, t, n, r, i) {
            t[e](n, r, i)
        },
        _renderTextLine: function(e, t, n, r, i, s) {
            i -= this.fontSize * this._fontSizeFraction;
            if (this.textAlign !== "justify") {
                this._renderChars(e, t, n, r, i, s);
                return
            }
            var o = this._getLineWidth(t, s)
              , u = this.width;
            if (u >= o) {
                var a = n.split(/\s+/)
                  , f = this._getWidthOfWords(t, n, s)
                  , l = u - f
                  , c = a.length - 1
                  , h = l / c
                  , p = 0;
                for (var d = 0, v = a.length; d < v; d++)
                    this._renderChars(e, t, a[d], r + p, i, s),
                    p += t.measureText(a[d]).width + h
            } else
                this._renderChars(e, t, n, r, i, s)
        },
        _getWidthOfWords: function(e, t) {
            return e.measureText(t.replace(/\s+/g, "")).width
        },
        _getLeftOffset: function() {
            return -this.width / 2
        },
        _getTopOffset: function() {
            return -this.height / 2
        },
        _renderTextFill: function(e) {
            if (!this.fill && !this._skipFillStrokeCheck)
                return;
            var t = 0;
            for (var n = 0, r = this._textLines.length; n < r; n++) {
                var i = this._getHeightOfLine(e, n)
                  , s = i / this.lineHeight;
                this._renderTextLine("fillText", e, this._textLines[n], this._getLeftOffset(), this._getTopOffset() + t + s, n),
                t += i
            }
            this.shadow && !this.shadow.affectStroke && this._removeShadow(e)
        },
        _renderTextStroke: function(e) {
            if ((!this.stroke || this.strokeWidth === 0) && !this._skipFillStrokeCheck)
                return;
            var t = 0;
            e.save(),
            this.strokeDashArray && (1 & this.strokeDashArray.length && this.strokeDashArray.push.apply(this.strokeDashArray, this.strokeDashArray),
            s && e.setLineDash(this.strokeDashArray)),
            e.beginPath();
            for (var n = 0, r = this._textLines.length; n < r; n++) {
                var i = this._getHeightOfLine(e, n)
                  , o = i / this.lineHeight;
                this._renderTextLine("strokeText", e, this._textLines[n], this._getLeftOffset(), this._getTopOffset() + t + o, n),
                t += i
            }
            e.closePath(),
            e.restore()
        },
        _getHeightOfLine: function() {
            return this.fontSize * this._fontSizeMult * this.lineHeight
        },
        _renderTextBackground: function(e) {
            this._renderTextBoxBackground(e),
            this._renderTextLinesBackground(e)
        },
        _renderTextBoxBackground: function(e) {
            if (!this.backgroundColor)
                return;
            e.save(),
            e.fillStyle = this.backgroundColor,
            e.fillRect(this._getLeftOffset(), this._getTopOffset(), this.width, this.height),
            e.restore()
        },
        _renderTextLinesBackground: function(e) {
            var t = 0
              , n = this._getHeightOfLine();
            if (!this.textBackgroundColor)
                return;
            e.save(),
            e.fillStyle = this.textBackgroundColor;
            for (var r = 0, i = this._textLines.length; r < i; r++) {
                if (this._textLines[r] !== "") {
                    var s = this._getLineWidth(e, r)
                      , o = this._getLineLeftOffset(s);
                    e.fillRect(this._getLeftOffset() + o, this._getTopOffset() + t, s, this.fontSize * this._fontSizeMult)
                }
                t += n
            }
            e.restore()
        },
        _getLineLeftOffset: function(e) {
            return this.textAlign === "center" ? (this.width - e) / 2 : this.textAlign === "right" ? this.width - e : 0
        },
        _clearCache: function() {
            this.__lineWidths = [],
            this.__lineHeights = [],
            this.__lineOffsets = []
        },
        _shouldClearCache: function() {
            var e = !1;
            for (var t in this._dimensionAffectingProps)
                this["__" + t] !== this[t] && (this["__" + t] = this[t],
                e = !0);
            return e
        },
        _getLineWidth: function(e, t) {
            return this.__lineWidths[t] ? this.__lineWidths[t] : (this.__lineWidths[t] = e.measureText(this._textLines[t]).width,
            this.__lineWidths[t])
        },
        _renderTextDecoration: function(e) {
            function i(r) {
                var i, s = 0, o, u, a;
                for (i = 0,
                o = n._textLines.length; i < o; i++) {
                    var f = n._getLineWidth(e, i)
                      , l = n._getLineLeftOffset(f)
                      , c = n._getHeightOfLine(e, i);
                    for (u = 0,
                    a = r.length; u < a; u++)
                        e.fillRect(n._getLeftOffset() + l, s + (n._fontSizeMult - 1 + r[u]) * n.fontSize - t, f, n.fontSize / 15);
                    s += c
                }
            }
            if (!this.textDecoration)
                return;
            var t = this.height / 2
              , n = this
              , r = [];
            this.textDecoration.indexOf("underline") > -1 && r.push(.85),
            this.textDecoration.indexOf("line-through") > -1 && r.push(.43),
            this.textDecoration.indexOf("overline") > -1 && r.push(-0.12),
            r.length > 0 && i(r)
        },
        _getFontDeclaration: function() {
            return [t.isLikelyNode ? this.fontWeight : this.fontStyle, t.isLikelyNode ? this.fontStyle : this.fontWeight, this.fontSize + "px", t.isLikelyNode ? '"' + this.fontFamily + '"' : this.fontFamily].join(" ")
        },
        render: function(e, t) {
            if (!this.visible)
                return;
            e.save(),
            this._setTextStyles(e),
            this._shouldClearCache() && this._initDimensions(e),
            t || this.transform(e),
            this._setStrokeStyles(e),
            this._setFillStyles(e),
            this.transformMatrix && e.transform.apply(e, this.transformMatrix),
            this.group && this.group.type === "path-group" && e.translate(this.left, this.top),
            this._render(e),
            e.restore()
        },
        toObject: function(e) {
            var t = n(this.callSuper("toObject", e), {
                text: this.text,
                fontSize: this.fontSize,
                fontWeight: this.fontWeight,
                fontFamily: this.fontFamily,
                fontStyle: this.fontStyle,
                lineHeight: this.lineHeight,
                textDecoration: this.textDecoration,
                textAlign: this.textAlign,
                textBackgroundColor: this.textBackgroundColor
            });
            return this.includeDefaultValues || this._removeDefaultValues(t),
            t
        },
        toSVG: function(e) {
            var t = this._createBaseSVGMarkup()
              , n = this._getSVGLeftTopOffsets(this.ctx)
              , r = this._getSVGTextAndBg(n.textTop, n.textLeft);
            return this._wrapSVGTextAndBg(t, r),
            e ? e(t.join("")) : t.join("")
        },
        _getSVGLeftTopOffsets: function(e) {
            var t = this._getHeightOfLine(e, 0)
              , n = -this.width / 2
              , r = 0;
            return {
                textLeft: n + (this.group && this.group.type === "path-group" ? this.left : 0),
                textTop: r + (this.group && this.group.type === "path-group" ? -this.top : 0),
                lineTop: t
            }
        },
        _wrapSVGTextAndBg: function(e, t) {
            e.push('	<g transform="', this.getSvgTransform(), this.getSvgTransformMatrix(), '">\n', t.textBgRects.join(""), "		<text ", this.fontFamily ? 'font-family="' + this.fontFamily.replace(/"/g, "'") + '" ' : "", this.fontSize ? 'font-size="' + this.fontSize + '" ' : "", this.fontStyle ? 'font-style="' + this.fontStyle + '" ' : "", this.fontWeight ? 'font-weight="' + this.fontWeight + '" ' : "", this.textDecoration ? 'text-decoration="' + this.textDecoration + '" ' : "", 'style="', this.getSvgStyles(), '" >', t.textSpans.join(""), "</text>\n", "	</g>\n")
        },
        _getSVGTextAndBg: function(e, t) {
            var n = []
              , r = []
              , i = 0;
            this._setSVGBg(r);
            for (var s = 0, o = this._textLines.length; s < o; s++)
                this.textBackgroundColor && this._setSVGTextLineBg(r, s, t, e, i),
                this._setSVGTextLineText(s, n, i, t, e, r),
                i += this._getHeightOfLine(this.ctx, s);
            return {
                textSpans: n,
                textBgRects: r
            }
        },
        _setSVGTextLineText: function(e, n, r, s, o) {
            var u = this.fontSize * (this._fontSizeMult - this._fontSizeFraction) - o + r - this.height / 2;
            n.push('<tspan x="', i(s + this._getLineLeftOffset(this.__lineWidths[e]), 4), '" ', 'y="', i(u, 4), '" ', this._getFillAttributes(this.fill), ">", t.util.string.escapeXml(this._textLines[e]), "</tspan>")
        },
        _setSVGTextLineBg: function(e, t, n, r, s) {
            e.push("		<rect ", this._getFillAttributes(this.textBackgroundColor), ' x="', i(n + this._getLineLeftOffset(this.__lineWidths[t]), 4), '" y="', i(s - this.height / 2, 4), '" width="', i(this.__lineWidths[t], 4), '" height="', i(this._getHeightOfLine(this.ctx, t) / this.lineHeight, 4), '"></rect>\n')
        },
        _setSVGBg: function(e) {
            this.backgroundColor && e.push("		<rect ", this._getFillAttributes(this.backgroundColor), ' x="', i(-this.width / 2, 4), '" y="', i(-this.height / 2, 4), '" width="', i(this.width, 4), '" height="', i(this.height, 4), '"></rect>\n')
        },
        _getFillAttributes: function(e) {
            var n = e && typeof e == "string" ? new t.Color(e) : "";
            return !n || !n.getSource() || n.getAlpha() === 1 ? 'fill="' + e + '"' : 'opacity="' + n.getAlpha() + '" fill="' + n.setAlpha(1).toRgb() + '"'
        },
        _set: function(e, t) {
            this.callSuper("_set", e, t),
            e in this._dimensionAffectingProps && (this._initDimensions(),
            this.setCoords())
        },
        complexity: function() {
            return 1
        }
    }),
    t.Text.ATTRIBUTE_NAMES = t.SHARED_ATTRIBUTES.concat("x y dx dy font-family font-style font-weight font-size text-decoration text-anchor".split(" ")),
    t.Text.DEFAULT_SVG_FONT_SIZE = 16,
    t.Text.fromElement = function(e, n) {
        if (!e)
            return null;
        var r = t.parseAttributes(e, t.Text.ATTRIBUTE_NAMES);
        n = t.util.object.extend(n ? t.util.object.clone(n) : {}, r),
        n.top = n.top || 0,
        n.left = n.left || 0,
        "dx"in r && (n.left += r.dx),
        "dy"in r && (n.top += r.dy),
        "fontSize"in n || (n.fontSize = t.Text.DEFAULT_SVG_FONT_SIZE),
        n.originX || (n.originX = "left");
        var i = e.textContent.replace(/^\s+|\s+$|\n+/g, "").replace(/\s+/g, " ")
          , s = new t.Text(i,n)
          , o = 0;
        return s.originX === "left" && (o = s.getWidth() / 2),
        s.originX === "right" && (o = -s.getWidth() / 2),
        s.set({
            left: s.getLeft() + o,
            top: s.getTop() - s.getHeight() / 2 + s.fontSize * (.18 + s._fontSizeFraction)
        }),
        s
    }
    ,
    t.Text.fromObject = function(e) {
        return new t.Text(e.text,r(e))
    }
    ,
    t.util.createAccessors(t.Text)
}(typeof exports != "undefined" ? exports : this),
function() {
    var e = fabric.util.object.clone;
    fabric.IText = fabric.util.createClass(fabric.Text, fabric.Observable, {
        type: "i-text",
        selectionStart: 0,
        selectionEnd: 0,
        selectionColor: "rgba(17,119,255,0.3)",
        isEditing: !1,
        editable: !0,
        editingBorderColor: "rgba(102,153,255,0.25)",
        cursorWidth: 2,
        cursorColor: "#333",
        cursorDelay: 1e3,
        cursorDuration: 600,
        styles: null,
        caching: !0,
        _skipFillStrokeCheck: !1,
        _reSpace: /\s|\n/,
        _currentCursorOpacity: 0,
        _selectionDirection: null,
        _abortCursorAnimation: !1,
        _charWidthsCache: {},
        initialize: function(e, t) {
            this.styles = t ? t.styles || {} : {},
            this.callSuper("initialize", e, t),
            this.initBehavior()
        },
        _clearCache: function() {
            this.callSuper("_clearCache"),
            this.__maxFontHeights = [],
            this.__widthOfSpace = []
        },
        isEmptyStyles: function() {
            if (!this.styles)
                return !0;
            var e = this.styles;
            for (var t in e)
                for (var n in e[t])
                    for (var r in e[t][n])
                        return !1;
            return !0
        },
        setSelectionStart: function(e) {
            e = Math.max(e, 0),
            this.selectionStart !== e && (this.fire("selection:changed"),
            this.canvas && this.canvas.fire("text:selection:changed", {
                target: this
            }),
            this.selectionStart = e),
            this._updateTextarea()
        },
        setSelectionEnd: function(e) {
            e = Math.min(e, this.text.length),
            this.selectionEnd !== e && (this.fire("selection:changed"),
            this.canvas && this.canvas.fire("text:selection:changed", {
                target: this
            }),
            this.selectionEnd = e),
            this._updateTextarea()
        },
        getSelectionStyles: function(e, t) {
            if (arguments.length === 2) {
                var n = [];
                for (var r = e; r < t; r++)
                    n.push(this.getSelectionStyles(r));
                return n
            }
            var i = this.get2DCursorLocation(e);
            return this.styles[i.lineIndex] ? this.styles[i.lineIndex][i.charIndex] || {} : {}
        },
        setSelectionStyles: function(e) {
            if (this.selectionStart === this.selectionEnd)
                this._extendStyles(this.selectionStart, e);
            else
                for (var t = this.selectionStart; t < this.selectionEnd; t++)
                    this._extendStyles(t, e);
            return this._clearCache(),
            this
        },
        _extendStyles: function(e, t) {
            var n = this.get2DCursorLocation(e);
            this.styles[n.lineIndex] || (this.styles[n.lineIndex] = {}),
            this.styles[n.lineIndex][n.charIndex] || (this.styles[n.lineIndex][n.charIndex] = {}),
            fabric.util.object.extend(this.styles[n.lineIndex][n.charIndex], t)
        },
        _render: function(e) {
            this.callSuper("_render", e),
            this.ctx = e,
            this.isEditing && this.renderCursorOrSelection()
        },
        renderCursorOrSelection: function() {
            if (!this.active)
                return;
            var e = this.text.split(""), t, n;
            this.canvas.contextTop ? (n = this.canvas.contextTop,
            n.save(),
            n.transform.apply(n, this.canvas.viewportTransform),
            this.transform(n)) : (n = this.ctx,
            n.save()),
            this.selectionStart === this.selectionEnd ? (t = this._getCursorBoundaries(e, "cursor"),
            this.renderCursor(t, n)) : (t = this._getCursorBoundaries(e, "selection"),
            this.renderSelection(e, t, n)),
            n.restore()
        },
        get2DCursorLocation: function(e) {
            typeof e == "undefined" && (e = this.selectionStart);
            var t = this.text.slice(0, e)
              , n = t.split(this._reNewline);
            return {
                lineIndex: n.length - 1,
                charIndex: n[n.length - 1].length
            }
        },
        getCurrentCharStyle: function(e, t) {
            var n = this.styles[e] && this.styles[e][t === 0 ? 0 : t - 1];
            return {
                fontSize: n && n.fontSize || this.fontSize,
                fill: n && n.fill || this.fill,
                textBackgroundColor: n && n.textBackgroundColor || this.textBackgroundColor,
                textDecoration: n && n.textDecoration || this.textDecoration,
                fontFamily: n && n.fontFamily || this.fontFamily,
                fontWeight: n && n.fontWeight || this.fontWeight,
                fontStyle: n && n.fontStyle || this.fontStyle,
                stroke: n && n.stroke || this.stroke,
                strokeWidth: n && n.strokeWidth || this.strokeWidth
            }
        },
        getCurrentCharFontSize: function(e, t) {
            return this.styles[e] && this.styles[e][t === 0 ? 0 : t - 1] && this.styles[e][t === 0 ? 0 : t - 1].fontSize || this.fontSize
        },
        getCurrentCharColor: function(e, t) {
            return this.styles[e] && this.styles[e][t === 0 ? 0 : t - 1] && this.styles[e][t === 0 ? 0 : t - 1].fill || this.cursorColor
        },
        _getCursorBoundaries: function(e, t) {
            var n = Math.round(this._getLeftOffset())
              , r = this._getTopOffset()
              , i = this._getCursorBoundariesOffsets(e, t);
            return {
                left: n,
                top: r,
                leftOffset: i.left + i.lineLeft,
                topOffset: i.top
            }
        },
        _getCursorBoundariesOffsets: function(e, t) {
            var n = 0
              , r = 0
              , i = 0
              , s = 0
              , o = 0;
            for (var u = 0; u < this.selectionStart; u++)
                e[u] === "\n" ? (o = 0,
                s += this._getHeightOfLine(this.ctx, r),
                r++,
                i = 0) : (o += this._getWidthOfChar(this.ctx, e[u], r, i),
                i++),
                n = this._getCachedLineOffset(r);
            return t === "cursor" && (s += (1 - this._fontSizeFraction) * this._getHeightOfLine(this.ctx, r) / this.lineHeight - this.getCurrentCharFontSize(r, i) * (1 - this._fontSizeFraction)),
            {
                top: s,
                left: o,
                lineLeft: n
            }
        },
        _getCachedLineOffset: function(e) {
            var t = this._getLineWidth(this.ctx, e);
            return this.__lineOffsets[e] || (this.__lineOffsets[e] = this._getLineLeftOffset(t))
        },
        renderCursor: function(e, t) {
            var n = this.get2DCursorLocation()
              , r = n.lineIndex
              , i = n.charIndex
              , s = this.getCurrentCharFontSize(r, i)
              , o = r === 0 && i === 0 ? this._getCachedLineOffset(r) : e.leftOffset;
            t.fillStyle = this.getCurrentCharColor(r, i),
            t.globalAlpha = this.__isMousedown ? 1 : this._currentCursorOpacity,
            t.fillRect(e.left + o, e.top + e.topOffset, this.cursorWidth / this.scaleX, s)
        },
        renderSelection: function(e, t, n) {
            n.fillStyle = this.selectionColor;
            var r = this.get2DCursorLocation(this.selectionStart)
              , i = this.get2DCursorLocation(this.selectionEnd)
              , s = r.lineIndex
              , o = i.lineIndex;
            for (var u = s; u <= o; u++) {
                var a = this._getCachedLineOffset(u) || 0
                  , f = this._getHeightOfLine(this.ctx, u)
                  , l = 0
                  , c = this._textLines[u];
                if (u === s)
                    for (var h = 0, p = c.length; h < p; h++)
                        h >= r.charIndex && (u !== o || h < i.charIndex) && (l += this._getWidthOfChar(n, c[h], u, h)),
                        h < r.charIndex && (a += this._getWidthOfChar(n, c[h], u, h));
                else if (u > s && u < o)
                    l += this._getLineWidth(n, u) || 5;
                else if (u === o)
                    for (var d = 0, v = i.charIndex; d < v; d++)
                        l += this._getWidthOfChar(n, c[d], u, d);
                n.fillRect(t.left + a, t.top + t.topOffset, l, f),
                t.topOffset += f
            }
        },
        _renderChars: function(e, t, n, r, i, s) {
            if (this.isEmptyStyles())
                return this._renderCharsFast(e, t, n, r, i);
            this.skipTextAlign = !0,
            r -= this.textAlign === "center" ? this.width / 2 : this.textAlign === "right" ? this.width : 0;
            var o = this._getHeightOfLine(t, s), u = this._getCachedLineOffset(s), a = n.split(""), f, l = "";
            r += u || 0,
            t.save(),
            i -= o / this.lineHeight * this._fontSizeFraction;
            for (var c = 0, h = a.length; c <= h; c++) {
                f = f || this.getCurrentCharStyle(s, c);
                var p = this.getCurrentCharStyle(s, c + 1);
                if (this._hasStyleChanged(f, p) || c === h)
                    this._renderChar(e, t, s, c - 1, l, r, i, o),
                    l = "",
                    f = p;
                l += a[c]
            }
            t.restore()
        },
        _renderCharsFast: function(e, t, n, r, i) {
            this.skipTextAlign = !1,
            e === "fillText" && this.fill && this.callSuper("_renderChars", e, t, n, r, i),
            e === "strokeText" && (this.stroke && this.strokeWidth > 0 || this.skipFillStrokeCheck) && this.callSuper("_renderChars", e, t, n, r, i)
        },
        _renderChar: function(e, t, n, r, i, s, o, u) {
            var a, f, l, c = this._fontSizeFraction * u / this.lineHeight;
            if (this.styles && this.styles[n] && (a = this.styles[n][r])) {
                var h = a.stroke || this.stroke
                  , p = a.fill || this.fill;
                t.save(),
                f = this._applyCharStylesGetWidth(t, i, n, r, a),
                l = this._getHeightOfChar(t, i, n, r),
                p && t.fillText(i, s, o),
                h && t.strokeText(i, s, o),
                this._renderCharDecoration(t, a, s, o, c, f, l),
                t.restore(),
                t.translate(f, 0)
            } else
                e === "strokeText" && this.stroke && t[e](i, s, o),
                e === "fillText" && this.fill && t[e](i, s, o),
                f = this._applyCharStylesGetWidth(t, i, n, r),
                this._renderCharDecoration(t, null, s, o, c, f, this.fontSize),
                t.translate(t.measureText(i).width, 0)
        },
        _hasStyleChanged: function(e, t) {
            return e.fill !== t.fill || e.fontSize !== t.fontSize || e.textBackgroundColor !== t.textBackgroundColor || e.textDecoration !== t.textDecoration || e.fontFamily !== t.fontFamily || e.fontWeight !== t.fontWeight || e.fontStyle !== t.fontStyle || e.stroke !== t.stroke || e.strokeWidth !== t.strokeWidth
        },
        _renderCharDecoration: function(e, t, n, r, i, s, o) {
            var u = t ? t.textDecoration || this.textDecoration : this.textDecoration;
            if (!u)
                return;
            u.indexOf("underline") > -1 && e.fillRect(n, r + o / 10, s, o / 15),
            u.indexOf("line-through") > -1 && e.fillRect(n, r - o * (this._fontSizeFraction + this._fontSizeMult - 1) + o / 15, s, o / 15),
            u.indexOf("overline") > -1 && e.fillRect(n, r - (this._fontSizeMult - this._fontSizeFraction) * o, s, o / 15)
        },
        _renderTextLine: function(e, t, n, r, i, s) {
            this.isEmptyStyles() || (i += this.fontSize * (this._fontSizeFraction + .03)),
            this.callSuper("_renderTextLine", e, t, n, r, i, s)
        },
        _renderTextDecoration: function(e) {
            if (this.isEmptyStyles())
                return this.callSuper("_renderTextDecoration", e)
        },
        _renderTextLinesBackground: function(e) {
            if (!this.textBackgroundColor && !this.styles)
                return;
            e.save(),
            this.textBackgroundColor && (e.fillStyle = this.textBackgroundColor);
            var t = 0;
            for (var n = 0, r = this._textLines.length; n < r; n++) {
                var i = this._getHeightOfLine(e, n);
                if (this._textLines[n] === "") {
                    t += i;
                    continue
                }
                var s = this._getLineWidth(e, n)
                  , o = this._getCachedLineOffset(n);
                this.textBackgroundColor && (e.fillStyle = this.textBackgroundColor,
                e.fillRect(this._getLeftOffset() + o, this._getTopOffset() + t, s, i / this.lineHeight));
                if (this.styles[n])
                    for (var u = 0, a = this._textLines[n].length; u < a; u++)
                        if (this.styles[n] && this.styles[n][u] && this.styles[n][u].textBackgroundColor) {
                            var f = this._textLines[n][u];
                            e.fillStyle = this.styles[n][u].textBackgroundColor,
                            e.fillRect(this._getLeftOffset() + o + this._getWidthOfCharsAt(e, n, u), this._getTopOffset() + t, this._getWidthOfChar(e, f, n, u) + 1, i / this.lineHeight)
                        }
                t += i
            }
            e.restore()
        },
        _getCacheProp: function(e, t) {
            return e + t.fontFamily + t.fontSize + t.fontWeight + t.fontStyle + t.shadow
        },
        _applyCharStylesGetWidth: function(t, n, r, i, s) {
            var o = s || this.styles[r] && this.styles[r][i];
            o ? o = e(o) : o = {},
            this._applyFontStyles(o);
            var u = this._getCacheProp(n, o);
            if (this.isEmptyStyles() && this._charWidthsCache[u] && this.caching)
                return this._charWidthsCache[u];
            typeof o.shadow == "string" && (o.shadow = new fabric.Shadow(o.shadow));
            var a = o.fill || this.fill;
            return t.fillStyle = a.toLive ? a.toLive(t, this) : a,
            o.stroke && (t.strokeStyle = o.stroke && o.stroke.toLive ? o.stroke.toLive(t, this) : o.stroke),
            t.lineWidth = o.strokeWidth || this.strokeWidth,
            t.font = this._getFontDeclaration.call(o),
            this._setShadow.call(o, t),
            this.caching ? (this._charWidthsCache[u] || (this._charWidthsCache[u] = t.measureText(n).width),
            this._charWidthsCache[u]) : t.measureText(n).width
        },
        _applyFontStyles: function(e) {
            e.fontFamily || (e.fontFamily = this.fontFamily),
            e.fontSize || (e.fontSize = this.fontSize),
            e.fontWeight || (e.fontWeight = this.fontWeight),
            e.fontStyle || (e.fontStyle = this.fontStyle)
        },
        _getStyleDeclaration: function(t, n) {
            return this.styles[t] && this.styles[t][n] ? e(this.styles[t][n]) : {}
        },
        _getWidthOfChar: function(e, t, n, r) {
            if (this.textAlign === "justify" && /\s/.test(t))
                return this._getWidthOfSpace(e, n);
            var i = this._getStyleDeclaration(n, r);
            this._applyFontStyles(i);
            var s = this._getCacheProp(t, i);
            if (this._charWidthsCache[s] && this.caching)
                return this._charWidthsCache[s];
            if (e) {
                e.save();
                var o = this._applyCharStylesGetWidth(e, t, n, r);
                return e.restore(),
                o
            }
        },
        _getHeightOfChar: function(e, t, n, r) {
            return this.styles[n] && this.styles[n][r] ? this.styles[n][r].fontSize || this.fontSize : this.fontSize
        },
        _getHeightOfCharAt: function(e, t, n) {
            var r = this._textLines[t][n];
            return this._getHeightOfChar(e, r, t, n)
        },
        _getWidthOfCharsAt: function(e, t, n) {
            var r = 0, i, s;
            for (i = 0; i < n; i++)
                s = this._textLines[t][i],
                r += this._getWidthOfChar(e, s, t, i);
            return r
        },
        _getLineWidth: function(e, t) {
            return this.__lineWidths[t] ? this.__lineWidths[t] : (this.__lineWidths[t] = this._getWidthOfCharsAt(e, t, this._textLines[t].length),
            this.__lineWidths[t])
        },
        _getWidthOfSpace: function(e, t) {
            if (this.__widthOfSpace[t])
                return this.__widthOfSpace[t];
            var n = this._textLines[t]
              , r = this._getWidthOfWords(e, n, t)
              , i = this.width - r
              , s = n.length - n.replace(/\s+/g, "").length
              , o = i / s;
            return this.__widthOfSpace[t] = o,
            o
        },
        _getWidthOfWords: function(e, t, n) {
            var r = 0;
            for (var i = 0; i < t.length; i++) {
                var s = t[i];
                s.match(/\s/) || (r += this._getWidthOfChar(e, s, n, i))
            }
            return r
        },
        _getHeightOfLine: function(e, t) {
            if (this.__lineHeights[t])
                return this.__lineHeights[t];
            var n = this._textLines[t]
              , r = this._getHeightOfChar(e, n[0], t, 0);
            for (var i = 1, s = n.length; i < s; i++) {
                var o = this._getHeightOfChar(e, n[i], t, i);
                o > r && (r = o)
            }
            return this.__maxFontHeights[t] = r,
            this.__lineHeights[t] = r * this.lineHeight * this._fontSizeMult,
            this.__lineHeights[t]
        },
        _getTextHeight: function(e) {
            var t = 0;
            for (var n = 0, r = this._textLines.length; n < r; n++)
                t += this._getHeightOfLine(e, n);
            return t
        },
        _renderTextBoxBackground: function(e) {
            if (!this.backgroundColor)
                return;
            e.save(),
            e.fillStyle = this.backgroundColor,
            e.fillRect(this._getLeftOffset(), this._getTopOffset(), this.width, this.height),
            e.restore()
        },
        toObject: function(t) {
            return fabric.util.object.extend(this.callSuper("toObject", t), {
                styles: e(this.styles)
            })
        }
    }),
    fabric.IText.fromObject = function(t) {
        return new fabric.IText(t.text,e(t))
    }
}(),
function() {
    var e = fabric.util.object.clone;
    fabric.util.object.extend(fabric.IText.prototype, {
        initBehavior: function() {
            this.initAddedHandler(),
            this.initRemovedHandler(),
            this.initCursorSelectionHandlers(),
            this.initDoubleClickSimulation()
        },
        initSelectedHandler: function() {
            this.on("selected", function() {
                var e = this;
                setTimeout(function() {
                    e.selected = !0
                }, 100)
            })
        },
        initAddedHandler: function() {
            var e = this;
            this.on("added", function() {
                this.canvas && !this.canvas._hasITextHandlers && (this.canvas._hasITextHandlers = !0,
                this._initCanvasHandlers()),
                e.canvas && (e.canvas._iTextInstances = e.canvas._iTextInstances || [],
                e.canvas._iTextInstances.push(e))
            })
        },
        initRemovedHandler: function() {
            var e = this;
            this.on("removed", function() {
                e.canvas && (e.canvas._iTextInstances = e.canvas._iTextInstances || [],
                fabric.util.removeFromArray(e.canvas._iTextInstances, e))
            })
        },
        _initCanvasHandlers: function() {
            var e = this;
            this.canvas.on("selection:cleared", function() {
                fabric.IText.prototype.exitEditingOnOthers(e.canvas)
            }),
            this.canvas.on("mouse:up", function() {
                e.canvas._iTextInstances && e.canvas._iTextInstances.forEach(function(e) {
                    e.__isMousedown = !1
                })
            }),
            this.canvas.on("object:selected", function() {
                fabric.IText.prototype.exitEditingOnOthers(e.canvas)
            })
        },
        _tick: function() {
            this._currentTickState = this._animateCursor(this, 1, this.cursorDuration, "_onTickComplete")
        },
        _animateCursor: function(e, t, n, r) {
            var i;
            return i = {
                isAborted: !1,
                abort: function() {
                    this.isAborted = !0
                }
            },
            e.animate("_currentCursorOpacity", t, {
                duration: n,
                onComplete: function() {
                    i.isAborted || e[r]()
                },
                onChange: function() {
                    e.canvas && (e.canvas.clearContext(e.canvas.contextTop || e.ctx),
                    e.renderCursorOrSelection())
                },
                abort: function() {
                    return i.isAborted
                }
            }),
            i
        },
        _onTickComplete: function() {
            var e = this;
            this._cursorTimeout1 && clearTimeout(this._cursorTimeout1),
            this._cursorTimeout1 = setTimeout(function() {
                e._currentTickCompleteState = e._animateCursor(e, 0, this.cursorDuration / 2, "_tick")
            }, 100)
        },
        initDelayedCursor: function(e) {
            var t = this
              , n = e ? 0 : this.cursorDelay;
            this._currentTickState && this._currentTickState.abort(),
            this._currentTickCompleteState && this._currentTickCompleteState.abort(),
            clearTimeout(this._cursorTimeout1),
            this._currentCursorOpacity = 1,
            this.canvas && (this.canvas.clearContext(this.canvas.contextTop || this.ctx),
            this.renderCursorOrSelection()),
            this._cursorTimeout2 && clearTimeout(this._cursorTimeout2),
            this._cursorTimeout2 = setTimeout(function() {
                t._tick()
            }, n)
        },
        abortCursorAnimation: function() {
            this._currentTickState && this._currentTickState.abort(),
            this._currentTickCompleteState && this._currentTickCompleteState.abort(),
            clearTimeout(this._cursorTimeout1),
            clearTimeout(this._cursorTimeout2),
            this._currentCursorOpacity = 0,
            this.canvas && this.canvas.clearContext(this.canvas.contextTop || this.ctx)
        },
        selectAll: function() {
            this.setSelectionStart(0),
            this.setSelectionEnd(this.text.length)
        },
        getSelectedText: function() {
            return this.text.slice(this.selectionStart, this.selectionEnd)
        },
        findWordBoundaryLeft: function(e) {
            var t = 0
              , n = e - 1;
            if (this._reSpace.test(this.text.charAt(n)))
                while (this._reSpace.test(this.text.charAt(n)))
                    t++,
                    n--;
            while (/\S/.test(this.text.charAt(n)) && n > -1)
                t++,
                n--;
            return e - t
        },
        findWordBoundaryRight: function(e) {
            var t = 0
              , n = e;
            if (this._reSpace.test(this.text.charAt(n)))
                while (this._reSpace.test(this.text.charAt(n)))
                    t++,
                    n++;
            while (/\S/.test(this.text.charAt(n)) && n < this.text.length)
                t++,
                n++;
            return e + t
        },
        findLineBoundaryLeft: function(e) {
            var t = 0
              , n = e - 1;
            while (!/\n/.test(this.text.charAt(n)) && n > -1)
                t++,
                n--;
            return e - t
        },
        findLineBoundaryRight: function(e) {
            var t = 0
              , n = e;
            while (!/\n/.test(this.text.charAt(n)) && n < this.text.length)
                t++,
                n++;
            return e + t
        },
        getNumNewLinesInSelectedText: function() {
            var e = this.getSelectedText()
              , t = 0;
            for (var n = 0, r = e.split(""), i = r.length; n < i; n++)
                r[n] === "\n" && t++;
            return t
        },
        searchWordBoundary: function(e, t) {
            var n = this._reSpace.test(this.text.charAt(e)) ? e - 1 : e
              , r = this.text.charAt(n)
              , i = /[ \n\.,;!\?\-]/;
            while (!i.test(r) && n > 0 && n < this.text.length)
                n += t,
                r = this.text.charAt(n);
            return i.test(r) && r !== "\n" && (n += t === 1 ? 0 : 1),
            n
        },
        selectWord: function(e) {
            var t = this.searchWordBoundary(e, -1)
              , n = this.searchWordBoundary(e, 1);
            this.setSelectionStart(t),
            this.setSelectionEnd(n)
        },
        selectLine: function(e) {
            var t = this.findLineBoundaryLeft(e)
              , n = this.findLineBoundaryRight(e);
            this.setSelectionStart(t),
            this.setSelectionEnd(n)
        },
        enterEditing: function() {
            if (this.isEditing || !this.editable)
                return;
            return this.canvas && this.exitEditingOnOthers(this.canvas),
            this.isEditing = !0,
            this.initHiddenTextarea(),
            this.hiddenTextarea.focus(),
            this._updateTextarea(),
            this._saveEditingProps(),
            this._setEditingProps(),
            this._tick(),
            this.fire("editing:entered"),
            this.canvas ? (this.canvas.renderAll(),
            this.canvas.fire("text:editing:entered", {
                target: this
            }),
            this.initMouseMoveHandler(),
            this) : this
        },
        exitEditingOnOthers: function(e) {
            e._iTextInstances && e._iTextInstances.forEach(function(e) {
                e.selected = !1,
                e.isEditing && e.exitEditing()
            })
        },
        initMouseMoveHandler: function() {
            var e = this;
            this.canvas.on("mouse:move", function(t) {
                if (!e.__isMousedown || !e.isEditing)
                    return;
                var n = e.getSelectionStartFromPointer(t.e);
                n >= e.__selectionStartOnMouseDown ? (e.setSelectionStart(e.__selectionStartOnMouseDown),
                e.setSelectionEnd(n)) : (e.setSelectionStart(n),
                e.setSelectionEnd(e.__selectionStartOnMouseDown))
            })
        },
        _setEditingProps: function() {
            this.hoverCursor = "text",
            this.canvas && (this.canvas.defaultCursor = this.canvas.moveCursor = "text"),
            this.borderColor = this.editingBorderColor,
            this.hasControls = this.selectable = !1,
            this.lockMovementX = this.lockMovementY = !0
        },
        _updateTextarea: function() {
            if (!this.hiddenTextarea)
                return;
            this.hiddenTextarea.value = this.text,
            this.hiddenTextarea.selectionStart = this.selectionStart,
            this.hiddenTextarea.selectionEnd = this.selectionEnd
        },
        _saveEditingProps: function() {
            this._savedProps = {
                hasControls: this.hasControls,
                borderColor: this.borderColor,
                lockMovementX: this.lockMovementX,
                lockMovementY: this.lockMovementY,
                hoverCursor: this.hoverCursor,
                defaultCursor: this.canvas && this.canvas.defaultCursor,
                moveCursor: this.canvas && this.canvas.moveCursor
            }
        },
        _restoreEditingProps: function() {
            if (!this._savedProps)
                return;
            this.hoverCursor = this._savedProps.overCursor,
            this.hasControls = this._savedProps.hasControls,
            this.borderColor = this._savedProps.borderColor,
            this.lockMovementX = this._savedProps.lockMovementX,
            this.lockMovementY = this._savedProps.lockMovementY,
            this.canvas && (this.canvas.defaultCursor = this._savedProps.defaultCursor,
            this.canvas.moveCursor = this._savedProps.moveCursor)
        },
        exitEditing: function() {
            return this.selected = !1,
            this.isEditing = !1,
            this.selectable = !0,
            this.selectionEnd = this.selectionStart,
            this.hiddenTextarea && this.canvas && this.hiddenTextarea.parentNode.removeChild(this.hiddenTextarea),
            this.hiddenTextarea = null,
            this.abortCursorAnimation(),
            this._restoreEditingProps(),
            this._currentCursorOpacity = 0,
            this.fire("editing:exited"),
            this.canvas && this.canvas.fire("text:editing:exited", {
                target: this
            }),
            this
        },
        _removeExtraneousStyles: function() {
            for (var e in this.styles)
                this._textLines[e] || delete this.styles[e]
        },
        _removeCharsFromTo: function(e, t) {
            var n = t;
            while (n !== e) {
                var r = this.get2DCursorLocation(n).charIndex;
                n--;
                var i = this.get2DCursorLocation(n).charIndex
                  , s = i > r;
                s ? this.removeStyleObject(s, n + 1) : this.removeStyleObject(this.get2DCursorLocation(n).charIndex === 0, n)
            }
            this.text = this.text.slice(0, e) + this.text.slice(t),
            this._clearCache()
        },
        insertChars: function(e, t) {
            var n = this.text.slice(this.selectionStart, this.selectionStart + 1) === "\n";
            this.text = this.text.slice(0, this.selectionStart) + e + this.text.slice(this.selectionEnd),
            this.selectionStart === this.selectionEnd && this.insertStyleObjects(e, n, t),
            this.setSelectionStart(this.selectionStart + e.length),
            this.setSelectionEnd(this.selectionStart),
            this._clearCache(),
            this.canvas && this.canvas.renderAll(),
            this.setCoords(),
            this.fire("changed"),
            this.canvas && this.canvas.fire("text:changed", {
                target: this
            })
        },
        insertNewlineStyleObject: function(t, n, r) {
            this.shiftLineStyles(t, 1),
            this.styles[t + 1] || (this.styles[t + 1] = {});
            var i = this.styles[t][n - 1]
              , s = {};
            if (r)
                s[0] = e(i),
                this.styles[t + 1] = s;
            else {
                for (var o in this.styles[t])
                    parseInt(o, 10) >= n && (s[parseInt(o, 10) - n] = this.styles[t][o],
                    delete this.styles[t][o]);
                this.styles[t + 1] = s
            }
            this._clearCache()
        },
        insertCharStyleObject: function(t, n, r) {
            var i = this.styles[t]
              , s = e(i);
            n === 0 && !r && (n = 1);
            for (var o in s) {
                var u = parseInt(o, 10);
                u >= n && (i[u + 1] = s[u])
            }
            this.styles[t][n] = r || e(i[n - 1]),
            this._clearCache()
        },
        insertStyleObjects: function(e, t, n) {
            var r = this.get2DCursorLocation()
              , i = r.lineIndex
              , s = r.charIndex;
            this.styles[i] || (this.styles[i] = {}),
            e === "\n" ? this.insertNewlineStyleObject(i, s, t) : n ? this._insertStyles(this.copiedStyles) : this.insertCharStyleObject(i, s)
        },
        _insertStyles: function(e) {
            for (var t = 0, n = e.length; t < n; t++) {
                var r = this.get2DCursorLocation(this.selectionStart + t)
                  , i = r.lineIndex
                  , s = r.charIndex;
                this.insertCharStyleObject(i, s, e[t])
            }
        },
        shiftLineStyles: function(t, n) {
            var r = e(this.styles);
            for (var i in this.styles) {
                var s = parseInt(i, 10);
                s > t && (this.styles[s + n] = r[s])
            }
        },
        removeStyleObject: function(t, n) {
            var r = this.get2DCursorLocation(n)
              , i = r.lineIndex
              , s = r.charIndex;
            if (t) {
                var o = this._textLines[i - 1]
                  , u = o ? o.length : 0;
                this.styles[i - 1] || (this.styles[i - 1] = {});
                for (s in this.styles[i])
                    this.styles[i - 1][parseInt(s, 10) + u] = this.styles[i][s];
                this.shiftLineStyles(i, -1)
            } else {
                var a = this.styles[i];
                if (a) {
                    var f = this.selectionStart === this.selectionEnd ? -1 : 0;
                    delete a[s + f]
                }
                var l = e(a);
                for (var c in l) {
                    var h = parseInt(c, 10);
                    h >= s && h !== 0 && (a[h - 1] = l[h],
                    delete a[h])
                }
            }
        },
        insertNewline: function() {
            this.insertChars("\n")
        }
    })
}(),
fabric.util.object.extend(fabric.IText.prototype, {
    initDoubleClickSimulation: function() {
        this.__lastClickTime = +(new Date),
        this.__lastLastClickTime = +(new Date),
        this.__lastPointer = {},
        this.on("mousedown", this.onMouseDown.bind(this))
    },
    onMouseDown: function(e) {
        this.__newClickTime = +(new Date);
        var t = this.canvas.getPointer(e.e);
        this.isTripleClick(t) ? (this.fire("tripleclick", e),
        this._stopEvent(e.e)) : this.isDoubleClick(t) && (this.fire("dblclick", e),
        this._stopEvent(e.e)),
        this.__lastLastClickTime = this.__lastClickTime,
        this.__lastClickTime = this.__newClickTime,
        this.__lastPointer = t,
        this.__lastIsEditing = this.isEditing,
        this.__lastSelected = this.selected
    },
    isDoubleClick: function(e) {
        return this.__newClickTime - this.__lastClickTime < 500 && this.__lastPointer.x === e.x && this.__lastPointer.y === e.y && this.__lastIsEditing
    },
    isTripleClick: function(e) {
        return this.__newClickTime - this.__lastClickTime < 500 && this.__lastClickTime - this.__lastLastClickTime < 500 && this.__lastPointer.x === e.x && this.__lastPointer.y === e.y
    },
    _stopEvent: function(e) {
        e.preventDefault && e.preventDefault(),
        e.stopPropagation && e.stopPropagation()
    },
    initCursorSelectionHandlers: function() {
        this.initSelectedHandler(),
        this.initMousedownHandler(),
        this.initMouseupHandler(),
        this.initClicks()
    },
    initClicks: function() {
        this.on("dblclick", function(e) {
            this.selectWord(this.getSelectionStartFromPointer(e.e))
        }),
        this.on("tripleclick", function(e) {
            this.selectLine(this.getSelectionStartFromPointer(e.e))
        })
    },
    initMousedownHandler: function() {
        this.on("mousedown", function(e) {
            var t = this.canvas.getPointer(e.e);
            this.__mousedownX = t.x,
            this.__mousedownY = t.y,
            this.__isMousedown = !0,
            this.hiddenTextarea && this.canvas && this.canvas.wrapperEl.appendChild(this.hiddenTextarea),
            this.selected && this.setCursorByClick(e.e),
            this.isEditing && (this.__selectionStartOnMouseDown = this.selectionStart,
            this.initDelayedCursor(!0))
        })
    },
    _isObjectMoved: function(e) {
        var t = this.canvas.getPointer(e);
        return this.__mousedownX !== t.x || this.__mousedownY !== t.y
    },
    initMouseupHandler: function() {
        this.on("mouseup", function(e) {
            this.__isMousedown = !1;
            if (this._isObjectMoved(e.e))
                return;
            this.__lastSelected && (this.enterEditing(),
            this.initDelayedCursor(!0)),
            this.selected = !0
        })
    },
    setCursorByClick: function(e) {
        var t = this.getSelectionStartFromPointer(e);
        e.shiftKey ? t < this.selectionStart ? (this.setSelectionEnd(this.selectionStart),
        this.setSelectionStart(t)) : this.setSelectionEnd(t) : (this.setSelectionStart(t),
        this.setSelectionEnd(t))
    },
    _getLocalRotatedPointer: function(e) {
        var t = this.canvas.getPointer(e)
          , n = new fabric.Point(t.x,t.y)
          , r = new fabric.Point(this.left,this.top)
          , i = fabric.util.rotatePoint(n, r, fabric.util.degreesToRadians(-this.angle));
        return this.getLocalPointer(e, i)
    },
    getSelectionStartFromPointer: function(e) {
        var t = this._getLocalRotatedPointer(e), n = 0, r = 0, i = 0, s = 0, o, u;
        for (var a = 0, f = this._textLines.length; a < f; a++) {
            u = this._textLines[a].split(""),
            i += this._getHeightOfLine(this.ctx, a) * this.scaleY;
            var l = this._getLineWidth(this.ctx, a)
              , c = this._getLineLeftOffset(l);
            r = c * this.scaleX,
            this.flipX && (this._textLines[a] = u.reverse().join(""));
            for (var h = 0, p = u.length; h < p; h++) {
                var d = u[h];
                n = r,
                r += this._getWidthOfChar(this.ctx, d, a, this.flipX ? p - h : h) * this.scaleX;
                if (i <= t.y || r <= t.x) {
                    s++;
                    continue
                }
                return this._getNewSelectionStartFromOffset(t, n, r, s + a, p)
            }
            if (t.y < i)
                return this._getNewSelectionStartFromOffset(t, n, r, s + a, p)
        }
        if (typeof o == "undefined")
            return this.text.length
    },
    _getNewSelectionStartFromOffset: function(e, t, n, r, i) {
        var s = e.x - t
          , o = n - e.x
          , u = o > s ? 0 : 1
          , a = r + u;
        return this.flipX && (a = i - a),
        a > this.text.length && (a = this.text.length),
        a
    }
}),
fabric.util.object.extend(fabric.IText.prototype, {
    initHiddenTextarea: function() {
        this.hiddenTextarea = fabric.document.createElement("textarea"),
        this.hiddenTextarea.setAttribute("autocapitalize", "off"),
        this.hiddenTextarea.style.cssText = "position: fixed; bottom: 20px; left: 0px; opacity: 0; width: 0px; height: 0px; z-index: -999;",
        fabric.document.body.appendChild(this.hiddenTextarea),
        fabric.util.addListener(this.hiddenTextarea, "keydown", this.onKeyDown.bind(this)),
        fabric.util.addListener(this.hiddenTextarea, "keypress", this.onKeyPress.bind(this)),
        fabric.util.addListener(this.hiddenTextarea, "copy", this.copy.bind(this)),
        fabric.util.addListener(this.hiddenTextarea, "paste", this.paste.bind(this)),
        !this._clickHandlerInitialized && this.canvas && (fabric.util.addListener(this.canvas.upperCanvasEl, "click", this.onClick.bind(this)),
        this._clickHandlerInitialized = !0)
    },
    _keysMap: {
        8: "removeChars",
        9: "exitEditing",
        27: "exitEditing",
        13: "insertNewline",
        33: "moveCursorUp",
        34: "moveCursorDown",
        35: "moveCursorRight",
        36: "moveCursorLeft",
        37: "moveCursorLeft",
        38: "moveCursorUp",
        39: "moveCursorRight",
        40: "moveCursorDown",
        46: "forwardDelete"
    },
    _ctrlKeysMap: {
        65: "selectAll",
        88: "cut"
    },
    onClick: function() {
        this.hiddenTextarea && this.hiddenTextarea.focus()
    },
    onKeyDown: function(e) {
        if (!this.isEditing)
            return;
        if (e.keyCode in this._keysMap)
            this[this._keysMap[e.keyCode]](e);
        else {
            if (!(e.keyCode in this._ctrlKeysMap && (e.ctrlKey || e.metaKey)))
                return;
            this[this._ctrlKeysMap[e.keyCode]](e)
        }
        e.stopImmediatePropagation(),
        e.preventDefault(),
        this.canvas && this.canvas.renderAll()
    },
    forwardDelete: function(e) {
        this.selectionStart === this.selectionEnd && this.moveCursorRight(e),
        this.removeChars(e)
    },
    copy: function(e) {
        var t = this.getSelectedText()
          , n = this._getClipboardData(e);
        n && n.setData("text", t),
        this.copiedText = t,
        this.copiedStyles = this.getSelectionStyles(this.selectionStart, this.selectionEnd)
    },
    paste: function(e) {
        var t = null
          , n = this._getClipboardData(e);
        n ? t = n.getData("text") : t = this.copiedText,
        t && this.insertChars(t, !0)
    },
    cut: function(e) {
        if (this.selectionStart === this.selectionEnd)
            return;
        this.copy(),
        this.removeChars(e)
    },
    _getClipboardData: function(e) {
        return e && (e.clipboardData || fabric.window.clipboardData)
    },
    onKeyPress: function(e) {
        if (!this.isEditing || e.metaKey || e.ctrlKey)
            return;
        e.which !== 0 && this.insertChars(String.fromCharCode(e.which)),
        e.stopPropagation()
    },
    getDownCursorOffset: function(e, t) {
        var n = t ? this.selectionEnd : this.selectionStart, r, i, s = this.text.slice(0, n), o = this.text.slice(n), u = s.slice(s.lastIndexOf("\n") + 1), a = o.match(/(.*)\n?/)[1], f = (o.match(/.*\n(.*)\n?/) || {})[1] || "", l = this.get2DCursorLocation(n);
        if (l.lineIndex === this._textLines.length - 1 || e.metaKey || e.keyCode === 34)
            return this.text.length - n;
        var c = this._getLineWidth(this.ctx, l.lineIndex);
        i = this._getLineLeftOffset(c);
        var h = i
          , p = l.lineIndex;
        for (var d = 0, v = u.length; d < v; d++)
            r = u[d],
            h += this._getWidthOfChar(this.ctx, r, p, d);
        var m = this._getIndexOnNextLine(l, f, h);
        return a.length + 1 + m
    },
    _getIndexOnNextLine: function(e, t, n) {
        var r = e.lineIndex + 1, i = this._getLineWidth(this.ctx, r), s = this._getLineLeftOffset(i), o = s, u = 0, a;
        for (var f = 0, l = t.length; f < l; f++) {
            var c = t[f]
              , h = this._getWidthOfChar(this.ctx, c, r, f);
            o += h;
            if (o > n) {
                a = !0;
                var p = o - h
                  , d = o
                  , v = Math.abs(p - n)
                  , m = Math.abs(d - n);
                u = m < v ? f + 1 : f;
                break
            }
        }
        return a || (u = t.length),
        u
    },
    moveCursorDown: function(e) {
        this.abortCursorAnimation(),
        this._currentCursorOpacity = 1;
        var t = this.getDownCursorOffset(e, this._selectionDirection === "right");
        e.shiftKey ? this.moveCursorDownWithShift(t) : this.moveCursorDownWithoutShift(t),
        this.initDelayedCursor()
    },
    moveCursorDownWithoutShift: function(e) {
        this._selectionDirection = "right",
        this.setSelectionStart(this.selectionStart + e),
        this.setSelectionEnd(this.selectionStart)
    },
    swapSelectionPoints: function() {
        var e = this.selectionEnd;
        this.setSelectionEnd(this.selectionStart),
        this.setSelectionStart(e)
    },
    moveCursorDownWithShift: function(e) {
        this.selectionEnd === this.selectionStart && (this._selectionDirection = "right"),
        this._selectionDirection === "right" ? this.setSelectionEnd(this.selectionEnd + e) : this.setSelectionStart(this.selectionStart + e),
        this.selectionEnd < this.selectionStart && this._selectionDirection === "left" && (this.swapSelectionPoints(),
        this._selectionDirection = "right"),
        this.selectionEnd > this.text.length && this.setSelectionEnd(this.text.length)
    },
    getUpCursorOffset: function(e, t) {
        var n = t ? this.selectionEnd : this.selectionStart
          , r = this.get2DCursorLocation(n);
        if (r.lineIndex === 0 || e.metaKey || e.keyCode === 33)
            return n;
        var i = this.text.slice(0, n), s = i.slice(i.lastIndexOf("\n") + 1), o = (i.match(/\n?(.*)\n.*$/) || {})[1] || "", u, a = this._getLineWidth(this.ctx, r.lineIndex), f = this._getLineLeftOffset(a), l = f, c = r.lineIndex;
        for (var h = 0, p = s.length; h < p; h++)
            u = s[h],
            l += this._getWidthOfChar(this.ctx, u, c, h);
        var d = this._getIndexOnPrevLine(r, o, l);
        return o.length - d + s.length
    },
    _getIndexOnPrevLine: function(e, t, n) {
        var r = e.lineIndex - 1, i = this._getLineWidth(this.ctx, r), s = this._getLineLeftOffset(i), o = s, u = 0, a;
        for (var f = 0, l = t.length; f < l; f++) {
            var c = t[f]
              , h = this._getWidthOfChar(this.ctx, c, r, f);
            o += h;
            if (o > n) {
                a = !0;
                var p = o - h
                  , d = o
                  , v = Math.abs(p - n)
                  , m = Math.abs(d - n);
                u = m < v ? f : f - 1;
                break
            }
        }
        return a || (u = t.length - 1),
        u
    },
    moveCursorUp: function(e) {
        this.abortCursorAnimation(),
        this._currentCursorOpacity = 1;
        var t = this.getUpCursorOffset(e, this._selectionDirection === "right");
        e.shiftKey ? this.moveCursorUpWithShift(t) : this.moveCursorUpWithoutShift(t),
        this.initDelayedCursor()
    },
    moveCursorUpWithShift: function(e) {
        this.selectionEnd === this.selectionStart && (this._selectionDirection = "left"),
        this._selectionDirection === "right" ? this.setSelectionEnd(this.selectionEnd - e) : this.setSelectionStart(this.selectionStart - e),
        this.selectionEnd < this.selectionStart && this._selectionDirection === "right" && (this.swapSelectionPoints(),
        this._selectionDirection = "left")
    },
    moveCursorUpWithoutShift: function(e) {
        this.selectionStart === this.selectionEnd && this.setSelectionStart(this.selectionStart - e),
        this.setSelectionEnd(this.selectionStart),
        this._selectionDirection = "left"
    },
    moveCursorLeft: function(e) {
        if (this.selectionStart === 0 && this.selectionEnd === 0)
            return;
        this.abortCursorAnimation(),
        this._currentCursorOpacity = 1,
        e.shiftKey ? this.moveCursorLeftWithShift(e) : this.moveCursorLeftWithoutShift(e),
        this.initDelayedCursor()
    },
    _move: function(e, t, n) {
        var r = t === "selectionStart" ? "setSelectionStart" : "setSelectionEnd";
        e.altKey ? this[r](this["findWordBoundary" + n](this[t])) : e.metaKey || e.keyCode === 35 || e.keyCode === 36 ? this[r](this["findLineBoundary" + n](this[t])) : this[r](this[t] + (n === "Left" ? -1 : 1))
    },
    _moveLeft: function(e, t) {
        this._move(e, t, "Left")
    },
    _moveRight: function(e, t) {
        this._move(e, t, "Right")
    },
    moveCursorLeftWithoutShift: function(e) {
        this._selectionDirection = "left",
        this.selectionEnd === this.selectionStart && this._moveLeft(e, "selectionStart"),
        this.setSelectionEnd(this.selectionStart)
    },
    moveCursorLeftWithShift: function(e) {
        this._selectionDirection === "right" && this.selectionStart !== this.selectionEnd ? this._moveLeft(e, "selectionEnd") : (this._selectionDirection = "left",
        this._moveLeft(e, "selectionStart"),
        this.text.charAt(this.selectionStart) === "\n" && this.setSelectionStart(this.selectionStart - 1))
    },
    moveCursorRight: function(e) {
        if (this.selectionStart >= this.text.length && this.selectionEnd >= this.text.length)
            return;
        this.abortCursorAnimation(),
        this._currentCursorOpacity = 1,
        e.shiftKey ? this.moveCursorRightWithShift(e) : this.moveCursorRightWithoutShift(e),
        this.initDelayedCursor()
    },
    moveCursorRightWithShift: function(e) {
        this._selectionDirection === "left" && this.selectionStart !== this.selectionEnd ? this._moveRight(e, "selectionStart") : (this._selectionDirection = "right",
        this._moveRight(e, "selectionEnd"),
        this.text.charAt(this.selectionEnd - 1) === "\n" && this.setSelectionEnd(this.selectionEnd + 1))
    },
    moveCursorRightWithoutShift: function(e) {
        this._selectionDirection = "right",
        this.selectionStart === this.selectionEnd ? (this._moveRight(e, "selectionStart"),
        this.setSelectionEnd(this.selectionStart)) : (this.setSelectionEnd(this.selectionEnd + this.getNumNewLinesInSelectedText()),
        this.setSelectionStart(this.selectionEnd))
    },
    removeChars: function(e) {
        this.selectionStart === this.selectionEnd ? this._removeCharsNearCursor(e) : this._removeCharsFromTo(this.selectionStart, this.selectionEnd),
        this.setSelectionEnd(this.selectionStart),
        this._removeExtraneousStyles(),
        this._clearCache(),
        this.canvas && this.canvas.renderAll(),
        this.setCoords(),
        this.fire("changed"),
        this.canvas && this.canvas.fire("text:changed", {
            target: this
        })
    },
    _removeCharsNearCursor: function(e) {
        if (this.selectionStart !== 0)
            if (e.metaKey) {
                var t = this.findLineBoundaryLeft(this.selectionStart);
                this._removeCharsFromTo(t, this.selectionStart),
                this.setSelectionStart(t)
            } else if (e.altKey) {
                var n = this.findWordBoundaryLeft(this.selectionStart);
                this._removeCharsFromTo(n, this.selectionStart),
                this.setSelectionStart(n)
            } else {
                var r = this.text.slice(this.selectionStart - 1, this.selectionStart) === "\n";
                this.removeStyleObject(r),
                this.setSelectionStart(this.selectionStart - 1),
                this.text = this.text.slice(0, this.selectionStart) + this.text.slice(this.selectionStart + 1)
            }
    }
}),
fabric.util.object.extend(fabric.IText.prototype, {
    _setSVGTextLineText: function(e, t, n, r, i, s) {
        this.styles[e] ? this._setSVGTextLineChars(e, t, n, r, s) : this.callSuper("_setSVGTextLineText", e, t, n, r, i)
    },
    _setSVGTextLineChars: function(e, t, n, r, i) {
        var s = this._textLines[e].split("")
          , o = 0
          , u = this._getSVGLineLeftOffset(e) - this.width / 2
          , a = this._getSVGLineTopOffset(e)
          , f = this._getHeightOfLine(this.ctx, e);
        for (var l = 0, c = s.length; l < c; l++) {
            var h = this.styles[e][l] || {};
            t.push(this._createTextCharSpan(s[l], h, u, a.lineTop + a.offset, o));
            var p = this._getWidthOfChar(this.ctx, s[l], e, l);
            h.textBackgroundColor && i.push(this._createTextCharBg(h, u, a.lineTop, f, p, o)),
            o += p
        }
    },
    _getSVGLineLeftOffset: function(e) {
        return fabric.util.toFixed(this._getLineLeftOffset(this.__lineWidths[e]), 2)
    },
    _getSVGLineTopOffset: function(e) {
        var t = 0
          , n = 0;
        for (var r = 0; r < e; r++)
            t += this._getHeightOfLine(this.ctx, r);
        return n = this._getHeightOfLine(this.ctx, r),
        {
            lineTop: t,
            offset: (this._fontSizeMult - this._fontSizeFraction) * n / (this.lineHeight * this._fontSizeMult)
        }
    },
    _createTextCharBg: function(e, t, n, r, i, s) {
        return ['<rect fill="', e.textBackgroundColor, '" x="', t + s, '" y="', n - this.height / 2, '" width="', i, '" height="', r / this.lineHeight, '"></rect>'].join("")
    },
    _createTextCharSpan: function(e, t, n, r, i) {
        var s = this.getSvgStyles.call(fabric.util.object.extend({
            visible: !0,
            fill: this.fill,
            stroke: this.stroke,
            type: "text"
        }, t));
        return ['<tspan x="', n + i, '" y="', r - this.height / 2, '" ', t.fontFamily ? 'font-family="' + t.fontFamily.replace(/"/g, "'") + '" ' : "", t.fontSize ? 'font-size="' + t.fontSize + '" ' : "", t.fontStyle ? 'font-style="' + t.fontStyle + '" ' : "", t.fontWeight ? 'font-weight="' + t.fontWeight + '" ' : "", t.textDecoration ? 'text-decoration="' + t.textDecoration + '" ' : "", 'style="', s, '">', fabric.util.string.escapeXml(e), "</tspan>"].join("")
    }
}),
function() {
    function request(e, t, n) {
        var r = URL.parse(e);
        r.port || (r.port = r.protocol.indexOf("https:") === 0 ? 443 : 80);
        var i = r.protocol.indexOf("https:") === 0 ? HTTPS : HTTP
          , s = i.request({
            hostname: r.hostname,
            port: r.port,
            path: r.path,
            method: "GET"
        }, function(e) {
            var r = "";
            t && e.setEncoding(t),
            e.on("end", function() {
                n(r)
            }),
            e.on("data", function(t) {
                e.statusCode === 200 && (r += t)
            })
        });
        s.on("error", function(e) {
            e.errno === process.ECONNREFUSED ? fabric.log("ECONNREFUSED: connection refused to " + r.hostname + ":" + r.port) : fabric.log(e.message)
        }),
        s.end()
    }
    function requestFs(e, t) {
        var n = require("fs");
        n.readFile(e, function(e, n) {
            if (e)
                throw fabric.log(e),
                e;
            t(n)
        })
    }
    if (typeof document != "undefined" && typeof window != "undefined")
        return;
    var DOMParser = require("xmldom").DOMParser
      , URL = require("url")
      , HTTP = require("http")
      , HTTPS = require("https")
      , Canvas = require("canvas")
      , Image = require("canvas").Image;
    fabric.util.loadImage = function(e, t, n) {
        function r(r) {
            i.src = new Buffer(r,"binary"),
            i._src = e,
            t && t.call(n, i)
        }
        var i = new Image;
        e && (e instanceof Buffer || e.indexOf("data") === 0) ? (i.src = i._src = e,
        t && t.call(n, i)) : e && e.indexOf("http") !== 0 ? requestFs(e, r) : e ? request(e, "binary", r) : t && t.call(n, e)
    }
    ,
    fabric.loadSVGFromURL = function(e, t, n) {
        e = e.replace(/^\n\s*/, "").replace(/\?.*$/, "").trim(),
        e.indexOf("http") !== 0 ? requestFs(e, function(e) {
            fabric.loadSVGFromString(e.toString(), t, n)
        }) : request(e, "", function(e) {
            fabric.loadSVGFromString(e, t, n)
        })
    }
    ,
    fabric.loadSVGFromString = function(e, t, n) {
        var r = (new DOMParser).parseFromString(e);
        fabric.parseSVGDocument(r.documentElement, function(e, n) {
            t && t(e, n)
        }, n)
    }
    ,
    fabric.util.getScript = function(url, callback) {
        request(url, "", function(body) {
            eval(body),
            callback && callback()
        })
    }
    ,
    fabric.Image.fromObject = function(e, t) {
        fabric.util.loadImage(e.src, function(n) {
            var r = new fabric.Image(n);
            r._initConfig(e),
            r._initFilters(e, function(e) {
                r.filters = e || [],
                t && t(r)
            })
        })
    }
    ,
    fabric.createCanvasForNode = function(e, t, n, r) {
        r = r || n;
        var i = fabric.document.createElement("canvas")
          , s = new Canvas(e || 600,t || 600,r);
        i.style = {},
        i.width = s.width,
        i.height = s.height;
        var o = fabric.Canvas || fabric.StaticCanvas
          , u = new o(i,n);
        return u.contextContainer = s.getContext("2d"),
        u.nodeCanvas = s,
        u.Font = Canvas.Font,
        u
    }
    ,
    fabric.StaticCanvas.prototype.createPNGStream = function() {
        return this.nodeCanvas.createPNGStream()
    }
    ,
    fabric.StaticCanvas.prototype.createJPEGStream = function(e) {
        return this.nodeCanvas.createJPEGStream(e)
    }
    ;
    var origSetWidth = fabric.StaticCanvas.prototype.setWidth;
    fabric.StaticCanvas.prototype.setWidth = function(e, t) {
        return origSetWidth.call(this, e, t),
        this.nodeCanvas.width = e,
        this
    }
    ,
    fabric.Canvas && (fabric.Canvas.prototype.setWidth = fabric.StaticCanvas.prototype.setWidth);
    var origSetHeight = fabric.StaticCanvas.prototype.setHeight;
    fabric.StaticCanvas.prototype.setHeight = function(e, t) {
        return origSetHeight.call(this, e, t),
        this.nodeCanvas.height = e,
        this
    }
    ,
    fabric.Canvas && (fabric.Canvas.prototype.setHeight = fabric.StaticCanvas.prototype.setHeight)
}();

/* 
 * PikadayResponsive 
 * A responsive datepicker built on top of Pikaday. It shows the native datepicker on mobile devices and a nice JS-picker on desktop. 
 * 
 * @author: Francesco Novy 
 * @licence: MIT <http://www.opensource.org/licenses/mit-license.php> 
 * @link https://github.com/mydea/PikadayResponsive 
 * @copyright: (c) 2016 
 * @version: 0.7.0 
 */

(function(root, factory) {
    if (typeof define === 'function') {
        define('pikaday-responsive', ['exports'], function(exports) {
            return (exports['default'] = factory());
        });
    } else if (typeof module === 'object') {
        module.exports = factory();
    } else {
        root.pikadayResponsive = factory();
    }
}(this, function() {

    // Check if all dependencies are loaded
    if (!moment) {
        console.error("You need to load moment.js in order to use pikaday-responsive.");
        return;
    }

    if (!jQuery) {
        console.error("You need to load jQuery in order to use pikaday-responsive.");
        return;
    }

    if (!Pikaday) {
        console.error("You need to load pikaday in order to use pikaday-responsive.");
        return;
    }

    var defaultOptions = {
        format: "YYYY-MM-DD",
        outputFormat: "YYYY-MM-DD",
        checkIfNativeDate: function() {
            return Modernizr.inputtypes.date && (Modernizr.touchevents && navigator.appVersion.indexOf("Win") === -1);
        },
        classes: "",
        placeholder: "Select a date",
        pikadayOptions: {},
        dayOffset: 0
    };

    return function(el, options) {
        var $el = $(el);
        var settings = $.extend({}, defaultOptions, options);

        // The container element for the input
        var $container;
        // The actual input field
        var $input;
        // The display input field
        var $display;
        // The actual output value
        var obj = {
            pikaday: null,
            value: null,
            date: null,
            element: $el[0]
        };

        // Check if first param is <input>
        if (!$el.length || $el[0].tagName !== "INPUT") {
            console.error("pikadayResponsive expects an input-field as its first element.", $el[0]);
            return false;
        }

        // The original input field is made hidden. This field will contain the actual value.
        $el.attr("type", "hidden");
        // Wrap the input in a container
        $el.wrap("<span class='pikaday__container'></span>");
        $container = $el.parent(".pikaday__container");

        // If the original input has an ID, use it to generate IDs for the generated display inputs
        var originalId = $el.attr('id');

        if (settings.checkIfNativeDate()) {
            // Use native date picker
            $input = $("<input type='date' class='pikaday__invisible' placeholder='" + settings.placeholder + "'/>");
            if (originalId) {
                $input.attr('id', originalId + '-input');
            }
            $container.append($input);

            $display = $("<input type='text' readonly='readonly' class='pikaday__display pikaday__display--native " + settings.classes + "' placeholder='" + settings.placeholder + "' />");
            $container.append($display);

            $input.on("change", function() {
                var val = $(this).val();
                $display.removeClass("is-empty");

                if (!val) {
                    obj.date = null;
                    obj.value = null;
                    $display.addClass("is-empty");
                } else {
                    obj.date = moment(val, "YYYY-MM-DD");
                    obj.value = obj.date.format(settings.outputFormat);
                }

                // Convert numbers (unix timestamp) to ints
                if (obj.value * 1 === parseInt(obj.value, 10)) {
                    obj.value *= 1;
                }
                $el.val(obj.value);
                if (obj.date) {
                    $display.val(obj.date.format(settings.format));
                } else {
                    $display.val(null);
                }

                $el.trigger("change");
                $el.trigger("change-date", [obj]);
            });

        } else {
            // Use Pikaday
            $input = $("<input type='text' class='pikaday__display pikaday__display--pikaday " + settings.classes + "' placeholder='" + settings.placeholder + "' />");
            if (originalId) {
                $input.attr('id', originalId + '-input');
            }
            $container.append($input);

            var hasSelected = false;
            var selectTimer = null;

            obj.pikaday = new Pikaday($.extend({}, settings.pikadayOptions, {
                field: $input[0],
                format: settings.format,
            }));

            $input.on("change", function() {
                if (hasSelected) {
                    return;
                }

                hasSelected = true;
                selectTimer = window.setTimeout(function() {
                    hasSelected = false;
                }, 10);

                var val = $(this).val();
                $input.removeClass("is-empty");

                if (!val) {
                    obj.date = null;
                    obj.value = null;
                    $input.addClass("is-empty")
                } else {
                    obj.date = moment(val, settings.format);
                    // Add an optional day offset to account for time zones
                    obj.date.add(settings.dayOffset, "day");

                    obj.value = obj.date.format(settings.outputFormat);
                    $(this).val(obj.date.format(settings.format));
                }

                // Convert numbers (unix timestamp) to ints
                if (obj.value * 1 === parseInt(obj.value, 10)) {
                    obj.value *= 1;
                }
                $el.val(obj.value);

                // Wait 1ms in order to circumvent bug where events weren't triggered
                setTimeout(function() {
                    $el.trigger("change");
                    $el.trigger("change-date", [obj]);
                }, 1);
            });
        }

        /**
     * This function sets the date to a specific value.
     *
     * @method setDate
     * @param date It is preferred to give a moment-object as param, but vanilla Dates or strings in the outputFormat work too
     * @returns Object The moment-date that was used to set the date
     */
        var setDate = function(date, format) {
            // If date is null, reset the field
            if (!date) {
                if (obj.pikaday) {
                    obj.pikaday.setDate(null);
                } else {
                    $input.val(null);
                    $input.trigger("change");
                }

                return null;
            }

            // Format date into moment-date
            if (typeof date === "object" && typeof date.format !== "function") {
                date = moment(date);
            }
            if (typeof date === "string") {
                if (typeof format === "undefined" || !format) {
                    format = settings.outputFormat;
                }
                date = moment(date, format);
            }
            if (typeof date === "number") {
                date = moment(date);
            }

            if (obj.pikaday) {
                obj.pikaday.setMoment(date);
            } else {
                $input.val(date.format("YYYY-MM-DD"));
                $input.trigger("change");
            }

            return date;
        };

        if ($el.val()) {
            setDate($el.val());
        }

        obj.setDate = setDate;

        return obj;
    }
}));

(function($) {
    $.fn.columnize = function(options) {
        this.cols = [];
        this.offset = 0;
        this.before = [];
        this.lastOther = 0;
        this.prevMax = 0;
        this.debug = 0;
        this.setColumnStart = null;
        this.elipsisText = '';
        var defaults = {
            width: 400,
            columns: false,
            buildOnce: false,
            overflow: false,
            doneFunc: function() {},
            target: false,
            ignoreImageLoading: true,
            columnFloat: "left",
            lastNeverTallest: false,
            accuracy: false,
            precise: false,
            manualBreaks: false,
            cssClassPrefix: "",
            elipsisText: '...',
            debug: 0
        };
        options = $.extend(defaults, options);
        if (typeof (options.width) == "string") {
            options.width = parseInt(options.width, 10);
            if (isNaN(options.width)) {
                options.width = defaults.width;
            }
        }
        if (typeof options.setColumnStart == 'function') {
            this.setColumnStart = options.setColumnStart;
        }
        if (typeof options.elipsisText == 'string') {
            this.elipsisText = options.elipsisText;
        }
        if (options.debug) {
            this.debug = options.debug;
        }
        if (!options.setWidth) {
            if (options.precise) {
                options.setWidth = function(numCols) {
                    return 100 / numCols;
                }
                ;
            } else {
                options.setWidth = function(numCols) {
                    return Math.floor(100 / numCols);
                }
                ;
            }
        }
        function appendSafe($target, $elem) {
            try {
                $target.append($elem);
            } catch (e) {
                $target[0].appendChild($elem[0]);
            }
        }
        return this.each(function() {
            var $inBox = options.target ? $(options.target) : $(this);
            var maxHeight = $(this).height();
            var $cache = $('<div></div>');
            var lastWidth = 0;
            var columnizing = false;
            var manualBreaks = options.manualBreaks;
            var cssClassPrefix = defaults.cssClassPrefix;
            if (typeof (options.cssClassPrefix) == "string") {
                cssClassPrefix = options.cssClassPrefix;
            }
            var adjustment = 0;
            appendSafe($cache, $(this).contents().clone(true));
            if (!options.ignoreImageLoading && !options.target) {
                if (!$inBox.data("imageLoaded")) {
                    $inBox.data("imageLoaded", true);
                    if ($(this).find("img").length > 0) {
                        var func = function($inBox, $cache) {
                            return function() {
                                if (!$inBox.data("firstImageLoaded")) {
                                    $inBox.data("firstImageLoaded", "true");
                                    appendSafe($inBox.empty(), $cache.children().clone(true));
                                    $inBox.columnize(options);
                                }
                            }
                            ;
                        }($(this), $cache);
                        $(this).find("img").one("load", func);
                        $(this).find("img").one("abort", func);
                        return;
                    }
                }
            }
            $inBox.empty();
            columnizeIt();
            if (!options.buildOnce) {
                $(window).resize(function() {
                    if (!options.buildOnce) {
                        if ($inBox.data("timeout")) {
                            clearTimeout($inBox.data("timeout"));
                        }
                        $inBox.data("timeout", setTimeout(columnizeIt, 200));
                    }
                });
            }
            function prefixTheClassName(className, withDot) {
                var dot = withDot ? "." : "";
                if (cssClassPrefix.length) {
                    return dot + cssClassPrefix + "-" + className;
                }
                return dot + className;
            }
            function columnize($putInHere, $pullOutHere, $parentColumn, targetHeight) {
                while ((manualBreaks || $parentColumn.height() < targetHeight) && $pullOutHere[0].childNodes.length) {
                    var node = $pullOutHere[0].childNodes[0];
                    if ($(node).find(prefixTheClassName("columnbreak", true)).length) {
                        return;
                    }
                    if ($(node).hasClass(prefixTheClassName("columnbreak"))) {
                        return;
                    }
                    appendSafe($putInHere, $(node));
                }
                if ($putInHere[0].childNodes.length === 0)
                    return;
                var kids = $putInHere[0].childNodes;
                var lastKid = kids[kids.length - 1];
                $putInHere[0].removeChild(lastKid);
                var $item = $(lastKid);
                if ($item[0].nodeType == 3) {
                    var oText = $item[0].nodeValue;
                    var counter2 = options.width / 18;
                    if (options.accuracy)
                        counter2 = options.accuracy;
                    var columnText;
                    var latestTextNode = null;
                    while ($parentColumn.height() < targetHeight && oText.length) {
                        var indexOfSpace = oText.indexOf(' ', counter2);
                        if (indexOfSpace != -1) {
                            columnText = oText.substring(0, indexOfSpace);
                        } else {
                            columnText = oText;
                        }
                        latestTextNode = document.createTextNode(columnText);
                        appendSafe($putInHere, $(latestTextNode));
                        if (oText.length > counter2 && indexOfSpace != -1) {
                            oText = oText.substring(indexOfSpace);
                        } else {
                            oText = "";
                        }
                    }
                    if ($parentColumn.height() >= targetHeight && latestTextNode !== null) {
                        $putInHere[0].removeChild(latestTextNode);
                        oText = latestTextNode.nodeValue + oText;
                    }
                    if (oText.length) {
                        $item[0].nodeValue = oText;
                    } else {
                        return false;
                    }
                }
                if ($pullOutHere.contents().length) {
                    $pullOutHere.prepend($item);
                } else {
                    appendSafe($pullOutHere, $item);
                }
                return $item[0].nodeType == 3;
            }
            function split($putInHere, $pullOutHere, $parentColumn, targetHeight) {
                if ($putInHere.contents(":last").find(prefixTheClassName("columnbreak", true)).length) {
                    return;
                }
                if ($putInHere.contents(":last").hasClass(prefixTheClassName("columnbreak"))) {
                    return;
                }
                if ($pullOutHere.contents().length) {
                    var $cloneMe = $pullOutHere.contents(":first");
                    if (typeof $cloneMe.get(0) == 'undefined' || $cloneMe.get(0).nodeType != 1)
                        return;
                    var $clone = $cloneMe.clone(true);
                    if ($cloneMe.hasClass(prefixTheClassName("columnbreak"))) {
                        appendSafe($putInHere, $clone);
                        $cloneMe.remove();
                    } else if (manualBreaks) {
                        appendSafe($putInHere, $clone);
                        $cloneMe.remove();
                    } else if ($clone.get(0).nodeType == 1 && !$clone.hasClass(prefixTheClassName("dontend"))) {
                        appendSafe($putInHere, $clone);
                        if ($clone.is("img") && $parentColumn.height() < targetHeight + 20) {
                            $cloneMe.remove();
                        } else if ($cloneMe.hasClass(prefixTheClassName("dontsplit")) && $parentColumn.height() < targetHeight + 20) {
                            $cloneMe.remove();
                        } else if ($clone.is("img") || $cloneMe.hasClass(prefixTheClassName("dontsplit"))) {
                            $clone.remove();
                        } else {
                            $clone.empty();
                            if (!columnize($clone, $cloneMe, $parentColumn, targetHeight)) {
                                $cloneMe.addClass(prefixTheClassName("split"));
                                if ($cloneMe.get(0).tagName == 'OL') {
                                    var startWith = $clone.get(0).childElementCount + $clone.get(0).start;
                                    $cloneMe.attr('start', startWith + 1);
                                }
                                if ($cloneMe.children().length) {
                                    split($clone, $cloneMe, $parentColumn, targetHeight);
                                }
                            } else {
                                $cloneMe.addClass(prefixTheClassName("split"));
                            }
                            if ($clone.get(0).childNodes.length === 0) {
                                $clone.remove();
                                $cloneMe.removeClass(prefixTheClassName("split"));
                            } else if ($clone.get(0).childNodes.length == 1) {
                                var onlyNode = $clone.get(0).childNodes[0];
                                if (onlyNode.nodeType == 3) {
                                    var whitespace = /\s/;
                                    var str = onlyNode.nodeValue;
                                    if (whitespace.test(str)) {
                                        $clone.remove();
                                        $cloneMe.removeClass(prefixTheClassName("split"));
                                    }
                                }
                            }
                        }
                    }
                }
            }
            function singleColumnizeIt() {
                if ($inBox.data("columnized") && $inBox.children().length == 1) {
                    return;
                }
                $inBox.data("columnized", true);
                $inBox.data("columnizing", true);
                $inBox.empty();
                $inBox.append($("<div class='" + prefixTheClassName("first") + " " + prefixTheClassName("last") + " " + prefixTheClassName("column") + " " + "' style='width:100%; float: " + options.columnFloat + ";'></div>"));
                $col = $inBox.children().eq($inBox.children().length - 1);
                $destroyable = $cache.clone(true);
                if (options.overflow) {
                    targetHeight = options.overflow.height;
                    columnize($col, $destroyable, $col, targetHeight);
                    if (!$destroyable.contents().find(":first-child").hasClass(prefixTheClassName("dontend"))) {
                        split($col, $destroyable, $col, targetHeight);
                    }
                    while ($col.contents(":last").length && checkDontEndColumn($col.contents(":last").get(0))) {
                        var $lastKid = $col.contents(":last");
                        $lastKid.remove();
                        $destroyable.prepend($lastKid);
                    }
                    var html = "";
                    var div = document.createElement('DIV');
                    while ($destroyable[0].childNodes.length > 0) {
                        var kid = $destroyable[0].childNodes[0];
                        if (kid.attributes) {
                            for (var i = 0; i < kid.attributes.length; i++) {
                                if (kid.attributes[i].nodeName.indexOf("jQuery") === 0) {
                                    kid.removeAttribute(kid.attributes[i].nodeName);
                                }
                            }
                        }
                        div.innerHTML = "";
                        div.appendChild($destroyable[0].childNodes[0]);
                        html += div.innerHTML;
                    }
                    var overflow = $(options.overflow.id)[0];
                    overflow.innerHTML = html;
                } else {
                    appendSafe($col, $destroyable.contents());
                }
                $inBox.data("columnizing", false);
                if (options.overflow && options.overflow.doneFunc) {
                    options.overflow.doneFunc();
                }
                options.doneFunc();
            }
            function checkDontEndColumn(dom) {
                if (dom.nodeType == 3) {
                    if (/^\s+$/.test(dom.nodeValue)) {
                        if (!dom.previousSibling)
                            return false;
                        return checkDontEndColumn(dom.previousSibling);
                    }
                    return false;
                }
                if (dom.nodeType != 1)
                    return false;
                if ($(dom).hasClass(prefixTheClassName("dontend")))
                    return true;
                if (dom.childNodes.length === 0)
                    return false;
                return checkDontEndColumn(dom.childNodes[dom.childNodes.length - 1]);
            }
            function columnizeIt() {
                adjustment = 0;
                if (lastWidth == $inBox.width())
                    return;
                lastWidth = $inBox.width();
                var numCols = Math.round($inBox.width() / options.width);
                var optionWidth = options.width;
                var optionHeight = options.height;
                if (options.columns)
                    numCols = options.columns;
                if (manualBreaks) {
                    numCols = $cache.find(prefixTheClassName("columnbreak", true)).length + 1;
                    optionWidth = false;
                }
                if (numCols <= 1) {
                    return singleColumnizeIt();
                }
                if ($inBox.data("columnizing"))
                    return;
                $inBox.data("columnized", true);
                $inBox.data("columnizing", true);
                $inBox.empty();
                $inBox.append($("<div style='width:" + options.setWidth(numCols) + "%; float: " + options.columnFloat + ";'></div>"));
                $col = $inBox.children(":last");
                appendSafe($col, $cache.clone());
                maxHeight = $col.height();
                $inBox.empty();
                var targetHeight = maxHeight / numCols;
                var firstTime = true;
                var maxLoops = 3;
                var scrollHorizontally = false;
                if (options.overflow) {
                    maxLoops = 1;
                    targetHeight = options.overflow.height;
                } else if (optionHeight && optionWidth) {
                    maxLoops = 1;
                    targetHeight = optionHeight;
                    scrollHorizontally = true;
                }
                for (var loopCount = 0; loopCount < maxLoops && loopCount < 20; loopCount++) {
                    $inBox.empty();
                    var $destroyable, className, $col, $lastKid;
                    try {
                        $destroyable = $cache.clone(true);
                    } catch (e) {
                        $destroyable = $cache.clone();
                    }
                    $destroyable.css("visibility", "hidden");
                    for (var i = 0; i < numCols; i++) {
                        className = (i === 0) ? prefixTheClassName("first") : "";
                        className += " " + prefixTheClassName("column");
                        className = (i == numCols - 1) ? (prefixTheClassName("last") + " " + className) : className;
                        $inBox.append($("<div class='" + className + "' style='width:" + options.setWidth(numCols) + "%; float: " + options.columnFloat + ";'></div>"));
                    }
                    i = 0;
                    while (i < numCols - (options.overflow ? 0 : 1) || scrollHorizontally && $destroyable.contents().length) {
                        if ($inBox.children().length <= i) {
                            $inBox.append($("<div class='" + className + "' style='width:" + options.setWidth(numCols) + "%; float: " + options.columnFloat + ";'></div>"));
                        }
                        $col = $inBox.children().eq(i);
                        if (scrollHorizontally) {
                            $col.width(optionWidth + "px");
                        }
                        columnize($col, $destroyable, $col, targetHeight);
                        split($col, $destroyable, $col, targetHeight);
                        while ($col.contents(":last").length && checkDontEndColumn($col.contents(":last").get(0))) {
                            $lastKid = $col.contents(":last");
                            $lastKid.remove();
                            $destroyable.prepend($lastKid);
                        }
                        i++;
                        if ($col.contents().length === 0 && $destroyable.contents().length) {
                            $col.append($destroyable.contents(":first"));
                        } else if (i == numCols - (options.overflow ? 0 : 1) && !options.overflow) {
                            if ($destroyable.find(prefixTheClassName("columnbreak", true)).length) {
                                numCols++;
                            }
                        }
                    }
                    if (options.overflow && !scrollHorizontally) {
                        var IE6 = false;
                        var IE7 = (document.all) && (navigator.appVersion.indexOf("MSIE 7.") != -1);
                        if (IE6 || IE7) {
                            var html = "";
                            var div = document.createElement('DIV');
                            while ($destroyable[0].childNodes.length > 0) {
                                var kid = $destroyable[0].childNodes[0];
                                for (i = 0; i < kid.attributes.length; i++) {
                                    if (kid.attributes[i].nodeName.indexOf("jQuery") === 0) {
                                        kid.removeAttribute(kid.attributes[i].nodeName);
                                    }
                                }
                                div.innerHTML = "";
                                div.appendChild($destroyable[0].childNodes[0]);
                                html += div.innerHTML;
                            }
                            var overflow = $(options.overflow.id)[0];
                            overflow.innerHTML = html;
                        } else {
                            $(options.overflow.id).empty().append($destroyable.contents().clone(true));
                        }
                    } else if (!scrollHorizontally) {
                        $col = $inBox.children().eq($inBox.children().length - 1);
                        $destroyable.contents().each(function() {
                            $col.append($(this));
                        });
                        var afterH = $col.height();
                        var diff = afterH - targetHeight;
                        var totalH = 0;
                        var min = 10000000;
                        var max = 0;
                        var lastIsMax = false;
                        var numberOfColumnsThatDontEndInAColumnBreak = 0;
                        $inBox.children().each(function($inBox) {
                            return function($item) {
                                var $col = $inBox.children().eq($item);
                                var endsInBreak = $col.children(":last").find(prefixTheClassName("columnbreak", true)).length;
                                if (!endsInBreak) {
                                    var h = $col.height();
                                    lastIsMax = false;
                                    totalH += h;
                                    if (h > max) {
                                        max = h;
                                        lastIsMax = true;
                                    }
                                    if (h < min)
                                        min = h;
                                    numberOfColumnsThatDontEndInAColumnBreak++;
                                }
                            }
                            ;
                        }($inBox));
                        var avgH = totalH / numberOfColumnsThatDontEndInAColumnBreak;
                        if (totalH === 0) {
                            loopCount = maxLoops;
                        } else if (options.lastNeverTallest && lastIsMax) {
                            adjustment += 5;
                            targetHeight = targetHeight + 30;
                            if (loopCount == maxLoops - 1)
                                maxLoops++;
                        } else if (max - min > 30) {
                            targetHeight = avgH + 30;
                        } else if (Math.abs(avgH - targetHeight) > 20) {
                            targetHeight = avgH;
                        } else {
                            loopCount = maxLoops;
                        }
                    } else {
                        $inBox.children().each(function(i) {
                            $col = $inBox.children().eq(i);
                            $col.width(optionWidth + "px");
                            if (i === 0) {
                                $col.addClass(prefixTheClassName("first"));
                            } else if (i == $inBox.children().length - 1) {
                                $col.addClass(prefixTheClassName("last"));
                            } else {
                                $col.removeClass(prefixTheClassName("first"));
                                $col.removeClass(prefixTheClassName("last"));
                            }
                        });
                        $inBox.width($inBox.children().length * optionWidth + "px");
                    }
                    $inBox.append($("<br style='clear:both;'>"));
                }
                $inBox.find(prefixTheClassName("column", true)).find(":first" + prefixTheClassName("removeiffirst", true)).remove();
                $inBox.find(prefixTheClassName("column", true)).find(':last' + prefixTheClassName("removeiflast", true)).remove();
                $inBox.find(prefixTheClassName("split", true)).find(":first" + prefixTheClassName("removeiffirst", true)).remove();
                $inBox.find(prefixTheClassName("split", true)).find(':last' + prefixTheClassName("removeiflast", true)).remove();
                $inBox.data("columnizing", false);
                if (options.overflow) {
                    options.overflow.doneFunc();
                }
                options.doneFunc();
            }
        });
    }
    ;
    $.fn.renumberByJS = function($searchTag, $colno, $targetId, $targetClass) {
        this.setList = function($cols, $list, $tag1) {
            var $parents = this.before.parents();
            var $rest;
            $rest = $($cols[this.offset - 1]).find('>*');
            if (($rest.last())[0].tagName != $tag1.toUpperCase()) {
                if (this.debug) {
                    console.log("Last item in previous column, isn't a list...");
                }
                return 0;
            }
            $rest = $rest.length;
            var $tint = 1;
            if (this.lastOther <= 0) {
                $tint = this.before.children().length + 1;
            } else {
                $tint = $($parents[this.lastOther]).children().length + 1;
            }
            if ($($cols[this.offset]).find($tag1 + ':first li.split').length) {
                var $whereElipsis = $($cols[this.offset - 1]).find($tag1 + ':last li:last');
                if (this.elipsisText === '' || $($cols[this.offset - 1]).find($tag1 + ':last ~ div').length || $($cols[this.offset - 1]).find($tag1 + ':last ~ p').length) {
                    ;
                } else {
                    if ($($whereElipsis).find('ul, ol, dl').length == 0) {
                        var $txt = $whereElipsis.last().text();
                        var $len = $txt.length;
                        if ($txt.substring($len - 1) == ';') {
                            if ($txt.substring($len - 4) != this.elipsisText + ';') {
                                $txt = $txt.substring(0, $len - 1) + this.elipsisText + ';';
                            }
                        } else {
                            if ($txt.substring($len - 3) != this.elipsisText) {
                                $txt += this.elipsisText;
                            }
                        }
                        $whereElipsis.last().text($txt);
                    }
                }
                if ($($cols[this.offset]).find($tag1 + ':first >li.split >' + $tag1).length == 0) {
                    $tint--;
                }
            }
            if ($rest == 1) {
                $tint += this.prevMax;
            }
            if (this.nest > 1) {
                if (this.debug) {
                    console.log("Supposed to be a nested list...decr");
                }
                $tint--;
                var $tt = $($cols[this.offset - 1]).find($tag1 + ':first li.split:first');
                if ($tt.length > 0) {
                    if (this.debug) {
                        console.log("Previous column started with a split item, so that count is one less than expected");
                    }
                    $tint--;
                }
                $tt = $($cols[this.offset]).find($tag1 + ':first li:first').clone();
                $tt.children().remove();
                if ($.trim($tt.text()).length > 0) {
                    if (this.debug) {
                        console.log("If that was a complete list in the previous column, don't decr.");
                    }
                    $tint++;
                    if ($($cols[this.offset - 1]).find(">" + $tag1 + ':last ').children().length == 0) {
                        if (this.debug) {
                            console.log("unless that was empty, in which case revert");
                        }
                        $tint--;
                    }
                }
            } else {
                var $tt = $($cols[this.offset]).find($tag1 + ':first li:first ' + $tag1 + ".split li.split");
                if ($tt.length > 0) {
                    if (this.debug) {
                        console.log("[Nested] Column started with a split item, so that count is one less than expected");
                    }
                    $tint--;
                }
            }
            if (this.debug) {
                console.log("Setting the start value to " + $tint + " (" + this.prevMax + ")");
            }
            if ($tint > 0) {
                if (typeof this.setColumnStart == 'function') {
                    this.setColumnStart($list, $tint);
                } else {
                    $list.attr('start', $tint);
                }
            }
            return 0;
        }
        if (typeof $targetId === 'undefined') {
            $targetId = false;
        }
        if (typeof $targetClass === 'undefined') {
            $targetClass = false;
        }
        if (!$targetId && !$targetClass) {
            throw "renumberByJS(): Bad param, must pass an id or a class";
        }
        var $target = '';
        this.prevMax = 1;
        if ($targetClass) {
            $target = "." + $targetClass;
        } else {
            $target = "#" + $targetId;
        }
        var $tag1 = $searchTag.toLowerCase();
        var $tag2 = $searchTag.toUpperCase();
        this.cols = $($target);
        if (this.debug) {
            console.log("There are " + this.cols.length + " items, looking for " + $tag1);
        }
        this.before = $(this.cols[0]).find($tag1 + ':last');
        this.prevMax = this.before.children().length;
        for (this.offset = 1; this.offset < this.cols.length; this.offset++) {
            if (this.debug) {
                console.log("iterating " + this.offset + "...[of " + this.cols.length + "]");
            }
            if (this.offset % $colno == 0) {
                if (this.debug) {
                    console.log("First column (in theory..)");
                }
                this.prevMax = 1;
                continue;
            }
            this.before = $(this.cols[this.offset - 1]).find($tag1 + ':last');
            if (this.before.length) {
                if (this.debug) {
                    console.log("Have some " + $searchTag + " elements in the previous column");
                }
                var $list = $(this.cols[this.offset]).find($tag1 + ':first');
                var $first = $(this.cols[this.offset]).find('*:first');
                if ($first[0] !== $list[0]) {
                    continue;
                }
                var $parents = this.before.parents();
                this.lastOther = 0;
                var $found = false;
                for (; this.lastOther < $parents.length; this.lastOther++) {
                    if ($parents[this.lastOther].tagName != $tag2 && $parents[this.lastOther].tagName != "LI") {
                        $found = true;
                        this.lastOther--;
                        break;
                    }
                }
                this.nest = 1;
                if ($(this.cols[this.offset]).find(">" + $tag1 + ':first li ' + $tag1 + ":first").length) {
                    this.nest = 2;
                }
                this.setList(this.cols, $list, $tag1);
                this.lastOther--;
                $list = $(this.cols[this.offset]).find($tag1 + ':first li ' + $tag1 + ":first");
                if ($list.length) {
                    this.before = $(this.cols[this.offset - 1]).find(">" + $tag1 + ':last li ' + $tag1 + ":last");
                    this.prevMax = 0;
                    this.nest = 1;
                    this.setList(this.cols, $list, $tag1);
                }
                var $reset = $(this.cols[this.offset - 1]).find(">" + $tag1 + ':last');
                this.prevMax = $reset.children().length;
            }
        }
        return 0;
    }
    ;
}
)(jQuery);
/**
 * @fileOverview Kickass library to create and place poppers near their reference elements.
 * @version 0.5.3
 * @license
 * Copyright (c) 2016 Federico Zivolo and contributors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
!function(a, b) {
    "function" == typeof define && define.amd ? define(b) : "object" == typeof module && module.exports ? module.exports = b() : a.Popper = b()
}(this, function() {
    "use strict";
    function a(a, b, c) {
        this._reference = a.jquery ? a[0] : a,
        this.state = {};
        var d = "undefined" == typeof b || null === b
          , e = b && "[object Object]" === Object.prototype.toString.call(b);
        return d || e ? this._popper = this.parse(e ? b : {}) : this._popper = b.jquery ? b[0] : b,
        this._options = Object.assign({}, r, c),
        this._options.modifiers = this._options.modifiers.map(function(a) {
            if (this._options.modifiersIgnored.indexOf(a) === -1)
                return "applyStyle" === a && this._popper.setAttribute("x-placement", this._options.placement),
                this.modifiers[a] || a
        }
        .bind(this)),
        this.state.position = this._getPosition(this._popper, this._reference),
        k(this._popper, {
            position: this.state.position
        }),
        this.state.isParentTransformed = this._getIsParentTransformed(this._popper),
        this.update(),
        this._setupEventListeners(),
        this
    }
    function b(a) {
        var b = a.style.display
          , c = a.style.visibility;
        a.style.display = "block",
        a.style.visibility = "hidden";
        var d = (a.offsetWidth,
        q.getComputedStyle(a))
          , e = parseFloat(d.marginTop) + parseFloat(d.marginBottom)
          , f = parseFloat(d.marginLeft) + parseFloat(d.marginRight)
          , g = {
            width: a.offsetWidth + f,
            height: a.offsetHeight + e
        };
        return a.style.display = b,
        a.style.visibility = c,
        g
    }
    function c(a) {
        var b = {
            left: "right",
            right: "left",
            bottom: "top",
            top: "bottom"
        };
        return a.replace(/left|right|bottom|top/g, function(a) {
            return b[a]
        })
    }
    function d(a) {
        var b = Object.assign({}, a);
        return b.right = b.left + b.width,
        b.bottom = b.top + b.height,
        b
    }
    function e(a, b) {
        var c, d = 0;
        for (c in a) {
            if (a[c] === b)
                return d;
            d++
        }
        return null
    }
    function f(a, b) {
        var c = q.getComputedStyle(a, null);
        return c[b]
    }
    function g(a) {
        var b = a.offsetParent;
        return b !== q.document.body && b ? b : q.document.documentElement
    }
    function h(a) {
        return a === q.document ? q.document.body.scrollTop ? q.document.body : q.document.documentElement : ["scroll", "auto"].indexOf(f(a, "overflow")) !== -1 || ["scroll", "auto"].indexOf(f(a, "overflow-x")) !== -1 || ["scroll", "auto"].indexOf(f(a, "overflow-y")) !== -1 ? a === q.document.body ? h(a.parentNode) : a : a.parentNode ? h(a.parentNode) : a
    }
    function i(a) {
        return a !== q.document.body && ("fixed" === f(a, "position") || (a.parentNode ? i(a.parentNode) : a))
    }
    function j(a) {
        return a !== q.document.body && ("none" !== f(a, "transform") || (a.parentNode ? j(a.parentNode) : a))
    }
    function k(a, b) {
        function c(a) {
            return "" !== a && !isNaN(parseFloat(a)) && isFinite(a)
        }
        Object.keys(b).forEach(function(d) {
            var e = "";
            ["width", "height", "top", "right", "bottom", "left"].indexOf(d) !== -1 && c(b[d]) && (e = "px"),
            a.style[d] = b[d] + e
        })
    }
    function l(a) {
        var b = {};
        return a && "[object Function]" === b.toString.call(a)
    }
    function m(a) {
        var b = {
            width: a.offsetWidth,
            height: a.offsetHeight,
            left: a.offsetLeft,
            top: a.offsetTop
        };
        return b.right = b.left + b.width,
        b.bottom = b.top + b.height,
        b
    }
    function n(a) {
        var b = a.getBoundingClientRect();
        return {
            left: b.left,
            top: b.top,
            right: b.right,
            bottom: b.bottom,
            width: b.right - b.left,
            height: b.bottom - b.top
        }
    }
    function o(a, b, c, d) {
        var e = n(a)
          , f = n(b);
        if (c && !d) {
            var g = h(b);
            f.top += g.scrollTop,
            f.bottom += g.scrollTop,
            f.left += g.scrollLeft,
            f.right += g.scrollLeft
        }
        var i = {
            top: e.top - f.top,
            left: e.left - f.left,
            bottom: e.top - f.top + e.height,
            right: e.left - f.left + e.width,
            width: e.width,
            height: e.height
        };
        return i
    }
    function p(a) {
        for (var b = ["", "ms", "webkit", "moz", "o"], c = 0; c < b.length; c++) {
            var d = b[c] ? b[c] + a.charAt(0).toUpperCase() + a.slice(1) : a;
            if ("undefined" != typeof q.document.body.style[d])
                return d
        }
        return null
    }
    var q = window
      , r = {
        placement: "bottom",
        gpuAcceleration: !0,
        offset: 0,
        boundariesElement: "viewport",
        boundariesPadding: 5,
        preventOverflowOrder: ["left", "right", "top", "bottom"],
        flipBehavior: "flip",
        arrowElement: "[x-arrow]",
        modifiers: ["shift", "offset", "preventOverflow", "keepTogether", "arrow", "flip", "applyStyle"],
        modifiersIgnored: []
    };
    return a.prototype.destroy = function() {
        return this._popper.removeAttribute("x-placement"),
        this._popper.style.left = "",
        this._popper.style.position = "",
        this._popper.style.top = "",
        this._popper.style[p("transform")] = "",
        this._removeEventListeners(),
        this._options.removeOnDestroy && this._popper.remove(),
        this
    }
    ,
    a.prototype.update = function() {
        var a = {
            instance: this,
            styles: {}
        };
        a.placement = this._options.placement,
        a._originalPlacement = this._options.placement,
        a.offsets = this._getOffsets(this._popper, this._reference, a.placement),
        a.boundaries = this._getBoundaries(a, this._options.boundariesPadding, this._options.boundariesElement),
        a = this.runModifiers(a, this._options.modifiers),
        "function" == typeof this.state.updateCallback && this.state.updateCallback(a)
    }
    ,
    a.prototype.onCreate = function(a) {
        return a(this),
        this
    }
    ,
    a.prototype.onUpdate = function(a) {
        return this.state.updateCallback = a,
        this
    }
    ,
    a.prototype.parse = function(a) {
        function b(a, b) {
            b.forEach(function(b) {
                a.classList.add(b)
            })
        }
        function c(a, b) {
            b.forEach(function(b) {
                a.setAttribute(b.split(":")[0], b.split(":")[1] || "")
            })
        }
        var d = {
            tagName: "div",
            classNames: ["popper"],
            attributes: [],
            parent: q.document.body,
            content: "",
            contentType: "text",
            arrowTagName: "div",
            arrowClassNames: ["popper__arrow"],
            arrowAttributes: ["x-arrow"]
        };
        a = Object.assign({}, d, a);
        var e = q.document
          , f = e.createElement(a.tagName);
        if (b(f, a.classNames),
        c(f, a.attributes),
        "node" === a.contentType ? f.appendChild(a.content.jquery ? a.content[0] : a.content) : "html" === a.contentType ? f.innerHTML = a.content : f.textContent = a.content,
        a.arrowTagName) {
            var g = e.createElement(a.arrowTagName);
            b(g, a.arrowClassNames),
            c(g, a.arrowAttributes),
            f.appendChild(g)
        }
        var h = a.parent.jquery ? a.parent[0] : a.parent;
        if ("string" == typeof h) {
            if (h = e.querySelectorAll(a.parent),
            h.length > 1 && console.warn("WARNING: the given `parent` query(" + a.parent + ") matched more than one element, the first one will be used"),
            0 === h.length)
                throw "ERROR: the given `parent` doesn't exists!";
            h = h[0]
        }
        return h.length > 1 && h instanceof Element == !1 && (console.warn("WARNING: you have passed as parent a list of elements, the first one will be used"),
        h = h[0]),
        h.appendChild(f),
        f
    }
    ,
    a.prototype._getPosition = function(a, b) {
        var c = g(b)
          , d = i(b, c);
        return d ? "fixed" : "absolute"
    }
    ,
    a.prototype._getIsParentTransformed = function(a) {
        return j(a.parentNode)
    }
    ,
    a.prototype._getOffsets = function(a, c, d) {
        d = d.split("-")[0];
        var e = {};
        e.position = this.state.position;
        var f = "fixed" === e.position
          , h = this.state.isParentTransformed
          , i = g(f && h ? c : a)
          , j = o(c, i, f, h)
          , k = b(a);
        return ["right", "left"].indexOf(d) !== -1 ? (e.top = j.top + j.height / 2 - k.height / 2,
        "left" === d ? e.left = j.left - k.width : e.left = j.right) : (e.left = j.left + j.width / 2 - k.width / 2,
        "top" === d ? e.top = j.top - k.height : e.top = j.bottom),
        e.width = k.width,
        e.height = k.height,
        {
            popper: e,
            reference: j
        }
    }
    ,
    a.prototype._setupEventListeners = function() {
        if (this.state.updateBound = this.update.bind(this),
        q.addEventListener("resize", this.state.updateBound),
        "window" !== this._options.boundariesElement) {
            var a = h(this._reference);
            a !== q.document.body && a !== q.document.documentElement || (a = q),
            a.addEventListener("scroll", this.state.updateBound)
        }
    }
    ,
    a.prototype._removeEventListeners = function() {
        if (q.removeEventListener("resize", this.state.updateBound),
        "window" !== this._options.boundariesElement) {
            var a = h(this._reference);
            a !== q.document.body && a !== q.document.documentElement || (a = q),
            a.removeEventListener("scroll", this.state.updateBound)
        }
        this.state.updateBound = null
    }
    ,
    a.prototype._getBoundaries = function(a, b, c) {
        var d, e, f = {};
        if ("window" === c) {
            var i = q.document.body
              , j = q.document.documentElement;
            e = Math.max(i.scrollHeight, i.offsetHeight, j.clientHeight, j.scrollHeight, j.offsetHeight),
            d = Math.max(i.scrollWidth, i.offsetWidth, j.clientWidth, j.scrollWidth, j.offsetWidth),
            f = {
                top: 0,
                right: d,
                bottom: e,
                left: 0
            }
        } else if ("viewport" === c) {
            var k = g(this._popper)
              , l = h(this._popper)
              , n = m(k)
              , o = "fixed" === a.offsets.popper.position ? 0 : l.scrollTop
              , p = "fixed" === a.offsets.popper.position ? 0 : l.scrollLeft;
            f = {
                top: 0 - (n.top - o),
                right: q.document.documentElement.clientWidth - (n.left - p),
                bottom: q.document.documentElement.clientHeight - (n.top - o),
                left: 0 - (n.left - p)
            }
        } else
            f = g(this._popper) === c ? {
                top: 0,
                left: 0,
                right: c.clientWidth,
                bottom: c.clientHeight
            } : m(c);
        return f.left += b,
        f.right -= b,
        f.top = f.top + b,
        f.bottom = f.bottom - b,
        f
    }
    ,
    a.prototype.runModifiers = function(a, b, c) {
        var d = b.slice();
        return void 0 !== c && (d = this._options.modifiers.slice(0, e(this._options.modifiers, c))),
        d.forEach(function(b) {
            l(b) && (a = b.call(this, a))
        }
        .bind(this)),
        a
    }
    ,
    a.prototype.isModifierRequired = function(a, b) {
        var c = e(this._options.modifiers, a);
        return !!this._options.modifiers.slice(0, c).filter(function(a) {
            return a === b
        }).length
    }
    ,
    a.prototype.modifiers = {},
    a.prototype.modifiers.applyStyle = function(a) {
        var b, c = {
            position: a.offsets.popper.position
        }, d = Math.round(a.offsets.popper.left), e = Math.round(a.offsets.popper.top);
        return this._options.gpuAcceleration && (b = p("transform")) ? (c[b] = "translate3d(" + d + "px, " + e + "px, 0)",
        c.top = 0,
        c.left = 0) : (c.left = d,
        c.top = e),
        Object.assign(c, a.styles),
        k(this._popper, c),
        this._popper.setAttribute("x-placement", a.placement),
        this.isModifierRequired(this.modifiers.applyStyle, this.modifiers.arrow) && a.offsets.arrow && k(a.arrowElement, a.offsets.arrow),
        a
    }
    ,
    a.prototype.modifiers.shift = function(a) {
        var b = a.placement
          , c = b.split("-")[0]
          , e = b.split("-")[1];
        if (e) {
            var f = a.offsets.reference
              , g = d(a.offsets.popper)
              , h = {
                y: {
                    start: {
                        top: f.top
                    },
                    end: {
                        top: f.top + f.height - g.height
                    }
                },
                x: {
                    start: {
                        left: f.left
                    },
                    end: {
                        left: f.left + f.width - g.width
                    }
                }
            }
              , i = ["bottom", "top"].indexOf(c) !== -1 ? "x" : "y";
            a.offsets.popper = Object.assign(g, h[i][e])
        }
        return a
    }
    ,
    a.prototype.modifiers.preventOverflow = function(a) {
        var b = this._options.preventOverflowOrder
          , c = d(a.offsets.popper)
          , e = {
            left: function() {
                var b = c.left;
                return c.left < a.boundaries.left && (b = Math.max(c.left, a.boundaries.left)),
                {
                    left: b
                }
            },
            right: function() {
                var b = c.left;
                return c.right > a.boundaries.right && (b = Math.min(c.left, a.boundaries.right - c.width)),
                {
                    left: b
                }
            },
            top: function() {
                var b = c.top;
                return c.top < a.boundaries.top && (b = Math.max(c.top, a.boundaries.top)),
                {
                    top: b
                }
            },
            bottom: function() {
                var b = c.top;
                return c.bottom > a.boundaries.bottom && (b = Math.min(c.top, a.boundaries.bottom - c.height)),
                {
                    top: b
                }
            }
        };
        return b.forEach(function(b) {
            a.offsets.popper = Object.assign(c, e[b]())
        }),
        a
    }
    ,
    a.prototype.modifiers.keepTogether = function(a) {
        var b = d(a.offsets.popper)
          , c = a.offsets.reference
          , e = Math.floor;
        return b.right < e(c.left) && (a.offsets.popper.left = e(c.left) - b.width),
        b.left > e(c.right) && (a.offsets.popper.left = e(c.right)),
        b.bottom < e(c.top) && (a.offsets.popper.top = e(c.top) - b.height),
        b.top > e(c.bottom) && (a.offsets.popper.top = e(c.bottom)),
        a
    }
    ,
    a.prototype.modifiers.flip = function(a) {
        if (!this.isModifierRequired(this.modifiers.flip, this.modifiers.preventOverflow))
            return console.warn("WARNING: preventOverflow modifier is required by flip modifier in order to work, be sure to include it before flip!"),
            a;
        if (a.flipped && a.placement === a._originalPlacement)
            return a;
        var b = a.placement.split("-")[0]
          , e = c(b)
          , f = a.placement.split("-")[1] || ""
          , g = [];
        return g = "flip" === this._options.flipBehavior ? [b, e] : this._options.flipBehavior,
        g.forEach(function(h, i) {
            if (b === h && g.length !== i + 1) {
                b = a.placement.split("-")[0],
                e = c(b);
                var j = d(a.offsets.popper)
                  , k = ["right", "bottom"].indexOf(b) !== -1;
                (k && Math.floor(a.offsets.reference[b]) > Math.floor(j[e]) || !k && Math.floor(a.offsets.reference[b]) < Math.floor(j[e])) && (a.flipped = !0,
                a.placement = g[i + 1],
                f && (a.placement += "-" + f),
                a.offsets.popper = this._getOffsets(this._popper, this._reference, a.placement).popper,
                a = this.runModifiers(a, this._options.modifiers, this._flip))
            }
        }
        .bind(this)),
        a
    }
    ,
    a.prototype.modifiers.offset = function(a) {
        var b = this._options.offset
          , c = a.offsets.popper;
        return a.placement.indexOf("left") !== -1 ? c.top -= b : a.placement.indexOf("right") !== -1 ? c.top += b : a.placement.indexOf("top") !== -1 ? c.left -= b : a.placement.indexOf("bottom") !== -1 && (c.left += b),
        a
    }
    ,
    a.prototype.modifiers.arrow = function(a) {
        var c = this._options.arrowElement;
        if ("string" == typeof c && (c = this._popper.querySelector(c)),
        !c)
            return a;
        if (!this._popper.contains(c))
            return console.warn("WARNING: `arrowElement` must be child of its popper element!"),
            a;
        if (!this.isModifierRequired(this.modifiers.arrow, this.modifiers.keepTogether))
            return console.warn("WARNING: keepTogether modifier is required by arrow modifier in order to work, be sure to include it before arrow!"),
            a;
        var e = {}
          , f = a.placement.split("-")[0]
          , g = d(a.offsets.popper)
          , h = a.offsets.reference
          , i = ["left", "right"].indexOf(f) !== -1
          , j = i ? "height" : "width"
          , k = i ? "top" : "left"
          , l = i ? "left" : "top"
          , m = i ? "bottom" : "right"
          , n = b(c)[j];
        h[m] - n < g[k] && (a.offsets.popper[k] -= g[k] - (h[m] - n)),
        h[k] + n > g[m] && (a.offsets.popper[k] += h[k] + n - g[m]);
        var o = h[k] + h[j] / 2 - n / 2
          , p = o - d(a.offsets.popper)[k];
        return p = Math.max(Math.min(g[j] - n, p), 0),
        e[k] = p,
        e[l] = "",
        a.offsets.arrow = e,
        a.arrowElement = c,
        a
    }
    ,
    Object.assign || Object.defineProperty(Object, "assign", {
        enumerable: !1,
        configurable: !0,
        writable: !0,
        value: function(a) {
            if (void 0 === a || null === a)
                throw new TypeError("Cannot convert first argument to object");
            for (var b = Object(a), c = 1; c < arguments.length; c++) {
                var d = arguments[c];
                if (void 0 !== d && null !== d) {
                    d = Object(d);
                    for (var e = Object.keys(d), f = 0, g = e.length; f < g; f++) {
                        var h = e[f]
                          , i = Object.getOwnPropertyDescriptor(d, h);
                        void 0 !== i && i.enumerable && (b[h] = d[h])
                    }
                }
            }
            return b
        }
    }),
    a
});
//# sourceMappingURL=popper.min.js.map
/* jquery.panzoom.min.js 3.2.2 (c) Timmy Willison - MIT License */
!function(a, b) {
    "function" == typeof define && define.amd ? define(["jquery"], function(c) {
        return b(a, c)
    }) : "object" == typeof exports ? b(a, require("jquery")) : b(a, a.jQuery)
}("undefined" != typeof window ? window : this, function(a, b) {
    "use strict";
    function c(a, b) {
        for (var c = a.length; --c; )
            if (Math.round(+a[c]) !== Math.round(+b[c]))
                return !1;
        return !0
    }
    function d(a) {
        var c = {
            range: !0,
            animate: !0
        };
        return "boolean" == typeof a ? c.animate = a : b.extend(c, a),
        c
    }
    function e(a, c, d, e, f, g, h, i, j) {
        "array" === b.type(a) ? this.elements = [+a[0], +a[2], +a[4], +a[1], +a[3], +a[5], 0, 0, 1] : this.elements = [a, c, d, e, f, g, h || 0, i || 0, j || 1]
    }
    function f(a, b, c) {
        this.elements = [a, b, c]
    }
    function g(a, c) {
        if (!(this instanceof g))
            return new g(a,c);
        1 !== a.nodeType && b.error("Panzoom called on non-Element node"),
        b.contains(h, a) || b.error("Panzoom element must be attached to the document");
        var d = b.data(a, i);
        if (d)
            return d;
        this.options = c = b.extend({}, g.defaults, c),
        this.elem = a;
        var e = this.$elem = b(a);
        this.$set = c.$set && c.$set.length ? c.$set : e,
        this.$doc = b(a.ownerDocument || h),
        this.$parent = e.parent(),
        this.parent = this.$parent[0],
        this.isSVG = n.test(a.namespaceURI) && "svg" !== a.nodeName.toLowerCase(),
        this.panning = !1,
        this._buildTransform(),
        this._transform = b.cssProps.transform.replace(m, "-$1").toLowerCase(),
        this._buildTransition(),
        this.resetDimensions();
        var f = b()
          , j = this;
        b.each(["$zoomIn", "$zoomOut", "$zoomRange", "$reset"], function(a, b) {
            j[b] = c[b] || f
        }),
        this.enable(),
        this.scale = this.getMatrix()[0],
        this._checkPanWhenZoomed(),
        b.data(a, i, this)
    }
    var h = a.document
      , i = "__pz__"
      , j = Array.prototype.slice
      , k = /trident\/7./i
      , l = function() {
        if (k.test(navigator.userAgent))
            return !1;
        var a = h.createElement("input");
        return a.setAttribute("oninput", "return"),
        "function" == typeof a.oninput
    }()
      , m = /([A-Z])/g
      , n = /^http:[\w\.\/]+svg$/
      , o = "(\\-?\\d[\\d\\.e-]*)"
      , p = "\\,?\\s*"
      , q = new RegExp("^matrix\\(" + o + p + o + p + o + p + o + p + o + p + o + "\\)$");
    return e.prototype = {
        x: function(a) {
            var b = a instanceof f
              , c = this.elements
              , d = a.elements;
            return b && 3 === d.length ? new f(c[0] * d[0] + c[1] * d[1] + c[2] * d[2],c[3] * d[0] + c[4] * d[1] + c[5] * d[2],c[6] * d[0] + c[7] * d[1] + c[8] * d[2]) : d.length === c.length && new e(c[0] * d[0] + c[1] * d[3] + c[2] * d[6],c[0] * d[1] + c[1] * d[4] + c[2] * d[7],c[0] * d[2] + c[1] * d[5] + c[2] * d[8],c[3] * d[0] + c[4] * d[3] + c[5] * d[6],c[3] * d[1] + c[4] * d[4] + c[5] * d[7],c[3] * d[2] + c[4] * d[5] + c[5] * d[8],c[6] * d[0] + c[7] * d[3] + c[8] * d[6],c[6] * d[1] + c[7] * d[4] + c[8] * d[7],c[6] * d[2] + c[7] * d[5] + c[8] * d[8])
        },
        inverse: function() {
            var a = 1 / this.determinant()
              , b = this.elements;
            return new e(a * (b[8] * b[4] - b[7] * b[5]),a * -(b[8] * b[1] - b[7] * b[2]),a * (b[5] * b[1] - b[4] * b[2]),a * -(b[8] * b[3] - b[6] * b[5]),a * (b[8] * b[0] - b[6] * b[2]),a * -(b[5] * b[0] - b[3] * b[2]),a * (b[7] * b[3] - b[6] * b[4]),a * -(b[7] * b[0] - b[6] * b[1]),a * (b[4] * b[0] - b[3] * b[1]))
        },
        determinant: function() {
            var a = this.elements;
            return a[0] * (a[8] * a[4] - a[7] * a[5]) - a[3] * (a[8] * a[1] - a[7] * a[2]) + a[6] * (a[5] * a[1] - a[4] * a[2])
        }
    },
    f.prototype.e = e.prototype.e = function(a) {
        return this.elements[a]
    }
    ,
    g.rmatrix = q,
    g.defaults = {
        eventNamespace: ".panzoom",
        transition: !0,
        cursor: "move",
        disablePan: !1,
        disableZoom: !1,
        disableXAxis: !1,
        disableYAxis: !1,
        which: 1,
        increment: .3,
        exponential: !0,
        panOnlyWhenZoomed: !1,
        minScale: .3,
        maxScale: 6,
        rangeStep: .05,
        duration: 200,
        easing: "ease-in-out",
        contain: !1
    },
    g.prototype = {
        constructor: g,
        instance: function() {
            return this
        },
        enable: function() {
            this._initStyle(),
            this._bind(),
            this.disabled = !1
        },
        disable: function() {
            this.disabled = !0,
            this._resetStyle(),
            this._unbind()
        },
        isDisabled: function() {
            return this.disabled
        },
        destroy: function() {
            this.disable(),
            b.removeData(this.elem, i)
        },
        resetDimensions: function() {
            this.container = this.parent.getBoundingClientRect();
            var a = this.elem
              , c = a.getBoundingClientRect()
              , d = Math.abs(this.scale);
            this.dimensions = {
                width: c.width,
                height: c.height,
                left: b.css(a, "left", !0) || 0,
                top: b.css(a, "top", !0) || 0,
                border: {
                    top: b.css(a, "borderTopWidth", !0) * d || 0,
                    bottom: b.css(a, "borderBottomWidth", !0) * d || 0,
                    left: b.css(a, "borderLeftWidth", !0) * d || 0,
                    right: b.css(a, "borderRightWidth", !0) * d || 0
                },
                margin: {
                    top: b.css(a, "marginTop", !0) * d || 0,
                    left: b.css(a, "marginLeft", !0) * d || 0
                }
            }
        },
        reset: function(a) {
            a = d(a);
            var b = this.setMatrix(this._origTransform, a);
            a.silent || this._trigger("reset", b)
        },
        resetZoom: function(a) {
            a = d(a);
            var b = this.getMatrix(this._origTransform);
            a.dValue = b[3],
            this.zoom(b[0], a)
        },
        resetPan: function(a) {
            var b = this.getMatrix(this._origTransform);
            this.pan(b[4], b[5], d(a))
        },
        setTransform: function(a) {
            for (var c = this.$set, d = c.length; d--; )
                b.style(c[d], "transform", a),
                this.isSVG && c[d].setAttribute("transform", a)
        },
        getTransform: function(a) {
            var c = this.$set
              , d = c[0];
            return a ? this.setTransform(a) : (a = b.style(d, "transform"),
            !this.isSVG || a && "none" !== a || (a = b.attr(d, "transform") || "none")),
            "none" === a || q.test(a) || this.setTransform(a = b.css(d, "transform")),
            a || "none"
        },
        getMatrix: function(a) {
            var b = q.exec(a || this.getTransform());
            return b && b.shift(),
            b || [1, 0, 0, 1, 0, 0]
        },
        setMatrix: function(a, c) {
            if (!this.disabled) {
                c || (c = {}),
                "string" == typeof a && (a = this.getMatrix(a));
                var d = +a[0]
                  , e = "undefined" != typeof c.contain ? c.contain : this.options.contain;
                if (e) {
                    var f = c.dims;
                    f || (this.resetDimensions(),
                    f = this.dimensions);
                    var g, h, i, j = this.container, k = f.width, l = f.height, m = j.width, n = j.height, o = m / k, p = n / l;
                    "center" !== this.$parent.css("textAlign") || "inline" !== b.css(this.elem, "display") ? (i = (k - this.elem.offsetWidth) / 2,
                    g = i - f.border.left,
                    h = k - m - i + f.border.right) : g = h = (k - m) / 2;
                    var q = (l - n) / 2 + f.border.top
                      , r = (l - n) / 2 - f.border.top - f.border.bottom;
                    "invert" === e || "automatic" === e && o < 1.01 ? a[4] = Math.max(Math.min(a[4], g - f.border.left), -h) : a[4] = Math.min(Math.max(a[4], g), -h),
                    "invert" === e || "automatic" === e && p < 1.01 ? a[5] = Math.max(Math.min(a[5], q - f.border.top), -r) : a[5] = Math.min(Math.max(a[5], q), -r)
                }
                if ("skip" !== c.animate && this.transition(!c.animate),
                c.range && this.$zoomRange.val(d),
                this.options.disableXAxis || this.options.disableYAxis) {
                    var s = this.getMatrix();
                    this.options.disableXAxis && (a[4] = s[4]),
                    this.options.disableYAxis && (a[5] = s[5])
                }
                return this.setTransform("matrix(" + a.join(",") + ")"),
                this.scale = d,
                this._checkPanWhenZoomed(d),
                c.silent || this._trigger("change", a),
                a
            }
        },
        isPanning: function() {
            return this.panning
        },
        transition: function(a) {
            if (this._transition)
                for (var c = a || !this.options.transition ? "none" : this._transition, d = this.$set, e = d.length; e--; )
                    b.style(d[e], "transition") !== c && b.style(d[e], "transition", c)
        },
        pan: function(a, b, c) {
            if (!this.options.disablePan) {
                c || (c = {});
                var d = c.matrix;
                d || (d = this.getMatrix()),
                c.relative && (a += +d[4],
                b += +d[5]),
                d[4] = a,
                d[5] = b,
                this.setMatrix(d, c),
                c.silent || this._trigger("pan", d[4], d[5])
            }
        },
        zoom: function(a, c) {
            "object" == typeof a ? (c = a,
            a = null) : c || (c = {});
            var d = b.extend({}, this.options, c);
            if (!d.disableZoom) {
                var g = !1
                  , h = d.matrix || this.getMatrix()
                  , i = +h[0];
                "number" != typeof a && (a = d.exponential && i - d.increment >= 1 ? Math[a ? "sqrt" : "pow"](i, 2) : i + d.increment * (a ? -1 : 1),
                g = !0),
                a > d.maxScale ? a = d.maxScale : a < d.minScale && (a = d.minScale);
                var j = d.focal;
                if (j && !d.disablePan) {
                    this.resetDimensions();
                    var k = d.dims = this.dimensions
                      , l = j.clientX
                      , m = j.clientY;
                    this.isSVG || (l -= k.width / i / 2,
                    m -= k.height / i / 2);
                    var n = new f(l,m,1)
                      , o = new e(h)
                      , p = this.parentOffset || this.$parent.offset()
                      , q = new e(1,0,p.left - this.$doc.scrollLeft(),0,1,p.top - this.$doc.scrollTop())
                      , r = o.inverse().x(q.inverse().x(n))
                      , s = a / h[0];
                    o = o.x(new e([s, 0, 0, s, 0, 0])),
                    n = q.x(o.x(r)),
                    h[4] = +h[4] + (l - n.e(0)),
                    h[5] = +h[5] + (m - n.e(1))
                }
                h[0] = a,
                h[3] = "number" == typeof d.dValue ? d.dValue : a,
                this.setMatrix(h, {
                    animate: "undefined" != typeof d.animate ? d.animate : g,
                    range: !d.noSetRange
                }),
                d.silent || this._trigger("zoom", h[0], d)
            }
        },
        option: function(a, c) {
            var d;
            if (!a)
                return b.extend({}, this.options);
            if ("string" == typeof a) {
                if (1 === arguments.length)
                    return void 0 !== this.options[a] ? this.options[a] : null;
                d = {},
                d[a] = c
            } else
                d = a;
            this._setOptions(d)
        },
        _setOptions: function(a) {
            b.each(a, b.proxy(function(a, c) {
                switch (a) {
                case "disablePan":
                    this._resetStyle();
                case "$zoomIn":
                case "$zoomOut":
                case "$zoomRange":
                case "$reset":
                case "disableZoom":
                case "onStart":
                case "onChange":
                case "onZoom":
                case "onPan":
                case "onEnd":
                case "onReset":
                case "eventNamespace":
                    this._unbind()
                }
                switch (this.options[a] = c,
                a) {
                case "disablePan":
                    this._initStyle();
                case "$zoomIn":
                case "$zoomOut":
                case "$zoomRange":
                case "$reset":
                    this[a] = c;
                case "disableZoom":
                case "onStart":
                case "onChange":
                case "onZoom":
                case "onPan":
                case "onEnd":
                case "onReset":
                case "eventNamespace":
                    this._bind();
                    break;
                case "cursor":
                    b.style(this.elem, "cursor", c);
                    break;
                case "minScale":
                    this.$zoomRange.attr("min", c);
                    break;
                case "maxScale":
                    this.$zoomRange.attr("max", c);
                    break;
                case "rangeStep":
                    this.$zoomRange.attr("step", c);
                    break;
                case "startTransform":
                    this._buildTransform();
                    break;
                case "duration":
                case "easing":
                    this._buildTransition();
                case "transition":
                    this.transition();
                    break;
                case "panOnlyWhenZoomed":
                    this._checkPanWhenZoomed();
                    break;
                case "$set":
                    c instanceof b && c.length && (this.$set = c,
                    this._initStyle(),
                    this._buildTransform())
                }
            }, this))
        },
        _checkPanWhenZoomed: function(a) {
            var b = this.options;
            if (b.panOnlyWhenZoomed) {
                a || (a = this.getMatrix()[0]);
                var c = a <= b.minScale;
                b.disablePan !== c && this.option("disablePan", c)
            }
        },
        _initStyle: function() {
            var a = {
                "transform-origin": this.isSVG ? "0 0" : "50% 50%"
            };
            this.options.disablePan || (a.cursor = this.options.cursor),
            this.$set.css(a);
            var c = this.$parent;
            c.length && !b.nodeName(this.parent, "body") && (a = {
                overflow: "hidden"
            },
            "static" === c.css("position") && (a.position = "relative"),
            c.css(a))
        },
        _resetStyle: function() {
            this.$elem.css({
                cursor: "",
                transition: ""
            }),
            this.$parent.css({
                overflow: "",
                position: ""
            })
        },
        _bind: function() {
            var a = this
              , c = this.options
              , d = c.eventNamespace
              , e = "mousedown" + d + " pointerdown" + d + " MSPointerDown" + d
              , f = "touchstart" + d + " " + e
              , h = "touchend" + d + " click" + d + " pointerup" + d + " MSPointerUp" + d
              , i = {}
              , j = this.$reset
              , k = this.$zoomRange;
            if (b.each(["Start", "Change", "Zoom", "Pan", "End", "Reset"], function() {
                var a = c["on" + this];
                b.isFunction(a) && (i["panzoom" + this.toLowerCase() + d] = a)
            }),
            c.disablePan && c.disableZoom || (i[f] = function(b) {
                var d;
                ("touchstart" === b.type ? !(d = b.touches || b.originalEvent.touches) || (1 !== d.length || c.disablePan) && 2 !== d.length : c.disablePan || (b.which || b.originalEvent.which) !== c.which) || (b.preventDefault(),
                b.stopPropagation(),
                a._startMove(b, d))
            }
            ,
            3 === c.which && (i.contextmenu = !1)),
            this.$elem.on(i),
            j.length && j.on(h, function(b) {
                b.preventDefault(),
                a.reset()
            }),
            k.length && k.attr({
                step: c.rangeStep === g.defaults.rangeStep && k.attr("step") || c.rangeStep,
                min: c.minScale,
                max: c.maxScale
            }).prop({
                value: this.getMatrix()[0]
            }),
            !c.disableZoom) {
                var m = this.$zoomIn
                  , n = this.$zoomOut;
                m.length && n.length && (m.on(h, function(b) {
                    b.preventDefault(),
                    a.zoom()
                }),
                n.on(h, function(b) {
                    b.preventDefault(),
                    a.zoom(!0)
                })),
                k.length && (i = {},
                i[e] = function() {
                    a.transition(!0)
                }
                ,
                i[(l ? "input" : "change") + d] = function() {
                    a.zoom(+this.value, {
                        noSetRange: !0
                    })
                }
                ,
                k.on(i))
            }
        },
        _unbind: function() {
            this.$elem.add(this.$zoomIn).add(this.$zoomOut).add(this.$reset).off(this.options.eventNamespace)
        },
        _buildTransform: function() {
            return this._origTransform = this.getTransform(this.options.startTransform)
        },
        _buildTransition: function() {
            if (this._transform) {
                var a = this.options;
                this._transition = this._transform + " " + a.duration + "ms " + a.easing
            }
        },
        _getDistance: function(a) {
            var b = a[0]
              , c = a[1];
            return Math.sqrt(Math.pow(Math.abs(c.clientX - b.clientX), 2) + Math.pow(Math.abs(c.clientY - b.clientY), 2))
        },
        _getMiddle: function(a) {
            var b = a[0]
              , c = a[1];
            return {
                clientX: (c.clientX - b.clientX) / 2 + b.clientX,
                clientY: (c.clientY - b.clientY) / 2 + b.clientY
            }
        },
        _trigger: function(a) {
            "string" == typeof a && (a = "panzoom" + a),
            this.$elem.triggerHandler(a, [this].concat(j.call(arguments, 1)))
        },
        _startMove: function(a, d) {
            if (!this.panning) {
                var e, f, g, i, j, k, l, m, n = this, o = this.options, p = o.eventNamespace, q = this.getMatrix(), r = q.slice(0), s = +r[4], t = +r[5], u = {
                    matrix: q,
                    animate: "skip"
                }, v = a.type;
                "pointerdown" === v ? (e = "pointermove",
                f = "pointerup") : "touchstart" === v ? (e = "touchmove",
                f = "touchend") : "MSPointerDown" === v ? (e = "MSPointerMove",
                f = "MSPointerUp") : (e = "mousemove",
                f = "mouseup"),
                e += p,
                f += p,
                this.transition(!0),
                this.panning = !0,
                this._trigger("start", a, d);
                var w = function(a, b) {
                    if (b) {
                        if (2 === b.length) {
                            if (null != g)
                                return;
                            return g = n._getDistance(b),
                            i = +q[0],
                            void (j = n._getMiddle(b))
                        }
                        if (null != k)
                            return;
                        (m = b[0]) && (k = m.pageX,
                        l = m.pageY)
                    }
                    null == k && (k = a.pageX,
                    l = a.pageY)
                };
                w(a, d);
                var x = function(a) {
                    var b;
                    if (a.preventDefault(),
                    d = a.touches || a.originalEvent.touches,
                    w(a, d),
                    d) {
                        if (2 === d.length) {
                            var c = n._getMiddle(d)
                              , e = n._getDistance(d) - g;
                            return n.zoom(e * (o.increment / 100) + i, {
                                focal: c,
                                matrix: q,
                                animate: "skip"
                            }),
                            n.pan(+q[4] + c.clientX - j.clientX, +q[5] + c.clientY - j.clientY, u),
                            void (j = c)
                        }
                        b = d[0] || {
                            pageX: 0,
                            pageY: 0
                        }
                    }
                    b || (b = a),
                    n.pan(s + b.pageX - k, t + b.pageY - l, u)
                };
                b(h).off(p).on(e, x).on(f, function(a) {
                    a.preventDefault(),
                    b(this).off(p),
                    n.panning = !1,
                    a.type = "panzoomend",
                    n._trigger(a, q, !c(q, r))
                })
            }
        }
    },
    b.Panzoom = g,
    b.fn.panzoom = function(a) {
        var c, d, e, f;
        return "string" == typeof a ? (f = [],
        d = j.call(arguments, 1),
        this.each(function() {
            c = b.data(this, i),
            c ? "_" !== a.charAt(0) && "function" == typeof (e = c[a]) && void 0 !== (e = e.apply(c, d)) && f.push(e) : f.push(void 0)
        }),
        f.length ? 1 === f.length ? f[0] : f : this) : this.each(function() {
            new g(this,a)
        })
    }
    ,
    g
});
/*!
 *	Cliplister Content Integration Lib.
 *
 *	File:			cllib.inc.js
 *	Copyright by:           Cliplister GmbH
 *	Author: 		Cliplister GmbH
 *	Version:		2.5
 * 	lastChanges:            @Changelog.txt
 *
 */
(function(n, t) {
    function l(n) {
        return new Object(n)
    }
    if (n.Cliplister === t) {
        var c = function() {
            return new e
        }
          , r = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="
          , e = function() {}
          , i = n.document
          , o = "mycliplister.com/cliplister/";
        var h = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g, u, s, a = {
            "\b": "\\b",
            "\t": "\\t",
            "\n": "\\n",
            "\f": "\\f",
            "\r": "\\r",
            '"': '\\"',
            "\\": "\\\\"
        }, f;
        e.prototype = {
            doneRks: [],
            clips: [],
            tmplist: [],
            request: {},
            initialLoad: !0,
            log: [],
            tmp: [],
            config: {
                shopId: 0,
                SEO: !1,
                autoplay: !1,
                callbacks: {}
            },
            setID: function(n) {
                this.setshopId(n)
            },
            setshopId: function(n) {
                this.config.shopId = n
            },
            setSEO: function(n) {
                this.config.SEO = n
            },
            setAutoplay: function(n) {
                this.config.autoplay = n
            },
            player: function() {
                for (var n = 0; n < this.player.arguments.length; n++) {
                    this.player.arguments[n].mode = "player";
                    switch (this.clTypeOf(this.player.arguments[n])) {
                    case "string":
                        this.setID(this.player.arguments[n]);
                        break;
                    case "number":
                        this.setID(this.player.arguments[n]);
                        break;
                    case "boolean":
                        this.setSEO(this.player.arguments[n]);
                        break;
                    default:
                        this.addClip(this.player.arguments[n])
                    }
                }
            },
            thumbnail: function() {
                for (var n = 0; n < this.thumbnail.arguments.length; n++) {
                    this.thumbnail.arguments[n].mode = "thumbnail";
                    switch (this.clTypeOf(this.thumbnail.arguments[n])) {
                    case "string":
                        this.setID(this.thumbnail.arguments[n]);
                        break;
                    case "number":
                        this.setID(this.thumbnail.arguments[n]);
                        break;
                    case "boolean":
                        this.setSEO(this.thumbnail.arguments[n]);
                        break;
                    default:
                        this.addClip(this.thumbnail.arguments[n])
                    }
                }
            },
            onReadyBuildHTML: function(n) {
                if (this.initialLoad = !1,
                this.config.shopId === 0 && this.readshopId(n),
                this.readAutoplay(n),
                this.readSEO(n),
                this.addSEO(n),
                this.addshopId(n),
                typeof n == "undefined")
                    for (var t = 0; t < this.clips.length; t++)
                        this.clips[t].timer = (new Date).getTime();
                else
                    this.clips[n].timer = (new Date).getTime();
                this.buildRequest(n)
            },
            readshopId: function(n) {
                if (typeof n == "undefined") {
                    for (var i = 0; i < this.clips.length; i++)
                        if (this.clips[i].shopId !== t) {
                            this.config.shopId = this.clips[i].shopId;
                            break
                        }
                } else
                    this.clips[n].shopId !== t && (this.config.shopId = this.clips[n].shopId)
            },
            getCallback: function(n) {
                return this.config.callbacks[n]
            },
            readSEO: function(n) {
                if (typeof n == "undefined") {
                    for (var i = 0; i < this.clips.length; i++)
                        if (this.clips[i].SEO !== t) {
                            this.setSEO(this.clips[i].SEO);
                            break
                        }
                } else
                    this.clips[n].SEO !== t && this.setSEO(this.clips[n].SEO)
            },
            readAutoplay: function(n) {
                if (typeof n == "undefined") {
                    for (var i = 0; i < this.clips.length; i++)
                        if (this.clips[i].autoplay !== t) {
                            this.setAutoplay(this.clips[i].autoplay);
                            break
                        }
                } else
                    this.clips[n].autoplay !== t && this.setAutoplay(this.clips[n].autoplay)
            },
            addshopId: function(n) {
                if (typeof n == "undefined")
                    for (var t = 0; t < this.clips.length; t++)
                        this.clips[t].shopId = this.config.shopId;
                else
                    this.clips[n].shopId = this.config.shopId
            },
            addSEO: function(n) {
                if (typeof n == "undefined")
                    for (var t = 0; t < this.clips.length; t++)
                        this.clips[t].SEO = this.config.SEO;
                else
                    this.clips[n].SEO = this.config.SEO
            },
            addClip: function(n) {
                this.clTypeOf(n) === "array" ? this.clips = this.clips.concat(n) : this.clTypeOf(n) === "object" && this.clips.push(n)
            },
            checkVideoAvailability: function(n, t) {
                var i = new Image, r;
                i.onload = function() {
                    i.width < 2 ? n.style && (n.style.height = "0",
                    n.style.width = "0",
                    n.style.visibility = "hidden") : t && t()
                }
                ;
                r = n.src.replace(/\/ind/g, "");
                i.src = r.replace(/\?.*/g, "") + "/cx"
            },
            JSONstringify: function(n, t, i) {
                var r;
                if (u = "",
                s = "",
                typeof i == "number")
                    for (r = 0; r < i; r += 1)
                        s += " ";
                else
                    typeof i == "string" && (s = i);
                if (f = t,
                t && typeof t != "function" && (typeof t != "object" || typeof t.length != "number"))
                    throw new Error("this.JSONstringify");
                return this.JSONstr("", {
                    "": n
                })
            },
            JSONstr: function(n, t) {
                var r, h, e, c, l = u, o, i = t[n];
                typeof f == "function" && (i = f.call(t, n, i));
                switch (typeof i) {
                case "string":
                    return this.JSONquote(i);
                case "number":
                    return isFinite(i) ? String(i) : "null";
                case "boolean":
                case "null":
                    return String(i);
                case "object":
                    if (!i)
                        return "null";
                    if (u += s,
                    o = [],
                    Object.prototype.toString.apply(i) === "[object Array]") {
                        for (c = i.length,
                        r = 0; r < c; r += 1)
                            o[r] = this.JSONstr(r, i) || "null";
                        return e = o.length === 0 ? "[]" : u ? "[\n" + u + o.join(",\n" + u) + "\n" + l + "]" : "[" + o.join(",") + "]",
                        u = l,
                        e
                    }
                    if (f && typeof f == "object")
                        for (c = f.length,
                        r = 0; r < c; r += 1)
                            typeof f[r] == "string" && (h = f[r],
                            e = this.JSONstr(h, i),
                            e && o.push(this.JSONquote(h) + (u ? ": " : ":") + e));
                    else
                        for (h in i)
                            Object.prototype.hasOwnProperty.call(i, h) && (e = this.JSONstr(h, i),
                            e && o.push(this.JSONquote(h) + (u ? ": " : ":") + e));
                    return e = o.length === 0 ? "{}" : u ? "{\n" + u + o.join(",\n" + u) + "\n" + l + "}" : "{" + o.join(",") + "}",
                    u = l,
                    e
                }
            },
            JSONquote: function(n) {
                return h.lastIndex = 0,
                h.test(n) ? '"' + n.replace(h, function(n) {
                    var t = a[n];
                    return typeof t == "string" ? t : "\\u" + ("0000" + n.charCodeAt(0).toString(16)).slice(-4)
                }) + '"' : '"' + n.replace(/[\u00A0-\u2666<>\&]/g, function(n) {
                    return "&#" + n.charCodeAt(0) + ";"
                }) + '"'
            },
            clTypeOf: function(n) {
                return typeof n == "object" ? n.length ? "array" : "object" : typeof n
            },
            getHTML: function(u, f, e) {
                var s = this.clips[u].playerID, c, h, l, d, a, v, y;
                s || (s = e ? e : "Cliplister_" + this.getRandom(100, 999999999999),
                this.clips[u].playerID = s);
                this.clips[u].onReady && typeof this.clips[u].onReady == "function" && (this.config.callbacks[s] = this.clips[u].onReady);
                var w = this.clips[u].urlPattern !== t ? this.clips[u].urlPattern : "lcplay"
                  , b = this.config.autoplay !== t ? this.config.autoplay : "false"
                  , p = "";
                if (this.clips[u].param !== t)
                    for (c in this.clips[u].param)
                        p += "&" + c + "=" + encodeURIComponent(this.clips[u].param[c]);
                if (h = this.clips[u].geo,
                this.clips[u].mode == "player") {
                    l = n.location.protocol + "//" + (h ? h + "." : "") + o + w + r.charAt(63) + this.clips[u].shopId + r.charAt(63) + this.clips[u].request + "?id=" + s + "&autoplay=" + b + p;
                    function k(n, t) {
                        for (var r = t.length, i = 0; i < r; i++)
                            if (t[i] == n)
                                return !0;
                        return !1
                    }
                    d = this.clips[u].seoString !== t ? this.clips[u].seoString : "";
                    this.clips[u].request && (i.getElementById(s) || (a = i.createElement("div"),
                    a.id = s,
                    f.appendChild(a)),
                    typeof this.clips[u].indirect == "boolean" && this.clips[u].indirect ? (v = n.Cliplister.clips[u].size.split("x"),
                    i.getElementById(s).innerHTML += '<iframe width="' + v[0] + '" height="' + v[1] + '" src="' + l + '" frameborder="0" onload="javascript:Cliplister.checkVideoAvailability(this)" scrolling="no"><\/iframe>') : k(this.clips[u].request, this.doneRks) || this.ajax(l, !0, this.setupResponse, u))
                } else
                    this.clips[u].mode == "thumbnail" && this.clips[u].request && (y = this,
                    this.checkVideoAvailability({
                        src: n.location.protocol + "//" + (h ? h + "." : "") + o + "lcplay" + r.charAt(63) + this.clips[u].shopId + r.charAt(63) + this.clips[u].request + "/cx"
                    }, function() {
                        var t = i.createElement("img");
                        t.onload = function() {
                            f.appendChild(this)
                        }
                        ;
                        t.src = n.location.protocol + "//" + (h ? h + "." : "") + o + "thumbnail" + r.charAt(63) + y.clips[u].shopId + r.charAt(63) + y.clips[u].request
                    }))
            },
            setupResponse: function(n, r) {
                if (typeof n !== t) {
                    e.clips[r].response = n;
                    try {
                        eval(n.responseText + "")
                    } catch (f) {
                        if (n.responseText.replace(/^[\s\xA0]+/, "").replace(/[\s\xA0]+$/, "").match("^<")) {
                            var u = n.responseText;
                            u.replace(/\ /g, "").match("position:absolute;") && (u = u.replace(/ style=\"([a-z:0-9;]*)\"/g, ""));
                            i.getElementById(e.clips[r].playerID).innerHTML == "" && (i.getElementById(e.clips[r].playerID).innerHTML = u)
                        }
                    }
                }
            },
            buildRequest: function(i) {
                var f = 0, u;
                if (typeof i == "undefined")
                    for (u = 0; u < this.clips.length; u++)
                        this.request[u] = !0,
                        this.clips[u] && !this.clips[u].response && this.config.shopId && (this.request[u] = !1,
                        this.tmp[u] = this.tmp[u] || {},
                        this.tmp[u].elementID = this.clips[u].elementID,
                        this.clips[u].elementID = t,
                        this.tmp[u].mode = this.clips[u].mode,
                        this.clips[u].mode = t,
                        this.ajax(n.location.protocol + "//" + o + "lc" + r.charAt(63) + this.config.shopId + r.charAt(63) + "?" + this.encode(this.JSONstringify([this.clips[u]])), !0, function(i, r) {
                            var u, f, o;
                            e = n.Cliplister;
                            try {
                                u = eval("(" + i.responseText + ")");
                                n.Cliplister.clips[r] = Object.deepExtend(n.Cliplister.clips[r], u != t ? u[0] : []);
                                n.Cliplister.clips[r].elementID = n.Cliplister.tmp[r].elementID;
                                n.Cliplister.clips[r].mode = n.Cliplister.tmp[r].mode;
                                n.Cliplister.tmplist.length > 0 && (n.Cliplister.clips = n.Cliplister.tmplist.concat(n.Cliplister.clips),
                                n.Cliplister.tmplist = []);
                                n.Cliplister.request[r] = !0;
                                f = !0;
                                for (o in n.Cliplister.request)
                                    n.Cliplister.request[o] || (f = !1);
                                f && n.Cliplister.setupClipBuild()
                            } catch (s) {}
                        }, u),
                        f++);
                else
                    this.request[i] = !0,
                    this.clips[i] && !this.clips[i].response && this.config.shopId && (this.request[i] = !1,
                    this.tmp[i] = this.tmp[i] || {},
                    this.tmp[i].elementID = this.clips[i].elementID,
                    this.clips[i].elementID = t,
                    this.tmp[i].mode = this.clips[i].mode,
                    this.clips[i].mode = t,
                    this.ajax(n.location.protocol + "//" + o + "lc" + r.charAt(63) + this.config.shopId + r.charAt(63) + "?" + this.encode(this.JSONstringify([this.clips[i]])), !0, function(r, u) {
                        var f, o, s;
                        e = n.Cliplister;
                        try {
                            f = eval("(" + r.responseText + ")");
                            n.Cliplister.clips[u] = Object.deepExtend(n.Cliplister.clips[u], f != t ? f[0] : []);
                            n.Cliplister.clips[u].elementID = n.Cliplister.tmp[u].elementID;
                            n.Cliplister.clips[u].mode = n.Cliplister.tmp[u].mode;
                            n.Cliplister.tmplist.length > 0 && (n.Cliplister.clips = n.Cliplister.tmplist.concat(n.Cliplister.clips),
                            n.Cliplister.tmplist = []);
                            n.Cliplister.request[u] = !0;
                            o = !0;
                            for (s in n.Cliplister.request)
                                n.Cliplister.request[s] || (o = !1);
                            o && n.Cliplister.setupClipBuild(i)
                        } catch (h) {}
                    }, i),
                    f++);
                f == 0 && this.setupClipBuild(i)
            },
            reloadClips: function(n) {
                for (var t, u, r = 0; r < this.clips.length; r++)
                    if (typeof n == "undefined") {
                        if (t = i.getElementById(this.clips[r].playerID),
                        t)
                            while (t.hasChildNodes())
                                t.removeChild(t.firstChild)
                    } else if (this.clips[r].elementID == n) {
                        if (u = r,
                        t = i.getElementById(n),
                        t)
                            while (t.hasChildNodes())
                                t.removeChild(t.firstChild);
                        break
                    }
                this.onReadyBuildHTML(u)
            },
            setupClipBuild: function(n) {
                var r, u;
                if (typeof n == "undefined")
                    for (r = 0; r < this.clips.length; r++)
                        this.clips[r].elementID !== t && (u = i.getElementById(this.clips[r].elementID),
                        u && this.getHTML(r, u));
                else
                    u = i.getElementById(this.clips[n].elementID),
                    u && this.getHTML(n, u)
            },
            getRandom: function(n, t) {
                if (n > t)
                    return -1;
                if (n == t)
                    return n;
                var i;
                do
                    i = Math.random();
                while (i == 1);return n + parseInt(i * (t - n + 1))
            },
            ajax: function(t, i, r, u) {
                var f = null;
                !n.XDomainRequest && n.XMLHttpRequest ? (f = new XMLHttpRequest,
                f.open("GET", t, i),
                f.timeout = 5e3,
                f.onreadystatechange = function() {
                    f.readyState == 4 && (f.status == 200 && f.responseText != "" ? r(f, u) : f.abort())
                }
                ) : (f = new XDomainRequest,
                f.timeout = 5e3,
                f.onload = function() {
                    r(f, u)
                }
                ,
                f.onprogress = function() {}
                ,
                f.ontimeout = function() {}
                ,
                f.onerror = function() {}
                ,
                f.open("GET", t));
                n.setTimeout(function() {
                    f.send()
                }, 0)
            },
            ajaxPOST: function(t, i, r, u, f) {
                var e = null;
                !n.XDomainRequest && n.XMLHttpRequest ? (e = new XMLHttpRequest,
                e.open("POST", t, r),
                e.timeout = 5e3,
                e.setRequestHeader("Content-type", "application/x-www-form-urlencoded"),
                e.onreadystatechange = function() {
                    e.readyState == 4 && e.status == 200 && e.responseText != "" && u(e, f)
                }
                ) : (e = new XDomainRequest,
                e.timeout = 5e3,
                e.onload = function() {
                    u(e, f)
                }
                ,
                e.onprogress = function() {}
                ,
                e.ontimeout = function() {}
                ,
                e.onerror = function() {}
                ,
                e.open("POST", t));
                n.setTimeout(function() {
                    e.send("cldata=" + i)
                }, 0)
            },
            loadJS: function(n, r) {
                var e = i.getElementsByTagName("HEAD").item(0)
                  , u = i.createElement("script")
                  , f = !1;
                u.language = "javascript";
                u.type = "text/javascript";
                typeof r === t && (r = function() {}
                );
                u.onreadystatechange = u.onload = function() {
                    f || this.readyState && !/loaded|complete/.test(this.readyState) || (f = !0,
                    r())
                }
                ;
                u.src = n;
                e.appendChild(u)
            },
            encode: function(n) {
                n = escape(n);
                var s = "", f, t, i = "", h, c, e, u = "", o = 0;
                do
                    f = n.charCodeAt(o++),
                    t = n.charCodeAt(o++),
                    i = n.charCodeAt(o++),
                    h = f >> 2,
                    c = (f & 3) << 4 | t >> 4,
                    e = (t & 15) << 2 | i >> 6,
                    u = i & 63,
                    isNaN(t) ? e = u = 64 : isNaN(i) && (u = 64),
                    s = s + r.charAt(h) + r.charAt(c) + r.charAt(e) + r.charAt(u),
                    f = t = i = "",
                    h = c = e = u = "";
                while (o < n.length);return s
            },
            decode: function(n) {
                var t = "", o, s, h = "", c, f, i, e = "", u = 0;
                /[^A-Za-z0-9\+\/\=]/g.exec(n);
                n = n.replace(/[^A-Za-z0-9\+\/\=]/g, "");
                do
                    c = r.indexOf(n.charAt(u++)),
                    f = r.indexOf(n.charAt(u++)),
                    i = r.indexOf(n.charAt(u++)),
                    e = r.indexOf(n.charAt(u++)),
                    o = c << 2 | f >> 4,
                    s = (f & 15) << 4 | i >> 2,
                    h = (i & 3) << 6 | e,
                    t = t + String.fromCharCode(o),
                    i !== 64 && (t = t + String.fromCharCode(s)),
                    e !== 64 && (t = t + String.fromCharCode(h)),
                    o = s = h = "",
                    c = f = i = e = "";
                while (u < n.length);return unescape(t)
            },
            addLoadEvent: function(t) {
                var i = n.onload;
                n.onload = typeof n.onload != "function" ? t : function() {
                    try {
                        i()
                    } catch (n) {}
                    t()
                }
            }
        };
        n.Cliplister = n.CL = c();
        n.Clip = l;
        i.addEventListener ? i.addEventListener("DOMContentLoaded", function() {
            n.Cliplister.addLoadEvent(function() {
                i.removeEventListener("DOMContentLoaded", arguments.callee, !1);
                n.Cliplister.initialLoad && n.Cliplister.clips.length > 0 && n.Cliplister.onReadyBuildHTML()
            })
        }, !1) : i.attachEvent && i.attachEvent("onreadystatechange", function() {
            (i.readyState === "complete" || i.readyState === "loaded") && n.Cliplister.addLoadEvent(function() {
                i.detachEvent("onreadystatechange", arguments.callee);
                n.Cliplister.clips.length > 0 && n.Cliplister.onReadyBuildHTML()
            })
        });
        Object.isObjectLiteral = function(n) {
            return n && n.constructor && n.constructor === Object
        }
        ;
        Object.deepExtend = function(n, t) {
            for (var i in t)
                Object.isObjectLiteral(n[i]) && Object.isObjectLiteral(t[i]) ? (n[i] = n[i] || {},
                arguments.callee(n[i], t[i])) : n[i] = t[i];
            return n
        }
    }
}
)(window, undefined)

/*


   Magic 360 v4.6.4
   Copyright 2016 Magic Toolbox
   Buy a license: https://www.magictoolbox.com/magic360/
   License agreement: https://www.magictoolbox.com/license/


*/
eval(function(m, a, g, i, c, k) {
    c = function(e) {
        return (e < a ? '' : c(parseInt(e / a))) + ((e = e % a) > 35 ? String.fromCharCode(e + 29) : e.toString(36))
    }
    ;
    if (!''.replace(/^/, String)) {
        while (g--) {
            k[c(g)] = i[g] || c(g)
        }
        i = [function(e) {
            return k[e]
        }
        ];
        c = function() {
            return '\\w+'
        }
        ;
        g = 1
    }
    ;while (g--) {
        if (i[g]) {
            m = m.replace(new RegExp('\\b' + c(g) + '\\b','g'), i[g])
        }
    }
    return m
}('1a 6V=(17(){1a s,u;s=u=(17(){1a N={4D:"gc.3-b4",cQ:0,8c:{},$aY:17(R){18(R.$64||(R.$64=++H.cQ))},8v:17(R){18(H.8c[R]||(H.8c[R]={}))},$F:17(){},$1e:17(){18 1e},$1k:17(){18 1k},dP:"e5-"+1j.3x(1j.71()*1p bk().d0()),30:17(R){18(2y!=R)},aP:17(S,R){18(2y!=S)?S:R},4y:17(R){18!!(R)},1F:17(R){if(!H.30(R)){18 1e}if(R.$4J){18 R.$4J}if(!!R.63){if(1==R.63){18"88"}if(3==R.63){18"cA"}}if(R.1v&&R.dw){18"jp"}if(R.1v&&R.9d){18"2m"}if((R 5t 1f.e4||R 5t 1f.b0)&&R.51===H.3B){18"5V"}if(R 5t 1f.57){18"3N"}if(R 5t 1f.b0){18"17"}if(R 5t 1f.aF){18"1N"}if(H.1c.3F){if(H.30(R.bR)){18"1s"}}1r{if(R===1f.1s||R.51==1f.1m||R.51==1f.jq||R.51==1f.jH||R.51==1f.h5||R.51==1f.h3){18"1s"}}if(R 5t 1f.bk){18"6h"}if(R 5t 1f.a8){18"iC"}if(R===1f){18"1f"}if(R===1h){18"1h"}18 93(R)},21:17(W,V){if(!(W 5t 1f.57)){W=[W]}if(!V){18 W[0]}1L(1a U=0,S=W.1v;U<S;U++){if(!H.30(W)){7W}1L(1a T in V){if(!e4.1D.4b.1W(V,T)){7W}2Y{W[U][T]=V[T]}3k(R){}}}18 W[0]},8t:17(V,U){if(!(V 5t 1f.57)){V=[V]}1L(1a T=0,R=V.1v;T<R;T++){if(!H.30(V[T])){7W}if(!V[T].1D){7W}1L(1a S in(U||{})){if(!V[T].1D[S]){V[T].1D[S]=U[S]}}}18 V[0]},cP:17(T,S){if(!H.30(T)){18 T}1L(1a R in(S||{})){if(!T[R]){T[R]=S[R]}}18 T},$2Y:17(){1L(1a S=0,R=2m.1v;S<R;S++){2Y{18 2m[S]()}3k(T){}}18 1i},$A:17(T){if(!H.30(T)){18 H.$([])}if(T.e7){18 H.$(T.e7())}if(T.dw){1a S=T.1v||0,R=1p 57(S);4B(S--){R[S]=T[S]}18 H.$(R)}18 H.$(57.1D.aK.1W(T))},4L:17(){18 1p bk().d0()},5h:17(V){1a T;5G(H.1F(V)){1x"cW":T={};1L(1a U in V){T[U]=H.5h(V[U])}1I;1x"3N":T=[];1L(1a S=0,R=V.1v;S<R;S++){T[S]=H.5h(V[S])}1I;1w:18 V}18 H.$(T)},$:17(T){1a R=1k;if(!H.30(T)){18 1i}if(T.$bh){18 T}5G(H.1F(T)){1x"3N":T=H.cP(T,H.21(H.57,{$bh:H.$F}));T.3D=T.eN;18 T;1I;1x"1N":1a S=1h.cd(T);if(H.30(S)){18 H.$(S)}18 1i;1I;1x"1f":1x"1h":H.$aY(T);T=H.21(T,H.3l);1I;1x"88":H.$aY(T);T=H.21(T,H.3T);1I;1x"1s":T=H.21(T,H.1m);1I;1x"cA":1x"17":1x"3N":1x"6h":1w:R=1e;1I}if(R){18 H.21(T,{$bh:H.$F})}1r{18 T}},$1p:17(R,T,S){18 H.$(H.7M.89(R)).96(T||{}).1G(S||{})},4a:17(S,U,Y){1a V,T,W,X=[],R=-1;Y||(Y=H.dP);V=H.$(Y)||H.$1p("2G",{id:Y,1n:"4m/9f"}).2r((1h.fA||1h.3A),"1z");T=V.dR||V.eJ;if("1N"!=H.1F(U)){1L(1a W in U){X.2U(W+":"+U[W])}U=X.4O(";")}if(T.bS){R=T.bS(S+" {"+U+"}",T.f3.1v)}1r{R=T.iZ(S,U)}18 R},d6:17(U,R){1a T,S;T=H.$(U);if("88"!==H.1F(T)){18}S=T.dR||T.eJ;if(S.eG){S.eG(R)}1r{if(S.eH){S.eH(R)}}},ia:17(){18"ib-ic-hl-h2-h0".2C(/[ha]/g,17(T){1a S=1j.71()*16|0,R=T=="x"?S:(S&3|8);18 R.8j(16)}).8d()},hG:(17(){1a R;18 17(S){if(!R){R=1h.89("a")}R.7o("8X",S);18("!!"+R.8X).2C("!!","")}})(),k4:17(T){1a U=0,R=T.1v;1L(1a S=0;S<R;++S){U=31*U+T.dO(S);U%=ju}18 U}};1a H=N;1a I=N.$;if(!1f.dk){1f.dk=N;1f.$e5=N.$}H.57={$4J:"3N",4u:17(U,V){1a R=13.1v;1L(1a S=13.1v,T=(V<0)?1j.1Z(0,S+V):V||0;T<S;T++){if(13[T]===U){18 T}}18-1},3g:17(R,S){18 13.4u(R,S)!=-1},eN:17(R,U){1L(1a T=0,S=13.1v;T<S;T++){if(T in 13){R.1W(U,13[T],T,13)}}},2H:17(R,W){1a V=[];1L(1a U=0,S=13.1v;U<S;U++){if(U in 13){1a T=13[U];if(R.1W(W,13[U],U,13)){V.2U(T)}}}18 V},gF:17(R,V){1a U=[];1L(1a T=0,S=13.1v;T<S;T++){if(T in 13){U[T]=R.1W(V,13[T],T,13)}}18 U}};H.8t(aF,{$4J:"1N",3W:17(){18 13.2C(/^\\s+|\\s+$/g,"")},eq:17(R,S){18(S||1e)?(13.8j()===R.8j()):(13.5e().8j()===R.5e().8j())},5x:17(){18 13.2C(/-\\D/g,17(R){18 R.8T(1).8d()})},9P:17(){18 13.2C(/[A-Z]/g,17(R){18("-"+R.8T(0).5e())})},a6:17(R){18 3n(13,R||10)},gP:17(){18 2n(13)},cV:17(){18!13.2C(/1k/i,"").3W()},8m:17(S,R){R=R||"";18(R+13+R).4u(R+S+R)>-1}});N.8t(b0,{$4J:"17",1u:17(){1a S=H.$A(2m),R=13,T=S.5W();18 17(){18 R.6E(T||1i,S.a7(H.$A(2m)))}},48:17(){1a S=H.$A(2m),R=13,T=S.5W();18 17(U){18 R.6E(T||1i,H.$([U||(H.1c.2f?1f.1s:1i)]).a7(S))}},2q:17(){1a S=H.$A(2m),R=13,T=S.5W();18 1f.4z(17(){18 R.6E(R,S)},T||0)},cB:17(){1a S=H.$A(2m),R=13;18 17(){18 R.2q.6E(R,S)}},dm:17(){1a S=H.$A(2m),R=13,T=S.5W();18 1f.gw(17(){18 R.6E(R,S)},T||0)}});1a O={},G=2e.aG.5e(),F=G.3m(/(3f|8G|3F|9l)\\/(\\d+\\.?\\d*)/i),K=G.3m(/(gW|a3)\\/(\\d+\\.?\\d*)/i)||G.3m(/(e0|8O|dF|bL|8g|a3)\\/(\\d+\\.?\\d*)/i),M=G.3m(/4D\\/(\\d+\\.?\\d*)/i),B=1h.5j.2G;17 C(S){1a R=S.8T(0).8d()+S.aK(1);18 S in B||("dW"+R)in B||("dY"+R)in B||("5U"+R)in B||("O"+R)in B}H.1c={2Q:{f5:!!(1h.fq),ft:!!(1f.c2),fy:!!(1h.fw),4A:!!(1h.fb||1h.ff||1h.6A||1h.ed||1h.fi||1h.fh||1h.fp||1h.f1||1h.fk),aE:!!(1f.jc)&&!!(1f.jo)&&(1f.9j&&"jI"in 1p 9j),2W:C("2W"),4V:C("4V"),cp:C("cp"),cT:C("cT"),4X:1e,aC:1e,9O:1e,3c:1e,8J:(17(){18 1h.j4.iV("iU://k2.hE.hN/hO/h9/gY#hT","1.1")})()},2M:17(){18"hV"in 1f||(1f.ew&&1h 5t ew)||(2e.ii>0)||(2e.io>0)}(),4n:G.3m(/(8H|bb\\d+|iR).+|iz|hg\\/|hf|hj|hm|gZ|hu|k7|kd|ip(dI|eC|ad)|k9|k0|jS |jR|jT|kf|4n.+bL|ku|8g m(kD|in)i|kt( kk)?|cR|p(kr|jb)\\/|ja|j8|j9|jd(4|6)0|jg|iY|iX\\.(1c|iW)|jz|jy|dJ (ce|cR)|jt|fL/)?1k:1e,7m:(F&&F[1])?F[1].5e():(1f.8g)?"9l":!!(1f.f7)?"3F":(2y!==1h.i8||1i!=1f.f4)?"8G":(1i!==1f.eQ||!2e.eW)?"3f":"fu",4D:(F&&F[2])?2n(F[2]):0,7r:(K&&K[1])?K[1].5e():"",8R:(K&&K[2])?2n(K[2]):0,dV:"",aB:"",4W:"",2f:0,67:G.3m(/ip(?:ad|eC|dI)/)?"8z":(G.3m(/(?:eR|8H)/)||2e.67.3m(/eU|9u|fm/i)||["fo"])[0].5e(),7G:1h.8N&&"dM"==1h.8N.5e(),by:0,59:17(){18(1h.8N&&"dM"==1h.8N.5e())?1h.3A:1h.5j},4X:1f.4X||1f.fj||1f.fg||1f.fe||1f.fa||2y,9z:1f.9z||1f.dz||1f.dz||1f.f9||1f.fc||1f.fd||2y,56:1e,4o:17(){if(H.1c.56){18}1a U,T;H.1c.56=1k;H.3A=H.$(1h.3A);H.9u=H.$(1f);2Y{1a S=H.$1p("2b").1G({1d:1Q,1g:1Q,5w:"8r",2P:"4f",1z:-dc}).2r(1h.3A);H.1c.by=S.c5-S.91;S.2F()}3k(R){}2Y{U=H.$1p("2b");T=U.2G;T.e3="6I:37(9Q://),37(9Q://),fv 37(9Q://)";H.1c.2Q.aC=(/(37\\s*\\(.*?){3}/).2S(T.6I);T=1i;U=1i}3k(R){}if(!H.1c.e6){H.1c.e6=H.aH("4V").9P()}2Y{U=H.$1p("2b");U.2G.e3=H.aH("2H").9P()+":fz(f6);";H.1c.2Q.9O=!!U.2G.1v&&(!H.1c.2f||H.1c.2f>9);U=1i}3k(R){}if(!H.1c.2Q.9O){H.$(1h.5j).2k("9g-eS-3h")}2Y{H.1c.2Q.3c=(17(){1a V=H.$1p("3c");18!!(V.7Y&&V.7Y("2d"))})()}3k(R){}if(2y===1f.eT&&2y!==1f.eV){O.eX="f2"}H.3l.2R.1W(H.$(1h),"7U")}};(17(){1a W=[],V,U,S;17 R(){18!!(2m.9d.ax)}5G(H.1c.7m){1x"3F":if(!H.1c.4D){H.1c.4D=!!(1f.9j)?3:2}1I;1x"8G":H.1c.4D=(K&&K[2])?2n(K[2]):0;1I}H.1c[H.1c.7m]=1k;if(K&&"e0"===K[1]){H.1c.7r="8O"}if(!!1f.8O){H.1c.8O=1k}if(K&&"a3"===K[1]){H.1c.7r="8g";H.1c.8g=1k}if("dF"===H.1c.7r&&(M&&M[1])){H.1c.8R=2n(M[1])}if("8H"==H.1c.67&&H.1c.3f&&(M&&M[1])){H.1c.e1=1k}V=({8G:["-7x-","dY","7x"],3f:["-3f-","dW","3f"],3F:["-5U-","5U","5U"],9l:["-o-","O","o"]})[H.1c.7m]||["","",""];H.1c.dV=V[0];H.1c.aB=V[1];H.1c.4W=V[2];H.1c.2f=(!H.1c.3F)?2y:(1h.dU)?1h.dU:17(){1a X=0;if(H.1c.7G){18 5}5G(H.1c.4D){1x 2:X=6;1I;1x 3:X=7;1I}18 X}();W.2U(H.1c.67+"-3h");if(H.1c.4n){W.2U("4n-3h")}if(H.1c.e1){W.2U("8H-1c-3h")}if(H.1c.2f){H.1c.7r="ie";H.1c.8R=H.1c.2f;W.2U("ie"+H.1c.2f+"-3h");1L(U=11;U>H.1c.2f;U--){W.2U("gi-ie"+U+"-3h")}}if(H.1c.3f&&H.1c.4D<gn){H.1c.2Q.4A=1e}if(H.1c.4X){H.1c.4X.1W(1f,17(){H.1c.2Q.4X=1k})}if(H.1c.2Q.8J){W.2U("8J-3h")}1r{W.2U("9g-8J-3h")}S=(1h.5j.5Y||"").3m(/\\S+/g)||[];1h.5j.5Y=H.$(S).a7(W).4O(" ");2Y{1h.5j.7o("7l-3h-dA",H.1c.7r);1h.5j.7o("7l-3h-dA-gR",H.1c.8R)}3k(T){}if(H.1c.2f&&H.1c.2f<9){1h.89("gV");1h.89("gU")}})();(17(){H.1c.4A={9n:H.1c.2Q.4A,9L:17(){18!!(1h.gT||1h[H.1c.4W+"gN"]||1h.4A||1h.gM||1h[H.1c.4W+"gG"])},bC:17(R,S){S||(S={});if(13.9n){H.$(1h).1t(13.9W,13.ds=17(T){if(13.9L()){S.bE&&S.bE()}1r{H.$(1h).1O(13.9W,13.ds);S.bD&&S.bD()}}.48(13));H.$(1h).1t(13.a2,13.5r=17(T){S.7R&&S.7R();H.$(1h).1O(13.a2,13.5r)}.48(13));(R[H.1c.4W+"gh"]||R[H.1c.4W+"gg"]||R.fP||17(){}).1W(R)}1r{if(S.7R){S.7R()}}},cM:(1h.6A||1h.ed||1h[H.1c.4W+"fN"]||1h[H.1c.4W+"fT"]||17(){}).1u(1h),9W:1h.dH?"fS":(1h.6A?"":H.1c.4W)+"fK",a2:1h.dH?"fD":(1h.6A?"":H.1c.4W)+"fC",fF:H.1c.4W,fJ:1i}})();1a Q=/\\S+/g,E=/^(3i(eI|en|ee|eh)fV)|((5i|6C)(eI|en|ee|eh))$/,J={"ge":("2y"===93(B.ep))?"g6":"ep"},L={dX:1k,g0:1k,3w:1k,9b:1k,4k:1k},D=(1f.ey)?17(T,R){1a S=1f.ey(T,1i);18 S?S.fY(R)||S[R]:1i}:17(U,S){1a T=U.g1,R=1i;R=T?T[S]:1i;if(1i==R&&U.2G&&U.2G[S]){R=U.2G[S]}18 R};17 P(T){1a R,S;S=(H.1c.3f&&"2H"==T)?1e:(T in B);if(!S){R=H.1c.aB+T.8T(0).8d()+T.aK(1);if(R in B){18 R}}18 T}H.aH=P;H.3T={74:17(R){18!(R||"").8m(" ")&&(13.5Y||"").8m(R," ")},2k:17(V){1a S=(13.5Y||"").3m(Q)||[],U=(V||"").3m(Q)||[],R=U.1v,T=0;1L(;T<R;T++){if(!H.$(S).3g(U[T])){S.2U(U[T])}}13.5Y=S.4O(" ");18 13},7d:17(W){1a S=(13.5Y||"").3m(Q)||[],V=(W||"").3m(Q)||[],R=V.1v,U=0,T;1L(;U<R;U++){if((T=H.$(S).4u(V[U]))>-1){S.8A(T,1)}}13.5Y=W?S.4O(" "):"";18 13},g4:17(R){18 13.74(R)?13.7d(R):13.2k(R)},2E:17(S){1a T=S.5x(),R=1i;S=J[T]||(J[T]=P(T));R=D(13,S);if("2i"===R){R=1i}if(1i!==R){if("3w"==S){18 H.30(R)?2n(R):1}if(E.2S(S)){R=3n(R,10)?R:"eM"}}18 R},8B:17(S,R){1a U=S.5x();2Y{if("3w"==S){13.6t(R);18 13}S=J[U]||(J[U]=P(U));13.2G[S]=R+(("2J"==H.1F(R)&&!L[U])?"5L":"")}3k(T){}18 13},1G:17(S){1L(1a R in S){13.8B(R,S[R])}18 13},g3:17(){1a R={};H.$A(2m).3D(17(S){R[S]=13.2E(S)},13);18 R},6t:17(T,R){1a S;R=R||1e;13.2G.3w=T;T=3n(2n(T)*1Q);if(R){if(0===T){if("3p"!=13.2G.3j){13.2G.3j="3p"}}1r{if("65"!=13.2G.3j){13.2G.3j="65"}}}if(H.1c.2f&&H.1c.2f<9){if(!6R(T)){if(!~13.2G.2H.4u("aI")){13.2G.2H+=" b1:aW.aV.aI(8n="+T+")"}1r{13.2G.2H=13.2G.2H.2C(/8n=\\d*/i,"8n="+T)}}1r{13.2G.2H=13.2G.2H.2C(/b1:aW.aV.aI\\(8n=\\d*\\)/i,"").3W();if(""===13.2G.2H){13.2G.g2("2H")}}}18 13},96:17(R){1L(1a S in R){if("5V"===S){13.2k(""+R[S])}1r{13.7o(S,""+R[S])}}18 13},fX:17(){1a S=0,R=0;S=13.2E("2W-43");R=13.2E("2W-fZ");S=S.4u("5U")>-1?2n(S):S.4u("s")>-1?2n(S)*8Z:0;R=R.4u("5U")>-1?2n(R):R.4u("s")>-1?2n(R)*8Z:0;18 S+R},4Y:17(){18 13.1G({2N:"2p",3j:"3p"})},5q:17(){18 13.1G({2N:"",3j:"65"})},29:17(){18{1d:13.c5,1g:13.g7}},gd:17(S){1a R=13.29();R.1d-=(2n(13.2E("3i-1M-1d")||0)+2n(13.2E("3i-3I-1d")||0));R.1g-=(2n(13.2E("3i-1z-1d")||0)+2n(13.2E("3i-4d-1d")||0));if(!S){R.1d-=(2n(13.2E("5i-1M")||0)+2n(13.2E("5i-3I")||0));R.1g-=(2n(13.2E("5i-1z")||0)+2n(13.2E("5i-4d")||0))}18 R},7c:17(){18{1z:13.9B,1M:13.9C}},gf:17(){1a R=13,S={1z:0,1M:0};do{S.1M+=R.9C||0;S.1z+=R.9B||0;R=R.5l}4B(R);18 S},be:17(){1a V=13,S=0,U=0;if(H.30(1h.5j.bV)){1a R=13.bV(),T=H.$(1h).7c(),W=H.1c.59();18{1z:R.1z+T.y-W.gb,1M:R.1M+T.x-W.g8}}do{S+=V.g9||0;U+=V.ga||0;V=V.fW}4B(V&&!(/^(?:3A|fH)$/i).2S(V.90));18{1z:U,1M:S}},6K:17(){1a S=13.be();1a R=13.29();18{1z:S.1z,4d:S.1z+R.1g,1M:S.1M,3I:S.1M+R.1d}},dC:17(S){2Y{13.fI=S}3k(R){13.fG=S}18 13},2F:17(){18(13.5l)?13.5l.7p(13):13},6s:17(){H.$A(13.fB).3D(17(R){if(3==R.63||8==R.63){18}H.$(R).6s()});13.2F();13.bq();if(13.$64){H.8c[13.$64]=1i;4C H.8c[13.$64]}18 1i},3C:17(T,S){S=S||"4d";1a R=13.2v;("1z"==S&&R)?13.fE(T,R):13.eD(T);18 13},2r:17(T,S){1a R=H.$(T).3C(13,S);18 13},dK:17(R){13.3C(R.5l.8k(13,R));18 13},bf:17(R){if("88"!==H.1F("1N"==H.1F(R)?R=1h.cd(R):R)){18 1e}18(13==R)?1e:(13.3g&&!(H.1c.bH))?(13.3g(R)):(13.c9)?!!(13.c9(R)&16):H.$A(13.8W(R.90)).3g(R)}};H.3T.fU=H.3T.2E;H.3T.fR=H.3T.1G;if(!1f.3T){1f.3T=H.$F;if(H.1c.7m.3f){1f.1h.89("fM")}1f.3T.1D=(H.1c.7m.3f)?1f["[[fO.1D]]"]:{}}H.8t(1f.3T,{$4J:"88"});H.3l={29:17(){if(H.1c.2M||H.1c.gJ||H.1c.bH){18{1d:1f.gK,1g:1f.gL}}18{1d:H.1c.59().91,1g:H.1c.59().bd}},7c:17(){18{x:1f.gI||H.1c.59().9C,y:1f.gH||H.1c.59().9B}},cs:17(){1a R=13.29();18{1d:1j.1Z(H.1c.59().gD,R.1d),1g:1j.1Z(H.1c.59().gE,R.1g)}}};H.21(1h,{$4J:"1h"});H.21(1f,{$4J:"1f"});H.21([H.3T,H.3l],{2j:17(U,S){1a R=H.8v(13.$64),T=R[U];if(2y!==S&&2y===T){T=R[U]=S}18(H.30(T)?T:1i)},2X:17(T,S){1a R=H.8v(13.$64);R[T]=S;18 13},2T:17(S){1a R=H.8v(13.$64);4C R[S];18 13}});if(!(1f.au&&1f.au.1D&&1f.au.1D.ar)){H.21([H.3T,H.3l],{ar:17(R){18 H.$A(13.bN("*")).2H(17(T){2Y{18(1==T.63&&T.5Y.8m(R," "))}3k(S){}})}})}H.21([H.3T,H.3l],{cq:17(){18 13.ar(2m[0])},8W:17(){18 13.bN(2m[0])}});if(H.1c.4A.9n&&!1h.bM){H.3T.bM=17(){H.1c.4A.bC(13)}}H.1m={$4J:"1s",6b:H.$1e,1U:17(){18 13.52().3P()},52:17(){if(13.bO){13.bO()}1r{13.bR=1k}18 13},3P:17(){if(13.bK){13.bK()}1r{13.gO=1e}18 13},78:17(){13.6b=H.$1k;18 13},d4:17(){1a S,R;S=((/2z/i).2S(13.1n))?13.2w[0]:13;18(!H.30(S))?{x:0,y:0}:{x:S.2s,y:S.2u}},2B:17(){1a S,R;S=((/2z/i).2S(13.1n))?13.2w[0]:13;18(!H.30(S))?{x:0,y:0}:{x:S.5K||S.2s+H.1c.59().9C,y:S.5E||S.2u+H.1c.59().9B}},9x:17(){1a R=13.4j||13.gQ;4B(R&&3==R.63){R=R.5l}18 R},7i:17(){1a S=1i;5G(13.1n){1x"70":1x"eB":1x"ej":S=13.9F||13.gC;1I;1x"6v":1x"em":1x"eE":S=13.9F||13.gB;1I;1w:18 S}2Y{4B(S&&3==S.63){S=S.5l}}3k(R){S=1i}18 S},4T:17(){if(!13.bG&&13.3r!==2y){18(13.3r&1?1:(13.3r&2?3:(13.3r&4?2:0)))}18 13.bG},9a:17(){18(13.1S&&("2z"===13.1S||13.1S===13.4t))||(/2z/i).2S(13.1n)},cx:17(){18 13.1S?(("2z"===13.1S||13.4t===13.1S)&&13.ai):1===13.2w.1v&&(13.7u.1v?13.7u[0].4h==13.2w[0].4h:1k)}};H.af="cj";H.al="go";H.9H="";if(!1h.cj){H.af="gp";H.al="gq";H.9H="6U"}H.1m.1o={1n:"",x:1i,y:1i,2D:1i,3r:1i,4j:1i,9F:1i,$4J:"1s.gm",6b:H.$1e,6g:H.$([]),4g:17(R){1a S=R;13.6g.2U(S)},1U:17(){18 13.52().3P()},52:17(){13.6g.3D(17(S){2Y{S.52()}3k(R){}});18 13},3P:17(){13.6g.3D(17(S){2Y{S.3P()}3k(R){}});18 13},78:17(){13.6b=H.$1k;18 13},d4:17(){18{x:13.2s,y:13.2u}},2B:17(){18{x:13.x,y:13.y}},9x:17(){18 13.4j},7i:17(){18 13.9F},4T:17(){18 13.3r},gj:17(){18 13.6g.1v>0?13.6g[0].9x():2y}};H.21([H.3T,H.3l],{1t:17(T,V,W,Z){1a Y,R,U,X,S;if("1N"==H.1F(T)){S=T.4q(" ");if(S.1v>1){T=S}}if(H.1F(T)=="3N"){H.$(T).3D(13.1t.48(13,V,W,Z));18 13}if(!T||!V||H.1F(T)!="1N"||H.1F(V)!="17"){18 13}if(T=="7U"&&H.1c.56){V.1W(13);18 13}T=O[T]||T;W=3n(W||50);if(!V.$9J){V.$9J=1j.3x(1j.71()*H.4L())}Y=H.3l.2j.1W(13,"83",{});R=Y[T];if(!R){Y[T]=R=H.$([]);U=13;if(H.1m.1o[T]){H.1m.1o[T].1A.5C.1W(13,Z)}1r{R.2V=17(aa){aa=H.21(aa||1f.e,{$4J:"1s"});H.3l.2R.1W(U,T,H.$(aa))};13[H.af](H.9H+T,R.2V,1e)}}X={1n:T,fn:V,am:W,d8:V.$9J};R.2U(X);R.ex(17(ab,aa){18 ab.am-aa.am});18 13},1O:17(X){1a V=H.3l.2j.1W(13,"83",{}),T,R,S,Y,W,U;W=2m.1v>1?2m[1]:-1Q;if("1N"==H.1F(X)){U=X.4q(" ");if(U.1v>1){X=U}}if(H.1F(X)=="3N"){H.$(X).3D(13.1O.48(13,W));18 13}X=O[X]||X;if(!X||H.1F(X)!="1N"||!V||!V[X]){18 13}T=V[X]||[];1L(S=0;S<T.1v;S++){R=T[S];if(-1Q==W||!!W&&W.$9J===R.d8){Y=T.8A(S--,1)}}if(0===T.1v){if(H.1m.1o[X]){H.1m.1o[X].1A.2F.1W(13)}1r{13[H.al](H.9H+X,T.2V,1e)}4C V[X]}18 13},2R:17(V,X){1a U=H.3l.2j.1W(13,"83",{}),T,R,S;V=O[V]||V;if(!V||H.1F(V)!="1N"||!U||!U[V]){18 13}2Y{X=H.21(X||{},{1n:V})}3k(W){}if(2y===X.2D){X.2D=H.4L()}T=U[V]||[];1L(S=0;S<T.1v&&!(X.6b&&X.6b());S++){T[S].fn.1W(13,X)}},gs:17(S,R){1a V=("7U"==S)?1e:1k,U=13,T;S=O[S]||S;if(!V){H.3l.2R.1W(13,S);18 13}if(U===1h&&1h.9v&&!U.d2){U=1h.5j}if(1h.9v){T=1h.9v(S);T.gy(R,1k,1k)}1r{T=1h.gz();T.9p=S}if(1h.9v){U.d2(T)}1r{U.gA("6U"+R,T)}18 T},bq:17(){1a S=H.3l.2j.1W(13,"83");if(!S){18 13}1L(1a R in S){H.3l.1O.1W(13,R)}H.3l.2T.1W(13,"83");18 13}});(17(R){if("62"===1h.7Z){18 R.1c.4o.2q(1)}if(R.1c.3f&&R.1c.4D<gx){(17(){(R.$(["5Z","62"]).3g(1h.7Z))?R.1c.4o():2m.9d.2q(50)})()}1r{if(R.1c.3F&&R.1c.2f<9&&1f==1z){(17(){(R.$2Y(17(){R.1c.59().gt("1M");18 1k}))?R.1c.4o():2m.9d.2q(50)})()}1r{R.3l.1t.1W(R.$(1h),"gu",R.1c.4o);R.3l.1t.1W(R.$(1f),"6D",R.1c.4o)}}})(N);H.3B=17(){1a V=1i,S=H.$A(2m);if("5V"==H.1F(S[0])){V=S.5W()}1a R=17(){1L(1a Y in 13){13[Y]=H.5h(13[Y])}if(13.51.$3K){13.$3K={};1a aa=13.51.$3K;1L(1a Z in aa){1a X=aa[Z];5G(H.1F(X)){1x"17":13.$3K[Z]=H.3B.cm(13,X);1I;1x"cW":13.$3K[Z]=H.5h(X);1I;1x"3N":13.$3K[Z]=H.5h(X);1I}}}1a W=(13.2Z)?13.2Z.6E(13,2m):13;4C 13.ax;18 W};if(!R.1D.2Z){R.1D.2Z=H.$F}if(V){1a U=17(){};U.1D=V.1D;R.1D=1p U;R.$3K={};1L(1a T in V.1D){R.$3K[T]=V.1D[T]}}1r{R.$3K=1i}R.51=H.3B;R.1D.51=R;H.21(R.1D,S[0]);H.21(R,{$4J:"5V"});18 R};N.3B.cm=17(R,S){18 17(){1a U=13.ax;1a T=S.6E(R,2m);18 T}};(17(U){1a T=U.$;1a R=5,S=6q;U.1m.1o.2g=1p U.3B(U.21(U.1m.1o,{1n:"2g",2Z:17(X,W){1a V=W.2B();13.x=V.x;13.y=V.y;13.2s=W.2s;13.2u=W.2u;13.2D=W.2D;13.3r=W.4T();13.4j=X;13.4g(W)}}));U.1m.1o.2g.1A={1q:{7a:S,3r:1},5C:17(V){13.2X("1s:2g:1q",U.21(U.5h(U.1m.1o.2g.1A.1q),V||{}));13.1t("49",U.1m.1o.2g.1A.2V,1);13.1t("3E",U.1m.1o.2g.1A.2V,1);13.1t("2K",U.1m.1o.2g.1A.a9,1);if(U.1c.3F&&U.1c.2f<9){13.1t("9q",U.1m.1o.2g.1A.2V,1)}},2F:17(){13.1O("49",U.1m.1o.2g.1A.2V);13.1O("3E",U.1m.1o.2g.1A.2V);13.1O("2K",U.1m.1o.2g.1A.a9);if(U.1c.3F&&U.1c.2f<9){13.1O("9q",U.1m.1o.2g.1A.2V)}},a9:17(V){V.3P()},2V:17(Y){1a X,V,W;V=13.2j("1s:2g:1q");if(Y.1n!="9q"&&Y.4T()!=V.3r){18}if(13.2j("1s:2g:9T")){13.2T("1s:2g:9T");18}if("49"==Y.1n){X=1p U.1m.1o.2g(13,Y);13.2X("1s:2g:9E",X)}1r{if("3E"==Y.1n){X=13.2j("1s:2g:9E");if(!X){18}W=Y.2B();13.2T("1s:2g:9E");X.4g(Y);if(Y.2D-X.2D<=V.7a&&1j.7H(1j.3y(W.x-X.x,2)+1j.3y(W.y-X.y,2))<=R){13.2R("2g",X)}1h.2R("3E",Y)}1r{if(Y.1n=="9q"){X=1p U.1m.1o.2g(13,Y);13.2R("2g",X)}}}}}})(N);(17(S){1a R=S.$;S.1m.1o.2t=1p S.3B(S.21(S.1m.1o,{1n:"2t",6G:"3L",6j:1e,2Z:17(W,V,U){1a T=V.2B();13.x=T.x;13.y=T.y;13.2s=V.2s;13.2u=V.2u;13.2D=V.2D;13.3r=V.4T();13.4j=W;13.4g(V);13.6G=U}}));S.1m.1o.2t.1A={5C:17(){1a U=S.1m.1o.2t.1A.dp.48(13),T=S.1m.1o.2t.1A.9s.48(13);13.1t("49",S.1m.1o.2t.1A.a4,1);13.1t("3E",S.1m.1o.2t.1A.9s,1);1h.1t("4x",U,1);1h.1t("3E",T,1);13.2X("1s:2t:4E:1h:5k",U);13.2X("1s:2t:4E:1h:79",T)},2F:17(){13.1O("49",S.1m.1o.2t.1A.a4);13.1O("3E",S.1m.1o.2t.1A.9s);R(1h).1O("4x",13.2j("1s:2t:4E:1h:5k")||S.$F);R(1h).1O("3E",13.2j("1s:2t:4E:1h:79")||S.$F);13.2T("1s:2t:4E:1h:5k");13.2T("1s:2t:4E:1h:79")},a4:17(U){1a T;if(1!=U.4T()){18}T=1p S.1m.1o.2t(13,U,"3L");13.2X("1s:2t:3L",T)},9s:17(U){1a T;T=13.2j("1s:2t:3L");if(!T){18}U.3P();T=1p S.1m.1o.2t(13,U,"cu");13.2T("1s:2t:3L");13.2R("2t",T)},dp:17(U){1a T;T=13.2j("1s:2t:3L");if(!T){18}U.3P();if(!T.6j){T.6j=1k;13.2R("2t",T)}T=1p S.1m.1o.2t(13,U,"cS");13.2R("2t",T)}}})(N);(17(S){1a R=S.$;S.1m.1o.4i=1p S.3B(S.21(S.1m.1o,{1n:"4i",76:1e,75:1i,2Z:17(V,U){1a T=U.2B();13.x=T.x;13.y=T.y;13.2s=U.2s;13.2u=U.2u;13.2D=U.2D;13.3r=U.4T();13.4j=V;13.4g(U)}}));S.1m.1o.4i.1A={1q:{7a:5y},5C:17(T){13.2X("1s:4i:1q",S.21(S.5h(S.1m.1o.4i.1A.1q),T||{}));13.1t("2g",S.1m.1o.4i.1A.2V,1)},2F:17(){13.1O("2g",S.1m.1o.4i.1A.2V)},2V:17(V){1a U,T;U=13.2j("1s:4i:1s");T=13.2j("1s:4i:1q");if(!U){U=1p S.1m.1o.4i(13,V);U.75=4z(17(){U.76=1k;V.6b=S.$1e;13.2R("2g",V);13.2T("1s:4i:1s")}.1u(13),T.7a+10);13.2X("1s:4i:1s",U);V.78()}1r{3o(U.75);13.2T("1s:4i:1s");if(!U.76){U.4g(V);V.78().1U();13.2R("4i",U)}1r{}}}}})(N);(17(X){1a W=X.$;17 R(Y){18 Y.1S?(("2z"===Y.1S||Y.4t===Y.1S)&&Y.ai):1===Y.2w.1v&&(Y.7u.1v?Y.7u[0].4h==Y.2w[0].4h:1k)}17 T(Y){if(Y.1S){18("2z"===Y.1S||Y.4t===Y.1S)?Y.9D:1i}1r{18 Y.2w[0].4h}}17 U(Y){if(Y.1S){18("2z"===Y.1S||Y.4t===Y.1S)?Y:1i}1r{18 Y.2w[0]}}X.1m.1o.2O=1p X.3B(X.21(X.1m.1o,{1n:"2O",id:1i,2Z:17(Z,Y){1a aa=U(Y);13.id=aa.9D||aa.4h;13.x=aa.5K;13.y=aa.5E;13.5K=aa.5K;13.5E=aa.5E;13.2s=aa.2s;13.2u=aa.2u;13.2D=Y.2D;13.3r=0;13.4j=Z;13.4g(Y)}}));1a S=10,V=5y;X.1m.1o.2O.1A={5C:17(Y){13.1t(["4R",1f.2e.35?"7V":"7z"],X.1m.1o.2O.1A.7f,1);13.1t(["4G",1f.2e.35?"6x":"6z"],X.1m.1o.2O.1A.6F,1);13.1t("2K",X.1m.1o.2O.1A.a1,1)},2F:17(){13.1O(["4R",1f.2e.35?"7V":"7z"],X.1m.1o.2O.1A.7f);13.1O(["4G",1f.2e.35?"6x":"6z"],X.1m.1o.2O.1A.6F);13.1O("2K",X.1m.1o.2O.1A.a1)},a1:17(Y){Y.3P()},7f:17(Y){if(!R(Y)){13.2T("1s:2O:1s");18}13.2X("1s:2O:1s",1p X.1m.1o.2O(13,Y));13.2X("1s:2g:9T",1k)},6F:17(ab){1a Z=X.4L(),aa=13.2j("1s:2O:1s"),Y=13.2j("1s:2O:1q");if(!aa||!R(ab)){18}13.2T("1s:2O:1s");if(aa.id==T(ab)&&ab.2D-aa.2D<=V&&1j.7H(1j.3y(U(ab).5K-aa.x,2)+1j.3y(U(ab).5E-aa.y,2))<=S){13.2T("1s:2g:9E");ab.1U();aa.4g(ab);13.2R("2O",aa)}}}})(N);H.1m.1o.4r=1p H.3B(H.21(H.1m.1o,{1n:"4r",76:1e,75:1i,2Z:17(S,R){13.x=R.x;13.y=R.y;13.2s=R.2s;13.2u=R.2u;13.2D=R.2D;13.3r=0;13.4j=S;13.4g(R)}}));H.1m.1o.4r.1A={1q:{7a:6q},5C:17(R){13.2X("1s:4r:1q",H.21(H.5h(H.1m.1o.4r.1A.1q),R||{}));13.1t("2O",H.1m.1o.4r.1A.2V,1)},2F:17(){13.1O("2O",H.1m.1o.4r.1A.2V)},2V:17(T){1a S,R;S=13.2j("1s:4r:1s");R=13.2j("1s:4r:1q");if(!S){S=1p H.1m.1o.4r(13,T);S.75=4z(17(){S.76=1k;T.6b=H.$1e;13.2R("2O",T)}.1u(13),R.7a+10);13.2X("1s:4r:1s",S);T.78()}1r{3o(S.75);13.2T("1s:4r:1s");if(!S.76){S.4g(T);T.78().1U();13.2R("4r",S)}1r{}}}};(17(W){1a V=W.$;17 R(X){18 X.1S?(("2z"===X.1S||X.4t===X.1S)&&X.ai):1===X.2w.1v&&(X.7u.1v?X.7u[0].4h==X.2w[0].4h:1k)}17 T(X){if(X.1S){18("2z"===X.1S||X.4t===X.1S)?X.9D:1i}1r{18 X.2w[0].4h}}17 U(X){if(X.1S){18("2z"===X.1S||X.4t===X.1S)?X:1i}1r{18 X.2w[0]}}1a S=10;W.1m.1o.2o=1p W.3B(W.21(W.1m.1o,{1n:"2o",6G:"3L",id:1i,6j:1e,2Z:17(Z,Y,X){1a aa=U(Y);13.id=aa.9D||aa.4h;13.2s=aa.2s;13.2u=aa.2u;13.5K=aa.5K;13.5E=aa.5E;13.x=aa.5K;13.y=aa.5E;13.2D=Y.2D;13.3r=0;13.4j=Z;13.4g(Y);13.6G=X}}));W.1m.1o.2o.1A={5C:17(){1a Y=W.1m.1o.2o.1A.9I.1u(13),X=W.1m.1o.2o.1A.6F.1u(13);13.1t(["4R",1f.2e.35?"7V":"7z"],W.1m.1o.2o.1A.7f,1);13.1t(["4G",1f.2e.35?"6x":"6z"],W.1m.1o.2o.1A.6F,1);13.1t(["6n",1f.2e.35?"7A":"7J"],W.1m.1o.2o.1A.9I,1);13.2X("1s:2o:4E:1h:5k",Y);13.2X("1s:2o:4E:1h:79",X);V(1h).1t(1f.2e.35?"7A":"7J",Y,1);V(1h).1t(1f.2e.35?"6x":"6z",X,1)},2F:17(){13.1O(["4R",1f.2e.35?"7V":"7z"],W.1m.1o.2o.1A.7f);13.1O(["4G",1f.2e.35?"6x":"6z"],W.1m.1o.2o.1A.6F);13.1O(["6n",1f.2e.35?"7A":"7J"],W.1m.1o.2o.1A.9I);V(1h).1O(1f.2e.35?"7A":"7J",13.2j("1s:2o:4E:1h:5k")||W.$F,1);V(1h).1O(1f.2e.35?"6x":"6z",13.2j("1s:2o:4E:1h:79")||W.$F,1);13.2T("1s:2o:4E:1h:5k");13.2T("1s:2o:4E:1h:79")},7f:17(Y){1a X;if(!R(Y)){18}X=1p W.1m.1o.2o(13,Y,"3L");13.2X("1s:2o:3L",X)},6F:17(Y){1a X;X=13.2j("1s:2o:3L");if(!X||!X.6j||X.id!=T(Y)){18}X=1p W.1m.1o.2o(13,Y,"cu");13.2T("1s:2o:3L");13.2R("2o",X)},9I:17(Y){1a X;X=13.2j("1s:2o:3L");if(!X||!R(Y)){18}if(X.id!=T(Y)){13.2T("1s:2o:3L");18}if(!X.6j&&1j.7H(1j.3y(U(Y).5K-X.x,2)+1j.3y(U(Y).5E-X.y,2))>S){X.6j=1k;13.2R("2o",X)}if(!X.6j){18}X=1p W.1m.1o.2o(13,Y,"cS");13.2R("2o",X)}}})(N);H.1m.1o.3H=1p H.3B(H.21(H.1m.1o,{1n:"3H",7X:1,9K:1,cF:1,6G:"fs",2Z:17(S,R){13.2D=R.2D;13.3r=0;13.4j=S;13.x=R.3R[0].2s+(R.3R[1].2s-R.3R[0].2s)/2;13.y=R.3R[0].2u+(R.3R[1].2u-R.3R[0].2u)/2;13.cG=1j.7H(1j.3y(R.3R[0].2s-R.3R[1].2s,2)+1j.3y(R.3R[0].2u-R.3R[1].2u,2));13.4g(R)},cH:17(R){1a S;13.6G="f8";if(R.2w[0].4h!=13.6g[0].3R[0].4h||R.2w[1].4h!=13.6g[0].3R[1].4h){18}S=1j.7H(1j.3y(R.2w[0].2s-R.2w[1].2s,2)+1j.3y(R.2w[0].2u-R.2w[1].2u,2));13.9K=13.7X;13.7X=S/13.cG;13.cF=13.7X/13.9K;13.x=R.2w[0].2s+(R.2w[1].2s-R.2w[0].2s)/2;13.y=R.2w[0].2u+(R.2w[1].2u-R.2w[0].2u)/2;13.4g(R)}}));H.1m.1o.3H.1A={5C:17(){13.1t("4R",H.1m.1o.3H.1A.9S,1);13.1t("4G",H.1m.1o.3H.1A.9R,1);13.1t("6n",H.1m.1o.3H.1A.aD,1)},2F:17(){13.1O("4R",H.1m.1o.3H.1A.9S);13.1O("4G",H.1m.1o.3H.1A.9R);13.1O("6n",H.1m.1o.3H.1A.aD)},9S:17(S){1a R;if(S.3R.1v!=2){18}S.3P();R=1p H.1m.1o.3H(13,S);13.2X("1s:3H:1s",R)},9R:17(S){1a R;R=13.2j("1s:3H:1s");if(!R){18}S.3P();13.2T("1s:3H:1s")},aD:17(S){1a R;R=13.2j("1s:3H:1s");if(!R){18}S.3P();R.cH(S);13.2R("3H",R)}};(17(W){1a U=W.$;W.1m.1o.4p=1p W.3B(W.21(W.1m.1o,{1n:"4p",2Z:17(ac,ab,ae,Y,X,ad,Z){1a aa=ab.2B();13.x=aa.x;13.y=aa.y;13.2D=ab.2D;13.4j=ac;13.5A=ae||0;13.6X=Y||0;13.72=X||0;13.jv=ad||0;13.jw=Z||0;13.aA=ab.aA||0;13.5g=1e;13.4g(ab)}}));1a V,S;17 R(){V=1i}17 T(X,Y){18(X>50)||(1===Y&&!("9u"==W.1c.67&&X<1))||(0===X%12)||(0==X%4.js)}W.1m.1o.4p.1A={9p:"jr"in 1h||W.1c.2f>8?"jn":"6N",5C:17(){13.1t(W.1m.1o.4p.1A.9p,W.1m.1o.4p.1A.2V,1)},2F:17(){13.1O(W.1m.1o.4p.1A.9p,W.1m.1o.4p.1A.2V,1)},2V:17(ac){1a ad=0,aa=0,Y=0,X=0,ab,Z;if(ac.cN){Y=ac.cN*-1}if(ac.cO!==2y){Y=ac.cO}if(ac.cE!==2y){Y=ac.cE}if(ac.cD!==2y){aa=ac.cD*-1}if(ac.72){Y=-1*ac.72}if(ac.6X){aa=ac.6X}if(0===Y&&0===aa){18}ad=0===Y?aa:Y;X=1j.1Z(1j.26(Y),1j.26(aa));if(!V||X<V){V=X}ab=ad>0?"3x":"6B";ad=1j[ab](ad/V);aa=1j[ab](aa/V);Y=1j[ab](Y/V);if(S){3o(S)}S=4z(R,5y);Z=1p W.1m.1o.4p(13,ac,ad,aa,Y,0,V);Z.5g=T(V,ac.aA||0);13.2R("4p",Z)}}})(N);H.9u=H.$(1f);H.7M=H.$(1h);18 N})();(17(D){if(!D){6d"7j 7n 7s"}1a C=D.$;1a B=1f.dE||1f.c3||1i;s.7g=1p D.3B({1K:1i,56:1e,1q:{9r:D.$F,6e:D.$F,aL:D.$F,5r:D.$F,6k:D.$F,bo:D.$F,7b:1e,co:1k},1X:1i,7S:1i,aM:0,7h:{9r:17(E){if(E.4j&&(5y===E.4j.99||cy===E.4j.99)&&E.jJ){13.1q.9r.1u(1i,(E.5Z-(13.1q.co?13.aM:0))/E.jK).2q(1);13.aM=E.5Z}},6e:17(E){if(E){C(E).1U()}13.7N();if(13.56){18}13.56=1k;13.7O();!13.1q.7b&&13.1q.9r.1u(1i,1).2q(1);13.1q.6e.1u(1i,13).2q(1);13.1q.6k.1u(1i,13).2q(1)},aL:17(E){if(E){C(E).1U()}13.7N();13.56=1e;13.7O();13.1q.aL.1u(1i,13).2q(1);13.1q.6k.1u(1i,13).2q(1)},5r:17(E){if(E){C(E).1U()}13.7N();13.56=1e;13.7O();13.1q.5r.1u(1i,13).2q(1);13.1q.6k.1u(1i,13).2q(1)}},9e:17(){C(["6D","aJ","cC"]).3D(17(E){13.1K.1t(E,13.7h["6U"+E].48(13).cB(1))},13)},7N:17(){if(13.7S){2Y{3o(13.7S)}3k(E){}13.7S=1i}C(["6D","aJ","cC"]).3D(17(F){13.1K.1O(F)},13)},7O:17(){13.29();if(13.1K.2j("1p")){1a E=13.1K.5l;13.1K.2F().2T("1p").1G({2P:"jL",1z:"2i"});E.6s()}},dg:17(F){1a G=1p 9j(),E;C(["aJ","dT"]).3D(17(H){G["6U"+H]=C(17(I){13.7h["6U"+H].1W(13,I)}).1u(13)},13);G.5r=C(17(){13.1q.bo.1u(1i,13).2q(1);13.1q.7b=1e;13.9e();13.1K.41=F}).1u(13);G.6e=C(17(){if(5y!==G.99&&cy!==G.99){13.7h.5r.1W(13);18}E=G.jG;13.9e();if(B&&!D.1c.3F&&!("8z"===D.1c.67&&D.1c.4D<jF)){13.1K.7o("41",B.jB(E))}1r{13.1K.41=F}}).1u(13);G.aQ("jA",F);G.jC="df";G.jD()},2Z:17(F,E){13.1q=D.21(13.1q,E);13.1K=C(F)||D.$1p("1K",{},{"1Z-1d":"2p","1Z-1g":"2p"}).2r(D.$1p("2b").2k("3h-8K-1K").1G({2P:"4f",1z:-9Y,1d:10,1g:10,5w:"3p"}).2r(1h.3A)).2X("1p",1k);if(D.1c.2Q.aE&&13.1q.7b&&"1N"==D.1F(F)){13.dg(F);18}1a G=17(){if(13.di()){13.7h.6e.1W(13)}1r{13.7h.5r.1W(13)}G=1i}.1u(13);13.9e();if("1N"==D.1F(F)){13.1K.41=F}1r{if(D.1c.3F&&5==D.1c.4D&&D.1c.2f<9){13.1K.dd=17(){if(/5Z|62/.2S(13.1K.7Z)){13.1K.dd=1i;G&&G()}}.1u(13)}13.1K.41=F.5I("41")}13.1K&&13.1K.62&&G&&(13.7S=G.2q(1Q))},jE:17(){13.7N();13.7O();13.56=1e;18 13},di:17(){1a E=13.1K;18(E.8b)?(E.8b>0):(E.7Z)?("62"==E.7Z):E.1d>0},29:17(){18 13.1X||(13.1X={1d:13.1K.8b||13.1K.1d,1g:13.1K.bs||13.1K.1g})}})})(s);(17(C){if(!C){6d"7j 7n 7s"}if(C.3e){18}1a B=C.$;C.3e=1p C.3B({2Z:17(E,D){1a F;13.el=C.$(E);13.1q=C.21(13.1q,D);13.33=1e;13.6Z=13.av;F=C.3e.6r[13.1q.2W]||13.1q.2W;if("17"===C.1F(F)){13.6Z=F}1r{13.5u=13.7D(F)||13.7D("6J")}if("1N"==C.1F(13.1q.6Y)){13.1q.6Y="4s"===13.1q.6Y?eF:3n(13.1q.6Y)||1}},1q:{dl:60,43:jk,2W:"6J",6Y:1,3X:"j2",9G:C.$F,5p:C.$F,aS:C.$F,9A:C.$F,8U:1e,j1:1e},4w:1i,5u:1i,6Z:1i,j3:17(D){13.1q.2W=D;D=C.3e.6r[13.1q.2W]||13.1q.2W;if("17"===C.1F(D)){13.6Z=D}1r{13.6Z=13.av;13.5u=13.7D(D)||13.7D("6J")}},1y:17(F){1a D=/\\%$/,E;13.4w=F;13.az=0;13.6G=0;13.j5=0;13.8x={};13.4I="4I"===13.1q.3X||"4I-3s"===13.1q.3X;13.7v="7v"===13.1q.3X||"7v-3s"===13.1q.3X;1L(E in 13.4w){D.2S(13.4w[E][0])&&(13.8x[E]=1k);if("3s"===13.1q.3X||"4I-3s"===13.1q.3X||"7v-3s"===13.1q.3X){13.4w[E].3s()}}13.9w=C.4L();13.da=13.9w+13.1q.43;13.1q.9G.1W();if(0===13.1q.43){13.6w(1);13.1q.5p.1W()}1r{13.8p=13.34.1u(13);if(!13.1q.8U&&C.1c.2Q.4X){13.33=C.1c.4X.1W(1f,13.8p)}1r{13.33=13.8p.dm(1j.5b(8Z/13.1q.dl))}}18 13},aq:17(){if(13.33){if(!13.1q.8U&&C.1c.2Q.4X&&C.1c.9z){C.1c.9z.1W(1f,13.33)}1r{gX(13.33)}13.33=1e}},1U:17(D){D=C.30(D)?D:1e;13.aq();if(D){13.6w(1);13.1q.5p.2q(10)}18 13},ap:17(F,E,D){F=2n(F);E=2n(E);18(E-F)*D+F},34:17(){1a E=C.4L(),D=(E-13.9w)/13.1q.43,F=1j.3x(D);if(E>=13.da&&F>=13.1q.6Y){13.aq();13.6w(1);13.1q.5p.2q(10);18 13}if(13.4I&&13.az<F){1L(1a G in 13.4w){13.4w[G].3s()}}13.az=F;if(!13.1q.8U&&C.1c.2Q.4X){13.33=C.1c.4X.1W(1f,13.8p)}13.6w((13.7v?F:0)+13.6Z(D%1))},6w:17(D){1a E={},G=D;1L(1a F in 13.4w){if("3w"===F){E[F]=1j.5b(13.ap(13.4w[F][0],13.4w[F][1],D)*1Q)/1Q}1r{E[F]=13.ap(13.4w[F][0],13.4w[F][1],D);13.8x[F]&&(E[F]+="%")}}13.1q.aS(E,13.el);13.1V(E);13.1q.9A(E,13.el)},1V:17(D){18 13.el.1G(D)},7D:17(D){1a E,F=1i;if("1N"!==C.1F(D)){18 1i}5G(D){1x"an":F=B([0,0,1,1]);1I;1x"6J":F=B([0.25,0.1,0.25,1]);1I;1x"6J-in":F=B([0.42,0,1,1]);1I;1x"6J-cX":F=B([0,0,0.58,1]);1I;1x"6J-in-cX":F=B([0.42,0,0.58,1]);1I;1x"cf":F=B([0.47,0,0.j6,0.j7]);1I;1x"bT":F=B([0.39,0.jf,0.jh,1]);1I;1x"ji":F=B([0.jj,0.at,0.55,0.95]);1I;1x"ch":F=B([0.55,0.je,0.68,0.53]);1I;1x"c7":F=B([0.25,0.46,0.45,0.94]);1I;1x"jN":F=B([0.jM,0.dq,0.ke,0.ko]);1I;1x"c6":F=B([0.55,0.kn,0.kp,0.19]);1I;1x"bY":F=B([0.kq,0.61,0.d3,1]);1I;1x"km":F=B([0.kl,0.cl,0.d3,1]);1I;1x"kh":F=B([0.kg,0.dq,0.ki,0.22]);1I;1x"kj":F=B([0.bJ,0.84,0.44,1]);1I;1x"kz":F=B([0.77,0,0.cc,1]);1I;1x"kC":F=B([0.kB,0.at,0.kE,0.kA]);1I;1x"kv":F=B([0.23,1,0.32,1]);1I;1x"kw":F=B([0.86,0,0.kx,1]);1I;1x"ci":F=B([0.95,0.at,0.ky,0.ks]);1I;1x"cg":F=B([0.19,1,0.22,1]);1I;1x"jW":F=B([1,0,0,1]);1I;1x"jV":F=B([0.6,0.jX,0.98,0.jY]);1I;1x"jZ":F=B([0.jU,0.82,0.bJ,1]);1I;1x"jP":F=B([0.jO,0.jQ,0.15,0.86]);1I;1x"bX":F=B([0.6,-0.28,0.k1,0.cl]);1I;1x"bW":F=B([0.cc,0.ka,0.32,1.kb]);1I;1x"kc":F=B([0.68,-0.55,0.k8,1.55]);1I;1w:D=D.2C(/\\s/g,"");if(D.3m(/^ca-c8\\((?:-?[0-9\\.]{0,}[0-9]{1,},){3}(?:-?[0-9\\.]{0,}[0-9]{1,})\\)$/)){F=D.2C(/^ca-c8\\s*\\(|\\)$/g,"").4q(",");1L(E=F.1v-1;E>=0;E--){F[E]=2n(F[E])}}}18 B(F)},av:17(P){1a D=0,O=0,L=0,Q=0,N=0,J=0,K=13.1q.43;17 I(R){18((D*R+O)*R+L)*R}17 H(R){18((Q*R+N)*R+J)*R}17 F(R){18(3*D*R+2*O)*R+L}17 M(R){18 1/(5y*R)}17 E(R,S){18 H(G(R,S))}17 G(Y,Z){1a X,W,V,S,R,U;17 T(aa){if(aa>=0){18 aa}1r{18 0-aa}}1L(V=Y,U=0;U<8;U++){S=I(V)-Y;if(T(S)<Z){18 V}R=F(V);if(T(R)<0.k3){1I}V=V-S/R}X=0;W=1;V=Y;if(V<X){18 X}if(V>W){18 W}4B(X<W){S=I(V);if(T(S-Y)<Z){18 V}if(Y>S){X=V}1r{W=V}V=(W-X)*0.5+X}18 V}L=3*13.5u[0];O=3*(13.5u[2]-13.5u[0])-L;D=1-L-O;J=3*13.5u[1];N=3*(13.5u[3]-13.5u[1])-J;Q=1-J-N;18 E(P,M(K))}});C.3e.6r={an:"an",k5:"cf",k6:"bT",iT:"ci",9U:"cg",iS:"ch",bQ:"c7",hz:"c6",hy:"bY",hA:"bX",hB:"bW",bU:17(E,D){D=D||[];18 1j.3y(2,10*--E)*1j.hC(20*E*1j.hx*(D[0]||1)/3)},hw:17(E,D){18 1-C.3e.6r.bU(1-E,D)},dr:17(F){1L(1a E=0,D=1;1;E+=D,D/=2){if(F>=(7-4*E)/11){18 D*D-1j.3y((11-6*E-11*F)/4,2)}}},hs:17(D){18 1-C.3e.6r.dr(1-D)},2p:17(D){18 0}}})(s);(17(C){if(!C){6d"7j 7n 7s"}if(C.bZ){18}1a B=C.$;C.bZ=1p C.3B(C.3e,{2Z:17(D,E){13.ag=D;13.1q=C.21(13.1q,E);13.33=1e;13.$3K.2Z()},1y:17(H){1a D=/\\%$/,G,F,E=H.1v;13.aj=H;13.8w=1p 57(E);1L(F=0;F<E;F++){13.8w[F]={};1L(G in H[F]){D.2S(H[F][G][0])&&(13.8w[F][G]=1k);if("3s"===13.1q.3X||"4I-3s"===13.1q.3X||"7v-3s"===13.1q.3X){13.aj[F][G].3s()}}}13.$3K.1y([]);18 13},6w:17(D){1L(1a E=0;E<13.ag.1v;E++){13.el=C.$(13.ag[E]);13.4w=13.aj[E];13.8x=13.8w[E];13.$3K.6w(D)}}})})(s);(17(C){if(!C){6d"7j 7n 7s";18}if(C.ak){18}1a B=C.$;C.ak=17(E,F){1a D=13.7k=C.$1p("2b",1i,{2P:"4f","z-5d":c4}).2k("ht");C.$(E).1t("70",17(){D.2r(1h.3A)});C.$(E).1t("6v",17(){D.2F()});C.$(E).1t("4x",17(K){1a M=20,J=C.$(K).2B(),I=D.29(),H=C.$(1f).29(),L=C.$(1f).7c();17 G(P,N,O){18(O<(P-N)/2)?O:((O>(P+N)/2)?(O-N):(P-N)/2)}D.1G({1M:L.x+G(H.1d,I.1d+2*M,J.x-L.x)+M,1z:L.y+G(H.1g,I.1g+2*M,J.y-L.y)+M})});13.4m(F)};C.ak.1D.4m=17(D){13.7k.2v&&13.7k.7p(13.7k.2v);13.7k.3C(1h.8F(D))}})(s);(17(C){if(!C){6d"7j 7n 7s";18}if(C.hv){18}1a B=C.$;C.7F=17(G,F,E,D){13.8C=1i;13.5s=C.$1p("9m",1i,{2P:"4f","z-5d":c4,3j:"3p",3w:0.8}).2k(D||"").2r(E||1h.3A);13.c1(G);13.5q(F)};C.7F.1D.5q=17(D){13.5s.5q();13.8C=13.4Y.1u(13).2q(C.aP(D,hD))};C.7F.1D.4Y=17(D){3o(13.8C);13.8C=1i;if(13.5s&&!13.aw){13.aw=1p s.3e(13.5s,{43:C.aP(D,eL),5p:17(){13.5s.6s();4C 13.5s;13.aw=1i}.1u(13)}).1y({3w:[13.5s.2E("3w"),0]})}};C.7F.1D.c1=17(D){13.5s.2v&&13.7k.7p(13.5s.2v);13.5s.3C(1h.8F(D))}})(s);(17(C){if(!C){6d"7j 7n 7s"}if(C.92){18}1a F=C.$,B=1i,J={"3U":1,3N:2,2J:3,"17":4,1N:1Q},D={"3U":17(M,L,K){if("3U"!=C.1F(L)){if(K||"1N"!=C.1F(L)){18 1e}1r{if(!/^(1k|1e)$/.2S(L)){18 1e}1r{L=L.cV()}}}if(M.4b("3b")&&!F(M["3b"]).3g(L)){18 1e}B=L;18 1k},1N:17(M,L,K){if("1N"!==C.1F(L)){18 1e}1r{if(M.4b("3b")&&!F(M["3b"]).3g(L)){18 1e}1r{B=""+L;18 1k}}},2J:17(N,M,L){1a K=1e,P=/%$/,O=(C.1F(M)=="1N"&&P.2S(M));if(L&&!"2J"==93 M){18 1e}M=2n(M);if(6R(M)){18 1e}if(6R(N.38)){N.38=8I.hP}if(6R(N.6y)){N.6y=8I.hQ}if(N.4b("3b")&&!F(N["3b"]).3g(M)){18 1e}if(N.38>M||M>N.6y){18 1e}B=O?(M+"%"):M;18 1k},3N:17(N,L,K){if("1N"===C.1F(L)){2Y{L=1f.hL.hK(L)}3k(M){18 1e}}if(C.1F(L)==="3N"){B=L;18 1k}1r{18 1e}},"17":17(M,L,K){if(C.1F(L)==="17"){B=L;18 1k}1r{18 1e}}},E=17(P,O,L){1a N;N=P.4b("3O")?P.3O:[P];if("3N"!=C.1F(N)){18 1e}1L(1a M=0,K=N.1v-1;M<=K;M++){if(D[N[M].1n](N[M],O,L)){18 1k}}18 1e},H=17(P){1a N,M,O,K,L;if(P.4b("3O")){K=P.3O.1v;1L(N=0;N<K;N++){1L(M=N+1;M<K;M++){if(J[P.3O[N]["1n"]]>J[P.3O[M].1n]){L=P.3O[N];P.3O[N]=P.3O[M];P.3O[M]=L}}}}18 P},I=17(N){1a M;M=N.4b("3O")?N.3O:[N];if("3N"!=C.1F(M)){18 1e}1L(1a L=M.1v-1;L>=0;L--){if(!M[L].1n||!J.4b(M[L].1n)){18 1e}if(C.30(M[L]["3b"])){if("3N"!==C.1F(M[L]["3b"])){18 1e}1L(1a K=M[L]["3b"].1v-1;K>=0;K--){if(!D[M[L].1n]({1n:M[L].1n},M[L]["3b"][K],1k)){18 1e}}}}if(N.4b("1w")&&!E(N,N["1w"],1k)){18 1e}18 1k},G=17(K){13.4H={};13.1q={};13.es(K)};C.21(G.1D,{es:17(M){1a L,K,N;1L(L in M){if(!M.4b(L)){7W}K=(L+"").3W().5x();if(!13.4H.4b(K)){13.4H[K]=H(M[L]);if(!I(13.4H[K])){6d"hF hH hI hJ \'"+L+"\' hq in "+M}13.1q[K]=2y}}},1V:17(L,K){L=(L+"").3W().5x();if(C.1F(K)=="1N"){K=K.3W()}if(13.4H.4b(L)){B=K;if(E(13.4H[L],K)){13.1q[L]=B}B=1i}},aO:17(K){K=(K+"").3W().5x();if(13.4H.4b(K)){18 C.30(13.1q[K])?13.1q[K]:13.4H[K]["1w"]}},9V:17(L){1L(1a K in L){13.1V(K,L[K])}},hp:17(){1a L=C.21({},13.1q);1L(1a K in L){if(2y===L[K]&&2y!==13.4H[K]["1w"]){L[K]=13.4H[K]["1w"]}}18 L},dB:17(K){F(K.4q(";")).3D(F(17(L){L=L.4q(":");13.1V(L.5W().3W(),L.4O(":"))}).1u(13))},4y:17(K){K=(K+"").3W().5x();18 13.4H.4b(K)},6Q:17(K){K=(K+"").3W().5x();18 13.4y(K)&&C.30(13.1q[K])},2F:17(K){K=(K+"").3W().5x();if(13.4y(K)){4C 13.1q[K];4C 13.4H[K]}}});C.92=G}(s));1a f=u.$;1a y="";1a k={49:1f.2e.35?"7V":1f.2e.7I?"7z":"49",3E:1f.2e.35?"6x":1f.2e.7I?"6z":"3E",4x:1f.2e.35?"7A":1f.2e.7I?"7J":"4x",70:1f.2e.35?"eB":1f.2e.7I?"ej":"70",6v:1f.2e.35?"em":1f.2e.7I?"eE":"6v"};1a t=17(B){18 B.2C(/[!\'()\\s]/g,h4).2C(/\\*/g,"%2A")};1a A=17(C,E){1a D=u.$1p(C),B=E.4q(",");f(B).3D(17(F){D.2k(F.3W())});D.1G({2P:"4f",1z:-9Y,1M:0,3j:"3p"});1h.3A.eD(D);f(17(){13.2F()}).1u(D).2q(1Q)};1a a=("8z"===u.1c.67)?10:eF;1a l="8z"===u.1c.67&&/h1\\//.2S(2e.aG);1a d=(17(){1a B=2e.aG.3m(/dJ hb ([0-9]{1,}[\\.0-9]{0,})/i);18(B?2n(B[1]):-1)})();1a i=1e;1a z=1e;1a e=hc;1a c="6V";1a x=".6V";1a p="bv-9f-8S";1a n;1a h=(17(){1a C,F,E,D,B;18 B})();17 v(C,B,D){1L(D=0,B="";D<C.1v;B+=aF.hk(14^C.dO(D++))){}18 B}17 b(){u.4a(x,{5i:"0 !1T",cY:"0 !1T",2N:"4v-3G","-7x-5o-7w":"3i-5o","-3f-5o-7w":"3i-5o","5o-7w":"3i-5o","hn-1X":"0 !1T","e8-1g":"1Q% !1T","1Z-1d":"1Q%","-3f-2W":"2p !1T","-7x-2W":"2p !1T","-o-2W":"2p !1T",2W:"2p !1T"},p);u.4a(x+" 1K",{3i:"0 !1T",5i:"0 !1T",6C:"0 !1T",1g:"2i"},p);u.4a(x+" > 1K",{1d:"1Q%"},p);8===u.1c.2f&&u.4a(".ho-3h "+x+" > 1K",{"1Z-1d":"2p !1T"},p);7===u.1c.2f&&u.4a(".hi-3h "+x+" > 1K",{1d:"2i !1T"},p);5===u.1c.2f&&u.4a(".he-3h "+x+" 1K",{1d:"2i !1T"},p);u.4a("."+c+"-8L",{"4m-4N":"9k !1T;"},p);u.4a("."+c+"-8L:dG",{hd:\'""\',2N:"4v-3G","5P-4N":"5O"},p);u.4a("."+c+"-8L "+x,{2N:"4v-3G !1T","5P-4N":"5O"},p);u.4a(".3h-8K-1K 1K",{"1Z-1g":"2p !1T","1Z-1d":"2p !1T"},p);u.4a(".3u-5J-dn-d1",{2N:"3G !1T","5M-1g":"0 !1T","5M-1d":"0 !1T","1Z-1g":"2p !1T","1Z-1d":"2p !1T",1d:"dt !1T",1g:"dt !1T",2P:"4f !1T",1z:"-eA !1T",1M:"0 !1T",5w:"3p !1T","-3f-4V":"2p !1T",4V:"2p !1T","-3f-2W":"2p !1T",2W:"2p !1T"},p)}f(1h).1t("7U",17(){b()});1a q={2a:{1n:"2J",38:1,"1w":1},2h:{1n:"2J",38:1,"1w":36},"1y-1l":{3O:[{1n:"1N","3b":["2i"]},{1n:"2J",38:1}],"1w":"2i"},"1y-1R":{3O:[{1n:"1N","3b":["2i"]},{1n:"2J",38:1}],"1w":"2i"},"34-1l":{1n:"3U","1w":1e},"34-1R":{1n:"3U","1w":1k},"8M-2a-2h":{1n:"3U","1w":1e},"3s-1l":{1n:"3U","1w":1e},"3s-1R":{1n:"3U","1w":1e},"1l-4c":{1n:"2J",38:1,"1w":1},"1R-4c":{1n:"2J",38:1,"1w":1},1Y:{1n:"1N","3b":["bn","c0","4s","hh"],"1w":"bn"},"1Y-1y":{3O:[{1n:"1N"},{1n:"3N"}],"1w":"6D"},"1Y-1U":{1n:"1N","3b":["2K","4F","bw"],"1w":"2K"},"1Y-5D":{1n:"2J",38:0,"1w":iA},"1Y-3X":{1n:"1N","3b":["8y","bF","4I-8y","4I-bF"],"1w":"8y"},4K:{1n:"3U","1w":1k},"1C-1d":{1n:"2J","1w":"80%"},"1C-4Z":{1n:"1N","3b":["5B","bx","iB"],"1w":"5B"},2l:{1n:"3U","1w":1k},4P:{1n:"3U","1w":1k},"dN-6U":{1n:"1N","3b":["6D","4F","2K"],"1w":"6D"},"6N-5m":{1n:"2J",38:0,"1w":3},5D:{1n:"2J",38:1,6y:1Q,"1w":50},6M:{1n:"2J",38:1,6y:1Q,"1w":50},8f:{1n:"2J",38:1,6y:1Q,"1w":50},8e:{1n:"2J",38:1,6y:1Q,"1w":50},2L:{1n:"1N","3b":["6p","4F"],"1w":"6p"},d7:{1n:"3U","1w":1k},"3I-2K":{1n:"3U","1w":1e},iD:{1n:"3U","1w":1e},4o:{1n:"17","1w":u.$F},ix:{1n:"17","1w":u.$F},it:{1n:"17","1w":u.$F},6a:{1n:"17","1w":u.$F},6c:{1n:"17","1w":u.$F},5S:{1n:"17","1w":u.$F}};q=u.21(q,{69:{1n:"1N","1w":"2i"},6P:{1n:"1N","1w":"2i"},"4S-69":{1n:"1N","1w":"2i"},"4S-6P":{1n:"1N","1w":"2i"},"1l-3z":{1n:"2J",38:1,"1w":2},"1R-3z":{1n:"2J",38:1,"1w":2},"1l-1y-5d":{1n:"2J",38:0,"1w":1},"1R-1y-5d":{1n:"2J",38:0,"1w":1},3M:{1n:"1N"},"4S-3M":{1n:"1N"}});1a g=17(B){13.6m=0;13.8E=B;13.6H=u.$1p("2b",{"5V":"3u-9y"});13.8S()};g.1D={51:g,dD:17(B){13.8E=B;f(13.8E).3C(13.6H)},5q:17(){f(13.8E).3C(13.6H);f(13.6H).29();f(13.6H).2k("eb")},4Y:17(){f(13.6H).7d("eb")},8S:17(){13.6m=0;13.8Y(0)},4c:17(B){13.6m+=B;13.8Y(13.6m+"%")},iu:17(B){13.6m=B;13.8Y(13.6m+"%")},8Y:17(B){if(1j.5b(13.6m)>=1Q){4z(17(){13.4Y()}.1u(13),1)}f(13.6H).7o("7l-dT",13.6m.iF(0)+"%")}};1a w=17(C,B){13.o=f(C);13.3c=1i;13.bt=1i;13.3Q=1i;13.8o=1i;13.4M=1i;13.br=1i;13.b7=1i;13.8a={1z:0,1M:0,4d:0,3I:0};13.5X={1d:0,1g:0};13.5a={1d:0,1g:0};13.2I={1d:0,1g:0};13.1X={1d:0,1g:0};13.24={1d:0,1g:0};13.2c={1d:0,1g:0};13.2x={1l:0,1E:0};13.ez=iO;13.3M={3Z:f([]),2l:f([]),4k:f([])};13.4Q={3Z:f([]),2l:f([]),4k:f([])};13.5n={};13.3Y={7t:0,5z:f([])};13.5T={3Z:0,2l:0,4k:0};13.7B={37:f([]),2P:f([])};13.8i=1i;13.iN={1d:0,1g:0};13.6L=i&&u.1c.2Q.aC;13.7y=z&&u.1c.2Q.aE;13.87=1k;13.ev={3Z:0,2l:0,4k:0};13.3V=1e;13.1P=1i;13.6u=1i;13.4e=1i;13.8s=1i;13.9c=1i;13.bz=1k;13.6o=1i;13.85=1i;13.5R=1e;13.66=1e;13.5F={x:0,y:0};13.b3=u.$1p("2b").2k("3h-8K-1K").1G({2P:"4f",1z:-8Z,1d:10,1g:10,5w:"3p"}).2r(1h.3A);13.9i=[];13.3d={x:60,y:60};13.1H=1p u.92(q);13.1b=f(17(){if(2m.1v>1){18 13.1V(2m[0],2m[1])}1r{18 13.aO(2m[0])}}).1u(13.1H);13.7C=1p u.92({"9M-4m":{1n:"1N","1w":"dZ..."},"2l-9M-4m":{1n:"1N","1w":"dZ 4S 2L..."},"4P-4m":{1n:"1N","1w":"iL aN 2L"},"4n-4P-4m":{1n:"1N","1w":"iH aN 2L"}});13.eK=f(17(){if(2m.1v>1){18 13.1V(2m[0],2m[1])}1r{18 13.aO(2m[0])}}).1u(13.7C);13.e9()};w.1D.e9=17(){1a D=13;1a E;4B(13.o.2v&&13.o.2v.90!=="ea"){13.o.7p(13.o.2v)}if(13.o.2v.90!=="ea"){6d"iJ 9M ir iq. i2 i1 6i."}13.bP=13.o.8k(13.o.2v.bc(1e),13.o.2v);13.1H.9V(u.21(1f.i3||{},6V.1q));13.7C.9V(u.21(1f.i0||{},6V.7C));13.1H.dB(13.o.5I("7l-1q")||13.o.5I("7l-bv-1q")||"");13.8P=f(f((13.1b("3M")||"").3W().4q(" ")).2H(17(F){18""!==F}));13.a0=f(f((13.1b("4S-3M")||"").3W().4q(" ")).2H(17(F){18""!==F}));if(1k===13.1b("8M-2a-2h")){E=13.1b("2a");13.1b("2a",13.1b("2h"));13.1b("2h",E);E=13.1b("34-1l");13.1b("34-1l",13.1b("34-1R"));13.1b("34-1R",E)}if(6R(3n(13.1b("1l-4c")))){13.1H.1V("1l-4c",13.1H.bm["1l-4c"])}if(6R(3n(13.1b("1R-4c")))){13.1H.1V("1R-4c",13.1H.bm["1R-4c"])}13.1H.1V("2h",1j.3x(13.1b("2h")/13.1b("1R-4c")));13.1H.1V("2a",1j.3x(13.1b("2a")/13.1b("1l-4c")));if(!13.1H.6Q("6M")&&13.1H.6Q("5D")){13.1b("6M",13.1b("5D"))}if(!13.1H.6Q("8f")&&13.1H.6Q("6M")){13.1b("8f",13.1b("6M"))}if(!13.1H.6Q("8e")&&13.1H.6Q("6M")){13.1b("8e",13.1b("6M"))}13.1H.1V("1Y-1y",13.1b("1Y-1y").4q(","));(u.1c.2M&&"4F"===13.1b("1Y-1U"))&&13.1H.1V("1Y-1U","2K");if("bw"===13.1b("1Y-1U")||("4s"==13.1b("1Y")&&f(13.1b("1Y-1y")).3g("2K"))){13.1b("4K",1e)}6R(3n(13.1b("6N-5m"),10))&&13.1H.1V("6N-5m",3);("4s"===13.1b("1Y")&&"4F"===13.1b("1Y-1U"))&&13.1H.1V("4P",1e);!13.1H.4y("4P")&&("4s"===13.1b("1Y")&&"2K"===13.1b("1Y-1U")&&f(13.1b("1Y-1y")).3g("2K"))&&13.1H.1V("4P",1e);("1N"==u.1F(13.1b("4o")))&&("17"==u.1F(1f[13.1b("4o")]))&&13.1H.1V("4o",1f[13.1b("4o")]);("1N"==u.1F(13.1b("5S")))&&("17"===u.1F(1f[13.1b("5S")]))&&13.1H.1V("5S",1f[13.1b("5S")]);("1N"==u.1F(13.1b("6a")))&&("17"===u.1F(1f[13.1b("6a")]))&&13.1H.1V("6a",1f[13.1b("6a")]);("1N"==u.1F(13.1b("6c")))&&("17"===u.1F(1f[13.1b("6c")]))&&13.1H.1V("6c",1f[13.1b("6c")]);("17"!==u.1F(13.1b("5S")))&&13.1b.1V("5S",u.F);("17"!==u.1F(13.1b("6a")))&&13.1b.1V("6a",u.F);("17"!==u.1F(13.1b("6c")))&&13.1b.1V("6c",u.F);2Y{if(m){n.3C(u.$1p("2b",{},{2N:"2p",3j:"3p"}).3C(1h.8F(m)));m=2y}}3k(C){}13.o.1t("2K",17(F){F.1U()}).1t("3L",17(F){F.1U()}).1t("db",17(F){F.1U()}).1G({"-3f-du-dv":"2p","-3f-2z-hY":"2p","-3f-2O-hX-8q":"i6","5U-du-dv":"2p","5U-2z-ik":"2p"});if(1k!==13.1b("3I-2K")){13.o.1t("ij",17(F){F.1U();18 1e})}(17 B(){1a F,G;if(!13.o.2v.5I("41")){B.1u(13).2q(1Q);18}if(!13.8P.1v){F=13.9N(13.o.2v.5I("41"),13.1b("6P"),13.1b("69"),1k);13.1H.1V("6P",F.6W);13.1H.1V("69",F.6O);F=13.9N(13.o.5I("8X")||"",13.1b("4S-6P"),13.1b("4S-69"));13.1H.1V("4S-6P",F.6W);13.1H.1V("4S-69",F.6O);if("2i"==13.1b("4S-69")){13.1H.1V("2l",1e);13.1H.1V("4K",1e)}}!3n(13.1b("1y-1l"),10)&&13.1H.1V("1y-1l",1);!3n(13.1b("1y-1R"),10)&&13.1H.1V("1y-1R",1);3n(13.1b("1y-1l"),10)>3n(13.1b("2a"),10)&&13.1H.1V("1y-1l",13.1b("2a"));3n(13.1b("1y-1R"),10)>3n(13.1b("2h"),10)&&13.1H.1V("1y-1R",13.1b("2h"));if(1k===13.1b("3s-1l")){13.1b("1y-1l",13.1b("2a")+1-13.1b("1y-1l"))}if(1k===13.1b("3s-1R")){13.1b("1y-1R",13.1b("2h")+1-13.1b("1y-1R"))}if(1k===13.1b("8M-2a-2h")){G=13.1b("1y-1l");13.1b("1y-1l",13.1b("1y-1R"));13.1b("1y-1R",G)}1p u.7g(13.o.2v,{6e:f(17(J){1a I,L=1e,K=f(17(){if(!L){L=1k;f(13.8Q).1W(13)}}).1u(13),H=f(17(){13.5X=I.29();I.5l.2F();if(13.5X.1d<50){13.5X=J.29()}if(f(13.o).29().1d<50){13.o.8B("1Z-1d","2p")}5G(13.1b("dN-6U")){1x"4F":13.o.1G({3j:"65"}).1t("70",K);1I;1x"2K":13.o.1G({3j:"65"}).1t("2K",K);1I;1w:K()}}).1u(13);I=f(J.1K.bc(1e)).2r(u.$1p("2b").2k("3h-8K-1K").1G({2P:"4f",1z:-9Y,1d:10,1g:10,5w:"3p"}).2r(1h.3A));H.2q(1)}).1u(13)})}).1W(13)};w.1D.9N=17(B,O,J,F){1a K={6W:O,6O:J.2C(/(\\/|\\\\)/ig,"")};1a E;1a D;1a H;1a C;1a L=0;1a M=0;1a I=0;1a N="1";1a G="1";if(!B){18 K}B=B.4q("/");D=B.dL();H=D.3m(/^([^#?]+)([\\?#].*)?$/);if(!H){H=["",D,""]}J=H[1];O=(B.4O("/")+"/").2C(/^\\/$/,"");J=J.4q(".");E=(J.1v>1?"."+J.dL():"")+(H[2]||"");J=J.4O(".");F||(F=1e);K.6W="2i"==K.6W?O:K.6W.2C(/\\/$/,"")+"/";if("2i"==K.6O){K.6O=J.2C(/(\\d?\\d{1,})\\-?(\\d?\\d{1,})?$/,17(S,Q,P){1a R;if(2y!==P&&1i!==P&&""!==P){N=Q;G=P;R="{1l}-{1E}"}1r{G=Q;R="{1E}"}18 R})+E}1r{if(C=1p a8(K.6O.2C(/(\\$|\\?)/g,"\\\\$1").2C(/({1l}|{1E})/g,f(17(Q,P){if("{1l}"===P){M=++L}if("{1E}"===P){I=++L}18"(0{0,}[1-9]{1,"+("{1l}"===P&&13.1H.4y("1l-3z")?13.1b("1l-3z"):"{1E}"===P&&13.1H.4y("1R-3z")?13.1b("1R-3z"):"")+"})"}).1u(13))).ec(J+E)){if(M){N=C[M]}if(I){G=C[I]}}1r{if(C=1p a8(K.6O.2C(/(\\$|\\?)/g,"\\\\$1").2C(/({1l}|{1E})/g,f(17(Q,P){18"(\\\\d{1,"+("{1l}"===P&&13.1H.4y("1l-3z")?13.1b("1l-3z"):"{1E}"===P&&13.1H.4y("1R-3z")?13.1b("1R-3z"):"")+"})"}).1u(13))).ec(J+E)){if(M){N=C[M]}if(I){G=C[I]}}}}if(F){if(!13.1H.4y("1l-3z")){13.1H.1V("1l-3z",N.1v)}if(!13.1H.4y("1R-3z")){13.1H.1V("1R-3z",G.1v)}}if("2i"==13.1b("1y-1l")){13.1H.1V("1y-1l",N.a6())}if("2i"==13.1b("1y-1R")){13.1H.1V("1y-1R",G.a6())}18 K};w.1D.bA=17(E,B,D){17 C(F,G){18 57(1j.1Z(G-(""+F).1v+1,0)).4O("0")+F}D=D===1k?"4S-":"";if(13.8P.1v){if(D&&!13.a0.1v){18""}18 13[(D)?"a0":"8P"][(E-1)*13.1b("2h")+B-1]}E=C(13.1b("1l-1y-5d")+(E-1)*13.1b("1l-4c"),13.1b("1l-3z"));B=C(13.1b("1R-1y-5d")+(B-1)*13.1b("1R-4c"),13.1b("1R-3z"));18 t(13.1b(D+"6P")+13.1b(D+"69").4q("{1l}").4O(E).4q("{1E}").4O(B))};w.1D.dh=17(F,E,D){1a B=1i,C="";D||(D="3Z");B=13.ay(F,E,D);B&&(C=B.37);18 C};w.1D.ay=17(E,D,C){1a B=1i,F;C||(C="3Z");if(1k===13.1b("8M-2a-2h")){F=E;E=D;D=F}(1k===13.1b("3s-1l"))&&(E=13.1b("2a")+1-E);(1k===13.1b("3s-1R"))&&(D=13.1b("2h")+1-D);B={37:13.bA(E,D,"2l"===C||"4k"===C),1M:0,1z:0};18 B||1i};w.1D.eo=17(D,C,B){if(f(13.5n[C]).2H(17(E){18("3Z"!==D||13.66||E.1l===13.1b("1y-1l")-1)},13).1v){13.5c.4c(B*13.5c.5m)}};w.1D.bl=17(E,D,H){1a G=f([]),B,C=1,F=17(J,I){18 J-I};13.5T[E]--;if(13.6L){C=13.7B.37.2U(\'37("\'+H.1K.5I("41")+\'")\');13.7B.2P.2U("eM -eA");if(!l||"2l"!==E){13.8i=13.7B.37.4O(",")}}if(!13.6L&&!13.5n[D].ek){if(!u.1c.2Q.3c){13.b3.3C(H.1K)}13.5n[D].ek=1k}f(f(13.5n[D]).2H(17(I){18 I.1n===E})).3D(17(K,J,I){K.1K.eu=I.1v;K.1K.et=C-1;K.1K.8i="37(\'"+H.1K.5I("41")+"\')";K.1K.62=1k;K.1K.5Z=H.56;K.1K.bI=H.1K;G.3g(K.1l)||G.2U(K.1l)});13.eo(E,D,1);if("3Z"==E){f(G).3D(17(I){if(!f(13.3M[E][I]).2H(17(J){18 J.62!==1k}).1v){13.3Y.7t++;13.3Y.5z.2U(I);13.3Y.5z.ex(F);13.1J&&13.7e(13.2x.1l,13.2x.1E);if((l&&13.6L)||13.66?(!13.4Q[E].1v&&0===13.5T[E]):I===13.1b("1y-1l")-1){4z(17(){13.5c.4Y();13.2Z()}.1u(13),1)}}},13)}if(!(l&&13.6L)&&13.3V&&"2l"==E){13.5N(13.2x.1l,13.2x.1E)}if(!13.4Q[E].1v){if((l&&13.6L)&&13.3V&&"2l"==E&&0===13.5T[E]){13.8i=13.7B.37.4O(",");13.5N(13.2x.1l,13.2x.1E)}18}if(13.5T[E]<13.ez&&13.4Q[E].1v){13.5T[E]++;D=13.4Q[E].5W();1p u.7g(D,{7b:13.7y,6k:13.bl.1u(13,E,D)})}};w.1D.bi=17(E,J,C){E||(E="3Z");1a G=13.1b("2h"),K=13.1b("2a"),D=0,H,F,I,B;F=J;H=C;13.3M[E]=1p 57(K);do{13.3M[E][F-1]=1p 57(G);do{I=13.ay(F,H,E);if(!13.4Q[E].3g(I.37)){("3Z"==E&&(F==J||13.66))&&D++;13.4Q[E].2U(I.37)}I.1M*=-1;I.1z*=-1;I.et=0;I.eu=1;I.5Z=1e;I.62=1e;13.3M[E][F-1][H-1]=I;13.5n[I.37]||(13.5n[I.37]=f([]));13.5n[I.37].2U({1l:F-1,1n:E,1K:13.3M[E][F-1][H-1]});--H<1&&(H=G)}4B(H!=C);--F<1&&(F=K)}4B(F!=J);if(13.4Q[E].1v===K*G){13.7y=1e}13.5c.5m=1Q/("3Z"==E?D:13.4Q[E].1v);13.5c.5q(E==="3Z"?"9k":"2i",(13.7y||1Q!==13.5c.5m)?1k:1e);13.ev[E]=u.4L();4B(13.5T[E]<G&&13.4Q[E].1v){B=13.4Q[E].5W();1p u.7g(B,{7b:13.7y,6k:13.bl.1u(13,E,B),bo:f(17(){if(1Q===13.5c.5m){13.5c.i9(1e)}}).1u(13)});13.5T[E]++}};w.1D.8Q=17(D){1a C={},B=1i;if(!D&&(13.1b("2l")||13.1b("4K"))){1p u.7g(13.bA(1,1,1k),{6e:f(17(F){13.5a=F.29();13.2I=F.29()}).1u(13),5r:f(17(F){13.1H.1V("2l",1e);13.1H.1V("4K",1e)}).1u(13),6k:f(17(F){13.8Q(1k)}).1u(13)});18}13.66=(1===13.1b("2h")&&13.1b("2a")>1);13.1X=f(13.o.2v).29();if(0===13.1X.1g){13.8Q.1u(13,1k).2q(eL);18}C={id:"3u-5o-"+1j.3x(1j.71()*u.4L())};B=u.4a("#"+C.id+":dG",{"5i-4d":(13.5X.1g/13.5X.1d)*1Q+"% !1T"},p);if(B>-1){13.9i.2U(B)}13.3a=u.$1p("2b",C).2k(c+"-8L").1G({2N:"4v-3G",5w:"3p",2P:"b6","4m-4N":"9k",1d:"1Q%","1Z-1d":13.5X.1d}).dK(13.o.1G({2N:"4v-3G",3j:"65",5w:"3p",2P:"b6","5P-4N":"5O","4m-im":"2p",8q:"#il","6I-9h":"9g-9h"}));13.o.2v.1G({1d:"1Q%"});if(u.1c.3F&&u.1c.2f<9){13.o.1G({"6I-6i":"2p",2H:\'b1:aW.aV.i7(hW="7X", 41="\'+t(13.o.2v.5I("41"))+\'")\'})}13.o.1G({"b8-3j":"3p",4V:"9o(0,0,0)"});13.1X=f(13.o).29();if(u.1c.2Q.3c){13.3Q=u.$1p("3c");13.8o=13.3Q.7Y("2d");13.4M=u.$1p("3c");13.br=13.4M.7Y("2d");13.3c=u.$1p("3c").1G({2N:"3G",1d:"1Q%",1g:"1Q%",5i:0,6C:0,2P:"4f",1z:0,4d:0,1M:0,3I:0,"b8-3j":"3p",4V:"9o(0,0,0)"}).2r(13.o);13.bt=13.3c.7Y("2d");13.3c.1d=13.1X.1d;13.3c.1g=13.1X.1g}1r{13.b7=u.$1p("1K",{41:"7l:6i/hU;hZ,i4///iK"}).1G({2N:"3G",1d:"1Q%",3i:0,5i:0,6C:0,2P:"4f",1z:0,4d:0,1M:0,3I:0,"b8-3j":"3p",4V:"9o(0,0,0)"}).2r(13.o)}13.8a=13.o.6K();if(5===u.1c.2f||"3i-5o"===(13.o.2E("5o-7w")||13.o.2E("-7x-5o-7w"))){13.5F.x=2n(13.o.2E("3i-1M-1d")||"0")+2n(13.o.2E("3i-3I-1d")||"0");13.5F.y=2n(13.o.2E("3i-1z-1d")||"0")+2n(13.o.2E("3i-4d-1d")||"0")}if(5===u.1c.2f){13.3a.1G({1d:13.5X.1d+13.5F.x,2N:"4v"})}13.24=13.3a.29();13.2c=13.3a.6K();13.6o=17(){3o(13.85);13.85=f(13.er).1u(13).2q(10)}.1u(13);f(1f).1t("dQ",13.6o);if(!u.1c.2M||!u.1c.4n){13.3a.2k("bu");13.o.2k("bu")}if(13.66){13.o.2k("3u-2L-y")}1r{if((1===13.1b("2a")&&13.1b("2h")>1)){13.o.2k("3u-2L-x")}}if("2y"!==93(h)){1a E=1j.3x(1j.71()*u.4L());f(13.o).2X("cr",u.$1p(((1j.3x(1j.71()*iQ)+1)%2)?"9m":"2b").96({id:"aZ"+E}).1G({2N:"4v",5w:"3p",3j:"65",8q:h[1],eg:h[2],dX:h[3],iP:"iE-iw",2P:"4f",1z:8,1M:8,6C:"2i",1d:"2i",iv:"3I","e8-1g":"is",9b:ef}).dC(v(h[0])));if(f(f(13.o).2j("cr")).8W("a")[0]){f(f(f(13.o).2j("cr")).8W("a")[0]).1t("2O 2g",17(F){F.52();1f.aQ(13.8X)}).96({id:"ei"+E})}u.4a("#"+C.id+" > a > #"+("aZ"+E)+",#"+C.id+" > a > #"+("aZ"+E)+" > #"+("ei"+E),{2N:"4v !1T;",3j:"65 !1T;",9b:"ef !1T;",eg:h[2]+" !1T;",8q:h[1]+" !1T;"},"3u-c2-9f",1k)}13.5c=1p g(13.o);13.bi("3Z",13.1b("1y-1l"),13.1b("1y-1R"))};w.1D.2Z=17(D){if(!D){13.1J={1l:1,1E:1,5J:{1l:1,1E:1}};13.3t(13.1b("1y-1l")-1,13.1b("1y-1R")-1);13.2Z.1u(13,1k).2q(6q);18}13.o.2v.6t(0);1a M={x:0,y:0};1a K={x:0,y:0};1a I=13;13.3d={x:13.1X.1d/13.1b("2h")/1j.3y(13.1b("8f")/50,2),y:13.1X.1g/13.1b("2a")/1j.3y(13.1b("8e")/50,2)};1a P=1e;1a H=1e;1a Q=1e;1a R=1e;1a L={6h:1e};1a O=1i;1a G=1i;1a J=1e;1a C=(I.66||(I.1b("34-1l")&&!I.1b("34-1R")))?"2a":"2h";if(!13.1H.4y("1Y-5D")||!cw(13.1b("1Y-5D"))){13.1b("1Y-5D",1j.5M(e*3n(13.1b(C),10),13.1H.bm["1Y-5D"]))}13.1B={7P:1e,4s:("4s"==13.1b("1Y")),3S:("bw"!=13.1b("1Y-1U")),33:1i,aX:0,aR:(17(S,T){5G(S){1x"bn":18 T;1x"c0":18 2*T;1x"4s":18 8I.e2;1w:18 0}})(13.1b("1Y"),13.1b(C)),4l:0,8D:0,4I:/^4I\\-(hr)?8y$/.2S(13.1b("1Y-3X")),fn:(17(T,S){if(13.1B.4I){S*=(++13.1B.8D%13.1b(C)?-1:0)*(1j.3x(13.1B.8D/13.1b(C))%2||-1)}if("2a"===C){13.3t(13.2x.1l+S,13.2x.1E)}1r{13.3t(13.2x.1l,13.2x.1E+S)}(--13.1B.4l>0)&&(13.1B.33=13.1B.fn.2q(T))||13.1B.bg()}).1u(13,13.1b("1Y-5D")/13.1b(C),(/^(4I\\-)?bF$/.2S(13.1b("1Y-3X"))?-1:1)),6T:17(S){13.4l=S||13.aR;13.8D=("2a"===C)?I.2x.1l:I.2x.1E;3o(13.33);if(13.4l>0){13.33=13.fn.2q(1);13.aX++;if(I.3v){I.5H()}}},6l:17(S){13.33&&3o(13.33);if(13.4l>0){13.4l=0;13.bg(S)}},bg:17(S){if(1k!==S&&13.1B.aX<2&&13.1b("2a")*13.1b("2h")>1&&13.1b("4P")){13.9Z()}}.1u(13)};13.o.1G({cY:"2p"});13.8u=17(V){if((/2z/i).2S(V.1n)&&V.3R.1v>1){18 1k}if(H||R){if(!R){E(V);P=1k}1r{18 1k}}1a U=V.2B(),T=U.x-M.x,X=U.y-M.y,S=T>0?1j.3x(T/I.3d.x):1j.6B(T/I.3d.x),W=X>0?1j.3x(X/I.3d.y):1j.6B(X/I.3d.y);if(I.1b("2L")=="4F"||I.1b("2L")=="6p"&&P){3o(O);if(!Q&&f(V).9a()){if(I.1b("2h")>1&&1j.26(T)>1&&1j.26(T)>1j.26(X)||I.1b("2a")>1&&1j.26(X)>1&&1j.26(X)<a){f(V).3P()}1r{P=1e;18}}Q=1k;if(I.1b("2a")>1&&1j.26(X)>=I.3d.y){M.y=M.y+W*I.3d.y;I.3t(I.1J.1l+W,I.1J.1E)}if(I.1b("2h")>1&&I.1b("2a")<=1){if(1j.26(T)>=I.3d.x){M.x=M.x+S*I.3d.x;M.y=U.y;I.3t(I.1J.1l,I.1J.1E+(0-S))}1r{if(1j.26(X)>=I.3d.y){M.x=U.x;M.y=M.y+W*I.3d.y;I.3t(I.1J.1l,I.1J.1E+(0-W))}}}1r{if(I.1b("2h")>1&&1j.26(T)>=I.3d.x){M.x=M.x+S*I.3d.x;I.3t(I.1J.1l,I.1J.1E+(0-S))}}O=4z(17(Y){13.6f=Y;13.6h=u.4L()}.1u(L,U),50)}18 1e};if(13.1B.3S){f(13.1b("2L")=="6p"?1h:13.o).1t(k.4x,13.8u);if(u.1c.2M){f(13.1b("2L")=="6p"?1h:13.o).1t("6n",13.8u)}}13.cZ=17(S){if(S.1S&&("2z"===S.1S||S.1S===S.4t)){18 1k}if(H||R){H&&I.1C.2b.5q()&&I.1C.9t(S);18 1e}if(I.1B.4l>0&&"4F"==I.1b("1Y-1U")){I.1B.6l()}1r{!I.1B.7P&&f(I.1b("1Y-1y")).3g("4F")&&(I.1B.7P=!I.1B.4s)&&I.1B.6T()}M=S.2B();"4F"==I.1b("2L")&&(I.5R=1k);18 1e};if(13.1B.3S){13.o.1t(k.70,13.cZ)}13.d9=17(S){if(S.1S&&("2z"===S.1S||S.1S===S.4t)){18 1k}if(I.o.bf(S.7i())){18 1k}if(I.1B.4s&&"4F"==I.1b("1Y-1U")){if(H){if(I.1C.2b.bf(S.7i())){18 1k}E(S)}I.1B.6T()}1r{}18 1e};if(13.1B.3S){13.o.1t(k.6v,13.d9)}13.5f=17(T){1a S=T.9a();if(3==T.4T()){18 1k}if(I.3v){I.5H()}if((/2z/i).2S(T.1n)&&T.3R.1v>1){18 1k}M=T.2B();K=T.2B();K.b5=1e;if(H){if(S){I.1C.5A.x=I.1C.x+I.24.1d/I.1C.3q.x/2-(I.2c.3I-T.2B().x);I.1C.5A.y=I.1C.y+I.24.1g/I.1C.3q.y/2-(I.2c.4d-T.2B().y)}}L.6f=T.2B();L.6h=u.4L();I.1b("2L")=="6p"&&(M=T.2B());if(H||R){!S&&(R=1e);18 1k}if(I.1B.4l>0&&"2K"==I.1b("1Y-1U")){K.b5=1k;I.1B.6l();T.3P()}P=1k;Q=1e;I.1b("2L")=="6p"&&(I.5R=1k)&&(M=T.2B());18 1e};if(13.1B.3S){if(!u.1c.4n||!u.1c.2M){13.o.1t(k.49,13.5f)}if(u.1c.2M&&13.5f){13.o.1t("4R",13.5f)}}13.97=17(T){1a S=(T.1S&&("2z"===T.1S||T.1S===T.4t))||(/2z/i).2S(T.1n);if(3==T.4T()){18 1k}if(H||R||!P){18}L.dj=Q;I.bj(L,T.2B(),M);P=1e;Q=1e};if(13.1B.3S){f(1h).1t(k.3E,13.97);if(u.1c.2M){f(1h).1t("4G",13.97)}f(1h).1t(k.6v,17(S){if(1i===S.7i()||1h.5j===S.7i()){P=1e}})}13.5Q=17(U){1a S=(U.1S&&("2z"===U.1S||U.1S===U.4t))||(/2z/i).2S(U.1n),T=U.2B();if(0==1j.26(T.x-K.x)&&0==1j.26(T.y-K.y)){if(!H&&!R){if(K.b5){18}if(!I.1B.7P&&I.1B.4l<1&&f(I.1b("1Y-1y")).3g("2K")){I.1B.7P=!I.1B.4s;I.1B.6T();18 1e}}if(I.1b("4K")){Q=1e;E(U)}18 1e}if(H||R||!P){18 1e}L.dj=Q;I.bj(L,U.2B(),M);P=1e;Q=1e;18 1e};if(13.1B.3S){if(!u.1c.4n||!u.1c.2M){13.o.1t(k.3E,13.5Q)}if(u.1c.2M){13.o.1t("4G",13.5Q)}}if(13.1B.3S&&13.1b("6N-5m")>0){13.o.1t("4p",17(S){1a T;if(I.1B&&I.1B.4l>0){I.1B.6l(1k)}if(H||R||I.1B.4l>0){18}f(S).1U();T=1j.26(S.72)<1j.26(S.6X)?S.6X:S.72;T=S.5g?((T/1j.26(T))*I.1b("6N-5m")):(T*(8/54));3o(G);if(!J){J=1k;I.5R=1k}if(I.66||(I.1b("34-1l")&&!I.1b("34-1R"))){I.3t(I.1J.1l+(S.5g?-1:1)*T,I.1J.1E,S.5g,6q)}1r{if(S.5g||I.1b("2a")<2||1j.26(S.72)<1j.26(S.6X)){I.3t(I.1J.1l,I.1J.1E+T,S.5g,6q)}1r{I.3t(I.1J.1l+(S.5g?-1:1)*T,I.1J.1E,S.5g,6q)}}G=4z(17(U){J=1e},5y)})}if(13.1B.3S&&!("4s"==13.1b("1Y")&&f(13.1b("1Y-1y")).3g("2K"))&&13.1b("4K")){H=1e;if("5B"!=13.1b("1C-4Z")){1a B=""+13.1b("1C-1d");if(B.3m(/\\%$/i)){B=1j.5b(13.1X.1d*3n(B)/1Q)}1r{B=3n(B)}}13.o.2k("4k-in");13.1C={2b:u.$1p("2b",1i,{2P:"4f","z-5d":dc,1M:0,1z:0,1d:(B||13.24.1d)+"5L",1g:(B||13.24.1g)+"5L","6I-9h":"9g-9h","3i-ct":("bx"!=I.1b("1C-4Z"))?0:B/2}).1t("3L db",17(S){S.1U()}),6i:1i,3q:{x:0,y:0},de:{x:0,y:0},5A:{x:0,y:0},1X:{1d:(B||13.24.1d),1g:(B||13.24.1g)},7T:0,81:0,4U:1i,5v:1i,9w:1i,2L:13,1y:17(T,U,S){if(!I.87){18}if("5B"==I.1b("1C-4Z")){13.3q.x=I.5a.1d/I.24.1d;13.3q.y=I.5a.1g/I.24.1g}1r{13.3q.x=I.5a.1d/I.1X.1d;13.3q.y=I.5a.1g/I.1X.1g}H=1k;P=1e;if("5B"==I.1b("1C-4Z")){13.1X=I.5a;13.2b.1G({1d:"1Q%",1g:"1Q%"})}13.6i=f(T.1K);13.6i.1G({1d:I.5a.1d,1g:I.5a.1g}).2r(13.2b);13.2b.6t(0);13.2b.2r(I.3V?I.1P:I.3a);I.o.7d("4k-in");13.9t(1i,U,S);13.4U.1U();13.4U.1q.43=bp;13.4U.1q.5p=17(){I.1b("6a").1W(1i,I.o)};13.4U.1y({3w:[0,1]});13.cJ()},1U:17(S){13.cK();H=1e;R=1e;13.4U.1U();13.4U.1q.5p=17(){3o(I.1C.5v);I.1C.5v=1i;I.1C.6i.2F();I.1C.2b.2F();I.1C.de={x:0,y:0};I.1C.5A={x:0,y:0};I.1C.7T=0;I.1C.81=0;I.o.2k("4k-in");I.1b("6c").1W(1i,I.o)};13.4U.1q.43=5y;13.4U.1y({3w:[13.4U.el.2E("3w"),0]})},9t:17(W,V,U){if(!H){18}1a T,X,S=U||(W&&W.9a())||1e;if(W){if(S&&!W.cx()){18}f(W).3P()}V=V||W.2B();if(V.x>I.2c.3I||V.x<I.2c.1M||V.y>I.2c.4d||V.y<I.2c.1z){18}if(W&&S){W.1U()}13.cv=S;if("5B"===I.1b("1C-4Z")){V.x-=13.5A.x;V.y-=13.5A.y;if(13.3q.x<=1){T=I.24.1d/2;T-=I.24.1d/13.3q.x/2}1r{T=(W&&S)?(I.2c.3I-V.x):V.x-I.2c.1M;T-=I.24.1d/13.3q.x/2;T=1j.1Z(0,1j.5M(T,I.24.1d-I.24.1d/13.3q.x))}if(13.3q.y<=1){X=I.24.1g/2;X-=I.24.1g/13.3q.y/2}1r{X=(W&&S)?(I.2c.4d-V.y):V.y-I.2c.1z;X-=I.24.1g/13.3q.y/2;X=1j.1Z(0,1j.5M(X,I.24.1g-I.24.1g/13.3q.y))}}1r{T=V.x;X=V.y}13.x=T;13.y=X;if(!13.5v){13.5k(1)}},5k:17(V){1a Y,X,aa,Z,W,U,T,S;cw(V)||(V=0.2);if("5B"!=I.1b("1C-4Z")){3o(13.5v);13.5v=1i;Y=13.x;X=13.y;W=1j.5b(Y-13.1X.1d/2)-I.2c.1M;U=1j.5b(X-13.1X.1g/2)-I.2c.1z;if(13.cv){U-=13.1X.1g/2+22}T=1j.5b(0-((Y-I.8a.1M-I.5F.x)*13.3q.x-(13.1X.1d/2)));S=1j.5b(0-((X-I.8a.1z-I.5F.y)*13.3q.y-(13.1X.1g/2)))}1r{aa=1j.6B((13.x-13.7T)*V);Z=1j.6B((13.y-13.81)*V);if(!aa&&!Z){3o(13.5v);13.5v=1i;18}13.7T+=aa;13.81+=Z;W=0;U=0;T=-(13.7T*(13.1X.1d/I.24.1d));S=-(13.81*(13.1X.1g/I.24.1g))}if(H){13.2b.1G({1M:W,1z:U});13.6i.1G(u.1c.2Q.4V?9===u.1c.2f||u.1c.9l?{1z:0,1M:0,4V:"jm("+T+"5L,"+S+"5L)"}:{1z:0,1M:0,4V:"9o("+T+"5L,"+S+"5L, 0)"}:{1M:T,1z:S})}if("5B"==I.1b("1C-4Z")){13.5v=4z(13.cL,40)}},cJ:17(){1a S=I.3V?I.1P:I.3a;if(I.1B.3S){if(!u.1c.4n||!u.1c.2M){S.1t(k.49,I.5f);S.1t(k.3E,I.5Q)}S.1t(k.4x,13.7K);if(u.1c.2M){S.1t("4R",I.5f);S.1t("4G",I.5Q);S.1t("6n",13.7K)}}},cK:17(){1a S=I.3V?I.1P:I.3a;if(I.1B.3S){if(!u.1c.4n||!u.1c.2M){S.1O(k.49,I.5f);S.1O(k.3E,I.5Q)}S.1O(k.4x,13.7K);if(u.1c.2M){S.1O("4R",I.5f);S.1O("4G",I.5Q);S.1O("6n",13.7K)}}}};13.1C.4U=1p u.3e(13.1C.2b);13.1C.7K=13.1C.9t.48(13.1C);13.1C.cL=13.1C.5k.1u(13.1C);13.1C.2b.2k("3u-1C").2k("3u-1C-"+13.1b("1C-4Z"));if("5B"!=13.1b("1C-4Z")){I.1C.2b.1t("4p",17(U){1a T=U.5g?5:8/54,S;f(U).1U();T=(1Q+T*1j.26(U.5A))/1Q;if(U.5A<0){T=1/T}S=1j.1Z(1Q,1j.5b(I.1C.1X.1d*T));S=1j.5M(S,I.1X.1d);13.1G({1d:S,1g:S,"3i-ct":("bx"!=I.1b("1C-4Z"))?0:S/2});I.1C.1X=13.29();I.1C.5k(1)})}1a F=13.9y=u.$1p("2b").2k("3u-1C-9y-fl").3C(u.$1p("2b").2k("3u-9y")).1t(k.49+" "+k.4x,17(S){S.52()});F.b2=17(S){if(S){F.33=4z(17(){I.o.3C(F)},bp)}1r{if(F.33){3o(F.33);F.33=1e}(I.o===13.5l)&&I.o.7p(F)}};17 E(X,T){1a W,V,U,S=1e;if(Q){18}if(!I.87){18}if(u.1F(X)=="1s"){S=(X.1S&&("2z"===X.1S||X.1S===X.4t))||(/2z/i).2S(X.1n);if((U=f(X.9x())).74("7E")){if(H&&U.74("4K")){18}if(!H&&U.74("2L")){18}}X.1U()}if(H&&T){18}if(!H&&1e==T){18}if(H&&!T){I.1C.1U(u.1F(X)=="1s"?X.2B():1i);U&&U.74("2L")&&I.1B.4s&&I.1B.6T()}1r{W=I.7e(I.1J.1l,I.1J.1E);V=(u.1F(X)=="1s")?X.2B():X;F&&F.b2(1k);R=1k;P=1e;I.1B.6l();1p u.7g(I.dh(W.1l+1,W.1E+1,"4k"),{6e:f(17(Z,Y){I.6o();I.1C.1y(Y,V,Z)}).1u(1i,S),5r:17(){R=1e},6k:17(){F&&F.b2(1e)}})}18 1e}13.ba=E.1u(13,{x:I.2c.1M+(I.2c.3I-I.2c.1M)/2,y:I.2c.1z+(I.2c.4d-I.2c.1z)/2},1k);13.3J=E.1u(13,1i,1e)}if(13.1B.3S&&13.1b("2l")){13.6u=u.$1p("3r").2k("3u-7E 3u-7E-2l-aQ").1t(k.49,17(S){S.52()}).1t("2K",17(S){if(3==S.4T()){18 1k}S.1U();13.a5();18 1e}.48(13)).2r(13.3a);u.1c.2M&&13.6u.1t("4R",17(S){S.52()})}13.6o();if(13.1B.aR>0&&f(13.1b("1Y-1y")).3g("6D")){13.1B.6T()}1r{13.3t(13.2x.1l,13.2x.1E);if(13.1b("2a")*13.1b("2h")>1&&13.1b("4P")&&13.1B.3S){13.9Z()}}1a N=f(13.o).2j("cr");if(N){f(13.o).3C(N)}("17"==u.1F(13.1b("4o")))&&13.1b("4o").1W(1i,13.o)};w.1D.bj=17(F,E,G){if(!13.1b("d7")||!F.6h){18}1a D=u.4L()-F.6h;F.6h=1e;if(D<=0){18}if(D<50){D=50}1a C=0.gr;3d=13.3d,d5=13.1b("34-1l")&&13.3Y.7t==13.1b("2a"),gl=13.1b("34-1R"),dx=E.x-F.6f.x,dy=E.y-F.6f.y;17 B(K){1a L=K=="x"?dx:dy;1a H=L/D;1a J=(H/2)*(H/C);1a I;if(K=="x"){if(1j.26(dx)<1j.26(dy)){I=J-(F.6f.x-G.x)}1r{I=1j.26(L+(L>0?J:(0-J)))-1j.26(F.6f.x-G.x);I=L>0?(0-I):I}}1r{if(!d5||1j.26(dx)>=1j.26(dy)){I=J-(F.6f.y-G.y)}1r{I=1j.26(L+(L>0?J:(0-J)))-1j.26(F.6f.y-G.y);I=L>0?(0-I):I}}I/=3d[K];18 I>0?1j.3x(I):1j.6B(I)}13.3t(13.1J.1l+B("y"),13.1J.1E+B("x"),1k,2*1j.26(1j.3x(1j.1Z(1j.26(dx),1j.26(dy))/D/C)))};w.1D.3t=17(E,C,B,D){13.1J.1l=E;13.1J.1E=C;13.fx&&13.fx.1U();if(!B){13.1J.5J.1l=E;13.1J.5J.1E=C;13.5N(E,C);18}13.fx=1p u.3e(13.o,{43:D,2W:u.3e.6r.bQ,aS:(17(F){13.1J.5J.1E=F.1E;13.1J.5J.1l=F.1l;13.5N(F.1l,F.1E)}).1u(13)}).1y({1E:[13.1J.5J.1E,C],1l:[13.1J.5J.1l,E]})};w.1D.7e=17(E,C){1a B,D;E=1j.5b(E);C=1j.5b(C);if(13.1b("34-1l")){E%=13.1b("2a");E<0&&(E+=13.1b("2a"))}if(13.3Y.5z.3g(E)){E=13.3Y.5z.4u(E)}1r{1a B=(E-13.2x.1l)/1j.26(E-13.2x.1l);1a D=13.3Y.5z.2H(17(F){18(F-E)*B>0});E=D.1v?13.3Y.5z.4u(D[(B<0)?D.1v-1:0]):(!13.1b("34-1l")||13.3Y.7t<13.1b("2a"))?13.3Y.5z.4u(13.2x.1l):(B<0?13.3Y.7t-1:0)}if(!13.1b("34-1R")&&(!13.1B||13.1B.4l<1)){C>(13.1b("2h")-1)&&(C=13.1b("2h")-1);C<0&&(C=0)}C%=13.1b("2h");C<0&&(C+=13.1b("2h"));(!13.1b("34-1R"))&&(13.1J.1E=C);13.2x={1l:13.3Y.5z[E],1E:C};if(!13.1b("34-1l")||13.3Y.7t<13.1b("2a")){13.1J.1l=13.2x.1l}18 u.5h(13.2x)};w.1D.5N=17(F,B){1a D=13.7e(F,B),E,C,G;F=D.1l;B=D.1E;E=13.3M.3Z[F][B];if(13.3V&&!(l&&13.6L&&13.4Q.2l.1v)&&13.3M.2l[F]&&13.3M.2l[F][B]&&13.3M.2l[F][B].5Z){E=13.3M.2l[F][B]}if(!E.5Z){18}if(u.1c.2Q.3c){13.ck(E.bI)}1r{13.b7.41=E.37}if(13.5R&&(!13.8l||13.8l.1l!=F||13.8l.1E!=B)){13.1b("5S").1W(1i,13.o);13.5R=1e;if(13.3v){13.5H()}}13.8l=D};w.1D.ck=17(D){1a C=0,H=13.1X.1d,F=13.1X.1g,B=D.8b,G=D.bs;if((1f.g5||1)>=2&&((B*G)/(H*F)>=2)){H*=2;F*=2}C=1j.6B(1j.8h(1j.1Z(D.8b/H,D.bs/F))/1j.gk);13.3Q.1d=B;13.3Q.1g=G;13.4M.1d=B;13.4M.1g=G;13.8o.8V(D,0,0,B,G);1L(1a E=C-1;E>0;E--){13.4M.1d*=0.5;13.4M.1g*=0.5;13.br.8V(13.3Q,0,0,13.3Q.1d,13.3Q.1g,0,0,13.4M.1d,13.4M.1g);13.3Q.1d*=0.5;13.3Q.1g*=0.5;13.8o.8V(13.4M,0,0,13.4M.1d,13.4M.1g,0,0,13.3Q.1d,13.3Q.1g)}13.3c.1d=H;13.3c.1g=F;13.bt.8V(13.3Q,0,0,13.3Q.1d,13.3Q.1g,0,0,13.3c.1d,13.3c.1g)};w.1D.er=17(){1a B,D,C;13.8a=13.o.6K();13.24=13.3a.29();13.2c=13.3a.6K();if(13.3V){D=f(1h).29();C=13.2I.1d/13.2I.1g;if(u.1c.3F&&u.1c.7G){13.1P.1G({1d:D.1d,1g:D.1g})}13.24=13.1P.29();13.2c=13.1P.6K();13.o.1G(13.cz(D))}B=f(13.o).29();if(13.3V&&11==u.1c.2f&&1f.3K!==1f.1f){13.24.1d=13.1P.91;13.24.1g=13.1P.bd;B.1d=13.o.91;B.1g=13.o.bd}if(B.1d<=0||B.1g<=0){18}B.1d-=13.5F.x;B.1g-=13.5F.y;13.1X=B;if(13.1b("4K")){if((13.1X.1d*13.1X.1g)/(13.5a.1d*13.5a.1g)>0.8){13.3J&&13.3J();13.87=1e;13.o.7d("4k-in")}1r{13.87=1k;13.o.2k("4k-in")}}13.3d={x:13.1X.1d/13.1b("2h")/1j.3y(13.1b("8f")/50,2),y:13.1X.1g/13.1b("2a")/1j.3y(13.1b("8e")/50,2)};if(13.1J){13.5N(13.1J.1l,13.1J.1E)}};w.1D.2L=17(B){(13.3J)&&13.3J();if(13.3v){13.5H()}13.5R=1k;(B||1i)?13.3t(13.1J.1l,13.1J.1E+B,1k,1Q*(1j.8h(1j.26(B)/1j.8h(2)))):13.1B.6T(8I.e2)};w.1D.b9=17(B,C){if(!B){B=0}if(!C){C=0}if(!B&&!C){18}if(13.3J){13.3J()}if(13.3v){13.5H()}13.5R=1k;13.3t(13.1J.1l+C,13.1J.1E+B,1k,1Q*(1j.8h(1j.1Z(1j.26(B),1j.26(C))/1j.8h(2))))};w.1D.eZ=17(B){13.b9(B,0)};w.1D.eY=17(B){13.b9(0,B)};w.1D.4K=17(B){(u.30(B)?B:1k)?13.ba&&13.ba():13.3J&&13.3J()};w.1D.1U=17(){1a D,B,E,C=1f.dE||1f.c3||1i;if(13.1B&&13.1B.4l>0){13.1B.6l()}if(13.3V){13.o.2v.1G({});13.o.1G({1d:"",1g:"1Q%","1Z-1g":"","1Z-1d":""}).2r(13.3a)}if(13.1P){if(13.6S){f(1f).1O("8r",13.6S)}if(13.7L){3o(13.7L)}13.1P.6s();13.1P=1i}if(13.1C&&13.1C.2b){13.1C.2b.6s();13.1C=1i}if(13.6u){13.6u.6s();13.6u=1i}f(1f).1O("dQ",13.6o);3o(13.85);13.85=1i;13.o.bq();4B(13.o.2v!=13.o.cb){13.o.7p(13.o.cb)}if(13.1b("2L")=="6p"){f(1h).1O([k.4x,"6n"],13.8u)}f(1h).1O([k.3E,k.6v,"4G"],13.97);13.o.8k(13.bP,13.o.2v);13.o.8B("6I","");13.o.7d("4k-in");if(13.3a){13.3a.5l.8k(13.o,13.3a);13.3a.6s();13.3a=1i}1L(D=0,B=13.9i.1v;D<B;D++){u.d6("bv-9f",13.9i[D])}f(13.b3).2F();if(C){1L(E in 13.5n){f(13.5n[E]).3D(17(G){1a F=G.1K.8i.2C(/^37\\s*\\(\\s*["\']?/,"").2C(/["\']?\\s*\\)$/,"");if(/^df\\:/.2S(F)){C.eO(F)}})}}};w.1D.a5=17(){if(!13.1B.3S||!13.1b("2l")){18}13.3J&&13.3J();1a E=f(1h).29(),D=f(1f).7c(),C=f(1h).cs(),B=1f.3K!==1f.1f;if(B){if(C.1g<=E.1g){D.y=13.2c.1z}E.1g=1j.5M(E.1g,13.2I.1g);if(E.1g+D.y>C.1g){E.1d-=u.1c.by}}if(!13.1P){13.1P=u.$1p("2b",{},{2N:"3G",5w:"3p",2P:"4f",9b:eP,"4m-4N":"9k","5P-4N":"5O",3w:1,1d:13.24.1d,1g:13.24.1g,1z:13.2c.1z,1M:13.2c.1M}).2k(c+"-2l");if(!u.1c.2M||!u.1c.4n){13.1P.2k("bu")}if(u.1c.2f){13.1P.2k("3h-1L-ie"+u.1c.2f)}if(u.1c.2f&&u.1c.2f<8){13.1P.3C(u.$1p("9m",1i,{2N:"4v-3G",1g:"1Q%",1d:1,"5P-4N":"5O"}))}13.cz=17(I){1a F,H,G=13.2I.1d/13.2I.1g;F=1j.5M(13.2I.1d,I.1d*0.98);H=1j.5M(13.2I.1g,I.1g*0.98);if(F/H>G){F=H*G}1r{if(F/H<=G){H=F/G}}18{1d:1j.3x(F),1g:1j.3x(H)}};if(u.1c.3F&&u.1c.7G){13.6S=17(){1a F=f(1f).7c(),G=13.1P.be();13.7L&&3o(13.7L);13.7L=4z(17(){1p u.3e(13.1P,{43:jl}).1y({1z:[G.1z,F.y],1M:[G.1M,F.x]})}.1u(13),6q)}.1u(13)}if(13.1B.3S){if(!u.1c.4n||!u.1c.2M){13.1P.1t(k.49,13.5f);13.1P.1t(k.3E,13.5Q)}if(u.1c.2M){13.1P.1t("4R",13.5f);13.1P.1t("4G",13.5Q)}}}13.4e||(13.4e=f(13.o.2v.bc(1e)).1G({2P:"b6","z-5d":1}));13.4e.1G({"6C-1z":"-1Q%","6C-1M":"1Q%"}).6t(0);if(E.1d/E.1g>13.2I.1d/13.2I.1g){13.4e.1G({1d:"2i",1g:"98%","1Z-1g":13.2I.1g,2N:"4v-3G","5P-4N":"5O"})}1r{13.4e.1G({1d:"98%","1Z-1d":13.2I.1d,1g:"2i",2N:"4v-3G","5P-4N":"5O"})}13.1P.2r(1h.3A).3C(13.4e);13.1P.5q();13.o.1G({"1Z-1d":13.2I.1d,"1Z-1g":13.2I.1g,1d:13.4e.29().1d+13.5F.x,1g:"2i","6I-1X":13.4e.29().1d+"5L "+13.4e.29().1g+"5L","z-5d":2}).2r(13.1P,"1z");s.1c.2Q.4A&&13.1P.6t(1);s.1c.4A.bC(13.1P,{bE:13.bB.1u(13),bD:13.as.1u(13),7R:17(){13.8s||(13.8s=1p u.3e(13.1P,{43:bp,2W:u.3e.6r.9U,9G:(17(){13.1P.1G({1d:13.24.1d,1g:13.24.1g,1z:13.2c.1z,1M:13.2c.1M}).2r(1h.3A)}).1u(13),9A:(17(F){13.o.1G(13.4e.29());13.1X=13.o.29();13.5N(13.1J.1l,13.1J.1E)}).1u(13),5p:(17(){13.bB(1k)}).1u(13)}));13.8s.1y({1d:[13.24.1d,E.1d],1g:[13.24.1g,E.1g],1z:[13.2c.1z,0+D.y],1M:[13.2c.1M,0+D.x],3w:[0,1]})}.1u(13)})};w.1D.bB=17(I){1a G,B,E=0,H=0,C=1f.3K!==1f.1f,J,D=13.7Q();if(I&&!13.3V&&!C&&!(u.1c.3F&&u.1c.7G)){13.1P.1G({2N:"3G",2P:"iI",1z:0,4d:0,1M:0,3I:0,1d:"2i",1g:"2i"})}13.3V=1k;13.o.2v.1G({1d:"1Q%",1g:"2i","1Z-1d":13.2I.1d,"1Z-1g":13.2I.1g});13.6o();if(13.bz){4z((17(){13.5c.8S();13.5c.dD(13.1P);13.bi("2l",13.2x.1l+1,13.2x.1E+1)}).1u(13),1);13.bz=1e}13.5N(13.1J.1l,13.1J.1E);if(13.6S){f(1f).1t("8r",13.6S)}if(!13.73){13.73=u.$1p("3r").2k("3u-7E 3u-7E-2l-j0").2r(13.1P).1t(k.49,17(K){K.52()}).1t("2K",17(L){1a K;if(3==L.4T()){18 1k}L.1U();if(K=13.1P.2j("2l:9X:1s:7q")){u.7M.1O("7q",K);13.1P.2T("2l:9X:1s:7q")}13.6A();18 1e}.48(13));u.1c.2M&&13.73.1t("4R",17(K){K.52()})}13.73.5q();if(I){1a F=17(K){if(K.ih==27){u.7M.1O("7q",F);13.6A()}}.48(13);13.1P.2X("2l:9X:1s:7q",F);u.7M.1t("7q",F);!u.1c.2M&&(13.ao=1p u.7F("iy hS hR aN h8 h6-h7",hM,13.1P,c+"-cn"))}13.6u.4Y()};w.1D.6A=17(){1a D=13.1P.29(),C=13.1P.6K(),B=13.7e(13.1J.1l,13.1J.1E);13.ao&&13.ao.4Y(0);13.3J&&13.3J();if(D.1d/D.1g>13.2I.1d/13.2I.1g){13.4e.1G({1d:"2i",1g:"98%","1Z-1g":13.2I.1g,2N:"4v-3G","5P-4N":"5O"})}1r{13.4e.1G({1d:"98%","1Z-1d":13.2I.1d,1g:"2i",2N:"4v-3G","5P-4N":"5O"})}if(s.1c.4A.9n&&s.1c.4A.9L()){s.1c.4A.cM()}1r{13.73.4Y();13.9c||(13.9c=1p u.3e(13.1P,{43:6q,2W:u.3e.6r.9U,9G:(17(){13.3V=1e;13.1P.1G({2P:"4f"}).2r(1h.3A)}).1u(13),9A:(17(E){13.o.1G(13.4e.29());13.1X=13.o.29();13.5N(13.1J.1l,13.1J.1E)}).1u(13),5p:(17(){13.as(1k)}).1u(13)}));13.9c.1y({1d:[D.1d,13.24.1d],1g:[D.1g,13.24.1g],1z:[0+C.1z,13.2c.1z],1M:[0+C.1M,13.2c.1M],3w:[1,0.5]})}};w.1D.as=17(C){1a B,D=13.7Q();if(!13.1P){18}13.ah&&13.ah.2F()&&4C 13.ah;if(13.6S){f(1f).1O("8r",13.6S)}13.3V=1e;13.o.2r(13.3a).6t(0).1G({1d:"",1g:"","1Z-1g":"","1Z-1d":"1Q%","z-5d":""});13.o.2v.1G({1d:"",1g:"","1Z-1d":"","1Z-1g":""});13.6o();13.73.4Y();13.6u.5q();13.o.6t(1);13.1P.4Y()};w.1D.9Z=17(){if(!13.3v){13.3v=u.$1p("2b",{"5V":"3u-4P"});13.jx=u.$1p("9m",{"5V":"3u-4P-cn"}).3C(1h.8F(13.eK(u.1c.2M?"4n-4P-4m":"4P-4m"))).2r(13.3v);f(13.3v).2r(13.o)}if(13.1b("6N-5m")>0){1a B=17(D){13.o.1O("4p",B);13.5H()}.48(13);13.o.1t("4p",B)}if("4F"===13.1b("2L")){1a C=17(){13.5H();13.o.1O("4x",C)}.48(13);13.o.1t("4x",C)}};w.1D.5H=17(){if(!13.3v||13.3v.cI){18}13.3v.cI=1k;1p u.3e(13.3v,{43:5y,5p:17(){13.3v.2F();4C 13.3v}.1u(13)}).1y({3w:[13.3v.2E("3w"),0]})};w.1D.7Q=17(){1a B=13.7e(13.1J.1l,13.1J.1E);B.1l++;B.1E++;18 B};1a m=17(){18"gv$fr f0$"+"cU.6.4".2C("v","")+" gS$"+"c".8d()+((1f.aU$aT&&"1N"==u.1F(1f.aU$aT))?" fQ$"+1f.aU$aT.5e():"")};1a j=f([]);1a o={4D:"cU.6.4",1q:{},7C:{},dS:{},1y:17(C){1a B=1i;u.$A((C?[f(C)]:1h.cq("6V"))).3D((17(D){if(f(D)){!j.2H(17(E){18 E.o===D}).1v&&j.2U(B=1p w(D))}}).1u(13));18 B},1U:17(E){1a C,D,B;if(E){(D=r(E))&&(D=j.8A(j.4u(D),1))&&D[0].1U()&&(4C D[0]);18}4B(C=j.1v){D=j.8A(C-1,1);D[0].1U();4C D[0]}},2L:17(D,C){1a B;(B=r(D))&&B.2L(C)},3t:17(D,C){1a B=1i;if(B=r(D)){B.3J&&B.3J();B.3v&&B.5H();B.3t(B.1J.1l+C,B.1J.1E)}},6l:17(C){1a B;(B=r(C))&&B.1B.6l()},iM:17(C){1a B;(B=r(C))&&B.4K(1k)},iG:17(C){1a B;(B=r(C))&&B.4K(1e)},2l:17(C){1a B;(B=r(C))&&B.a5()},7Q:17(D){1a B,C=1i;if(B=r(D)){C=B.7Q();C.1R=C.1E;4C C.1E}18 C},i5:17(B,C){o.dS[B]=C}};17 r(D){1a C=[],B=1i;(D&&(B=f(D)))&&(C=j.2H(17(E){18 E.o===B}));18 C.1v?C[0]:1i}f(1h).1t("7U",17(){m=m();n=u.$1p("2b",{"5V":"3u-5J-dn-d1"}).2r(1h.3A);o.1y()});18 o})();', 62, 1281, '|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||this||||function|return||var|option|browser|width|false|window|height|document|null|Math|true|row|Event|type|Custom|new|options|else|event|jAddEvent|jBind|length|default|case|start|top|handler|_autospin|magnifier|prototype|col|jTypeOf|jSetCss|_options|break|current|img|for|left|string|jRemoveEvent|fullScreenBox|100|column|pointerType|important|stop|set|call|size|autospin|max||extend|||boxSize||abs|||jGetSize|rows|div|boxBoundaries||navigator|ieMode|btnclick|columns|auto|jFetch|jAddClass|fullscreen|arguments|parseFloat|touchdrag|none|jDelay|jAppendTo|clientX|mousedrag|clientY|firstChild|changedTouches|currentFrame|undefined|touch||jGetPageXY|replace|timeStamp|jGetCss|jRemove|style|filter|fullScreenSize|number|click|spin|touchScreen|display|tap|position|features|jCallEvent|test|jDel|push|handle|transition|jStore|try|init|defined|||timer|loop|pointerEnabled||url|minimum||wrapper|enum|canvas|ppf|FX|webkit|contains|magic|border|visibility|catch|Doc|match|parseInt|clearTimeout|hidden|ratio|button|reverse|jump|m360|hintBox|opacity|floor|pow|digits|body|Class|append|jEach|mouseup|trident|block|touchpinch|right|_hideM|parent|dragstart|images|array|oneOf|stopDefaults|backstageCanvas|touches|cancelable|Element|boolean|isFullScreen|jTrim|direction|loadedRows|small||src||duration|||||jBindAsEvent|mousedown|addCSS|hasOwnProperty|increment|bottom|fullScreenImage|absolute|pushToEvents|identifier|dblbtnclick|target|zoom|frames|text|mobile|onready|mousescroll|split|dbltap|infinite|MSPOINTER_TYPE_TOUCH|indexOf|inline|styles|mousemove|exists|setTimeout|fullScreen|while|delete|version|listeners|hover|touchend|schema|alternate|J_TYPE|magnify|now|backstageCanvas2|align|join|hint|imageQueue|touchstart|large|getButton|fadeFX|transform|domPrefix|requestAnimationFrame|hide|shape||constructor|stopDistribution||||ready|Array||getDoc|zoomSize|round|progressBar|index|toLowerCase|mDownEvent|isMouse|detach|padding|documentElement|move|parentNode|step|imageMap|box|onComplete|show|onerror|messageBox|instanceof|cubicBezier|moveTimer|overflow|jCamelize|200|indexes|delta|inner|add|speed|pageY|borders|switch|hideHintBox|getAttribute|tmp|pageX|px|min|jump_|middle|vertical|mUpEvent|spinStarted|onspin|pendingImages|ms|class|shift|normalSize|className|loaded|||complete|nodeType|J_UUID|visible|isVerticalSpin|platform||filename|onzoomin|isQueueStopped|onzoomout|throw|onload|spos|events|date|image|dragged|oncomplete|pause|value|touchmove|resizeCallback|drag|300|Transition|kill|jSetOpacity|fullscreenIcon|mouseout|render|pointerup|maximum|MSPointerUp|exitFullscreen|ceil|margin|load|apply|onTouchEnd|state|node|background|ease|jGetRect|useMultiBackground|sensitivity|mousewheel|tpl|filepath|isset|isNaN|fullScreenScrollCallback|play|on|Magic360|path|deltaX|cycles|easeFn|mouseover|random|deltaY|leaveFSButton|jHasClass|tm|timedout||stopQueue|end|threshold|xhr|jGetScroll|jRemoveClass|checkJumpRowCol|onTouchStart|ImageLoader|_handlers|getRelated|MagicJS|tooltip|data|engine|not|setAttribute|removeChild|keydown|uaName|found|count|targetTouches|continuous|sizing|moz|useXHR|MSPointerDown|pointermove|bgImages|lang|parseCubicBezier|icon|Message|backCompat|sqrt|msPointerEnabled|MSPointerMove|animateBind|fullScreenScrollCallbackTimer|doc|_unbind|_cleanup|invoked|getCurrentFrame|fallback|_timer|ddx|domready|pointerdown|continue|scale|getContext|readyState||ddy||_EVENTS_||reflowTimer||canMagnify|element|createElement|boundaries|naturalWidth|storage|toUpperCase|sensitivityY|sensitivityX|opera|log|bgURL|toString|replaceChild|lastFrame|has|Opacity|backstageCtx|loopBind|color|scroll|fullScreenFX|implement|mMoveEvent|getStorage|pStyles_arr|pStyles|clockwise|ios|splice|jSetCssProp|hideTimer|playedFrames|placeholder|createTextNode|gecko|android|Number|svg|temporary|container|swap|compatMode|chrome|sis|preInit|uaVersion|reset|charAt|forceAnimation|drawImage|byTag|href|setValue|1000|tagName|clientWidth|Options|typeof|||setProps|mDocUpEvent||status|isTouchEvent|zIndex|fullScreenExitFX|callee|_bind|css|no|repeat|addedCSS|XMLHttpRequest|center|presto|span|capable|translate3d|eventType|dblclick|onprogress|handleMouseUp|animate|win|createEvent|startTime|getTarget|loader|cancelAnimationFrame|onAfterRender|scrollTop|scrollLeft|pointerId|btnclickEvent|relatedTarget|onStart|_event_prefix_|onTouchMove|J_EUID|previousScale|enabled|loading|prepareFilename|cssFilters|dashize|https|handleTouchEnd|handleTouchStart|ignore|expoOut|fromJSON|changeEventName|pseudo|10000|setupHint|bis|onClick|errorEventName|opr|handleMouseDown|enterFullscreen|jToInt|concat|RegExp|onclick||||||_event_add_|el_arr|fullscreenProgressBox|isPrimary|styles_arr|Tooltip|_event_del_|priority|linear|leaveFSMessage|calc|stopAnimation|getElementsByClassName|onExitFullScreen|05|HTMLElement|cubicBezierAtTime|hideFX|caller|getImageInfo|cycle|deltaMode|cssDomPrefix|multibackground|handleTouchMove|xhr2|String|userAgent|normalizeCSS|Alpha|abort|slice|onabort|loadedBytes|to|get|ifndef|open|maxFrames|onBeforeRender|Pltm|mgctlbx|Microsoft|DXImageTransform|runs|uuid|crM360|Function|progid|toggle|imgCacheBox||autospinStopped|relative|imgContext|backface|rotate|_showM||cloneNode|clientHeight|jGetPosition|hasChild|onpause|J_EXT|preloadImages|_checkDragFrames|Date|onImageLoaded|defaults|once|onxhrerror|400|jClearEvents|backstageCtx2|naturalHeight|canvasContext|desktop|magic360|never|circle|scrollbarsWidth|firstFullScreenRun|prepareUrl|onEnteredFullScreen|request|onExit|onEnter|anticlockwise|which|webkit419|cachedObject|165|preventDefault|firefox|requestFullScreen|getElementsByTagName|stopPropagation|oi|quadOut|cancelBubble|insertRule|easeOutSine|elasticIn|getBoundingClientRect|easeOutBack|easeInBack|easeOutCubic|PFX|twice|setMessage|runtime|webkitURL|999|offsetWidth|easeInCubic|easeOutQuad|bezier|compareDocumentPosition|cubic|lastChild|175|getElementById||easeInSine|easeOutExpo|easeInQuad|easeInExpo|addEventListener|ctxDraw|045|wrap|message|progressiveLoad|perspective|byClass||jGetFullSize|radius|dragend|touchEvent|isFinite|isPrimaryTouch|304|adjustFSSize|textnode|jDefer|error|wheelDeltaX|wheelDeltaY|curScale|_initialDistance|update|hidding|registerEvents|unRegisterEvents|moveBind|cancel|detail|wheelDelta|nativize|UUID|phone|dragmove|animation|v4|jToBool|object|out|outline|mHoverEvent|getTime|cont|dispatchEvent|355|getClientXY|loopR|removeCSS|smoothing|euid|mOutEvent|finishTime|selectstart|9999|onreadystatechange|pos|blob|loadBlob|getImageURL|isReady|moved|magicJS|fps|interval|hdn||handleMouseMove|03|bounceIn|onchange|10px|user|select|item|||mozCancelAnimationFrame|ua|fromString|changeContent|changePlaceholder|URL|safari|after|msExitFullscreen|hone|windows|enclose|pop|backcompat|initialize|charCodeAt|stylesId|resize|sheet|callbacks|progress|documentMode|cssPrefix|Webkit|fontWeight|Moz|Loading|crios|androidBrowser|MAX_VALUE|cssText|Object|mjs|cssTransformProp|toArray|line|run|IMG|shown|exec|cancelFullScreen|Left|2147483647|fontSize|Right|m360CrA|MSPointerOver|URLCached||pointerout|Bottom|onImageLoadProgress|styleFloat||reflow|parseSchema|bgIndex|framesOnImage|imageLoadStarted|DocumentTouch|sort|getComputedStyle|concurrentImages|10000px|pointerover|od|appendChild|MSPointerOut|Infinity|deleteRule|removeRule|Top|styleSheet|localString|500|0px|forEach|revokeObjectURL|20000|WebKitPoint|webos|cssfilters|TransitionEvent|mac|WebKitTransitionEvent|taintEnabled|transitionend|rotateY|rotateX|mgctlbxV|oCancelFullScreen|webkitTransitionEnd|cssRules|mozInnerScreenY|xpath|2px|ActiveXObject|pinchupdate|oCancelAnimationFrame|msRequestAnimationFrame|fullscreenEnabled|msCancelAnimationFrame|webkitCancelRequestAnimationFrame|oRequestAnimationFrame|msFullscreenEnabled|webkitRequestAnimationFrame|webkitCancelFullScreen|webkitexitFullscreen|mozRequestAnimationFrame|msCancelFullScreen|holder|linux||other|mozCancelFullScreen|evaluate|M360|pinchstart|air|unknown|red|querySelector||query|blur|head|childNodes|fullscreenerror|MSFullscreenError|insertBefore|prefix|innerText|html|innerHTML|activeElement|fullscreenchange|xiino|iframe|ExitFullscreen|DOMElement|requestFullscreen|mgctlbxP|jSetStyle|MSFullscreenChange|CancelFullScreen|jGetStyle|Width|offsetParent|jGetTransitionDuration|getPropertyValue|delay|lineHeight|currentStyle|removeAttribute|jGetStyles|jToggleClass|devicePixelRatio|cssFloat|offsetHeight|clientLeft|offsetLeft|offsetTop|clientTop|v3|getInnerSize|float|jGetFullScroll|RequestFullScreen|RequestFullscreen|lt|getOriginalTarget|LN2|loopC|custom|536|removeEventListener|attachEvent|detachEvent|01|jRaiseEvent|doScroll|DOMContentLoaded|mgctlbxN|setInterval|420|initEvent|createEventObject|fireEvent|toElement|fromElement|scrollWidth|scrollHeight|map|FullScreen|pageYOffset|pageXOffset|presto925|innerWidth|innerHeight|webkitIsFullScreen|FullscreenElement|returnValue|toFloat|srcElement|ver|mgctlbxL|fullscreenElement|figcaption|figure|edge|clearInterval|feature|elaine|xxxxxxxxxxxx|CriOS|yxxx|KeyEvent|escape|KeyboardEvent|full|screen|leave|SVG11|xy|nt|150|content|ie5|blackberry|bada|off|ie7|blazer|fromCharCode|4xxx|compal|font|ie8|getJSON|parameter|anti|bounceOut|MagicToolboxTooltip|fennec|MessageBox|elasticOut|PI|cubicOut|cubicIn|backIn|backOut|cos|5000|w3|Incorrect|getAbsoluteURL|definition|of|the|parse|JSON|4000|org|TR|NEGATIVE_INFINITY|POSITIVE_INFINITY|key|ESC|Image|gif|ontouchstart|sizingMethod|highlight|callout|base64|Magic360Lang|find|Cannot|Magic360Options|R0lGODlhAQABAIAAAAAAAP|registerCallback|transparent|AlphaImageLoader|getBoxObjectFor|setIncrementalStyle|generateUUID|xxxxxxxx|xxxx|||||keyCode|maxTouchPoints|contextmenu|action|000|decoration||msMaxTouchPoints||360|Magic|2em|onstop|incrementByVal|textAlign|serif|onstart|Press|avantgo|3600|square|regexp|emulate3D|sans|toFixed|magnifyOff|Swipe|fixed|Error|yH5BAEAAAAALAAAAAABAAEAAAIBRAA7|Drag|magnifyOn|lastBgSize|6000|fontFamily|101|meego|quadIn|expoIn|http|hasFeature|link|up|treo|addRule|close|roundCss|normal|setTransition|implementation|curFrame|745|715|pocket|psp|plucker|re|ProgressEvent|series|085|575|symbian|565|easeInOutSine|445|600|250|translate|wheel|FormData|collection|MouseEvent|onwheel|000244140625|xda|4294967296|deltaZ|deltaFactor|hintMessage|wap|vodafone|GET|createObjectURL|responseType|send|destroy|537|response|UIEvent|withCredentials|lengthComputable|total|static|455|easeInOutQuad|785|easeInOutCirc|135|maemo|lge|midp|075|easeInCirc|easeInOutExpo|04|335|easeOutCirc|kindle|735|www|000001|getHashCode|sineIn|sineOut|hiptop|265|iris|885|275|easeInOutBack|iemobile|515|mmp|895|easeInQuart|685|easeOutQuart|os|645|easeInOutCubic|055|955|675|215|ixi|035|palm|netfront|easeOutQuint|easeInOutQuint|07|795|easeInOutQuart|06|755|easeInQuint|ob|855'.split('|'), 0, {}))

T.Utils = T.Utils || {};

jQuery.extend(T.Utils, {
    "breakpoints": {
        "md": "600px",
        "lg": "900px"
    },
    "margins": {
        "xs": "5px",
        "s": "10px",
        "m": "15px",
        "l": "20px",
        "xl": "30px",
        "xls": "40px",
        "xxL": "60px"
    },
    "charts": {
        "background": "#eee",
        "color": "#c1c2c3",
        "highlightColor": "#74a8ca",
        "labelFontColor": "#222",
        "labelFontFamily": "Arial",
        "labelFontSize": 14,
        "padding": 20,
        "valueFontColor": "#222",
        "valueFontFamily": "Arial",
        "valueFontHighlightColor": "#fff",
        "valueFontSize": 16,
        "valueFontStyle": "bold",
        "Pie": {
            "colors": ["#c1c2c3", "#999", "#0064a6", "#666", "#f2f2f2", "#d4d9de"],
            "cutout": "50%",
            "legendBoxSize": 20,
            "legendItemMargin": 20,
            "legendLabelIndent": 10
        },
        "HorizontalBar": {
            "barMaxSize": 40,
            "barSpacing": 20,
            "barPadding": 10,
            "valueFontColor": "#fff",
            "valueFontHighlightColor": "#fff"
        },
        "VerticalBar": {
            "barMaxSize": 40,
            "barSpacing": 20,
            "labelLineHeight": 1.25,
            "valueFontColor": "#222"
        }
    },
    "dealerLocator": {
        "detailViewZoomLevel": 15,
        "smallScreenShowMorePageSize": 5
    },
    "filterShowInital": {
        "mobile": 1,
        "tablet": 2,
        "desktop": 4
    },
    "loader": {
        "cssElementAmount": 12
    },
    "list": {
        "itemPerRow": 1,
        "itemPerRowMd": 2,
        "itemPerRowLg": 4
    },
    "popover": {
        "defaults": {
            "align": "center",
            "position": "bottom",
            "width": 500
        }
    },
    "shareWindow": {
        "height": 500,
        "width": 600,
        "left": 0,
        "top": 0
    },
    "toTop": {
        "animateDuration": 600
    },
    "moreless": {
        "ContentText2col": {
            "heights": {
                "mobile": 200,
                "tablet": 200,
                "desktop": 150
            },
            "multiplier": 1
        },
        "ContentTextMedia": {
            "heights": {
                "mobile": 200,
                "tablet": 200,
                "desktop": 300
            },
            "multiplier": 1
        },
        "ReviewItem": {
            "heights": {
                "mobile": 200,
                "tablet": 200,
                "desktop": 150
            },
            "multiplier": 1
        },
        "DownloadBasketTop": {
            "heights": {
                "mobile": 90,
                "tablet": 90,
                "desktop": 90
            },
            "multiplier": 1
        }
    },
    "teaser": {
        "container": ["200-4", "200-4", "200-4"]
    },
    "video": {
        "youtube": {
            "color": "white"
        }
    },
    "carousel": {
        "slidesToShow": {
            "mobile": 1,
            "tablet": 2,
            "desktop": 4
        },
        "slidesToScroll": {
            "mobile": 1,
            "tablet": 2,
            "desktop": 4
        }
    },
    "localStorageKey": {
        "productCompare": {
            "mkt": "product-compare-mkt",
            "shop": "product-compare-shop"
        }
    }
});

(function($) {
    T.Config = T.Config || {};
    return $.extend(T.Config, {
        paths: {}
    });
}
)(jQuery);

var slice = [].slice
  , hasProp = {}.hasOwnProperty;

(function($) {
    var glob_config;
    glob_config = window.localization.configurations;
    T.Utils = T.Utils || {};
    $.extend(T.Utils, {
        _events: {},
        allSynced: false,
        loaderRequestCounter: $('.js-loader-static').length,
        modulesSynced: function() {
            T.Utils.initialRendering();
            T.Utils.initialAjaxRequestTrigger();
            return T.Utils.allSynced = true;
        },
        load: function(src, callback) {
            var $script, script;
            $script = $("script[src='" + src + "']");
            if (!$script.length) {
                script = document.createElement('script');
                script.onload = function() {
                    return callback();
                }
                ;
                document.body.appendChild(script);
                return script.src = src;
            } else {
                return callback();
            }
        },
        _youtubeApiCallbackStack: [],
        loadYoutubeApi: function(callback) {
            if (typeof YT === 'undefined') {
                T.Utils._youtubeApiCallbackStack.push(callback);
                return T.Utils.requestYoutubeAPi();
            } else {
                return callback();
            }
        },
        _youtubeApiLoading: false,
        requestYoutubeAPi: function() {
            if (!T.Utils._youtubeApiLoading) {
                window.onYouTubeIframeAPIReady = T.Utils.youtubeApiLoaded;
                !(T.Utils._youtubeApiLoading = true);
                return T.Utils.load('//www.youtube.com/iframe_api', function() {});
            }
        },
        youtubeApiLoaded: function() {
            var i, j, ref, stack;
            stack = T.Utils._youtubeApiCallbackStack.length;
            for (i = j = 0,
            ref = stack; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
                T.Utils._youtubeApiCallbackStack[i]();
            }
            return T.Utils._youtubeApiLoading = false;
        },

        /*
    		Loads javascript library used for ecorebates from a remote server.
     */
        loadEcrScript: function(url) {
            $.getScript(url);
            return window._ecr = window._ecr || {};
        },

        /*
    		Add product sku to ecorebates widget.
    
    		@param {String} sku Prodcut sku
     */
        addSkusToEcr: function(sku) {
            if (window._ecr && sku) {
                return window._ecr["ecr-" + sku] = sku;
            }
        },

        /*
    		Took from https://coffeescript-cookbook.github.io/chapters/functions/debounce
     */
        debounce: function(func, threshold, execAsap) {
            var timeout;
            timeout = null;
            return function() {
                var args, delayed, obj;
                args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
                obj = this;
                delayed = function() {
                    if (!execAsap) {
                        func.apply(obj, args);
                    }
                    return timeout = null;
                }
                ;
                if (timeout) {
                    clearTimeout(timeout);
                } else if (execAsap) {
                    func.apply(obj, args);
                }
                return timeout = setTimeout(delayed, threshold || 100);
            }
            ;
        },

        /*
    			Cookie handling set, get and check cookie
    
    			@param {Sting} data: key=value pair string (isset, set) | key string (get)
    			@param {Sting} method: isset | return | get | set (default)
    			@param {object} config: optional configuration to set cookie (domain, path, expires)
    			@return case 'isset' {Boolean}
    			@return case 'return': {Boolean} cookie string
     */
        cookieHandling: function(data, method, config) {
            var c, j, key, len1, ref;
            switch (method) {
            case 'isset':
                return document.cookie.split('; ').indexOf(data) > -1;
            case 'get':
                key = data + '=';
                ref = document.cookie.split(';');
                for (j = 0,
                len1 = ref.length; j < len1; j++) {
                    c = ref[j];
                    c = c.replace(/^\s+/g, '');
                    if (c.indexOf(key) === 0) {
                        return c.substring(key.length, c.length);
                    }
                }
                return null;
            case 'return':
                return document.cookie;
            default:
                if (config) {
                    if (config.domain != null) {
                        data = data + '; domain=' + config.domain;
                    }
                    if (config.path != null) {
                        data = data + '; path=' + config.path;
                    }
                    if (config.expires != null) {
                        data = data + '; expires=' + config.expires;
                    }
                }
                return document.cookie = data;
            }
        },
        currentViewport: 'mobile',
        registerMq: function(breakpoint, enquireObject, type) {
            if (type == null) {
                type = 'min';
            }
            breakpoint = T.Utils.breakpoints[breakpoint];
            return enquire.register("screen and (" + type + "-width: " + breakpoint + ")", enquireObject);
        },
        viewportRegistered: false,
        registerViewportQuery: function() {
            if (!this.viewportRegistered) {
                enquire.register("screen and (max-width: " + T.Utils.breakpoints['md'] + ")", {
                    match: function() {
                        return T.Utils.enquireViewportChanged('mobile');
                    }
                });
                enquire.register("screen and (min-width: " + T.Utils.breakpoints['md'] + ") and (max-width: " + T.Utils.breakpoints['lg'] + ")", {
                    match: function() {
                        return T.Utils.enquireViewportChanged('tablet');
                    }
                });
                enquire.register("screen and (min-width: " + T.Utils.breakpoints['lg'] + ")", {
                    match: function() {
                        return T.Utils.enquireViewportChanged('desktop');
                    }
                });
                return this.viewportRegistered = true;
            }
        },
        viewportEventsEnabled: false,
        enquireViewportChanged: function(viewport) {
            var oldViewport, ref;
            oldViewport = T.Utils.currentViewport;
            T.Utils.currentViewport = viewport;
            if (T.Utils.viewportEventsEnabled && oldViewport !== viewport) {
                return (ref = T.Utils.application) != null ? ref.getModuleById(1)._events.emit('viewportChanged', viewport) : void 0;
            }
        },

        /*
    		Gets the current viewport title
    
    		@return	[String] The current viewport title (mobile, tablet or desktop)
     */
        getViewport: function() {
            return T.Utils.currentViewport;
        },

        /*
    		Checks the current viewport whether it equals the given string.
    
    		@param [String] vp The viewport to check for. Possible values: 'mobile', 'tablet'|'md', 'desktop'|'lg'
    		@return [Boolean] true if the current viewport matches the given value. false in any other case.
     */
        isViewport: function(vp) {
            switch (vp) {
            case 'md':
            case 'tablet':
                return T.Utils.currentViewport === 'tablet';
            case 'lg':
            case 'desktop':
                return T.Utils.currentViewport === 'desktop';
            case 'mobile':
            case void 0:
                return T.Utils.currentViewport === 'mobile';
            }
        },

        /*
    		Checks if an element is visible on the screen.
    
    		@param [jQuery] $el The jQuery element to check for.
    		@return [Boolean] true if the element is visible on the screen.
     */
        isVisibleOnScreen: function($el) {
            var $window, elHeight, elOffset, elWidth, winHeight, winScrollLeft, winScrollTop, winWidth;
            $window = $(window);
            elHeight = $el.outerHeight();
            elOffset = $el.offset();
            elWidth = $el.outerWidth();
            winHeight = $window.height();
            winScrollLeft = $window.scrollLeft();
            winScrollTop = $window.scrollTop();
            winWidth = $window.width();
            return elOffset.top + elHeight > winScrollTop && elOffset.left + elWidth > winScrollLeft && elOffset.top < winScrollTop + winHeight && elOffset.left < winScrollLeft + winWidth;
        },

        /*
    		Returns an elements offscreen direction if its completely invisible on the screen.
    
    		@param [jQuery] $el The jQuery element to check for.
    		@return [String] The elements offscreen direction. Possible values: 'top', 'left', 'right', 'bottom', 'none'. 'none' is returned, if the element is visible on the screen.
     */
        getOffScreenDirection: function($el) {
            var $window, elHeight, elOffset, elWidth, winHeight, winScrollLeft, winScrollTop, winWidth;
            if (!T.Utils.isVisibleOnScreen($el)) {
                $window = $(window);
                elHeight = $el.outerHeight();
                elOffset = $el.offset();
                elWidth = $el.outerWidth();
                winHeight = $window.height();
                winScrollLeft = $window.scrollLeft();
                winScrollTop = $window.scrollTop();
                winWidth = $window.width();
                if (elOffset.top + elHeight <= winScrollTop) {
                    return 'top';
                } else if (elOffset.left + elWidth <= winScrollLeft) {
                    return 'left';
                } else if (elOffset.left >= winScrollLeft + winWidth) {
                    return 'right';
                } else if (elOffset.top >= winScrollTop + winHeight) {
                    return 'bottom';
                }
            } else {
                return 'none';
            }
        },

        /*
    		Returns an elements screen overlap direction if its completely only partly visible on the screen.
    
    		@param [jQuery] $el The jQuery element to check for.
    		@return [String] The elements overlap direction. Possible values: 'top', 'left', 'right', 'bottom', 'none'. 'none' is returned, if the element is fully visible on the screen.
     */
        getOverlapDirection: function($el) {
            var $window, elHeight, elOffset, elWidth, winHeight, winScrollLeft, winScrollTop, winWidth;
            if (T.Utils.isVisibleOnScreen($el)) {
                $window = $(window);
                elHeight = $el.outerHeight();
                elOffset = $el.offset();
                elWidth = $el.outerWidth();
                winHeight = $window.height();
                winScrollLeft = $window.scrollLeft();
                winScrollTop = $window.scrollTop();
                winWidth = $window.width();
                if (elOffset.left < winScrollLeft && elOffset.left + elWidth > winScrollLeft + winWidth || elWidth > winWidth) {
                    return 'horizontal';
                } else if (elOffset.top < winScrollTop && elOffset.top + elHeight > winScrollTop + winHeight || elHeight > winHeight) {
                    return 'vertical';
                } else if (elOffset.top < winScrollTop) {
                    return 'top';
                } else if (elOffset.left < winScrollLeft) {
                    return 'left';
                } else if (elOffset.left + elWidth > winScrollLeft + winWidth) {
                    return 'right';
                } else if (elOffset.top + elHeight > winScrollTop + winHeight) {
                    return 'bottom';
                } else {
                    return 'none';
                }
            } else {
                return 'none';
            }
        },

        /*
    		Returns an array of ids, that are currently set in the location hash for a given scope.
    
    		@param [String] scope The scope, for which the ids should be returned.
    		@return [Array] An array of ids.
     */
        getHashIds: function(scope) {
            var hashObject;
            hashObject = T.Utils.parseHashUrl(location.hash);
            return hashObject[scope] || [];
        },

        /*
    		Checks the current location hash for a specific scope and id.
    
    		@param [String] scope The hash scope to check for.
    		@param [String] id The id to check for.
    		@return [Boolean] True if the fiven pair of scope and id is currently set in the location hash.
     */
        hashContains: function(scope, id) {
            var hashObject;
            hashObject = T.Utils.parseHashUrl(location.hash);
            return hashObject.hasOwnProperty(scope) && hashObject[scope].indexOf(id) !== -1;
        },

        /*
    		isValid
    		checks each item of a jquery selection and returns true if all items are valid
    
    		@param: {jQuery Object} $query
    		@return: {Boolean} true / false | true = is valid
     */
        isValid: function($query) {
            var $check, valid;
            valid = true;
            $check = $query.filter(':not(button):not([type="hidden"]):not([readonly]):not([disabled])');
            $check.each(function() {
                valid = $(this).is(":valid");
                if (!valid) {
                    return false;
                }
            });
            return valid;
        },

        /*
    		localizePrice
    		Returns a localized price string for a given value (type = number)
    
    		custom price handling with java.text.DecimalFormat since it has to match the hybris configured pattern
    		(not via toLocaleString({locale},...) and Intl.NumberFormat)
    
    		@param: {number} price fromated as price
    		@return: {string} price fromated as localized price
     */
        localizePrice: function(price) {
            var config, formated, priceArray;
            config = this.getConfigFromDecimalFormat(glob_config.priceFormat);
            formated = [config.prefix];
            priceArray = price.toFixed(config.maximumFractionDigits).replace(/0+$/, '').split('.');
            if (priceArray[1].length < config.minimumFractionDigits) {
                priceArray = price.toFixed(config.minimumFractionDigits).split('.');
            }
            priceArray[0] = priceArray[0].replace(/\B(?=(\d{3})+(?!\d))/g, glob_config.groupingSeparator);
            formated.push(priceArray.join(glob_config.decimalSeparator));
            formated.push(config.suffix);
            return formated.join('').replace('¤', glob_config.currencySymbol);
        },

        /*
    		Parses a given hash and converts it to an object.
    
    		@param [String] hash A location hash.
    		@return [Object] An object which contains the current set scopes as keys and their ids as an array.
     */
        parseHashUrl: function(hash) {
            var j, len1, p, parts, result, urlParts;
            urlParts = hash.match(/[^\/]+=[^\/]+/g);
            result = {};
            if (urlParts && urlParts.length) {
                for (j = 0,
                len1 = urlParts.length; j < len1; j++) {
                    p = urlParts[j];
                    parts = p.split('=');
                    if (!result.hasOwnProperty(parts[0])) {
                        result[parts[0]] = [];
                    }
                    result[parts[0]].push(parts[1]);
                    result[parts[0]].sort();
                }
            }
            return result;
        },

        /*
    		Converts a given price pattern (java.text.DecimalFormat) to an object
    		containing required toLocaleString settings and pre- and suffix for price string
    
    		@param [String] pattern | java decimal format
    		@return [Object] config | An object which contains toLocaleString settings (minimumFractionDigits, maximumFractionDigits) and suffix and prefix for price string.
     */
        getConfigFromDecimalFormat: function(pattern) {
            var config, format, fraction, minimumFraction, numberStr;
            config = {};
            format = pattern.match(/([^#0,.]*)([#0,.]*)([^#0,.]*)/);
            numberStr = format[2];
            fraction = numberStr.split('.')[1] || [];
            minimumFraction = fraction.match(/0/g) || [];
            config.prefix = format[1];
            config.suffix = format[3];
            config.maximumFractionDigits = fraction.length;
            config.minimumFractionDigits = minimumFraction.length;
            return config;
        },

        /*
    		Converts a given Hash Object (returned from parseHashUrl) to a hash string.
    
    		@param [Object] hashObject The Hash Object which should be converted.
    		@return [String] The converted hash string.
     */
        renderHashUrl: function(hashObject) {
            var j, key, len1, parts, ref, val;
            parts = [];
            for (key in hashObject) {
                ref = hashObject[key];
                for (j = 0,
                len1 = ref.length; j < len1; j++) {
                    val = ref[j];
                    parts.push(key + "=" + val);
                }
            }
            if (parts.length) {
                return "#/" + (parts.join('/')) + "/";
            } else {
                return "";
            }
        },

        /*
    		Replaces the given oldId with the newId for the given scope in the location.hash.
    
    		@param [String] scope The hash scope.
    		@param [String] oldId The old id that should be replaced.
    		@param [String] newId The new id.
     */
        replaceHash: function(scope, oldId, newId) {
            return location.hash = location.hash.replace(new RegExp("/" + scope + "=" + oldId + "/","g"), "/" + scope + "=" + newId + "/");
        },

        /*
    		Removed the given id for the scope from the location.hash.
    
    		@param [String] scope The hash scope.
    		@param [Array] id The ids that should be removed.
     */
        removeHash: function(scope, id) {
            var hash, hashObject, index, item, j, len1;
            hashObject = T.Utils.parseHashUrl(location.hash);
            for (j = 0,
            len1 = id.length; j < len1; j++) {
                item = id[j];
                if (hashObject.hasOwnProperty(scope)) {
                    index = hashObject[scope].indexOf(item);
                    if (index !== -1) {
                        hashObject[scope].splice(index, 1);
                    }
                    if (!hashObject[scope].length) {
                        delete hashObject[scope];
                    }
                }
            }
            hash = T.Utils.renderHashUrl(hashObject);
            if (!hash) {
                hash = '!';
            }
            return location.hash = hash;
        },

        /*
    		Sets the given id for the hash scope in current location.hash.
    		If the scope is nonexistent, it will be added.
    		If the scope already contains ids, the new id will be added to the scope.
    
    		@param [String] scope The hash scope.
    		@param [String] id The id that should be set.
     */
        setHash: function(scope, id) {
            var hashObject;
            hashObject = T.Utils.parseHashUrl(location.hash);
            if (!hashObject.hasOwnProperty(scope)) {
                hashObject[scope] = [];
            }
            if (hashObject[scope].indexOf(id) === -1) {
                hashObject[scope].push(id);
            }
            return location.hash = T.Utils.renderHashUrl(hashObject);
        },

        /*
    		Splits the given  url into an Object with base and get parameters
    
    		@param [String] url The url to split.
     */
        splitUrl: function(url) {
            var temp, urlGet, urlObj, urlSpl, urlSplPre;
            urlSplPre = url.split('?');
            urlSpl = void 0;
            urlGet = void 0;
            urlObj = {};
            urlObj.base = urlSplPre[0];
            if (urlSplPre.length > 2) {
                temp = urlSplPre.slice(1, urlSplPre.length);
                urlSplPre[1] = temp.join('?');
            }
            if (urlSplPre.length > 1) {
                urlSpl = urlSplPre[1].split('#');
                urlObj.get = {};
                urlGet = urlSpl[0].split('&');
                if (urlSpl.length > 1) {
                    urlObj.hash = urlSpl[1];
                }
                $.each(urlGet, function() {
                    var existingValue, part, tempGet;
                    part = this.toString().split('=');
                    if (part.length > 2) {
                        tempGet = part.slice(1, part.length);
                        part[1] = tempGet.join('=');
                    }
                    if (urlObj.get[part[0]] === void 0) {
                        if (typeof part[0] === 'string' && part[0] !== '') {
                            return urlObj.get[part[0]] = part[1];
                        }
                    } else {
                        if (typeof urlObj.get[part[0]] !== 'object') {
                            existingValue = urlObj.get[part[0]];
                            urlObj.get[part[0]] = [];
                            urlObj.get[part[0]].push(existingValue);
                        }
                        return urlObj.get[part[0]].push(part[1]);
                    }
                });
            }
            return urlObj;
        },

        /*
    		Scrolls smoothly to the given reference position.
    
    		@param [jQuery/number/function] reference The reference element to scroll to. Can be a jQuery object or a number. If it is a function, it will be handled as callback.
    		@param [function] callback Optional callback function.
     */
        scrollToTop: function(reference, callback) {
            var callbackCalled, scrollTop, speed;
            speed = T.Utils.toTop.animateDuration;
            scrollTop = 0;
            callbackCalled = false;
            if (typeof reference === 'object' && typeof reference.offset === 'function') {
                scrollTop = reference.offset().top;
            }
            if (typeof reference === 'number') {
                scrollTop = reference;
            }
            return $('html,body').animate({
                scrollTop: scrollTop
            }, speed, function() {
                if (!callbackCalled) {
                    if (callback != null) {
                        callbackCalled = true;
                        callback();
                    }
                    if (typeof reference === 'function') {
                        callbackCalled = true;
                        return reference();
                    }
                }
            });
        },

        /*
    		Configurates DotJS Template engine
     */
        configDoTJS: function() {
            doT.templateSettings.evaluate = /\[\{([\s\S]+?(\}?)+)\}\]/g;
            doT.templateSettings.interpolate = /\[\{=([\s\S]+?)\}\]/g;
            doT.templateSettings.encode = /\[\{!([\s\S]+?)\}\]/g;
            doT.templateSettings.use = /\[\{#([\s\S]+?)\}\]/g;
            doT.templateSettings.define = /\[\{##\s*([\w\.$]+)\s*(\:|=)([\s\S]+?)#\}\]/g;
            doT.templateSettings.conditional = /\[\{\?(\?)?\s*([\s\S]*?)\s*\}\]/g;
            doT.templateSettings.iterate = /\[\{~\s*(?:\}\]|([\s\S]+?)\s*\:\s*([\w$]+)\s*(?:\:\s*([\w$]+))?\s*\}\])/g;
            return doT.templateSettings.strip = false;
        },

        /*
    		onAjaxControllerTriggered(ev)
    		call function on event handling for trigger elements (button, select, etc.)
    		@param [event object] ev
    		@param [boolean|$element] current
    		@return [array] array of request objects
     */
        onAjaxControllerTriggered: function(ev, current) {
            var config, elm, id;
            if (ev) {
                elm = current ? ev.currentTarget : ev.target;
                ev.preventDefault();
            } else {
                elm = current[0];
            }
            id = T.Utils.getAjaxId(elm);
            config = $(elm).data('request');
            if (typeof config !== 'object') {
                config = false;
            }
            if (id) {
                return T.Utils.startAjaxRequest(id, config);
            } else {
                console.error('trigger element has to be placed in ajax form or data data-attribute ajaxRequestID is required on trigger element:');
                console.error(elm);
                return false;
            }
            return true;
        },

        /*
    		getAjaxId(ev)
    		Get Ajax container ID from event object (button, select, etc.)
    
    		@param [Object] elm – Element for
    		@return [String|Undefined] id – returns ajax container id or undefined.
     */
        getAjaxId: function(elm) {
            var $trigger, id, idArray;
            $trigger = $(elm);
            id = $trigger.attr('data-ajax-request-id');
            if (typeof id === 'undefined') {
                id = $trigger.closest('.js-ajax-request').attr('data-ajax-id');
                try {
                    idArray = JSON.parse(id);
                    if (Object.prototype.toString.call(idArray) === '[object Array]') {
                        id = idArray[0];
                    }
                } catch (undefined) {}
            }
            return id;
        },

        /*
    		Gets all required data for ajax request by data-ajax of the ajax object
    		and complete object values with default values for required parameters
    
    		It is essential to use attr data-ajax instead of data('ajax') to get the current
    		request configuration because elm data could be manipulated before
    		via 'config' and 'data' parameter in startAjaxRequest method
    
    		@param [String] id – The id of the ajax object that stores the ajax-data and template scripts.
    		@param [Boolean] formdata – save form data in request object. not needed for init call
    		@return [Object] request – returns all data in request object.
     */
        getAjaxRequestObj: function(id, formdata) {
            var $ajaxobj, buildError, dataajax, dataajaxComplete, error, error1, error2, multi, request;
            multi = false;
            $ajaxobj = $('.js-ajax-request[data-ajax-id="' + id + '"]');
            if (!$ajaxobj.length) {
                $ajaxobj = $('.js-ajax-request[data-ajax-id*="' + id + '"]');
                if ($ajaxobj.length) {
                    try {
                        multi = JSON.parse($ajaxobj.attr('data-ajax-id')).indexOf(id) > -1;
                    } catch (undefined) {}
                } else {
                    return 'noid';
                }
            }
            try {
                dataajax = JSON.parse($ajaxobj.attr("data-ajax"));
                request = !multi ? dataajax : dataajax[id];
                dataajaxComplete = $ajaxobj.attr('data-ajax-complete');
                if (dataajaxComplete) {
                    try {
                        request.complete = new Function(dataajaxComplete);
                    } catch (error1) {
                        buildError = error1;
                        console.error("content '" + dataajaxComplete + "' of " + (data - ajax - complete) + " could not be parsed to function");
                    }
                }
            } catch (error2) {
                error = error2;
                console.error('"data-ajax" value has to be an object');
            }
            if (!request) {
                return false;
            }
            request.id = id;
            request.obj = $ajaxobj;
            if (formdata) {
                request.formdata = T.Utils.getFormDataPairs($ajaxobj, request.customNameAttr);
            }
            if (request.paramFormat && request.paramFormat.toLowerCase() === 'json') {
                try {
                    request.formdata = JSON.stringify(request.formdata);
                    request.contentType = "application/json; charset=utf-8";
                } catch (undefined) {}
            }
            request.async = T.Utils.setDefaultValue(request.async, true);
            request.method = T.Utils.setDefaultValue(request.method, 'GET');
            request.dataType = T.Utils.setDefaultValue(request.dataType, 'json').toLowerCase();
            request.dataRendering = T.Utils.setDefaultValue(request.dataRendering, 'TRUE');
            request.crossDomain = true;
            request.trigger = {};
            return request;
        },
        initialRendering: function(id) {
            var $init;
            $init = id ? $('[data-init-data=' + id + ']') : $('[data-init-data]');
            return $init.each(function() {
                var $target, blockCallupFunction, initdata;
                $target = $(this);
                initdata = JSON.parse($target.text());
                blockCallupFunction = $target.attr('data-no-initial-callup');
                return T.Utils.startInitialRendering($target.data('initData'), initdata, blockCallupFunction);
            });
        },
        initialAjaxRequestTrigger: function() {
            var $init;
            $init = $('.js-trigger-ajax-request[data-onload=true]');
            return $init.each(function() {
                return $(this).trigger('allsynced');
            });
        },

        /*
    		call this function on click, load, etc to start Ajax call for a specific container
    		@param [string] id - refers to ajax-request element with attribute. e.g. data-ajax-id="search-001"
    		@param [object] initdata - json object with rendering data
    		@param [boolean] blockCallupFunction - do not use callup function on initial request
     */
        startInitialRendering: function(id, initdata, blockCallupFunction) {
            var request;
            request = this.getAjaxRequestObj(id);
            if (typeof request !== 'object') {
                console.error('"data-ajax" value has to be an object');
                return;
            }
            request.triggerRendering = true;
            return this.handleAjaxResponse(request, initdata, blockCallupFunction);
        },

        /*
    		method starts Ajax call
    		@param [string] id - refers to ajax-request element with attribute. e.g. data-ajax-id="search-001"
    		@param [object] a - object for additional configuration of the ajax call
    		@param [object] data - object for additional key:value pairs as request parameters
    	@param [Function] cb - optional callback to be called when the ajax operation finished. The signature of the
    													function is expected to be (err)
    		@return [object] return Object with request promise.
    			Indexed [key] for 'string' and 'array' request.url
    			Named [key] for request.url object e.g.
     */
        startAjaxRequest: function(id, a, data, cb) {
            var allsuccess, callnr, config, ctx, event, item, key, last, request, requestError, requestSuccess, returnObject, url, urlobj, urls;
            config = a;
            ctx = this;
            if (id) {
                request = this.getAjaxRequestObj(id, true);
                if (request === 'noid') {
                    console.error('no request id:', id);
                    return;
                }
            } else if (typeof config === 'object' && config !== null) {
                request = config;
                request.async = T.Utils.setDefaultValue(request.async, true);
                request.method = T.Utils.setDefaultValue(request.method, 'GET');
                request.dataType = T.Utils.setDefaultValue(request.dataType, 'json').toLowerCase();
                request.dataRendering = T.Utils.setDefaultValue(request.dataRendering, 'FALSE');
                request.crossDomain = true;
                request.formdata = {};
                request.trigger = {};
            } else {
                return false;
            }
            if (request.validateRequired) {
                item = request.customNameAttr || 'name';
                if (!this.isValid($("[" + item + "]", $(request.obj)))) {
                    return false;
                }
            }
            if (typeof config === 'object' && config !== null) {
                request.trigger = config;
                if (config.method) {
                    request.method = config.method;
                }
                if (config.url) {
                    request.url = config.url;
                }
                if (config.dataRendering) {
                    request.dataRendering = config.dataRendering;
                }
                if (config.errorCase) {
                    request.errorCase = config.errorCase;
                }
                if (typeof config.data === 'object') {
                    request.formdata = $.extend(request.formdata, config.data);
                }
                if (config.functionCallup) {
                    request.functionCallup = config.functionCallup;
                }
                request.beforeSend = T.Utils.setDefaultValue(config.beforeSend, null);
            }
            if (typeof data === 'object') {
                request.formdata = $.extend(request.formdata, data);
            }
            if (typeof request !== 'object') {
                console.error('"data-ajax" value has to be an object');
                return;
            }
            if (this.loaderRequestCounter && request.requiresLoaderRequestsDone) {
                return false;
            }
            if (request.obj) {
                event = request.obj.attr('data-loader-event') === 'request';
            }
            if (event && !request.preventLoader) {
                request.obj.trigger('request');
            }
            request.httpheader = request.method === 'POST' ? T.Utils.getCSRFTokenHeader() : {};
            request.contentType = T.Utils.setDefaultValue(request.contentType, 'application/x-www-form-urlencoded; charset=UTF-8');
            if (typeof request.url === 'string') {
                urls = [request.url];
                request.url = urls;
            }
            this.response = {};
            urlobj = request.url;
            allsuccess = true;
            last = urlobj.length;
            callnr = 0;
            returnObject = {};
            if (request.obj) {
                request.errorelms = $('.js-show-on-requesterror', request.obj);
            }
            if (request.obj) {
                request.successelms = $('.js-show-on-requestsuccess', request.obj);
            }
            if (request.errorelms && request.errorelms.length) {
                request.errorelms.toggleClass('is-hidden', true);
            }
            if (request.successelms && request.successelms.length) {
                request.successelms.toggleClass('is-hidden', true);
            }
            for (key in urlobj) {
                url = urlobj[key];
                if (allsuccess === true) {
                    requestSuccess = $.proxy(requestError, this);
                    requestError = $.proxy(requestError, this);
                    returnObject[key] = $.ajax({
                        async: request.async,
                        beforeSend: request.beforeSend,
                        cache: false,
                        data: request.formdata,
                        headers: request.httpheader,
                        url: url,
                        method: request.method,
                        dataType: request.dataType,
                        contentType: request.contentType,
                        crossDomain: request.crossDomain,
                        context: document.body
                    }).done(requestSuccess = function(result) {
                        var json;
                        ++callnr;
                        json = ctx.response;
                        if (Object.prototype.toString.call(result) === '[object Array]') {
                            ctx.response = result;
                        } else {
                            if (request.dataType === 'json') {
                                ctx.response = $.extend(true, {}, json, result);
                            }
                            if ((callnr === last) && (allsuccess === true)) {
                                if (!ctx.response) {
                                    ctx.response = {};
                                }
                                ctx.response.requestdata = request.formdata;
                                if (request.dataType === 'html') {
                                    ctx.response = result;
                                }
                            }
                        }
                        if ((request.dataRendering && request.dataRendering !== "FALSE") || request.functionCallup || request.errorCase) {
                            T.Utils.handleAjaxResponse(request, ctx.response);
                        } else {
                            if (request.successelms && request.successelms.length) {
                                request.successelms.toggleClass('is-hidden', false);
                            }
                        }
                        if (event && !request.preventLoader) {
                            T.Utils.application.getModuleById(1)._events.emit('loader:close', {
                                $trigger: request.obj
                            });
                        }
                        if (typeof request.complete === "function") {
                            request.complete();
                        }
                        return typeof cb === "function" ? cb(null, ctx.response.response) : void 0;
                    }
                    ).fail(requestError = function(xhr, ajaxOptions, thrownError) {
                        ctx.allsuccess = false;
                        switch (xhr.status) {
                        case 400:
                            console.error('Bad Request');
                            break;
                        case 402:
                            console.error('Payment Required');
                            break;
                        case 403:
                            console.error('Forbidden');
                            break;
                        case 404:
                            console.error('Request URL not found');
                            break;
                        case 408:
                            console.error('Request Timeout');
                            break;
                        default:
                            console.error('an request error occoured');
                        }
                        if (event && !request.preventLoader) {
                            T.Utils.application.getModuleById(1)._events.emit('loader:close', {
                                $trigger: request.obj
                            });
                        }
                        if (request.errorelms && request.errorelms.length) {
                            request.errorelms.toggleClass('is-hidden', false);
                        }
                        return typeof cb === "function" ? cb(thrownError) : void 0;
                    }
                    );
                }
            }
            return returnObject;
        },
        renderTemplateMarkup: function(request, result, errorCase) {
            var $tempContainer, container, template;
            container = errorCase ? 'error' : 'success';
            $tempContainer = $('[data-ajax-template="' + container + '"]', request.obj);
            if ($tempContainer.length === 0) {
                console.error('no ', container, ' template defined');
                return;
            }
            template = doT.template($tempContainer.html());
            return template(result);
        },
        ajaxResponseErrorCaseCheck: function(errorCase, result) {
            var checkobj, hasError;
            hasError = false;
            for (checkobj in errorCase) {
                hasError = T.Utils.checkObjNode(result, checkobj, errorCase[checkobj]);
                if (hasError) {
                    break;
                }
            }
            return hasError;
        },

        /*
    		handle Response data
    		@param: [Object] request - configuration for ajax request
    		@param: [Object] result - result data of ajax call
    		@param [boolean] blockCallupFunction - do not use callup function on initial request
     */
        handleAjaxResponse: function(request, result, blockCallupFunction) {
            var functionCall, hasErrorInResponse, startRendering, stateRendered;
            startRendering = request.triggerRendering || request.dataRendering !== "FALSE";
            hasErrorInResponse = false;
            if (request.errorCase) {
                hasErrorInResponse = T.Utils.ajaxResponseErrorCaseCheck(request.errorCase, result);
            }
            if (request.errorelms && request.errorelms.length && hasErrorInResponse) {
                request.errorelms.toggleClass('is-hidden', false);
            }
            if (startRendering) {
                stateRendered = false;
                (function(callback) {
                    var $batch, isArray, j, len1, nextCall, render, renderArray, renderObj;
                    if (request.dataType === 'html') {
                        $batch = $('<div/>').append(result);
                    } else {
                        $batch = $('<div/>').html(T.Utils.renderTemplateMarkup(request, result, hasErrorInResponse));
                    }
                    if (typeof request.trigger.render === 'object') {
                        renderObj = request.trigger.render;
                        renderArray = [];
                        isArray = Object.prototype.toString.call(renderObj) === '[object Array]';
                        if (!isArray) {
                            renderArray.push(renderObj);
                        } else {
                            renderArray = renderObj;
                        }
                        for (j = 0,
                        len1 = renderArray.length; j < len1; j++) {
                            render = renderArray[j];
                            T.Utils.syncContent($batch, render.id, render.method);
                        }
                    } else {
                        T.Utils.syncContent($batch);
                    }
                    if (stateRendered = true) {
                        if (typeof callback === 'function') {
                            callback();
                        }
                        nextCall = request.followUpRequest;
                        if (nextCall !== void 0 && typeof nextCall === 'object') {
                            T.Utils.startAjaxRequest(nextCall.id, nextCall.data, nextCall.config);
                        }
                    }
                }
                )(request.trigger.callback);
            }
            if (request.functionCallup && !blockCallupFunction) {
                if (!hasErrorInResponse) {
                    functionCall = Function(request.functionCallup + "(" + JSON.stringify(result) + ")");
                    if (typeof functionCall !== 'function') {
                        console.error('value of data-ajax functionCallup "' + request.functionCallup + '" is not a defined Function');
                        return;
                    }
                    functionCall();
                }
            }
            if (request.successelms && request.successelms.length && !hasErrorInResponse) {
                request.successelms.toggleClass('is-hidden', false);
            }
        },

        /*
    		get form data as object with key:value pairs for each input.
    		transform values given as json data to key:value pair
    		e.g.
    		<input name="standardFilters" value="{"key1":"val1","key2":"name2"}>
    		output =
    		standardFilters.key1 = "name1"
    		standardFilters.key2 = "name2"
    
    		@param: [jQuery object] $form - form elements only: form, fieldset, input
    		@param: [string] customNameAttr - optional parameter to choose another attribute for key instead of name
    		@return: [object] keyValue - $form data as object of key:value pairs
     */
        getFormDataPairs: function($form, customNameAttr) {
            var $successfulFormControls, conf, count0, count1, formdata, isarray, j, key, keyValue, keyname, l, len1, len2, name, nameRegEx, obj, ref, requestname, serializeArray, serie, seriename, subkey, unsortedData, value, valuekey, valueobj, valueval;
            keyValue = {};
            formdata = [];
            if ($form.is('fieldset') || $form.is('div')) {
                $successfulFormControls = $form.filter('input, select').add('input, select', $form);
                formdata = $successfulFormControls.serializeArray();
            } else {
                formdata = $form.serializeArray();
            }
            if (customNameAttr) {
                formdata = T.Utils.remapFormdata(formdata, $form, customNameAttr, true);
            }
            for (j = 0,
            len1 = formdata.length; j < len1; j++) {
                obj = formdata[j];
                valueobj = '';
                try {
                    valueobj = JSON.parse(obj.value);
                } catch (undefined) {}
                isarray = Object.prototype.toString.call(valueobj) === '[object Array]';
                if (typeof valueobj === 'object' && !isarray) {
                    for (keyname in valueobj) {
                        if (valueobj.hasOwnProperty(keyname)) {
                            switch (obj.name) {
                            case 'keyValuePair':
                                keyValue[keyname] = valueobj[keyname];
                                break;
                            default:
                                keyValue[obj.name + '.' + keyname] = valueobj[keyname];
                            }
                        }
                    }
                } else if (isarray) {
                    keyValue[obj.name] = valueobj;
                } else {
                    keyValue[obj.name] = keyValue[obj.name] ? keyValue[obj.name] + ',' + obj.value : obj.value;
                }
            }
            $('.m-rangeslider .js-slider', $form).each(function() {
                var $slider, $sliderinput, conf, ident, lower, typeval, upper;
                $slider = $(this);
                conf = $slider.data();
                $sliderinput = $slider.find('input.js-value');
                lower = $sliderinput[0];
                upper = $sliderinput[1];
                ident = $slider.find('input:not(.js-value)')[0];
                typeval = $slider.find('input:not(.js-value)')[1];
                if (keyValue[lower.name] === String(conf.rangeMin)) {
                    keyValue[lower.name] = null;
                }
                if (keyValue[upper.name] === String(conf.rangeMax)) {
                    keyValue[upper.name] = null;
                }
                if (keyValue[lower.name] === null && keyValue[upper.name] === null) {
                    delete keyValue[ident.name];
                    delete keyValue[typeval.name];
                    delete keyValue[lower.name];
                    return delete keyValue[upper.name];
                }
            });
            conf = $form.data();
            if (conf && conf.ajax) {
                serializeArray = conf.ajax.requestParamSeries;
                if (serializeArray) {
                    unsortedData = {};
                    for (l = 0,
                    len2 = serializeArray.length; l < len2; l++) {
                        serie = serializeArray[l];
                        seriename = serie.name;
                        unsortedData[seriename] = [];
                        nameRegEx = new RegExp(seriename);
                        for (key in keyValue) {
                            if (!hasProp.call(keyValue, key))
                                continue;
                            value = keyValue[key];
                            if (nameRegEx.test(key)) {
                                delete keyValue[key];
                                name = key.split('.');
                                if (name.length >= 2) {
                                    unsortedData[seriename][name[0]] = unsortedData[seriename][name[0]] || {};
                                    switch (name.length) {
                                    case 2:
                                        unsortedData[seriename][name[0]][name[1]] = value;
                                        break;
                                    case 3:
                                        unsortedData[seriename][name[0]][name[1]] = unsortedData[seriename][name[0]][name[1]] || {};
                                        unsortedData[seriename][name[0]][name[1]][name[2]] = value;
                                    }
                                }
                            }
                        }
                        count0 = 0;
                        ref = unsortedData[seriename];
                        for (key in ref) {
                            if (!hasProp.call(ref, key))
                                continue;
                            obj = ref[key];
                            if (!serie.checkFor || obj.hasOwnProperty(serie.checkFor)) {
                                for (subkey in obj) {
                                    if (!hasProp.call(obj, subkey))
                                        continue;
                                    value = obj[subkey];
                                    requestname = String(seriename + '[' + count0 + '].' + subkey);
                                    if (typeof value === 'object' && value !== null) {
                                        count1 = 0;
                                        for (valuekey in value) {
                                            if (!hasProp.call(value, valuekey))
                                                continue;
                                            valueval = value[valuekey];
                                            keyValue[requestname + '[' + count1 + ']'] = valueval;
                                            ++count1;
                                        }
                                    } else {
                                        keyValue[requestname] = value;
                                    }
                                }
                                ++count0;
                            }
                        }
                    }
                }
            }
            return keyValue;
        },
        checkObjNode: function(obj, path, testvalue) {
            var value;
            value = T.Utils.getObjectValofPath(obj, path);
            return value === testvalue;
        },
        getObjectValofPath: function(obj, path) {
            var recompose;
            recompose = function(obj, string) {
                var newObj, newString, parts;
                parts = string.split('.');
                if (typeof obj[parts[0]] === 'undefined') {
                    return false;
                }
                newObj = obj[parts[0]];
                if (parts[1]) {
                    parts.splice(0, 1);
                    newString = parts.join('.');
                    return recompose(newObj, newString);
                }
                return newObj;
            }
            ;
            return recompose(obj, path);
        },

        /*
    		Calculates and returns the width of the scrollbar.
    		For further information see: https://davidwalsh.name/detect-scrollbar-width
     */
        getScrollbarWidth: function() {
            var $body, $measure, scrollbarWidth;
            $body = $('body');
            $body.append('<div class="scrollbar-measure js-scrollbar-measure"></div>');
            $measure = $body.find('.js-scrollbar-measure');
            scrollbarWidth = $measure[0].offsetWidth - $measure[0].clientWidth;
            $measure.remove();
            return scrollbarWidth;
        },

        /*
    		remap formdata with new attribute used instead of name attribute within key:value pairs
    
    		@param: [object] formdata - object of serialized form array
    		@param: [jQuery object] $form - form elements only: form, fieldset, input
    		@param: [string] attr - attr that should be instead of name attribute
    		@param: [boolean] filter - returns a new array that contains only remapped key:value (default return all key:value pairs)
    		@return: [object] formdata - returns remapped object
     */
        remapFormdata: function(formdata, $form, attr, filter) {
            var $mappings, formdataJavaObj, key, obj;
            $mappings = $form.filter('[' + attr + ']').add('[' + attr + ']', $form);
            if ($mappings.length > 0) {
                formdataJavaObj = filter ? [] : formdata;
                for (key in formdata) {
                    if (!hasProp.call(formdata, key))
                        continue;
                    obj = formdata[key];
                    $mappings.each(function() {
                        var $e, newobj;
                        $e = $(this);
                        if ($e.prop('name') === obj.name) {
                            newobj = {
                                name: $e.attr(attr),
                                value: obj.value
                            };
                            if (filter) {
                                return formdataJavaObj.push(newobj);
                            } else {
                                return formdataJavaObj[key] = newobj;
                            }
                        }
                    });
                }
                return formdataJavaObj;
            } else {
                return formdata;
            }
        },

        /*
    		Split template into parts and sync each part with existing DOM elements
    
    		@param [jquery object] $template.
    		@param [sting] addmethod - manipulates the add method for given section. | optional
     */
        syncContent: function($template, partid, addmethod) {
            var $sections, j, len1, section;
            if (partid) {
                $sections = $('[data-replace-id="' + partid + '"]', $template);
            } else {
                $sections = $('[data-replace-id]', $template);
            }
            for (j = 0,
            len1 = $sections.length; j < len1; j++) {
                section = $sections[j];
                T.Utils.replaceContent(section, addmethod);
            }
        },

        /*
    		replace content of one element with the content of the connected element
    		connected by same value for 'data-replace-id' and 'data-replace-container'
    
    		@param [Obj.Node] part. part of the template that will be replaced
    		@param [sting] addmethod - manipulates the add method for given part. | optional
     */
        replaceContent: function(part, addmethod) {
            var $container, $part, checkSyncStatus, closeLoader, content, e, error1, height, id, method, scrollTop, scrollto;
            $part = $(part);
            content = $part.html();
            id = $part.data("replace-id");
            method = addmethod || $part.data("add-method") || 'replace';
            closeLoader = $part.data("close-loader");
            scrollto = $part.data('scrollto');
            switch (id) {
            case 'head':
                $container = $('head');
                break;
            case 'body':
                $container = $('body');
                break;
            default:
                $container = $('[data-replace-container="' + id + '"]');
            }
            height = $container.outerHeight();
            $container.css({
                'height': height,
                'overflow': 'hidden'
            });
            switch (method) {
            case 'replace':
                try {
                    T.Utils.application._sandbox.removeModules($container[0]);
                } catch (error1) {
                    e = error1;
                    console.log(e);
                }
                $container.html(content);
                break;
            case 'append':
                $container.append(content);
                break;
            case 'prepend':
                $container.prepend(content);
            }
            if (scrollto) {
                scrollTop = $(window).scrollTop();
            }
            checkSyncStatus = setInterval(function() {
                var appModule;
                if (T.Utils.allSynced) {
                    clearInterval(checkSyncStatus);
                    T.Utils.application._sandbox.addModules($container[0]);
                    appModule = T.Utils.application.getModuleById(1);
                    appModule._events.emit('dom:replacement', $container[0]);
                    appModule._events.emit('recalc', {
                        $ctx: $container,
                        $element: $container
                    });
                    $container.find('img').on('load', function() {
                        return T.Utils.application.getModuleById(1)._events.emit('recalc', {
                            $ctx: $container,
                            $element: $container
                        });
                    });
                    if (closeLoader) {
                        T.Utils.application.getModuleById(1)._events.emit('loader:close', {
                            $trigger: $container
                        });
                    }
                    if (scrollto) {
                        setTimeout(function() {
                            return $(window).scrollTop(scrollTop);
                        }, 200);
                    }
                    return $container.css({
                        'height': '',
                        'overflow': ''
                    });
                }
            }, 200);
        },
        setDefaultValue: function(a, value) {
            if (typeof a === 'undefined') {
                a = value;
            }
            return a;
        },

        /*
    		Ajax response handler for event tracking ICORE-35478
    		notifies layout decorator: tracking with tracking data
    
    		@param {Object} data: ajax request response
     */
        functionCallAjaxTrackingProductFilters: function(data) {
            if (data.response) {
                return T.Utils.application.getModuleById(1)._events.emit('utils:ajax-productlist', data.response);
            }
        },
        functionCallTest: function(data) {
            console.log('this is the ajax response data handling function');
            console.info(data);
        },
        getCSRFTokenHeader: function() {
            var $meta, header, name, value;
            header = {};
            $meta = $('head meta');
            name = $meta.filter('[name="_csrf_header"]').attr('content');
            value = $meta.filter('[name="_csrf"]').attr('content');
            header[name] = value;
            return header;
        },
        collectJson: function(obj1, obj2) {
            var jsonArrayToObject, jsonRestoreObjectToArray, object;
            jsonArrayToObject = function(obj, prefix) {
                var i, k, len, newobj, pre;
                pre = prefix || 'prfx_';
                for (k in obj) {
                    if (typeof obj[k] === 'object' && obj[k] !== null) {
                        if (Array.isArray(obj[k]) === true) {
                            newobj = {};
                            len = obj[k].length;
                            i = 0;
                            while (i < len) {
                                newobj[pre + i] = obj[k][i];
                                ++i;
                            }
                            obj[k] = newobj;
                        }
                        jsonArrayToObject(obj[k], pre);
                    }
                }
                return obj;
            }
            ;
            jsonRestoreObjectToArray = function(obj, prefix) {
                var k, key, newarray, pre;
                pre = prefix || 'prfx_';
                for (k in obj) {
                    if (typeof obj[k] === 'object' && obj[k] !== null) {
                        if (obj[k].hasOwnProperty(pre + '0')) {
                            newarray = [];
                            for (key in obj[k]) {
                                newarray.push(obj[k][key]);
                            }
                            obj[k] = newarray;
                        }
                        jsonRestoreObjectToArray(obj[k], pre);
                    }
                }
                return obj;
            }
            ;
            object = $.extend(true, jsonArrayToObject(obj1), jsonArrayToObject(obj2, 'prfx_2'));
            return jsonRestoreObjectToArray(object);
        },

        /*
    		localStorage helpers
     */
        localStorageGetItem: function(key) {
            var error, error1, value;
            value = localStorage.getItem(key);
            try {
                if (JSON.parse(value)) {
                    value = JSON.parse(value);
                }
            } catch (error1) {
                error = error1;
                console.error('localStorage parse error');
            }
            return value;
        },
        localStorageSetItem: function(key, value) {
            if (typeof value === 'object') {
                value = JSON.stringify(value);
            }
            return localStorage.setItem(key, value);
        },

        /*
    		event from window.onstorage
    		notify layout with storage event data
    		@param {Object} ev: window.onstorage event data
    
    		note: when using jQuery binding, the standard event data is stored in ev.originalEvent
    		note: only two window.onstorage event.key are checked (see variables.json -> T.Utils.localStorageKey)
     */
        onStorage: function(ev) {
            var storageKey;
            storageKey = ev.originalEvent.key;
            if (storageKey != null) {
                if (storageKey === T.Utils.localStorageKey.productCompare.mkt || storageKey === T.Utils.localStorageKey.productCompare.shop) {
                    return T.Utils.application.getModuleById(1)._events.emit('utils:storageUpdateSkuCompare', {
                        key: storageKey,
                        val: JSON.parse(ev.originalEvent.newValue)
                    });
                }
            }
        },

        /*
    			This util method is called from the doT template 'filterlayer_doT_ajax'.
    			The template renders all available and selected filters for the product list.
    			setSelectedFilters() is a helper function which checks some conditions to decide
    			wheter a filter should be rendered of not.
    
    			@param {Sting} filterName: name of the filter in the current iteration
    			@param {Object} filter: properties of the filter element
    			@param {Object} availableFilters: array of objects of all available filters
    			@return case 'true' {Boolean}: is returned if the filter passes as conditions
    			@return case 'false': {Boolean}: is returne if the filter fails on one condition
     */
        setSelectedFilter: function(filterName, filter, availableFilters) {
            var a, availableFilter, filterEntry, hiddenvalue, i, isChecked;
            for (i in availableFilters) {
                availableFilter = availableFilters[i];
                if (availableFilter.attribute === filterName) {
                    switch (availableFilter.type) {
                    case 'slider':
                        availableFilter.lowerMarker = filter.minValue;
                        availableFilter.upperMarker = filter.maxValue;
                        return false;
                    default:
                        isChecked = false;
                        for (a in availableFilter.entries) {
                            filterEntry = availableFilter.entries[a];
                            switch (filterEntry.type) {
                            case 'range':
                                if (filterEntry.minValue === filter.minValue && filterEntry.maxValue === filter.maxValue) {
                                    filterEntry.selected = true;
                                    return false;
                                }
                                break;
                            case 'category':
                                filterEntry.selected = filterEntry.value === filter.value;
                                if (filterEntry.selected) {
                                    return false;
                                }
                                break;
                            default:
                                if (filterEntry.value === filter.value) {
                                    filterEntry.checked = 'checked';
                                    if (availableFilter.type === 'singlevalue') {
                                        return false;
                                    }
                                    isChecked = true;
                                }
                                break;
                            }
                        }
                        if (isChecked === true) {
                            return false;
                        }
                        if (availableFilter.type === 'multivalue') {
                            hiddenvalue = filter;
                            hiddenvalue.hidden = true;
                            hiddenvalue.checked = 'checked';
                            availableFilter.entries.push(hiddenvalue);
                            return false;
                        }
                        break;
                    }
                }
            }
            return true;
        },

        /*
    			This util method creates a hidden element for a target and set target readonly (disabled)
    
    			@param {Object} target: element for that a hidden element shall be created
    			@param {string} wrapperselector: to find the wrapper to add hidden element
     */
        createHiddenElementForReadonly: function(target, wrapperselector) {
            var $hidden, $target, $wrapper, nameToSetForHidden, valueToSetAsHidden;
            $target = $(target);
            if ($target.length > 0) {
                valueToSetAsHidden = $target.val();
                nameToSetForHidden = $target.prop('name');
                $wrapper = $target.closest(wrapperselector);
                if ($wrapper.find('input:hidden[name="' + nameToSetForHidden + '"]').length === 0) {
                    $hidden = '<input type=\"hidden\" name=\"' + nameToSetForHidden + '\" value=\"' + valueToSetAsHidden + '\" />';
                    $wrapper.append($hidden);
                }
                $target.addClass('readonly').prop('disabled', true);
                return $wrapper.addClass('readonly');
            }
        },

        /*
    			This util method can be called anytime to close an open layer
     */
        hideLayer: function() {
            return T.Utils.application.getModuleById(1)._events.emit('hideLayer');
        },
        setupPerformanceLogging: function() {
            var eventCounter, intervalTimer, lastEventTime, sPageURL, sURLVariables;
            sPageURL = window.location.search.substring(1);
            sURLVariables = sPageURL.split('&');
            if (sURLVariables.indexOf('perfMode=true') === -1) {
                return;
            }
            lastEventTime = 0;
            intervalTimer = setInterval(function() {
                var current, lastEventTimeRounded;
                current = window.performance.now();
                if ((lastEventTime > 0) && ((current - lastEventTime) > 3000)) {
                    clearInterval(intervalTimer);
                    lastEventTimeRounded = Math.round(lastEventTime * 1000) / 1000;
                    return console.log("[EVENT];Offset:" + current + ";Action:RECORD_END;LastTime:" + lastEventTimeRounded);
                }
            }, 500);
            eventCounter = 0;
            return T.Sandbox.prototype.dispatch = function() {
                var diffTime, endTime, event, eventEmitter, eventEmitters, eventId, eventsCalled, i, j, ref, startTime, theArguments;
                theArguments = arguments;
                startTime = Math.round(window.performance.now() * 1000) / 1000;
                eventEmitters = this._eventEmitters;
                eventId = "ev" + ++eventCounter;
                eventsCalled = 0;
                event = theArguments[0];
                console.log("[EVENT];Offset:" + startTime + ";Action:START;Name:" + event + ";Id:" + eventId);
                for (i = j = 0,
                ref = eventEmitters.length; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
                    eventEmitter = eventEmitters[i];
                    eventsCalled += (eventEmitter._listeners['$' + event] || []).length;
                    if (eventEmitter !== void 0) {
                        eventEmitter.handle.apply(eventEmitter, arguments);
                    }
                }
                endTime = Math.round(window.performance.now() * 1000) / 1000;
                diffTime = Math.round((endTime - startTime) * 1000) / 1000;
                lastEventTime = endTime;
                console.log("[EVENT];Offset:" + endTime + ";Action:END;Name:" + event + ";Id:" + eventId + ";HandlersCalled:" + eventsCalled + ";MsUsed:" + diffTime);
                return this;
            }
            ;
        },
        isRTL: function() {
            var ref, ref1;
            return ((ref = $('html')) != null ? ref.attr('dir') : void 0) === 'rtl' || ((ref1 = $('body')) != null ? ref1.attr('dir') : void 0) === 'rtl';
        },

        /*
    			A temporary IE detection method till IE can be thrown away.
    			Normally feature detection using Modernizr would be sufficient
    			but there are IE bugs which must be handled specifically
    			@return boolean whether the current browser is IE or not
    		@see ICORE-40956
    
    		TODO should be removed once support for IE11 is removed
     */
        isIE: function() {
            return navigator.appName === 'Microsoft Internet Explorer' || !!(navigator.userAgent.match(/Trident/) || navigator.userAgent.match(/rv:11/)) || (typeof $.browser !== "undefined" && $.browser.msie === 1);
        },

        /*
    		An array of callback functions which receives a dom element as their first argument
    		which are called once new content should be initialized. These will be called at
    		* Application.start() once the application is fully initialized, synced and T.Utils.application is set
    		* dom:replacement is published in case of new markup is rendered into the page (e.g. after ajax renderContent)
    
    			The major reason is that global elements not defined in components don't have any access to some _events object to
    		register themselves for dom:replacement object.
     */
        contentInitializerListener: [],

        /*
    		Adds the content initializer callback.
    		@param cb a callback function in form of function(container) where container is a DOM element (not a jquery object)
     */
        registerContentInitializer: function(cb) {
            return T.Utils.contentInitializerListener.push(cb);
        },

        /*
    		Internal function called from main.coffee once the application startup is finished and the content initialization
    		can be activated (and executed initially once)
     */
        startContentInitialization: function() {
            T.Utils.contentInitializerListener.forEach(function(listener) {
                return listener(document);
            });
            return T.Utils.application.getModuleById(1)._events.on('dom:replacement', function(container) {
                return T.Utils.contentInitializerListener.forEach(function(listener) {
                    return listener(container);
                });
            });
        },

        /*
    		A list of event listener to modify cloned slide markup before the content gets initialized by Terrific.JS.
    		This is needed in case some slides handle with global DOM ids (e.g. Cliplister). So interested parties
    		get the ability to adapt the markup before the component is initialized
     */
        slideMarkupCloned: T.Utils.slideMarkupCloned || [],

        /*
    		Registers a callback which is informed once slides are cloned.
    		@param cb Function Gets a data parameter containing
    			$component (the jquery object which is a to-be-Terrific.js element)
    			slideClonedId: some unique id for the page identifying the element
    		element
     */
        registerSlideMarkupCloned: function(cb) {
            return T.Utils.slideMarkupCloned.push(cb);
        },

        /*
    		Internal function to be called once a component needs to be modified in course of cloning of slick slides.
     */
        notifySlideMarkupCloned: function(data) {
            return T.Utils.slideMarkupCloned.forEach(function(listener) {
                return listener(data);
            });
        }
    });
    T.Utils.configDoTJS();

    /*
  	opens print dialog on click
   */
    T.Utils.registerContentInitializer(function(container) {
        return $(container).find('.js-print-dialog').on('click', function(ev) {
            ev.preventDefault();
            return T.Utils.debounce(function(ev) {
                return window.print();
            }, 250)(ev);
        });
    });

    /*
  	trigger ajax request on click
  	@selector: .js-trigger-ajax-request
  	@required data-attr on selector: data-ajax-request-id -> equals data-ajax-id of aim container (.js-ajax-request)
   */
    T.Utils.registerContentInitializer(function(container) {
        return $(container).find(':not(:input).js-trigger-ajax-request, button.js-trigger-ajax-request').on('click allsynced', function(ev) {
            ev.preventDefault();
            return T.Utils.debounce(function(ev) {
                return T.Utils.onAjaxControllerTriggered(ev, true);
            }, 250)(ev);
        });
    });

    /*
  	$(document).on 'click allsynced', ':not(:input).js-trigger-ajax-request, button.js-trigger-ajax-request', (ev) ->
  		ev.preventDefault()
   */
    $(document).on('change allsynced', ':input:not(button).js-trigger-ajax-request', T.Utils.debounce(function(ev) {
        return T.Utils.onAjaxControllerTriggered(ev);
    }, 250));
    T.Utils.registerViewportQuery();

    /*
  	window event handler: onstorage
   */
    $(window).on('storage', T.Utils.onStorage);
}
)(jQuery);

/**
* Main file
 */
(function($) {
    T.Module.prototype.$ = function(selector) {
        return $(this._ctx).find(selector);
    }
    ;
    $(document).ready(function() {
        var application;
        if (!T.Utils.application) {
            T.Utils.setupPerformanceLogging();
            application = new T.Application($('body')[0]);
            application.registerModules();
            application.start();
            T.Utils.viewportEventsEnabled = true;
            T.Utils.application = application;
            T.Utils.startContentInitialization();
        }
    });
}
)(jQuery);

!function($) {
    T.Module.BackgroundImage = T.createModule({
        start: function(resolve) {
            var mod, src;
            return mod = this,
            this.$ctx = $(this._ctx),
            this.$template = this.$(".tpl-backgroundimage"),
            T.Utils.registerMq("lg", {
                match: function() {
                    return mod._events.on("backgroundimage:set", $.proxy(mod.onSetImage, mod))
                },
                unmatch: function() {
                    return mod._events.off("backgroundimage:set")
                }
            }),
            src = this.$ctx.data("src"),
            null != src && this.renderImage(src, !1),
            resolve()
        },
        renderImage: function(src, fadeable) {
            var $img, $newImage, $oldImage, template, tplCode;
            return tplCode = this.$template.html(),
            template = doT.template(tplCode),
            null != src ? ($newImage = $(template({
                fadeable: fadeable,
                src: src
            })).filter(".a-image"),
            this.swapImage($newImage)) : ($oldImage = this.$(".a-image"),
            $img = $oldImage.find("img"),
            $img.one("transitionend", function() {
                return $oldImage.remove()
            }),
            $img.removeClass("fade-in"))
        },
        swapImage: function($newImage) {
            var $img, $oldImage;
            return $oldImage = this.$(".a-image"),
            $newImage.appendTo(this.$ctx),
            $img = $newImage.find("img"),
            Modernizr.csstransitions && $img.hasClass("fadeable") ? $img.on("load", function() {
                if ($img.hasClass("lazyloading") || $img.hasClass("lazyloaded"))
                    return $img.one("transitionend", function() {
                        return $oldImage.remove()
                    }),
                    setTimeout(function() {
                        return $img.addClass("fade-in")
                    }, 10)
            }) : ($img.addClass("fade-in"),
            $oldImage.remove())
        },
        onSetImage: function(data) {
            return this.renderImage(data.src, !0)
        }
    })
}(jQuery),
function($) {
    T.Module.ErrorMessage = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$ctx.hide(),
            this.$ctx.slideDown(),
            resolve()
        }
    })
}(jQuery),
function($) {
    T.Module.FormLabel = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.Image = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$sources = this.$("[data-srcset]"),
            this.$img = this.$("img"),
            "none" === this.$img.css("display") && this.$img.removeClass("lazypreload"),
            this.$img.on("load", function(_this) {
                return function(ev) {
                    return _this.onLoadImage(ev)
                }
            }(this)),
            this.$sources.length || this.$img.attr("src", this.$img.data("src")).removeClass("lazyload"),
            this.imageSizes = this.$ctx.data("image-settings"),
            this.imageSizes && this.replaceImagePlaceholder(),
            resolve()
        },
        sync: function() {},
        onLoadImage: function(ev) {
            return this._events.emit("image:loaded", {
                $currentTarget: $(ev.currentTarget)
            })
        },
        replaceImagePlaceholder: function() {
            var realUrl, vp, vp_src;
            for (vp in this.imageSizes)
                realUrl = [],
                vp_src = this.$ctx.find(".js_" + vp),
                vp_src.length > 0 && ($.each(this.imageSizes[vp], function(index, imgset) {
                    var replace_url;
                    return replace_url = vp_src.data("srcset").replace("{width}", imgset.width).replace("{height}", imgset.height),
                    realUrl.push(replace_url + " " + imgset.resolution + "x")
                }),
                vp_src.attr("data-srcset", realUrl.join(",")));
            return this.$img.attr("class", "lazyload")
        }
    })
}(jQuery),
function($) {
    T.Module.LoadMore = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.elm = {
                $body: $("body"),
                $button: $("button", this.$ctx)
            },
            this.config = this.$ctx.data(),
            this.isActive = !1,
            this.closeLoader = $.proxy(this.closeLoader, this),
            this.openLoader = $.proxy(this.openLoader, this),
            this.onClickButton = $.proxy(this.onClickButton, this),
            this.elm.$button.on("click", $.proxy(this.onClickButton, this)),
            resolve()
        },
        sync: function() {},
        closeLoader: function() {
            if (this.isActive)
                return this._events.emit("loader:close", {
                    $trigger: this.elm.$button
                })
        },
        openLoader: function() {
            return this._events.emit("loader:open", {
                $trigger: this.elm.$button
            }),
            this.isActive = !0
        },
        onClickButton: function(ev) {}
    })
}(jQuery),
function($) {
    T.Module.Loader = T.createModule({
        start: function(resolve) {
            return this._events.on("loader:close", $.proxy(this.onCloseLoader, this)),
            this._events.on("loader:open", $.proxy(this.onOpenLoader, this)),
            this._events.on("loader:register", $.proxy(this.onRegisterLoader, this)),
            this._events.on("loader:reposition", $.proxy(this.onRepositionLoader, this)),
            this._events.emit("loader:register", {
                $ctx: $("body")
            }),
            $(window).on("resize", T.Utils.debounce($.proxy(this.onWindowResize, this), 50)),
            resolve()
        },
        sync: function() {},
        createLoader: function(conf) {
            var $loader, i, j, loaderMarkup, ref;
            for (loaderMarkup = doT.template(this.$(".tpl-loader").html())({
                area: "area" === conf.loaderType,
                layer: "layer" === conf.loaderType
            }),
            $loader = $(loaderMarkup),
            $loader.data("loader-configuration", conf),
            i = j = 0,
            ref = T.Utils.loader.cssElementAmount; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j)
                $loader.find(".loading-indicator").append('<span class="loader-el loader-el-' + i + '" />');
            return this.setPosition($loader),
            "inline" !== conf.loaderType ? $loader.appendTo("body") : conf.$trigger.find(".a-loader").length || $loader.appendTo(conf.$trigger),
            conf.$trigger.data("$loader", $loader),
            $loader
        },
        registerLoader: function($trigger) {
            var event, mod;
            return mod = this,
            event = $trigger.data("loader-event"),
            $trigger.on(event, function() {
                return mod._events.emit("loader:open", $.extend($(this).data(), {
                    $trigger: $trigger
                }))
            })
        },
        setPosition: function($loader) {
            var $area, conf;
            if (conf = $loader.data("loader-configuration"),
            "area" === conf.loaderType && ($area = $(conf.loaderArea),
            $loader.css({
                height: $area.outerHeight(),
                left: $area.offset().left,
                top: $area.offset().top,
                width: $area.outerWidth()
            }),
            "fixed" === $area.css("position")))
                return $loader.css({
                    position: "fixed"
                })
        },
        onCloseLoader: function(data) {
            var $loader, $trigger;
            return null != data.$trigger && data.$trigger.length && ($trigger = data.$trigger,
            $loader = $trigger.data("$loader"),
            $trigger.removeData("$loader")),
            null != data.$loader && data.$loader.length && ($loader = data.$loader),
            null != $loader && $loader.remove(),
            --T.Utils.loaderRequestCounter
        },
        onOpenLoader: function(conf) {
            var $loader;
            return $loader = this.createLoader(conf),
            ++T.Utils.loaderRequestCounter
        },
        onRegisterLoader: function(data) {
            var mod;
            return mod = this,
            data.$ctx.find("[data-loader]").each(function() {
                return mod.registerLoader($(this))
            })
        },
        onRepositionLoader: function(data) {
            return this.setPosition(data.$loader)
        },
        onWindowResize: function() {
            var mod;
            return mod = this,
            $(".a-loader.area").each(function() {
                return mod._events.emit("loader:reposition", {
                    $loader: $(this)
                })
            })
        }
    })
}(jQuery),
function($) {
    T.Module.MoreContentToggleLink = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            this.$ctx = $(this._ctx),
            this.isVisibleMobile = this.$ctx.data("is-visible-mobile"),
            this.isVisibleTablet = this.$ctx.data("is-visible-tablet"),
            this.isVisibleDesktop = this.$ctx.data("is-visible-desktop"),
            this.isVisibleViewPortDefined = this.isVisibleMobile || this.isVisibleTablet || this.isVisibleDesktop,
            this.isVisibleViewPortDefined && (this.isVisibleMobile = !!this.isVisibleMobile,
            this.isVisibleTablet = !!this.isVisibleTablet,
            this.isVisibleDesktop = !!this.isVisibleDesktop),
            this.$contentToggle = this.$(".js-content-toggle"),
            this.$contentLessToggle = this.$(".js-content-less-toggle"),
            this.$content = this.$(".content"),
            this.moreText = this.$contentToggle.data("more-text"),
            this.lessText = this.$contentToggle.data("less-text"),
            this.$toggleText = this.$contentToggle.find(".text"),
            this.$morelessbutton = this.$(".more-less-button, .js-more-less-button"),
            this.$ctx.on("click", ".js-content-toggle, .js-content-less-toggle", $.proxy(this.onClickContentToggle, this)),
            $(window).on("resize", T.Utils.debounce($.proxy(this.onResize, this), 50)),
            this._events.on("openMoreLessLink", $.proxy(this.onOpenMoreLessLink, this)),
            this.$content.on("transitionend", function() {
                return mod.sendRecalc(mod.$content)
            }),
            this.onResize(),
            resolve()
        },
        sync: function() {},
        activate: function() {
            if (this.$contentToggle.removeClass("hidden"),
            this.$contentLessToggle.removeClass("hidden"),
            this.$morelessbutton.removeClass("hidden"),
            this.$content.hasClass("is-open"))
                return this.$contentToggle.addClass("is-open"),
                this.$contentLessToggle.addClass("is-open")
        },
        closeContent: function() {
            var mod;
            return mod = this,
            Modernizr.csstransitions ? (this.$content.addClass("is-in-transition"),
            this.setContentHeight(),
            this.$content.off("transitionend").one("transitionend", function() {
                return mod.$content.removeClass("is-in-transition").css("max-height", "")
            }),
            this.$content.removeClass("is-open"),
            setTimeout(function() {
                return mod.$content.css("max-height", "0")
            }, 10)) : this.$content.removeClass("is-open"),
            this.$toggleText.text(this.moreText),
            this.sendRecalc(this.$content)
        },
        deactivate: function() {
            return this.$contentToggle.addClass("hidden"),
            this.$contentLessToggle.addClass("hidden"),
            this.$morelessbutton.addClass("hidden"),
            this.$content.addClass("is-open").css("max-height", "")
        },
        openContent: function() {
            var mod;
            return mod = this,
            Modernizr.csstransitions ? (this.$content.off("transitionend").one("transitionend", function() {
                return mod.$content.removeClass("is-in-transition").addClass("is-open").css("max-height", "")
            }).addClass("is-in-transition"),
            this.setContentHeight()) : (this.setContentHeight(),
            this.$content.addClass("is-open").css("max-height", "")),
            this.$toggleText.text(this.lessText),
            this.sendRecalc(this.$content)
        },
        sendRecalc: function($element) {
            return this._events.emit("recalc", {
                $element: $element,
                $ctx: this.$ctx
            })
        },
        setContentHeight: function() {
            var mod;
            return mod = this,
            this.$content.css("max-height", this.$content[0].scrollHeight),
            this.sendRecalc(this.$content)
        },
        toggleContent: function() {
            return this.$contentToggle.hasClass("is-open") ? this.closeContent() : this.openContent(),
            this.$contentToggle.toggleClass("is-open")
        },
        onClickContentToggle: function(ev) {
            return this.toggleContent(),
            ev.preventDefault()
        },
        onOpenMoreLessLink: function(data) {
            var mod;
            mod = this,
            mod.$ctx.closest("[data-t-id='" + data.parentId + "']").length && !mod.$contentToggle.hasClass("is-open") && mod.toggleContent()
        },
        onResize: function() {
            if (this.activate(),
            this.isVisibleViewPortDefined)
                switch (T.Utils.getViewport()) {
                case "mobile":
                    if (!this.isVisibleMobile)
                        return this.deactivate();
                    break;
                case "tablet":
                    if (!this.isVisibleTablet)
                        return this.deactivate();
                    break;
                case "desktop":
                    if (!this.isVisibleDesktop)
                        return this.deactivate()
                }
        }
    })
}(jQuery),
function($) {
    T.Module.Pinit = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            this.$ctx = $(this._ctx),
            this.$ctx.on("click", $.proxy(mod.onClickShare, mod)),
            resolve()
        },
        sync: function() {},
        onClickShare: function(ev) {
            var imageUrl, sharer;
            return ev.preventDefault(),
            sharer = $(ev.currentTarget).attr("href"),
            imageUrl = this.getActiveImage(),
            window.open(sharer + "http://google.com&media=" + imageUrl, "sharer", this.getWindowParameters())
        },
        getWindowParameters: function() {
            var conf, i, openConf;
            conf = T.Utils.shareWindow,
            openConf = [];
            for (i in conf)
                conf.hasOwnProperty(i) && openConf.push(i + "=" + conf[i]);
            return openConf.join(",")
        },
        getActiveImage: function() {
            var imageUrl;
            return imageUrl = $(".slick-current").find("source").attr("srcset")
        }
    })
}(jQuery),
function($) {
    T.Module.Rating = T.createModule({
        start: function(resolve) {
            var $score, $scorePos, $scorePosClone, scoreRel, scoreVal;
            return $score = this.$("[data-score]"),
            scoreVal = parseFloat($score.data("score")),
            scoreVal > 0 && (scoreRel = parseInt(scoreVal.toFixed(2).substring(2)),
            $score.children().slice(0, Math.floor(scoreVal)).addClass("is-active"),
            scoreRel > 0 && ($scorePos = $score.children().eq(Math.floor(scoreVal) - 1),
            $scorePosClone = $scorePos.clone(),
            setTimeout(function() {
                var $rel, width;
                return width = $score.children().eq(0).width(),
                $rel = $scorePosClone.addClass("is-active-partly").css("width", Math.round(scoreRel / 100 * width) + "px"),
                $scorePos.after(" ").after($rel).after(" ")
            }, 100))),
            resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.SelectedFilter = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.name = this.$ctx.data("input-name"),
            this.value = this.$ctx.data("input-value"),
            this.type = this.$ctx.data("input-type"),
            this.deselectable = this.$ctx.data("input-deselectable"),
            this.targeturl = this.$ctx.data("input-targeturl"),
            this.$ctx.on("click", function(_this) {
                return function(e) {
                    return _this.onClick(e)
                }
            }(this)),
            resolve()
        },
        sync: function() {},
        onClick: function(e) {
            return null == this.deselectable && null == this.targeturl || this.deselectable === !0 && ("" === this.targeturl || null == this.targeturl) ? (this.value = this.$ctx.is(":first-child") ? "" : this.$ctx.prev().data("input-value"),
            this._events.emit("selectedfilter:clicked", {
                name: this.name,
                value: this.value,
                valueType: this.valuetype,
                type: this.type,
                resetValue: !0
            })) : this.deselectable === !0 && "" !== this.targeturl ? location.href = this.targeturl : void 0
        },
        onReset: function() {
            return !0
        }
    })
}(jQuery),
function($) {
    T.Module.Text2col = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$initText = $([]),
            this.$(".lazyload").addClass("lazypreload"),
            this._events.on("recalc.tab", $.proxy(this.onRecalc, this)),
            this._events.on("t.sync", $.proxy(this.sync, this)),
            this.isSynced = !1,
            resolve()
        },
        sync: function() {
            var mod;
            this.isSynced || (mod = this,
            this.isSynced = !0,
            this.$text = this.$(".columnize"),
            T.Utils.registerMq("lg", {
                match: function() {
                    return mod.doColumnize()
                },
                unmatch: function() {
                    return mod.unColumnize()
                }
            }))
        },
        doColumnize: function() {
            var $images, mod;
            return mod = this,
            this.$(".lazyload, .lazyloading").length < 1 ? ($images = mod.$ctx.find("img"),
            $images.each(function(i, img) {
                var $img;
                return $img = $(img),
                $img.css({
                    height: $img.height(),
                    width: $img.width()
                })
            }),
            this.$text = this.$(".columnize"),
            this.$initText = this.$text.clone(!0, !0),
            this.$text.columnize({
                columns: 2
            }),
            $images.each(function(i, img) {
                var $img;
                return $img = $(img),
                $img.css({
                    height: "",
                    width: ""
                })
            })) : setTimeout(function() {
                return mod.doColumnize()
            }, 200)
        },
        unColumnize: function() {
            return this.$text = this.$(".columnize").replaceWith(this.$initText),
            this.$initText = $([])
        },
        onRecalc: function(data) {
            if ($(data.$element).find(".columnize").length > 0)
                return this.unColumnize(),
                this.doColumnize()
        }
    })
}(jQuery),
function($) {
    T.Module.ToTop = T.createModule({
        start: function(resolve) {
            return $(this._ctx).on("click", "", $.proxy(this.onClick, this)),
            resolve()
        },
        onClick: function(ev) {
            return T.Utils.scrollToTop(),
            ev.preventDefault()
        }
    })
}(jQuery),
function($) {
    T.Module.Tooltip = T.createModule({
        start: function(resolve) {
            return this._events.on("tooltip:open", $.proxy(this.onOpenTooltip, this)),
            this._events.on("tooltip:close", $.proxy(this.onCloseTooltip, this)),
            resolve()
        },
        sync: function() {},
        correctPosition: function($tooltip) {
            var offscreen, overlap;
            switch (overlap = T.Utils.getOverlapDirection($tooltip),
            offscreen = T.Utils.getOffScreenDirection($tooltip),
            "none" === overlap && "none" !== offscreen && (overlap = offscreen),
            overlap) {
            case "top":
            case "left":
            case "right":
                return $tooltip.data("position-correct", "bottom"),
                this.positionTooltip($tooltip)
            }
        },
        createTooltip: function($trigger) {
            var $tooltip, position, tooltipMarkup;
            return position = $trigger.data("tooltip-position") || "top",
            tooltipMarkup = doT.template(this.$(".tpl-tooltip").html())({
                text: $trigger.attr("title"),
                position: position
            }),
            $tooltip = $(tooltipMarkup),
            $tooltip.appendTo("body"),
            $trigger.data("$tooltip", $tooltip),
            $tooltip.data("$trigger", $trigger),
            $tooltip
        },
        hideTooltip: function($tooltip) {
            return $tooltip.removeClass("is-active")
        },
        positionTooltip: function($tooltip) {
            var $trigger, baseX, baseY, left, position, top, triggerOffset;
            switch ($trigger = $tooltip.data("$trigger"),
            triggerOffset = $trigger.offset(),
            $tooltip.removeClass("tooltip-bottom tooltip-left tooltip-right tooltip-top"),
            position = $tooltip.data("position-correct") || $trigger.data("tooltip-position") || "top",
            baseX = triggerOffset.left,
            baseY = triggerOffset.top,
            position) {
            case "bottom":
                $tooltip.addClass("tooltip-bottom"),
                left = baseX + $trigger.outerWidth() / 2 - $tooltip.outerWidth(!0) / 2,
                top = baseY + $trigger.outerHeight();
                break;
            case "left":
                $tooltip.addClass("tooltip-left"),
                left = baseX - $tooltip.outerWidth(!0),
                top = baseY + $trigger.outerHeight() / 2 - $tooltip.outerHeight(!0) / 2;
                break;
            case "right":
                $tooltip.addClass("tooltip-right"),
                left = baseX + $trigger.outerWidth(),
                top = baseY + $trigger.outerHeight() / 2 - $tooltip.outerHeight(!0) / 2;
                break;
            case "top":
                $tooltip.addClass("tooltip-top"),
                left = baseX + $trigger.outerWidth() / 2 - $tooltip.outerWidth(!0) / 2,
                top = baseY - $tooltip.outerHeight(!0)
            }
            return $tooltip.css({
                left: left,
                top: top
            }),
            this.correctPosition($tooltip)
        },
        showTooltip: function($tooltip) {
            return $tooltip.addClass("is-active")
        },
        onCloseTooltip: function(data) {
            var $tooltip, $trigger;
            if ($trigger = data.$trigger,
            $tooltip = $trigger.data("$tooltip"),
            $tooltip && $tooltip.length)
                return $tooltip.one("transitionend", function() {
                    return $tooltip.remove()
                }),
                this.hideTooltip($tooltip),
                $trigger.removeData("$tooltip"),
                $trigger.attr("title", $trigger.data("title")).removeData("title"),
                $(window).off("orientationchange.tooltip resize.tooltip")
        },
        onOpenTooltip: function(data) {
            var $tooltip, $trigger;
            if ($trigger = data.$trigger,
            $trigger.length)
                return $tooltip = this.createTooltip($trigger),
                this.positionTooltip($tooltip),
                this.showTooltip($tooltip),
                $trigger.data("title", $trigger.attr("title")).removeAttr("title"),
                $(window).on("orientationchange.tooltip resize.tooltip", $.proxy(this.onWindowResize, this))
        },
        onWindowResize: function() {
            var mod;
            return mod = this,
            $(".a-tooltip").each(function() {
                return mod.positionTooltip($(this))
            })
        }
    })
}(jQuery),
function($) {
    T.Module.AddToCartPopover = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.Breadcrumb = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.$bcItems = mod.$ctx.find("li"),
            mod.$mobileToggle = mod.$ctx.find(".js-mobile-toggle"),
            T.Utils.registerMq("md", {
                match: function() {
                    return mod.$mobileToggle.on("click.mobile", $.proxy(mod.onClickMobileToggle, mod))
                },
                unmatch: function() {
                    return mod.$mobileToggle.off("click.mobile")
                }
            }, "max"),
            resolve()
        },
        sync: function() {},
        onClickMobileToggle: function(ev) {
            return this.$bcItems.not(":last").toggleClass("is-hidden-mobile"),
            this.$mobileToggle.toggleClass("is-active-mobile")
        }
    })
}(jQuery),
function($) {
    T.Module.Carousel = T.createModule({
        slickConfiguration: {
            lazyLoad: "ondemand"
        },
        start: function(resolve) {
            var config;
            return this.$ctx = $(this._ctx),
            this.id = this.$ctx.data("t-id"),
            config = T.Utils.carousel,
            this.slidesToShow = {
                mobile: config.slidesToShow.mobile,
                tablet: config.slidesToShow.tablet,
                desktop: config.slidesToShow.desktop
            },
            this.slidesToScroll = {
                mobile: config.slidesToScroll.mobile,
                tablet: config.slidesToScroll.tablet,
                desktop: config.slidesToScroll.desktop
            },
            this.slickexists = !1,
            this.countSlidesPerPage = 4,
            this.countSlideSets = 1,
            this.currentSlideSet = 1,
            this.initialSlide = 0,
            this.$slider = this.$(".slick-slider"),
            this.$carouselControls = this.$(".js-carousel-controls"),
            this.$paginationArrows = this.$(".js-carousel-paginationarrows"),
            this.$pagationText = this.$(".js-paginationnumber"),
            this.isSynced = !1,
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            this._events.on("recalc", function(_this) {
                return function(data) {
                    if (_this.$ctx.closest(data.$element).length && _this.slickexists)
                        return _this.$slider.slick("setPosition")
                }
            }(this)),
            this._events.on("viewportChanged", function(_this) {
                return function(viewport) {
                    return _this.onViewportChanged(viewport)
                }
            }(this)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.setCarouselControls(),
            this.matchTeaserHeights(),
            this.refreshCarousel(),
            this.isSynced = !0,
            T.Utils.allSynced = !0)
        },
        updateSlideHeight: function($slide) {
            if (this.slickexists)
                return $slide.height("auto")
        },
        initSlick: function() {
            if (this.destroySlider(),
            this.slidesJustifyCarousel())
                return T.Utils.isRTL() && this.$slider.attr("dir", "rtl"),
                this.$slider.slick($.extend(this.slickConfiguration, {
                    appendArrows: this.$paginationArrows,
                    arrows: !0,
                    autoplay: !1,
                    centerPadding: "0px",
                    centerMode: !1,
                    dots: !1,
                    fade: !1,
                    useCSS: !0,
                    cssEase: "linear",
                    initialSlide: this.initialSlide,
                    nextArrow: this.$(".next"),
                    prevArrow: this.$(".prev"),
                    slide: ".slide",
                    slidesToShow: this.slidesToShow.desktop,
                    slidesToScroll: this.slidesToScroll.desktop,
                    speed: 300,
                    rtl: T.Utils.isRTL(),
                    responsive: [{
                        breakpoint: parseInt(T.Utils.breakpoints.lg),
                        settings: {
                            slidesToShow: this.slidesToShow.tablet,
                            slidesToScroll: this.slidesToScroll.tablet
                        }
                    }, {
                        breakpoint: parseInt(T.Utils.breakpoints.md),
                        settings: {
                            slidesToShow: this.slidesToShow.mobile,
                            slidesToScroll: this.slidesToScroll.mobile
                        }
                    }]
                })),
                this.slickexists = !0,
                this.$slider.on("setPosition", function(_this) {
                    return function() {
                        return _this.setCarouselControls()
                    }
                }(this))
        },
        destroySlider: function() {
            if (this.slickexists)
                return this.$slider.off("setPosition"),
                this.$slider.slick("unslick"),
                this.slickexists = !1
        },
        onViewportChanged: function(viewport) {
            return this.refreshCarousel()
        },
        refreshCarousel: function() {
            return this.countSlidesPerPage = this.slidesToShow[T.Utils.getViewport()],
            this.countSlides(),
            this.initSlick(),
            this.setCarouselControls()
        },
        setCarouselControls: function() {
            var currentSlide;
            return this.slickexists ? (currentSlide = this.$slider.find(".slick-current").data("slick-index"),
            this.currentSlideSet = Math.floor(currentSlide / this.countSlidesPerPage) + 1) : this.currentSlideSet = 1,
            1 === this.countSlideSets ? this.$carouselControls.addClass("hidden") : (this.$carouselControls.removeClass("hidden"),
            this.$pagationText.html(this.currentSlideSet + "/" + this.countSlideSets))
        },
        matchTeaserHeights: function() {
            if (T.Utils.isViewport("desktop") || T.Utils.isViewport("tablet"))
                return T.Utils.debounce(this.$ctx.find(".m-teaser .a-heading").matchHeight(), 50),
                T.Utils.debounce(this.$ctx.find(".m-teaser .content-inner").matchHeight(), 50),
                T.Utils.debounce(this.$ctx.find(".m-teaser .teaser-content").matchHeight(), 50)
        },
        slidesJustifyCarousel: function() {
            return this.totalNumberOfSlides() > this.slidesToShow[T.Utils.getViewport()]
        },
        totalNumberOfSlides: function() {
            return this.$ctx.find(".slide:not(.slick-cloned)").length
        },
        countSlides: function() {
            return 0 === this.countSlidesPerPage ? this.countSlideSets = this.countSlidesPerPage = 1 : this.countSlideSets = Math.floor((this.totalNumberOfSlides() - 1) / this.countSlidesPerPage) + 1
        },
        replaceSlides: function(slides) {
            var oldPosition;
            if (oldPosition = -1,
            this.slickexists && (oldPosition = this.$slider.slick("slickCurrentSlide")),
            this.destroySlider(),
            this.$slider.find(".slide").remove(),
            Array.isArray(slides) ? $.each(slides, function(_this) {
                return function(index, element) {
                    return _this.$slider.append(element)
                }
            }(this)) : this.$slider.append(slides),
            this.$slider.find(".slide").each(function(index, element) {
                return T.Utils.application._sandbox.addModules(element)
            }),
            this.refreshCarousel(),
            oldPosition > -1)
                return this.$slider.slick("slickGoTo", oldPosition, !1)
        }
    })
}(jQuery),
function($) {
    T.Module.CheckoutDeliveryBillingAddress = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.CheckoutDeliveryService = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.CheckoutDeliveryShippingAddress = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.CompareHeader = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.offsetMarkerSelector = ".js-mark-offset",
            mod.markerOffsetTop = 0,
            mod.isStickyPrevious = !1,
            mod.$window = $(window),
            mod.stickyPartSelector = ".js-toggle-sticky",
            mod.unstickyPartSelector = ".js-toggle-unsticky",
            mod.stickyIsActiveClass = "is-active",
            mod.$sticky,
            mod.$unsticky,
            mod.initSkuComparison(),
            mod.matchHeightSelector = ".js-compare-col-height",
            mod.matchHeightTitleSelector = ".js-stickyitem-title-height",
            mod.isSynced = !1,
            mod._events.on("t.sync", $.proxy(mod.sync, mod)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.setupCompareHeader(),
            this.isSynced = !0)
        },
        initSkuComparison: function() {
            var localStorageKey, mod, strSkuInComparison;
            return mod = this,
            localStorageKey = mod.$ctx.attr("data-key"),
            strSkuInComparison = mod.$ctx.attr("data-skuincomparison"),
            T.Utils.localStorageSetItem(localStorageKey, strSkuInComparison)
        },
        setHeaderHeight: function() {
            var $cols, mod;
            return mod = this,
            $cols = mod.$ctx.find(mod.matchHeightSelector),
            $cols.matchHeight(),
            mod.markerOffsetTop = mod.$offsetMarker.offset().top
        },
        setStickyItemHeight: function() {
            var $titles, mod;
            return mod = this,
            $titles = mod.$sticky.find(mod.matchHeightTitleSelector),
            $titles.matchHeight()
        },
        setStickyWidth: function() {
            var mod, widthForFixedPositionTarget;
            return mod = this,
            widthForFixedPositionTarget = mod.$ctx.width(),
            mod.$sticky.width(widthForFixedPositionTarget)
        },
        setupCompareHeader: function() {
            var mod;
            return mod = this,
            mod.$offsetMarker = mod.$ctx.find(mod.offsetMarkerSelector),
            mod.$sticky = mod.$ctx.find(mod.stickyPartSelector),
            mod.$unsticky = mod.$ctx.find(mod.unstickyPartSelector),
            mod.setStickyWidth(),
            mod.setStickyItemHeight(),
            mod.setHeaderHeight(),
            mod.$window.off("scroll.sticky.compare"),
            mod.$window.on("scroll.sticky.compare", $.proxy(mod.onWindowScroll, mod))
        },
        onWindowScroll: function(ev) {
            var isSticky, mod, scrollTop;
            if (mod = this,
            scrollTop = mod.$window.scrollTop(),
            ev.stopImmediatePropagation(),
            isSticky = scrollTop >= mod.markerOffsetTop,
            isSticky !== mod.isStickyPrevious)
                return mod.isStickyPrevious = isSticky,
                isSticky ? (mod.$unsticky.removeClass(mod.stickyIsActiveClass),
                mod.$sticky.addClass(mod.stickyIsActiveClass)) : (mod.$sticky.removeClass(mod.stickyIsActiveClass),
                mod.$unsticky.addClass(mod.stickyIsActiveClass))
        }
    })
}(jQuery),
function($) {
    T.Module.CompareItem = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.emptyColSelector = ".js-empty-col",
            mod.toggleDifferencesSelector = ".js-compareview-toggle-differences",
            mod.basketBtnSelector = ".js-add-to-basket",
            mod.hiddenClass = "hidden",
            mod.$emptyCol = mod.$ctx.filter(mod.emptyColSelector),
            mod.$emptyCol.on("click", $.proxy(mod.onClickEmptyCol, mod)),
            mod.$toggleDifferences = mod.$ctx.find(mod.toggleDifferencesSelector),
            mod.$toggleDifferences.on("click", $.proxy(mod.onClickToggleDifferences, mod)),
            mod.$addToBasketButton = mod.$ctx.find(mod.basketBtnSelector),
            mod.$addToBasketButton.on("click", $.proxy(mod.onClickAddToCartButton, mod)),
            mod._events.on("compareitem:toggleCompareDifferences", $.proxy(mod.onToggleDifferences, mod)),
            resolve()
        },
        sync: function() {},
        onClickAddToCartButton: function(ev) {
            var $ajaxform, config, mod, request;
            return mod = this,
            ev.preventDefault(),
            $ajaxform = $(ev.currentTarget).closest(".js-ajax-request"),
            config = $ajaxform.data(),
            request = T.Utils.startAjaxRequest(config.ajaxId),
            !!request && request[0].done(function(result) {
                if (mod._events.emit("popover:open", mod.$addToBasketButton),
                mod._events.emit("cart:update"),
                config.promotionUpdate && T.Utils.startAjaxRequest(!1, {
                    url: config.promotionUpdate + "/" + $ajaxform.find("[name=productCode]").val(),
                    dataType: "html",
                    dataRendering: !0
                }),
                config.cartUpdate)
                    return T.Utils.startAjaxRequest(!1, {
                        url: config.cartUpdate,
                        dataType: "html",
                        dataRendering: !0
                    })
            })
        },
        onClickEmptyCol: function(ev) {
            var $target, mod;
            return mod = this,
            ev.preventDefault(),
            $target = mod.$ctx.find(".m-compareadditem"),
            mod._events.emit("compareitem:clickEmptyColumn", $target)
        },
        onClickToggleDifferences: function(ev) {
            var blnShowOnlyDifferences, mod;
            return mod = this,
            ev.preventDefault(),
            blnShowOnlyDifferences = !!$(ev.target).attr("data-toggle"),
            mod._events.emit("compareitem:toggleCompareDifferences", blnShowOnlyDifferences)
        },
        onToggleDifferences: function(blnShowOnlyDifferences) {
            var $targetAll, $targetOnlyDifferences, mod;
            return mod = this,
            $targetAll = mod.$toggleDifferences.find("span:not([data-toggle=true])"),
            $targetOnlyDifferences = mod.$toggleDifferences.find("[data-toggle=true]"),
            $targetOnlyDifferences.toggleClass(mod.hiddenClass, blnShowOnlyDifferences),
            $targetAll.toggleClass(mod.hiddenClass, !blnShowOnlyDifferences)
        }
    })
}(jQuery),
function($) {
    T.Module.ContentText2Col = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.ContentTextMedia = T.createModule({
        start: function(resolve) {
            var $layer, $video;
            return this.$ctx = $(this._ctx),
            this.config = this.$ctx.data(),
            this.$media = this.$(".media"),
            this.$content = this.$(".content"),
            this.$contentInner = this.$(".content-inner"),
            this.$heading = this.$(".heading"),
            this.isVP2Special = !1,
            this.initialAlign = "left",
            this.imageLoaded = !1,
            this.videoLoaded = !1,
            this.$moreLess = this.$(".js-moreless"),
            this.$moreLessReference = this.$("[data-moreless-reference-id]"),
            null != this.config.headingVp2Special && (this.isVP2Special = !!this.config.headingVp2Special),
            "right" === this.config.mediaFloat && (this.initialAlign = "right"),
            this.stateClassMediaHidden = "hidden",
            T.Utils.isViewport("mobile") || this.positionElements(),
            this.hasMedia = this.$media.length > 0,
            this.$mediaImage = this.$media.find("img"),
            this.hasImage = this.$mediaImage.length > 0,
            $video = this.$ctx.find(".m-video-cliplister"),
            this.hasVideo = $video.length > 0,
            this.hasVideo && (this.mediaVideoId = $video.data("video-id")),
            (this.hasImage || this.hasVideo) && (this.$moreLess.attr("data-external-resize-control", !0),
            $(window).on("resize", T.Utils.debounce(function(_this) {
                return function() {
                    return _this.recalculateMoreLess()
                }
            }(this), 50)),
            this.hasVideo ? this._events.on("video:loaded", function(_this) {
                return function(data) {
                    return _this.onLoadVideo(data)
                }
            }(this)) : this._events.on("image:loaded", function(_this) {
                return function(data) {
                    return _this.onLoadMedia(data)
                }
            }(this))),
            $layer = this.$ctx.find(".media .media-inner > .m-layer"),
            $layer.length > 0 && $layer.appendTo($("body")),
            this._events.on("viewportChanged", function(_this) {
                return function(viewport) {
                    return _this.onViewportChange(viewport)
                }
            }(this)),
            this._events.on("contentextmedia:reset-align", function(_this) {
                return function() {
                    return _this.onResetAlign()
                }
            }(this)),
            this._events.on("contenttextmedia:video-prechecked", function(_this) {
                return function(data) {
                    return _this.onVideoPrechecked(data)
                }
            }(this)),
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            this.initializedStatePublished = !1,
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            T.Utils.allSynced = !0,
            this.needMoreLessSync ? this.recalculateMoreLess() : this.hasImage || this.hasVideo || this.initialized())
        },
        closeMoreLess: function(notransition) {
            var ref;
            if (this.isMoreLessOpen())
                return this.fetchMoreLessComponent(),
                null != (ref = this.moreLessComponent) ? ref.close(!1) : void 0
        },
        isMoreLessOpen: function() {
            var ref;
            return this.fetchMoreLessComponent(),
            null != (ref = this.moreLessComponent) ? ref.isOpen() : void 0
        },
        isImageLoaded: function() {
            return 0 === this.media.length || this.imageLoaded
        },
        setAlign: function(align) {
            var targetAlign;
            if (targetAlign = align || this.initialAlign,
            this.config.mediaFloat = targetAlign,
            !T.Utils.isViewport("mobile"))
                return this.resetElements(),
                this.positionElements()
        },
        matchHeights: function() {
            if (this.isVP2Special)
                return "tablet" === T.Utils.getViewport() ? this.$heading.add(this.$media).matchHeight() : this.$heading.add(this.$media).matchHeight({
                    remove: !0
                })
        },
        positionElements: function() {
            return "right" === this.config.mediaFloat && this.$media.prev().is(this.$content) === !1 && this.$media.insertAfter(this.$content),
            this.isVP2Special && ("tablet" === T.Utils.getViewport() ? ("right" === this.config.mediaFloat ? this.$heading.insertBefore(this.$media) : this.$heading.insertAfter(this.$media),
            this.$heading.addClass("heading-special"),
            this.$content.appendTo(this.$ctx)) : this.$heading.removeClass("heading-special").prependTo(this.$contentInner)),
            this.matchHeights()
        },
        resetElements: function() {
            if (this.config.headingAbove ? this.$heading.prependTo(this.$ctx) : this.$heading.prependTo(this.$content),
            this.$media.next().is(this.$content) === !1)
                return this.$media.insertBefore(this.$content)
        },
        recalculateMoreLess: function() {
            if (this.fetchMoreLessComponent(),
            null != this.moreLessComponent)
                return this.moreLessComponent.isInitialized() ? (this.moreLessComponent.setReference(this.$moreLessReference),
                this.moreLessComponent.calculate(),
                this.needMoreLessSync = !1,
                this.initialized()) : this.needMoreLessSync = !0
        },
        fetchMoreLessComponent: function() {
            var tId;
            if (!this.moreLessComponent && (tId = this.$moreLess.data("t-id"),
            null != tId))
                return this.moreLessComponent = this._sandbox.getModuleById(tId)
        },
        initialized: function() {
            if (!this.initializedStatePublished)
                return this._events.emit("contenttextmedia:initialized", {
                    $component: this.$ctx,
                    component: this
                }),
                this.initializedStatePublished = !0
        },
        onLoadMedia: function(data) {
            if (this.$mediaImage.is(data.$currentTarget))
                return this.imageLoaded = !0,
                this.matchHeights(),
                this.recalculateMoreLess()
        },
        onLoadVideo: function(data) {
            if (data.$component.closest(this.$ctx).length > 0)
                return this.videoLoaded = !0,
                this.matchHeights(),
                this.recalculateMoreLess()
        },
        onResetAlign: function() {
            return this.setAlign(this.initialAlign)
        },
        onVideoPrechecked: function(data) {
            if (this.mediaVideoId === data.videoId)
                return this.$media.removeClass(this.stateClassMediaHidden)
        },
        onViewportChange: function(viewport) {
            return "mobile" === viewport ? this.resetElements() : this.positionElements()
        }
    })
}(jQuery),
function($) {
    T.Module.ContentTextMediaBig = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.ContentTextMediaSlider = T.createModule({
        start: function(resolve) {
            var i, len, ref, slide;
            for (this.$ctx = $(this._ctx),
            this.$carousel = this.$(".m-teaserslider"),
            this.contentTextMedias = [],
            this.mediaFloat = this.$ctx.data("media-float"),
            T.Utils.allSynced = !1,
            this._events.on("carouselSliderSlideBeforeChange", function(_this) {
                return function(data) {
                    return _this.onCarouselSliderSlideBeforeChange(data)
                }
            }(this)),
            this._events.on("contenttextmedia:initialized", function(_this) {
                return function(data) {
                    return _this.onContentTextMediaInitialized(data)
                }
            }(this)),
            ref = this.$ctx.find(".slide"),
            i = 0,
            len = ref.length; i < len; i++)
                slide = ref[i],
                $(slide).attr("data-initialized", !1);
            return this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            T.Utils.allSynced = !0,
            this.carousel = this._sandbox.getModuleById(this.$carousel.data("t-id")),
            this.$ctx.find(".m-contenttextmedia").each(function(_this) {
                return function(index, element) {
                    var contentTextMedia;
                    if (contentTextMedia = _this._sandbox.getModuleById($(element).data("t-id")),
                    _this.contentTextMedias.push(contentTextMedia),
                    null != _this.mediaFloat)
                        return contentTextMedia.setAlign(_this.mediaFloat)
                }
            }(this)))
        },
        setAlign: function(align) {
            if (this.mediaFloat = align,
            this.isSynced)
                return this.contentTextMedias.forEach(function(element) {
                    return element.setAlign(align)
                })
        },
        onCarouselSliderSlideBeforeChange: function(data) {
            var contentTextMedia, jContentTextMedia;
            if (data.$slide.closest(this.$ctx).length > 0 && (jContentTextMedia = data.$slide.children(".m-contenttextmedia"),
            jContentTextMedia.length > 0))
                return contentTextMedia = this._sandbox.getModuleById(jContentTextMedia.data("t-id")),
                contentTextMedia.closeMoreLess(!0)
        },
        onContentTextMediaInitialized: function(data) {
            var carouselComponent, carouselId;
            if (data.$component.closest(this.$ctx).length > 0 && (data.$component.closest(".slide").attr("data-initialized", !0),
            0 === this.$ctx.find(".slide:not([data-initialized=true])").length && (carouselId = this.$carousel.data("t-id"),
            null != carouselId)))
                return carouselComponent = this._sandbox.getModuleById(carouselId),
                null != carouselComponent ? carouselComponent.instantiateSlider() : void 0
        }
    })
}(jQuery),
function($) {
    T.Module.ConversionBar = T.createModule({
        start: function(resolve) {
            var $ctx, mod;
            return mod = this,
            $ctx = $(mod._ctx),
            mod.isSynced = !1,
            mod.elm = {
                $searchButton: $(".js-search", $ctx),
                $cartAmount: $('[data-replace-container="ajax-002-cart"]', $ctx),
                $shopatron: $(".js-shopatron", $ctx)
            },
            this.elm.$searchButton.on("click", $.proxy(this.onClickSearchButton, this)),
            this._events.on("t.sync", $.proxy(this.sync, this)),
            this._events.on("checkSearchState", $.proxy(this.onCheckSearchState, this)),
            this._events.on("closeSearchByNav", $.proxy(this.onCloseSearchByNav, this)),
            this._events.on("toggleSearchForm", $.proxy(this.onToggleSearchForm, this)),
            this._events.on("cart:update", $.proxy(this.onCartUpdate, this)),
            this._events.on("cart:message", $.proxy(this.onCartMessage, this)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            this.getShopatronSessionId())
        },
        getShopatronSessionId: function() {
            var config, mod, request, sessionId;
            if (mod = this,
            mod.elm.$shopatron.length > 0) {
                if (sessionId = T.Utils.cookieHandling("shopatronsessionid", "get"),
                !sessionId)
                    return config = {
                        path: "/",
                        domain: location.hostname.replace(/([^\.]+)/, "")
                    },
                    T.Utils.cookieHandling("shopatronsessionid=_", "set", config),
                    request = T.Utils.startAjaxRequest("ajax-get-shopatron-session-id"),
                    !!request && request[0].done(function(result) {
                        return T.Utils.cookieHandling("shopatronsessionid=" + result, "set", config),
                        mod.updateShopatronCartUrl(),
                        mod.updateShopatronCartQuantity()
                    }).fail(function(xhr, ajaxOptions, thrownError) {
                        return T.Utils.cookieHandling("shopatronsessionid=", "set", config),
                        console.log("getShopatronSessionId failed")
                    });
                if ("_" !== sessionId)
                    return mod.updateShopatronCartUrl(),
                    mod.updateShopatronCartQuantity()
            }
        },
        updateShopatronCartQuantity: function() {
            var mod, request, sessionId;
            if (mod = this,
            sessionId = T.Utils.cookieHandling("shopatronsessionid", "get"))
                return request = T.Utils.startAjaxRequest("ajax-get-shopatron-cart-quantity", null, {
                    cart_id: sessionId
                }),
                !!request && request[0].done(function(result) {
                    return mod.elm.$cartAmount.html(result)
                }).fail(function(xhr, ajaxOptions, thrownError) {
                    return console.log("getShopatronCartQuantity failed")
                })
        },
        updateShopatronCartUrl: function() {
            var sessionId;
            if (sessionId = T.Utils.cookieHandling("shopatronsessionid", "get"))
                return $('a[data-replace-container="shoppingcart_link"]').each(function() {
                    var href, queryDelim;
                    if (href = $(this).attr("href"),
                    !(href.indexOf("&rp=") > 0 || href.indexOf("?rp=") > 0))
                        return queryDelim = href.indexOf("?") > 0 ? "&" : "?",
                        href += queryDelim + "rp=" + encodeURIComponent(window.location.pathname),
                        0 !== $(".js-shopatron-add-sessionid").length && (href += "&PHPSESSID=" + sessionId),
                        $(this).attr("href", href)
                })
        },
        sendSearchState: function() {
            return this._events.emit("toggleSearchForm", {
                isSearchActive: this.elm.$searchButton.hasClass("is-active")
            })
        },
        onClickSearchButton: function(ev) {
            return this.elm.$searchButton.toggleClass("is-active"),
            this._events.emit("closeMobileNav.header", this.elm.$searchButton),
            this.sendSearchState(),
            ev.preventDefault()
        },
        onCloseSearchByNav: function() {
            return this.elm.$searchButton.removeClass("is-active"),
            this._events.emit("closeSearchForm.header")
        },
        onCheckSearchState: function() {
            return this.sendSearchState()
        },
        onToggleSearchForm: function(data) {
            return data.isSearchActive ? this.elm.$searchButton.addClass("is-active") : this.elm.$searchButton.removeClass("is-active")
        },
        onCartUpdate: function(data) {
            var mod, request;
            return mod = this,
            request = T.Utils.startAjaxRequest("ajax-002-cart"),
            !!request && request[0].done(function(result) {
                return mod.elm.$cartAmount.html(result.quantity)
            })
        },
        onCartMessage: function(data) {
            var $cartMessageContent, template;
            return template = doT.template(this.$(".tpl-cartmessage").html()),
            $cartMessageContent = $(template({
                errorMessage: data.errorMessage
            })),
            T.Utils.syncContent($cartMessageContent, "cart_flyout", "append")
        }
    })
}(jQuery);
var indexOf = [].indexOf || function(item) {
    for (var i = 0, l = this.length; i < l; i++)
        if (i in this && this[i] === item)
            return i;
    return -1
}
;
!function($) {
    var glob_config;
    return glob_config = window.localization.configurations,
    T.Module.CustomFilterDateSelection = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.isSynced = !1,
            this.sel = {
                customFilterDropdown: ".js-custom-filter-dropdown",
                customFilterDropdownButton: ".js-custom-filter-dropdown-button",
                customDropdownSliderContainer: ".js-slider",
                confirmButton: ".js-confirm-date",
                clearButton: ".js-clear-date",
                datepickers: ".js-filter-datepicker",
                hiddenInputFrom: ".js-date-from",
                hiddenInputTo: ".js-date-to",
                selectDateList: ".js-select",
                clearCustomDropdownInput: ".js-clear-input",
                customInputText: ".js-input-text",
                modDataPicker: '[data-t-decorator="DatePicker"]'
            },
            this.elm = {
                $customDropdown: $(this.sel.customFilterDropdown, this.$ctx),
                $customDropdownButton: $(this.sel.customFilterDropdownButton, this.$ctx),
                $customDropdownSliderContainer: $(this.sel.customDropdownSliderContainer, this.$ctx),
                $confirmButton: $(this.sel.confirmButton, this.$ctx),
                $clearButton: $(this.sel.clearButton, this.$ctx),
                $datepickers: $(this.sel.datepickers, this.$ctx),
                $hiddenInputFrom: $(this.sel.hiddenInputFrom, this.$ctx),
                $hiddenInputTo: $(this.sel.hiddenInputTo, this.$ctx),
                $selectDateList: $(this.sel.selectDateList, this.$ctx),
                $clearCustomDropdownInput: $(this.sel.clearCustomDropdownInput, this.$ctx),
                $customInputText: $(this.sel.customInputText, this.$ctx)
            },
            this.dataPickersFromEvent = [],
            this.localizedDateDisplayedFormat = glob_config.dateFormat.toUpperCase(),
            this.localizedDateCombineString = this.$ctx.data("datecombinestring"),
            this.dateFormat = "YYYY-MM-DD",
            this.placeholderText = null != this.elm.$customDropdown.attr("data-placeholder") ? this.elm.$customDropdown.attr("data-placeholder") : "",
            T.Utils.allSynced = !1,
            this.$ctx.on("click", this.sel.customFilterDropdown, function(_this) {
                return function(ev) {
                    return _this.onToggleDropdown(ev)
                }
            }(this)),
            this.$ctx.on("change", this.sel.customInputText, function(_this) {
                return function(ev) {
                    return _this.onToggleClearInputIcon(ev)
                }
            }(this)),
            this.$ctx.on("click", this.sel.confirmButton, function(_this) {
                return function(ev) {
                    return _this.onConfirmDate(ev)
                }
            }(this)),
            this.$ctx.on("click", this.sel.clearButton, function(_this) {
                return function(ev) {
                    return _this.onClearDate(ev)
                }
            }(this)),
            this.$ctx.on("click", this.sel.clearCustomDropdownInput, function(_this) {
                return function(ev) {
                    return _this.onClearDate(ev)
                }
            }(this)),
            this.$ctx.on("click", this.sel.selectDateList, function(_this) {
                return function(ev) {
                    return _this.onConfirmDate(ev)
                }
            }(this)),
            this.$ctx.on("click", this.sel.customDropdownSliderContainer, function(_this) {
                return function(ev) {
                    return _this.onClickInsideTheCustomDropdown(ev)
                }
            }(this)),
            $("html").on("click", function(_this) {
                return function(ev) {
                    return _this.onClickOutside(ev)
                }
            }(this)),
            this.$ctx.on("inputdatepicker:initdatepicker", function(_this) {
                return function($ev, data) {
                    return _this.onInitDatepicker(data)
                }
            }(this)),
            this.$ctx.on("change", 'input[data-t-decorator="DatePicker"]', function(_this) {
                return function(ev) {
                    return _this.onSelectNewValueOnDatePicker(ev)
                }
            }(this)),
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            this.elm.$customInputText.text(this.placeholderText),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            T.Utils.allSynced = !0)
        },
        setCustomDate: function(confirmItIsExpiryDate, date) {
            return confirmItIsExpiryDate ? null != this.dataPickersFromEvent[2] && (this.dataPickersFromEvent[2].setDate(new Date(date), !0),
            this.dataPickersFromEvent[2].date = new Date(date),
            this.dataPickersFromEvent[2].value = date,
            this.dataPickersFromEvent[2].element.value = date) : this.dataPickersFromEvent[1] && (this.dataPickersFromEvent[1].setDate(new Date(date), !0),
            this.dataPickersFromEvent[1].date = new Date(date),
            this.dataPickersFromEvent[1].value = date,
            this.dataPickersFromEvent[1].element.value = date),
            this.elm.$clearCustomDropdownInput.removeClass("hidden")
        },
        preselectDataFromHiddenInputFields: function() {
            var $presetedFromDate, $presetedToDate;
            return this.isTheDateFormatValid(this.elm.$hiddenInputFrom.val()) && this.isTheDateFormatValid(this.elm.$hiddenInputTo.val()) ? ($presetedFromDate = this.elm.$hiddenInputFrom.val(),
            $presetedToDate = this.elm.$hiddenInputTo.val(),
            this.dataPickersFromEvent[1].setDate(new Date($presetedFromDate), !0),
            this.dataPickersFromEvent[2].setDate(new Date($presetedToDate), !0),
            this.elm.$customInputText.text(moment($presetedFromDate).format(this.localizedDateDisplayedFormat) + " " + this.localizedDateCombineString.to + " " + moment($presetedToDate).format(this.localizedDateDisplayedFormat))) : this.isTheDateFormatValid(this.elm.$hiddenInputFrom.val()) && !this.isTheDateFormatValid(this.elm.$hiddenInputTo.val()) ? ($presetedFromDate = this.elm.$hiddenInputFrom.val(),
            this.dataPickersFromEvent[1].setDate(new Date($presetedFromDate), !0),
            this.dataPickersFromEvent[2].setDate(null),
            this.dataPickersFromEvent[2].pikaday.setMinDate(new Date(this.elm.$hiddenInputFrom.val())),
            this.elm.$customInputText.text(this.localizedDateCombineString.after + " " + moment($presetedFromDate).format(this.localizedDateDisplayedFormat))) : !this.isTheDateFormatValid(this.elm.$hiddenInputFrom.val()) && this.isTheDateFormatValid(this.elm.$hiddenInputTo.val()) ? ($presetedToDate = this.elm.$hiddenInputTo.val(),
            this.dataPickersFromEvent[1].setDate(null),
            this.dataPickersFromEvent[2].setDate(new Date($presetedToDate), !0),
            this.dataPickersFromEvent[1].pikaday.setMaxDate(new Date(this.elm.$hiddenInputTo.val())),
            this.elm.$customInputText.text(this.localizedDateCombineString.before + " " + moment($presetedToDate).format(this.localizedDateDisplayedFormat))) : (this.dataPickersFromEvent[1].setDate(null),
            this.dataPickersFromEvent[2].setDate(null),
            console.log("case no prefill", this.elm.$hiddenInputFrom.val(), this.isTheDateFormatValid(this.elm.$hiddenInputFrom.val()), this.elm.$hiddenInputTo.val(), this.isTheDateFormatValid(this.elm.$hiddenInputTo.val()))),
            this.elm.$clearCustomDropdownInput.removeClass("hidden")
        },
        isTheDateFormatValid: function(date) {
            try {
                return !!date.match(/^[0-9]{4}\-(0[1-9]|1[012])\-(0[1-9]|[12][0-9]|3[01])/)
            } catch (error) {
                return !1
            }
        },
        setValuesFromDatepicker: function() {
            var $dateFromValue, $dateToValue;
            if ($dateFromValue = this.dataPickersFromEvent[1].value,
            $dateToValue = this.dataPickersFromEvent[2].value,
            null != $dateFromValue && this.isTheDateFormatValid($dateFromValue) && null != $dateToValue && this.isTheDateFormatValid($dateToValue) && (this.elm.$hiddenInputFrom.val($dateFromValue),
            this.elm.$hiddenInputTo.val($dateToValue),
            this.elm.$customInputText.text(moment($dateFromValue).format(this.localizedDateDisplayedFormat) + " " + this.localizedDateCombineString.to + " " + moment($dateToValue).format(this.localizedDateDisplayedFormat)),
            this.elm.$clearCustomDropdownInput.removeClass("hidden")),
            null == $dateFromValue || !this.isTheDateFormatValid($dateFromValue) || null !== $dateToValue && this.isTheDateFormatValid($dateToValue) || (this.elm.$hiddenInputFrom.val($dateFromValue),
            this.elm.$hiddenInputTo.val(null),
            this.elm.$customInputText.text(this.localizedDateCombineString.after + " " + moment($dateFromValue).format(this.localizedDateDisplayedFormat)),
            this.elm.$clearCustomDropdownInput.removeClass("hidden")),
            (null === $dateFromValue || !this.isTheDateFormatValid($dateFromValue)) && null != $dateToValue && this.isTheDateFormatValid($dateToValue))
                return this.elm.$hiddenInputFrom.val(null),
                this.elm.$hiddenInputTo.val($dateToValue),
                this.elm.$customInputText.text(this.localizedDateCombineString.before + " " + moment($dateToValue).format(this.localizedDateDisplayedFormat)),
                this.elm.$clearCustomDropdownInput.removeClass("hidden")
        },
        clearDates: function() {
            var i, len, picker, ref, results;
            for (ref = this.dataPickersFromEvent,
            results = [],
            i = 0,
            len = ref.length; i < len; i++)
                picker = ref[i],
                null != picker && picker.pikaday.setDate(null),
                this.elm.$customInputText.text(this.placeholderText),
                this.elm.$hiddenInputFrom.val(null),
                this.elm.$hiddenInputTo.val(null),
                this.elm.$customDropdownSliderContainer.removeClass("is-slide-active"),
                results.push(this.elm.$clearCustomDropdownInput.addClass("hidden"));
            return results
        },
        onSelectNewValueOnDatePicker: function(ev) {
            return 1 === $(ev.currentTarget).closest(this.sel.modDataPicker).data("picker-nr") ? null != this.dataPickersFromEvent[1].value ? this.dataPickersFromEvent[2].pikaday.setMinDate(new Date(this.dataPickersFromEvent[1].value)) : this.dataPickersFromEvent[2].pikaday.setMinDate(null) : 2 === $(ev.currentTarget).closest(this.sel.modDataPicker).data("picker-nr") ? null != this.dataPickersFromEvent[2].value ? this.dataPickersFromEvent[1].pikaday.setMaxDate(new Date(this.dataPickersFromEvent[2].value)) : this.dataPickersFromEvent[1].pikaday.setMaxDate(null) : void 0
        },
        onInitDatepicker: function(data) {
            return this.dataPickersFromEvent[data.nr] = data.obj
        },
        onClickOutside: function(ev) {
            return !($(ev.target).closest(".pika-single").length > 0) && (this.elm.$customDropdownSliderContainer.hasClass("is-slide-active") ? this.elm.$customDropdownSliderContainer.removeClass("is-slide-active") : void 0)
        },
        onClickInsideTheCustomDropdown: function(ev) {
            return ev.stopPropagation()
        },
        onToggleDropdown: function(ev) {
            return ev.stopPropagation(),
            $(this.sel.customDropdownSliderContainer).not(this.elm.$customDropdownSliderContainer).removeClass("is-slide-active"),
            this.elm.$customDropdownSliderContainer.hasClass("is-slide-active") ? this.elm.$customDropdownSliderContainer.removeClass("is-slide-active") : (this.elm.$customDropdownSliderContainer.addClass("is-slide-active"),
            this.preselectDataFromHiddenInputFields())
        },
        onToggleClearInputIcon: function() {
            return "" !== this.elm.$customInputText.text() && this.elm.$customInputText.text() !== this.placeholderText ? this.elm.$clearCustomDropdownInput.removeClass("hidden") : this.elm.$clearCustomDropdownInput.addClass("hidden")
        },
        onConfirmDate: function(ev) {
            var $currentTargetValue, $res, $resForCustomDropdown, confirmItIsExpiryDate, ref;
            return ev.preventDefault(),
            ref = ev.currentTarget,
            indexOf.call(this.elm.$selectDateList, ref) >= 0 && (this.clearDates(),
            this.pikaDay = $(ev.currentTarget).closest(".js-customfilterdateselection-inner").find(".m-forminput-datepicker"),
            $currentTargetValue = $(ev.currentTarget).data("calculation-mode"),
            confirmItIsExpiryDate = !1,
            $(ev.currentTarget).hasClass("js-expiryDate") ? (confirmItIsExpiryDate = !0,
            $res = moment().add($currentTargetValue, "d").format(this.dateFormat),
            $resForCustomDropdown = moment().add($currentTargetValue, "d").format(this.localizedDateDisplayedFormat),
            this.elm.$customInputText.text(this.localizedDateCombineString.before + " " + $resForCustomDropdown),
            this.elm.$hiddenInputFrom.val(null),
            this.elm.$hiddenInputTo.val($res)) : ($res = moment().add($currentTargetValue, "d").format(this.dateFormat),
            $resForCustomDropdown = moment().add($currentTargetValue, "d").format(this.localizedDateDisplayedFormat),
            this.elm.$customInputText.text(this.localizedDateCombineString.after + " " + $resForCustomDropdown),
            this.elm.$hiddenInputTo.val(null),
            this.elm.$hiddenInputFrom.val($res)),
            this.setCustomDate(confirmItIsExpiryDate, $res)),
            $(ev.currentTarget).hasClass("js-confirm-date") && (0 === $(this.elm.$datepickers.eq(0)).val().length && 0 === $(this.elm.$datepickers.eq(1)).val().length ? this.clearDates() : this.setValuesFromDatepicker()),
            this.$ctx.trigger("update"),
            this.elm.$customDropdownSliderContainer.removeClass("is-slide-active")
        },
        onClearDate: function(ev) {
            return ev.preventDefault(),
            ev.stopPropagation(),
            this.clearDates(),
            this.$ctx.trigger("update")
        }
    })
}(jQuery),
function($) {
    T.Module.DealerLocatorProductTeaser = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.DealerTeaser = T.createModule({
        start: function(resolve) {
            return this._events.emit("dealerTeaserStart"),
            resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.DobAvailabilityServicepartnerItem = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.sync = $.proxy(this.sync, this),
            this._events.on("t.sync", this.sync),
            console.log("DobAvailabilityServicepartnerItem start"),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            console.log("DobAvailabilityServicepartnerItem sync"))
        }
    })
}(jQuery),
function($) {
    T.Module.DownPayment = T.createModule({
        start: function(resolve) {
            return this.loaderActive = !1,
            this.$ctx = $(this._ctx),
            this.$option = $(".js-downpayment-value input[type=radio]", this.$ctx),
            this.$update = $(".js-downpayment-update", this.$ctx),
            this.$invalidUpdate = $(".js-downpayment-update:invalid, .js-downpayment-update.has-error", this.$ctx),
            this.$updatebutton = $(".js-update-button", this.$ctx),
            this.sync = $.proxy(this.sync, this),
            this.closeCalculateLoader = $.proxy(this.closeCalculateLoader, this),
            this.openCalculateLoader = $.proxy(this.openCalculateLoader, this),
            this.onChangeDownpayment = $.proxy(this.onChangeDownpayment, this),
            this.onFocusCustomInput = $.proxy(this.onFocusCustomInput, this),
            this.onListeningComponentUpdate = $.proxy(this.onListeningComponentUpdate, this),
            this.onUpdateCustomValue = $.proxy(this.onUpdateCustomValue, this),
            this._events.on("t.sync", this.sync),
            this._events.on("totalamount:downpaymentupdate", this.onListeningComponentUpdate),
            this.$option.on("change", this.onChangeDownpayment),
            this.$update.on("focus", this.onFocusCustomInput),
            this.$update.on("focusout", this.onUpdateCustomValue),
            this.$updatebutton.on("click", this.onUpdateCustomValue),
            resolve()
        },
        sync: function() {
            this.isSynced || (this._events.emit("downpayment:updateform", T.Utils.getFormDataPairs(this.$ctx)),
            this.isSynced = !0)
        },
        closeCalculateLoader: function() {
            if (this.loaderActive)
                return setTimeout($.proxy(function() {
                    return this._events.emit("loader:close", {
                        $trigger: this.$updatebutton
                    }),
                    this.loaderActive = !1
                }, this), 200)
        },
        openCalculateLoader: function() {
            if (!this.loaderActive)
                return this.loaderActive = !0,
                this._events.emit("loader:open", {
                    $trigger: this.$updatebutton,
                    loaderType: this.$updatebutton.data("loaderType")
                })
        },
        UpdateRadioOptionWithCustomValue: function(custom) {
            var $downpayment, base;
            return $downpayment = this.$option.filter(":checked"),
            "function" != typeof this.$update.get(0).checkValidity || this.$update.get(0).validity.valid ? !("function" == typeof (base = this.$update.get(0)).checkValidity ? base.checkValidity() : void 0) && isNaN(custom || custom > this.$update.attr("max") || custom < this.$update.attr("min")) ? void this.$update.addClass("has-error") : $downpayment.val() !== custom ? (this.openCalculateLoader(),
            $downpayment.val(custom).trigger("change")) : void 0 : void this.$update.addClass("has-error")
        },
        onChangeDownpayment: function(ev) {
            return this._events.emit("downpayment:updateform", T.Utils.getFormDataPairs(this.$ctx)),
            this._events.emit("downpayment:update", ev.currentTarget.value)
        },
        onFocusCustomInput: function(ev) {
            if ($(ev.currentTarget).hasClass("has-error"))
                return $(ev.currentTarget).val(this.$option.filter(":checked").val()).removeClass("has-error")
        },
        onListeningComponentUpdate: function() {
            return this.closeCalculateLoader()
        },
        onUpdateCustomValue: function(ev) {
            return ev.preventDefault(),
            this.UpdateRadioOptionWithCustomValue(this.$update.val())
        }
    })
}(jQuery),
function($) {
    T.Module.DownloadBasketBottom = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.$downloadBasketTrigger = mod.$ctx.find(".js-trigger-download-basket"),
            mod.$downloadButton = mod.$ctx.find(".js-download-button button"),
            mod.$linkText = mod.$downloadBasketTrigger.find(".text"),
            mod.$downloadBasketTrigger.on("click", $.proxy(mod.onClickDownloadBasketTrigger, mod)),
            mod._events.on("press:basketChanged", $.proxy(mod.onBasketChanged, mod)),
            mod._events.on("press:pictureNumberTextUpdated", $.proxy(mod.onPressPictureNumberTextUpdated, mod)),
            resolve()
        },
        sync: function() {},
        onPressPictureNumberTextUpdated: function(data) {
            var mod;
            return mod = this,
            mod.$linkText.html(data)
        },
        onClickDownloadBasketTrigger: function(ev) {
            var mod;
            if (mod = this,
            ev.preventDefault(),
            !mod.$downloadBasketTrigger.data("disabled"))
                return mod._events.emit("press:openBasket")
        },
        onBasketChanged: function(data) {
            var basketEmpty, mod, ref;
            return mod = this,
            basketEmpty = 0 === (null != (ref = data.downloadIDs) ? ref.length : void 0),
            mod.$downloadBasketTrigger.data("disabled", basketEmpty),
            mod.$downloadButton.prop("disabled", basketEmpty)
        }
    })
}(jQuery),
function($) {
    T.Module.DownloadBasketTop = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.$carousel = mod.$ctx.find(".downloadbasket-carousel"),
            mod.$moreLessLink = mod.$ctx.find(".a-morelesslink"),
            this.$moreLess = this.$ctx.find(".js-moreless"),
            mod.$slideTemplate = doT.template(mod.$ctx.find(".js-slide-template").text()),
            mod.resetSelectionUrl = mod.$ctx.data("reset-selection-url"),
            mod.$resetSelectionButton = mod.$ctx.find(".js-reset-selection"),
            mod.$downloadButton = mod.$ctx.find(".js-download-button button"),
            mod.moreLessLinkText = mod.$ctx.data("morelesslink-text"),
            mod.urlPictureAdd = mod.$ctx.data("url-picture-add"),
            mod.urlPictureRemove = mod.$ctx.data("url-picture-remove"),
            mod.urlPictureClear = mod.$ctx.data("url-picture-clear"),
            mod.urlRequestBasketState = mod.$ctx.data("url-request-basket-state"),
            mod.sync = $.proxy(mod.sync, mod),
            mod.$resetSelectionButton.on("click", $.proxy(mod.onResetSelection, mod)),
            mod._events.on("t.sync", mod.sync),
            mod._events.on("press:basketChanged", $.proxy(mod.onPressBasketChanged, mod)),
            mod._events.on("press:openBasket", $.proxy(mod.onPressOpenBasket, mod)),
            mod._events.on("press:pictureAdd", $.proxy(mod.onPressPictureAdd, mod)),
            mod._events.on("press:pictureRemove", $.proxy(mod.onPressPictureRemove, mod)),
            mod._events.on("press:pictureClear", $.proxy(mod.onPressPictureClear, mod)),
            mod._events.on("press:requestBasketState", $.proxy(mod.onPressRequestBasketState, mod)),
            mod._events.on("press:pictureNumberTextUpdated", $.proxy(mod.onPressPictureNumberTextUpdated, mod)),
            mod._events.emit("press:requestBasketState"),
            resolve()
        },
        sync: function() {
            var mod;
            mod = this,
            mod.isSynced || (mod.isSynced = !0,
            mod.$carouselModule = mod._sandbox.getModuleById(mod.$carousel.data("t-id")),
            this.moreLessComponent = this._sandbox.getModuleById(this.$moreLess.data("t-id")))
        },
        requestAction: function(url, data, sourceId) {
            var mod;
            return mod = this,
            T.Utils.startAjaxRequest(!1, {
                url: url,
                dataType: "JSON"
            }, data, function(err, response) {
                if (null == err)
                    return sourceId && (response.sourceId = sourceId),
                    mod._events.emit("press:basketChanged", response),
                    "function" == typeof cb ? cb() : void 0
            })
        },
        onPressBasketChanged: function(data) {
            var hasNoItems, mod, ref, ref1, ref2, ref3, result, text;
            return mod = this,
            mod.$carouselModule && (result = [],
            $(data.items).each(function(index, element) {
                return result.push(mod.$slideTemplate(element))
            }),
            mod.$carouselModule.replaceSlides(result)),
            hasNoItems = 0 === data.items.length,
            hasNoItems && null != (ref = this.moreLessComponent) && ref.close(!1),
            mod.$resetSelectionButton.prop("disabled", hasNoItems),
            hasNoItems ? this.$moreLessLink.addClass("not-active") : this.$moreLessLink.removeClass("not-active"),
            mod.$downloadButton.prop("disabled", hasNoItems),
            text = data.items.length.toString(),
            mod.moreLessLinkText.indexOf("{0}") !== -1 ? text = mod.moreLessLinkText.replace(/\{0}/g, text) : text += mod.moreLessLinkText,
            null != (ref1 = this.moreLessComponent) && ref1.setLessText(text),
            null != (ref2 = this.moreLessComponent) && ref2.setMoreText(text),
            null != (ref3 = this.moreLessComponent) && ref3.calculate(),
            mod._events.emit("press:pictureNumberTextUpdated", text)
        },
        onPressPictureNumberTextUpdated: function(data) {
            var mod;
            return mod = this,
            mod.$moreLessLink.find("span.text").html(data)
        },
        onPressOpenBasket: function(data) {
            var ref;
            return null != (ref = this.moreLessComponent) && ref.open(),
            T.Utils.scrollToTop(this.$ctx)
        },
        onResetSelection: function(evt) {
            var mod;
            return evt.preventDefault(),
            mod = this,
            mod.onPressPictureClear({
                sourceId: mod.$ctx.data("t-id")
            })
        },
        onPressPictureAdd: function(data) {
            var mod;
            if (mod = this,
            !data.processed)
                return data.processed = !0,
                mod.requestAction(mod.urlPictureAdd, {
                    "add[]": data.imageId
                }, data.sourceId)
        },
        onPressPictureRemove: function(data) {
            var mod;
            if (mod = this,
            !data.processed)
                return data.processed = !0,
                mod.requestAction(mod.urlPictureRemove, {
                    "remove[]": data.imageId
                }, data.sourceId)
        },
        onPressPictureClear: function(data) {
            var mod;
            if (mod = this,
            null == data || !data.processed)
                return null != data && (data.processed = !0),
                mod.requestAction(mod.urlPictureClear, {}, null != data ? data.sourceId : void 0)
        },
        onPressRequestBasketState: function(data) {
            var mod;
            if (mod = this,
            null == data || !data.processed)
                return null != data && (data.processed = !0),
                mod.requestAction(mod.urlRequestBasketState, {}, null != data ? data.sourceId : void 0)
        }
    })
}(jQuery),
function($) {
    T.Module.Filter = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.filterInitiallyClosed = this.$ctx.data("filter-initially-closed"),
            this.$filterShowHide = this.$(".js-filter-toggle"),
            this.$filterGroupWrapper = this.$(".js-filter-group-wrapper"),
            this.$filterBlockOuter = this.$(".js-filter-block-outer"),
            this.$filterclosebutton = this.$(".js-filter-closefilterarea-button"),
            this.$filterLayer = this.$(".js-filterlayer"),
            this.$filterresetbutton = this.$(".js-action-reset"),
            this.layerIsOpen = !0,
            this.$filterShowHide.on("click", function(_this) {
                return function(ev) {
                    return _this.onClickFilterShowHide(ev)
                }
            }(this)),
            this.$filterclosebutton.on("click", function(_this) {
                return function(ev) {
                    return _this.onClickFilterCloseButton(ev)
                }
            }(this)),
            this.$filterresetbutton.on("click", function(_this) {
                return function(ev) {
                    return _this.onClickFilterResetButton(ev)
                }
            }(this)),
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            this._events.on("toggleFilterlayer", function(_this) {
                return function() {
                    return _this.onToggleFilterLayer()
                }
            }(this)),
            this._events.on("toggleComparelayer", function(_this) {
                return function() {
                    return _this.onToggleCompareLayer()
                }
            }(this)),
            this._events.on("viewportChanged", function(_this) {
                return function(viewport) {
                    return _this.onViewportChanged(viewport)
                }
            }(this)),
            T.Utils.isIE() && this.$ctx.addClass("hidden"),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            this.onViewportChanged(T.Utils.getViewport()),
            this.filterSetOpenCloseStateOnInit(),
            T.Utils.isIE() && this.$ctx.removeClass("hidden"))
        },
        filterSetOpenCloseStateOnInit: function() {
            if (!window.filterAlreadyRendered)
                return this.filterInitiallyClosed && this.closeFilterLayer(!0),
                window.filterAlreadyRendered = !0
        },
        isFilterLayerVisible: function() {
            return this.$filterLayer.hasClass("filter-block-is-opened")
        },
        setFilterLayerVisible: function(show) {
            return show ? this.$filterLayer.addClass("is-opened") : this.$filterLayer.removeClass("is-opened")
        },
        setFilterBlockOuterVisible: function(show) {
            return show ? (this.$filterBlockOuter.addClass("is-opened"),
            this.$filterLayer.addClass("filter-block-is-opened")) : (this.$filterBlockOuter.removeClass("is-opened"),
            this.$filterLayer.removeClass("filter-block-is-opened"))
        },
        openFilterLayer: function() {
            return T.Utils.isViewport("tablet") || T.Utils.isViewport("desktop") ? (this.setFilterBlockOuterVisible(!0),
            this.setFilterLayerVisible(!0)) : (this.setFilterBlockOuterVisible(!0),
            this.setFilterLayerVisible(!0)),
            this.layerIsOpen = !0,
            this._events.emit("filterLayerOpened")
        },
        closeFilterLayer: function(hideBreadcrumb) {
            var $selectedFilters, filterLayerVisible;
            return T.Utils.isViewport("tablet") || T.Utils.isViewport("desktop") ? ($selectedFilters = this.$filterLayer.find(".js-selected-filter"),
            $selectedFilters.length > 0 ? (this.setFilterBlockOuterVisible(!1),
            filterLayerVisible = !hideBreadcrumb,
            this.setFilterLayerVisible(filterLayerVisible),
            this._events.emit("filterLayerClosed", {
                headerVisible: filterLayerVisible
            })) : (this.setFilterLayerVisible(!1),
            this._events.emit("filterLayerClosed", {
                headerVisible: !1
            }))) : (this.setFilterBlockOuterVisible(!1),
            this.setFilterLayerVisible(!1),
            this._events.emit("filterLayerClosed", {
                headerVisible: !1
            })),
            this.layerIsOpen = !1
        },
        onClickFilterShowHide: function(ev) {
            return ev.preventDefault(),
            this.$filterGroupWrapper.toggleClass("show-all"),
            this.$filterShowHide.toggleClass("is-active")
        },
        onClickFilterCloseButton: function(ev) {
            return this.closeFilterLayer(!1)
        },
        onClickFilterResetButton: function(ev) {
            ev.preventDefault(),
            this._events.emit("filterlayerresetbutton:clicked"),
            this.closeFilterLayer(!1)
        },
        onToggleFilterLayer: function() {
            return this.layerIsOpen ? this.closeFilterLayer(!1) : this.openFilterLayer()
        },
        onToggleCompareLayer: function() {
            return this.setFilterLayerVisible(!this.isFilterLayerVisible())
        },
        onViewportChanged: function(viewport) {
            var hiddenElements;
            return (this.$filterGroupWrapper || this.$filterShowHide) && (hiddenElements = this.$filterGroupWrapper.children().length > T.Utils.filterShowInital[viewport],
            this.$filterShowHide.toggleClass("hidden", !hiddenElements)),
            this.layerIsOpen ? this.openFilterLayer() : this.closeFilterLayer(!1)
        }
    })
}(jQuery),
function($) {
    T.Module.FilterBar = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.$filterbarTitle = mod.$(".js-filterbar-title"),
            mod.$filterbarNav = mod.$(".js-filterbar-nav"),
            mod.$filterbutton = mod.$(".js-filterbar-filter"),
            mod.$filterBarTextSpan = mod.$filterbutton.find(".js-filterbar-filter-text"),
            mod.$filterbarItems = mod.$filterbarNav.find("li:not(.js-filterbar-recommendations, .js-filterbar-title)"),
            mod.$viewTypeButtons = mod.$filterbarNav.find(".js-filterbar-view-toggle"),
            mod.$inputGridListStatus = mod.$filterbarNav.find("input.js-view-state"),
            mod.$filterbarArrow = mod.$(".js-filterbar-arrow"),
            mod.$filterbarSortingSelect = mod.$(".js-filterbar-sorting"),
            mod.$parent = mod.$ctx.closest(".m-filter"),
            mod.$pageNrInput = mod.$parent.find('[name="pageNumber"]'),
            mod.parentId = mod.$parent.data("t-id"),
            mod.listId = mod.$ctx.data("list-id"),
            mod.$ctx.on("click", ".js-filterbar-nav > li:not(.filterbar-recommendations, .js-filterbar-title, .js-filterbar-icons, .js-filterbar-filter)", $.proxy(mod.onClickNav, mod)),
            this.$filterbutton.on("click", function(_this) {
                return function(ev) {
                    return _this.handleFilterButton(ev)
                }
            }(this)),
            mod.$filterbarSortingSelect.on("change", $.proxy(mod.onChangeSortingOption, this)),
            mod.$viewTypeButtons.on("click", $.proxy(mod.onClickViewTypeButton, mod)),
            mod._events.on("onGridListInit", $.proxy(mod.onGridListInitSetView, mod)),
            mod._events.on("onGridListButton", $.proxy(mod.onClickViewTypeButton, mod)),
            this._events.on("filterLayerOpened", function(_this) {
                return function() {
                    return _this.onFilterLayerOpened()
                }
            }(this)),
            this._events.on("filterLayerClosed", function(_this) {
                return function(data) {
                    return _this.onFilterLayerClosed(data)
                }
            }(this)),
            mod._events.on("updateSortingDropdown", $.proxy(mod.onUpdateSortingDropdown, this)),
            mod._events.on("updateActiveFilterCount", $.proxy(this.onUpdateActiveFilterCount, mod)),
            mod._events.on("updateItemCount", $.proxy(this.onUpdateItemCount, mod)),
            mod.checkActiveFilterCountVisibility(),
            mod.checkAvailableProductSets(),
            resolve()
        },
        sync: function() {},
        checkActiveFilterCountVisibility: function() {
            var mod;
            return mod = this,
            "0" !== mod.$filterBarTextSpan.attr("data-active-filter-count") ? mod.$filterbutton.addClass("has-active-filters") : mod.$filterbutton.removeClass("has-active-filters")
        },
        checkAvailableProductSets: function() {
            var mod;
            if (mod = this,
            !mod.$ctx.hasClass("has-grid-list-toggle"))
                return mod._events.emit("modifyGridView")
        },
        toggleListViewType: function($activeToggleButton, viewTypeStatus) {
            return this.$viewTypeButtons.removeClass("is-active"),
            $activeToggleButton.addClass("is-active"),
            this.$inputGridListStatus.attr("value", viewTypeStatus)
        },
        updateSortingDropDown: function(data) {
            var $select, mod;
            if (mod = this,
            $select = mod.$filterbarSortingSelect.find("select"),
            $select.val(data.sortKey),
            data.triggerChange && $select.trigger("change.select2"),
            data.triggerUpdateSticky)
                return mod._events.emit("updateStickySortingDropDown", {
                    $ctx: this.$ctx
                })
        },
        onClickNav: function(ev) {
            var $currentTarget;
            return $currentTarget = $(ev.currentTarget),
            this.$filterbarItems.removeClass("is-active"),
            $currentTarget.addClass("is-active"),
            $currentTarget.hasClass("js-filterbar-compare") && this._events.emit("toggleComparelayer"),
            ev.preventDefault()
        },
        handleFilterButton: function(ev) {
            return this.$filterbarItems.removeClass("is-active"),
            this.$filterbutton.addClass("is-active"),
            this._events.emit("toggleFilterlayer"),
            ev.preventDefault()
        },
        onChangeSortingOption: function(ev) {
            var mod, sortKey;
            return mod = this,
            this.$ctx.hasClass("js-noajax") ? (sortKey = mod.$filterbarSortingSelect.find("select").val(),
            mod._events.emit("filterBarSortingChange", {
                sortKey: sortKey,
                parentId: mod.parentId
            }),
            mod._events.emit("updateStickySortingDropDown", {
                $ctx: this.$ctx,
                sortKey: sortKey
            })) : (mod.$pageNrInput.val("1"),
            T.Utils.onAjaxControllerTriggered(ev))
        },
        onUpdateActiveFilterCount: function(data) {
            var mod;
            if (mod = this,
            mod.$filterBarTextSpan.length > 0)
                return mod.$filterBarTextSpan.attr("data-active-filter-count", data.activeFilterCount),
                mod.checkActiveFilterCountVisibility()
        },
        onUpdateItemCount: function(data) {
            if (this.listId === data.listId)
                return this.$filterbarTitle.find(".js-counter").text(data.itemCount)
        },
        onClickViewTypeButton: function(ev, btn) {
            var $currentList, $currentTarget, $productListWrap, $tabPanel, mod, viewTypeStatus;
            if (btn ? (mod = this,
            $currentTarget = mod.$filterbarNav.find(btn)) : (ev.preventDefault(),
            $currentTarget = $(ev.currentTarget)),
            !$currentTarget.hasClass("is-active")) {
                if ($productListWrap = $currentTarget.closest(".productlist-wrap"),
                $tabPanel = $currentTarget.closest(".tab-panel.is-active"),
                $productListWrap.length && ($currentList = $productListWrap.find(".o-list .js-list-layout")),
                $tabPanel.length && ($currentList = $tabPanel.find(".js-list-layout")),
                viewTypeStatus = "grid",
                $currentTarget.hasClass("js-filterbar-listview") && (viewTypeStatus = "list"),
                this.toggleListViewType($currentTarget, viewTypeStatus),
                "grid" === viewTypeStatus)
                    return this._events.emit("toggleGridView", {
                        listId: this.listId,
                        currentList: $currentList
                    });
                if ("list" === viewTypeStatus)
                    return this._events.emit("toggleListView", {
                        listId: this.listId,
                        currentList: $currentList
                    })
            }
        },
        onGridListInitSetView: function(data) {
            var $activeToggleButton, viewTypeClass, viewTypeStatus;
            if (this.listId === data.listId)
                return viewTypeStatus = "grid",
                viewTypeClass = "gridview",
                "list-view" === data.viewType && (viewTypeStatus = "list",
                viewTypeClass = "listview"),
                $activeToggleButton = this.$filterbarNav.find(".js-filterbar-view-toggle.filterbar-" + viewTypeClass),
                this.toggleListViewType($activeToggleButton, viewTypeStatus),
                this._events.emit("updateStickyViewTypeButtonState", {
                    listId: data.listId,
                    viewType: data.viewType
                })
        },
        onFilterLayerOpened: function() {
            return this.$filterbarArrow.addClass("is-active"),
            this.$filterbutton.addClass("is-active")
        },
        onFilterLayerClosed: function(data) {
            return this.$filterbutton.removeClass("is-active"),
            data.headerVisible ? this.$filterbarArrow.addClass("is-active") : this.$filterbarArrow.removeClass("is-active")
        },
        onUpdateSortingDropdown: function(data) {
            if (this.$ctx = data.$ctx)
                return this.updateSortingDropDown(data)
        }
    })
}(jQuery),
function($) {
    T.Module.FilterLayer = T.createModule({
        request: {},
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.$filterGroupWrapper = mod.$(".js-filter-group-wrapper"),
            mod.$filterInput = mod.$(".js-value"),
            mod.$ctx.on("change", ".js-value", $.proxy(mod.onChangeFilterValue, mod)),
            this.doEventBinding(),
            mod.equalizeHeadingHeights(),
            resolve()
        },
        doEventBinding: function() {
            return this._events.on("selectedfilter:clicked", $.proxy(this.onRemoveSelectedFilter, this)),
            this._events.on("filterlayerresetbutton:clicked", $.proxy(this.onReset, this))
        },
        equalizeHeadingHeights: function() {
            return this.$(".js-filterlist-heading, .js-equalize-heading").matchHeight()
        },
        toggleElementActiveState: function($item) {
            var $filterList, $input, isMultiSelect;
            if ($input = $item.find(".js-filter-item-input"),
            $filterList = $item.closest(".js-filter-list-container"),
            isMultiSelect = $filterList.data("multiple-select"),
            isMultiSelect ? $item.removeClass("is-active") : $filterList.find(".js-filter-list-row-item").removeClass("is-active"),
            $input.is(":checked") && $item.addClass("is-active"),
            !isMultiSelect)
                return $filterList.find(".js-filter-list-row-item:not(.is-active) .js-filter-item-input").prop("checked", !1)
        },
        onChangeFilterValue: function(ev) {
            var $filterList, $item;
            if ($item = $(ev.target).closest(".js-filter-list-row-item"),
            $filterList = $item.closest(".js-filter-list-container"),
            $filterList.length > 0)
                return this.toggleElementActiveState($item)
        },
        onRemoveSelectedFilter: function(data) {
            var $category, $input, $inputfield, mod, option, selector;
            switch (mod = this,
            data.type) {
            case "default":
                if (selector = "[value='" + data.value + "']",
                $input = mod.$filterGroupWrapper.find(selector),
                !$input.length)
                    return;
                return data.resetValue && $input.val(""),
                $input.trigger("click");
            case "range":
                if (selector = "[data-range-name='" + data.name + "']",
                $input = mod.$filterGroupWrapper.find(selector),
                !$input.length)
                    return;
                return "SELECT" === $input[0].tagName ? ($input[0].selectedIndex = -1,
                $input.trigger("click")) : ($inputfield = $input.find("input"),
                $inputfield.val(null),
                $inputfield.filter(":first").trigger("change"));
            case "category":
                if (selector = "[name='" + data.name + "']",
                option = "option[value='" + data.value + "']",
                $category = mod.$filterGroupWrapper.find(selector),
                !$category.length)
                    return;
                return 0 === $(option, $category).length && $category.prepend("<option value='" + data.value + "'>back...</option>"),
                $category.val(data.value),
                $category.trigger("click")
            }
        },
        onReset: function() {
            return !0
        }
    })
}(jQuery),
function($) {
    T.Module.FilterList = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.$filterItemHeader = mod.$(".js-filterlist-heading"),
            mod.$filterListHeadingIcon = mod.$(".js-filterlist-heading-icon"),
            mod.$filterItemCloseIcon = mod.$(".js-filterlist-close-icon"),
            mod.$filterItemCloseIcon.on("click", $.proxy(mod.onFilterItemCloseIconClicked, mod)),
            mod._events.on("filterStateChange", $.proxy(this.onFilterStateChange, mod)),
            T.Utils.registerMq("md", {
                match: function() {
                    return mod.$filterItemHeader.on("click.mobile", $.proxy(mod.onFilterItemHeaderClicked, mod))
                },
                unmatch: function() {
                    return mod.$filterItemHeader.off("click.mobile")
                }
            }, "max"),
            this.checkHeadingIconState(),
            resolve()
        },
        sync: function() {},
        checkHeadingIconState: function() {
            if (this.$(".js-filter-item-input:checked").length > 0)
                return this.$filterListHeadingIcon.addClass("is-active")
        },
        onFilterItemCloseIconClicked: function(ev) {
            var $input, $rowItem;
            return $rowItem = $(ev.currentTarget).closest(".js-filter-list-row-item"),
            $input = $rowItem.find(".js-filter-item-input"),
            $input.trigger("click")
        },
        onFilterItemHeaderClicked: function(ev) {
            return $(ev.currentTarget).toggleClass("is-opened"),
            this.$container = $(ev.currentTarget).parent().find(".js-filter-list-container"),
            this.$container.toggleClass("open-mobile")
        },
        onFilterStateChange: function(data) {
            var mod;
            if (mod = this,
            data.$filterList.closest(mod.$ctx).length)
                return data.$filterList.find(".js-filter-list-row-item.is-active").length > 0 ? mod.$filterListHeadingIcon.addClass("is-active") : mod.$filterListHeadingIcon.removeClass("is-active")
        }
    })
}(jQuery),
function($) {
    T.Module.FooterPagefunctionsFollow = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$printLink = mod.$(".print"),
            mod.$printLink.on("click", $.proxy(mod.onClickPrint, mod)),
            mod.$shareLink = mod.$(".share-link"),
            mod.$shareLink.on("click", $.proxy(mod.onClickShare, mod)),
            mod.$shareLink.each(function() {
                var $link;
                return $link = $(this),
                $link.data("original-href", $link.attr("href")),
                $link.attr("href", $link.attr("href").replace("{currentUrl}", location.href))
            }),
            resolve()
        },
        sync: function() {},
        onClickPrint: function() {
            return window.print()
        },
        onClickShare: function(ev) {
            var $link, shareUrl;
            return $link = $(ev.currentTarget),
            shareUrl = $link.data("original-href"),
            shareUrl = shareUrl.replace("{currentUrl}", location.href),
            $link.hasClass("email") ? location.href = shareUrl : (window.open(shareUrl, "sharer", this.getWindowParameters()),
            ev.preventDefault())
        },
        getWindowParameters: function() {
            var conf, i, openConf;
            conf = T.Utils.shareWindow,
            openConf = [];
            for (i in conf)
                conf.hasOwnProperty(i) && openConf.push(i + "=" + conf[i]);
            return openConf.join(",")
        }
    })
}(jQuery);
var hasProp = {}.hasOwnProperty;
!function($) {
    T.Module.Form = T.createModule({
        start: function(resolve) {
            var mod;
            return this.$ctx = $(this._ctx),
            mod = this,
            T.Utils.allSynced = !1,
            this.isSynced = !1,
            this.select = {
                error: ".has-error, .is-invalid, .has-confirm-error, .has-ajax-error"
            },
            this.elm = {
                $form: "FORM" === mod.$ctx.get(0).tagName ? mod.$ctx : mod.$ctx.closest("form"),
                $selectAutocompleteOnload: mod.$ctx.find(".js-autocomplete-onload"),
                $selectPreselectOnload: mod.$ctx.find(".js-preselect-onload"),
                $formActions: mod.$ctx.find(".js-formaction-toggle"),
                $formActionsInverse: mod.$ctx.find(".js-formaction-toggle-inverse"),
                $formSectionInvertReadonly: mod.$ctx.find('[data-invert="readonly"]')
            },
            this.state = {
                hasInvertReadonly: "readonly" === mod.$ctx.data("invert")
            },
            this.autocomplete = {
                suggestData: [],
                $suggestLayers: mod.$(".js-suggest-layer"),
                $replaceLayers: mod.$(".js-replace-layer")
            },
            this.autosubmit = mod.$ctx.data("autosubmit") || !1,
            this.autosubmitDelay = mod.$ctx.data("autosubmit-delay") || 5e3,
            this.preventDoubleSubmit = mod.$ctx.data("prevent-double-submit") || !1,
            this.disableSubmitButton = mod.$ctx.data("disable-submit-button") || !1,
            this.sync = $.proxy(this.sync, this),
            this.onClickSuggestlayer = $.proxy(this.onClickSuggestlayer, this),
            this.onHideSuggestlayers = $.proxy(this.onHideSuggestlayers, this),
            this.onStoreAutocompleteData = $.proxy(this.onStoreAutocompleteData, this),
            this.onSubmitForm = $.proxy(this.onSubmitForm, this),
            this.onToggleSuggestlayer = $.proxy(this.onToggleSuggestlayer, this),
            this.onTriggerAAFReplace = $.proxy(this.onTriggerAAFReplace, this),
            this.onToggleFormActions = $.proxy(this.onToggleFormActions, this),
            this.onToggleReplacelayer = $.proxy(this.onToggleReplacelayer, this),
            this.disableSubmit = $.proxy(this.disableSubmit, this),
            this.enableSubmit = $.proxy(this.enableSubmit, this),
            this.getErrorbox = $.proxy(this.getErrorbox, this),
            this.scrollToError = $.proxy(this.scrollToError, this),
            this.autocomplete.$suggestLayers.on("mousedown.autocomplete", this.onClickSuggestlayer),
            this._events.on("t.sync", this.sync),
            this._events.on("form:toggleSuggestlayer", this.onToggleSuggestlayer),
            this._events.on("form:hideSuggestlayers", this.onHideSuggestlayers),
            this._events.on("form:storeAutocompleteData", this.onStoreAutocompleteData),
            this._events.on("form:triggerAAFReplace", this.onTriggerAAFReplace),
            this._events.on("form:toggleReplacelayer", this.onToggleReplacelayer),
            this._events.on("form:disableSubmit", this.disableSubmit),
            this._events.on("form:enableSubmit", this.enableSubmit),
            this._events.on("form:toggleFormActions", this.onToggleFormActions),
            this.elm.$form.on("submit", this.onSubmitForm),
            this.autosubmit && setTimeout(function() {
                return mod.$ctx.submit()
            }, mod.autosubmitDelay),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.setupEditable(),
            this.setupAAFSelect(),
            this.scrollToError(),
            this.isSynced = !0,
            T.Utils.allSynced = !0)
        },
        disableSubmit: function(data) {
            if (console.log("disable submit ", data.id, this.$ctx.find('[data-t-id="' + data.id + '"]').length),
            this.$ctx.find('[data-t-id="' + data.id + '"]').length > 0)
                return this.$ctx.find('[type="submit"]').attr("disabled", "disabled"),
                this.$ctx.on("submit", function(ev) {
                    return ev.preventDefault(),
                    !1
                })
        },
        enableSubmit: function(data) {
            var mod;
            if (mod = this,
            mod.$ctx.find('[data-t-id="' + data.id + '"]').length > 0)
                return mod.$ctx.find('[type="submit"]').attr("disabled", !1),
                mod.$ctx.off("submit")
        },
        getErrorbox: function(ctx) {
            return $(this.select.error, ctx || this.$ctx).add(".js-errorbox", ctx || this.$ctx).filter(":visible")
        },
        scrollToError: function() {
            var $error, $errorboxes;
            if ($errorboxes = this.getErrorbox(),
            $error = $errorboxes.filter(":not(.is-scrollto-disabled)"),
            $error.length)
                return $errorboxes.toggleClass("is-scrollto-disabled", !0),
                T.Utils.scrollToTop($error.eq(0))
        },
        setupAAFSelect: function() {
            var mod;
            if (mod = this,
            mod.elm.$selectAutocompleteOnload.val() && setTimeout(function() {
                return mod.elm.$selectAutocompleteOnload.is("select") ? mod.elm.$selectAutocompleteOnload.trigger("change") : mod.elm.$selectAutocompleteOnload.trigger("autocomplete.onload")
            }, 10),
            mod.elm.$selectPreselectOnload.length > 0)
                return mod._events.emit("forminput:preselect", {
                    targetTId: mod.$ctx.data("t-id")
                })
        },
        setupEditable: function() {
            return this.state.hasInvertReadonly && this.setupReadonlyEditable(),
            this.elm.$formSectionInvertReadonly.length && this.setupReadonlyEditable(this.elm.$formSectionInvertReadonly),
            this.setupInvertReadonly()
        },
        setupInvertReadonly: function() {
            var $triggeredit;
            return $triggeredit = $(".js-trigger-edit", this.$ctx),
            $triggeredit.on("click", function(_this) {
                return function(ev) {
                    return _this.onClickButtonEdit(ev)
                }
            }(this))
        },
        checkSubmitWasDoubleClicked: function(data) {
            if (!data || data.dblClickCheck) {
                if (void 0 === this.lastSubmitClicked && (this.lastSubmitClicked = 0),
                $.now() - this.lastSubmitClicked < 1500)
                    return !0;
                this.lastSubmitClicked = $.now()
            }
            return !1
        },
        setupReadonlyEditable: function($sections) {
            var $editable;
            return $sections = $sections || this.$ctx,
            $editable = $(":input:not([readonly], :hidden, .readonly, :button)", $sections),
            $editable.each(function() {
                var $e;
                return $e = $(this),
                $e.addClass("js-make-editable"),
                $e.is("select") ? (T.Utils.createHiddenElementForReadonly($e, ".select-wrap"),
                $e.trigger("edit", {
                    invert: !0
                })) : $e.prop("readonly", !0)
            }),
            this._events.emit("form:trigger", {
                action: "readonly",
                $form: $sections,
                editclass: "js-make-editable"
            }),
            this._events.emit("select:updateInactiveWithoutValue", !0),
            $editable.trigger("preventSelectingReadonlyFields", [!0])
        },
        onClickButtonEdit: function(ev) {
            var $readonly, mod;
            return mod = this,
            ev.preventDefault(),
            $readonly = $(ev.currentTarget).closest(".m-form").find(".js-make-editable"),
            mod._events.emit("form:trigger", {
                action: "editable",
                $form: mod.$ctx,
                editclass: "js-make-editable"
            }),
            $readonly.trigger("preventSelectingReadonlyFields", [!1]),
            $readonly.trigger("edit", {
                invert: !1
            }),
            $(ev.currentTarget).hide(),
            $(".info-text").removeClass("hidden")
        },
        onClickSuggestlayer: function() {
            return this._events.emit("forminput:triggerAAFSuggest", {
                address1: this.autocomplete.suggestData[0]
            })
        },
        onHideSuggestlayers: function() {
            return this.autocomplete.$suggestLayers.toggleClass("hidden", !0)
        },
        onStoreAutocompleteData: function(data) {
            var adrObj, cleanedObj, i, key, len, ref, returnReduced, value;
            if (null != data && null != data.suggestData) {
                for (returnReduced = [],
                ref = data.suggestData,
                i = 0,
                len = ref.length; i < len; i++) {
                    adrObj = ref[i],
                    cleanedObj = {};
                    for (key in adrObj)
                        hasProp.call(adrObj, key) && (value = adrObj[key],
                        null != value && (value.length > 0 || "object" == typeof value) && (cleanedObj[key] = value));
                    returnReduced.push(cleanedObj)
                }
                return this.autocomplete.suggestData = returnReduced
            }
        },
        onSubmitForm: function(ev, data) {
            var $mainformerror;
            return $(ev.currentTarget).find(this.select.error).length ? (ev.preventDefault(),
            $mainformerror = this.getErrorbox(this.elm.$form),
            $mainformerror.not(".is-scrollto-disabled").length || $mainformerror.eq(0).removeClass("is-scrollto-disabled"),
            this.scrollToError(),
            !1) : (this.disableSubmitButton && this.elm.$form.find('[type="submit"]').attr("disabled", "disabled"),
            (!this.preventDoubleSubmit || !this.checkSubmitWasDoubleClicked(data)) && void 0)
        },
        onToggleFormActions: function(hideActions) {
            var mod;
            if (mod = this,
            mod.elm.$formActions.length > 0 && mod.elm.$formActions.toggleClass("hidden", hideActions),
            mod.elm.$formActionsInverse.length > 0)
                return mod.elm.$formActionsInverse.toggleClass("hidden", !hideActions)
        },
        onToggleReplacelayer: function(data) {
            var $elmToHide, $elmToShow, cssClass;
            return $elmToShow = data.show,
            $elmToHide = data.hide,
            cssClass = data.cssClass,
            $elmToShow.removeClass(cssClass),
            $elmToHide.addClass(cssClass)
        },
        onToggleSuggestlayer: function(data) {
            var $targetLayer, blnShow, targetId;
            if (this.onHideSuggestlayers(),
            null != data && (targetId = data.id,
            blnShow = data.show,
            $targetLayer = this.autocomplete.$suggestLayers.filter("[data-aaf-suggest-container=" + targetId + "]"),
            null != $targetLayer))
                return $targetLayer.toggleClass("hidden", !blnShow)
        },
        onTriggerAAFReplace: function(data) {
            var $ajaxContainer, $replace, $select, $selectWrapper, $targetLayer, name;
            if ($ajaxContainer = this.$ctx.data("ajax-id"),
            data.ajaxId === $ajaxContainer)
                return $targetLayer = this.autocomplete.$replaceLayers.filter("[data-replace-container=" + data.ajaxId + "]"),
                null != data && ($selectWrapper = $targetLayer.find("[data-replace]"),
                $select = $selectWrapper.find("select"),
                name = $select.data("objName"),
                $replace = this.$ctx.find('[data-autocomplete="replace"]'),
                name === data.id && ($select.find("option:not(:disabled)").remove(),
                $select.select2({
                    data: data.options
                }),
                $select.val("").trigger("change"),
                null != data.options)) ? this._events.emit("form:toggleReplacelayer", {
                    show: $targetLayer,
                    hide: $replace,
                    cssClass: "hidden"
                }) : void 0
        }
    })
}(jQuery);
var hasProp = {}.hasOwnProperty
  , indexOf = [].indexOf || function(item) {
    for (var i = 0, l = this.length; i < l; i++)
        if (i in this && this[i] === item)
            return i;
    return -1
}
;
!function($) {
    T.Module.FormInput = T.createModule({
        start: function(resolve) {
            var onPreventSelectingReadonlyFields;
            return this.$ctx = $(this._ctx),
            this.isSynced = !1,
            this.elm = {
                $input: this.$ctx,
                $inputField: this.$("input"),
                $confirmfield: this.$ctx.filter("[data-confirm-field]"),
                $errorWrapper: this.$ctx.nextAll(".js-error-wrapper")
            },
            this.group = this.$ctx.data("groupName"),
            this.elm.$inputGroup = $('[data-group-name="' + this.group + '"]'),
            this.isCheckbox = Boolean(this.elm.$inputField.filter("[type=checkbox]").length),
            this.isSelect = Boolean(this.$ctx.find("select").length),
            this.isAutocompleteTrigger = Boolean(this.$ctx.filter("[data-autocomplete]").length),
            this.state = {
                hasGroup: Boolean(this.group)
            },
            this.stateclass = {
                error: "has-error",
                noerror: "has-no-error",
                focused: "had-focus",
                empty: "is-empty",
                noConfirm: "has-confirm-error",
                ajaxError: "has-ajax-error"
            },
            this.constraintRequest = $.proxy(this, "constraintRequest"),
            this.evaluateConstraintResponse = $.proxy(this, "evaluateConstraintResponse"),
            this.getSelectionOfArray = $.proxy(this, "getSelectionOfArray"),
            this.getTypeConstraintSelection = $.proxy(this, "getTypeConstraintSelection"),
            this.groupObjectArrayByKeys = $.proxy(this, "groupObjectArrayByKeys"),
            this.staffsalesCheckRegistration = $.proxy(this, "staffsalesCheckRegistration"),
            this.onChangeAutocompleteInitiatorCityfetch = $.proxy(this, "onChangeAutocompleteInitiatorCityfetch"),
            this.onFocusoutConfirm = $.proxy(this, "onFocusoutConfirm"),
            this.onFocusoutInput = $.proxy(this, "onFocusoutInput"),
            this.onFocusInput = $.proxy(this, "onFocusInput"),
            this.onHandleCustomError = $.proxy(this, "onHandleCustomError"),
            this.onKeyupOrChangeInput = $.proxy(this, "onKeyupOrChangeInput"),
            this.onPreselect = $.proxy(this, "onPreselect"),
            this.onPreventSelectingReadonlyFields = $.proxy(this, "onPreventSelectingReadonlyFields"),
            this.onSetCustomError = $.proxy(this, "onSetCustomError"),
            this.onTriggerAAFDouble = $.proxy(this, "onTriggerAAFDouble"),
            this.onTriggerAAFMultiselect = $.proxy(this, "onTriggerAAFMultiselect"),
            this.onTriggerAAFPreselect = $.proxy(this, "onTriggerAAFPreselect"),
            this.onTriggerAAFSelect = $.proxy(this, "onTriggerAAFSelect"),
            this.onTriggerAAFRegistration = $.proxy(this, "onTriggerAAFRegistration"),
            this.onTriggerAAFSingle = $.proxy(this, "onTriggerAAFSingle"),
            this.onTriggerAAFSuggest = $.proxy(this, "onTriggerAAFSuggest"),
            this.preventSelectingReadonlyFields = $.proxy(this, "preventSelectingReadonlyFields"),
            this.setupAutocompleteFeatures = $.proxy(this, "setupAutocompleteFeatures"),
            this.wrapInParagraphs = $.proxy(this, "wrapInParagraphs"),
            this._events.on("forminput:triggerAAFDouble", this.onTriggerAAFDouble),
            this._events.on("forminput:triggerAAFMultiselect", this.onTriggerAAFMultiselect),
            this._events.on("forminput:triggerAAFPreselect", this.onTriggerAAFPreselect),
            this._events.on("forminput:triggerAAFRegistration", this.onTriggerAAFRegistration),
            this._events.on("forminput:triggerAAFSingle", this.onTriggerAAFSingle),
            this._events.on("forminput:triggerAAFSuggest", this.onTriggerAAFSuggest),
            this._events.on("forminput:preselect", this.onPreselect),
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            this.elm.$inputField.is("[readonly]") && this.preventSelectingReadonlyFields(!0),
            this.elm.$input.hasClass(this.stateclass.error) || this.$ctx.find("." + this.stateclass.error).length > 0 && this.toggleStateClass(this.stateclass.error),
            this.elm.$input.on("focus", this.onFocusInput),
            this.isSelect ? this.elm.$input.on("change", function(_this) {
                return function(ev, data) {
                    return _this.onChangeInput(ev, data)
                }
            }(this)) : this.elm.$input.on("focusout", function(_this) {
                return function(ev) {
                    return _this.onFocusoutInput(ev)
                }
            }(this)),
            this.isCheckbox ? this.elm.$inputField.on("change", this.onKeyupOrChangeInput) : this.elm.$input.on("keyup", this.onKeyupOrChangeInput),
            this.elm.$input.on("preventSelectingReadonlyFields", this.onPreventSelectingReadonlyFields),
            this.elm.$input.on("setCustomError", this.onSetCustomError),
            this.elm.$input.filter('[data-autocomplete="region"]').on("change", this.onChangeAutocompleteInitiatorCityfetch),
            this.elm.$input.filter('[data-autocomplete="cityfetch"]').find("select").on("forminput:triggerAAFSelect", this.onTriggerAAFSelect),
            onPreventSelectingReadonlyFields = function(e, blnPrevent) {
                return this.preventSelectingReadonlyFields(blnPrevent)
            }
            ,
            this.elm.$confirmfield.on("focusout", this.onFocusoutConfirm),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.setupAutocompleteFeatures(),
            this.setupConstraints(),
            this.elm.$input.on("setInputError", this.onHandleCustomError),
            this.isSynced = !0)
        },
        setupConstraints: function() {
            this.constraint = {
                attrName: this.$ctx.data("constraintAttributeName"),
                type: {
                    url: this.$ctx.data("typeConstraintUrl"),
                    validationArray: this.$ctx.data("typeConstraints")
                },
                attr: {
                    url: this.$ctx.data("attributeConstraintUrl")
                }
            },
            this.isSelect && (this.constraint.attrName = $("select", this.$ctx).data("constraintAttributeName")),
            this.state.attrConstraintTrigger = Boolean(this.constraint.attr.url),
            this.state.typeConstraintTrigger = Boolean(this.constraint.type.url) && Boolean(this.group) && Boolean(this.constraint.type.validationArray),
            this.state.constraintTrigger = this.state.attrConstraintTrigger || this.state.typeConstraintTrigger,
            this.state.bothConstraintTrigger = this.state.attrConstraintTrigger && this.state.typeConstraintTrigger,
            this.state.constraintTrigger && this.state.typeConstraintTrigger && this.state.hasGroup && this.constraint.type.validationArray && (this.elm.typeConstraintsSelection = this.getTypeConstraintSelection(this.elm.$inputGroup, this.constraint.type.validationArray)),
            this.isSelect || this.elm.$input.on("triggerconstraint", function(_this) {
                return function() {
                    if (_this.constraint && _this.state.constraintTrigger)
                        return _this.triggerConstraints()
                }
            }(this))
        },
        setupAutocompleteFeatures: function() {
            var mod;
            return mod = this,
            mod.elm.$autocompleteInitiatorValidateonly = mod.$ctx.filter('[data-autocomplete="validationonly"]'),
            mod.elm.$autocompleteInitiatorAddresslookup = mod.$ctx.filter('[data-autocomplete="double"]'),
            mod.elm.$autocompleteInitiatorPostalcode2Address = mod.$ctx.filter('[data-autocomplete="single"]'),
            mod.elm.$autocompleteInitiatorSingleresult = mod.$ctx.filter('[data-autocomplete="suggest"]'),
            mod.elm.$autocompleteInitiatorTown2District = mod.$ctx.filter("[data-autocomplete-town2district]"),
            mod.elm.$autocompleteInitiatorDistrict2HiddenZip = mod.$ctx.filter("[data-autocomplete-district2hiddenzip]"),
            mod.elm.$autocompleteInitiatorZip2City = mod.$ctx.filter('[data-autocomplete="zip2city"]'),
            mod.elm.$autocompleteInitiatorCity2Zip = mod.$ctx.filter("[data-autocomplete-city2zip]"),
            mod.elm.$autocompleteInitiatorStaffSalesRegistration = mod.$ctx.filter('[data-autocomplete="registration"]'),
            mod.elm.$autocompleteInitiatorValidateonly.on("focus input", function(ev) {
                var $parentAjaxContainer, ajaxId, initiator, inputValue, request, targetId;
                return initiator = ev.currentTarget,
                inputValue = initiator.value,
                $parentAjaxContainer = $(initiator).closest(".js-ajax-request"),
                ajaxId = $(initiator).data("ajaxRequestId"),
                targetId = $(initiator).prop("id"),
                inputValue && inputValue.length >= 3 && "undefined" !== $parentAjaxContainer ? (request = T.Utils.startAjaxRequest(ajaxId),
                !!request && request[0].always(function() {}).done(function(result) {
                    var showAjaxError;
                    if (null != result)
                        return showAjaxError = result.valid === !1 && null != result.error,
                        mod.toggleStateClass(mod.stateclass.ajaxError, showAjaxError),
                        $parentAjaxContainer.find("[data-replace-origin=" + targetId + "]").text(result.error)
                }).fail(function(xhr, ajaxOptions, thrownError) {
                    switch (xhr.status) {
                    case 500:
                        return mod.toggleStateClass(mod.stateclass.ajaxError);
                    default:
                        return mod.toggleStateClass(mod.stateclass.ajaxError, !1)
                    }
                })) : mod.toggleStateClass(mod.stateclass.ajaxError, !1)
            }),
            mod.elm.$autocompleteInitiatorAddresslookup.on("focus input", function(ev) {
                var $dependant, $parentAjaxContainer, $readonly, ajaxId, dependantId, dependantValue, initiator, inputValue, request, targetId;
                if (initiator = ev.currentTarget,
                inputValue = initiator.value,
                $parentAjaxContainer = $(initiator).closest(".js-ajax-request"),
                ajaxId = $(initiator).data("ajaxRequestId"),
                $readonly = $("form").find('[data-autocomplete="readonly"]'),
                targetId = $(initiator).prop("id"),
                inputValue && inputValue.length > 0 && "undefined" !== $parentAjaxContainer) {
                    if (dependantId = $(initiator).data("needs"),
                    $dependant = $parentAjaxContainer.find("#" + dependantId),
                    dependantValue = $dependant.val(),
                    !dependantValue)
                        return;
                    return request = T.Utils.startAjaxRequest(ajaxId),
                    !!request && request[0].always(function() {}).done(function(result) {
                        var adr, dependantMod, key, showAjaxError, value;
                        if (dependantMod = mod._sandbox.getModuleById($dependant.data("t-id")),
                        null == result)
                            return mod.toggleStateClass(mod.stateclass.ajaxError, !1),
                            dependantMod.toggleStateClass(mod.stateclass.ajaxError, !1);
                        if (!result.valid)
                            return mod._events.emit("forminput:triggerAAFDouble", {}),
                            showAjaxError = result.valid === !1 && null != result.error,
                            mod.toggleStateClass(mod.stateclass.ajaxError, showAjaxError),
                            dependantMod.toggleStateClass(mod.stateclass.ajaxError, showAjaxError),
                            "" !== targetId && $parentAjaxContainer.find("[data-replace-origin=" + targetId + "]").text(result.error).toggleClass("hidden", !1),
                            $parentAjaxContainer.find("[data-replace-origin=" + dependantId + "]").text(result.error).toggleClass("hidden", !0);
                        if (null != result.addresses) {
                            adr = result.addresses[0];
                            for (key in adr)
                                hasProp.call(adr, key) && (value = adr[key],
                                null != value && value.length > 0 && mod._events.emit("forminput:triggerAAFDouble", {
                                    id: key,
                                    val: value
                                }));
                            return mod.toggleStateClass(mod.stateclass.ajaxError, !1),
                            dependantMod.toggleStateClass(mod.stateclass.ajaxError, !1)
                        }
                    }).fail(function(xhr, ajaxOptions, thrownError) {
                        return console.error(xhr)
                    })
                }
                return mod.toggleStateClass(mod.stateclass.ajaxError, !1),
                $readonly.prop("readonly", !1)
            }),
            mod.elm.$autocompleteInitiatorPostalcode2Address.on("focus input", function(ev) {
                var $parentAjaxContainer, ajaxId, initiator, inputValue, request;
                return initiator = ev.currentTarget,
                inputValue = initiator.value,
                $parentAjaxContainer = $(initiator).closest(".js-ajax-request"),
                ajaxId = $(initiator).data("ajaxRequestId"),
                inputValue && inputValue.length >= 3 && "undefined" !== $parentAjaxContainer ? (request = T.Utils.startAjaxRequest(ajaxId),
                !!request && request[0].always(function() {}).done(function(result) {
                    var adr, key, lastIndex, results, value;
                    if (null != result && null != result.addresses) {
                        lastIndex = result.addresses.length - 1,
                        adr = result.addresses[lastIndex],
                        results = [];
                        for (key in adr)
                            hasProp.call(adr, key) && (value = adr[key],
                            null != value && value.length > 0 ? results.push(mod._events.emit("forminput:triggerAAFSingle", {
                                id: key,
                                val: value
                            })) : results.push(void 0));
                        return results
                    }
                }).fail(function(xhr, ajaxOptions, thrownError) {
                    return console.error(xhr)
                })) : mod.toggleStateClass(mod.stateclass.ajaxError, !1)
            }),
            mod.elm.$autocompleteInitiatorStaffSalesRegistration.each(function(_this) {
                return function(index, element) {
                    var $select;
                    return mod = _this,
                    $select = $(element).find("select"),
                    $select.length > 0 ? $(element).on("change", mod.staffsalesCheckRegistration) : $(element).on("focusout autocomplete.onload", mod.staffsalesCheckRegistration)
                }
            }(this)),
            mod.elm.$autocompleteInitiatorSingleresult.on("focus input", function(ev) {
                var $parentAjaxContainer, $suggestLayer, ajaxId, initiator, inputValue, request, targetId;
                return initiator = ev.currentTarget,
                inputValue = initiator.value,
                $parentAjaxContainer = $(initiator).closest(".js-ajax-request"),
                ajaxId = $(initiator).data("ajaxRequestId"),
                targetId = $(initiator).prop("id"),
                $suggestLayer = $parentAjaxContainer.find("[data-aaf-suggest-container=" + targetId + "]"),
                inputValue && inputValue.length > 0 && "undefined" !== $parentAjaxContainer ? (request = T.Utils.startAjaxRequest(ajaxId),
                !!request && request[0].always(function() {}).done(function(result) {
                    var reselectTarget, suggestResult;
                    if (null != result) {
                        if (result.valid)
                            return mod._events.emit("form:storeAutocompleteData", {
                                suggestData: result.addresses
                            }),
                            suggestResult = $parentAjaxContainer.find("[data-replace-container=" + ajaxId + "]").html(),
                            $suggestLayer.html(suggestResult),
                            mod._events.emit("form:toggleSuggestlayer", {
                                id: targetId,
                                show: !0
                            });
                        if (reselectTarget = $(initiator).data("autocomplete-reselect"),
                        null != reselectTarget)
                            return $("form").find("#" + reselectTarget).val("").trigger("change")
                    }
                }).fail(function(xhr, ajaxOptions, thrownError) {
                    return console.error(xhr)
                })) : mod._events.emit("form:toggleSuggestlayer", {
                    id: targetId,
                    show: !1
                })
            }),
            mod.elm.$autocompleteInitiatorTown2District.on("change", function(ev, data) {
                var $initiatorSelect, $initiatorSelectWrapper, $param, $parentAjaxContainer, ajaxId, inputValue, preselectedValue, request, targetHiddenErrorId, targetSelectId;
                return null != data && data.preventAjaxRequestByChange ? void (null != data.hidden && ($param = $("form").find("#" + data.hidden.hiddenRegionId),
                $param.val(data.hidden.hiddenRegionValue))) : ($initiatorSelectWrapper = $(ev.currentTarget),
                $initiatorSelect = $initiatorSelectWrapper.find("select"),
                inputValue = $initiatorSelect.val(),
                targetSelectId = $initiatorSelectWrapper.data("autocomplete-target"),
                targetHiddenErrorId = $initiatorSelectWrapper.data("autocomplete-hidden-error-id"),
                preselectedValue = $initiatorSelectWrapper.data("preselected-value"),
                $parentAjaxContainer = $initiatorSelect.closest(".js-ajax-request"),
                ajaxId = $initiatorSelectWrapper.data("ajaxRequestId"),
                inputValue && inputValue.length > 0 && "undefined" !== $parentAjaxContainer ? (request = T.Utils.startAjaxRequest(ajaxId),
                !!request && request[0].always(function() {}).done(function(result) {
                    var adr;
                    return null != result && result.valid ? (adr = result.addresses.map(function(item, i) {
                        return item[targetSelectId]
                    }),
                    adr.length > 0 && (mod._events.emit("forminput:triggerAAFMultiselect", {
                        group: mod.group,
                        id: targetSelectId,
                        options: adr,
                        preselected: preselectedValue
                    }),
                    $initiatorSelectWrapper.data("preselected-value", ""))) : mod.resetDropdownCascade({
                        errorCityfetch: !1,
                        errorTown2District: !1,
                        errorDistrict2HiddenZip: {
                            id: targetHiddenErrorId
                        }
                    }),
                    mod.elm.$input.trigger("triggerconstraint")
                }).fail(function(xhr, ajaxOptions, thrownError) {
                    return console.error(xhr)
                })) : mod.resetDropdownCascade({
                    errorCityfetch: !1,
                    errorTown2District: !1,
                    errorDistrict2HiddenZip: {
                        id: targetHiddenErrorId
                    }
                }))
            }),
            mod.elm.$autocompleteInitiatorDistrict2HiddenZip.on("change", function(ev, data) {
                var $initiatorSelect, $initiatorSelectWrapper, $param, $parentAjaxContainer, ajaxId, inputValue, request, targetHiddenId, targetHiddenObjname, targetSelectId, targetValue;
                return null != data && data.preventAjaxRequestByChange ? void (null != data.hidden && ($param = $("form").find("#" + data.hidden.hiddenZipId),
                $param.val(data.hidden.hiddenZipValue))) : ($initiatorSelectWrapper = $(ev.currentTarget),
                $initiatorSelect = $initiatorSelectWrapper.find("select"),
                inputValue = $initiatorSelect.val(),
                $parentAjaxContainer = $initiatorSelect.closest(".js-ajax-request"),
                ajaxId = $initiatorSelectWrapper.data("ajaxRequestId"),
                targetSelectId = $initiatorSelectWrapper.data("autocomplete-target"),
                targetHiddenId = $initiatorSelectWrapper.data("autocomplete-hidden-id"),
                targetHiddenObjname = $initiatorSelectWrapper.data("autocomplete-hidden-objname"),
                targetValue = "",
                null != targetHiddenId ? $param = $("form").find("#" + targetHiddenId) : console.error("error REGION2TOWN2DISTRICT_AUTOCOMPLETE (CN) last part - missing autocomplete-target, cannot set hidden value"),
                inputValue && inputValue.length > 0 && "undefined" !== $parentAjaxContainer ? (request = T.Utils.startAjaxRequest(ajaxId),
                !!request && request[0].always(function() {}).done(function(result) {
                    var adr;
                    return null != result && result.valid && (adr = result.addresses.filter(function(item) {
                        if (item[targetSelectId] === inputValue || item[targetHiddenObjname] === inputValue)
                            return !0
                    }),
                    adr.length > 0 && null != adr[0][targetHiddenObjname] && (targetValue = adr[0][targetHiddenObjname])),
                    $param.val(targetValue),
                    mod.elm.$input.trigger("triggerconstraint")
                }).fail(function(xhr, ajaxOptions, thrownError) {
                    return console.error(xhr)
                })) : $param.val(targetValue))
            }),
            mod.elm.$autocompleteInitiatorZip2City.on("focus input change", function(ev, data) {
                var $dependant, $parentAjaxContainer, $replace, $replaceWith, ajaxId, dependantId, dependantValue, initiator, inputValue, request;
                if (initiator = ev.currentTarget,
                inputValue = $(initiator).is(".m-forminput-dropdown") ? $(initiator).find("select").val() : initiator.value,
                $parentAjaxContainer = $(initiator).closest(".js-ajax-request"),
                ajaxId = $(initiator).data("ajaxRequestId"),
                $replace = $parentAjaxContainer.find('[data-autocomplete="replace"]'),
                $replaceWith = $parentAjaxContainer.find("[data-replace-container=" + ajaxId + "]"),
                inputValue && inputValue.length >= 3 && "undefined" !== $parentAjaxContainer) {
                    if (dependantId = $(initiator).data("needs"),
                    $dependant = $parentAjaxContainer.find("#" + dependantId),
                    dependantValue = $dependant.val(),
                    null == dependantValue)
                        return;
                    return "" === dependantValue ? void mod._events.emit("form:toggleReplacelayer", {
                        show: $replace,
                        hide: $replaceWith,
                        cssClass: "hidden"
                    }) : (request = T.Utils.startAjaxRequest(ajaxId),
                    !!request && request[0].always(function() {}).done(function(result) {
                        var adr, targetSelectId;
                        return null != result && (result.valid ? null != result.addresses && (targetSelectId = $replace.data("objName"),
                        adr = result.addresses.map(function(item, i) {
                            return item[targetSelectId]
                        }),
                        adr.length > 0 && mod._events.emit("form:triggerAAFReplace", {
                            ajaxId: ajaxId,
                            id: targetSelectId,
                            options: adr
                        })) : mod._events.emit("form:toggleReplacelayer", {
                            show: $replace,
                            hide: $replaceWith,
                            cssClass: "hidden"
                        })),
                        mod.elm.$input.trigger("triggerconstraint")
                    }).fail(function(xhr, ajaxOptions, thrownError) {
                        return console.error(xhr)
                    }))
                }
                return mod._events.emit("form:toggleReplacelayer", {
                    show: $replace,
                    hide: $replaceWith,
                    cssClass: "hidden"
                })
            }),
            mod.elm.$autocompleteInitiatorCity2Zip.on("change", function(ev, data) {
                var $initiatorSelect, $initiatorSelectWrapper, $param, inputValue, targetObjname;
                return null != data && data.preventAjaxRequestByChange ? void (null != data.visible && ($param = $("form").find("#" + data.visible.visibleZipId),
                $param.val(data.visible.visibleZipValue))) : ($initiatorSelectWrapper = $(ev.currentTarget),
                $initiatorSelect = $initiatorSelectWrapper.find("select"),
                inputValue = $initiatorSelect.val(),
                targetObjname = $initiatorSelectWrapper.data("autocomplete-city2zip-target"),
                null != targetObjname ? $("form").find("#" + targetObjname).val(inputValue) : void 0)
            }),
            mod.elm.$input.on("edit", $.proxy(function(ev, eventData) {
                var $target, invertReadonly, target;
                if (ev.preventDefault(),
                ev.stopPropagation(),
                target = ev.currentTarget,
                invertReadonly = eventData.invert,
                $target = "INPUT" === target.tagName ? $(target) : $(target).find(":checkbox, :radio, :hidden:not(option)"),
                $target.length > 0)
                    return mod.makeEditable($target, invertReadonly)
            }, mod))
        },
        staffsalesCheckRegistration: function(ev) {
            var $parentAjaxContainer, ajaxId, initiator, mod, request;
            return mod = this,
            initiator = ev.currentTarget,
            $parentAjaxContainer = $(initiator).closest(".js-ajax-request"),
            ajaxId = $(initiator).data("ajaxRequestId"),
            "undefined" !== $parentAjaxContainer ? (request = T.Utils.startAjaxRequest(ajaxId),
            !!request && request[0].always(function() {}).done(function(result) {
                var e;
                try {
                    result = JSON.parse(result)
                } catch (error) {
                    e = error,
                    console.error(e.description)
                }
                if (null != result && null != result.fields)
                    return mod._events.emit("forminput:triggerAAFRegistration", {
                        result: result
                    })
            }).fail(function(xhr, ajaxOptions, thrownError) {
                return console.info(xhr)
            })) : mod.toggleStateClass(mod.stateclass.ajaxError, !1)
        },
        constraintRequest: function(constraintType) {
            var $groupSet, $select, data, followUp, handleResult, response, url;
            if ($groupSet = !1,
            constraintType = constraintType || "attr",
            "type" === constraintType) {
                if (!this.elm.typeConstraintsSelection && (this.elm.typeConstraintsSelection = this.getTypeConstraintSelection(this.elm.$inputGroup, this.constraint.type.validationArray),
                !this.elm.typeConstraintsSelection.length))
                    return;
                if ($groupSet = this.getSelectionOfArray(this.elm.typeConstraintsSelection, ":valid"),
                !$groupSet.length)
                    return !1;
                url = this.constraint.type.url,
                $select = this.elm.$inputGroup
            } else
                "attr" === constraintType && (url = this.constraint.attr.url,
                $select = this.$ctx,
                this.state.bothConstraintTrigger && (followUp = this.constraintRequest));
            return data = T.Utils.getFormDataPairs($select, "data-constraint-attribute-name"),
            handleResult = this.evaluateConstraintResponse,
            response = T.Utils.startAjaxRequest(!1, {
                url: url,
                method: "POST"
            }, data),
            response[0].done(function(_this) {
                return function(result) {
                    if (handleResult(result, $groupSet),
                    followUp && !_this.$ctx.hasClass(_this.stateclass.error))
                        return followUp("type")
                }
            }(this)).fail(function(xhr, ajaxOptions, thrownError) {
                return console.error(xhr)
            })
        },
        evaluateConstraintResponse: function(response, $groupSet) {
            var $elm, $input, $nested, elm, j, len, message, violationArray;
            if (response.constraintViolations.length && this.constraint) {
                if (violationArray = this.groupObjectArrayByKeys(response.constraintViolations, "property", "message"),
                message = "",
                $groupSet && $groupSet.length)
                    for (j = 0,
                    len = $groupSet.length; j < len; j++)
                        elm = $groupSet[j],
                        $elm = $(elm),
                        $nested = $elm.find("input, select"),
                        $input = $nested.length ? $nested : $elm,
                        $elm.trigger("setInputError", this.wrapInParagraphs(violationArray[$input.data("constraintAttributeName")]));
                else
                    message = this.wrapInParagraphs(violationArray[this.constraint.attrName]),
                    this.$ctx.trigger("setInputError", message);
                return violationArray
            }
            return $elm = $groupSet ? $groupSet : this.$ctx,
            $elm.trigger("setInputError"),
            !1
        },
        getSelectionOfArray: function(typeConstraintsSelection, selector) {
            var $constraint, $selection, count, countFiltered, j, len;
            if (typeConstraintsSelection.constructor !== Array || !typeConstraintsSelection.length)
                return !1;
            for ($selection = $(),
            j = 0,
            len = typeConstraintsSelection.length; j < len; j++)
                $constraint = typeConstraintsSelection[j],
                count = $constraint.length,
                countFiltered = $constraint.find("input, select").length ? count : $constraint.filter(function() {
                    return $(this).is(selector)
                }).length,
                count === countFiltered && ($selection = $selection.add($constraint));
            return $selection
        },
        getTypeConstraintSelection: function($group, validationArray) {
            var $typeConstaint, j, len, typeConstraint, typeConstraintsSelection;
            for (typeConstraintsSelection = [],
            j = 0,
            len = validationArray.length; j < len; j++)
                typeConstraint = validationArray[j],
                $typeConstaint = $group.filter(function(i) {
                    var $elmConstraintSet;
                    if ($elmConstraintSet = $($group[i]).data("typeConstraints"),
                    $elmConstraintSet && indexOf.call($elmConstraintSet, typeConstraint) >= 0)
                        return !0
                }),
                $typeConstaint.length && typeConstraintsSelection.push($typeConstaint);
            return typeConstraintsSelection
        },
        groupObjectArrayByKeys: function(result, prop, togroup) {
            var groupedResult, input, j, key, len, message;
            for (groupedResult = [],
            j = 0,
            len = result.length; j < len; j++)
                input = result[j],
                key = input[prop],
                message = input[togroup],
                groupedResult[key] || (groupedResult[key] = []),
                groupedResult[key].push(message);
            return groupedResult
        },
        toggleStateClass: function(state, set, ctx) {
            var $wrapper, show;
            return show = "undefined" == typeof set || set,
            $wrapper = "undefined" == typeof ctx ? this.$ctx : ctx,
            $wrapper.toggleClass(state, show)
        },
        makeEditable: function($elm, blnInvertReadonly) {
            return $elm.prop("readonly", blnInvertReadonly)
        },
        preventSelectingReadonlyFields: function(blnPrevent) {
            var mod;
            if (mod = this,
            null != mod.elm.$inputField && mod.elm.$inputField.length)
                return blnPrevent ? (mod.$('label[for="' + mod.elm.$inputField.attr("id") + '"]').on("click", function(ev) {
                    return ev.preventDefault()
                }),
                mod.elm.$inputField.attr("tabindex", "-1")) : (mod.$('label[for="' + mod.elm.$inputField.attr("id") + '"]').off("click"),
                mod.elm.$inputField.attr("tabindex", "0"))
        },
        resetDropdownCascade: function(errorObj) {
            var targetCity2ZipResetId, targetHiddenErrorId;
            if (errorObj.errorCityfetch && this.elm.$inputGroup.filter('[data-autocomplete="cityfetch"]').trigger("edit", {
                invert: !0
            }),
            errorObj.errorTown2District && this.elm.$inputGroup.filter("[data-autocomplete-town2district]").trigger("edit", {
                invert: !0
            }),
            null != errorObj.errorDistrict2HiddenZip && (targetHiddenErrorId = errorObj.errorDistrict2HiddenZip.id,
            this.elm.$inputGroup.filter("[data-autocomplete-district2hiddenzip]").trigger("edit", {
                invert: !0
            }),
            $("form").find("#" + targetHiddenErrorId).val("")),
            null != errorObj.errorCity2Zip)
                return targetCity2ZipResetId = errorObj.errorCity2Zip.id,
                $("form").find("#" + targetCity2ZipResetId).val("")
        },
        toggleDisabled: function($enable, $disable, blnInvertReadonly) {
            return $enable.is("select") && $enable.parent().removeClass("inactive-without-value"),
            $disable.is("select") && $disable.parent().removeClass("inactive-without-value"),
            $enable.attr("disabled", blnInvertReadonly),
            $disable.attr("disabled", !blnInvertReadonly)
        },
        triggerConstraints: function() {
            var $elm;
            if ($elm = this.$ctx,
            $elm.is(":invalid") || $elm.hasClass(this.stateclass.error) || $elm.hasClass(this.stateclass.noConfirm) || $elm.hasClass(this.stateclass.ajaxError))
                return !1;
            if (this.state.attrConstraintTrigger) {
                if ($elm.is("empty"))
                    return !1;
                this.constraintRequest("attr")
            } else
                this.state.typeConstraintTrigger && this.constraintRequest("type");
            return !0
        },
        wrapInParagraphs: function(message) {
            var j, len, parag, text;
            if (text = "",
            "[object Array]" === Object.prototype.toString.call(message))
                for (j = 0,
                len = message.length; j < len; j++)
                    parag = message[j],
                    Boolean(parag) && (text += "<p>" + parag + "</p>");
            else
                Boolean(message) && (text = "<p>" + message + "</p>");
            return text
        },
        onChangeAutocompleteInitiatorCityfetch: function(ev, data) {
            var $initiatorSelect, $initiatorSelectWrapper, $parentAjaxContainer, ajaxId, inputValue, mod, preselectedValue, request, targetCity2ZipResetId, targetHiddenErrorId, targetHiddenId, targetOptionName, targetSelectId;
            if (mod = this,
            null == data || !data.preventAjaxRequestByChange)
                return $initiatorSelectWrapper = $(ev.currentTarget),
                $initiatorSelect = $initiatorSelectWrapper.find("select"),
                inputValue = $initiatorSelect.val(),
                $parentAjaxContainer = $initiatorSelect.closest(".js-ajax-request"),
                ajaxId = $initiatorSelectWrapper.data("ajaxRequestId"),
                targetSelectId = $initiatorSelectWrapper.data("autocomplete-target"),
                targetHiddenId = $initiatorSelectWrapper.data("autocomplete-hidden-target"),
                targetHiddenErrorId = $initiatorSelectWrapper.data("autocomplete-hidden-error-id"),
                targetOptionName = $initiatorSelectWrapper.data("autocomplete-city2zip-key"),
                targetCity2ZipResetId = $initiatorSelectWrapper.data("autocomplete-city2zip-reset-target"),
                preselectedValue = $initiatorSelectWrapper.data("preselected-value"),
                inputValue && inputValue.length > 0 && "undefined" !== $parentAjaxContainer ? (request = T.Utils.startAjaxRequest(ajaxId),
                !!request && request[0].always(function() {}).done(function(result) {
                    var $autocomplete, $param, adr, adrObj, cleanedObj, j, k, key, len, len1, ref, remappedObj, returnReduced, returnRemapped, value;
                    if (null == result)
                        return mod.resetDropdownCascade({
                            errorCityfetch: !0,
                            errorTown2District: !0,
                            errorDistrict2HiddenZip: {
                                id: targetHiddenErrorId
                            },
                            errorCity2Zip: {
                                id: targetCity2ZipResetId
                            }
                        });
                    if (!result.valid)
                        return mod.resetDropdownCascade({
                            errorCityfetch: !0,
                            errorTown2District: !0,
                            errorDistrict2HiddenZip: {
                                id: targetHiddenErrorId
                            },
                            errorCity2Zip: {
                                id: targetCity2ZipResetId
                            }
                        });
                    if (null != targetOptionName) {
                        for (returnReduced = [],
                        ref = result.addresses,
                        j = 0,
                        len = ref.length; j < len; j++) {
                            adrObj = ref[j],
                            cleanedObj = {};
                            for (key in adrObj)
                                hasProp.call(adrObj, key) && (value = adrObj[key],
                                key !== targetSelectId && key !== targetOptionName || null != value && (value.length > 0 || "object" == typeof value) && (cleanedObj[key] = value));
                            returnReduced.push(cleanedObj)
                        }
                        for (returnRemapped = [],
                        k = 0,
                        len1 = returnReduced.length; k < len1; k++) {
                            adrObj = returnReduced[k],
                            remappedObj = {};
                            for (key in adrObj)
                                hasProp.call(adrObj, key) && (value = adrObj[key],
                                key === targetSelectId ? null != value && (value.length > 0 || "object" == typeof value) && (remappedObj.text = value) : key === targetOptionName && null != value && (value.length > 0 || "object" == typeof value) && (remappedObj.id = value),
                                delete returnReduced[key]);
                            returnRemapped.push(remappedObj)
                        }
                        adr = returnRemapped
                    } else
                        adr = result.addresses.map(function(item, i) {
                            return item[targetSelectId]
                        });
                    return null != targetHiddenId && ($param = $("form").find("#" + targetHiddenId),
                    $param.val(inputValue)),
                    adr.length > 0 ? ($autocomplete = mod.elm.$inputGroup.find("select").filter('[data-obj-name="' + targetSelectId + '"]'),
                    $autocomplete.trigger("forminput:triggerAAFSelect", {
                        options: adr,
                        preselected: preselectedValue
                    }),
                    $initiatorSelectWrapper.data("preselected-value", "")) : void 0
                }).fail(function(xhr, ajaxOptions, thrownError) {
                    return console.error(xhr)
                })) : void 0
        },
        onHandleCustomError: function(ev, errorMessage, append) {
            var $errorbox, $input, index;
            if ($input = this.elm.$input,
            this.toggleStateClass(this.stateclass.error, Boolean(errorMessage)),
            !Boolean(errorMessage))
                return !0;
            if (this.toggleStateClass(this.stateclass.focused, !1),
            index = ($($input).data("fieldNr") || 1) - 1,
            this.elm.$constraintErrorBox || (this.elm.$constraintErrorBox = $($input).parent().find(".js-custom-error-message").eq(index)),
            $errorbox = this.elm.$constraintErrorBox,
            $errorbox && $errorbox.length) {
                if ($errorbox.html().indexOf(errorMessage) !== -1)
                    return !0;
                append ? $errorbox.append(errorMessage) : $errorbox.html(errorMessage)
            }
            return !0
        },
        onFocusInput: function(ev) {
            return this.toggleStateClass(this.stateclass.focused, !1)
        },
        onFocusoutConfirm: function(ev) {
            var confirmation, confirmid, value;
            confirmation = ev.currentTarget.value,
            confirmation && (confirmid = $(ev.currentTarget).attr("data-confirm-field"),
            value = document.getElementById(confirmid).value,
            this.toggleStateClass(this.stateclass.noConfirm, (null != value ? value.toLowerCase() : void 0) !== (null != confirmation ? confirmation.toLowerCase() : void 0)))
        },
        onFocusoutInput: function(ev) {
            var $input, isEmpty, mod;
            if (mod = this,
            $input = mod.elm.$input.is(":input") ? mod.elm.$input : mod.$(":input"),
            isEmpty = null == $input.val() || !$input.val().length,
            mod.toggleStateClass(mod.stateclass.focused),
            mod.toggleStateClass(mod.stateclass.error + " " + mod.stateclass.noerror, !1),
            mod.toggleStateClass(mod.stateclass.empty, isEmpty),
            mod._events.emit("form:hideSuggestlayers"),
            !this.isAutocompleteTrigger && this.constraint && this.state.constraintTrigger)
                return this.triggerConstraints()
        },
        onChangeInput: function(ev, data) {
            var $input, $preselectRegionKey, $preselectZipKey, $select, changeByAutocomplete, mod;
            return mod = this,
            $input = mod.$ctx,
            $select = $input.find("select"),
            $preselectRegionKey = $select.data("preselect-region-key"),
            $preselectZipKey = $select.data("preselect-city-key"),
            changeByAutocomplete = null != data && data.preventAjaxRequestByChange,
            changeByAutocomplete && ($preselectRegionKey || $preselectZipKey) || this.toggleStateClass(this.stateclass.error + " " + this.stateclass.noerror, !1),
            !0
        },
        onKeyupOrChangeInput: function(ev) {
            var mod;
            return mod = this,
            mod.toggleStateClass(mod.stateclass.error + " " + mod.stateclass.noerror, !1),
            mod.isCheckbox ? mod.elm.$inputField.removeClass(mod.stateclass.error) : mod.toggleStateClass(mod.stateclass.empty, "" === ev.currentTarget.value)
        },
        onPreselect: function(data) {
            var $input, $parentForm, $preselectRegionKey, $preselectZipKey, $select, $selectWrapper, allDataAvailable, key, mod, parsedRequestData, request, requestData, requestId, targetPreselectCity2zipKey, targetPreselectCity2zipTarget, targetPreselectCityByKey, targetPreselectDistrict2zipKey, targetPreselectHiddenRegion, targetPreselectHiddenZip, targetSelectId, targetTId, value;
            if (mod = this,
            $input = mod.$ctx,
            $input.is(".m-forminput-dropdown") && ($selectWrapper = $input,
            $parentForm = $selectWrapper.closest(".m-form"),
            targetTId = "" + data.targetTId,
            $parentForm.attr("data-t-id") === targetTId && ($select = $input.find("select"),
            $preselectRegionKey = $select.data("preselect-region-key"),
            $preselectZipKey = $select.data("preselect-city-key"),
            null != $preselectRegionKey || null != $preselectZipKey))) {
                requestId = $select.data("preselect-request"),
                targetSelectId = $select.data("objName"),
                targetPreselectCityByKey = $select.data("preselectCityByKey"),
                targetPreselectHiddenRegion = $select.data("preselectHiddenRegion"),
                targetPreselectHiddenZip = $select.data("preselectHiddenZip"),
                targetPreselectDistrict2zipKey = $select.data("preselectDistrict2zipKey"),
                targetPreselectCity2zipKey = $select.data("preselectCity2zipKey"),
                targetPreselectCity2zipTarget = $select.data("preselectCity2zipTarget"),
                requestData = $select.attr("data-preselect-request-data");
                try {
                    parsedRequestData = JSON.parse(requestData)
                } catch (undefined) {}
                if (requestData = parsedRequestData || {},
                $.isEmptyObject(requestData)) {
                    if (request = T.Utils.startAjaxRequest(requestId),
                    !request)
                        return !1
                } else {
                    allDataAvailable = !0;
                    for (key in requestData)
                        if (value = requestData[key],
                        null == value || "" === value) {
                            allDataAvailable = !1;
                            break
                        }
                    if (!allDataAvailable)
                        return !1;
                    if (request = T.Utils.startAjaxRequest(requestId, null, requestData),
                    !request)
                        return !1
                }
                return request[0].always(function() {}).done(function(result) {
                    var adr, adrObj, cleanedObj, hiddenDistrictZipValue, hiddenRegionId, hiddenZipId, hiddenZipValue, j, k, l, len, len1, len2, len3, len4, len5, len6, len7, m, n, o, p, q, ref, ref1, ref2, remappedObj, remappedObj2, remappedObj3, returnReduced, returnReduced2, returnReduced3, returnRemapped, returnRemapped2, returnRemapped3, visibleZipValue;
                    if (null != result && result.valid) {
                        if (null != targetPreselectCityByKey) {
                            for (returnReduced = [],
                            ref = result.addresses,
                            j = 0,
                            len = ref.length; j < len; j++) {
                                adrObj = ref[j],
                                cleanedObj = {};
                                for (key in adrObj)
                                    hasProp.call(adrObj, key) && (value = adrObj[key],
                                    key !== targetSelectId && key !== targetPreselectCityByKey || null != value && (value.length > 0 || "object" == typeof value) && (cleanedObj[key] = value));
                                returnReduced.push(cleanedObj)
                            }
                            for (returnRemapped = [],
                            k = 0,
                            len1 = returnReduced.length; k < len1; k++) {
                                adrObj = returnReduced[k],
                                remappedObj = {};
                                for (key in adrObj)
                                    hasProp.call(adrObj, key) && (value = adrObj[key],
                                    key === targetSelectId ? null != value && (value.length > 0 || "object" == typeof value) && (remappedObj.text = value) : key === targetPreselectCityByKey && null != value && (value.length > 0 || "object" == typeof value) && (remappedObj.id = value),
                                    delete returnReduced[key]);
                                returnRemapped.push(remappedObj)
                            }
                            adr = returnRemapped
                        } else
                            adr = null != targetPreselectCity2zipKey ? result.addresses.map(function(item, i) {
                                return {
                                    text: item[targetSelectId],
                                    id: item[targetPreselectCity2zipKey]
                                }
                            }) : result.addresses.map(function(item, i) {
                                return item[targetSelectId]
                            });
                        if (null != targetPreselectCity2zipKey) {
                            for (returnReduced2 = [],
                            ref1 = result.addresses,
                            l = 0,
                            len2 = ref1.length; l < len2; l++) {
                                adrObj = ref1[l],
                                cleanedObj = {};
                                for (key in adrObj)
                                    hasProp.call(adrObj, key) && (value = adrObj[key],
                                    key !== targetSelectId && key !== targetPreselectCity2zipKey || null != value && (value.length > 0 || "object" == typeof value) && (cleanedObj[key] = value));
                                returnReduced2.push(cleanedObj)
                            }
                            for (returnRemapped2 = [],
                            m = 0,
                            len3 = returnReduced2.length; m < len3; m++) {
                                adrObj = returnReduced2[m],
                                remappedObj2 = {};
                                for (key in adrObj)
                                    hasProp.call(adrObj, key) && (value = adrObj[key],
                                    value === $preselectZipKey && (remappedObj2 = adrObj));
                                $.isEmptyObject(remappedObj2) || returnRemapped2.push(remappedObj2)
                            }
                            for (n = 0,
                            len4 = returnRemapped2.length; n < len4; n++) {
                                adrObj = returnRemapped2[n];
                                for (key in adrObj)
                                    hasProp.call(adrObj, key) && (value = adrObj[key],
                                    key === targetPreselectCity2zipKey && (visibleZipValue = value))
                            }
                        }
                        if (null != targetPreselectDistrict2zipKey) {
                            for (returnReduced3 = [],
                            ref2 = result.addresses,
                            o = 0,
                            len5 = ref2.length; o < len5; o++) {
                                adrObj = ref2[o],
                                cleanedObj = {};
                                for (key in adrObj)
                                    hasProp.call(adrObj, key) && (value = adrObj[key],
                                    key !== targetSelectId && key !== targetPreselectDistrict2zipKey || null != value && (value.length > 0 || "object" == typeof value) && (cleanedObj[key] = value));
                                returnReduced3.push(cleanedObj)
                            }
                            for (returnRemapped3 = [],
                            p = 0,
                            len6 = returnReduced3.length; p < len6; p++) {
                                adrObj = returnReduced3[p],
                                remappedObj3 = {};
                                for (key in adrObj)
                                    hasProp.call(adrObj, key) && (value = adrObj[key],
                                    value === $preselectZipKey && (remappedObj3 = adrObj));
                                $.isEmptyObject(remappedObj3) || returnRemapped3.push(remappedObj3)
                            }
                            for (q = 0,
                            len7 = returnRemapped3.length; q < len7; q++) {
                                adrObj = returnRemapped3[q];
                                for (key in adrObj)
                                    hasProp.call(adrObj, key) && (value = adrObj[key],
                                    key === targetPreselectDistrict2zipKey && (hiddenDistrictZipValue = value))
                            }
                        }
                        if (adr.length > 0)
                            return null != targetPreselectHiddenRegion && (hiddenRegionId = targetPreselectHiddenRegion),
                            null != targetPreselectHiddenZip && (hiddenZipId = targetPreselectHiddenZip),
                            null != targetPreselectHiddenRegion || null != targetPreselectHiddenZip ? (hiddenZipValue = targetPreselectDistrict2zipKey ? hiddenDistrictZipValue : $preselectZipKey,
                            mod._events.emit("forminput:triggerAAFPreselect", {
                                group: mod.group,
                                id: targetSelectId,
                                options: adr,
                                preselected: $preselectZipKey,
                                hidden: {
                                    hiddenRegionId: hiddenRegionId,
                                    hiddenRegionValue: $preselectRegionKey,
                                    hiddenZipId: hiddenZipId,
                                    hiddenZipValue: hiddenZipValue
                                }
                            })) : null != visibleZipValue ? mod._events.emit("forminput:triggerAAFPreselect", {
                                group: mod.group,
                                id: targetSelectId,
                                options: adr,
                                preselected: $preselectZipKey,
                                visible: {
                                    visibleZipId: targetPreselectCity2zipTarget,
                                    visibleZipValue: visibleZipValue
                                }
                            }) : mod._events.emit("forminput:triggerAAFPreselect", {
                                group: mod.group,
                                id: targetSelectId,
                                options: adr,
                                preselected: $preselectZipKey
                            })
                    }
                }).fail(function(xhr, ajaxOptions, thrownError) {
                    return console.error(xhr)
                })
            }
        },
        onSetCustomError: function(ev, set) {
            return this.toggleStateClass(this.stateclass.focused, !1),
            this.toggleStateClass(this.stateclass.error, set)
        },
        onTriggerAAFDouble: function(data) {
            var $input, name;
            return null == data.id ? this.$ctx.filter(".is-aaf-double").removeClass("is-aaf-double").val("").prop("readonly", !1) : ($input = this.$ctx,
            name = $input.data("objName"),
            name === data.id && ($input.val(data.val).addClass("is-aaf-double"),
            "readonly" === $input.data("autocomplete")) ? $input.prop("readonly", !0) : void 0)
        },
        onTriggerAAFMultiselect: function(data) {
            var $input, $select, dataAttr, mod, name, val;
            if (mod = this,
            $input = mod.$ctx,
            dataAttr = $input.data("autocomplete"),
            "multifetch" === dataAttr && null != data && null != data.id && ($select = $input.find("select"),
            name = $select.data("objName"),
            name === data.id && this.group === data.group)) {
                switch ($select.find("option.was-disabled").toggleClass("was-disabled", !1).prop("disabled", !0),
                $select.find("option:not(:disabled)").remove(),
                $select.find("option:disabled").toggleClass("was-disabled", !0).prop("disabled", !1),
                $select.select2({
                    data: data.options,
                    minimumResultsForSearch: -1
                }),
                T.Utils.getViewport()) {
                case "mobile":
                    $select.select2("destroy")
                }
                return null != data.options && "multifetch" === dataAttr && $input.trigger("edit", {
                    invert: !1
                }),
                null != data.preselected && $select.find("option[value='" + data.preselected + "']").length ? (val = data.preselected,
                $select.val(val).trigger("change")) : $select.val("").trigger("change")
            }
        },
        onTriggerAAFPreselect: function(data) {
            var $input, $options, $select, hiddenData, mod, name, val, visibleData, wasDisabled;
            if (mod = this,
            $input = mod.$ctx,
            null != data && null != data.id && ($select = $input.find("select"),
            name = $select.data("objName"),
            name === data.id && this.group === data.group)) {
                switch ($select.find("option.was-disabled").toggleClass("was-disabled", !1).prop("disabled", !0),
                $select.find("option:not(:disabled)").remove(),
                $select.find("option:disabled").toggleClass("was-disabled", !0).prop("disabled", !1),
                $select.select2({
                    data: data.options,
                    minimumResultsForSearch: -1
                }),
                T.Utils.getViewport()) {
                case "mobile":
                    $select.select2("destroy")
                }
                if (wasDisabled = "readonly" === $input.closest(".m-form").data("invert"),
                null != data.options && $input.trigger("edit", {
                    invert: !data.options.length > 0
                }),
                null != data.preselected ? (val = data.preselected,
                $options = $("option", $select),
                $options.filter(function() {
                    return $(this).val() === val
                }).length || $options.filter(function() {
                    return $(this).html() === val
                }).length && (val = $options.filter(function() {
                    return $(this).html() === val
                }).get(0).value),
                null != data.hidden ? (hiddenData = data.hidden,
                $select.val(val).trigger("change", {
                    preventAjaxRequestByChange: !0,
                    hidden: hiddenData
                })) : null != data.visible ? (visibleData = data.visible,
                $select.val(val).trigger("change", {
                    preventAjaxRequestByChange: !0,
                    visible: visibleData
                })) : $select.val(val).trigger("change", {
                    preventAjaxRequestByChange: !1
                })) : $select.val("").trigger("change", {
                    preventAjaxRequestByChange: !0
                }),
                wasDisabled && null != data.options)
                    return $input.trigger("edit", {
                        invert: data.options.length > 0
                    })
            }
        },
        onTriggerAAFSelect: function(ev, data) {
            var $input, $select, mod, val;
            if (mod = this,
            $input = mod.$ctx,
            $select = $(ev.currentTarget),
            null != data) {
                switch ($select.find("option.was-disabled").toggleClass("was-disabled", !1).prop("disabled", !0),
                $select.find("option:not(:disabled)").remove(),
                $select.find("option:disabled").toggleClass("was-disabled", !0).prop("disabled", !1),
                $select.select2({
                    data: data.options,
                    minimumResultsForSearch: -1
                }),
                T.Utils.getViewport()) {
                case "mobile":
                    $select.select2("destroy")
                }
                return null != data.options && "cityfetch" === $input.data("autocomplete") && $input.trigger("edit", {
                    invert: !Boolean(data.options.length)
                }),
                null != data.preselected ? (val = data.preselected,
                $select.val(val).trigger("change")) : $select.val("").trigger("change")
            }
        },
        onTriggerAAFSingle: function(data) {
            var $input, name;
            if (null != data.id && ($input = this.$ctx,
            name = $input.data("objName"),
            name === data.id && "single" !== $input.data("autocomplete")))
                return $input.val(data.val)
        },
        onTriggerAAFRegistration: function(data) {
            var $input, $select, field, j, len, name, ref, results;
            if (null != data.result.fields && ($input = this.$ctx,
            $select = $input.find("select"),
            name = $select.length > 0 ? $select.data("objName") : $input.data("objName"),
            null != name)) {
                for (ref = data.result.fields,
                results = [],
                j = 0,
                len = ref.length; j < len; j++)
                    field = ref[j],
                    null != field.field && field.field === name ? (null != field.value && ($select.length > 0 ? null != field.options ? this.replaceTheSelectOptionsAndSelectValue($select, field.options, field.value) : $select.val(field.value).trigger("change.select2") : $input.val(field.value)),
                    null != field.type && "error" === field.type && this.$ctx.trigger("setInputError", field.reason),
                    $select.length > 0 ? (T.Utils.createHiddenElementForReadonly($select, ".select-wrap"),
                    results.push($select.trigger("edit", {
                        invert: field.disabled
                    }))) : results.push($input.prop("readonly", field.disabled))) : results.push(void 0);
                return results
            }
        },
        replaceTheSelectOptionsAndSelectValue: function($select, $options, $value) {
            var $placeHolder, $selectOptions, j, len, option;
            for ($selectOptions = [],
            $placeHolder = "",
            j = 0,
            len = $options.length; j < len; j++)
                option = $options[j],
                "" === option.value && ($placeHolder = option.label),
                $selectOptions.push({
                    id: option.value,
                    text: option.label
                });
            if ($select.empty().select2({
                data: $selectOptions,
                placeholder: $placeHolder,
                minimumResultsForSearch: -1
            }),
            null != $value)
                return $select.val($value).trigger("change.select2")
        },
        onTriggerAAFSuggest: function(data) {
            var $input, $select, adr, dataAttr, indicator, key, mod, name, results, value;
            if (mod = this,
            $input = mod.$ctx,
            name = $input.data("objName"),
            dataAttr = $input.data("autocomplete"),
            ($input.prop("id") || "regionfetch" === dataAttr) && null != data && null != data.address1) {
                adr = data.address1,
                results = [];
                for (key in adr)
                    hasProp.call(adr, key) && (value = adr[key],
                    null != value ? (indicator = name ? name : key,
                    value.length > 0 && $input.data("objName") === indicator && key === indicator && ($input.val(value),
                    delete adr[key]),
                    "object" == typeof value && "regionfetch" === dataAttr && null != value.uniqueIdentifier ? ($select = $input.find("select"),
                    $select.val(value.uniqueIdentifier).trigger("change"),
                    results.push(delete adr[key])) : results.push(void 0)) : results.push(void 0));
                return results
            }
        }
    })
}(jQuery),
function($) {
    T.Module.HelpfulFunction = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.elm = {
                $trigger: mod.$(".js-trigger-helpful")
            },
            mod.state = {
                rated: "was-rated"
            },
            mod.config = mod.$ctx.data(),
            mod.cookieData = "_helpfulFunction_voted=" + mod.config.id,
            T.Utils.cookieHandling(mod.cookieData, "isset") && mod.hideVote(),
            mod.elm.$trigger.on("click", $.proxy(this.onTriggerClick, this)),
            resolve()
        },
        hideVote: function() {
            var mod;
            return mod = this,
            mod.$ctx.addClass(mod.state.rated)
        },
        onTriggerClick: function(e) {
            var mod;
            return e.preventDefault(),
            mod = this,
            mod.hideVote(),
            T.Utils.cookieHandling(mod.cookieData, "set")
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.ImageList = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.ImageSequencer = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            Magic360.lang = {
                "hint-text": this.$ctx.data("hint-text"),
                "mobile-hint-text": this.$ctx.data("hint-text-mobile")
            },
            resolve()
        }
    })
}(jQuery),
function($) {
    T.Module.ItemServiceItem = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    var closeButtonSelector;
    closeButtonSelector = ".js-close-button",
    T.Module.Layer = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$background = this.$(".js-overlay"),
            this.$closeButton = this.$(closeButtonSelector),
            this.configuration = this.$ctx.data(),
            $(document).on("click", "[data-layer-id='" + this.configuration.id + "']", $.proxy(this.onClickTrigger, this)),
            this.$ctx.data("openonload") && this.openLayer(),
            this.$closeButton.length && (this.$ctx.on("click", closeButtonSelector, $.proxy(this.onClickCloseButton, this)),
            this.$background.on("click", $.proxy(this.onClickBackground, this)),
            $(document).on("keyup", $.proxy(this.onKeyup, this))),
            this._events.on("sparepartsCloseLayer", $.proxy(this.hideLayer, this)),
            this._events.on("hideLayer", $.proxy(this.hideLayer, this)),
            this._events.on("showLayer", $.proxy(this.onShowLayer, this)),
            resolve()
        },
        sync: function() {},
        hideLayer: function(skipEmit) {
            if (this.$ctx.removeClass("is-active"),
            this._events.emit("togglePageScrolling", {
                pin: !1
            }),
            !skipEmit)
                return this._events.emit("closeLayer", {
                    $ctx: this.$ctx
                })
        },
        showLayer: function($triggerElement, emitOpenLayerEvent) {
            if (this.$ctx.addClass("is-active"),
            this.$background.css("right", T.Utils.getScrollbarWidth()),
            this._events.emit("reArrangeTabs"),
            emitOpenLayerEvent)
                return this._events.emit("openLayer", {
                    $ctx: this.$ctx,
                    $triggerElement: $triggerElement
                })
        },
        openLayer: function() {
            return this.$ctx.addClass("is-active"),
            this._events.emit("togglePageScrolling", {
                pin: !0
            })
        },
        onClickBackground: function(ev) {
            return this.hideLayer()
        },
        onClickCloseButton: function(ev) {
            return ev.preventDefault(),
            ev.stopPropagation(),
            this.hideLayer()
        },
        onClickTrigger: function(ev) {
            var $triggerElement;
            return ev.preventDefault(),
            $triggerElement = $(ev.currentTarget),
            this.showLayer($triggerElement, !0)
        },
        onKeyup: function(ev) {
            if (27 === ev.keyCode)
                return this.hideLayer()
        },
        onShowLayer: function(data) {
            return this.showLayer(data.$evTarget, !0)
        },
        onHideLayer: function() {
            return this.hideLayer()
        }
    })
}(jQuery);
var onGoogleMapsApiLoaded;
!function($, storeLocatorJsonConfig, google) {
    T.Module.LocationSearch = T.createModule({
        start: function(resolve) {
            var parameters;
            return this.$ctx = $(this._ctx),
            this.jsonConfig = storeLocatorJsonConfig,
            this.google = google,
            this.initializeLocationSearch = $.proxy(this, "initializeLocationSearch"),
            this.onGoogleMapsApiIsLoading = $.proxy(this, "onGoogleMapsApiIsLoading"),
            this.onGoogleMapsApiLoaded = $.proxy(this, "onGoogleMapsApiLoaded"),
            this.parentModuleId = this.$ctx.closest(".o-dealerlocator").data("t-id"),
            this._events.on("t.sync", $.proxy(this.sync, this)),
            this._events.on("googleMapsApiIsLoading", $.proxy(this.onGoogleMapsApiIsLoading, this)),
            parameters = "",
            $.each(this.jsonConfig.gmapsOpts, function(name, value) {
                return parameters += "&" + name + "=" + value
            }),
            this.googleMapsApiUrl = "//maps.googleapis.com/maps/api/js?libraries=places" + parameters + "&v=3&callback=onGoogleMapsApiLoaded",
            this.googleMapsApiIsLoading = !1,
            this.moduleInitialized = !1,
            $(document).on("googleMapsApiLoaded", this.onGoogleMapsApiLoaded),
            resolve()
        },
        sync: function() {
            return "object" !== ("object" != typeof this.google || typeof this.google.maps) ? this.loadGoogleMapsApi() : this.initializeLocationSearch()
        },
        initializeLocationSearch: function() {
            if (!this.moduleInitialized)
                return this.moduleInitialized = !0,
                this._events.emit("googleMapsApiReady", {
                    googleMaps: this.google.maps,
                    jsonConfig: this.jsonConfig,
                    parentModuleId: this.parentModuleId
                })
        },
        loadGoogleMapsApi: function() {
            var script;
            if (!this.googleMapsApiIsLoading)
                return this._events.emit("googleMapsApiIsLoading", {}),
                script = document.createElement("script"),
                script.type = "text/javascript",
                script.src = this.googleMapsApiUrl,
                document.body.appendChild(script)
        },
        onGoogleMapsApiIsLoading: function() {
            return this.googleMapsApiIsLoading = !0
        },
        onGoogleMapsApiLoaded: function(event, data) {
            if (this.google = data.google,
            this.google)
                return this.initializeLocationSearch()
        }
    })
}(jQuery, window.storeLocator, window.google),
onGoogleMapsApiLoaded = function() {
    return $(document).trigger("googleMapsApiLoaded", {
        google: window.google
    })
}
,
function($, doT) {
    var buttonBackToDealerListSelector, buttonShowLayerSelector, buttonShowMoreSelector, buttonToggleDealerListSelector, dealerDetailSelector, dealerDetailViewTplSelector, dealerDetailWrapSelector, dealerFeatureListTplSelector, dealerItemListTplSelector, dealerListSelector, dealerListWrapSelector, dealerNoResultsTplSelector, dealerWrapSelector, mapContainerInnerSelector, mapContainerSelector, mapWrapSelector;
    dealerWrapSelector = ".js-dealer-wrap",
    mapWrapSelector = ".js-map-wrap",
    dealerListWrapSelector = ".js-dealer-list-wrap",
    dealerDetailWrapSelector = ".js-dealer-detail-wrap",
    dealerListSelector = ".js-dealer-list",
    dealerDetailSelector = ".js-dealer-detail",
    mapContainerSelector = ".js-map",
    mapContainerInnerSelector = ".js-map-inner",
    buttonToggleDealerListSelector = ".js-button-toggle-list",
    buttonShowLayerSelector = ".js-button-show-layer",
    buttonBackToDealerListSelector = ".js-link-back-to-list",
    buttonShowMoreSelector = ".js-button-show-more",
    dealerItemListTplSelector = ".js-dealer-item-list-tpl",
    dealerFeatureListTplSelector = ".js-dealer-feature-tpl",
    dealerDetailViewTplSelector = ".js-dealer-detail-view-tpl",
    dealerNoResultsTplSelector = ".js-dealer-no-results-tpl",
    T.Module.MapList = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            this.doT = doT,
            mod.addMarkerEvents = $.proxy(mod.addMarkerEvents, mod),
            mod.addMapMarkerActiveClass = $.proxy(mod.addMapMarkerActiveClass, mod),
            mod.addDealerListEvents = $.proxy(mod.addDealerListEvents, mod),
            mod.addDealerFacetsToArray = $.proxy(mod.addDealerFacetsToArray, mod),
            mod.changeToggleButtonIcon = $.proxy(mod.changeToggleButtonIcon, mod),
            mod.destroyMarkers = $.proxy(mod.destroyMarkers, mod),
            mod.disableAllMapControls = $.proxy(mod.disableAllMapControls, mod),
            mod.disableSmallScreenBehaviour = $.proxy(mod.disableSmallScreenBehaviour, mod),
            mod.filterDealerByFacets = $.proxy(mod.filterDealerByFacets, mod),
            mod.enableAllMapControls = $.proxy(mod.enableAllMapControls, mod),
            mod.enableSmallScreenBehaviour = $.proxy(mod.enableSmallScreenBehaviour, mod),
            mod.handleDealerVisibilityState = $.proxy(mod.handleDealerVisibilityState, mod),
            mod.handleMarkerAndBoundsState = $.proxy(mod.handleMarkerAndBoundsState, mod),
            mod.handleMapState = $.proxy(mod.handleMapState, mod),
            mod.hideDealerDetail = $.proxy(mod.hideDealerDetail, mod),
            mod.initialize = $.proxy(mod.initialize, mod),
            mod.initializeMap = $.proxy(mod.initializeMap, mod),
            mod.initializeEventHandler = $.proxy(mod.initializeEventHandler, mod),
            mod.removeMapMarkerActiveClass = $.proxy(mod.removeMapMarkerActiveClass, mod),
            mod.renderDealerDetailView = $.proxy(mod.renderDealerDetailView, mod),
            mod.renderDealerList = $.proxy(mod.renderDealerList, mod),
            mod.renderFeatureList = $.proxy(mod.renderFeatureList, mod),
            mod.renderMarkers = $.proxy(mod.renderMarkers, mod),
            mod.resetActiveMarkerClass = $.proxy(mod.resetActiveMarkerClass, mod),
            mod.showDealerDetail = $.proxy(mod.showDealerDetail, mod),
            mod.setMapBounds = $.proxy(mod.setMapBounds, mod),
            mod.setMapCenter = $.proxy(mod.setMapCenter, mod),
            mod.setMapZoomLevel = $.proxy(mod.setMapZoomLevel, mod),
            mod.setViewportDependingMapSettings = $.proxy(mod.setViewportDependingMapSettings, mod),
            mod.stringPad = $.proxy(mod.stringPad, mod),
            mod.triggerMapResize = $.proxy(mod.triggerMapResize, mod),
            mod.toggleMapListView = $.proxy(mod.toggleMapListView, mod),
            mod.toggleMapMarkerMouseOverClass = $.proxy(mod.toggleMapMarkerMouseOverClass, mod),
            mod.toggleDealerItemMouseOverClass = $.proxy(mod.toggleDealerItemMouseOverClass, mod),
            mod.onClickButtonBackToList = $.proxy(mod.onClickButtonBackToList, mod),
            mod.onClickButtonShowMore = $.proxy(mod.onClickButtonShowMore, mod),
            mod.onClickButtonToggleList = $.proxy(mod.onClickButtonToggleList, mod),
            mod.onClickDealerItem = $.proxy(mod.onClickDealerItem, mod),
            mod.onClickDealerMarker = $.proxy(mod.onClickDealerMarker, mod),
            mod.onClickMapContainer = $.proxy(mod.onClickMapContainer, mod),
            mod.onFilterByFacets = $.proxy(mod.onFilterByFacets, mod),
            mod.onLoadRichMarkerLibCallback = $.proxy(mod.onLoadRichMarkerLibCallback, mod),
            mod.onNewDealerDataAvailable = $.proxy(mod.onNewDealerDataAvailable, mod),
            mod.onCloseLayer = $.proxy(mod.onCloseLayer, mod),
            mod.onOpenLayer = $.proxy(mod.onOpenLayer, mod),
            mod.replaceImagePlaceholder = $.proxy(mod.replaceImagePlaceholder, mod),
            mod.$mapWrap = mod.$(mapWrapSelector),
            mod.$dealerWrap = mod.$(dealerWrapSelector),
            mod.$dealerListWrap = mod.$(dealerListWrapSelector),
            mod.$dealerDetailWrap = mod.$(dealerDetailWrapSelector),
            mod.$dealerList = mod.$(dealerListSelector),
            mod.$dealerDetail = mod.$(dealerDetailSelector),
            mod.$mapContainer = mod.$(mapContainerSelector),
            mod.$mapContainerInner = mod.$(mapContainerInnerSelector),
            mod.$buttonToggleList = mod.$(buttonToggleDealerListSelector),
            mod.$buttonShowLayer = mod.$(buttonShowLayerSelector),
            mod.$buttonBackToList = mod.$(buttonBackToDealerListSelector),
            mod.$buttonShowMore = mod.$(buttonShowMoreSelector),
            mod.dealerItemListTpl = mod.doT.template(mod.$(dealerItemListTplSelector).html()),
            mod.dealerFeatureListTpl = mod.doT.template(mod.$(dealerFeatureListTplSelector).html()),
            mod.dealerDetailViewTpl = mod.doT.template(mod.$(dealerDetailViewTplSelector).html()),
            mod.dealerNoResultsTpl = mod.doT.template(mod.$(dealerNoResultsTplSelector).html()),
            mod._events.on("googleMapsApiReady", mod.initialize),
            mod._events.on("newDealersAvailable", mod.onNewDealerDataAvailable),
            mod._events.on("filterByFacets", mod.onFilterByFacets),
            mod._events.on("openLayer", mod.onOpenLayer),
            mod._events.on("closeLayer", mod.onCloseLayer),
            this._events.on("viewportChanged", function(_this) {
                return function(viewport) {
                    return _this.onViewportChange(viewport)
                }
            }(this)),
            this.onViewportChange(T.Utils.getViewport()),
            mod.globalSettings = T.Utils.dealerLocator,
            mod.richMarkerUrl = window.jsBasePath + "richmarker.js",
            mod.mapZoomLevelDetail = mod.globalSettings.detailViewZoomLevel,
            mod.showMorePageSize = mod.globalSettings.smallScreenShowMorePageSize,
            mod.showMoreCurrentlyVisible = mod.globalSettings.smallScreenShowMorePageSize,
            mod.hasProductContext = !1,
            mod.hasDealerResults = !1,
            mod.richMarkerLibLoaded = !1,
            mod.delayedMarkerInit = !1,
            mod.currentViewport = "",
            mod.parentModuleId = mod.$ctx.closest(".o-dealerlocator").data("t-id"),
            mod.dealerGallerySizes = mod.$ctx.data("dealer-image-settings"),
            mod.markers = [],
            mod.markersByDealerId = [],
            mod.dealersById = [],
            mod.dealerFacets = {},
            mod.selectedFiltersCount = 0,
            mod.activeDealerId = "",
            resolve()
        },
        addDealerFacetsToArray: function(dealer) {
            var mod;
            if (mod = this,
            "filter-visible" === dealer.filterState)
                return $.each(dealer.facets, function(index, facet) {
                    if ($.inArray(facet, mod.dealerFacets) === -1)
                        return null == mod.dealerFacets[facet] && (mod.dealerFacets[facet] = {},
                        mod.dealerFacets[facet].itemCount = 0),
                        mod.dealerFacets[facet].itemCount++
                })
        },
        addDealerListEvents: function() {
            var mod;
            return mod = this,
            this.$dealerList.on("mouseover mouseout", ".js-dealer-item", function(ev) {
                var dealerId, dealerItem;
                return dealerItem = $(ev.target).closest(".js-dealer-item"),
                dealerId = dealerItem.data("dealer-id"),
                mod.toggleMapMarkerMouseOverClass(mod.markersByDealerId[dealerId])
            }),
            this.$dealerList.on("click", ".js-dealer-item", this.onClickDealerItem)
        },
        addMarkerEvents: function(marker) {
            var $dealerItem, mod;
            return mod = this,
            $dealerItem = mod.$dealerList.find('.js-dealer-item[data-dealer-id="' + marker.dealerId + '"]'),
            marker.addListener("mouseover", function() {
                return mod.toggleMapMarkerMouseOverClass(marker),
                mod.toggleDealerItemMouseOverClass($dealerItem)
            }),
            marker.addListener("mouseout", function() {
                return mod.toggleMapMarkerMouseOverClass(marker),
                mod.toggleDealerItemMouseOverClass($dealerItem)
            }),
            marker.addListener("click", function() {
                return mod.onClickDealerMarker(marker)
            })
        },
        addMapMarkerActiveClass: function(marker) {
            return $(marker.content).addClass("active")
        },
        destroyMarkers: function() {
            var mod;
            return mod = this,
            $.each(this.markers, function(index, marker) {
                return mod.googleMaps.event.clearInstanceListeners(marker),
                marker.setMap(null)
            }),
            this.markers = [],
            this.markersByDealerId = {}
        },
        disableSmallScreenBehaviour: function() {
            var enableControls;
            if (enableControls = !0,
            this.$buttonToggleList.removeClass("mobile-hidden"),
            this.$buttonShowLayer.addClass("mobile-hidden"),
            this.handleShowMoreButtonState(),
            this.$mapContainer.off("click.triggerShowLayer"),
            null != this.map)
                return this.$mapContainer.removeClass("trigger-layer"),
                this.toggleAllMapControls(enableControls),
                this.handleMarkerAndBoundsState()
        },
        enableSmallScreenBehaviour: function() {
            var enableControls;
            if (enableControls = !1,
            this.$buttonToggleList.addClass("mobile-hidden"),
            this.$buttonShowLayer.removeClass("mobile-hidden"),
            this.handleShowMoreButtonState(),
            this.$mapContainer.on("click.triggerShowLayer", this.onClickMapContainer),
            null != this.map)
                return this.$mapContainer.addClass("trigger-layer"),
                this.toggleAllMapControls(enableControls),
                this.handleMarkerAndBoundsState()
        },
        filterDealerByFacets: function() {
            var activeDealers, mod;
            return mod = this,
            activeDealers = 0,
            this.dealerFacets = {},
            $.each(mod.dealers, function(dealerIndex, dealer) {
                var dealerIsVisible, dealerIsVisibleAND, dealerIsVisibleOR;
                return dealerIsVisible = !1,
                dealerIsVisibleOR = !1,
                dealerIsVisibleAND = !0,
                mod.selectedFiltersCount > 0 ? ($.each(mod.selectedFilterGroups, function(groupId, filterGroup) {
                    return "AND" === filterGroup.innerOperator ? ($.each(filterGroup.selectedFilterItems, function(facetIndex, activeFacet) {
                        if ($.inArray(activeFacet, dealer.facets) === -1)
                            return dealerIsVisibleAND = !1
                    }),
                    dealerIsVisible = dealerIsVisibleAND) : ($.each(filterGroup.selectedFilterItems, function(facetIndex, activeFacet) {
                        if ($.inArray(activeFacet, dealer.facets) >= 0)
                            return dealerIsVisibleOR = !0
                    }),
                    dealerIsVisible = dealerIsVisibleOR)
                }),
                dealerIsVisible && (activeDealers++,
                dealer.dealerIndex = mod.stringPad(activeDealers, 2))) : (activeDealers++,
                dealerIsVisible = !0,
                dealer.dealerIndex = mod.stringPad(activeDealers, 2)),
                mod.handleDealerVisibilityState(dealer, dealerIsVisible, activeDealers)
            }),
            this.handleMarkerAndBoundsState(),
            this.$dealerList.find(".js-dealer-item.mobile-hidden").length > 0 ? this.$buttonShowMore.removeClass("hidden") : this.$buttonShowMore.addClass("hidden"),
            this._events.emit("newFacetDataAvailable", {
                facets: mod.dealerFacets,
                itemCount: activeDealers
            })
        },
        handleDealerVisibilityState: function(dealer, isVisible, activeDealerCount) {
            var $dealerItem, marker;
            return $dealerItem = this.$dealerList.find('.js-dealer-item[data-dealer-id="' + dealer.dealerID + '"]'),
            marker = this.markersByDealerId[dealer.dealerID],
            isVisible ? (dealer.filterState = "filter-visible",
            marker.filterState = "filter-visible",
            $dealerItem.find('.js-location-pin[data-dealer-id="' + dealer.dealerID + '"]').data("dealer-index", dealer.dealerIndex).attr("data-dealer-index", dealer.dealerIndex),
            $(marker.content).data("dealer-index", dealer.dealerIndex).attr("data-dealer-index", dealer.dealerIndex),
            activeDealerCount > this.showMoreCurrentlyVisible ? (dealer.mobileState = "mobile-hidden",
            marker.mobileState = "mobile-hidden") : (dealer.mobileState = "mobile-visible",
            marker.mobileState = "mobile-visible")) : (dealer.filterState = "filter-hidden",
            marker.filterState = "filter-hidden"),
            this.addDealerFacetsToArray(dealer),
            $dealerItem.removeClass("filter-hidden").removeClass("filter-visible").addClass(dealer.filterState),
            $dealerItem.removeClass("mobile-hidden").removeClass("mobile-visible").addClass(dealer.mobileState)
        },
        handleMarkerAndBoundsState: function() {
            var anyMarkerVisible, mod;
            if (mod = this,
            null != this.googleMaps && null != this.markers && this.markers.length > 0)
                return this.mapBounds = new this.googleMaps.LatLngBounds,
                anyMarkerVisible = !1,
                $.each(mod.markers, function(index, marker) {
                    return "filter-visible" === marker.filterState ? (anyMarkerVisible = !0,
                    "mobile" === mod.currentViewport ? "mobile-visible" === marker.mobileState ? (marker.setVisible(!0),
                    mod.mapBounds.extend(marker.getPosition())) : marker.setVisible(!1) : (marker.setVisible(!0),
                    mod.mapBounds.extend(marker.getPosition()))) : marker.setVisible(!1)
                }),
                anyMarkerVisible || (this.mapBounds = null),
                this.handleMapState()
        },
        handleMapState: function() {
            if (null != this.map)
                return null != this.activeDealerLoaction ? (this.setMapCenter(this.activeDealerLoaction),
                this.setMapZoomLevel(this.mapZoomLevelDetail)) : null != this.mapBounds ? (this.setMapCenter(this.mapBounds.getCenter()),
                this.setMapBounds(this.mapBounds)) : (this.setMapCenter(this.mapCenter),
                this.setMapZoomLevel(this.mapZoomLevelInitial))
        },
        handleShowMoreButtonState: function() {
            if (this.hasDealerResults)
                return this.$dealerList.find(".js-dealer-item.mobile-hidden:not(.filter-hidden)").length > 0 ? this.$buttonShowMore.removeClass("hidden") : this.$buttonShowMore.addClass("hidden")
        },
        hideDealerDetail: function() {
            var $dealerItem, mod;
            return mod = this,
            this.resetActiveMarkerClass(),
            this.map.fitBounds(this.mapBounds),
            "mobile" === this.currentViewport ? (this.$dealerListWrap.removeClass("hidden"),
            this.$dealerDetailWrap.addClass("hidden"),
            "" !== this.activeDealerId && ($dealerItem = mod.$dealerList.find('.js-dealer-item[data-dealer-id="' + this.activeDealerId + '"]'),
            T.Utils.scrollToTop($dealerItem))) : (this.$dealerListWrap.removeClass("hidden"),
            this.$dealerListWrap.animate({
                left: "0",
                right: "0"
            }),
            this.$dealerDetailWrap.animate({
                left: "100%",
                right: "-100%"
            }, 300, function() {
                return mod.$dealerDetailWrap.addClass("hidden")
            })),
            this.activeDealerId = "",
            this.activeDealerLoaction = null
        },
        initialize: function(data) {
            if (this.googleMaps = data.googleMaps,
            this.jsonConfig = data.jsonConfig,
            this.initializeFilter(),
            !this.jsonConfig.initiallyCollapsed)
                return this.initializeMap(),
                this.initializeEventHandler(),
                this.$ctx.removeClass("pre-initialized")
        },
        initializeFilter: function() {
            var activeFilters, enableFilter;
            return enableFilter = !1,
            activeFilters = [],
            this.jsonConfig.showFilters && (enableFilter = !0),
            this.jsonConfig.activeFilters && (activeFilters = this.jsonConfig.activeFilters),
            this._events.emit("initializeFilter", {
                enableFilter: enableFilter,
                activeFilters: activeFilters,
                baseFilterGroups: this.jsonConfig.filterGroups
            })
        },
        initializeMap: function() {
            var latLng, mod, zoomLevel;
            return mod = this,
            this.loadRichMarkerLib(),
            latLng = {
                lat: mod.jsonConfig.inititalPos.center.lat,
                lng: mod.jsonConfig.inititalPos.center.lng
            },
            zoomLevel = mod.jsonConfig.inititalPos.zoom,
            this.$mapContainerInner.length > 0 && (this.map = new this.googleMaps.Map(this.$mapContainerInner[0],{
                center: latLng,
                zoom: zoomLevel
            })),
            this.setMapCenter(latLng),
            this.mapCenter = latLng,
            this.mapZoomLevelInitial = zoomLevel,
            this.$mapWrap.removeClass("pre-initialized"),
            this.setViewportDependingMapSettings(this.currentViewport)
        },
        initializeEventHandler: function() {
            var mod;
            return mod = this,
            this.$buttonToggleList.on("click", this.onClickButtonToggleList),
            this.$buttonBackToList.on("click", this.onClickButtonBackToList),
            this.$buttonShowMore.on("click", this.onClickButtonShowMore),
            this.googleMaps.event.addDomListener(window, "resize", function() {
                return mod.handleMapState()
            })
        },
        loadRichMarkerLib: function() {
            return T.Utils.load(this.richMarkerUrl, this.onLoadRichMarkerLibCallback)
        },
        renderDealerList: function(dealers) {
            var mod, noResultsHtml;
            return mod = this,
            this.$dealerList.off("mouseover mouseout"),
            this.$dealerList.empty(),
            this.dealerFacets = {},
            dealers.length > 0 ? ($.each(dealers, function(index, dealer) {
                var dealerHtml;
                return index >= mod.showMorePageSize ? dealer.mobileState = "mobile-hidden" : dealer.mobileState = "mobile-visible",
                dealer.dealerIndex = mod.stringPad(index + 1, 2),
                dealer.filterState = "filter-visible",
                dealerHtml = mod.dealerItemListTpl(dealer),
                mod.$dealerList.append(dealerHtml),
                null != dealer.facets && dealer.facets.length > 0 && mod.addDealerFacetsToArray(dealer),
                null != dealer.details.features && dealer.details.features.length > 0 && mod.renderFeatureList("dealer-list", dealer),
                mod.dealersById[dealer.dealerID] = dealer
            }),
            this.richMarkerLibLoaded && this.addDealerListEvents(),
            this.$dealerList.removeClass("no-results"),
            this.hasDealerResults = !0,
            this._events.emit("newFacetDataAvailable", {
                facets: mod.dealerFacets,
                itemCount: mod.dealers.length
            }),
            "mobile" === mod.currentViewport && dealers.length > this.showMorePageSize ? this.$buttonShowMore.removeClass("hidden") : void 0) : (noResultsHtml = mod.dealerNoResultsTpl({}),
            this.$dealerList.append(noResultsHtml),
            this.$dealerList.addClass("no-results"),
            this.hasDealerResults = !1)
        },
        renderDealerDetailView: function(dealer) {
            var dealerDetailHtml, mod;
            return mod = this,
            dealer.currentLocation = mod.currentLocation.lat + "," + mod.currentLocation.lng,
            dealerDetailHtml = this.dealerDetailViewTpl({
                dealer: dealer,
                maplist: mod
            }),
            this.$dealerDetailWrap.find(".js-dealer-detail").remove(),
            this.$dealerDetailWrap.append(dealerDetailHtml),
            this._sandbox.addModules(this.$dealerDetailWrap.find(".dealer-gallery")[0]),
            this.renderFeatureList("dealer-detail", dealer)
        },
        renderFeatureList: function(viewType, dealer) {
            var $featureListHtml, $parentToAppend;
            return dealer.viewType = viewType,
            $featureListHtml = this.dealerFeatureListTpl(dealer),
            $parentToAppend = "dealer-detail" === viewType ? this.$dealerDetailWrap.find(".js-dealer-detail") : this.$dealerList.find('.js-dealer-item[data-dealer-id="' + dealer.dealerID + '"]'),
            $parentToAppend.find(".js-feature-wrap").append($featureListHtml),
            this._sandbox.addModules($parentToAppend.find(".js-feature-wrap")[0])
        },
        renderMarkers: function(dealers) {
            var mod;
            return mod = this,
            this.destroyMarkers(),
            this.richMarkerLibLoaded && "function" == typeof RichMarker ? dealers.length > 0 ? (this.mapBounds = new this.googleMaps.LatLngBounds,
            $.each(dealers, function(index, dealer) {
                var $dealerItem, $listMarker, marker, markerLocation;
                if ($dealerItem = mod.$dealerList.find('.js-dealer-item[data-dealer-id="' + dealer.dealerID + '"]'),
                $listMarker = $dealerItem.find('.js-location-pin[data-dealer-id="' + dealer.dealerID + '"]').clone(),
                1 === $listMarker.length)
                    return $listMarker.data("testing-id") && $listMarker.attr("testing_id", $listMarker.data("testing-id")),
                    markerLocation = new mod.googleMaps.LatLng(dealer.coords.lat,dealer.coords.lng),
                    marker = new RichMarker({
                        map: mod.map,
                        position: markerLocation,
                        draggable: !1,
                        flat: !0,
                        anchor: RichMarkerPosition.BOTTOM,
                        content: $listMarker[0]
                    }),
                    marker.dealerId = dealer.dealerID,
                    mod.addMarkerEvents(marker),
                    mod.markers.push(marker),
                    mod.markersByDealerId[dealer.dealerID] = marker,
                    marker.filterState = "filter-visible",
                    "mobile-hidden" === dealer.mobileState ? marker.mobileState = "mobile-hidden" : marker.mobileState = "mobile-visible",
                    "mobile" === mod.currentViewport && "mobile-hidden" === dealer.mobileState ? marker.setVisible(!1) : mod.mapBounds.extend(markerLocation)
            }),
            this.handleMapState()) : void 0 : this.delayedMarkerInit = !0
        },
        removeMapMarkerActiveClass: function(marker) {
            return $(marker.content).removeClass("active")
        },
        resetActiveMarkerClass: function() {
            var marker;
            if ("" !== this.activeDealerId)
                return marker = this.markersByDealerId[this.activeDealerId],
                this.removeMapMarkerActiveClass(marker)
        },
        setMapBounds: function(bounds) {
            return this.map.fitBounds(bounds)
        },
        setMapCenter: function(newMapCenter) {
            return this.map.panTo(newMapCenter)
        },
        setMapZoomLevel: function(zoomLevel) {
            return this.map.setZoom(zoomLevel)
        },
        setViewportDependingMapSettings: function(viewport) {
            return "mobile" === viewport ? (this.$mapContainer.addClass("trigger-layer"),
            this.toggleAllMapControls(!1)) : (this.$mapContainer.removeClass("trigger-layer"),
            this.toggleAllMapControls(!0))
        },
        showDealerDetail: function(dealerId) {
            var dealer, dealerLocation, marker, mod;
            return mod = this,
            this.resetActiveMarkerClass(),
            dealer = this.dealersById[dealerId],
            dealerLocation = new this.googleMaps.LatLng(dealer.coords.lat,dealer.coords.lng),
            marker = this.markersByDealerId[dealerId],
            this.activeDealerId = dealerId,
            this.activeDealerLoaction = dealerLocation,
            this.renderDealerDetailView(dealer),
            this.addMapMarkerActiveClass(marker),
            this.handleMapState(),
            "mobile" === this.currentViewport ? (this.$dealerListWrap.addClass("hidden"),
            this.$dealerDetailWrap.removeClass("hidden"),
            T.Utils.scrollToTop(this.$mapWrap)) : (this.$mapWrap.hasClass("full-width") && this.toggleMapListView(),
            this.$dealerListWrap.animate({
                left: "-100%",
                right: "100%"
            }, 300, function() {
                return mod.$dealerListWrap.addClass("hidden")
            }),
            this.$dealerDetailWrap.removeClass("hidden"),
            this.$dealerDetailWrap.animate({
                left: "0",
                right: "0"
            }))
        },
        showMapLayer: function($evTarget) {
            return this.mapNode = this.map.getDiv(),
            this._events.emit("appendMapToLayer", {
                $evTarget: $evTarget,
                mapNode: this.mapNode
            })
        },
        showMoreDealer: function() {
            var mod, newCurrentlyVisible, visibleIndex;
            if (mod = this,
            visibleIndex = 0,
            newCurrentlyVisible = this.showMoreCurrentlyVisible + this.showMorePageSize,
            this.showMoreCurrentlyVisible < this.dealers.length && ($.each(mod.dealers, function(index, dealer) {
                var marker;
                if ("filter-hidden" !== dealer.filterState)
                    return visibleIndex >= mod.showMoreCurrentlyVisible && visibleIndex < newCurrentlyVisible && (dealer.mobileState = "visible",
                    mod.$dealerList.find('.js-dealer-item[data-dealer-id="' + dealer.dealerID + '"]').toggleClass("mobile-hidden").toggleClass("mobile-visible"),
                    marker = mod.markersByDealerId[dealer.dealerID],
                    marker.setVisible(!0),
                    marker.mobileState = "mobile-visible",
                    mod.mapBounds.extend(marker.getPosition())),
                    visibleIndex++
            }),
            this.showMoreCurrentlyVisible = newCurrentlyVisible,
            this.handleMapState()),
            newCurrentlyVisible >= visibleIndex)
                return this.$buttonShowMore.addClass("hidden")
        },
        stringPad: function(str, max) {
            var mod;
            return mod = this,
            str = str.toString(),
            str.length < max ? mod.stringPad("0" + str, max) : str
        },
        triggerMapResize: function() {
            return this.googleMaps.event.trigger(this.map, "resize")
        },
        toggleAllMapControls: function(enableControls) {
            return this.map.setOptions({
                disableDoubleClickZoom: !enableControls,
                draggable: enableControls,
                scrollwheel: enableControls,
                panControl: enableControls,
                disableDefaultUI: !enableControls
            })
        },
        toggleDealerItemMouseOverClass: function($dealerItem) {
            return $dealerItem.toggleClass("mouseover")
        },
        toggleMapMarkerMouseOverClass: function(marker) {
            return $(marker.content).toggleClass("mouseover")
        },
        toggleMapListView: function() {
            var icon;
            return icon = this.$buttonToggleList.find(".icon"),
            this.$dealerWrap.toggleClass("visible"),
            this.$mapWrap.toggleClass("full-width"),
            "mobile" !== this.currentViewport && (icon.toggleClass("icon-arrow-left"),
            icon.toggleClass("icon-arrow-right")),
            this.triggerMapResize(),
            this.handleMapState()
        },
        onClickButtonBackToList: function(ev) {
            return ev.preventDefault(),
            this.hideDealerDetail()
        },
        onClickButtonShowMore: function(ev) {
            return ev.preventDefault(),
            this.showMoreDealer()
        },
        onClickButtonToggleList: function(ev) {
            return ev.preventDefault(),
            this.toggleMapListView()
        },
        onClickDealerItem: function(ev) {
            var $evTarget, dealerId, notClickOnBuyLink, notClickOnFeatureItem;
            if ($evTarget = $(ev.target),
            notClickOnFeatureItem = !$evTarget.closest(".js-link-feature").length && !$evTarget.is(".js-link-feature"),
            notClickOnBuyLink = !$evTarget.closest(".js-link-buy-online").length && !$evTarget.is(".js-link-buy-online"),
            notClickOnFeatureItem && notClickOnBuyLink)
                return ev.preventDefault(),
                dealerId = $evTarget.closest(".js-dealer-item").data("dealer-id"),
                this.showDealerDetail(dealerId)
        },
        onClickDealerMarker: function(marker) {
            var dealerId;
            if (dealerId = $(marker.content).data("dealer-id"),
            this.showDealerDetail(dealerId),
            "mobile" === this.currentViewport)
                return this._events.emit("hideLayer", {})
        },
        onClickMapContainer: function(ev) {
            var $evTarget;
            return ev.preventDefault(),
            $evTarget = $(ev.target),
            this.showMapLayer($evTarget)
        },
        onCloseLayer: function() {
            return this.$mapContainer.append(this.mapNode),
            this.toggleAllMapControls(!1),
            this.triggerMapResize(),
            this.handleMapState()
        },
        onFilterByFacets: function(data) {
            return this.selectedFilterGroups = data.selectedFilterGroups,
            this.selectedFiltersCount = data.selectedFiltersCount,
            this.hideDealerDetail(),
            this.filterDealerByFacets()
        },
        onLoadRichMarkerLibCallback: function() {
            if (this.richMarkerLibLoaded = !0,
            this.delayedMarkerInit)
                return this.renderMarkers(this.dealers),
                this.addDealerListEvents()
        },
        onNewDealerDataAvailable: function(data) {
            if (this.parentModuleId === data.parentModuleId && (this.jsonConfig.initiallyCollapsed && (this.initializeMap(),
            this.initializeEventHandler(),
            this.$ctx.removeClass("pre-initialized")),
            this.dealers = data.dealers,
            this.hasProductContext = data.hasProductContext,
            this.currentLocation = data.currentLocation,
            this.$buttonToggleList.removeClass("hidden"),
            this.$buttonShowLayer.removeClass("hidden"),
            this.$mapWrap.hasClass("full-width") && this.toggleMapListView(),
            "" !== this.activeDealerId && this.hideDealerDetail(),
            this.renderDealerList(data.dealers),
            this.renderMarkers(data.dealers),
            this.selectedFiltersCount.length > 0))
                return this.filterDealerByFacets()
        },
        onOpenLayer: function() {
            return this.toggleAllMapControls(!0),
            this.triggerMapResize(),
            this.handleMapState()
        },
        onViewportChange: function(viewport) {
            return this.currentViewport = viewport,
            "mobile" === viewport ? this.enableSmallScreenBehaviour() : this.disableSmallScreenBehaviour(),
            this.handleMapState()
        },
        replaceImagePlaceholder: function(url, viewport) {
            var realUrl;
            return realUrl = "",
            $.each(this.dealerGallerySizes[viewport], function(index, vp) {
                return realUrl += url.replace("{width}", vp.width).replace("{height}", vp.height) + " " + vp.resolution + "x, "
            }),
            realUrl
        }
    })
}(jQuery, window.doT),
function($) {
    T.Module.MediaGallery = T.createModule({
        slickConfiguration: {
            centerMode: !1,
            slidesToShow: 1,
            slidesPerRow: 1,
            initialSlide: 0,
            infinite: !1,
            useCSS: !1
        },
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.$paginationnumber = mod.$(".js-paginationnumber"),
            mod.$sliderControls = mod.$(".js-mediagallery-controls"),
            mod.$mainSlider = mod.$(".js-mediagallery-mainslider"),
            mod.$mainsliderControls = mod.$(".js-mediagallery-controls"),
            mod.$mainsliderArrowLeft = mod.$(".js-mediagallery-controls > .prev"),
            mod.$mainsliderArrowRight = mod.$(".js-mediagallery-controls > .next"),
            mod.$thumbnailSlider = mod.$(".js-mediagallery-thumbnailcarousel"),
            mod.$thumbnailSliderControls = mod.$(".js-mediagallery-thumbnailcarousel-controls"),
            mod.$thumbnailSliderArrowLeft = mod.$(".js-mediagallery-thumbnailcarousel-controls > .prev"),
            mod.$thumbnailSliderArrowRight = mod.$(".js-mediagallery-thumbnailcarousel-controls > .next"),
            mod.$btnOpenLayer = mod.$(".js-mediagallery-zoom"),
            mod.$btnOpenLayer.addClass("hidden"),
            mod.totalNumberOfSlides = mod.$ctx.find(".mediagallery-slide:not(.slick-cloned)").length,
            mod.countSlidesPerPage = 1,
            mod.currentSlide = 1,
            mod.mainSliderInitialized = !1,
            mod.initMainSlider(),
            mod._events.on("recalc", $.proxy(mod.onReCalc, mod)),
            mod._events.on("t.sync", $.proxy(mod.sync, mod)),
            mod._events.on("videoPlaying", $.proxy(mod.onVideoStart, mod)),
            mod._events.on("videoStop", $.proxy(mod.onVideoStop, mod)),
            mod._events.on("videoEnded", $.proxy(mod.onVideoStop, mod)),
            this._events.on("viewportChanged", function(_this) {
                return function(viewport) {
                    return _this.onViewportChange(viewport)
                }
            }(this)),
            resolve()
        },
        sync: function() {
            var mod;
            mod = this,
            mod.forceSliderHeightReCalc()
        },
        activateThumb: function(index) {
            return this.$thumbnailSlider.find(".js-mediagallery-thumbnailcarousel-slide").removeClass("is-active slick-current").eq(index).addClass("is-active slick-current")
        },
        addSliderEventListener: function() {
            var mod;
            return mod = this,
            mod.$mainSlider.on("beforeChange", $.proxy(mod.onMainSlideBeforeChange, mod)),
            mod.$mainSlider.on("afterChange", $.proxy(mod.onSliderAfterChange, mod)),
            mod.$thumbnailSlider.on("setPosition", $.proxy(mod.onThumbnailSlideSetPosition, mod)),
            mod.$thumbnailSlider.on("click", ".js-mediagallery-thumbnailcarousel-slide", $.proxy(this.onClickThumbnailCarouselSlide, mod))
        },
        forceSliderHeightReCalc: function() {
            var mod;
            if (mod = this,
            mod.mainSliderInitialized)
                return mod.$mainSlider.slick("setPosition")
        },
        getCurrentDownloadBySlide: function() {},
        getVideoInSlide: function() {
            var currentSlideVideo, mod;
            return mod = this,
            currentSlideVideo = mod.$mainSlider.find(".slick-current .m-video"),
            currentSlideVideo.length > 0 && currentSlideVideo
        },
        initMainSlider: function() {
            var mod;
            if (mod = this,
            mod.$ctx.removeClass("pre-init"),
            T.Utils.isRTL() && this.$mainSlider.attr("dir", "rtl"),
            mod.$mainSlider.slick($.extend(mod.slickConfiguration, {
                appendArrows: mod.$mainsliderControls,
                arrows: !0,
                autoplay: !1,
                centerPadding: "0px",
                dots: !1,
                fade: mod.$mainSlider.data("mediagallery-fade"),
                nextArrow: mod.$mainsliderArrowRight,
                prevArrow: mod.$mainsliderArrowLeft,
                speed: 300,
                rtl: T.Utils.isRTL()
            })),
            mod.activateThumb(mod.$mainSlider.find(".slick-current").data("slick-index")),
            mod.setMediaGalleryMainSliderControls(),
            mod.mainSliderInitialized = !0,
            mod.totalNumberOfSlides > 1)
                return mod.$thumbnailSlider.removeClass("hidden"),
                mod.initThumbnailSlider(),
                mod.addSliderEventListener()
        },
        initThumbnailSlider: function() {
            var countSlider, initialSlide, slidesToScrollDesktop, slidesToShowDesktop;
            return countSlider = this.$thumbnailSlider.find(".js-mediagallery-thumbnailcarousel-slide").length,
            initialSlide = 1 === countSlider ? -1 : 0,
            slidesToShowDesktop = slidesToScrollDesktop = this.$(".mediagallery-downloadlink-desktop").length > 0 ? 3 : 5,
            T.Utils.isRTL() && this.$thumbnailSlider.attr("dir", "rtl"),
            this.$thumbnailSlider.slick({
                appendArrows: this.$thumbnailSliderControls,
                arrows: !0,
                autoplay: !1,
                centerPadding: "0px",
                centerMode: !1,
                dots: !1,
                fade: !1,
                initialSlide: initialSlide,
                infinite: !1,
                nextArrow: this.$thumbnailSliderArrowRight,
                prevArrow: this.$thumbnailSliderArrowLeft,
                slide: ".js-mediagallery-thumbnailcarousel-slide",
                slidesToShow: slidesToShowDesktop,
                slidesToScroll: slidesToScrollDesktop,
                speed: 300,
                rtl: T.Utils.isRTL(),
                responsive: [{
                    breakpoint: parseInt(T.Utils.breakpoints.lg),
                    settings: {
                        slidesToShow: slidesToShowDesktop,
                        slidesToScroll: slidesToScrollDesktop
                    }
                }, {
                    breakpoint: parseInt(T.Utils.breakpoints.md),
                    settings: {
                        slidesToShow: 3,
                        slidesToScroll: 3
                    }
                }]
            })
        },
        setMainSliderCaption: function() {
            return this.$("figcaption").html(this.$mainSlider.find(".slick-current").data("caption-text"))
        },
        setMediaGalleryMainSliderControls: function() {
            var currentMainSlide, currentSlide;
            return currentMainSlide = this.$mainSlider.slick("slickCurrentSlide"),
            0 === currentMainSlide ? this.$mainsliderArrowLeft.addClass("is-inactive").attr("disabled", "disabled") : this.$mainsliderArrowLeft.removeClass("is-inactive").removeAttr("disabled"),
            currentMainSlide === this.totalNumberOfSlides - 1 ? this.$mainsliderArrowRight.addClass("is-inactive").attr("disabled", "disabled") : this.$mainsliderArrowRight.removeClass("is-inactive").removeAttr("disabled"),
            this.setMainSliderCaption(),
            1 === this.totalNumberOfSlides && this.toggleSliderControls(!1),
            currentSlide = this.$mainSlider.find(".slick-current").data("slick-index"),
            this.currentSlide = currentSlide + 1,
            this.setPaginationNumbers()
        },
        setMediaGalleryThumbnailSliderControls: function() {
            var arrayAllVisibleThumbnails, maxCountThumbs, maxIndexVisible, minIndexVisible;
            return maxCountThumbs = this.$thumbnailSlider.find(".js-mediagallery-thumbnailcarousel-slide").length,
            arrayAllVisibleThumbnails = this.$thumbnailSlider.find(".slick-active"),
            minIndexVisible = arrayAllVisibleThumbnails.first().data("slick-index") + 1,
            maxIndexVisible = arrayAllVisibleThumbnails.last().data("slick-index") + 1,
            1 === minIndexVisible ? this.$thumbnailSliderArrowLeft.addClass("is-inactive").attr("disabled", "disabled") : this.$thumbnailSliderArrowLeft.removeClass("is-inactive").removeAttr("disabled"),
            maxIndexVisible === maxCountThumbs ? this.$thumbnailSliderArrowRight.addClass("is-inactive").attr("disabled", "disabled") : this.$thumbnailSliderArrowRight.removeClass("is-inactive").removeAttr("disabled")
        },
        setPaginationNumbers: function() {
            var mod;
            if (mod = this,
            this.totalNumberOfSlides > 1)
                return mod.$paginationnumber.html(mod.currentSlide + "/" + mod.totalNumberOfSlides)
        },
        setSlickDragEvents: function(value) {
            var mod;
            if (mod = this,
            mod.mainSliderInitialized)
                return mod.$mainSlider.slick("slickSetOption", "draggable", value),
                mod.$mainSlider.slick("slickSetOption", "touchMove", value),
                mod.$mainSlider.slick("slickSetOption", "swipeToSlide", value),
                mod.$mainSlider.slick("slickSetOption", "swipe", value)
        },
        toggleSliderControls: function(enableControls) {
            var mod;
            return mod = this,
            enableControls ? mod.$sliderControls.removeClass("hidden") : mod.$sliderControls.addClass("hidden")
        },
        onClickThumbnailCarouselSlide: function(ev) {
            var index;
            return index = $(ev.currentTarget).data("slick-index"),
            this.$mainSlider.slick("slickGoTo", index),
            this.activateThumb(index)
        },
        onMainSlideBeforeChange: function(event, slick, currentSlide, nextSlide) {
            var mod, videoComponent;
            return mod = this,
            videoComponent = mod.getVideoInSlide(),
            mod._events.emit("pageSliderSlideBeforeChange", {
                currentSlide: currentSlide,
                $slide: $(slick.$slides.get(currentSlide)),
                videoComponent: videoComponent
            })
        },
        onSliderAfterChange: function(event, slick, currentSlide) {
            var direction, mod, videoComponent;
            return mod = this,
            direction = mod.$thumbnailSlider.find(".slick-current").data("slick-index") < currentSlide ? "slickNext" : "slickPrev",
            mod.setMediaGalleryMainSliderControls(),
            mod.activateThumb(currentSlide),
            mod.$thumbnailSlider.find(".slick-current").hasClass("slick-active") || mod.$thumbnailSlider.slick(direction),
            mod.$btnOpenLayer.data("slick-index", currentSlide),
            videoComponent = mod.getVideoInSlide(),
            mod._events.emit("pageSliderSlideAfterChange", {
                currentSlide: currentSlide,
                $slide: $(slick.$slides.get(currentSlide)),
                videoComponent: videoComponent
            }),
            mod._events.emit("mediagallery:changedownload", {
                currentDownload: mod.getCurrentDownloadBySlide($(slick.$slides.get(currentSlide)))
            })
        },
        onReCalc: function(data) {
            var mod;
            if (mod = this,
            mod.$ctx.closest(data.$element).length && (mod.$mainSlider.hasClass("slick-initialized") && this.forceSliderHeightReCalc(),
            mod.$thumbnailSlider.hasClass("slick-initialized")))
                return mod.$thumbnailSlider.slick("setPosition")
        },
        onThumbnailSlideSetPosition: function() {
            return this.setMediaGalleryThumbnailSliderControls()
        },
        onVideoStart: function(data) {
            var mod;
            if (mod = this,
            data.$ctx.closest(mod.$ctx).length)
                return mod.toggleSliderControls(!1),
                mod.setSlickDragEvents(!1)
        },
        onVideoStop: function(data) {
            var mod;
            if (mod = this,
            data.$ctx.closest(mod.$ctx).length)
                return mod.toggleSliderControls(!0),
                mod.setSlickDragEvents(!0)
        },
        onViewportChange: function() {
            return this.forceSliderHeightReCalc()
        }
    })
}(jQuery),
function($) {
    T.Module.MediaGalleryLayer = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            T.Utils.allSynced = !1,
            mod.isSynced = !1,
            mod.$paginationnumber = mod.$(".js-paginationnumber"),
            mod.$mainSlider = mod.$(".js-mediagallery-mainslider"),
            mod.$sliderControls = mod.$(".js-mediagallery-controls"),
            mod.$sliderControlArrowLeft = mod.$(".js-mediagallery-controls > .prev"),
            mod.$sliderControlArrowRight = mod.$(".js-mediagallery-controls > .next"),
            mod.$zoomButtons = mod.$(".js-mediagalleryproduct-zoom-in, .js-mediagalleryproduct-zoom-out"),
            mod.$zoomButtonIn = mod.$(".js-mediagalleryproduct-zoom-in button"),
            mod.$zoomButtonOut = mod.$(".js-mediagalleryproduct-zoom-out button"),
            mod.totalNumberOfSlides = mod.$ctx.find(".mediagallery-slide:not(.slick-cloned)").length,
            mod.countSlidesPerPage = 1,
            mod.currentSlide = 1,
            mod.slickSettings = {
                adaptiveHeight: !1,
                appendArrows: mod.$sliderControls,
                arrows: !0,
                autoplay: !1,
                centerMode: !1,
                centerPadding: "0px",
                dots: !1,
                fade: mod.$mainSlider.data("mediagallery-fade"),
                initialSlide: 0,
                infinite: !1,
                nextArrow: this.$sliderControlArrowRight,
                prevArrow: this.$sliderControlArrowLeft,
                slidesToShow: 1,
                slidesPerRow: 1,
                speed: 300,
                useCSS: !1,
                draggable: !1,
                swipe: !1
            },
            mod.panZoomSettings = {
                disablePan: !0,
                exponential: !1,
                minScale: 1,
                $zoomIn: $(mod.$zoomButtons[0]),
                $zoomOut: $(mod.$zoomButtons[1])
            },
            this.lastZoomFactor = 1,
            mod.mainSliderInitialized = !1,
            this._events.on("viewportChanged", function(_this) {
                return function(viewport) {
                    return _this.onViewportChange(viewport)
                }
            }(this)),
            mod._events.on("t.sync", $.proxy(mod.sync, mod)),
            mod._events.on("openLayer", $.proxy(mod.onOpenLayer, mod)),
            mod._events.on("closeLayer", $.proxy(mod.onCloseLayer, mod)),
            mod._events.on("videoPlaying", $.proxy(mod.onVideoStart, mod)),
            mod._events.on("videoStop", $.proxy(mod.onVideoStop, mod)),
            mod._events.on("videoEnded", $.proxy(mod.onVideoStop, mod)),
            resolve()
        },
        sync: function() {
            var mod;
            mod = this,
            mod.isSynced || (mod.$mainSlider.slick(mod.slickSettings),
            mod.mainSliderInitialized = !0,
            mod.$mainSlider.on("beforeChange", $.proxy(mod.onSliderBeforeChange, mod)),
            mod.$mainSlider.on("afterChange", $.proxy(mod.onSliderAfterChange, mod)),
            mod.$currentSlide = mod.$mainSlider.find(".slick-current"),
            mod.$imageContainer = mod.$mainSlider.find(".slick-current div.js-mediagalleryproduct-zoomimage"),
            mod.$currentImage = mod.$mainSlider.find(".slick-current .js-mediagalleryproduct-zoomimage img"),
            1 === mod.totalNumberOfSlides && mod.toggleSliderControls(!1),
            mod.isSynced = !0,
            T.Utils.allSynced = !0)
        },
        activateSlide: function($slide) {
            var mod;
            return mod = this,
            mod.updateSliderControlsState(),
            mod.setMainSliderCaption(),
            "image-hires" === $slide.data("media-type") || "image-ocr" === $slide.data("media-type") ? (mod.$zoomButtons.removeClass("hidden"),
            mod.$imageContainer = $slide.find("div.js-mediagalleryproduct-zoomimage"),
            mod.$currentImage = $slide.find(".js-mediagalleryproduct-zoomimage img"),
            mod.initPanzoom()) : mod.$zoomButtons.addClass("hidden")
        },
        addPanZoomListeners: function() {
            var mod;
            return mod = this,
            mod.$currentImage.on("panzoomchange.mediagallery", $.proxy(mod.onPanZoomChange, mod)),
            mod.$currentImage.on("panzoomstart", $.proxy(function(ev, panzoom) {
                return mod.$currentImage.off("panzoomchange.mediagallery"),
                mod.onPanZoomChange(ev, panzoom, mod)
            }, mod)),
            mod.$currentImage.on("panzoomend", $.proxy(function(ev, panzoom) {
                return mod.onPanZoomChange(ev, panzoom, mod),
                mod.$currentImage.on("panzoomchange.mediagallery", $.proxy(mod.onPanZoomChange, mod))
            }, mod))
        },
        checkImageState: function() {
            var mod;
            if (mod = this,
            void 0 !== mod.$currentImage[0])
                return mod.$currentImage.width() > 12 ? mod.setupPanzoom() : mod._events.on("image:loaded", $.proxy(mod.onImageLoaded, mod))
        },
        getVideoInSlide: function() {
            var currentSlideVideo, mod;
            return mod = this,
            currentSlideVideo = mod.$mainSlider.find(".slick-current .m-video"),
            currentSlideVideo.length > 0 && currentSlideVideo
        },
        initPanzoom: function() {
            var mod;
            if (mod = this,
            $.fn.panzoom)
                return mod.checkImageState()
        },
        resetZoom: function(destroyPanZoom) {
            var mod;
            if (mod = this,
            mod.$currentImage && mod.$currentImage.panzoom && "function" == typeof mod.$currentImage.panzoom && (mod.$currentImage.panzoom("reset"),
            destroyPanZoom))
                return mod.$currentImage.panzoom("destroy")
        },
        setMainSliderCaption: function() {
            return this.$("figcaption").html(this.$mainSlider.find(".slick-current").data("caption-text"))
        },
        setPaginationNumbers: function() {
            var mod;
            if (mod = this,
            mod.totalNumberOfSlides > 1)
                return mod.$paginationnumber.html(this.currentSlide + "/" + this.totalNumberOfSlides)
        },
        setSlickDragEvents: function(value) {
            var mod;
            if (mod = this,
            mod.mainSliderInitialized)
                return mod.$mainSlider.slick("slickSetOption", "draggable", value),
                mod.$mainSlider.slick("slickSetOption", "touchMove", value),
                mod.$mainSlider.slick("slickSetOption", "swipeToSlide", value),
                mod.$mainSlider.slick("slickSetOption", "swipe", value)
        },
        setupPanzoom: function() {
            var maxScale, mod, totalZoomSteps;
            return mod = this,
            totalZoomSteps = parseInt(mod.$imageContainer.data("total-zoomsteps"), 10),
            maxScale = mod.$currentImage[0].naturalWidth / mod.$currentImage.width(),
            $.extend(mod.panZoomSettings, {
                increment: (maxScale - 1) / totalZoomSteps,
                maxScale: maxScale
            }),
            mod.$currentImage.panzoom(mod.panZoomSettings),
            mod.addPanZoomListeners(),
            mod.$zoomButtonOut.attr("disabled", "disabled")
        },
        toggleSliderControls: function(enableControls) {
            var mod;
            return mod = this,
            enableControls ? mod.$sliderControls.removeClass("hidden") : mod.$sliderControls.addClass("hidden")
        },
        updateSliderControlsState: function() {
            var currentMainSlide, currentSlide;
            return currentMainSlide = this.$mainSlider.slick("slickCurrentSlide"),
            0 === currentMainSlide ? this.$sliderControlArrowLeft.addClass("is-inactive") : this.$sliderControlArrowLeft.removeClass("is-inactive"),
            currentMainSlide === this.totalNumberOfSlides - 1 ? this.$sliderControlArrowRight.addClass("is-inactive") : this.$sliderControlArrowRight.removeClass("is-inactive"),
            currentSlide = this.$mainSlider.find(".slick-current").data("slick-index"),
            this.currentSlide = currentSlide + 1,
            this.setPaginationNumbers()
        },
        onCloseLayer: function() {
            var mod;
            return mod = this,
            mod._events.emit("togglePageScrolling", {
                pin: !1
            })
        },
        onImageLoaded: function(data) {
            var mod;
            if (mod = this,
            data.$currentTarget.closest(mod.$mainSlider.find(".slick-current")))
                return mod._events.off("image:loaded"),
                mod.setupPanzoom()
        },
        onOpenLayer: function(data) {
            var mod;
            return mod = this,
            mod.$ctx.closest(data.$ctx).length && (mod.$mainSlider.slick("slickGoTo", data.$triggerElement.data("slick-index"), !0),
            mod.$currentSlide = mod.$mainSlider.find(".slick-current"),
            1 === mod.totalNumberOfSlides && (this.activateSlide(mod.$currentSlide),
            mod.$mainSlider.resize())),
            mod._events.emit("togglePageScrolling", {
                pin: !0
            })
        },
        onPanZoomChange: function(ev, panzoom) {
            var currentZoomFactor, currentZoomFactorRoundedString, currentZoomFactorString, matrixData, maxScaleRounded, mod, offsetX, offsetY;
            return mod = this,
            matrixData = panzoom.getMatrix(),
            currentZoomFactorString = matrixData[0],
            offsetX = matrixData[4],
            offsetY = matrixData[5],
            currentZoomFactorRoundedString = parseFloat(currentZoomFactorString).toFixed(2),
            currentZoomFactor = parseFloat(currentZoomFactorRoundedString),
            maxScaleRounded = parseFloat(panzoom.options.maxScale.toFixed(2)),
            currentZoomFactor > 1 ? (panzoom.options.disablePan = !1,
            mod.$zoomButtonOut.removeAttr("disabled"),
            currentZoomFactor === maxScaleRounded ? mod.$zoomButtonIn.attr("disabled", "disabled") : mod.$zoomButtonIn.removeAttr("disabled")) : (mod.$currentImage.panzoom("resetPan", {
                animate: !0,
                silent: !0
            }),
            offsetX = "0",
            offsetY = "0",
            panzoom.options.disablePan = !0,
            mod.$zoomButtonOut.attr("disabled", "disabled"),
            mod.$zoomButtonIn.removeAttr("disabled")),
            "panzoomend" !== ev.type && "panzoomchange" !== ev.type || currentZoomFactor !== mod.lastZoomFactor && currentZoomFactor <= maxScaleRounded && mod._events.emit("setZoom", {
                zoomFactor: currentZoomFactor,
                $ctx: mod.$mainSlider.find(".slick-current"),
                offsetX: offsetX,
                offsetY: offsetY
            }),
            this.lastZoomFactor = currentZoomFactor
        },
        onSliderBeforeChange: function(event, slick, currentSlide) {
            var $slide, mod, videoComponent;
            return mod = this,
            $slide = $(slick.$slides.get(currentSlide)),
            mod.resetZoom(!0),
            videoComponent = mod.getVideoInSlide(),
            mod._events.emit("layerSliderSlideBeforeChange", {
                currentSlide: currentSlide,
                $slide: $slide,
                videoComponent: videoComponent
            })
        },
        onSliderAfterChange: function(event, slick, currentSlide) {
            var mod, videoComponent;
            return mod = this,
            mod.$currentSlide = mod.$mainSlider.find(".slick-current"),
            mod.activateSlide(mod.$currentSlide),
            videoComponent = mod.getVideoInSlide(),
            mod._events.emit("layerSliderSlideAfterChange", {
                currentSlide: currentSlide,
                $slide: $(slick.$slides.get(currentSlide)),
                videoComponent: videoComponent
            })
        },
        onVideoStart: function(data) {
            var mod;
            if (mod = this,
            data.$ctx.closest(mod.$ctx).length)
                return mod.toggleSliderControls(!1),
                mod.setSlickDragEvents(!1)
        },
        onVideoStop: function(data) {
            var mod;
            if (mod = this,
            data.$ctx.closest(mod.$ctx).length)
                return mod.toggleSliderControls(!0),
                mod.setSlickDragEvents(!0)
        },
        onViewportChange: function() {
            return this.resetZoom()
        }
    })
}(jQuery),
function($) {
    T.Module.MoreLess = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$link = this.$ctx.find(".js-morelesslink"),
            this.$linkIcon = this.$link.find(".icon"),
            this.$linkText = this.$link.find(".text"),
            this.linkTextMore = this.$link.data("moreless-text-more"),
            this.linkTextLess = this.$link.data("moreless-text-less"),
            this.linkIconMore = this.$link.data("moreless-icon-more"),
            this.linkIconLess = this.$link.data("moreless-icon-less"),
            this.$moreLess = this.$ctx,
            this.$flex = this.$ctx.find(".js-content"),
            this.$reference = this.$ctx.closest("[data-moreless-reference-id]"),
            this.externalResizeControl = this.$ctx.data("external-resize-control"),
            this.configName = this.$ctx.data("moreless-config"),
            this.config = T.Utils.moreless[this.configName],
            T.Utils.allSynced = !1,
            this._events.on("moreless:close", function(_this) {
                return function(data) {
                    return _this.onClose(data)
                }
            }(this)),
            this._events.on("moreless:open", function(_this) {
                return function(data) {
                    return _this.onOpen(data)
                }
            }(this)),
            this.$link.on("click", function(_this) {
                return function(ev) {
                    return _this.onClickToggle(ev)
                }
            }(this)),
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            this.initialized = !0,
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            T.Utils.allSynced = !0,
            this.externalResizeControl || (this.calculate(),
            $(window).on(T.Utils.debounce("resize", function(_this) {
                return function() {
                    return _this.calculate()
                }
            }(this), 50))))
        },
        setMoreText: function(linkTextMore) {
            this.linkTextMore = linkTextMore
        },
        setLessText: function(linkTextLess) {
            this.linkTextLess = linkTextLess
        },
        setReference: function($reference) {
            this.$reference = $reference
        },
        isInitialized: function() {
            return this.initialized
        },
        isOpen: function() {
            return this.$link.is(".is-open")
        },
        calculate: function(retryCounter) {
            var moreLessNeeded, originalFlexHeight, referenceHeight, siblingsHeight;
            return retryCounter || (retryCounter = 0),
            referenceHeight = this.getReferenceHeight(),
            0 === referenceHeight ? void (retryCounter < 5 && setTimeout(function(_this) {
                return function() {
                    return _this.calculate(retryCounter + 1)
                }
            }(this), 300)) : (siblingsHeight = this.getSiblingsHeight(),
            originalFlexHeight = this.getOriginalFlexHeight(),
            moreLessNeeded = siblingsHeight + originalFlexHeight > referenceHeight && referenceHeight > 0,
            moreLessNeeded ? (this.$flex.addClass("is-cropped"),
            this.$link.is(".is-open") ? this.$flex.css("max-height", "") : this.$flex.css("max-height", referenceHeight - siblingsHeight),
            this.$link.removeClass("hidden")) : (this.$flex.css("max-height", "").removeClass("is-cropped"),
            this.$link.addClass("hidden")))
        },
        getOriginalFlexHeight: function() {
            return this.$flex.length ? this.$flex[0].scrollHeight : 0
        },
        getReferenceHeight: function() {
            var multiplier;
            return multiplier = this.config ? this.config.multiplier : 1,
            this.$reference.length ? this.$reference.height() * multiplier : this.config ? this.config.heights[T.Utils.getViewport()] : void 0
        },
        getSiblingsHeight: function() {
            var $siblings, heightSum;
            return heightSum = 0,
            $siblings = this.$ctx.find(".heading"),
            $siblings.each(function() {
                return heightSum += $(this).outerHeight(!0)
            }),
            heightSum
        },
        open: function() {
            return this.$linkText.text(this.linkTextLess),
            this.$link.addClass("is-open"),
            this.$flex.css("max-height", this.getOriginalFlexHeight()),
            this.$flex.removeClass("is-cropped"),
            this.$linkIcon.addClass(this.linkIconLess),
            this.$linkIcon.removeClass(this.linkIconMore)
        },
        close: function(notransition) {
            var originalFlexHeight, referenceHeight, siblingsHeight;
            if (notransition && this.$flex.addClass("notransition"),
            referenceHeight = this.getReferenceHeight(),
            siblingsHeight = this.getSiblingsHeight(),
            originalFlexHeight = this.getOriginalFlexHeight(),
            this.$linkText.text(this.linkTextMore),
            this.$link.removeClass("is-open"),
            this.$flex.css("max-height", referenceHeight - siblingsHeight),
            this.$flex.addClass("is-cropped"),
            this.$linkIcon.removeClass(this.linkIconLess),
            this.$linkIcon.addClass(this.linkIconMore),
            notransition)
                return this.$flex.removeClass("notransition")
        },
        onClickToggle: function(ev) {
            return this.isOpen() ? this.close() : this.open()
        },
        onClose: function(data) {
            if (this.$link.filter(data.$link).length > 0) {
                if (this.$link.is(":not(.is-open)"))
                    return;
                return this.close(data.notransition)
            }
        },
        onOpen: function(data) {
            if (this.$link.filter(data.$link).length > 0) {
                if (this.$link.is(".is-open"))
                    return;
                return this.open()
            }
        }
    })
}(jQuery),
function($) {
    return T.Module.MultiOptionButton = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$button = this.$ctx.find(".js-multi-option-button"),
            this.$button.on("click", $.proxy(this.onClickTrigger, this)),
            resolve()
        },
        onClickTrigger: function(ev) {
            return ev.stopPropagation(),
            this.$button.hasClass("is-active") ? (this.$button.removeClass("is-active"),
            this._events.emit("popover:close"),
            $(document).off("click")) : (this.$button.addClass("is-active"),
            $(document).on("click", $.proxy(this.onClickOutsideTrigger, this)))
        },
        onClickOutsideTrigger: function(ev) {
            return ev.stopPropagation(),
            this.$button.removeClass("is-active"),
            $(document).off("click"),
            this._events.emit("popover:close")
        }
    })
}(jQuery),
function($) {
    T.Module.NavAnchor = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.isSynced = !1,
            mod.$ctx = $(this._ctx),
            mod.$navigation = this.$(".js-navigation"),
            mod.$list = this.$(".js-fixed"),
            mod.$more = this.$(".js-hidden-more-active"),
            mod.$moreActive = this.$(".js-more-active"),
            mod.$moreTrigger = this.$(".js-more"),
            mod.$moreContainer = this.$(".js-more-container"),
            mod.$moreContainerList = this.$(".js-more-container-list"),
            T.Utils.registerMq("lg", {
                match: function() {
                    return mod.setupMobile()
                },
                unmatch: function() {
                    return mod.setupDesktop()
                }
            }, "max"),
            mod._events.on("t.sync", $.proxy(this.sync, this)),
            resolve()
        },
        sync: function() {
            var mod;
            this.isSynced || (mod = this,
            mod.isSynced = !0,
            mod.$ctx.on("click", "a[href]", $.proxy(mod.onClickLink, mod)),
            $(window).on(T.Utils.debounce("resize", $.proxy(mod.onWindowResize, mod), 50)),
            $(window).on("scroll", $.proxy(mod.onWindowScroll, mod)),
            mod._events.emit("header:disable-sticky"),
            mod.preloadContentImages())
        },
        calculateMoreContainerPosition: function() {
            return this.$moreContainer.css("width", this.$moreTrigger.position().left + this.$moreTrigger.outerWidth())
        },
        checkSections: function() {
            var $activeLink, $links, $window, navAnchorHeight;
            if ($window = $(window),
            $links = this.$list.find("a[href]"),
            navAnchorHeight = this.$navigation.outerHeight(),
            $links.each(function() {
                var $link, $section, target;
                return $link = $(this),
                target = $link.attr("href"),
                $section = $(target),
                $section.length && $section.offset().top <= $window.scrollTop() + navAnchorHeight + 5 ? ($links.removeClass("is-active"),
                $link.addClass("is-active")) : $link.removeClass("is-active")
            }),
            !T.Utils.isViewport("desktop") && ($activeLink = $links.filter(".is-active"),
            $activeLink.length || ($activeLink = $links.filter(":first")),
            !this.$moreActive.find("a").is($activeLink)))
                return this.$moreActive.empty(),
                $activeLink.clone().appendTo(this.$moreActive)
        },
        preloadContentImages: function() {
            return this.$list.find("a[href]:not(.js-more)").each(function() {
                var $content, href;
                return href = $(this).attr("href"),
                $content = $(href),
                $content.find(".lazyload").addClass("lazypreload")
            })
        },
        setupDesktop: function() {
            return this.$moreContainerList.children().prependTo(this.$list),
            $(document).off("click.navanchor"),
            this.$moreContainer.css("width", "")
        },
        setupMobile: function() {
            return this.$moreActive.empty(),
            this.$list.find("a:first").clone().appendTo(this.$moreActive),
            this.$list.children("li:not(.hidden-desktop):not(.to-top)").appendTo(this.$moreContainerList),
            $(document).on("click.navanchor", $.proxy(this.onClickDocument, this)),
            this.$moreContainer.css("width", this.$moreContainer.width() + this.$moreTrigger.outerWidth())
        },
        onClickDocument: function(ev) {
            var $target;
            if ($target = $(ev.target),
            this.$moreTrigger.hasClass("is-open") && !$target.closest(this.$more).length)
                return this.$moreTrigger.removeClass("is-open")
        },
        onClickLink: function(ev) {
            var $link, $section;
            return $link = $(ev.currentTarget),
            $section = $($link.attr("href")),
            $section.length && (T.Utils.scrollToTop($section.offset().top - this.$list.outerHeight()),
            this.$moreTrigger.removeClass("is-open")),
            $link.is(this.$moreTrigger) && (this.calculateMoreContainerPosition(),
            this.$moreTrigger.toggleClass("is-open")),
            ev.preventDefault()
        },
        onWindowResize: function() {
            return this.calculateMoreContainerPosition()
        },
        onWindowScroll: function(ev) {
            var scrollTop;
            return scrollTop = $(window).scrollTop(),
            scrollTop >= this.$ctx.offset().top ? this.$navigation.addClass("is-fixed") : this.$navigation.removeClass("is-fixed"),
            this.checkSections()
        }
    })
}(jQuery),
function($) {
    T.Module.Navfooter = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$section = mod.$(".section"),
            mod.$lists = mod.$(".section ul"),
            mod.$groupHeader = mod.$lists.find(".group-header"),
            mod.$closeButton = mod.$(".js-close"),
            mod.$textButtonClose = this.$section.data("text-button-close"),
            mod.$textButtonShowAll = this.$section.data("text-button-show-all"),
            mod.$closeButton.on("click", $.proxy(mod.onClickClose, mod)),
            T.Utils.registerMq("md", {
                match: function() {
                    return mod.$groupHeader.find("a").on("click", $.proxy(mod.onClickToggle, mod)),
                    mod.$lists.each(function() {
                        return mod.mobileNav($(this))
                    })
                },
                unmatch: function() {
                    return mod.$groupHeader.find("a").off("click"),
                    mod.$lists.each(function() {
                        return mod.mobileNav($(this), "reset"),
                        mod.displayLists($(this))
                    }),
                    mod.$lists.find("li > a > i").each(function() {
                        return $(this).removeClass("icon-arrow-up").addClass("icon-arrow-down")
                    })
                }
            }, "max"),
            T.Utils.registerMq("md", {
                match: function() {
                    return mod.$lists.each(function() {
                        return mod.displayLists($(this))
                    })
                }
            }),
            T.Utils.registerMq("lg", {
                match: function() {
                    return mod.$lists.each(function() {
                        return mod.hideLists($(this))
                    })
                },
                unmatch: function() {
                    return mod.$lists.each(function() {
                        return mod.displayLists($(this))
                    })
                }
            }),
            resolve()
        },
        sync: function() {},
        displayLists: function($list) {
            return $list.addClass("hidden-list")
        },
        hideLists: function($list) {
            return $list.removeClass("hidden-list")
        },
        mobileNav: function($list, reset) {
            var $groupHeader, $overviewLink;
            return $groupHeader = $list.find(".group-header a"),
            $overviewLink = $list.find(".overview a"),
            reset ? ($list.removeClass("hidden-list"),
            $groupHeader.attr("href", $overviewLink.attr("href"))) : ($list.addClass("hidden-list"),
            $overviewLink.attr("href", $groupHeader.attr("href")),
            $groupHeader.attr("href", "javascript:void(null)"))
        },
        onClickToggle: function(ev) {
            var $toggle;
            return $toggle = $(ev.currentTarget),
            $toggle.closest(".list-unstyled").toggleClass("hidden-list"),
            $toggle.find(".icon").toggleClass("icon-arrow-down").toggleClass("icon-arrow-up")
        },
        onClickClose: function(ev) {
            var $button, $section;
            return $button = $(ev.currentTarget),
            $section = $button.parent(),
            $section.find("ul").each(function() {
                return $(this).toggleClass("hidden-list")
            }),
            $button.hasClass("opened") ? $button.removeClass("opened").text(this.$textButtonShowAll) : $button.text(this.$textButtonClose).addClass("opened")
        }
    })
}(jQuery),
function($) {
    T.Module.NavMain = T.createModule({
        start: function(resolve) {
            var hashids, mod;
            return mod = this,
            this.$ctx = $(this._ctx),
            mod.$menu = mod.$(".navigation"),
            mod.$menuToggle = this.$ctx.find(".js-mobile-menu-toggle"),
            mod.$navHeader = mod.$(".js-nav-header"),
            mod.$titleIdentifier = mod.$(".js-title-identifier"),
            mod.$previousLink = mod.$(".js-previous-link"),
            mod.$overviewLink = mod.$(".js-overview-link"),
            mod.counter = 0,
            mod.$previousLink.data("text-home", mod.$previousLink.find(".text").text()),
            mod.$("nav li > a").each(function() {
                var $link, $nextLevel;
                if ($link = $(this),
                $nextLevel = $link.siblings("ul"),
                $nextLevel.length)
                    return $link.addClass("has-child-level")
            }),
            T.Utils.registerMq("lg", {
                setup: function() {
                    return mod.$menu.find(".second-level .js-close").on("click.desktop", $.proxy(mod.onClickFlyoutClose, mod))
                },
                match: function() {
                    return mod.$menu.find("img").on("load", $.proxy(mod.onLoadImage, mod)),
                    mod.$menu.find(".first-level > li > a").on("click.desktop", $.proxy(mod.onClickFirstLevelDesktop, mod)),
                    mod.$menu.css("height", "")
                },
                unmatch: function() {
                    return mod.$menu.find(".first-level > li > a").off("click.desktop"),
                    mod.$(".is-active").removeClass("is-active"),
                    mod.$menu.css("height", "")
                }
            }),
            T.Utils.registerMq("lg", {
                setup: function() {
                    return mod.$menuToggle.on("click.mobile", $.proxy(mod.onClickMenuToggle, mod)),
                    mod.$previousLink.on("click.mobile", $.proxy(mod.onClickPrevious, mod)),
                    mod._events.on("closeMobileNav.header", $.proxy(mod.onCloseMobileNav, mod))
                },
                match: function() {
                    return mod.$(".navigation li:not(.overview) > a").on("click.mobile", $.proxy(mod.onClickNavEntry, mod))
                },
                unmatch: function() {
                    return mod.$menu.hasClass("is-active-mobile") && mod.$menuToggle.trigger("click.mobile"),
                    mod.$(".navigation li:not(.overview) > a").off("click.mobile"),
                    mod.$(".is-active-mobile,.is-active-parent-mobile").removeClass("is-active-mobile is-active-parent-mobile")
                }
            }, "max"),
            hashids = T.Utils.getHashIds("NavMain"),
            location.hash && hashids.length && this.showMenuOnStart(hashids[0]),
            mod._events.on("navmain:open-mobile-menu", $.proxy(mod.onOpenMobileMenu, mod)),
            mod._events.on("navmain:open-flyout", $.proxy(mod.onOpenFlyout, mod)),
            resolve()
        },
        showMenuOnStart: function(hashid) {
            var $link;
            return $link = this.$("nav [data-id='" + hashid + "']"),
            $link.next(".second-level").find(".lazyload").addClass("lazypreload"),
            $link.trigger("click"),
            T.Utils.removeHash("NavMain", [hashid])
        },
        setNavHeightMobile: function() {
            var $activeLayer, height;
            return $activeLayer = this.$menu.find(".is-active-mobile:last"),
            height = this.$navHeader.height(),
            $activeLayer.length ? (height = height + $activeLayer.height() + "px",
            this.$menu.find(".second-level").addClass("fade-in")) : height = "",
            this.$menu.css("height", height)
        },
        setNavHeightDesktop: function($firstLevelEntry) {
            var $secondLevel, conversionBarHeight, firstLevelHeight, height, navHeight, navigationHeight;
            return navigationHeight = this.$menu.outerHeight(),
            conversionBarHeight = this.$menu.find(".conversion-bar").outerHeight(),
            firstLevelHeight = this.$menu.find(".first-level").outerHeight(),
            $secondLevel = $firstLevelEntry.find(".second-level"),
            this.$menu.css("height", $secondLevel.outerHeight()),
            $firstLevelEntry.hasClass("is-active") ? (navHeight = $secondLevel.outerHeight(),
            height = firstLevelHeight + navHeight + conversionBarHeight + "px",
            this.$menu.css("height", height),
            this.$menu.find(".second-level").addClass("fade-in")) : (height = firstLevelHeight,
            this.$menu.css("height", height),
            $secondLevel.removeClass("fade-in"))
        },
        setOverviewLink: function($link) {
            return this.$overviewLink.attr("href", $link.attr("href"))
        },
        setPreviousLink: function($link) {
            return $link.length ? this.$previousLink.find(".text").text($link.text()) : this.$previousLink.find(".text").text(this.$previousLink.data("text-home"))
        },
        setSecondLevelHeightDesktop: function($firstLevel) {
            return $firstLevel.find(".second-level > li").matchHeight()
        },
        setTitleIdentifier: function($link) {
            return this.$titleIdentifier.text($link.text())
        },
        onClickButtonClose: function(ev) {
            return this.$(".navigation").removeClass("active"),
            this.menu.parent().find(".button-menu .icon").toggleClass("icon-listview").toggleClass("icon-close"),
            this._events.emit("headerOpen")
        },
        onClickFirstLevelDesktop: function(ev) {
            var $currentLink, $firstLevelEntry;
            if ($currentLink = $(ev.currentTarget),
            $firstLevelEntry = $currentLink.parent(),
            this.$menu.css("height", $firstLevelEntry.outerHeight()),
            this.$menu.find(".first-level > li").hasClass("is-active") || this.$menu.find(".second-level").removeClass("fade-in"),
            $firstLevelEntry.hasClass("is-active") || $firstLevelEntry.siblings().removeClass("is-active"),
            $currentLink.siblings("ul").length)
                return $firstLevelEntry.toggleClass("is-active"),
                $firstLevelEntry.hasClass("is-active") && this.setSecondLevelHeightDesktop($firstLevelEntry),
                this.setNavHeightDesktop($firstLevelEntry),
                ev.preventDefault()
        },
        onClickFlyoutClose: function(ev) {
            var $closeButton;
            return $closeButton = $(ev.currentTarget),
            $closeButton.closest(".second-level").siblings("a").trigger("click")
        },
        onClickMenuToggle: function(ev) {
            var $navmeta, $toggle;
            return $toggle = $(ev.currentTarget),
            $navmeta = this.$ctx.find($toggle).closest("m-navmeta"),
            this.$menu.toggleClass("is-active-mobile"),
            this.$menu.height("auto"),
            this.$menuToggle.toggleClass("is-active-mobile"),
            this._events.emit("toggleNavMetaMenu", {
                isMenuOpen: this.$menu.hasClass("is-active-mobile"),
                $headerCtx: $toggle.closest(".o-header")
            }),
            this._events.emit("closeSearchByNav"),
            this._events.emit("headerOpen")
        },
        onClickNavEntry: function(ev) {
            var $link, $onlyEntry, $parentLayer, $secondLevelLink, $siblings;
            if ($link = $(ev.currentTarget),
            $siblings = $link.siblings("ul"),
            $parentLayer = $link.closest("ul"),
            $onlyEntry = $siblings.children("li:not(.overview):not(.close)"),
            1 === $onlyEntry.length && $onlyEntry.children(".a-link").hasClass("has-child-level") && (this.$navHeader.addClass("js-only-entry"),
            $siblings.addClass("is-skipped-level"),
            $siblings = $onlyEntry.children("ul"),
            $siblings.parent().closest("ul").addClass("is-active-mobile is-active-parent-mobile"),
            $secondLevelLink = $link.closest("li").find(".second-level-link")),
            $siblings.length)
                return $parentLayer.addClass("is-active-parent-mobile"),
                $siblings.addClass("is-active-mobile"),
                this.$navHeader.hasClass("js-only-entry") ? this.setOverviewLink($secondLevelLink) : this.setOverviewLink($link),
                this.setPreviousLink($parentLayer.siblings("a")),
                this.setTitleIdentifier($link),
                this.$navHeader.addClass("is-active"),
                this.setNavHeightMobile(),
                ev.preventDefault()
        },
        onClickPrevious: function(ev) {
            var $activeLayer, $parentLayer, $parentLink;
            return $activeLayer = this.$(".is-active-mobile:last"),
            $parentLayer = $activeLayer.parent().closest("ul"),
            $parentLink = $parentLayer.siblings("a"),
            this.$navHeader.hasClass("js-only-entry") && (this.$menu.find("ul").removeClass("is-active-mobile is-active-parent-mobile"),
            this.$navHeader.removeClass("is-active js-only-entry")),
            $activeLayer.removeClass("is-active-mobile"),
            $parentLayer.removeClass("is-active-parent-mobile"),
            $parentLayer.parents("ul").length ? (this.setOverviewLink($parentLink),
            this.setPreviousLink($parentLink.closest("ul").siblings("a")),
            this.setTitleIdentifier($parentLink)) : this.$navHeader.removeClass("is-active"),
            this.setNavHeightMobile(),
            ev.preventDefault()
        },
        onCloseMobileNav: function() {
            return this.$menu.removeClass("is-active-mobile"),
            this.$menuToggle.removeClass("is-active-mobile"),
            this._events.emit("closeNavMetaMenu.header"),
            this._events.emit("headerClose")
        },
        onLoadImage: function(ev) {
            var $firstLevel, $img;
            if ($img = $(ev.currentTarget),
            $firstLevel = $img.closest(".second-level").closest("li"),
            $firstLevel.hasClass("is-active"))
                return this.setSecondLevelHeightDesktop($firstLevel),
                this.setNavHeightDesktop($firstLevel)
        },
        onOpenFlyout: function(data) {
            var $entry;
            if (data.id)
                return $entry = this.$("[data-id='" + data.id + "']"),
                $entry.siblings(".second-level").find(".lazyload").addClass("lazypreload"),
                $entry.trigger("click")
        },
        onOpenMobileMenu: function() {
            if (!this.$menuToggle.hasClass("is-active-mobile"))
                return this.$menuToggle.trigger("click")
        }
    })
}(jQuery),
function($) {
    T.Module.NavMeta = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$closeButton = this.$(".js-close-mobile"),
            this.$closeButton.on("click", $.proxy(this.onClickMobileNavClose, this)),
            this.$selectLanguage = this.$(".language-selector").find("select"),
            this.$selectLanguage.on("change", $.proxy(this.onChangeLanguage, this)),
            this._events.on("toggleNavMetaMenu", $.proxy(this.onToggleNavMetaMenu, this)),
            this._events.on("closeNavMetaMenu.header", $.proxy(this.closeNavMetaMenu, this)),
            resolve()
        },
        sync: function() {},
        closeNavMetaMenu: function(ev) {
            return this.$ctx.removeClass("is-active-mobile")
        },
        onToggleNavMetaMenu: function(data) {
            if (this.$ctx.closest(data.$headerCtx).length)
                return this.$ctx.toggleClass("is-active-mobile")
        },
        onChangeLanguage: function() {
            var location;
            return location = this.$selectLanguage.val(),
            window.location = location
        },
        onClickMobileNavClose: function(ev) {
            return this._events.emit("closeMobileNav.header")
        }
    })
}(jQuery),
function($) {
    T.Module.NavMyAccount = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.OrderCancelItem = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$requestform = $(".js-ajax-request", this.$ctx),
            this.$requesttrigger = $(".js-trigger-order-cancellation", this.$ctx),
            this.$requesterrorbox = $(".js-request-error-box", this.$ctx),
            this.sync = $.proxy(this.sync, this),
            this.handleFailedCancelRequest = $.proxy(this.handleFailedCancelRequest, this),
            this.onTriggerCancellationRequest = $.proxy(this.onTriggerCancellationRequest, this),
            this._events.on("t.sync", this.sync),
            this.$requestform.on("submit", this.onTriggerCancellationRequest),
            console.log("OrderCancelItem start"),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            console.log("OrderCancelItem sync"))
        },
        handleFailedCancelRequest: function(jqXHR, textStatus, thrownError) {
            return this._events.emit("hideLayer", !0),
            this.$requesterrorbox.toggleClass("hidden", !1)
        },
        onTriggerCancellationRequest: function(e) {
            var request;
            if (this.$requestform.get(0).checkValidity())
                return request = T.Utils.startAjaxRequest(this.$requestform.data("ajax-id")),
                request[0].fail(this.handleFailedCancelRequest),
                e.preventDefault()
        }
    })
}(jQuery),
function($) {
    T.Module.OrderCookbook = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$downloadLanguage = $(".js-select-language", this.$ctx),
            this.$downloadLink = $(".js-download-cookbook-link", this.$ctx),
            this.$form = $(".js-ajax-request", this.$ctx),
            this.stateclass = {
                hidden: "is-hidden"
            },
            this.changeDownloadLink = $.proxy(this.changeDownloadLink, this),
            this.onChangeLanguage = $.proxy(this.onChangeLanguage, this),
            this.onSubmitForm = $.proxy(this.onSubmitForm, this),
            this.sync = $.proxy(this.sync, this),
            this._events.on("t.sync", this.sync),
            this.$downloadLanguage.on("change", this.onChangeLanguage),
            this.$form.on("submit", this.onSubmitForm),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0)
        },
        changeDownloadLink: function(id) {
            var i, len, link, ref, results;
            for (ref = this.$downloadLink,
            results = [],
            i = 0,
            len = ref.length; i < len; i++)
                link = ref[i],
                results.push($(link).toggleClass(this.stateclass.hidden, Boolean($(link).data("factoryMaterialNumber") - id)));
            return results
        },
        onChangeLanguage: function(ev) {
            return this.changeDownloadLink(this.$downloadLanguage.val())
        },
        onSubmitForm: function(ev) {
            return ev.preventDefault(),
            T.Utils.startAjaxRequest(this.$form.data("ajaxId"))
        }
    })
}(jQuery),
function($) {
    T.Module.OrderPurchaseItem = T.createModule({
        start: function(resolve) {
            return resolve();
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.PaymentDeliveryMethod = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.PaymentQRCode = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this._selector = {
                qrConfig: "[data-payment-qr-config]"
            },
            this.weChatData = $(this._selector.qrConfig).data("paymentQrConfig"),
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            this.showQRCode(),
            this.checkIfPayed())
        },
        showQRCode: function() {
            return this.weChatData.codeUrl || (console.error("weChatPayment Url is expired!"),
            this.weChatData.codeUrl = "weChatPayment Url is expired!"),
            $(this.$ctx).qrcode({
                typeNumber: 7,
                render: "canvas",
                width: 300,
                height: 300,
                correctLevel: 3,
                text: this.weChatData.codeUrl
            }),
            !0
        },
        checkIfPayed: function() {
            var response;
            return this.weChatData.queryUrl ? this.weChatData.returnUrl ? !!(response = T.Utils.startAjaxRequest(!1, {
                url: this.weChatData.queryUrl,
                dataType: "JSON",
                method: "POST"
            })) && (response[0].fail(function(_this) {
                return function(result) {
                    return console.error("weChatPayment: checkIfPayed failed: ", result, "redirect to ", _this.weChatData.returnUrl),
                    window.location.href = _this.weChatData.returnUrl
                }
            }(this)),
            response[0].done(function(_this) {
                return function(result) {
                    return "PENDING" === result ? void setTimeout(function() {
                        return _this.checkIfPayed()
                    }, 3e3) : window.location.href = _this.weChatData.returnUrl
                }
            }(this)),
            !0) : (console.error("weChatPayment: cannot check if payed! (no returnUrl)"),
            !1) : (console.error("weChatPayment: cannot check if payed! (no queryUrl)"),
            !1)
        }
    })
}(jQuery),
function($) {
    T.Module.PaymentSelection = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.isSynced = !1,
            this.downpaymentData = {},
            this.sync = $.proxy(this.sync, this),
            this.extendFormData = $.proxy(this.extendFormData, this),
            this.onClickImage = $.proxy(this.onClickImage, this),
            this.onChangeMethod = $.proxy(this.onChangeMethod, this),
            this._events.on("t.sync", this.sync),
            this._events.on("downpayment:updateform", this.extendFormData),
            this.$(".a-image").on("click", this.onClickImage),
            this.$ctx.on("change", ":radio", this.onChangeMethod),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0)
        },
        extendFormData: function(downpaymentData) {
            return this.downpaymentData = downpaymentData
        },
        onChangeMethod: function(ev) {
            var $clickedRadio;
            return $clickedRadio = $(ev.currentTarget),
            this.handleAjaxRequest($clickedRadio)
        },
        onClickImage: function(ev) {
            var $clickedImage, $closestInput;
            if ($clickedImage = $(ev.currentTarget),
            !$clickedImage.data("popover-id"))
                return $closestInput = $clickedImage.parent().find(":input"),
                $closestInput.prop("checked", !0).trigger("change")
        },
        handleAjaxRequest: function(el) {
            var $installments, data, mod, request;
            return data = {},
            mod = this,
            $(el).is("[data-exclude]") && ($installments = mod.$ctx.find(".installments"),
            $installments.children().remove()),
            this.$(":radio:checked").each(function() {
                var $radio;
                return $radio = $(this),
                data[$radio.attr("name")] = $radio.val()
            }),
            data = $.extend(this.downpaymentData, data),
            request = T.Utils.startAjaxRequest(this.$ctx.data("ajax-id"), null, data),
            !!request && request[0].done(function(response) {
                var installments;
                return installments = mod.$ctx.find(".installments"),
                0 === installments.children().length ? installments.hide() : installments.show()
            })
        }
    })
}(jQuery),
function($) {
    return T.Module.Popover = T.createModule({
        start: function(resolve) {
            var config, mod;
            return mod = this,
            this.$ctx = $(this._ctx),
            config = T.Utils.popover,
            this.defaults = {
                align: config.defaults.align,
                position: config.defaults.position,
                width: this.$ctx.css("width")
            },
            this.appended = !1,
            this.configuration = $.extend(this.defaults, this.$ctx.data()),
            null != this.configuration.id && (this.configuration.id = this.configuration.id.toString()),
            this.events = this.configuration.events,
            this.imagesCount = 0,
            this.isSticky = this.configuration.sticky || !1,
            this.timeoutClosePopover = this.configuration.timeoutClose || !1,
            this.width = "",
            this.dataName = "popoverId",
            this.comparePopoverEventNamespace = "popoverid",
            this.comparePopoverContainerSelector = ".js-toggle-compare",
            this.opened = !1,
            this.options = {
                arrowElement: ".js-popover-arrow",
                boundariesElement: this.getBoundaries(this.configuration.boundaries),
                boundariesPadding: 0,
                flipBehavior: this.getFlipBehaviour(),
                gpuAcceleration: !0,
                modifiers: this.getModifiers(),
                placement: this.configuration.position
            },
            this.$close = this.$(".js-popover-close"),
            this.$parentTrigger = $('[data-popover-parent-id="' + this.configuration.id + '"]'),
            T.Utils.registerContentInitializer(function(_this) {
                return function(content) {
                    var $trigger;
                    return $trigger = $(content).find('[data-popover-id="' + _this.configuration.id + '"]'),
                    null != _this.events ? $trigger.on(_this.events, function(ev) {
                        return _this.prepareOpen(ev)
                    }) : $trigger.not(".js-add-to-basket").on("click", function(ev) {
                        return _this.prepareOpen(ev)
                    })
                }
            }(this)),
            this._events.on("popover:open", function(_this) {
                return function($triggerElement) {
                    return _this.onOpenPopovers($triggerElement)
                }
            }(this)),
            this._events.on("popover:close", function(_this) {
                return function(data) {
                    return _this.onClosePopovers(data)
                }
            }(this)),
            this._events.on("image:loaded", function(_this) {
                return function() {
                    return _this.onLoadAnyImage()
                }
            }(this)),
            this._events.on("popover:openbyid", function(_this) {
                return function(data) {
                    return _this.onOpenPopoverById(data)
                }
            }(this)),
            this.$parentTrigger.length && (this.$trigger = this.$parentTrigger),
            this.$ctx.css(this.detectPopoverDimensions()),
            this.setupImages(),
            this.configuration.openOnload && this.prepareOpen(),
            enquire.register("screen and (max-width: " + this.width + "px)", {
                match: function() {
                    if (mod.imagesCount && "number" == typeof mod.width)
                        return mod.$ctx.addClass("no-image-float").css("max-width", 250)
                },
                unmatch: function() {
                    if (mod.imagesCount && "number" == typeof mod.width)
                        return mod.$ctx.removeClass("no-image-float").css("max-width", mod.width)
                },
                setup: function() {}
            }),
            resolve()
        },
        stop: function() {
            if (null != this.popper)
                return this.popper.destroy()
        },
        appendToDom: function() {
            if (!this.appended)
                return this.$ctx.appendTo("body"),
                this.$close.on("click", function(_this) {
                    return function(ev) {
                        return _this.onClickClose(ev)
                    }
                }(this)),
                this.appended = !0
        },
        clearTimeout: function() {
            return window.clearTimeout(this.timeoutID),
            this.timeoutID = null
        },
        closePopover: function() {
            if (this.$ctx.removeClass("is-active"),
            $(document).off("click.popover"),
            $(document).off("click." + this.comparePopoverEventNamespace),
            $(document).off("keyup.popover"),
            $(document).off("keyup." + this.comparePopoverEventNamespace),
            $(window).off("resize.popover"),
            $(window).off("scroll.popover"),
            this.clearTimeout(),
            this.opened = !1,
            this.popper && (this.popper.destroy(),
            "add-to-cart" === this.configuration.id.toString()))
                return this.$ctx.remove()
        },
        closePopoverAfterTimeout: function() {
            var mod;
            if (mod = this,
            this.timeoutClosePopover > 0)
                return this.timeoutID = window.setTimeout(function() {
                    return mod.closePopover()
                }, this.timeoutClosePopover)
        },
        detectPopoverDimensions: function() {
            switch (this.configuration.width) {
            case "trigger":
                this.width = this.$trigger.outerWidth();
                break;
            case !1:
            case void 0:
                this.width = "auto";
                break;
            default:
                this.width = parseInt(this.configuration.width)
            }
            return {
                "max-width": this.width
            }
        },
        getBoundaries: function(boundaries) {
            return boundaries ? this.$ctx.closest(boundaries).get(0) : "viewport"
        },
        getFlipBehaviour: function() {
            switch (this.configuration.position) {
            case "top":
                return ["top", "bottom"];
            case "bottom":
                return ["bottom", "top"];
            case "left":
                return ["left", "right", "top", "bottom"];
            case "right":
                return ["right", "left", "top", "bottom"];
            case !1:
            case void 0:
                return ["right", "left", "top", "bottom"];
            default:
                return ["right", "left", "top", "bottom"]
            }
        },
        getModifiers: function() {
            return this.isSticky || this.configuration.boundaries ? ["shift", "offset", "preventOverflow", "flip", "applyStyle"] : ["shift", "offset", "preventOverflow", "keepTogether", "arrow", "flip", "applyStyle"]
        },
        openPopover: function($trigger) {
            return this.popper.update(),
            this.$ctx.addClass("is-active"),
            this.setArrowPosition($trigger),
            this.closePopoverAfterTimeout(),
            this.opened = !0,
            !this.hasImages || this.hasImages && this.imagesLoaded >= this.imagesCount ? (this._events.emit("popover:close", {
                $ctx: this.$ctx
            }),
            this.popper.update(),
            this.$ctx.addClass("is-active"),
            this.setArrowPosition($trigger),
            this.closePopoverAfterTimeout(),
            $(document).on("click.popover", $.proxy(this.onClickDocument, this)),
            $(document).on("keyup.popover", $.proxy(this.onClickEsc, this))) : (this.openWhenImageLoaded = !0,
            void this.$(".lazyload").addClass("lazypreload"))
        },
        openPopoverById: function(id) {
            var $trigger;
            return $trigger = this.$ctx,
            this._events.emit("popover:close", {
                $ctx: this.$ctx
            }),
            this.popper.update(),
            this.$ctx.addClass("is-active"),
            this.setArrowPosition($trigger),
            $(document).on("click." + this.comparePopoverEventNamespace, null, id, $.proxy(this.onClickDocumentPopoverById, this)),
            $(document).on("keyup." + this.comparePopoverEventNamespace, $.proxy(this.onClickEsc, this))
        },
        setArrowPosition: function($trigger) {
            return "top" === this.$ctx.attr("x-placement") || "bottom" === this.$ctx.attr("x-placement") ? this.$(".popover-arrow").css({
                left: $trigger.offset().left + $trigger.outerWidth() / 2 - this.$ctx.offset().left
            }) : this.$(".popover-arrow").css({
                left: ""
            })
        },
        setupImages: function() {
            return this.imagesCount = this.$("img.lazyload").length,
            this.hasImages = this.imagesCount > 0,
            this.imagesLoaded = 0,
            this.$("img").on("load", $.proxy(this.onLoadImage, this))
        },
        setupPopover: function($trigger) {
            var mod;
            0 === $trigger.offset().left && 0 === $trigger.offset().top && ($trigger = $('[data-popover-id="' + this.configuration.id + '"]')),
            mod = this;
            try {
                return this.popper = new Popper($trigger,this.$ctx.get(0),this.options).onCreate(function(instance) {
                    mod.isSticky && (instance.state.position = "fixed")
                }).onUpdate(function(data) {
                    mod.setArrowPosition($trigger)
                })
            } catch (error) {}
        },
        prepareOpen: function(ev) {
            var $trigger;
            if ($trigger = $(null != ev ? ev.target : '[data-popover-id="' + this.configuration.id + '"]'),
            this.appendToDom(),
            this.setupPopover($trigger),
            this.clearTimeout(),
            this.configuration.triggerToggle && this.$ctx.hasClass("is-active") ? this.closePopover() : this.openPopover($trigger),
            ev)
                return ev.preventDefault()
        },
        prepareOpenById: function(id) {
            return this.appendToDom(),
            this.setupPopover(this.$ctx),
            this.clearTimeout(),
            this.openPopoverById(id)
        },
        onClickClose: function(ev) {
            var $target;
            if ($target = $(ev.target),
            !$target.hasClass("a-link") && !$target.parent().hasClass("a-link"))
                return this.closePopover(),
                ev.preventDefault()
        },
        onClickDocument: function(ev) {
            var $target, childNode, i, len, ref;
            if ($target = $(ev.target),
            !$(ev.target).data(this.dataName)) {
                for (ref = $(ev.target).parents(),
                i = 0,
                len = ref.length; i < len && (childNode = ref[i],
                !$(childNode).data(this.dataName)); i++)
                    ;
                if (!($target.closest(this.$ctx).length || $target.closest(this.$trigger).length || $(childNode).data(this.dataName)))
                    return this.$close.trigger("click")
            }
        },
        onClickDocumentPopoverById: function(ev) {
            var $comparePopoverContainer, $comparePopoverTrigger, $eventTarget, mod, targetPopoverDataId;
            if (mod = this,
            ev.handleObj.namespace === mod.comparePopoverEventNamespace)
                return targetPopoverDataId = ev.data,
                $eventTarget = $(ev.target),
                $eventTarget.data(mod.dataName) || ($comparePopoverContainer = $eventTarget.closest(mod.comparePopoverContainerSelector),
                $comparePopoverTrigger = $comparePopoverContainer.find("[data-popover-id='" + targetPopoverDataId + "']"),
                $comparePopoverTrigger.length) ? void 0 : this.$close.trigger("click")
        },
        onClickEsc: function(ev) {
            if (27 === ev.which)
                return this.$close.trigger("click"),
                this.clearTimeout()
        },
        onClosePopovers: function(data) {
            if ("object" == typeof data && data.hasOwnProperty("$ctx") && !this.$ctx.is(data.$ctx))
                return this.closePopover()
        },
        onLoadAnyImage: function() {
            if (this.opened && this.popper)
                return this.popper.update()
        },
        onLoadImage: function(ev) {
            var $img;
            if ($img = $(ev.currentTarget),
            $img.hasClass("lazyload") || (this.imagesLoaded += 1),
            $img.addClass("lazypreload"),
            this.imagesLoaded >= this.imagesCount && this.popper && (this.popper.update(),
            this.openWhenImageLoaded))
                return this.prepareOpen(),
                this.openWhenImageLoaded = !1
        },
        onOpenPopoverById: function(id) {
            if (id && this.configuration.id === id)
                return this.prepareOpenById(id)
        },
        onOpenPopovers: function($triggerElement) {
            var $popover, popoverId;
            if (popoverId = $triggerElement.data().popoverId,
            $popover = $('[data-id="' + popoverId + '"]'),
            $popover.is(this.$ctx))
                return this.prepareOpen()
        },
        onWindowResize: function() {
            if (this.popper)
                return this.popper.update()
        }
    })
}(jQuery),
function($) {
    T.Module.PressDateSelection = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.$ajaxForm = mod.$ctx.closest(".js-ajax-request"),
            mod.$submitBtn = mod.$(".js-submit-date-selection"),
            mod.$submitBtn.on("click", $.proxy(mod.onSubmitDateSelection, mod)),
            mod._events.on("filter:reset", $.proxy(mod.onFilterReset, mod)),
            resolve()
        },
        sync: function() {},
        onSubmitDateSelection: function(ev) {
            var config, mod, request;
            return ev.preventDefault(),
            ev.stopImmediatePropagation(),
            mod = this,
            config = mod.$ajaxForm.data(),
            mod._events.emit("updateSortingDropdown", {
                $ctx: $(".m-filterbar .js-filterbar-sorting select").first(),
                sortKey: "",
                triggerChange: !0,
                triggerUpdateSticky: !0
            }),
            request = T.Utils.startAjaxRequest(config.ajaxId, {
                beforeSend: function(ev, xhr) {
                    var additionalParameters;
                    return additionalParameters = {
                        pageNumber: 1
                    },
                    xhr.data = mod.$ajaxForm.find(".js-press-date-selection").serialize() + "&" + $.param(additionalParameters)
                }
            }),
            request[0].done(function(xhr) {
                return mod._events.emit("loadMoreButtonVisibility", {
                    loadMoreButtonVisibility: xhr.response.pageNumber < xhr.response.maxPageNumber
                })
            })
        },
        onFilterReset: function() {
            var mod;
            return mod = this,
            mod.$submitBtn.trigger("click")
        }
    })
}(jQuery),
function($) {
    T.Module.PressPictureGalleryLayer = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.$addToBasketCheckBox = mod.$ctx.find(".js-add-to-download-basket-layer"),
            mod.$addToBasketCheckBox.on("change", $.proxy(mod.onChangeAddToBasketCheckBox, mod)),
            mod.$layer = mod.$ctx.closest(".m-layer"),
            mod.hasLayer = mod.$layer.length,
            mod.hasLayer && (mod.layer = mod._sandbox.getModuleById(mod.$layer.data("t-id"))),
            mod.imageId = mod.$ctx.data("image-id"),
            mod.downloadId = mod.$ctx.data("download-id"),
            mod.selected = mod.$ctx.data("selected"),
            mod.selected && mod.$addToBasketCheckBox.prop("checked", !0),
            mod._events.on("press:basketChanged", $.proxy(mod.onBasketChanged, mod)),
            resolve()
        },
        sync: function() {},
        onBasketChanged: function(data) {
            var button, isChecked, mod;
            if (mod = this,
            null != data.downloadIDs && (isChecked = data.downloadIDs.indexOf(mod.downloadId) !== -1,
            mod.$addToBasketCheckBox.prop("checked", isChecked),
            data.sourceId === mod.$ctx.data("t-id")))
                return isChecked ? (mod._events.emit("popover:open", mod.$addToBasketCheckBox),
                button = $(".layer-add-to-download-basket[data-id='" + mod.imageId + "-popover-basket-layer'] .js-open-press-basket-button"),
                button.on("click", $.proxy(mod.onOpenPressBasket, mod))) : mod._events.emit("popover:close", mod.$addToBasketCheckBox)
        },
        onChangeAddToBasketCheckBox: function(ev) {
            var eventName, mod;
            return mod = this,
            eventName = ev.target.checked ? "press:pictureAdd" : "press:pictureRemove",
            mod._events.emit(eventName, {
                imageId: [mod.downloadId],
                sourceId: mod.$ctx.data("t-id")
            })
        },
        onOpenPressBasket: function(evt) {
            var $popover, mod;
            return mod = this,
            $popover = $("[data-id='" + mod.$addToBasketCheckBox.data("popover-id") + "']"),
            mod._events.emit("popover:close", mod),
            mod.hasLayer && mod.layer.hideLayer(),
            mod._events.emit("press:openBasket")
        }
    })
}(jQuery),
function($) {
    T.Module.PressPictureTeaser = T.createModule({
        start: function(resolve) {
            var mod, ref;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.$addToBasketCheckBox = mod.$(".js-add-to-download-basket", mod.$ctx),
            mod.imageId = mod.$ctx.data("image-id"),
            mod.downloadId = mod.$ctx.data("download-id"),
            mod.pictureData = mod.$ctx.data("item"),
            mod.initialSelected = null != (ref = mod.pictureData) ? ref.selected : void 0,
            mod.$image = mod.$ctx.find(".js-teaser-image"),
            mod.$addToBasketCheckBox.on("change", $.proxy(mod.onChangeAddToBasketCheckBox, mod)),
            mod.$addToBasketCheckBox.prop("checked", mod.initialSelected),
            mod._events.on("press:basketChanged", $.proxy(mod.onBasketChanged, mod)),
            mod.$image.on("click", $.proxy(mod.onTeaserImageClicked, mod)),
            resolve()
        },
        sync: function() {},
        onTeaserImageClicked: function() {
            var $teaser, $teaserElement, $teaserLayerContent, mod, newModules, renderedTemplate, template;
            if (mod = this,
            $teaserLayerContent = $(".js-press-overlay-content").first(),
            $teaserElement = $teaserLayerContent.closest(".m-layer"),
            $teaser = mod._sandbox.getModuleById($teaserElement.data("t-id")),
            template = $(".tpl-press-picture-gallery-layer").html(),
            null != $teaser)
                return renderedTemplate = $(doT.template(template)({
                    items: [mod.pictureData],
                    selected: mod.$addToBasketCheckBox.prop("checked")
                })),
                $teaserLayerContent.html(renderedTemplate),
                newModules = $teaserLayerContent.find("[data-t-name]"),
                T.Utils.application._sandbox.addModules(newModules.first()[0]),
                $teaser.showLayer(null, !1)
        },
        onBasketChanged: function(data) {
            var $button, isChecked, mod;
            if (mod = this,
            null != data.downloadIDs && (isChecked = data.downloadIDs.indexOf(mod.downloadId) !== -1,
            mod.$addToBasketCheckBox.prop("checked", isChecked),
            data.sourceId === mod.$ctx.data("t-id")))
                return isChecked ? (mod._events.emit("popover:open", mod.$addToBasketCheckBox),
                $button = $(".add-to-download-basket[data-id='" + mod.imageId + "-popover-basket'] .js-open-press-basket-button"),
                $button.off("click.openPressBasket").on("click.openPressBasket", $.proxy(mod.onOpenPressBasket, mod))) : mod._events.emit("popover:close", mod.$addToBasketCheckBox)
        },
        onChangeAddToBasketCheckBox: function(ev) {
            var eventName, mod;
            return mod = this,
            eventName = ev.target.checked ? "press:pictureAdd" : "press:pictureRemove",
            mod._events.emit(eventName, {
                imageId: [mod.downloadId],
                sourceId: mod.$ctx.data("t-id")
            })
        },
        onOpenPressBasket: function() {
            var mod;
            return mod = this,
            mod._events.emit("popover:close", mod.$addToBasketCheckBox),
            mod._events.emit("press:openBasket")
        }
    })
}(jQuery),
function($) {
    T.Module.PressTeaser = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.ProcessAccordion = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.$ctx.on("click", ".js-content-toggle", $.proxy(this.onClickContentToggle, this)),
            mod.$ctx.on("click", ".js-pa-next", $.proxy(mod.onClickNext, mod)),
            $(window).on(T.Utils.debounce("resize", $.proxy(this.onResize, this), 50)),
            this.$(".item").length && this.initAccordion(),
            resolve()
        },
        initAccordion: function() {
            return this.$(".js-content-toggle").removeClass("is-open"),
            this.$(".item .content").css("max-height", ""),
            this.$(".item").addClass("is-deactivated"),
            this.openPanel(this.$(".item").first()[0].id)
        },
        openPanel: function(id) {
            var $item;
            return this.$(".js-content-toggle").removeClass("is-open"),
            this.$(".item .content").css("max-height", ""),
            this.$(".item .content").removeClass("is-open"),
            !!id && ($item = this.$("#" + id),
            $item.removeClass("is-deactivated"),
            $item.find(".js-content-toggle").addClass("is-open"),
            $item.find(".content").addClass("is-open"),
            this.setContentHeight($item))
        },
        setContentHeight: function($item) {
            return $item.each(function() {
                var $content;
                return $content = $(this).find(".content"),
                $content.css("max-height", $content[0].scrollHeight)
            })
        },
        onClickContentToggle: function(ev) {
            var $contentToggle, $item;
            return $contentToggle = $(ev.currentTarget),
            $item = $contentToggle.closest(".item"),
            !$item.hasClass("is-deactivated") && ($contentToggle.hasClass("is-open") ? ($contentToggle.removeClass("is-open"),
            $item.find(".content").css("max-height", ""),
            $item.find(".content").removeClass("is-open")) : this.openPanel($item[0].id))
        },
        onClickNext: function(ev) {
            var $nextItem;
            return $nextItem = $(ev.currentTarget).closest(".item").next(),
            $nextItem.is(".item") ? this.openPanel($nextItem[0].id) : this.openPanel(null),
            ev.preventDefault()
        },
        onResize: function() {
            return this.setContentHeight(this.$(".is-open").closest(".item"))
        }
    })
}(jQuery),
function($) {
    T.Module.ProcessBar = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$stepList = this.$ctx.find("ul"),
            this.$steps = this.$ctx.find("li"),
            $(window).on("resize.ProcessBar", T.Utils.debounce($.proxy(this.calculateWidths, this), 50)),
            this.calculateWidths(),
            resolve()
        },
        sync: function() {},
        calculateWidths: function() {
            var mod;
            return mod = this,
            mod.$stepList.addClass("is-full"),
            mod.$steps.each(function() {
                var $step;
                if ($step = $(this),
                $step.width() < $step.find(".step-content")[0].scrollWidth)
                    return mod.$stepList.removeClass("is-full")
            })
        }
    })
}(jQuery),
function($) {
    T.Module.ProductConversionArea = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.$compareProduct = mod.$ctx.find(".js-product-compare"),
            mod.$addToBasketButton = $(".js-add-to-basket", mod.$ctx),
            mod.$imageLabelLinkList = $(".product-label-list a"),
            mod.selector = {
                dealerlayerbutton: ".js-onlinedealer-action",
                shopatronbutton: ".js-shopatron-addtocart-action"
            },
            mod.$compareProduct.on("change", ".js-toggle-compare", $.proxy(mod.onChangeCompareProduct, mod)),
            mod.$compareProduct.on("click", $.proxy(mod.onTriggerComparePopover, mod)),
            mod.$imageLabelLinkList.on("click", function(_this) {
                return function(ev) {
                    return _this.onImageLabelLinkClick(ev)
                }
            }(this)),
            this.$addToBasketButton.on("click", $.proxy(this.onClickAddToCartButton, this)),
            mod.$ctx.on("click", mod.selector.dealerlayerbutton, $.proxy(this.onClickDealerLayerButton, this)),
            mod.$ctx.on("click", mod.selector.shopatronbutton, $.proxy(this.onClickShopatronButton, this)),
            mod._events.on("layout:storageUpdated", $.proxy(mod.onStorageUpdated, mod)),
            mod._events.on("productconversionarea:skuComparisonChanged", $.proxy(mod.onSkuComparisonChanged, mod)),
            resolve()
        },
        sync: function() {},
        switchAjaxConfigUrl: function($elm, blnInComparison) {
            var error, matchAdd, matchRemove, mod, objAjaxConfig, patternAdd, patternRemove, strAdd, strAjaxConfig, strRemove;
            if (mod = this,
            $elm) {
                strAjaxConfig = $elm.attr("data-ajax");
                try {
                    objAjaxConfig = JSON.parse(strAjaxConfig)
                } catch (error1) {
                    error = error1,
                    console.error('"data-ajax" value has to be an object')
                }
                return "object" == typeof objAjaxConfig && null !== objAjaxConfig && (strAdd = "add-to",
                strRemove = "remove-from",
                patternAdd = new RegExp(strAdd),
                patternRemove = new RegExp(strRemove),
                matchAdd = objAjaxConfig.url.match(patternAdd),
                matchRemove = objAjaxConfig.url.match(patternRemove),
                blnInComparison ? null != matchAdd && (objAjaxConfig.url = objAjaxConfig.url.replace(patternAdd, strRemove)) : null != matchRemove && (objAjaxConfig.url = objAjaxConfig.url.replace(patternRemove, strAdd))),
                $elm.attr("data-ajax", JSON.stringify(objAjaxConfig))
            }
        },
        switchCompareLabel: function($elm, numberOfItems, blnInComparison) {
            var $label, $labelNotComparable, $labelisComparable, isComparable, labelId, mod;
            if (mod = this,
            $elm)
                return isComparable = numberOfItems > 1,
                labelId = $elm.attr("id"),
                $label = $elm.siblings('[for="' + labelId + '"]'),
                $labelNotComparable = $label.children(":not(.js-compare-label)"),
                $labelisComparable = $label.find(".js-compare-label"),
                isComparable ? ($labelNotComparable.toggleClass("hidden", blnInComparison),
                $labelisComparable.toggleClass("hidden", !blnInComparison)) : ($labelNotComparable.toggleClass("hidden", !1),
                $labelisComparable.toggleClass("hidden", !0))
        },
        onClickDealerLayerButton: function(ev) {
            var config, mod;
            return mod = this,
            ev.preventDefault(),
            config = $(ev.currentTarget).data(),
            config.eventName = "onlinedealerbutton:click",
            mod._events.emit("onlinedealerbutton:click", config)
        },
        onClickShopatronButton: function(ev) {
            var mod, request, sessionId;
            return mod = this,
            ev.preventDefault(),
            sessionId = T.Utils.cookieHandling("shopatronsessionid", "get"),
            request = T.Utils.startAjaxRequest(!1, {
                url: $(ev.currentTarget).data("baseUrl"),
                method: "POST",
                dataType: "json",
                dataRendering: !1,
                data: {
                    productCode: $(ev.currentTarget).data("sku"),
                    shopatronSessionId: sessionId
                }
            }),
            !!request && request[0].done(function(result) {
                var queryDelim, redirectURL;
                return result.success ? (queryDelim = result.redirectURL.indexOf("?") > 0 ? "&" : "?",
                redirectURL = result.redirectURL + queryDelim + "rp=" + encodeURIComponent(window.location.pathname),
                0 !== $(".js-shopatron-add-sessionid").length && (redirectURL += "&PHPSESSID=" + sessionId),
                window.location.href = redirectURL) : result.errorMessage ? mod._events.emit("cart:message", {
                    errorMessage: result.errorMessage
                }) : void 0
            })
        },
        onClickAddToCartButton: function(ev) {
            var $ajaxform, config, mod, request;
            return mod = this,
            ev.preventDefault(),
            $ajaxform = $(ev.currentTarget).closest(".js-ajax-request"),
            config = $ajaxform.data(),
            request = T.Utils.startAjaxRequest(config.ajaxId),
            !!request && request[0].done(function(result) {
                if (mod._events.emit("popover:open", mod.$addToBasketButton),
                mod._events.emit("cart:update"),
                config.promotionUpdate && T.Utils.startAjaxRequest(!1, {
                    url: config.promotionUpdate + "/" + $ajaxform.find("[name=productCode]").val(),
                    dataType: "html",
                    dataRendering: !0
                }),
                config.cartUpdate)
                    return T.Utils.startAjaxRequest(!1, {
                        url: config.cartUpdate,
                        dataType: "html",
                        dataRendering: !0
                    })
            })
        },
        onTriggerComparePopover: function(ev) {
            var $chk, $target, mod;
            if (mod = this,
            $target = $(ev.currentTarget),
            $chk = $target.find(".js-compare-popover:disabled"),
            $chk.length > 0 && null != $chk.attr("data-popover-id"))
                return mod._events.emit("popover:openbyid", {
                    id: $chk.attr("data-popover-id"),
                    $trigger: $chk
                })
        },
        onChangeCompareProduct: function(ev) {
            var $chk, $parentAjaxContainer, ajaxRequestData, ajaxRequestId, chkName, mod, obj, request;
            return mod = this,
            $parentAjaxContainer = $(ev.currentTarget).closest(".js-ajax-request"),
            $chk = mod.$compareProduct.find(".js-update-localstorage"),
            chkName = $chk.attr("name"),
            ajaxRequestId = $parentAjaxContainer.attr("data-ajax-id"),
            obj = {},
            obj["" + chkName] = $chk.val(),
            ajaxRequestData = obj,
            request = T.Utils.startAjaxRequest(ajaxRequestId, null, ajaxRequestData),
            !!request && request[0].always(function() {}).done(function(result) {
                var $skuContainer, arrSku, eventData, isInComparison, localStorageKey, ownSku, strSkuInComparison;
                if (null != result)
                    return $skuContainer = mod.$compareProduct.find(".js-update-localstorage"),
                    localStorageKey = $skuContainer.attr("data-key"),
                    strSkuInComparison = $skuContainer.attr("data-skuincomparison"),
                    T.Utils.localStorageSetItem(localStorageKey, strSkuInComparison),
                    ownSku = $skuContainer.val(),
                    isInComparison = strSkuInComparison.indexOf(ownSku) !== -1,
                    mod.switchAjaxConfigUrl(mod.$compareProduct, isInComparison),
                    arrSku = JSON.parse(strSkuInComparison),
                    mod.switchCompareLabel($skuContainer, arrSku.length, isInComparison),
                    eventData = {
                        id: $skuContainer.attr("id"),
                        arrSku: arrSku
                    },
                    mod._events.emit("productconversionarea:skuComparisonChanged", eventData)
            }).fail(function(xhr, ajaxOptions, thrownError) {
                return console.info(xhr)
            })
        },
        onStorageUpdated: function(data) {
            var $compareCheckbox, eventData, mod;
            if (mod = this,
            null != data && ($compareCheckbox = mod.$compareProduct.find(".js-update-localstorage"),
            $compareCheckbox.attr("data-key") === data.key))
                return eventData = {
                    id: null,
                    arrSku: data.val
                },
                mod.onSkuComparisonChanged(eventData)
        },
        onSkuComparisonChanged: function(data) {
            var $notifiedCompareCheckbox, arrSku, emitterID, isInComparison, isTooMany, mod, ownSku, strSkuInComparison;
            if (mod = this,
            null != data && ($notifiedCompareCheckbox = mod.$compareProduct.find(".js-update-localstorage"),
            $notifiedCompareCheckbox.length > 0 && (emitterID = data.id,
            arrSku = data.arrSku,
            $notifiedCompareCheckbox.attr("id") !== emitterID)))
                return null != arrSku && $notifiedCompareCheckbox.attr("data-skuincomparison", JSON.stringify(arrSku)),
                isTooMany = 4 === data.arrSku.length,
                ownSku = $notifiedCompareCheckbox.val(),
                strSkuInComparison = $notifiedCompareCheckbox.attr("data-skuincomparison"),
                isInComparison = strSkuInComparison.indexOf(ownSku) !== -1,
                isTooMany ? $notifiedCompareCheckbox.prop("disabled", !isInComparison) : $notifiedCompareCheckbox.prop("disabled", !1),
                mod.switchCompareLabel($notifiedCompareCheckbox, data.arrSku.length, isInComparison),
                $notifiedCompareCheckbox.prop("checked", isInComparison),
                mod.switchAjaxConfigUrl(mod.$compareProduct, isInComparison)
        },
        onImageLabelLinkClick: function(ev) {
            if ("mobile" === T.Utils.getViewport())
                return $(".m-popover.is-active").removeClass("is-active")
        }
    })
}(jQuery),
function($) {
    T.Module.ProductPromotion = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.$promotionItemSeparators = mod.$(".promotion-separator"),
            mod.$promotionItem = mod.$(".m-productpromotionteaser"),
            this.isFixed = this.$ctx.hasClass("fixed"),
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            this._events.on("viewportChanged", function(_this) {
                return function(viewport) {
                    return _this.onViewportChanged(viewport)
                }
            }(this)),
            resolve()
        },
        sync: function() {
            if (!this.isSynced)
                return this.initializePromotionItems(),
                this.onViewportChanged(T.Utils.getViewport()),
                this.isSynced = !0
        },
        initializePromotionItems: function() {
            if (this.$promotionItem.filter(":odd").addClass("odd"),
            this.$promotionItem.filter(":first").addClass("first"),
            this.$promotionItem.filter(":last").addClass("last"),
            this.isFixed)
                return this.$promotionItemSeparators.removeClass("hidden")
        },
        onViewportChanged: function(viewport) {
            if (this.isFixed)
                return "tablet" === viewport ? (this.$promotionItemSeparators.filter(":odd").addClass("hidden"),
                this.$promotionItemSeparators.last().addClass("hidden")) : (this.$promotionItemSeparators.filter(":odd").removeClass("hidden"),
                this.$promotionItemSeparators.last().removeClass("hidden"))
        }
    })
}(jQuery),
function($) {
    T.Module.ProductPromotionTeaser = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.ProductRegistrationApplianceDetails = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.ProductServices = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.ProductSetHead = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.$(".js-productset-thumbnail").on("click", $.proxy(mod.onClickProductThumbnail, mod)),
            resolve()
        },
        sync: function() {},
        onClickProductThumbnail: function(ev) {
            var mod;
            return ev.preventDefault(),
            mod = this,
            mod._events.emit("productsethead:openComponentTab", {
                headId: mod.$ctx.data("t-id"),
                tabId: $(ev.currentTarget).data("tab-reference-id")
            })
        }
    })
}(jQuery),
function($) {
    T.Module.ProductTeaser = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            T.Utils.addSkusToEcr(mod.$ctx.data("sku")),
            resolve()
        }
    })
}(jQuery),
function($) {
    T.Module.ProductTeaserSet = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.productsetComponentTemplate = mod.$ctx.closest(".o-list").find(".tpl-productset-component").html(),
            mod.productsetComponentReplaceContainerId,
            mod.handleProductSetComponentRequest = $.proxy(mod.handleProductSetComponentRequest, mod),
            mod.$(".js-productset-component-togglebox").one("click.ttb", $.proxy(mod.onClickProductsetTabstoggleboxItem, mod)),
            mod.$(".js-trigger-productset-component-request").one("click.tab", $.proxy(mod.onClickProductsetComponentTab, mod)),
            mod._events.on("productsethead:openComponentTab", $.proxy(mod.openComponentTab, mod)),
            resolve()
        },
        sync: function() {},
        handleProductSetComponentRequest: function($elm, cb) {
            var mod, request;
            return mod = this,
            mod.productsetComponentReplaceContainerId = $elm.data("ajax-id"),
            mod.productsetComponentReplaceContainerId ? (request = T.Utils.startAjaxRequest(mod.productsetComponentReplaceContainerId),
            request ? request[0].done(function(result) {
                var $productsetComponent, $targetTab, i, len, productsetComp, template;
                for ($elm.removeAttr("data-ajax-id"),
                $targetTab = mod.$("[data-replace-tabitem-container='" + mod.productsetComponentReplaceContainerId + "']"),
                template = mod.productsetComponentTemplate,
                $targetTab.html(doT.template(template)({
                    response: result
                })),
                $productsetComponent = $targetTab.find('[data-t-name="ProductTeaser"]'),
                i = 0,
                len = $productsetComponent.length; i < len; i++)
                    productsetComp = $productsetComponent[i],
                    T.Utils.application._sandbox.addModules(productsetComp);
                return "function" == typeof cb ? cb() : void 0
            }) : ("function" == typeof cb && cb(),
            !1)) : void ("function" == typeof cb && cb())
        },
        onClickProductsetComponentTab: function(ev) {
            var mod;
            return mod = this,
            ev.preventDefault(),
            mod.handleProductSetComponentRequest($(ev.currentTarget).closest(".js-ajax-request"))
        },
        onClickProductsetTabstoggleboxItem: function(ev) {
            var mod;
            return mod = this,
            ev.preventDefault(),
            mod.handleProductSetComponentRequest($(ev.currentTarget))
        },
        openComponentTab: function(data) {
            var mod, modHeadId;
            if (mod = this,
            modHeadId = mod.$('[data-t-name="ProductSetHead"]').data("t-id"),
            null != data.headId && null != data.datbId || modHeadId === data.headId)
                return mod.handleProductSetComponentRequest(mod.$("[data-tab-reference='" + data.tabId + "']:visible"), function() {
                    return mod._events.emit("openTabToggleBox", {
                        $parent: mod.$ctx,
                        scrollToTab: !1,
                        tabId: data.tabId
                    })
                })
        }
    })
}(jQuery),
function($) {
    T.Module.PromotionAnchorTeaser = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.PromotionBundle = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.QuantitySelector = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$minus = this.$(".js-quantityselector-button-minus"),
            this.$plus = this.$(".js-quantityselector-button-plus"),
            this.$input = this.$(".js-quantityselector-value"),
            this.initvalue = this.$input.val(),
            this.minvalue = parseInt(this.$input.attr("data-min")),
            this.maxvalue = parseInt(this.$input.attr("data-max")),
            this.$minus.on("click", $.proxy(this.onClickMinus, this)),
            this.$plus.on("click", $.proxy(this.onClickPlus, this)),
            this.$ctx.on("change", $.proxy(this.onChangeVal, this)),
            this.$input.on("keydown", $.proxy(this.catchEnter, this)),
            this.initTestingId(),
            resolve()
        },
        checkDisabled: function() {
            return 0 === this.getValue() || this.getValue() === this.minvalue ? this.$minus.attr("disabled", "disabled") : this.getValue() <= this.minvalue ? this.setValue(this.initvalue) : this.$minus.removeAttr("disabled"),
            this.getValue() === this.maxvalue ? this.$plus.attr("disabled", "disabled") : this.getValue() >= this.maxvalue ? this.setValue(this.initvalue) : this.$plus.removeAttr("disabled")
        },
        getValue: function() {
            var value;
            return value = this.$input.val(),
            isNaN(this.$input.val()) && this.$input.val(this.initvalue),
            parseInt(this.$input.val())
        },
        initTestingId: function() {
            var $input;
            return $input = this.$input,
            $input.attr("testing_id") || $input.attr("testing_id"),
            $input.attr("testing_id", "quantity_" + this.initvalue)
        },
        setTestingId: function() {
            var $input;
            return $input = this.$input,
            $input.attr("testing_id", "quantity_" + $input.val())
        },
        setValue: function(value) {
            return this.$input.val(value)
        },
        stepValue: function(step) {
            var value;
            return value = this.getValue(),
            value += step,
            null != this.minvalue && value < this.minvalue && (value = this.minvalue),
            null != this.maxvalue && value > this.maxvalue && (value = this.maxvalue),
            this.setValue(value).trigger("change")
        },
        onClickMinus: function(ev) {
            return this.stepValue(-1),
            this.checkDisabled(),
            ev.preventDefault()
        },
        onClickPlus: function(ev) {
            return this.stepValue(1),
            this.checkDisabled(),
            ev.preventDefault()
        },
        onChangeVal: function() {
            return this.getValue(),
            this.checkDisabled(),
            this.setTestingId()
        },
        catchEnter: function(ev) {
            var mod;
            if (mod = this,
            13 === ev.keyCode)
                return ev.preventDefault(),
                mod.$input.blur()
        }
    })
}(jQuery),
function($) {
    T.Module.RangeSlider = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.$slider = mod.$(".js-slider"),
            mod.$input = mod.$(".js-value"),
            mod.$slider.length && mod.$input.length && (mod.noUiRangeSlider = noUiSlider.create(mod.$slider[0], {
                start: [mod.$slider.data("marker-lower"), mod.$slider.data("marker-upper")],
                step: 1,
                range: {
                    min: [mod.$slider.data("range-min")],
                    max: [mod.$slider.data("range-max")]
                },
                format: {
                    to: function(value) {
                        return Math.round(value)
                    },
                    from: function(value) {
                        return Math.round(value)
                    }
                }
            }),
            mod.noUiRangeSlider.on("end", function(values, handle) {
                var $input, val;
                return $input = mod.$input.eq(handle),
                val = values[handle],
                $input.attr("value", val).trigger("change")
            }),
            mod.$input.on("change", $.proxy(mod.onValueChanged, mod))),
            resolve()
        },
        sync: function() {},
        onValueChanged: function(ev) {
            var index, pos;
            return index = this.$input.index($(ev.currentTarget)),
            pos = [null, null],
            pos[index] = parseInt(this.$input.eq(index).val()),
            this.noUiRangeSlider.set(pos),
            this.$input.eq(index).blur()
        }
    })
}(jQuery),
function($) {
    T.Module.Reviews = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.apiUrl = mod.$ctx.data("api-url"),
            mod.productId = "" + mod.$ctx.data("product-id"),
            mod.tabId = mod.$ctx.data("tab-id"),
            mod.redirectUrl = mod.$ctx.data("redirect-url"),
            mod.campaignId = mod.$ctx.data("campaign-id"),
            mod.hashScope = "Tabs",
            window.$BV ? mod.initializeBazaarVoice() : $.ajax({
                url: mod.apiUrl,
                cache: !0,
                dataType: "script",
                success: function() {
                    return $($BV.docReady),
                    mod.initializeBazaarVoice()
                }
            }),
            resolve()
        },
        initializeBazaarVoice: function() {
            var mod, options;
            return mod = this,
            window.$BV && (options = {},
            null != mod.productId && (options.productId = mod.productId),
            null != mod.redirectUrl && "" !== mod.redirectURL && (null == options.events && (options.events = {}),
            options.events.submissionSubmitted = function(data) {
                return setTimeout(function() {
                    return window.location.replace(mod.redirectUrl)
                }, 2e3)
            }
            ),
            mod.campaignId && (null == options.events && (options.events = {}),
            options.events.submissionLoad = function(data) {
                return document.getElementsByName("campaignid")[0].value = mod.campaignId
            }
            ),
            $BV.configure("global", options),
            $BV.isTrackingAllowed = !1,
            $BV.ui("rr", "show_reviews", {
                doShowContent: function() {
                    return mod.openReviewTab(),
                    !1
                }
            }),
            $BV.ui("qa", "show_questions", {
                doShowContent: function() {
                    return mod.openReviewTab(),
                    !1
                }
            })),
            window.submitReview = function(productCode) {
                return window.$BV ? $BV.ui("rr", "submit_review", {
                    productId: productCode
                }) : console && console.error ? console.error("cannot submit reviews: BV JS Lib not loaded") : void 0
            }
            ,
            window.reloadBVRatings = function(productCode) {
                if (window.$BV)
                    return $BV.ui("rr", "show_reviews", {
                        productId: productCode,
                        submissionContainerDiv: "BVRRContainer",
                        doShowContent: function() {
                            return mod.openReviewTab(),
                            !1
                        }
                    })
            }
            ,
            window.reloadBVQuestionAndAnswer = function(productCode) {
                if (window.$BV)
                    return $BV.ui("qa", "show_questions", {
                        productId: productCode,
                        submissionContainerDiv: "BVQAContainer",
                        doShowContent: function() {
                            return mod.openReviewTab(),
                            !1
                        }
                    })
            }
        },
        openReviewTab: function() {
            var mod;
            return mod = this,
            mod._events.emit("openTab", {
                tabId: mod.tabId,
                scrollToTab: !0
            })
        }
    })
}(jQuery),
function($) {
    T.Module.ScrollDown = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$window = $(window),
            this.scrollTolerance = this.$ctx.data("scrolldown-tolerance") || 0,
            this.scrollRate = this.$ctx.data("scroll-offset") || void 0,
            this.$window.on("scroll", function(_this) {
                return function(ev) {
                    return _this.onScroll(ev)
                }
            }(this)),
            null != this.scrollRate && this.$ctx.on("click", function(_this) {
                return function() {
                    return _this.scrollToPositionByPercentData()
                }
            }(this)),
            resolve()
        },
        sync: function() {},
        onScroll: function(ev) {
            return this.$window.scrollTop() > this.scrollTolerance ? this.$ctx.removeClass("is-active") : this.$ctx.addClass("is-active")
        },
        scrollToPositionByPercentData: function() {
            var $window, scrollRatePixel;
            if (null != this.scrollRate)
                return $window = this.$window,
                scrollRatePixel = $window.height() * (parseFloat(this.scrollRate) / 100),
                T.Utils.scrollToTop(scrollRatePixel)
        }
    })
}(jQuery),
function($) {
    var clearSelector, inputSelector, layerSelector, submitSelector, suggestItemCurrentClass, suggestOptionSelector, suggestResultsRowSelector;
    inputSelector = ".js-searchfield-input",
    submitSelector = ".js-searchfield-searchbutton",
    clearSelector = ".js-searchfield-icon-remove",
    layerSelector = ".js-searchfield-suggestlayer",
    suggestOptionSelector = ".suggestlayer-results-row :input",
    suggestItemCurrentClass = "state-current",
    suggestResultsRowSelector = ".js-suggestlayer-results-row",
    T.Module.SearchField = T.createModule({
        start: function(resolve) {
            var inputProxySelector, mod, mutationObserverSupport;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.$currentSelectedItem = !1,
            mod.$input = this.$(inputSelector),
            mod.$submit = this.$(submitSelector),
            mod.$clear = this.$(clearSelector),
            mod.$layer = this.$(layerSelector),
            mod.$form = this.$(".js-ajax-request"),
            mod.ajaxEnabled = this.$form.length > 0,
            mod.$errorMessage = this.$(".a-errormessage.error-custom"),
            mod.id = this.$ctx.data("t-id"),
            mod.clientValidation = this.$ctx.data("client-validation") || !1,
            mod.isValid = !1,
            mod.suggestLayerUpdate = !1,
            mod.layerOffsetPosition = 0,
            mod.ajaxCallStateCache = "",
            mod.resultList = [],
            mod.clientValidation && mod.$submit.attr("disabled", "disabled"),
            mod.$ctx.on("focus", inputSelector, $.proxy(mod.onFocusInput, this)),
            mod.$ctx.on("input", inputSelector, $.proxy(mod.onChangeInput, this)),
            mod.$ctx.on("blur", inputSelector, $.proxy(mod.onBlurInput, this)),
            mod.$ctx.on("keydown", inputSelector, $.proxy(mod.onKeydownInput, this)),
            mod.$ctx.on("click", clearSelector, $.proxy(mod.onClickClear, this)),
            mod.$ctx.on("change", suggestOptionSelector, $.proxy(mod.onChangeOption, this)),
            mod.$ctx.on("mouseenter", layerSelector, $.proxy(mod.onLayerHover, this)),
            mod.$(".js-searchform").on("submit", $.proxy(this.onSearchSubmit, this)),
            mod._events.on("triggerSearch", $.proxy(mod.onTriggerSearch, this)),
            mod._events.on("showInputError", $.proxy(mod.onShowInputError, this)),
            mod._events.on("hideInputError", $.proxy(mod.onHideInputError, this)),
            mod._events.on("updateProxyValue", $.proxy(mod.proxyValueChanged, this)),
            mutationObserverSupport = window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver,
            mutationObserverSupport && (inputProxySelector = mod.$ctx.attr("data-input-proxy-selector"),
            null != inputProxySelector && (mod.$inputProxy = mod.$ctx.closest("form").find("input." + inputProxySelector),
            mod.$inputProxy.length > 0 && (mod.inputClassObserver = new MutationObserver($.proxy(function(mutations) {
                return mod.$inputProxy.attr("class", mod.$input.attr("class") + " proxyField " + inputProxySelector),
                mod.$inputProxy.on("focus", function(ev) {
                    return mod.$input.focus()
                })
            })),
            mod.inputClassObserver.observe(mod.$input[0], {
                attributes: !0,
                attributeFilter: ["class"]
            }),
            mod.$input.on("input", function(ev) {
                return mod.proxyValueChanged()
            }),
            mod.proxyValueChanged()))),
            resolve()
        },
        adjustLayerOffsetToFormRow: function() {
            var mod, modPosition, rowPosition;
            return mod = this,
            rowPosition = mod.$ctx.closest(".form-row").position(),
            modPosition = mod.$ctx.position(),
            mod.layerOffsetPosition = modPosition.left - rowPosition.left,
            mod.$layer.css({
                left: "-" + mod.layerOffsetPosition + "px"
            })
        },
        adjustLayerWidthToFormRow: function() {
            var mod, rowWidth;
            return mod = this,
            rowWidth = this.$ctx.closest(".form-row").width(),
            mod.$layer.css({
                "min-width": rowWidth + "px",
                width: rowWidth + "px"
            })
        },
        bindKeyboardEvents: function() {
            var mod;
            if (mod = this,
            !mod.eventsBound)
                return $(document).on("keydown", $.proxy(mod.onKeyPress, mod)),
                mod.eventsBound = !0
        },
        checkAjaxCallState: function() {
            var ajaxCallCacheState, mod;
            if (mod = this,
            ajaxCallCacheState = mod.getAjaxCallCacheState(),
            ajaxCallCacheState !== mod.ajaxCallCacheState)
                return mod.getSuggestionData(),
                mod.ajaxCallCacheState = ajaxCallCacheState
        },
        closeLayer: function() {
            return this.$layer.addClass("hidden"),
            this.$(suggestOptionSelector).prop("disabled", !0),
            this.unbindKeyboardEvents()
        },
        getAjaxCallCacheState: function() {
            var mod;
            return mod = this,
            mod.$input.val()
        },
        getAjaxRequestFormData: function() {
            return null
        },
        getSearchKeys: function() {
            var $form, mod, searchKeys;
            return mod = this,
            $form = mod.$ctx.find("[data-searchkey]"),
            0 === $form.length ? [] : (searchKeys = $form.data("searchkey").replace(RegExp(" ", "g"), ""),
            searchKeys.split(","))
        },
        getSuggestionData: function() {
            var mod, request;
            return mod = this,
            request = T.Utils.startAjaxRequest(mod.$form.data("ajax-id"), {}, mod.getAjaxRequestFormData()),
            !!request && request[0].done(function(response) {
                return mod.resultList = response,
                mod.validate(),
                mod.suggestLayerUpdate = !0
            })
        },
        openLayer: function() {
            var mod;
            return mod = this,
            mod.ajaxEnabled && mod.checkAjaxCallState(),
            this.$(suggestOptionSelector).prop("disabled", !1),
            this.$layer.removeClass("hidden"),
            this.bindKeyboardEvents()
        },
        proxyValueChanged: function() {
            var mod;
            if (mod = this,
            mod.$inputProxy && mod.$inputProxy.length > 0)
                return mod.$inputProxy.val(mod.$input.val())
        },
        resetCurrentSelection: function() {
            var mod;
            if (mod = this,
            mod.$currentSelectedItem)
                return mod.$currentSelectedItem.removeClass(suggestItemCurrentClass),
                mod.$currentSelectedItem = !1
        },
        onSearchSubmit: function(ev) {
            var mod;
            if (mod = this,
            this.ajaxEnabled && $(ev.currentTarget).find('[data-t-id="' + mod.id + '"]'))
                return ev.preventDefault(),
                this.submitSearch()
        },
        submitSearch: function() {
            var mod, searchKeys, searchQuery;
            if (mod = this,
            mod.proxyValueChanged(),
            searchKeys = mod.getSearchKeys(),
            searchQuery = mod.$input.val(),
            searchQuery.length && searchKeys.length)
                return mod._events.emit("searchByKeys", searchKeys, mod.id, searchQuery)
        },
        toggleErrorState: function(toggle) {
            return toggle = !this.$input.is(".is-empty") && toggle,
            this.$input.toggleClass("has-error is-invalid", toggle)
        },
        unbindKeyboardEvents: function() {
            var mod;
            if (mod = this,
            mod.eventsBound)
                return $(document).off("keydown", $.proxy(mod.onKeyPress, mod)),
                mod.eventsBound = !1
        },
        validate: function() {
            var i, len, mod, obj, ref, val;
            if (mod = this,
            mod.resetCurrentSelection(),
            mod.proxyValueChanged(),
            mod.clientValidation) {
                for (val = mod.$input.val(),
                ref = mod.resultList,
                i = 0,
                len = ref.length; i < len; i++)
                    if (obj = ref[i],
                    obj.value === val)
                        return mod.$submit.removeAttr("disabled"),
                        void (mod.isValid = !0);
                return mod.$submit.attr("disabled", "disabled"),
                mod.isValid = !1
            }
        },
        onBlurInput: function() {
            var mod;
            return mod = this,
            setTimeout(function() {
                return mod.$input.is(":focus") || mod.closeLayer(),
                mod.clientValidation ? mod.toggleErrorState(!mod.isValid) : mod.toggleErrorState(!1)
            }, 150)
        },
        onChangeInput: function() {
            var mod, term;
            return mod = this,
            term = mod.$input.val(),
            term.length >= 2 ? (mod.openLayer(),
            mod.$clear.removeClass("hidden")) : (mod.closeLayer(),
            mod.$clear.addClass("hidden"),
            mod.resetCurrentSelection()),
            this.validate()
        },
        onChangeOption: function(ev) {
            var mod;
            return mod = this,
            mod.$input.val(ev.currentTarget.value),
            mod.proxyValueChanged(),
            mod._events.emit("updateProxyValue"),
            this.validate()
        },
        onClickClear: function(ev) {
            return this.$input.val(""),
            this.$input.addClass("is-empty"),
            this.onChangeInput(),
            this.toggleErrorState(!1)
        },
        onFocusInput: function() {
            var mod, term;
            return mod = this,
            term = this.$input.val(),
            mod.suggestLayerUpdate || !mod.ajaxEnabled ? (term.length >= 2 && mod.openLayer(),
            this.toggleErrorState(!1)) : term.length >= 2 ? (mod.openLayer(),
            mod.$clear.removeClass("hidden"),
            mod.validate()) : void 0
        },
        onHideInputError: function(data) {
            var mod;
            if (mod = this,
            data.$ctx.find('[data-t-id="' + mod.id + '"]'))
                return mod.$errorMessage.hide()
        },
        onKeydownInput: function(ev) {
            var mod;
            if (mod = this,
            13 === ev.keyCode && !mod.isValid && !mod.$currentSelectedItem)
                return ev.preventDefault()
        },
        onKeyPress: function(ev) {
            var mod;
            switch (mod = this,
            ev.which) {
            case 13:
                if (mod.$currentSelectedItem)
                    return ev.preventDefault,
                    mod.onPickCurrent(),
                    !1;
                break;
            case 38:
                return ev.preventDefault,
                mod.onSelectPrevious(),
                !1;
            case 40:
                return ev.preventDefault,
                mod.onSelectNext(),
                !1
            }
        },
        onLayerHover: function() {
            var mod;
            return mod = this,
            mod.resetCurrentSelection()
        },
        onPickCurrent: function() {
            var mod;
            return mod = this,
            mod.$currentSelectedItem.find(".a-formlabel").trigger("click"),
            mod.resetCurrentSelection()
        },
        onSelectNext: function() {
            var $next, mod, options;
            if (mod = this,
            options = mod.$ctx.find(suggestResultsRowSelector),
            options.length > 0) {
                if (!mod.$currentSelectedItem)
                    return $next = $(options[0]),
                    $next.addClass(suggestItemCurrentClass),
                    mod.$currentSelectedItem = $next;
                if ($next = mod.$currentSelectedItem.next(),
                $next.length > 0)
                    return mod.$currentSelectedItem.removeClass(suggestItemCurrentClass),
                    $next.addClass(suggestItemCurrentClass),
                    mod.$currentSelectedItem = $next
            }
        },
        onSelectPrevious: function() {
            var $prev, mod, options;
            if (mod = this,
            options = mod.$ctx.find(suggestResultsRowSelector),
            options.length > 0 && mod.$currentSelectedItem)
                return $prev = mod.$currentSelectedItem.prev(),
                $prev.length > 0 ? (mod.$currentSelectedItem.removeClass(suggestItemCurrentClass),
                $prev.addClass(suggestItemCurrentClass),
                mod.$currentSelectedItem = $prev) : mod.resetCurrentSelection()
        },
        onShowInputError: function(data) {
            var mod;
            if (mod = this,
            data.$ctx.find('[data-t-id="' + mod.id + '"]'))
                return mod.$errorMessage.show()
        },
        onTriggerSearch: function(data) {
            var mod;
            if (mod = this,
            data.$ctx.find('[data-t-id="' + mod.id + '"]'))
                return mod.$input.val(data.query),
                mod._events.emit("updateProxyValue"),
                mod.submitSearch()
        }
    })
}(jQuery),
function($) {
    var inputSelector, resetSelector, suggestLayerSelector;
    inputSelector = ".js-search-input",
    resetSelector = ".js-reset-button",
    suggestLayerSelector = ".suggest-layer",
    T.Module.SearchInput = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.$inputField = mod.$(inputSelector),
            mod.$resetButton = mod.$(resetSelector),
            mod.$suggestLayer = mod.$(suggestLayerSelector),
            mod.config = mod.$ctx.data(),
            mod.$ctx.on("click", resetSelector, $.proxy(mod.onClickResetButton, mod)),
            $("body").on("click", $.proxy(mod.onClickOuterLayout, mod)),
            mod.$ctx.on("focus input", inputSelector, $.proxy(mod.onChangeInputField, mod)),
            mod.$ctx.on("blur", inputSelector, $.proxy(mod.onBlurInputField, mod)),
            mod.$ctx.on("blur", suggestLayerSelector, $.proxy(mod.onClickCloseButton, mod)),
            mod.$ctx.on("click", suggestLayerSelector, $.proxy(mod.onClickSuggestLayer, mod)),
            mod.$(".js-close-button").on("click", $.proxy(mod.onClickCloseButton, mod)),
            mod._events.on("toggleMobileMenu", $.proxy(mod.onToggleMobileMenu, mod)),
            mod._events.on("toggleSearchForm", $.proxy(mod.onToggleSearchForm, mod)),
            mod._events.on("closeSearchForm.header", $.proxy(mod.onCloseSearchForm, mod)),
            T.Utils.registerMq("lg", {
                match: function() {
                    return mod.$ctx.removeClass("hidden")
                },
                unmatch: function() {
                    return mod._events.emit("checkSearchState")
                }
            }),
            resolve()
        },
        buildCategoryURL: function(entry, key, name) {
            var url;
            return url = entry.split(/[__]+/).pop().slice(0, -1) + "?source=" + name,
            '"' + key + '":"' + url + '"'
        },
        renderSearchFlyout: function(result) {
            var data, functionName, i, inputValue, key, keywords, keywords2, mainresult, mod, newdata, nextresult, nr, obj, pattern, ref, ref1, regex, value;
            mod = this,
            data = mod.config,
            result.main && (mainresult = result.main.data),
            result.next && (nextresult = result.next.data),
            mainresult.noresult = !0,
            mainresult.keywords = {},
            keywords = mainresult.suggestionGroups[0].suggestions;
            for (i in keywords)
                obj = keywords[i],
                mainresult.keywords[obj.searchterm] = obj.nrResults;
            if (nextresult) {
                keywords2 = nextresult.suggestionGroups[0].suggestions;
                for (i in keywords2)
                    obj = keywords2[i],
                    nr = mainresult.keywords[obj.searchterm],
                    nr ? nr += obj.nrResults : mainresult.keywords[obj.searchterm] = obj.nrResults
            }
            mainresult.keywordarray = [],
            ref = mainresult.keywords;
            for (key in ref)
                value = ref[key],
                mainresult.keywordarray.push({
                    nrResults: value,
                    searchterm: key
                });
            mainresult.keywordarray.length > 0 && (mainresult.noresult = !1),
            mainresult.products = [],
            mainresult.products.push({
                name: result.main.name,
                suggestions: mainresult.suggestionGroups[1].suggestions
            }),
            mainresult.products[0].suggestions.length > 0 && (mainresult.noresult = !1),
            nextresult && (mainresult.products.push({
                name: result.next.name,
                suggestions: nextresult.suggestionGroups[1].suggestions
            }),
            mainresult.products[1].suggestions.length > 0 && (mainresult.noresult = !1)),
            mainresult.categories = mainresult.suggestionGroups[2].suggestions,
            ref1 = data.preRendering;
            for (key in ref1)
                if (functionName = ref1[key],
                pattern = '"' + key + '"s*:s*"[^"]*"',
                regex = new RegExp(pattern,"g"),
                newdata = JSON.stringify(mainresult.categories).replace(regex, function($1) {
                    switch (functionName) {
                    case "buildCategoryURL":
                        return mod.buildCategoryURL($1, key, result.main.name)
                    }
                }),
                mainresult.categories = JSON.parse(newdata),
                "undefined" == typeof mainresult.categories)
                    return;
            return mainresult.categories.length > 0 && (mainresult.noresult = !1),
            T.Utils.startInitialRendering(data.ajaxId, mainresult),
            inputValue = mod.$inputField.val(),
            mod.$suggestLayer.find(".js-showall-link").each(function() {
                var href;
                return href = $(this).attr("href"),
                href = href.replace("searchkey", inputValue),
                $(this).attr("href", href)
            })
        },
        onBlurInputField: function() {
            return setTimeout(function() {
                if (!this.$(".suggest-layer").hasClass("active"))
                    return this.$(".suggest-layer").addClass("hidden")
            }, 150)
        },
        onBlurSuggestLayer: function() {
            return this.$suggestLayer.removeClass("active")
        },
        onChangeInputField: function() {
            var data, inputValue, mod, openFlyout, request, result1, result2;
            return mod = this,
            data = mod.config,
            inputValue = mod.$inputField.val(),
            mod.$suggestLayer.removeClass("active"),
            inputValue.length ? mod.$resetButton.removeClass("hidden") : mod.$resetButton.addClass("hidden"),
            inputValue.length >= 3 ? (clearTimeout(openFlyout),
            !!(request = T.Utils.startAjaxRequest(data.ajaxId)) && (result1 = "shop",
            result2 = "product",
            (!request.shop || request.product && "product" === data.mainRequest) && (result1 = "product",
            result2 = "shop"),
            request[result1].done(function(mainresult) {
                return request[result2] ? request[result2].done(function(nextresult) {
                    return mod.renderSearchFlyout({
                        main: {
                            name: result1,
                            data: mainresult
                        },
                        next: {
                            name: result2,
                            data: nextresult
                        }
                    })
                }) : (mod.renderSearchFlyout({
                    main: {
                        name: result1,
                        data: mainresult
                    }
                }),
                console.info("one request"))
            }).fail(function(xhr, ajaxOptions, thrownError) {
                return console.info(xhr)
            }),
            openFlyout = setTimeout(function() {
                return mod.$suggestLayer.removeClass("hidden")
            }, 300))) : mod.$suggestLayer.addClass("hidden")
        },
        onClickCloseButton: function() {
            return this.$suggestLayer.hasClass("hidden") === !1 && this.$suggestLayer.addClass("hidden"),
            this.$suggestLayer.removeClass("active")
        },
        onClickOuterLayout: function(e) {
            if (!$(e.target).closest(this.$ctx).length && $(e.target) !== this.$ctx)
                return this.onClickCloseButton(e)
        },
        onClickResetButton: function() {
            if (this.$inputField[0].value = "",
            this.$suggestLayer.removeClass("active"),
            this.$suggestLayer.hasClass("hidden") === !1)
                return this.$suggestLayer.addClass("hidden"),
                this.onChangeInputField()
        },
        onClickSuggestLayer: function() {
            return this.$suggestLayer.addClass("active")
        },
        onCloseSearchForm: function() {
            return this.$ctx.addClass("hidden")
        },
        onToggleMobileMenu: function(data) {
            if (data.isMenuOpen)
                return this.$ctx.addClass("hidden")
        },
        onToggleSearchForm: function(data) {
            return data.isSearchActive ? (this.$ctx.removeClass("hidden"),
            this.$inputField.focus()) : this.$ctx.addClass("hidden")
        }
    })
}(jQuery),
function($) {
    T.Module.SelectedPressPicture = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.id = mod.$ctx.data("picture-id"),
            mod.downloadId = mod.$ctx.data("download-id"),
            mod.pictureData = mod.$ctx.data("item"),
            mod.$image = mod.$ctx.find(".js-selected-picture-image"),
            mod.$unselect = mod.$(".js-unselect"),
            mod.onClickUnselect = $.proxy(mod.onClickUnselect, mod),
            mod.$unselect.on("click", mod.onClickUnselect),
            mod.$image.on("click", $.proxy(mod.onImageClicked, mod)),
            resolve()
        },
        sync: function() {},
        onClickUnselect: function(evt) {
            var mod;
            return mod = this,
            evt.preventDefault(),
            mod._events.emit("press:pictureRemove", {
                imageId: [mod.downloadId]
            })
        },
        onImageClicked: function() {
            var $teaser, $teaserElement, $teaserLayerContent, mod, newModules, renderedTemplate, template;
            if (mod = this,
            $teaserLayerContent = $(".js-press-overlay-content").first(),
            $teaserElement = $teaserLayerContent.closest(".m-layer"),
            $teaser = mod._sandbox.getModuleById($teaserElement.data("t-id")),
            template = $(".tpl-press-picture-gallery-layer").html(),
            null != $teaser)
                return renderedTemplate = $(doT.template(template)({
                    items: [mod.pictureData],
                    selected: !0
                })),
                $teaserLayerContent.html(renderedTemplate),
                newModules = $teaserLayerContent.find("[data-t-name]"),
                T.Utils.application._sandbox.addModules(newModules.first()[0]),
                $teaser.showLayer(null, !1)
        }
    })
}(jQuery),
function($) {
    T.Module.ServiceTeaser = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$serviceTeaser = $(mod._ctx),
            mod.$content = mod.$serviceTeaser.find(".content"),
            mod.$serviceTeaser.parents(".g-layout-fourth").length && mod.$content.addClass("content-fullwidth"),
            resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.SignIn = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this._selector = {
                signInForm: ".js-ajax-request",
                lastInput: ".js-last-input",
                customErrorMessage: ".js-custom-error-message"
            },
            this.elm = {
                $ajaxForm: $(this._selector.signInForm, this.$ctx),
                $lastInput: $(this._selector.lastInput, this.$ctx)
            },
            this.signInRequestArray = this.elm.$ajaxForm.data("ajaxId"),
            this.stashCustomError = this.getCustomError(this.elm.$lastInput),
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync
                }
            }(this)),
            this._events.on("signinstoreselector:select", function(_this) {
                return function(ev) {
                    return _this.onStoreSelect(ev)
                }
            }(this)),
            this.elm.$ajaxForm.on("submit", function(_this) {
                return function(ev, ajaxId, config) {
                    return _this.onSubmitForm(ev, ajaxId, config)
                }
            }(this)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0)
        },
        getCustomError: function($input) {
            var index, text;
            return index = ($input.data("fieldNr") || 1) - 1,
            text = $input.parent().find(this._selector.customErrorMessage).eq(index).text()
        },
        handleFormError: function(text) {
            var errorMessage;
            return errorMessage = text || this.stashCustomError,
            this.elm.$lastInput.trigger("setInputError", errorMessage),
            this.$ctx.is(":hidden") && this._events.emit("signin:hiddenformerror"),
            !0
        },
        handleSignInResponses: function(request) {
            var hasError;
            if (this.preventSubmitRequest = !0,
            request)
                return hasError = !1,
                request[0].done(function(_this) {
                    return function(result) {
                        var ajaxConfig;
                        if (result) {
                            switch (!0) {
                            case Boolean(result.errorMessage):
                                hasError = _this.handleFormError(result.errorMessage),
                                _this.preventSubmitRequest = !1;
                                break;
                            case Boolean(result.success && !result.redirectURL && !result.possiblePointOfServices):
                            case Boolean(!result.redirectURL && result.possiblePointOfServices && result.possiblePointOfServices.length < 2):
                                1 === result.possiblePointOfServices.length && (ajaxConfig = {
                                    data: {
                                        uid: result.possiblePointOfServices[0].uid
                                    }
                                }),
                                _this.preventSubmitRequest = !1,
                                _this.elm.$ajaxForm.trigger("submit", [_this.signInRequestArray[1], ajaxConfig]);
                                break;
                            case Boolean(result.redirectURL):
                                document.location.assign(result.redirectURL);
                                break;
                            default:
                                _this.preventSubmitRequest = !1
                            }
                            return !0
                        }
                    }
                }(this)).fail(function(_this) {
                    return function(xhr, ajaxOptions, thrownError) {
                        return hasError = _this.handleFormError(),
                        _this.preventSubmitRequest = !1,
                        !0
                    }
                }(this)),
                hasError && T.Utils.scrollToTop(this.$ctx),
                !0
        },
        onStoreSelect: function(ev) {
            return !this.preventSubmitRequest && (this.handleSignInResponses(T.Utils.onAjaxControllerTriggered(ev, !0)),
            !0)
        },
        onSubmitForm: function(ev, ajaxId, ajaxConfig) {
            var ID;
            return ev.preventDefault(),
            !this.preventSubmitRequest && (ID = ajaxId || this.signInRequestArray[0],
            console.info("handleSignInResponse", ID, ajaxConfig),
            this.handleSignInResponses(T.Utils.startAjaxRequest(ID, ajaxConfig)),
            !0)
        }
    })
}(jQuery),
function($) {
    T.Module.SignInStoreSelector = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this._selector = {
                signInTrigger: ".js-trigger-signin"
            },
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            this._events.on("signin:hiddenformerror", function(_this) {
                return function(data) {
                    return _this.removeModule(data)
                }
            }(this)),
            $(this._selector.signInTrigger, this.$ctx).on("click", function(_this) {
                return function(ev) {
                    return _this.onSelectStore(ev)
                }
            }(this)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0)
        },
        stop: function() {
            this.$ctx.remove()
        },
        removeModule: function() {
            return this._sandbox.removeModules(this._ctx)
        },
        onSelectStore: function(ev) {
            return ev.preventDefault(),
            T.Utils.debounce(function(_this) {
                return function(ev) {
                    return _this._events.emit("signinstoreselector:select", ev)
                }
            }(this), 250)(ev)
        }
    })
}(jQuery),
function($) {
    T.Module.SparepartProductteaser = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            this.$ctx = $(this._ctx),
            resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.Stage = T.createModule({
        slickConfiguration: {
            adaptiveHeight: !1,
            centerMode: !0,
            slidesToShow: 1,
            slidesPerRow: 1,
            initialSlide: 0,
            infinite: !0,
            useCSS: !1
        },
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            T.Utils.allSynced = !1,
            mod.isSynced = !1,
            this.isSliderInitialized = !1,
            this.$slider = this.$(".slick-slider"),
            this.$stageControls = this.$(".js-stage-controls"),
            this.$spteaser = this.$(".stageproduct-teaser"),
            this.$spcallouts = this.$(".stageproduct-callout"),
            this.$slides = this.$(".slide:not(.slick-cloned)"),
            this.$(".m-layer").appendTo("body"),
            this.$(".a-image img").on("load", $.proxy(this.onImgLoad, this)),
            this._events.on("videoPlaying", function(_this) {
                return function(data) {
                    return _this.onVideoPlaying(data)
                }
            }(this)),
            this._events.on("videoStop", function(_this) {
                return function(data) {
                    return _this.onVideoStop(data)
                }
            }(this)),
            this._events.on("videoEnded", function(_this) {
                return function(data) {
                    return _this.onVideoStop(data)
                }
            }(this)),
            this._events.on("t.sync", $.proxy(this.sync, this)),
            this.clonedId = 1,
            resolve()
        },
        sync: function() {
            this.isSynced || (this.initSlick(),
            this.isSynced = !0,
            T.Utils.allSynced = !0)
        },
        hideStageOverlay: function() {
            return this.$(".teaser").addClass("hidden"),
            this.$(".js-stage-controls").addClass("hidden"),
            this.setSlickDragEvents(!1),
            this.showPaginationDots(!0)
        },
        showStageOverlay: function(showPaginationDots) {
            return this.$(".teaser").removeClass("hidden"),
            this.$(".js-stage-controls").removeClass("hidden"),
            this.setSlickDragEvents(!0),
            this.showPaginationDots(showPaginationDots)
        },
        showPaginationDots: function(flag) {
            return null == flag || flag === !0 ? this.$paginationDots.removeClass("hidden") : this.$paginationDots.addClass("hidden")
        },
        getVideoInCurrentSlide: function() {
            var currentSlideVideo, mod;
            return mod = this,
            currentSlideVideo = mod.$slider.find(".slick-current .m-video"),
            currentSlideVideo.length > 0 && currentSlideVideo
        },
        getVideoInSlide: function(slideIndex) {
            var result;
            return result = this.getSlide(slideIndex).find(".m-video"),
            result.length ? result : null
        },
        initSlick: function() {
            var $components, component, i, len, results, showArrows, showDots, sliderId;
            for (showDots = this.$slider.find(".slide").length > 1 && this.$slider.data("dots-visibility"),
            showArrows = this.$slider.find(".slide").length > 1 && this.$slider.data("arrows-visibility"),
            showArrows || this.$(".prev, .next").addClass("hidden"),
            this.$slider.find(".slick-current picture img").on("load", $.proxy(this.onImgLoad, this)),
            this.$slider.on("setPosition", $.proxy(this.onSliderSetPosition, this)),
            this.$slider.on("beforeChange", $.proxy(this.onSlideBeforeChange, this)),
            this.$slider.on("afterChange", $.proxy(this.onSliderAfterChange, this)),
            this.$slider.on("init", $.proxy(this.onSliderInit, this)),
            T.Utils.isRTL() && this.$slider.attr("dir", "rtl"),
            this.$slider.slick($.extend(this.slickConfiguration, {
                appendArrows: this.$stageControls,
                appendDots: this.$stageControls,
                arrows: showArrows,
                autoplay: this.$slider.data("slick-autoplay") || !1,
                autoplaySpeed: this.$slider.data("slick-autoplayspeed"),
                centerPadding: "0px",
                dots: showDots,
                dotsClass: this.$slider.data("dots-class"),
                fade: this.$slider.data("slick-fade"),
                initialSlide: 0,
                nextArrow: this.$(".next"),
                prevArrow: this.$(".prev"),
                speed: 300,
                adaptiveHeight: this.$slider.data("slick-adaptiveheight") || !0,
                rtl: T.Utils.isRTL()
            })),
            $components = this.$slider.find(".slick-cloned").find("[data-t-id]"),
            $components.removeData("t-id"),
            $components.removeAttr("data-t-id"),
            sliderId = this.$ctx.data("t-id"),
            results = [],
            i = 0,
            len = $components.length; i < len; i++)
                component = $components[i],
                T.Utils.notifySlideMarkupCloned({
                    $component: $(component),
                    slideClonedId: this.clonedId++ + "-slider-" + sliderId
                }),
                results.push(this._sandbox.addModules(component));
            return results
        },
        setSlickDragEvents: function(value) {
            var mod;
            if (mod = this,
            mod.isSliderInitialized)
                return mod.$slider.slick("slickSetOption", "draggable", value),
                mod.$slider.slick("slickSetOption", "touchMove", value),
                mod.$slider.slick("slickSetOption", "swipeToSlide", value),
                mod.$slider.slick("slickSetOption", "swipe", value)
        },
        setStageControls: function() {
            var currentHeight, viewport;
            return viewport = T.Utils.getViewport(),
            "desktop" !== viewport ? (currentHeight = this.$(".slick-current .js-image-video-wrapper").height(),
            this.$stageControls.height(currentHeight)) : this.$stageControls.removeAttr("style")
        },
        getSlide: function(slideIndex) {
            return $(this.$slides.get(slideIndex))
        },
        isVideoPaused: function(videoComponent) {
            var videoModule;
            return videoModule = this._sandbox.getModuleById(videoComponent.data("t-id")),
            (null != videoModule ? videoModule.isVideoPaused() : void 0) || !1
        },
        onImgLoad: function(ev) {
            var $img;
            if ($img = $(ev.currentTarget),
            this.$(".slick-current").find($img).length && this.isSliderInitialized)
                return this.$slider.slick("setPosition"),
                this.setStageControls()
        },
        onVideoPlaying: function(data) {
            if (data.$ctx.closest(this.$ctx).length)
                return this.hideStageOverlay()
        },
        onVideoStop: function(data) {
            var videoComponent;
            if (data.$ctx.closest(this.$ctx).length)
                return this.showStageOverlay(!1),
                videoComponent = this.getVideoInCurrentSlide(),
                null != videoComponent ? this.showStageOverlay(!this.isVideoPaused(videoComponent)) : this.showStageOverlay(!0)
        },
        onSlideBeforeChange: function(event, slick, currentSlide, nextSlide) {
            var nextVideoComponent, videoComponent;
            return videoComponent = this.getVideoInCurrentSlide(),
            this._events.emit("stageSliderSlideBeforeChange", {
                currentSlide: currentSlide,
                stage: this,
                $slide: this.getSlide(currentSlide),
                videoComponent: videoComponent
            }),
            nextVideoComponent = this.getVideoInSlide(nextSlide),
            null != nextVideoComponent ? this.showStageOverlay(!this.isVideoPaused(nextVideoComponent)) : this.showStageOverlay(!0)
        },
        onSliderAfterChange: function(ev, slick, currentSlide) {
            var $nextSlide, $previousSlide, mod, videoComponent;
            return mod = this,
            $nextSlide = slick.$slides.eq(currentSlide + 1 % slick.$slides.length),
            $nextSlide.find(".lazyload").addClass("lazypreload"),
            $previousSlide = slick.$slides.eq(currentSlide - 1 % slick.$slides.length),
            $previousSlide.find(".lazyload").addClass("lazypreload"),
            videoComponent = mod.getVideoInCurrentSlide(),
            mod._events.emit("stageSliderSlideAfterChange", {
                currentSlide: currentSlide,
                stage: this,
                $slide: $(slick.$slides.get(currentSlide)),
                videoComponent: videoComponent
            })
        },
        onSliderInit: function() {
            if (this.isSliderInitialized = !0,
            this.$paginationDots = this.$(".a-paginationdots"),
            T.Utils.isRTL())
                return this.$paginationDots.attr("dir", "rtl")
        },
        onSliderSetPosition: function() {
            return this.setStageControls()
        }
    })
}(jQuery),
function($) {
    T.Module.SubtotalAmount = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.Table = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$window = $(window),
            this.hasFixedHead = !1,
            this.isScrollingActive = !1,
            this.el = {
                $table: this.$("table")
            },
            this._events.on("recalc", $.proxy(this.onRecalc, this)),
            this._events.on("image:loaded", $.proxy(this.syncRowHeight, this)),
            this.setupDOMReferences(),
            this.setupFixedHead(),
            this.setupScrollable(),
            this.setupStatic(),
            resolve()
        },
        sync: function() {},
        activateScrolling: function() {
            if (!this.isScrollingActive)
                return this.$table.addClass("is-hidden"),
                this.$scrollable.prependTo(this.$ctx),
                this.$pinned.length && (this.$pinned.insertBefore(this.$scrollable),
                this.syncRowHeight()),
                this.$fixedHead.length && (this.$fixedHead.prependTo(this.$scrollable),
                this.$pinned.length && (this.$scrollable.find(".fixed-head th:first").remove(),
                this.$fixedHeadPinned.prependTo(this.$pinned)),
                this.syncScrollableFixedWidth(),
                this.syncPinnedFixedWidth(),
                this.setFixedPosition()),
                this.isScrollingActive = !0
        },
        deactivateScrolling: function() {
            if (this.isScrollingActive)
                return this.$(".pinned, .scrollable").remove(),
                this.$table.removeClass("is-hidden"),
                this.$pinned.find(".fixed-head").remove(),
                this.$scrollable.find(".fixed-head").remove(),
                this.createFixedHead(),
                this.$fixedHead.prependTo(this.$ctx),
                this.setFixedPosition(),
                this.isScrollingActive = !1
        },
        checkWidth: function() {
            var maxTableWidth, maxWidth;
            return maxWidth = this.$ctx.width(),
            maxTableWidth = this.el.$table.outerWidth(),
            maxTableWidth > maxWidth ? this.activateScrolling() : this.deactivateScrolling()
        },
        createFixedHead: function() {
            if (this.$fixedHead = this.$table.clone(),
            this.$fixedHead.find("tbody, caption").remove(),
            this.$fixedHead = this.$fixedHead.wrap('<div class="fixed-head">').parent(),
            this.$pinned.length && (this.$fixedHeadPinned = this.$fixedHead.clone(),
            this.$fixedHeadPinned.find("th:gt(0)").remove()),
            void 0 === this.$thead.data("fixed"))
                return this.$fixedHead = $([]),
                this.$fixedHeadPinned = $([])
        },
        setupDOMReferences: function() {
            return this.$table = this.$("table"),
            this.$thead = this.$("thead"),
            this.$tbody = this.$("tbody"),
            this.$pinned = this.$table.clone(),
            this.$pinned.find("td, th:not(:first-child), caption").remove(),
            this.$pinned = this.$pinned.wrap('<div class="pinned">').parent(),
            this.$pinned.find("tr:not(:has(th))").remove(),
            this.$pinned.find("tr").length < this.$table.find("tr").length && (this.$pinned = $([])),
            this.$scrollable = this.$table.clone(),
            this.$pinned.length && this.$scrollable.find("th:first-child").remove(),
            this.$scrollable = this.$scrollable.wrap('<div class="scrollable">').parent(),
            this.createFixedHead()
        },
        setupFixedHead: function() {
            if (this.$fixedHead.length)
                return this.$fixedHead.prependTo(this.$ctx),
                this.hasFixedHead = !0,
                this.$window.on("scroll", $.proxy(this.setFixedPosition, this))
        },
        setupScrollable: function() {
            return this.$window.on("resize.setupScrollable", T.Utils.debounce($.proxy(this.onResize, this), 50)),
            this.checkWidth()
        },
        setupStatic: function() {
            if (this.$ctx.data("is-static"))
                return this.$window.off("resize.setupScrollable"),
                this.$(".scrollable").removeClass("scrollable")
        },
        setFixedPosition: function() {
            var $fixedHead, offsetTop, scrollTop, tableHeight;
            if (scrollTop = this.$window.scrollTop(),
            offsetTop = this.$ctx.offset().top,
            tableHeight = this.$ctx.height(),
            $fixedHead = this.$(".fixed-head"),
            this.hasFixedHead)
                return scrollTop > offsetTop ? scrollTop > offsetTop + tableHeight ? $fixedHead.css("top", "") : $fixedHead.css("top", scrollTop - offsetTop) : $fixedHead.css("top", "")
        },
        syncPinnedFixedWidth: function() {
            var $pinnedFixed;
            return $pinnedFixed = this.$pinned.find(".fixed-head"),
            $pinnedFixed.find("table").css("width", this.$pinned.find("tbody th:first").innerWidth())
        },
        syncRowHeight: function() {
            var mod;
            return mod = this,
            this.$scrollable.find("tr").each(function(i, el) {
                var $pinnedCell, $scrollableCell, pinnedCellHeight, scrollableCellHeight;
                return $pinnedCell = mod.$pinned.find("tr:eq(" + i + ") th"),
                pinnedCellHeight = $pinnedCell.outerHeight(),
                $scrollableCell = $(el).children(":first"),
                scrollableCellHeight = $scrollableCell.outerHeight(),
                pinnedCellHeight > scrollableCellHeight ? $scrollableCell.css("height", pinnedCellHeight) : $pinnedCell.css("height", scrollableCellHeight)
            })
        },
        syncScrollableFixedWidth: function() {
            var $scrollableFixed;
            return $scrollableFixed = this.$scrollable.find(".fixed-head"),
            this.$scrollable.find("tbody tr:first").children().each(function(i) {
                return $scrollableFixed.find("th").eq(i).css("width", $(this)[0].scrollWidth)
            })
        },
        onRecalc: function(data) {
            if (this.$ctx.closest(data.$element).length)
                return this.onResize()
        },
        onResize: function() {
            if (this.el = {
                $table: this.$("table")
            },
            this.checkWidth(),
            this.isScrollingActive && (this.syncRowHeight(),
            this.hasFixedHead))
                return this.syncPinnedFixedWidth(),
                this.syncScrollableFixedWidth()
        }
    })
}(jQuery),
function($) {
    T.Module.Tabs = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.sync = $.proxy(this, "sync"),
            mod.arrangeTabs = $.proxy(this, "arrangeTabs"),
            mod.getOverlappingTab = $.proxy(this, "getOverlappingTab"),
            mod.getTabById = $.proxy(this, "getTabById"),
            mod.openTab = $.proxy(this, "openTab"),
            mod.sendRecalc = $.proxy(this, "sendRecalc"),
            mod.sendStickyHide = $.proxy(this, "sendStickyHide"),
            mod.setupTabs = $.proxy(this, "setupTabs"),
            mod.onClickTab = $.proxy(this, "onClickTab"),
            mod.onClickTabMore = $.proxy(this, "onClickTabMore"),
            mod.onClickTabMorePaneItem = $.proxy(this, "onClickTabMorePaneItem"),
            mod.onOpenTab = $.proxy(this, "onOpenTab"),
            mod.onWindowHashchange = $.proxy(this, "onWindowHashchange"),
            mod.onWindowResize = $.proxy(this, "onWindowResize"),
            T.Utils.allSynced = !1,
            mod.isSynced = !1,
            mod.hashScope = mod.$ctx.data("hash-scope") || "Tabs",
            mod.borderWidth = 1,
            mod.delay = 250,
            mod.disableHashchange = !!mod.$ctx.attr("data-hashchange"),
            mod.groupid = mod.$ctx.data("group-id"),
            mod.groupSelector = mod.groupid ? ".js-tabgroup-" + mod.groupid : "",
            mod.groupid && mod.$ctx.find("> div.tabs-wrapper > section.tab-panel").addClass("js-tabgroup-" + mod.groupid),
            mod.$tabs = mod.$(".tabs-nav" + mod.groupSelector),
            mod.$tabsInitial = mod.$tabs.find("li:not(.tab-more)"),
            mod.$moreTab = mod.$tabs.find(".tab-more"),
            mod.$moreTabPane = mod.$tabs.find(".js-tab-more-pane"),
            mod.$moreTabPaneList = mod.$tabs.find(".js-tab-more-pane-list"),
            mod.$tabPanels = mod.$(".tab-panel" + mod.groupSelector),
            mod._events.on("t.sync", mod.sync),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.disableHashchange ? this.openTab() : location.hash ? (this.initialHash = !0,
            this.onWindowHashchange(),
            this.initialHash = !1) : this.openTab(),
            this.setupTabs(),
            this.isSynced = !0,
            T.Utils.allSynced = !0)
        },
        arrangeTabs: function() {
            var $criticalTab, $hiddenTabs, mod;
            return mod = this,
            mod.$moreTabPaneList.children().removeClass("js-tab-more-pane-item tab-more-pane-item").insertBefore(mod.$moreTab),
            $criticalTab = mod.getOverlappingTab(),
            $criticalTab ? ($hiddenTabs = $criticalTab.prev().nextUntil(".tab-more"),
            $hiddenTabs.addClass("js-tab-more-pane-item tab-more-pane-item").appendTo(mod.$moreTabPaneList),
            $hiddenTabs.length && (mod.$moreTab.removeClass("hidden"),
            this.$moreTabPane.find("li").hasClass("is-active")) ? this.$moreTab.addClass("is-active") : void 0) : mod.$moreTab.addClass("hidden")
        },
        getOverlappingTab: function() {
            var $criticalTab, mod, moreTabWidth, totalWidthTabContainer, totalWidthTabs;
            return mod = this,
            totalWidthTabContainer = mod.$tabs.innerWidth(),
            moreTabWidth = mod.$moreTab.outerWidth(!0),
            totalWidthTabs = moreTabWidth,
            $criticalTab = null,
            mod.$tabs.find("li:not(.tab-more):not(.js-tab-more-pane)").each(function() {
                if (totalWidthTabs += $(this).outerWidth(!0),
                totalWidthTabs + mod.borderWidth > totalWidthTabContainer)
                    return $criticalTab = $(this),
                    !1
            }),
            $criticalTab && $criticalTab.is(mod.$tabsInitial.filter(":last")) && (totalWidthTabs -= moreTabWidth - 1,
            totalWidthTabs <= totalWidthTabContainer) ? null : $criticalTab
        },
        getTabById: function(id) {
            var $link;
            return $link = this.disableHashchange ? this.$tabs.find("a[href*='" + id + "']") : this.$tabs.find("a[href*='" + this.hashScope + "=" + id + "']"),
            $link.length ? $link.closest("li") : $([])
        },
        openTab: function($tab) {
            var $tabContent, ajaxId, mod;
            return mod = this,
            $tab || ($tab = mod.$tabsInitial.hasClass("initial-active") ? mod.$tabs.find(".initial-active") : mod.$tabs.find("li:first")),
            mod.$tabsInitial.removeClass("is-active"),
            mod.$moreTab.removeClass("is-active"),
            $tab.addClass("is-active"),
            mod.$tabPanels.removeClass("is-active").eq(mod.$tabsInitial.index($tab)).addClass("is-active"),
            mod.$moreTabPane.find("li").hasClass("is-active") && mod.$moreTab.addClass("is-active"),
            $tab.data("jump-to") && T.Utils.scrollToTop($tab.offset().top),
            ajaxId = $tab.data("ajax-request-id"),
            ajaxId && (T.Utils.startAjaxRequest(ajaxId, !1, !1),
            $tab.removeAttr("data-ajax-request-id"),
            $tab.removeData("ajax-request-id")),
            $tabContent = $({}),
            mod.$tabPanels.each(function() {
                if ($(this).hasClass("is-active"))
                    return $tabContent = this,
                    mod.sendRecalc($tabContent),
                    mod.sendStickyHide($tabContent)
            })
        },
        sendRecalc: function($tabContent) {
            return this._events.emit("recalc", {
                $element: $tabContent,
                $ctx: this.$ctx
            })
        },
        sendStickyHide: function($tabContent) {
            return this._events.emit("hideSticky", {
                $element: $tabContent,
                $ctx: this.$ctx
            })
        },
        setupTabs: function() {
            var mod;
            return mod = this,
            this._events.on("openTab", this.onOpenTab),
            this.$ctx.on("click", ".tabs-nav" + mod.groupSelector + " > li:not(.tab-more):not(.js-tab-more-pane)", this.onClickTab),
            this.$ctx.on("click", ".tabs-nav" + mod.groupSelector + " .js-tab-more-pane-item", this.onClickTabMorePaneItem),
            this.$ctx.on("click", ".tabs-nav" + mod.groupSelector + " > .tab-more", this.onClickTabMore),
            this.disableHashchange || $(window).on("hashchange.tabs", this.onWindowHashchange),
            this._events.on("reArrangeTabs", this.arrangeTabs),
            this.arrangeTabs(),
            T.Utils.startAddModule = !0,
            $(window).on("resize", this.onWindowResize)
        },
        onClickTab: function(ev) {
            var $target, mod, newId, oldId;
            if (mod = this,
            $target = $(ev.currentTarget),
            !$target.find("a").data("tab-link") && (ev.preventDefault(),
            this.$moreTab.hasClass("is-open") && this.$moreTab.trigger("click"),
            oldId = this.$(".tab-panel" + mod.groupSelector + ".is-active").attr("id"),
            this.openTab($target),
            newId = this.$(".tab-panel" + mod.groupSelector + ".is-active").attr("id"),
            !this.disableHashchange))
                return T.Utils.hashContains(this.hashScope, oldId) ? T.Utils.replaceHash(this.hashScope, oldId, newId) : T.Utils.setHash(this.hashScope, newId)
        },
        onClickTabMore: function(ev) {
            return this.$moreTab.toggleClass("is-open"),
            ev.preventDefault()
        },
        onClickTabMorePaneItem: function(ev) {
            return this.$moreTab.removeClass("is-open"),
            this.openTab($(ev.currentTarget)),
            ev.stopImmediatePropagation()
        },
        onOpenTab: function(data) {
            var $tab, mod, oldId;
            if (mod = this,
            $tab = this.getTabById(data.tabId),
            $tab.length > 0 && (this.disableHashchange ? (this.$moreTab.hasClass("is-open") && this.$moreTab.trigger("click"),
            this.openTab($tab)) : (oldId = this.$(".tab-panel" + mod.groupSelector + ".is-active").attr("id"),
            T.Utils.hashContains(this.hashScope, oldId) ? T.Utils.replaceHash(this.hashScope, oldId, data.tabId) : T.Utils.setHash(this.hashScope, data.tabId)),
            data.scrollToTab))
                return T.Utils.scrollToTop($tab.offset().top, data.callback)
        },
        onWindowHashchange: function() {
            var $tab, i, id, len, tabIds;
            for (tabIds = T.Utils.getHashIds(this.hashScope),
            i = 0,
            len = tabIds.length; i < len; i++)
                if (id = tabIds[i],
                $tab = this.getTabById(id),
                $tab.length)
                    return this.openTab($tab),
                    void (this.initialHash && T.Utils.scrollToTop($tab));
            return this.openTab()
        },
        onWindowResize: function() {
            var mod;
            mod = this,
            mod.arrangeTabs(),
            T.Utils.debounce($.proxy(mod.arrangeTabs, mod), mod.delaylay)
        }
    })
}(jQuery),
function($) {
    T.Module.TabsTogglebox = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.id = mod.$ctx.attr("data-t-id"),
            mod.toggleBoxIsActive = !1,
            mod.groupid = mod.$ctx.data("group-id"),
            mod.groupSelector = mod.groupid ? ".js-tabgroup-" + mod.groupid : "",
            mod.productsetTablinkSelector = ".js-trigger-productset-component-request",
            mod.$togglebox = mod.$(".m-togglebox").first(),
            mod.$tabs = mod.groupid ? mod.$(".m-tabs[data-group-id='" + mod.groupid + "']") : mod.$(".m-tabs"),
            mod.groupid && mod.$tabs.find("> div.tabs-wrapper > section.tab-panel").addClass("js-tabgroup-" + mod.groupid),
            mod.$tabLinks = this.$(".tabs-nav" + mod.groupSelector + " li:not(.tab-more) > a"),
            mod.$tabContents = this.$(".tab-panel" + mod.groupSelector),
            mod.productsetSetup = !!mod.$ctx.attr("data-productset-setup"),
            mod._events.on("onGridListInit", $.proxy(mod.onGridListInit, mod)),
            mod._events.on("openTabToggleBox", $.proxy(mod.onOpenTabToggleBox, mod)),
            T.Utils.registerMq("lg", {
                match: function() {
                    return mod.setupTabs()
                },
                unmatch: function() {
                    return mod.setupTogglebox()
                }
            }),
            T.Utils.isViewport("desktop") || this.setupTogglebox(),
            resolve()
        },
        sync: function() {},
        fillTabs: function() {
            var mod;
            return mod = this,
            this.$tabLinks.each(function() {
                return $(this).parent().removeClass("is-active")
            }),
            this.$tabContents.removeClass("is-active"),
            this.$togglebox.children(".item").each(function(i) {
                var $content, $tab;
                if ($content = $(this).children(".body").children(),
                $tab = mod.$tabContents.eq(i),
                $content.appendTo($tab),
                $tab.attr("id", $tab.data("id")).removeData("id"),
                $(this).children(".is-open").length)
                    return mod.$tabLinks.eq(i).parent().addClass("is-active"),
                    $tab.addClass("is-active")
            }),
            this.$togglebox.empty()
        },
        fillTogglebox: function() {
            var mod, template;
            return mod = this,
            template = this.$(".tpl-tabstogglebox-togglebox-item").html(),
            this.$tabLinks.each(function(i, link) {
                var $content, $link, $listElement, $toggleboxContent, $toggleboxItem, ajaxRequestId, id;
                return $link = $(link),
                $listElement = $link.parent("li"),
                $content = mod.$tabContents.eq(i),
                id = $content.attr("id"),
                $toggleboxItem = $(doT.template(template)({
                    id: id,
                    title: $link.text()
                })),
                $content.data("id", id).removeAttr("id"),
                $toggleboxContent = $toggleboxItem.find(".togglebox-content"),
                $content.children().appendTo($toggleboxContent),
                ajaxRequestId = $listElement.data("ajax-request-id"),
                null != ajaxRequestId && ($toggleboxItem.attr("data-ajax-request-id", ajaxRequestId),
                $toggleboxContent.attr("data-replace-container", $content.attr("data-replace-container")),
                $listElement.removeData("ajax-request-id"),
                $listElement.removeAttr("data-ajax-request-id"),
                $content.removeData("replace-container"),
                $content.removeAttr("data-replace-container")),
                $content.hasClass("is-active") && $toggleboxItem.children().addClass("is-open"),
                $toggleboxItem.appendTo(mod.$togglebox)
            })
        },
        fillProductsetTogglebox: function() {
            var mod;
            return mod = this,
            mod.$tabLinks.each(function(i, link) {
                var $content, $link, id;
                if ($link = $(link),
                !$link.is(mod.productsetTablinkSelector) && ($content = mod.$tabContents.eq(i),
                id = $content.attr("id"),
                $content.data("id", id).removeAttr("id"),
                $content.hasClass("is-active")))
                    return mod.$togglebox.children().eq(i).children().addClass("is-open")
            })
        },
        setupTogglebox: function() {
            return this.$tabs.addClass("hidden"),
            this.productsetSetup ? this.fillProductsetTogglebox() : this.fillTogglebox(),
            this.$togglebox.removeClass("hidden"),
            this.toggleBoxIsActive = !0
        },
        setupTabs: function() {
            return this.$togglebox.addClass("hidden"),
            this.productsetSetup || this.fillTabs(),
            this.$tabs.removeClass("hidden"),
            this.toggleBoxIsActive = !1
        },
        onGridListInit: function() {
            var mod;
            return mod = this,
            mod.$togglebox.find(".js-list-layout").addClass("g-layout-fourth").removeClass("g-layout-full")
        },
        onOpenTabToggleBox: function(data) {
            var $toggle, mod, scrollToTab, tabId;
            if (mod = this,
            data.$parent.find('[data-t-id="' + mod.id + '"]').length) {
                if (tabId = data.tabId,
                scrollToTab = data.scrollToTab,
                mod.toggleBoxIsActive)
                    return $toggle = mod.$("[data-tab-reference='" + tabId + "']:visible"),
                    mod._events.emit("openToggleBoxItem", {
                        $toggle: $toggle,
                        instant: $toggle.data("close-instantly")
                    }),
                    void (scrollToTab && T.Utils.scrollToTop($toggle.offset().top));
                if (!mod.toggleBoxIsActive)
                    return mod._events.emit("openTab", {
                        tabId: tabId,
                        scrollToTab: scrollToTab
                    })
            }
        },
        onToggleListView: function() {
            var mod;
            return mod = this,
            mod.$togglebox.find(".js-list-layout").addClass("g-layout-full").removeClass("g-layout-fourth")
        }
    })
}(jQuery),
function($) {
    T.Module.TeaserSlider = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            this.$ctx = $(this._ctx),
            this.$paginationArrows = this.$(".js-paginationarrows"),
            this.$paginationNumber = this.$(".js-paginationnumber"),
            this.$slider = this.$(".slick-slider"),
            this.$slides = this.$(".slide"),
            this.initSlider(),
            this._events.on("recalc", function(data) {
                if (mod.$ctx.closest(data.$element).length)
                    return mod.$slider.slick("setPosition")
            }),
            resolve()
        },
        sync: function() {},
        initSlider: function() {
            return this.$slider.slick({
                appendArrows: this.$paginationArrows,
                arrows: !0,
                nextArrow: this.$(".next"),
                prevArrow: this.$(".prev"),
                slidesToShow: 1
            }),
            this.$slides.length > 1 ? this.setPaginationNumber(1) : this.$(".teaserslider-paginationarrows, .teaserslider-paginationnumber").hide(),
            this.$slider.on("beforeChange", function(_this) {
                return function(ev, slick, currentSlide, nextSlide) {
                    return _this.onSlideBeforeChange(ev, slick, currentSlide, nextSlide)
                }
            }(this)),
            this.$slider.on("afterChange", function(_this) {
                return function(event, slick, currentSlide) {
                    return _this.onSlideAfterChange(event, slick, currentSlide)
                }
            }(this))
        },
        setPaginationNumber: function(slide) {
            return this.$paginationNumber.text(slide + "/" + this.$slides.length)
        },
        onSlideBeforeChange: function(ev, slick, currentSlide, nextSlide) {
            if (this.$slides.length > 1)
                return this.setPaginationNumber(nextSlide + 1)
        },
        onSlideAfterChange: function(event, slick, currentSlide) {}
    })
}(jQuery),
function($) {
    T.Module.TermsConditions = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.stateClassHasOpenLayer = "has-open-layer",
            this.stateClassHasOpenLayerSelector = ".has-open-layer",
            this.agreeButtonSelector = ".js-agree-button",
            this.cancelButtonSelector = ".js-cancel-terms-button",
            this.acceptCheckboxSelector = ".js-accept-term",
            this.acceptCheckboxClass = "js-accept-term",
            this.layerTriggerSelector = "[data-layer-id]",
            this.dataReplaceContainerSelector = "[data-replace-container]",
            this.formInputSelector = '[data-t-name="FormInput"]',
            this.sync = $.proxy(this.sync, this),
            this.$layerTriggerCollection = this.$(this.layerTriggerSelector, this.$ctx),
            this._events.on("t.sync", this.sync),
            this.$layerTriggerCollection.on("click", $.proxy(this.onOpenLayer, this)),
            this.$ctx.on("click", this.agreeButtonSelector, $.proxy(this.onClickAcceptButton, this)),
            this.$ctx.on("click", this.cancelButtonSelector, $.proxy(this.onClickCancelButton, this)),
            this._events.on("closeLayer", $.proxy(this.onCloseLayer, this)),
            this._events.on("hideLayer", $.proxy(this.onCloseLayer, this)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0)
        },
        setAcceptCheckboxState: function(state) {
            var isCheckbox, matchingCheckbox, openLayerTrigger;
            return openLayerTrigger = this.$(this.stateClassHasOpenLayerSelector),
            isCheckbox = openLayerTrigger.hasClass(this.acceptCheckboxClass),
            isCheckbox === !0 ? openLayerTrigger.prop("checked", state) : (matchingCheckbox = openLayerTrigger.parents(this.formInputSelector).find(this.acceptCheckboxSelector),
            matchingCheckbox.prop("checked", state)),
            this._events.emit("hideLayer", !0)
        },
        onOpenLayer: function(ev) {
            var $layerInner, eventTarget, mod, request;
            return ev.preventDefault(),
            mod = this,
            eventTarget = $(ev.currentTarget),
            eventTarget.addClass(this.stateClassHasOpenLayer),
            $layerInner = this.$(this.dataReplaceContainerSelector),
            $layerInner.empty(),
            this._events.emit("loader:open", {
                loaderType: "layer",
                $trigger: $layerInner
            }),
            request = T.Utils.onAjaxControllerTriggered(ev, !0),
            !!request && request[0].then(function() {
                return mod._events.emit("loader:close", {
                    $trigger: $layerInner
                })
            })
        },
        onCloseLayer: function(ev) {
            return this.$(this.stateClassHasOpenLayerSelector).removeClass(this.stateClassHasOpenLayer)
        },
        onClickAcceptButton: function(ev) {
            return ev.stopPropagation(),
            ev.preventDefault(),
            this.setAcceptCheckboxState(!0)
        },
        onClickCancelButton: function(ev) {
            return ev.stopPropagation(),
            ev.preventDefault(),
            this.setAcceptCheckboxState(!1)
        }
    })
}(jQuery),
function($) {
    var contentRowsWithCompareDifferencesSelector, contentSelector, disableHashChangeClass, disableHashOnToggleItemClass, externalMarker, itemsSelector, itemsWithCompareDifferencesSelector, openClass, openSelector, specificTogglesSelector, subtitleSelector, titleSelector, toggleOnCompareDifferencesSelector, toggleSelector, transitionClass, transitionSelector;
    return contentSelector = ".togglebox-content",
    openClass = "is-open",
    openSelector = "." + openClass,
    subtitleSelector = ".togglebox-subtitle",
    toggleSelector = ".js-togglebox-toggle",
    transitionClass = "is-in-transition",
    transitionSelector = "." + transitionClass,
    titleSelector = ".togglebox-title",
    specificTogglesSelector = "> .item > " + toggleSelector + ", > .item > " + contentSelector + " > .item > " + toggleSelector,
    toggleOnCompareDifferencesSelector = ".js-toggle-on-compare-differences",
    itemsSelector = "> .item",
    itemsWithCompareDifferencesSelector = ".js-has-compare-differences",
    contentRowsWithCompareDifferencesSelector = ".js-has-compare-cell-differences",
    disableHashChangeClass = "js-disable-hash-change",
    disableHashOnToggleItemClass = "js-disable-set-hash",
    externalMarker = ".js-external-marker",
    T.Module.Togglebox = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            this.$ctx = $(this._ctx),
            this.isSynced = !1,
            this._events.on("t.sync", $.proxy(this.sync, this)),
            this.hashScope = this.$ctx.data("hash-scope") || "Togglebox",
            this.singleSelection = null != this.$ctx.data("single-selection") && this.$ctx.data("single-selection") || !1,
            this.id = this.$ctx.data("t-id"),
            this.$contentToggles = this.$(specificTogglesSelector),
            this.$externalMarker = this.$(externalMarker),
            this.activeItem = this.$ctx.data("initial-open"),
            this.$ctx.on("click", specificTogglesSelector, $.proxy(this.onClickContentToggle, this)),
            this._events.on("openToggleBoxItem", $.proxy(this.onOpenToggleBoxItem, this)),
            this._events.on("openToggleBox", function(id) {
                if (mod.$externalMarker.length > 0 && mod.$externalMarker.hasClass(id))
                    return mod.openPanel(mod.$externalMarker)
            }),
            this._events.on("closeToggleBox", function(id, animate) {
                if (mod.$externalMarker.length > 0 && mod.$externalMarker.hasClass(id))
                    return mod.closePanel(mod.$externalMarker, animate)
            }),
            this._events.on("closeAllToggleBoxItems", $.proxy(this.onCloseAllToggleBoxItems, this)),
            this._events.on("compareitem:toggleCompareDifferences", $.proxy(this.onToggleCompareDifferences, this)),
            $(window).on("hashchange", $.proxy(this.onWindowHashchange, this)),
            this.$ctx.on("transitionend", contentSelector, function() {
                return mod.sendRecalc($(this))
            }),
            location.hash && this.onWindowHashchange(),
            null != this.activeItem && this.handleActiveItem(),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.sendReloadAllClips(),
            this.isSynced = !0)
        },
        closePanel: function($toggle, instant) {
            var $content, i, idArray, len, mod, toggleItem;
            for (mod = this,
            idArray = [],
            i = 0,
            len = $toggle.length; i < len; i++)
                toggleItem = $toggle[i],
                $content = $(toggleItem).next(contentSelector),
                $(toggleItem).removeClass(openClass),
                Modernizr.csstransitions && !instant ? ($content.addClass(transitionClass),
                mod.setContentHeight($content),
                $content.off("transitionend").one("transitionend", function() {
                    return $content.removeClass(transitionClass).css("max-height", "")
                }),
                $content.removeClass(openClass),
                setTimeout(function() {
                    return $content.css("max-height", "0")
                }, 10)) : $content.removeClass(openClass),
                idArray.push($content.attr("id"));
            if (mod.sendRecalc($content),
            !mod.$ctx.hasClass(disableHashChangeClass))
                return T.Utils.removeHash(mod.hashScope, idArray)
        },
        getToggleById: function(id) {
            return this.$("#" + id).prev(toggleSelector)
        },
        handleActiveItem: function() {
            var $activeItem, activeItemIsOpen, initialScrollTo;
            return $activeItem = this.$(toggleSelector).eq(this.activeItem - 1),
            activeItemIsOpen = $activeItem.hasClass("is-open"),
            initialScrollTo = this.$ctx.attr("data-initial-scrollto"),
            initialScrollTo ? activeItemIsOpen ? void 0 : $activeItem.trigger("click") : T.Utils.scrollToTop($activeItem, function() {
                if (!activeItemIsOpen)
                    return $activeItem.trigger("click")
            })
        },
        openPanel: function($toggle) {
            var $listElement, ajaxId, mod;
            return mod = this,
            $listElement = $toggle.parent("div"),
            ajaxId = $listElement.data("ajax-request-id"),
            ajaxId ? (T.Utils.startAjaxRequest(ajaxId, !1, !1, function(err) {
                return mod.openPanelLoaded($toggle)
            }),
            $listElement.removeAttr("data-ajax-request-id"),
            $listElement.removeData("ajax-request-id")) : mod.openPanelLoaded($toggle)
        },
        openPanelLoaded: function($toggle) {
            var $content;
            if (!$toggle.hasClass(openClass))
                return $content = $toggle.next(contentSelector),
                $toggle.addClass(openClass),
                Modernizr.csstransitions ? ($content.off("transitionend").one("transitionend", function() {
                    return $content.removeClass(transitionClass).addClass(openClass).css("max-height", "")
                }).addClass(transitionClass),
                this.setContentHeight($content)) : (this.setContentHeight($content),
                $content.addClass(openClass).css("max-height", "")),
                this.sendRecalc($content),
                $toggle.hasClass(disableHashOnToggleItemClass) || T.Utils.setHash(this.hashScope, $content.attr("id")),
                this.sendReloadCliplister($content)
        },
        sendRecalc: function($element) {
            return this._events.emit("recalc", {
                $element: $element,
                $ctx: this.$ctx
            })
        },
        sendReloadAllClips: function() {
            var $toggleboxContents, mod;
            return mod = this,
            $toggleboxContents = mod.$ctx.find(contentSelector),
            $toggleboxContents.each(function() {
                var $content;
                if ($content = $(this),
                $content.is(openSelector) || $content.is(transitionSelector))
                    return mod.sendReloadCliplister($content)
            })
        },
        sendReloadCliplister: function($toggleboxContent) {
            var targetVideoId;
            if (targetVideoId = $toggleboxContent.find(".m-video-cliplister").first().data("video-id"),
            null != targetVideoId)
                return this._events.emit("video:reloadclip", {
                    reloadId: targetVideoId
                })
        },
        setContentHeight: function($content) {
            var mod;
            return mod = this,
            $content.each(function() {
                var $currentContent, currentHeight;
                return $currentContent = $(this),
                currentHeight = $currentContent[0].scrollHeight,
                $currentContent.find("" + contentSelector + openSelector).each(function() {
                    if ($(this)[0].scrollHeight > $(this).height())
                        return currentHeight += $(this)[0].scrollHeight
                }),
                0 === currentHeight && (currentHeight = "none"),
                $currentContent.css("max-height", currentHeight)
            })
        },
        togglePanel: function($toggle, closeInstantly) {
            var $openToggle, instant, mod;
            if (mod = this,
            $toggle.closest('[data-t-name="Togglebox"]').data("t-id") === mod.id)
                return $openToggle = $toggle.parent().siblings().children("" + toggleSelector + openSelector),
                instant = null != closeInstantly,
                this.singleSelection && $openToggle.length && this.closePanel($openToggle, instant),
                $toggle.hasClass(openClass) ? this.closePanel($toggle, instant) : this.openPanel($toggle)
        },
        onClickContentToggle: function(ev) {
            return ev.preventDefault(),
            ev.stopImmediatePropagation(),
            this.togglePanel($(ev.currentTarget))
        },
        onCloseAllToggleBoxItems: function(instant, $item, listId) {
            var $itemsToClose, mod;
            if (mod = this,
            mod.$ctx.closest('[data-t-id="' + listId + '"]').length > 0)
                return $itemsToClose = mod.$("" + toggleSelector).not($item),
                mod.closePanel($itemsToClose, instant)
        },
        onOpenToggleBoxItem: function(data) {
            var mod;
            if (mod = this,
            data.$toggle.closest(mod.$ctx).length > 0 && !data.$toggle.hasClass("is-open"))
                return mod.togglePanel(data.$toggle, data.instant)
        },
        onToggleCompareDifferences: function(blnShowOnlyDifferences) {
            var $items, $itemsWithDifferences, $itemsWithoutDifferences, mod;
            if (mod = this,
            mod.$ctx.is(toggleOnCompareDifferencesSelector))
                return $items = mod.$ctx.find(itemsSelector),
                $itemsWithDifferences = $items.filter(itemsWithCompareDifferencesSelector),
                $itemsWithoutDifferences = $items.filter(":not(" + itemsWithCompareDifferencesSelector + ")"),
                $itemsWithDifferences.each(function() {
                    var $closedItemWithDifferences, $contentRowsWithoutCompareDifferences, $toggleforItem;
                    if ($contentRowsWithoutCompareDifferences = $(this).find("tr:not(" + contentRowsWithCompareDifferencesSelector + ")"),
                    $contentRowsWithoutCompareDifferences.toggleClass("hidden", blnShowOnlyDifferences),
                    blnShowOnlyDifferences)
                        return $toggleforItem = $(this).find(toggleSelector),
                        $closedItemWithDifferences = $toggleforItem.filter(":not(" + openSelector + ")"),
                        $closedItemWithDifferences.trigger("click")
                }),
                $itemsWithoutDifferences.toggleClass("hidden", blnShowOnlyDifferences)
        },
        onWindowHashchange: function() {
            var $toggles, i, id, len, mod, toggleboxIds;
            if (mod = this,
            !mod.$ctx.hasClass(disableHashChangeClass)) {
                for (toggleboxIds = T.Utils.getHashIds(this.hashScope),
                $toggles = $([]),
                i = 0,
                len = toggleboxIds.length; i < len; i++)
                    id = toggleboxIds[i],
                    $toggles = $toggles.add(this.getToggleById(id));
                return $toggles.filter(subtitleSelector).each(function() {
                    return mod.openPanel($(this))
                }),
                $toggles.filter(titleSelector).each(function() {
                    return mod.openPanel($(this))
                }),
                $toggles.length ? void 0 : mod.$contentToggles.filter(openSelector).each(function() {
                    return mod.closePanel($(this), !1)
                })
            }
        }
    })
}(jQuery),
function($) {
    T.Module.TotalAmount = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.config = this.$ctx.data(),
            this.stateclass = {
                hidden: "is-hidden"
            },
            this.$downpaymentwrap = this.$(".js-downpayment-info"),
            this.$due = {
                text: this.$(".js-update-due"),
                value: this.$(".js-calculate-due")
            },
            this.$balance = {
                text: this.$(".js-update-balance")
            },
            this.sync = $.proxy(this.sync, this),
            this.onChangeDownpayment = $.proxy(this, "onChangeDownpayment"),
            this.onGetUpdateDownpayment = $.proxy(this, "onGetUpdateDownpayment"),
            this._events.on("t.sync", this.sync),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            this._events.on("downpayment:update", this.onGetUpdateDownpayment),
            this.$due.value.on("change", this.onChangeDownpayment))
        },
        onChangeDownpayment: function(ev) {
            var downpayment, noDownpayment;
            if (downpayment = Number(this.$due.value.val()),
            noDownpayment = !Boolean(downpayment),
            this.$downpaymentwrap.toggleClass(this.stateclass.hidden, noDownpayment),
            !noDownpayment)
                return this.$due.text.text(T.Utils.localizePrice(downpayment)),
                this.$balance.text.text(T.Utils.localizePrice(this.config.totalPrice - downpayment)),
                this._events.emit("totalamount:downpaymentupdate")
        },
        onGetUpdateDownpayment: function(value) {
            return this.$due.value.val(Number(value)).trigger("change")
        }
    })
}(jQuery),
function($) {
    T.Module.TypePlateFinder = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.isSynced = !1,
            T.Utils.allSynced = !1,
            mod._events.on("t.sync", $.proxy(mod.sync, mod)),
            mod.$category = mod.$('select[data-category="select"]'),
            mod.$group = mod.$('select[data-group="select"]'),
            mod.$category.on("change", $.proxy(mod.enableGroups, mod)),
            mod.$group.on("change", $.proxy(mod.loadTypePlates, mod)),
            resolve()
        },
        sync: function() {
            var mod;
            if (mod = this,
            !mod.isSynced)
                return mod.initPreselecting(),
                mod.isSynced = !0,
                T.Utils.allSynced = !0
        },
        getCurrentGroup: function() {
            var mod;
            return mod = this,
            mod.$group.filter("[data-category='" + mod.$category.val() + "']")
        },
        hideGroups: function() {
            var mod;
            return mod = this,
            mod.$group.prop("disabled", !0).closest(".m-forminput").addClass("hidden")
        },
        initPreselecting: function() {
            var category, group, mod;
            if (mod = this,
            category = mod.$ctx.data("preselect-category"),
            group = mod.$ctx.data("preselect-group"),
            category && mod.preselectFinder("category", category),
            group)
                return mod.preselectFinder("group", group)
        },
        preselectFinder: function(type, val) {
            var $element, mod;
            return mod = this,
            $element = "category" === type ? mod.$category : mod.getCurrentGroup(),
            $element.find("[value='" + val + "']").attr("selected", "selected").trigger("change")
        },
        showGroup: function($group) {
            var mod;
            return mod = this,
            mod.$(".typeplatefinder-groups .label-text").removeClass("disabled"),
            $group.prop("disabled", !1).removeClass("hidden"),
            $group.closest(".m-forminput").removeClass("hidden")
        },
        enableGroups: function() {
            var mod;
            return mod = this,
            mod.hideGroups(),
            mod.showGroup(mod.getCurrentGroup())
        },
        loadTypePlates: function() {
            var mod;
            return mod = this,
            T.Utils.startAjaxRequest(mod.$ctx.data("ajax-id"))
        }
    })
}(jQuery),
function($) {
    T.Module.Video = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$video = this.$("video"),
            this.$poster = this.$(".js-play-layer"),
            this.$posterBackground = this.$poster.children(".a-image"),
            this._events.on("openLayer", function(_this) {
                return function(data) {
                    return _this.onOpenLayer(data)
                }
            }(this)),
            this._events.on("closeLayer", function(_this) {
                return function(data) {
                    return _this.onCloseLayer(data)
                }
            }(this)),
            this._events.on("pageSliderSlideBeforeChange", function(_this) {
                return function(data) {
                    return _this.onSlideBeforeChange(data)
                }
            }(this)),
            this._events.on("pageSliderSlideAfterChange", function(_this) {
                return function(data) {
                    return _this.onSlideAfterChange(data)
                }
            }(this)),
            this._events.on("layerSliderSlideBeforeChange", function(_this) {
                return function(data) {
                    return _this.onSlideBeforeChange(data)
                }
            }(this)),
            this._events.on("layerSliderSlideAfterChange", function(_this) {
                return function(data) {
                    return _this.onSlideAfterChange(data)
                }
            }(this)),
            this._events.on("stageSliderSlideBeforeChange", function(_this) {
                return function(data) {
                    return _this.onStageSlideBeforeChange(data)
                }
            }(this)),
            this._events.on("stageSliderSlideAfterChange", function(_this) {
                return function(data) {
                    return _this.onSlideAfterChange(data)
                }
            }(this)),
            this._events.on("toggleVideoControls", function(_this) {
                return function(data) {
                    return _this.onToggleVideoControls(data)
                }
            }(this)),
            this.isInitialized = !1,
            this.videoIsPlaying = !1,
            this.videoIsPaused = !1,
            this.configAutoPlay = !1,
            this.initialAutoPlay = !1,
            this.slideIsPending = !1,
            this.initPoster(),
            this.initAutoplay(),
            this.setupVideo(),
            resolve()
        },
        sync: function() {},
        isVideoPaused: function() {
            return this.videoIsPaused
        },
        emitVideoLoaded: function() {
            return this._events.emit("video:loaded", {
                $component: this.$ctx
            })
        },
        beforePause: function() {
            if (this.videoIsPlaying && !this.$video.prop("seeking"))
                return this.videoIsPlaying = !1,
                this.videoIsPaused = !0,
                this._events.emit("videoStop", {
                    $ctx: this.$ctx
                })
        },
        beforePlay: function(triggerPlayerAction) {
            if (!this.videoIsPlaying && !this.slideIsPending)
                return this.hidePoster(!0),
                triggerPlayerAction && this.videoPlay(),
                this.videoIsPlaying = !0,
                this.videoIsPaused = !1,
                this._events.emit("videoPlaying", {
                    $ctx: this.$ctx
                })
        },
        beforeStop: function(triggerPlayerAction) {
            if (this.videoIsPlaying)
                return triggerPlayerAction && this.videoStop(),
                this.videoIsPlaying = !1,
                this.videoIsPaused = !1,
                this._events.emit("videoStop", {
                    $ctx: this.$ctx
                })
        },
        checkShouldAutoPlay: function() {
            var configAutoPlay, inPageMediaGalleryFirstSlide, notInMediaGallery, notInMediaGalleryLayer, notInSingleLayer;
            return configAutoPlay = this.$ctx.data("autoplay"),
            notInSingleLayer = !this.$ctx.closest(".js-video-layer").length,
            notInMediaGallery = !this.$ctx.closest(".js-media-gallery-slide").length,
            notInMediaGalleryLayer = !this.$ctx.closest(".js-mediagalleryproduct-slide").length,
            inPageMediaGalleryFirstSlide = this.$ctx.closest('.js-media-gallery-slide[data-slick-index="0"]').length,
            this.configAutoPlay = configAutoPlay,
            this.initialAutoPlay = configAutoPlay && notInSingleLayer && notInMediaGalleryLayer && (notInMediaGallery || inPageMediaGalleryFirstSlide)
        },
        initAutoplay: function() {
            if (this.checkShouldAutoPlay(),
            this.initialAutoPlay)
                return this.beforePlay(!0)
        },
        initPoster: function() {
            return this.$poster.on("click", function(_this) {
                return function() {
                    return _this.onClickPoster()
                }
            }(this))
        },
        initialize: function() {
            return this.$video.prop("controls") || this.$video.prop("controls", !0),
            "none" === this.$video.prop("preload") && this.$video.prop("preload", "metadata"),
            this.isInitialized = !0
        },
        showPoster: function(showBackground) {
            return this.$poster.removeClass("hidden"),
            this.showPosterBackground(showBackground)
        },
        showPosterBackground: function(showBackground) {
            return showBackground ? this.$posterBackground.removeClass("hidden") : this.$posterBackground.addClass("hidden")
        },
        hidePoster: function(showBackground) {
            return this.$poster.addClass("hidden"),
            this.showPosterBackground(showBackground)
        },
        setupVideo: function() {
            return this.$video.on("play", function(_this) {
                return function() {
                    return _this.beforePlay()
                }
            }(this)),
            this.$video.on("pause", function(_this) {
                return function() {
                    return _this.beforePause()
                }
            }(this)),
            this.$video.on("ended", function(_this) {
                return function() {
                    return _this.beforeStop()
                }
            }(this))
        },
        videoPlay: function() {
            if (this.$video.prop("controls") || this.$video.prop("controls", !0),
            this.$video.get(0))
                return this.$video.get(0).play()
        },
        videoStop: function() {
            if (this.$video.prop("controls") || this.$video.prop("controls", !0),
            this.$video.get(0))
                return this.$video.get(0).pause()
        },
        onClickPoster: function() {
            return this.beforePlay(!0)
        },
        onCloseLayer: function(data) {
            if (this.$ctx.closest(data.$ctx).length)
                return this.beforeStop(!0)
        },
        onOpenLayer: function(data) {
            var triggerElementLayerId;
            if (triggerElementLayerId = $(data.$triggerElement).data("layer-id"),
            this.$ctx.closest('.js-video-layer[data-id="' + triggerElementLayerId + '"]').length && (this.isInitialized || this.initialize(),
            this.configAutoPlay))
                return this.beforePlay(!0)
        },
        onStageSlideBeforeChange: function(data) {
            return data.stage.hideStageOverlay(),
            this.onSlideBeforeChange(data)
        },
        onSlideBeforeChange: function(data) {
            if (this.$ctx.closest(data.$slide).length && data.videoComponent)
                return this.beforeStop(!0),
                this.slideIsPending = !0
        },
        onSlideAfterChange: function(data) {
            if (this.$ctx.closest(data.$slide).length && data.videoComponent && (this.slideIsPending = !1,
            this.isInitialized || this.initialize(),
            this.configAutoPlay))
                return this.beforePlay(!0)
        },
        onToggleVideoControls: function(data) {
            if (this.$ctx.closest(data.$slide).length)
                return data.showControls ? this.$video.prop("controls", !0) : this.$video.prop("controls", !1)
        }
    })
}(jQuery),
function($) {
    T.Module.VoucherCode = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.elm = {
                $preventToggle: $(".js-prevent-toggle", mod.$ctx)
            },
            mod.elm.$preventToggle.on("click", $.proxy(this.onClickPreventToggle, this)),
            resolve()
        },
        sync: function() {},
        onClickPreventToggle: function(ev) {
            return ev.preventDefault()
        }
    })
}(jQuery),
function($) {
    T.Module.Charts = T.createModule({
        start: function(resolve) {
            var e, mod;
            mod = this,
            mod.$ctx = $(this._ctx),
            mod.$chartData = mod.$("[data-chart]");
            try {
                mod.data = mod.collectData(),
                mod.ratio = 16 / 9,
                mod.settings = T.Utils.charts,
                mod.canvas = new fabric.StaticCanvas(mod.$("canvas")[0],{
                    allowTouchScrolling: !0,
                    backgroundColor: this.settings.background
                })
            } catch (error) {
                e = error,
                console.error(e),
                mod.$ctx.addClass("canvas-failed")
            }
            return $(window).on("resize", T.Utils.debounce($.proxy(mod.onWindowResize, mod), 50)),
            mod.onWindowResize(),
            resolve()
        },
        collectData: function() {
            var result;
            return result = [],
            this.$chartData.find("li").each(function() {
                var $li, $value;
                if ($li = $(this),
                $value = $li.find("[data-value]"),
                !$value.length)
                    throw new Error("Missing value for element " + $li[0].outerHTML);
                return result.push({
                    label: $li.clone().children().remove().end().text(),
                    isHighlight: $li.is("[data-highlight]"),
                    value: $li.find("[data-value]").data("value")
                })
            }),
            result
        },
        getColor: function(obj) {
            return obj.isHighlight ? this.settings.highlightColor : this.settings.color
        },
        getLabel: function(obj) {
            return obj.label.trim()
        },
        getUnit: function() {
            return this.$chartData.data("unit")
        },
        getValueText: function(obj) {
            return obj.value + " " + this.getUnit()
        },
        resize: function() {},
        scaleRetina: function() {
            var canvas, h, w;
            return this.canvas.setDimensions({
                height: this.$ctx.width() / this.ratio,
                width: this.$ctx.width()
            }),
            canvas = this.canvas.getElement(),
            w = canvas.width,
            h = canvas.height,
            canvas.setAttribute("height", h * devicePixelRatio),
            canvas.setAttribute("width", w * devicePixelRatio),
            canvas.getContext("2d").scale(devicePixelRatio, devicePixelRatio),
            this.canvas.renderAll()
        },
        onWindowResize: function() {
            var width;
            return width = this.$ctx.width(),
            this.canvas.setDimensions({
                height: width / this.ratio,
                width: width
            }),
            this.resize()
        }
    })
}(jQuery),
function($) {
    T.Module.CompareAddItem = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.targetUrl = mod.$ctx.attr("data-href"),
            mod._events.on("compareitem:clickEmptyColumn", $.proxy(mod.onClickAddAnother, mod)),
            resolve()
        },
        sync: function() {},
        onClickAddAnother: function($target) {
            var mod, url;
            if (mod = this,
            mod.$ctx.is($target) && (url = mod.targetUrl))
                return window.location.href = url
        }
    })
}(jQuery),
function($) {
    T.Module.CartShopping = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.CheckoutDelivery = T.createModule({
        start: function(resolve) {
            return this.isSynced = !1,
            this.$ctx = $(this._ctx),
            this.loaderRemoved = !1,
            this.sync = $.proxy(this, "sync"),
            this.onClickIframeLayerTrigger = $.proxy(this, "onClickIframeLayerTrigger"),
            this.onTriggerCheckoutDeliveryDateChange = $.proxy(this, "onTriggerCheckoutDeliveryDateChange"),
            this._events.on("t.sync", this.sync),
            resolve()
        },
        sync: function(mod) {
            this.isSynced || (this.isSynced = !0,
            this.loaderRemoved || (this._events.emit("loader:close", {
                $loader: this.$(".js-loader-static")
            }),
            this.loaderRemoved = !0)),
            this.initDeliveryChange(),
            this.initDeliveryDate(),
            this.initDeliveryUPS()
        },
        initDeliveryChange: function() {
            return this.$triggerCheckoutDeliveryDateChange = this.$ctx.find(".js-checkout-deliverydate-change"),
            this.$triggerCheckoutDeliveryDateChange.on("change", this.onTriggerCheckoutDeliveryDateChange)
        },
        initDeliveryDate: function() {
            return this.$initDeliveryDateCheck = this.$ctx.find(".js-checkout-deliverydate-init"),
            this.$initDeliveryDateCheck.on("init", this.onTriggerCheckoutDeliveryDateChange),
            this.$initDeliveryDateCheck.trigger("init")
        },
        initDeliveryUPS: function() {
            var mod;
            if (mod = this,
            this.$form = this.$ctx.find(".js-ups-config"),
            this.$form.length)
                return this.iframeLayerConfiguration = this.$form.data("iframe-layer"),
                this.$iframeLayerTrigger = this.$ctx.find(".js-iframe-layer"),
                this.$iframeLayerTrigger.on("click", this.onClickIframeLayerTrigger)
        },
        onClickIframeLayerTrigger: function(obj) {
            var addParams, iframeUrl, inputName, inputValue, key, mod, paramrefs, requestParams, requestUrl;
            if (this.$ctx.find(".js-ups-radio").trigger("setCustomError", !1),
            mod = this,
            requestUrl = mod.iframeLayerConfiguration.url,
            addParams = mod.iframeLayerConfiguration.params || {},
            paramrefs = mod.iframeLayerConfiguration.paramrefs)
                for (key in paramrefs)
                    paramrefs.hasOwnProperty(key) && ("#" === paramrefs[key].charAt(0) ? inputValue = mod.$form.find(paramrefs[key]).val() : paramrefs[key].indexOf("<currenthost>") >= 0 ? inputValue = mod.getMockedUrl(paramrefs[key]) : (inputName = paramrefs[key].replace(/\./, "\\."),
                    inputValue = mod.$form.find("input[name=" + inputName + "]").val()),
                    inputValue && inputValue.length > 0 && (addParams[key] = inputValue));
            return requestParams = $.param(addParams),
            requestUrl && requestParams && (iframeUrl = requestUrl + (requestUrl.indexOf("?") > 0 ? "&" : "?") + requestParams,
            mod._events.emit("showIframeLayer", {
                url: iframeUrl
            })),
            !1
        },
        onTriggerCheckoutDeliveryDateChange: function(obj) {
            var $initiator, mod, request, requestId, targetIdForErrorReplace;
            return mod = this,
            $initiator = $(obj.currentTarget),
            requestId = $initiator.data("ajax-request-id"),
            targetIdForErrorReplace = $initiator.data("target"),
            request = T.Utils.startAjaxRequest(requestId),
            !!request && request[0].always(function() {}).done(function(result) {
                var eventDataDate, eventDataError;
                if (null != result)
                    return eventDataDate = {
                        dates: result.availableDates,
                        blockedDays: result.nonDeliveryDaysOfWeek
                    },
                    eventDataError = {
                        action: "ajaxerror",
                        $form: mod.$ctx
                    },
                    result.error ? ($.extend(eventDataDate, {
                        blockAll: !0
                    }),
                    $.extend(eventDataError, {
                        showAjaxError: !0
                    }),
                    mod.$ctx.find("[data-replace-origin=" + targetIdForErrorReplace + "]").text(result.error)) : ($.extend(eventDataDate, {
                        blockAll: !1
                    }),
                    $.extend(eventDataError, {
                        showAjaxError: !1
                    })),
                    mod._events.emit("forminput-datepicker:deliveryDate", eventDataDate),
                    mod._events.emit("form:trigger", eventDataError)
            }).fail(function(xhr, ajaxOptions, thrownError) {
                return console.info(xhr)
            })
        },
        getMockedUrl: function(url) {
            var currenthost, currenturl;
            return currenthost = location.href.indexOf("/templates/") >= 0 ? location.href.substr(0, location.href.indexOf("/templates/")) : location.protocol + "//" + location.host,
            currenturl = url.replace("<currenthost>", currenthost),
            currenturl.indexOf("_callbacksimulation_") > 0 && (currenturl = currenturl.substr(0, currenturl.indexOf("_callbacksimulation_") - 1)),
            location.href.indexOf("/templates/") >= 0 && (currenturl += ".html"),
            currenturl + (currenturl.indexOf("?") > 0 ? "&" : "?") + "_callbacksimulation_"
        }
    })
}(jQuery),
function($) {
    T.Module.CheckoutOrderSummary = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.CheckoutWelcome = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.CompareDetail = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.CookieLaw = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            this.$ctx = $(this._ctx),
            this.isLayerOpen = !1,
            this.$oneOptionForm = this.$(".js-oneoptioncookie"),
            this.$setCookiesForm = this.$(".js-setcookies"),
            this.$autoAcceptForm = this.$(".js-autoaccept"),
            this.$cookieLawLayer = this.$(".js-cookielaw-layer"),
            this.setCookiesFormSelector = ".js-setcookies",
            this.$acceptSettings = this.$(".js-accept-settings"),
            this.$accept = this.$(".js-accept"),
            this.$deny = this.$(".js-deny"),
            this.$acceptedValue = this.$(".js-accepted-value"),
            this.unloadChecked = !1,
            this.$ctx.on("submit", ".js-oneoptioncookie", $.proxy(this.onSubmitOneOptionForm, this)),
            this.$ctx.on("submit", this.setCookiesFormSelector, $.proxy(this.onSubmitSetCookiesForm, this)),
            this.$accept.on("click", $.proxy(this.onClickAccept, this)),
            this.$deny.on("click", $.proxy(this.onClickDeny, this)),
            this.$cookieLawLayer.on("click", $.proxy(this.onClickCookieLawLayer, this)),
            this.initAutoAccept(),
            this._events.on("t.sync", $.proxy(this.sync, this)),
            this._events.on("closeLayer", $.proxy(this.onCloseLayer, this)),
            this._events.on("openLayer", $.proxy(this.onOpenLayer, this)),
            resolve()
        },
        sync: function() {
            this.$oneOptionForm.addClass("is-active"),
            $(window).on("beforeunload", function(_this) {
                return function(ev) {
                    return _this.onBeforeUnload(ev)
                }
            }(this)),
            $(document).on("pagehide", function(_this) {
                return function(ev) {
                    return _this.onBeforeUnload(ev)
                }
            }(this)),
            $(document).on("unload", function(_this) {
                return function(ev) {
                    return _this.onBeforeUnload(ev)
                }
            }(this))
        },
        autoAccept: function() {
            var mod, request;
            return mod = this,
            request = T.Utils.startAjaxRequest(this.$autoAcceptForm.data("ajax-id")),
            !!request && request[0].done(function() {
                return mod.hide(!mod.isLayerOpen)
            })
        },
        clearAutoAccept: function() {
            return clearTimeout(this.autoAcceptTimeout)
        },
        hide: function(animate) {
            var mod;
            return mod = this,
            animate ? (Modernizr.csstransitions && this.$oneOptionForm.one("transitionend", function() {
                return mod.$ctx.remove()
            }),
            setTimeout(function() {
                return mod.$oneOptionForm.removeClass("is-active")
            }, 10)) : mod.$ctx.remove()
        },
        initAutoAccept: function() {
            var mod;
            if (mod = this,
            this.$autoAcceptForm.length)
                return this.autoAcceptTimeout = setTimeout(function() {
                    return mod.autoAccept()
                }, this.$autoAcceptForm.data("autoaccept-timeout"))
        },
        resetAutoAccept: function() {
            return this.clearAutoAccept(),
            this.initAutoAccept()
        },
        setAcceptedValue: function(val) {
            return this.$acceptedValue.val(val)
        },
        onClickAccept: function(ev) {
            return this.setAcceptedValue("true"),
            this.$oneOptionForm.submit()
        },
        onClickDeny: function(ev) {
            return this.setAcceptedValue("false"),
            this.$oneOptionForm.submit()
        },
        onClickCookieLawLayer: function(ev) {
            var mod, request, url;
            return mod = this,
            !(url = $(ev.currentTarget).data("ajax-url")) || (!(request = T.Utils.startAjaxRequest(!1, {
                url: url,
                dataType: "html",
                data: this.urlParamObject
            })) || (this.request = request[0],
            this.request.done(function(data) {
                return mod.layerContentInner = $(".cookielaw-layer .layer-content-inner"),
                $(mod.layerContentInner).html(data),
                mod._events.emit("loader:register", {
                    $ctx: $(mod.layerContentInner)
                })
            }).fail(function() {
                return console.info("error")
            })))
        },
        onCloseLayer: function(data) {
            if (this.$(data.$ctx).length)
                return this.isLayerOpen = !1,
                this.initAutoAccept()
        },
        onOpenLayer: function(data) {
            if (this.$(data.$ctx).length)
                return this.isLayerOpen = !0,
                this.clearAutoAccept()
        },
        onSubmitOneOptionForm: function(ev) {
            var mod, request;
            return mod = this,
            ev.preventDefault(),
            request = T.Utils.startAjaxRequest(this.$oneOptionForm.data("ajax-id")),
            !!request && request[0].done(function() {
                return mod.clearAutoAccept(),
                mod._events.emit("loader:close", {
                    $trigger: mod.$oneOptionForm
                }),
                mod.hide(!0)
            })
        },
        onSubmitSetCookiesForm: function(ev) {
            var $setCookiesForm, mod, request;
            return mod = this,
            ev.preventDefault(),
            $setCookiesForm = mod.$(mod.setCookiesFormSelector),
            request = T.Utils.startAjaxRequest($setCookiesForm.data("ajax-id")),
            !!request && request[0].done(function() {
                return mod.clearAutoAccept(),
                mod._events.emit("loader:close", {
                    $trigger: $setCookiesForm
                }),
                mod.hide(!1)
            })
        },
        onBeforeUnload: function(ev) {
            this.checkedUnload !== !0 && (this.checkedUnload = !0,
            this.$oneOptionForm.hasClass("is-active") && this.autoAccept())
        }
    })
}(jQuery),
function($) {
    T.Module.DealerLocator = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.DobAddress = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.data = mod.$ctx.data(),
            mod.jsCitySelector = ".js-city-selector",
            mod.jsStreetSelector = ".js-street-selector",
            mod.jsPostalCodeSelector = ".js-postalcode-selector",
            mod.jsToggleBox = ".js-togglebox-final-address",
            mod.jsRadioSelection = ".js-dobaddress-final-address",
            mod.jsRadioCorrectSelection = ".js-dobaddress-final-address-correct",
            mod.jsToggleBoxCheckedRadios = mod.jsToggleBox + " input[type='radio']:checked",
            mod.form = "form",
            mod.$cityInput = mod.$ctx.find(mod.jsCitySelector),
            mod.$streetInput = mod.$ctx.find(mod.jsStreetSelector),
            mod.$postalCodeInput = mod.$ctx.find(mod.jsPostalCodeSelector),
            mod.$form = mod.$ctx.find(mod.form),
            mod.$fieldSetToggleBox = mod.$ctx.find(mod.jsToggleBox),
            mod.$form.on("submit", $.proxy(mod.onSubmitForm, mod)),
            mod.$ctx.on("change", mod.jsRadioSelection, $.proxy(mod.onFinalAddressSelected, this)),
            resolve()
        },
        sync: function() {},
        disableAddressFields: function(disabled) {
            var mod;
            return mod = this,
            mod.$postalCodeInput.attr("disabled", disabled),
            mod.$cityInput.attr("disabled", disabled),
            mod.$streetInput.attr("disabled", disabled)
        },
        handleAjaxResult: function(result) {
            var mod;
            return mod = this,
            result.correctAddress && 1 === result.list.length ? mod.submitForm() : (mod.$ctx.find(mod.jsToggleBoxCheckedRadios).prop("checked", !1),
            mod._events.emit("openToggleBox", "final_address"),
            T.Utils.scrollToTop(mod.$fieldSetToggleBox.offset().top),
            this.$form.find('[type="submit"]').removeAttr("disabled")),
            mod.disableAddressFields(!0)
        },
        submitForm: function() {
            var mod;
            return mod = this,
            mod.$form.addClass("js-is-valid").trigger("submit", {
                dblClickCheck: !1
            })
        },
        onFinalAddressSelected: function(ev) {
            var mod, selectedValue, tokens;
            switch (mod = this,
            selectedValue = $(ev.currentTarget).val(),
            mod.disableAddressFields(!1),
            selectedValue) {
            case "correct":
                return mod.submitForm();
            case "change":
                return T.Utils.scrollToTop(mod.$postalCodeInput),
                mod._events.emit("closeToggleBox", "final_address");
            default:
                return tokens = selectedValue.split("*-*"),
                tokens.length >= 3 && (mod.$postalCodeInput.val(tokens[0]),
                mod.$cityInput.val(tokens[1]),
                mod.$streetInput.val(tokens[2])),
                mod._events.emit("closeToggleBox", "final_address"),
                T.Utils.scrollToTop(mod.$postalCodeInput)
            }
        },
        onSubmitForm: function(ev) {
            var data, mod, request;
            return mod = this,
            data = mod.data,
            !(!mod.$form.hasClass("js-is-valid") && !data.noajax) || (ev.preventDefault(),
            mod.$form.find('[type="submit"]').attr("disabled", "disabled"),
            !($.active > 0) && (request = T.Utils.startAjaxRequest(data.ajaxId, data.ajax, {
                zip: mod.$postalCodeInput.val(),
                city: mod.$cityInput.val(),
                street: mod.$streetInput.val()
            }),
            request[0].done($.proxy(mod.handleAjaxResult, mod)),
            !1))
        }
    })
}(jQuery),
function($) {
    var glob_config;
    glob_config = window.localization.configurations,
    T.Module.DobAppointment = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.isSynced = !1,
            T.Utils.allSynced = !1,
            this.sync = $.proxy(this, "sync"),
            this.getWorkingDays = $.proxy(this, "getWorkingDays"),
            this.handleResponseWorkingDays = $.proxy(this, "handleResponseWorkingDays"),
            this.initCalendar = $.proxy(this, "initCalendar"),
            this.updateTimeslots = $.proxy(this, "updateTimeslots"),
            this.onChangeAppointment = $.proxy(this, "onChangeAppointment"),
            this.onChangeTimeslot = $.proxy(this, "onChangeTimeslot"),
            this.$calendar = this.$(".js-appointment-calendar"),
            this.$timeslots = this.$(".js-timeslot"),
            this.$appointmentDay = this.$(".js-appointment-day"),
            this.$appointmentTime = this.$(".js-appointment-time"),
            this.$optionBook = this.$(".js-appointment-option-book"),
            this.$optionContact = this.$(".js-appointment-option-contact"),
            this._events.on("t.sync", this.sync),
            this.$optionBook.parent().toggleClass("hidden"),
            resolve()
        },
        sync: function() {
            if (!this.isSynced)
                return setTimeout(this.getWorkingDays(), 1),
                this.isSynced = !0,
                T.Utils.allSynced = !0
        },
        initCalendar: function(response) {
            var dateArray, dateMax, dateMin, disabledDays, m, mformat;
            for (dateArray = [],
            disabledDays = "",
            $.each(response.availableDates, function(i, el) {
                return dateArray.push(moment(el))
            }),
            dateMin = moment.min(dateArray),
            dateMax = moment.max(dateArray),
            m = moment(dateMin); m.diff(dateMax, "days"); )
                mformat = m.format("YYYY-MM-DD"),
                response.availableDates.indexOf(mformat) === -1 && (disabledDays += mformat + ","),
                m.add(1, "days");
            return this.$calendar.html(doT.template(this.$(".tpl-calendar").html())({
                dateMin: dateMin,
                dateMax: dateMax,
                defaultDate: dateMin,
                disabledDays: disabledDays,
                disableWeekends: ""
            })),
            this.$appointments = this.$calendar.find("input[data-t-name]"),
            this.$appointments.on("change", this.onChangeAppointment),
            this.$timeslots.on("change.timeslot", this.onChangeTimeslot),
            T.Utils.application._sandbox.addModules(this.$appointments[0])
        },
        getWorkingDays: function() {
            var request;
            return request = T.Utils.startAjaxRequest(this.$ctx.data("ajax-appointment")),
            !!request && request[0].done(this.handleResponseWorkingDays)
        },
        handleResponseWorkingDays: function(response) {
            var workdays;
            return workdays = response.availableDates || [],
            Boolean(workdays.length) || this.$optionContact.is(":checked") || this.$optionContact.click(),
            Boolean(workdays.length) && !this.$optionBook.is(":checked") && this.$optionBook.click(),
            this.$optionBook.parent().toggleClass("hidden", !Boolean(workdays.length)),
            this.initCalendar(response)
        },
        updateTimeslots: function(response) {
            return this.$timeslots.prop("disabled", !0),
            this.$timeslots.prop("checked", !1),
            this.$timeslots.each(function(i, el) {
                var $timeslot;
                if ($timeslot = $(el),
                response.indexOf($timeslot.val()) !== -1)
                    return $timeslot.prop("disabled", !1)
            }),
            this.$timeslots.filter(":enabled").first().prop("checked", !0).trigger("change.timeslot"),
            this.$appointmentDay.text(moment(this.$appointments.val()).format(glob_config.dateFormat.toUpperCase()))
        },
        onChangeAppointment: function(ev) {
            var request;
            return request = T.Utils.startAjaxRequest(this.$ctx.data("ajax-freeappointment"), {}, {
                date: $(ev.currentTarget).val()
            }),
            !!request && request[0].done(this.updateTimeslots)
        },
        onChangeTimeslot: function(ev) {
            return this.$appointmentTime.text($(ev.currentTarget).parent().find(".label-text").text()),
            this.$appointmentTime.show()
        }
    })
}(jQuery),
function($) {
    T.Module.DobAvailabilityResultList = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.sync = $.proxy(this.sync, this),
            this._events.on("t.sync", this.sync),
            console.log("DobAvailabilityResultList start"),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            console.log("DobAvailabilityResultList sync"))
        }
    })
}(jQuery),
function($) {
    T.Module.DobSummary = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.validateTermsSelector = ".js-validate-terms",
            mod.requiredSelector = ".js-required",
            mod.errorboxSelector = ".js-errorbox",
            mod.errorboxHiddenClass = "hidden",
            mod.$formWithTerms = mod.$ctx.find(mod.validateTermsSelector),
            mod.$required = mod.$formWithTerms.find(mod.requiredSelector),
            mod.$errorbox,
            mod.$formWithTerms.length && mod.$required.length && mod.setupTermsAcceptedValidation(),
            resolve()
        },
        sync: function() {},
        checkTermsAccepted: function() {
            var mod;
            return mod = this,
            !(!mod.$required.length || !mod.$required.is(":checked"))
        },
        setupTermsAcceptedValidation: function() {
            var mod;
            return mod = this,
            mod.$formWithTerms.on("submit", $.proxy(mod.onSubmitFormWithTerms, mod)),
            mod.$required.on("change", $.proxy(mod.onClickTermsAccepted, mod)),
            mod.$errorbox = mod.$formWithTerms.find(mod.errorboxSelector)
        },
        onClickTermsAccepted: function() {
            var mod;
            if (mod = this,
            mod.$errorbox.length)
                return mod.$errorbox.toggleClass(mod.errorboxHiddenClass, mod.checkTermsAccepted())
        },
        onSubmitFormWithTerms: function(ev) {
            var allowSubmit, mod;
            return mod = this,
            allowSubmit = mod.checkTermsAccepted(),
            allowSubmit ? (mod.$ctx.find('[type="submit"]').attr("disabled", "disabled"),
            mod.$errorbox.addClass(mod.errorboxHiddenClass),
            mod._events.emit("loader:open", {
                loaderType: "layer"
            }),
            !0) : (mod.$errorbox.removeClass(mod.errorboxHiddenClass),
            T.Utils.scrollToTop(mod.$errorbox),
            mod.$ctx.find('[type="submit"]').removeAttr("disabled"),
            !1)
        }
    })
}(jQuery),
function($) {
    T.Module.FirstAid = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.$categories = mod.$(".categories"),
            mod.$changeLink = mod.$(".js-change-link"),
            mod.$titles = mod.$(".titles"),
            mod.$solutions = mod.$(".solutions"),
            mod.request = {
                step1: "firstaid-solution",
                step1direct: "firstaid-direct-solution",
                step2: "firstaid-repair"
            },
            mod.isSynced = !1,
            mod._events.on("t.sync", $.proxy(mod.sync, mod)),
            mod.$categories.find("> li > a").on("click", $.proxy(mod.onClickCategoryDesktop, mod)),
            mod.$changeLink.on("click", $.proxy(mod.onClickChangeLinkDesktop, mod)),
            mod.$categories.find(".problems li > a").on("click", $.proxy(mod.onClickProblemDesktop, mod)),
            T.Utils.registerMq("md", {
                match: function() {
                    return mod.moveChangeLink(),
                    mod.$categories.find("> li > a").on("click.mobile", $.proxy(mod.onClickCategoryMobile, mod)),
                    mod.$categories.find(".problems li > a").on("click.mobile", $.proxy(mod.onClickProblemMobile, mod)),
                    mod.$ctx.addClass("mobile")
                },
                unmatch: function() {
                    return mod.$categories.find(".problems li > a").off("click.mobile"),
                    mod.$categories.find("> li > a").off("click.mobile"),
                    mod.moveChangeLink(),
                    mod.$ctx.removeClass("mobile")
                }
            }, "max"),
            resolve()
        },
        sync: function() {
            var mod;
            mod = this,
            mod.isSynced || (mod.$ctx.data("ajax-init") && mod.configureAjax(),
            mod.isSynced = !0)
        },
        generateProblemField: function(name, id, hasGroup, problemData, fallbackData) {
            var $hidden, val;
            return val = hasGroup ? problemData : fallbackData,
            $hidden = $('<input type="hidden" name="' + name + '" id="' + id + '" value="' + val + '">')
        },
        ajaxInit: function(data) {
            var $ajaxContainerStep1, $ajaxContainerStep2, $hiddenCodeStep2, $problemGroupToSelect, $problemToSelect, ajaxConfigObj, ajaxDataObj, hasAdvice, hasCode, hasDiagnosisCode, hasProblemGroupId, hasProblemId, mod, request, resultingProblemGroupId, resultingProblemId, strProblemgroupid, strProblemid;
            if (mod = this,
            "undefined" != typeof data) {
                if ($ajaxContainerStep1 = mod.$ctx.find("[data-ajax-id=" + mod.request.step1direct + "]"),
                $ajaxContainerStep2 = mod.$ctx.find("[data-ajax-id=" + mod.request.step2 + "]"),
                hasAdvice = "undefined" != typeof data.adviceid && data.adviceid.length > 0,
                hasCode = "undefined" != typeof data.code && data.code.length > 0,
                hasDiagnosisCode = "undefined" != typeof data.diagnosiscode && data.diagnosiscode.length > 0,
                hasProblemGroupId = "undefined" != typeof data.problemgroupid && data.problemgroupid.length > 0,
                hasProblemId = "undefined" != typeof data.problemid && data.problemid.length > 0,
                hasProblemGroupId ? (resultingProblemGroupId = data.problemgroupid,
                hasProblemId && (resultingProblemId = data.problemid)) : hasDiagnosisCode && (strProblemgroupid = mod.$ctx.attr("data-problemgroup-id"),
                strProblemid = mod.$ctx.attr("data-problem-id"),
                resultingProblemGroupId = strProblemgroupid,
                resultingProblemId = strProblemid),
                $problemGroupToSelect = mod.$ctx.find("[data-cat-id=" + resultingProblemGroupId + "]"),
                !$problemGroupToSelect.length)
                    return;
                return $problemToSelect = mod.$ctx.find("[data-problem-id=" + resultingProblemId + "]"),
                hasCode && $ajaxContainerStep2.length > 0 && ($hiddenCodeStep2 = $('<input type="hidden" name="code" value="' + data.code + '">'),
                $ajaxContainerStep2.append($hiddenCodeStep2)),
                ajaxConfigObj = null,
                ajaxDataObj = mod.setAjaxDataObj,
                request = T.Utils.startAjaxRequest(mod.request.step1direct, ajaxConfigObj, ajaxDataObj),
                !!request && request[0].always(function() {}).done(function(result) {
                    var $hiddenAdviceId, $hiddenCode, $hiddenDiagnosisCode, $hiddenProblemGroupID, $hiddenProblemId;
                    if ($hiddenAdviceId = hasAdvice ? $('<input type="hidden" name="adviceid" value="' + data.adviceid + '">') : null,
                    $hiddenCode = hasCode ? $('<input type="hidden" name="code" value="' + data.code + '">') : null,
                    $hiddenDiagnosisCode = hasDiagnosisCode ? $('<input type="hidden" name="diagnosiscode" value="' + data.diagnosiscode + '">') : null,
                    $hiddenProblemGroupID = mod.generateProblemField("problemgroupid", "problemGroupID", hasProblemGroupId, data.problemgroupid, strProblemgroupid),
                    $hiddenProblemId = mod.generateProblemField("problemid", "problemId", hasProblemId, data.problemid, strProblemid),
                    $ajaxContainerStep1.append($hiddenCode, $hiddenAdviceId, $hiddenDiagnosisCode, $hiddenProblemGroupID, $hiddenProblemId),
                    (hasProblemGroupId || hasDiagnosisCode) && (mod.$ctx.removeClass("two").addClass("one"),
                    $problemGroupToSelect.siblings(".problems").show(),
                    $problemGroupToSelect.parent("li").addClass("selected-category"),
                    $problemGroupToSelect.parent().siblings("li").hide(),
                    mod.$titles.find(".selectedcategory").text(": " + $problemGroupToSelect.find(".text").text()),
                    mod.$changeLink.show(),
                    hasProblemId || hasDiagnosisCode))
                        return mod.$titles.find(".selectedproblem").text(": " + $problemToSelect.find(".text").text()),
                        mod.$ctx.removeClass("one").addClass("two"),
                        mod.$categories.hide(),
                        mod.checkHeight(),
                        mod.$solutions.show(),
                        mod._events.emit("form:toggleFormActions", !1)
                }).fail(function(xhr, ajaxOptions, thrownError) {
                    return console.info(xhr)
                })
            }
        },
        setAjaxConfigObj: function(ajaxId) {
            var mod, originalAjaxRequestObj, originalAjaxRequestObjUrl, strippedAjaxRequestObjUrl;
            return mod = this,
            originalAjaxRequestObj = T.Utils.getAjaxRequestObj(ajaxId),
            originalAjaxRequestObjUrl = originalAjaxRequestObj.url,
            strippedAjaxRequestObjUrl = originalAjaxRequestObjUrl,
            {
                url: strippedAjaxRequestObjUrl
            }
        },
        setAjaxDataObj: function() {
            return {
                data: ""
            }
        },
        toggleProblems: function($selectedcategory) {
            var $category, $categoryLink;
            return this.$ctx.hasClass("one") ? ($selectedcategory.removeClass("selected-category"),
            $selectedcategory.siblings("li").show(),
            $selectedcategory.find(".problems").hide(),
            this.$changeLink.hide(),
            this.$ctx.removeClass("one")) : this.$ctx.hasClass("two") ? ($category = this.$categories.find(".selected-category"),
            $categoryLink = $category.find("[data-cat-id]").eq(0),
            this.$ctx.removeClass("two").addClass("one"),
            this.$categories.show(),
            this.showProblems($categoryLink),
            this.$solutions.hide()) : void 0
        },
        configureAjax: function() {
            var ajaxData, params, querystring;
            querystring = window.location.search.substring(1);
            try {
                params = JSON.parse('{"' + decodeURI(querystring).replace(/"/g, '\\"').replace(/&/g, '","').replace(/=/g, '":"') + '"}')
            } catch (undefined) {}
            if (ajaxData = params || {},
            !$.isEmptyObject(ajaxData))
                return this.ajaxInit(ajaxData)
        },
        moveChangeLink: function() {
            return this.$titles.find(this.$changeLink).length > 0 ? this.$categories.after(this.$changeLink) : this.$ctx.hasClass("two") ? this.$titles.find(".problem-title").after(this.$changeLink) : this.$titles.find(".category-title").after(this.$changeLink)
        },
        showProblems: function($categoryLink) {
            if (this.$ctx.find("#problemGroupID").val($categoryLink.attr("data-cat-id")),
            $categoryLink.hasClass("has-problems") & !$categoryLink.parent("li").hasClass("selected-category"))
                return this.$ctx.addClass("one"),
                $categoryLink.siblings(".problems").show(),
                $categoryLink.parent("li").addClass("selected-category"),
                $categoryLink.parent().siblings("li").hide(),
                this.$changeLink.show(),
                this.checkHeight()
        },
        showSolutions: function($problem) {
            var ajaxConfigObj, ajaxDataObj, mod, request;
            if (mod = this,
            $problem.data("problem-id"))
                return this.$ctx.removeClass("one").addClass("two"),
                this.$categories.hide(),
                this.$ctx.find("#problemId").val($problem.attr("data-problem-id")),
                ajaxConfigObj = mod.setAjaxConfigObj(mod.request.step1),
                ajaxDataObj = mod.setAjaxDataObj,
                request = T.Utils.startAjaxRequest(this.request.step1, ajaxConfigObj, ajaxDataObj),
                !!request && request[0].always(function() {}).done(function(result) {
                    return mod.$solutions.show(),
                    mod.checkHeight(),
                    mod._events.emit("form:toggleFormActions", !1)
                })
        },
        checkHeight: function() {
            var $selectedCategory, height1, height2, mod;
            return mod = this,
            $selectedCategory = mod.$ctx.find(".selected-category"),
            $selectedCategory.length > 0 && mod.$solutions.is(":hidden") ? (height2 = $selectedCategory.find(".problems").height(),
            height1 = mod.$ctx.find(".titles").outerHeight(!0),
            mod.$ctx.height(height1 + height2)) : (mod.$ctx.css("height", ""),
            $("body").scrollTop() > mod.$ctx.offset().top ? T.Utils.scrollToTop(mod.$ctx) : void 0)
        },
        onClickCategoryDesktop: function(ev) {
            var $categoryLink;
            return ev.preventDefault(),
            $categoryLink = $(ev.currentTarget),
            this.showProblems($categoryLink),
            this.$titles.find(".selectedcategory").text(": " + $categoryLink.find(".text").text())
        },
        onClickCategoryMobile: function(ev) {
            var $categoryLink;
            return ev.preventDefault(),
            $categoryLink = $(ev.currentTarget),
            this.$titles.find(".category-title").after(this.$changeLink),
            this.showProblems($categoryLink),
            this.$titles.find(".selectedcategory").text(": " + $categoryLink.find(".text").text());
        },
        onClickChangeLinkDesktop: function(ev) {
            var $category, mod;
            return mod = this,
            ev.preventDefault(),
            $category = mod.$changeLink.parents().find(".selected-category"),
            mod.toggleProblems($category),
            mod.checkHeight(),
            mod._events.emit("form:toggleFormActions", !0)
        },
        onClickProblemDesktop: function(ev) {
            var $problem;
            return ev.preventDefault(),
            $problem = $(ev.currentTarget),
            this.showSolutions($problem),
            this.$titles.find(".selectedproblem").text(": " + $problem.find(".text").text())
        },
        onClickProblemMobile: function(ev) {
            var $problem;
            return ev.preventDefault(),
            $problem = $(ev.currentTarget),
            this.$titles.find(".problem-title").after(this.$changeLink)
        }
    })
}(jQuery),
function($) {
    T.Module.Header = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$header = $(mod._ctx),
            mod.$navWrap = mod.$(".nav-wrap"),
            mod.$navMain = mod.$(".m-navmain"),
            mod.$navMeta = mod.$(".m-navmeta"),
            mod.$conversionBar = mod.$(".conversion-bar"),
            mod.$searchForm = mod.$(".search-form"),
            mod.$breadcrumb = mod.$(".m-breadcrumb"),
            mod.$breadcrumbWrap = mod.$(".breadcrumb-wrap"),
            mod.$headerContent = mod.$(".header-content"),
            mod.$headerElements = mod.$(".header-elements"),
            mod._events.on("headerOpen", $.proxy(mod.onHeaderOpen, mod)),
            mod._events.on("headerClose", $.proxy(mod.onHeaderClose, mod)),
            T.Utils.registerMq("md", {
                match: function() {
                    return mod.setupMobile()
                }
            }, "max"),
            "tablet" === T.Utils.getViewport() && mod.setupMobile(),
            T.Utils.registerMq("lg", {
                match: function() {
                    return mod.setupDesktop()
                },
                unmatch: function() {
                    return mod.setupMobile()
                }
            }),
            resolve()
        },
        sync: function() {},
        setupDesktop: function() {
            if (this.$navMeta.prependTo(this.$headerElements),
            this.$conversionBar.appendTo(this.$navWrap),
            this.$searchForm.prependTo(this.$navWrap),
            this.$breadcrumb.appendTo(this.$navWrap),
            "header2" === this.$header.data("header"))
                return this.$navWrap.appendTo(this.$headerContent)
        },
        setupMobile: function() {
            if (this.$navMain.after(this.$navMeta),
            this.$conversionBar.prependTo(this.$navWrap),
            this.$navMain.after(this.$searchForm),
            this.$breadcrumb.appendTo(this.$breadcrumbWrap),
            "header2" === this.$header.data("header"))
                return this.$navWrap.appendTo(this.$headerElements),
                this.$breadcrumbWrap.appendTo(this.$headerContent)
        },
        onHeaderOpen: function() {
            return this.$header.toggleClass("header-open")
        },
        onHeaderClose: function() {
            return this.$header.removeClass("header-open")
        }
    })
}(jQuery),
function($) {
    T.Module.HeaderShop = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.Layout = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.state = {
                contentToggleHidden: "hidden"
            },
            T.Utils.allSynced = !1,
            mod.isSynced = !1,
            mod._events.on("t.sync", $.proxy(mod.sync, mod)),
            mod.initContentToggle(),
            mod.$("[data-promotion-trigger-id]").on("click", $.proxy(mod.onPromotionTriggerClick, mod)),
            mod._events.on("dom:replacement", $.proxy(mod.onAddDomContent, mod)),
            mod._events.on("togglePageScrolling", $.proxy(mod.onToggleScrolling, mod)),
            mod._events.on("utils:storageUpdateSkuCompare", $.proxy(mod.onStorageUpdateSkuCompare, mod)),
            resolve()
        },
        sync: function() {
            var mod;
            mod = this,
            mod.setContentTextMediaAlignment(),
            mod.isSynced || (mod.isSynced = !0,
            T.Utils.modulesSynced())
        },
        filterAndHideDeselectedContentToggles: function($selectedContentToggle) {
            var $toHide, mod;
            return mod = this,
            $toHide = mod.$(mod.selector.contentToggle.allTargets).filter(function() {
                return !$(this).is($selectedContentToggle)
            }).addClass(mod.state.contentToggleHidden),
            mod.toggleValidationOnContentToggles($toHide)
        },
        toggleValidationOnContentToggles: function($content) {
            var disable, mod;
            return mod = this,
            disable = $content.hasClass(mod.state.contentToggleHidden),
            $content.find("fieldset").each(function() {
                return $(this).prop("disabled", disable)
            })
        },
        initContentToggle: function() {
            var mod;
            return mod = this,
            mod.selector = {
                contentToggle: {
                    allTargets: "[data-content-id]",
                    toggle: "[data-content-toggle]",
                    trigger: "[data-content-toggle-trigger]"
                }
            },
            mod.$ctx.on("change", $.proxy(mod.onChangeContentToggleTrigger, mod)),
            mod.$ctx.on("change", mod.selector.contentToggle.trigger, $.proxy(mod.onChangeContentToggleTrigger, mod)),
            mod.$ctx.on("change", mod.selector.contentToggle.toggle, $.proxy(mod.onContentToggle, mod)),
            mod.triggerContentToggle()
        },
        setContentTextMediaAlignment: function() {
            var $containers;
            if ($containers = $(".contenttextmedia-align-start-right, .contenttextmedia-align-start-left"),
            $containers.each(function(_this) {
                return function(index, element) {
                    var $container, $updateContainers, alignRight;
                    return $container = $(element),
                    alignRight = $container.hasClass("contenttextmedia-align-start-right"),
                    $updateContainers = $container.find(".m-contenttextmedia:has(.media):not(.m-contenttextmediaslider .m-contenttextmedia), .m-contenttextmediaslider:has(.m-contenttextmedia .media)"),
                    $updateContainers.each(function(index, updateElement) {
                        var modId;
                        modId = $(updateElement).data("t-id"),
                        _this._sandbox.getModuleById(modId).setAlign(alignRight ? "right" : "left"),
                        alignRight = !alignRight
                    })
                }
            }(this)),
            0 === $containers.length)
                return this._events.emit("contentextmedia:reset-align", {})
        },
        triggerContentToggle: function() {
            var mod;
            return mod = this,
            mod.$(mod.selector.contentToggle.toggle).trigger("change"),
            mod.$(mod.selector.contentToggle.trigger).trigger("change"),
            !0
        },
        onAddDomContent: function(data) {
            var mod;
            return mod = this,
            mod.triggerContentToggle(),
            !0
        },
        onContentToggle: function(ev) {
            var $contentToggleElement, $targetElm, contentToggle, mod;
            if (mod = this,
            $contentToggleElement = $(ev.target),
            !$contentToggleElement.is("[type=hidden]") && (contentToggle = $contentToggleElement.data("content-toggle"),
            null != contentToggle)) {
                switch (contentToggle) {
                case ":selected":
                    $targetElm = this.$('[data-content-id="' + $contentToggleElement.find("option:selected").data("content-toggle-id") + '"]');
                    break;
                case ":checked":
                    $targetElm = this.$('[data-content-id="' + $contentToggleElement.data("content-toggle-id") + '"]')
                }
                if ($contentToggleElement.is("select")) {
                    if ($contentToggleElement.val())
                        return $targetElm.removeClass("hidden"),
                        this.filterAndHideDeselectedContentToggles($targetElm)
                } else if ($contentToggleElement.is(":checked, :selected"))
                    return $targetElm.removeClass(mod.state.contentToggleHidden),
                    $targetElm.is(".js-toggle-validate") && mod.toggleValidationOnContentToggles($targetElm),
                    mod.filterAndHideDeselectedContentToggles($targetElm)
            }
        },
        onChangeContentToggleTrigger: function(ev) {
            var $toggleTriggerElements, mod;
            return mod = this,
            $toggleTriggerElements = $(mod.selector.contentToggle.trigger + ":not([type=hidden])"),
            $toggleTriggerElements.each(function() {
                var dataContentToggleTrigger, selected;
                if (("radio" === this.type || "checkbox" === this.type) && (selected = this.checked,
                dataContentToggleTrigger = $(this).data("content-toggle-trigger"),
                void 0 !== dataContentToggleTrigger && (mod.$toggleContainerElm = $('[data-content-toggle-container="' + dataContentToggleTrigger + '"]'),
                selected || mod.$toggleContainerElm.addClass(mod.state.contentToggleHidden),
                selected)))
                    return mod.$toggleContainerElm.removeClass(mod.state.contentToggleHidden)
            })
        },
        onPromotionTriggerClick: function(ev) {
            var $target, mod, triggerId;
            return mod = this,
            triggerId = $(ev.currentTarget).data("promotion-trigger-id"),
            $target = mod.$("[data-promotion-target-id='" + triggerId + "']"),
            $target.length && T.Utils.scrollToTop($target, function() {
                return mod._events.emit("openMoreLessLink", {
                    parentId: $target.data("t-id")
                })
            }),
            ev.preventDefault()
        },
        onStorageUpdateSkuCompare: function(data) {
            var eventData, mod;
            if (mod = this,
            null != data)
                return eventData = data,
                mod._events.emit("layout:storageUpdated", eventData)
        },
        onToggleScrolling: function(data) {
            var mod;
            return mod = this,
            data.pin ? mod.$ctx.addClass("pinned") : mod.$ctx.removeClass("pinned")
        }
    })
}(jQuery),
function($) {
    T.Module.List = T.createModule({
        start: function(resolve) {
            var config;
            return this.getViewTypeFromCtx = $.proxy(this.getViewTypeFromCtx, this),
            this.handleLoadMoreState = $.proxy(this.handleLoadMoreState, this),
            this.requestMoreItems = $.proxy(this.requestMoreItems, this),
            this.renderMoreItems = $.proxy(this.renderMoreItems, this),
            this.showInitialItems = $.proxy(this.showInitialItems, this),
            this.showMoreItems = $.proxy(this.showMoreItems, this),
            this.toggleListViewType = $.proxy(this.toggleListViewType, this),
            this.updateInitialListViewType = $.proxy(this.updateInitialListViewType, this),
            this.onLoadMore = $.proxy(this.onLoadMore, this),
            this.onInitializeLoadMore = $.proxy(this.onInitializeLoadMore, this),
            this.onToggleGridView = $.proxy(this.onToggleGridView, this),
            this.onToggleListView = $.proxy(this.onToggleListView, this),
            this.onModifyGridView = $.proxy(this.onModifyGridView, this),
            this.sync = $.proxy(this.sync, this),
            this.isSynced = !1,
            this.$ctx = $(this._ctx),
            this.$list = this.$ctx.find(".js-list-layout"),
            this.hasProductSets = this.$ctx.hasClass("js-has-productsets"),
            this.$ctx.data("ecr-active") && T.Utils.loadEcrScript(this.$ctx.data("ecr-url")),
            this._events.on("toggleGridView", this.onToggleGridView),
            this._events.on("toggleListView", this.onToggleListView),
            this._events.on("modifyGridView", this.onModifyGridView),
            this._events.on("initializeLoadMore", this.onInitializeLoadMore),
            this._events.on("loadMore", this.onLoadMore),
            this._events.on("t.sync", this.sync),
            config = T.Utils.list,
            this.currentPageSize = 0,
            this.listId = this.$ctx.data("list-id"),
            this.staticViewType = "grid-view",
            this.currentViewType,
            this.hasDynamicViewType = !1,
            this.currentViewTypeLarge = "",
            this.hasViewTypeToggle = this.$ctx.data("has-view-type-toggle"),
            this.equalHeightActive = !1,
            this.$matchedElements = [],
            this.itemsPerRow = {
                mobile: config.itemPerRow,
                tablet: config.itemPerRowMd,
                desktop: config.itemPerRowLg
            },
            this.currentItemsPerRow = 0,
            this.allItems = [],
            this.initializeListViewType(),
            this._events.on("viewportChanged", function(_this) {
                return function(viewport) {
                    return _this.onViewportChange(viewport)
                }
            }(this)),
            this.onViewportChange(T.Utils.getViewport()),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.updateInitialListViewType(),
            this.isSynced = !0)
        },
        equalizeHeights: function(enableEqualHeights) {
            var $items, $itemsToApplyEqualHeight, $itemsWithEqualHeight, mod, tempArray;
            if (mod = this,
            $items = mod.findListItems(),
            $itemsWithEqualHeight = $items.filter(".has-equal-height"),
            $items.length > 0)
                return enableEqualHeights ? (this.equalHeightActive = !0,
                $itemsToApplyEqualHeight = $itemsWithEqualHeight.length > 0 ? $items.slice($itemsWithEqualHeight.length - $itemsWithEqualHeight.length % mod.itemsPerRow, $items.length) : $items,
                tempArray = mod.createItemHeightMatchingGroups($itemsToApplyEqualHeight),
                setTimeout(function() {
                    return $.each(tempArray, function(index, itemGroup) {
                        return $(itemGroup).matchHeight({
                            byRow: !0,
                            property: "height",
                            target: null,
                            remove: !1
                        })
                    })
                }),
                mod.$matchedElements.concat(tempArray),
                mod.$matchedElements.push($itemsToApplyEqualHeight)) : (null != mod.$matchedElements && mod.$matchedElements.length > 0 && $.each(mod.$matchedElements, function(index, itemGroup) {
                    return $(itemGroup).matchHeight({
                        remove: !0
                    })
                }),
                mod.findListItems().removeClass("has-equal-height"),
                this.equalHeightActive = !1)
        },
        findListItems: function() {
            return this.$ctx.find(".js-product-teaser")
        },
        createItemHeightMatchingGroups: function($itemsToApplyEqualHeight) {
            var $buttonGroup, $conversionWrapper, $priceWrapper, $productDetail, $productInfo, $productTextWrapper, $stockInfo;
            return $productDetail = $itemsToApplyEqualHeight.find(".js-detail-wrapper"),
            $productInfo = $itemsToApplyEqualHeight.find(".js-product-info-wrapper"),
            $productTextWrapper = $itemsToApplyEqualHeight.find(".js-product-text-wrapper"),
            $conversionWrapper = $itemsToApplyEqualHeight.find(".js-conversion-wrapper"),
            $priceWrapper = $itemsToApplyEqualHeight.find(".js-price-wrapper"),
            $stockInfo = $itemsToApplyEqualHeight.find(".js-stock-info-wrapper"),
            $buttonGroup = $itemsToApplyEqualHeight.find(".js-button-group-wrapper"),
            [$productDetail, $productInfo, $productTextWrapper, $conversionWrapper, $priceWrapper, $stockInfo, $buttonGroup]
        },
        handleLoadMoreState: function(loadMoreState) {
            return this.equalHeightActive && this.equalizeHeights(!0),
            this.currentPageSize = loadMoreState.currentPageSize,
            this._events.emit("loadMoreCallback", {
                listId: this.listId,
                currentPageSize: loadMoreState.currentPageSize,
                hideLoadMoreButton: loadMoreState.allElementsVisible
            })
        },
        initializeListViewType: function() {
            return this.getViewTypeFromCtx(),
            this.toggleListViewType(this.staticViewType)
        },
        getViewTypeFromCtx: function() {
            if (this.$ctx.hasClass("list-view") && (this.staticViewType = "list-view"),
            this.currentViewType = this.staticViewType,
            null != this.hasViewTypeToggle && this.hasViewTypeToggle)
                return this.hasDynamicViewType = !0,
                this.currentViewTypeLarge = this.staticViewType
        },
        requestMoreItems: function(requestData) {
            var handleFail, handleSuccess, loadMoreState;
            return loadMoreState = {},
            loadMoreState = {
                allElementsVisible: !1
            },
            handleSuccess = function(a) {
                var current, list, max;
                return a && (list = a.response),
                list && list.items ? (current = parseInt(list.pageNumber),
                max = parseInt(list.maxPageNumber),
                loadMoreState.allElementsVisible = current >= max,
                this.handleLoadMoreState(loadMoreState)) : (console.error("No items found in JSON"),
                !1)
            }
            ,
            handleFail = function() {
                return loadMoreState.allElementsVisible = !0,
                this.handleLoadMoreState(loadMoreState)
            }
            ,
            requestData.done($.proxy(handleSuccess, this)).fail($.proxy(handleFail, this))
        },
        renderMoreItems: function(data) {
            var $template, allElementsVisible, allItems, itemsToRender, loadMoreState, newCurrentPageSize, result;
            return allElementsVisible = !1,
            loadMoreState = {},
            itemsToRender = [],
            allItems = data.jsonData[data.jsonAttrKey],
            newCurrentPageSize = data.currentPageSize + data.loadMorePageSize,
            0 === data.currentPageSize ? (data.renderAllItems && $.each(allItems, function(index, item) {
                if (index >= data.loadMorePageSize)
                    return item.isHidden = !0
            }),
            this.allItems = allItems,
            itemsToRender = 0 === data.loadMorePageSize || data.renderAllItems ? allItems : allItems.slice(data.currentPageSize, newCurrentPageSize)) : itemsToRender = allItems.slice(data.currentPageSize, newCurrentPageSize),
            result = {},
            result[data.jsonAttrKey] = itemsToRender,
            null != data.urlParams && $.each(data.urlParams, function(key, value) {
                return result[key] = value
            }),
            $template = $("<div/>").html(T.Utils.renderTemplateMarkup(data.request, result, !1)),
            T.Utils.syncContent($template, data.replaceContainerId, data.contentRenderType),
            newCurrentPageSize >= data.jsonData[data.jsonAttrKey].length && (allElementsVisible = !0),
            loadMoreState.currentPageSize = newCurrentPageSize,
            loadMoreState.allElementsVisible = allElementsVisible,
            loadMoreState
        },
        showInitialItems: function(initialPageSize) {
            var $listItems, currentPageSize, hiddenElements, i, j, loadMoreState, ref;
            if ($listItems = this.$ctx.find(".js-item"),
            currentPageSize = $listItems.length,
            hiddenElements = currentPageSize > initialPageSize,
            loadMoreState = {},
            loadMoreState.allElementsVisible = !hiddenElements,
            !isNaN(initialPageSize))
                for (i = j = 0,
                ref = initialPageSize - 1; 0 <= ref ? j <= ref : j >= ref; i = 0 <= ref ? ++j : --j)
                    $($listItems[i]).removeClass("hidden");
            return this._events.emit("updateItemCount", {
                listId: this.listId,
                itemCount: currentPageSize
            }),
            loadMoreState
        },
        showMoreItems: function(currentPageSize, loadMorePageSize, hiddenClass, hiddenSelector, visibleClass) {
            var $hiddenItems, allElementsVisible, i, j, k, loadMoreState, newCurrentPageSize, ref, ref1;
            if ($hiddenItems = this.$ctx.find(".js-item." + hiddenSelector),
            allElementsVisible = !1,
            loadMoreState = {},
            newCurrentPageSize = currentPageSize + loadMorePageSize,
            0 === loadMorePageSize)
                for (i = j = 0,
                ref = $hiddenItems.length - 1; 0 <= ref ? j <= ref : j >= ref; i = 0 <= ref ? ++j : --j)
                    $($hiddenItems[i]).removeClass(hiddenClass),
                    null != visibleClass && "" !== visibleClass && $($hiddenItems[i]).addClass(visibleClass);
            else
                for (i = k = 0,
                ref1 = loadMorePageSize - 1; 0 <= ref1 ? k <= ref1 : k >= ref1; i = 0 <= ref1 ? ++k : --k)
                    $($hiddenItems[i]).removeClass(hiddenClass),
                    null != visibleClass && "" !== visibleClass && $($hiddenItems[i]).addClass(visibleClass);
            return 0 === this.$ctx.find(".js-item." + hiddenSelector).length && (allElementsVisible = !0),
            loadMoreState.currentPageSize = newCurrentPageSize,
            loadMoreState.allElementsVisible = allElementsVisible,
            loadMoreState
        },
        toggleListViewType: function(newViewType) {
            return "grid-view" === newViewType ? (this.$ctx.addClass("grid-view"),
            this.$ctx.removeClass("list-view")) : (this.$ctx.addClass("list-view"),
            this.$ctx.removeClass("grid-view"))
        },
        updateInitialListViewType: function() {
            return this._events.emit("onGridListInit", {
                listId: this.listId,
                viewType: this.currentViewType
            })
        },
        onLoadMore: function(data) {
            var loadMoreState;
            if (this.listId === data.listId) {
                switch (loadMoreState = {},
                data.loadMoreType) {
                case "dom":
                    loadMoreState = this.showMoreItems(data.currentPageSize, data.loadMorePageSize, "hidden", "hidden", "");
                    break;
                case "data":
                    loadMoreState = data.currentPageSize > 0 && data.renderAllItems ? this.showMoreItems(data.currentPageSize, data.loadMorePageSize, "load-more-hidden", "load-more-hidden:not(.filter-hidden)", "load-more-visible") : this.renderMoreItems(data);
                    break;
                case "ajax":
                    return void (loadMoreState = this.requestMoreItems(data.requestData))
                }
                return this.equalizeHeights(!0),
                this.handleLoadMoreState(loadMoreState)
            }
        },
        onInitializeLoadMore: function(data) {
            var $initdata, current, initdata, list, loadMoreState, max;
            if (this.listId === data.listId)
                switch (data.loadMoreType) {
                case "dom":
                    return this.handleLoadMoreState(this.showInitialItems(data.initialPageSize));
                case "ajax":
                    return $initdata = this.$ctx.find("[data-init-data]").eq(0),
                    $initdata.length && (initdata = JSON.parse($initdata.text())),
                    !(!initdata || !initdata.response) && (loadMoreState = {},
                    list = initdata.response,
                    current = parseInt(list.pageNumber),
                    max = parseInt(list.maxPageNumber),
                    loadMoreState.allElementsVisible = current === max,
                    this.handleLoadMoreState(loadMoreState))
                }
        },
        onModifyGridView: function() {
            if (this.$ctx.hasClass(this.hasProductSets))
                return this.$ctx.addClass("grid-view-skip-md")
        },
        onToggleGridView: function(data) {
            if (this.listId === data.listId)
                return this.$list = data.$currentList || this.$list,
                this.currentViewTypeLarge = "grid-view",
                this.currentViewType = "grid-view",
                this.toggleListViewType("grid-view"),
                this.equalizeHeights(!0)
        },
        onToggleListView: function(data) {
            if (this.listId === data.listId)
                return this.$list = data.$currentList || this.$list,
                this.currentViewTypeLarge = "list-view",
                this.currentViewType = "list-view",
                this.toggleListViewType("list-view"),
                this.equalizeHeights(!1)
        },
        onViewportChange: function(viewport) {
            var newListViewType;
            if (newListViewType = "grid-view",
            this.hasDynamicViewType ? "desktop" === viewport && (newListViewType = "list-view" === this.currentViewTypeLarge ? "list-view" : "grid-view") : newListViewType = "list-view" === this.staticViewType ? "list-view" : "grid-view",
            this.currentItemsPerRow = this.itemsPerRow[viewport],
            newListViewType !== this.currentViewType && (this.currentViewType = newListViewType,
            this.toggleListViewType(newListViewType)),
            "mobile" === viewport) {
                if (this.equalHeightActive)
                    return this.equalizeHeights(!1)
            } else if ("grid-view" === newListViewType)
                return this.equalizeHeights(!0)
        }
    })
}(jQuery),
function($) {
    T.Module.MyProducts = T.createModule({
        start: function(resolve) {
            var mod;
            return this.$ctx = $(this._ctx),
            mod = this,
            this.onSubmitDeleteProductForm = $.proxy(this.onSubmitDeleteProductForm, this),
            this.class = {
                ajaxform: ".js-delete-product-form",
                submit: ".js-submit-delete-product"
            },
            this.$deleteProductForm = this.$(mod.class.ajaxform),
            this.$deleteProductForm.on("submit", this.onSubmitDeleteProductForm),
            resolve()
        },
        sync: function() {},
        onSubmitDeleteProductForm: function(ev) {
            var $form, ajaxConf, ajaxId, mod, request;
            return mod = this,
            ev.preventDefault(),
            $form = $(ev.currentTarget),
            ajaxId = $form.data("ajax-id"),
            ajaxConf = $form.data("ajax"),
            request = T.Utils.startAjaxRequest(ajaxId),
            !!request && request[0].then(function(response) {
                var hasError;
                if (hasError = T.Utils.ajaxResponseErrorCaseCheck(ajaxConf.errorCase, response))
                    return mod._events.emit("loader:close", {
                        $trigger: $(mod.class.submit, $form)
                    })
            })
        }
    })
}(jQuery),
function($) {
    T.Module.MyProfileForms = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.deleteAddressFormSelector = ".js-delete-address-form",
            this.submitDeleteAddressSelector = ".js-submit-delete-address",
            this.deleteAccountFormSelector = ".js-delete-account-form",
            this.submitDeleteAccountSelector = ".js-submit-delete-account",
            this.sync = $.proxy(this.sync, this),
            this.$deleteAddressForm = this.$(this.deleteAddressFormSelector),
            this.$deleteAddressForm.on("submit", $.proxy(this.onSubmitDeleteAddressForm, this)),
            this.$deleteAccountForm = this.$(this.deleteAccountFormSelector),
            this.deleteAccountAjaxConfig = this.$deleteAccountForm.data("ajax"),
            this.deleteAccountAjaxId = this.$deleteAccountForm.data("ajax-id"),
            this.$deleteAccountForm.on("submit", $.proxy(this.onSubmitDeleteAccountForm, this)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            T.Utils.allSynced = !0)
        },
        onSubmitDeleteAccountForm: function(ev) {
            var mod, request;
            return mod = this,
            ev.preventDefault(),
            request = T.Utils.startAjaxRequest(this.deleteAccountAjaxId, this.deleteAccountAjaxConfig),
            !!request && request[0].then(function(response) {
                var hasError;
                if (hasError = T.Utils.ajaxResponseErrorCaseCheck(mod.deleteAccountAjaxConfig.errorCase, response))
                    return mod._events.emit("loader:close", {
                        $trigger: mod.$deleteAccountForm.find(mod.submitDeleteAccountSelector)
                    })
            })
        },
        onSubmitDeleteAddressForm: function(ev) {
            var $form, mod, request;
            return mod = this,
            ev.preventDefault(),
            $form = $(ev.currentTarget),
            mod.deleteAddressAjaxConfig = $form.data("ajax"),
            mod.deleteAddressAjaxId = $form.data("ajax-id"),
            request = T.Utils.startAjaxRequest(mod.deleteAddressAjaxId, mod.deleteAddressAjaxConfig),
            !!request && request[0].then(function(response) {
                var hasError;
                if (hasError = T.Utils.ajaxResponseErrorCaseCheck(mod.deleteAddressAjaxConfig.errorCase, response))
                    return mod._events.emit("loader:close", {
                        $trigger: mod.$deleteAddressForm.find(mod.submitDeleteAddressSelector)
                    })
            })
        }
    })
}(jQuery),
function($) {
    T.Module.OnlineDealerLayer = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.OrderPurchaseDetail = T.createModule({
        start: function(resolve) {
            return resolve()
        },
        sync: function() {}
    })
}(jQuery),
function($) {
    T.Module.ProductDetail = T.createModule({
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(mod._ctx),
            mod.$ctx.data("ecr-active") && T.Utils.loadEcrScript(mod.$ctx.data("ecr-url")),
            T.Utils.addSkusToEcr(mod.$ctx.data("sku")),
            resolve()
        }
    })
}(jQuery),
function($) {
    T.Module.Raw = T.createModule({
        start: function(resolve) {
            return this.$ctx = $(this._ctx),
            this.$style = this.$("style"),
            this.$script = this.$("script"),
            this.id = this.$ctx.data("t-id"),
            this.idClass = "o-raw-" + this.id,
            this.$ctx.addClass(this.idClass),
            this.$style.length && this.$style.html(this.$style.html().replace(/\s*([^@} ]+)\s*{/g, "\n." + this.idClass + " $1 {")).attr("type", "text/css").appendTo(this.$ctx),
            this.$script.length && (this.$script.appendTo("body").attr("type", "text/javascript"),
            eval(this.$script.html())),
            resolve()
        }
    })
}(jQuery),
function($) {
    T.Module.ServiceTeaserArea = T.createModule({
        start: function(resolve) {
            return $(window).on("resize", function(_this) {
                return function() {
                    return T.Utils.debounce(_this.matchTeaserHeights, 50)
                }
            }(this)),
            this.$ctx = $(this._ctx),
            this.isSynced = !1,
            T.Utils.allSynced = !1,
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            this._events.on("image:loaded", function(_this) {
                return function(data) {
                    return _this.onImageLoaded(data)
                }
            }(this)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            T.Utils.allSynced = !0,
            this.matchTeaserHeights())
        },
        matchTeaserHeights: function() {
            var serviceTeaserLength;
            return T.Utils.debounce(this.$("> .m-serviceteaser").matchHeight(), 50),
            T.Utils.isViewport("desktop") ? (T.Utils.debounce(this.$("> .m-serviceteaser .a-heading").matchHeight(), 50),
            T.Utils.debounce(this.$("> .m-serviceteaser .content-inner").matchHeight(), 50)) : T.Utils.isViewport("tablet") && (serviceTeaserLength = this.$("> .m-serviceteaser").length,
            2 === serviceTeaserLength || 4 === serviceTeaserLength) ? (T.Utils.debounce(this.$("> .m-serviceteaser .a-heading").matchHeight(), 50),
            T.Utils.debounce(this.$("> .m-serviceteaser .content-inner").matchHeight(), 50)) : void 0
        },
        onImageLoaded: function(data) {
            if (data.$currentTarget.closest(this.$ctx).length > 0)
                return this.matchTeaserHeights()
        }
    })
}(jQuery),
function($) {
    T.Module.TeaserContainer = T.createModule({
        start: function(resolve) {
            return this.parseTeaserConfig(),
            this.calculate(),
            this.setClasses(),
            $(window).on("resize", T.Utils.debounce($.proxy(this.onResize, this), 50)),
            this.$("img").on("load", $.proxy(this.onLoadTeaserImage, this)),
            this.initTeaser(),
            resolve()
        },
        sync: function() {},
        calculate: function() {
            var amountOfTeasers, checkFlag, configIndex, i, k, lastRule, minSum, prevRule, ref, restAmount, results;
            for (this.$teasers = this.$("> .m-teaser"),
            this.teaserRows = [],
            amountOfTeasers = this.$teasers.length,
            restAmount = amountOfTeasers,
            configIndex = this.rules.length - 1,
            results = []; restAmount > 0 && configIndex >= 0; )
                if (lastRule = this.rules[configIndex],
                prevRule = this.rules[configIndex - 1],
                minSum = 0,
                checkFlag = !1,
                lastRule.flex) {
                    for (i = k = ref = configIndex; ref <= 0 ? k <= 0 : k >= 0; i = ref <= 0 ? ++k : --k)
                        minSum += this.rules[i].amount;
                    for (checkFlag = restAmount % lastRule.amount === 0; restAmount >= minSum || checkFlag && restAmount > 0; )
                        this.teaserRows.splice(0, 0, lastRule.class),
                        restAmount -= lastRule.amount,
                        checkFlag = restAmount % lastRule.amount === 0;
                    if (null == prevRule && restAmount > 0 && restAmount < lastRule.amount && !this.teaserRows.length) {
                        this.teaserRows.splice(0, 0, lastRule.class),
                        restAmount -= lastRule.amount;
                        break
                    }
                    results.push(configIndex--)
                } else
                    this.teaserRows.splice(0, 0, lastRule.class),
                    restAmount -= lastRule.amount,
                    configIndex--;
            return results
        },
        getTeaserRowRule: function(rowClass) {
            var k, len, ref, rule;
            for (ref = this.rules,
            k = 0,
            len = ref.length; k < len; k++)
                if (rule = ref[k],
                rule.class === rowClass)
                    return rule
        },
        initTeaser: function() {
            return this.matchTeaserHeights()
        },
        matchTeaserHeights: function() {
            var i, k, mod, ref, results;
            if (mod = this,
            T.Utils.isViewport("desktop")) {
                for (results = [],
                i = k = 0,
                ref = $(this._ctx).data("rowCount"); 0 <= ref ? k < ref : k > ref; i = 0 <= ref ? ++k : --k)
                    T.Utils.debounce(mod.$("> .row-" + i + " .a-image").matchHeight(), 50),
                    T.Utils.debounce(mod.$("> .row-" + i + " .a-heading").matchHeight(), 50),
                    T.Utils.debounce(mod.$("> .row-" + i + " .content-inner").matchHeight(), 50),
                    T.Utils.debounce(mod.$("> .row-" + i + " .teaser-content").matchHeight(), 50),
                    results.push(T.Utils.debounce(mod.$("> .row-" + i + " .teaser-wrap").matchHeight(), 50));
                return results
            }
            if (T.Utils.isViewport("tablet"))
                return T.Utils.debounce(mod.$('> [class*="teaser-200-"] .a-image').matchHeight(), 50),
                T.Utils.debounce(mod.$('> [class*="teaser-200-"] .a-heading').matchHeight(), 50),
                T.Utils.debounce(mod.$('> [class*="teaser-200-"] .content-inner').matchHeight(), 50),
                T.Utils.debounce(mod.$('> [class*="teaser-200-"] .teaser-content').matchHeight(), 50),
                T.Utils.debounce(mod.$('> [class*="teaser-200-"] .teaser-wrap').matchHeight(), 50)
        },
        parseTeaserConfig: function() {
            var config, flexibleAmountOfRows, k, len, results, rule, ruleParts, teasersPerRow;
            for (config = T.Utils.teaser.container,
            this.rules = [],
            results = [],
            k = 0,
            len = config.length; k < len; k++) {
                switch (rule = config[k],
                teasersPerRow = 1,
                flexibleAmountOfRows = !1,
                ruleParts = rule.match(/(100|200-2|200-4|300|500)(\*n)?/),
                ruleParts[1]) {
                case "200-2":
                case "500":
                    teasersPerRow = 2;
                    break;
                case "300":
                    teasersPerRow = 3;
                    break;
                case "200-4":
                    teasersPerRow = 4
                }
                "*n" === ruleParts[2] && (flexibleAmountOfRows = !0),
                results.push(this.rules.push({
                    amount: teasersPerRow,
                    class: "teaser-" + ruleParts[1],
                    flex: flexibleAmountOfRows
                }))
            }
            return results
        },
        setClasses: function() {
            var i, mod, rowCount;
            return mod = this,
            i = 0,
            mod.$teasers.removeClass("hidden"),
            rowCount = 0,
            this.teaserRows.forEach(function(rowClass) {
                var j, k, ref, rule;
                for (rule = mod.getTeaserRowRule(rowClass),
                j = k = 0,
                ref = rule.amount; 0 <= ref ? k < ref : k > ref; j = 0 <= ref ? ++k : --k)
                    mod.$teasers.eq(i).removeClass(),
                    mod.$teasers.eq(i).addClass("m-teaser").addClass(rowClass),
                    mod.$teasers.eq(i).addClass("row-" + rowCount),
                    i++;
                return rowCount++
            }),
            mod.$teasers.filter(":gt(" + (i - 1) + ")").addClass("hidden"),
            $(this._ctx).data("row-count", rowCount)
        },
        onResize: function() {
            return this.matchTeaserHeights()
        },
        onLoadTeaserImage: function() {
            return this.matchTeaserHeights()
        }
    })
}(jQuery),
function($) {
    T.Module.Image.Hotspots = T.createDecorator({
        start: function(resolve, reject) {
            var $hotspots;
            return this._parent.start(resolve, reject),
            $hotspots = this.$(".image-hotspot"),
            $hotspots.each(function() {
                var $trigger;
                return $trigger = $(this),
                $trigger.css({
                    left: $trigger.data("x"),
                    top: $trigger.data("y")
                })
            }),
            $hotspots.on("click", function(ev) {
                return ev.preventDefault(),
                ev.stopPropagation()
            })
        }
    })
}(jQuery),
function($) {
    T.Module.Image.Ocr = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            mod = this,
            mod.$ctx = $(mod._ctx),
            mod.zoomFactor = 1,
            mod.oldFrameLeft = 0,
            mod.oldFrameTop = 0,
            mod.vikbeValue = mod.$ctx.data("vikbe-value"),
            mod.ocrUrlImageSmall = mod.$ctx.data("ocr-url-small"),
            mod.ocrUrlImageLarge = mod.$ctx.data("ocr-url-large"),
            mod.$image = mod.$ctx.find("img"),
            mod.$ocrFrame = mod.$ctx.find(".js-sparepart-scan-frame"),
            mod.initialPosLeft = parseInt(mod.$ocrFrame.data("initial-pos-left"), 10),
            mod.initialPosTop = parseInt(mod.$ocrFrame.data("initial-pos-top"), 10),
            mod.ocrFrameDefaultSizes = {
                mobile: {
                    width: parseInt(this.$ocrFrame.data("width-mobile")),
                    height: parseInt(this.$ocrFrame.data("height-mobile"))
                },
                tablet: {
                    width: parseInt(this.$ocrFrame.data("width-tablet")),
                    height: parseInt(this.$ocrFrame.data("height-tablet"))
                },
                desktop: {
                    width: parseInt(this.$ocrFrame.data("width-desktop")),
                    height: parseInt(this.$ocrFrame.data("height-desktop"))
                }
            },
            isNaN(mod.initialPosLeft) && (mod.initialPosLeft = 0),
            isNaN(mod.initialPosTop) && (mod.initialPosTop = 0),
            mod.zoomFactor = 1,
            mod.oldFrameLeft = 0,
            mod.oldFrameTop = 0,
            this._events.on("resetFramePosition", $.proxy(mod.onResetFramePosition, mod)),
            this._events.on("setZoom", $.proxy(this.onSetZoom, this)),
            this.initializeEvents()
        },
        transmitOCRData: function(ev, ocrData) {
            var mod, request, url, viewport;
            return mod = this,
            viewport = T.Utils.getViewport(),
            url = "mobile" === viewport && 1 === this.$ctx.closest(".m-mediagallerylayer").length ? mod.ocrUrlImageSmall : mod.ocrUrlImageLarge,
            request = T.Utils.startAjaxRequest(!1, {
                url: url,
                dataType: "JSON",
                data: ocrData
            }),
            !!request && request[0].done($.proxy(mod.transmitOCRDataSuccessCallback, mod)).fail($.proxy(mod.transmitOCRDataErrorCallback, mod))
        },
        transmitOCRDataErrorCallback: function(xhr) {
            return console.info(xhr)
        },
        transmitOCRDataSuccessCallback: function(response) {
            var mod;
            return mod = this,
            response.number ? (mod._events.emit("findsparepart", {
                sparepartnumber: response.number
            }),
            mod._events.emit("sparepartsCloseLayer")) : mod.showNoPartNumberFoundPopover()
        },
        showNoPartNumberFoundPopover: function() {
            var mod;
            return mod = this,
            mod._events.emit("popover:open", mod.$(".js-sparepart-scan-frame"))
        },
        collectOCRData: function(ev) {
            var bottomRightX, bottomRightY, currentDisplayFactor, currentDisplayedWidth, mod, normalizedBottomRightX, normalizedBottomRightY, normalizedTopLeftX, normalizedTopLeftY, realWidth, topLeftX, topLeftY;
            return mod = this,
            realWidth = mod.$image[0].naturalWidth,
            currentDisplayedWidth = this.initialDisplayWidth * mod.zoomFactor,
            currentDisplayFactor = currentDisplayedWidth / realWidth,
            topLeftX = parseInt(this.$ocrFrame.offset().left) - parseInt(this.$image.offset().left),
            topLeftY = parseInt(this.$ocrFrame.offset().top) - parseInt(this.$image.offset().top),
            bottomRightX = topLeftX + parseInt(this.$ocrFrame.css("width")),
            bottomRightY = topLeftY + parseInt(this.$ocrFrame.css("height")),
            normalizedTopLeftX = Math.round(topLeftX / currentDisplayFactor),
            normalizedTopLeftY = Math.round(topLeftY / currentDisplayFactor),
            normalizedBottomRightX = Math.round(bottomRightX / currentDisplayFactor),
            normalizedBottomRightY = Math.round(bottomRightY / currentDisplayFactor),
            mod.transmitOCRData(ev, {
                vikbe: mod.vikbeValue,
                x1: normalizedTopLeftX,
                x2: normalizedBottomRightX,
                y1: normalizedTopLeftY,
                y2: normalizedBottomRightY
            })
        },
        initializeEvents: function() {
            var mod;
            return mod = this,
            mod.$ocrFrame.removeClass("hidden"),
            mod.$ctx.on("click", $.proxy(mod.onFrameClick, mod)),
            mod.$ctx.on("touchstart mousedown", ".js-sparepart-scan-frame", $.proxy(mod.onFrameTouchStart, mod)),
            mod.$ctx.on("touchmove mousemove", ".js-sparepart-scan-frame", $.proxy(mod.onFrameTouchMove, mod)),
            mod.$ctx.on("touchmove mousemove", $.proxy(mod.onFrameTouchMove, mod)),
            mod.$ctx.on("touchend mouseup", ".js-sparepart-scan-frame", $.proxy(mod.onFrameTouchEnd, mod))
        },
        setFramePosition: function(leftPos, topPos) {
            var bottomMax, bottomPos, heightFrame, leftPosCtx, rightMax, rightPos, topPosCtx, widthFrame;
            return leftPosCtx = parseInt(this.$ctx.css("left")),
            topPosCtx = parseInt(this.$ctx.css("top")),
            widthFrame = parseInt(this.$ocrFrame.css("width")),
            heightFrame = parseInt(this.$ocrFrame.css("height")),
            leftPos === -1 && (leftPos = parseInt(this.$ocrFrame.css("left"))),
            topPos === -1 && (topPos = parseInt(this.$ocrFrame.css("top"))),
            leftPos < 0 && (leftPos = 0),
            topPos < 0 && (topPos = 0),
            this.$ctx.width() > 0 && (rightMax = this.$ctx.width(),
            rightPos = leftPos + widthFrame + leftPosCtx,
            rightPos > rightMax && (leftPos = rightMax - widthFrame)),
            this.$ctx.height() > 0 && (bottomMax = this.$ctx.height(),
            bottomPos = topPos + heightFrame + topPosCtx,
            bottomPos > bottomMax && (topPos = bottomMax - heightFrame)),
            this.$ocrFrame.css({
                left: leftPos + "px ",
                top: topPos + "px "
            })
        },
        setFrameZoom: function(data) {
            var frameHeight, frameWidth, mod, newHeight, newWidth, viewport;
            return mod = this,
            mod.zoomFactor = data.zoomFactor,
            viewport = T.Utils.getViewport(),
            frameWidth = mod.ocrFrameDefaultSizes[viewport].width,
            frameHeight = mod.ocrFrameDefaultSizes[viewport].height,
            newWidth = frameWidth * data.zoomFactor,
            newHeight = frameHeight * data.zoomFactor,
            this.$ocrFrame.css("width", newWidth + "px"),
            this.$ocrFrame.css("height", newHeight + "px"),
            this.setFramePosition(-1, -1)
        },
        onFrameTouchStart: function(ev) {
            var mod;
            switch (mod = this,
            mod.oldFrameLeft = parseInt(mod.$ocrFrame.css("left")),
            mod.oldFrameTop = parseInt(mod.$ocrFrame.css("top")),
            ev.type) {
            case "touchstart":
                return this.touchOrigin = ev.originalEvent.touches[0];
            default:
                return this.touchOrigin = ev,
                ev.preventDefault()
            }
        },
        onFrameTouchEnd: function(ev) {
            return delete this.touchOrigin
        },
        onFrameTouchMove: function(ev) {
            var evData, horizontalDistance, mod, newFrameLeft, newFrameTop, verticalDistance;
            if (mod = this,
            evData = ev,
            this.touchOrigin) {
                switch (ev.type) {
                case "touchmove":
                    evData = ev.originalEvent.touches[0],
                    horizontalDistance = ev.originalEvent.touches[0].pageX - this.touchOrigin.pageX,
                    verticalDistance = ev.originalEvent.touches[0].pageY - this.touchOrigin.pageY;
                    break;
                default:
                    horizontalDistance = ev.pageX - this.touchOrigin.pageX,
                    verticalDistance = ev.pageY - this.touchOrigin.pageY
                }
                newFrameLeft = mod.oldFrameLeft + horizontalDistance,
                newFrameTop = mod.oldFrameTop + verticalDistance,
                mod.setFramePosition(newFrameLeft, newFrameTop)
            }
            return this.lastMove || ev.preventDefault(),
            this.lastMove = evData
        },
        onFrameClick: function(ev) {
            var horizontalDistance, mod, newFrameLeft, newFrameTop, verticalDistance;
            switch (mod = this,
            mod.oldFrameLeft = parseInt(mod.$ocrFrame.css("left")),
            mod.oldFrameTop = parseInt(mod.$ocrFrame.css("top")),
            ev.type) {
            case "touchmove":
                horizontalDistance = ev.originalEvent.touches[0].pageX - this.touchOrigin.pageX,
                verticalDistance = ev.originalEvent.touches[0].pageY - this.touchOrigin.pageY,
                newFrameLeft = mod.oldFrameLeft + horizontalDistance,
                newFrameTop = mod.oldFrameTop + verticalDistance;
                break;
            default:
                newFrameLeft = ev.pageX - mod.$ctx.offset().left - parseInt(mod.$ocrFrame.css("width")) / 2,
                newFrameTop = ev.pageY - mod.$ctx.offset().top - parseInt(mod.$ocrFrame.css("height")) / 2
            }
            return delete this.touchOrigin,
            this.setFramePosition(newFrameLeft, newFrameTop),
            this.collectOCRData(ev)
        },
        onLoadImage: function(ev) {
            var mod;
            return mod = this,
            mod.initialDisplayWidth = mod.$image.width(),
            mod._events.emit("image:loaded", {
                $currentTarget: $(ev.currentTarget)
            })
        },
        onResetFramePosition: function(data) {
            var mod;
            if (mod = this,
            mod.$ctx.closest(data.$ctx).length)
                return mod.setFramePosition(mod.initialPosLeft, mod.initialPosTop)
        },
        onSetZoom: function(data) {
            var mod;
            if (mod = this,
            mod.$ctx.closest(data.$ctx).length)
                return mod.setFrameZoom(data)
        }
    })
}(jQuery),
function($) {
    T.Module.LoadMore.Ajax = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            T.Utils.allSynced = !1,
            this.isSynced = !1,
            this.$ctx = $(this._ctx),
            this.config = this.$ctx.data(),
            this.checkDataResponse = $.proxy(this.checkDataResponse, this),
            this.countUpPageNumber = $.proxy(this.countUpPageNumber, this),
            this.hideComponent = $.proxy(this.hideComponent, this),
            this.initializeLoadMore = $.proxy(this.initializeLoadMore, this),
            this.showComponent = $.proxy(this.showComponent, this),
            this.onClickButton = $.proxy(this.onClickButton, this),
            this.onLoadMoreCallback = $.proxy(this.onLoadMoreCallback, this),
            this.onSubmitFilter = $.proxy(this.onSubmitFilter, this),
            this.sync = $.proxy(this.sync, this),
            this._events.on("loadMoreCallback", this.onLoadMoreCallback),
            this._events.on("t.sync", this.sync),
            this._events.on("loadMoreButtonVisibility", this.onSubmitFilter),
            this.componentHidden = !1,
            this.pageinput = this.config.inputId || !1,
            this.listId = this.config.listId,
            this.request = {}
        },
        sync: function() {
            var response;
            this.isSynced || (this._events.emit("initializeLoadMore", {
                listId: this.listId,
                loadMoreType: "ajax"
            }),
            this.isSynced = !0,
            T.Utils.allSynced = !0,
            this.$ctx.data("initial-ajax-request") && (response = T.Utils.onAjaxControllerTriggered(null, this.$ctx),
            response && response[0] && response[0].done(function(_this) {
                return function() {
                    var resp;
                    if (response[0].responseText && (resp = JSON.parse(response[0].responseText).response,
                    resp.pageNumber >= resp.maxPageNumber))
                        return _this.hideComponent()
                }
            }(this))))
        },
        checkDataResponse: function() {
            return !!this.request && this._events.emit("loadMore", {
                listId: this.listId,
                loadMoreType: "ajax",
                requestData: this.request[0]
            })
        },
        countUpPageNumber: function() {
            var elm, mod;
            if (mod = this,
            mod.pageinput)
                return elm = document.getElementById(mod.pageinput),
                ++elm.value
        },
        hideComponent: function() {
            var $button;
            return $button = this.$ctx,
            this.componentHidden = !0,
            $button.slideUp(function() {
                return $button.addClass("hidden").removeAttr("style")
            })
        },
        loadMore: function() {
            var listContainer, mod, renderArray, updateContainers;
            return mod = this,
            renderArray = [],
            updateContainers = mod.config.ajaxUpdateContainers,
            "[object Array]" === Object.prototype.toString.call(updateContainers) && (renderArray = renderArray.concat(updateContainers)),
            listContainer = {
                id: mod.config.ajaxRenderId,
                method: "append"
            },
            renderArray.unshift(listContainer),
            mod._parent.openLoader(),
            mod.request = T.Utils.startAjaxRequest(mod.config.ajaxRequestId, {
                render: renderArray,
                callback: $.proxy(mod.checkDataResponse, mod)
            })
        },
        showComponent: function() {
            var $button;
            return $button = this.$ctx,
            $button.removeClass("hidden").removeAttr("style"),
            this.componentHidden = !1
        },
        onClickButton: function(ev) {
            var mod;
            return mod = this,
            mod.countUpPageNumber(),
            mod.loadMore()
        },
        onLoadMoreCallback: function(data) {
            if (this.listId === data.listId) {
                if (this._parent.closeLoader(),
                data.hideLoadMoreButton)
                    return this.hideComponent();
                if (this.componentHidden)
                    return this.showComponent()
            }
        },
        onSubmitFilter: function(data) {
            return data.loadMoreButtonVisibility ? this.showComponent() : this.hideComponent()
        }
    })
}(jQuery),
function($) {
    T.Module.LoadMore.Data = T.createDecorator({
        start: function(resolve, reject) {
            var hasValidInitEvent;
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.initializeLoadMore = $.proxy(this.initializeLoadMore, this),
            this.hideComponent = $.proxy(this.hideComponent, this),
            this.loadJsonDataCallback = $.proxy(this.loadJsonDataCallback, this),
            this.loadMore = $.proxy(this.loadMore, this),
            this.parseUrlParams = $.proxy(this.parseUrlParams, this),
            this.showComponent = $.proxy(this.showComponent, this),
            this.onClickButton = $.proxy(this.onClickButton, this),
            this.onToggleLoadMore = $.proxy(this.onToggleLoadMore, this),
            this.onInitEvent = $.proxy(this.onInitEvent, this),
            this.onLoadMoreCallback = $.proxy(this.onLoadMoreCallback, this),
            this.initialPageSize = parseInt(this.$ctx.data("page-size-initial"), 10),
            this.loadMorePageSize = parseInt(this.$ctx.data("page-size-loadmore"), 10),
            this.currentPageSize = 0,
            this.initEvent = this.$ctx.data("init-event"),
            this.initId = this.$ctx.data("init-id"),
            this.requestContext = this.$ctx.data("request-context"),
            this.loadMoreUrl = this.$ctx.data("loadmore-url"),
            this.loadMoreUrlParam = this.$ctx.data("loadmore-url-param"),
            this.urlParamObject = {},
            this.jsonAttributeKey = this.$ctx.data("loadmore-json-property"),
            this.replaceContainerId = this.$ctx.data("loadmore-replace-container"),
            this.renderAllItems = this.$ctx.data("render-all-items"),
            this.dataHasBeenLoaded = !1,
            this.contentRenderType = "append",
            this._events.on("toggleLoadMore", this.onToggleLoadMore),
            this._events.on("loadMoreCallback", this.onLoadMoreCallback),
            this.listId = this.$ctx.data("list-id"),
            null != this.loadMoreUrlParam && "" !== this.loadMoreUrlParam && this.parseUrlParams(),
            hasValidInitEvent = null != this.initEvent && "" !== this.initEvent,
            hasValidInitEvent ? this._events.on(this.initEvent, this.onInitEvent) : this.initializeLoadMore()
        },
        initializeLoadMore: function() {
            var mod, request;
            if (mod = this,
            !this.dataHasBeenLoaded)
                return this.dataHasBeenLoaded = !0,
                this.currentPageSize = 0,
                null != this.loadMoreUrl && null != this.replaceContainerId ? (isNaN(this.initialPageSize) && (this.loadMorePageSize = 0),
                isNaN(this.loadMorePageSize) && (this.loadMorePageSize = 0),
                !!(request = T.Utils.startAjaxRequest(!1, {
                    url: this.loadMoreUrl,
                    dataType: "JSON",
                    data: this.urlParamObject
                })) && (this.request = request[0],
                this.request.obj = $(this.requestContext),
                this.request.done(this.loadJsonDataCallback).fail(function() {
                    return mod.hideComponent()
                }))) : this.hideComponent()
        },
        hideComponent: function() {
            var mod;
            return mod = this,
            this.$ctx.slideUp(function() {
                return mod.$ctx.addClass("hidden").removeAttr("style")
            })
        },
        loadJsonDataCallback: function(data) {
            return data.response ? this.jsonData = data.response : this.jsonData = data,
            this._events.emit("updateItemCount", {
                listId: this.listId,
                itemCount: this.jsonData[this.jsonAttributeKey].length
            }),
            this._events.emit("initializeLoadMore", {
                listId: this.listId,
                jsonData: this.jsonData
            }),
            this.loadMore(this.initialPageSize),
            this.contentRenderType = "append"
        },
        loadMore: function(loadMorePageSize) {
            return this._parent.openLoader(),
            this._events.emit("loadMore", {
                listId: this.listId,
                loadMoreType: "data",
                request: this.request,
                urlParams: this.urlParamObject,
                jsonData: this.jsonData,
                jsonAttrKey: this.jsonAttributeKey,
                currentPageSize: this.currentPageSize,
                loadMorePageSize: loadMorePageSize,
                contentRenderType: this.contentRenderType,
                replaceContainerId: this.replaceContainerId,
                renderAllItems: this.renderAllItems
            })
        },
        parseUrlParams: function() {
            var mod, urlParamArray;
            if (mod = this,
            urlParamArray = this.loadMoreUrlParam.split(","),
            urlParamArray.length > 0 && $.each(urlParamArray, function(index, keyValuePair) {
                var keyValueArray;
                return keyValueArray = keyValuePair.split("="),
                mod.urlParamObject[keyValueArray[0]] = keyValueArray[1]
            }),
            null != this.urlParamObject.option)
                return this.replaceContainerId += "-" + this.urlParamObject.option
        },
        showComponent: function() {
            var mod;
            return mod = this,
            this.$ctx.slideDown(function() {
                return mod.$ctx.removeClass("hidden").removeAttr("style")
            })
        },
        onClickButton: function(ev) {
            return this.loadMore(this.loadMorePageSize)
        },
        onInitEvent: function(data) {
            return null != data.eventName && "onlinedealerbutton:click" === data.eventName ? (this.dataHasBeenLoaded = !1,
            this.contentRenderType = "replace",
            this.loadMoreUrl = data.baseUrl,
            this.initializeLoadMore(),
            this._events.emit("showOnlineDealerLayer", {
                $evTarget: null
            })) : this.initializeLoadMore()
        },
        onLoadMoreCallback: function(data) {
            if (this.listId === data.listId && (this._parent.closeLoader(),
            this.currentPageSize = data.currentPageSize,
            data.hideLoadMoreButton))
                return this.hideComponent()
        },
        onToggleLoadMore: function(data) {
            return data.showComponent ? this.showComponent() : this.hideComponent()
        }
    })
}(jQuery),
function($) {
    T.Module.LoadMore.Dom = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.initializeLoadMore = $.proxy(this.initializeLoadMore, this),
            this.hideComponent = $.proxy(this.hideComponent, this),
            this.onClickButton = $.proxy(this.onClickButton, this),
            this.onLoadMoreCallback = $.proxy(this.onLoadMoreCallback, this),
            this.initialPageSize = parseInt(this.$ctx.data("page-size-initial"), 10),
            this.loadMorePageSize = parseInt(this.$ctx.data("page-size-loadmore"), 10),
            this.currentPageSize = this.initialPageSize,
            this._events.on("loadMoreCallback", this.onLoadMoreCallback),
            this.listId = this.$ctx.data("list-id"),
            this.initializeLoadMore()
        },
        initializeLoadMore: function() {
            if (isNaN(this.loadMorePageSize) && (this.loadMorePageSize = 0),
            this._events.emit("initializeLoadMore", {
                listId: this.listId,
                loadMoreType: "dom",
                initialPageSize: this.initialPageSize
            }),
            isNaN(this.initialPageSize))
                return this.hideComponent()
        },
        hideComponent: function() {
            var mod;
            return mod = this,
            this.$ctx.slideUp(function() {
                return mod.$ctx.addClass("hidden").removeAttr("style")
            })
        },
        onClickButton: function(ev) {
            return this._parent.openLoader(),
            this._events.emit("loadMore", {
                listId: this.listId,
                loadMoreType: "dom",
                currentPageSize: this.currentPageSize,
                loadMorePageSize: this.loadMorePageSize
            })
        },
        onLoadMoreCallback: function(data) {
            if (this.listId === data.listId && (this._parent.closeLoader(),
            this.currentPageSize = data.currentPageSize,
            data.hideLoadMoreButton))
                return this.hideComponent()
        }
    })
}(jQuery),
function($, doT) {
    T.Module.SelectedFilter.ClientSide = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.doT = doT,
            this.groupId = this.$ctx.data("groupId"),
            this.onFilterStateChange = $.proxy(this, "onFilterStateChange"),
            this.onClick = $.proxy(this, "onClick"),
            this.onReset = $.proxy(this, "onReset"),
            this._events.on("filterStateChange", this.onFilterStateChange)
        },
        destroy: function() {
            return this._events.off("filterStateChange"),
            this._events.off("filterlayerresetbutton:clicked"),
            this.$ctx.remove()
        },
        onClick: function(ev) {
            return this._events.emit("selectedfilter:clicked", {
                name: this.name,
                value: this.value,
                type: this.type,
                resetValue: !1,
                groupId: this.groupId
            }),
            this.destroy()
        },
        onFilterStateChange: function(data) {
            if (data.itemData.itemId === this.value && "selected" !== data.itemData.actionType)
                return this.destroy()
        },
        onReset: function() {
            return this.destroy()
        }
    })
}(jQuery, window.doT),
function($) {
    T.Module.Charts.HorizontalBar = T.createDecorator({
        bars: [],
        labels: [],
        values: [],
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject)
        },
        addBar: function(obj, index) {
            var rect;
            return rect = new fabric.Rect({
                left: this.settings.padding,
                top: this.getBarTop(obj, index),
                fill: this.getColor(obj),
                width: this.getBarWidth(obj),
                height: this.getBarHeight(),
                selectable: !1
            }),
            this.bars.push(rect),
            this.canvas.add(rect)
        },
        addLabelText: function(obj, index) {
            var text, top;
            return top = this.getBarTop(obj, index) + this.getBarHeight(obj, index),
            text = new fabric.Text(this.getLabel(obj),{
                left: this.settings.padding,
                top: top,
                fill: this.settings.labelFontColor,
                fontFamily: this.settings.labelFontFamily,
                fontSize: this.settings.labelFontSize,
                selectable: !1
            }),
            this.labels.push(text),
            this.canvas.add(text)
        },
        addValueText: function(obj, index) {
            var color, text, top;
            return top = this.getBarTop(obj, index),
            color = this.settings.HorizontalBar.valueFontColor,
            obj.isHighlight && (color = this.settings.HorizontalBar.valueFontHighlightColor),
            text = new fabric.Text(this.getValueText(obj),{
                left: 0,
                top: top,
                fill: color,
                fontFamily: this.settings.valueFontFamily,
                fontSize: this.settings.valueFontSize,
                fontStyle: this.settings.valueFontStyle,
                lineHeight: 1,
                selectable: !1
            }),
            text.set("left", this.getValueTextLeft(obj, text)),
            text.set("top", top + (this.getBarHeight() - text.height) / 2),
            this.values.push(text),
            this.canvas.add(text)
        },
        centerBars: function() {
            var mod, space;
            return mod = this,
            space = this.getBarSpace(),
            this.bars.forEach(function(rect, index) {
                var label, shift, value;
                return label = mod.labels[index],
                value = mod.values[index],
                shift = (space - rect.height - label.height) / 2,
                label.set("top", label.top + shift),
                value.set("top", value.top + shift),
                rect.set("top", rect.top + shift)
            }),
            this.canvas.renderAll()
        },
        createChart: function() {
            var mod;
            return mod = this,
            this.data.forEach(function(obj, index) {
                return mod.addBar(obj, index),
                mod.addLabelText(obj, index),
                mod.addValueText(obj, index)
            }),
            this.centerBars(),
            this.scaleRetina()
        },
        getBarHeight: function() {
            return Math.min((this.canvas.height - 2 * this.settings.padding - this.settings.HorizontalBar.barSpacing * this.data.length) / this.data.length, this.settings.HorizontalBar.barMaxSize)
        },
        getBarSpace: function() {
            return (this.canvas.height - 2 * this.settings.padding) / this.data.length
        },
        getBarTop: function(obj, index) {
            return this.settings.padding + this.getBarSpace(obj, index) * index
        },
        getBarWidth: function(obj) {
            var max;
            return max = 0,
            this.data.forEach(function(obj) {
                if (obj.value > max)
                    return max = obj.value
            }),
            obj.value / max * (this.canvas.width - 2 * this.settings.padding)
        },
        getValueTextLeft: function(obj, text) {
            var barWidth, baseX;
            return baseX = this.settings.padding,
            barWidth = this.getBarWidth(obj),
            Math.ceil(text.width) >= Math.floor(barWidth) - 2 * this.settings.HorizontalBar.barPadding ? baseX + barWidth + this.settings.HorizontalBar.barPadding : baseX + barWidth - text.width - this.settings.HorizontalBar.barPadding
        },
        resize: function() {
            return this.canvas.clear(),
            this.bars = [],
            this.labels = [],
            this.values = [],
            this.createChart()
        }
    })
}(jQuery),
function($) {
    T.Module.Charts.VerticalBar = T.createDecorator({
        bars: [],
        labels: [],
        values: [],
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject)
        },
        addBar: function(obj, index) {
            var rect;
            return rect = new fabric.Rect({
                top: this.canvas.height - this.settings.padding - this.labels[index].height,
                left: this.getBarLeft(obj, index),
                fill: this.getColor(obj),
                height: this.getBarHeight(obj),
                width: this.getBarWidth(),
                selectable: !1,
                originY: "bottom"
            }),
            this.bars.push(rect),
            this.canvas.add(rect)
        },
        addLabelText: function(obj, index) {
            var left, text;
            return left = this.getBarLeft(obj, index),
            text = new fabric.Text(this.getLabel(obj),{
                left: left,
                top: this.canvas.height - .6 * this.settings.padding,
                fill: this.settings.labelFontColor,
                fontFamily: this.settings.labelFontFamily,
                fontSize: this.settings.labelFontSize,
                lineHeight: this.settings.VerticalBar.labelLineHeight,
                selectable: !0,
                originY: "bottom"
            }),
            text.set("left", left + (this.getBarWidth() - text.width) / 2),
            this.labels.push(text),
            this.canvas.add(text)
        },
        addValueText: function(obj, index) {
            var color, left, text, top;
            return top = this.canvas.height - this.getBarHeight(obj) - this.settings.valueFontSize,
            left = this.getBarLeft(obj, index),
            color = this.settings.VerticalBar.valueFontColor,
            text = new fabric.Text(this.getValueText(obj),{
                left: left,
                top: top,
                fill: color,
                fontFamily: this.settings.valueFontFamily,
                fontSize: this.settings.valueFontSize,
                lineHeight: 1,
                selectable: !1,
                originY: "bottom"
            }),
            text.set("top", top - 1.5 * text.height),
            text.set("left", left + (this.getBarWidth() - text.width) / 2),
            this.values.push(text),
            this.canvas.add(text)
        },
        centerBars: function() {
            var mod, space;
            return mod = this,
            space = this.getBarSpace(),
            this.bars.forEach(function(rect, index) {
                var label, shift, value;
                return shift = (space - rect.width) / 2,
                label = mod.labels[index],
                value = mod.values[index],
                label.set("left", label.left + shift),
                value.set("left", value.left + shift),
                rect.set("left", rect.left + shift)
            }),
            this.canvas.renderAll()
        },
        createChart: function() {
            var mod;
            return mod = this,
            this.data.forEach(function(obj, index) {
                return mod.addLabelText(obj, index),
                mod.addBar(obj, index),
                mod.addValueText(obj, index)
            }),
            this.centerBars(),
            this.scaleRetina()
        },
        getBarHeight: function(obj) {
            var max;
            return max = 0,
            this.data.forEach(function(obj) {
                if (obj.value > max)
                    return max = obj.value
            }),
            obj.value / max * (this.canvas.height - 2 * this.settings.padding - this.settings.valueFontSize - this.settings.VerticalBar.labelLineHeight * this.settings.labelFontSize)
        },
        getBarLeft: function(obj, index) {
            return this.settings.padding + this.getBarSpace(obj, index) * index
        },
        getBarSpace: function() {
            return (this.canvas.width - 2 * this.settings.padding) / this.data.length
        },
        getBarWidth: function() {
            return Math.min((this.canvas.width - 2 * this.settings.padding - this.settings.VerticalBar.barSpacing * this.data.length) / this.data.length, this.settings.VerticalBar.barMaxSize)
        },
        getValueText: function(obj) {
            return "" + obj.value
        },
        getValueTextTop: function(obj, text) {
            var barWidth, baseX;
            return baseX = this.settings.padding,
            barWidth = this.getBarWidth(obj),
            Math.ceil(text.width) >= Math.floor(barWidth) - 2 * this.settings.padding ? baseX + barWidth + this.settings.padding : barWidth - text.width
        },
        getValueTextLeft: function(obj) {
            return this.getBarWidth(obj)
        },
        resize: function() {
            return this.canvas.clear(),
            this.bars = [],
            this.labels = [],
            this.values = [],
            this.createChart()
        }
    })
}(jQuery),
function($) {
    T.Module.Filter.Ajax = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.onClickFilterResetButton = $.proxy(this, "onClickFilterResetButton")
        },
        onClickFilterResetButton: function(ev) {
            var id, mod;
            if (ev.preventDefault(),
            mod = this,
            id = T.Utils.getAjaxId($(ev.currentTarget)))
                return $("[data-init-data=" + id + "]").length ? T.Utils.initialRendering(id) : mod._events.emit("filter:reset")
        }
    })
}(jQuery),
function($, doT) {
    var filterGroupsSelector, selectedFilterContainerSelector, selectedFilterTplSelector, selectedFilterWrapSelector, showHideWrapperSelector;
    filterGroupsSelector = ".js-filter-group",
    selectedFilterWrapSelector = ".js-selected-filter-wrap",
    selectedFilterContainerSelector = ".js-selected-filter-container",
    selectedFilterTplSelector = ".js-selected-filter-tpl",
    showHideWrapperSelector = ".js-show-hide-wrapper",
    T.Module.Filter.ClientSide = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.doT = doT,
            this.checkShowHideState = $.proxy(this, "checkShowHideState"),
            this.handleActiveFilterCount = $.proxy(this, "handleActiveFilterCount"),
            this.handleEmptyFilterList = $.proxy(this, "handleEmptyFilterList"),
            this.handleFilterDataObjectChange = $.proxy(this, "handleFilterDataObjectChange"),
            this.handleFilterDataObjectReset = $.proxy(this, "handleFilterDataObjectReset"),
            this.handleSelectedFilterContainerState = $.proxy(this, "handleSelectedFilterContainerState"),
            this.handleNewFacetData = $.proxy(this, "handleNewFacetData"),
            this.showComponent = $.proxy(this, "showComponent"),
            this.updateItemCount = $.proxy(this, "updateItemCount"),
            this.onFilterStateChange = $.proxy(this, "onFilterStateChange"),
            this.onNewFacetDataAvailable = $.proxy(this, "onNewFacetDataAvailable"),
            this.onUpdateItemCount = $.proxy(this, "onUpdateItemCount"),
            this.$showHideWrapper = this.$(showHideWrapperSelector),
            this.$filterGroups = this.$(filterGroupsSelector),
            this.$selectedFilterWrap = this.$(selectedFilterWrapSelector),
            this.$selectedFilterContainer = this.$(selectedFilterContainerSelector),
            this.selectedFilterTpl = this.doT.template(this.$(selectedFilterTplSelector).html()),
            this._events.on("newFacetDataAvailable", this.onNewFacetDataAvailable),
            this._events.on("filterStateChange", this.onFilterStateChange),
            this._events.on("updateItemCount", this.onUpdateItemCount),
            this.selectedFilterGroups = {},
            this.selectedFiltersCount = 0,
            this.listId = this.$ctx.data("list-id"),
            this.checkShowHideState(this.$filterGroups)
        },
        checkShowHideState: function($filterGroups) {
            return $filterGroups.length <= 4 ? this.$showHideWrapper.addClass("hidden") : this.$showHideWrapper.removeClass("hidden")
        },
        handleActiveFilterCount: function() {
            return this._events.emit("updateActiveFilterCount", {
                listId: this.listId,
                activeFilterCount: this.selectedFiltersCount
            })
        },
        handleEmptyFilterList: function() {
            return $.each(this.$(".js-filter-list-container"), function(index, filterList) {
                var $filterList, filterListRows;
                return $filterList = $(filterList),
                filterListRows = $filterList.find(".js-filter-list-row:not(.hidden)"),
                0 === filterListRows.length ? $filterList.closest(".js-filter-group").addClass("hidden") : $filterList.closest(".js-filter-group").removeClass("hidden")
            })
        },
        handleFilterDataObjectChange: function(data) {
            if (null != data.groupId) {
                if ("selected" === data.actionType)
                    return this.renderSelectedFilter(data),
                    null == this.selectedFilterGroups[data.groupId] && (this.selectedFilterGroups[data.groupId] = {}),
                    null == this.selectedFilterGroups[data.groupId].selectedFilterItems && (this.selectedFilterGroups[data.groupId].selectedFilterItems = []),
                    this.selectedFilterGroups[data.groupId].innerOperator = data.innerOperator,
                    this.selectedFilterGroups[data.groupId].selectedFilterItems.push(data.itemId),
                    this.selectedFiltersCount++;
                if (this.selectedFilterGroups[data.groupId].selectedFilterItems.splice($.inArray(data.itemId, this.selectedFilterGroups[data.groupId].selectedFilterItems), 1),
                this.selectedFiltersCount--,
                0 === this.selectedFilterGroups[data.groupId].selectedFilterItems.length)
                    return delete this.selectedFilterGroups[data.groupId]
            }
        },
        handleFilterDataObjectReset: function() {
            var mod;
            return mod = this,
            this.selectedFiltersCount = 0,
            $.each(this.selectedFilterGroups, function(groupId, filterGroup) {
                return delete mod.selectedFilterGroups[groupId]
            })
        },
        handleFilterStateChange: function(callback, data, emitFilterEvent) {
            if ("function" == typeof callback && callback(data),
            this.handleActiveFilterCount(),
            this.handleSelectedFilterContainerState(),
            emitFilterEvent)
                return this._events.emit("filterByFacets", {
                    listId: this.listId,
                    selectedFilterGroups: this.selectedFilterGroups,
                    selectedFiltersCount: this.selectedFiltersCount
                })
        },
        handleSelectedFilterContainerState: function() {
            return this.selectedFiltersCount < 1 ? this.$selectedFilterWrap.removeClass("selected") : this.$selectedFilterWrap.addClass("selected")
        },
        handleNewFacetData: function(facets) {
            return $.each(this.$(".js-filter-group"), function(index, filterGroup) {
                var $filterGroup, visibleFilterCount;
                return $filterGroup = $(filterGroup),
                visibleFilterCount = 0,
                $.each($filterGroup.find(".js-filter-list-row-item"), function(index, filterRowItem) {
                    var $filterRow, $filterRowItem, $itemFilterCount, filterItemId;
                    return $filterRowItem = $(filterRowItem),
                    $filterRow = $filterRowItem.closest(".js-filter-list-row"),
                    filterItemId = $filterRowItem.data("item-id"),
                    facets.hasOwnProperty(filterItemId) ? ($filterRow.removeClass("hidden"),
                    visibleFilterCount++,
                    $itemFilterCount = $filterRowItem.find(".js-item-filter-count"),
                    $itemFilterCount.length > 0 ? $itemFilterCount.text(facets[filterItemId].itemCount) : void 0) : $filterRow.addClass("hidden")
                })
            })
        },
        renderSelectedFilter: function(selectedFilterData) {
            var selectedFilterHtml;
            return selectedFilterHtml = this.selectedFilterTpl(selectedFilterData),
            this.$selectedFilterContainer.append(selectedFilterHtml),
            this._sandbox.addModules(this.$selectedFilterContainer.find('.js-selected-filter[data-input-value="' + selectedFilterData.itemId + '"]')[0])
        },
        resetSortDropdown: function() {
            return this._events.emit("updateSortingDropdown", {
                sortKey: "",
                triggerChange: !0,
                triggerUpdateSticky: !0
            })
        },
        showComponent: function() {
            return this.$ctx.removeClass("hidden")
        },
        updateItemCount: function(newItemCount) {
            return this.$ctx.find(".js-counter").text(newItemCount)
        },
        onClickFilterResetButton: function(ev) {
            var emitFilterEvent, mod;
            return ev.preventDefault(),
            mod = this,
            emitFilterEvent = !0,
            this._events.emit("filterlayerresetbutton:clicked"),
            this.handleFilterStateChange(this.handleFilterDataObjectReset, {}, emitFilterEvent),
            this._events.emit("initializeActiveFilter", {
                $ctx: mod.$ctx
            }),
            this._parent.closeFilterLayer()
        },
        onFilterStateChange: function(data) {
            var emitFilterEvent, mod;
            if (mod = this,
            data.$filterList.closest(mod.$ctx).length)
                return emitFilterEvent = !0,
                null != data.emitFilterEvent && (emitFilterEvent = data.emitFilterEvent),
                mod.handleFilterStateChange(mod.handleFilterDataObjectChange, data.itemData, emitFilterEvent)
        },
        onNewFacetDataAvailable: function(data) {
            var mod;
            if (mod = this,
            mod.listId === data.listId)
                return mod.handleNewFacetData(data.facets),
                mod.handleEmptyFilterList(),
                mod.showComponent(),
                mod.updateItemCount(data.itemCount),
                mod.checkShowHideState(mod.$(".js-filter-group:not(.hidden)")),
                this._parent.closeFilterLayer()
        },
        onUpdateItemCount: function(data) {
            var mod;
            if (mod = this,
            mod.listId = data.listId)
                return mod.updateItemCount(data.itemCount)
        }
    })
}(jQuery, window.doT),
function($) {
    T.Module.Filter.DealerLocator = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.initializeActiveFilters = $.proxy(this, "initializeActiveFilters"),
            this.initializeBaseFilterItems = $.proxy(this, "initializeBaseFilterItems"),
            this.onInitializeActiveFilter = $.proxy(this, "onInitializeActiveFilter"),
            this.onInitializeFilter = $.proxy(this, "onInitializeFilter"),
            this._events.on("initializeActiveFilter", this.onInitializeActiveFilter),
            this._events.on("initializeFilter", this.onInitializeFilter),
            this.baseFilterGroups = [],
            this.activeFilters = []
        },
        initializeActiveFilters: function(activeFilters) {
            var mod;
            return mod = this,
            $.each(activeFilters, function(index, activeFilter) {
                return $.each(mod.baseFilterGroups, function(index, baseFilterGroup) {
                    return $.each(baseFilterGroup.filters, function(index, filterItem) {
                        var $filterList, data, emitFilterEvent;
                        if (activeFilter === filterItem.filterID)
                            return emitFilterEvent = !1,
                            data = {
                                actionType: "selected",
                                itemId: filterItem.filterID,
                                itemName: filterItem.title,
                                groupId: baseFilterGroup.groupID,
                                isPreselected: !0
                            },
                            $filterList = mod.$('.js-filter-list-container[data-group-id="' + baseFilterGroup.groupID + '"]'),
                            mod._events.emit("filterStateChange", {
                                $filterList: $filterList,
                                itemData: data,
                                emitFilterEvent: emitFilterEvent
                            }),
                            mod._events.emit("addPreselectedFilter", {
                                groupId: baseFilterGroup.groupID,
                                filterId: filterItem.filterID,
                                isPreselected: !0
                            })
                    })
                })
            })
        },
        initializeBaseFilterItems: function(data) {
            var $template, key, request;
            return this.baseFilterGroups = data.baseFilterGroups,
            request = {
                obj: this.$ctx
            },
            $template = $("<div/>").html(T.Utils.renderTemplateMarkup(request, data, !1)),
            key = this.$ctx.find("[data-replace-container]").data("replace-container"),
            T.Utils.syncContent($template, key, "replace")
        },
        onInitializeActiveFilter: function(data) {
            var mod;
            if (mod = this,
            mod.$ctx === data.$ctx && mod.activeFilters.length > 0)
                return mod.initializeActiveFilters(mod.activeFilters),
                mod.$filterLayer.addClass("is-opened")
        },
        onInitializeFilter: function(data) {
            return data.enableFilter ? (this.initializeBaseFilterItems(data),
            data.activeFilters.length > 0 && (this.activeFilters = data.activeFilters,
            this.initializeActiveFilters(data.activeFilters),
            this._parent.filterBlockOuterToggle(!0),
            T.Utils.isViewport("tablet") || T.Utils.isViewport("desktop")) ? this.$filterLayer.addClass("is-opened") : void 0) : this.$(".js-filterbar-filter").addClass("filterbar-item-invisible")
        }
    })
}(jQuery),
function($) {
    T.Module.FilterBar.ClientSide = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.onNewFacetDataAvailable = $.proxy(this, "onNewFacetDataAvailable"),
            this.listId = this.$ctx.data("list-id"),
            this._events.on("newFacetDataAvailable", $.proxy(this.onNewFacetDataAvailable, this))
        },
        onNewFacetDataAvailable: function(data) {
            var mod;
            if (mod = this,
            mod.listId === data.listId)
                return data.triggerChange = !0,
                data.triggerUpdateSticky = !0,
                mod._parent.updateSortingDropDown(data)
        }
    })
}(jQuery),
function($) {
    T.Module.FilterBar.Sticky = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.$sticky = this.$(".sticky-container"),
            this.$stickyContent = this.$(".filter-bar-sticky-content"),
            this.$filter = this.$ctx.closest(".m-filter"),
            this.listId = this.$ctx.data("list-id"),
            $(window).on("scroll.sticky-filter", $.proxy(this.onWindowScroll, this)),
            $(window).on("resize.sticky-filter", $.proxy(this.onWindowResize, this)),
            this.lastScrollTop = $(window).scrollTop(),
            this._events.on("t.sync", $.proxy(this.sync, this)),
            this._events.on("upDateStickyBar", $.proxy(this.setupSticky, this)),
            this._events.on("updateStickyViewTypeButtonState", $.proxy(this.onUpdateStickyViewTypeButtonState, this)),
            this._events.on("updateStickySortingDropDown", $.proxy(this.onUpdateStickySortingDropDown, this)),
            this._events.on("hideSticky", $.proxy(this.hideSticky, this)),
            this._events.on("toggleGridView", $.proxy(this.setSortButtons, this)),
            this._events.on("toggleListView", $.proxy(this.setSortButtons, this)),
            this.setupSticky()
        },
        sync: function() {
            this._events.emit("header:disable-sticky")
        },
        setupSticky: function() {
            return this.$ctx.find(".js-filterbar-nav").clone(!1).appendTo(this.$stickyContent),
            this.replaceClasses(),
            this.$selectSticky = this.$sticky.find(".js-sticky-filterbar-sorting").find("select"),
            this.$selectSticky.select2({
                minimumResultsForSearch: -1
            }),
            this.setSortButtons(),
            this.$sticky.find(".js-sticky-filterbar-filter").on("click", $.proxy(this.scrollToFilter, this)),
            this.$sticky.find(".js-sticky-filterbar-compare").on("click", $.proxy(this.scrollToFilter, this)),
            this.$selectSticky.on("change.userAction", $.proxy(this.onChangeSortingOptionSticky, this))
        },
        setSortButtons: function() {
            return this.$stickyContent.find(".js-filterbar-icons").html(this.$ctx.find(".js-filterbar-icons").html()),
            this.$depictionBtns = this.$sticky.find(".js-filterbar-view-toggle").on("click", $.proxy(this.switchDepiction, this))
        },
        replaceClasses: function() {
            return this.$stickyContent.find(".js-filterbar-compare").removeClass("js-filterbar-compare").addClass("js-sticky-filterbar-compare"),
            this.$stickyContent.find(".js-filterbar-filter").removeClass("js-filterbar-filter").addClass("js-sticky-filterbar-filter"),
            this.$stickyContent.find(".js-filterbar-sorting").removeClass("js-filterbar-sorting").addClass("js-sticky-filterbar-sorting")
        },
        scrollToFilter: function() {
            var position;
            return position = this.$ctx.offset().top - 20,
            T.Utils.scrollToTop(position)
        },
        switchDepiction: function(ev) {
            var $target, mod;
            if (mod = this,
            $target = $(ev.currentTarget),
            !$target.hasClass("is-active"))
                return $target.hasClass("js-filterbar-gridview") ? T.Utils.scrollToTop(this.ctx, function() {
                    return mod._events.emit("onGridListButton", "", ".js-filterbar-gridview")
                }) : T.Utils.scrollToTop(this.$ctx, function() {
                    return mod._events.emit("onGridListButton", "", ".js-filterbar-listview")
                }),
                this.$depictionBtns.removeClass("is-active"),
                $target.addClass("is-active");
        },
        hideSticky: function(data) {
            var mod;
            if (mod = this,
            mod.$sticky.closest(data.$element).length)
                return mod.$sticky.addClass("no-anim"),
                mod.$sticky.removeClass("is-active"),
                mod.$sticky.removeClass("no-anim")
        },
        onChangeSortingOptionSticky: function() {
            var mod, sortKey;
            return mod = this,
            mod.scrollToFilter(),
            sortKey = this.$selectSticky.val(),
            mod._events.emit("updateSortingDropdown", {
                $ctx: this.$ctx,
                sortKey: sortKey,
                triggerChange: !0,
                triggerUpdateSticky: !1
            })
        },
        onUpdateStickySortingDropDown: function(data) {
            var mod;
            if (mod = this,
            mod.$ctx === data.$ctx)
                return mod.$selectSticky.val(data.sortKey).trigger("change.select2")
        },
        onUpdateStickyViewTypeButtonState: function(data) {
            var viewTypeClass;
            if (this.listId === data.listId)
                return this.$sticky.find(".js-filterbar-view-toggle").removeClass("is-active"),
                viewTypeClass = "gridview",
                "list-view" === data.viewType && (viewTypeClass = "listview"),
                this.$sticky.find(".js-filterbar-view-toggle.filterbar-" + viewTypeClass).addClass("is-active")
        },
        onWindowScroll: function() {
            var scrollTop;
            return scrollTop = $(window).scrollTop(),
            "top" === T.Utils.getOffScreenDirection(this.$filter) && scrollTop - this.lastScrollTop < 0 ? this.$sticky.addClass("is-active") : this.$sticky.removeClass("is-active"),
            this.lastScrollTop = scrollTop
        },
        onWindowResize: function() {
            var mod;
            switch (mod = this,
            T.Utils.getViewport()) {
            case "mobile":
                if ("object" == typeof mod.$selectSticky.data("select2"))
                    return mod.$selectSticky.select2("destroy");
                break;
            default:
                if ("object" != typeof mod.$selectSticky.data("select2"))
                    return mod.$selectSticky.select2({
                        minimumResultsForSearch: -1
                    })
            }
        }
    })
}(jQuery),
function($) {
    T.Module.FilterLayer.Ajax = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.$pageNrInput = this.$('[name="pageNumber"]'),
            this.$requestElm = this.$ctx.closest(".js-ajax-request"),
            this.$list = this.$ctx.closest("[data-list-id]"),
            $.extend(this.request, {
                id: this.$requestElm.attr("data-ajax-id"),
                listId: this.$list.attr("data-list-id")
            }),
            this.requestStarted = !1,
            this.triggerProductListUpdate = $.proxy(this, "triggerProductListUpdate"),
            this.onChangeFilterValue = $.proxy(this, "onChangeFilterValue"),
            this.onRemoveSelectedFilter = $.proxy(this, "onRemoveSelectedFilter")
        },
        checkFilterResponse: function(request) {
            return this._events.emit("loadMore", {
                listId: this.request.listId,
                loadMoreType: "ajax",
                requestData: request[0]
            })
        },
        triggerProductListUpdate: function(data) {
            var request;
            if (this.requestStarted === !1)
                return !!(request = T.Utils.startAjaxRequest(data.id, data.config)) && (this.checkFilterResponse(request),
                this.requestStarted = !0)
        },
        onChangeFilterValue: function(ev) {
            var $duplicates, $filter, mod, singlevalue;
            return mod = this,
            $filter = $(ev.currentTarget),
            singlevalue = $filter.data("singleValue"),
            singlevalue && ($duplicates = mod.$("[data-single-value='" + singlevalue + "']").not($filter),
            $duplicates.length > 0 && $duplicates.val(""),
            mod.$("[data-hidden-filter='" + singlevalue + "']").remove()),
            mod.$pageNrInput.val("1"),
            this.triggerProductListUpdate(this.request)
        },
        onRemoveSelectedFilter: function(data) {
            var $category, $hiddenfilter, $input, $inputfield, categoryval, hidden, mod, option, selector;
            if (mod = this,
            hidden = "[data-hidden-filter='" + data.name + "']",
            $hiddenfilter = mod.$(hidden),
            "category" === data.type && (categoryval = "",
            data.value && (categoryval = '{"attribute":"categories","valueType":"MULTI","values.0":"' + data.value + '"}')),
            $hiddenfilter.length > 0)
                switch (data.type) {
                case "category":
                    categoryval ? $hiddenfilter.attr("value", categoryval) : $hiddenfilter.remove();
                    break;
                default:
                    $hiddenfilter.remove()
                }
            else
                switch (data.type) {
                case "default":
                    if (selector = "[value='" + data.value + "']",
                    $input = mod.$filterGroupWrapper.find(selector),
                    !$input.length)
                        return;
                    $input.attr("checked", !1);
                    break;
                case "range":
                    if (selector = "[data-range-name='" + data.name + "']",
                    $input = mod.$filterGroupWrapper.find(selector),
                    !$input.length)
                        return;
                    "SELECT" === $input[0].tagName ? $input[0].selectedIndex = -1 : ($inputfield = $input.find("input"),
                    $inputfield.val("null"));
                    break;
                case "category":
                    if (selector = "[data-single-value='" + data.name + "']",
                    option = "option[value='" + categoryval + "']",
                    $category = mod.$filterGroupWrapper.find(selector),
                    !$category.length)
                        return;
                    0 === $(option, $category).length && ($category.val(""),
                    $category.eq(0).prepend("<option value='" + categoryval + "'>back...</option>").attr),
                    $(option, $category).closest($category).val(categoryval)
                }
            return this.triggerProductListUpdate(this.request)
        }
    })
}(jQuery),
function($) {
    T.Module.FilterLayer.ClientSide = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            mod = this,
            mod.$ctx = $(this._ctx),
            this.removeFilterItemRowActiveState = $.proxy(this, "removeFilterItemRowActiveState"),
            this.onChangeFilterValue = $.proxy(this, "onChangeFilterValue"),
            this.onReset = $.proxy(this, "onReset")
        },
        removeFilterItemRowActiveState: function($filterItemRow) {
            var $filterItemInput;
            if ($filterItemRow.length > 0)
                return $filterItemRow.removeClass("is-active"),
                $filterItemInput = $filterItemRow.find(".js-filter-item-input"),
                $filterItemInput.prop("checked", !1)
        },
        onChangeFilterValue: function(ev) {
            var $filterList, $input, $item, actionType, itemData, itemId, itemName;
            return $input = $(ev.target),
            $item = $input.closest(".js-filter-list-row-item"),
            $filterList = $item.closest(".js-filter-list-container"),
            itemId = $item.data("item-id"),
            itemName = $item.data("item-name"),
            actionType = "deselected",
            $input.is(":checked") && (actionType = "selected"),
            itemData = {
                actionType: actionType,
                itemId: itemId,
                itemName: itemName,
                groupId: $filterList.data("group-id"),
                innerOperator: $filterList.data("inner-operator")
            },
            this._parent.toggleElementActiveState($item),
            this._events.emit("filterStateChange", {
                $filterList: $filterList,
                itemData: itemData
            })
        },
        onReset: function() {
            var $filterGroups, $filterItemRows, mod;
            return mod = this,
            $filterGroups = this.$(".js-filter-list-container"),
            $filterItemRows = $filterGroups.find(".js-filter-list-row-item"),
            $.each($filterItemRows, function(index, filterItemRow) {
                var $filterItemRow;
                return $filterItemRow = $(filterItemRow),
                mod.removeFilterItemRowActiveState($filterItemRow)
            })
        }
    })
}(jQuery),
function($) {
    T.Module.FilterLayer.DealerLocator = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            mod = this,
            mod.$ctx = $(this._ctx),
            this.addFilterItemRowActiveState = $.proxy(this, "addFilterItemRowActiveState"),
            mod._events.on("addPreselectedFilter", $.proxy(mod.onAddPreselectedFilter, mod))
        },
        addFilterItemRowActiveState: function($filterItemRow, data) {
            var $filterItemInput;
            if ($filterItemRow.length > 0)
                return $filterItemRow.addClass("is-active"),
                data.isPreselected && $filterItemRow.addClass("is-preselected"),
                $filterItemInput = $filterItemRow.find(".js-filter-item-input"),
                $filterItemInput.prop("checked", !0)
        },
        onAddPreselectedFilter: function(data) {
            var $filterGroup, $filterItemRow;
            return $filterGroup = this.$('.js-filter-list-container[data-group-id="' + data.groupId + '"]'),
            $filterItemRow = $filterGroup.find('.js-filter-list-row-item[data-item-id="' + data.filterId + '"]'),
            this.addFilterItemRowActiveState($filterItemRow, data)
        }
    })
}(jQuery),
function($) {
    T.Module.FilterLayer.Productlist = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            $.extend(this.request, {
                config: {
                    functionCallup: "T.Utils.functionCallAjaxTrackingProductFilters"
                }
            })
        }
    })
}(jQuery),
function($) {
    T.Module.FilterLayer.QuotesOrders = T.createDecorator({
        request: null,
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            T.Utils.allSynced = !1,
            this.$filterGroupWrapper = null,
            this.$filterInput = null,
            this._selector = {
                inputFields: ".js-value-input",
                customDateFilters: ".js-customfilterdateselection"
            },
            this.elm = {
                $inputFields: $(this._selector.inputFields, this.$ctx)
            },
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            $(this._selector.inputFields, this.$ctx).on("focusout", function(_this) {
                return function(ev) {
                    return _this.onChangeFilterValue(ev)
                }
            }(this)),
            $(this._selector.customDateFilters, this.$ctx).on("update", function(_this) {
                return function(ev) {
                    return _this.onChangeFilterValue(ev)
                }
            }(this)),
            console.log("{{ FilterLayer.QuotesOrders }} start"),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            T.Utils.allSynced = !0,
            console.log("{{ FilterLayer.QuotesOrders }} sync"))
        },
        doEventBinding: function() {
            return console.log("doEventBinding")
        },
        equalizeHeadingHeights: function() {
            return console.log("equalizeHeadingHeights")
        },
        toggleElementActiveState: function($item) {
            return console.log("toggleElementActiveState")
        },
        onChangeFilterValue: function(ev) {
            var $dataTable;
            return console.log("onChangeFilterValue"),
            $dataTable = $(document.getElementById(this.$ctx.data("table-id"))),
            $dataTable.trigger("tableQuoteList.updateTableData")
        },
        onRemoveSelectedFilter: function(data) {
            return console.log("onRemoveSelectedFilter")
        },
        onReset: function() {
            return window.location.reload(!0)
        }
    })
}(jQuery),
function($) {
    T.Module.FormInput.ActionLink = T.createDecorator({
        start: function(resolve, reject) {
            return this.$ctx = $(this._ctx),
            T.Utils.allSynced = !1,
            this._selector = {
                requestButtonSelector: ".js-action-link"
            },
            this.elm = {
                $requestButton: $(this._selector.requestButtonSelector, this.$ctx)
            },
            this.maxClicks = this.elm.$requestButton.data("max-clicks"),
            this.doneClicks = 0,
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            $(this._selector.requestButtonSelector, this.$ctx).on("click", function(_this) {
                return function(ev) {
                    return _this.onClickRequestButton(ev)
                }
            }(this)),
            console.log("{{ name }} start"),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            T.Utils.allSynced = !0,
            console.log("{{ name }} sync"))
        },
        getRequest: function(ev) {
            var request;
            return this.elm.$requestButton.attr("disabled") || (request = T.Utils.onAjaxControllerTriggered(ev, !0)),
            !!request && (this.doneClicks++,
            this.doneClicks === this.maxClicks && (this.elm.$requestButton.attr("disabled", "disabled"),
            this.elm.$requestButton.css("cursor", "default")),
            !0)
        },
        onClickRequestButton: function(ev) {
            return ev.preventDefault(),
            T.Utils.debounce(function(_this) {
                return function(ev) {
                    return _this.getRequest(ev)
                }
            }(this), 250, !0)(ev)
        }
    })
}(jQuery),
function($) {
    var glob_button, glob_common, glob_config, glob_month, glob_weekday;
    glob_common = window.localization.messages.common,
    glob_button = glob_common.button,
    glob_month = glob_common.month,
    glob_weekday = glob_common.weekday,
    glob_config = window.localization.configurations,
    T.Module.FormInput.Calendar = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            mod = this,
            mod.$ctx = $(this._ctx),
            $.extend(this.elm, {
                $calendar: this.$ctx
            }),
            mod.configuration = mod.$ctx.data(),
            mod.configuration.dateDisplayFormat = glob_config.dateFormat.toUpperCase(),
            mod.configuration.dateFormat = "YYYY-MM-DD",
            mod.numberOfMonths = 1,
            mod.initCalendar(),
            this._events.on("viewportChanged", function(_this) {
                return function(viewport) {
                    return _this.onViewportChange(viewport)
                }
            }(this)),
            this.onViewportChange(T.Utils.getViewport()),
            $(document).on("keyup", $.proxy(mod.onKeyup, this))
        },
        checkDisabledDate: function(date) {
            var d, disabledDays, i, len;
            if (this.configuration.dateDisabledDays)
                for (disabledDays = this.configuration.dateDisabledDays.split(","),
                i = 0,
                len = disabledDays.length; i < len; i++)
                    if (d = disabledDays[i],
                    moment(date).format(this.configuration.dateFormat) === d.trim())
                        return !0;
            return !1
        },
        initCalendar: function() {
            var settings;
            return settings = {
                checkIfNativeDate: function() {
                    return !1
                },
                classes: "m-forminput-datepicker input calendar hidden",
                dayOffset: 0,
                format: this.configuration.dateDisplayFormat,
                outputFormat: this.configuration.dateFormat,
                pikadayOptions: {
                    bound: !1,
                    defaultDate: moment(),
                    disableDayFn: $.proxy(this.checkDisabledDate, this),
                    firstDay: this.getFirstDay(),
                    mainCalendar: "left",
                    numberOfMonths: this.numberOfMonths,
                    setDefaultDate: !0,
                    showMonthAfterYear: !1,
                    showTime: !1,
                    isRTL: this.getTextDireciton(),
                    i18n: {
                        previousMonth: glob_button.previous,
                        nextMonth: glob_button.next,
                        months: [glob_month.january.long, glob_month.february.long, glob_month.march.long, glob_month.april.long, glob_month.may.long, glob_month.june.long, glob_month.july.long, glob_month.august.long, glob_month.september.long, glob_month.october.long, glob_month.november.long, glob_month.december.long],
                        weekdays: [glob_weekday.sunday.long, glob_weekday.monday.long, glob_weekday.tuesday.long, glob_weekday.wednesday.long, glob_weekday.thursday.long, glob_weekday.friday.long, glob_weekday.saturday.long],
                        weekdaysShort: [glob_weekday.sunday.short, glob_weekday.monday.short, glob_weekday.tuesday.short, glob_weekday.wednesday.short, glob_weekday.thursday.short, glob_weekday.friday.short, glob_weekday.saturday.short]
                    },
                    theme: "m-forminput-datepicker calendar container"
                },
                placeholder: ""
            },
            this.configuration.dateMax && (settings.pikadayOptions.maxDate = moment(this.configuration.dateMax).toDate()),
            this.configuration.dateMin && (settings.pikadayOptions.minDate = moment(this.configuration.dateMin).toDate()),
            this.configuration.dateDisableWeekends && (settings.pikadayOptions.disableWeekends = this.configuration.dateDisableWeekends),
            this.configuration.defaultDate && (settings.pikadayOptions.defaultDate = moment(this.configuration.defaultDate).toDate()),
            settings.pikadayOptions.setDefaultDate && this.$ctx.val(moment(this.configuration.defaultDate).format(this.configuration.dateFormat)),
            this.pikadayinstance = pikadayResponsive(this.$ctx, settings),
            this.configurateWrapper()
        },
        stepDate: function(step) {
            var date;
            for (date = this.pikadayinstance.pikaday.getMoment(),
            date.add(step, "d"); this.checkDisabledDate(date); )
                date.add(step, "d");
            return this.pikadayinstance.pikaday.setMoment(date)
        },
        onKeyup: function(ev) {
            switch (ev.which) {
            case 39:
                this.stepDate(1);
                break;
            case 37:
                this.stepDate(-1)
            }
        },
        configurateWrapper: function() {
            var mod;
            return mod = this,
            mod.elm.$wrapper = mod.$ctx.parent(),
            mod.setParentAttributes(["data-field-nr"]),
            mod.moveClassToParent()
        },
        setParentAttributes: function(attributes) {
            var a, i, len, mod, results;
            for (mod = this,
            results = [],
            i = 0,
            len = attributes.length; i < len; i++)
                a = attributes[i],
                results.push(mod.elm.$wrapper.attr(a, mod.$ctx.attr(a)));
            return results
        },
        moveClassToParent: function() {
            var mod;
            return mod = this,
            mod.elm.$wrapper.attr("class", mod.$ctx.attr("class")).end().attr("class", "")
        },
        onViewportChange: function(viewport) {
            return "desktop" === viewport ? this.numberOfMonths = 2 : this.numberOfMonths = 1,
            this.pikadayinstance.pikaday._o.numberOfMonths = this.numberOfMonths,
            this.pikadayinstance.pikaday.gotoMonth(this.pikadayinstance.pikaday.getMoment().toDate().getMonth()),
            this.pikadayinstance.pikaday.draw()
        },
        getFirstDay: function() {
            switch (glob_config.firstDayOfWeek) {
            case "sunday":
                return 0;
            case "monday":
                return 1;
            case "tuesday":
                return 2;
            case "wednesday":
                return 3;
            case "thursday":
                return 4;
            case "friday":
                return 5;
            case "saturday":
                return 6;
            default:
                return 0
            }
        },
        getTextDireciton: function() {
            return "true" === glob_config.textDirectionRightToLeft
        }
    })
}(jQuery),
function($) {
    var glob_button, glob_common, glob_config, glob_month, glob_weekday;
    glob_config = window.localization.configurations,
    glob_common = window.localization.messages.common,
    glob_button = glob_common.button,
    glob_month = glob_common.month,
    glob_weekday = glob_common.weekday,
    T.Module.FormInput.DatePicker = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            $.extend(this.elm = {
                $datePicker: this.$ctx
            }),
            $.extend(this.stateclass, {
                error: "has-error",
                noerror: "has-no-error",
                errorrequired: "is-not-selected",
                focused: "had-focus",
                empty: "is-empty",
                readonly: "[readonly]",
                ajaxError: "has-ajax-error"
            }),
            this.configuration = this.$ctx.data(),
            this.configuration.dateDisplayFormat = glob_config.dateFormat.toUpperCase(),
            this.configuration.dateFormat = "YYYY-MM-DD",
            this.configuration.blockAll = !1,
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            this._events.on("form:trigger", function(_this) {
                return function(data) {
                    return _this.onFormTrigger(data)
                }
            }(this)),
            this._events.on("forminput-datepicker:deliveryDate", function(_this) {
                return function(data) {
                    return _this.onUpdateDeliveryDate(data)
                }
            }(this)),
            this.elm.$datePicker.is(this.stateclass.readonly) ? this.formatOutputedDate() : this.initDatePicker(),
            resolve()
        },
        addLeadingZero: function(date) {
            return 1 === date.length ? "0" + date : date
        },
        checkDisabledDate: function(date) {
            var availableDays, blockedDays, cfg, d, d2, dayOfWeek, disableDate, i, j, len, len1, momentDate, shiftedBlockedDays;
            if (shiftedBlockedDays = [],
            "undefined" != typeof this.configuration.nonDeliveryDaysOfWeek && ("string" != typeof this.configuration.nonDeliveryDaysOfWeek && (this.configuration.nonDeliveryDaysOfWeek = this.configuration.nonDeliveryDaysOfWeek.toString()),
            blockedDays = this.configuration.nonDeliveryDaysOfWeek.split(","),
            shiftedBlockedDays = this.shiftDays(blockedDays)),
            cfg = this.configuration.availableDays,
            cfg && cfg.length > 0) {
                for (availableDays = "string" == typeof cfg ? cfg.split(",") : cfg,
                momentDate = moment(date).format(this.configuration.dateFormat).trim(),
                dayOfWeek = date.getDay(),
                disableDate = !0,
                i = 0,
                len = availableDays.length; i < len; i++)
                    if (d = availableDays[i],
                    momentDate === d)
                        for (disableDate = !1,
                        j = 0,
                        len1 = shiftedBlockedDays.length; j < len1; j++)
                            d2 = shiftedBlockedDays[j],
                            dayOfWeek === d2 && (disableDate = !0);
                return disableDate
            }
            if (this.configuration.blockAll)
                return !0
        },
        checkForInvalidDateString: function(value) {
            return "Invalid date" === value.toString() || "Invalid Date" === value.toString()
        },
        invertDatePickerLayout: function() {
            var $wrapper, stash;
            if ($wrapper = this.$ctx.parent(),
            $wrapper.hasClass("date-picker"))
                return this.checkForInvalidDateString(this.$ctx.val()) && this.$ctx.attr("value", ""),
                stash = $wrapper.attr("class"),
                this.$ctx.parent().replaceWith(this.$ctx.attr({
                    type: "text",
                    class: stash
                }))
        },
        initDatePicker: function() {
            var mod;
            return mod = this,
            mod.pikadayinstance = "",
            mod.pikadayinstance = pikadayResponsive(mod.elm.$datePicker, {
                format: this.configuration.dateDisplayFormat,
                outputFormat: this.configuration.dateFormat,
                checkIfNativeDate: function() {},
                placeholder: mod.getPlaceholder(),
                classes: "m-forminput input",
                dayOffset: 0,
                pikadayOptions: {
                    firstDay: this.getFirstDay(),
                    disableDayFn: mod.configuration.disabledays ? $.proxy(this.checkDisabledDate, this) : null,
                    minDate: !!mod.configuration.disabledays && moment().toDate(),
                    showTime: !1,
                    isRTL: this.getTextDireciton(),
                    yearRange: [1900, (new Date).getFullYear()],
                    defaultDate: mod.configuration.defaultDate ? new Date(mod.configuration.defaultDate) : void 0,
                    setDefaultDate: !!mod.configuration.defaultDate,
                    i18n: {
                        previousMonth: glob_button.previous,
                        nextMonth: glob_button.next,
                        months: [glob_month.january.long, glob_month.february.long, glob_month.march.long, glob_month.april.long, glob_month.may.long, glob_month.june.long, glob_month.july.long, glob_month.august.long, glob_month.september.long, glob_month.october.long, glob_month.november.long, glob_month.december.long],
                        weekdays: [glob_weekday.sunday.long, glob_weekday.monday.long, glob_weekday.tuesday.long, glob_weekday.wednesday.long, glob_weekday.thursday.long, glob_weekday.friday.long, glob_weekday.saturday.long],
                        weekdaysShort: [glob_weekday.sunday.short, glob_weekday.monday.short, glob_weekday.tuesday.short, glob_weekday.wednesday.short, glob_weekday.thursday.short, glob_weekday.friday.short, glob_weekday.saturday.short]
                    }
                }
            }),
            mod.configurateWrapper(),
            this.elm.$datePicker.closest('[data-t-name="CustomFilterDateSelection"]').trigger("inputdatepicker:initdatepicker", {
                nr: this.elm.$datePicker.data("picker-nr"),
                obj: mod.pikadayinstance
            })
        },
        configurateWrapper: function() {
            var mod;
            return mod = this,
            mod.elm.$wrapper = mod.$ctx.parent(),
            mod.elm.$next = mod.$ctx.next(),
            mod.elm.$input = $("+input", mod.elm.$datePicker),
            mod.setParentAttributes(["data-field-nr"]),
            mod.moveClassToParent(),
            mod.handleForminputEvents(mod.elm.$datePicker.filter("[required]").length)
        },
        handleForminputEvents: function(required) {
            return this.elm.$input.on("focus", function(_this) {
                return function(ev) {
                    return _this.checkForInvalidDateString(_this.$ctx.val()) && _this.$ctx.attr("value", ""),
                    _this._parent.toggleStateClass(_this.stateclass.focused, !1, _this.elm.$wrapper),
                    _this._parent.toggleStateClass(_this.stateclass.error + " " + _this.stateclass.noerror, !1, _this.elm.$wrapper),
                    _this._parent.toggleStateClass(_this.stateclass.error + " " + _this.stateclass.noerror, !1, _this.elm.$next)
                }
            }(this)),
            this.elm.$input.on("focusout", function(_this) {
                return function(ev) {
                    return _this.checkForInvalidDateString(_this.$ctx.val()) && _this.$ctx.attr("value", ""),
                    _this._parent.toggleStateClass(_this.stateclass.focused, !0, _this.elm.$wrapper)
                }
            }(this)),
            this.elm.$input.on("keyup", function(_this) {
                return function(ev) {
                    return _this.checkForInvalidDateString(_this.$ctx.val()) && _this.$ctx.attr("value", ""),
                    _this._parent.toggleStateClass(_this.stateclass.error + " " + _this.stateclass.noerror, !1, _this.elm.$wrapper),
                    _this._parent.toggleStateClass(_this.stateclass.error + " " + _this.stateclass.noerror, !1, _this.elm.$next)
                }
            }(this)),
            required && (this.elm.$input.attr("required", !0),
            this.elm.$input.on("focusout keyup", function(_this) {
                return function(ev) {
                    var target;
                    return target = ev.currentTarget,
                    _this._parent.toggleStateClass(_this.stateclass.errorrequired, "" === target.value || _this.checkForInvalidDateString(target.value), _this.elm.$wrapper)
                }
            }(this))),
            this.elm.$input.on("focusout keyup", function(_this) {
                return function(ev) {
                    var target;
                    if (target = ev.currentTarget,
                    "Invalid date" === target.value || _this.elm.$wrapper.hasClass(_this.stateclass.ajaxError))
                        return $(_this).attr("value", "")
                }
            }(this))
        },
        setParentAttributes: function(attributes) {
            var a, i, len, mod, results;
            for (mod = this,
            results = [],
            i = 0,
            len = attributes.length; i < len; i++)
                a = attributes[i],
                results.push(mod.elm.$wrapper.attr(a, mod.$ctx.attr(a)));
            return results
        },
        moveClassToParent: function() {
            var mod;
            return mod = this,
            mod.$ctx.hasClass("has-error") && mod.elm.$next.addClass("has-error"),
            mod.$ctx.hasClass("has-ajax-error") && mod.elm.$next.addClass("has-ajax-error"),
            mod.elm.$wrapper.attr("class", mod.$ctx.attr("class")).end().attr("class", "")
        },
        formatOutputedDate: function() {
            var date;
            return date = new Date(this.$ctx.val()),
            this.checkForInvalidDateString(date) ? (console.info("true"),
            date = "",
            this.$ctx.attr("value", ""),
            !0) : (this.elm.$clone = this.$ctx.clone(),
            this.$ctx.attr("type", "hidden").after(function(_this) {
                return function() {
                    return _this.elm.$clone.attr("disabled", !0).val(function() {
                        return _this.configuration.dateDisplayFormat.replace(/YYYY/, date.getFullYear()).replace(/MM/, _this.addLeadingZero((date.getMonth() + 1).toString())).replace(/DD/, _this.addLeadingZero(date.getDate().toString()))
                    })
                }
            }(this)))
        },
        getFirstDay: function() {
            switch (glob_config.firstDayOfWeek) {
            case "sunday":
                return 0;
            case "monday":
                return 1;
            case "tuesday":
                return 2;
            case "wednesday":
                return 3;
            case "thursday":
                return 4;
            case "friday":
                return 5;
            case "saturday":
                return 6;
            default:
                return 0
            }
        },
        getPlaceholder: function() {
            var mod, placeholder;
            return mod = this,
            placeholder = mod.elm.$datePicker.attr("placeholder") || "",
            mod.elm.$datePicker.attr("placeholder", ""),
            placeholder
        },
        getTextDireciton: function() {
            return "true" === glob_config.textDirectionRightToLeft
        },
        shiftDays: function(arrIndex) {
            var i, len, shiftedIndex, x, y;
            for (shiftedIndex = [],
            i = 0,
            len = arrIndex.length; i < len; i++)
                x = arrIndex[i],
                y = parseInt(x, 10) - 1,
                shiftedIndex.push(y);
            return shiftedIndex
        },
        onFormTrigger: function(data) {
            var mod;
            if (mod = this,
            0 !== mod.elm.$datePicker.closest(data.$form).length)
                switch (data.action) {
                case "readonly":
                    if (mod.pikadayinstance)
                        return mod.pikadayinstance.pikaday.destroy(),
                        mod.invertDatePickerLayout(),
                        mod.$ctx.addClass(data.editclass),
                        mod.$ctx.attr("readonly", !0),
                        mod.formatOutputedDate();
                    break;
                case "editable":
                    if (mod.$ctx.hasClass(data.editclass))
                        return mod.$ctx.attr("readonly", !1),
                        mod.elm.$clone.remove(),
                        mod.initDatePicker();
                    break;
                case "ajaxerror":
                    return mod._parent.toggleStateClass(mod.stateclass.ajaxError, data.showAjaxError, mod.elm.$wrapper)
                }
        },
        onUpdateDeliveryDate: function(data) {
            var mod;
            if (mod = this,
            null != data.dates && (mod.configuration.availableDays = data.dates),
            null != data.blockedDays && (mod.configuration.nonDeliveryDaysOfWeek = data.blockedDays),
            null != data.blockAll)
                return mod.configuration.blockAll = data.blockAll
        }
    })
}(jQuery),
function($) {
    T.Module.FormInput.Dropdown = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            mod = this,
            mod.$dropdown = mod.$ctx,
            mod.$select = mod.$("select"),
            mod.$selectlink = mod.$select.filter(".js-input-select-link"),
            mod.$constrainttrigger = mod.$dropdown.filter(""),
            mod.$required = mod.$select.filter("[required]"),
            mod.requiredclass = "is-not-selected",
            mod.inactiveWithoutValueClass = "inactive-without-value",
            mod.selectonlyclasses = ["js-trigger-ajax-request", "js-input-select-link"].join(" "),
            mod.ctxonlyclasses = "js-make-editable has-error",
            mod.initDropdown(),
            mod.$required.on({
                change: function(ev) {
                    var $requiredSelect;
                    return $requiredSelect = $(ev.currentTarget),
                    mod.updateRequired($requiredSelect)
                }
            }),
            mod.$selectlink.on({
                change: function(ev) {
                    return mod.followOptionLink(ev)
                }
            }),
            mod.$dropdown.on("edit", $.proxy(function(ev, eventData) {
                var $disable, $enable, $requiredSelect, $target, invertReadonly;
                return $target = $(ev.currentTarget),
                $enable = $target.find("select"),
                $disable = $target.find("input"),
                invertReadonly = eventData.invert,
                $requiredSelect = $target.find("select[required]"),
                mod.updateRequired($requiredSelect),
                mod._parent.toggleDisabled($enable, $disable, invertReadonly),
                mod.onUpdateInactiveWithoutValue(invertReadonly)
            }, mod)),
            this._events.on("select:updateInactiveWithoutValue", function(_this) {
                return function(blnHideIntro) {
                    return _this.onUpdateInactiveWithoutValue(blnHideIntro)
                }
            }(this)),
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this._parent.sync(),
            this.state.attrConstraintTrigger = Boolean(this.constraint.attr.url),
            this.state.typeConstraintTrigger = Boolean(this.constraint.type.url),
            this.state.constraintTrigger = this.state.attrConstraintTrigger || this.state.typeConstraintTrigger,
            this.isAutocompleteTrigger || this.$dropdown.on("change", function(_this) {
                return function(ev) {
                    return _this.onSelect(ev)
                }
            }(this)),
            this.$dropdown.on("triggerconstraint", function(_this) {
                return function(ev) {
                    return _this.onSelect(ev)
                }
            }(this)),
            this.isSynced = !0)
        },
        initDropdown: function() {
            var mod;
            return mod = this,
            T.Utils.registerMq("md", {
                setup: function() {
                    if (mod.$select.is(":disabled"))
                        return mod.$select.closest(".select-wrap").addClass("select-disabled")
                },
                match: function() {
                    return mod.$select.select2({
                        dropdownAutoWidth: !0,
                        dropdownParent: $("body"),
                        minimumResultsForSearch: 1 / 0
                    }),
                    mod.updateRequired(mod.$required),
                    mod.onUpdateInactiveWithoutValue(!0),
                    mod.$select.on("select2:open", $.proxy(mod.onOpenSelect2, mod)),
                    mod.$select.on("select2:close", function(e) {
                        return mod.$dropdown.addClass("had-focus")
                    }),
                    mod.$dropdown.removeClass(mod.selectonlyclasses),
                    mod.$select.removeClass(mod.ctxonlyclasses)
                },
                unmatch: function() {
                    return mod.$select.select2("destroy")
                }
            })
        },
        makeEditable: function(ev, blnInvertReadonly) {
            var $el;
            return $el = $(ev.currentTarget),
            $el.find("select").attr("disabled", blnInvertReadonly),
            $el.find("input").attr("disabled", !blnInvertReadonly)
        },
        followOptionLink: function(ev) {
            var mod, target;
            if (mod = this,
            target = ev.currentTarget,
            0 !== target.selectedIndex)
                return window.location.href = target.value
        },
        updateRequired: function($select) {
            var $requiredForminput, $requiredSelect, isSelected, mod, selectedValue;
            if (mod = this,
            "undefined" != typeof $select)
                return $requiredSelect = $select,
                $requiredForminput = $requiredSelect.closest(".m-forminput-dropdown"),
                selectedValue = $requiredSelect.val(),
                isSelected = null != selectedValue && selectedValue.length > 0,
                $requiredForminput.toggleClass(mod.requiredclass, !isSelected)
        },
        onOpenSelect2: function() {
            var $select2, $wrapper, mod;
            if (mod = this,
            $select2 = mod.$(".select2"),
            $wrapper = mod.$(".select2-dropdown").parent(),
            $(".select2-container").width(mod.$dropdown.width()),
            $wrapper.length)
                return $wrapper.css({
                    left: 0,
                    top: $select2.position().top + $select2.outerHeight(),
                    width: $select2.outerWidth()
                })
        },
        onUpdateInactiveWithoutValue: function(blnHideIntro) {
            var $select, mod;
            if (mod = this,
            $select = mod.$select.filter(":visible"),
            ($select.is(":disabled") || $select.is("[readonly]")) && !$select.val())
                return $select.closest(".select-wrap").toggleClass(mod.inactiveWithoutValueClass, blnHideIntro)
        },
        onSelect: function() {
            if (this.constraint && this.state.constraintTrigger) {
                if (this.$select.is(":invalid"))
                    return !1;
                if (this.state.attrConstraintTrigger) {
                    if (!this.$select.val())
                        return !1;
                    this.constraintRequest("attr")
                } else
                    this.state.typeConstraintTrigger && this.constraintRequest("type")
            }
            return !0
        }
    })
}(jQuery),
function($) {
    T.Module.FormInput.MultilineDropdown = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            mod = this,
            mod.$dropdown = mod.$ctx,
            mod.$select = $("select", mod.$dropdown),
            mod.$selectlink = mod.$select.filter(".js-input-select-link"),
            mod.$required = mod.$select.filter('[required="true"]'),
            mod.selectonlyclasses = ["js-trigger-ajax-request"].join(" "),
            mod.ctxonlyclasses = "js-make-editable has-error",
            mod.initDropdown(),
            mod.$dropdown.on("edit", $.proxy(function(ev, eventData) {
                var $disable, $enable, $target, invertReadonly;
                return $target = $(ev.currentTarget),
                $enable = $target.find("select"),
                $disable = $target.find("input"),
                invertReadonly = eventData.invert,
                mod._parent.toggleDisabled($enable, $disable, invertReadonly)
            }, mod)),
            mod.$required.on({
                change: function(ev) {
                    return mod.$dropdown.removeClass("is-not-selected")
                }
            }),
            mod.$selectlink.on({
                change: function(ev) {
                    return mod.followOptionLink(ev)
                }
            }),
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this._parent.sync(),
            this.state.attrConstraintTrigger = Boolean(this.constraint.attr.url),
            this.state.typeConstraintTrigger = Boolean(this.constraint.type.url),
            this.state.constraintTrigger = this.state.attrConstraintTrigger || this.state.typeConstraintTrigger,
            this.isAutocompleteTrigger || this.$dropdown.on("change", function(_this) {
                return function(ev) {
                    return _this.onSelect(ev)
                }
            }(this)),
            this.$dropdown.on("triggerconstraint", function(_this) {
                return function(ev) {
                    return _this.onSelect(ev)
                }
            }(this)),
            this.isSynced = !0)
        },
        initDropdown: function() {
            var content, mod;
            return mod = this,
            content = function(option) {
                var $option;
                return option.id ? $option = $("<div>" + option.element.dataset.content + "</div>") : option.text
            }
            ,
            mod.$select.select2({
                dropdownParent: mod.$ctx,
                minimumResultsForSearch: 1 / 0,
                width: "style",
                templateResult: content
            }),
            mod.$dropdown.removeClass(mod.selectonlyclasses),
            mod.$select.removeClass(mod.ctxonlyclasses),
            mod.$select.on("select2:open", function() {
                var $select2;
                return $select2 = mod.$(".select2"),
                mod.$(".select2-dropdown").parent().css({
                    left: 0,
                    top: $select2.position().top + $select2.outerHeight(),
                    width: $select2.outerWidth()
                }),
                mod.$select.on("select2:close", function(e) {
                    return mod.$dropdown.addClass("had-focus")
                })
            })
        },
        followOptionLink: function(ev) {
            var mod, target;
            if (mod = this,
            target = ev.currentTarget,
            0 !== target.selectedIndex)
                return window.location.href = target.value
        },
        onSelect: function() {
            if (this.constraint && this.state.constraintTrigger) {
                if (this.$select.is(":invalid"))
                    return !1;
                if (this.state.attrConstraintTrigger) {
                    if (!this.$select.val())
                        return !1;
                    this.constraintRequest("attr")
                } else
                    this.state.typeConstraintTrigger && this.constraintRequest("type")
            }
            return !0
        }
    })
}(jQuery),
function($) {
    T.Module.FormInput.SliderCaptcha = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            mod = this,
            mod.$ctx = $(this._ctx),
            mod.$captchaKeyField = mod.$(".js-captcha-key"),
            mod.captchaKeyValue = mod.$ctx.data("captcha-key"),
            mod.ulockUrl = mod.$ctx.data("unlock-url"),
            mod.$captchaValueField = mod.$(".js-captcha-token"),
            mod.$form = mod.$ctx.closest('[data-t-name="Form"]'),
            mod.$slider = mod.$(".js-slider-captcha"),
            mod.$sliderValue = mod.$(".js-slider-captcha-value"),
            mod.disableSubmit(),
            mod.setUpSlideCaptcha(),
            mod.onUiSliderEnd = $.proxy(mod, "onUiSliderEnd"),
            mod.$slider[0].noUiSlider.on("end", mod.onUiSliderEnd)
        },
        sync: function() {},
        disableSubmit: function() {
            var mod;
            return mod = this,
            mod._events.emit("form:disableSubmit", {
                id: mod.$ctx.data("t-id")
            })
        },
        enableSubmit: function() {
            var mod;
            return mod = this,
            mod._events.emit("form:enableSubmit", {
                id: mod.$ctx.data("t-id")
            })
        },
        getCaptcha: function() {
            var mod, request, response;
            return mod = this,
            !!(request = T.Utils.startAjaxRequest("unlock", null, {
                ckey: mod.captchaKeyValue
            })) && (response = request[0],
            response.done($.proxy(mod.setCaptcha, mod)).fail($.proxy(mod.disableSubmit, mod)))
        },
        setCaptcha: function(response) {
            var mod;
            return mod = this,
            mod.$captchaValueField.val(response.token),
            mod.enableSubmit()
        },
        setUpSlideCaptcha: function() {
            var mod;
            return mod = this,
            mod.$captchaKeyField.val(mod.captchaKeyValue),
            noUiSlider.create(mod.$slider[0], {
                start: [0],
                range: {
                    min: 0,
                    max: 1
                }
            })
        },
        onUiSliderEnd: function(values) {
            var mod, val;
            mod = this,
            val = parseInt(values[0]),
            1 === val ? (mod.$sliderValue.val(val).trigger("change"),
            mod.getCaptcha(),
            mod._parent.toggleStateClass("has-error", !1)) : (mod.$slider[0].noUiSlider.set(0),
            mod.disableSubmit())
        }
    })
}(jQuery),
function($) {
    T.Module.FormInput.TextArea = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            mod = this,
            mod.$ctx = $(mod._ctx),
            mod.$textAreaInput = mod.$("textarea"),
            mod.$textAreaCharacterCounter = mod.$(".character-counter"),
            mod.$textAreaInput.is("[required]") && mod.$ctx.addClass("is-required"),
            void 0 !== mod.$textAreaCharacterCounter.html() && mod.initTextArea(),
            mod.elm.$input = mod.$textAreaInput,
            mod.$ctx.on("edit", $.proxy(function(ev, eventData) {
                var invertReadonly;
                return invertReadonly = eventData.invert,
                mod._parent.makeEditable(mod.$textAreaInput, invertReadonly)
            }, mod))
        },
        initTextArea: function() {
            return this.maxLength = void 0 !== this.$textAreaInput.attr("maxlength") && this.$textAreaInput.attr("maxlength"),
            this.$textAreaInput.on("keyup", $.proxy(this.onTextAreaInputChange, this)),
            this.onTextAreaInputChange()
        },
        onTextAreaInputChange: function(ev) {
            if (this.$textAreaInput = void 0 === ev ? this.$textAreaInput[0] : ev.target,
            this.maxLength !== !1)
                return this.length = this.$textAreaInput.value.length,
                this.$textAreaCharacterCounter.text(this.maxLength - this.length),
                13 === ev.which && (this.$textAreaInput.value = this.$textAreaInput.value.trim(),
                this.$textAreaInput.value = this.$textAreaInput.value.replace(/(?:\r\n|\r|\n)/g, ""),
                this.length = this.$textAreaInput.value.length),
                this.$textAreaCharacterCounter.text(this.maxLength - this.length)
        }
    })
}(jQuery),
function($) {
    var stateClassVideoLayerLinkHidden;
    stateClassVideoLayerLinkHidden = "hidden",
    T.Module.Layer.ClipLister = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.$video = this.$ctx.find(".m-video-cliplister"),
            this.layerVideoId = this.$video.data("video-id"),
            this._events.on("contenttextmedia:video-prechecked", function(_this) {
                return function(data) {
                    return _this.onVideoPrechecked(data)
                }
            }(this))
        },
        onVideoPrechecked: function(data) {
            if (this.layerVideoId === data.videoId)
                return $("[data-layer-id='" + this.configuration.id + "']").removeClass(stateClassVideoLayerLinkHidden)
        }
    })
}(jQuery),
function($, doT) {
    var containerInnerSelector;
    containerInnerSelector = ".js-layer-container-inner",
    T.Module.Layer.DealerLocator = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.$containerInner = this.$(containerInnerSelector),
            this.onAppendMapToLayer = jQuery.proxy(this, "onAppendMapToLayer"),
            this.doT = doT,
            this._events.on("t.sync", $.proxy(this.sync, this)),
            this._events.on("appendMapToLayer", this.onAppendMapToLayer)
        },
        sync: function() {
            var mod;
            mod = this
        },
        onAppendMapToLayer: function(data) {
            return this.$containerInner.append(data.mapNode),
            this._parent.showLayer(data.$evTarget, !0)
        }
    })
}(jQuery, window.doT),
function($, doT) {
    T.Module.Layer.OnlineDealer = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this._events.on("showOnlineDealerLayer", this.onShowOnlineDealerLayer)
        },
        sync: function() {
            var mod;
            mod = this
        },
        onShowOnlineDealerLayer: function(data) {
            return this._parent.showLayer(data.$evTarget, !1)
        }
    })
}(jQuery, window.doT),
function($, doT) {
    T.Module.Layer.Iframe = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.isSynced = !1,
            this.$ctx = $(this._ctx),
            this.configuration = this.$ctx.data(),
            this.$iframe = this.$ctx.find("iframe"),
            this.sync = $.proxy(this.sync, this),
            this.onShowIframeLayer = $.proxy(this.onShowIframeLayer, this),
            this._events.on("showIframeLayer", this.onShowIframeLayer)
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0)
        },
        onShowIframeLayer: function(data) {
            return data.url && this.$iframe.attr("src", data.url),
            this._parent.showLayer(data.$evTarget, !1)
        }
    })
}(jQuery, window.doT),
function($) {
    var downloadTargetSelector;
    downloadTargetSelector = ".js-change-download:not(.lazyload, .lazyloaded)",
    T.Module.MediaGallery.Pressdetail = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            mod = this,
            this.$downloadTarget1 = this.$("[data-target-dpi1]"),
            this.$downloadTarget2 = this.$("[data-target-dpi2]"),
            this._events.on("mediagallery:changedownload", $.proxy(this.onChangeDownload, this)),
            this.initCurrentSlideDownloads(),
            resolve()
        },
        sync: function() {},
        initCurrentSlideDownloads: function() {
            return this._events.emit("mediagallery:changedownload", {
                currentDownload: this.getCurrentDownloadBySlide(this.$mainSlider.find(".slick-current"))
            })
        },
        getCurrentDownloadBySlide: function($slide) {
            var downloads, url1, url2;
            return url1 = $slide.find(downloadTargetSelector).data("download-dpi1"),
            url2 = $slide.find(downloadTargetSelector).data("download-dpi2"),
            downloads = {
                dpi1: url1,
                dpi2: url2
            }
        },
        onChangeDownload: function(data) {
            return this.$downloadTarget1.attr("href", data.currentDownload.dpi1),
            this.$downloadTarget2.attr("href", data.currentDownload.dpi2)
        }
    })
}(jQuery),
function($, doT) {
    var sparePartItemSlideTplSelector, sparePartNoResultsSelector;
    sparePartItemSlideTplSelector = ".js-sparepart-item-slide-tpl",
    sparePartNoResultsSelector = ".js-sparepart-no-results",
    T.Module.MediaGallery.Spareparts = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            mod = this,
            mod.doT = doT,
            mod.$ctx = $(mod._ctx),
            mod.$paginationnumber = mod.$(".js-paginationnumber"),
            mod.ajaxDone = !1,
            mod.imagesArray = [],
            mod.sparePartsArray = [],
            mod.downloadArray = [],
            mod.sparepartItemSlideTpl = mod.doT.template(mod.$(sparePartItemSlideTplSelector).html()),
            mod.sparepartNoResultsTpl = mod.doT.template(mod.$(sparePartNoResultsSelector).html()),
            mod.$(".js-mediagallery-zoom").removeClass("hidden"),
            mod._events.on("t.sync", $.proxy(mod.sync, mod)),
            mod._events.on("pageSliderSlideAfterChange", $.proxy(mod.onPageSliderSlideAfterChange, mod)),
            mod._events.on("layerSliderSlideAfterChange", $.proxy(mod.onLayerSliderSlideAfterChange, mod)),
            resolve()
        },
        sync: function() {
            var mod, request;
            if (mod = this,
            !mod.ajaxDone) {
                if (request = T.Utils.startAjaxRequest("mediagallery-spareparts-images", null, "init"),
                !request)
                    return !1;
                request[0].done($.proxy(mod.getSparePartsSuccessCallback, mod)).fail($.proxy(mod.getSparePartsErrorCallback, mod)),
                mod.ajaxDone = !0,
                mod._parent.setSlickDragEvents(!1)
            }
        },
        stop: function() {
            var mod;
            return mod = this,
            mod._events.off("t.sync"),
            mod._events.off("pageSliderSlideAfterChange"),
            mod._events.off("layerSliderSlideAfterChange"),
            mod.$mainSlider.slick("unslick")
        },
        emitSparePartDataChange: function() {
            var indexActiveSlide, mod;
            return mod = this,
            indexActiveSlide = mod.$mainSlider.slick("slickCurrentSlide"),
            mod._events.emit("sparePartDataChange", {
                imageList: mod.imagesArray[indexActiveSlide],
                sparePartList: mod.sparePartsArray[indexActiveSlide]
            })
        },
        disableSwipeEvents: function() {
            var mod;
            return mod = this,
            mod.$mainSlider.slick("slickSetOption", "draggable", !1),
            mod.$mainSlider.slick("slickSetOption", "touchMove", !1),
            mod.$mainSlider.slick("slickSetOption", "swipeToSlide", !1),
            mod.$mainSlider.slick("slickSetOption", "swipe", !1)
        },
        getSparePartsErrorCallback: function(xhr, ajaxOptions, thrownError) {
            return console.info(xhr)
        },
        getSparePartsSuccessCallback: function(xhrData) {
            var data, mod, noResultsHtml;
            if (mod = this,
            null != xhrData && null != xhrData.response) {
                if (data = xhrData.response,
                !(data.length > 0))
                    return mod.stop(),
                    noResultsHtml = mod.sparepartNoResultsTpl({}),
                    mod.$ctx.closest(".js-sparepart-wrapper").empty().append(noResultsHtml),
                    this._events.emit("sparepartsNoResults");
                if ($.each(data, function(index, item) {
                    var slideHtml;
                    return item.index = index,
                    slideHtml = mod.sparepartItemSlideTpl(item),
                    mod.$mainSlider.slick("slickAdd", slideHtml),
                    mod._sandbox.addModules(mod.$mainSlider.find(".js-mediagallery-slide:last-child")[0]),
                    mod.imagesArray.push(item.diagram[0].image),
                    mod.sparePartsArray.push(item.items),
                    mod.downloadArray.push(item.diagram[0].download)
                }),
                mod.disableSwipeEvents(),
                mod.addSliderEventListener(),
                mod.totalNumberOfSlides = data.length,
                mod.currentSlide = 1,
                mod.setPaginationNumbers(),
                mod.emitSparePartDataChange(),
                mod.setDownloadLinks(),
                mod.initializeSparePartLayer(data),
                1 === data.length)
                    return mod._parent.toggleSliderControls(!1)
            }
        },
        initializeSparePartLayer: function(data) {
            var mod;
            return mod = this,
            this._events.emit("initializeSparePartLayer", {
                data: data,
                downloads: mod.downloadArray
            })
        },
        setDownloadLinks: function() {
            var $downloadAllFiles, $downloadFile, indexActiveSlide, mod;
            return mod = this,
            indexActiveSlide = mod.$mainSlider.slick("slickCurrentSlide"),
            $downloadFile = mod.$(".js-spare-part-download-file"),
            $downloadAllFiles = mod.$(".js-spare-part-download-all-files"),
            $downloadFile.find("span").html(mod.downloadArray[indexActiveSlide][0].txt),
            $downloadFile.attr("href", mod.downloadArray[indexActiveSlide][0].href),
            $downloadAllFiles.find("span").html(mod.downloadArray[indexActiveSlide][1].txt),
            $downloadAllFiles.attr("href", mod.downloadArray[indexActiveSlide][1].href)
        },
        setOCRFrame: function() {
            var $ocrFrame, mod;
            if (mod = this,
            mod.$(".a-image-hires .js-sparepart-scan-frame").addClass("hidden"),
            $ocrFrame = mod.$mainSlider.find(".slick-current .a-image-hires .js-sparepart-scan-frame"),
            $ocrFrame.length > 0)
                return $ocrFrame.removeClass("hidden"),
                $ocrFrame.css({
                    left: 0,
                    top: 0
                })
        },
        onPageSliderSlideAfterChange: function() {
            if (this.setOCRFrame(),
            this.emitSparePartDataChange(),
            this.downloadArray.length > 0)
                return this.setDownloadLinks()
        },
        onLayerSliderSlideAfterChange: function(data) {
            var mod;
            return mod = this,
            mod.$mainSlider.slick("slickGoTo", data.currentSlide, !0)
        }
    })
}(jQuery, window.doT),
function($, doT) {
    var sparePartItemSlideTplSelector;
    sparePartItemSlideTplSelector = ".js-sparepart-item-layer-slide-tpl",
    T.Module.MediaGalleryLayer.Spareparts = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            mod = this,
            mod.$ctx = $(mod._ctx),
            mod.doT = doT,
            mod.downloadArray = [],
            mod.sparepartItemSlideTpl = mod.doT.template(mod.$(sparePartItemSlideTplSelector).html()),
            this._events.on("initializeSparePartLayer", $.proxy(this.onInitializeSparePartLayer, this)),
            this._events.on("layerSliderSlideAfterChange", $.proxy(this.onLayerSliderSlideAfterChange, this)),
            this._events.on("layerSliderSlideAfterChange", $.proxy(this.onLayerSliderSlideAfterChange, this)),
            this._events.on("sparepartsNoResults", $.proxy(this.onSparepartsNoResults, this))
        },
        stop: function() {
            var mod;
            return mod = this,
            mod._events.off("initializeSparePartLayer"),
            mod._events.off("layerSliderSlideAfterChange"),
            mod._events.off("sparepartsNoResults"),
            mod.$mainSlider.slick("unslick")
        },
        setDownloadLinks: function() {
            var $downloadAllFiles, $downloadFile, indexActiveSlide, mod;
            return mod = this,
            indexActiveSlide = mod.$mainSlider.slick("slickCurrentSlide"),
            $downloadFile = mod.$(".js-spare-part-download-file"),
            $downloadAllFiles = mod.$(".js-spare-part-download-all-files"),
            $downloadFile.find("span").html(mod.downloadArray[indexActiveSlide][0].txt),
            $downloadFile.attr("href", mod.downloadArray[indexActiveSlide][0].href),
            $downloadAllFiles.find("span").html(mod.downloadArray[indexActiveSlide][1].txt),
            $downloadAllFiles.attr("href", mod.downloadArray[indexActiveSlide][1].href)
        },
        updateSlide: function() {
            var $currentSlide, mod;
            if (mod = this,
            $currentSlide = mod.$mainSlider.find(".slick-current"),
            mod._events.emit("resetFramePosition", {
                $ctx: $currentSlide
            }),
            mod.downloadArray.length > 0)
                return mod.setDownloadLinks()
        },
        onInitializeSparePartLayer: function(eventData) {
            var mod;
            if (mod = this,
            eventData.data.length > 0 && (mod._parent.setSlickDragEvents(!1),
            $.each(eventData.data, function(index, item) {
                var slideHtml;
                return item.index = index,
                slideHtml = mod.sparepartItemSlideTpl(item),
                mod.$mainSlider.slick("slickAdd", slideHtml),
                mod._sandbox.addModules(mod.$mainSlider.find(".js-mediagallery-slide:last-child")[0])
            }),
            mod.totalNumberOfSlides = eventData.data.length,
            eventData.downloads && (mod.downloadArray = eventData.downloads),
            mod.updateSlide(),
            1 === eventData.data.length))
                return mod._parent.toggleSliderControls(!1)
        },
        onLayerSliderSlideAfterChange: function() {
            var mod;
            return mod = this,
            mod.updateSlide()
        },
        onSparepartsNoResults: function() {
            var mod;
            return mod = this,
            mod.stop()
        }
    })
}(jQuery, window.doT),
function($) {
    T.Module.ProductTeaser.SetItem = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject)
        }
    })
}(jQuery),
function($, doT) {
    var buttonGeoLocationSelector, formSelector, inputAddressSelector, inputCountryCodeSelector, inputLatSelector, inputLngSelector, inputUserCountryCodeSelector, inputWrapperSelector, layerSelector, submitSelector, suggestOptionSelector;
    inputWrapperSelector = ".js-searchinput",
    inputAddressSelector = ".js-searchfield-input",
    inputLatSelector = ".js-lat-input",
    inputLngSelector = ".js-lng-input",
    inputCountryCodeSelector = ".js-country-code-input",
    inputUserCountryCodeSelector = ".js-user-country-code-input",
    submitSelector = ".js-searchfield-searchbutton",
    layerSelector = ".js-searchfield-suggestlayer",
    formSelector = ".js-ajax-request",
    buttonGeoLocationSelector = ".js-button-geo-location",
    suggestOptionSelector = ".suggestlayer-results-row :input",
    T.Module.SearchField.DealerLocator = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.doT = doT,
            this.initialize = jQuery.proxy(this, "initialize"),
            this.initByGeoLocation = jQuery.proxy(this, "initByGeoLocation"),
            this.initByUrl = jQuery.proxy(this, "initByUrl"),
            this.checkForCountryCodeContext = jQuery.proxy(this, "checkForCountryCodeContext"),
            this.disableGeoLocation = jQuery.proxy(this, "disableGeoLocation"),
            this.getLatLngByAddress = jQuery.proxy(this, "getLatLngByAddress"),
            this.getLatLngByAddressCallback = jQuery.proxy(this, "getLatLngByAddressCallback"),
            this.getAddressByLatLng = jQuery.proxy(this, "getAddressByLatLng"),
            this.getAddressByLatLngCallback = jQuery.proxy(this, "getAddressByLatLngCallback"),
            this.getAutoCompleteSuggestions = jQuery.proxy(this, "getAutoCompleteSuggestions"),
            this.getDealerLocations = jQuery.proxy(this, "getDealerLocations"),
            this.getDealerLocationsCallback = jQuery.proxy(this, "getDealerLocationsCallback"),
            this.getUrlHashObject = jQuery.proxy(this, "getUrlHashObject"),
            this.displaySuggestions = jQuery.proxy(this, "displaySuggestions"),
            this.setAddressInSearchField = jQuery.proxy(this, "setAddressInSearchField"),
            this.setLatLngForDealerSearch = jQuery.proxy(this, "setLatLngForDealerSearch"),
            this.setUserCountryForDealerSearch = jQuery.proxy(this, "setUserCountryForDealerSearch"),
            this.onChangeInput = jQuery.proxy(this, "onChangeInput"),
            this.onClickButtonGeoLocation = jQuery.proxy(this, "onClickButtonGeoLocation"),
            this.onClickButtonFindDealer = jQuery.proxy(this, "onClickButtonFindDealer"),
            this.onClickSuggestionItem = jQuery.proxy(this, "onClickSuggestionItem"),
            this.onChangeOption = jQuery.proxy(this, "onChangeOption"),
            this._events.on("googleMapsApiReady", $.proxy(this.initialize, this)),
            this.$inputWrapper = this.$(inputWrapperSelector),
            this.$inputAddress = this.$(inputAddressSelector),
            this.$inputLat = this.$(inputLatSelector),
            this.$inputLng = this.$(inputLngSelector),
            this.$inputCountryCode = this.$(inputCountryCodeSelector),
            this.$inputUserCountryCode = this.$(inputUserCountryCodeSelector),
            this.$buttonGeoLocation = this.$(buttonGeoLocationSelector),
            this.$submit = this.$(submitSelector),
            this.$layer = this.$(layerSelector),
            this.$suggestOption = this.$(suggestOptionSelector),
            this.$form = this.$(formSelector),
            this.moduleInitialized = !1,
            this.shouldInitializeByUrl = !1,
            this.hasProductContext = !1,
            this.jsonConfig = void 0,
            this.parentModuleId = this.$ctx.closest(".o-dealerlocator").data("t-id"),
            this.urlObject = void 0,
            this.disableAutoSearchByLocation = !0,
            this.suggestionTpl = this.doT.template(this.$(".js-google-suggestion-template").html()),
            this.googleGeocodeApiUrl = "https://maps.googleapis.com/maps/api/geocode/json",
            this.urlObject = T.Utils.splitUrl(window.location.href),
            this.shouldInitializeByUrl = this.verifyUrlForSearchByUrl()
        },
        checkForCountryCodeContext: function() {
            if (null != this.jsonConfig.countryCode)
                return this.$inputCountryCode.val(this.jsonConfig.countryCode)
        },
        disableGeoLocation: function() {
            return this.$buttonGeoLocation.off("click"),
            this.$buttonGeoLocation.remove(),
            this.$inputWrapper.removeClass("has-geo-location")
        },
        displaySuggestions: function(suggestions, status) {
            var mod, suggestionHtml;
            if (mod = this,
            status === mod.googleMaps.places.PlacesServiceStatus.OK) {
                if (suggestions.length > 0)
                    return mod._parent.validate(),
                    suggestions.parentModuleId = mod.parentModuleId,
                    suggestionHtml = mod.suggestionTpl(suggestions),
                    mod.$layer.empty().append(suggestionHtml)
            } else
                status === mod.googleMaps.places.PlacesServiceStatus.ZERO_RESULTS
        },
        getLatLngByAddress: function(address) {
            var mod, options;
            return mod = this,
            this.geoCoder || (this.geoCoder = new this.googleMaps.Geocoder),
            options = {
                address: address
            },
            null != this.jsonConfig.countryCode && (options.componentRestrictions = {
                country: this.jsonConfig.countryCode
            }),
            this.geoCoder.geocode(options, mod.getLatLngByAddressCallback)
        },
        getAddressByLatLng: function(latLng) {
            var mod;
            return mod = this,
            this.geoCoder || (this.geoCoder = new this.googleMaps.Geocoder),
            this.geoCoder.geocode({
                location: latLng
            }, mod.getAddressByLatLngCallback)
        },
        getLatLngByAddressCallback: function(results, status) {
            var address, location, mod;
            if (mod = this,
            status === mod.googleMaps.GeocoderStatus.OK && results[0])
                return address = results[0].formatted_address,
                location = {
                    lat: results[0].geometry.location.lat(),
                    lng: results[0].geometry.location.lng()
                },
                mod.setUserCountryForDealerSearch(results[0].address_components),
                mod.initializeDealerSearch(location, address)
        },
        getAddressByLatLngCallback: function(results, status) {
            var address, location, mod;
            if (mod = this,
            status === mod.googleMaps.GeocoderStatus.OK && results[0])
                return address = results[0].formatted_address,
                location = {
                    lat: results[0].geometry.location.lat(),
                    lng: results[0].geometry.location.lng()
                },
                mod.setAddressInSearchField(address),
                mod.setUserCountryForDealerSearch(results[0].address_components),
                mod.initializeDealerSearch(location, address)
        },
        getAutoCompleteSuggestions: function(searchTerm) {
            var options, service;
            return options = {
                input: searchTerm,
                types: ["geocode"]
            },
            null != this.jsonConfig.countryCode && (options.componentRestrictions = {
                country: this.jsonConfig.countryCode
            }),
            service = new this.googleMaps.places.AutocompleteService,
            service.getPlacePredictions(options, this.displaySuggestions)
        },
        getDealerLocations: function() {
            var request;
            return this.toggleUserInterface(!1),
            request = T.Utils.startAjaxRequest(this.$form.data("ajax-id")),
            !!request && request[0].done(this.getDealerLocationsCallback)
        },
        getDealerLocationsCallback: function(data) {
            var mod;
            return mod = this,
            mod.toggleUserInterface(!0),
            mod._events.emit("newDealersAvailable", {
                parentModuleId: mod.parentModuleId,
                currentLocation: mod.currentLocation,
                hasProductContext: mod.hasProductContext,
                dealers: data.dealers
            })
        },
        initialize: function(data) {
            if (!this.moduleInitialized) {
                if (this.moduleInitialized = !0,
                this.googleMaps = data.googleMaps,
                this.jsonConfig = data.jsonConfig,
                this.disableAutoSearchByLocation = this.jsonConfig.initiallyCollapsed,
                this.checkForCountryCodeContext(),
                this.$buttonGeoLocation.on("click", this.onClickButtonGeoLocation),
                this.$submit.on("click", this.onClickButtonFindDealer),
                this.$suggestOption.on("change", this.onChangeOption),
                this.shouldInitializeByUrl)
                    return this.initByUrl();
                if (this.disableAutoSearchByLocation !== !0)
                    return this.initByGeoLocation()
            }
        },
        initByUrl: function() {
            var address, location;
            return address = this.urlObject.get.address,
            location = {
                lat: this.urlObject.get.lat,
                lng: this.urlObject.get.lng
            },
            this.setAddressInSearchField(decodeURIComponent(address)),
            this.setLatLngForDealerSearch(location),
            this.getDealerLocations()
        },
        initByGeoLocation: function() {
            var mod;
            if (mod = this,
            this.googleMaps && this.jsonConfig && this.jsonConfig.gmapsOpts.client)
                return "object" != typeof navigator.geolocation ? (mod.toggleUserInterface(!0),
                void mod.disableGeoLocation()) : navigator.geolocation.getCurrentPosition(function(position) {
                    var latLng;
                    return latLng = {
                        lat: position.coords.latitude,
                        lng: position.coords.longitude
                    },
                    mod.getAddressByLatLng(latLng)
                }, function(error) {
                    if (error.code === error.PERMISSION_DENIED)
                        return mod.disableGeoLocation()
                })
        },
        initializeDealerSearch: function(location, address) {
            return this.setLatLngForDealerSearch(location),
            this.getDealerLocations()
        },
        setAddressInSearchField: function(address) {
            return this.$inputAddress.val(address),
            this.$clear.removeClass("hidden"),
            this.$inputAddress.one("click", this.getAutoCompleteSuggestions(address))
        },
        setLatLngForDealerSearch: function(location) {
            return this.$inputLat.val(location.lat),
            this.$inputLng.val(location.lng),
            this.currentLocation = location
        },
        setUserCountryForDealerSearch: function(addressComponents) {
            var userCountryCode;
            if (userCountryCode = "",
            $.each(addressComponents, function(index, addressComponent) {
                if ("country" === addressComponent.types[0])
                    return userCountryCode = addressComponent.short_name
            }),
            "" !== userCountryCode)
                return this.$inputUserCountryCode.val(userCountryCode)
        },
        toggleUserInterface: function(shouldEnable) {
            return shouldEnable ? (this.$inputAddress.removeAttr("disabled"),
            this.$buttonGeoLocation.removeAttr("disabled"),
            this.$submit.removeAttr("disabled"),
            this.$layer.find("input").removeAttr("disabled")) : (this.$inputAddress.attr("disabled", "disabled"),
            this.$buttonGeoLocation.attr("disabled", "disabled"),
            this.$submit.attr("disabled", "disabled"),
            this.$layer.find("input").attr("disabled", "disabled"))
        },
        verifyUrlForSearchByUrl: function() {
            return null != this.urlObject.get && null != this.urlObject.get.lat && null != this.urlObject.get.lng && null != this.urlObject.get.address
        },
        onChangeInput: function() {
            var mod, term;
            return mod = this,
            term = mod.$inputAddress.val(),
            term.length >= 2 ? (this.getAutoCompleteSuggestions(term),
            this._parent.openLayer(),
            this.$clear.removeClass("hidden")) : (this._parent.closeLayer(),
            this.$clear.addClass("hidden")),
            this._parent.validate()
        },
        onChangeOption: function(ev) {
            var address;
            return this.$input.val(ev.currentTarget.value),
            this.$input.trigger("trackingSuggestionSelected"),
            this.validate(),
            address = this.$inputAddress.val(),
            this.getLatLngByAddress(address)
        },
        onClickButtonFindDealer: function(ev) {
            var address;
            return ev.preventDefault(),
            address = this.$inputAddress.val(),
            this.getLatLngByAddress(address)
        },
        onClickButtonGeoLocation: function(ev) {
            return ev.preventDefault(),
            this.initByGeoLocation()
        }
    })
}(jQuery, window.doT),
function($) {
    T.Module.SearchField.DobCity = T.createDecorator({
        start: function(resolve, reject) {
            var codeSelector, mod;
            return this._parent.start(resolve, reject),
            mod = this,
            codeSelector = mod.$ctx.attr("data-postalcode-selector"),
            mod.$postalCodeField = null != codeSelector ? mod.$input.closest("form").find("." + codeSelector) : $()
        },
        getAjaxCallCacheState: function() {
            var mod;
            return mod = this,
            mod.$postalCodeField.val() + "*_*" + mod.$input.val()
        },
        getAjaxRequestFormData: function() {
            var mod, postalCode;
            return mod = this,
            postalCode = null,
            mod.$postalCodeField.length > 0 && (postalCode = mod.$postalCodeField.val()),
            {
                input: "town",
                "dobAddressData.addressData.postalcode": postalCode
            }
        },
        openLayer: function() {
            var mod;
            return mod = this,
            mod._parent.adjustLayerOffsetToFormRow(),
            mod._parent.adjustLayerWidthToFormRow(),
            mod._parent.openLayer()
        }
    })
}(jQuery),
function($) {
    T.Module.SearchField.DobPostalCode = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject)
        },
        getAjaxRequestFormData: function() {
            return {
                input: "postalcode"
            }
        },
        openLayer: function() {
            var mod;
            return mod = this,
            mod._parent.adjustLayerWidthToFormRow(),
            mod._parent.openLayer()
        },
        onChangeOption: function(ev) {
            var citySelector, mod, string, tokens;
            if (mod = this,
            string = ev.currentTarget.value)
                return string.indexOf("::") !== -1 ? (tokens = string.split("::"),
                mod.$input.val(tokens[0]),
                citySelector = mod.$ctx.attr("data-city-selector"),
                tokens.length > 0 && citySelector && (mod.$input.closest("form").find("." + citySelector).val(tokens[1]),
                mod._events.emit("updateProxyValue"))) : mod.$input.val(string),
                mod._parent.validate()
        }
    })
}(jQuery),
function($) {
    T.Module.SearchField.DobStreet = T.createDecorator({
        start: function(resolve, reject) {
            var citySelector, codeSelector, mod;
            return this._parent.start(resolve, reject),
            mod = this,
            codeSelector = mod.$ctx.attr("data-postalcode-selector"),
            mod.$postalCodeField = null != codeSelector ? mod.$input.closest("form").find("." + codeSelector) : $(),
            citySelector = mod.$ctx.attr("data-city-selector"),
            mod.$cityField = null != citySelector ? mod.$input.closest("form").find("." + citySelector) : $()
        },
        getAjaxCallCacheState: function() {
            var mod;
            return mod = this,
            mod.$postalCodeField.val() + "*_*" + mod.$cityField.val() + "*_*" + mod.$input.val()
        },
        getAjaxRequestFormData: function() {
            var city, mod, postalCode;
            return mod = this,
            postalCode = mod.$postalCodeField.val(),
            city = mod.$cityField.val(),
            {
                input: "street",
                "dobAddressData.addressData.postalcode": postalCode,
                "dobAddressData.addressData.town": city
            }
        },
        openLayer: function() {
            var mod;
            return mod = this,
            mod._parent.adjustLayerWidthToFormRow(),
            mod._parent.openLayer()
        }
    })
}(jQuery),
function($, doT) {
    T.Module.SearchField.ENumber = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject)
        }
    })
}(jQuery, window.doT),
function($) {
    T.Module.SearchField.Sparepart = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject)
        },
        onKeydownInput: function(ev) {
            if (13 === ev.keyCode)
                return ev.preventDefault(),
                this.submitSearch()
        },
        onSearchSubmit: function(ev) {
            if ($(ev.currentTarget).find("[data-t-id='" + this.id + "']"))
                return ev.preventDefault(),
                this.submitSearch()
        }
    })
}(jQuery),
function($) {
    T.Module.Stage.Campaign = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.$slider.on("init", $.proxy(this.onStageChange, this)),
            this.$slider.on("beforeChange", $.proxy(this.onStageChange, this))
        },
        onStageChange: function(ev, slick, currentSlide, nextSlide) {
            var backgroundImage;
            this.isSliderInitialized || (currentSlide = 0),
            null != nextSlide && (currentSlide = nextSlide),
            backgroundImage = this.$slider.find(".slide:not(.slick-cloned)").eq(currentSlide).data("backgroundimage"),
            this._events.emit("backgroundimage:set", {
                src: backgroundImage
            })
        }
    })
}(jQuery),
function($) {
    T.Module.Table.QuoteList = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            T.Utils.allSynced = !1,
            this._selector = {
                rowLink: ".js-link",
                telephoneLink: ".js-call",
                paginationPrev: ".js-prev",
                paginationNext: ".js-next",
                headerCells: ".js-sort",
                sortIndicator: ".js-sort-indicator",
                selHiddenSortOrder: ".js-sort-order",
                selHiddenSortColumn: ".js-sort-column",
                selHiddenCurrentPage: ".js-current-page"
            },
            this._state = {
                sortup: "is-ascending",
                sortdown: "is-descending"
            },
            this.elm = {
                $rowLink: $(this._selector.rowLink, this.$ctx),
                $hiddenSortOrder: $(this._selector.selHiddenSortOrder, this.$ctx),
                $hiddenSortColumn: $(this._selector.selHiddenSortColumn, this.$ctx),
                $hiddenCurrentPage: $(this._selector.selHiddenCurrentPage, this.$ctx)
            },
            this._events.on("t.sync", function(_this) {
                return function() {
                    return _this.sync()
                }
            }(this)),
            this.$ctx.on("click", this._selector.rowLink, function(_this) {
                return function(ev) {
                    return _this.onClickOnARow(ev)
                }
            }(this)),
            this.$ctx.on("click", this._selector.telephoneLink, function(_this) {
                return function(ev) {
                    return _this.onClickOnATelephoneLink(ev)
                }
            }(this)),
            this.$ctx.on("click", this._selector.paginationPrev, function(_this) {
                return function(ev) {
                    return _this.onGoingToPreviousTablePage(ev)
                }
            }(this)),
            this.$ctx.on("click", this._selector.paginationNext, function(_this) {
                return function(ev) {
                    return _this.onGoingToNextTablePage(ev)
                }
            }(this)),
            this.$ctx.on("click", this._selector.headerCells, function(_this) {
                return function(ev) {
                    return _this.onClickHeader(ev)
                }
            }(this)),
            this.$ctx.on("tableQuoteList.updateTableData", function(_this) {
                return function(ev) {
                    return _this.onUpdateTableData(ev)
                }
            }(this)),
            resolve()
        },
        sync: function() {
            this.isSynced || (this.isSynced = !0,
            T.Utils.allSynced = !0,
            console.log("{{ name }} sync"))
        },
        startAjaxRequest: function(ev) {
            return T.Utils.onAjaxControllerTriggered(ev, !0),
            !1
        },
        onClickOnARow: function(ev) {
            var url;
            return ev.preventDefault(),
            ev.stopPropagation(),
            url = $(ev.currentTarget).data("details-url"),
            window.location.href = url
        },
        onClickOnATelephoneLink: function(ev) {
            return ev.stopImmediatePropagation()
        },
        onGoingToPreviousTablePage: function(ev) {
            var page;
            return page = parseInt(this.elm.$hiddenCurrentPage.val()) - 1,
            this.elm.$hiddenCurrentPage.val(page),
            this.startAjaxRequest(ev)
        },
        onGoingToNextTablePage: function(ev) {
            var page;
            return page = parseInt(this.elm.$hiddenCurrentPage.val()) + 1,
            this.elm.$hiddenCurrentPage.val(page),
            this.startAjaxRequest(ev)
        },
        onClickHeader: function(ev) {
            var $headcolumn, ascending, sortColumn;
            return $headcolumn = $(ev.currentTarget),
            ascending = $headcolumn.hasClass("is-ascending"),
            $(this._selector.headerCells).removeClass(this._state.sortup + " " + this._state.sortdown),
            sortColumn = $headcolumn.data("sortcolumn"),
            this.elm.$hiddenSortColumn.val(sortColumn),
            this.elm.$hiddenCurrentPage.val("1"),
            ascending ? ($headcolumn.addClass(this._state.sortdown),
            $headcolumn.removeClass(this._state.sortup),
            this.elm.$hiddenSortOrder.val("DESCENDING")) : ($headcolumn.addClass(this._state.sortup),
            $headcolumn.removeClass(this._state.sortdown),
            this.elm.$hiddenSortOrder.val("ASCENDING")),
            this.startAjaxRequest(ev)
        },
        onUpdateTableData: function(ev) {
            return console.log("onUpdateTableData"),
            this.elm.$hiddenCurrentPage.val("1"),
            this.startAjaxRequest(ev)
        }
    })
}(jQuery),
function($, doT) {
    T.Module.Tabs.Static = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this._parent.sync = $.proxy(this, "sync"),
            this._parent.setupTabs = $.proxy(this, "setupTabs"),
            this.elm = {
                $activeTabLink: this.$tabs.find(".is-active")
            },
            T.Utils.allSynced = !1,
            this.isSynced = !1
        },
        sync: function() {
            this.isSynced || (this.setupTabs(),
            this.isSynced = !0,
            T.Utils.allSynced = !0)
        },
        setupTabs: function() {
            var $tab;
            if (this.$ctx.on("click", ".tab-more", this._parent.onClickTabMore),
            this._events.on("reArrangeTabs", this._parent.arrangeTabs),
            this.arrangeTabs(),
            T.Utils.startAddModule = !0,
            $(window).on("resize", this._parent.onWindowResize),
            $tab = this.elm.$activeTabLink,
            $tab.length && $tab.data("jump-to"))
                return T.Utils.scrollToTop($tab.offset().top)
        }
    })
}(jQuery),
function($) {
    T.Module.TeaserSlider.ContentTextMediaSlider = T.createDecorator({
        start: function(resolve, reject) {
            if (this._parent.start(resolve, reject),
            this.slidesToShow = {
                mobile: 1,
                tablet: 1,
                desktop: 1
            },
            this.slidesToScroll = {
                mobile: 1,
                tablet: 1,
                desktop: 1
            },
            this.countSlidesPerPage = 1,
            this.$slides.length <= 1)
                return this.$paginationArrows.addClass("hidden"),
                this.$paginationNumber.addClass("hidden")
        },
        instantiateSlider: function() {
            if (this.$slides.length > 1)
                return this._parent.initSlider()
        },
        initSlider: function() {},
        getSlide: function(slideIndex) {
            return $(this.$slides.get(slideIndex))
        },
        onSlideBeforeChange: function(event, slick, currentSlide, nextSlide) {
            return this._parent.onSlideBeforeChange(event, slick, currentSlide, nextSlide),
            this._events.emit("carouselSliderSlideBeforeChange", {
                currentSlide: currentSlide,
                carousel: this,
                $slide: this.getSlide(currentSlide)
            })
        },
        onSlideAfterChange: function(event, slick, currentSlide) {
            return this._parent.onSlideAfterChange(event, slick, currentSlide),
            this._events.emit("carouselSliderSlideAfterChange", {
                currentSlide: currentSlide,
                carousel: this,
                $slide: $(slick.$slides.get(currentSlide))
            })
        }
    })
}(jQuery),
function($) {
    T.Utils && T.Utils.registerSlideMarkupCloned(function(data) {
        var clonedVideoId;
        if ("Video" === data.$component.data("t-name") && "ClipLister" === data.$component.data("t-decorator"))
            return clonedVideoId = data.$component.data("video-id") + "_" + data.slideClonedId,
            data.$component.attr("data-video-id", clonedVideoId),
            data.$component.data("video-id", clonedVideoId),
            data.$component.find(".video-content").attr("id", clonedVideoId)
    }),
    T.Module.Video.ClipLister = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            this.showVideoControls = !0,
            this.videoId = this.$ctx.data("video-id"),
            this.$videoWrapper = this.$ctx.find(".video-wrapper"),
            this.precheckEnabled = this.$ctx.data("precheck-enabled"),
            this.precheckStateClass = "is-hidden",
            this.precheckEnabled && this.$videoWrapper.addClass(this.precheckStateClass),
            mod = this,
            Cliplister.player({
                elementID: this.videoId,
                requestkey: this.$ctx.data("requestkey"),
                slot: this.$ctx.data("slot"),
                keytype: this.$ctx.data("keytype"),
                indirect: !1,
                autoplay: !1,
                size: this.$ctx.data("size"),
                lang: this.$ctx.data("lang"),
                onReady: function() {
                    return mod.api = this.api,
                    mod.initializeClipLister()
                }
            }, this.$ctx.data("customer-no")),
            this._events.on("video:reloadclip", function(_this) {
                return function(ev) {
                    return _this.onReloadAsyncCliplister(ev)
                }
            }(this))
        },
        initAutoplay: function() {
            if (this._parent.checkShouldAutoPlay(),
            this.api && this.initialAutoPlay)
                return this._parent.beforePlay(!0)
        },
        initializeClipLister: function() {
            if (this.precheckEnabled && this._events.emit("contenttextmedia:video-prechecked", {
                videoId: this.videoId
            }),
            this.precheckEnabled && this.$videoWrapper.removeClass(this.precheckStateClass),
            this.api.preload(),
            this.api.setEvent("playing", function(_this) {
                return function() {
                    return _this.beforePlay()
                }
            }(this)),
            this.api.setEvent("paused", function(_this) {
                return function() {
                    return _this.beforePause()
                }
            }(this)),
            this.api.setEvent("stopped", function(_this) {
                return function() {
                    return _this.beforeStop()
                }
            }(this)),
            this.api.setEvent("finished", function(_this) {
                return function() {
                    return _this.beforeStop()
                }
            }(this)),
            this.toggleVideoPlayerControls(this.showVideoControls),
            this.api.setEvent("ready", function(_this) {
                return function() {
                    return setTimeout(function() {
                        return _this.emitVideoLoaded()
                    }, 10)
                }
            }(this)),
            this.initialAutoPlay)
                return this.beforePlay(!0)
        },
        setupVideo: function() {
            if (this.api)
                return this.initializeClipLister()
        },
        toggleVideoPlayerControls: function(showControls) {
            if (this.api)
                return showControls ? this.api.setEvent("controlsIn") : this.api.setEvent("controlsOut")
        },
        videoPlay: function() {
            if (this.api)
                return this.api.play()
        },
        videoStop: function() {
            if (this.api)
                return this.api.stop()
        },
        onReloadAsyncCliplister: function(data) {
            var reloadId;
            if (reloadId = data.reloadId,
            reloadId === this.videoId)
                return Cliplister.reloadClips(this.videoId)
        },
        onToggleVideoControls: function(data) {
            if (this.$ctx.closest(data.$slide).length && (this.showVideoControls = data.showControls,
            this.api))
                return this.toggleVideoPlayerControls(data.showControls)
        }
    })
}(jQuery),
function($) {
    T.Module.Video.Iframe = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.srcCreated = !1,
            T.Utils.loadYoutubeApi(function(_this) {
                return function() {
                    return _this.initializeYoutube()
                }
            }(this)),
            this.$wrapper = this.$(".js-video-wrapper"),
            this.$iframe = this.$(".js-video-iframe")
        },
        buildSrc: function() {
            var reg, src, srcAttrs;
            return src = this.$ctx.data("src"),
            srcAttrs = [],
            reg = /^https?:/,
            src.match(reg) && (src = src.replace(reg, "")),
            src = location.protocol + src,
            src += src.match(/\?/) ? "&" : "?",
            src.match(/youtube/) && (srcAttrs.push("origin=" + location.origin),
            srcAttrs.push("color=" + T.Utils.video.youtube.color),
            srcAttrs.push("rel=0")),
            this.$wrapper.addClass("video-wrapper-active"),
            this.$iframe.attr("src", src + srcAttrs.join("&"))
        },
        initAutoplay: function() {
            if (this._parent.checkShouldAutoPlay(),
            this.youtubePlayer && this.initialAutoPlay)
                return this._parent.beforePlay(!0)
        },
        initializeYoutube: function() {
            return this.srcCreated || (this.buildSrc(),
            this.srcCreated = !0),
            this.youtubePlayer = new YT.Player(this.$iframe.attr("id"),{
                events: {
                    onReady: function(_this) {
                        return function() {
                            return _this.onPlayerReady()
                        }
                    }(this),
                    onStateChange: function(_this) {
                        return function(ev) {
                            return _this.onStateChangeYoutubePlayer(ev)
                        }
                    }(this)
                }
            }),
            this.emitVideoLoaded()
        },
        setupVideo: function() {},
        videoPlay: function() {
            if (this.youtubePlayer)
                return this.youtubePlayer.playVideo()
        },
        videoStop: function() {
            if (this.youtubePlayer)
                return this.youtubePlayer.stopVideo()
        },
        onPlayerReady: function() {
            if (this.initialAutoPlay)
                return this._parent.beforePlay(!0)
        },
        onStateChangeYoutubePlayer: function(ev) {
            switch (ev.data) {
            case 0:
                return this._parent.beforeStop();
            case 1:
                return this._parent.beforePlay();
            case 2:
                return this._parent.beforePause()
            }
        }
    })
}(jQuery),
function($) {
    T.Module.Charts.Pie = T.createDecorator({
        startAngle: -.5 * Math.PI,
        legendRects: [],
        legendTexts: [],
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject)
        },
        addPieLegendBox: function(obj, index) {
            var rect;
            return rect = new fabric.Rect({
                fill: this.getColor(obj, index),
                height: this.settings.Pie.legendBoxSize,
                left: this.getLegendLeft(),
                top: this.getLegendTop(obj, index),
                width: this.settings.Pie.legendBoxSize
            }),
            this.legendRects.push(rect),
            this.canvas.add(rect)
        },
        addPieLegendText: function(obj, index) {
            var legendLeft, legendTop, text;
            return legendLeft = this.getLegendLeft() + this.settings.Pie.legendBoxSize + this.settings.Pie.legendLabelIndent,
            legendTop = this.getLegendTop(obj, index) + (this.settings.Pie.legendBoxSize - this.settings.labelFontSize) / 2,
            text = new fabric.Text(this.getValueText(obj),{
                left: legendLeft,
                top: legendTop,
                fill: this.settings.labelFontColor,
                fontFamily: this.settings.labelFontFamily,
                fontSize: this.settings.labelFontSize,
                lineHeight: 1
            }),
            this.legendTexts.push(text),
            this.canvas.add(text)
        },
        addPieSegment: function(obj, index) {
            var radius, segment, strokeRadius;
            return radius = this.getRadius(),
            strokeRadius = radius - radius * parseInt(this.settings.Pie.cutout) / 100,
            segment = new fabric.Circle({
                radius: radius - strokeRadius / 2,
                left: this.settings.padding,
                top: this.settings.padding,
                startAngle: this.getStartAngle(obj, index),
                endAngle: this.getEndAngle(obj, index),
                stroke: this.getColor(obj, index),
                strokeWidth: strokeRadius,
                fill: "",
                selectable: !1
            }),
            this.canvas.add(segment)
        },
        centerLegend: function() {
            var diff, height, mod;
            return mod = this,
            height = -this.settings.Pie.legendItemMargin,
            this.legendRects.forEach(function(r) {
                return height += r.height + mod.settings.Pie.legendItemMargin
            }),
            diff = (this.canvas.height - 2 * this.settings.padding - height) / 2,
            this.legendRects.forEach(function(r) {
                return r.set("top", r.top + diff)
            }),
            this.legendTexts.forEach(function(t) {
                return t.set("top", t.top + diff)
            }),
            this.canvas.renderAll()
        },
        createChart: function() {
            var mod;
            return mod = this,
            this.data.forEach(function(obj, index) {
                return mod.addPieSegment(obj, index),
                mod.addPieLegendBox(obj, index),
                mod.addPieLegendText(obj, index)
            }),
            this.centerLegend(),
            this.scaleRetina()
        },
        getColor: function(obj, index) {
            var i;
            for (i in this.data)
                if (i < index && this.data[i].isHighlight) {
                    index -= 1;
                    break
                }
            return obj.isHighlight ? this.settings.highlightColor : this.settings.Pie.colors[index]
        },
        getEndAngle: function(obj, index) {
            var sum;
            return sum = 0,
            this.data.forEach(function(o) {
                return sum += o.value
            }),
            this.getStartAngle(obj, index) + 2 * obj.value / sum * Math.PI
        },
        getRadius: function() {
            return (this.canvas.height - 2 * this.settings.padding) / 2
        },
        getStartAngle: function(obj, index) {
            var i, start, sum;
            sum = 0,
            start = 0;
            for (i in this.data)
                sum += this.data[i].value,
                i < index && (start += this.data[i].value);
            return this.startAngle + 2 * Math.PI * start / sum
        },
        getLegendLeft: function() {
            return 3 * this.settings.padding + 2 * this.getRadius()
        },
        getLegendTop: function(obj, index) {
            var mod, top;
            return mod = this,
            top = this.settings.padding,
            this.legendTexts.forEach(function(t) {
                return top += t.height + mod.settings.Pie.legendItemMargin
            }),
            top
        },
        resize: function() {
            return this.canvas.clear(),
            this.legendRects = [],
            this.legendTexts = [],
            this.createChart()
        }
    })
}(jQuery),
function($) {
    T.Module.Header.Sticky = T.createDecorator({
        lastScrollTop: 0,
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.$headerElements = this.$(".header-elements"),
            this.$sticky = this.$(".nav-sticky"),
            this.$stickyElements = this.$sticky.find(".nav-sticky-elements"),
            this.$originalNavMain = this.$(".m-navmain"),
            this.setupSticky(),
            $(window).on("scroll.sticky", $.proxy(this.onWindowScroll, this)),
            $(window).on("resize.sticky", $.proxy(this.onWindowResize, this)),
            this.calculateNavMainWidth(),
            this.lastScrollTop = $(window).scrollTop(),
            this._events.on("header:disable-sticky", $.proxy(this.onDisableStickyHeader, this))
        },
        sync: function() {},
        calculateNavMainWidth: function() {
            var $navMain, $otherStickyElements, navMainMaxWidth;
            if ($navMain = this.$stickyElements.find(".m-navmain"),
            $navMain.length)
                return T.Utils.isViewport("desktop") ? ($otherStickyElements = $navMain.siblings(),
                navMainMaxWidth = Math.floor(this.$stickyElements.width()),
                $otherStickyElements.each(function() {
                    return navMainMaxWidth -= Math.ceil($(this).outerWidth(!0))
                }),
                navMainMaxWidth -= 1,
                navMainMaxWidth > $navMain.find(".first-level")[0].scrollWidth && (navMainMaxWidth = ""),
                $navMain.css({
                    width: navMainMaxWidth
                })) : $navMain.css({
                    width: ""
                })
        },
        setupSticky: function() {
            var $clonedConversionBar;
            return this.$(".m-navmain").clone().find(".second-level").remove().end().appendTo(this.$stickyElements),
            this.$stickyElements.find(".a-totop").appendTo(this.$stickyElements),
            $clonedConversionBar = this.$(".conversion-bar").clone(),
            $clonedConversionBar.children().each(function(i, e) {
                return $(e).removeAttr("data-t-id")
            }),
            $clonedConversionBar.appendTo(this.$stickyElements),
            this._sandbox.addModules($clonedConversionBar[0]),
            this.$stickyElements.find(".js-mobile-menu-toggle").on("click", $.proxy(this.onClickMobileMenuToggle, this)),
            this.$stickyElements.find(".m-navmain .first-level > li > .a-link").on("click", $.proxy(this.onClickMenuEntry, this)),
            this.$stickyElements.find(".conversion-bar [data-popover-id]").on("click", $.proxy(this.onClickConversionBarPopoverTrigger, this)),
            this.$stickyElements.find(".js-search").on("click", $.proxy(this.onClickSearchTrigger, this))
        },
        onClickConversionBarPopoverTrigger: function(ev) {
            return T.Utils.scrollToTop(),
            ev.preventDefault()
        },
        onClickMenuEntry: function(ev) {
            var $trigger, mod;
            if (mod = this,
            $trigger = $(ev.currentTarget),
            $trigger.data("id"))
                return T.Utils.scrollToTop(mod.$originalNavMain, function() {
                    return mod._events.emit("navmain:open-flyout", {
                        id: $trigger.data("id") || null
                    })
                }),
                ev.preventDefault()
        },
        onClickMobileMenuToggle: function(ev) {
            var mod;
            return mod = this,
            T.Utils.scrollToTop(mod.$originalNavMain, function() {
                return mod._events.emit("navmain:open-mobile-menu")
            }),
            ev.preventDefault()
        },
        onClickSearchTrigger: function(ev) {
            var mod;
            return mod = this,
            T.Utils.scrollToTop(function() {
                return mod._events.emit("toggleSearchForm", {
                    isSearchActive: !0
                })
            }),
            ev.preventDefault()
        },
        onDisableStickyHeader: function() {
            return this.$sticky.remove(),
            $(window).off("scroll.sticky"),
            $(window).off("resize.sticky")
        },
        onWindowResize: function(ev) {
            return this.calculateNavMainWidth()
        },
        onWindowScroll: function(ev) {
            var scrollTop;
            return scrollTop = $(window).scrollTop(),
            "top" === T.Utils.getOffScreenDirection(this.$headerElements) && scrollTop - this.lastScrollTop < 0 ? (this.$sticky.hasClass("is-active") || this.calculateNavMainWidth(),
            this.$sticky.addClass("is-active")) : this.$sticky.removeClass("is-active"),
            this.lastScrollTop = scrollTop
        }
    })
}(jQuery),
function($) {
    T.Module.Layout.Tooltip = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this._events.on("t.sync", $.proxy(this.tooltipSync, this))
        },
        tooltipSync: function() {
            $(document).on("mouseenter", "[data-tooltip]", $.proxy(this.onEnterTooltipTrigger, this)),
            $(document).on("mouseleave", "[data-tooltip]", $.proxy(this.onLeaveTooltipTrigger, this))
        },
        onEnterTooltipTrigger: function(ev) {
            var $trigger;
            return $trigger = $(ev.currentTarget),
            this._events.emit("tooltip:open", {
                $trigger: $trigger
            })
        },
        onLeaveTooltipTrigger: function(ev) {
            var $trigger;
            return $trigger = $(ev.currentTarget),
            this._events.emit("tooltip:close", {
                $trigger: $trigger
            })
        }
    })
}(jQuery),
function($) {
    T.Module.Layout.Tracking = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.$ctx = $(this._ctx),
            this.defaults = {
                trackingSelector: "[data-eventTracking]",
                debounceEventsTime: 1e3,
                eventNamespace: ".tracking",
                isDev: !0
            },
            this.configuration = $.extend(this.defaults, this.$ctx.data()),
            this._events.on("dom:replacement", function(_this) {
                return function() {
                    return _this.initializeEventTracking()
                }
            }(this)),
            this._events.on("utils:ajax-productlist", function(_this) {
                return function(trackingData) {
                    return _this.onTrackAjaxResponseProductlist(trackingData)
                }
            }(this)),
            this.initializeEventTracking()
        },
        initializeEventTracking: function() {
            var $elementsRaw;
            return $elementsRaw = this.$(this.configuration.trackingSelector).filter(":not([tracked])"),
            $.each($elementsRaw, function(_this) {
                return function(index, element) {
                    var $element, elementData, eventTrackingString, ref;
                    return $element = $(element),
                    eventTrackingString = _this.replaceEscapingChar($element),
                    elementData = $.parseJSON(eventTrackingString),
                    elementData.eventTypeArray = (null != (ref = elementData.eventType) ? ref.split(" ") : void 0) || [],
                    0 === elementData.eventTypeArray.length ? void _this.outputConsoleLog("No eventType is set", "warn") : ($element.data("elementData", elementData),
                    $element.attr("tracked", !0),
                    _this.bindEvent($element, elementData))
                }
            }(this))
        },
        bindEvent: function($element, elementData) {
            return "onLoad" === elementData.eventType ? this.processEvent($element) : $.each(elementData.eventTypeArray, function(_this) {
                return function(index, event) {
                    return $element.on(event + _this.configuration.eventNamespace, T.Utils.debounce(function(ev) {
                        return _this.processEvent($element)
                    }, _this.configuration.debounceEventsTime, !0))
                }
            }(this))
        },
        processEvent: function($element) {
            var dataValues, elementData, eventTrackingString;
            return eventTrackingString = this.replaceEscapingChar($element),
            elementData = $.parseJSON(eventTrackingString),
            elementData ? (dataValues = this.fetchElementValues(elementData.dataValues, $element),
            null != dataValues ? this.trackValues(elementData.trackType, dataValues) : void 0) : this.outputConsoleLog("No dataValues are found on the Element", "warn")
        },
        fetchElementValues: function(dataValues, $element) {
            var abortTracking, helperObj, i, key, len, subObject, subValue, trackingValue, value;
            helperObj = {},
            abortTracking = !1;
            for (key in dataValues) {
                if (value = dataValues[key],
                trackingValue = null,
                "getValue" === key)
                    trackingValue = this.getValue(value, $element, dataValues.key);
                else if ("getValueById" === key)
                    trackingValue = this.getValueBySelector(value, $element, value.key);
                else if ("filterInitialValue" === key)
                    abortTracking = !this.filterInitialValue(value, $element, value);
                else if ("getCheckboxChecked" === key)
                    trackingValue = this.getCheckboxChecked($element, value);
                else if ("triggerFormSubmitEvent" === key)
                    this.triggerFormSubmitEvent($element),
                    abortTracking = !0;
                else if ("key" === key)
                    ;
                else if (Array.isArray(value))
                    for (trackingValue = {
                        key: key,
                        value: []
                    },
                    i = 0,
                    len = value.length; i < len; i++)
                        subObject = value[i],
                        subValue = "string" != typeof subObject && "number" != typeof subObject && "boolean" != typeof subObject ? this.fetchElementValues(subObject, $element) : subObject,
                        trackingValue.value.push(subValue);
                else
                    trackingValue = "object" == typeof value ? {
                        key: key,
                        value: this.fetchElementValues(value, $element)
                    } : {
                        key: key,
                        value: value
                    };
                if (null !== trackingValue && (helperObj[key]instanceof Array ? helperObj[key].push(trackingValue.value) : helperObj[trackingValue.key] = trackingValue.value),
                abortTracking)
                    return
            }
            return helperObj
        },
        getValue: function(valueType, $element, key) {
            var trackingValue, valueAction, valueTypeLowerCase;
            return valueAction = {},
            valueType || (valueType = ""),
            valueTypeLowerCase = valueType.toLocaleLowerCase(),
            trackingValue = "",
            valueAction = {
                href: function() {
                    return trackingValue = $element.closest("a").attr("href")
                },
                input: function() {
                    var inputValue;
                    return inputValue = $element.is("input") ? $element.val() : $element.find("input").val(),
                    trackingValue = inputValue
                },
                select: function() {
                    var optionValue;
                    return optionValue = $element.find("option:selected").attr("value"),
                    optionValue || (optionValue = $element.find("option:selected").text()),
                    trackingValue = optionValue
                },
                selectdata: function() {
                    var optionValue;
                    return optionValue = $element.find("option:selected").attr("data-track-value"),
                    optionValue || (optionValue = $element.find("option:selected").attr("value")),
                    trackingValue = optionValue
                },
                status: function() {
                    var statusValue;
                    return statusValue = $element.is(":checked"),
                    "dealer_locator_filter_interaction" === key && (statusValue = statusValue ? "enabled" : "disabled"),
                    trackingValue = statusValue
                },
                name: function() {
                    return trackingValue = $element.attr("name")
                },
                text: function() {
                    return trackingValue = $element.text()
                },
                hasclass: function() {
                    return trackingValue = $element.hasClass("teaser-is-selected")
                }
            },
            "function" == typeof valueAction[valueTypeLowerCase] ? valueAction[valueTypeLowerCase]() : this.outputConsoleLog(valueType + " is no valid value, please proof the value of valueType", "warn"),
            {
                key: key || valueType,
                value: trackingValue
            }
        },
        getValueBySelector: function(data, $element, key) {
            var selector;
            for (selector in data)
                if ("key" !== selector)
                    return this.getValue(data[selector], $(selector), key)
        },
        triggerFormSubmitEvent: function($element) {
            return $element.closest("form").find("input").trigger("formSubmit")
        },
        getCheckboxChecked: function($element, key) {
            return {
                key: key,
                value: $element.is(":checked") ? "checked" : "unchecked"
            }
        },
        filterInitialValue: function(data, $element, initialValue) {
            return "checkbox" === $element.prop("type") && $element.is(":checked") !== initialValue
        },
        replaceEscapingChar: function($element) {
            var eventTrackingString;
            return eventTrackingString = $element.attr("data-eventtracking"),
            eventTrackingString = eventTrackingString.replace(/dataValues":\[\\{/, 'dataValues":[{'),
            eventTrackingString = eventTrackingString.replace(/\[\/{/, "[{"),
            eventTrackingString = eventTrackingString.replace(/}\/\]/, "}]")
        },
        trackValues: function(trackType, dataValues) {
            return trackType && dataValues && 0 !== dataValues.length ? void 0 !== window.bshEventQueue ? (this.outputConsoleLog('Tracking Event "' + trackType + '" with values ' + JSON.stringify(dataValues), "info"),
            window.bshEventQueue.push({
                command: "ADD EVENT",
                name: trackType,
                data: dataValues
            })) : this.outputConsoleLog("Either tracking library is not available, trackType is undefined on element", "warn") : void this.outputConsoleLog("Tracking Event on this element is not valid, check data-attribute values", "warn")
        },
        outputConsoleLog: function(message, type) {
            var color;
            if (color = "Green",
            "warn" === type ? color = "Tomato" : "error" === type && (color = "Red"),
            this.configuration.isDev)
                return console.info("%c" + message, "color:" + color)
        },
        onTrackAjaxResponseProductlist: function(trackingData) {
            var appliedFilters, dataValues, entry, i, item, j, k, len, len1, len2, productfilterssku, ref, ref1, ref2, selectedFilter, totalResultCount, trackType;
            if (trackType = "productfilters",
            dataValues = {},
            appliedFilters = {},
            productfilterssku = [],
            trackingData.selectedFilters)
                for (ref = trackingData.selectedFilters,
                i = 0,
                len = ref.length; i < len; i++)
                    if (selectedFilter = ref[i],
                    selectedFilter.entries)
                        for (ref1 = selectedFilter.entries,
                        j = 0,
                        len1 = ref1.length; j < len1; j++)
                            entry = ref1[j],
                            "range" === entry.type ? appliedFilters[entry.type] = selectedFilter.attribute + " " + entry.minValue + "-" + entry.maxValue : appliedFilters[entry.type] = entry.value;
            if (dataValues = appliedFilters,
            trackingData.items && trackingData.items.length)
                for (ref2 = trackingData.items,
                k = 0,
                len2 = ref2.length; k < len2; k++)
                    item = ref2[k],
                    productfilterssku.push(item.sku);
            return dataValues.productfilterssku = productfilterssku,
            trackingData.totalResultCount && (totalResultCount = trackingData.totalResultCount),
            dataValues.totalResultCount = totalResultCount,
            this.outputConsoleLog('Tracking Event "' + trackType + '" with values ' + JSON.stringify(dataValues), "info"),
            void 0 !== window.bshEventQueue ? (this.outputConsoleLog('Tracking Event "' + trackType + '" with values ' + JSON.stringify(dataValues), "info"),
            window.bshEventQueue.push({
                command: "ADD EVENT",
                name: trackType,
                data: dataValues
            })) : this.outputConsoleLog("Either tracking library is not available, trackType is undefined on element", "warn")
        }
    })
}(jQuery),
function($) {
    return T.Module.List.OnlineDealer = T.createDecorator({
        start: function(resolve, reject) {
            return this._parent.start(resolve, reject),
            this.onDealerTeaserAdded = $.proxy(this.onDealerTeaserAdded, this),
            this.onImageLoaded = $.proxy(this.onImageLoaded, this),
            this.$ctx = $(this._ctx),
            this._events.on("dealerTeaserStart", this.onDealerTeaserAdded),
            this._events.on("image:loaded", this.onImageLoaded)
        },
        equalizeHeights: function() {
            var $items, $itemsWithoutImage, $title, $toEqualize, matchHeightOptions;
            if ($itemsWithoutImage = this.$ctx.find('[data-has-no-image="true"]'),
            $items = this.$ctx.find(".js-item"),
            matchHeightOptions = {
                byRow: !0,
                property: "height",
                target: null,
                remove: !1
            },
            $itemsWithoutImage.length > 0 && $itemsWithoutImage.length !== $items.length && ($toEqualize = $items.find(".js-media"),
            $toEqualize.matchHeight(matchHeightOptions),
            $items.addClass("has-equal-height")),
            $title = this.$ctx.find(".shop-title"),
            $title.length > 0)
                return $title.matchHeight(matchHeightOptions)
        },
        onDealerTeaserAdded: function() {
            return this.equalizeHeights()
        },
        onImageLoaded: function(data) {
            var $itemsWithoutImage, mod;
            if (mod = this,
            data.$currentTarget.closest(".js-media").length > 0 && ($itemsWithoutImage = this.$ctx.find('[data-has-no-image="true"]'),
            $itemsWithoutImage.length > 0))
                return T.Utils.debounce(mod.equalizeHeights(), 100)
        },
        onViewportChange: function(viewport) {
            return this._parent.onViewportChange(viewport),
            T.Utils.debounce($.fn.matchHeight._update(), 100)
        }
    })
}(jQuery),
function($) {
    T.Module.List.Sparepart = T.createDecorator({
        start: function(resolve, reject) {
            var mod;
            return this._parent.start(resolve, reject),
            this.$list = $(this._ctx),
            mod = this,
            mod.$itemToOpen = !1,
            this._events.on("sparePartDataChange", $.proxy(this.onSparePartDataChange, this)),
            this._events.on("filterBarSortingChange", $.proxy(this.onSortingChange, this)),
            this._events.on("findsparepart", $.proxy(this.onFindItem, this)),
            this._events.on("recalc", $.proxy(this.onRecalc, this)),
            this._events.on("searchByKeys", $.proxy(this.onSearchByKeys, this))
        },
        getItems: function($list) {
            var $listItems;
            return $listItems = $list.find(".item")
        },
        findAndScroll: function(searchQuery) {
            var mod;
            return mod = this,
            mod._events.emit("triggerSearch", {
                query: searchQuery,
                $ctx: mod.$ctx
            })
        },
        scrollToItem: function($item) {
            var mod;
            return mod = this,
            T.Utils.scrollToTop($item, function() {
                return mod._events.emit("openToggleBoxItem", {
                    $toggle: $item
                }),
                mod.$itemToOpen = !1
            })
        },
        sortItems: function(sortKey) {
            var $items, sortedItemHtml, sortedItems;
            return $items = this.getItems(this.$list),
            sortKey = "." + sortKey,
            sortedItems = $items.sort(function(a, b) {
                return $(b).find(sortKey).text() < $(a).find(sortKey).text() ? 1 : -1
            }),
            sortedItemHtml = "",
            sortedItems.each(function() {
                return sortedItemHtml = sortedItemHtml + '<div class="item">' + $(this).html() + "</div>"
            }),
            $items.parent().html(sortedItemHtml)
        },
        fillList: function(result) {
            var $template, key, request;
            return request = {
                obj: this.$list
            },
            $template = $("<div/>").html(T.Utils.renderTemplateMarkup(request, result, !1)),
            key = this.$list.find("[data-replace-container]").data("replace-container"),
            T.Utils.syncContent($template, key, "replace"),
            this.updateListHeading(result),
            this.checkViewport()
        },
        updateListHeading: function(result) {
            var $listHeader, itemsLength;
            if (result.items)
                return itemsLength = result.items.length,
                $listHeader = this.$list.find(".js-filterbar-title .js-counter"),
                $listHeader.text(itemsLength + " ")
        },
        resetSearch: function(bash) {
            var $errorMessage, $input;
            return $input = this.$(".js-searchfield-input"),
            $errorMessage = this.$(".js-searchinput").find(".a-errormessage.error-custom"),
            $errorMessage.hide(),
            bash ? $input.val(bash) : $input.val("")
        },
        onViewportChange: function(viewport) {
            return this._parent.onViewportChange(viewport),
            this.checkViewport()
        },
        checkViewport: function() {
            if ("mobile" === T.Utils.getViewport() && this.$list.find(".sparepartlist-dot").addClass("grid-view"),
            "tablet" === T.Utils.getViewport() && this.$list.find(".sparepartlist-dot").removeClass("grid-view").addClass("list-view"),
            "desktop" === T.Utils.getViewport())
                return this.$list.find(".sparepartlist-dot").removeClass("grid-view").addClass("list-view")
        },
        onSortingChange: function(data) {
            if (data.sortKey)
                return this.sortItems(data.sortKey)
        },
        onSearchByKeys: function(searchKeys, id, searchQuery) {
            var $result, i, j, key, len, len1, listId, mod, result, resultSet, results, skuId;
            if (mod = this,
            resultSet = [],
            listId = mod.$ctx.data("t-id"),
            mod.$ctx.find('[data-t-id="' + id + '"]').length > 0)
                for (i = 0,
                len = searchKeys.length; i < len; i++)
                    for (key = searchKeys[i],
                    results = mod.$ctx.find("." + key),
                    j = 0,
                    len1 = results.length; j < len1; j++)
                        result = results[j],
                        $result = $(result),
                        $result.text().toLowerCase() === searchQuery.toLowerCase() && (skuId = $result.closest(".js-togglebox-toggle").data("result-key"),
                        resultSet.indexOf(skuId) < 0 && resultSet.push(skuId));
            return resultSet.length > 0 ? (mod.$itemToOpen = mod.$ctx.find('[data-result-key="' + resultSet[0] + '"]'),
            mod._events.emit("hideInputError", {
                $ctx: mod.$ctx
            }),
            mod._events.emit("openToggleBoxItem", {
                $toggle: mod.$itemToOpen,
                instant: !1
            }),
            mod._events.emit("closeAllToggleBoxItems", !0, mod.$itemToOpen, listId),
            T.Utils.scrollToTop(mod.$itemToOpen)) : mod._events.emit("showInputError", {
                $ctx: mod.$ctx
            })
        },
        onSearchSubmit: function(ev) {
            return ev.preventDefault(),
            this.findAndScroll(this.$(".js-searchfield-input").val())
        },
        onSparePartDataChange: function(data) {
            var dataArray;
            return this.resetSearch(),
            dataArray = {
                items: data.sparePartList
            },
            this.fillList(dataArray)
        },
        onFindItem: function(data) {
            return this.resetSearch(data.sparepartnumber),
            this.findAndScroll(data.sparepartnumber)
        },
        onRecalc: function(data) {
            var mod;
            if (mod = this,
            mod.$ctx.find('[data-t-id="' + data.$ctx.data("t-id") + '"]').length > 0 && mod.$itemToOpen)
                return mod.scrollToItem(mod.$itemToOpen)
        }
    })
}(jQuery);



// mnrichte@SCHEMA
(function($) {
    T.Module.MediaGallerySyncedContent = T.createModule({
        slickConfiguration: {
            centerMode: !1,
            slidesToShow: 1,
            slidesPerRow: 1,
            initialSlide: 0,
            infinite: !1,
            useCSS: !1
        },
        start: function(resolve) {
            var mod;
            return mod = this,
            mod.$ctx = $(this._ctx),
            mod.$paginationnumber = mod.$(".js-paginationnumber"),
            mod.$sliderControls = mod.$(".js-mediagallery-controls"),
            mod.$mainSlider = mod.$(".js-mediagallery-mainslider"),
            mod.$mainsliderControls = mod.$(".js-mediagallery-controls"),
            mod.$mainsliderArrowLeft = mod.$(".js-mediagallery-controls > .prev"),
            mod.$mainsliderArrowRight = mod.$(".js-mediagallery-controls > .next"),
            mod.$thumbnailSlider = mod.$(".js-mediagallery-thumbnailcarousel"),
            mod.$thumbnailSliderControls = mod.$(".js-mediagallery-thumbnailcarousel-controls"),
            mod.$thumbnailSliderArrowLeft = mod.$(".js-mediagallery-thumbnailcarousel-controls > .prev"),
            mod.$thumbnailSliderArrowRight = mod.$(".js-mediagallery-thumbnailcarousel-controls > .next"),
            mod.$btnOpenLayer = mod.$(".js-mediagallery-zoom"),
            mod.$btnOpenLayer.addClass("hidden"),
            mod.totalNumberOfSlides = mod.$ctx.find(".mediagallery-slide:not(.slick-cloned)").length,
            mod.countSlidesPerPage = 1,
            mod.currentSlide = 1,
            mod.mainSliderInitialized = !1,
            mod.initMainSlider(),
            mod._events.on("recalc", $.proxy(mod.onReCalc, mod)),
            mod._events.on("t.sync", $.proxy(mod.sync, mod)),
            mod._events.on("videoPlaying", $.proxy(mod.onVideoStart, mod)),
            mod._events.on("videoStop", $.proxy(mod.onVideoStop, mod)),
            mod._events.on("videoEnded", $.proxy(mod.onVideoStop, mod)),
            this._events.on("viewportChanged", function(_this) {
                return function(viewport) {
                    return _this.onViewportChange(viewport)
                }
            }(this)),
            resolve()
        },
        sync: function() {
            var mod;
            mod = this,
            mod.forceSliderHeightReCalc()
        },
        activateThumb: function(index) {
            return this.$thumbnailSlider.find(".js-mediagallery-thumbnailcarousel-slide").removeClass("is-active slick-current").eq(index).addClass("is-active slick-current")
        },
        addSliderEventListener: function() {
            var mod;
            return mod = this,
            mod.$mainSlider.on("beforeChange", $.proxy(mod.onMainSlideBeforeChange, mod)),
            mod.$mainSlider.on("afterChange", $.proxy(mod.onSliderAfterChange, mod)),
            mod.$thumbnailSlider.on("setPosition", $.proxy(mod.onThumbnailSlideSetPosition, mod)),
            mod.$thumbnailSlider.on("click", ".js-mediagallery-thumbnailcarousel-slide", $.proxy(this.onClickThumbnailCarouselSlide, mod))
        },
        forceSliderHeightReCalc: function() {
            var mod;
            if (mod = this,
            mod.mainSliderInitialized)
                return mod.$mainSlider.slick("setPosition")
        },
        getCurrentDownloadBySlide: function() {},
        getVideoInSlide: function() {
            var currentSlideVideo, mod;
            return mod = this,
            currentSlideVideo = mod.$mainSlider.find(".slick-current .m-video"),
            currentSlideVideo.length > 0 && currentSlideVideo
        },
        initMainSlider: function() {
            var mod;
            if (mod = this,
            mod.$ctx.removeClass("pre-init"),
            mod.$mainSlider.slick($.extend(mod.slickConfiguration, {
                appendArrows: mod.$mainsliderControls,
                arrows: !0,
                autoplay: !1,
                centerPadding: "0px",
                dots: !1,
				// mnrichte@SCHEMA set slider Main
				initialSlide: window.parseInt(T.Utils.getHashIds('slide')[0] || "0", 10),
                fade: mod.$mainSlider.data("mediagallery-fade"),
                nextArrow: mod.$mainsliderArrowRight,
                prevArrow: mod.$mainsliderArrowLeft,
                speed: 300
            })),
            mod.activateThumb(mod.$mainSlider.find(".slick-current").data("slick-index")),
            mod.setMediaGalleryMainSliderControls(),
            mod.mainSliderInitialized = !0,
            mod.totalNumberOfSlides > 1)
                return mod.$thumbnailSlider.removeClass("hidden"),
                mod.initThumbnailSlider(),
                mod.addSliderEventListener()
        },
        initThumbnailSlider: function() {
            var countSlider, initialSlide, slidesToScrollDesktop, slidesToShowDesktop;
            return countSlider = this.$thumbnailSlider.find(".js-mediagallery-thumbnailcarousel-slide").length,
            initialSlide = initialSlide ? initialSlide : (1 === countSlider ? -1 : 0),
			initialSlide = window.parseInt(T.Utils.getHashIds('slide')[0] || "0", 10),
            slidesToShowDesktop = slidesToScrollDesktop = this.$(".mediagallery-downloadlink-desktop").length > 0 ? 3 : 5,
            this.$thumbnailSlider.slick({
                appendArrows: this.$thumbnailSliderControls,
                arrows: !0,
                autoplay: !1,
                centerPadding: "0px",
                centerMode: !1,
                dots: !1,
                fade: !1,
				// mnrichte@SCHEMA set slider Thump
                initialSlide: initialSlide,
                infinite: !1,
                nextArrow: this.$thumbnailSliderArrowRight,
                prevArrow: this.$thumbnailSliderArrowLeft,
                slide: ".js-mediagallery-thumbnailcarousel-slide",
                slidesToShow: slidesToShowDesktop,
                slidesToScroll: slidesToScrollDesktop,
                speed: 300,
                responsive: [{
                    breakpoint: parseInt(T.Utils.breakpoints.lg),
                    settings: {
                        slidesToShow: slidesToShowDesktop,
                        slidesToScroll: slidesToScrollDesktop
                    }
                }, {
                    breakpoint: parseInt(T.Utils.breakpoints.md),
                    settings: {
                        slidesToShow: 3,
                        slidesToScroll: 3
                    }
                }]
            }),
            $("[content-index='" + initialSlide + "']").addClass("activeSyncedContent")
        },
        setMainSliderCaption: function() {
            return this.$("figcaption").html(this.$mainSlider.find(".slick-current").data("caption-text"))
        },
        setMediaGalleryMainSliderControls: function() {
            var currentMainSlide, currentSlide;
            return currentMainSlide = this.$mainSlider.slick("slickCurrentSlide"),
            0 === currentMainSlide ? this.$mainsliderArrowLeft.addClass("is-inactive").attr("disabled", "disabled") : this.$mainsliderArrowLeft.removeClass("is-inactive").removeAttr("disabled"),
            currentMainSlide === this.totalNumberOfSlides - 1 ? this.$mainsliderArrowRight.addClass("is-inactive").attr("disabled", "disabled") : this.$mainsliderArrowRight.removeClass("is-inactive").removeAttr("disabled"),
            this.setMainSliderCaption(),
            1 === this.totalNumberOfSlides && this.toggleSliderControls(!1),
            currentSlide = this.$mainSlider.find(".slick-current").data("slick-index"),
            this.currentSlide = currentSlide + 1,
            this.setPaginationNumbers()
        },
        setMediaGalleryThumbnailSliderControls: function() {
            var arrayAllVisibleThumbnails, maxCountThumbs, maxIndexVisible, minIndexVisible;
            return maxCountThumbs = this.$thumbnailSlider.find(".js-mediagallery-thumbnailcarousel-slide").length,
            arrayAllVisibleThumbnails = this.$thumbnailSlider.find(".slick-active"),
            minIndexVisible = arrayAllVisibleThumbnails.first().data("slick-index") + 1,
            maxIndexVisible = arrayAllVisibleThumbnails.last().data("slick-index") + 1,
            1 === minIndexVisible ? this.$thumbnailSliderArrowLeft.addClass("is-inactive").attr("disabled", "disabled") : this.$thumbnailSliderArrowLeft.removeClass("is-inactive").removeAttr("disabled"),
            maxIndexVisible === maxCountThumbs ? this.$thumbnailSliderArrowRight.addClass("is-inactive").attr("disabled", "disabled") : this.$thumbnailSliderArrowRight.removeClass("is-inactive").removeAttr("disabled")
        },
        setPaginationNumbers: function() {
            var mod;
            if (mod = this,
            this.totalNumberOfSlides > 1)
                return mod.$paginationnumber.html(mod.currentSlide + "/" + mod.totalNumberOfSlides)
        },
        setSlickDragEvents: function(value) {
            var mod;
            if (mod = this,
            mod.mainSliderInitialized)
                return mod.$mainSlider.slick("slickSetOption", "draggable", value),
                mod.$mainSlider.slick("slickSetOption", "touchMove", value),
                mod.$mainSlider.slick("slickSetOption", "swipeToSlide", value),
                mod.$mainSlider.slick("slickSetOption", "swipe", value)
        },
        toggleSliderControls: function(enableControls) {
            var mod;
            return mod = this,
            enableControls ? mod.$sliderControls.removeClass("hidden") : mod.$sliderControls.addClass("hidden")
        },
        onClickThumbnailCarouselSlide: function(ev) {
            var index;
            return index = $(ev.currentTarget).data("slick-index"),
            this.$mainSlider.slick("slickGoTo", index),
            this.activateThumb(index)
        },
        onMainSlideBeforeChange: function(event, slick, currentSlide, nextSlide) {
            var mod, videoComponent;
            return mod = this,
            videoComponent = mod.getVideoInSlide(),
            mod._events.emit("pageSliderSlideBeforeChange", {
                currentSlide: currentSlide,
                $slide: $(slick.$slides.get(currentSlide)),
                videoComponent: videoComponent
            })
        },
        onSliderAfterChange: function(event, slick, currentSlide) {
            var direction, mod, videoComponent, allContentIndexed, toDisplay;
            return mod = this,
            direction = mod.$thumbnailSlider.find(".slick-current").data("slick-index") < currentSlide ? "slickNext" : "slickPrev",
            mod.setMediaGalleryMainSliderControls(),
            mod.activateThumb(currentSlide),
            mod.$thumbnailSlider.find(".slick-current").hasClass("slick-active") || mod.$thumbnailSlider.slick(direction),
            mod.$btnOpenLayer.data("slick-index", currentSlide),
            videoComponent = mod.getVideoInSlide(),
            mod._events.emit("pageSliderSlideAfterChange", {
                currentSlide: currentSlide,
                $slide: $(slick.$slides.get(currentSlide)),
                videoComponent: videoComponent
            }),
            mod._events.emit("mediagallery:changedownload", {
                currentDownload: mod.getCurrentDownloadBySlide($(slick.$slides.get(currentSlide)))
            }),
            allContentIndexed = $("[content-index]"),
            allContentIndexed.removeClass("activeSyncedContent"),
            toDisplay = $("[content-index='" + currentSlide + "']"),
            toDisplay.addClass("activeSyncedContent")
        },
        onReCalc: function(data) {
            var mod;
            if (mod = this,
            mod.$ctx.closest(data.$element).length && (mod.$mainSlider.hasClass("slick-initialized") && this.forceSliderHeightReCalc(),
            mod.$thumbnailSlider.hasClass("slick-initialized")))
                return mod.$thumbnailSlider.slick("setPosition")
        },
        onThumbnailSlideSetPosition: function() {
            return this.setMediaGalleryThumbnailSliderControls()
        },
        onVideoStart: function(data) {
            var mod;
            if (mod = this,
            data.$ctx.closest(mod.$ctx).length)
                return mod.toggleSliderControls(!1),
                mod.setSlickDragEvents(!1)
        },
        onVideoStop: function(data) {
            var mod;
            if (mod = this,
            data.$ctx.closest(mod.$ctx).length)
                return mod.toggleSliderControls(!0),
                mod.setSlickDragEvents(!0)
        },
        onViewportChange: function() {
            return this.forceSliderHeightReCalc()
        }
    })
}
)(jQuery);
